# ********************************************************************
# Board Components
# ********************************************************************
# flag                      value
# ********************************************************************

## U-boot default silent mode [ FALSE | TRUE ]
Config_SILENT_ON = FALSE

##Package type [ FPGA | BGA | BGA_27x27]
Config_Package_type = BGA

##Board Name [ FPGA | Demo | Demo_27x27]
Config_Board = TV002_V001

#Config_PCB_Header_FILE = "pcb_tv001_bga.h"
Config_PCB_Header_FILE = "pcb_tv002_bga_Vulcan3.h"

##DRAM size auto from [ OTP | uboot_def ]
Config_dram_size_from = OTP

##DRAM Bank1 base/size [ 0_0GB | 0_5GB | 1_0GB | 1_5GB | 2_0GB | uboot_def ]
Config_dram_bank1_base = 0_0GB
Config_dram_bank1_size = 0_5GB

##DRAM Bank2 base/size [ 0_0GB | 0_5GB | 1_0GB | 1_5GB | 2_0GB | uboot_def ]
Config_dram_bank2_base = 0_5GB
Config_dram_bank2_size = 1_0GB

# ********************************************************************
# Config Platform Model [ 2K | 4K | 8K ]
# ********************************************************************
Config_Platform_Model = 4K

# ********************************************************************
# Bootcode type select
# ********************************************************************
# flag                      value
# ********************************************************************
##Bootcode type [ RELEASE | DEBUG]
Config_Boot_Type_is = DEBUG

# ********************************************************************
# Boot Flash type select (for uboot)
# ********************************************************************
# flag                      value
# ********************************************************************
##Boot Flash Type is [ NAND | SPI | EMMC | NONE ]
Config_Boot_Flash_Type_is = EMMC

# ********************************************************************
# EMMC TIMING MODE (for uboot)
# ********************************************************************
# flag                      value
# ********************************************************************
##Boot Flash Type is [ HS400 | HS200 | NORMAL ]
Config_emmc_timing_is = NORMAL

# ********************************************************************
# EMMC RPMB Fuction (for Auxcode)
# ********************************************************************
# flag                      value
# ********************************************************************
##eMMC RPMB func [ FALSE | TRUE ]
Config_emmc_flash_RPMB_enable = FALSE

# ********************************************************************
# Config
# ********************************************************************
# flag                      value
# ********************************************************************
Config_Aux_Code_Image_File = "Aux_code_uni_atf.bin"
Config_Extra_image_File_list = B22_ddr3_4G4G4G_d1_1_5GB_V1 B22_ddr3_4G4G4G_d2_1_5GB_V1 B22_ddr3_4G4G4G4G_d2_2GB_V1 B23_ddr4_4G4G4G4G_d1_2GB_V1 B23_ddr4_4G4G4G_d1_1_5GB_V1

# ********************************************************************
# Config
# ********************************************************************
# flag                      value
# ********************************************************************
##Default Uart Port [ 0 | 1 ]
Config_Use_Uart_Port = 1

##Default STR Mode [Enable | Disable]
Config_Support_STR = Enable

##Default STR no_console_suspend Mode [ Enable | Disable]
Config_Support_No_Console_Suspend_STR = Enable

##Default support EXT4 file system [ TRUE | FALSE ]
Config_EXT4_FS_Support_Enable = TRUE

##Default support EXT4 factory [ TRUE | FALSE ]
Config_EXT4_Factory_Enable = TRUE

##Default load tvconfigs
Config_EXT4_Load_TvConfigs = TRUE

##Default load takeover
Config_EXT4_Load_Takeover = TRUE
# ********************************************************************
# flag                      value
# ********************************************************************
##Rebuild Auxcode [ TRUE | FALSE ]
Config_Rebuild_Aux_Code = FALSE

##Disable Auxcode Watchdog [ TRUE | FALSE ]
Config_Disable_Aux_Code_Watchdog = FALSE

## PRINT_DISABLE in Auxcode [ TRUE | FALSE ]
Config_Disable_log_in_Aux_Code = FALSE

# ********************************************************************
# Config
# ********************************************************************
# flag                      value
# ********************************************************************
Config_DTE_Bootcode_Config_Value = rtk_tv002
Config_DTE_Bootcode_Board_name_Value = tv002
#Config_DTE_Bootcode_SOC_Value = rtk (Removed)
Config_DTE_Bootcode_Image_File = "dte_bootcode.img"
Config_EMCU_PREFIX_FILE = "ecpu.bin"
Config_ARM_REDIRECT1_FILE = "arm_start.o"
Config_ARM_REDIRECT1_OFFSET = a0000000
Config_ARM_REDIRECT2_FILE = "arm_start2.o"
Config_ARM_REDIRECT2_OFFSET = a001f800

# ********************************************************************
# Config
# ********************************************************************
# flag                      value
# ********************************************************************
#Config_Process_DTE_KBoot = TRUE
Config_DTE_KBoot_Image_File = "KBoot.bin"
Config_DTE_KBoot_Standalone_Image_File = "KBoot_Standalone_rtd2885m.bin"
Config_Enable_KBoot = TRUE
Config_Rebuild_KBoot = FALSE

# ********************************************************************
# Rescue Linux attribute
# ********************************************************************
# flag                      value
# ********************************************************************
##Rescue Switch [ FLASH | USB | NULL ]
Rescue_Source =             FLASH
##Rescue_Flash_Source =     [S | K | SK]
Rescue_Flash_Source =       SK
#Rescue_File_Name =          vmlinux.rescue.rtd2885m.bin.lzma
Rescue_File_Name =         vmlinux.rescue.rtd2885m.tv002.optee.bin.lzma
Rescue_K_File_Name =        tee.bin

# ********************************************************************
# Config
# ********************************************************************
# flag                      value
# ********************************************************************
##Usb update when AC ON feature [ Enable | Disable ]
Config_AC_on_Usb_Update_image = Enable
Config_AC_on_Usb_Update_dvrboot = Disable

##Config_Secure_Type[ NAGRA | RTK | RTK_SIMPLE ]
Config_Secure_Type = RTK
# ********************************************************************
# RSA key file & AES key file (under bin/image)
# ********************************************************************
# flag                      value
# ********************************************************************
##OTP Secure Boot [ TRUE | FALSE ]
Config_OTP_Secure_Boot =     TRUE
Config_Secure_RSA_Root_Key_File = "rsa_root_key.pem"
Config_Secure_RSA_Ext_Key_File = "rsa_ext_key.pem"
Config_Secure_AES_Root_K_Key_File = "key_root_k.bin"
Config_Secure_AES_Root_S_Key_File = "key_root_s.bin"
Config_Secure_AES_Root_AUX_Key_File = "key_root_aux.bin"
Config_Secure_AES_Ext_FPK_Key_File = "key_ext_fpk.bin"
Config_Secure_AES_Ext_FPK_S_Key_File = "key_ext_fpk_s.bin"
Config_Secure_RSA_Key_File = "rsa_key_2048.pem"
Config_Secure_RSA_Ext_2ndBoot_Key_File =  "rsa_ext_key_2ndboot.pem"
Config_Secure_RSA_Ext_FW_Key_File =       "rsa_ext_key.pem"

# ********************************************************************
# Module Test
# ********************************************************************
# flag                      value
# ********************************************************************
##Config_Module_Test_Boot  [TRUE | FALSE]
Config_Module_Test_Boot =  FALSE

# ********************************************************************
# user defined
# ********************************************************************
# flag                      value
# ********************************************************************
#User_Defined =		     CONFIG_USB_BYPASS_PORT_BASE_1	1

# ********************************************************************
# Force Flash type (for flash_image_maker)
# ********************************************************************
# flag                      value
# ********************************************************************
##Force Flash Type [ TRUE | FALSE ]
Config_Force_Flash_Type = TRUE

# ********************************************************************
# Flash type select (for flash_image_maker)
# ********************************************************************
# flag                      value
# ********************************************************************
##Force Flash Type is [ NAND | SPI | EMMC ]
Config_Flash_Type_is = EMMC

# ********************************************************************
# Config RTD LOGBUF
# ********************************************************************
# flag                      value
# ********************************************************************
##Config_RTD_LOGBUF [ TRUE | FALSE ]
Config_RTD_LOGBUF = TRUE
# ********************************************************************
# Config boot ATF
# ********************************************************************
# flag                      value
# ********************************************************************
##Config Boot ATF [ TRUE | FALSE ]
Config_Boot_ATF = TRUE

# ********************************************************************
# Config OF LIBFDT
# ********************************************************************
# flag                      value
# ********************************************************************
##Config_OF_LIBFDT [ TRUE | FALSE ]//TRUE:use DTS;FALSE:use ATAG
Config_OF_LIBFDT = TRUE
DTB_File_Name = rtd2885m.dtb
Config_DTE_Bootcode_HW_Value = "rtd2885m"

# ********************************************************************
# Config OF Vulcan3_PCB
# ********************************************************************
# flag                      value
# ********************************************************************
Config_Vulcan3_PCB = TRUE

# ********************************************************************
# Config OF Panel_Type
# ********************************************************************
# flag                      value
# ********************************************************************
##Config_Panel_Type [ NORMAL | FHD ]
Config_Panel_Type = FHD
