#ifndef __SPI_MGR_H__
#define __SPI_MGR_H__

// spi layout
#define RESETROM_SPI_ERASE_OFFSIZE     0x0
#define RESETROM_SPI_ERASE_SIZE        0x5000
#define RESETROM_SPI_OFFSET            0x0
#define RESETROM_SPI_ALLO_SIZE         0x4c00

#define SYSINFO_SPI_ERASE_OFFSIZE     0x4000
#define SYSINFO_SPI_ERASE_SIZE        0x1000
#define SYSINFO_SPI_OFFSET            0x4c00
#define SYSINFO_SPI_ALLO_SIZE         0x0400

#define AUXCODE_SPI_OFFSET             0x6000

// QC area
#define QC_AUDIO_IMG_START            0x300000
#define QC_AUDIO_IMG_SIZE_LIMIT       0x200000

#define QC_VE_PATTERN_START           0x500000 // qc_ve code offset in spi flash
#define QC_VE_PATTERN_SIZE_LIMIT      0x200000

typedef struct{
    int chip_id;  
    int chip_mask;
    int magic_no;
    unsigned int sysinfo_size;   
    unsigned int auxcode_size;          
    unsigned int hwsetting_size;
    unsigned int ext_fw_size;
    unsigned int uboot_size;
    int uboot_ddr_addr;
}spi_sys_info_t;

typedef struct
{
    unsigned int resetrom_offset;
    unsigned int resetrom_allo_size;
    unsigned int sysinfo_offset;
    unsigned int sysinfo_allo_size;
    unsigned int auxcode_offset;
    unsigned int auxcode_allo_size;
    unsigned int hwsetting_offset;
    unsigned int hwsetting_allo_size;
    unsigned int extfw_offset;
    unsigned int extfw_allo_size;
    unsigned int uboot_offset;
    unsigned int uboot_allo_size;
}spi_layout_t;

#endif
