/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 2012 by Chuck Chen <ycchen@realtek.com>
 *
 * Time initialization.
 */

#include <common.h>
#include <asm/utils.h>
#include <asm/arch/system.h>
#include <rbus/sys_reg_reg.h>
#include <rbus/pll_reg_reg.h>
#include <rbus/pll27x_reg_reg.h>
#include <rbus/stb_reg.h>
#include <rbus/sb2_reg.h>
#include <rbus/sbx_reg.h>

//#define wfi()	__asm__ __volatile__ ("wfi" : : : "memory")
extern int rtk_do_ip_bisr(void);

#if 0
//#define SB2_INV_INT_EN_VADDR			0xb801a004
#define DC_EC_CTRL_VADDR				0xb80072d0
#define DC_EC_ADDCMD_HI_VADDR			0xb80072d4
#define DC_EC_ADDCMD_LO_VADDR			0xb80072d8
#define DC_RD_TAG_CHECK_VADDR			0xb80072dc
//#define DC_EXP_LANE_CTRL_VADDR			0xb8007f04
#endif

void enable_switch_pinmux_to_spi(void)
{
	;
}
void disable_switch_pinmux_to_spi(void)
{
	;
}

void enable_ccdinr_memshare(void)
{
#if 0 // MAC3_FIX_ME_ASAP
	unsigned int _iTemp;

//	printf("*** REG(0xb8024010)=0x%08x\n", rtd_inl(0xb8024010));
//	printf("*** REG(0xb802404c)=0x%08x\n", rtd_inl(0xb802404c));
//	printf("*** REG(0xb8024000)=0x%08x\n", rtd_inl(0xb8024000));

	_iTemp = rtd_inl(0xb8024010);
	_iTemp |= 1UL<<19;
	rtd_outl(0xb8024010, _iTemp);	// force_2D = 1

	_iTemp = rtd_inl(0xb802404c);
	_iTemp &= ~(1UL<<10);
	rtd_outl(0xB802404C, _iTemp);	// force_2D_timing = 0

	_iTemp = rtd_inl(0xb8024000);
	_iTemp &= ~(1UL<<28);
	rtd_outl(0xb8024000, _iTemp);	// ip_enable = 0

	_iTemp = rtd_inl(0xb8024010);
	_iTemp |= 1UL<<29;
	rtd_outl(0xb8024010, _iTemp);	// Ccdinr_memshare_en = 1

//	printf("*** Enable DI memshare\n");
//	printf("*** REG(0xb8024010)=0x%08x\n", rtd_inl(0xb8024010));
//	printf("*** REG(0xb802404c)=0x%08x\n", rtd_inl(0xb802404c));
//	printf("*** REG(0xb8024000)=0x%08x\n", rtd_inl(0xb8024000));
#endif
}

void disable_ccdinr_memshare(void)
{
#if 0 // MAC3_FIX_ME_ASAP
	unsigned int _iTemp;

//	printf("*** REG(0xb8024010)=0x%08x\n", rtd_inl(0xb8024010));
//	printf("*** REG(0xb802404c)=0x%08x\n", rtd_inl(0xb802404c));
//	printf("*** REG(0xb8024000)=0x%08x\n", rtd_inl(0xb8024000));

	_iTemp = rtd_inl(0xb8024010);
	_iTemp &= ~(1UL<<19);
	rtd_outl(0xb8024010, _iTemp);	// force_2D = 0

	_iTemp = rtd_inl(0xb802404c);
	_iTemp &= ~(1UL<<10);
	rtd_outl(0xB802404C, _iTemp);	// force_2D_timing = 0

	_iTemp = rtd_inl(0xb8024000);
	_iTemp &= ~(1UL<<28);
	rtd_outl(0xb8024000, _iTemp);	// ip_enable = 0

	_iTemp = rtd_inl(0xb8024010);
	_iTemp &= ~(1UL<<29);
	rtd_outl(0xb8024010, _iTemp);	// Ccdinr_memshare_en = 0

//	printf("*** Disable DI memshare\n");
//	printf("*** REG(0xb8024010)=0x%08x\n", rtd_inl(0xb8024010));
//	printf("*** REG(0xb802404c)=0x%08x\n", rtd_inl(0xb802404c));
//	printf("*** REG(0xb8024000)=0x%08x\n", rtd_inl(0xb8024000));
#endif
}

/*
 * clock enable api
 */
void enable_clock(uint reg_reset, uint mask_reset, uint reg_clock, uint mask_clock)
{
	// rst = 0
	rtd_outl(reg_reset, mask_reset);

	// clk = 1
	rtd_outl(reg_clock, mask_clock|_BIT0);

	// clk = 0
	rtd_outl(reg_clock, mask_clock);

	// rst = 0
	rtd_outl(reg_reset, mask_reset);

	// wait
	udelay(10);

	// rst = 1
	rtd_outl(reg_reset, mask_reset|_BIT0);

	// wait
	udelay(10);

	// clk = 1
	rtd_outl(reg_clock, mask_clock|_BIT0);
}

/*
 * enable audio related clock
 */
void enable_audio_clock(void)
{
	// rst = 0
	// ACPU, AE
	// AUDIO2_DAC, AUDIO_ADC, AUDIO_DAC,AUDIO
	//rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT12 | _BIT2);
	rtd_outl(SYS_REG_SYS_SRST1_reg, _BIT19 | _BIT18 | _BIT17 | _BIT16 | _BIT10);

	// clk = 1
	// ACPU
	// AUDIO_PRE512FS
	// AUDIO2_512FS,pre_512fs_arc
	// audio_ad_128fs, audio2_dma_r_512fs, audio_dma_r_512fs, audio_da1_256fs, audio_da1_128fs
	// audio_da0_256fs, audio_da0_128fs, audio_ad_256fs, audio_ad_128fs
	//rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT12 | _BIT0);
	rtd_outl(SYS_REG_SYS_CLKEN1_reg, _BIT17 | _BIT10 | _BIT0);
	rtd_outl(SYS_REG_SYS_CLKEN2_reg, _BIT15 | _BIT6 | _BIT0);
	rtd_outl(SYS_REG_SYS_CLKEN3_reg, _BIT9 | _BIT8 | _BIT7 | _BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0);

	// clk = 0
	//rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT12);
	rtd_outl(SYS_REG_SYS_CLKEN1_reg, _BIT17 | _BIT10);
	rtd_outl(SYS_REG_SYS_CLKEN2_reg, _BIT15 | _BIT6);
	rtd_outl(SYS_REG_SYS_CLKEN3_reg, _BIT9 | _BIT8 | _BIT7 | _BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1);

	// rst = 0
	//rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT12 | _BIT2);
	rtd_outl(SYS_REG_SYS_SRST1_reg, _BIT19 | _BIT18 | _BIT17 | _BIT16 | _BIT10);
	udelay(10);

	// rst = 1
	//rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT12 | _BIT2 | _BIT0);
	rtd_outl(SYS_REG_SYS_SRST1_reg, _BIT19 | _BIT18 | _BIT17 | _BIT16 | _BIT10 | _BIT0);
	udelay(10);

	// clk = 1
//	rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT12 | _BIT0);
	rtd_outl(SYS_REG_SYS_CLKEN1_reg, _BIT17 | _BIT10 | _BIT0);
	rtd_outl(SYS_REG_SYS_CLKEN2_reg, _BIT15 | _BIT6 | _BIT0);
	rtd_outl(SYS_REG_SYS_CLKEN3_reg, _BIT9 | _BIT8 | _BIT7 | _BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT2 | _BIT1 | _BIT0);
}

#ifdef CONFIG_ACPU2_SUPPORT

/*
 * enable audio2 related clock
 */
void enable_audio2_clock(void)
{
	// rst = 0
	// ACPU2
	rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT11);

	// clk = 1
	// ACPU2
	rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT11 | _BIT0);

	// clk = 0
	rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT11);

	// rst = 0
	rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT11);
	udelay(10);

	// rst = 1
	rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT11 | _BIT0);
	udelay(10);

	// clk = 1
	rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT11 | _BIT0);
}

#endif

/*
 * enable video related clock
 */
void enable_video_clock(void)
{
	// rst = 0
	//VE_BLK_WRAP, VE_LGCY_P2, VE_LGCY, VDE, VE_P2, VE, VCPU
	// VDEC, ME, SE
	rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT9 | _BIT8 | _BIT6 | _BIT5 | _BIT4 | _BIT3);
	rtd_outl(SYS_REG_SYS_SRST1_reg, _BIT22 | _BIT12 | _BIT5 | _BIT4);

	// clk = 1
	// VE_LGCY_P2, VE_LGCY, VE_P2, VE, VCPU
	// VDEC, ME, SE
	rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT8   | _BIT7  | _BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT0);
	rtd_outl(SYS_REG_SYS_CLKEN1_reg, _BIT22 | _BIT12 | _BIT5 | _BIT0);

	// clk = 0
	rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT8  | _BIT7 | _BIT6 | _BIT5 | _BIT4 | _BIT3);
	rtd_outl(SYS_REG_SYS_CLKEN1_reg, _BIT22 | _BIT12 | _BIT5);

	// rst = 0
	rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT9 | _BIT8 | _BIT6 | _BIT5 | _BIT4 | _BIT3);
	rtd_outl(SYS_REG_SYS_SRST1_reg, _BIT22 | _BIT12 | _BIT5 | _BIT4);
	udelay(10);

	// rst = 1
	rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT9 | _BIT8 | _BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT0);
	rtd_outl(SYS_REG_SYS_SRST1_reg, _BIT22 | _BIT12 | _BIT5 | _BIT4 |  _BIT0);
	udelay(10);

	// clk = 1
	rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT8 | _BIT7 | _BIT6 | _BIT5 | _BIT4 | _BIT3 | _BIT0);
	rtd_outl(SYS_REG_SYS_CLKEN1_reg, _BIT22 | _BIT12 | _BIT5 | _BIT0);

#if 0 //cklai@move ssb7 priority setting from hw_setting to uboot due to clken here
	rtd_outl(SBX_ssb7_misc_ctrl_reg, 0x00000004);
#endif

}

#ifdef CONFIG_VCPU2_SUPPORT
/*
 * enable video2 related clock
 */
void enable_video2_clock(void)
{
	// rst = 0
	// VDE2, VE2_P2, VE2, VCPU2
	rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT17 | _BIT16 | _BIT15 | _BIT14);

	// clk = 1
	// VE2_P2, VE2, VCPU2
	rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT16 | _BIT15 | _BIT14 | _BIT0);

	// clk = 0
	rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT16 | _BIT15 | _BIT14);

	// rst = 0
	rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT17 | _BIT16 | _BIT15 | _BIT14);
	udelay(10);

	// rst = 1
	rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT17 | _BIT16 | _BIT15 | _BIT14 | _BIT0);
	udelay(10);

	// clk = 1
	rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT16 | _BIT15 | _BIT14 | _BIT0);
}
#endif

/*
 * enable PLLDDS PLLAUD
 */
void enable_plldds_pllaud(void)
{
	//-------- PLLDDSA,max 432-------------------------------------------------
	rtd_outl(PLL_REG_SYS_PLL_DISPA_SD2_reg,0x00000004);//PLLDDSA pll power down
	rtd_outl(PLL_REG_SYS_PLL_DISPA_SD1_reg,0x400DE000);//PLLDDSA_N=0x1(/2),CS=2'b11,CP=2'b11,ICP=4'b0000,RS=3'b110
	rtd_outl(PLL_REG_SYS_PLL_DISPA_SD2_reg,0x00003D05);//PLLDDSA pll power on,F=0,N=61,27/2*(61+3)/2=432MHz
	rtd_outl(PLL_REG_SYS_DVFS_DDSA_reg,0x58200015);//PLLDDSA_OC_EN=1,OC_MODE=0,OC_STEP=0x1,PLLDDSA_EN_PI_DEBUG=1,PLLDDSA_PI_CUR_SEL=0x2
	rtd_outl(PLL_REG_SYS_PLL_DISPA_SD2_reg,0x00003D07);//release PLLDDSA reset

	//-------- PLLDDSB,max 432-------------------------------------------------
	rtd_outl(PLL_REG_SYS_PLL_DISPB_SD2_reg,0x00000004);//PLLDDSB pll power down
	rtd_outl(PLL_REG_SYS_PLL_DISPB_SD1_reg,0x400DE000);//PLLDDSB_N=0x1(/2),CS=2'b11,CP=2'b11,ICP=4'b0000,RS=3'b110
	rtd_outl(PLL_REG_SYS_PLL_DISPB_SD2_reg,0x00003D05);//PLLDDSB pll power on,F=0,N=61,27/2*(61+3)/2=432MHz
	rtd_outl(PLL_REG_SYS_DVFS_DDSB_reg,0x58200015);//PLLDDSB_OC_EN=1,OC_MODE=0,OC_STEP=0x1,PLLDDSB_EN_PI_DEBUG=1,PLLDDSB_PI_CUR_SEL=0x2
	rtd_outl(PLL_REG_SYS_PLL_DISPB_SD2_reg,0x00003D07);//release PLLDDSB reset
}

/*
 * enable PLL27X
 */
void enable_pll27x(void)
{
#if 0 // fekao move to hw_setting: CRT.tbl
	rtd_outl(PLL27X_REG_SYS_PLL_27X3_reg,0x00000000);//PLL27X RST and Power off
	rtd_outl(PLL27X_REG_SYS_PLL_27X1_reg,0x0224000A);//M=10,324
	rtd_outl(PLL27X_REG_SYS_PLL_27X2_reg,0x880F6501);//XIXO driving=0x3,lowest
	rtd_outl(PLL27X_REG_SYS_PLL_27X3_reg,0x00000005);//PLL27X power on
	mdelay(1);//delay 1ms
	rtd_outl(PLL27X_REG_SYS_PLL_27X4_reg,0x2206FE01);
	rtd_outl(PLL27X_REG_SYS_PLL_27X3_reg,0x00000007);//PLL27X RST release
	mdelay(1);//delay 1ms
	rtd_outl(PLL27X_REG_SYS_PLL_27X3_reg,0x00000017);//PS_EN=1
#endif

	//-------- PLLDISP,max 630-------------------------------------------------
//	mark this line because panel cannot turn on
	rtd_outl(PLL27X_REG_SYS_PLL_DISP2,0x00000003);//DPLL_X_BPSIN=1
	rtd_outl(PLL27X_REG_SYS_PLL_DISP3_reg,0x20300004);//PLLDISP power down,hold reset,freeze
	rtd_outl(PLL27X_REG_SYS_PLL_DISP1_reg,0x01300330);//set M=19,N=0
	//Icp=b'0011,Rs=b'011,Cp=b'0
	rtd_outl(PLL27X_REG_PLL_SSC0_reg,0x00000800);//Oc_step_set=0x80,Fcode_t_ssc=0,27*[(19+3)+(0/2048)]=594
	//(M_CODE+3+(F_CODE/2048))/(N_CODE+2)/(O^2)
	rtd_outl(PLL27X_REG_SYS_PLL_DISP3_reg,0x20300005);//PLLDISP power on,DPLL_WDRST=0
	////ScalerTimer_DelayXms(0x200);//at least > 100us
	rtd_outl(PLL27X_REG_PLL_SSC0_reg,0x02AB0801);//Oc_en=1
	rtd_outl(PLL27X_REG_SYS_PLL_DISP3_reg,0x20300047);//release PLLDISP reset,DPLL_RSTB=1

	//-------- PLL AUD -------------------------------------------------
	rtd_outl(PLL27X_REG_SYS_PLL_AUD3_reg,0x00000000);//disable pllaud
	udelay(15);//at least > 10us
	rtd_outl(PLL27X_REG_SYS_PLL_PSAUD1_reg,0x00000000);//Disable PSAUD phase shifter & PSAUD all function
	udelay(15);//at least > 10us
	rtd_outl(PLL27X_REG_SYS_PLL_PSAUD1_reg,0x00000004);//PSAUD_EN 0 --> 1
	udelay(15);//at least > 10us
	rtd_outl(PLL27X_REG_SYS_PLL_PSAUD1_reg,0x0000000C);//PSAUD_PSEN 0 --> 1
	udelay(15);//at least > 10us
	rtd_outl(PLL27X_REG_SYS_PLL_AUD3_reg,0x00000019);//Enable PLLAUD_CK196M/CK295M output

}
/*
 * enable pll output
 */
void enable_plloutput(void)
{
	udelay(300); // wait at least > 150us
	rtd_outl(PLL_REG_SYS_PLL_DISPA_SD2_reg,0x00003D03);// PLLDDSA output enable
	rtd_outl(PLL_REG_SYS_PLL_DISPB_SD2_reg,0x00003D03);// PLLDDSB output enable
	rtd_outl(PLL27X_REG_SYS_PLL_DISP3_reg, 0x20300043);// PLLDISP output enable
}
/*
 * Enable essential clock domains, modules and
 * do some additional special settings needed
 */
int clock_init(void)
{
#if 0 // MAC3_FIX_ME_ASAP
	//enable DCSYS error command detection
	rtd_outl(DC_EC_ADDCMD_HI_VADDR, 0x0);
	rtd_outl(DC_EC_ADDCMD_LO_VADDR, 0x0);
	rtd_outl(DC_EC_CTRL_VADDR, _BIT3 | _BIT2 | _BIT1 | _BIT0);
	rtd_outl(DC_RD_TAG_CHECK_VADDR, _BIT1 | _BIT0);

	// disable write merge
	//rtd_outl(DC_EXP_LANE_CTRL_VADDR, 0x1);

	// enable rbus timeout
	//rtd_outl(SB2_INV_INT_EN_VADDR, _BIT5 | _BIT4 | _BIT0);
#endif

#ifdef CONFIG_REALTEK_WATCHDOG
	//enable_clock(STB_WDOG_DATA13_reg, _BIT1, STB_WDOG_DATA14_reg, _BIT1); // WDog
#endif

	enable_clock(SYS_REG_SYS_SRST1_reg, _BIT5 | _BIT16, SYS_REG_SYS_CLKEN1_reg, _BIT5 | _BIT16 ); // SE, AUDIO
	enable_clock(SYS_REG_SYS_SRST2_reg, _BIT9, SYS_REG_SYS_CLKEN2_reg, _BIT9); // PWM
	enable_clock(SYS_REG_SYS_SRST3_reg, _BIT28, SYS_REG_SYS_CLKEN3_reg, _BIT28); // LZMA
	enable_clock(STB_ST_SRST0_reg, _BIT3, STB_ST_CLKEN0_reg, _BIT3); // ISO_PWM
	//enable_clock(STB_ST_SRST1_reg, _BIT16, STB_ST_CLKEN1_reg, _BIT15); // LSADC

	enable_plldds_pllaud(); // PLLDDS/PLLAUD
	enable_pll27x(); //PLL27x
	enable_plloutput(); // output enable

	rtk_do_ip_bisr(); // do ip's bisr

	return 0;

}

int strClock_init(void)
{
#if 0 // MAC3_FIX_ME_ASAP
	//enable DCSYS error command detection
	rtd_outl(DC_EC_ADDCMD_HI_VADDR, 0x0);
	rtd_outl(DC_EC_ADDCMD_LO_VADDR, 0x0);
	rtd_outl(DC_EC_CTRL_VADDR, _BIT3 | _BIT2 | _BIT1 | _BIT0);
	rtd_outl(DC_RD_TAG_CHECK_VADDR, _BIT1 | _BIT0);

	// disable write merge
	//rtd_outl(DC_EXP_LANE_CTRL_VADDR, 0x1);

	// enable rbus timeout
	//rtd_outl(SB2_INV_INT_EN_VADDR, _BIT5 | _BIT4 | _BIT0);
#endif

#ifdef CONFIG_REALTEK_WATCHDOG
	//enable_clock(STB_WDOG_DATA13_reg, _BIT1, STB_WDOG_DATA14_reg, _BIT1); // WDog
#endif

	enable_clock(SYS_REG_SYS_SRST1_reg, _BIT5 | _BIT16, SYS_REG_SYS_CLKEN1_reg, _BIT5 | _BIT16 ); // SE, AUDIO
	enable_clock(SYS_REG_SYS_SRST2_reg, _BIT9, SYS_REG_SYS_CLKEN2_reg, _BIT9); // PWM
	enable_clock(SYS_REG_SYS_SRST3_reg, _BIT28, SYS_REG_SYS_CLKEN3_reg, _BIT28); // LZMA
	//enable_clock(STB_ST_SRST0_reg, _BIT3, STB_ST_CLKEN0_reg, _BIT3); // ISO_PWM  just mark this one for google/tally led which use iso pwm
	//enable_clock(STB_ST_SRST1_reg, _BIT16, STB_ST_CLKEN1_reg, _BIT15); // LSADC

	enable_plldds_pllaud(); // PLLDDS/PLLAUD
	enable_pll27x(); //PLL27x
	enable_plloutput(); // output enable

	rtk_do_ip_bisr(); // do ip's bisr

	return 0;

}

void disable_acpu_clock(void)
{
	//  Reset flow : CLKEN = "0"  -> RSTN = 0 -> RSTN = 1 -> CLKEN = 1
	//rtd_outl(SYS_REG_SYS_CLKEN0_reg, _BIT12);
	//rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT12);
	//rtd_outl(SYS_REG_SYS_SRST0_reg, _BIT12 | _BIT0);
}
