/*
 *  On-line: Bootcode need to generate environment variable "system_parameters",
 *           and pass them to kernel for installer.
 *
 * Off-line: When generating bootloader.tar in compile time,
 *           we need to pass the system_parameters for image_file_creator.
 */

#ifndef __SYS_PARAM__
#define __SYS_PARAM__

/*
 ************************************************
 * Attention:
 *   Because this file will be included by image_file_creator,
 *     please don't add code that depends on bootcode definition.
 *
 * Ex.
 *     (X) include "some_define.h"
 *     (X) #define SYS_PARAM_SOME_DEFINE CONFIG_SOME_DEFINE
 *     (X) #ifdef CONFIG_SOME_DEFINE
 ************************************************
 */

/* system_parameter_1 */
#define SYS_PARAM_TV_SYSTEM						"NULL"

/* system_parameter_2 */
#define SYS_PARAM_BOOT_FLASH					"emmc"

/* system_parameter_3 */
#define SYS_PARAM_BOOTCODE_START				0x1bc00		// blk_no: 0xDE ~ 0xC000 // sync with dvrmain.c
#define SYS_PARAM_BOOTCODE_SIZE					0x1800000	// 24M

/* system_parameter_4 */
#define SYS_PARAM_FACTORY_RO_START				0x1800000	// blk_no: 0xC000 ~ 0xE000
#define SYS_PARAM_FACTORY_RO_SIZE				0x400000	// 4M

/* system_parameter_5 */
#define SYS_PARAM_FACTORY_EEPROM_START			0x1C00000	// blk_no: 0xE000 ~ 0x1E000
#define SYS_PARAM_FACTORY_EEPROM_SIZE			0x2F00000	// 47M

/* system_parameter_6 */
#define SYS_PARAM_FACTORY_START					0x4B00000	// blk_no: 0x1E000 ~ 0x26000
#define SYS_PARAM_FACTORY_SIZE					0x0100000	// 1M

/* system_parameter_7 */
#define SYS_PARAM_SECURE_STORE_START			0x4C00000	// blk_no: 0x26000 ~ 0x2E000
#define SYS_PARAM_SECURE_STORE_SIZE				0x1000000	// 16M

/* system_parameter_8 */
#define SYS_PARAM_RESERVED_START				0x5c00000	// blk_no: 0x2E000~ 0x36000
#define SYS_PARAM_RESERVED_SIZE					0x1000000	// 16M

/*fw_table addr*/
#define SYS_PARAM_FW_TABLE_START				0x6C00000	// blk_no:0x36000

/* system_parameter_9 */
#define SYS_PARAM_EMCU_START					0x3FD800	// blk_no: 0x1FEC
#define SYS_PARAM_EMCU_SIZE						0x2800
#define SYS_PARAM_RESCUE_START					0x200000	// blk_no: 0x1000
#define SYS_PARAM_RESCUE_SIZE					0x1000000
#define SYS_PARAM_K_RESCUE_START				0x1200000	// blk_no: 0x9000


#endif /* __SYS_PARAM__ */
