

/************************************************************************
 *  Include files
 ************************************************************************/

//#include <sysdefs.h>
//#include <sys_api.h>
//#include <syscon_api.h>
//#include <env_api.h>
//#include <env.h>
//#include <product.h>

//#include <syserror.h>
//#include <stdio.h>
//#include <string.h>
#include <common.h>
#include <malloc.h>
#include <linux/ctype.h>
#include <panel.h>

#include <panel_config_parameter.h>

#include <asm/io.h>
#include <platform_lib/board/pcb_mgr.h>
#include <platform_lib/board/pcb.h>
#include <asm/arch/factorylib.h>

#ifdef PANEL_CONFIG_FROM_FACTORY_PANEL_BIN
 #ifdef CONFIG_REALTEK_EERPOM_TV010_A
 #include "../drivers/eeprom/EEP_TV010_A/eeprom.h"
 #endif
 #include <config.h>

 #if defined(VBY_ONE_PANEL_CMI_V500_4K2K_VBY1)
 #include <asm/arch/panel/CMI_V500_4K2K_VBY1.h>
 #elif defined(VBY_ONE_PANEL_CHINA_STAR_4K2K_VBY1)
 #include <asm/arch/panel/China_Star_4K2K_VBY1.h>
 #elif defined(LVDS_PANEL_TSB_CMI_V400HJ2_PE1_REVC1)
 #include <asm/arch/panel/CMI_V400HJ2-PE1_REVC1.h>
 #elif defined(LVDS_PANEL_TSB_SAMSUNG_LSC400HM03)
 #include <asm/arch/panel/tsb_samsung_lsc400hm03.h>
 #elif defined(CONFIG_PANEL_NAME)
  #ifdef CONFIG_CUSTOMER_TV010
   #include <asm/arch/panel/Skyworth_Default_4K2K_VBY1.h>
  #else
   #include CONFIG_PANEL_NAME
  #endif
 #else
 #include <asm/arch/panel/default_panel.h>
 #endif
#endif

#ifdef CONFIG_CUSTOM_SN_PANEL
#include <asm/arch/panel/SN_4K2K_VBY1_1Seg8Port.h>
#define PANEL_NUM 16

extern PANEL_CONFIG_PARAMETER panel_setting[PANEL_NUM];
#else
#include <panel_setting.h>
#endif


/************************************************************************
 *  Definitions
 ************************************************************************/
//#define PANEL_ADJUST_PRINT	printf
#define PANEL_ADJUST_PRINT

uchar vby1_aphy16_23_output = 0; 
/************************************************************************
 *  Public variables
 ************************************************************************/
struct _PANEL_CONFIG_PARAMETER  default_panel_parameter;
#if defined(USE_PANEL_CONFIG_PARAM_EXTEND_FOR_TV035)
struct _C_PANEL_CONFIG_PARAM_EXTEND  default_c_panel_param_extend;

#define PANEL_EXTEND_BIN_FILE			FACTORY_HEADER_FILE_NAME"bin_panel/panel_extend/"
#endif
//UINT8 LVDS_4_PORTS_INDEX;
/************************************************************************
 *  Static variables
 ************************************************************************/

/* Default settings of env. variables */



/************************************************************************
 *  Static function prototypes
 ************************************************************************/

/************************************************************************
 *  Implementation : Static functions
 ************************************************************************/
#if defined(PANEL_CONFIG_FROM_FACTORY_PANEL_BIN) || defined(CONFIG_CUSTOM_SN_PANEL)
uint env_panel_change_panel_bin_in_factory(char *panel_bin_path)
{
	int ret = 0;

	//ret = factory_delete(panel_bin_path);
	//if (ret)
	//{
	//	printf("[ERR] remove %s failed\n", panel_bin_path);
	//}

	ret = factory_write(panel_bin_path, (char *)&default_panel_parameter, sizeof(default_panel_parameter));
	if (ret)
	{
		printf("[ERR] write %s failed\n", panel_bin_path);
	}

	ret = factory_save();
	if (ret)
	{
		printf("[ERR] save facroty failed\n");
	}

	return ret;
}

#endif


#if defined(PANEL_CONFIG_FROM_FACTORY_PANEL_BIN) && defined(PANEL_LIST_FROM_FACTORY)||defined(CONFIG_CUSTOM_SN_PANEL)
void env_panel_set_default(void)
{
	memset(&default_panel_parameter, 0, sizeof(PANEL_CONFIG_PARAMETER));

	default_panel_parameter.iCONFIG_DISPLAY_PORT					= CONFIG_DISPLAY_PORT ;
	default_panel_parameter.iCONFIG_DISPLAY_COLOR_BITS				= CONFIG_DISPLAY_COLOR_BITS ;
	default_panel_parameter.iCONFIG_DISPLAY_EVEN_RSV1_BIT			= CONFIG_DISPLAY_EVEN_RSV1_BIT ;
	default_panel_parameter.iCONFIG_DISPLAY_ODD_RSV1_BIT			= CONFIG_DISPLAY_ODD_RSV1_BIT ;
	default_panel_parameter.iCONFIG_DISPLAY_BITMAPPING_TABLE		= CONFIG_DISPLAY_BITMAPPING_TABLE ;
	default_panel_parameter.iCONFIG_DISPLAY_PORTAB_SWAP 			= CONFIG_DISPLAY_PORTAB_SWAP ;
	default_panel_parameter.iCONFIG_DISPLAY_RED_BLUE_SWAP			= CONFIG_DISPLAY_RED_BLUE_SWAP ;
	default_panel_parameter.iCONFIG_DISPLAY_MSB_LSB_SWAP			= CONFIG_DISPLAY_MSB_LSB_SWAP ;
	default_panel_parameter.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT		= CONFIG_DISPLAY_SKEW_DATA_OUTPUT ;
	default_panel_parameter.iCONFIG_DISPLAY_OUTPUT_INVERSE			= CONFIG_DISPLAY_OUTPUT_INVERSE ;
	default_panel_parameter.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL	= CONFIG_DISPLAY_VERTICAL_SYNC_NORMAL ;
	default_panel_parameter.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL	= CONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL ;
	default_panel_parameter.iCONFIG_DISPLAY_RATIO_4X3				= CONFIG_DISPLAY_RATIO_4X3 ;
	default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MAX				= CONFIG_DISPLAY_CLOCK_MAX ;
	default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MIN				= CONFIG_DISPLAY_CLOCK_MIN ;
	default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE			= CONFIG_DISPLAY_REFRESH_RATE ;
	default_panel_parameter.iCONFIG_DISPLAY_CLOCK_TYPICAL			= CONFIG_DISPLAY_CLOCK_TYPICAL ;
	default_panel_parameter.iCONFIG_DISP_HORIZONTAL_TOTAL			= CONFIG_DISP_HORIZONTAL_TOTAL ;
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL 			= CONFIG_DISP_VERTICAL_TOTAL ;
	default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH				= CONFIG_DISP_HSYNC_WIDTH ;
	default_panel_parameter.iCONFIG_DISP_VSYNC_LENGTH				= CONFIG_DISP_VSYNC_LENGTH ;
	default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS				= CONFIG_DISP_DEN_STA_HPOS ;
	default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS				= CONFIG_DISP_DEN_END_HPOS ;
	default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS				= CONFIG_DISP_DEN_STA_VPOS ;
	default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS				= CONFIG_DISP_DEN_END_VPOS ;
	default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS				= CONFIG_DISP_ACT_STA_HPOS ;
	default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS				= CONFIG_DISP_ACT_END_HPOS ;
	default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS				= CONFIG_DISP_ACT_STA_VPOS ;
	default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS				= CONFIG_DISP_ACT_END_VPOS ;
	default_panel_parameter.iCONFIG_DISP_HSYNC_LASTLINE 			= CONFIG_DISP_HSYNC_LASTLINE ;
	default_panel_parameter.iCONFIG_DISP_DCLK_DELAY 				= CONFIG_DISP_DCLK_DELAY ;
	default_panel_parameter._iCONFIG_DISP_ACT_STA_BIOS				= _CONFIG_DISP_ACT_STA_BIOS ;
	default_panel_parameter.iCONFIG_DEFAULT_DPLL_M_DIVIDER			= CONFIG_DEFAULT_DPLL_M_DIVIDER ;
	default_panel_parameter.iCONFIG_DEFAULT_DPLL_N_DIVIDER			= CONFIG_DEFAULT_DPLL_N_DIVIDER ;
	default_panel_parameter.iPANEL_TO_LVDS_ON_ms					= PANEL_TO_LVDS_ON_ms ;
	default_panel_parameter.iLVDS_TO_LIGHT_ON_ms					= LVDS_TO_LIGHT_ON_ms ;
	default_panel_parameter.iLIGHT_TO_LDVS_OFF_ms					= LIGHT_TO_LDVS_OFF_ms ;
	default_panel_parameter.iLVDS_TO_PANEL_OFF_ms					= LVDS_TO_PANEL_OFF_ms ;
	default_panel_parameter.iPANEL_OFF_TO_ON_ms 					= PANEL_OFF_TO_ON_ms ;
	default_panel_parameter.iCONFIG_BACKLIGHT_PWM_FREQ				= CONFIG_BACKLIGHT_PWM_FREQ ;
	default_panel_parameter.iCONFIG_BACKLIGHT_PWM_DUTY				= CONFIG_BACKLIGHT_PWM_DUTY ;
	default_panel_parameter.iFIX_LAST_LINE_ENABLE					= FIX_LAST_LINE_ENABLE ;
	default_panel_parameter.iFIX_LAST_LINE_4X_ENABLE				= FIX_LAST_LINE_4X_ENABLE ;
	default_panel_parameter.iVFLIP									= CONFIG_VFLIP_ON ;
	default_panel_parameter.iPICASSO_CONTROL_ON 					= CONFIG_PICASSO_CONTROL_ON ;
	default_panel_parameter.i3D_DISPLAY_SUPPORT 					= CONFIG_3D_DISPLAY_SUPPORT_ON ;
	default_panel_parameter.i3D_LINE_ALTERNATIVE_SUPPORT			= CONFIG_3D_LINE_ALTERNATIVE_ON ;
	default_panel_parameter.i3D_PR_OUTPUT_LR_SWAP					= CONFIG_3D_PR_OUTPUT_LR_SWAP ;
	default_panel_parameter.i3D_SG_OUTPUT_120HZ_ON					= CONFIG_3D_SG_OUTPUT_120HZ_ON ;
	default_panel_parameter.i3D_SG_24HZ_OUTPUT_FHD_ON				= CONFIG_3D_SG_24HZ_OUTPUT_FHD_ON ;
	default_panel_parameter.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE		= CONFIG_SCALER_2D_3D_CVT_HWSHIFT_ON ;
	default_panel_parameter.iCONFIG_SFG_SEG_NUM 					= CONFIG_SFG_SEG_NUM;
	default_panel_parameter.iCONFIG_SFG_PORT_NUM					= CONFIG_SFG_PORT_NUM;
	default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG1			= CONFIG_DISPLAY_PORT_CONFIG1;
	default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG2			= CONFIG_DISPLAY_PORT_CONFIG2;

#ifdef CONFIG_LVDS_4_PORTS_INDEX
	default_panel_parameter.iCONFIG_LVDS_4_PORTS_INDEX				= CONFIG_LVDS_4_PORTS_INDEX;
#else
	default_panel_parameter.iCONFIG_LVDS_4_PORTS_INDEX				= 0;
#endif

#ifdef CONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN	= CONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN;
#else
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN	= 0;
#endif

#ifdef CONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX	= CONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX;
#else
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX	= 0;
#endif

#ifdef CONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN	= CONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN;
#else
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN	= 0;
#endif

#ifdef CONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX	= CONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX;
#else
	default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX	= 0;
#endif

#ifdef CONFIG_LVDS_PN_SWAP
	default_panel_parameter.iCONFIG_LVDS_PN_SWAP	= 1;
	printf(" LVDS_PN_SWAP ON \n ");
#else
	default_panel_parameter.iCONFIG_LVDS_PN_SWAP	= 0;
#endif

#ifdef CONFIG_LVDS_MIRROR
	default_panel_parameter.iCONFIG_LVDS_MIRROR 	= 1;
	printf(" Rescue_With_Lvds_Mirror ON \n ");
#else
	default_panel_parameter.iCONFIG_LVDS_MIRROR 	= 0;
#endif

#ifdef CONFIG_PANEL_TYPE
	default_panel_parameter.iCONFIG_PANEL_TYPE 	= CONFIG_PANEL_TYPE;
#else
	default_panel_parameter.iCONFIG_PANEL_TYPE 	= 0;
#endif

#ifdef CONFIG_PANEL_CUSTOM_INDEX
	default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX = CONFIG_PANEL_CUSTOM_INDEX;
#else
	default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX	= 0;
#endif

	default_panel_parameter.iCONFIG_SR_MODE 		= CONFIG_SR_MODE;
	default_panel_parameter.iCONFIG_SR_PIXEL_MODE	= CONFIG_SR_PIXEL_MODE;

	default_panel_parameter.i3D_DISPLAY_TIMING			= CONFIG_PANEL_3D_TIMING;
	default_panel_parameter.iCONFIG_CUSTOMER_PANEL_ID	= CONFIG_CUSTOMER_PANEL_ID;

#ifdef CONFIG_CUSTOM_SN_PANEL
	default_panel_parameter.iPANEL_WIDTH_MM= CONFIG_PANEL_WIDTH_MM;
	default_panel_parameter.iPANEL_HEIGHT_MM= CONFIG_PANEL_HEIGHT_MM;
	default_panel_parameter.iBACKLIGHT_PWM_48HZ_FREQ= CONFIG_BACKLIGHT_PWM_48HZ_FREQ;
	default_panel_parameter.iBACKLIGHT_PWM_50HZ_FREQ= CONFIG_BACKLIGHT_PWM_50HZ_FREQ;
	default_panel_parameter.iBACKLIGHT_PWM_60HZ_FREQ= CONFIG_BACKLIGHT_PWM_60HZ_FREQ;
	
	default_panel_parameter.iPixelClk60Hz= CONFIG_PIXEL_CLK_60Hz;
	default_panel_parameter.iHTotal60Hz= CONFIG_HTOTAL_60Hz;
	default_panel_parameter.iVTotal60Hz=CONFIG_VTOTAL_60Hz; 
	default_panel_parameter.iHSyncWidth_60Hz=CONFIG_HSYNC_WIDTH_60Hz;
	default_panel_parameter.iVSyncWidth_60Hz=CONFIG_VSYNC_WIDTH_60Hz;
	default_panel_parameter.iHFrontPorch_60Hz=CONFIG_HFRONT_PORCH_60Hz;
	default_panel_parameter.iHbackPorch_60Hz=CONFIG_HBACK_PORCH_60Hz;
	default_panel_parameter.iVFrontPorch_60Hz=CONFIG_VFRONT_PORCH_60Hz;
	default_panel_parameter.iVbackPorch_60Hz=CONFIG_VBACK_PORCH_60Hz;

	default_panel_parameter.iPixelClk50Hz= CONFIG_PIXEL_CLK_50Hz;
	default_panel_parameter.iHTotal50Hz= CONFIG_HTOTAL_50Hz;
	default_panel_parameter.iVTotal50Hz=CONFIG_VTOTAL_50Hz; 
	default_panel_parameter.iHSyncWidth_50Hz=CONFIG_HSYNC_WIDTH_50Hz;
	default_panel_parameter.iVSyncWidth_50Hz=CONFIG_VSYNC_WIDTH_50Hz;
	default_panel_parameter.iHFrontPorch_50Hz=CONFIG_HFRONT_PORCH_50Hz;
	default_panel_parameter.iHbackPorch_50Hz=CONFIG_HBACK_PORCH_50Hz;
	default_panel_parameter.iVFrontPorch_50Hz=CONFIG_VFRONT_PORCH_50Hz;
	default_panel_parameter.iVbackPorch_50Hz=CONFIG_VBACK_PORCH_50Hz;

	default_panel_parameter.iPixelClk48Hz= CONFIG_PIXEL_CLK_48Hz;
	default_panel_parameter.iHTotal48Hz= CONFIG_HTOTAL_48Hz;
	default_panel_parameter.iVTotal48Hz=CONFIG_VTOTAL_48Hz; 
	default_panel_parameter.iHSyncWidth_48Hz=CONFIG_HSYNC_WIDTH_48Hz;
	default_panel_parameter.iVSyncWidth_48Hz=CONFIG_VSYNC_WIDTH_48Hz;
	default_panel_parameter.iHFrontPorch_48Hz=CONFIG_HFRONT_PORCH_48Hz;
	default_panel_parameter.iHbackPorch_48Hz=CONFIG_HBACK_PORCH_48Hz;
	default_panel_parameter.iVFrontPorch_48Hz=CONFIG_VFRONT_PORCH_48Hz;
	default_panel_parameter.iVbackPorch_48Hz=CONFIG_VBACK_PORCH_48Hz;
#endif	
	

	strcpy(default_panel_parameter.sPanelName, CONFIG_DISP_PANEL_NAME);

#ifdef CONFIG_CUSTOMER_TV010
    ////for TV010
    default_panel_parameter.iCONFIG_BACKLIGHT_DUTYMAX = CONFIG_BACKLIGHT_DUTYMAX;
    default_panel_parameter.iCONFIG_BACKLIGHT_DUTYMIN = CONFIG_BACKLIGHT_DUTYMIN;
    default_panel_parameter.iCONFIG_PANEL_GAMMA_TYPE = CONFIG_PANEL_GAMMA_TYPE;

    default_panel_parameter.iCONFIG_TCON_MODE0 = CONFIG_TCON_MODE0;
    default_panel_parameter.iCONFIG_TCON_MODE1 = CONFIG_TCON_MODE1;
    default_panel_parameter.iCONFIG_HDREN = CONFIG_HDREN;
    default_panel_parameter.iCONFIG_LDEN = CONFIG_LDEN;

    default_panel_parameter.iCONFIG_PANELSIZE = CONFIG_PANELSIZE;
    default_panel_parameter.iCONFIG_IPWMFeq = CONFIG_IPWMFeq;
    default_panel_parameter.iCONFIG_IPWMDuty = CONFIG_IPWMDuty;
    default_panel_parameter.iCONFIG_VPWMFeq = CONFIG_VPWMFeq;
    default_panel_parameter.iCONFIG_VPWMDuty = CONFIG_VPWMDuty;

    default_panel_parameter.iCONFIG_SSC_Enable = CONFIG_SSC_Enable;
    default_panel_parameter.iCONFIG_SSC_Freq = CONFIG_SSC_Freq;
    default_panel_parameter.iCONFIG_EYE_TX_Enable = CONFIG_EYE_TX_Enable;
    default_panel_parameter.iCONFIG_SSC_Level = CONFIG_SSC_Level;
    default_panel_parameter.iCONFIG_TCON_TYPE = CONFIG_TCON_TYPE;

    default_panel_parameter.iCONFIG_Enable_FLL_Clock_Adjust = CONFIG_Enable_FLL_Clock_Adjust;
    default_panel_parameter.iCONFIG_FLL_NEW_MODE_SYNTHESISN_Val = CONFIG_FLL_NEW_MODE_SYNTHESISN_Val;
    default_panel_parameter.iCONFIG_Fix_last_line_systhesisn_ratio = CONFIG_Fix_last_line_systhesisn_ratio;

    default_panel_parameter.iCONFIG_LD_Enable = CONFIG_LD_Enable;
    default_panel_parameter.iCONFIG_LD_SPIDecoderMcuInPower_Enable = CONFIG_LD_SPIDecoderMcuInPower_Enable;
    default_panel_parameter.iCONFIG_LD_Partition_Amount = CONFIG_LD_Partition_Amount;
    default_panel_parameter.iCONFIG_LD_Alogorithm_Soc = CONFIG_LD_Alogorithm_Soc;

    default_panel_parameter.iCONFIG_OFFRS_TIMEOUT = CONFIG_OFFRS_TIMEOUT;

    default_panel_parameter.iCONFIG_EYE_TX_Amplitude_Current = CONFIG_EYE_TX_Amplitude_Current;
    default_panel_parameter.iCONFIG_EYE_TX_Termination_Res = CONFIG_EYE_TX_Termination_Res;
    default_panel_parameter.iCONFIG_EYE_TX_Bias_Voltage = CONFIG_EYE_TX_Bias_Voltage;
    default_panel_parameter.iCONFIG_EYE_TX_Emphasis_Current = CONFIG_EYE_TX_Emphasis_Current;
    default_panel_parameter.iCONFIG_EYE_TX_Output_Enable = CONFIG_EYE_TX_Output_Enable;
    default_panel_parameter.iCONFIG_Force60Hz_Nosignal_PlayPic = CONFIG_Force60Hz_Nosignal_PlayPic;
    default_panel_parameter.iCONFIG_SSC_FineTune_Enable = CONFIG_SSC_FineTune_Enable;
    default_panel_parameter.iCONFIG_FORCE_HDR_VIVID_Enable = CONFIG_FORCE_HDR_VIVID_Enable;
    default_panel_parameter.iCONFIG_VIP_HDR_3DLUT_ENABLE = CONFIG_VIP_HDR_3DLUT_ENABLE;
    default_panel_parameter.iCONFIG_EYE_EPI_TX_Enable = CONFIG_EYE_EPI_TX_Enable;
#endif // CONFIG_CUSTOMER_TV010
}
#else

int env_panel_set_by_name(char * name,int len)
{
	int cnt = 0;
	char * p,* q;
	int i;
	for(i = 0;i < PANEL_NUM;++i)
	{
		p = (char *)panel_setting[i].sPanelName;
		q = name;
		//printf("\nstart compare panel_name:");
		for(cnt = 0;cnt <= len;++cnt)
		{
			if(*p != *q)
			{
				//printf("\nfail:panel[%d]:%c name[%d]:%c ",cnt,*p,cnt,*q);
				break;
			}
			else
			{
				//printf("%c",*p);
				p++;
				q++;
			}
		}
		if(cnt > len)
		{
			return i;
		}
	}

	return -1;
}

extern int CusApi_env_setup_env_panel(void);
extern int check_PQ_file_current_status(const char *cur_panelname);
void env_panel_set_default(void)
{
	const char *panelselect = getenv("panel_select");
	int ret = 0;

#ifdef CONFIG_AUTODETECT_PANEL
	const char *paneldetect = getenv("panel_detect"); // 0:auto, 1:manual
#endif

	int select = 0; // default is benq22 panel
#ifdef CONFIG_SYS_PANEL_SUPPORT_INI_FILE
	int panel_src = 0; // 0:from ini, 1:from built-in
#endif

#ifdef CONFIG_AUTODETECT_PANEL
	if( panelselect != NULL && simple_strtoul(paneldetect, NULL, 10) != 0)
	{
		select = simple_strtoul(panelselect, NULL, 10);
	}
	else // panel detect mode is auto, set select to panle_num
	{
		extern int panel_num;
		if(panel_num != -1)
			select = panel_num;
		else
		{
			printf("[ERR] auto detect panel has something wrong, set panel to  %s !!!\n", panel_setting[select].sPanelName);
		}
	}
#else
	if( panelselect != NULL)
	{
		select = simple_strtoul(panelselect, NULL, 10);
#ifdef CONFIG_SYS_PANEL_SUPPORT_INI_FILE
		panel_src = 1; // 1:from built-in
#endif
	}
	else
	{
#ifdef CONFIG_SYS_PANEL_SUPPORT_INI_FILE
		panel_src = 0; // 0:from ini
#endif
	}
#endif

#if defined(Config_Module_Test_Boot_TRUE)
#ifdef CONFIG_FORCE_PANEL_NUM
#ifdef CONFIG_SYS_PANEL_SUPPORT_INI_FILE
	panel_src = 1; // 1:from built-in
#endif
	select = FORCE_PANEL_NUM; // for MT, force set to panel 9
#endif
#endif

#ifdef CONFIG_SYS_PANEL_SUPPORT_INI_FILE	
	printf(":Y: %s panel_src=%d, panel_select=%d\n", __FUNCTION__, panel_src, select);

	if(panel_src == 0){ // try to use ini setting
		printf(":Y: try to get setting from <%s>\n", PANEL_INI_FILE_NAME);
		if(CusApi_env_setup_env_panel() == 0){ // fail to get ini panel
			select = 0; // default use 0
			printf(":Y: from ini failed, use default [%d]\n", select);
			memcpy(&default_panel_parameter, &panel_setting[select], sizeof(PANEL_CONFIG_PARAMETER));
		}
		else{
			printf(":Y: from ini ok\n");
		}
	}
	else {
		printf(":Y: panel use [%d]\n", select);
		memcpy(&default_panel_parameter, &panel_setting[select], sizeof(PANEL_CONFIG_PARAMETER));
	}
#else
	memcpy(&default_panel_parameter, &panel_setting[select], sizeof(PANEL_CONFIG_PARAMETER));
#endif
	ret = check_PQ_file_current_status(panel_setting[select].sPanelName);
	if(ret < 0)
		printf("No match pq file at factory!\r\n");
	
#if 0 // print panel setting info
	printf("iCONFIG_DISPLAY_PORT=%d\n", default_panel_parameter.iCONFIG_DISPLAY_PORT);
	printf("iCONFIG_DISPLAY_COLOR_BITS=%d\n", default_panel_parameter.iCONFIG_DISPLAY_COLOR_BITS);
	printf("iCONFIG_DISPLAY_EVEN_RSV1_BIT=%d\n", default_panel_parameter.iCONFIG_DISPLAY_EVEN_RSV1_BIT);
	printf("iCONFIG_DISPLAY_ODD_RSV1_BIT=%d\n", default_panel_parameter.iCONFIG_DISPLAY_ODD_RSV1_BIT);
	printf("iCONFIG_DISPLAY_BITMAPPING_TABLE=%d\n", default_panel_parameter.iCONFIG_DISPLAY_BITMAPPING_TABLE);
	printf("iCONFIG_DISPLAY_PORTAB_SWAP=%d\n", default_panel_parameter.iCONFIG_DISPLAY_PORTAB_SWAP);

	printf("iCONFIG_DISPLAY_RED_BLUE_SWAP=%d\n", default_panel_parameter.iCONFIG_DISPLAY_RED_BLUE_SWAP);
	printf("iCONFIG_DISPLAY_MSB_LSB_SWAP=%d\n", default_panel_parameter.iCONFIG_DISPLAY_MSB_LSB_SWAP);
	printf("iCONFIG_DISPLAY_SKEW_DATA_OUTPUT=%d\n", default_panel_parameter.iCONFIG_DISPLAY_SKEW_DATA_OUTPUT);
	printf("iCONFIG_DISPLAY_OUTPUT_INVERSE=%d\n", default_panel_parameter.iCONFIG_DISPLAY_OUTPUT_INVERSE);
	printf("iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL=%d\n", default_panel_parameter.iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL);
	printf("iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL=%d\n", default_panel_parameter.iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL);
	printf("iCONFIG_DISPLAY_RATIO_4X3=%d\n", default_panel_parameter.iCONFIG_DISPLAY_RATIO_4X3);

	printf("iCONFIG_DISPLAY_CLOCK_MAX=%d\n", default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MAX);
	printf("iCONFIG_DISPLAY_CLOCK_MIN=%d\n", default_panel_parameter.iCONFIG_DISPLAY_CLOCK_MIN);
	printf("iCONFIG_DISPLAY_REFRESH_RATE=%d\n", default_panel_parameter.iCONFIG_DISPLAY_REFRESH_RATE);
	printf("iCONFIG_DISPLAY_CLOCK_TYPICAL=%d\n", default_panel_parameter.iCONFIG_DISPLAY_CLOCK_TYPICAL);

	printf("iCONFIG_DISP_HORIZONTAL_TOTAL=%d\n", default_panel_parameter.iCONFIG_DISP_HORIZONTAL_TOTAL);
	printf("iCONFIG_DISP_VERTICAL_TOTAL=%d\n", default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL);

	printf("iCONFIG_DISP_HSYNC_WIDTH=%d\n", default_panel_parameter.iCONFIG_DISP_HSYNC_WIDTH);
	printf("iCONFIG_DISP_VSYNC_LENGTH=%d\n", default_panel_parameter.iCONFIG_DISP_VSYNC_LENGTH);

	printf("iCONFIG_DISP_DEN_STA_HPOS=%d\n", default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS);
	printf("iCONFIG_DISP_DEN_END_HPOS=%d\n", default_panel_parameter.iCONFIG_DISP_DEN_END_HPOS);
	printf("iCONFIG_DISP_DEN_STA_VPOS=%d\n", default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS);
	printf("iCONFIG_DISP_DEN_END_VPOS=%d\n", default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS);

	printf("iCONFIG_DISP_ACT_STA_HPOS=%d\n", default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS);
	printf("iCONFIG_DISP_ACT_END_HPOS=%d\n", default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS);
	printf("iCONFIG_DISP_ACT_STA_VPOS=%d\n", default_panel_parameter.iCONFIG_DISP_ACT_STA_VPOS);
	printf("iCONFIG_DISP_ACT_END_VPOS=%d\n", default_panel_parameter.iCONFIG_DISP_ACT_END_VPOS);

	printf("iCONFIG_DISP_HSYNC_LASTLINE=%d\n", default_panel_parameter.iCONFIG_DISP_HSYNC_LASTLINE);
	printf("iCONFIG_DISP_DCLK_DELAY=%d\n", default_panel_parameter.iCONFIG_DISP_DCLK_DELAY);
	//printf("iCONFIG_DISP_ACT_STA_BIOS=%d\n", default_panel_parameter.iCONFIG_DISP_ACT_STA_BIOS);
	printf("iCONFIG_DEFAULT_DPLL_M_DIVIDER=%d\n", default_panel_parameter.iCONFIG_DEFAULT_DPLL_M_DIVIDER);
	printf("iCONFIG_DEFAULT_DPLL_N_DIVIDER=%d\n", default_panel_parameter.iCONFIG_DEFAULT_DPLL_N_DIVIDER);

	printf("iPANEL_TO_LVDS_ON_ms=%d\n", default_panel_parameter.iPANEL_TO_LVDS_ON_ms);
	printf("iLVDS_TO_LIGHT_ON_ms=%d\n", default_panel_parameter.iLVDS_TO_LIGHT_ON_ms);

	printf("iLIGHT_TO_LDVS_OFF_ms=%d\n", default_panel_parameter.iLIGHT_TO_LDVS_OFF_ms);
	printf("iLVDS_TO_PANEL_OFF_ms=%d\n", default_panel_parameter.iLVDS_TO_PANEL_OFF_ms);

	printf("iPANEL_OFF_TO_ON_ms=%d\n", default_panel_parameter.iPANEL_OFF_TO_ON_ms);
	printf("iCONFIG_BACKLIGHT_PWM_FREQ=%d\n", default_panel_parameter.iCONFIG_BACKLIGHT_PWM_FREQ);
	printf("iCONFIG_BACKLIGHT_PWM_DUTY=%d\n", default_panel_parameter.iCONFIG_BACKLIGHT_PWM_DUTY);
	printf("iFIX_LAST_LINE_ENABLE=%d\n", default_panel_parameter.iFIX_LAST_LINE_ENABLE);
	printf("iFIX_LAST_LINE_4X_ENABLE=%d\n", default_panel_parameter.iFIX_LAST_LINE_4X_ENABLE);
	printf("iVFLIP=%d\n", default_panel_parameter.iVFLIP);

	printf("iPICASSO_CONTROL_ON=%d\n", default_panel_parameter.iPICASSO_CONTROL_ON);
	printf("i3D_DISPLAY_SUPPORT=%d\n", default_panel_parameter.i3D_DISPLAY_SUPPORT);
	printf("i3D_LINE_ALTERNATIVE_SUPPORT=%d\n", default_panel_parameter.i3D_LINE_ALTERNATIVE_SUPPORT);
	printf("i3D_PR_OUTPUT_LR_SWAP=%d\n", default_panel_parameter.i3D_PR_OUTPUT_LR_SWAP);
	printf("i3D_SG_OUTPUT_120HZ_ON=%d\n", default_panel_parameter.i3D_SG_OUTPUT_120HZ_ON);
	printf("i3D_SG_24HZ_OUTPUT_FHD_ON=%d\n", default_panel_parameter.i3D_SG_24HZ_OUTPUT_FHD_ON);
	printf("iSCALER_2D_3D_CVT_HWSHIFT_ENABLE=%d\n", default_panel_parameter.iSCALER_2D_3D_CVT_HWSHIFT_ENABLE);

	//append new parameters 2012-3-21
	printf("iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN=%d\n", default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN);
	printf("iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX=%d\n", default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX);
	printf("iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN=%d\n", default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN);
	printf("iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX=%d\n", default_panel_parameter.iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX);

	printf("iCONFIG_LVDS_4_PORTS_INDEX=%d\n", default_panel_parameter.iCONFIG_LVDS_4_PORTS_INDEX);
	printf("iCONFIG_LVDS_PN_SWAP=%d\n", default_panel_parameter.iCONFIG_LVDS_PN_SWAP);
	printf("iCONFIG_LVDS_MIRROR=%d\n", default_panel_parameter.iCONFIG_LVDS_MIRROR);

	printf("iCONFIG_DISPLAY_PORT_CONFIG1=%d\n", default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG1);
	printf("iCONFIG_DISPLAY_PORT_CONFIG2=%d\n", default_panel_parameter.iCONFIG_DISPLAY_PORT_CONFIG2);
	printf("iCONFIG_SR_MODE=%d\n", default_panel_parameter.iCONFIG_SR_MODE);
	printf("iCONFIG_SR_PIXEL_MODE=%d\n", default_panel_parameter.iCONFIG_SR_PIXEL_MODE);
	printf("iCONFIG_SFG_SEG_NUM=%d\n", default_panel_parameter.iCONFIG_SFG_SEG_NUM);
	printf("iCONFIG_SFG_PORT_NUM=%d\n", default_panel_parameter.iCONFIG_SFG_PORT_NUM);
	printf("iCONFIG_PANEL_TYPE=%d\n", default_panel_parameter.iCONFIG_PANEL_TYPE);
	printf("iCONFIG_PANEL_CUSTOM_INDEX=%d\n", default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX);

	printf("i3D_DISPLAY_TIMING=%d\n", default_panel_parameter.i3D_DISPLAY_TIMING);

	printf("iCONFIG_CUSTOMER_PANEL_ID=%d\n", default_panel_parameter.iCONFIG_CUSTOMER_PANEL_ID);

	printf("sPanelName=%s\n", default_panel_parameter.sPanelName);
#endif
}
#endif
#if defined(USE_PANEL_CONFIG_PARAM_EXTEND_FOR_TV035)
void env_panel_extend_set_default(void)
{

	default_c_panel_param_extend.iCONFIG_CUSTOMER_PANEL_ID					= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_PANEL_INDEX				= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_HDR			= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_LD			= 0xff ;
	
	default_c_panel_param_extend.iCONFIG_CUSTOMER_OLED		= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_AMP 			= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_PANEL_EN_AND_PWM_ON_FLIP			= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_BACKLIGHT_ACT_MAX			= 0xff ;
	
	default_c_panel_param_extend.iCONFIG_CUSTOMER_BACKLIGHT_ACT_MIN		= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_ENERGY_SAVING			= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_ENERGY_SAVING_RATIO	= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_SPEAKER_OUTPUT	= 0xff ;
	default_c_panel_param_extend.iCONFIG_PLATFORM_EYE = 0xff;

	default_c_panel_param_extend.iCONFIG_CUSTOMER_RESVER04			= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_RESVER05	= 0xff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_RESVER06	= 0xff ;

	
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER01				= 0xffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER02				= 0xffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER03				= 0xffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER04			= 0xffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER05			= 0xffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER06			= 0xffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER07 			= 0xffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER08				= 0xffff ;
	
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_01				= 0xffffffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_02				= 0xffffffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_03				= 0xffffffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_04				= 0xffffffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_05				= 0xffffffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_06				= 0xffffffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_07				= 0xffffffff ;
	default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_08				= 0xffffffff ;


	strcpy(default_c_panel_param_extend.sPanel_disp_Name, CONFIG_DISP_PANEL_NAME);
}

uint env_panel_set_panel_to_default(char *panel_path)
{
	int ret = 0;
	char *raw_ptr = NULL;
	int file_len = 0;
	char fatorypanelbin[120] = "tmp/factory/bin_panel/panel.bin";
	
	ret =factory_read(panel_path, &raw_ptr, &file_len);
	if (ret)
	{
		printf("[ERR]%s not found\n",panel_path);
		return 1;
	}
	memcpy(&default_panel_parameter, raw_ptr, sizeof(default_panel_parameter));
	ret = factory_write(fatorypanelbin, (char *)&default_panel_parameter, sizeof(default_panel_parameter));
	if (ret)
	{
		printf("[ERR] write %s failed\n", panel_path);
	}

	ret = factory_save();
	if (ret)
	{
		printf("[ERR] save facroty failed\n");
	}
	return ret;
}

#endif

#ifdef CONFIG_REALTEK_EERPOM_TV010_A
#if 0
bool CheckEepromPanel()
{
	int  CurpanelID = 0;
	PANEL_CONFIG_PARAMETER panelparam;
	unsigned long eepcrc,eepnamecrc = 0;
	char *raw_ptr = NULL;
	int file_len = 0;
	bool ret=FALSE;
	char panelName[32];
	memset(&panelparam,0,PANEL_PARAM_SIZE);
	memset(panelName,0,sizeof(panelName));

	Eeprom_Read(EEP_AD_PANELBIN,  PANEL_PARAM_SIZE, (UINT8*)&panelparam);
	Eeprom_Read(EEP_AD_PANELBIN_CRC,  sizeof(eepcrc), (UINT8*)&eepcrc);
	Eeprom_Read(EEP_AD_PANELNAME,  sizeof(panelName), (UINT8*)&panelName);
	Eeprom_Read(EEP_AD_PANELNAME_CRC,  sizeof(eepnamecrc), (UINT8*)&eepnamecrc);
	CurpanelID = default_panel_parameter.iCONFIG_CUSTOMER_PANEL_ID;

	if(panelparam.sPanelName!=NULL)
	{
		if(panelparam.sPanelName[0]>0x40&&panelparam.sPanelName[0]<0x7B)// first char must A~z
		{
			unsigned long crc = 0,namecrc=0;
			crc = crc32(crc, (unsigned char*)&panelparam, PANEL_PARAM_SIZE);
			namecrc = crc32(namecrc, (unsigned char*)panelName, sizeof(panelName));
			printf("\n>>>Eeppanel crc=0x%lx,crc=0x%lx,eepnamecrc=0x%lx,namecrc=0x%lx<<<<<<<",eepcrc, crc,eepnamecrc, namecrc);
			if(crc == eepcrc)
			{
				printf("\n\033[1;32m<<<<Eeprom_Panel_bin_crccheck_OK>>>>>>>\033[m");

				char checkpanelbin[120] ={0};
				char fatorypanelbin[120] ="tmp/factory/bin_panel/panel.bin";

				if(eepnamecrc==namecrc)
				{
				    printf("\n>>>>>>>>>>>>>>>>>(eepnamecrc==namecrc)");
				    sprintf(checkpanelbin,"tmp/factory/bin_panel/panel/%s_panel.bin",panelName);
				}
				else
				    sprintf(checkpanelbin,"tmp/factory/bin_panel/panel/%s_panel.bin",panelparam.sPanelName);
				printf("\n>>>>>>>>>>>>>>>>>checkpanelbin=%s<<<<<<<<",checkpanelbin);
				if ((factory_read(checkpanelbin, &raw_ptr, &file_len) == 0) && file_len == sizeof(default_panel_parameter))
				{
					printf("\n\033[1;32m########%s is exsit ok############\033[m",checkpanelbin);
					memcpy(&default_panel_parameter, raw_ptr, file_len);
					env_panel_change_panel_bin_in_factory(fatorypanelbin);
					//Eeprom_Write(EEP_AD_PANELID, 1, &(default_panel_parameter.iCONFIG_CUSTOMER_PANEL_ID));
				}
				else
				{
					printf("\n\033[1;31m########%s is not exsit ############\033[m",checkpanelbin);
					printf("\n<<<<<checkpanelbin=%s>>>>>",checkpanelbin);
					memcpy(&default_panel_parameter, &panelparam, sizeof(default_panel_parameter));

					ret = factory_write(checkpanelbin, (char *)&default_panel_parameter, sizeof(default_panel_parameter));
					if (ret)
					{
						printf("[ERR] write %s failed\n", checkpanelbin);
					}
					ret = factory_delete(fatorypanelbin);
					if (ret)
					{
						printf("[ERR] remove %s failed\n", fatorypanelbin);
					}

					ret = factory_write(fatorypanelbin, (char *)&default_panel_parameter, sizeof(default_panel_parameter));
					if (ret)
					{
						printf("[ERR] write %s failed\n", fatorypanelbin);
					}

					ret = factory_save();
					if (ret)
					{
						printf("[ERR] save facroty failed\n");
					}

					//Eeprom_Write(EEP_AD_PANELID, 1, &(panelparam.iCONFIG_CUSTOMER_PANEL_ID));
				}
				ret=TRUE;
			}
			else
			{
				ret=FALSE;
				printf("\n\033[1;31m<<<<Eeprom_Panel_bin_crccheck_Fail>>>>>>>\033[m");
			}
		}
		else
		{
			printf("\n\033[1;31m<<<<Eeprom_Panel_bin_PanelName_FirstChar_Error,must be a-z,A-Z>>>>>>>\033[m");
			ret=FALSE;
		}
	}
	return ret;
}

void LoadFactoryPanelBinByEepName(uchar *panelname)
{
    int file_len = 0;
	char *raw_ptr = NULL;
	printf("\n\033[1;32m<<<<LoadFactoryPanelBinByEepName%s>>>>>>>\033[m",panelname);

	char checkpanelbin[120] ={0};
	char fatorypanelbin[120] ="tmp/factory/bin_panel/panel.bin";

	sprintf(checkpanelbin,"tmp/factory/bin_panel/panel/%s_panel.bin",panelname);
	printf("\n>>>>>>>>>>>>>>>>>checkpanelbin=%s<<<<<<<<",checkpanelbin);
	if ((factory_read(checkpanelbin, &raw_ptr, &file_len) == 0) && file_len == sizeof(default_panel_parameter))
	{
		printf("\n\033[1;32m########%s is exsit ok############\033[m",checkpanelbin);
		memcpy(&default_panel_parameter, raw_ptr, file_len);
		env_panel_change_panel_bin_in_factory(fatorypanelbin);
		//Eeprom_Write(EEP_AD_PANELID, 1, &(default_panel_parameter.iCONFIG_CUSTOMER_PANEL_ID));
		int ret = 0;
        char strInfo[20]="RmStorageParam";
		ret = factory_write("tmp/factory/bin_panel/RmStorageParam", strInfo, sizeof(strInfo));// to tell TvServer ,boot has used new panel.bin
		if (ret)
		{
			printf("[ERR] write tmp/factory/bin_panel/RmStorageParam failed\n");
		}

		ret = factory_save();

	}
	else
	{
		printf("\n\033[1;31m########%s is not exsit ############\033[m",checkpanelbin);

		//Eeprom_Write(EEP_AD_PANELID, 1, &(panelparam.iCONFIG_CUSTOMER_PANEL_ID));
	}

}
#endif
#endif

#if defined(PANEL_LIST_FROM_FACTORY)
uchar env_setup_env_panel(uchar *panel_filename)
{
	char *raw_ptr = NULL;
	uint parameter_len = 0;
	unsigned int rc = 1;	/* 0:fail 1:success */
#ifdef PANEL_CONFIG_FROM_FACTORY_PANEL_BIN
	int file_len = 0;
#endif
	int i = 0;
	char tmp_str[3] = {0};
	char *raw1 = NULL;
	char *raw2 = NULL;
	char *raw3 = NULL;
	char *raw4 = NULL;
#if defined(USE_PANEL_CONFIG_PARAM_EXTEND_FOR_TV035)
	uint c_param_extend_len = 0;
	char *raw5 = NULL;
	char *raw6 = NULL;
#endif 
#ifdef CONFIG_REALTEK_EERPOM_TV010_A
	__attribute__ ((unused)) char  Eep_panelID = 0,EepPanelName[sizeof(default_panel_parameter.sPanelName)],curPanelName[sizeof(default_panel_parameter.sPanelName)];
#if defined(CONFIG_EPI_CONVERT_VBY1_TEST) && defined(Config_Board_TV010_PANEL)
	unsigned long eepnamecrc=0,namecrc=0;
#endif
#endif
#if 0 // debug
	unsigned char* p;
#endif

	parameter_len = sizeof(default_panel_parameter);
#if defined(CONFIG_EPI_CONVERT_VBY1_TEST) && defined(Config_Board_TV010_PANEL)
	int EpiTestPinStatus =  IO_Get(PIN_EPI_TEST_DETECT); 
#endif

	if (panel_filename == NULL) // set default value
	{
		printf("\n\033[1;41<<<<<<<<<<panel_filename NULL>>>>>>>>>>\033[m");
		env_panel_set_default();
        printf("Panel: %s\n", default_panel_parameter.sPanelName);
	}
	else
	{
#ifdef CONFIG_PANEL_SHARP_60_MEMC
		//reset to default panel
		env_panel_set_default();
#else //#ifdef CONFIG_PANEL_SHARP_60_MEMC

#ifdef PANEL_CONFIG_FROM_FACTORY_PANEL_BIN
		/* read panel parameter from factory */

		if ((factory_read((char *)panel_filename, &raw_ptr, &file_len) == 0) && file_len == parameter_len) {
			memcpy(&default_panel_parameter, raw_ptr, sizeof(default_panel_parameter));

			printf("Panel: Use parameters in %s\n", panel_filename);
		
#if defined(CONFIG_EPI_CONVERT_VBY1_TEST) && defined(Config_Board_TV010_PANEL)
        strcpy(curPanelName,default_panel_parameter.sPanelName);
		vby1_aphy16_23_output = 0;
		if(EpiTestPinStatus == 0 && default_panel_parameter.iCONFIG_PANEL_TYPE == 4 )
		{
			if ((factory_read("tmp/factory/bin_panel/panel/Skyworth_Default_4K2K_VBY1_panel.bin", &raw_ptr, &file_len) == 0) && file_len == parameter_len)
			{
				memcpy(&default_panel_parameter, raw_ptr, sizeof(default_panel_parameter));
				strcpy(default_panel_parameter.sPanelName,curPanelName);
				vby1_aphy16_23_output = 1;
				printf("\n\033[1;32m@@@@@Read Skyworth_Default_4K2K_VBY1 Ok\033[m");
			}
		}
#endif
		}
		else {
			if (file_len != 0) {
				printf("Panel: Use default config (panel.bin size is not matched)\n");
				printf("[WARN] size of panel.bin is 0x%x\n", file_len);
				printf("[WARN] size of default_panel_parameter is 0x%x\n", parameter_len);
			}
			else{
				printf("Panel: Use default config (%s is not found)\n", panel_filename);
			}
			//reset to default panel
			env_panel_set_default();
		}


#else
		env_panel_set_default();
#endif

#endif //#ifdef CONFIG_PANEL_SHARP_60_MEMC

		printf("\n\033[1;33m<<<<<<Panel: %s>>>>>>>>\033[m\n", default_panel_parameter.sPanelName);
		printf("\n\033[1;33m<<<<<<parameter_len: %d >>>>>>>>\033[m\n", parameter_len);

#if defined(USE_PANEL_CONFIG_PARAM_EXTEND_FOR_TV035)
	if(default_panel_parameter.iCONFIG_PANEL_TYPE ==P_LVDS_2K1K || default_panel_parameter.iCONFIG_PANEL_TYPE ==P_MINI_LVDS ){
		printf("\n unsupport Lvds panel type. set panel to 289x default panel\n");
		if(env_panel_set_panel_to_default(DEF_PANEL_TV035))
		{
			printf("\n set panel type to P_VBY1_4K2K\n");
			default_panel_parameter.iCONFIG_PANEL_TYPE = P_VBY1_4K2K; 
		}
	}
	char *c_panel_extend_filename = NULL;
	c_panel_extend_filename = malloc(100);
	memset(c_panel_extend_filename, 0, 100);
	sprintf(c_panel_extend_filename, "%s%s%s", PANEL_EXTEND_BIN_FILE, default_panel_parameter.sPanelName,"_extend.bin"); // get file full path
	file_len=0;
	
	c_param_extend_len = sizeof(default_c_panel_param_extend);
	
	if ((factory_read((char *)c_panel_extend_filename, &raw_ptr, &file_len) == 0) && file_len == c_param_extend_len) {
		memcpy(&default_c_panel_param_extend, raw_ptr, sizeof(default_c_panel_param_extend));
	
		printf("Panel: Use parameters extend in %s\n", c_panel_extend_filename);
	}
	else {
		if (file_len != 0) {
			printf("Panel: Use default config (panel_extend.bin size is not matched)\n");
			printf("[WARN] size of panel_extend.bin is 0x%x\n", file_len);
			printf("[WARN] size of default_c_panel_param_extend is 0x%x\n", c_param_extend_len);
			printf("Panel: Use default config (%s is not found)\n", c_panel_extend_filename);
		}
		else{
			printf("Panel: Use default config (%s is not found)\n", c_panel_extend_filename);
		}
		//reset to default panel
		env_panel_extend_set_default();
	}
	free(c_panel_extend_filename);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_PLATFORM_EYE);

#if 0
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_PANEL_ID);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_PANEL_INDEX);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_HDR);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_LD);
	
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_OLED);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_AMP);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_PANEL_EN_AND_PWM_ON_FLIP);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_BACKLIGHT_ACT_MAX);

	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_BACKLIGHT_ACT_MIN);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_RESVER01);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_RESVER02);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_RESVER03);	

	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER01);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER02);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER03);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER04);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER05);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER06);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER07);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER08);

	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_01);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_02);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_03);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_04);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_05);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_06);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_07);
	printf("Panel:default_c_panel_param_extend 0x%x \n", default_c_panel_param_extend.iCONFIG_CUSTOMER_DISP_RESVER_32_08);

	printf("Panel:default_c_panel_param_extend %s \n", default_c_panel_param_extend.sPanel_disp_Name);
#endif	
#endif
	}

	//resource leak
	raw1 = malloc(150);
	raw2 = malloc(150);
	raw3 = malloc(150);
	raw4 = malloc(150);
	if ((raw1 == NULL) || (raw2 == NULL) || (raw3 == NULL) || (raw4 == NULL))
	{
		printf("[ERR] %s:%d: malloc for raw data failed\n", __FUNCTION__, __LINE__);
		rc = 0;
		goto err_raw1_4;
	}
#if defined(USE_PANEL_CONFIG_PARAM_EXTEND_FOR_TV035)
	raw5 = malloc(150);
	raw6 = malloc(150);
	if ( (raw5 == NULL)|| (raw6 == NULL))
	{
		printf("[ERR] %s:%d: malloc for raw data failed\n", __FUNCTION__, __LINE__);
		rc = 0;
		goto err_raw5_6;
	}
#endif

	/***********************************************
	 * FIXME: use magic number here is a bad decision !!!!!!!!!!
	 ***********************************************/

	/* generate panel env */
	for (i = 0 ; i < 50 ; i++)
		sprintf( raw1+2*i, "%.2x", *((UINT8 *)&default_panel_parameter+i));

	if (parameter_len < 100)
	{
		for (i = 50 ; i < parameter_len ; i++)
			sprintf( raw2+2*(i-50), "%.2x", *((UINT8 *)&default_panel_parameter+i));
	}
	else
	{
		for (i = 50 ; i < 100 ; i++)
			sprintf( raw2+2*(i-50), "%.2x", *((UINT8 *)&default_panel_parameter+i));
#if defined(PANEL_CONFIG_FROM_FACTORY_PANEL_BIN)
		for (i = 100 ; i < 150 ; i++)
			sprintf( raw3+2*(i-100), "%.2x", *((UINT8 *)&default_panel_parameter+i));

		for (i = 150 ; i < parameter_len ; i++)
			sprintf( raw4+2*(i-150), "%.2x", *((UINT8 *)&default_panel_parameter+i));
#else
		for (i = 100 ; i < parameter_len ; i++)
			sprintf( raw3+2*(i-100), "%.2x", *((UINT8 *)&default_panel_parameter+i));
#endif
	}
#if defined(USE_PANEL_CONFIG_PARAM_EXTEND_FOR_TV035)
	/* generate panel  extend env */
	for (i = 0 ; i < 50 ; i++)
		sprintf( raw5+2*i, "%.2x", *((UINT8 *)&default_c_panel_param_extend+i));

	if (c_param_extend_len < 100)
	{
		for (i = 50 ; i < c_param_extend_len ; i++)
			sprintf( raw6+2*(i-50), "%.2x", *((UINT8 *)&default_c_panel_param_extend+i));
	}
	else
	{
		for (i = 50 ; i < 100 ; i++)
			sprintf( raw6+2*(i-50), "%.2x", *((UINT8 *)&default_c_panel_param_extend+i));
	}
#endif

//	printf("sizeof(default_panel_parameter)=%d \n", parameter_len);//hcy test

#if 0 // debug
	printf("bootcode inside panel parameter\n" ) ;
	p = (unsigned char*)&default_panel_parameter  ;

	for (i=0; i < sizeof(default_panel_parameter); i++) {
		if (i%16 == 0)
			printf("\n %02x",*p++ ) ;
		else
			printf(" %02x",*p++ ) ;
	}
	printf("\n" ) ;
#endif

	/* set panel_parameter1 */
	raw_ptr = raw1; /* Create new */

	if (setenv("panel_parameter_1", raw_ptr))
	{
		rc = 0;
	}

	for (i = 0 ; i < 50 ; i++)
	{
		strncpy(tmp_str, raw_ptr+2*i, 2);
		tmp_str[2] = '\0';
		*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
	}

	if (parameter_len < 100) // paramter size is less than 100, only need use two raws
	{
		/* set panel_parameter2 */
		raw_ptr = raw2;  /* Create new */

		if (setenv("panel_parameter_2", raw_ptr))
		{
			rc = 0;
		}

		for (i = 50 ; i < parameter_len ; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-50), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}
	}
	else
	{
		/* set panel_parameter2 */
		raw_ptr = raw2;  /* Create new */
		if (setenv("panel_parameter_2", raw_ptr))
		{
			rc = 0;
		}

		for (i = 50 ; i < 100 ; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-50), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter3 */
		raw_ptr = raw3;  /* Create new */
		if (setenv("panel_parameter_3", raw_ptr))
		{
			rc = 0;
		}

		for (i = 100 ; i < parameter_len  ; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-100), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}

		/* set panel_parameter4 */
		raw_ptr = raw4;  /* Create new */
		if (setenv("panel_parameter_4", raw_ptr))
		{
			rc = 0;
		}

		for (i = 150 ; i < parameter_len  ; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-150), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_panel_parameter+i) = strtoul(tmp_str, (char **)NULL, 16);
		}
	}
#if defined(USE_PANEL_CONFIG_PARAM_EXTEND_FOR_TV035)


	/* set panel_extend_parameter1 */
	raw_ptr = raw5; /* Create new */

	if (setenv("c_panel_param_extend_1", raw_ptr))
	{
		rc = 0;
	}

	for (i = 0 ; i < 50 ; i++)
	{
		strncpy(tmp_str, raw_ptr+2*i, 2);
		tmp_str[2] = '\0';
		*((UINT8 *)&default_c_panel_param_extend+i) = strtoul(tmp_str, (char **)NULL, 16);
	}

	if (c_param_extend_len < 100) // paramter size is less than 100, only need use two raws
	{
		/* set panel_parameter2 */
		raw_ptr = raw6;  /* Create new */

		if (setenv("c_panel_param_extend_2", raw_ptr))
		{
			rc = 0;
		}

		for (i = 50 ; i < c_param_extend_len ; i++)
		{
			strncpy(tmp_str, raw_ptr+2*(i-50), 2);
			tmp_str[2] = '\0';
			*((UINT8 *)&default_c_panel_param_extend+i) = strtoul(tmp_str, (char **)NULL, 16);
		}
	}
	else
	{
		printf("\n\033[1;33m<<<<<<default_c_panel_param_extend: size error >>>>>>>>\033[m\n");
	}
#endif
//	LVDS_4_PORTS_INDEX = default_panel_parameter.iCONFIG_LVDS_4_PORTS_INDEX;

#if 0 // debug
	printf("\n\nenv's final panel parameter\n" ) ;
	p = (unsigned char*)&default_panel_parameter  ;

	for (i=0; i< sizeof(default_panel_parameter); i++) {
		if (i%16 == 0)
			printf("\n %02x",*p++ ) ;
		else
			printf(" %02x",*p++ ) ;
	}
	printf("\n" ) ;
#endif

	/* set panel_file_name */
	raw_ptr = default_panel_parameter.sPanelName;
	if (setenv("panel_file_name", raw_ptr))
	{
		rc = 0;
	}
#if defined(USE_PANEL_CONFIG_PARAM_EXTEND_FOR_TV035)
	raw_ptr = default_c_panel_param_extend.sPanel_disp_Name;
	if (setenv("c_panel_extend_disp_name", raw_ptr))
	{
		rc = 0;
	}

err_raw5_6:
	free((void *)raw5);
	free((void *)raw6);
#endif

err_raw1_4:
	free((void *)raw1);
	free((void *)raw2);
	free((void *)raw3);
	free((void *)raw4);

	return rc;
}
#endif

