/*
 * (C) Copyright 2000
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * Add to readline cmdline-editing by
 * (C) Copyright 2005
 * JinHua Luo, GuangDong Linux Center, <luo.jinhua@gd-linux.com>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/* #define	DEBUG	*/

#include <common.h>
#include <watchdog.h>
#include <command.h>
#include <malloc.h>
#include <version.h>
#ifdef CONFIG_MODEM_SUPPORT
#include <malloc.h>		/* for free() prototype */
#endif

#ifdef CONFIG_QC_VERIFY
#include <qc_verify.h>
#endif

#ifdef CONFIG_AUTO_PROGRAM_OTP
extern int rtk_auto_program_otp(void);
#endif

#ifdef CONFIG_KCPU_LOAD_OPTEE
extern int kboot_load_normal_optee_status(void);
#endif

#ifdef CONFIG_REALTEK_EERPOM_TV010_A
#ifndef UINT8
#define UINT8  unsigned char
#endif
extern int getKeypadDisable(UINT8 *tmpflag);
#endif
#if defined(Config_Board_TV010_PANEL)
extern void init_network_driver(void);
#endif
#if defined(CONFIG_ANDROID_RECOVERY) && defined(CONFIG_CUSTOMER_TV010)
void writeRecoveryCmd(const char *filename);
#endif 
#ifdef CONFIG_SYS_PANEL_SUPPORT
#include "panel.h"
#endif

#ifdef CONFIG_SYS_HUSH_PARSER
#include <hush.h>
#endif

//add by keven_yuan begin
#include <drivers/lsadc/lsadc.h>
#include <platform_lib/board/pcb_mgr.h>
//add by keven_yuan end

#include <post.h>
#include <linux/ctype.h>
#include <menu.h>
#include <ppoverlay_reg.h>
#include <asm/arch/bootparam.h>
#include <asm/arch/fw_info.h>
#ifdef Config_Module_Test_Boot_TRUE
#include<module_test.h>
#endif

#ifndef IS_FPGA
#include <platform_lib/board/pcb.h>
#endif

#if CONFIG_ANDROID_RECOVERY
#include <asm/arch/factorylib.h>
#include <asm/arch/system.h>
#include <gpt_parse.h>
#include <parse_h.h>
#define BOOT_RECOVERY_FILE_NAME	FACTORY_HEADER_FILE_NAME"recovery"
#define USB_STORAGE_UPGRADE_FILE1 "install.zip"
#define USB_STORAGE_UPGRADE_FILE2 "install.img"
#define USB_STORAGE_UPGRADE_FILE_PATH "/mnt/usb/sda/"
#if defined(CONFIG_CUSTOMER_TV002) && defined(CONFIG_SYS_RTK_EMMC_FLASH)
#define FACTORY_DATA_RESET_COMMAND "boot-recovery"
#define FACTORY_DATA_RESET_ARGUMENTS "recovery\n--wipe_data\n--reason=ResetConfirmFragment\n--locale=en-US"
extern u64 rtk_eMMC_write_byte(u64  byte_addr_str,unsigned int data_size,unsigned int * buffer );
#endif
#define BOOT_MAGIC "ANDROID!"
layout_part_desc misc_part_info;
int bEnterRecovery = 0;
int bNewbootflow = 0;
#define BLOCK_SHIFT 9
#define BLOCK_SIZE (1 << BLOCK_SHIFT)
extern unsigned int rtk_eMMC_read( unsigned int address, unsigned int data_size, unsigned int * buffer);
#ifndef CONFIG_FSW
typedef struct _bootloader_message {
    char command[32];
    char status[32];
    char recovery[1024];
} bootloader_message;
#endif
#endif

#if defined(CONFIG_SILENT_CONSOLE) || defined(CONFIG_POST) || defined(CONFIG_CMDLINE_EDITING)
DECLARE_GLOBAL_DATA_PTR;
#endif

/*
 * Board-specific Platform code can reimplement show_boot_progress () if needed
 */
static void inline __show_boot_progress (int val) {}
void show_boot_progress (int val) __attribute__((weak, alias("__show_boot_progress")));

#if defined(CONFIG_UPDATE_TFTP)
int update_tftp (ulong addr);
#endif /* CONFIG_UPDATE_TFTP */

#define MAX_DELAY_STOP_STR 32

#undef DEBUG_PARSER

char        console_buffer[CONFIG_SYS_CBSIZE + 1];	/* console I/O buffer	*/

static char * delete_char (char *buffer, char *p, int *colp, int *np, int plen);
static const char erase_seq[] = "\b \b";		/* erase sequence	*/
static const char   tab_seq[] = "        ";		/* used to expand TABs	*/

#ifdef CONFIG_BOOT_RETRY_TIME
static uint64_t endtime = 0;  /* must be set, default is instant timeout */
static int      retry_time = -1; /* -1 so can call readline before main_loop */
#endif

#define	endtick(seconds) (get_ticks() + (uint64_t)(seconds) * get_tbclk())

#ifndef CONFIG_BOOT_RETRY_MIN
#define CONFIG_BOOT_RETRY_MIN CONFIG_BOOT_RETRY_TIME
#endif

#ifdef CONFIG_MODEM_SUPPORT
int do_mdm_init = 0;
extern void mdm_init(void); /* defined in board.c */
#endif

extern int boot_power_on_mode;
extern uchar boot_ac_on;
extern int check_usb_update(const char *install_file_name, uchar bBootcode);
extern int check_file_in_usb(const char *install_file_name);
#ifdef CONFIG_CHECK_IMG_VERSION
extern bool check_if_image_update_by_version( bool forceUpdate );
#endif


#ifdef CONFIG_USB_UPDATE_SCRIPT
extern int check_usb_autoscript_update(const char * script_file_name,uchar bBootcode);
#endif
extern int rtk_FLASH_install(void);
extern void set_bootparam_upgrade(int val);
extern bool boot_on_fast_install_detect;

extern void CusApi_main_loop_before_enter_rescue(void);
extern BOOT_MODE CusApi_abortboot(void);
#ifdef CONFIG_FSW
extern bool fsw_emmc_bootup;
extern char *fat_ls_str_first (char *interface, char *dev_part, const char* str);
#endif

void disable_acpu_clock(void);
/*
 * Define the ASCII encoding
 */
#define _BACKSPACE		0x08
#define _TAB			0x09
#define _ENTER			0x0D
#define _ESC			0x1B
#define _SPACE			0x20
#define _DELETE		0x7f
#define _CTRL_B                 0x02

BOOT_MODE boot_mode = BOOT_NORMAL_MODE;
bool is_update_boot = false;
void cleanRecoveryCmd(int enterRecovery);
void getBootVersion(void);

/***************************************************************************
 * Watch for 'delay' seconds for autoboot stop or autoboot delay string.
 * returns: 0 -  no key string, allow autoboot 1 - got key string, abort
 */
#if defined(CONFIG_BOOTDELAY) && (CONFIG_BOOTDELAY >= 0)
# if defined(CONFIG_AUTOBOOT_KEYED)
#ifndef CONFIG_MENU
// cklai mark this line to prevent parsing failed in source insight.
// static inline
#endif
int abortboot(int bootdelay)
{
	int abort = 0;
	uint64_t etime = endtick(bootdelay);
	struct {
		char* str;
		u_int len;
		int retry;
	}
	delaykey [] = {
		{ str: getenv ("bootdelaykey"),  retry: 1 },
		{ str: getenv ("bootdelaykey2"), retry: 1 },
		{ str: getenv ("bootstopkey"),   retry: 0 },
		{ str: getenv ("bootstopkey2"),  retry: 0 },
	};

	char presskey [MAX_DELAY_STOP_STR];
	u_int presskey_len = 0;
	u_int presskey_max = 0;
	u_int i;

#ifndef CONFIG_ZERO_BOOTDELAY_CHECK
	if (bootdelay == 0)
		return 0;
#endif

#  ifdef CONFIG_AUTOBOOT_PROMPT
	printf(CONFIG_AUTOBOOT_PROMPT);
#  endif

#  ifdef CONFIG_AUTOBOOT_DELAY_STR
	if (delaykey[0].str == NULL)
		delaykey[0].str = CONFIG_AUTOBOOT_DELAY_STR;
#  endif
#  ifdef CONFIG_AUTOBOOT_DELAY_STR2
	if (delaykey[1].str == NULL)
		delaykey[1].str = CONFIG_AUTOBOOT_DELAY_STR2;
#  endif
#  ifdef CONFIG_AUTOBOOT_STOP_STR
	if (delaykey[2].str == NULL)
		delaykey[2].str = CONFIG_AUTOBOOT_STOP_STR;
#  endif
#  ifdef CONFIG_AUTOBOOT_STOP_STR2
	if (delaykey[3].str == NULL)
		delaykey[3].str = CONFIG_AUTOBOOT_STOP_STR2;
#  endif

	for (i = 0; i < sizeof(delaykey) / sizeof(delaykey[0]); i ++) {
		delaykey[i].len = delaykey[i].str == NULL ?
				    0 : strlen (delaykey[i].str);
		delaykey[i].len = delaykey[i].len > MAX_DELAY_STOP_STR ?
				    MAX_DELAY_STOP_STR : delaykey[i].len;

		presskey_max = presskey_max > delaykey[i].len ?
				    presskey_max : delaykey[i].len;

#  if DEBUG_BOOTKEYS
		printf("%s key:<%s>\n",
		       delaykey[i].retry ? "delay" : "stop",
		       delaykey[i].str ? delaykey[i].str : "NULL");
#  endif
	}

	/* In order to keep up with incoming data, check timeout only
	 * when catch up.
	 */
	do {
		if (tstc()) {
			if (presskey_len < presskey_max) {
				presskey [presskey_len ++] = getc();
			}
			else {
				for (i = 0; i < presskey_max - 1; i ++)
					presskey [i] = presskey [i + 1];

				presskey [i] = getc();
			}
		}

		for (i = 0; i < sizeof(delaykey) / sizeof(delaykey[0]); i ++) {
			if (delaykey[i].len > 0 &&
			    presskey_len >= delaykey[i].len &&
			    memcmp (presskey + presskey_len - delaykey[i].len,
				    delaykey[i].str,
				    delaykey[i].len) == 0) {
#  if DEBUG_BOOTKEYS
				printf("got %skey\n",
				       delaykey[i].retry ? "delay" : "stop");
#  endif

#  ifdef CONFIG_BOOT_RETRY_TIME
				/* don't retry auto boot */
				if (! delaykey[i].retry)
					retry_time = -1;
#  endif
				abort = 1;
			}
		}
	} while (!abort && get_ticks() <= etime);

#  if DEBUG_BOOTKEYS
	if (!abort)
		puts("key timeout\n");
#  endif

#ifdef CONFIG_SILENT_CONSOLE
	if (abort)
		gd->flags &= ~GD_FLG_SILENT;
#endif

	return abort;
}

# else	/* !defined(CONFIG_AUTOBOOT_KEYED) */

#ifdef CONFIG_MENUKEY
static int menukey = 0;
#endif

#ifndef CONFIG_MENU
// cklai mark this following line to prevent parsing failed in source insight.
// static inline
#endif
int rtk_osc_autok(void);
int rtk_disable_ng(void);
int abortboot(int bootdelay)
{
	int abort = 0;
	BOOT_MODE Cus_bootmode = BOOT_NORMAL_MODE;
	//int retry_times = 1;
	
#ifdef CONFIG_LOGBUFFER_DEFAULT_VALUE

	char *logbuffer;
    	int loglength;
    	int logrc;	
#endif

#ifdef CONFIG_MENUPROMPT
	printf(CONFIG_MENUPROMPT);
#else
#ifdef CONFIG_BSP_REALTEK
	printf("Hit Esc or Tab key to enter console mode or rescue linux: %2d ", bootdelay);
#else
	printf("Hit any key to stop autoboot: %2d ", bootdelay);
#endif
#endif

#ifdef CONFIG_NOCS_BSD
	printf("0xb8060500=0x%08x\n", rtd_inl(0xb8060500));
	if(rtd_inl(0xb8060500) == 0xbeaa2379){
		abort = 1;
		return abort;
	}
#endif

#if defined CONFIG_ZERO_BOOTDELAY_CHECK
	/*
	 * Check if key already pressed
	 * Don't check if bootdelay < 0
	 */
	if (bootdelay >= 0) {
		if (tstc()) {	/* we got a key press	*/
			(void) getc();  /* consume input	*/
			puts ("\b\b\b 0");
			abort = 1;	/* don't auto boot	*/
		}
	}
#endif

#if CONFIG_ANDROID_RECOVERY
    char *dst_addr;
    int dst_length;
    if (factory_read(BOOT_RECOVERY_FILE_NAME, &dst_addr, &dst_length)) {
        printf("\n------------can't find %s\n", BOOT_RECOVERY_FILE_NAME);
    } else {
        bootloader_message* pBootMsg = (bootloader_message*)dst_addr;
        if (strcmp("boot-recovery", pBootMsg->command) == 0) {
            printf("\n------------We will Enter Recovery Rescue\n");
            bEnterRecovery = 1;
        }
    }
#ifdef CONFIG_SYS_RTK_EMMC_FLASH
    getBootVersion();
    if(bNewbootflow)
    {
	unsigned int *u32dst_addr = NULL;
	unsigned int block_no = 0;
	block_no =  misc_part_info.offset/BLOCK_SIZE;
	u32dst_addr = malloc(sizeof(bootloader_message));
	if(u32dst_addr == NULL)
	{
	    printf("malloc fail not enough memory!!!!\n");
	}

        rtk_eMMC_read(block_no, sizeof(bootloader_message), u32dst_addr);

        bootloader_message* pBootMsg = (bootloader_message*)u32dst_addr;

        if (strcmp("boot-recovery", pBootMsg->command) == 0) {
            bEnterRecovery = 1;
        }
        else if(strcmp("boot-fastboot", pBootMsg->command) == 0) {
            bEnterRecovery = 1;
        }
        else if(strcmp("reboot-bootloader", pBootMsg->command) == 0 || strcmp("bootonce-bootloader", pBootMsg->command) == 0) {
            /*
            memset(pBootMsg->command, '\0', sizeof(pBootMsg->command));
            memset(pBootMsg->status, '\0', sizeof(pBootMsg->command));
            rtk_eMMC_write(block_no, sizeof(bootloader_message), u32dst_addr);
            abort = 1;
	    */
            bEnterRecovery = 2;
        }
        else
        {
            printf("Current Misc context %s \n", (char*)pBootMsg);
        }
    }
#endif
#endif

/*
 **********************************************************
 * Realtek Patch:
 *     Detect specific key from UART or LSADC,
 *         and execute the coresponding action.
 *
 * 	_ESC	: Enter console mode
 * 	_TAB	: Enter rescue mode
 * 	_SPACE	: Enter normal mode but user needs to execute boot command manually
 * 	No key	: Enter normal mode
 **********************************************************
 */
	int console_key = 0;
#ifdef CONFIG_KCPU_LOAD_RESCUE
	int update_by_tab = 0;
#endif
	int hit_count = 0;
	int pre_console_key = 0;

#if defined(CONFIG_DETECT_LSADC)
	int lsadc_key1 = -1;
	int index = -1;
	int hitvalue = -1;
	int torrence  = -1;
	//int nConfrmCountVolKey=0;
	unsigned long long Lsadc_Key_info;
#endif

#define DETECT_KEY_RETRY_COUNT 10
	int loop_i = 0;
#if defined(CONFIG_DETECT_LSADC)
#if defined(Config_Board_TV035) || defined(Config_Board_TV035_INT_DDR) || defined(Config_Board_TV035_INT_DDR_DCU1_4G4G_DCU2_4G4G) || defined(CONFIG_BOARD_298X_TV013_QFP176_EMMC)
	int nConfirmCount=0;
#endif
	int nConfrmCountPowerKey=0;

#endif

	boot_mode = BOOT_NORMAL_MODE;

#if 0 // only for test
	int test_delay = 1;

	while ((test_delay > 0)) {

		--test_delay;

		printf("\b\b\b%2d ", test_delay);

		for (loop_i = 0;loop_i < 100; ++loop_i) {
			udelay(10000);
		}
	}

	printf("\n");
#endif // test key

#ifdef CONFIG_AUTO_PROGRAM_OTP
	rtk_auto_program_otp(); /* used to auto program otp */
#endif

#ifdef CONFIG_NG_PROGRAM_OTP
	// Check OSC K
	rtk_osc_autok();

	// Check ng
	rtk_disable_ng();
#endif

#ifdef CONFIG_KCPU_LOAD_OPTEE
	extern int kboot_load_fw_status(void);
	if (!kboot_load_fw_status())
	{
		printf("\n\033[0;31mWARNING: KBOOT LOAD OPTEE FAILTURE !!\033[0m\n");
		boot_mode = BOOT_CONSOLE_MODE;
		abort = 1; /* don't auto boot   */
	}
#endif
#ifndef CONFIG_RTKPCB
#if defined(CONFIG_CUSTOMER_TV002) && defined(CONFIG_SYS_RTK_EMMC_FLASH)
    static int nConfirmCountFDR=0, nConfirmCountRescue=0;
    unsigned long long valuePower=0, valueUp=0;
    bootloader_message *bcb = NULL;
    u64 byte_cnt = 0;
    
    pcb_mgr_get_enum_info_byname("PIN_KEYPAD_UP", &valueUp);
    pcb_mgr_get_enum_info_byname("PIN_KEYPAD_PWR", &valuePower);
#endif
#endif
	for (loop_i = 0;loop_i < DETECT_KEY_RETRY_COUNT && (!abort);loop_i++) {

	if (tstc()) {    /* we got a key press from UART */
		console_key = getc();
		if (console_key) {              //avoid dirty uart data
			pre_console_key = console_key;
			printf("\n");
			udelay(50000);
			WATCHDOG_KICK();
			for (hit_count = 0; hit_count <5; hit_count++) {
				if (tstc()) {
					console_key = getc();
					if (console_key != pre_console_key) {
						console_key = 0;
						break;
					}
				}
				else {
					console_key =0;
					break;
				}
				udelay(50000);
			}
		}
	}
	else
	{
		/* use for skyworth usb fast install */
		if(boot_on_fast_install_detect){
			printf("\033[1;31m Enter skyworth usb fast install \033[m\n");
			console_key = _TAB;
		}
	}

#if defined(CONFIG_TV010_DETECT_OLED)
    unsigned char system_lock = 0;
    getOledSysLock(&system_lock);
    if (system_lock == 1)
    {
        if ((console_key != _ESC) && (console_key != _DELETE))
        {
            console_key = _ESC;
        }
    }
#endif
	switch (console_key) {
		case _ESC:
		case _DELETE:
#ifndef Config_Boot_Type_is_RELEASE
		case _CTRL_B:
#endif
		case _TAB:
		case _BACKSPACE:
		case _SPACE:
		case _ENTER:
			#ifndef CONFIG_RTKPCB
			#ifndef Config_Board_Demo
			printf("USB power high\n");
			IO_Set(PIN_USB_EN_P1, 1);
			IO_Set(PIN_USB_EN_P0, 1);
			#endif
			#endif
			break;
		default:
			printf("USB power low\n");
			break;
	}
	switch (console_key) {
		case _ESC:
		case _DELETE:
#ifndef Config_Boot_Type_is_RELEASE
		case _CTRL_B:
#endif
			printf("Press Esc Key\n");
			boot_mode = BOOT_CONSOLE_MODE;
			abort = 1; /* don't auto boot	*/
			break;

		case _TAB:
			// enter rescue case: Press TAB key
			printf("Press Tab Key\n");
#ifdef CONFIG_LOGBUFFER_DEFAULT_VALUE

			logrc=factory_read("tmp/factory/rtdlog",&logbuffer,&loglength);
			if(!logrc)
			{
				factory_delete("tmp/factory/rtdlog");
				factory_save();
			}
#endif

#ifdef CONFIG_KCPU_LOAD_RESCUE
			setenv("rescue_cmd", "go r -tab");
			update_by_tab = 1;
#else

#ifndef CONFIG_SYS_RTK_SPI_FLASH
			setenv("rescue_cmd", "go r");
#else
			setenv("rescue_cmd", "go ru");
#endif

#endif
			boot_mode = BOOT_RESCUE_MODE;
			abort = 1; /* don't auto boot	*/
#if CONFIG_ANDROID_RECOVERY
			cleanRecoveryCmd(bEnterRecovery);
#endif
			break;

		case _BACKSPACE:
			// enter rescue case: Press Backspace key
			printf("Press Backspace Key\n");
			setenv("rescue_cmd", "go r");
			boot_mode = BOOT_RESCUE_MODE;
			abort = 1; /* don't auto boot	*/
			{
				/* append the install filename to system_parameters */
				char *msg = NULL;
				msg = (char *)malloc(100);
				memset(msg, 0, 100);
				strncpy(msg, getenv("system_parameters_1"), 70);
				strcat(msg, " imgfile_pattern=output.bin");
				setenv("system_parameters_1", msg);
				free(msg);
			}
			break;

		case _SPACE:
			printf("Press Space Key\n");
			boot_mode = BOOT_MANUAL_MODE;
			abort = 1; /* don't auto boot	*/
			break;

		case _ENTER:
#ifdef CONFIG_LOGBUFFER_DEFAULT_VALUE
			printf("Press Enter Key\n");
			logrc=factory_read("tmp/factory/rtdlog",&logbuffer,&loglength);

			if(logrc)
			{
				int rc;
				rc = factory_write("tmp/factory/rtdlog",NULL,0);
				if(rc)
				{
					printf("factory_write error.\n");
				}
				//run_command("factory write tmp/factory/rtdlog 1000000 20", 0);
				factory_save();
			}

#ifdef CONFIG_KCPU_LOAD_RESCUE
			setenv("rescue_cmd", "go r -tab");
			update_by_tab = 1;
#else

#ifndef CONFIG_SYS_RTK_SPI_FLASH
			setenv("rescue_cmd", "go r");
#else
			setenv("rescue_cmd", "go ru");
#endif

#endif
			boot_mode = BOOT_RESCUE_MODE;
			abort = 1; /* don't auto boot   */
#if CONFIG_ANDROID_RECOVERY
			cleanRecoveryCmd(bEnterRecovery);
#endif
			break;
#endif

		default:
#ifdef CONFIG_SYS_RTK_SPI_FLASH
			printf("SPI solution, force run rescue linux!\r\n");
			setenv("rescue_cmd", "go r");
			boot_mode = BOOT_RESCUE_MODE;
			abort = 1; /* don't auto boot	*/
#endif
			debug("Press Key is %c\n", console_key);
			/* do nothing */
			break;
		}

		Cus_bootmode = CusApi_abortboot();
		if(Cus_bootmode != BOOT_NORMAL_MODE)
		{
			if(Cus_bootmode == BOOT_RESCUE_MODE)
				boot_mode = BOOT_RESCUE_MODE;
			abort = 1;
			break;
		}
#if defined(CONFIG_BOARD_298X_TV013_QFP176_EMMC) 
		if (pcb_mgr_get_enum_info_byname("PIN_KEYPAD_MENU", &Lsadc_Key_info) == 0)
		{
			if(Lsadc_Key_info != 0)
			{
				index = GET_PIN_INDEX(Lsadc_Key_info);
				hitvalue = GET_LSADC_HITVALUE(Lsadc_Key_info);
				torrence = GET_LSADC_TOLERANCE(Lsadc_Key_info);
				lsadc_key1 = lsadc_get(index);
				if((ABS(lsadc_key1, hitvalue))<torrence)
				{
					if(++nConfirmCount==3)
					{
						setenv("rescue_cmd", "go r");
						boot_mode = BOOT_RESCUE_MODE;
						abort = 1; /* don't auto boot	*/
						break;
					}
					udelay(10000);
				}else
					nConfirmCount=0;
			}
		}
#endif
#ifndef CONFIG_RTKPCB
#if defined(CONFIG_CUSTOMER_TV002) && defined(CONFIG_SYS_RTK_EMMC_FLASH)
 		if(boot_ac_on == 1) {
 		    printf("\033[0;32;31m BOOT AC ON \n\033[m");
            if(valuePower != 0 && IO_Get(valuePower) == 0)
            {
                nConfirmCountRescue++;
                if (valueUp != 0 && IO_Get(valueUp) == 0)
                {
                    nConfirmCountFDR++;
                    nConfirmCountRescue=0;
                }
            }
            if (nConfirmCountFDR >=3)
            {
                if ((bcb = malloc(sizeof(bootloader_message))) == NULL)
                {
                    printf("malloc size %u fail for BCB Command!\n",sizeof(bootloader_message));
                    break;
                }
                memset(bcb, 0, sizeof(bootloader_message));
                if (sizeof(bcb->command) < strlen(FACTORY_DATA_RESET_COMMAND))
                {
                    printf("Command size is too long! skipping...\n");
                    break;
                }
                memcpy(bcb->command,FACTORY_DATA_RESET_COMMAND,strlen(FACTORY_DATA_RESET_COMMAND));
                if ((sizeof(bcb->recovery)) < strlen(FACTORY_DATA_RESET_ARGUMENTS))
                {
                    printf("BCB args is too long! skipping...\n");
                    break;
                }
                memcpy(bcb->recovery,FACTORY_DATA_RESET_ARGUMENTS,strlen(FACTORY_DATA_RESET_ARGUMENTS));
                printf("\033[0;32;31m go FACTORY_DATA_RESET \n\033[m");
                if (!misc_part_info.size || !misc_part_info.offset)
                {
                    printf("part size:%llu, part offset:%llu!! Either parsing wrong or partition is missing!! skipping...\n",misc_part_info.size,misc_part_info.offset);
                    break;
                }
                else
                {
                    byte_cnt = rtk_eMMC_write_byte(misc_part_info.offset, sizeof(bootloader_message), (unsigned int *)bcb);
                    //check if number of bytes written is correct, otherwise clear it.
                    if (byte_cnt != sizeof(bootloader_message))
                    {
                        printf("failed to write to misc part! clearing misc part...\n");
                        memset(bcb, 0, sizeof(bootloader_message));
                        rtk_eMMC_write_byte(misc_part_info.offset, byte_cnt, (unsigned int *) bcb);
                        break;
                    }
                    if (bcb != NULL)
                        free(bcb);
                    do_reset (NULL, 0, 0, NULL);
                }
            }
            //printf("\033[0;32;31m IO_Get PWR %d \n\033[m",hitvaluePower);
            else if(nConfirmCountRescue==3)
            {
                boot_mode = BOOT_RESCUE_MODE;
                //abort = 1; /* don't auto boot	*/
                printf("\033[0;32;31m go BOOT_RESCUE_MODE \n\033[m");
                break;
            }
            udelay(10000);
        }
#endif
#endif
#if defined(Config_Board_TV035) || defined(Config_Board_TV035_INT_DDR) || defined(Config_Board_TV035_INT_DDR_DCU1_4G4G_DCU2_4G4G)
		if (pcb_mgr_get_enum_info_byname("PIN_KEYPAD_RIGHT", &Lsadc_Key_info) == 0)
		{
			if(Lsadc_Key_info != 0)
			{
				index = GET_PIN_INDEX(Lsadc_Key_info);
				hitvalue = GET_LSADC_HITVALUE(Lsadc_Key_info);
				torrence = GET_LSADC_TOLERANCE(Lsadc_Key_info);
				lsadc_key1 = lsadc_get(index);
				if((ABS(lsadc_key1, hitvalue))<torrence)
				{
					if(++nConfirmCount==3)
					{
						setenv("rescue_cmd", "go r");
						boot_mode = BOOT_RESCUE_MODE;
						abort = 1; /* don't auto boot	*/
						break;
					}
					udelay(10000);
				}else
					nConfirmCount=0;
			}
		}
#if 0
		if (pcb_mgr_get_enum_info_byname("PIN_KEYPAD_LEFT", &Lsadc_Key_info) == 0)
		{
			if(Lsadc_Key_info != 0)
			{
				index = GET_PIN_INDEX(Lsadc_Key_info);
				hitvalue = GET_LSADC_HITVALUE(Lsadc_Key_info);
				torrence = GET_LSADC_TOLERANCE(Lsadc_Key_info);
				lsadc_key1 = lsadc_get(index);
				if((ABS(lsadc_key1, hitvalue))<torrence)
				{
					if(++nConfrmCountVolKey==3)
					{
						printf(" %s  %s  %d go update panel \n",__FILE__,__FUNCTION__,__LINE__);
#if 1						
						char *msg,*tmp_msg;
						char c_str_add[]="Panel";
						bool go_update=0;
						int str_len=strlen((char *)bootparam.install_file_name);
						int c_str_add_len=strlen(c_str_add);
						msg = (char *)malloc(128);
						tmp_msg = (char *)malloc(str_len+c_str_add_len+1);
						memset(msg, 0, 128);
						memset(tmp_msg, 0, str_len+c_str_add_len+1);
						if (str_len > 0)
						{
							int i;
							for ( i = 0 ; i+9 < str_len ; i++	)
							{
								if ( bootparam.install_file_name[i] == 'U' && bootparam.install_file_name[i+1] == 'p' && bootparam.install_file_name[i+2] == 'g' \
									&& bootparam.install_file_name[i+3] == 'r' && bootparam.install_file_name[i+4] == 'a' && bootparam.install_file_name[i+5] == 'd' \
									&& bootparam.install_file_name[i+6] == 'e' )
								{
									strcat(tmp_msg, c_str_add);
									for ( ; i < str_len ; i++  )
									{
										tmp_msg[i+c_str_add_len]=bootparam.install_file_name[i];
									}
									sprintf( msg, "tv_system=%s imgfile_pattern=%s",
										SYS_PARAM_TV_SYSTEM,
										tmp_msg
									);
									setenv("system_parameters_1", msg);
									go_update=1;
									break;
								}
								tmp_msg[i]=bootparam.install_file_name[i];	
							}
						}
						free(msg);
						free(tmp_msg);
#endif
						if ( go_update )
						{
							setenv("rescue_cmd", "go r");
							boot_mode = BOOT_RESCUE_MODE;
							abort = 1; /* don't auto boot	*/
						}
						break;
					}
					else
					{
						printf(" %s  %s  %d set abort = 0  \n",__FILE__,__FUNCTION__,__LINE__);
						abort = 0;
					}
					udelay(10000);
				}else
					nConfrmCountVolKey=0;
			}
		}
#endif

#endif

#if defined(CONFIG_ANDROID_RECOVERY) && defined(CONFIG_CUSTOMER_TV010)
		printf("Find CONFIG_BOARD_TV010_BGA_EERPOM\n");
		
		unsigned char keypaddisable = 0;
#ifdef CONFIG_REALTEK_EERPOM_TV010_A
		getKeypadDisable(&keypaddisable);
#endif		
		if((boot_ac_on == 1) && (0 == keypaddisable)){
			printf("Check Recovery Mode\n");
			
#if defined(CONFIG_DETECT_LSADC)			
			if (pcb_mgr_get_enum_info_byname("PIN_KEYPAD_PWR", &Lsadc_Key_info) == 0)
			{
				if(Lsadc_Key_info != 0)
				{
					index = GET_PIN_INDEX(Lsadc_Key_info);
					hitvalue = GET_LSADC_HITVALUE(Lsadc_Key_info);
					torrence = GET_LSADC_TOLERANCE(Lsadc_Key_info);
					lsadc_key1 = lsadc_get(index);
					if((ABS(lsadc_key1, hitvalue))<torrence)
					{
						printf("keypad power is long pressed, times: %d\n", nConfrmCountPowerKey);
						if(++nConfrmCountPowerKey>=5)
						{
							char *filename = NULL;
							if( check_file_in_usb(USB_STORAGE_UPGRADE_FILE1) ){
								filename = USB_STORAGE_UPGRADE_FILE1;
							}else{
								if( check_file_in_usb(USB_STORAGE_UPGRADE_FILE2) )
									filename = USB_STORAGE_UPGRADE_FILE2;							
							}
							printf("======== Checking into android recovery ====\n");
							if(filename == NULL || strcmp(filename,USB_STORAGE_UPGRADE_FILE1) == 0)
							{
								writeRecoveryCmd(filename);
							}
							setenv("rescue_cmd", "go r");
							boot_mode = BOOT_RESCUE_MODE;
							abort = 1;
							panel_init_2nd();

							if (boot_mode != BOOT_NORMAL_MODE) {
								init_network_driver();
							}

							return abort;
						}else{
							bootdelay = 1;
						}
						udelay(10000);
					}else {
						nConfrmCountPowerKey=0;
					}
				}
			}
#endif
		}

#endif
	}
#ifndef CONFIG_RTKPCB    
#if defined(CONFIG_CUSTOMER_TV002) && defined(CONFIG_SYS_RTK_EMMC_FLASH)
    //free up the allocated memory if exit the loop
    if (bcb != NULL)
        free(bcb);
#endif
#endif

#ifdef CONFIG_SYS_PANEL_SUPPORT
	if(boot_mode == BOOT_CONSOLE_MODE)
		panel_dpg_enable();
#endif

#ifdef CONFIG_PANEL_INIT_2ND_AFTER_LOGO
	if(console_key)
		panel_init_2nd();
#endif

	// enter rescue case: found LOCAL_UPGRADE_EN=1 in 000BootParam.h (factory)
#ifdef CONFIG_SYS_BOOT_PARM
	if(bootparam.local_upgrade_en==1)
	{
		set_bootparam_upgrade(0);
		mdelay(100);
		printf("\n====== bootparam.local_upgrade_en is %d ======\n", bootparam.local_upgrade_en);
		setenv("rescue_cmd", "go r");
		boot_mode = BOOT_RESCUE_MODE;
		abort = 1; /* don't auto boot	*/
	}
#endif

	// enter rescue case: found TAG is not TAG_COMPLETE in layout.txt (factory)
	if (!abort) {
		if (boot_tag != TAG_COMPLETE) {
			printf("\n====== boot_tag(%d) is not TAG_COMPLETE ======\n", boot_tag);
			setenv("rescue_cmd", "go r");
			boot_mode = BOOT_RESCUE_MODE;
			abort = 1;
		}
	}

	// enter rescue case: found string boot-recovery in recovery (factory)
#if 0 //CONFIG_ANDROID_RECOVERY
	if (!abort) {
		if (bEnterRecovery == 1) {
			printf("\n====== Enter into android recovery ======\n");
			setenv("rescue_cmd", "go r");
			boot_mode = BOOT_RESCUE_MODE;
			abort = 1;
		}
	}
#endif

#if defined(CONFIG_USB_UPDATE_WHEN_AC_ON) || defined(CONFIG_RESCUE_SOURCE_FROM_USB)
	unsigned int start_usb_update = 0;
    int retry_times = 1;
	// usb update case: AC on
#ifdef CONFIG_USB_UPDATE_WHEN_AC_ON
	if ((!abort) && (boot_ac_on == 1))
	{
#if defined(CONFIG_CUSTOMER_TV002)
    if(boot_mode == BOOT_RESCUE_MODE) {
		start_usb_update = 1;
    }
#else
		start_usb_update = 1;
#endif
		printf("\n====== boot_ac_on=1 ======\n");
	}
#endif

	// usb update case: enter rescue from usb
#ifdef CONFIG_RESCUE_SOURCE_FROM_USB
	if (boot_mode == BOOT_RESCUE_MODE)
	{
		start_usb_update = 1;

		printf("\n====== boot_mode=BOOT_RESCUE_MODE ======\n");
	}
#endif

	// start detect usb and read install.img
	if (start_usb_update)
	{
		char filename[64];
		int ret = 0;

		#ifndef CONFIG_RTKPCB
		printf("Tact key USB power high \n");
		IO_Set(PIN_USB_EN_P1, 1);
		IO_Set(PIN_USB_EN_P0, 1);
		mdelay(500);
		#endif
		// usb start_ac to init usb
		ret = run_command( "usb start", 0 );

		if (ret != 0 && retry_times-- > 0) {
			printf("[USB] retry.... \n");
			ret = run_command("usb start", 0);
		}

		if (ret != 0)
		{
			/* usb start_ac error */
			printf("[INFO] %s:usb start_ac failed. (No USB plug-in)\n", __FUNCTION__);
		}
		else
		{
			/* usb start_ac success */

#ifdef CONFIG_USB_UPDATE_UBOOT_WHEN_AC_ON
			#ifdef CONFIG_USB_UPDATE_SCRIPT
			if (check_usb_autoscript_update( USB_AUTO_SCRIPT, 1))
			{
			#endif
				// check dvrboot.exe.bin from usb
				if (check_usb_update(BOOTCODE_RESCUE, 1))
				{
					run_command_list("go 0x1500000", -1, 0);
                                        is_update_boot = true;
					boot_mode = BOOT_CONSOLE_MODE;
					abort = 1; /* don't auto boot	*/
				}
			#ifdef CONFIG_USB_UPDATE_SCRIPT
			}
			#endif
#endif /* CONFIG_USB_UPDATE_UBOOT_WHEN_AC_ON */

#ifdef CONFIG_USB_UPDATE_SCRIPT
			if (check_usb_autoscript_update( USB_AUTO_SCRIPT, 0))
			{
#endif
				// check install.img from usb
				if (strlen((char *)bootparam.install_file_name) > 0)
					strcpy(filename, (char *)bootparam.install_file_name);
				else
					strcpy(filename, FULL_IMG);
#ifdef CONFIG_FSW
				if (check_usb_update(filename, 0) && fsw_emmc_bootup == 0)
#else
				if (check_usb_update(filename, 0))
#endif
				{
#ifdef CONFIG_USB_UPDATE_READ_RESCUE_FROM_FLASH
					run_command_list("mmc rescan", -1, 0); // rescan mmc device to prevent mmc read error
					printf("Get extern param again from: ");
					//rtk_FLASH_install(); // get the latest extern parameter from flash
					setenv("rescue_cmd", "go r");
#else

#ifdef CONFIG_KCPU_LOAD_RESCUE
					flush_dcache_all(); // flush dcache for kcpu access
					if (update_by_tab)
						run_command("kboot go_r -tab", 0); // notify kcpu to go rescue linux in ram
					else
						run_command("kboot go_r", 0); // notify kcpu to go rescue linux for secure update in ram
					printf("[FATAL] k enter rescue, s should enter busy loop.\n");
#else
		#ifdef CONFIG_CMD_MMC
					run_command_list("mmc rescan", -1, 0); // rescan mmc device to prevent mmc read error
		#endif
					setenv("rescue_cmd", "go k");
#endif	/* CONFIG_KCPU_LOAD_RESCUE */

#endif
					boot_mode = BOOT_RESCUE_MODE;
					abort = 1; /* don't auto boot	*/
				}
#ifdef CONFIG_FSW
				else
				{
					char* pswName = NULL;
					pswName = fat_ls_str_first("usb", "0:1","psw_");
					//printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
					printf("[trace code] pswName = %s\n", pswName);
					if (check_usb_update(pswName, 0) && fsw_emmc_bootup == 0)
					{
						//printf("[trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
#ifdef CONFIG_USB_UPDATE_READ_RESCUE_FROM_FLASH
						run_command_list("mmc rescan", -1, 0); // rescan mmc device to prevent mmc read error
						printf("Get extern param again from: ");
						//rtk_FLASH_install(); // get the latest extern parameter from flash
						setenv("rescue_cmd", "go r");
#else

#ifdef CONFIG_KCPU_LOAD_RESCUE
						flush_dcache_all(); // flush dcache for kcpu access
						if (update_by_tab)
							run_command("kboot go_r -tab", 0); // notify kcpu to go rescue linux in ram
						else
							run_command("kboot go_r", 0); // notify kcpu to go rescue linux for secure update in ram
						printf("[FATAL] k enter rescue, s should enter busy loop.\n");
#else
			#ifdef CONFIG_CMD_MMC
						run_command_list("mmc rescan", -1, 0); // rescan mmc device to prevent mmc read error
			#endif
						setenv("rescue_cmd", "go k");
#endif	/* CONFIG_KCPU_LOAD_RESCUE */

#endif
						boot_mode = BOOT_RESCUE_MODE;
						abort = 1; /* don't auto boot	*/
					}
#ifndef CONFIG_RTKPCB    
#if defined(CONFIG_CUSTOMER_TV002) && defined(CONFIG_SYS_RTK_EMMC_FLASH)                    
					else
					{
						printf("Pressing keypad when AC ON, there is no install.img in the U-disk or no U-disk plug-in, Do reset %s, %d\n", __FUNCTION__, __LINE__);
						bcb = malloc(sizeof(bootloader_message));
						if(NULL != bcb)
						{
							memset(bcb, 0, sizeof(bootloader_message));
							if (sizeof(bcb->command) >= strlen(FACTORY_DATA_RESET_COMMAND))
							{
								memcpy(bcb->command,FACTORY_DATA_RESET_COMMAND,strlen(FACTORY_DATA_RESET_COMMAND));
								if ((sizeof(bcb->recovery)) >= strlen(FACTORY_DATA_RESET_ARGUMENTS))
								{
									memcpy(bcb->recovery,FACTORY_DATA_RESET_ARGUMENTS,strlen(FACTORY_DATA_RESET_ARGUMENTS));
									printf("\033[0;32;31m go FACTORY_DATA_RESET \n\033[m");
									if (!misc_part_info.size || !misc_part_info.offset)
									{
										free(bcb);
										printf("part size:%llu, part offset:%llu!! Either parsing wrong or partition is missing!! skipping...\n",misc_part_info.size,misc_part_info.offset);
									}
									else
									{
										byte_cnt = rtk_eMMC_write_byte(misc_part_info.offset, sizeof(bootloader_message), (unsigned int *)bcb);
										//check if number of bytes written is correct, otherwise clear it.
										if (byte_cnt != sizeof(bootloader_message))
										{
											printf("failed to write to misc part! clearing misc part...\n");
											memset(bcb, 0, sizeof(bootloader_message));
											rtk_eMMC_write_byte(misc_part_info.offset, byte_cnt, (unsigned int *) bcb);
										}
										else
										{
											free(bcb);
											printf("start reset, %s, %d\n", __FUNCTION__, __LINE__);
											do_reset (NULL, 0, 0, NULL);
										}
									}
								}
								else
								{
									free(bcb);
									printf("BCB args is too long! skipping...\n");
								}
							}
							else
							{
								free(bcb);
								printf("Command size is too long! skipping...\n");
							}
						}
						else
						{
							printf("malloc size %u fail for BCB Command!\n",sizeof(bootloader_message));
						}
					}
#endif
#endif
				}
#endif
#ifdef CONFIG_USB_UPDATE_SCRIPT
			}
#endif

			// usb stop
			int ret = 0;
			char cmd[12];

			memset(cmd, 0, sizeof(cmd));
			sprintf(cmd, "usb stop");
			ret = run_command(cmd, 0);
			if (ret != 0)
			{
				/* Usb stop error */
				printf("[INFO] %s:usb stop failed.\n", __FUNCTION__);
			}
		}
	}
#endif /* CONFIG_USB_UPDATE_WHEN_AC_ON || CONFIG_RESCUE_SOURCE_FROM_USB */

	while ((bootdelay > 0) && (!abort)) {
		int i;

		--bootdelay;
		/* delay 100 * 10ms */
		for (i=0; !abort && i<100; ++i) {
			if (tstc()) {	/* we got a key press	*/
				abort  = 1;	/* don't auto boot	*/
				bootdelay = 0;	/* no more delay	*/
# ifdef CONFIG_MENUKEY
				menukey = getc();
# else
				(void) getc();  /* consume input	*/
# endif
				break;
			}
			udelay(10000);
		}

		printf("\b\b\b%2d ", bootdelay);
	}

	putc('\n');

#ifdef CONFIG_SILENT_CONSOLE
	if (abort)
		gd->flags &= ~GD_FLG_SILENT;
#endif

#ifdef CONFIG_PANEL_INIT_2ND_AFTER_LOGO
	if (boot_mode != BOOT_NORMAL_MODE) {
		init_network_driver();
	}
#endif

	return abort;
}
#endif	/* CONFIG_AUTOBOOT_KEYED */
#endif	/* CONFIG_BOOTDELAY >= 0  */

/****************************************************************************/

void main_loop (void)
{
#ifndef CONFIG_SYS_HUSH_PARSER
	static char lastcommand[CONFIG_SYS_CBSIZE] = { 0, };
	int len;
	int rc = 1;
	int flag;
#endif

#if defined(CONFIG_BOOTDELAY) && (CONFIG_BOOTDELAY >= 0)
	char *s;
	int bootdelay;
#endif
#ifdef CONFIG_PREBOOT
	char *p;
#endif
#ifdef CONFIG_BOOTCOUNT_LIMIT
	unsigned long bootcount = 0;
	unsigned long bootlimit = 0;
	char *bcs;
	char bcs_set[16];
#endif /* CONFIG_BOOTCOUNT_LIMIT */

#ifdef CONFIG_BOOTCOUNT_LIMIT
	bootcount = bootcount_load();
	bootcount++;
	bootcount_store (bootcount);
	sprintf (bcs_set, "%lu", bootcount);
	setenv ("bootcount", bcs_set);
	bcs = getenv ("bootlimit");
	bootlimit = bcs ? simple_strtoul (bcs, NULL, 10) : 0;
#endif /* CONFIG_BOOTCOUNT_LIMIT */

#ifdef CONFIG_MODEM_SUPPORT
	debug ("DEBUG: main_loop:   do_mdm_init=%d\n", do_mdm_init);
	if (do_mdm_init) {
		char *str = strdup(getenv("mdm_cmd"));
		setenv ("preboot", str);  /* set or delete definition */
		if (str != NULL)
			free (str);
		mdm_init(); /* wait for modem connection */
	}
#endif  /* CONFIG_MODEM_SUPPORT */

#ifdef CONFIG_VERSION_VARIABLE
	{
		setenv ("ver", version_string);  /* set version variable */
	}
#endif /* CONFIG_VERSION_VARIABLE */

        WATCHDOG_KICK();


#ifdef CONFIG_SYS_HUSH_PARSER
	u_boot_hush_start ();
#endif

#if defined(CONFIG_HUSH_INIT_VAR)
	hush_init_var ();
#endif

#ifdef CONFIG_PREBOOT
	if ((p = getenv ("preboot")) != NULL) {
# ifdef CONFIG_AUTOBOOT_KEYED
		int prev = disable_ctrlc(1);	/* disable Control C checking */
# endif

		run_command_list(p, -1, 0);

# ifdef CONFIG_AUTOBOOT_KEYED
		disable_ctrlc(prev);	/* restore Control C checking */
# endif
	}
#endif /* CONFIG_PREBOOT */

#if defined(CONFIG_UPDATE_TFTP)
	update_tftp (0UL);
#endif /* CONFIG_UPDATE_TFTP */

#if defined(CONFIG_BOOTDELAY) && (CONFIG_BOOTDELAY >= 0)
	s = getenv ("bootdelay");
	bootdelay = s ? (int)simple_strtol(s, NULL, 10) : CONFIG_BOOTDELAY;

	debug ("### main_loop entered: bootdelay=%d\n\n", bootdelay);

#if defined(CONFIG_MENU_SHOW)
	bootdelay = menu_show(bootdelay);
#endif
# ifdef CONFIG_BOOT_RETRY_TIME
	init_cmd_timeout ();
# endif	/* CONFIG_BOOT_RETRY_TIME */

#ifdef CONFIG_POST
	if (gd->flags & GD_FLG_POSTFAIL) {
		s = getenv("failbootcmd");
	}
	else
#endif /* CONFIG_POST */
#ifdef CONFIG_BOOTCOUNT_LIMIT
	if (bootlimit && (bootcount > bootlimit)) {
		printf ("Warning: Bootlimit (%u) exceeded. Using altbootcmd.\n",
		        (unsigned)bootlimit);
		s = getenv ("altbootcmd");
	}
	else
#endif /* CONFIG_BOOTCOUNT_LIMIT */
	{
#ifdef Config_Boot_Type_is_RELEASE
		setenv("bootcmd", CONFIG_BOOTCOMMAND);
#endif
		s = getenv ("bootcmd");
	}

#ifdef CONFIG_QC_VERIFY
	s = NULL;
	boot_mode = BOOT_QC_VERIFY_MODE;
#else
	debug ("### main_loop: bootcmd=\"%s\"\n", s ? s : "<UNDEFINED>");
#endif

	if (s == NULL) {
		printf("[WARN] bootcmd in env is NULL.\n");
		printf("[WARN] you need to execute \"env default -f\" to reset env.\n");
	}

#ifdef CONFIG_RUN_FLASH_WRITER
	boot_mode=BOOT_FLASH_WRITER_MODE;
	s = NULL;
	bootdelay = 0;
#endif
#ifdef CONFIG_REALTEK_PCMCIA
	WATCHDOG_DISABLE();
	extern void pcmcia_read_cis_test(void);
	pcmcia_read_cis_test();
#endif

#if defined(CONFIG_CMD_NAND)
#if (defined(Config_Board_TV043_RENO_V001) || defined(Config_Board_TV043_RENO_V002))
	//USER : LewisLee DATE : 2018/08/01
	//short time patch for nand Flash WP pin
//	IO_Set(PIN_FLASH_WP, 1);
	rtd_outl(0xb801bd0c, 0x00000081);
	rtd_outl(0xb801bd20, 0x00000081);
	puts("Set Nand WP as High@Main.c\n");
#endif //#if (defined(Config_Board_TV043_RENO_V001) || defined(Config_Board_TV043_RENO_V002))
#endif

    if (bootdelay >= 0 && s && !abortboot (bootdelay)) {

#if defined(Config_Module_Test_SWVersion_TRUE)
    //extern void modt_send();
    modt_send();
#endif
#if defined(Config_Module_Test_Boot_TRUE)
	usb_rw_test();
	modt_post_init();
#endif
        #ifdef CONFIG_AUTOBOOT_KEYED
            int prev = disable_ctrlc(1);    /* disable Control C checking */
        #endif

        #ifdef CONFIG_STAY_IN_CONSOLE
        	boot_mode = BOOT_CONSOLE_MODE;
        #else

#ifdef CONFIG_KCPU_LOAD_OPTEE
	if(kboot_load_normal_optee_status())
	{
		run_command_list(s, -1, 0);
	}
	else
	{
		printf("[ERR] kboot load normal optee.bin fail, load rescue optee.bin ok;\n");
		printf("[ERR] your install.img don't include optee.bin\n");
	}
#else
	run_command_list(s, -1, 0);
#endif

	/* enter rescue mode because of booting failed or other reasons */
	setenv("rescue_cmd", "go r");
	boot_mode = BOOT_RESCUE_MODE;
#endif

#ifdef CONFIG_AUTOBOOT_KEYED
	disable_ctrlc(prev);    /* restore Control C checking */
#endif
    }

	if(spi_flash_check_flag){
		boot_mode = BOOT_CONSOLE_MODE;
}
/***********************************************************
 * Realtek Related
 ***********************************************************/
	if (boot_mode == BOOT_RESCUE_MODE) {	/* Enter rescue linux */
		#ifndef CONFIG_RTKPCB
		#ifndef Config_Board_Demo
		printf("Boot mode rescue USB power high \n");
		IO_Set(PIN_USB_EN_P1, 1);
		IO_Set(PIN_USB_EN_P0, 1);
		#endif
		#endif
#if defined(Config_Board_TV010_PANEL)
#ifndef IS_FPGA
		#if defined(Config_Board_TV010_R8_PANEL)
			printf("R8 set the mtg forcebg,if recovery mode \n");
			rtd_setbits(PPOVERLAY_Main_Display_Control_RSV_reg, _BIT1); //mtg
		#endif
		IO_Set(PIN_LVDS_ON_OFF, 1);
#endif
		panel_init_2nd();
#endif

#ifndef IS_FPGA
#ifdef CONFIG_REALTEK_WATCHDOG
		WATCHDOG_KICK();
#else
		WATCHDOG_DISABLE();
#endif
#endif

		CusApi_main_loop_before_enter_rescue(); // call customized function

		s = getenv ("rescue_cmd");
		if (s)
			run_command_list(s, -1, 0);
		boot_mode = BOOT_CONSOLE_MODE;
	}
	else if (boot_mode == BOOT_MANUAL_MODE) {	/* Load images but boot manually */
#ifndef IS_FPGA
		WATCHDOG_DISABLE();
#endif

#ifdef CONFIG_KCPU_LOAD_OPTEE
		if(kboot_load_normal_optee_status())
		{
			run_command_list("bootr m", -1, 0);
		}
		else
		{
			printf("[ERR] kboot load normal optee.bin fail, load rescue optee.bin ok;\n");
			printf("[ERR] your install.img don't include optee.bin\n");
		}
#else
		run_command_list("bootr m", -1, 0);
#endif


	}
#ifdef CONFIG_QC_VERIFY
	else if (boot_mode == BOOT_QC_VERIFY_MODE) {	/* For QC code */
#ifndef IS_FPGA
		WATCHDOG_DISABLE();
#endif
        #if defined (CONFIG_QC_ONCE_ALL)
        WATCHDOG_DISABLE();
        #endif
		//run_command_list("qc", -1, 0);
		#if defined (CONFIG_QC_VERIFY_ATO)
		rtd_outl(0xb801b6f4, 0x00000001); //clear watch dog counter
		rtd_outl(0xb801b6f0, 0x000000a5); //disable watch dog
		#endif
				
		#ifdef CONFIG_AUTO_PROGRAM_OTP
		rtk_auto_program_otp(); /* used to auto program otp */
		#endif

		#ifdef CONFIG_NG_PROGRAM_OTP
		// Check OSC K
		rtk_osc_autok();
		// Check ng
		rtk_disable_ng();
		#endif  

		qc_verify(2);
	}
#endif
#ifdef CONFIG_RUN_FLASH_WRITER
	else if (boot_mode == BOOT_FLASH_WRITER_MODE) {	/* For Flash Writer */
#ifndef IS_FPGA
		WATCHDOG_DISABLE();
#endif
		disable_acpu_clock(); // disable ACPU to run d>g>c
#ifndef CONFIG_STAY_IN_CONSOLE
		run_command_list("go 0x01500000", -1, 0);
#endif

	}
#endif
#ifdef CONFIG_MENUKEY
	if (menukey == CONFIG_MENUKEY) {
		s = getenv("menucmd");
		if (s)
			run_command_list(s, -1, 0);
	}
#endif /* CONFIG_MENUKEY */
#endif /* CONFIG_BOOTDELAY */

	/*
	 * Main Loop for Monitor Command Processing
	 */
#ifdef CONFIG_SYS_HUSH_PARSER
#ifndef IS_FPGA
	WATCHDOG_DISABLE();
#endif
	puts("Enter console mode, disable watchdog ...\n\n");

#if defined(CONFIG_SYS_SUPPORT_MULTICORE)
	extern uint g_console_protect_enable;
	g_console_protect_enable = 0; // disable console protection
#endif

#ifdef CONFIG_NOCS_BSD
	printf("0xb8060500=0x%08x\n", rtd_inl(0xb8060500));
	if(rtd_inl(0xb8060500) == 0xbeaa2379){
		printf("call BSD RPC automatic!!!\n");
		run_command_list("rtkbsd rpc", -1, 0);
	}
#endif

#ifdef CONFIG_USB_UPDATE_SCRIPT
        if( is_update_boot)
                run_command_list( "reset", -1, 0 );
#endif

#if defined(Config_Board_TV010_PANEL) && defined(Config_Board_TV010_R8)
    unsigned char system_lock = 0;
    getOledSysLock(&system_lock);
    if (system_lock == 1)
    {
        printf("OLED fatal error:Panel Short Circuit,You must Repair this Panel...\n");
        //while(1);
    }
#endif

	parse_file_outer();
	/* This point is never reached */
	for (;;);
#else
	for (;;) {
#ifdef CONFIG_BOOT_RETRY_TIME
		if (rc >= 0) {
			/* Saw enough of a valid command to
			 * restart the timeout.
			 */
			reset_cmd_timeout();
		}
#endif
		len = readline (CONFIG_SYS_PROMPT);

		flag = 0;	/* assume no special flags for now */
		if (len > 0)
			strcpy (lastcommand, console_buffer);
		else if (len == 0)
			flag |= CMD_FLAG_REPEAT;
#ifdef CONFIG_BOOT_RETRY_TIME
		else if (len == -2) {
			/* -2 means timed out, retry autoboot
			 */
			puts ("\nTimed out waiting for command\n");
# ifdef CONFIG_RESET_TO_RETRY
			/* Reinit board to run initialization code again */
			do_reset (NULL, 0, 0, NULL);
# else
			return;		/* retry autoboot */
# endif
		}
#endif

		if (len == -1)
			puts ("<INTERRUPT>\n");
		else
			rc = run_command(lastcommand, flag);

		if (rc <= 0) {
			/* invalid command or not repeatable, forget it */
			lastcommand[0] = 0;
		}
	}
#endif /*CONFIG_SYS_HUSH_PARSER*/
}

#ifdef CONFIG_BOOT_RETRY_TIME
/***************************************************************************
 * initialize command line timeout
 */
void init_cmd_timeout(void)
{
	char *s = getenv ("bootretry");

	if (s != NULL)
		retry_time = (int)simple_strtol(s, NULL, 10);
	else
		retry_time =  CONFIG_BOOT_RETRY_TIME;

	if (retry_time >= 0 && retry_time < CONFIG_BOOT_RETRY_MIN)
		retry_time = CONFIG_BOOT_RETRY_MIN;
}

/***************************************************************************
 * reset command line timeout to retry_time seconds
 */
void reset_cmd_timeout(void)
{
	endtime = endtick(retry_time);
}
#endif

#ifdef CONFIG_CMDLINE_EDITING

/*
 * cmdline-editing related codes from vivi.
 * Author: Janghoon Lyu <nandy@mizi.com>
 */

#define putnstr(str,n)	do {			\
		printf ("%.*s", (int)n, str);	\
	} while (0)

#define CTL_CH(c)		((c) - 'a' + 1)
#define CTL_BACKSPACE		('\b')
#define DEL			((char)255)
#define DEL7			((char)127)
#define CREAD_HIST_CHAR		('!')

#define getcmd_putch(ch)	putc(ch)
#define getcmd_getch()		getc()
#define getcmd_cbeep()		getcmd_putch('\a')

#define HIST_MAX		20
#define HIST_SIZE		CONFIG_SYS_CBSIZE

static int hist_max = 0;
static int hist_add_idx = 0;
static int hist_cur = -1;
unsigned hist_num = 0;

char* hist_list[HIST_MAX];
char hist_lines[HIST_MAX][HIST_SIZE + 1];	 /* Save room for NULL */

#define add_idx_minus_one() ((hist_add_idx == 0) ? hist_max : hist_add_idx-1)

static void hist_init(void)
{
	int i;

	hist_max = 0;
	hist_add_idx = 0;
	hist_cur = -1;
	hist_num = 0;

	for (i = 0; i < HIST_MAX; i++) {
		hist_list[i] = hist_lines[i];
		hist_list[i][0] = '\0';
	}
}

static void cread_add_to_hist(char *line)
{
	strcpy(hist_list[hist_add_idx], line);

	if (++hist_add_idx >= HIST_MAX)
		hist_add_idx = 0;

	if (hist_add_idx > hist_max)
		hist_max = hist_add_idx;

	hist_num++;
}

static char* hist_prev(void)
{
	char *ret;
	int old_cur;

	if (hist_cur < 0)
		return NULL;

	old_cur = hist_cur;
	if (--hist_cur < 0)
		hist_cur = hist_max;

	if (hist_cur == hist_add_idx) {
		hist_cur = old_cur;
		ret = NULL;
	} else
		ret = hist_list[hist_cur];

	return (ret);
}

static char* hist_next(void)
{
	char *ret;

	if (hist_cur < 0)
		return NULL;

	if (hist_cur == hist_add_idx)
		return NULL;

	if (++hist_cur > hist_max)
		hist_cur = 0;

	if (hist_cur == hist_add_idx) {
		ret = "";
	} else
		ret = hist_list[hist_cur];

	return (ret);
}

#ifndef CONFIG_CMDLINE_EDITING
static void cread_print_hist_list(void)
{
	int i;
	unsigned long n;

	n = hist_num - hist_max;

	i = hist_add_idx + 1;
	while (1) {
		if (i > hist_max)
			i = 0;
		if (i == hist_add_idx)
			break;
		printf("%s\n", hist_list[i]);
		n++;
		i++;
	}
}
#endif /* CONFIG_CMDLINE_EDITING */

#define BEGINNING_OF_LINE() {			\
	while (num) {				\
		getcmd_putch(CTL_BACKSPACE);	\
		num--;				\
	}					\
}

#define ERASE_TO_EOL() {				\
	if (num < eol_num) {				\
		printf("%*s", (int)(eol_num - num), ""); \
		do {					\
			getcmd_putch(CTL_BACKSPACE);	\
		} while (--eol_num > num);		\
	}						\
}

#define REFRESH_TO_EOL() {			\
	if (num < eol_num) {			\
		wlen = eol_num - num;		\
		putnstr(buf + num, wlen);	\
		num = eol_num;			\
	}					\
}

static void cread_add_char(char ichar, int insert, unsigned long *num,
	       unsigned long *eol_num, char *buf, unsigned long len)
{
	unsigned long wlen;

	/* room ??? */
	if (insert || *num == *eol_num) {
		if (*eol_num > len - 1) {
			getcmd_cbeep();
			return;
		}
		(*eol_num)++;
	}

	if (insert) {
		wlen = *eol_num - *num;
		if (wlen > 1) {
			memmove(&buf[*num+1], &buf[*num], wlen-1);
		}

		buf[*num] = ichar;
		putnstr(buf + *num, wlen);
		(*num)++;
		while (--wlen) {
			getcmd_putch(CTL_BACKSPACE);
		}
	} else {
		/* echo the character */
		wlen = 1;
		buf[*num] = ichar;
		putnstr(buf + *num, wlen);
		(*num)++;
	}
}

static void cread_add_str(char *str, int strsize, int insert, unsigned long *num,
	      unsigned long *eol_num, char *buf, unsigned long len)
{
	while (strsize--) {
		cread_add_char(*str, insert, num, eol_num, buf, len);
		str++;
	}
}

static int cread_line(const char *const prompt, char *buf, unsigned int *len,
		int timeout)
{
	unsigned long num = 0;
	unsigned long eol_num = 0;
	unsigned long wlen;
	char ichar;
	int insert = 1;
	int esc_len = 0;
	char esc_save[8];
	int init_len = strlen(buf);
	int first = 1;

	if (init_len)
		cread_add_str(buf, init_len, 1, &num, &eol_num, buf, *len);

	while (1) {
#ifdef CONFIG_BOOT_RETRY_TIME
		while (!tstc()) {	/* while no incoming data */
			if (retry_time >= 0 && get_ticks() > endtime)
				return (-2);	/* timed out */
			WATCHDOG_RESET();
		}
#endif
		if (first && timeout) {
			uint64_t etime = endtick(timeout);

			while (!tstc()) {	/* while no incoming data */
				if (get_ticks() >= etime)
					return -2;	/* timed out */
				WATCHDOG_RESET();
			}
			first = 0;
		}

		ichar = getcmd_getch();

		if ((ichar == '\n') || (ichar == '\r')) {
			putc('\n');
			break;
		}

		/*
		 * handle standard linux xterm esc sequences for arrow key, etc.
		 */
		if (esc_len != 0) {
			if (esc_len == 1) {
				if (ichar == '[') {
					esc_save[esc_len] = ichar;
					esc_len = 2;
				} else {
					cread_add_str(esc_save, esc_len, insert,
						      &num, &eol_num, buf, *len);
					esc_len = 0;
				}
				continue;
			}

			switch (ichar) {

			case 'D':	/* <- key */
				ichar = CTL_CH('b');
				esc_len = 0;
				break;
			case 'C':	/* -> key */
				ichar = CTL_CH('f');
				esc_len = 0;
				break;	/* pass off to ^F handler */
			case 'H':	/* Home key */
				ichar = CTL_CH('a');
				esc_len = 0;
				break;	/* pass off to ^A handler */
			case 'A':	/* up arrow */
				ichar = CTL_CH('p');
				esc_len = 0;
				break;	/* pass off to ^P handler */
			case 'B':	/* down arrow */
				ichar = CTL_CH('n');
				esc_len = 0;
				break;	/* pass off to ^N handler */
			default:
				esc_save[esc_len++] = ichar;
				cread_add_str(esc_save, esc_len, insert,
					      &num, &eol_num, buf, *len);
				esc_len = 0;
				continue;
			}
		}

		switch (ichar) {
		case 0x1b:
			if (esc_len == 0) {
				esc_save[esc_len] = ichar;
				esc_len = 1;
			} else {
				puts("impossible condition #876\n");
				esc_len = 0;
			}
			break;

		case CTL_CH('a'):
			BEGINNING_OF_LINE();
			break;
		case CTL_CH('c'):	/* ^C - break */
			*buf = '\0';	/* discard input */
			return (-1);
		case CTL_CH('f'):
			if (num < eol_num) {
				getcmd_putch(buf[num]);
				num++;
			}
			break;
		case CTL_CH('b'):
			if (num) {
				getcmd_putch(CTL_BACKSPACE);
				num--;
			}
			break;
		case CTL_CH('d'):
			if (num < eol_num) {
				wlen = eol_num - num - 1;
				if (wlen) {
					memmove(&buf[num], &buf[num+1], wlen);
					putnstr(buf + num, wlen);
				}

				getcmd_putch(' ');
				do {
					getcmd_putch(CTL_BACKSPACE);
				} while (wlen--);
				eol_num--;
			}
			break;
		case CTL_CH('k'):
			ERASE_TO_EOL();
			break;
		case CTL_CH('e'):
			REFRESH_TO_EOL();
			break;
		case CTL_CH('o'):
			insert = !insert;
			break;
		case CTL_CH('x'):
		case CTL_CH('u'):
			BEGINNING_OF_LINE();
			ERASE_TO_EOL();
			break;
		case DEL:
		case DEL7:
		case 8:
			if (num) {
				wlen = eol_num - num;
				num--;
				memmove(&buf[num], &buf[num+1], wlen);
				getcmd_putch(CTL_BACKSPACE);
				putnstr(buf + num, wlen);
				getcmd_putch(' ');
				do {
					getcmd_putch(CTL_BACKSPACE);
				} while (wlen--);
				eol_num--;
			}
			break;
		case CTL_CH('p'):
		case CTL_CH('n'):
		{
			char * hline;

			esc_len = 0;

			if (ichar == CTL_CH('p'))
				hline = hist_prev();
			else
				hline = hist_next();

			if (!hline) {
				getcmd_cbeep();
				continue;
			}

			/* nuke the current line */
			/* first, go home */
			BEGINNING_OF_LINE();

			/* erase to end of line */
			ERASE_TO_EOL();

			/* copy new line into place and display */
			strcpy(buf, hline);
			eol_num = strlen(buf);
			REFRESH_TO_EOL();
			continue;
		}
#ifdef CONFIG_AUTO_COMPLETE
		case '\t': {
			int num2, col;

			/* do not autocomplete when in the middle */
			if (num < eol_num) {
				getcmd_cbeep();
				break;
			}

			buf[num] = '\0';
			col = strlen(prompt) + eol_num;
			num2 = num;
			if (cmd_auto_complete(prompt, buf, &num2, &col)) {
				col = num2 - num;
				num += col;
				eol_num += col;
			}
			break;
		}
#endif
		default:
			cread_add_char(ichar, insert, &num, &eol_num, buf, *len);
			break;
		}
	}
	*len = eol_num;
	buf[eol_num] = '\0';	/* lose the newline */

	if (buf[0] && buf[0] != CREAD_HIST_CHAR)
		cread_add_to_hist(buf);
	hist_cur = hist_add_idx;

	return 0;
}

#endif /* CONFIG_CMDLINE_EDITING */

/****************************************************************************/

/*
 * Prompt for input and read a line.
 * If  CONFIG_BOOT_RETRY_TIME is defined and retry_time >= 0,
 * time out when time goes past endtime (timebase time in ticks).
 * Return:	number of read characters
 *		-1 if break
 *		-2 if timed out
 */
int readline (const char *const prompt)
{
	/*
	 * If console_buffer isn't 0-length the user will be prompted to modify
	 * it instead of entering it from scratch as desired.
	 */
	console_buffer[0] = '\0';

	return readline_into_buffer(prompt, console_buffer, 0);
}


int readline_into_buffer(const char *const prompt, char *buffer, int timeout)
{
	char *p = buffer;
#ifdef CONFIG_CMDLINE_EDITING
	unsigned int len = CONFIG_SYS_CBSIZE;
	int rc;
	static int initted = 0;

	/*
	 * History uses a global array which is not
	 * writable until after relocation to RAM.
	 * Revert to non-history version if still
	 * running from flash.
	 */
	if (gd->flags & GD_FLG_RELOC) {
		if (!initted) {
			hist_init();
			initted = 1;
		}

		if (prompt)
			puts (prompt);

		rc = cread_line(prompt, p, &len, timeout);
		return rc < 0 ? rc : len;

	} else {
#endif	/* CONFIG_CMDLINE_EDITING */
	char * p_buf = p;
	int	n = 0;				/* buffer index		*/
	int	plen = 0;			/* prompt length	*/
	int	col;				/* output column cnt	*/
	char	c;

	/* print prompt */
	if (prompt) {
		plen = strlen (prompt);
		puts (prompt);
	}
	col = plen;

	for (;;) {
#ifdef CONFIG_BOOT_RETRY_TIME
		while (!tstc()) {	/* while no incoming data */
			if (retry_time >= 0 && get_ticks() > endtime)
				return (-2);	/* timed out */
			WATCHDOG_RESET();
		}
#endif
		WATCHDOG_RESET();		/* Trigger watchdog, if needed */

#ifdef CONFIG_SHOW_ACTIVITY
		while (!tstc()) {
			show_activity(0);
			WATCHDOG_RESET();
		}
#endif
		c = (char)getc();

		/*
		 * Special character handling
		 */
		switch (c) {
		case '\r':				/* Enter		*/
		case '\n':
			*p = '\0';
			puts ("\r\n");
			return (p - p_buf);

		case '\0':				/* nul			*/
			continue;

		case 0x03:				/* ^C - break		*/
			p_buf[0] = '\0';	/* discard input */
			return (-1);

		case 0x15:				/* ^U - erase line	*/
			while (col > plen) {
				puts (erase_seq);
				--col;
			}
			p = p_buf;
			n = 0;
			continue;

		case 0x17:				/* ^W - erase word	*/
			p=delete_char(p_buf, p, &col, &n, plen);
			while ((n > 0) && (*p != ' ')) {
				p=delete_char(p_buf, p, &col, &n, plen);
			}
			continue;

		case 0x08:				/* ^H  - backspace	*/
		case 0x7F:				/* DEL - backspace	*/
			p=delete_char(p_buf, p, &col, &n, plen);
			continue;

		default:
			/*
			 * Must be a normal character then
			 */
			if (n < CONFIG_SYS_CBSIZE-2) {
				if (c == '\t') {	/* expand TABs		*/
#ifdef CONFIG_AUTO_COMPLETE
					/* if auto completion triggered just continue */
					*p = '\0';
					if (cmd_auto_complete(prompt, console_buffer, &n, &col)) {
						p = p_buf + n;	/* reset */
						continue;
					}
#endif
					puts (tab_seq+(col&07));
					col += 8 - (col&07);
				} else {
					++col;		/* echo input		*/
					putc (c);
				}
				*p++ = c;
				++n;
			} else {			/* Buffer full		*/
				putc ('\a');
			}
		}
	}
#ifdef CONFIG_CMDLINE_EDITING
	}
#endif
}

/****************************************************************************/

static char * delete_char (char *buffer, char *p, int *colp, int *np, int plen)
{
	char *s;

	if (*np == 0) {
		return (p);
	}

	if (*(--p) == '\t') {			/* will retype the whole line	*/
		while (*colp > plen) {
			puts (erase_seq);
			(*colp)--;
		}
		for (s=buffer; s<p; ++s) {
			if (*s == '\t') {
				puts (tab_seq+((*colp) & 07));
				*colp += 8 - ((*colp) & 07);
			} else {
				++(*colp);
				putc (*s);
			}
		}
	} else {
		puts (erase_seq);
		(*colp)--;
	}
	(*np)--;
	return (p);
}

/****************************************************************************/
#ifndef CONFIG_SYS_HUSH_PARSER
int parse_line (char *line, char *argv[])
{
	int nargs = 0;

#ifdef DEBUG_PARSER
	printf ("parse_line: \"%s\"\n", line);
#endif
	while (nargs < CONFIG_SYS_MAXARGS) {

		/* skip any white space */
		while (isblank(*line))
			++line;

		if (*line == '\0') {	/* end of line, no more args	*/
			argv[nargs] = NULL;
#ifdef DEBUG_PARSER
		printf ("parse_line: nargs=%d\n", nargs);
#endif
			return (nargs);
		}

		argv[nargs++] = line;	/* begin of argument string	*/

		/* find end of string */
		while (*line && !isblank(*line))
			++line;

		if (*line == '\0') {	/* end of line, no more args	*/
			argv[nargs] = NULL;
#ifdef DEBUG_PARSER
		printf ("parse_line: nargs=%d\n", nargs);
#endif
			return (nargs);
		}

		*line++ = '\0';		/* terminate current arg	 */
	}

	printf ("** Too many args (max. %d) **\n", CONFIG_SYS_MAXARGS);

#ifdef DEBUG_PARSER
	printf ("parse_line: nargs=%d\n", nargs);
#endif
	return (nargs);
}
#endif
/****************************************************************************/

#ifndef CONFIG_SYS_HUSH_PARSER
static void process_macros (const char *input, char *output)
{
	char c, prev;
	const char *varname_start = NULL;
	int inputcnt = strlen (input);
	int outputcnt = CONFIG_SYS_CBSIZE;
	int state = 0;		/* 0 = waiting for '$'  */

	/* 1 = waiting for '(' or '{' */
	/* 2 = waiting for ')' or '}' */
	/* 3 = waiting for '''  */
#ifdef DEBUG_PARSER
	char *output_start = output;

	printf ("[PROCESS_MACROS] INPUT len %d: \"%s\"\n", strlen (input),
		input);
#endif

	prev = '\0';		/* previous character   */

	while (inputcnt && outputcnt) {
		c = *input++;
		inputcnt--;

		if (state != 3) {
			/* remove one level of escape characters */
			if ((c == '\\') && (prev != '\\')) {
				if (inputcnt-- == 0)
					break;
				prev = c;
				c = *input++;
			}
		}

		switch (state) {
		case 0:	/* Waiting for (unescaped) $    */
			if ((c == '\'') && (prev != '\\')) {
				state = 3;
				break;
			}
			if ((c == '$') && (prev != '\\')) {
				state++;
			} else {
				*(output++) = c;
				outputcnt--;
			}
			break;
		case 1:	/* Waiting for (        */
			if (c == '(' || c == '{') {
				state++;
				varname_start = input;
			} else {
				state = 0;
				*(output++) = '$';
				outputcnt--;

				if (outputcnt) {
					*(output++) = c;
					outputcnt--;
				}
			}
			break;
		case 2:	/* Waiting for )        */
			if (c == ')' || c == '}') {
				int i;
				char envname[CONFIG_SYS_CBSIZE], *envval;
				int envcnt = input - varname_start - 1;	/* Varname # of chars */

				/* Get the varname */
				for (i = 0; i < envcnt; i++) {
					envname[i] = varname_start[i];
				}
				envname[i] = 0;

				/* Get its value */
				envval = getenv (envname);

				/* Copy into the line if it exists */
				if (envval != NULL)
					while ((*envval) && outputcnt) {
						*(output++) = *(envval++);
						outputcnt--;
					}
				/* Look for another '$' */
				state = 0;
			}
			break;
		case 3:	/* Waiting for '        */
			if ((c == '\'') && (prev != '\\')) {
				state = 0;
			} else {
				*(output++) = c;
				outputcnt--;
			}
			break;
		}
		prev = c;
	}

	if (outputcnt)
		*output = 0;
	else
		*(output - 1) = 0;

#ifdef DEBUG_PARSER
	printf ("[PROCESS_MACROS] OUTPUT len %d: \"%s\"\n",
		strlen (output_start), output_start);
#endif
}

/****************************************************************************
 * returns:
 *	1  - command executed, repeatable
 *	0  - command executed but not repeatable, interrupted commands are
 *	     always considered not repeatable
 *	-1 - not executed (unrecognized, bootd recursion or too many args)
 *           (If cmd is NULL or "" or longer than CONFIG_SYS_CBSIZE-1 it is
 *           considered unrecognized)
 *
 * WARNING:
 *
 * We must create a temporary copy of the command since the command we get
 * may be the result from getenv(), which returns a pointer directly to
 * the environment data, which may change magicly when the command we run
 * creates or modifies environment variables (like "bootp" does).
 */
static int builtin_run_command(const char *cmd, int flag)
{
	char cmdbuf[CONFIG_SYS_CBSIZE];	/* working copy of cmd		*/
	char *token;			/* start of token in cmdbuf	*/
	char *sep;			/* end of token (separator) in cmdbuf */
	char finaltoken[CONFIG_SYS_CBSIZE];
	char *str = cmdbuf;
	char *argv[CONFIG_SYS_MAXARGS + 1];	/* NULL terminated	*/
	int argc, inquotes;
	int repeatable = 1;
	int rc = 0;

#ifdef DEBUG_PARSER
	printf ("[RUN_COMMAND] cmd[%p]=\"", cmd);
	puts (cmd ? cmd : "NULL");	/* use puts - string may be loooong */
	puts ("\"\n");
#endif

	clear_ctrlc();		/* forget any previous Control C */

	if (!cmd || !*cmd) {
		return -1;	/* empty command */
	}

	if (strlen(cmd) >= CONFIG_SYS_CBSIZE) {
		puts ("## Command too long!\n");
		return -1;
	}

	strcpy (cmdbuf, cmd);

	/* Process separators and check for invalid
	 * repeatable commands
	 */

#ifdef DEBUG_PARSER
	printf ("[PROCESS_SEPARATORS] %s\n", cmd);
#endif
	while (*str) {

		/*
		 * Find separator, or string end
		 * Allow simple escape of ';' by writing "\;"
		 */
		for (inquotes = 0, sep = str; *sep; sep++) {
			if ((*sep=='\'') &&
			    (*(sep-1) != '\\'))
				inquotes=!inquotes;

			if (!inquotes &&
			    (*sep == ';') &&	/* separator		*/
			    ( sep != str) &&	/* past string start	*/
			    (*(sep-1) != '\\'))	/* and NOT escaped	*/
				break;
		}

		/*
		 * Limit the token to data between separators
		 */
		token = str;
		if (*sep) {
			str = sep + 1;	/* start of command for next pass */
			*sep = '\0';
		}
		else
			str = sep;	/* no more commands for next pass */
#ifdef DEBUG_PARSER
		printf ("token: \"%s\"\n", token);
#endif

		/* find macros in this token and replace them */
		process_macros (token, finaltoken);

		/* Extract arguments */
		if ((argc = parse_line (finaltoken, argv)) == 0) {
			rc = -1;	/* no command at all */
			continue;
		}

		if (cmd_process(flag, argc, argv, &repeatable))
			rc = -1;

		/* Did the user stop this? */
		if (had_ctrlc ())
			return -1;	/* if stopped then not repeatable */
	}

	return rc ? rc : repeatable;
}
#endif

/*
 * Run a command using the selected parser.
 *
 * @param cmd	Command to run
 * @param flag	Execution flags (CMD_FLAG_...)
 * @return 0 on success, or != 0 on error.
 */
int run_command(const char *cmd, int flag)
{
#ifndef CONFIG_SYS_HUSH_PARSER
	/*
	 * builtin_run_command can return 0 or 1 for success, so clean up
	 * its result.
	 */
	if (builtin_run_command(cmd, flag) == -1)
		return 1;

	return 0;
#else
	return parse_string_outer(cmd,
			FLAG_PARSE_SEMICOLON | FLAG_EXIT_FROM_LOOP);
#endif
}

#ifndef CONFIG_SYS_HUSH_PARSER
/**
 * Execute a list of command separated by ; or \n using the built-in parser.
 *
 * This function cannot take a const char * for the command, since if it
 * finds newlines in the string, it replaces them with \0.
 *
 * @param cmd	String containing list of commands
 * @param flag	Execution flags (CMD_FLAG_...)
 * @return 0 on success, or != 0 on error.
 */
static int builtin_run_command_list(char *cmd, int flag)
{
	char *line, *next;
	int rcode = 0;

	/*
	 * Break into individual lines, and execute each line; terminate on
	 * error.
	 */
	line = next = cmd;
	while (*next) {
		if (*next == '\n') {
			*next = '\0';
			/* run only non-empty commands */
			if (*line) {
				debug("** exec: \"%s\"\n", line);
				if (builtin_run_command(line, 0) < 0) {
					rcode = 1;
					break;
				}
			}
			line = next + 1;
		}
		++next;
	}
	if (rcode == 0 && *line)
		rcode = (builtin_run_command(line, 0) >= 0);

	return rcode;
}
#endif

int run_command_list(const char *cmd, int len, int flag)
{
	int need_buff = 1;
	char *buff = (char *)cmd;	/* cast away const */
	int rcode = 0;

	if (len == -1) {
		len = strlen(cmd);
#ifdef CONFIG_SYS_HUSH_PARSER
		/* hush will never change our string */
		need_buff = 0;
#else
		/* the built-in parser will change our string if it sees \n */
		need_buff = strchr(cmd, '\n') != NULL;
#endif
	}
	if (need_buff) {
		buff = malloc(len + 1);
		if (!buff)
			return 1;
		memcpy(buff, cmd, len);
		buff[len] = '\0';
	}
#ifdef CONFIG_SYS_HUSH_PARSER
	rcode = parse_string_outer(buff, FLAG_PARSE_SEMICOLON);
#else
	/*
	 * This function will overwrite any \n it sees with a \0, which
	 * is why it can't work with a const char *. Here we are making
	 * using of internal knowledge of this function, to avoid always
	 * doing a malloc() which is actually required only in a case that
	 * is pretty rare.
	 */
	rcode = builtin_run_command_list(buff, flag);
	if (need_buff)
		free(buff);
#endif

	return rcode;
}

/****************************************************************************/

#if defined(CONFIG_CMD_RUN)
int do_run (cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[])
{
	int i;

	if (argc < 2)
		return CMD_RET_USAGE;

	for (i=1; i<argc; ++i) {
		char *arg;

		if ((arg = getenv (argv[i])) == NULL) {
			printf ("## Error: \"%s\" not defined\n", argv[i]);
			return 1;
		}

		if (run_command(arg, flag) != 0)
			return 1;
	}
	return 0;
}
#endif

#if CONFIG_ANDROID_RECOVERY
void cleanRecoveryCmd(int enterRecovery)
{
	if(enterRecovery == 1)
	{
		char *dst_addr;
		int dst_length, rc;
		if (factory_read(BOOT_RECOVERY_FILE_NAME, &dst_addr, &dst_length))
		{
			printf("in TAB ------------can't find %s\n", BOOT_RECOVERY_FILE_NAME);
		}
		else
		{
			bootloader_message* pBootMsg = (bootloader_message*)dst_addr;
			printf("\n in TAB ----remove recovery command and status--------\n");
			memset(pBootMsg->command, '\0', sizeof(pBootMsg->command));
			memset(pBootMsg->status, '\0', sizeof(pBootMsg->status));

			rc = factory_write(BOOT_RECOVERY_FILE_NAME, dst_addr, dst_length);
			if(rc) {
				printf("%s: factory_write error.\n", BOOT_RECOVERY_FILE_NAME);
			}
			factory_save();
		}
	}
}

#if defined(CONFIG_ANDROID_RECOVERY) && defined(CONFIG_CUSTOMER_TV010)
void writeRecoveryCmd(const char *filename)
{
	int rc;
	factory_delete(BOOT_RECOVERY_FILE_NAME);

	bootloader_message boot;
	memset(&boot, 0, sizeof(boot));
	sprintf(boot.command, "boot-recovery");
	if( NULL == filename )
		sprintf(boot.recovery,"recovery\n--show_text\n--locale=zh_CN" );
	else
		sprintf(boot.recovery,"recovery\n--update_package=%s%s\n--wipe_data\n--locale=zh_CN", USB_STORAGE_UPGRADE_FILE_PATH,filename);

	printf("writeRecoveryCmd, command: %s \n", boot.command);
	printf("writeRecoveryCmd, recovery: %s \n", boot.recovery);

	rc = factory_write(BOOT_RECOVERY_FILE_NAME, (char *)&boot, sizeof(boot));
	if(rc) {
		printf("%s: factory_write error.\n", BOOT_RECOVERY_FILE_NAME);
	}
	factory_save();
}
#endif

void getBootVersion(void)
{
    struct boot_img_hdr_v0 *boot_img_hdr = (struct boot_img_hdr_v0 *)CONFIG_BOOT_IMG_BUF_ADDR;
    gpt_entry entry;
    unsigned long long start;
    unsigned long long size;

    get_gpt_entry_by_name(&entry, "boot");
    start = get_partition_starting_by_gpt_entry(entry);
    size = BLOCK_SIZE;
    start = start/size;
    rtk_eMMC_read(start, size, (unsigned int*)CONFIG_BOOT_IMG_BUF_ADDR);

    if(strncmp(BOOT_MAGIC, (char*)boot_img_hdr->magic, sizeof(boot_img_hdr->magic)) == 0) {
        bNewbootflow = 1;
    }
}
#endif
