#include <common.h>
#include <u-boot/zlib.h>
#include <asm/byteorder.h>
#include <fdt.h>
#include <libfdt.h>
#include <fdt_support.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/system.h>
#include <exports.h>
#include <environment.h>
#include <wakeup.h>
#include <asm/arch/system.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/bootparam.h>
#include <platform_lib/board/pcb_mgr.h>
#include <watchdog.h>
#include <factorylib.h>

#define REG_MAGIC_51                               0xb8060110
#define REG_EMCU_RESET                             0xB8060034
#define REG_EMCU_CLKEN                             0xb8060044
#define SHARE_MEMORY_FOR_LED_STANDBY_TYPE          0xB8060570

extern int PanelID_NoMatch;
extern int boot_power_on_mode;
extern int BOOT_STDWN_RTRY_CNT;

int CusApi_get_powerdown_param(char *param, int buf_length)
{
	return 0;
}

void CusApi_boot_prep_linux_for_standby(void)
{
        printf("PanelID_NoMatch = %d\n",PanelID_NoMatch);

        if(PanelID_NoMatch){
            if(BOOT_STDWN_RTRY_CNT > 5)
                rtd_outl(REG_MAGIC_51, 0xbaad000D);
            else
                rtd_outl(REG_MAGIC_51, 0xbaad0005);
        }
#if 1//defined(CONFIG_MISC_MGR_WAKEUP)
       // printf("boot_power_on_mode =%d\n",boot_power_on_mode);
        if(boot_power_on_mode == POWER_OFF)
        {
            unsigned long long value=0;
            unsigned int  keyarray[2] = { 0x9500000, 0x000000 };

            unsigned long long keypad[6]={0x00,0x00,0x00,0x00,0x00,0x00};

            if (pcb_mgr_get_enum_info_byname("PIN_KEYPAD_PWR", &value) == 0)
            {
                keypad[0] = value;
            }

            powerMgr_setup_irda(4, 1, &keyarray[0]);
            powerMgr_setup_keypad_multi(1, &keypad[0]);
        }
#endif

}

void CusApi_linux_param_set(char *kargs)
{
}

void CusApi_boot_prep_linux_bootargs(void)
{
    char *commandline = NULL;
    char *tmp_cmdline = NULL;
    int len = 0;

    if(CONFIG_VIP_RESERVED_ADDR) {
        commandline = getenv("bootargs");
        len = strlen(commandline) + 32;
        tmp_cmdline = (char *)malloc(len);
        if (!tmp_cmdline) {
            printf("[ERR] %s: Malloc failed\n", __func__);
        }
        else {
            memset(tmp_cmdline, 0, len);

            sprintf(tmp_cmdline, "%s VIP=%dM@%dM", commandline,
			VIP_UBOOT_RESERVED_SIZE >> 20,
			VIP_UBOOT_RESERVED_ADDR >> 20
		);
            setenv("bootargs", tmp_cmdline);

            free(tmp_cmdline);
        }
    }

    if(CONFIG_OD_RESERVED_ADDR) {
        commandline = getenv("bootargs");
        len = strlen(commandline) + 32;
        tmp_cmdline = (char *)malloc(len);
        if (!tmp_cmdline) {
           printf("[ERR] %s: Malloc failed\n", __func__);
        }
        else {
            memset(tmp_cmdline, 0, len);

            sprintf(tmp_cmdline, "%s OD=%dM@%dM", commandline,
			OD_UBOOT_RESERVED_SIZE >> 20,
			OD_UBOOT_RESERVED_ADDR >> 20
           );
            setenv("bootargs", tmp_cmdline);

            free(tmp_cmdline);
        }
    }
}
