/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 2012 by Chuck Chen <ycchen@realtek.com>
 *
 * panel select command
*/
#include <common.h>
#include <command.h>
#include <malloc.h>
#include <asm/arch/system.h>
#include <tar.h>
#include <factorylib.h>
#include <factorylib_ro.h>
#ifdef CONFIG_LZMA
#include <lzma/LzmaTypes.h>
#include <lzma/LzmaDec.h>
#include <lzma/LzmaTools.h>
#endif /* CONFIG_LZMA */
#include "cus_bootparam.h"


//#define PANEL_CONFIG_FROM_FACTORY_PANEL_HEADER	// from Darwin feature
//#define PANEL_CONFIG_FROM_FACTORY_PANEL_BIN	// from MacArthur feature

#define PANEL_BIN_FILENAME_IN_FACTORY	FACTORY_HEADER_FILE_NAME"bin_panel/panel.bin"
//#define PANEL_SPEC_INFO_FILE_NAME		FACTORY_HEADER_FILE_NAME"panelspecindex/panelspec_info"
#define PANEL_BIN_FILE_PREFIX			FACTORY_HEADER_FILE_NAME"bin_panel/panel/"

#define SN_PANEL_BIN_FILE			FACTORY_RO_HEADER_FILE_NAME"bin_panel/panel/sn_panel.bin"
#define PN_BLOCK_SIZE 611//0x00~0x262
#define PN_HEADER_SIZE 0x20//0x00~0x1F

#if 0 //def PANEL_CONFIG_FROM_FACTORY_PANEL_HEADER
extern char panel_file_name[100];
#endif

extern unsigned int tar_read_print_info;
extern unsigned char tar_read_print_prefix[32];

extern uint env_panel_change_panel_bin_in_factory(char *panel_bin_path);
extern uchar env_setup_env_panel(uchar *panel_filename);

#ifdef CONFIG_CUSTOM_SN_PANEL	
#include <common.h>
#include <drivers/i2c/rtk_i2c_lib.h>
#include "panel.h"
#include <panel_config_parameter.h>

#define SN_PANEL_BIN_FILE_PREFIX			FACTORY_RO_HEADER_FILE_NAME"bin_panel/panel/sn_panel.bin"

extern uchar env_setup_env_panel_sn(uchar *panel_filename);

extern uchar env_setup_sn_panel(uchar *panel_filename);
#define PANEL_NUM 55	//48

extern PANEL_CONFIG_PARAMETER_SN panel_setting[PANEL_NUM];
extern bool EnPnUpdate;

//extern uint env_panel_sn_change_panel_bin_in_factory(char *panel_bin_path);
#else
#include <asm/arch/panel/panel_setting.h>

#endif

extern int gets(char *s);
extern char* strtrim(char *s);

#ifdef CONFIG_CUSTOMER_TV010
extern int printPanelListFromIni(char *filestart, size_t filelen);
#endif


#ifdef CONFIG_CUSTOM_SN_PANEL
extern int do_PQ_file_change_handle(const char *cur_panelname, const char *prev_panelname);
extern void delete_PQ_file(void);

extern struct _PANEL_CONFIG_PARAMETER  default_panel_parameter;

void panel_information_display(char type)
{
    UINT8 tmpPanelIndex=0;
    //UINT32 tmpPanel_Number=0;
    char tmpPanelIDString[17]={0};
    char tmpRevString[17]={0};
    UINT8 tmpChassis_Index=0;
    int tmpPanel_Width=3840;
    int tmpPanel_Height=2160;

    char *rev_ptr_p=NULL;
    char *raw_ptr_s = NULL;
    char *raw_ptr_p = NULL;
    int file_len = 0;
    int i  = 0;
    UINT32 tmpPanelCnt=0;

    char *tar_read_file_full_path = NULL;
    tar_read_file_full_path = malloc(100);
    memset(tar_read_file_full_path, 0, 100);
    sprintf(tar_read_file_full_path, "%s", SN_PANEL_BIN_FILE_PREFIX);
    if ((factory_ro_read((char *)SN_PANEL_BIN_FILE, &raw_ptr_s, &file_len) == 0)) {

        printf("sn_panel.bin size =%d (0x%x) byte.\n",file_len,file_len);
        raw_ptr_p=raw_ptr_s+PN_HEADER_SIZE+i*PN_BLOCK_SIZE;
        rev_ptr_p =raw_ptr_s+PN_HEADER_SIZE+i*PN_BLOCK_SIZE;
        memcpy(&tmpRevString,rev_ptr_p, sizeof(char)*16);
        printf("Version:%s \n",rev_ptr_p);

        memcpy(&tmpPanelCnt,raw_ptr_p+16, sizeof(UINT32));

        //tmpPanelCnt =panel_setting[select].snInfo[0].Panel_Number;
        //tmpPanelCnt=16;
        printf("Panel Number =%d\n",tmpPanelCnt);
        if(type==0)
            printf("ID    Index    Chassis-  (Width x Height)\n");
        else
            printf("Index    ID    Chassis-  (Width x Height)\n");
        for(i=0;i<tmpPanelCnt;i++){
        raw_ptr_p=raw_ptr_s+PN_HEADER_SIZE+i*PN_BLOCK_SIZE;
        //memcpy(&tmpPanel_Number,raw_ptr_p+16, sizeof(UINT32));
        memcpy(&tmpPanelIndex,raw_ptr_p+32, sizeof(UINT8));
        memcpy(tmpPanelIDString,raw_ptr_p+33, sizeof(char)*16);
        //strncpy(IDs,tmpPanelIDString,16);
        memcpy(&tmpChassis_Index,raw_ptr_p+50, sizeof(UINT8));
        memcpy(&tmpPanel_Width,raw_ptr_p+51, sizeof(UINT16));
        memcpy(&tmpPanel_Height,raw_ptr_p+53, sizeof(UINT16));
        if(type==0)
            printf(" %s  %d  %d (%dx%d)\n",tmpPanelIDString ,tmpPanelIndex,tmpChassis_Index,tmpPanel_Width,tmpPanel_Height);
        else               
            printf(" [%d]  %s  %d (%dx%d)\n",tmpPanelIndex,tmpPanelIDString,tmpChassis_Index,tmpPanel_Width,tmpPanel_Height);                
        }
        //printf("-----------------------------------------------\n");
    }
}

int do_sn_panel_selection(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
	char buf[128];
	int select = -1, prev_select = -1;

    UINT32 tmpPanelCnt=0;
	char *raw_ptr_s = NULL;
	//char *raw_ptr_p = NULL;
	int file_len = 0;
    
	const char *oldselect = getenv("panel_select");

	const char *oldPanelDbg = getenv("PANEL_DEBUG");

	if(oldPanelDbg==NULL)
		;
#if defined(Config_Module_Test_Boot_TRUE)
#ifdef CONFIG_FORCE_PANEL_NUM
	//marked by yorke
	//setenv("panel_detect", FORCE_PANEL_NUM);
	//saveenv();

	printf("MT cannot select panel, using panel [9] %s\n", panel_setting[FORCE_PANEL_NUM].sPanelName);
	return CMD_RET_SUCCESS;
#endif
#endif

#if defined(CONFIG_AUTODETECT_PANEL) || defined(CONFIG_CUSTOM_SN_PANEL)

	int autodetect = 0;
	const char *paneldetect = getenv("panel_detect");

	autodetect = simple_strtoul(paneldetect, NULL, 10);
	if(autodetect)
		;
#endif

	int panelmodebg = 0;
	const char *panelmodeStr = getenv("PANEL_DEBUG");

	panelmodebg = simple_strtoul(panelmodeStr, NULL, 10);
	printf("--panelmodebg=%d--\n",panelmodebg);

#if defined(CONFIG_AUTODETECT_PANEL) || defined(CONFIG_CUSTOM_SN_PANEL)

	printf("===================================================\n");
	printf("Please select panel debug method, current is %s mode\n", (panelmodebg ? "Normal":"Debug"));
	printf("[0] Debug mode\n[1] Normal mode\n[2] info\n[3] Test Panel ID out of list\n[4] Rtk panel setting\n");
	printf("=> ");
	gets(buf);
	select = simple_strtoul(strtrim(buf), NULL, 10);
	panelmodebg = simple_strtoul(strtrim(buf), NULL, 10);
	
	
	setenv("panel_detect", strim(buf));
	if(select ==1)
	{
		printf("\n===================================================\n");
		printf("### your selection is [1] Normal mode ###\n");
		printf("===================================================\n");
		setenv("PANEL_DEBUG", strim(buf));
		setenv("rtk_pn", "0");
		saveenv();
		//eric test
		return CMD_RET_SUCCESS;
	}	
	else if(select ==2){
		printf("\n===================================================\n");
		printf("Panel & HW info \n");
		unsigned char data[16] = {0};
		char IDs[17] = {0};
		//IDs[16]=0x0a;
		unsigned char regAddr[2] = {0,0xE0}; //regAddr[2] = {0x0,0xe0}; 		
		int len,ii;   
		int ret;
		len =16;   
				//lenjj=16;
		I2C_Init();
		I2C_SetSpeed( TCON_I2C , 400 );
		printf("1.NVM Panel ID : \n");
		ret=I2C_Read_EX(TCON_I2C, 0x55 , 2, regAddr, len, data);
		if(ret !=S_OK)
				printf("Please check Panel connection? --\n");
		else{
			for(ii = 0; ii < len; ii++){
					printf("%02X ",data[ii]);
				if((ii%16)==15) 
					printf("\n");
			}
		}	
		printf("\n");

#ifndef CONFIG_RTKPCB
		int panel_type = IO_Get(PIN_PANEL_LESS);
		if(panel_type==0)
			printf("2.Panel less GPIO =%d,panel connected. \n",panel_type);
		else	
			printf("2.Panel less GPIO =%d ,panel disconnected.\n",panel_type);
#endif

		printf("\n");
		char *raw_ptr = NULL;
        
		if(factory_read((char *)PANEL_BIN_FILENAME_IN_FACTORY, &raw_ptr, &file_len) == 0) {
			memcpy(&default_panel_parameter, raw_ptr, sizeof(default_panel_parameter));

			if(default_panel_parameter.snInfo.PanelIDString[0]==0)
				printf("3.Panel ID read from Panel.bin is null\n");
			else{	
				strncpy(IDs,default_panel_parameter.snInfo.PanelIDString,16);
				printf("3.Panel ID read from Panel.bin,\n");
				printf(" PanelIDString=%s \n",IDs);
			}	
		}	

		printf("\n");
		printf("4.Sn Panel list: \n");
		panel_information_display(0);
		
		return CMD_RET_SUCCESS;
		
	}
	else if(select ==3){
		printf("\n[0]Disable Panel ID out of list \n");
		printf("[1]Enable Panel ID out of list \n");
		//const char *PanelID_OutList = getenv("PanelID_out_list");
		
		printf("=> ");
		gets(buf);
		setenv("PanelID_out_list", strim(buf));
		saveenv();
		return CMD_RET_SUCCESS;
	}
	else if(select ==4){
		//Bypass sync from sn_panel.bin
		printf("\n[0]Disable RTK panel \n");
		printf("[1]Enable RTK panel \n");		
		printf("=> ");
		gets(buf);
		setenv("rtk_pn", strim(buf));
		saveenv();
		return CMD_RET_SUCCESS;
	}	
	else
	{
		printf("\n===================================================\n");
		printf("### your selection is [1] Debug mode ###\n");
		setenv("PANEL_DEBUG", strim(buf));
                EnPnUpdate=1;      
	}

        
#endif
	select = simple_strtoul(oldselect, NULL, 10);
	printf("===================================================\n");
	if(oldselect != NULL)
	{ 
		printf("The current selection is [%d] %s\n", select, panel_setting[select].sPanelName);
		prev_select = select;
	}
	else
	{
		printf("You don't select any panel, default is %s\n", panel_setting[0].sPanelName);
		prev_select = 0;
	}
	printf("===================================================\n");
	printf("Please select the panel number you want:\n");

    if(factory_ro_read((char *)SN_PANEL_BIN_FILE, &raw_ptr_s, &file_len) == 0)
    {
        tmpPanelCnt=file_len/PN_BLOCK_SIZE;
    }

	panel_information_display(1);
	/*    
	for( i = 0; i < tmpPanelCnt ; i++)
	{
		printf("[%d] %s\n", i, panel_setting[i].sPanelName);
	}*/

	printf("=> ");
	gets(buf);
	select = simple_strtoul(strtrim(buf), NULL, 10);
	//printf("--panel_setting[%d]=%d--\n",select,sizeof(panel_setting[select]));
	if( select < tmpPanelCnt && select >=0)
	{
		printf("\n===================================================\n");
		printf("you have selected [%d] %s\n", select, panel_setting[select].sPanelName);
		printf("===================================================\n");
		setenv("panel_select", strim(buf));
		setenv("PANEL_SELECT", strim(buf));
		saveenv();

		if(select != prev_select)
			//do_PQ_file_change_handle(panel_setting[select].sPanelName, panel_setting[prev_select].sPanelName);
			delete_PQ_file();

		
		char *tar_read_file_full_path = NULL;
		tar_read_file_full_path = malloc(100);
		memset(tar_read_file_full_path, 0, 100);
		sprintf(tar_read_file_full_path, "%s", SN_PANEL_BIN_FILE_PREFIX); // get file full path
		
		#ifdef CONFIG_CUSTOM_SN_PANEL
		if (env_setup_sn_panel((uchar *)tar_read_file_full_path))
		{
			env_panel_change_panel_bin_in_factory(PANEL_BIN_FILENAME_IN_FACTORY);
		}

		env_setup_env_panel_sn((uchar *)PANEL_BIN_FILENAME_IN_FACTORY);
				
		free(tar_read_file_full_path);	
		#endif
		
	}
	else
	{
		printf("\n [ERR] wrong input! \n");
	}

	return CMD_RET_SUCCESS;
}

#endif
