#include <common.h>
#include <asm/arch/bootparam.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/system.h>
#include <exports.h>
#include <drivers/i2c/rtk_g2c_lib.h>
#include <drivers/i2c/rtk_i2c_lib.h>
#include <panel.h>
#include <panel_config_parameter.h>


#ifdef CONFIG_CUSTOM_SN_PANEL
#include <ppoverlay_reg.h>
#include <sfg_reg.h>

extern int IsID_Match(void);
extern void rtd_part_outl(unsigned int addr, unsigned int B, unsigned int C, unsigned int D);
extern void panel_set_spread_spectrum(UINT8  bEnable, UINT16 u16Percent, UINT32 ss_freq);
extern int boot_power_on_mode;
#if defined(Config_Vulcan3_PCB_TRUE)
extern int EnableFHD;
#endif
#endif
#ifdef CONFIG_CUSTOM_PQ_SELECT
#define MODEL_ENV_FILE_NAME "tmp/factory/Model_Env.xml"
extern int CusApi_env_readXmlFile(const char* pFileName, const char *pItemName, char *pParameter, size_t parameterLen);
#endif
#ifdef CONFIG_TCON_LESS
#include <factorylib.h>
#include <factorylib_ro.h>
#include <asm/arch/takeoverlib_ext4.h>
#endif
#ifdef CONFIG_CUSTOM_SET_SERIAL_NUMBER
#define SERIAL_CODE         "serialNumber"
#define PRODUCT_CODE        "product_code"
#define FACTORY_SERIAL_NUMBER_FILE  "tmp/factory/serialNumber.xml"
#define TAKEOVER_SERIAL_NUMBER_FILE   "takeover/serialNumber.xml"

#if defined(CONFIG_FSW)
extern bool fsw_emmc_bootup;
extern bool fsw_spi_bootup;
#endif
extern int fsw_2k_panel_id;

extern uchar boot_panel_type;

void env_SetSerialNo(char *pParameter)
{
	int i;
	char convet_code[12] = {0};
	//char under_symbol = '_';
	char finalstr[32] = {0};
	char serialStr[12]={0};
	char defaultvalue[7] = {'0','0','0','0','0','0','0'};
	char* serialstr;
	for(i = 0; i < 12 ; i++)
	{
		if(i == 0)
			continue;
		else
		{
			if(pParameter[i] == '0')
				convet_code[i-1] = 'x';
			else if(pParameter[i] == '1')
				convet_code[i-1] = 'q';
			else if(pParameter[i] == '2')
				convet_code[i-1] = 'a';
			else if(pParameter[i] == '3')
				convet_code[i-1] = 'z';
			else if(pParameter[i] == '4')
				convet_code[i-1] = 'w';
			else if(pParameter[i] == '5')
				convet_code[i-1] = 'e';
			else if(pParameter[i] == '6')
				convet_code[i-1] = 's';
			else if(pParameter[i] == '7')
				convet_code[i-1] = 'd';
			else if(pParameter[i] == '8')
				convet_code[i-1] = 'c';
			else if(pParameter[i] == '9')
				convet_code[i-1] = 'v';
		}
	}

    //read serial number
	if(!CusApi_env_readXmlFile(FACTORY_SERIAL_NUMBER_FILE,SERIAL_CODE,serialStr,sizeof(serialStr)))
	{
		sprintf(finalstr, "%s%s", convet_code,serialStr);
	}
	else if(!CusApi_env_readXmlFile(TAKEOVER_SERIAL_NUMBER_FILE,SERIAL_CODE,serialStr,sizeof(serialStr)))
		{
		sprintf(finalstr, "%s%s", convet_code,serialStr);
	}
	else
	{
		sprintf(finalstr, "%s%s", convet_code,defaultvalue);
	}

    //setenv
	if (((serialstr = getenv("FINAL_SERIAL_NUMBER")) != NULL) && (strcmp(serialstr, finalstr) == 0))
		printf("the serial number is the same as before\n");
	else
	{
		setenv("FINAL_SERIAL_NUMBER", finalstr);
	}
}
#endif

bool CusApi_panel_interface_common(void)
{
#ifdef CONFIG_CUSTOM_SN_PANEL
#ifdef CONFIG_TCON_LESS
#ifndef CONFIG_RTKPCB
	int pin_panel_less = IO_Get(PIN_PANEL_LESS);
	int pin_fbffc_top = IO_Get(PIN_FBFFC_TOP);
	int pin_fbffc_bottom = IO_Get(PIN_FBFFC_BOTTOM);
	int pin_tconless_sel = IO_Get(PIN_TCONLESS_SEL);
#else
	int pin_panel_less = 0;
	int pin_fbffc_top = 0;
	int pin_fbffc_bottom = 0;
	int pin_tconless_sel = 0;		
#endif
	if(IsID_Match())
	{
		if (pin_fbffc_top==1 && pin_fbffc_bottom==0)
		{
			// Cross FFC
			printf("[trace code] Cross FFC !!!\n");
			return true;
		}
		else if(pin_panel_less == 0)
		{
			// tcon/tcon_less
			if(pin_fbffc_top==0 && pin_fbffc_bottom==1)
			{
				// tcon_less
				printf("[trace code] Panel & Tcon-less !!!\n");
				return true;
			}
			else
			{
				// tcon
				printf("[trace code] Panel & Tcon !!!\n");
				return false;
			}		
		}
		else
		{
			// panel_less, tcon/tcon_less
			if(pin_tconless_sel==0)
			{
				// tcon_less
				printf("[trace code] Panel-less & Tcon-less !!!\n");
				return false;
			}
			else
			{
				// tcon
				printf("[trace code] Panel-less & Tcon !!!\n");
				return false;
			}
		}
	}
	else
		return true;
#else
	if(IsID_Match())
		return false;
	else
		return true;
#endif

#else
	return false;
#endif
}

void CusApi_panel_i2c_init(void)
{

}

void CusApi_panel_customized_setting(void)
{
#if 1
	UINT8 strength =0;
	UINT8 ssEn=0;
	UINT8 ssPercent=0;
	UINT32 ssFreq=0;
	UINT8 Pre_em_en=0;
	UINT8 Pre_em_level=0;
#if defined(Config_Vulcan3_PCB_TRUE)
	UINT8 LVDS_clock_level_even=0;
	UINT8 LVDS_clock_level_odd=0;
#else
	UINT8 LVDS_clock_level=0;
#endif
#ifdef CONFIG_CUSTOM_SET_SERIAL_NUMBER
	char productStr[32]={0};
	char defaultvalue[9] = {'P','0','0','0','0','0','0','0','0'};
#endif
	sfg_sfg_ctrl_24_RBUS	sfg_ctrl_24_reg;
	sfg_sfg_ctrl_25_RBUS	sfg_ctrl_25_reg;
	sfg_sfg_ctrl_26_RBUS	sfg_ctrl_26_reg;

	UINT32 dh_den_sta = default_panel_parameter.iCONFIG_DISP_DEN_STA_HPOS;
	UINT32 dh_den_end = dh_den_sta + (default_panel_parameter.iCONFIG_DISP_ACT_END_HPOS - default_panel_parameter.iCONFIG_DISP_ACT_STA_HPOS);

	printf("CusApi_panel_customized_setting\n");
	//Pre-empahsis
	Pre_em_en =default_panel_parameter.snInfo.Pre_emphasis_On_Off;
	//Pre_em_en=1;
	rtd_part_outl(0xb8000D04, 30, 30, Pre_em_en); // LANE0
	rtd_part_outl(0xb8000D14, 30, 30, Pre_em_en); // LANE1
	rtd_part_outl(0xb8000D24, 30, 30, Pre_em_en); // LANE2
	rtd_part_outl(0xb8000D34, 30, 30, Pre_em_en); // LANE3
	rtd_part_outl(0xb8000D44, 30, 30, Pre_em_en); // LANE4
	rtd_part_outl(0xb8000D54, 30, 30, Pre_em_en); // LANE5
	rtd_part_outl(0xb8000D64, 30, 30, Pre_em_en); // LANE6
	rtd_part_outl(0xb8000D74, 30, 30, Pre_em_en); // LANE7

	//printf("01 0xb8000D00 =%x \n",rtd_inl(0xb8000D00));
	//driver strength
	strength=default_panel_parameter.snInfo.Drive_strength;
	if(fsw_spi_bootup || fsw_emmc_bootup)
	{
		if(get_ddr_size() == 0x60000000)
		{
			if(fsw_2k_panel_id == 1)
				strength=7;	// WXGA
			else if(fsw_2k_panel_id == 2)
				strength=6;	// FHD
		}
	}

	//strength=4;
	printf("strength=%d\n",strength);
	//printf("[2k trace code] %s, %s, %d\n", __FILE__, __FUNCTION__, __LINE__);
	if(boot_panel_type == P_LVDS_2K1K){
#if defined(Config_Vulcan3_PCB_TRUE)
		LVDS_clock_level_even=default_panel_parameter.snInfo.LVDS_clock_level_even;
		LVDS_clock_level_odd=default_panel_parameter.snInfo.LVDS_clock_level_odd;
		printf("LVDS_clock_level_even=%d\n",LVDS_clock_level_even);
		printf("LVDS_clock_level_odd=%d\n",LVDS_clock_level_odd);
		if(EnableFHD){
			//rtd_part_outl(0xb8000D00, 5, 0, strength); // LANE0
			//rtd_part_outl(0xb8000D10, 5, 0, strength); // LANE1
			rtd_part_outl(0xb8000D20, 5, 0, strength); // LANE2
			rtd_part_outl(0xb8000D30, 5, 0, strength); // LANE3
			rtd_part_outl(0xb8000D40, 5, 0, strength); // LANE4
			rtd_part_outl(0xb8000D50, 5, 0, LVDS_clock_level_odd); // LANE5
			rtd_part_outl(0xb8000D60, 5, 0, strength); // LANE6
			rtd_part_outl(0xb8000D70, 5, 0, strength); // LANE7
			rtd_part_outl(0xb8000D80, 5, 0, strength); // LANE8
			rtd_part_outl(0xb8000D90, 5, 0, strength); // LANE9
			rtd_part_outl(0xb8000Da0, 5, 0, LVDS_clock_level_even); // LANEa
			rtd_part_outl(0xb8000Db0, 5, 0, strength); // LANEb
		}
		else{
			rtd_part_outl(0xb8000D20, 5, 0, strength); // LANE2
			rtd_part_outl(0xb8000D30, 5, 0, LVDS_clock_level_odd); // LANE3
			printf("LVDS_clock_level_odd=%d\n",LVDS_clock_level_odd);
			rtd_part_outl(0xb8000D40, 5, 0, strength); // LANE4
			rtd_part_outl(0xb8000D50, 5, 0, strength); // LANE5
			rtd_part_outl(0xb8000D60, 5, 0, strength); // LANE6
		}

		//0:JEIDA 1:VESA
		//default_panel_parameter.iCONFIG_DISPLAY_BITMAPPING_TABLE=0;
		rtd_part_outl(0xb802D008, 13, 12, default_panel_parameter.iCONFIG_DISPLAY_BITMAPPING_TABLE);
#else
		rtd_part_outl(0xb8000D20, 5, 0, strength); // LANE2

		LVDS_clock_level=default_panel_parameter.snInfo.LVDS_clock_level;
		rtd_part_outl(0xb8000D30, 5, 0, LVDS_clock_level); // LANE3
		printf("LVDS_clock_level=%d\n",LVDS_clock_level);
		rtd_part_outl(0xb8000D40, 5, 0, strength); // LANE4
		rtd_part_outl(0xb8000D50, 5, 0, strength); // LANE5
		rtd_part_outl(0xb8000D60, 5, 0, strength); // LANE6
#endif
	}
	else{
		rtd_part_outl(0xb8000D00, 5, 0, strength); // LANE0
		rtd_part_outl(0xb8000D10, 5, 0, strength); // LANE1
		rtd_part_outl(0xb8000D20, 5, 0, strength); // LANE2
		rtd_part_outl(0xb8000D30, 5, 0, strength); // LANE3
		rtd_part_outl(0xb8000D40, 5, 0, strength); // LANE4
		rtd_part_outl(0xb8000D50, 5, 0, strength); // LANE5
		rtd_part_outl(0xb8000D60, 5, 0, strength); // LANE6
		rtd_part_outl(0xb8000D70, 5, 0, strength); // LANE7
	}

	//printf("02 0xb8000D00 =%x \n",rtd_inl(0xb8000D00));
	//level
	Pre_em_level =default_panel_parameter.snInfo.Pre_emphasis_level;

	//level shift 1~8
	Pre_em_level=Pre_em_level+1;
	//Pre_em_level=3;
	if(Pre_em_level>=0x1F)
		Pre_em_level = 0x1F;

	printf("Pre_em_en=%d, Pre_em_level=%d\n",Pre_em_en,Pre_em_level);
	rtd_part_outl(0xb8000D04, 5, 0, Pre_em_level); // LANE0
	rtd_part_outl(0xb8000D14, 5, 0, Pre_em_level); // LANE1
	rtd_part_outl(0xb8000D24, 5, 0, Pre_em_level); // LANE2
	rtd_part_outl(0xb8000D34, 5, 0, Pre_em_level); // LANE3
	rtd_part_outl(0xb8000D44, 5, 0, Pre_em_level); // LANE4
	rtd_part_outl(0xb8000D54, 5, 0, Pre_em_level); // LANE5
	rtd_part_outl(0xb8000D64, 5, 0, Pre_em_level); // LANE6
	rtd_part_outl(0xb8000D74, 5, 0, Pre_em_level); // LANE7

	//printf("03 0xb8000D00 =%x \n",rtd_inl(0xb8000D00));
	//spread spectrum
	ssEn = default_panel_parameter.snInfo.Spread_spectrum_On_Off;
	ssPercent=default_panel_parameter.snInfo.SpreadPermillage*2;
	ssFreq = default_panel_parameter.snInfo.SpreadFreq;
	//test
	//ssEn=1;
	//ssPercent=10;
	//ssFreq=60000;
	printf("ssEn=%d, ssPercent=%d, ssFreq=%d\n",ssEn,ssPercent,ssFreq);
	panel_set_spread_spectrum(ssEn,ssPercent,ssFreq);

	ppoverlay_dv_length_RBUS dv_length_reg;
	ppoverlay_dh_width_RBUS dh_width_reg;
	//ppoverlay_memcdtg_control_RBUS memcdtg_control_reg;
	ppoverlay_memcdtg_dv_total_RBUS memcdtg_dv_total_reg;
	ppoverlay_memcdtg_dh_total_RBUS memcdtg_dh_total_reg;
	ppoverlay_memcdtg_dv_den_start_end_RBUS memcdtg_dv_den_start_end_reg;
	ppoverlay_memcdtg_dh_den_start_end_RBUS memcdtg_dh_den_start_end_reg;

	//ppoverlay_memc_mux_ctrl_RBUS memc_mux_ctrl_reg;

	ppoverlay_main_active_h_start_end_RBUS main_active_h_start_end_reg;
	//ppoverlay_main_background_v_start_end_RBUS main_background_v_start_end_reg;
	ppoverlay_main_active_v_start_end_RBUS main_active_v_start_end_reg;

	dv_length_reg.regValue = rtd_inl(PPOVERLAY_DV_Length_reg);
	dh_width_reg.regValue = rtd_inl(PPOVERLAY_DH_Width_reg);
	
	memcdtg_dv_total_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DV_TOTAL_reg);
	memcdtg_dh_total_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DH_TOTAL_reg);
	memcdtg_dv_den_start_end_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DV_DEN_Start_End_reg);
	memcdtg_dh_den_start_end_reg.regValue = rtd_inl(PPOVERLAY_memcdtg_DH_DEN_Start_End_reg);

	main_active_h_start_end_reg.regValue =rtd_inl(PPOVERLAY_MAIN_Active_H_Start_End_reg);
	main_active_v_start_end_reg.regValue =rtd_inl(PPOVERLAY_MAIN_Active_V_Start_End_reg);

	printf("Htotal(%x = %x) %d\n", PPOVERLAY_memcdtg_DH_TOTAL_reg, memcdtg_dh_total_reg.regValue,memcdtg_dh_total_reg.regValue & 0x00001FFF);
	printf("Hactive(%x = %x) %d\n",PPOVERLAY_MAIN_Active_H_Start_End_reg,main_active_h_start_end_reg.regValue,main_active_h_start_end_reg.regValue & 0x00000FFF);
	printf("H_DEN start(%x = %x) %d\n", PPOVERLAY_memcdtg_DH_DEN_Start_End_reg, memcdtg_dh_den_start_end_reg.regValue,memcdtg_dh_den_start_end_reg.regValue>>16);
	printf("HPulse(%x = %x) %d\n", PPOVERLAY_DH_Width_reg, dh_width_reg.regValue,dh_width_reg.regValue);
	
	printf("Vtotal(%x = %x) %d\n", PPOVERLAY_memcdtg_DV_TOTAL_reg, memcdtg_dv_total_reg.regValue,memcdtg_dv_total_reg.regValue&0x00001FFF);
	printf("Vactive(%x = %x) %d\n",PPOVERLAY_MAIN_Active_V_Start_End_reg,main_active_v_start_end_reg.regValue,main_active_v_start_end_reg.regValue&0x00000FFF);
	printf("V_DEN start(%x = %x) %d\n", PPOVERLAY_memcdtg_DV_DEN_Start_End_reg, memcdtg_dv_den_start_end_reg.regValue,memcdtg_dv_den_start_end_reg.regValue>>16);
	printf("VPulse(%x = %x) %d\n", PPOVERLAY_DV_Length_reg, dv_length_reg.regValue,dv_length_reg.regValue);

	if(( strcmp(default_panel_parameter.snInfo.PanelIDString, "I_PNLLESS_2K") == 0 )||
		( strcmp(default_panel_parameter.snInfo.PanelIDString, "Y_PNLLESS_4K") == 0 ))
	{
		sfg_ctrl_24_reg.regValue = rtd_inl(SFG_SFG_CTRL_24_reg);
		sfg_ctrl_24_reg.dv_den_sta = default_panel_parameter.iCONFIG_DISP_DEN_STA_VPOS;
		sfg_ctrl_24_reg.dv_den_end = default_panel_parameter.iCONFIG_DISP_DEN_END_VPOS;
		rtd_outl(SFG_SFG_CTRL_24_reg, sfg_ctrl_24_reg.regValue);

		sfg_ctrl_25_reg.regValue = rtd_inl(SFG_SFG_CTRL_25_reg);
		sfg_ctrl_25_reg.dh_den_sta = dh_den_sta;
		sfg_ctrl_25_reg.dh_den_end =dh_den_end;
		rtd_outl(SFG_SFG_CTRL_25_reg, sfg_ctrl_25_reg.regValue);

		sfg_ctrl_26_reg.regValue = rtd_inl(SFG_SFG_CTRL_26_reg);
		sfg_ctrl_26_reg.dv_width = default_panel_parameter.iVSyncWidth_60Hz;
		sfg_ctrl_26_reg.dh_width = default_panel_parameter.iHSyncWidth_60Hz;
		sfg_ctrl_26_reg.dh_total = default_panel_parameter.iCONFIG_DISP_HORIZONTAL_TOTAL;
		rtd_outl(SFG_SFG_CTRL_26_reg, sfg_ctrl_26_reg.regValue);
	}
#ifndef CONFIG_RTKPCB
	//sn power seq spec
	if (boot_power_on_mode == POWER_OFF){
		//IO_Set(PIN_DEMOD_RST_STBY, 0);
	}else{
		if(fsw_spi_bootup || fsw_emmc_bootup){
			printf("USB power high in CusApi_panel_customized_setting\n");
			IO_Set(PIN_USB_EN_P1, 1);
			IO_Set(PIN_USB_EN_P0, 1);
		}
	}

	//IO_Set(PIN_WIFI_HOST_RESET, 1);	
	//mdelay(10);
	IO_Set(PIN_WIFI_HOST_RESET, 0);
	mdelay(100);//CN request delay
       if(boot_power_on_mode != POWER_OFF)
	    IO_Set(PIN_WIFI_HOST_RESET, 1);
#endif
#ifdef CONFIG_CUSTOM_SET_SERIAL_NUMBER
	//Get data from Model env and serialNumber xml file to set serial number
#if defined(CONFIG_FSW)
	if(fsw_emmc_bootup || fsw_spi_bootup)
		return;
#endif
    if(!CusApi_env_readXmlFile(MODEL_ENV_FILE_NAME,PRODUCT_CODE,productStr,sizeof(productStr)))
		env_SetSerialNo(productStr);
	else
		env_SetSerialNo(defaultvalue);
#endif		
#endif	
	
}
