#include <common.h>
#include <asm/arch/bootparam.h>
#include <asm/arch/fw_info.h>
#include <asm/arch/system.h>
#include <asm/arch/io.h>
#include <asm/arch/panel_config_parameter.h>
#include <panel.h>
#include <platform_lib/board/pcb_mgr.h>
#ifndef IS_FPGA
#include <platform_lib/board/pcb.h>
#endif
#include <watchdog_api.h>
#include <rbus/tcon_reg.h>
#include <rbus/epi_reg.h>

#include "cus_common.h"

void CusApi_do_reset(void)
{
	unsigned long long param;
	
	if(default_panel_parameter.iCONFIG_PANEL_TYPE == P_MINI_LVDS || default_panel_parameter.iCONFIG_PANEL_TYPE == P_EPI_TYPE)
	{
		if (pcb_mgr_get_enum_info_byname("PIN_BL_ON_OFF", &param) == 0)
			IO_Set(param, 0);
		
		udelay (50000);		
		vbe_disp_lane_power_off();
#if defined(TCON_TCON_IP_EN_reg)
		rtd_outl(TCON_TCON_IP_EN_reg, 0x0);	
#endif
#if defined(EPI_EPI_TCON_IP_EN_reg)
		rtd_outl(EPI_EPI_TCON_IP_EN_reg, 0x0);
#endif
		mdelay(10);
		
		if (pcb_mgr_get_enum_info_byname("PIN_LVDS_ON_OFF", &param) == 0)
		{
			IO_Set(param, 0);
		}

		puts ("wait...(0/2)\n");
		mdelay (1000);
		puts ("wait...(1/2)\n");
		mdelay (1000);		
	}
}
