/*
 * Realtek common configuration settings
 *
 * Won't include this file.
 * Just type "make <board_name>_config" and will be included in source tree.
 */

#ifndef __CONFIG_RTK_COMMON_H
#define __CONFIG_RTK_COMMON_H

/* PRJ*.inc config */
#include "../../src/include/project_config.h"


#ifdef Config_Boot_ATF_TRUE

#ifdef CONFIG_SYS_SUPPORT_MULTICORE
#undef CONFIG_SYS_SUPPORT_MULTICORE
#endif

#ifdef CONFIG_USE_IRQ
#undef CONFIG_USE_IRQ                          /* support for IRQs */
#endif

#ifndef CONFIG_BOOT_ATF
#define CONFIG_BOOT_ATF
#endif
#endif

/*
 * Realtek feature support
 */
#define CONFIG_BSP_REALTEK	1
//#define CONFIG_BRING_UP
/*
 * Realtek logbuffer default value setup
 */
#define CONFIG_LOGBUFFER_DEFAULT_VALUE 1

/*
 * Realtek IC type
 */
//#define CONFIG_RTDXXXX /* Remove this config in the future */

/*
 * Package type definition from $(PRJ).inc
 */
#if defined (Config_Package_type_BGA)
  #define CONFIG_RTK_BGA
#elif defined (Config_Package_type_BGA_27x27)
  #define CONFIG_RTK_BGA_27x27
#endif

#if defined(Config_SILENT_ON_FALSE)
 #define CONFIG_FORCE_IN_DEBUG
 #define CONFIG_NO_TIMER_LOG
#endif
/*
 * Uart Port Setting from $(PRJ).inc
 */
#if defined (Config_Use_Uart_Port_0)
  #define UART_PORT 0
#elif defined (Config_Use_Uart_Port_1)
  #define UART_PORT 1
#else
  #define UART_PORT 0
#endif

/*
 * RTICE related control flag (normally disable)
 */
//#define CONFIG_RUN_FLASH_WRITER
//#define CONFIG_STAY_IN_CONSOLE
//#define CONFIG_CMD_EFUSE_BURNING

/*
 * Bringup IC related
 */
#define IS_PINMUX_READY

#ifndef IS_FPGA
#define CONFIG_CMD_KEY_BURNING
#ifndef CONFIG_RUN_FLASH_WRITER
#define CONFIG_OTP_UTIL
#define CONFIG_CMD_RTK_GPIO
#endif

//#define CONFIG_CMD_RTK_OTP
#define CONFIG_CMD_IRDA
#define CONFIG_AUTO_PROGRAM_OTP
#endif

#define CONFIG_CMD_TUNER

//#define CONFIG_CMD_RTK_MD
/*
 * Boot flash type setting from $(PRJ).inc
 */
#ifndef CONFIG_RUN_FLASH_WRITER
#if defined(Config_Boot_Flash_Type_is_SPI)
  #define CONFIG_SYS_RTK_SPI_FLASH
#elif defined(Config_Boot_Flash_Type_is_NAND)
  #define CONFIG_SYS_RTK_NAND_FLASH
#elif defined(Config_Boot_Flash_Type_is_EMMC)
  #define CONFIG_SYS_RTK_EMMC_FLASH
#elif defined(Config_Boot_Flash_Type_is_SPI_NAND)
  #define CONFIG_SYS_RTK_SPI_NAND
#elif defined(Config_Boot_Flash_Type_is_NONE)
  #define CONFIG_SYS_RTK_FLASH_NONE
#endif
#else
  #define CONFIG_SYS_RTK_FLASH_NONE
#endif

#if defined(Config_OTP_Secure_Boot_TRUE)
#define CONFIG_SYS_MCP_UTILITY
//#define CONFIG_REALTEK_CP_DDTS
#endif
#define CONFIG_RTK_MCP
#define CONFIG_RTK_SWSHA256
//#define CONFIG_SYS_SUPPORT_SWAES
#define CONFIG_RTK_HWRSA

#if defined(Config_Amp_For_Alc_Board_TRUE)
#define CONFIG_AMP_FOR_ALC_BOARD
#endif

/*
 * High Level Configuration Options
 */
#define CONFIG_ARMV7		1	/* This is an ARM V7 CPU core */
//#define CONFIG_ARM_CA7_MPCORE	1	/* This is an ARM Cortex-A7 MPCore */
//#define CONFIG_ARM_CA17_MPCORE	1	/* This is an ARM Cortex-A17 MPCore */
#define CONFIG_ARCH_CPU_ARMA53	1	/* This is an ARM A53 */
//#define CONFIG_ARCH_CPU_ARMA57	1	/* This is an ARM A57 */

//#define CONFIG_USE_CCI_BUS

/* Display CPU and Board Info */
#define CONFIG_DISPLAY_CPUINFO		1
#define CONFIG_DISPLAY_BOARDINFO	1
//#define CONFIG_SYS_SUPPORT_MULTICORE /* defined in specific config */
#ifdef CONFIG_SYS_SUPPORT_MULTICORE
//#define CONFIG_SYS_SUPPORT_MULTITHREAD
#ifndef CONFIG_QC_MULTI_CORE_TEST
#define CONFIG_PANEL_INIT_MULTICORE
#endif
#endif
#define CONFIG_SKIP_LOWLEVEL_INIT	1
#ifndef Config_OF_LIBFDT_TRUE
#define CONFIG_CMDLINE_TAG		1	/* enable passing of ATAGs */
#define CONFIG_SETUP_MEMORY_TAGS	1
//#define CONFIG_INITRD_TAG		1
#define CONFIG_REVISION_TAG		1
#endif
#if defined(CONFIG_SYS_RTK_EMMC_FLASH)
#if defined(Config_AVB_Version_P)
 #define  CONFIG_VERIFY_BOOT_P          1
#else
  #define CONFIG_VERIFY_BOOT_Q          1
#endif
 #define CONFIG_VERIFY_BOOT               1
 #define CONFIG_CANONICAL_BOOT        1
 #endif

/*
 * Size of malloc() pool
 * Total Size Environment - 128k
 * Malloc - add 256k
 */
#if defined(Config_Boot_Flash_Type_is_SPI)
#define CONFIG_ENV_SIZE			(8 << 10)
#else
#define CONFIG_ENV_SIZE			(128 << 10)
#endif
#define CONFIG_SYS_MALLOC_LEN		(7 << 20)
#define CONFIG_SYS_NON_CACHE_LEN	(1 << 20)

/*
 * Hardware drivers
 */
#ifndef IS_FPGA
//#define CONFIG_USE_RTK_RTC			1
#endif
//#define CONFIG_REALTEK_WATCHDOG
//#define CONFIG_REALTEK_FREE_CNT
/*
 * serial port - NS16550 compatible
 */
#define UART0_BASE				0x18062300
#define UART1_BASE				0x1801b100

#ifdef IS_RDC_FPGA
#undef UART0_BASE
#undef UART1_BASE

#define UART0_BASE				0x2FB03000
#define UART1_BASE				0x2FB03000
#endif

#if (UART_PORT == 0)
 #define V_NS16550_CLK_27M		27000000
 #define V_NS16550_CLK_108M		108000000
 #define V_NS16550_CLK			V_NS16550_CLK_27M
 #define CONFIG_SYS_NS16550_COM1	UART0_BASE
#elif (UART_PORT == 1)
 #define V_NS16550_CLK_27M		27000000
 #define V_NS16550_CLK_108M		108000000
 #define V_NS16550_CLK			V_NS16550_CLK_27M
 #define CONFIG_SYS_NS16550_COM1	UART1_BASE
#else
 #error "UART_PORT defined error."
#endif

#define CONFIG_SYS_NS16550
#define CONFIG_SYS_NS16550_SERIAL
#define CONFIG_SYS_NS16550_REG_SIZE		(-4)
#define CONFIG_SYS_NS16550_CLK			V_NS16550_CLK

#define CONFIG_BAUDRATE					115200
#define CONFIG_SYS_BAUDRATE_TABLE		{4800, 9600, 19200, 38400, 57600, 115200}

#define CONFIG_SYS_CONSOLE_IS_IN_ENV	1
#define CONFIG_CONS_INDEX				1

#if defined(Config_Platform_Model_4K)
#define CURRENT_PLATFORM_MODEL	4
#elif defined(Config_Platform_Model_2K)
#define CURRENT_PLATFORM_MODEL	2
#elif defined(Config_Platform_Model_8K)
#define CURRENT_PLATFORM_MODEL	8
#else
#define CURRENT_PLATFORM_MODEL	4 /* default as 4K */
#endif

#ifdef IS_FPGA
  #undef V_NS16550_CLK
//  #define V_NS16550_CLK			32000000	//FPGA
  #define V_NS16550_CLK			40000000	//FPGA

  #undef CONFIG_SYS_NS16550_COM1
  #define CONFIG_SYS_NS16550_COM1	UART1_BASE	//FPGA
#endif

#ifdef IS_RDC_FPGA
  #undef V_NS16550_CLK
  #undef CONFIG_BAUDRATE

  #define V_NS16550_CLK		25000000	  //FPGA
  #define CONFIG_BAUDRATE	57600
#endif

/*
 * Environment setup
 */

#define CONFIG_BOOTDELAY	0

#define CONFIG_ENV_OVERWRITE

#if (UART_PORT == 0)
  #define CONFIG_BOOTARGS \
	"androidboot.console=ttyS0 console=ttyS0,115200 androidboot.dtbo_idx=0"

  #define CONFIG_EXTRA_ENV_SETTINGS \
	"loadaddr=0x03000000\0" \
	"console=ttyS0,115200\0"
#elif (UART_PORT == 1)
  #define CONFIG_BOOTARGS \
	"androidboot.console=ttyS1 console=ttyS1,115200 androidboot.dtbo_idx=0"

  #define CONFIG_EXTRA_ENV_SETTINGS \
	"loadaddr=0x03000000\0" \
	"console=ttyS1,115200\0"
#else
  #error "UART_PORT defined error."
#endif

#ifndef IS_FPGA
#define CONFIG_BOOTCOMMAND "bootr"
#endif

/* Flash */
#define CONFIG_SYS_NO_FLASH	1

/* commands to include */
#include <config_cmd_default.h>


/*
 * Miscellaneous configurable options
 */

/* CPU count setting, max count 4 (0 for auto detect) */
#define CONFIG_SYS_NR_CPUS	1

#define CONFIG_SYS_LONGHELP	/* undef to save memory */
#define CONFIG_SYS_HUSH_PARSER	/* use "hush" command parser */
#define CONFIG_SYS_CBSIZE		4096
/* Print Buffer Size */
#define CONFIG_SYS_PBSIZE		(CONFIG_SYS_CBSIZE + sizeof(CONFIG_SYS_PROMPT) + 16)
#define CONFIG_SYS_MAXARGS		16
/* Boot Argument Buffer Size */
#define CONFIG_SYS_BARGSIZE		(CONFIG_SYS_CBSIZE)

/* for rtk plateform verify */
//#define CONFIG_RT_PVERIFY

/* Multi-Core function (for QC code test currently) */
//#define CONFIG_SYS_SUPPORT_MULTICORE

#ifdef CONFIG_SYS_SUPPORT_MULTICORE
/*
   TLB page_table = BASE + get_id() * 0x4000
   core0: original TLB
   core1: 0x0300_4000
   core2: 0x0300_8000
   core3: 0x0300_c000
*/
#define CONFIG_MULTICORE_TLB_BASE   0x03000000

/*
   Stack pointer base for each core
*/
#define CONFIG_SYS_INIT_CORE1_SP_ADDR  0x230C0000
#define CONFIG_SYS_INIT_CORE2_SP_ADDR  0x230D0000
#define CONFIG_SYS_INIT_CORE3_SP_ADDR  0x230E0000
#define CONFIG_SYS_INIT_CORE4_SP_ADDR  0x230F0000

/*
   Some commands about multi-core
*/

#define CONFIG_CMD_SCUTEST
#define CONFIG_CMD_COPROC
#endif

/*
 * memtest setup
 */
#define CONFIG_SYS_MEMTEST_START	0x00000000
#define CONFIG_SYS_MEMTEST_END		(CONFIG_SYS_MEMTEST_START + (32 << 20))

/* Default load address */
#define CONFIG_SYS_LOAD_ADDR		0x03000000

/* Use General purpose timer 2 */
#define CONFIG_SYS_TIMER		2
#define CONFIG_SYS_HZ			1000

/*
 * Stack sizes
 *
 * The stack sizes are set up in start.S using the settings below
 */
//stack size is setup in linker script 1MB
#ifdef CONFIG_USE_IRQ
  #define CONFIG_STACKSIZE_IRQ	(4 << 10)	/* IRQ stack */
  #define CONFIG_STACKSIZE_FIQ	(4 << 10)	/* FIQ stack */
#endif

/*
 * SDRAM Memory Map
 * Even though we use two CS all the memory
 * is mapped to one contiguous block
 */

/*
 * DRAM bank/size setting from $(PRJ).inc (It's not the real Hardware DC1/DC2 dram info)
 */
#ifdef Config_dram_size_from_OTP
#define CONFIG_RAM_SIZE_FROM_OTP_SETTING
#endif

#ifdef Config_dram_bank2_size_0_0GB // bank2 size is 0, only use 1 bank
#define CONFIG_NR_DRAM_BANKS		1
#else
#define CONFIG_NR_DRAM_BANKS		2
#endif

#if defined(Config_dram_bank1_base_0_0GB)
#define CONFIG_SYS_SDRAM_BASE	0x00000000
#elif defined(Config_dram_bank1_base_0_5GB)
#define CONFIG_SYS_SDRAM_BASE	0x20000000
#elif defined(Config_dram_bank1_base_1_0GB)
#define CONFIG_SYS_SDRAM_BASE	0x40000000
#elif defined(Config_dram_bank1_base_1_5GB)
#define CONFIG_SYS_SDRAM_BASE	0x60000000
#elif defined(Config_dram_bank1_base_2_0GB)
#define CONFIG_SYS_SDRAM_BASE	0x80000000
#elif defined(Config_dram_bank1_base_uboot_def) // uboot defined value
#define CONFIG_SYS_SDRAM_BASE	0x00000000
#else
#error "Need to define DRAM bank1 base address"
#endif

#if defined(Config_dram_bank1_size_0_0GB) // impossible setting
#error "DRAM bank1 size cannot set as zero"
#elif defined(Config_dram_bank1_size_0_5GB)
#define CONFIG_SYS_RAM_DCU1_SIZE	0x20000000
#elif defined(Config_dram_bank1_size_1_0GB)
#define CONFIG_SYS_RAM_DCU1_SIZE	0x40000000
#elif defined(Config_dram_bank1_size_1_5GB)
#define CONFIG_SYS_RAM_DCU1_SIZE	0x60000000
#elif defined(Config_dram_bank1_size_2_0GB)
#define CONFIG_SYS_RAM_DCU1_SIZE	0x80000000
#elif defined(Config_dram_bank1_size_uboot_def) // uboot defined value
#define CONFIG_SYS_RAM_DCU1_SIZE	0x20000000
#else
#error "Need to define DRAM bank1 size"
#endif

#if defined(Config_dram_bank2_base_0_0GB)
#define CONFIG_SYS_SDRAM_DCU2_BASE	0x00000000
#elif defined(Config_dram_bank2_base_0_5GB)
#define CONFIG_SYS_SDRAM_DCU2_BASE	0x20000000
#elif defined(Config_dram_bank2_base_1_0GB)
#define CONFIG_SYS_SDRAM_DCU2_BASE	0x40000000
#elif defined(Config_dram_bank2_base_1_5GB)
#define CONFIG_SYS_SDRAM_DCU2_BASE	0x60000000
#elif defined(Config_dram_bank2_base_2_0GB)
#define CONFIG_SYS_SDRAM_DCU2_BASE	0x80000000
#elif defined(Config_dram_bank2_base_uboot_def) // uboot defined value
#define CONFIG_SYS_SDRAM_DCU2_BASE	0x00000000
#else
#error "Need to define DRAM bank2 base address"
#endif

#if defined(Config_dram_bank2_size_0_0GB)
#define CONFIG_SYS_RAM_DCU2_SIZE	0x00000000
#elif defined(Config_dram_bank2_size_0_5GB)
#define CONFIG_SYS_RAM_DCU2_SIZE	0x20000000
#elif defined(Config_dram_bank2_size_1_0GB)
#define CONFIG_SYS_RAM_DCU2_SIZE	0x40000000
#elif defined(Config_dram_bank2_size_1_5GB)
#define CONFIG_SYS_RAM_DCU2_SIZE	0x60000000
#elif defined(Config_dram_bank2_size_2_0GB)
#define CONFIG_SYS_RAM_DCU2_SIZE	0x80000000
#elif defined(Config_dram_bank2_size_uboot_def) // uboot defined value
#define CONFIG_SYS_RAM_DCU2_SIZE	0x20000000
#else
#error "Need to define DRAM bank2 size"
#endif

/////// SDRAM Memory Map End ///////

#define CONFIG_NO_RELOCATION
//if the relocation is enabled, the address is used to be the stack at very beginning.
#define CONFIG_SYS_INIT_SP_ADDR     0x00100000
#define CONFIG_SYS_IRQ_STACK_START_IN_ADDR	0x0001ff00	// use 8 bytes to store caller pc and spsr (exception mode)

#define CONFIG_SYS_L2CACHE_OFF
#if 0 // 1:cache disable   0:enable
	#define CONFIG_SYS_ICACHE_OFF
   #define CONFIG_SYS_DCACHE_OFF
#else
   #define CONFIG_NONCACHE_ALLOCATION
   #define CONFIG_CMD_CACHE
#endif

#define CONFIG_SYS_CACHELINE_SIZE 64

/*
 * rm include/autoconf.mk ---- prevent use old CONFIG_SYS_TEXT_BASE
 * make CONFIG_SYS_TEXT_BASE
 */
#ifndef CONFIG_SYS_TEXT_BASE
  #define CONFIG_SYS_TEXT_BASE		0x00020000
#endif

#ifdef IS_FPGA_RUN_ON_DISRAM
#undef CONFIG_SYS_TEXT_BASE
#define CONFIG_SYS_TEXT_BASE		0x000f0000	// from 0x000f_0000 to 0x0012_0000
#endif

#define CONFIG_BOOT_PARAM_BASE			(0x00100000 + 0x100)
#define CONFIG_HEAP_RELOCATION

/* ENV related config options */
#ifdef CONFIG_RUN_FLASH_WRITER
#define CONFIG_ENV_IS_NOWHERE
#endif

#define CONFIG_SYS_PROMPT       "Realtek> "

/* Library support */
#ifndef IS_FPGA
#define CONFIG_LZMA
#define CONFIG_LZO
#define CONFIG_AVBLIB
#endif

#ifdef IS_FPGA
#undef CONFIG_CMD_NET
#endif

#ifdef CONFIG_CMD_NET
  /* Eth Net */
  #define CONFIG_CMD_PING
  #define CONFIG_CMD_TFTPPUT
//  #define CONFIG_RTL8139CPLUS
  #define CONFIG_RTL8168
//  #define CONFIG_TFTP_BLOCKSIZE		400

  /* Network setting */

  #define CONFIG_ETHADDR				00:10:20:30:40:50
  #define CONFIG_IPADDR				192.168.0.200
  #define CONFIG_GATEWAYIP			192.168.0.1
  #define CONFIG_SERVERIP				192.168.0.3
  #define CONFIG_NETMASK				255.255.255.0
#endif

/* Dss info*/
#ifndef IS_FPGA
//#define CONFIG_CMD_DSSINFO
#endif

/* NAND */
//#define CONFIG_MTD_NAND_RTK

/* BISR */
#ifndef IS_FPGA
#ifdef CONFIG_ARCH_CPU_ARMA57
//#define ENABLE_SCPU1_BISR //Mag2 only
#endif

#ifdef CONFIG_ARCH_CPU_ARMA53
//#define ENABLE_SCPU2_BISR
#endif
#define ENABLE_VCPU_BISR
#define ENABLE_VE_BISR
//#define ENABLE_ACPU_BISR
//#define ENABLE_MCU_BISR
//#define ENABLE_GPU_BISR

#define ENABLE_DISPI_BISR
//#define ENABLE_DISPD_BISR
//#define ENABLE_KME_BISR

#define ENABLE_KMC_BISR
//#define ENABLE_DEMOD_BISR // move to kdriver
#define ENABLE_WOV_BISR
#define ENABLE_BISR_CHECK

// #define ENABLE_DISP2TVE_BISR	 //Mag2 only
//#define ENABLE_DISP_AFBC_BISR
#endif

/* USB Setting */
#ifndef IS_FPGA
/*
 * get_vfatname_block     => assign to 0x0130_0000
 * get_dentfromdir_block  => assign to 0x0131_0000
 * do_fat_read_block      => assign to 0x0132_0000
 */
//#define CONFIG_FAT_USE_EXTMEM_FOR_LARGE_ARRAY

#define CONFIG_PARTITIONS
#define CONFIG_DOS_PARTITION
#define CONFIG_CMD_USB
#define CONFIG_USB_STORAGE

/* controller selection */
#define CONFIG_USB_XHCI
#define CONFIG_USB_EHCI
//#define CONFIG_USB_OHCI_NEW


/* xhci */
#ifdef CONFIG_USB_XHCI
#define CONFIG_USB_RTK_XHCI
#define CONFIG_USB_XHCI_CONTROLLER_COUNT    1
#define CONFIG_SYS_USB_XHCI_MAX_ROOT_PORTS  3
#else
#define CONFIG_USB_XHCI_CONTROLLER_COUNT    0
#endif

/* ehci */
#ifdef CONFIG_USB_EHCI
#define CONFIG_USB_EHCI_CONTROLLER_COUNT    1
#define CONFIG_USB_RTK_EHCI
#define CONFIG_SYS_USB_EHCI_MAX_ROOT_PORTS  2
//#define CONFIG_USB_RTKBT
#else
#define CONFIG_USB_EHCI_CONTROLLER_COUNT    0
#endif

/* ohci */
#ifdef CONFIG_USB_OHCI_NEW
#define CONFIG_USB_OHCI_CONTROLLER_COUNT    1
#define CONFIG_USB_RTK_OHCI
#define CONFIG_SYS_USB_OHCI_CPU_INIT
#ifdef CONFIG_SYS_USB_EHCI_MAX_ROOT_PORTS
#define CONFIG_SYS_USB_OHCI_MAX_ROOT_PORTS  (CONFIG_SYS_USB_EHCI_MAX_ROOT_PORTS)
#else
#define CONFIG_SYS_USB_OHCI_MAX_ROOT_PORTS  (2)
#endif
#define CONFIG_SYS_USB_OHCI_SLOT_NAME       "RTK-OHCI"
#define CONFIG_SYS_USB_OHCI_REGS_BASE       0x18012400
#else
#define CONFIG_USB_OHCI_CONTROLLER_COUNT    0
#endif

#define CONFIG_USB_MAX_CONTROLLER_COUNT     \
    ( CONFIG_USB_XHCI_CONTROLLER_COUNT +    \
      CONFIG_USB_EHCI_CONTROLLER_COUNT +    \
      CONFIG_USB_OHCI_CONTROLLER_COUNT )

#if defined(CONFIG_USB_RTK_OHCI) || defined(CONFIG_USB_RTK_EHCI)
#define CONFIG_RTK_USB20
#endif

//#define CONFIG_USB_OTG
#ifdef Config_Module_Test_Boot_TRUE
#ifdef CONFIG_USB_STORAGE
#define CONFIG_USB_STORAGE_RW_TEST  /* uncomment it for USB storage RW test */
#endif /* CONFIG_USB_STORAGE */

// #define CONFIG_USB_8723_ENUM_TEST   /* uncomment it for rtd8723 WIFI+BT dongle enueration test */
#endif /* Config_Module_Test_Boot_TRUE */
#endif

/* PCB Manager */
#ifndef IS_FPGA
#ifndef CONFIG_RUN_FLASH_WRITER
#ifdef IS_PINMUX_READY
#define CONFIG_SYS_PCB_MANAGER
#endif
#endif
#endif

/* MCP utility */
#ifndef IS_FPGA
//#define CONFIG_SYS_MCP_UTILITY
//#define CONFIG_REALTEK_CP_DDTS
#endif

/* TP utility */
#ifndef IS_FPGA
//#define CONFIG_REALTEK_TP_DDTS
#endif

/* DEMODULE */
#ifndef IS_FPGA
  #define CONFIG_SYS_DEMODULE
#endif

/* HW SEMAPHORE */
#ifndef IS_FPGA
  #define CONFIG_SYS_HW_SEM
#endif

/* BOOT PARAMETER SUPPORT */
#ifndef IS_FPGA
  #define CONFIG_SYS_BOOT_PARM
#endif

/* load command */
#define CONFIG_CMD_LOAD

/* Factory */
#ifndef IS_FPGA
  #define CONFIG_SYS_FACTORY
  //#define CONFIG_SYS_FACTORY_PROTECT_ALL  /* Add rtk_checksum to confirm data */
  //#define PANEL_CONFIG_FROM_FACTORY_PANEL_BIN
  //#define PANEL_LIST_FROM_FACTORY
#endif

#ifndef IS_FPGA
/* Factory Read-only : depend on customer */
#define CONFIG_SYS_FACTORY_READ_ONLY
#endif

/* Decide Bootcode Enable Panel Parameter */
#ifndef IS_FPGA
#ifndef CONFIG_STAY_IN_CONSOLE
#ifndef CONFIG_RUN_FLASH_WRITER
#define CONFIG_SYS_PANEL_SUPPORT
#endif
#endif
#endif

/* Panel Parameter */
#ifdef CONFIG_SYS_PANEL_SUPPORT
  #define CONFIG_SYS_PANEL_PARAMETER
  #define CONFIG_SYS_PANEL_DISABLE_PATTERN_GEN
  #define CONFIG_CMD_PANEL
  #define CONFIG_SYS_PANEL_SUPPORT_INI_FILE
#else
  #undef CONFIG_SYS_PANEL_SUPPORT
  #undef CONFIG_SYS_PANEL_PARAMETER
  #undef CONFIG_CMD_PANEL
#endif

/* GDMA support */
#ifndef IS_FPGA
#ifndef CONFIG_RUN_FLASH_WRITER
#ifndef CONFIG_STAY_IN_CONSOLE
// remove by weihao because label name wrong in rbus, fixed me
#define CONFIG_SYS_GDMA_SUPPORT
//#define CONFIG_SYS_SE_SUPPORT
#ifdef CONFIG_SYS_GDMA_SUPPORT
  #define CONFIG_RTK_GDMA_SUPPORT
#else
  #undef CONFIG_SYS_GDMA_SUPPORT
  #undef CONFIG_RTK_GDMA_SUPPORT
#endif
#endif
#endif
#endif

#if defined(CONFIG_SYS_RTK_EMMC_FLASH)
  /* MMC */
  #define CONFIG_MMC
  #ifndef CONFIG_PARTITIONS
    #define CONFIG_PARTITIONS
  #endif
  #define CONFIG_DOS_PARTITION

  #if defined(Config_EXT4_FS_Support_Enable_TRUE)
    #define RTK_EXT4_PATCH
  	#define CONFIG_EFI_PARTITION

  	#define CONFIG_FS_EXT4
  	#define CONFIG_CMD_EXT4

	#if defined(Config_EXT4_Factory_Enable_TRUE)
		#define CONFIG_EXT4_WRITE
		#define CONFIG_CMD_EXT4_WRITE
	#endif
  #endif

  #define CONFIG_GENERIC_MMC
  #define CONFIG_RTK_MMC
  #ifndef Config_Boot_Type_is_RELEASE
  #define CONFIG_CMD_MMC
  #endif
  #define CONFIG_LG_CHG
  #ifdef CONFIG_LG_CHG
    #ifndef CONFIG_MMC_BOUNCE_BUFFER
      #define CONFIG_MMC_BOUNCE_BUFFER
    #endif
    #define CONFIG_SUPPORT_EMMC_RPMB
  #endif

  /* ENV */
  #undef CONFIG_ENV_IS_NOWHERE
  #ifdef CONFIG_SYS_FACTORY
    #define CONFIG_ENV_IS_IN_FACTORY
  #else
    #define CONFIG_ENV_IS_IN_MMC	/* if enable CONFIG_SYS_FACTORY, env will be saved in factory data */
  #endif
#endif // CONFIG_SYS_RTK_EMMC_FLASH

#if defined(Config_FW_Type_QC)
#define CONFIG_MTD_NAND_RTK
//#define CONFIG_MTD_RBT_TEST //for rbt table test
#define CONFIG_SYS_MAX_NAND_DEVICE 1
#define CONFIG_SYS_NAND_BASE 0xb8010000
#define CONFIG_MTD_DEVICE
#define CONFIG_MTD_PARTITIONS
#define CONFIG_CMD_NAND
#define CONFIG_CMD_MTDPARTS   /* mtd parts support		  */
#endif

#if defined(CONFIG_SYS_RTK_NAND_FLASH)
  /*
   *Nand support
   */
  #define CONFIG_MTD_NAND_RTK
  //#define CONFIG_MTD_RBT_TEST //for rbt table test
  #define CONFIG_SYS_MAX_NAND_DEVICE 1
  #define CONFIG_SYS_NAND_BASE 0xb8010000
  #define CONFIG_MTD_DEVICE
  #define CONFIG_MTD_PARTITIONS
  #define CONFIG_CMD_NAND
  #define CONFIG_CMD_MTDPARTS	/* mtd parts support		*/

  //default mtdids
  #define MTDIDS_DEFAULT "nand0=rtk_nand"
  //default mtd partition
  #define MTDPARTS_DEFAULT		"mtdparts=rtk_nand:473088k,4352k(/),20480k(/usr/local/etc),26368k"

  /* ENV */
  #undef CONFIG_ENV_IS_NOWHERE
  #ifdef CONFIG_SYS_FACTORY
    #define CONFIG_ENV_IS_IN_FACTORY
  #else
    #define CONFIG_ENV_IS_IN_NAND	  /* if enable CONFIG_SYS_FACTORY, env will be saved in factory data */
  #endif
#endif // CONFIG_SYS_RTK_NAND_FLASH

  #define CONFIG_RTK_SPI_NOR
#if defined(CONFIG_SYS_RTK_SPI_FLASH)
  /* SPI */

  //#define CONFIG_RESCUE_SOURCE_FROM_USB
  /* ENV */
  #undef CONFIG_ENV_IS_NOWHERE
  #ifdef CONFIG_SYS_FACTORY
    #define CONFIG_ENV_IS_IN_FACTORY
  #else
    #define CONFIG_ENV_IS_IN_SPI_FLASH	/* if enable CONFIG_SYS_FACTORY, env will be saved in factory data */
  #endif
  #define CONFIG_MD5
#endif // CONFIG_SYS_RTK_SPI_FLASH

#if defined(CONFIG_SYS_RTK_SPI_NAND)
	  #define CONFIG_MTD_SPI_NAND_RTK
  #undef CONFIG_ENV_IS_NOWHERE
  #ifdef CONFIG_SYS_FACTORY
	#define CONFIG_ENV_IS_IN_FACTORY
  #else
	#define CONFIG_ENV_IS_IN_SPI_NAND	  /* if enable CONFIG_SYS_FACTORY, env will be saved in factory data */
  #endif

  #define CONFIG_CMD_SPI_NAND
  //#define CONFIG_MTD_TABLE_TEST //for table test

#endif
#ifdef CONFIG_PARTITIONS
  #define CONFIG_CMD_FAT
#endif

/* RNG */
#define CONFIG_RNG
#ifdef IS_FPGA
#define CONFIG_CMD_RNG
#endif

/* TCON settting from factory */
//#define CONFIG_PANEL_APPLY_TCON_SETTING

/* Pin Mux */
#ifndef IS_FPGA
#ifndef CONFIG_RUN_FLASH_WRITER
#ifdef IS_PINMUX_READY
#define CONFIG_SYS_PIN_MUX
#define CONFIG_SYS_VIDDQ
#define CONFIG_CORE_IDDQ_THRESHOLD	68
#endif
#endif
#endif

/* MENU */
#ifndef IS_FPGA
#define CONFIG_REALTEK_MENU
#endif

/* GPIO */
#ifndef IS_FPGA
#define CONFIG_REALTEK_GPIO
#endif

/* GPIO ROKU*/
#ifdef CONFIG_REALTEK_GPIO
#define CONFIG_REALTEK_GPIO_ROKU
#endif

/* I2C */
#ifndef IS_FPGA
  #define CONFIG_I2C_MULTI_BUS
#define CONFIG_REALTEK_I2C
#endif

/* AMP */
#ifndef IS_FPGA
#define CONFIG_REALTEK_AMP
#define CONFIG_REALTEK_AMP_ALC1310
#define CONFIG_REALTEK_AMP_AD82010
#define CONFIG_REALTEK_AMP_TAS5707
#define CONFIG_REALTEK_AMP_TAS5711
#define CONFIG_REALTEK_AMP_TAS5751
#define CONFIG_REALTEK_AMP_AD82088
#define CONFIG_REALTEK_AMP_ALC1311
#define CONFIG_REALTEK_AMP_ALC1312
#endif

/* PWM */
#ifndef IS_FPGA
#ifndef CONFIG_RUN_FLASH_WRITER
#define CONFIG_REALTEK_PWM
#endif
#endif

/* PWM ROKU*/
#ifdef CONFIG_REALTEK_PWM
#define CONFIG_REALTEK_PWM_ROKU
#endif

/* LSADC */
#ifndef IS_FPGA
#define CONFIG_REALTEK_LSADC
#define CONFIG_CMD_LSADC
#endif

/* CW */
#ifndef IS_FPGA
#define CONFIG_REALTEK_CW
//#define CONFIG_CMD_RTK_CW
#endif

/* TIMER */
#ifndef IS_RDC_FPGA
#define CONFIG_REALTEK_TIMER
#endif

/* AUDIO OUTPUT*/
#ifndef IS_FPGA
#define ENABLE_PCB_AUDIO_OUTPUT_TYPE
#endif

#define CONFIG_SYS_MD_SUPPORT

/* HW LZMA */
//#define CONFIG_CMD_LZMA

/*HW monitor bootcode test function related*/
//#ifdef  Config_RTD_HW_MONITOR_TRUE
//#define CONFIG_CMD_HW_MONITOR
//#endif

/* MISC Wakeup */
//#define CONFIG_MISC_MGR_WAKEUP

/* Local Dimming Interface */
//#define CONFIG_REALTEK_LOCAL_DIMMING_INTERFACE

/* Logo Display */
//#define CONFIG_SYS_LOGO_DISP
#ifdef CONFIG_SYS_LOGO_DISP
  //#define CONFIG_SYS_LOGO_DISP_NTSC
  //#define CONFIG_SYS_LOGO_DISP_PAL
  //#define CONFIG_SYS_LOGO_DISP_1080P50
  //#define CONFIG_SYS_LOGO_DISP_1080P60
#endif

/* Bootcode Feature: Rescue linux read from USB */
#define CONFIG_RESCUE_FROM_USB
#define CONFIG_RESCUE_FROM_USB_FILENAME				"vmlinux.rescue.rtd285x.bin"

/* Bootcode Feature: Boot images read from USB */
//#define CONFIG_BOOT_FROM_USB
//#define CONFIG_BOOT_FROM_USB_KERNEL_FILENAME		"vmlinux.bin"
//#define CONFIG_BOOT_FROM_USB_AUDIO_FW_FILENAME		"bluecore.audio"
//#define CONFIG_BOOT_FROM_USB_VIDEO_FW_1_FILENAME	"video_firmware.bin"
//#define CONFIG_BOOT_FROM_USB_VIDEO_FW_2_FILENAME	"video2_firmware.bin"
//#define CONFIG_BOOT_FROM_USB_LZMA_EXTNAME			"lzma"

/*
 * AC on USB update feature setting from $(PRJ).inc
 */
#ifdef Config_AC_on_Usb_Update_image_Enable
  /* Bootcode Feature: Detect install.img from USB when AC on */
  #define CONFIG_USB_UPDATE_WHEN_AC_ON

#ifdef Config_AC_on_Usb_Update_dvrboot_Enable
  /* Bootcode Feature: Detect dvrboot.exe.bin from USB when AC on */
  #define CONFIG_USB_UPDATE_UBOOT_WHEN_AC_ON
#endif
#endif
/* Bootcode Feature: Read rescue linux from install.img or flash */
//#define CONFIG_USB_UPDATE_READ_RESCUE_FROM_FLASH

#if 0
  /* Bootcode Feature: Clear env from factory after updated bootcode */
  #define CONFIG_CLEAR_ENV_AFTER_UPDATE_BOOTCODE
#endif

#if 0
  /* Bootcode Feature: Display the time information to evaluate */
  #define CONFIG_DISPLAY_TIME_EVALUATION
#endif

#if 0
  /* Bootcode Feature: Customize function callback register */
  #define CONFIG_CUSTOMIZE_FUNC_REGISTER
#endif

#ifndef CONFIG_FORCE_IN_DEBUG
  /* Bootcode Feature: Disable print log in uboot stage */
  #define CONFIG_SILENT_CONSOLE
#endif

#if 0
  /* Bootcode Feature: Disable print log in kernel stage */
  #define CONFIG_SILENT_KERNEL
#endif

// Config panel name and compile options
#if (0) // CMI V500 VBY1 panel setting
  /* VBY1 panel setting */
  #define CONFIG_PANEL_NAME "asm/arch/panel/CMI_V500_4K2K_VBY1.h"
  #define VBY_ONE 1
  #define VBY_ONE_PANEL_CMI_V500_4K2K_VBY1
#elif (0) // China Start 4k2k VBY1 panel
  #define CONFIG_PANEL_NAME "asm/arch/panel/China_Star_4K2K_VBY1.h"
  #define VBY_ONE 1
  #define VBY_ONE_PANEL_CHINA_STAR_4K2K_VBY1
#elif (0) //PixelWorks PA-168 4k2k MEMC TCON control
  //PixelWorks PA-168 4k2k MEMC TCON control
  //#define ENABLE_PA168_BOOTUP_IN_2CH_MODE  	// rtd289x boot up LVDS output in 2ch mode
  #ifdef ENABLE_PA168_BOOTUP_IN_2CH_MODE
  #define CONFIG_PANEL_NAME "asm/arch/panel/au_t550QVF01_demo_v3.h"
  #else
  #define CONFIG_PANEL_NAME "asm/arch/panel/au_t550QVF01_PA168.h"
  #endif
#elif (0) // Samsung LSC400HM03
  #define CONFIG_PANEL_NAME "asm/arch/panel/tsb_samsung_lsc400hm03.h"
  #define LVDS_PANEL_TSB_SAMSUNG_LSC400HM03
#elif (0) // 4k2k30Hz_4port LVDS + millet3
  #define CONFIG_PANEL_NAME "asm/arch/panel/CMI_Millet3_v500_4k2k.h"
  //#define LVDS_PANEL_MILLET3_4K2K_30
  #define LVDS_PANEL_MILLET3_2K1K_120
#elif defined(Config_Panel_SKYWORTH_VBY1)
  /* Skyworth VBY1 4k2k panel setting */
  #define CONFIG_PANEL_NAME "asm/arch/panel/Default_4K2K_600M_VBY1_1Seg8Port.h"
#elif defined(Config_Panel_LG120_VBY1)
  #define CONFIG_PANEL_NAME "asm/arch/panel/LG_4K2K_120Hz_VBY1_1Seg16Port.h"
#elif defined(Config_Panel_LG120_VBY1_CURVE)
  #define CONFIG_PANEL_NAME "asm/arch/panel/LG_4K2K_120Hz_VBY1_4Seg16Port.h"
#elif defined(Config_Panel_VBY1_TO_LVDS)
  #define CONFIG_PANEL_NAME "asm/arch/panel/Default_VBY1_to_LVDS.h"
#elif defined(Config_Panel_Chinastart_VBY1)
  #define CONFIG_PANEL_NAME "asm/arch/panel/China_Star_4K2K_600M_VBY1.h"
#else // default 60Hz panel
  /* LVDS panel setting */
  #define CONFIG_PANEL_NAME "asm/arch/panel/default_panel.h"
  //#define CONFIG_PANEL_NAME "asm/arch/panel/Default_4K2K_600M_VBY1_1Seg8Port.h"
  //#define CONFIG_PANEL_NAME "asm/arch/panel/LG_4K2K_65_EPI.h"
#endif

#if defined(Config_Module_Test_Boot_TRUE)
#define CONFIG_FORCE_PANEL_NUM
#define FORCE_PANEL_NUM 9
#endif

/*config Android OTA/Recovery mode feature*/
/*this feature should be used with the specific android recovery image(as the role of normal rescue)*/
#ifndef IS_FPGA
#define CONFIG_ANDROID_RECOVERY 1
#endif

#define BOOTCODE_RESCUE         "dvrboot.rescue.exe.bin"
#define FULL_IMG                "install.img"
#define USB_AUTO_SCRIPT         "rtk_autoupdate.lst"
#define FACTORY_FLAG_FILE	FACTORY_HEADER_FILE_NAME"updateflags.dat"

#define MAX_USB_SCRIPT_LINE	64
#define MAX_USB_SCRIPT_LINE_LEN	128

/* KBoot */
//#define CONFIG_CMD_KBOOT
#define CONFIG_KCPU_LOAD_K_FW
#ifdef Rescue_Flash_Source_K
#define CONFIG_KCPU_LOAD_RESCUE
#endif
#ifdef Config_Enable_KBoot_TRUE
#define CONFIG_KBOOT_LOAD_AV_FW
#endif

#define CONFIG_NX_ATTR_FOR_OPTEE_REGION

/*
 *  Board Name
 */
#define CONFIG_SHOW_BOARDNAME
#ifdef CONFIG_SHOW_BOARDNAME

#if defined(Config_Board_Demo)
  #define BOARD_NAME "DemoBoard"
#elif defined(Config_Board_Demo_27x27)
  #define BOARD_NAME "Demo_27x27_Board"
#elif defined(Config_Board_Demo_19x19)
  #define BOARD_NAME "Demo_19x19_Board"
#elif defined(Config_Board_Demo_19x19_MT)
  #define BOARD_NAME "Demo_19x19_Board_MT"
  #elif defined(Config_Board_Demo_MT)
  #define BOARD_NAME "Demo_Board_MT"
#elif defined(Config_Board_FPGA)
  #define BOARD_NAME "FPGA_Board"
#elif defined(Config_Board_Demo_Modt)
  #define BOARD_NAME "DemoBoard_MT"
#elif defined(Config_Board_TV010)
  #define BOARD_NAME "TV010"
  #define Config_Board_TV010
  #define Config_Board_TV010_PANEL
#elif defined(Config_Board_TV010_R888)
  #define BOARD_NAME "TV010_R888"
  #define Config_Board_TV010
  #define Config_Board_TV010_R888_PANEL
#elif defined(Config_Board_TV043_RENO_V001)
  #define BOARD_NAME "TV043_Reno_V001"
#elif defined(Config_Board_TV002_V001)
  #define BOARD_NAME "TV002_V001"
#else
  #define BOARD_NAME "RT_Board"
#endif

#endif

/*
 * Rescue Source setting from $(PRJ).inc
 */
#ifdef Rescue_Source_USB
  #define CONFIG_RESCUE_SOURCE_FROM_USB
#endif

/*
 * STD/STR config from $(PRJ).inc
 */
#ifndef CONFIG_RUN_FLASH_WRITER
//#define SUPPORT_MIPS_ACPU
//#define CONFIG_ACPU2_SUPPORT

#ifdef Config_Support_STR_Enable
	#define CONFIG_STR_ENABLE
#endif
#ifdef Config_Support_No_Console_Suspend_STR_Enable
        #define CONFIG_NO_CONSOLE_SUSPEND_STR_ENABLE
#endif
#endif

#ifdef CONFIG_NO_CONSOLE_SUSPEND_STR_ENABLE
  #define CONFIG_BOOTARGS_EX \
        "no_console_suspend"
#endif

#ifdef Config_Less_Console_output_Enable
#define CONFIG_LESS_CONSOLE
#endif

#define Brief_Message
#define DBG_CKP(fmt,args...)                     printf("[%s:%d]" fmt, __FUNCTION__, __LINE__, ## args)
#define DBG_WAR(fmt,args...)                     printf("[%s:%d]Warning:" fmt, __FUNCTION__, __LINE__, ## args)
#define DBG_ERR(fmt,args...)                     printf("[%s:%d]Err:" fmt, __FUNCTION__, __LINE__, ## args)
#ifdef Brief_Message
	#define DBG_MSG(fmt,args...)
#else
	#define DBG_MSG(fmt,args...)             printf("[%s:%d]MSG:" fmt, __FUNCTION__, __LINE__, ## args)
#endif

#ifdef Config_PANEL_INIT_2ND_AFTER_LOGO_is_TRUE
#define CONFIG_PANEL_INIT_2ND_AFTER_LOGO
#endif

#define CONFIG_SYS_VSNPRINTF

#endif /* __CONFIG_RTK_COMMON_H */
