/*
 * Configuration settings for the Realtek Demo board.
 *
 * Won't include this file.
 * Just type "make <board_name>_config" and will be included in source tree.
 */

#ifndef __CONFIG_RTK_DEMO_H
#define __CONFIG_RTK_DEMO_H

/*
 * Include the common settings.
 */
/*
 * OTP autoburn
 */

//#define CONFIG_OTP_UTIL
//#define CONFIG_AUTO_PROGRAM_OTP

#include <configs/rtk_common.h>

/* Boot Revision */
#ifdef Param_boot_rev /* use define in ${PRJ}.inc */
	#define BOOT_REV_STRING		Param_boot_rev
#else
	#define CONFIG_COMPANY_ID	"0001"
	#define CONFIG_BOARD_ID		"1000"
	#define CONFIG_VERSION		"0000"
	#define BOOT_REV_STRING		CONFIG_COMPANY_ID"."CONFIG_BOARD_ID"."CONFIG_VERSION
#endif

/* Panel ini support */
#ifdef CONFIG_SYS_PANEL_SUPPORT_INI_FILE
#define PANEL_INI_FILE_NAME "tmp/factory/bin_panel/rtkPanel.ini"
#endif

/* no flash storage to save env */
//#define CONFIG_ENV_IS_NOWHERE

///////////////////////////////////////////////
// QC related configs
///////////////////////////////////////////////
#define CONFIG_QC_VERIFY

/* U-boot command */
#define CONFIG_CMD_QC

/* IC Type */
#if defined(Config_Package_type_BGA_27x27)
	#define CONFIG_RTK_B27_QC
#elif defined(Config_Package_type_BGA)
	#define CONFIG_RTK_B22_QC
//#elif defined(Config_Package_type_BGA_B2B)
//	#define CONFIG_RTK_B22_B2B_QC
#endif

/* QC code running type */
#if defined(Config_FW_Type_QC)
	#define CONFIG_EQC	1
	#define CONFIG_FT	0
    #define CONFIG_OLT	0
	#define CONFIG_QC_VERIFY_ATO	0
	#define CONFIG_QC_ONCE_ALL	1
#elif defined(Config_FW_Type_FT)
	#define CONFIG_EQC	0
	#define CONFIG_FT	1
	#define CONFIG_OLT	0
	#define CONFIG_QC_VERIFY_ATO	0
	#define CONFIG_QC_ONCE_ALL	1
#elif defined(Config_FW_Type_OLT)
	#define CONFIG_EQC	1
	#define CONFIG_FT	0
	#define CONFIG_OLT	1
	#define CONFIG_QC_VERIFY_ATO	0
	#define CONFIG_QC_ONCE_ALL	1
#endif
#define CONFIG_RMA	0  //for RMA IC analysis
#define CONFIG_PG	0  //for pattern gen

#if defined(Config_Flash_Type_is_NAND)
#define NAND_BOOT_QC	1
#else
#define NAND_BOOT_QC	0
#endif

/* Define each ip */
#if (CONFIG_EQC || CONFIG_OLT)
	#define CONFIG_MAX_POWER_MEASURE	0
	#define CONFIG_QC_SCPU_PWR_CTRL	0
	#define CONFIG_QC_BIST	0
	#define CONFIG_QC_BISR	0
	#define CONFIG_QC_SCPU	1
	#define CONFIG_QC_ACPU	1
	#define CONFIG_QC_GPU	1
	#define CONFIG_QC_VE	1
	#define CONFIG_QC_VE_Encode	1
	#define CONFIG_QC_VDE	1
	#define CONFIG_QC_SE	1
	#define CONFIG_QC_MD	1
	#define CONFIG_QC_CP	1
	#define CONFIG_QC_8051	0	//after EMCU OTP burns, close the test
	#define CONFIG_QC_AUDIO	1
	#define CONFIG_QC_IFD	1
	#define CONFIG_QC_CEC	1
	#define CONFIG_QC_HDMI	1
	#define CONFIG_QC_HDMI_TX	0	//Merlin6 no need this item
	#define CONFIG_QC_USB	1
	#define CONFIG_QC_ETN	1
	#define CONFIG_QC_VDC_TOP	1
	#define CONFIG_QC_VDC_PQ	1
	#define CONFIG_QC_VBI	1
#if defined(Config_Flash_Type_is_NAND)
	#define CONFIG_QC_NAND	1
#else
	#define CONFIG_QC_EMMC	1
#endif
	#define CONFIG_QC_SPI	1
	#define CONFIG_QC_SPI_NAND	0	//Merlin6 no need this item
	#define CONFIG_QC_I3DDMA	1
	#define CONFIG_QC_PERIPHERAL	1
	#define CONFIG_QC_MD_DOMAIN	1
	#define CONFIG_QC_VIP	1
	#define CONFIG_QC_MEMC	1
	#define CONFIG_QC_I_DOMAIN	1
	#define CONFIG_QC_MULTI_CORE_TEST	0
	#define CONFIG_QC_VP9	0
	#define CONFIG_QC_OTP	0
	#define CONFIG_QC_TVE	0
	#define CONFIG_QC_MHL	0
	#define CONFIG_QC_DDR	0
	#define CONFIG_QC_I2RND	0
	#define CONFIG_QC_STANDBY	0
	#define CONFIG_QC_Dolby_HDR	0
	#define CONFIG_QC_CBUS_RX	0
	#define CONFIG_QC_eCBUS_TX_Test	0
	#define CONFIG_QC_MHL_TX_CBUS	0
	#define CONFIG_QC_OTP_SW_KEY	0
	#define CONFIG_QC_CARDREADER	0

#else //FT
	#define CONFIG_QC_SCPU_PWR_CTRL	1
	#define CONFIG_QC_SCPU	1
	#define CONFIG_QC_ACPU	1
	#define CONFIG_QC_GPU	1
	#define CONFIG_QC_VE	1
	#define CONFIG_QC_VE_Encode	1
	#define CONFIG_QC_VDE	1
	#define CONFIG_QC_VDC_PQ	1
#if defined(Config_Flash_Type_is_NAND)
	#define CONFIG_QC_NAND	1
#else
	#define CONFIG_QC_EMMC	1
#endif
	#define CONFIG_QC_SPI	1
	#define CONFIG_QC_MD_DOMAIN	1
	#define CONFIG_QC_VIP	1
	#define CONFIG_QC_MEMC	1
	#define CONFIG_QC_LZMA  1
	#define CONFIG_QC_IFD	1

	#define CONFIG_QC_USB	0
	#define CONFIG_QC_ETN	0
	#define CONFIG_QC_SE	0
	#define CONFIG_QC_MD	0
	#define CONFIG_QC_CP	0	//Compilation failed
	#define CONFIG_QC_BISR  0
	#define CONFIG_QC_HDMI	0
//#ifndef CONFIG_RTK_B19_QC
//	#define CONFIG_QC_USB   0
//#endif

#endif //CONFIG_EQC

#if (CONFIG_QC_CP)
#define CONFIG_SYS_MCP_UTILITY
#define CONFIG_REALTEK_CP_DDTS
#endif
#define CONFIG_RTK_MCP
#define CONFIG_REALTEK_CW

#if CONFIG_QC_CEC
#define CONFIG_Merlin6_CEC   1
#endif

#if CONFIG_QC_ETN
#define CONFIG_Merlin6_ETN   1
#endif

#if CONFIG_QC_USB
//for USB
	#define CONFIG_BOOT_USB_EHCI 1
	#define CONFIG_BOOT_USB_XHCI 1
	#define CONFIG_BOOT_USB_STORAGE 1
	#define CONFIG_USB_PATCH 1
#if (CONFIG_EQC == 1) 	
	#define CONFIG_FAT_USE_EXTMEM_FOR_LARGE_ARRAY
	#define CONFIG_FAT_WRITE	
#endif
       #define CONFIG_USB_PORT_NUM  4
//for FS
	#define CONFIG_BOOT_FS 1
	#define CONFIG_BOOT_FS_FAT 1

	#ifndef CONFIG_SUPPORT_VFAT
	#define CONFIG_SUPPORT_VFAT 
#endif

#ifndef CONFIG_DOS_PARTITION
#define CONFIG_DOS_PARTITION 1
#endif
#endif //CONFIG_QC_USB

#define BOARD_NAME_STRING "Board: Realtek QC Board\n"

#if CONFIG_MAX_POWER_MEASURE
#if (CONFIG_QC_SCPU == 0)
#warning "%%% CONFIG_MAX_POWER_MEASURE needs CONFIG_QC_SCPU, force true. \n"
#undef CONFIG_QC_SCPU
#define CONFIG_QC_SCPU 1
#endif //#if (CONFIG_QC_SCPU == 0)

//#define CONFIG_SYS_SUPPORT_MULTICORE
#define CONFIG_MULTICORE_TLB_BASE   0x03000000

/*
 *  *    Stack pointer base for each core
 *   *    */
#define CONFIG_SYS_INIT_CORE1_SP_ADDR  0x1f100000
#define CONFIG_SYS_INIT_CORE2_SP_ADDR  0x1f200000
#define CONFIG_SYS_INIT_CORE3_SP_ADDR  0x1f300000
#define CONFIG_SYS_INIT_CORE4_SP_ADDR  0x1f400000
#define CONFIG_CMD_SCUTEST
#define CONFIG_CMD_COPROC
#endif //#if CONFIG_MAX_POWER_MEASURE

#if (CONFIG_FT == 1) //disable panel related functions
#undef CONFIG_SYS_PANEL_SUPPORT
#undef CONFIG_SYS_PANEL_PARAMETER
#undef CONFIG_CMD_PANEL
#undef CONFIG_SYS_GDMA_SUPPORT
#undef CONFIG_RTK_GDMA_SUPPORT
#endif

#if defined(CONFIG_QC_MULTI_CORE_TEST) ||(CONFIG_QC_SCPU_PWR_CTRL)
/* MTEST */
#define CONFIG_SYS_SUPPORT_MULTICORE
//#define CONFIG_USE_IRQ
#define CONFIG_CMD_MTEST_MULTICORE
#ifdef CONFIG_SYS_SUPPORT_MULTICORE
/*
 *  *    TLB page_table = BASE + get_id() * 0x4000
 *   *       core0: original TLB
 *    *          core1: 0x0300_4000
 *     *             core2: 0x0300_8000
 *      *                core3: 0x0300_c000
 *       *                */
#define CONFIG_MULTICORE_TLB_BASE   0x03000000
#ifdef CONFIG_USE_IRQ
  #define CONFIG_STACKSIZE_IRQ	(4 << 10)	/* IRQ stack */
  #define CONFIG_STACKSIZE_FIQ	(4 << 10)	/* FIQ stack */
#endif
/*
 *  *    Stack pointer base for each core
 *   *    */
#define CONFIG_SYS_INIT_CORE1_SP_ADDR  0x1f100000
#define CONFIG_SYS_INIT_CORE2_SP_ADDR  0x1f200000
#define CONFIG_SYS_INIT_CORE3_SP_ADDR  0x1f300000
#define CONFIG_SYS_INIT_CORE4_SP_ADDR  0x1f400000

/*
 *  *    Some commands about multi-core
 *   *    */
#define CONFIG_CMD_MTEST_MULTICORE
#define CONFIG_CMD_SCUTEST
#define CONFIG_CMD_COPROC
#endif
#endif

/*
	if enable Config_Redef_Bootcode_Addr in project_config.h,
	then redefine CONFIG_SYS_TEXT_BASE
	and define CONFIG_REDEF_BOOTCODE_ADDR for uboot/Makefile
*/
#ifdef Config_Redef_Bootcode_Addr_TRUE
#define CONFIG_SYS_TEXT_BASE      0x10000000
#define CONFIG_REDEF_BOOTCODE_ADDR 1
#endif

#ifdef CONFIG_VIP_SUPPORT
#define CONFIG_VIP_RESERVED_ADDR 0x2fe00000
#define CONFIG_VIP_RESERVED_SIZE  0x200000
#else
#define CONFIG_VIP_RESERVED_ADDR 0x0000000
#define CONFIG_VIP_RESERVED_SIZE  0x0000000
#endif
#ifdef CONFIG_OD_SUPPORT
#define CONFIG_OD_RESERVED_ADDR 0x30000000
#define CONFIG_OD_RESERVED_SIZE  0x800000
#else
#define CONFIG_OD_RESERVED_ADDR 0x00000000
#define CONFIG_OD_RESERVED_SIZE  0x0000000
#endif
#undef CONFIG_ARCH_CPU_ARMA57
#undef CONFIG_USE_CCI_BUS

#endif /* __CONFIG_RTK_DEMO_H */
