/*----------------------------------------------------------------------------
*
*The confidential and proprietary information contained in this file may
*only be used by a person authorised under and to the extent permitted
*by a subsisting licensing agreement from ARM Limited.
*
*        (C) COPYRIGHT 2008-2009,2011,2013 ARM Limited.
*             ALL RIGHTS RESERVED
*             
*This entire notice must be reproduced on all copies of this file
*and copies of this file may only be made by a person if such person is
*permitted to do so under the terms of a subsisting license agreement
*from ARM Limited.
*
*     SVN Information
*
*     Checked In          : $Date$
*
*     Revision            : $Revision$
*
*     Release Information : r0p0-00rel0
*
*-----------------------------------------------------------------------------
* 
*-----------------------------------------------------------------------------
* Abstract :Common Header File
*-----------------------------------------------------------------------------
* Overview
*----------
* 
*
* 
* 
**************************************************************/
#ifndef __MALI_COMMON_H__
#define __MALI_COMMON_H__

#include <asm/arch/io.h> //uboot


//#define write32(addr, val) (*(volatile unsigned int *)(addr) = (val))
//#define read32(addr) (*(volatile unsigned int *)(addr))
#define write32	rtd_outl
//#define rtd_outl(offset,val)            (*(volatile unsigned long *)(offset) = val)
#define read32 rtd_inl

//replace read32 from DV. "DON'T" add return() in this macro..
#if 0
#define jump_to_addr(addr) do{ \
	if( addr == 0xa0003000) { printf("code ok:0x%x. jump to 0x%x\n at %s %d", rtd_inl(0xB804e060), addr, __FUNCTION__, __LINE__);  } \
	else if ( addr == 0xa0003020) { printf("code fail:0x%x . jump to 0x%x %s %d\n", rtd_inl(0xB804e060), addr, __FUNCTION__, __LINE__);  } \
	else if ( addr == 0xa4000000) { printf("dv code jump(useless):0x%x. jump to 0x%x %s %d.\n",rtd_inl(0xB804e060), addr, __FUNCTION__, __LINE__);   } \
	else printf("unknown code jump:0x%x. jump to 0x%x %s %d.\n", rtd_inl(0xB804e060), addr, __FUNCTION__, __LINE__); \
} while(0)
#else
#define jump_to_addr(addr)
#endif//


/* these functions are in cache.s */
extern void clean_dcache(void);  
extern void clean_dcache_line(int);
extern void clean_invalidate_dcache_line(int);
extern void flush_tlb(void);
extern void flush_branch_pred_array(void);
extern void invalidate_icache(void);
extern void invalidate_icache_line(int);
extern void instr_sync_barrier(void);
extern void data_sync_barrier(void);

/* these functions are in helpers.s */
extern void call_wfi(void);
extern void enable_irq(void);
extern void disable_irq(void);

#endif//__MALI_COMMON_H__
