;;----------------------------------------------------------------------------
;;
;;The confidential and proprietary information contained in this file may
;;only be used by a person authorised under and to the extent permitted
;;by a subsisting licensing agreement from ARM Limited.
;;
;;        (C) COPYRIGHT 2008-2009,2011,2013 ARM Limited.
;;             ALL RIGHTS RESERVED
;;             
;;This entire notice must be reproduced on all copies of this file
;;and copies of this file may only be made by a person if such person is
;;permitted to do so under the terms of a subsisting license agreement
;;from ARM Limited.
;;
;;    SVN Information
;;
;;    Checked In          : $Date$
;;
;;    Revision            : $Revision$
;;
;;    Release Information : r0p0-00rel0
;;
;;-----------------------------------------------------------------------------
;; 
;;-----------------------------------------------------------------------------
;; Abstract :Host CPU TTB initialisation
;;-----------------------------------------------------------------------------
;; Overview
;;----------
;; 
;;
;; 
;; 
;;----------------------------------------------------------------------------
                AREA    TransTable, DATA, ALIGN=14
                EXPORT  ttb_first_level

NGLOBAL         EQU (1<<17)
SHARED          EQU (1<<16)
APX             EQU (1<<15)
TEX1            EQU (1<<12)
AP0             EQU (1<<10)
AP1             EQU (1<<11)
PARITY          EQU (1<<9)
XN              EQU (1<<4)
CACHE           EQU (1<<3)
BUFFER          EQU (1<<2)
SECTION         EQU (2<<0)

UNMAPPED        EQU 0



MEMORY          EQU (TEX1 | CACHE | BUFFER | SECTION | AP0 | AP1)
NON_CACHED      EQU (TEX1                  | SECTION | AP0 | AP1)          
DEVICE          EQU (               BUFFER | SECTION | AP0 | AP1)
SO_MEMORY       EQU (                        SECTION | AP0 | AP1)
                 
SHARED_MEMORY    EQU (MEMORY    | SHARED)
SHARED_SO_MEMORY EQU (SO_MEMORY | SHARED)
SHARED_DEVICE    EQU (DEVICE    | SHARED)

                MACRO   
                SET_TTB $VA, $ATTR
                DCD     (($VA) :AND: 0xfff00000) :OR: $ATTR
                MEND

                GBLA    VA
VA              SETA    0

ttb_first_level
	        ;; Range 0x00000000 -> 0x1bffffff: Unused Peripherals + Secure Memories
                WHILE   (0x$VA < 0x1c0)
                DCD     UNMAPPED
VA              SETA    0x$VA + 1
                WEND

		;; Range 0x1c000000 -> 0x1fffffff: registers
                WHILE   (0x$VA < 0x200)
                SET_TTB (0x$VA :SHL: 20), DEVICE
VA              SETA    0x$VA + 1
                WEND
	
	        ;; Range 0x20000000 -> 0x2bffffff: Unused
                WHILE   (0x$VA < 0x2c0)
                DCD     UNMAPPED
VA              SETA    0x$VA + 1
                WEND

		;; Range 0x2c000000 -> 0x2d0fffff: registers, CPU Periph Base + MALI_T720 Registers
                WHILE   (0x$VA < 0x2d1)
                SET_TTB (0x$VA :SHL: 20), DEVICE
VA              SETA    0x$VA + 1
                WEND
	
	        ;; Range 0x2d100000 -> 0x7fffffff: Unused
                WHILE   (0x$VA < 0x800)
                DCD     UNMAPPED
VA              SETA    0x$VA + 1
                WEND

	        ;; Range 0x80000000 -> 0x87ffffff: memory - cached
                WHILE   (0x$VA  < 0x880)
                [ ENABLE_SMP                
                SET_TTB (0x$VA :SHL: 20), SHARED_MEMORY
                |                
                SET_TTB (0x$VA :SHL: 20), MEMORY
                ]                
VA              SETA    0x$VA + 1
                WEND

		;; Range 0x88000000 -> 0x9fffffff: normal memory / non-cached
                WHILE   (0x$VA  < 0xa00)
                SET_TTB (0x$VA :SHL: 20), NON_CACHED
VA              SETA    0x$VA + 1
                WEND

                END
