//----------------------------------------------------------------------------
// The confidential and proprietary information contained in this file may
// only be used by a person authorised under and to the extent permitted
// by a subsisting licensing agreement from ARM Limited.
//
// (C) COPYRIGHT 2006 ARM Limited.
// ALL RIGHTS RESERVED
//
// This entire notice must be reproduced on all copies of this file
// and copies of this file may only be made by a person if such person is
// permitted to do so under the terms of a subsisting license agreement
// from ARM Limited.
//
// Checked In : $Date: 2012-06-05 14:18:54 +0100 (Tue, 05 Jun 2012) $
// Revision : $Revision: 131145 $
//
//----------------------------------------------------------------------------

#ifndef __TB_UTIL_H
#define __TB_UTIL_H


#define MAX_PATTERN_NUM 4
typedef struct test_vector {
	const char * vector_name;
	const char * cmd_string;
	char * load_pattern[MAX_PATTERN_NUM];
	unsigned int load_pattern_num;
	char * pattern[MAX_PATTERN_NUM];
	unsigned long pattern_offset[MAX_PATTERN_NUM];
	unsigned int pattern_num;
}test_vector ;

/* Typedefs */
/**
 */
typedef enum mali_error_code
{
    MALI_ERROR_NO_ERROR           =  0,
    MALI_ERROR_OUT_OF_MEMORY      = -1,
    MALI_ERROR_FUNCTION_FAILED    = -2,
    MALI_ERROR_NOTHING_TO_DO      = -3,
} mali_error_code;


mali_error_code cmd_read_configtxt(test_vector *vector);

/**
 */
typedef mali_error_code cmd_function(char* buf, test_vector * vector);


/* Functions inside tb_util.c */
void print_help();

extern int debug_print;
extern unsigned long gpu_pattern_golden_size;
extern unsigned long  gpu_pattern_size;
#define ONLY_PRINT 0
#define NULL 0
#define EMMC_BLOCK_SIZE_SHIFT       (9)

#define EMMC_QC_EXTERND_DATA_1_ADDR				0x01300000				// offset 18 MB outlite_21_oc.bin
#define EMMC_QC_EXTERND_DATA_1_BLK_ADDR		    (EMMC_QC_EXTERND_DATA_1_ADDR>>EMMC_BLOCK_SIZE_SHIFT) //

#define EMMC_QC_EXTERND_DATA_2_ADDR				0x02300000				// offset 22 MB outfb_21.bin
#define EMMC_QC_EXTERND_DATA_2_BLK_ADDR		    (EMMC_QC_EXTERND_DATA_2_ADDR>>EMMC_BLOCK_SIZE_SHIFT) //

#define EMMC_TMP_BUFFER                         0x01500000 //0x1500000
#define EMMC_BLOCK_SIZE             (512UL)
#define ROUND_UP(x,y) (((x)+(y)-1)&~((y)-1))
#define GPU_PATTERN_ADDR          0x01600000 //0x5000000
#define GPU_PATTERN_GOLDEN_ADDR   0x01b00000 //0x6000000



/* Select if you want debug output or not */
#define DPRINTF(...) do{if(debug_print) printf(__VA_ARGS__);}while(0)
#define IPRINTF(...) do{printf("  "__VA_ARGS__);}while(0)
/*#define DPRINTF(A, ...)*/
#define PRINTERR(...)  printf( "ERR: %s(): line:%d " , __FUNCTION__, __LINE__); printf(" " __VA_ARGS__) ; printf("\n")
// #define PRINTERR(...)  printf( "ERR: %s(): line:%d " __VA_ARGS__ "\n", __FUNCTION__, __LINE__)


#define IF_ERR_PRINT_AND_GOTO_FUNCTION_END(...) \
    if ( err != MALI_ERROR_NO_ERROR){\
        PRINTERR(__VA_ARGS__);\
        goto function_end;\
    }\


#endif
