#include "config.h"
#include "../tb_util.h"
#if GPU_WRAPPER_TEST
#define SYS_REG_GPU_CLK_OFFSET              0xb8000114
#define SYS_REG_GPU_RESET_OFFSET            0xb8000104
#define REG_GPU_INTERRUPT_ENABLE_OFFSET     0xb810e050
#define REG_GPU_RESET_OFFSET                0xb810f000
#define SYS_REG_INT_CTRL_SCPU               0xb8000290

static unsigned int unmatch_count = 0;
mali_error_code test_read_default(unsigned long addr, unsigned long default_value )
{
	unsigned long uReg;
	//uReg = rtd_inl(addr);
	//printf("[read register] addr: 0x%x value: 0x%x\n",addr,uReg);
	//printf("[write register] addr: 0x%x value: 0x%x\n",addr,value);
	//rtd_outl(addr,value);
	uReg = rtd_inl(addr);
	printf("[read register] addr: 0x%x value: 0x%x\n",addr,uReg);
	if (uReg == default_value )
		printf("r/w match default value!\n");
	else{
		printf("r/w mismatch default value !\n");
		unmatch_count++;
	}



}
mali_error_code test_write(unsigned long addr, unsigned long value)
{
	unsigned long uReg;
	//uReg = rtd_inl(addr);
	//printf("[read register] addr: 0x%x value: 0x%x\n",addr,uReg);
	printf("[write register] addr: 0x%x value: 0x%x\n",addr,value);
	rtd_outl(addr,value);
	uReg = rtd_inl(addr);
	printf("[read register] addr: 0x%x value: 0x%x\n",addr,uReg);
	if (uReg == value )
		printf("r/w match!\n");
	else{
		printf("r/w mismatch!\n");
		unmatch_count++;
	}
	
}
mali_error_code gpu_wrapper_test(void)
{
	unsigned long test_vector[] = {
			0xb810e000, 0x7f00,
			0xb810E030, 0x20010,
			0xb810E04C, 0x02,
			0xb810E058, 0x2aa,
		};
	
	int i,count;
	unmatch_count=0;
	printf(">>>>>>> enter gpu_wrapper_test <<<<<<<<<<<\n");
	count = sizeof(test_vector)/(2*sizeof(unsigned long));
	printf("count=%d\n",count);
	for (i = 0; i<count;i++){
		test_read_default(test_vector[2*i], test_vector[2*i+1]);
		test_write(test_vector[2*i], 0x00000001);
		test_write(test_vector[2*i], test_vector[2*i+1]);
		}
	printf("[result] unmatch count = %d \n", unmatch_count);
	printf("Test Passed!\n");
	return MALI_ERROR_NO_ERROR;
}

#endif

