#include "config.h"
#include "../tb_util.h"
#if MP_M470_MP_F050_PMU_APB

static const char* pattern_0 ="\
TRUE\n\
TRUE\n";


static test_vector mp_m470_mp_F050_PMU_APB_vector = {
	.vector_name = "mp_m470_mp_F050_PMU_APB",
	.cmd_string = "\
# Reset the GPU\n\
reset\n\
#######\n\
##### Power down start\n\
#######\n\
# dump the reset state of the status register for reference\n\
check_reg 80002008 = 00000000 > 0\n\
# Power down everything\n\
writereg 80002004 00000FFF\n\
# wait for the powerdown to complete\n\
wait posedge irq\n\
# Clear the PMU interrupt\n\
writereg 80002018 00000001\n\
# Now power up everything\n\
writereg 80002000 00000FFF\n\
# wait for the powerup to complete\n\
wait posedge irq\n\
# Clear the PMU interrupt\n\
writereg 80002018 00000001\n\
# dump the status register for checking\n\
check_reg 80002008 = 00000000 >> 0\n\
#######\n\
##### Power up complete\n\
#######\n",
};

mali_error_code mp_m470_mp_F050_PMU_APB(void){
	mali_error_code err = MALI_ERROR_NO_ERROR;
	mp_m470_mp_F050_PMU_APB_vector.pattern_num = 1;
	mp_m470_mp_F050_PMU_APB_vector.pattern[0] = pattern_0;
	mp_m470_mp_F050_PMU_APB_vector.pattern_offset[0] = 0;
	IPRINTF("\n\n\n\n>>>>>enter function mp_m470_mp_F050_PMU_APB <<<<<\n");
	err = cmd_read_configtxt(&mp_m470_mp_F050_PMU_APB_vector);
	return err;

}

#endif