#include "config.h"
#include "../tb_util.h"
#if PP_M470_MP_F014_MMU_PP0_IRQ

static const char* pattern_0 ="\
12000010: ........ 00000001 00000000 00000001\n\
12000020: 00000001 ........ ........ ........\n";

static const char* pattern_1 = "\
12000010: ........ 00000002 00000000 00000002\n\
12000020: 00000002 ........ ........ ........\n";

static test_vector pp_m470_mp_F014_MMU_PP0_IRQ_vector = {
	.vector_name = "pp_m470_mp_F014_MMU_PP0_IRQ",
	.cmd_string = "\
reset\n\
timeout 10000\n\
# Set up interrupt mask\n\
writereg 1200001c 00000001\n\
writereg 12000014 00000001\n\
wait posedge irq\n\
dump_reg 12000014 12000024 > 0\n\
reset\n\
writereg 1200001c 00000002\n\
writereg 12000014 00000002\n\
wait posedge irq\n\
dump_reg 12000014 12000024 > 1\n\
quit\n",
};

mali_error_code pp_m470_mp_F014_MMU_PP0_IRQ(void){
	mali_error_code err = MALI_ERROR_NO_ERROR;
	pp_m470_mp_F014_MMU_PP0_IRQ_vector.pattern_num = 2;
	pp_m470_mp_F014_MMU_PP0_IRQ_vector.pattern[0] = pattern_0;
	pp_m470_mp_F014_MMU_PP0_IRQ_vector.pattern[1] = pattern_1;
	pp_m470_mp_F014_MMU_PP0_IRQ_vector.pattern_offset[0] = 0;
	pp_m470_mp_F014_MMU_PP0_IRQ_vector.pattern_offset[1] = 0;

	IPRINTF("\n\n\n\n>>>>>enter function pp_m470_mp_F014_MMU_PP0_IRQ <<<<<\n");
	err = cmd_read_configtxt(&pp_m470_mp_F014_MMU_PP0_IRQ_vector);
	return err;

}

#endif

