/*-----------------------------------------------------------------------------
 * The confidential and proprietary information contained in this file may
 * only be used by a person authorised under and to the extent permitted
 * by a subsisting licensing agreement from ARM Limited or its affiliates.
 *
 *            (C) COPYRIGHT 2008-2009, 2011-2014, 2017 ARM Limited or its affiliates.
 *                ALL RIGHTS RESERVED
 *
 * This entire notice must be reproduced on all copies of this file
 * and copies of this file may only be made by a person if such person is
 * permitted to do so under the terms of a subsisting license agreement
 * from ARM Limited or its affiliates.
 *
 *      Release Information : r0p0-00eac0
 *
 *-----------------------------------------------------------------------------
 *
 *-----------------------------------------------------------------------------
 * Abstract : Mali Performance Counters
 *-----------------------------------------------------------------------------*/

#include "MaliFns.h"
#include "MaliDefines_DVALIN.h"

/* Defines for Performance Counters - Cores */


void Mali_InitPerfCounters() {
	printf("Setting Performance counters...\n");
	Mali_WrReg(PRFCNT_CONFIG,0x00000001);
	Mali_WrReg(PRFCNT_JM_EN,0xFFFFFFFF);
	Mali_WrReg(PRFCNT_SHADER_EN,0xFFFFFFFF);
	Mali_WrReg(PRFCNT_TILER_EN,0xFFFFFFFF);
	Mali_WrReg(PRFCNT_MMU_L2_EN,0xFFFFFFFF);
	Mali_WrReg(PRFCNT_BASE_LO,0xb8000000);
	Mali_WrReg(PRFCNT_BASE_HI,0x00000000);
	Mali_WrReg(PRFCNT_CONFIG,0x00000021);
};

void Mali_InitPerfCountersFn(int core, int cnt_num, int cnt_id) {
};

void Mali_ReadPerfCounters() {
};
