/*----------------------------------------------------------------------------
*
* The confidential and proprietary information contained in this file may
* only be used by a person authorised under and to the extent permitted
* by a subsisting licensing agreement from ARM Limited or its affiliates.
*
*        (C) COPYRIGHT 2008-2009, 2011-2017 ARM Limited or its affiliates.
*             ALL RIGHTS RESERVED
*             
* This entire notice must be reproduced on all copies of this file
* and copies of this file may only be made by a person if such person is
* permitted to do so under the terms of a subsisting license agreement
* from ARM Limited or its affiliates.
*
* Release   : r0p0-00eac0
*-----------------------------------------------------------------------------*/
#include "MaliFns.h"
#include "non_coherent_DVALIN_compare.h"
// Max errors - note this is a negative number
#ifndef MAX_ERR
  #define MAX_ERR -4
#endif
#ifndef VERBOSE_CHECK
  #define VERBOSE_CHECK 0
#endif

int Load_input_compare () {
  int res = 0;
  struct t_LoadData_input_compare *r = &LoadData_input_compare;
  printf("Comparing data for 1st job\n");
  if (res > MAX_ERR) { res += Mali_MemCmp((unsigned int *)0xd6129000, 0xd6129000, r->compare_d6129000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCmp((unsigned int *)0xd612a000, 0xd612a000, r->compare_d612a000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCmp((unsigned int *)0xd612b000, 0xd612b000, r->compare_d612b000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCmp((unsigned int *)0xd612c000, 0xd612c000, r->compare_d612c000, 0, 0x400); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_compare_2 () {
  int res = 0;
  struct t_LoadData_input_compare_2 *r2 = &LoadData_input_compare_2;
  printf("Comparing data for 2nd job\n");
  if (res > MAX_ERR) { res += Mali_MemCmp((unsigned int *)0xd612d000, 0xd612d000, r2->compare_d612d000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCmp((unsigned int *)0xd612e000, 0xd612e000, r2->compare_d612e000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCmp((unsigned int *)0xd612f000, 0xd612f000, r2->compare_d612f000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCmp((unsigned int *)0xd6130000, 0xd6130000, r2->compare_d6130000, 0, 0x400); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};
