
/******************************************************
 Include Files
******************************************************/
#include <qc_verify_common.h>
#include "IFD_qc.h"
#include "ifd_driver.h"
#include "ifd_agc.c"
#include "ifd_analog.c"
#include "ifd_cr.c"
#include "ifd_video.c"
#include "ATSC3/demod_rtk_common.c"

/******************************************************
General Variations
******************************************************/
#define LOOP 1000
bool g_scan_flag=0;
UINT8 g_scan_curr_audio_std=0xff;
UINT8 g_curr_audio_std=0xff;

extern StructIFDDataType stIFDUserData;
extern ATV_TUNER_MODULE *pTuner;

/******************************************************
Functions Definition
******************************************************/
void drv_ifd_reset_nco(void)
{
	rtd_outl(IFD_108_cr_freq_sat_reg , 0x00000000);
	ScalerTimer_DelayXms(300);
	rtd_outl(IFD_108_cr_freq_sat_reg , 0x0a000);
}

#if 0
static  void drv_ifd_reset(void)	
{
	IFD_QC_FUNC();
	drv_ifd_power_on(1);
	udelay(1000);
}
#endif

#ifdef Test_IFD_QC_TunerIfdFreq_Verify
static void drv_ifd_vd_reset(void)
{
	rtd_outl(0xb8000104,0x00200001);
	udelay(10);
}
#endif

void drv_ifd_pinshare(void)
{
	IFD_QC_FUNC();
	
	rtd_maskl(0xb8060204,~(0xf << 12), (0x6 << 12)); 	//GPIO 06 : TUNER SDA
	rtd_maskl(0xb8060204,~(0xf << 4), (0x6 << 4)); 	//GPIO 07 : TUNER SCL
}

void drvif_vdc_init(void)
{
   	/*
	rtd_maskl(0xb8000104, 0xFF9FF7Fe, 0x00608801); //[22]RSTN_VDEC[21]RSTN_VDEC2[15]RSTN_IFADC[11]RSTN_APLL_ADC
    	rtd_maskl(0xb8000108, 0xF3FFFFFe, 0x0C000001); //[27]RSTN_ATVIN2[26]RSTN_ATVIN
    	rtd_maskl(0xb8000114, 0xFFBFF7Fe, 0x00408801); //[22]CLKEN_VDEC[15]CLKEN_IFADC[11]CLKEN_APLL_ADC
   	rtd_maskl(0xb8000118, 0xF3BFFFFe, 0x0C400001); //[27]CLKEN_ATVIN_VD[26]CLKEN_ATVIN_IFD
	ScalerTimer_DelayXms(5);
	*/
	// vd initial setting
	rtd_outl(0xb8019004,0x0003FC00);		// set AV							// VIDEO_CONTROL1
	rtd_outl(0xb8019080,0x00000000);		// decimation filter has been changed				// INOUT_CTRL
	rtd_outl(0xb801909C,0x00000047);		// set bgate_raw_sel enable					// VIDEO_CONTROL2
	rtd_outl(0xb8019620,0x00000108);		// set VDC 444 output					// FSW_CTRL2
	rtd_outl(0xb8019764,0x0008007F);		// bit[9:8]=01, select Select the VCO freq = 432M			// MISC_CONTROL
	rtd_outl(0xb80197FC,0x00000000);		// Disable clamp test mode					// ADC_UPDN_CTRL
	rtd_outl(0xb8019608,0x000000C9);		// select Y path (often sets C9 or 1B)				// AD_SW_CTRL0
	rtd_outl(0xb801960C,0x00000000);		// set Y							// CLAMP_UPDN_EN
	rtd_outl(0xb8019610,0x000000FF);		// enable AD1~AD4 clamp up/dn				// CLAMP_RGB_UPDN_EN
	rtd_outl(0xb801907C,0x00000081);

	//Set For IFD
	rtd_outl(0xb8019080,0x0000000b);
	rtd_outl(0xb8019084,0x000000a0);
}
extern void drvif_scaleri2c_tuner_init(void);
void drvif_ifd_init(void)
{
	IFD_QC_FUNC();
	drv_ifd_tuner_BuildTuner();
	drv_ifd_set_adc_init();
	drvif_vdc_init();
	drvif_scaleri2c_tuner_init();//initial I2C
}

void drv_ifd_delay_ms(UINT32 ms)
{
	UINT32 test_i;
	for(test_i=0;test_i<10000;test_i++);
}

/******************************************************
Variations Definition (by Config)
******************************************************/
#ifdef Test_IFD_QC_TunerIfdFreq_Verify
#define VIDEO_TEST_TIME 100
#define RF_FREQ_NUM 1//3
UINT32 rf_freq[RF_FREQ_NUM]={1752500,};
UINT8 rf_status[RF_FREQ_NUM];
#endif

#ifdef Test_IFD_QC_Gain_Verify
#define GAIN_FREQ_NUM 1
#define GAIN_AVG_SHIFT 3
#define GAIN_TEST_TIME (1<<GAIN_AVG_SHIFT)
#define GAIN_TARGET 0x100
#endif

/******************************************************
Functions Definition (by Config)
******************************************************/
#ifdef Test_IFD_QC_TunerIfdFreq_Verify
void drvif_vdc_ifd_path_setting(UINT8 on_off)
{
	if(on_off)
		rtd_maskl(VDTOP_INOUT_CTRL_VADDR,~(_BIT3|_BIT1|_BIT0), _BIT3|_BIT1|_BIT0); // 1_9080, INOUT_CTRL
	else
		rtd_maskl(VDTOP_INOUT_CTRL_VADDR,~(_BIT3|_BIT1|_BIT0), 0x00);	// 1_9080
}
UINT8 drv_ifd_vd_check_hvlock(void)
{
	UINT32 Data;
	udelay(100);
	Data=(UINT32)rtd_inl(VDTOP_VIDEO_STATUS_REG1_VADDR);
	IFD_QC_MSG("[VD] b8019008[3:0]=%x ",(Data&0xf));
	if (!(Data & _BIT0))
	{
		if ((Data & _BIT1) && (Data & _BIT2))
		{
			return 1;
		}
	}
	return 0;
}
UINT8 drv_ifd_vd_get_noise_status(void)
{
	UINT8 noise;
	noise = (UINT8)rtd_inl(VDTOP_NOISE_STATUS_VADDR);
	return noise;
}
#endif

#ifdef Test_IFD_QC_AudioPerFoms_Verify
static void drv_ifd_audio_initial(void)
{
	IFD_QC_FUNC();
	rtd_outl(0xb8000104,0x000F0000);
	rtd_outl(0xb8000104, _BIT19|_BIT18|_BIT17|_BIT16|_BIT0);
	rtd_outl(0xb800011c,0x000003FE);
	rtd_outl(0xb800011c, _BIT9|_BIT8|_BIT7|_BIT6|_BIT5|_BIT4|_BIT3|_BIT2|_BIT1|_BIT0);
	rtd_outl(0xb8000114,0x00030000);
	rtd_outl(0xb8000114, _BIT17|_BIT16|_BIT0);
	rtd_outl(0xb8000118,0x00009000);
	rtd_outl(0xb8000118, _BIT15|_BIT12|_BIT0);
	rtd_outl(AUDIO_GLOBAL_CTRL_2_VADDR, 0x000001F0);
	udelay(20);

	//void drv_ifd_audio_aud_DrClock()
	rtd_maskl(AUDIO_GLOBAL_CTRL_1_VADDR, _BIT31|_BIT30|_BIT29|_BIT28, _BIT31|_BIT30|_BIT29|_BIT28);//SDRAM on
	rtd_maskl(AUDIO_GLOBAL_CTRL_1_VADDR, _BIT20, _BIT20);//SIF ADC CLOCK on
	rtd_maskl(AUDIO_GLOBAL_CTRL_1_VADDR, _BIT13|_BIT12|_BIT5|_BIT4, _BIT13|_BIT5);//PLL AUDIO

	//void drv_ifd_audio_aud_DrBaseband()
	rtd_maskl(AUDIO_ANALOG_DEPOP2_VADDR, _BIT3|_BIT2|_BIT1|_BIT0, _BIT3|_BIT2|_BIT1|_BIT0);//enable output normal mode FOR HP/AIO Frank
	//rtd_maskl(IFD_ANALOG_VDAC_CTRL1_VADDR, _BIT24,_BIT24);// turn on "REG_VDAC_POWMBIAS" for BB audio
	rtd_maskl(AUDIO_ANALOG_POWER_VADDR, _BIT13|_BIT12|_BIT11|_BIT10|_BIT9|_BIT8|_BIT7|_BIT6|_BIT5|_BIT4|_BIT3|_BIT2|_BIT1,_BIT13|_BIT12|_BIT11|_BIT10|_BIT9|_BIT8|_BIT7|_BIT6|_BIT5|_BIT4|_BIT3|_BIT2|_BIT1);//turn on audio power
	rtd_maskl(AUDIO_ANALOG_CI01_VADDR ,_BIT27|_BIT26|_BIT23|_BIT22, _BIT27|_BIT26|_BIT23|_BIT22);//Frank AIO & HP BIAS current 20u

	//void drv_ifd_audio_aud_DrGpio()
	//void drv_ifd_audio_aud_DrSIF()
   	rtd_maskl(AUDIO_MSD_CRTL_WORD_VADDR, ~_BIT29,_BIT29);
     	rtd_maskl(AUDIO_SIF_AGC_EVAL_CNT_VADDR, ~_BIT16,_BIT16);
}
#endif


/******************************************************
IFD QC Code
******************************************************/
#ifdef Test_IFD_QC_CRC_Verify
UINT8 CIFD_CRC_108M_New(bool eq_en, UINT16 *eqTable, bool output_en, UINT16 *outputTable, bool grpdelay_en, UINT16 *grdyTable, UINT32 crc_in)
{
	UINT8 RetryCRC=5; // Diff_Cnt=0;
	UINT32 crc_out;
	UINT8 Sta_Value=_FAIL;
	//UINT32 bw=0,delay=0,EQ_FILTER=0;

	//setting
	drv_ifd_video_outputlpf_coef_update(output_en, outputTable);
	udelay(500);
	drv_ifd_video_outputlpf_en(output_en);
	drv_ifd_set_eq_coef(eqTable);
	udelay(500);
	drv_ifd_eq_en(eq_en);
	drv_ifd_grp_delay_en(grpdelay_en, grdyTable);
	udelay(500);

	//filter coefficent check
	if (output_en) drv_ifd_outputlpf_coef_check(outputTable);
	if (eq_en) drv_ifd_eq_coef_check(eqTable);
	if (grpdelay_en) drv_ifd_grpdelay_coef_check(grdyTable);

	//reset
	drv_ifd_soft_reset(1);
	udelay(500);

	//enable crc
	rtd_outl(IFD_108_CRC3_Ctrl_result_reg, 0x00000003);
	udelay(500);
	
	drv_ifd_soft_reset(0);
	udelay(500);

	do {
		crc_out=rtd_inl(IFD_108_CRC3_Ctrl_result_reg)>>4;
		if(crc_in==crc_out) break;
		udelay(500);
		IFD_QC_MSG( "[CRC108M] crc_in =0x%x, crc_out=0x%x\n",crc_in, crc_out);
		RetryCRC--;
    	}while(RetryCRC);

	//disable crc
	rtd_outl(IFD_108_CRC3_Ctrl_result_reg, 0x00000000);

	IFD_QC_MSG( "[CRC108M] eq_en=%d, output_en=%d, grpdelay_en=%d, crc_in =0x%x, crc_out=0x%x,",eq_en, output_en, grpdelay_en, crc_in, crc_out);

	if(RetryCRC>0)
	{
		Sta_Value =_SUCCESS;
		printk( " Pass !\n");
	}
	else
	{
		Sta_Value =_SUCCESS;
          	//Sta_Value =_FAIL;
		printk( " Fail !\n");
	}
	return  Sta_Value;

}

UINT8 CIFD_CRC_108M_Test_Case(void)
{

	UINT8  IFD_Value = _SUCCESS;
	UINT8 i, j, k,I=0,J=0,K=0;
	UINT8 Index_table[]={1,1,1,1};

	StructEQNotch EqTable[]=
	{
		{{
	              0x001, 0x3ff, 0x002, 0x3fe,
	              0x002, 0x3ff, 0x001, 0x000,
	              0x000, 0x001, 0x3ff, 0x002,
	              0x3fe, 0x001, 0x001, 0x3fe,
	              0x003, 0x3fe, 0x001, 0x000,
	              0x000, 0x001, 0x3ff, 0x004,
	              0x3fa, 0x009, 0x3fc, 0x3fd,
	              0x019, 0x3dd, 0x06e, 0x131,
	       	}},
	};
	StructOuputLpfCoef OuputLpfCoefTable[]=
	{
		{{
	              0x3FFF, 0x000A, 0x0019, 0x0002, 0x3FE6,
	              0x0003, 0x001A, 0x3FF1, 0x3FED, 0x001A,
	              0x0004, 0x3FE3, 0x0010, 0x0013, 0x3FE2,
	              0x0001, 0x001E, 0x3FE9, 0x3FF3, 0x0022,
	              0x3FF3, 0x3FE7, 0x0020, 0x0000, 0x3FDF,
	              0x001B, 0x000D, 0x3FDA, 0x0012, 0x0019,
	              0x3FDA, 0x0006, 0x0022, 0x3FDD, 0x3FFA,
	              0x002A, 0x3FE4, 0x3FED, 0x002D, 0x3FEE,
	              0x3FE1, 0x002E, 0x3FFA, 0x3FD6, 0x002B,
	              0x0007, 0x3FCD, 0x0024, 0x0016, 0x3FC8,
	              0x001A, 0x0025, 0x3FC5, 0x000D, 0x0033,
	              0x3FC7, 0x3FFD, 0x003F, 0x3FCC, 0x3FEB,
	              0x004A, 0x3FD6, 0x3FD7, 0x0051, 0x3FE4,
	              0x3FC2, 0x0055, 0x3FF7, 0x3FAD, 0x0053,
	              0x000F, 0x3F98, 0x004D, 0x002C, 0x3F84,
	              0x003F, 0x004F, 0x3F71, 0x0029, 0x007B,
	              0x3F60, 0x0007, 0x00B2, 0x3F52, 0x3FD2,
	              0x00FD, 0x3F46, 0x3F79, 0x0174, 0x3F3D,
	              0x3EC0, 0x027D, 0x3F38, 0x3C09, 0x0930,
	              0x148C,
	       	}},
	};
	StructGroupDelay GroupDelayTable[]=
	{
		{{
           	0x02A, 0x7E0, 0x7D7, 0x0E2, 0x2CF,
           	0x11F, 0x716, 0x01A, 0x0BF, 0x6A9,
           	0x14A, 0x717, 0x075, 0x7E6, 0x7E7,
           	0x02C, 0x7D4, 0x024, 0x7E5, 0x012,
           	0x7F6, 0x004, 0x000, 0x7FD, 0x004,
          	0x7FC, 0x003, 0x7FE, 0x001, 0x7FF,
           	0x000, 0x000, 0x000, 0x000,
		}},
	};
	#if 0
	UINT32 crc_table[]=
	{0xacef,0x4889,0x522,0xf54b,0x681,0xff68,0x9c0f,0x7301};
	#else
	UINT32 crc_table[]=
	{0x9648,0x3aff,0x342a,0xe0fb,0x1182,0xf80d,0x402,0x5480};
	#endif
	
	UINT8 eq_en[]=
       	{0,0,0,0,1,1,1,1};
	UINT8 output_en[]=
       	{0,0,1,1,0,0,1,1};
	UINT8 grpdelay_en[]=
	{0,1,0,1,0,1,0,1};
	UINT8 len, eq=0, opt=0, dely=0, crc=0;

	len=0.5*(sizeof(Index_table)/sizeof(UINT8));

	for(i=0;i<len;i=i+1)
	{
		for(j=0;j<len;j=j+1)
		{
			for(k=0;k<len;k=k+1)
			{
				eq=0;
				opt=0;
				dely=0;
				IFD_Value = CIFD_CRC_108M_New(eq_en[crc], EqTable[eq].EQNotch_Table, output_en[crc], OuputLpfCoefTable[opt].StructOuputLpfCoef_Table, grpdelay_en[crc], GroupDelayTable[dely].GroupDelay_Table, crc_table[crc]);
				if(IFD_Value==_FAIL) return _FAIL;
				crc++;
				K=K+2;
			}
			K=0;
			J=J+2;
		}
		J=0;
		I=I+2;
	}
	I=0;
	
	return _SUCCESS;
}

UINT8 CIFD_CRC_54M_New(UINT8 decimation_en, UINT8 shaping_image_sel, UINT8 shaping_bw_sel, UINT32 crc_in)//Return _SUCCESS or _FAIL
{
	UINT8 RetryCRC=5; // Diff_Cnt=0;
	UINT32 crc_out;
	UINT8 Sta_Value=_FAIL;
	
	//enable crc
	rtd_outl(IFD_108_CRC_Ctrl_register_reg , 0x0000004c);
	
	//settings
	drv_ifd_set_54to27_decimation_enable(decimation_en);
	drv_ifd_set_shaping_filter(shaping_bw_sel);
	drv_ifd_set_shaping_img(shaping_image_sel);

	//reset
	drv_ifd_soft_reset(1);
	udelay(100);
	drv_ifd_soft_reset(0);
	udelay(100);
	
	do {
		crc_out=rtd_inl(IFD_108_CRC2_result_reg);
		if(crc_in==crc_out) break;//Diff_Cnt++;
		udelay(500);
		IFD_QC_MSG( "[CRC54M] crc_in =0x%x, crc_out=0x%x\n",crc_in, crc_out);
		RetryCRC--;
    	}while(RetryCRC);

	//disable crc
	rtd_outl(IFD_108_CRC_Ctrl_register_reg , 0x00000000);

	IFD_QC_MSG( "[CRC54M] decimation_en=%d, shaping_image_sel=%d, shaping_bw_sel=%d, crc_in =0x%x, crc_out=0x%x,\n",decimation_en, shaping_image_sel,shaping_bw_sel, crc_in, crc_out);

	if(RetryCRC>0)
	{
		Sta_Value =_SUCCESS;
		printk( " Pass !\n");
	}
	else
	{
          	Sta_Value =_FAIL;
		printk( " Fail !\n");
	}
	return  Sta_Value;
}

UINT8 CIFD_CRC_54M_Test_Case(void)
{
	UINT8  IFD_Value = _SUCCESS;
	UINT8 i, j, k;
	UINT8 decimation_en_table[]={0x0, 0x1};
	UINT8 shaping_image_table[]={0x0, 0x1};
	UINT8 shaping_bw_table[]={0x0, 0x1};
#if 0
	UINT32 crc_table[]=
	{
		0x18a88ab7,0xa50d49b3,0x18a88ab7,0xd8dca173,
		0x18a88ab7,0xa50d49b3,0x18a88ab7,0xd8dca173,
	};
#else
	UINT32 crc_table[]=
	{
		0x2b103d68,0x6c97e48b,0x2b103d68,0xe1aaef4a,
		0x2b103d68,0x6c97e48b,0x2b103d68,0xe1aaef4a,
	};
#endif

	UINT8 len_i, len_j, len_k;
	len_i = sizeof(decimation_en_table)/sizeof(UINT8);
	len_j = sizeof(shaping_image_table)/sizeof(UINT8);
	len_k = sizeof(shaping_bw_table)/sizeof(UINT8);

	for(i=0;i<len_i;i++)
	{
		for(j=0;j<len_j;j++)
		{
			for(k=0;k<len_k;k++)
			{
				IFD_Value = CIFD_CRC_54M_New(decimation_en_table[i],shaping_image_table[j],shaping_bw_table[k], crc_table[i*len_k*len_j+j*len_k+k]);
				if(IFD_Value==_FAIL) return _FAIL;
			}
		}
	}
	return _SUCCESS;
}

UINT8 CIFD_CRC_FIFO_New(UINT32 crc_27mhz_FIFO ,UINT32 crc_49mhz_FIFO)
{
	UINT8 RetryCRC=5; // Diff_Cnt=0;
	UINT32 crc_out = 0;
	UINT32 crc1_out = 0;
	UINT8 Sta_Value=_FAIL;

	//enable crc
	rtd_outl(VD_IFD_INPUT_IFD_FIFO_CRC , 0x00000001);

	//reset
	drv_ifd_soft_reset(1);
	udelay(100);
	drv_ifd_soft_reset(0);
	udelay(100);

	do {
		crc_out=rtd_inl(IFD27_FIFO_CRC27_result_reg);
		crc1_out=rtd_inl(IFD49_FIFO_CRC49_result_reg);
		if((crc_27mhz_FIFO==crc_out)&&(crc_49mhz_FIFO==crc1_out)) break;//Diff_Cnt++;
		IFD_QC_MSG(  "[CRC_FIFO] IFD crc_27mhz_fifo =0x%x, crc_out=0x%x\n", crc_27mhz_FIFO, crc_out);
		IFD_QC_MSG(  "[CRC_FIFO] IFD crc_49mhz_fifo =0x%x, crc_out=0x%x\n", crc_49mhz_FIFO, crc1_out);
		udelay(500);
		RetryCRC--;
    	}while(RetryCRC);

	//disable CRC
	rtd_outl(VD_IFD_INPUT_IFD_FIFO_CRC , 0x00000000);

	IFD_QC_MSG( "[CRC_FIFO] crc_fifo27_in=%x, crc_fifo27_out=0x%x, crc_fifo49_in=%x, crc_fifo49_out =0x%x,\n",crc_27mhz_FIFO, crc_out, crc_49mhz_FIFO, crc1_out);

	if(RetryCRC>0)
	{
		printk( " Pass !\n");
		Sta_Value =_SUCCESS;
	}
	else
	{
		printk( " Fail !\n");
		Sta_Value =_FAIL;
	}
	
	return  Sta_Value;
	
}

UINT8 CIFD_CRC_FIFO_Test_Case(void)
{

	UINT8  IFD_Value = _SUCCESS;
	//UINT8 len_i, len_j, len_k;
	UINT32 crc_27mhz_FIFO=0x6ef2;
	UINT32 crc_49mhz_FIFO=0xc85b;
	
	IFD_Value = CIFD_CRC_FIFO_New(crc_27mhz_FIFO,crc_49mhz_FIFO);
	if(IFD_Value==_FAIL) return _FAIL;

	return _SUCCESS;
}

UINT8 CIFD_QC_CRC_Verify(void)
{
       IFD_QC_MSG_INFO("*==IFD CIFD_QC_CRC_Verify==*\n");

	UINT8 Crc_Bit0=_FAIL, Crc_Bit1=_FAIL, Crc_Bit2=_FAIL;

	Crc_Bit0 = CIFD_CRC_54M_Test_Case();
	//Crc_Bit1 = CIFD_CRC_108M_Test_Case();
	Crc_Bit1 = _SUCCESS;
	//Crc_Bit2 = CIFD_CRC_FIFO_Test_Case();
	Crc_Bit2 = _SUCCESS;

	if((Crc_Bit0==_SUCCESS)&&(Crc_Bit1==_SUCCESS)&&(Crc_Bit2==_SUCCESS))
	{
	    	return _SUCCESS ;
	}
	else
	{
		IFD_QC_MSG_WARNING("CRC verify fail ... crc_54=%d, crc_108=%d, crc_fifo=%x\n",Crc_Bit0,Crc_Bit1, Crc_Bit2);
	    	return _FAIL;
	}

}
#endif
UINT8 CIFD_QC_ATSC3_Verify(void)
{
	IFD_QC_MSG_INFO( "*==IFD ATSC3.0 I2C Verify==*\n");
	if (I2Ccontest() == FUNCTION_ERROR)
		return FUNCTION_ERROR;
	else
	{
		ADCdumpSNR();
		//ADCdumpIDNL();
	}
		return FUNCTION_SUCCESS;
}

#ifdef Test_IFD_QC_TunerIfdFreq_Verify
UINT8 CIFD_QC_TunerIfdFreq_Verify(void)
{
       IFD_QC_MSG_INFO( "*==IFD CIFD_QC_TunerIfdFreq_Verify==*\n");

	UINT8  RetryCheck=RF_FREQ_NUM;
	UINT8 afc=0, i, j,result=0;
	UINT32 curr_freq=0;
	INT32 offset = 0;
	UINT8 delay_cnt;
	UINT8 cr_count_thr=5;
	UINT8 cr_count=100;
	UINT8 AScan_Noise_stas = 0;
	UINT8 HVlock = 0;
	UINT32 maxout=0;

	//clear status
	for (i=0;i<RF_FREQ_NUM;i++) rf_status[i]=0;
	do
	{
		curr_freq =rf_freq[RF_FREQ_NUM-RetryCheck];
		IFD_QC_MSG_INFO( "FreqHz = %dHz\n",curr_freq*100);

		drv_ifd_soft_reset(1);
		udelay(100);
		drv_ifd_soft_reset(0);
		udelay(100);

		drv_ifd_set_video_ntsc();
		drvif_vdc_ifd_path_setting(1);
		pTuner->SetRfFreqHz(pTuner, curr_freq);
		udelay(500);

		j=0;
		for(delay_cnt=0;delay_cnt<=cr_count;delay_cnt++)
		{
			udelay(1000);
			IFD_QC_MSG("CR lock = %d, %dth\n", drv_ifd_get_cr_lock_status(), delay_cnt+1);
			if(drv_ifd_get_cr_lock_status()==_TRUE)
			{
				j++;
				if (j>=cr_count_thr) break;
			}
		}

		if(j<cr_count_thr)
		{
			IFD_QC_MSG_WARNING("CR unlock with frequency=%d\n",curr_freq);
			rf_status[RF_FREQ_NUM-RetryCheck]=0;
		}
		else
		{
			offset = drv_ifd_get_cr_offset_100hz(afc);
			if(offset!=0)
			{
				curr_freq  = curr_freq + offset;
				pTuner->SetRfFreqHz(pTuner, curr_freq);
				udelay(500);
			}
			IFD_QC_MSG("CR lock with frequency=%d, offset=%d\n",curr_freq, offset);
			rf_status[RF_FREQ_NUM-RetryCheck]=1;
		}
	}while(--RetryCheck);

	for (i=0;i<RF_FREQ_NUM;i++)
	{
		result=result+rf_status[i];
	}
	drv_ifd_vd_reset();
	udelay(100000);
	// Check HV
	if (result==RF_FREQ_NUM)
	{
		IFD_QC_MSG_WARNING("Tuner IF CR locks\n");
		return _SUCCESS;
		for(i=0;i<VIDEO_TEST_TIME;i++)
		{
			//clear
			AScan_Noise_stas = 0;
			HVlock = 0;

			udelay(1000);
			maxout=rtd_inl(IFD_108_agc_max_status_reg)&0x7ff;
			AScan_Noise_stas = (drv_ifd_vd_get_noise_status()&0xff);
	    		HVlock = drv_ifd_vd_check_hvlock();
	    		printk("Max=%x; Noise status=%x; Lock status=%x; %dth\n" ,maxout, AScan_Noise_stas, HVlock, i+1);
			
			if(HVlock == 1)
				break;
			}

		if(HVlock == 1)
		{
			IFD_QC_MSG("Tuner IF CR lock and HV lock, verify ok\n");
			return _SUCCESS;
		}
		else if (HVlock == 0)
			{
				IFD_QC_MSG_WARNING("Tuner IF CR lock but HV unlock verify fail\n");
				return _FAIL;
			}
		}
	else
	{
		IFD_QC_MSG_WARNING("Tuner IF CR unlock, verify fail\n");
		return _FAIL;
	}

}
#endif

#ifdef Test_IFD_QC_Gain_Verify
UINT32 CIFD_QC_Count_if_output(void)
{
	//INT8 RetryCheck=0,delay_cnt=0;
	//UINT32 curr_freq;
	UINT32 if_gain;
	UINT32 if_gain_sum=0;
	UINT32 if_gain_ave[2]={0};
	UINT32  per_if_gain_ave=0;
	//UINT32 rf_full[3]={0};
	//UINT32 rf_max=0;
	//INT32 PGA_gain[2]={0};
	INT8 i=1; //situation=0;
		if_gain_sum=0;

		for(i=1;i<=GAIN_TEST_TIME;i++)
		{
			udelay(50);

			if_gain= drv_ifd_agc_get_if_output();

   			if_gain_sum = if_gain + if_gain_sum;


			IFD_QC_MSG("IFD the %dth if_gain_sum =%x  \n", i,if_gain_sum);
			IFD_QC_MSG("IFD the %dth if_gain =%x  \n",i, if_gain);


		}
		if_gain_ave[0]=if_gain_sum>>GAIN_AVG_SHIFT;//depend on max
		per_if_gain_ave=if_gain_ave[0];
		IFD_QC_MSG("IFD if gain ave[0]=%x\n",if_gain_ave[0]);

		return per_if_gain_ave;

}

UINT8 CIFD_QC_Gain_Verify(void)
{
       IFD_QC_MSG_INFO( "*==IFD CIFD_QC_Gain_Verify==*\n");

	UINT8 RetryCheck=0; // delay_cnt=0;
	//UINT32 curr_freq;
	//UINT32 if_gain;
	//UINT32 if_gain_sum=0;
	UINT32 if_gain_ave=0;
	UINT32  per_if_gain_ave=0,max_output=0;
	//UINT32 rf_full[3]={0};
	//UINT32 rf_max=0;
	//INT32 PGA_gain[2]={0};
	//INT8 i=1,situation=0;

	do{
		//Calculate RF/IF gavg gain
		per_if_gain_ave=CIFD_QC_Count_if_output();
		IFD_QC_MSG("per_if_gain_ave =%x  \n",per_if_gain_ave);

		//clear sum
		//if_gain_sum=0;
		if((per_if_gain_ave<0xf00)&&(per_if_gain_ave>0x650))
		{
			drv_ifd_agc_targ_val(0x400);
			if_gain_ave=CIFD_QC_Count_if_output();
			IFD_QC_MSG("the signal is normal , the if max target is rise ,then the  per_if_gain_ave =%x  \n",per_if_gain_ave);
			IFD_QC_MSG("the signal is normal , the if max target is rise ,then the  if agc =%x  \n",if_gain_ave);
			if(if_gain_ave>per_if_gain_ave)
			{
				IFD_QC_MSG("Gain_Verify : the signal is normal , the if max target is rise ,the test is ok\n");
				drv_ifd_agc_targ_val(GET_IFD_AGCLOOP1_MAXTARGET_NTSC());
				return _SUCCESS;
			}
			else
			{
				IFD_QC_MSG_WARNING("Gain_Verify : the signal is normal , the if max target is rise ,the test is fail\n");
				drv_ifd_agc_targ_val(GET_IFD_AGCLOOP1_MAXTARGET_NTSC());
				return _FAIL;
			}
		}

		if((per_if_gain_ave==0xf00))
		{
			max_output=rtd_inl(IFD_108_agc_max_status_reg);
			drv_ifd_agc_targ_val(max_output/2);
			if_gain_ave=CIFD_QC_Count_if_output();
			IFD_QC_MSG("the signal is normal , the if max target is weak ,then the  per_if_gain_ave =%x  \n",per_if_gain_ave);
			IFD_QC_MSG("the signal is normal , the if max target is weak ,then the  if agc =%x  \n",if_gain_ave);
			if(per_if_gain_ave>if_gain_ave)
			{
				IFD_QC_MSG("Gain_Verify : the signal is normal , the if max target is weak ,the test is ok\n");
				drv_ifd_agc_targ_val(GET_IFD_AGCLOOP1_MAXTARGET_NTSC());
				return _SUCCESS;
			}
			else
			{
				IFD_QC_MSG_WARNING("Gain_Verify : the signal is normal , the if max target is weak ,the test is fail\n");
				drv_ifd_agc_targ_val(GET_IFD_AGCLOOP1_MAXTARGET_NTSC());
				return _FAIL;
			}
		}
		RetryCheck++;
	}while(RetryCheck<GAIN_FREQ_NUM);
        return 0;
}
#endif

#ifdef Test_IFD_QC_AudioPerFoms_Verify
UINT8 CIFD_QC_AudioPerFoms_Verify(void)
{
	UINT32 Check_SoundCarrier_Energy[2]={0}, maxout;
	UINT8 ierr=0;

	IFD_QC_MSG_INFO( "*==IFD CIFD_QC_AudioPerFoms_Verify==*\n");
	drv_ifd_audio_initial();
	rtd_maskl(0xb8006198,0xfffff00f,0x170);
	drv_ifd_agc_targ_val(GET_ATV_IFD_AGCLOOP1_MAXTARGETNTSC());  // modified gain traget after QC gain verify
	
redo:
	udelay(100000);
	if(drv_ifd_get_cr_lock_status()==_TRUE)
	{
		maxout=rtd_inl(IFD_108_agc_max_status_reg)&0x7ff;
		udelay(100000);
		Check_SoundCarrier_Energy[0]=rtd_inl(AUDIO_MSD_MAG_4_5_VADDR);
		IFD_QC_MSG( "[AUDIO][0x%x] SoundCarrier Energy status=0x%x\n",maxout, Check_SoundCarrier_Energy[0]);
		udelay(100000);
		Check_SoundCarrier_Energy[1]=rtd_inl(AUDIO_MSD_MAG_4_5_VADDR);
		IFD_QC_MSG( "[AUDIO][0x%x] SoundCarrier Energy status=0x%x\n",maxout, Check_SoundCarrier_Energy[1]);

		if((Check_SoundCarrier_Energy[0]>0x1000)||(Check_SoundCarrier_Energy[1]>0x1000))
		{
			return _SUCCESS;
		}
		else
		{
			if (ierr<10)
			{
		 		ierr++;
				goto redo;
			}
		}
		IFD_QC_MSG_WARNING( "[AUDIO] AudioPerFoms Verify fail -- Audio Tone small\n");
		return _FAIL;
	}
	else
	{
		IFD_QC_MSG_WARNING( "[AUDIO] AudioPerFoms Verify fail -- CR unlock\n");
		return _FAIL;
	}
}
#endif

int CDEMOD_TO_TP_Test(void)
{
	return _SUCCESS;	
}


UINT8 CDEMOD_QC_VERIFY(void)
{
	return _SUCCESS;
}

UINT8 CIFD_QC_VERIFY(void)
{

	int IFD_result = 1;
	IFD_QC_MSG("*** ATV Demod QC Verify test start -- QC *** \n\n");

	//initial IFD
	drv_ifd_pinshare();
	drvif_ifd_init();
	pTuner->Initialize(pTuner);
	//EQC test
	#ifdef Test_IFD_QC_CRC_Verify
	if(CIFD_QC_CRC_Verify()!=_FAIL)
	{
		IFD_QC_MSG_INFO("*==IFD CRC QC Verify Success==* \n\n");
	}
	else
	{
		IFD_QC_MSG_INFO("*==IFD CRC QC Verify fails==* \n\n");
		IFD_result = 0;
	}
	#endif
	
	#ifdef Test_IFD_QC_TunerIfdFreq_Verify
	if(CIFD_QC_TunerIfdFreq_Verify()!=_FAIL)
	{
		IFD_QC_MSG_INFO("*==IFD TunerIfdFreq QC Verify Success ==*\n\n");
	}
	else
	{
		IFD_QC_MSG_INFO("*==IFD TunerIfdFreq QC Verify fail ==*\n\n");
		IFD_result = 0;
	}
	#endif
    
	#ifdef Test_IFD_QC_ATSC3_I2Creadwrite_Verify
    if (IsAtsc3McmPackage() == 0)
	{
		IFD_QC_MSG_INFO("This is not MCM package!!\n");
	}
	else 
	{
		if (CIFD_QC_ATSC3_Verify() == 0)
		{
			IFD_QC_MSG_INFO("*==IFD ATSC3 QC Verify Success==* \n\n");
		}
		else
		{
			IFD_QC_MSG_INFO("*==IFD ATSC3 QC Verify fails==* \n\n");
			IFD_result = 0;
		}
		
	}
	#endif 
	
	if (IFD_result == 0)
		goto IFD_tst_Open_fail;

	#ifdef Test_IFD_QC_Gain_Verify
	if(CIFD_QC_Gain_Verify()!=_FAIL)
	{
		IFD_QC_MSG_INFO("*==IFD Gain QC Verify Success ==*\n\n");
	}
	else
	{
		IFD_QC_MSG_INFO("*==IFD Gain QC Verify fail ==*\n\n");
		goto IFD_tst_Open_fail;
	}
 	#endif

	#ifdef Test_IFD_QC_AudioPerFoms_Verify
	if(CIFD_QC_AudioPerFoms_Verify()!=_FAIL)
	{
		IFD_QC_MSG_INFO("*==IFD Audio Performanc QC Verify Success==* \n\n");
	}
	else
	{
		IFD_QC_MSG_INFO("*==IFD Audio Performanc QC Verify fail==* \n\n");
		goto IFD_tst_Open_fail;
	}
	#endif
		

	return _SUCCESS;

IFD_tst_Open_fail:
	
       return _FAIL;
}

int QC_Verifier_IFD(void)
{   
    	int ret=_SUCCESS;
		
	#if 0//loop
	
	int ii=LOOP,r=_FAIL;
	while(ii)
	{
		printk("\n\n\n\n*==QC verify=%d times==*\n",(LOOP-ii+1));
		ii--;
		//r=CIFD_QC_VERIFY();
        	r=CDEMOD_QC_VERIFY();
        	if(r==_FAIL) break;
	}
	
	#else// 1 time
	
    	if(CDEMOD_QC_VERIFY()==_FAIL)
	{
        	ret = _FAIL;
		printk("Ddemod Verifier is fail\n");
	}
	if(CIFD_QC_VERIFY()==_FAIL)
	{
        	ret = _FAIL;
		printk("Ademod Verifier is fail\n");
	}
    	if(ret==_FAIL)
	{
	 	printk("Demod Verifier is fail\n");
		return _FAIL;
	}
    	else
    	{
        	printk("Demod Verifier is Ok\n");
		return _SUCCESS;
    	}
		
	#endif
}
