#include "IFD_qc.h"

void drv_ifd_analog_preset(void)
{ 	
	//Module Reset/Clock Control All turn on
	//************Reset bit*****************//
	rtd_outl(0xb8000100, 0xfff823ff);
	rtd_outl(0xb8000104, 0xfbf1bfff);
	rtd_outl(0xb8000108, 0xbffddf3f);
	rtd_outl(0xb800010C, 0xfcc07eff);
	//************Clock enable bit*********//
	rtd_outl(0xb8000110, 0xbdf821ff);
	rtd_outl(0xb8000114, 0xfbdfbffd);
	rtd_outl(0xb8000118, 0xbffddf7f);
	rtd_outl(0xb800011C, 0xfcc0e3c1);
	
	IfdMbiasPowAndAdcPow();                 
    CRT_CLK_TVALL_OFF();                      //Turn off TVALL
	DemodPllDefault();
	DemodPllSetting();
    ScalerTimer_DelayXms(1);                  //delay 50uS
    DemodAdcDefault();
	DemodAdcSetting();
	ScalerTimer_DelayXms(1);                  //delay 50uS
	CRT_CLK_TVFRONTED_ON();                   //Turn on TV Frontend
	CRT_CLK_ATVDEMOD_ON();                    //Turn on ATVDemod
	ScalerTimer_DelayXms(1);                  //delay 50uS
	DemodFrontendPathSetting();
	others();
	return;
}
void IfdMbiasPowAndAdcPow(void)
{
    //1. CRT_CLK_OnOff(TVADC, CLK_ON, NULL);					//Turn on CLKEN_IFADC
	rtd_outl(0xb8000114, 0x00008001);							//<bit15>CLKEN_IFADC, set to 1
	rtd_outl(0xb8000104, 0x00008001);							//<bit15>RSTN_IFADC, set to 1(Release)
	ScalerTimer_DelayXms(1);									//delay 50uS

	//2. MBIAS and PLL_LDO Power turn on
	rtd_maskl(0xb8033100, 0xfffeffff, 0x00010000);  			//<bit16>REG_POW_MBIAS turn on
	ScalerTimer_DelayXms(1);									//delay 50uS
	rtd_maskl(0xb80004d4, 0xffffbbff, 0x00004400);  			//<bit14>PLL_POW_LDO11V, <bit10>PLL_POW_LDO turn on
	ScalerTimer_DelayXms(1);									//delay 50uS

	//3. turn Off ADC/PGA power
	rtd_maskl(0xb8033104,0xfeffffff, 0x00000000);				//IQADC input cm power off <bit24> = 0  
	rtd_outl(0xb8033124,0x00000000);							//PGA/ADC Power Off
	ScalerTimer_DelayXms(1);									//delay 50uS
}
void CRT_CLK_TVALL_OFF(void)
{
	// turn off Demod IP
	//CRT_CLK_OnOff(TVALL, CLK_OFF, NULL);        				//Turn off TVALL
	//ATV turn off	
	rtd_outl(0xb8000104, 0x00800000);							//RSTN_IF_DEMOD<bit23> set to 0(active low)
	rtd_outl(0xb8000108, 0x00400000);							//RSTN_IF_DEMOD_logic<bit22> set to 0(active low)
	rtd_outl(0xb8000114, 0x00800000);							//CLKEN_IF_DEMOD<bit23> set to 0(CLK off)
	ScalerTimer_DelayXms(1);									//driver delay 1mS

	//DTV Demod IP reset
	rtd_outl(0xb8000100, 0x01182000);							//Demod IP Reset<bit24, bit20, bit19, bit13> set to 0(active low)
	rtd_outl(0xb8000108, 0x00000800);							//Demod IP Reset<bit11> set to 0(active low)
	ScalerTimer_DelayXms(1);									//driver delay 1mS

	//DTV Demod Wrapper reset
	rtd_outl(0xb8000100, 0x80e00000);							//Demod IP Reset<bit31, bit23, bit22, bit21> set to 0(active low)
	rtd_outl(0xb8000104, 0x00000002);							//RSTN_dtv_demod_mb<bit2> set to 0(active low)
	ScalerTimer_DelayXms(1);									//driver delay 1mS

	//DTV Demod turn off
	rtd_outl(0xb8000110, 0x81d82000);							//Demod CLK<bit31, bit24, bit23, bit22, bit20, bit19, bit13> set to 0
	rtd_outl(0xb8000118, 0x00000800);							//CLKEN_DTV_DEMOD<bit11> set to 0
	ScalerTimer_DelayXms(1);									//driver delay 10uS

}
void DemodPllDefault(void)
{
	//Merlin5 register default setup 
	rtd_outl(0xb80004c4,0x00000000);				//DTV PLLDIF PLLDIF_DIVDIG_SEL = 000(2), PLLDIF_DIVADC_SEL = 00(divide by 8)
	rtd_outl(0xb80004d0,0x0224000e);				//PLL27X, LFP Setting, M<10>+2=14(VCO=432M)
	rtd_outl(0xb80004d4,0x00086521);				//<bit23:21>VDD11_PAD_SEL = 0x0,<bit20:19>PLL_LDO_XTAL_SEL=0x1(1.76V),<bit8:9>PLL_LDO_SEL=0x1(0.952V)
													//<bit5:4>PLL27X_PS_54M_DELAY=0x2(VCO=432M),<bit0>PLL27X_PS_DUTY_SEL = larger duty cycle
	rtd_outl(0xb80004d8,0x00000004);				//Default setting, <bit2>PLL27X_VCORSTB=0x1(normal), <bit1>PLL27X_RSTB=0x0(Active Reset), <bit0>PLL27X_POW=0x0(Off).
	rtd_outl(0xb80004dc,0x4001c001);				//Default ATV mode, <bit30:29>PLL27X_IFADC_DUTY=0x2,<bit17:16>PLL27X_CK108M_DIV=0x1(DIV=4;VCO=432M) PLL27X setting,<bit0>PLL_CK_IFADC_MUX=0x0(ATV mode)
	rtd_outl(0xb8000514,0x00000009);				//<bit3>PLL27x 108M clk to digital=0x1(enable), <bit0>write bit used
	rtd_outl(0xb8000500,0x0000041c);				//<bit11:10>PLL27X_IFADC_CK108M_DIV=0x1(VCO=432M),<bit4>PLL27X_IFADC_DTV_CKO_EN=0x1(enable),<bit3:2>PLL27X_IFADC_ATV_CKO_SEL=0x3(135M or 162M (depend on VCO and REG_PLL27x_IFADC_DIV))
	rtd_outl(0xb8000504,0x000e0224);				//PLL27X_IFADC VCO M,N, M<10>+2�P=14(VCO=432M)
	rtd_outl(0xb8000508,0x00000000);				//PLL27X_IFADC Poweroff and VCORSTB reset
	ScalerTimer_DelayXms(1);						//delay 10uS

	//PLL27X
	rtd_maskl(0xb80004d8, 0xffff00f0, 0x00000104);// <bit15:8>PLL_RESERVE=1(ADC CLK From PLLDIF),<bit2>PLL27X_VCORSTB=0x1(normal), <bit1>PLL27X_RSTB=0x0(Active Reset), <bit0>PLL27X_POW=0x0(Off).
	rtd_maskl(0xb80004dc, 0xfdfffffe, 0x02000000);	//Set PLL_L2H_CML_POW<bit25> = enable(0x1) and MUX to DTV Mode<bit0>=0x0

	//PLL27X_IFADC
	rtd_maskl(0xb8000500, 0xfffffff3, 0x0000000C);	//PPLL27X_IFADC_DTV_CKO_SEL = 00(/3), PLL27X_IFADC_ATV_CKO_SEL = 11 (135M or 162M (depend on VCO and REG_PLL27x_IFADC_DIV).
	rtd_maskl(0xb8000508, 0xfffffff8, 0x00000007);	//IFADC, RSTB and VCORSTB Power on
}
void DemodPllSetting(void)
{
	//ATVIN_CLK_SEL, ATV Input clock select
	rtd_maskl(0xb8000204,0xFFFCFFFF,0x00000000);				//[17]ATVIN_CLK_SEL, [16]ATVIN_VD_CLK_SEL

	//ATV System CLK=108MHz, VCO=432MHz
	rtd_outl(0xb80004d0, 0x0224000e);           				//VCO = M<6:0>14+2 = 16, N:00=1, 27 /1 *16=432MHz,[9:8]PLL27X_N = 0(1), [6:0]PLL27X_M = 0xe(14)
	rtd_outl(0xb80004d4, 0x000f6521);							//[18]PLL_XIXO_LOAD=0, [17:16]PLL_XIXO_DRIVE_SEL=0x3,[5:4]PLL27X_PS_54M_DELAY=0x2(VCO=432M)
	rtd_outl(0xb80004dc, 0x4201c001);           				//[30:29]PLL27X_IFADC_DUTY=0x01(vco/4), [25]PLL_L2H_CML_POW=0x1, [17:16]PLL27X_CK108M_DIV=0x1(vco=432M), 
																//[11:10]PLL27X_IFADC_CKO_SEL=0x11(162M),[9]PLL27X_IFADC_DIV=0x0(divide 4), [0]PLL_CK_IFADC_MUX=0x1(ATV mode)
	rtd_outl(0xb8000514, 0x0000000b);							//[3]PLL27x 108M clk to digital=0x1, [1]PLL27X_PS_EN=0x1(PLL27x phase swallow enable), [0]write_bit(1 to set, 0 to clear)
	rtd_maskl(0xb80004dc, 0xFDFFFFFE, 0x02000001);
	rtd_maskl(0xb80004d8, 0xFFFF00FF, 0x00000100);

	//PLL27X Power On
	rtd_outl(0xb80004d8, 0x00000000);   						//PLL27X_VCORSTB[2], 1:normal, 0:reset; PLL27X_RSTB[1], 1:normal, 0:reset; PLL27X_POW[0], 0:power down, 1:power on
	rtd_outl(0xb80004d8, 0x00000006);							//[2]PLL27X_VCORSTB = 0x1, [1]PLL27X_RSTB = 0x1, Reset release 
	rtd_outl(0xb80004d8, 0x00000007);							//[0]PLL27X_POW =0x1, turn on PLL27X_POW

	//ATV ADC CLK=108MHz, VCO=432MHz, VCO and DIV setting//
	rtd_maskl(0xb8000500, 0xFFFFF3E2, 0x00000418);				//[11:10]PLL27X_IFADC_CK108M_DIV=0x3(VCO=648M),[4]PLL27X_IFADC_DTV_CKO_EN=0x1(enable),[3:2]PLL27X_IFADC_ATV_CKO_SEL=0x11(162M), [0]PIP_IFADC_ATV_CKO_SEL=0x0(PLL27x_IFADC)		
	rtd_maskl(0xb8000504, 0xFC80FFF8, 0x000E0004);				//VCO = M<6:0>+2 = 22+2, N:00=1, 27 /1 *24=648MHz, PLL27X_IFADC_M<bit22:16> = 0x16(22), PLL27X_IFADC_N<bit25:24>=0x0(1), 
																//PLL27X_IFADC PUMP current<bit2:0>=0x4(0x100:25uF)
	rtd_outl(0xb80004b8, 0x00024200);							//<bit17>ATVADCDIV_RSTB=0x1(normal), <bit14>DIF216M_DIV=0x1(div3), <bit9>PLL27X_IFADC_ATV_CKO_EN=0x1, <bit2>PLL27X_IFADC_REF_SEL=0(XTAL)
																
	//PLL27X_IFADC power On															
	ScalerTimer_DelayXms(1);									//Driver delay 50uS
	rtd_maskl(0xb8000508, 0xfffffff8, 0x00000000);  			//<2:1>PLL27X_IFADC_VCORSTB, PLL27X_IFADC_RSTB reset = 0(Reset); <0>PLL27X_IFADC_POW turn off
	rtd_maskl(0xb8000508, 0xfffffffe, 0x00000001);  			//<0>PLL27X_IFADC_POW turn On
	rtd_maskl(0xb8000508, 0xfffffff9, 0x00000006);  			//<2:1>PLL27X_IFADC_VCORSTB, PLL27X_IFADC_RSTB reset = 1(release)
	ScalerTimer_DelayXms(5);                             			//delay 10mS
}
void DemodAdcDefault(void)
{
	//Merlin5 ADC register default
	rtd_outl(0xb8033100,0x00010502);					//<bit16=1>IFD MBIAS power on,<bit11:10>REG_I_VCM_SEL=0x1(0.632V),<bit9:8>ADC2X_BG_SEL= 0x1(1.216V),  <bit7:0>REG_IFD_RESERVED=0x02(10u PGA IB20U select)  
	rtd_outl(0xb8033104,0x00000340);					//<bit24>IQADC input cm power off, <bit9:8>REG_IPGA_BW=0x1(75M), <bit6:4>REG_IFCMP_ISEL=0x4(50uF) 
	rtd_outl(0xb8033118,0x30200010);					//<bit30:28>IQ ADC calibration input swing=0x11, <bit21:20>REG_IQ_CAL_DIV=0x10, REG_CKOUT_SEL_Q: the default is "1:I_CKOUT" on AIF spec
	rtd_outl(0xb8033120,0x00040000);					//<bit18:16>REG_IQCAL_ISEL=0x100(50uA), IF ADC GAIN FIX EN <bit0> = 0(SIF mode)
	rtd_outl(0xb8033124,0x00000000);					//PGA/ADC Power Off
	rtd_outl(0xb8033128,0x00100022);					//<bit21:20>REG_QPGA_BW=0x1(75M), Default setting(10=20uA), IQ PGA CURRENT  select
		
	//IFADC+IFPGA power on
	//rtd_maskl(0xb8033104, 0xfefffcff, 0x00000100);	//REG_ADC2X_DIFPOW, IFADC input cm power set to off(b24)=0x0, IPGA_BW<bit9:8>=0x01(75M)
	rtd_maskl(0xb8033124, 0xfffffefe, 0x00000101);		//I_PGA<bit8> power on, <bit0>I_ADC power on
	rtd_maskl(0xb8033128, 0x8ff8ffff, 0x00020000);		//<bit30:28>REG_QPGA_INPUT_SEL=0x0(No input),<bit18:16>REG_IPGA_INPUT_SEL=0x2(IFD input)

	//IQADC+IQPGA power on
	rtd_outl(0xb803312C,0x00000400);					//default setting, <bit11:10>REG_Q_VCM_SEL=0x1(0.632V)
	rtd_outl(0xb8033130,0x88004000);					//default setting, <bit31:30>REG_QADC_I_VREF_SEL=0x1(1.0X),<bit27:26>REG_IADC_I_VREF_SEL=0x1(1.0X),<bit15:14>REG_QADC_LDO0_SEL=0x1(1.3V)
	rtd_outl(0xb8033134,0x11000091);					//default setting, <bit29:28>REG_QADC_VREF_SEL=0x1(1.4V), <bit25:24>REG_IADC_VREF_SEL=0x1(1.4V), <bit8:7>REG_IADC_LDO0_SEL=0x1(1.3V)
														//<bit6:4>REG_QADC_LDO_SEL=0x1(0.961V), <bit2:0>REG_IADC_LDO_SEL=0x1(0.961V)
	//Set IPGA/QPGA GAIN = 0dB
	rtd_maskl(0xb8033120, 0xfffffffe, 0x00000001);		//IF ADC GAIN FIX EN <bit0>= 1(Internal Demod IQ mode)
	rtd_maskl(0xb803312c, 0xffeecc00, 0x00000000);		//<bit20>Q single_end=0x0, <bit16>I single_end=0, <bit13:12>Q_CKIN_Sel=00(from PLL27x_IFADC), <bit9:8>I_CKIN_Sel=00: From PLL27X_IFADC, 
														//<bit7:4>reg_qpga_d=0x0(0dB), <bit3:0>reg_ipga_d=0x0(0dB)
}
void DemodAdcSetting(void)
{
	//ATV mode, set PLL27X_IFADC_DUTY and ATVADCDIV_RSTB toggle flow 
	rtd_maskl(0xb80004b8, 0xfffffdff, 0x00000000);				//<bit9>PLL27X_IFADC_ATV_CKO_EN = 0x0(turn off)
	rtd_maskl(0xB80004dc, 0x9fffffff, 0x40000000); 				//<30:29>PLL27X_IFADC_DUTY setup
	rtd_maskl(0xb80004b8, 0xfffdffff, 0x00000000);				//<bit17>ATVADCDIV_RSTB = 0x0(active reset)
	rtd_maskl(0xb80004b8, 0xfffdffff, 0x00020000);				//<bit17>ATVADCDIV_RSTB = 0x1(release reset)
	rtd_maskl(0xb80004b8, 0xfffffdff, 0x00000200);				//<bit9>PLL27X_IFADC_ATV_CKO_EN = 0x1(turn on)
	ScalerTimer_DelayXms(5);									//delay 5mS

	//CRT_CLK_OnOff(TVFRONTEND, CLK_ON, NULL);					//Turn On ATV and Frontend
	//rtd_outl(0xb8000110, 0x00480001);							//<bit22>Clken_dtv_demod_mb, <bit19>CLKEN_dtv_frontend,  set to 1
	//rtd_outl(0xb8000110, 0x00480000);							//<bit22>Clken_dtv_demod_mb, <bit19>CLKEN_dtv_frontend, set to 0
	rtd_outl(0xb8000100, 0x00080001);							//<bit19>RSTN_dtv_frontend,  set to 1(release)
	rtd_outl(0xb8000104, 0x00000003);							//<bit1>RSTN_dtv_demod_mb,  set to 1(release)
	rtd_outl(0xb8000110, 0x00480001);							//<bit22>Clken_dtv_demod_mb, <bit19>CLKEN_dtv_frontend,  set to 1
	ScalerTimer_DelayXms(1);									//Driver delay 50uS
}
void CRT_CLK_TVFRONTED_ON(void)
{
	//CRT_CLK_OnOff(TVFRONTEND, CLK_ON, NULL);					//Turn On ATV and Frontend
	//rtd_outl(0xb8000110, 0x00480001);							//<bit22>Clken_dtv_demod_mb, <bit19>CLKEN_dtv_frontend,  set to 1
	//rtd_outl(0xb8000110, 0x00480000);							//<bit22>Clken_dtv_demod_mb, <bit19>CLKEN_dtv_frontend, set to 0
	rtd_outl(0xb8000100, 0x00080001);							//<bit19>RSTN_dtv_frontend,  set to 1(release)
	rtd_outl(0xb8000104, 0x00000003);							//<bit1>RSTN_dtv_demod_mb,  set to 1(release)
	rtd_outl(0xb8000110, 0x00480001);							//<bit22>Clken_dtv_demod_mb, <bit19>CLKEN_dtv_frontend,  set to 1
	ScalerTimer_DelayXms(1);									//Driver delay 50uS
}
void CRT_CLK_ATVDEMOD_ON(void)
{
	//AtvDemodPowerControl(1) turn on AtvDemod
	//rtd_outl(0xb8000114, 0x00800001);							//<bit23>CLKEN_IF_DEMOD, <bit0>write bit(1)
	//rtd_outl(0xb8000114, 0x00800000);							//<bit23>CLKEN_IF_DEMOD, <bit0>write bit(0)
	rtd_outl(0xb8000104, 0x00800001);							//<bit23>RSTN_IF_DEMOD, <bit0>write bit(1) Reset release 
	rtd_outl(0xb8000114, 0x00800001);							//<bit23>CLKEN_IF_DEMOD, <bit0>write bit(1)
	ScalerTimer_DelayXms(1);									//Driver delay 10uS
	//rtd_outl(0xb8000118, 0x04000001);							//<bit26>CLKEN_ATVIN_IFD, <bit0>write bit(1)
	//rtd_outl(0xb8000118, 0x04000000);							//<bit26>CLKEN_ATVIN_IFD, <bit0>write bit(0)
	rtd_outl(0xb8000108, 0x0c400001);							//<bit27>RSTN_ATVIN2, <bit26>RSTN_ATVIN1, <bit22>RSTN_IF_DEMOD_logic, <bit0>write bit(1) Reset release 
	rtd_outl(0xb8000118, 0x04000001);							//<bit26>CLKEN_ATVIN_IFD, <bit0>write bit(1)
	ScalerTimer_DelayXms(1);									//Driver delay 10uS
}
void DemodFrontendPathSetting(void)
{
	rtd_maskl(0xb8000844, 0x0FFFFFFF, 0x30000000); 				//GPIO_106, Set pinmux  ATV_IF_AGC	//gpio_61: ATV_IF_AGC
}
void others(void)
{
	//Spec\DISPI\MacArthur5-DesignSpec-I-Domain_YPP&VDCADC
	rtd_outl(0xb8020000, 0x000000ff);							//ADC_POWER enable

	//Input filer - 108MHz and BPF
	rtd_outl(0xb8018090, 0x00000000);	
	rtd_outl(0xb8018094, 0x00000011);							//adc_clk_sel<bit5:4> = 0x01(108M), input_dn_filter_sel<bit2:0> = 0x1(low pass filter for 108MHz)
}
void drv_ifd_adc_clock_init_108M(void)
{
	//[17]ATVIN_CLK_SEL, ATV Input clcok select
	// 1: Video Decoder Clock
	// 0: IF Demod Clock
	//rtd_maskl(0xb8000204, 0xfffdffff, 0x0);
	rtd_maskl(0xb8000204,0xFFFCFFFF,0x00000000);				//[17]ATVIN_CLK_SEL, [16]ATVIN_VD_CLK_SEL

	/////Demod(A+D) CLK / Reast set to 0///////////////////
	rtd_outl(0xb8000110, 0x81d82000);				//Demod CLK<bit31, bit24, bit23, bit22, bit20, bit19, bit13> set to 0
	rtd_outl(0xb8000114, 0x80808000);				//Demod CLK<bit31, bit23, bit15> set to 0
	rtd_outl(0xb8000118, 0x04000800);				//Demod CLK<bit26, bit11> set to 0
	rtd_outl(0xb8000100, 0x81f82000);				//Demod Reset<bit31, bit24, bit23, bit22, bit21, bit20, bit19, bit13> set to 0(active low)
	rtd_outl(0xb8000104, 0x80808002);				//Demod Reset<bit31, bit23, bit15, bit2> set to 0(active low)
	rtd_outl(0xb8000108, 0xc4000800);				//Demod Reset<bit27, bit26, bit22, bit11> set to 0(active low)
	ScalerTimer_DelayXms(10);


	//[0]PLL_CK_IFADC_MUX, CLKOUT for IFADC MUX
	// 0:DTV Mode
	// 1:ATV Mode
	rtd_maskl(0xb80004dc, 0xFDFFFFFE, 0x02000001);				//[25]PLL_L2H_CML_POW, [0]PLL_CK_IFADC_MUX

	//[0]PIP_IFADC_ATV_CKO_SEL, IFADC Clock Source Select
	// 0: PLL27X_IFADC
	// 1: PLL27X
	rtd_maskl(0xb8000500, 0xFFFFFFFE, 0x0);

	//ATV System CLK=108MHz, VCO=432MHz
	rtd_outl(0xb80004d0, 0x0224000e);           				//VCO = M<6:0>+2 = 14+2, N:00=1, 27 /1 *16=432MHz,[9:8]PLL27X_N = 0(1), [6:0]PLL27X_M = 0xe(14)
	rtd_outl(0xb80004d4, 0x880f6521);							//[5:4]PLL27X_PS_54M_DELAY=0x10(VCO=432M),
	rtd_outl(0xb80004dc, 0x2201c801);           				//[30:29]PLL27X_IFADC_DUTY=0x01(vco/2), [25]PLL_L2H_CML_POW=0x1, [17:16]PLL27X_CK108M_DIV=0x01(vco=432M), 
																//[11:10]PLL27X_IFADC_CKO_SEL=0x10(108M),[9]PLL27X_IFADC_DIV=0x0(divide 4), [0]PLL_CK_IFADC_MUX=0x1(ATV mode)
	rtd_outl(0xb8000514, 0x0000004b);							//[6]PLL27X_IFADC_CKO_EN=0x1,[3]PLL27x 108M clk to digital=0x1, [1]PLL27X_PS_EN=0x1(PLL27x phase swallow enable), [0]write_bit(1 to set, 0 to clear)
	rtd_outl(0xb80004d8, 0x00000000);   						//PLL27X_VCORSTB[2], 1:normal, 0:reset; PLL27X_RSTB[1], 1:normal, 0:reset; PLL27X_POW[0], 0:power down, 1:power on
	rtd_outl(0xb80004d8, 0x00000005);
	rtd_outl(0xb80004d8, 0x00000007);							
	ScalerTimer_DelayXms(5);
	rtd_maskl(0xb80004dc, 0x9fffffff, 0x00000000);           	//[30:29]Clear PLL27X_IFADC_DUTY
	rtd_outl(0xb8000514, 0x00000040);							//[6]disable PLL27X_IFADC_CKO_EN
	rtd_maskl(0xb80004dc, 0x9fffffff, 0x20000000);          	//[30:29]Set PLL27X_IFADC_DUTY =0x1(VCO/2)
	rtd_outl(0xb8000514, 0x00000041);							//[6]Enable PLL27X_IFADC_CKO_EN

	////////////////////////////////////////////////////
	//PLL VCO Change Start
	////////////////////////////////////////////////////
	//ATV ADC CLK=108MHz, VCO=540MHz, VCO and DIV setting			
	rtd_maskl(0xb8000500, 0xFFFFFF00, 0x00000018);				//[4]PLL27X_IFADC_DTV_CKO_EN=0x1(enable),[3:2]PLL27X_IFADC_ATV_CKO_SEL=0x10(108M), [0]PIP_IFADC_ATV_CKO_SEL=0x0(PLL27x_IFADC)		
	rtd_maskl(0xb8000504, 0xFC80FFF8, 0x00120003);				//VCO = M<6:0>+2 = 18+2, N:00=1, 27 /1 *20=540MHz, PLL27X_IFADC_M<bit22:16> = 0x12(18), PLL27X_IFADC_N<bit25:24>=0x0(1), 
																//PLL27X_IFADC PUMP current<bit2:0>=0x3(011:20u)	
	//Power Reset and On
	ScalerTimer_DelayXms(5);
	rtd_outl(0xb8000508, 0x00000000);
	rtd_outl(0xb8000508, 0x00000006);
	rtd_outl(0xb8000508, 0x00000007);
	////////////////////////////////////////////////////
	//PLL VCO Change End
	////////////////////////////////////////////////////

	////TVSB1, IFADC, frontend CLK / RESET flow///////
	rtd_outl(0xb8000110, 0x00080001);				//<bit19>CLKEN_dtv_frontend,  set to 1
	rtd_outl(0xb8000114, 0x80008001);				//<bit31>CLKEN_TVSB1, <bit15>CLKEN_IFADC, set to 1

	rtd_outl(0xb8000110, 0x00080000);				//<bit19>CLKEN_dtv_frontend, set to 0
	rtd_outl(0xb8000114, 0x80008000);				//<bit31>CLKEN_TVSB1, <bit15>CLKEN_IFADC, set to 0

	rtd_outl(0xb8000100, 0x00080001);				//<bit19>RSTN_dtv_frontend,  set to 1(release)
	rtd_outl(0xb8000104, 0x80008001);				//<bit31>RSTN_TVSB1, <bit15>RSTN_IFADC, set to 1(release)

	rtd_outl(0xb8000110, 0x00080001);				//<bit19>CLKEN_dtv_frontend,  set to 1
	rtd_outl(0xb8000114, 0x80008001);				//<bit31>CLKEN_TVSB1, <bit15>CLKEN_IFADC, set to 1
	ScalerTimer_DelayXms(10);
	
	return;
}

void drv_ifd_adc_clock_init_162M(void)
{
	//[17]ATVIN_CLK_SEL, ATV Input clcok select
	// 1: Video Decoder Clock
	// 0: IF Demod Clock
	//rtd_maskl(0xb8000204, 0xfffdffff, 0x0);
	rtd_maskl(0xb8000204,0xFFFCFFFF,0x00000000);				//[17]ATVIN_CLK_SEL, [16]ATVIN_VD_CLK_SEL

	/////Demod(A+D) CLK / Reast set to 0///////////////////
	rtd_outl(0xb8000110, 0x81d82000);				//Demod CLK<bit31, bit24, bit23, bit22, bit20, bit19, bit13> set to 0
	rtd_outl(0xb8000114, 0x80808000);				//Demod CLK<bit31, bit23, bit15> set to 0
	rtd_outl(0xb8000118, 0x04000800);				//Demod CLK<bit26, bit11> set to 0
	rtd_outl(0xb8000100, 0x81f82000);				//Demod Reset<bit31, bit24, bit23, bit22, bit21, bit20, bit19, bit13> set to 0(active low)
	rtd_outl(0xb8000104, 0x80808002);				//Demod Reset<bit31, bit23, bit15, bit2> set to 0(active low)
	rtd_outl(0xb8000108, 0xc4000800);				//Demod Reset<bit27, bit26, bit22, bit11> set to 0(active low)
	ScalerTimer_DelayXms(10);

	//[0]PLL_CK_IFADC_MUX, CLKOUT for IFADC MUX
	// 0:DTV Mode
	// 1:ATV Mode
	rtd_maskl(0xb80004dc, 0xFDFFFFFE, 0x02000001);				//[25]PLL_L2H_CML_POW, [0]PLL_CK_IFADC_MUX

	//[0]PIP_IFADC_ATV_CKO_SEL, IFADC Clock Source Select
	// 0: PLL27X_IFADC
	// 1: PLL27X
	rtd_maskl(0xb8000500, 0xFFFFFFFE, 0x0);

	//ATV System CLK=108MHz, VCO=432MHz
	rtd_outl(0xb80004d0, 0x0224000e);           				//VCO = M<6:0>+2 = 14+2, N:00=1, 27 /1 *16=432MHz,[9:8]PLL27X_N = 0(1), [6:0]PLL27X_M = 0xe(14)
	rtd_outl(0xb80004d4, 0x880f6521);							//[5:4]PLL27X_PS_54M_DELAY=0x10(VCO=432M),
	rtd_outl(0xb80004dc, 0x2201ce01);           				//[30:29]PLL27X_IFADC_DUTY=0x01(vco/2), [25]PLL_L2H_CML_POW=0x1, [17:16]PLL27X_CK108M_DIV=0x01(vco=432M), 
																//[11:10]PLL27X_IFADC_CKO_SEL=0x11(162M),[9]PLL27X_IFADC_DIV=0x1(divide 2), [0]PLL_CK_IFADC_MUX=0x1(ATV mode)
	rtd_outl(0xb8000514, 0x0000004b);							//[6]PLL27X_IFADC_CKO_EN=0x1,[3]PLL27x 108M clk to digital=0x1, [1]PLL27X_PS_EN=0x1(PLL27x phase swallow enable), [0]write_bit(1 to set, 0 to clear)
	rtd_outl(0xb80004d8, 0x00000000);   						//PLL27X_VCORSTB[2], 1:normal, 0:reset; PLL27X_RSTB[1], 1:normal, 0:reset; PLL27X_POW[0], 0:power down, 1:power on
	rtd_outl(0xb80004d8, 0x00000005);
	rtd_outl(0xb80004d8, 0x00000007);							
	ScalerTimer_DelayXms(5);
	rtd_maskl(0xb80004dc, 0x9fffffff, 0x00000000);           	//[30:29]Clear PLL27X_IFADC_DUTY
	rtd_outl(0xb8000514, 0x00000040);							//[6]disable PLL27X_IFADC_CKO_EN
	rtd_maskl(0xb80004dc, 0x9fffffff, 0x20000000);          	//[30:29]Set PLL27X_IFADC_DUTY =0x1(VCO/2)
	rtd_outl(0xb8000514, 0x00000041);							//[6]Enable PLL27X_IFADC_CKO_EN

	////////////////////////////////////////////////////
	//PLL VCO Change Start
	////////////////////////////////////////////////////
	//ATV ADC CLK=162MHz, VCO=324MHz, VCO and DIV setting			
	rtd_maskl(0xb8000500, 0xFFFFFF00, 0x0000001C);				//[4]PLL27X_IFADC_DTV_CKO_EN=0x1(enable),[3:2]PLL27X_IFADC_ATV_CKO_SEL=0x11(162M), [0]PIP_IFADC_ATV_CKO_SEL=0x0(PLL27x_IFADC)		
	rtd_maskl(0xb8000504, 0xFC80FFF8, 0x000a0003);				//VCO = M<6:0>+2 = 10+2, N:00=1, 27 /1 *12=324MHz, PLL27X_IFADC_M<bit22:16> = 0xa(10), PLL27X_IFADC_N<bit25:24>=0x0(1), 
																//PLL27X_IFADC PUMP current<bit2:0>=0x3(011:20u)	
	rtd_maskl(0xb80004dc, 0xfffffdff, 0x00000200);           	//[9]PLL27X_IFADC_DIV=0x1(1: divide by 2 (use when VCO=324M to generate 162M))

	//Power Reset and On
	ScalerTimer_DelayXms(5);
	rtd_outl(0xb8000508, 0x00000000);
	rtd_outl(0xb8000508, 0x00000006);
	rtd_outl(0xb8000508, 0x00000007);
	////////////////////////////////////////////////////
	//PLL VCO Change End
	////////////////////////////////////////////////////

	////TVSB1, IFADC, frontend CLK / RESET flow///////
	rtd_outl(0xb8000110, 0x00080001);				//<bit19>CLKEN_dtv_frontend,  set to 1
	rtd_outl(0xb8000114, 0x80008001);				//<bit31>CLKEN_TVSB1, <bit15>CLKEN_IFADC, set to 1

	rtd_outl(0xb8000110, 0x00080000);				//<bit19>CLKEN_dtv_frontend, set to 0
	rtd_outl(0xb8000114, 0x80008000);				//<bit31>CLKEN_TVSB1, <bit15>CLKEN_IFADC, set to 0

	rtd_outl(0xb8000100, 0x00080001);				//<bit19>RSTN_dtv_frontend,  set to 1(release)
	rtd_outl(0xb8000104, 0x80008001);				//<bit31>RSTN_TVSB1, <bit15>RSTN_IFADC, set to 1(release)

	rtd_outl(0xb8000110, 0x00080001);				//<bit19>CLKEN_dtv_frontend,  set to 1
	rtd_outl(0xb8000114, 0x80008001);				//<bit31>CLKEN_TVSB1, <bit15>CLKEN_IFADC, set to 1
	ScalerTimer_DelayXms(10);

	return;
}

void drv_ifd_pll_default(void)
{
	//paste from script

	//IFADC_CLK reset flow need to do frist
	rtd_outl(0xb8000114, 0x00008000);				//<bit15>CLKEN_IFADC, set to 0
	rtd_outl(0xb8000104, 0x00008000);				//<bit15>RSTN_IFADC, set to 0(Reset)
	rtd_outl(0xb8000104, 0x00008001);				//<bit15>RSTN_IFADC, set to 1(Release)
	rtd_outl(0xb8000114, 0x00008001);
	
	//Merlin4 register default setup 
	rtd_outl(0xb80004c4,0x00000000);				//DTV PLLDIF PLLDIF_DIVDIG_SEL = 000(2), PLLDIF_DIVADC_SEL = 00(divide by 8)
	rtd_outl(0xb80004c8,0x00000000);				//Power down PLLDIF_POW, RSTB, VCO_RSTB, DTVSystemCLK_Sync_SEL = 0(from PLLDIF)
	rtd_outl(0xb80004d0,0x0224000a);				//PLL27X, LFP Setting, M<10>+2=12(VCO =324M)
	rtd_outl(0xb80004d4,0x88086501);				//PLL_XIXO_DRIVE_SEL=00(00 strongest driving), LDO PowerOn and PLL_LDO11V_SEL =01(0.968V /recommend),
													//PLL_LDO_SEL=01(0.952V) PLL27X_PS_DUTY_SEL = larger duty cycle
	rtd_outl(0xb80004d8,0x00000000);				//PLL27X Poweroff and VCORSTB reset.
	rtd_outl(0xb80004dc,0x2002ce01);				//PLL27X setting, default ATV mode
	rtd_outl(0xb8000514,0x00000049);				//<bit6>PLL27X_IFADC_CKO_EN, =0x1(enable, )<bit3>PLL27x 108M clk to digital=0x1(enable), <bit0>write bit used
	rtd_outl(0xb8000500,0x0000000c);				//IFADC CKO SEL Setting
	rtd_outl(0xb8000504,0x000a0224);				//IFADC LFP Setting, M<10>+2�P=12(VCO=324M)
	rtd_outl(0xb8000508,0x00000000);				//IFADC Poweroff and VCORSTB reset

	ScalerTimer_DelayXms(5);

	//PLLDIF
	rtd_maskl(0xb80004c8, 0xfffffff8, 0x00000000);	//Reset PLLDIF[bit 0:2] set to 0
	rtd_maskl(0xb80004c8, 0xfffffff8, 0x00000006);	//Set PLLDIF_RSTB and PLLDIF_VCO set to normal
	rtd_maskl(0xb80004c8, 0xfffffff8, 0x00000007);  //Set PLLDIF_POW, PLLDIF_RSTB and PLLDIF_VCO to power on
	rtd_maskl(0xb80004c8, 0x7fffffff, 0x80000000);	//Set DTVSysClk select CKO from PLL27X

	//PLL27X
	rtd_maskl(0xb80004d4, 0xfff8ffff, 0x00000000);	//<b18>PLL_XIXO_Load = 0x0 and <b16, b17>PLL_XIXO_Drive_SEL = 0x0
	rtd_maskl(0xb80004d8, 0xffff00f0, 0x00000007);	//PLL27X, <bit0,1,2,4> set to 1, Set PLL27X_POW, PLL23X_RSTB_VCO to power on, 
													//PLL_RESERVE <bit15:8> = 0(PINMUX ADC_CLK From PLL27X_IFADC);(CN_demod set to 1:form PLLDIF)
	rtd_maskl(0xb80004dc, 0xfdfffffe, 0x02000000);	//Set PLL_L2H_CML_POW<bit25> = enable(0x1) and MUX to DTV Mode<bit0>=0x0

	//PLL27X_IFADC
	rtd_maskl(0xb8000500, 0xfffffff3, 0x0000000C);	//PPLL27X_IFADC_DTV_CKO_SEL = 00(/3), PLL27X_IFADC_ATV_CKO_SEL = 11 (135M or 162M (depend on VCO and REG_PLL27x_IFADC_DIV).
	rtd_maskl(0xb8000508, 0xfffffff8, 0x00000007);	//IFADC, RSTB and VCORSTB Power on

}

void drv_ifd_adc_default(void)
{
	//paste from script

	//register default
	rtd_outl(0xb8033100,0x00010202);					//PGA IB20U select <bit7:0> = 0x02(10u),IFD MBIAS power on(bit16=1), ADC2X_BG_SEL= 10(1.221V)
	rtd_outl(0xb8033104,0x00000040);					//IFADC Comparator bias select, <bit6:4>= 100(50uF), IQADC input cm power off <bit24> = 0  
	rtd_outl(0xb8033118,0x30200010);					//IQ ADC calibration input swing <bit30:28> = 0x11, REG_IQ_CAL_DIV<bit21:20> = 0x10, REG_CKOUT_SEL_Q: the default is "1:I_CKOUT" on AIF spec
	rtd_outl(0xb8033120,0x00440000);					//REG_IQCMP_ISEL <bit22:20> = 0x100(50uA), REG_IQCAL_ISEL <bit18:16> = 0x100(50uA), IF ADC GAIN FIX EN <bit0> = 0(SIF mode)
	rtd_outl(0xb8033124,0x00000000);					//PGA/ADC Power Off
	rtd_outl(0xb8033128,0x00000022);					//Default setting(10=20uA), IQ PGA CURRENT  select(same with Mac5P)
		
	//IFADC+IFPGA power on
	rtd_maskl(0xb8033100, 0xfffeffff, 0x00010000);		//turn on MBIAS
	rtd_maskl(0xb8033104, 0xfefffcff, 0x00000200);		//REG_ADC2X_DIFPOW, IFADC input cm power set to off(b24)=0x0, IPGA_BW<bit9:8>=0x02(50M)
	rtd_maskl(0xb8033124, 0xfffffefe, 0x00000101);		//I_PGA<bit8> power on, <bit0>I_ADC power on
	rtd_maskl(0xb8033128, 0xfff88fff, 0x00020000);		//I PGA input select = IFD input, Q PGA input select = No input

	//IQADC+IQPGA power on
	rtd_outl(0xb803312C,0x00000000);					//default setting
	rtd_outl(0xb8033130,0x00000000);					//default setting
	rtd_outl(0xb8033134,0x22000022);					//REG_IADC_LDO_SEL = 01, REG_QADC_LDO_SEL = 01, IADC, QADC_META_POW = turn off, REG_IADC_VREF_SEL = 10, REG_QADC_VREF_SEL = 10

	//Set IPGA/QPGA GAIN = 0dB
	rtd_maskl(0xb8033120, 0xfffffffe, 0x00000001);		//IF ADC GAIN FIX EN <bit0>= 1(Internal Demod IQ mode)
	rtd_maskl(0xb803312c, 0xffeecc00, 0x00000000);		//Q single_end<bit20>=0x0, I single_end<bit16>=0, Q_CKIN_Sel<bit13:12>=00, I_CKIN_Sel<bit9:8>=00: From PLL27X_IFADC, 
													//reg_qpga_d<bit7:4>=0x0(0dB), reg_ipga_d<bit3:0>=0x0(0dB)
	return;
}

void drv_ifd_dac_default(void)
{
	//paste from script

	//Video DAC Default Setting
	rtd_outl(0xb8033000,0x00002002);
	rtd_outl(0xb8033004,0x00000000);
	rtd_outl(0xb8033008,0x20000313);
	rtd_outl(0xb8033024,0x00000000);

	//Vide DAC power on
	rtd_maskl(0xb8033000, 0xeeefffff, 0x11100000);

	//Bypass DAC input : VD
	rtd_outl(0xb8033024,0x00000000);
	
	return;
}

void drv_ifd_power_on(bool enable)
{
	if(enable) 
	{
		rtd_outl(SYS_REG_SYS_CLKEN1_reg, SYS_REG_SYS_CLKEN1_clken_if_demod(1) | SYS_REG_SYS_CLKEN1_write_data(1));
		rtd_outl(SYS_REG_SYS_CLKEN1_reg, SYS_REG_SYS_CLKEN1_clken_if_demod(1) | SYS_REG_SYS_CLKEN1_write_data(0));
		rtd_outl(SYS_REG_SYS_SRST1_reg, SYS_REG_SYS_SRST1_rstn_if_demod(1) | SYS_REG_SYS_SRST1_write_data(1));
		rtd_outl(SYS_REG_SYS_CLKEN1_reg, SYS_REG_SYS_CLKEN1_clken_if_demod(1) | SYS_REG_SYS_CLKEN1_write_data(1));
		mdelay(10);
		rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_atvin_ifd(1) | SYS_REG_SYS_CLKEN2_write_data(1));
		rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_atvin_ifd(1) | SYS_REG_SYS_CLKEN2_write_data(0));
		rtd_outl(SYS_REG_SYS_SRST2_reg, SYS_REG_SYS_SRST2_rstn_atvin2(1) | SYS_REG_SYS_SRST2_rstn_atvin(1) | SYS_REG_SYS_SRST2_rstn_if_demod_logic(1) | SYS_REG_SYS_SRST2_write_data(1));
		rtd_outl(SYS_REG_SYS_CLKEN2_reg, SYS_REG_SYS_CLKEN2_clken_atvin_ifd(1) | SYS_REG_SYS_CLKEN2_write_data(1));
		mdelay(10);
	} else {
		
	}
	return ;
}

void drv_ifd_adc_power_on(bool enable)
{
	return ;
}

bool drv_ifd_adc_power_check(void)
{
	return 0;
}

void drv_ifd_set_adcinput_swing(IFD_ADC_SHAGAIN setting1, IFD_ADC_FULLSCALE setting2)
{
	return;
}

void drv_ifd_adc_input_sel(IFD_ADC_INPUT_SEL input_source)
{
	return;
}

void drv_ifd_adc_clock(IFD_CLK_RATE adc_clock)
{
	return;
}

void drv_ifd_adc_clock_source_set(IFD_IFADC_MUX value)
{
	return;
}

bool drv_ifd_adc_clock_source_get_info(void)
{
	return 1;
}

void drv_ifd_adc_pga_gain_fix(bool enable, IFD_ADC_PGAFIX_CTRL fix_pga_gain)
{
	return;
}
