#include <qc_verify_common.h>
#include <hdmi_qc.h>
#include "mhl_cbus.h"
#include "MHL3.h"
#include "MHL_CDF.h"


#if MHL3_ENABLE

typedef unsigned int UINT32;
typedef unsigned short UINT16;
typedef unsigned char UINT8;


#define timer_7_reset() {};
#define TC7CVR 0xb8000000
#define TOTAL_SLOT_NUM 25

#define MHLVER_2p2  (0x22)
#define MHLVER_3p0  (0x30)
#define MHLVER_3p2  (0x32)

ENUM_MHL3_FSM mhl3_fsm;
unsigned char mhl_src_ver = MHLVER_3p0;
unsigned char mhl_av_link = MHLVER_2p2;
unsigned char mhl3_link_rate;
bool mhl3_link_rate_updated;
unsigned int rap_mode_up_retry_cnt;
unsigned int startup_rety;
unsigned char emsc_slot_size;

unsigned int peer_blk_rx_buffer_avail;
bool blk_recv_info;
unsigned char blk_recv_count;

MHL3_BIST_T bist_ecbus, bist_avlink;
unsigned char bist_testing;

enum {
	SRC_VER_WAITING,
	SRC_VER_FAIL,
	SRC_VER_TIMEOUT,
	SRC_VER_3,
	SRC_VER_2,
};

enum {
	ECBUS_SPEED_WAITING,
	ECBUS_SPEED_TIMEOUT,
	ECBUS_SPEED_OK,
};

enum {
	RAP_MODE_WAITING,
	RAP_MODE_REPLY_FAIL,
	RAP_MODE_TIMEOUT,
	RAP_MODE_UP,
	RAP_MODE_DOWN,
};


bool SET_HPD(void);
bool SET_INT(int,int);
bool WRITE_STAT(int,int);
//bool WRITE_XSTAT(int,int);
bool MSC_MSG(int,int);
bool READ_DEVCAP(int);
bool READ_XDEVCAP(int);
bool GET_DDC_ERRORCODE(void);
bool GET_MSC_ERRORCODE(void);
bool GET_STATE(void);
bool drvif_CBUS_RX_APHY_initial(void);
bool drvif_CBUS_RX_DPHY_initial(void);
bool drvif_CBUS_RX_MAC_initial(void);
bool drvif_CBUS_RX_Capability_Register_Table(void);
void drvif_mhl3_cbus_switch(unsigned char is_ecbus);
bool drvif_switch_to_oCBUS(unsigned char wakeup_done);
bool drvif_switch_to_eCBUS(void);
bool drvif_eCBUS_Start_Up(void);
bool drvif_eCBUS_Shut_Down(void);
bool drvif_eCBUS_TDM_Slot_Sync(void);
bool drvif_eCBUS_eMSC_Link_Training(void);
bool drvif_Enable_MHL_Z0(void);
bool drvif_Measure_CK_GDI(void);
bool drvif_Set_eMSC_TX_Slot_Map(void);
bool drvif_Check_eMSC_RX_Slot_Map(void);
bool drvif_List_eMSC_Slot_Map(void);
bool drvif_CBUS_Discovery(void);
bool drvif_Send_Block_Transaction(unsigned char *,int);
/*bool drvif_CBUS_EDIDLoad(unsigned char*,UINT16) ;
bool drvif_CBUS_EDIDEnable(UINT8) ;
void drvif_CBUS_EDID_DDC12_AUTO_Enable(UINT8) ;
void drvif_CBUS_LoadEDID(unsigned char*,int);*/
int Send_Block_BLK_RCV_BUFFER_INFO(void);
int Send_Block_EMSC_SUPPORT(void);

int Send_count_of_REQ;							//  Count of eMSC REQ
int Send_RX_UNLOAD_ACK = 0;					// RX_UNLOAD_ACK of eMSC Block Transaction Standard Transport Header, Real_Number =  Set_Number
int Send_LENGTH_REMAINING = 0;					// LENGTH_REMAINING of eMSC Block Transaction Standard Transport Header, Real_Number =  Set_Number
int Send_Block_data_array[256] = {};					// BURST_ID Data Array

int Recv_RX_UNLOAD_ACK = 0;
int Recv_LENGTH_REMAINING = 0;

int PEER_BLK_RX_BUFFER_AVAIL = 256;
int PEER_BLK_RX_BUFFER_done = 0;
int PEER_BLK_RX_BUFFER_SIZE = 256;

int Send_heat_beat_ms = 0;

int Block_Transaction_ok = 0;
int Block_Transaction_timeout = 1;
int Block_Transaction_peer_out_of_space = 2;

void hdmi_delayus(unsigned int us)
{
#if 1
	udelay(us);
#else
volatile u_int32_t loop1, loop2;
	for (loop1=0; loop1<us; loop1++) {
		for (loop2=0; loop2<700; loop2++);
		{
		loop2=loop2;
		}
	}
#endif
}

#if 0
UINT8 hdmi_Cbus_edid[256] =
{
	//monitor table
	0x00,0xff,0xff,0xff,0xff,0xff,0xff,0x00,0x4a,0x8b,0x3b,0x2a,0x01,0x01,0x01,0x01,
	0x0d,0x16,0x01,0x03,0x80,0x3c,0x22,0x78,0x2a,0x2c,0xc5,0xa5,0x55,0x54,0xa1,0x27,
	0x0c,0x50,0x54,0xad,0xcf,0x00,0xd1,0xc0,0x81,0x80,0x81,0xc0,0x95,0x00,0xb3,0x00,
	0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x1d,0x00,0x72,0x51,0xd0,0x1e,0x20,0x6e,0x28,
	0x55,0x00,0x40,0x84,0x63,0x00,0x00,0x1e,0x66,0x21,0x50,0xb0,0x51,0x00,0x1b,0x30,
	0x40,0x70,0x36,0x00,0x56,0x50,0x21,0x00,0x00,0x1e,0x00,0x00,0x00,0xfc,0x00,0x56,
	0x53,0x32,0x37,0x30,0x42,0x47,0x54,0x57,0x50,0x0a,0x20,0x20,0x00,0x00,0x00,0xfd,
	0x00,0x38,0x4b,0x1e,0x53,0x11,0x00,0x0a,0x20,0x20,0x20,0x20,0x20,0x20,0x01,0xe7,
	0x02,0x03,0x22,0xf1,0x4f,0xa2,0x14,0x10,0x1f,0x04,0x13,0x03,0x12,0x02,0x11,0x01,
	0x06,0x07,0x15,0x16,0x23,0x09,0x07,0x01,0x83,0x01,0x00,0x00,0x65,0x03,0x0c,0x00,
	0x20,0x00,0x8c,0x0a,0xd0,0x8a,0x20,0xe0,0x2d,0x10,0x10,0x3e,0x96,0x00,0x56,0x50,
	0x21,0x00,0x00,0x18,0x01,0x1d,0x00,0x72,0x51,0xd0,0x1e,0x20,0x6e,0x28,0x55,0x00,
	0x56,0x50,0x21,0x00,0x00,0x1e,0x8c,0x0a,0xd0,0x8a,0x20,0xe0,0x2d,0x10,0x10,0x3e,
	0x96,0x00,0x56,0x50,0x21,0x00,0x00,0x18,0x8c,0x0a,0xd0,0x90,0x20,0x40,0x31,0x20,
	0x0c,0x40,0x55,0x00,0x56,0x50,0x21,0x00,0x00,0x18,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x2a,
};
#endif
#if 0
int QC_Verifier_CBUS_RX(void)
{

	int timeout_cnt;

	// ----------------------------------------------------------------------------------
	// initial CBUS_RX APHY, DPHY, MAC, Capability Register,  EDID
	// ----------------------------------------------------------------------------------
	rtd_maskl(HDMI_HDMI_VCR_reg,~HDMI_HDMI_VCR_cbus_ddc_chsel_mask,HDMI_HDMI_VCR_cbus_ddc_chsel_mask);	// DDC select source from cbus
	/*drvif_CBUS_LoadEDID(hdmi_Cbus_edid,256);*/
	if (!drvif_CBUS_RX_APHY_initial()) {return FAILED;}
	if (!drvif_CBUS_RX_DPHY_initial()) {return FAILED;}
	if (!drvif_CBUS_RX_MAC_initial()) {return FAILED;}
	if (!drvif_CBUS_RX_Capability_Register_Table()) {return FAILED;}

	// ----------------------------------------------------------------------------------
	// eCBUS Discovery
	// ----------------------------------------------------------------------------------
	rtd_maskl(PINMUX_PMM_ST_GPIO_CFG_3_reg,~PINMUX_PMM_ST_GPIO_CFG_3_st_gpio_14_ps_mask,PINMUX_PMM_ST_GPIO_CFG_3_st_gpio_14_ps(0xF));
	rtd_maskl(0xb8061100,~(0x4000),0);	// GPIO_14 is GPI

	if  ((rtd_inl(0xb8061110) & 0x4000) == 0x4000)
	{
		HDMI_PRINTF("MHL Cable is Detected !!!\n");
		rtd_maskl(CBUS_PMM_CBUS_STANDBY_08_reg,~CBUS_PMM_CBUS_STANDBY_08_cable_det_mask,CBUS_PMM_CBUS_STANDBY_08_cable_det_mask);		// MHL Cable is attached
		if(!drvif_CBUS_Discovery()) {return FAILED;}
	}
	else
	{
		HDMI_PRINTF("No MHL Cable Detect !!!\n\n\n");
		return FAILED;
	}

	// ----------------------------------------------------------------------------------
	// Source Output AV Link Data
	// ----------------------------------------------------------------------------------
	if(!WRITE_STAT(0x31,0x08)) {return FAILED;}	// LINK_MODE(PATH_EN)
	//while (((rtd_inl(CBUS_CBUS_MSC_06_reg) & CBUS_CBUS_MSC_06_wr_stat_irq_mask) != CBUS_CBUS_MSC_06_wr_stat_irq_mask)) {}
	//rtd_outl(0xb800A278,0x00C04008);                // Clear path_en & clk_mode_chg Flag
	HDMI_PRINTF("Waiting for Source send MSC_MSG(RAP{CONTENT_ON})...");

	timeout_cnt = 0;
	while ((((rtd_inl(CBUS_CBUS_MSC_06_reg) & CBUS_CBUS_MSC_06_rap_irq_mask) != CBUS_CBUS_MSC_06_rap_irq_mask) || (rtd_inl(CBUS_CBUS_MSC_12_reg)  != 0x00000010)) && (timeout_cnt <= 500))
	{
		mdelay(1);
		timeout_cnt = timeout_cnt + 1;
	}

	if (timeout_cnt > 500)
	{
		HDMI_PRINTF("\nTimeout for waiting MSC_MSG(RAP{CONTENT_ON}) : > 500ms\n");
		return FAILED;
	}
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_rap_irq_mask);				// Clear RAP Flag
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_get_msg_irq_mask);			// Clear MSC_CMD Flag
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_allmsc_cmd_irq_mask);		// Clear All MSC_CMD Flag
	HDMI_PRINTF("OK!\n");
	if(!MSC_MSG(0x21,0x00)) {return FAILED;}										// Reply MSC_MSG(RAPK{No_Error})

	// ----------------------------------------------------------------------------------
	// eMSC Link Training & Maintenance
	// ----------------------------------------------------------------------------------
	if(!drvif_Set_eMSC_TX_Slot_Map()) {return FAILED;}
	if(!drvif_eCBUS_eMSC_Link_Training()) {return FAILED;}
	rtd_outl(ECBUS_RX_ECBUS_EMSC_RX_ADDR_reg,0);			// Reset eMSC RX Buffet Write Pointer
	rtd_outl(ECBUS_RX_ECBUS_EMSC_TX_ADDR_reg,0);			// Reset eMSC TX Buffet Write Pointer
	if(!drvif_Check_eMSC_RX_Slot_Map()) {return FAILED;}
	if(!drvif_List_eMSC_Slot_Map()) {return FAILED;}
HDMI_PRINTF("----- eCBUS DONE ------\n");
while(1) {HDMI_DELAYMS(100);  };
	// ----------------------------------------------------------------------------------
	// eMSC Block Transaction
	// ----------------------------------------------------------------------------------
	int recv_data_byte, temp, i;
	rtd_outl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_3_reg,ECBUS_RX_ECBUS_EMSC_TRANS_DET_3_emsc_rx_done_irq_mask);	// Clear rx_done Flag

	// Block Transaction
	HDMI_PRINTF("\n\n");
	while(1)
	{
		if (rtd_inl(ECBUS_RX_ECBUS_EMSC_RX_BLK_CNT_reg) != 0)
		{
			// Receive Block Transaction
			Recv_RX_UNLOAD_ACK = rtd_inl(ECBUS_RX_ECBUS_EMSC_RX_DATA_reg);
			Recv_LENGTH_REMAINING = rtd_inl(ECBUS_RX_ECBUS_EMSC_RX_DATA_reg);
			HDMI_PRINTF("Recv_RX_UNLOAD_ACK = 0x%02X ; Recv_LENGTH_REMAINING = 0x%02X;\n",Recv_RX_UNLOAD_ACK,Recv_LENGTH_REMAINING);
			for (i = 0; i < Recv_LENGTH_REMAINING; i++)
			{
				recv_data_byte = rtd_inl(ECBUS_RX_ECBUS_EMSC_RX_DATA_reg);
				HDMI_PRINTF("0x%02X ",recv_data_byte);
				if ((i == 0) && (recv_data_byte == 0x00) && (PEER_BLK_RX_BUFFER_done == 0)) {PEER_BLK_RX_BUFFER_done++;}
				if ((i == 1) && (recv_data_byte == 0x63) && (PEER_BLK_RX_BUFFER_done == 1)) {PEER_BLK_RX_BUFFER_done++;}
				if ((i == 2) && (PEER_BLK_RX_BUFFER_done == 2))
				{
					PEER_BLK_RX_BUFFER_SIZE = recv_data_byte;
					PEER_BLK_RX_BUFFER_done++;
				}
				if ((i == 3) && (PEER_BLK_RX_BUFFER_done == 3))
				{
					PEER_BLK_RX_BUFFER_SIZE = PEER_BLK_RX_BUFFER_SIZE + recv_data_byte * 256;
					PEER_BLK_RX_BUFFER_AVAIL = PEER_BLK_RX_BUFFER_SIZE - (256 - PEER_BLK_RX_BUFFER_AVAIL);
					PEER_BLK_RX_BUFFER_done++;
				}
			}
			PEER_BLK_RX_BUFFER_AVAIL = PEER_BLK_RX_BUFFER_AVAIL + Recv_RX_UNLOAD_ACK;
			Send_RX_UNLOAD_ACK = Send_RX_UNLOAD_ACK + (Recv_LENGTH_REMAINING + 2);
			rtd_outl(ECBUS_RX_ECBUS_EMSC_TRANS_CTRL_reg,ECBUS_RX_ECBUS_EMSC_TRANS_CTRL_block_fw_done_mask);		// Block f/w Done
			HDMI_PRINTF("\nPEER_BLK_RX_BUFFER_AVAIL = %d\n\n",PEER_BLK_RX_BUFFER_AVAIL);
		}

		// Send Block Transaction
		i = 0;
		if (Send_heat_beat_ms < 40)
		{
			mdelay(1);
			Send_heat_beat_ms++;
		} else
		{
			switch(i)
			{
				case 0:
					temp = Send_Block_BLK_RCV_BUFFER_INFO();
					if (temp == Block_Transaction_ok) {i++;}
					if (temp == Block_Transaction_timeout) {return FAILED;}
					break;
				case 1:
					temp = Send_Block_EMSC_SUPPORT();
					if (temp == Block_Transaction_ok) {i++;}
					if (temp == Block_Transaction_timeout) {return FAILED;}
					break;
				default:
					temp = Send_Block_BLK_RCV_BUFFER_INFO();
					if (temp == Block_Transaction_timeout) {return FAILED;}
			}
			Send_heat_beat_ms = 0;
		}

	}

	return 1;
}

int Send_Block_EMSC_SUPPORT(void)
{
	int tx_checksum, i;

	Send_count_of_REQ = 17;
	if (PEER_BLK_RX_BUFFER_AVAIL >= Send_count_of_REQ*3)
	{
		Send_LENGTH_REMAINING = Send_count_of_REQ + 1 - 2;
		Send_Block_data_array[0] = Send_RX_UNLOAD_ACK;
		Send_Block_data_array[1] = Send_LENGTH_REMAINING;
		Send_Block_data_array[2] = _EMSC_SUPPORT_H;
		Send_Block_data_array[3] = _EMSC_SUPPORT_L;
		Send_Block_data_array[4] = 0;						// Checksum
		Send_Block_data_array[5] = 16;						// Total Entire = 16
		Send_Block_data_array[6] = 1;						// SEQ = 1
		Send_Block_data_array[7] = 5;						// NUM_ENT = 5
		Send_Block_data_array[8] = _3D_VIC_H;
		Send_Block_data_array[9] = _3D_VIC_L;
		Send_Block_data_array[10] = _3D_DTD_H;
		Send_Block_data_array[11] = _3D_DTD_L;
		Send_Block_data_array[12] = _HEV_VIC_H;
		Send_Block_data_array[13] = _HEV_VIC_L;
		Send_Block_data_array[14] = _HEV_DTDA_H;
		Send_Block_data_array[15] = _HEV_DTDA_L;
		Send_Block_data_array[16] = _HEV_DTDB_H;
		Send_Block_data_array[17] = _HEV_DTDB_L;
		tx_checksum = 0;
		for (i = 2; i < Send_count_of_REQ + 1 -2; i++)	{tx_checksum = tx_checksum + Send_Block_data_array[i];}
		Send_Block_data_array[4] = 256 - (tx_checksum % 256);// Checksum
		if(!drvif_Send_Block_Transaction(Send_Block_data_array,Send_count_of_REQ)) {return Block_Transaction_timeout;}

		Send_count_of_REQ = 17;
		Send_LENGTH_REMAINING = Send_count_of_REQ + 1 - 2;
		Send_Block_data_array[0] = Send_RX_UNLOAD_ACK;
		Send_Block_data_array[1] = Send_LENGTH_REMAINING;
		Send_Block_data_array[2] = _EMSC_SUPPORT_H;
		Send_Block_data_array[3] = _EMSC_SUPPORT_L;
		Send_Block_data_array[4] = 0;						// Checksum
		Send_Block_data_array[5] = 16;						// Total Entire = 16
		Send_Block_data_array[6] = 2;						// SEQ = 2
		Send_Block_data_array[7] = 5;						// NUM_ENT = 5
		Send_Block_data_array[8] = _VC_ASSIGN_H										;
		Send_Block_data_array[9] = _VC_ASSIGN_L;

		Send_Block_data_array[10] = _VC_CONFIRM_H;
		Send_Block_data_array[11] = _VC_CONFIRM_L;
		Send_Block_data_array[12] = _AUD_DELAY_H;
		Send_Block_data_array[13] = _AUD_DELAY_L;
		Send_Block_data_array[14] = _BIST_SETUP_H;
		Send_Block_data_array[15] = _BIST_SETUP_L;
		Send_Block_data_array[16] = _BIST_RETURN_STAT_H;
		Send_Block_data_array[17] = _BIST_RETURN_STAT_L;
		tx_checksum = 0;
		for (i = 2; i < Send_count_of_REQ + 1 -2; i++)	{tx_checksum = tx_checksum + Send_Block_data_array[i];}
		Send_Block_data_array[4] = 256 - (tx_checksum % 256);// Checksum
		if(!drvif_Send_Block_Transaction(Send_Block_data_array,Send_count_of_REQ)) {return Block_Transaction_timeout;}

		Send_count_of_REQ = 17;
		Send_LENGTH_REMAINING = Send_count_of_REQ + 1 - 2;
		Send_Block_data_array[0] = Send_RX_UNLOAD_ACK;
		Send_Block_data_array[1] = Send_LENGTH_REMAINING;
		Send_Block_data_array[2] = _EMSC_SUPPORT_H;
		Send_Block_data_array[3] = _EMSC_SUPPORT_L;
		Send_Block_data_array[4] = 0;						// Checksum
		Send_Block_data_array[5] = 16;						// Total Entire = 16
		Send_Block_data_array[6] = 3;						// SEQ = 3
		Send_Block_data_array[7] = 5;						// NUM_ENT = 5
		Send_Block_data_array[8] = _BIST_DISCARD_H										;
		Send_Block_data_array[9] = _BIST_DISCARD_L;
		Send_Block_data_array[10] = _BIST_ECHO_REQUEST_H;
		Send_Block_data_array[11] = _BIST_ECHO_REQUEST_L;
		Send_Block_data_array[12] = _BIST_ECHO_RESPONSE_H;
		Send_Block_data_array[13] = _BIST_ECHO_RESPONSE_L;
		Send_Block_data_array[14] = _EMSC_SUPPORT_H;
		Send_Block_data_array[15] = _EMSC_SUPPORT_L;
		Send_Block_data_array[16] = _HID_PAYLOAD_H;
		Send_Block_data_array[17] = _HID_PAYLOAD_L;
		tx_checksum = 0;
		for (i = 2; i < Send_count_of_REQ + 1 -2; i++)	{tx_checksum = tx_checksum + Send_Block_data_array[i];}
		Send_Block_data_array[4] = 256 - (tx_checksum % 256);// Checksum
		if(!drvif_Send_Block_Transaction(Send_Block_data_array,Send_count_of_REQ)) {return Block_Transaction_timeout;}

		Send_count_of_REQ = 17;
		Send_LENGTH_REMAINING = Send_count_of_REQ + 1 - 2;
		Send_Block_data_array[0] = Send_RX_UNLOAD_ACK;
		Send_Block_data_array[1] = Send_LENGTH_REMAINING;
		Send_Block_data_array[2] = _EMSC_SUPPORT_H;
		Send_Block_data_array[3] = _EMSC_SUPPORT_L;
		Send_Block_data_array[4] = 0;						// Checksum
		Send_Block_data_array[5] = 16;						// Total Entire = 16
		Send_Block_data_array[6] = 4;						// SEQ = 4
		Send_Block_data_array[7] = 1;						// NUM_ENT = 1
		Send_Block_data_array[8] = _BLK_RCV_BUFFER_INFO_H										;
		Send_Block_data_array[9] = _BLK_RCV_BUFFER_INFO_L;
		Send_Block_data_array[10] = 0;
		Send_Block_data_array[11] = 0;
		Send_Block_data_array[12] = 0;
		Send_Block_data_array[13] = 0;
		Send_Block_data_array[14] = 0;
		Send_Block_data_array[15] = 0;
		Send_Block_data_array[16] = 0;
		Send_Block_data_array[17] = 0;
		tx_checksum = 0;
		for (i = 2; i < Send_count_of_REQ + 1 -2; i++)	{tx_checksum = tx_checksum + Send_Block_data_array[i];}
		Send_Block_data_array[4] = 256 - (tx_checksum % 256);// Checksum
		if(!drvif_Send_Block_Transaction(Send_Block_data_array,Send_count_of_REQ)) {return Block_Transaction_timeout;}

		Send_RX_UNLOAD_ACK = 0;
		HDMI_PRINTF("PEER_BLK_RX_BUFFER_AVAIL = %d\n\n",PEER_BLK_RX_BUFFER_AVAIL);
		return Block_Transaction_ok;
	}
	return Block_Transaction_peer_out_of_space;
}

int Send_Block_BLK_RCV_BUFFER_INFO(void)
{
	Send_count_of_REQ = 5;
	if (PEER_BLK_RX_BUFFER_AVAIL >= Send_count_of_REQ)
	{
		PEER_BLK_RX_BUFFER_AVAIL = PEER_BLK_RX_BUFFER_AVAIL - (Send_count_of_REQ + 1);
		Send_LENGTH_REMAINING = Send_count_of_REQ + 1 - 2;
		Send_Block_data_array[0] = Send_RX_UNLOAD_ACK;
		Send_Block_data_array[1] = Send_LENGTH_REMAINING;
		Send_Block_data_array[2] = _BLK_RCV_BUFFER_INFO_H;
		Send_Block_data_array[3] = _BLK_RCV_BUFFER_INFO_L;
		Send_Block_data_array[4] = _BLK_RCV_BUFFER_SIZE_L;
		Send_Block_data_array[5] = _BLK_RCV_BUFFER_SIZE_H;
		if(!drvif_Send_Block_Transaction(Send_Block_data_array,Send_count_of_REQ)) {return  Block_Transaction_timeout;}
		Send_RX_UNLOAD_ACK = 0;
		HDMI_PRINTF("PEER_BLK_RX_BUFFER_AVAIL = %d\n\n",PEER_BLK_RX_BUFFER_AVAIL);
		return Block_Transaction_ok;
	}
	return Block_Transaction_peer_out_of_space;
}
#endif

bool drvif_Send_Block_Transaction(unsigned char *emsc_txbuf_wdata, int count)
{
	int i, timeout_cnt;
	rtd_outl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_3_reg,ECBUS_RX_ECBUS_EMSC_TRANS_DET_3_emsc_tx_done_irq_mask);
	rtd_outl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_reg,(ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_crc_inverted_mask | ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_get_error_mask | ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_get_nack_mask | ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_time_out_mask));

	// Step1 : Write Block Transaction Data Byte to TX Buffer
	for (i = 0; i <= count; i++) {rtd_outl(ECBUS_RX_ECBUS_EMSC_TX_DATA_reg,emsc_txbuf_wdata[i]);}

	// Step2 : Set Count Value of REQ Command
	rtd_outl(ECBUS_RX_ECBUS_EMSC_TX_REQ_CNT_reg,count);

	// Step3 : Send Block Transaction
	rtd_maskl(ECBUS_RX_ECBUS_EMSC_TRANS_CTRL_reg,~ECBUS_RX_ECBUS_EMSC_TRANS_CTRL_emsc_tx_sent_mask,ECBUS_RX_ECBUS_EMSC_TRANS_CTRL_emsc_tx_sent_mask);
	HDMI_PRINTF("[MHL3] Waiting for Send Block Transaction...");

	// Step4 : Wait eMSC TX Done
	timeout_cnt = 0;
	while ((((rtd_inl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_3_reg) & ECBUS_RX_ECBUS_EMSC_TRANS_DET_3_emsc_tx_done_irq_mask) != ECBUS_RX_ECBUS_EMSC_TRANS_DET_3_emsc_tx_done_irq_mask) || ((rtd_inl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_reg) & (ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_crc_inverted_mask | ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_get_error_mask | ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_get_nack_mask | ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_time_out_mask)) != 0)) & (timeout_cnt <= 100))
	{
		mdelay(1);
		timeout_cnt = timeout_cnt + 1;
	}

	if (timeout_cnt > 100)
	{
		HDMI_PRINTF("\nTimeout for Send Block Transaction: > 100ms\n");
		return FALSE;
	}

	if ((rtd_inl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_reg) & (ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_crc_inverted_mask | ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_get_error_mask | ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_get_nack_mask | ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_time_out_mask)) != 0)
	{
		if ((rtd_inl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_reg) & ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_crc_inverted_mask) == ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_crc_inverted_mask) { HDMI_PRINTF("\nTX Send Inverted CRC Because of get_invaild\n");}
		if ((rtd_inl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_reg) & ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_get_error_mask) == ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_get_error_mask) { HDMI_PRINTF("\nTX Get Error\n");}
		if ((rtd_inl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_reg) & ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_get_nack_mask) == ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_get_nack_mask) { HDMI_PRINTF("\nTX Get NACK\n");}
		if ((rtd_inl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_reg) & ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_time_out_mask) == ECBUS_RX_ECBUS_EMSC_TRANS_DET_4_tx_time_out_mask) { HDMI_PRINTF("\nTX Timout\n");}
		return FALSE;
	}
	HDMI_PRINTF("OK\n");
	return TRUE;

}


/******************************************************************************
*  FROM QC CODE BEGIN
*******************************************************************************/

bool SET_HPD(void)
{
	int clr_flag = CBUS_FW0_REQ_05_fw0_fin_mask | CBUS_FW0_REQ_05_fw0_cmd_event_mask | CBUS_FW0_REQ_05_fw0_data_event_mask | CBUS_FW0_REQ_05_fw0_rcv_err_mask;
	int timeout_cnt = 0;
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_head_mask,CBUS_FW0_REQ_00_fw0_head(0x2));		// MSC Channel
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_tx_case_mask,CBUS_FW0_REQ_00_fw0_tx_case(0x1));	// MSC(cmd1)
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_fifo_clr_mask,CBUS_FW0_REQ_00_fw0_fifo_clr_mask);		// Clear FIFO
	rtd_outl(CBUS_FW0_REQ_01_reg,CBUS_FW0_REQ_01_get_fw0_cmd1(0x64));  	// cmd1 = SET_HPD
	rtd_maskl(CBUS_FW0_REQ_05_reg,~CBUS_FW0_REQ_05_fw0_wait_case_mask,CBUS_FW0_REQ_05_get_fw0_wait_case(0x1));	// Wait cmd
	rtd_maskl(CBUS_FW0_REQ_05_reg,~clr_flag,clr_flag);		// Clear Receive Flag
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_req_mask,CBUS_FW0_REQ_00_fw0_req_mask);			// Transmit cmd
	HDMI_PRINTF("Sending SET_HPD() => ");

	while (((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_fin_mask) != (CBUS_FW0_REQ_05_fw0_fin_mask)) && (timeout_cnt <= 100))
	{
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;
	}

	if (timeout_cnt > 100)
	{
		HDMI_PRINTF("Reply Timout\n");
		return FALSE;
	}

	if ((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_rcv_err_mask) == CBUS_FW0_REQ_05_fw0_rcv_err_mask)
	{
		HDMI_PRINTF("reply error\n");
		return FALSE;
	}

	HDMI_PRINTF("reply cmd = 0x%02X\n",rtd_inl(CBUS_FW0_REQ_06_reg));	// Reply cmd
	return TRUE;
}

bool SET_INT(int offset, int data)
{
	int clr_flag = CBUS_FW0_REQ_05_fw0_fin_mask | CBUS_FW0_REQ_05_fw0_cmd_event_mask | CBUS_FW0_REQ_05_fw0_data_event_mask | CBUS_FW0_REQ_05_fw0_rcv_err_mask;
	int timeout_cnt = 0;
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_head_mask,CBUS_FW0_REQ_00_fw0_head(0x2));		// MSC Channel
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_tx_case_mask,CBUS_FW0_REQ_00_fw0_tx_case(0x3));	// MSC(cmd1+offset+data)
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_fifo_clr_mask,CBUS_FW0_REQ_00_fw0_fifo_clr_mask);		// Clear FIFO
	rtd_outl(CBUS_FW0_REQ_01_reg,CBUS_FW0_REQ_01_get_fw0_cmd1(0x60));  	// cmd1 = SET_INT
	rtd_outl(CBUS_FW0_REQ_03_reg,CBUS_FW0_REQ_03_fw0_offset(offset));		// offset = 0x20~0x2F
	rtd_outl(CBUS_FW0_REQ_04_reg,CBUS_FW0_REQ_04_fw0_data(data));			// data
	rtd_maskl(CBUS_FW0_REQ_05_reg,~CBUS_FW0_REQ_05_fw0_wait_case_mask,CBUS_FW0_REQ_05_get_fw0_wait_case(0x1));	// Wait cmd
	rtd_maskl(CBUS_FW0_REQ_05_reg,~clr_flag,clr_flag);		// Clear Receive Flag
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_req_mask,CBUS_FW0_REQ_00_fw0_req_mask);			// Transmit cmd
	HDMI_PRINTF("Sending SET_INT(offset = 0x%02X, data = 0x%02X) => ",offset,data);

	while (((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_fin_mask) != CBUS_FW0_REQ_05_fw0_fin_mask) && (timeout_cnt <= 10))
	{
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;
	}

	if (timeout_cnt > 10)
	{
		HDMI_PRINTF("Reply Timout\n");
		return FALSE;
	}

	if ((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_rcv_err_mask) == CBUS_FW0_REQ_05_fw0_rcv_err_mask)
	{
		HDMI_PRINTF("reply error\n");
		return FALSE;
	}

	HDMI_PRINTF("reply cmd = 0x%02X\n",rtd_inl(CBUS_FW0_REQ_06_reg)); // Reply cmd
	return TRUE;
}

bool WRITE_STAT(int offset, int data)
{
	int clr_flag = CBUS_FW0_REQ_05_fw0_fin_mask | CBUS_FW0_REQ_05_fw0_cmd_event_mask | CBUS_FW0_REQ_05_fw0_data_event_mask | CBUS_FW0_REQ_05_fw0_rcv_err_mask;
	int timeout_cnt = 0;
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_head_mask,CBUS_FW0_REQ_00_fw0_head(0x2));		// MSC Channel
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_tx_case_mask,CBUS_FW0_REQ_00_fw0_tx_case(0x3));	// MSC(cmd1+offset+data)
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_fifo_clr_mask,CBUS_FW0_REQ_00_fw0_fifo_clr_mask);		// Clear FIFO
	rtd_outl(CBUS_FW0_REQ_01_reg,CBUS_FW0_REQ_01_get_fw0_cmd1(0x60));  	// cmd1 = WRITE_STAT
	rtd_outl(CBUS_FW0_REQ_03_reg,CBUS_FW0_REQ_03_fw0_offset(offset));		// offset = 0x30~0x3F
	rtd_outl(CBUS_FW0_REQ_04_reg,CBUS_FW0_REQ_04_fw0_data(data));			// data
	rtd_maskl(CBUS_FW0_REQ_05_reg,~CBUS_FW0_REQ_05_fw0_wait_case_mask,CBUS_FW0_REQ_05_get_fw0_wait_case(0x1));	// Wait cmd
	rtd_maskl(CBUS_FW0_REQ_05_reg,~clr_flag,clr_flag);		// Clear Receive Flag
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_req_mask,CBUS_FW0_REQ_00_fw0_req_mask);			// Transmit cmd
	/*HDMI_PRINTF("Sending WRITE_STAT(offset = 0x%02X, data = 0x%02X) => ",offset,data);*/

	while (((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_fin_mask) != CBUS_FW0_REQ_05_fw0_fin_mask) && (timeout_cnt <= 10))
	{
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;
	}

	if (timeout_cnt > 10)
	{
		HDMI_PRINTF("WR_ST:Reply Timout\n");
		return FALSE;
	}

	if ((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_rcv_err_mask) == CBUS_FW0_REQ_05_fw0_rcv_err_mask)
	{
		HDMI_PRINTF("WR_ST:reply error\n");
		return FALSE;
	}

	/*HDMI_PRINTF("reply cmd = 0x%02X\n",rtd_inl(CBUS_FW0_REQ_06_reg)); // Reply cmd*/
	return TRUE;
}

bool WRITE_XSTAT(int offset, int data)
{
	int clr_flag = CBUS_FW0_REQ_05_fw0_fin_mask | CBUS_FW0_REQ_05_fw0_cmd_event_mask | CBUS_FW0_REQ_05_fw0_data_event_mask | CBUS_FW0_REQ_05_fw0_rcv_err_mask;
	int timeout_cnt = 0;
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_head_mask,CBUS_FW0_REQ_00_fw0_head(0x2));		// MSC Channel
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_tx_case_mask,CBUS_FW0_REQ_00_fw0_tx_case(0x3));	// MSC(cmd1+offset+data)
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_fifo_clr_mask,CBUS_FW0_REQ_00_fw0_fifo_clr_mask);		// Clear FIFO
	rtd_outl(CBUS_FW0_REQ_01_reg,CBUS_FW0_REQ_01_get_fw0_cmd1(0x70));  	// cmd1 = WRITE_XSTAT
	rtd_outl(CBUS_FW0_REQ_03_reg,CBUS_FW0_REQ_03_fw0_offset(offset));		// offset = 0x90~0xAF
	rtd_outl(CBUS_FW0_REQ_04_reg,CBUS_FW0_REQ_04_fw0_data(data));			// data
	rtd_maskl(CBUS_FW0_REQ_05_reg,~CBUS_FW0_REQ_05_fw0_wait_case_mask,CBUS_FW0_REQ_05_get_fw0_wait_case(0x1));	// Wait cmd
	rtd_maskl(CBUS_FW0_REQ_05_reg,~clr_flag,clr_flag);		// Clear Receive Flag
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_req_mask,CBUS_FW0_REQ_00_fw0_req_mask);			// Transmit cmd
	HDMI_PRINTF("[MHL3] Sending WRITE_XSTAT(offset = 0x%02X, data = 0x%02X) => \n",offset,data);

	while (((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_fin_mask) != CBUS_FW0_REQ_05_fw0_fin_mask) && (timeout_cnt <= 10))
	{
		hdmi_delayus(1000);
		timeout_cnt =  timeout_cnt + 1;
	}

	if (timeout_cnt > 10)
	{
		HDMI_PRINTF("Reply Timout\n");
		return FALSE;
	}

	if ((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_rcv_err_mask) == CBUS_FW0_REQ_05_fw0_rcv_err_mask)
	{
		HDMI_PRINTF("reply error\n");
		return FALSE;
	}

	/*HDMI_PRINTF("reply cmd = 0x%02X\n",rtd_inl(CBUS_FW0_REQ_06_reg));*/
	return TRUE;
}

bool MSC_MSG(int offset, int data)
{
	int clr_flag = CBUS_FW0_REQ_05_fw0_fin_mask | CBUS_FW0_REQ_05_fw0_cmd_event_mask | CBUS_FW0_REQ_05_fw0_data_event_mask | CBUS_FW0_REQ_05_fw0_rcv_err_mask;
	int timeout_cnt = 0;
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_head_mask,CBUS_FW0_REQ_00_fw0_head(0x2));		// MSC Channel
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_tx_case_mask,CBUS_FW0_REQ_00_fw0_tx_case(0x3));	// MSC(cmd1+offset+data)
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_fifo_clr_mask,CBUS_FW0_REQ_00_fw0_fifo_clr_mask);		// Clear FIFO
	rtd_outl(CBUS_FW0_REQ_01_reg,CBUS_FW0_REQ_01_get_fw0_cmd1(0x68));  	// cmd1 = MSC_MSG
	rtd_outl(CBUS_FW0_REQ_03_reg,CBUS_FW0_REQ_03_fw0_offset(offset));		// offset
	rtd_outl(CBUS_FW0_REQ_04_reg,CBUS_FW0_REQ_04_fw0_data(data));			// data
	rtd_maskl(CBUS_FW0_REQ_05_reg,~CBUS_FW0_REQ_05_fw0_wait_case_mask,CBUS_FW0_REQ_05_get_fw0_wait_case(0x1));	// Wait cmd
	rtd_maskl(CBUS_FW0_REQ_05_reg,~clr_flag,clr_flag);		// Clear Receive Flag
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_req_mask,CBUS_FW0_REQ_00_fw0_req_mask);			// Transmit cmd
	HDMI_PRINTF("Sending MSC_MSG(offset = 0x%02X, data = 0x%02X) => ",offset,data);

	while (((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_fin_mask) != CBUS_FW0_REQ_05_fw0_fin_mask) && (timeout_cnt <= 10))
	{
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;
	}

	if (timeout_cnt > 10)
	{
		HDMI_PRINTF("Reply Timout\n");
		return FALSE;
	}

	if ((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_rcv_err_mask) == CBUS_FW0_REQ_05_fw0_rcv_err_mask)
	{
		HDMI_PRINTF("reply error\n");
		return FALSE;
	}

	HDMI_PRINTF("reply cmd = 0x%02X\n",rtd_inl(CBUS_FW0_REQ_06_reg)); // Reply cmd
	return TRUE;
}

bool READ_DEVCAP(int offset)
{
	int clr_flag = CBUS_FW0_REQ_05_fw0_fin_mask | CBUS_FW0_REQ_05_fw0_cmd_event_mask | CBUS_FW0_REQ_05_fw0_data_event_mask | CBUS_FW0_REQ_05_fw0_rcv_err_mask;
	int timeout_cnt = 0;
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_head_mask,CBUS_FW0_REQ_00_fw0_head(0x2));		// MSC Channel
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_tx_case_mask,CBUS_FW0_REQ_00_fw0_tx_case(0x5));	// MSC(cmd1+offset)
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_fifo_clr_mask,CBUS_FW0_REQ_00_fw0_fifo_clr_mask);		// Clear FIFO
	rtd_outl(CBUS_FW0_REQ_01_reg,CBUS_FW0_REQ_01_get_fw0_cmd1(0x61));  	// cmd1 = READ_DEVCAP
	rtd_outl(CBUS_FW0_REQ_03_reg,CBUS_FW0_REQ_03_fw0_offset(offset));		// offset = 0x00~0x0F
	rtd_maskl(CBUS_FW0_REQ_05_reg,~CBUS_FW0_REQ_05_fw0_wait_case_mask,CBUS_FW0_REQ_05_get_fw0_wait_case(0x3));	// Wait cmd + data
	rtd_maskl(CBUS_FW0_REQ_05_reg,~clr_flag,clr_flag);		// Clear Receive Flag
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_req_mask,CBUS_FW0_REQ_00_fw0_req_mask);			// Transmit cmd
	HDMI_PRINTF("Sending READ_DEVCAP(offset = 0x%02X) => ",offset);

	while (((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_fin_mask) != CBUS_FW0_REQ_05_fw0_fin_mask) && (timeout_cnt <= 10))
	{
		hdmi_delayus(1000);
		timeout_cnt =  timeout_cnt + 1;
	}

	if (timeout_cnt > 10)
	{
		HDMI_PRINTF("Reply Timout\n");
		return FALSE;
	}

	if ((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_rcv_err_mask) == CBUS_FW0_REQ_05_fw0_rcv_err_mask)
	{
		HDMI_PRINTF("reply error\n");
		return FALSE;
	}

	HDMI_PRINTF("reply cmd = 0x%02X, data = 0x%02X\n",rtd_inl(CBUS_FW0_REQ_06_reg),rtd_inl(CBUS_FW0_REQ_07_reg)); // Reply data & cmd
	return TRUE;
}

bool mhl3_read_xdevcap(unsigned int offset)
{
	int clr_flag = CBUS_FW0_REQ_05_fw0_fin_mask|CBUS_FW0_REQ_05_fw0_cmd_event_mask|CBUS_FW0_REQ_05_fw0_data_event_mask|CBUS_FW0_REQ_05_fw0_rcv_err_mask;
	int timeout_cnt = 0;
	rtd_maskl(CBUS_FW0_REQ_00_reg, ~CBUS_FW0_REQ_00_fw0_head_mask, CBUS_FW0_REQ_00_fw0_head(0x2));		// MSC Channel
	rtd_maskl(CBUS_FW0_REQ_00_reg, ~CBUS_FW0_REQ_00_fw0_tx_case_mask, CBUS_FW0_REQ_00_fw0_tx_case(0x5));	// MSC(cmd1+offset)
	rtd_maskl(CBUS_FW0_REQ_00_reg, ~CBUS_FW0_REQ_00_fw0_fifo_clr_mask, CBUS_FW0_REQ_00_fw0_fifo_clr_mask);		// Clear FIFO
	rtd_outl(CBUS_FW0_REQ_01_reg, CBUS_FW0_REQ_01_get_fw0_cmd1(0x71));  	// cmd1 = READ_XDEVCAP
	rtd_outl(CBUS_FW0_REQ_03_reg, CBUS_FW0_REQ_03_fw0_offset(offset));		// offset = 0x80~0x8F
	rtd_maskl(CBUS_FW0_REQ_05_reg, ~CBUS_FW0_REQ_05_fw0_wait_case_mask, CBUS_FW0_REQ_05_get_fw0_wait_case(0x3));	// Wait cmd + data
	rtd_maskl(CBUS_FW0_REQ_05_reg, ~clr_flag,clr_flag);		// Clear Receive Flag
	rtd_maskl(CBUS_FW0_REQ_00_reg, ~CBUS_FW0_REQ_00_fw0_req_mask, CBUS_FW0_REQ_00_fw0_req_mask);			// Transmit cmd
	//HDMI_PRINTF("Sending XREAD_DEVCAP(offset = 0x%02X) => ",offset);

	while (((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_fin_mask) != CBUS_FW0_REQ_05_fw0_fin_mask) && (timeout_cnt <= 10))
	{
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;
	}

	if (timeout_cnt > 10)
	{
		HDMI_PRINTF("Reply Timout\n");
		return FALSE;
	}

	if ((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_rcv_err_mask) == CBUS_FW0_REQ_05_fw0_rcv_err_mask)
	{
		HDMI_PRINTF("reply error\n");
		return FALSE;
	}

	HDMI_PRINTF("reply cmd = 0x%02X, xdata = 0x%02X\n",rtd_inl(CBUS_FW0_REQ_06_reg),rtd_inl(CBUS_FW0_REQ_07_reg)); // Reply data & cmd
	return TRUE;
}

bool GET_DDC_ERRORCODE(void)
{
	int clr_flag = CBUS_FW0_REQ_05_fw0_fin_mask | CBUS_FW0_REQ_05_fw0_cmd_event_mask | CBUS_FW0_REQ_05_fw0_data_event_mask | CBUS_FW0_REQ_05_fw0_rcv_err_mask;
	int timeout_cnt = 0;
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_head_mask,CBUS_FW0_REQ_00_fw0_head(0x2));		// MSC Channel
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_tx_case_mask,CBUS_FW0_REQ_00_fw0_tx_case(0x1));	// MSC(cmd1)
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_fifo_clr_mask,CBUS_FW0_REQ_00_fw0_fifo_clr_mask);		// Clear FIFO
	rtd_outl(CBUS_FW0_REQ_01_reg,CBUS_FW0_REQ_01_get_fw0_cmd1(0x6A));  	// cmd1 = GET_DDC_ERRORCODE
	rtd_maskl(CBUS_FW0_REQ_05_reg,~CBUS_FW0_REQ_05_fw0_wait_case_mask,CBUS_FW0_REQ_05_get_fw0_wait_case(0x2));	// Wait data
	rtd_maskl(CBUS_FW0_REQ_05_reg,~clr_flag,clr_flag);		// Clear Receive Flag
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_req_mask,CBUS_FW0_REQ_00_fw0_req_mask);			// Transmit cmd
	HDMI_PRINTF("Sending GET_DDC_ERRORCODE() => ");

	while (((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_fin_mask) != CBUS_FW0_REQ_05_fw0_fin_mask) && (timeout_cnt <= 10))
	{
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;
	}

	if (timeout_cnt > 10)
	{
		HDMI_PRINTF("Reply Timout\n");
		return FALSE;
	}

	if ((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_rcv_err_mask) == CBUS_FW0_REQ_05_fw0_rcv_err_mask)
	{
		HDMI_PRINTF("reply error\n");
		return FALSE;
	}

	HDMI_PRINTF("reply data = 0x%02X\n",rtd_inl(CBUS_FW0_REQ_07_reg)); // Reply data
	return TRUE;
}

bool GET_MSC_ERRORCODE(void)
{
	int clr_flag = CBUS_FW0_REQ_05_fw0_fin_mask | CBUS_FW0_REQ_05_fw0_cmd_event_mask | CBUS_FW0_REQ_05_fw0_data_event_mask | CBUS_FW0_REQ_05_fw0_rcv_err_mask;
	int timeout_cnt = 0;
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_head_mask,CBUS_FW0_REQ_00_fw0_head(0x2));		// MSC Channel
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_tx_case_mask,CBUS_FW0_REQ_00_fw0_tx_case(0x1));	// MSC(cmd1)
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_fifo_clr_mask,CBUS_FW0_REQ_00_fw0_fifo_clr_mask);		// Clear FIFO
	rtd_outl(CBUS_FW0_REQ_01_reg,CBUS_FW0_REQ_01_get_fw0_cmd1(0x6B));  	// cmd1 = GET_MSC_ERRORCODE
	rtd_maskl(CBUS_FW0_REQ_05_reg,~CBUS_FW0_REQ_05_fw0_wait_case_mask,CBUS_FW0_REQ_05_get_fw0_wait_case(0x2));	// Wait data
	rtd_maskl(CBUS_FW0_REQ_05_reg,~clr_flag,clr_flag);		// Clear Receive Flag
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_req_mask,CBUS_FW0_REQ_00_fw0_req_mask);			// Transmit cmd
	HDMI_PRINTF("Sending GET_MSC_ERRORCODE() => ");

	while (((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_fin_mask) != CBUS_FW0_REQ_05_fw0_fin_mask) && (timeout_cnt <= 10))
	{
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;;
	}

	if (timeout_cnt > 10)
	{
		HDMI_PRINTF("Reply Timout\n");
		return FALSE;
	}

	if ((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_rcv_err_mask) == CBUS_FW0_REQ_05_fw0_rcv_err_mask)
	{
		HDMI_PRINTF("reply error\n");
		return FALSE;
	}

	HDMI_PRINTF("reply data = 0x%02X\n",rtd_inl(CBUS_FW0_REQ_07_reg)); // Reply data
	return TRUE;
}

bool GET_STATE(void)
{
	int clr_flag = CBUS_FW0_REQ_05_fw0_fin_mask | CBUS_FW0_REQ_05_fw0_cmd_event_mask | CBUS_FW0_REQ_05_fw0_data_event_mask | CBUS_FW0_REQ_05_fw0_rcv_err_mask;
	int timeout_cnt = 0;
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_head_mask,CBUS_FW0_REQ_00_fw0_head(0x2));		// MSC Channel
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_tx_case_mask,CBUS_FW0_REQ_00_fw0_tx_case(0x1));	// MSC(cmd1)
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_fifo_clr_mask,CBUS_FW0_REQ_00_fw0_fifo_clr_mask);		// Clear FIFO
	rtd_outl(CBUS_FW0_REQ_01_reg,CBUS_FW0_REQ_01_get_fw0_cmd1(0x62));  	// cmd1 = GET_STATE
	rtd_maskl(CBUS_FW0_REQ_05_reg,~CBUS_FW0_REQ_05_fw0_wait_case_mask,CBUS_FW0_REQ_05_get_fw0_wait_case(0x2));	// Wait data
	rtd_maskl(CBUS_FW0_REQ_05_reg,~clr_flag,clr_flag);		// Clear Receive Flag
	rtd_maskl(CBUS_FW0_REQ_00_reg,~CBUS_FW0_REQ_00_fw0_req_mask,CBUS_FW0_REQ_00_fw0_req_mask);			// Transmit cmd
	HDMI_PRINTF("Sending GET_STATE() => ");

	while (((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_fin_mask) != CBUS_FW0_REQ_05_fw0_fin_mask) && (timeout_cnt <= 10))
	{
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;;
	}

	if (timeout_cnt > 10)
	{
		HDMI_PRINTF("Reply Timout\n");
		return FALSE;
	}

	if ((rtd_inl(CBUS_FW0_REQ_05_reg) & CBUS_FW0_REQ_05_fw0_rcv_err_mask) == CBUS_FW0_REQ_05_fw0_rcv_err_mask)
	{
		HDMI_PRINTF("reply error\n");
		return FALSE;
	}

	HDMI_PRINTF("reply data = 0x%02X\n",rtd_inl(CBUS_FW0_REQ_07_reg)); // Reply data
	return TRUE;
}

bool drvif_CBUS_RX_APHY_initial(void)
{
	/*rtd_outl(0xb8062B30,0x00080B03);		// R50(-) = 0x8 (for echo-cancelling input)*/
										// Enable CBUS RX/TX BAIS & LDO
	rtd_outl(0xb8062B34,0x00000000);
	rtd_outl(0xb8062B38,0x030A3608);
	rtd_outl(0xb8062B3C,0x00000400);
	/*rtd_outl(0xb8062B40,0x0007108E);		// R100K Auto-K Enable*/
	rtd_outl(0xb8062B44,0x1D084643);		// R50(+) = 0x8, R50 Auto-K disable
	rtd_outl(0xb8062B48,0x84042E44);		// eCBUS PLL output = 27MHz*48/6 = 600MHz
	return TRUE;
}

bool drvif_CBUS_RX_DPHY_initial(void)
{
	rtd_outl(0xb8062F00,0x00000010);		// DPHY disable and reset, use 1 stage bub_remove
	rtd_outl(0xb8062F04,0x00000080);		// RX edge position manual mode Enable
	rtd_outl(0xb8062F0C,0x00000090);		// stat detection circuit enable and auto mode
	rtd_outl(0xb8062F10,0x0000000A);		// define timeout threshold value for state detection (COMMA2)
	rtd_outl(0xb8062F14,0x00000004);		// stat_diff_th
	rtd_outl(0xb8062F24,0x00000090);		// ini_bound_en, tx edge auto-k disable
	rtd_outl(0xb8062F28,0x00000002);		// ini_timeout
	rtd_outl(0xb8062F2C,0x00000004);		// ini_wait_cnt
	rtd_outl(0xb8062F30,0x00000014);		// nth_ini
	rtd_outl(0xb8062F34,0x00000006);		// ini_cnt, ini_eq_th[8]
	rtd_outl(0xb8062F38,0x00000032);		// ini_eq_th[7:0], ini_eq_th = 0x32
	rtd_outl(0xb8062F4C,0x00000008);		// DPHY PTG Disable, txdata_delay = 8
	rtd_outl(0xb8062F50,0x0000000B);		// tx_phase_ini
	rtd_outl(0xb8062F54,0x00000000);		// tx_phase_max
	rtd_outl(0xb8062F58,0x00000000);		// tx_phase_min
	rtd_outl(0xb8062F60,0x00000001);		// adapt_mode => 1(min) & 0(max)
	rtd_outl(0xb8062F64,0x00000000);		// adapter_timer = 0
	rtd_outl(0xb8062F68,0x00000014);		// nth_one_m = 20
	rtd_outl(0xb8062F6C,0x00000014);		// nth_zero_m = 20
	rtd_outl(0xb8062F80,0x00000080);		// rx_timeout = 128
	rtd_outl(0xb8062F84,0x00000002);		// comma2_pattern[9:8]
	rtd_outl(0xb8062F88,0x0000007C);		// comma2_pattern[7:0], comma2_pattern = 0x27C
	rtd_outl(0xb8062F90,0x00000000);
	rtd_outl(0xb8062F94,0x00000000);
	rtd_outl(0xb8062F98,0x00000000);
	rtd_outl(0xb8062F9C,0x00000001);		// DPHY Debug Pin enable
	rtd_outl(0xb8062FA0,0x00000000);
	return TRUE;
}

bool drvif_CBUS_RX_MAC_initial(void)
{
	rtd_outl(0xb800A500,0x000000C2);		// MAC Power Disable, LSB First
	rtd_outl(0xb800A504,0x0000004C);		// COMMA2 Debounce Detect = 8, Loss = 1, COMMA1/2 LSB First
	rtd_outl(0xb800A508,0x00000010);		// Check COMMA2 with Disparity
	rtd_outl(0xb800A514,0x000000FF);		// COM1/COM2/Loss/Err Debounce
	rtd_outl(0xb800A520,0x00000010);		// Check COM1 Loss
	rtd_outl(0xb800A524,0x00000085);		// Set Sink TX Slot0
	rtd_outl(0xb800A528,0x000000A0);		// Check Source RX Slot0
	rtd_outl(0xb800A530,0x00000012);		// eMSC Reset
	rtd_outl(0xb800A538,0x00000003);  		// eMSC TX Sync threshold /* set 0 is also ok in merlin */
	rtd_outl(0xb800A5F8,0x00000000);		// CBUS1 CRC Swap
	rtd_maskl(CBUS_oCBUS_CTRL_00_reg, ~CBUS_oCBUS_CTRL_00_cbus3_en_mask, CBUS_oCBUS_CTRL_00_cbus3_en(1));
	return TRUE;
}

bool drvif_CBUS_RX_Capability_Register_Table(void)
{
	rtd_outl(0xb800A004,0x00000032);		// MHL3.2
	rtd_outl(0xb800A008,0x00000031);		// Device Sink, Output VBUS 900mA
	rtd_outl(0xb800A00C, CDF_CR_ADOPTER_ID_H);		// Apaptor ID MSB
	rtd_outl(0xb800A010, CDF_CR_ADOPTER_ID_L);		// Apaptor ID LSB
	rtd_outl(0xb800A014,0x0000003F);		// Support VGA, Data Island, PP-Mode, YUV(422/444), RGB(444)
	rtd_outl(0xb800A018,0x00000001);		// 2ch/8ch PCM Audio
	rtd_outl(0xb800A01C,0x00000000);		// VT Mode
	rtd_outl(0xb800A020,0x00000041);		// Audio output, Display output
	rtd_outl(0xb800A024,0x0000000F);		// MHL B/W
	rtd_outl(0xb800A028,0x0000005F);		// RBP, UCP_RX, UCP_TX, SP, RAP, RCP Support
	rtd_outl(0xb800A02C,0x000000AB);		// Device ID LSB
	rtd_outl(0xb800A030,0x000000CD);		// Device ID MSB
	rtd_outl(0xb800A034,0x00000010);		// Scratchpad_size = 16-Byte
	rtd_outl(0xb800A038,0x00000033);		// STAT_size = 4-Byte, INT_size = 4-Byte
	rtd_outl(0xb800A180,0x00000003);		// eCBUS-S 8-bit Mode support only
	rtd_outl(0xb800A184,0x00000007);		// TMDS Support 6Gbps
	rtd_outl(0xb800A188,0x00000012);		// HID Device, Charger, USB Device
	rtd_outl(0xb800A18C,0x00000000);		// Not Support Phone function
	rtd_outl(0xb800A190,0x00000000);		// ACRFD_DIV_SUPPORT
	rtd_outl(0xb800A400,0x00000080);		// CBUS3 Function Enable, CBUS1 Disable
	return TRUE;
}


/**************************************************
*
*
*
**************************************************/
void drvif_mhl3_cbus_switch(unsigned char is_ecbus)
{
	if (is_ecbus) {
		rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg, ~CBUS_PMM_CBUS_PHY_4_en_cbus_rx_mask, 0);
		rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg, ~CBUS_PMM_CBUS_PHY_4_mhl_bmos_en_rx_mask, 0);
		rtd_maskl(CBUS_PMM_CBUS_PHY_5_reg, ~CBUS_PMM_CBUS_PHY_5_en_buf_ecbusrx_mask, CBUS_PMM_CBUS_PHY_5_en_buf_ecbusrx_mask);
		rtd_maskl(CBUS_PMM_CBUS_PHY_6_reg, ~CBUS_PMM_CBUS_PHY_6_pll_pow_ecbusrx_mask, CBUS_PMM_CBUS_PHY_6_pll_pow_ecbusrx_mask);
		rtd_maskl(CBUS_PMM_CBUS_PHY_6_reg, ~CBUS_PMM_CBUS_PHY_6_pll_ldo_pow_ecbusrx_mask, CBUS_PMM_CBUS_PHY_6_pll_ldo_pow_ecbusrx_mask);

		rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_reg, ~ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_en_mask, ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_en_mask);
		rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_reg, ~ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_rstn_mask, ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_rstn_mask);

		rtd_maskl(CBUS_oCBUS_CTRL_00_reg, ~CBUS_oCBUS_CTRL_00_cbus1_en_mask, CBUS_oCBUS_CTRL_00_cbus1_en_mask);
	} else {

		rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg, ~ECBUS_RX_ECBUS_STARTUP_CTRL_ecbus_pwup_mask, 0);
		rtd_maskl(ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_reg, ~ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_emsc_reset_mask, ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_emsc_reset_mask);	// eMSC Reset

		rtd_maskl(CBUS_oCBUS_CTRL_00_reg, ~(CBUS_oCBUS_CTRL_00_cbus1_en_mask|CBUS_oCBUS_CTRL_00_cbus3_en_mask), 0);

		rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_reg, ~ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_en_mask, 0);
		rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_reg, ~ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_rstn_mask, 0);

		rtd_maskl(CBUS_PMM_CBUS_PHY_5_reg, ~CBUS_PMM_CBUS_PHY_5_en_buf_ecbusrx_mask, 0);
		rtd_maskl(CBUS_PMM_CBUS_PHY_6_reg, ~CBUS_PMM_CBUS_PHY_6_pll_pow_ecbusrx_mask, 0);
		rtd_maskl(CBUS_PMM_CBUS_PHY_6_reg, ~CBUS_PMM_CBUS_PHY_6_pll_ldo_pow_ecbusrx_mask, 0);
		rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg, ~CBUS_PMM_CBUS_PHY_4_mhl_bmos_en_rx_mask, CBUS_PMM_CBUS_PHY_4_mhl_bmos_en_rx_mask);
		rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg, ~CBUS_PMM_CBUS_PHY_4_en_cbus_rx_mask, CBUS_PMM_CBUS_PHY_4_en_cbus_rx_mask);
	}

}

bool drvif_switch_to_oCBUS(unsigned char wakeup_done)
{
	rtd_maskl(CBUS_PMM_CBUS_PHY_5_reg,~CBUS_PMM_CBUS_PHY_5_en_buf_ecbusrx_mask,0);			//Disable eCBUS Driver & echo-cancelling circuit
	rtd_maskl(CBUS_PMM_CBUS_PHY_6_reg,~CBUS_PMM_CBUS_PHY_6_pll_pow_ecbusrx_mask,0);			// Disable eCBUS PLL
	rtd_maskl(CBUS_PMM_CBUS_PHY_6_reg,~CBUS_PMM_CBUS_PHY_6_pll_ldo_pow_ecbusrx_mask,0);		// Disable eCBUS LDO
	rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg,~CBUS_PMM_CBUS_PHY_4_en_cbus_rx_mask,CBUS_PMM_CBUS_PHY_4_en_cbus_rx_mask);					// Enable CBUS_RX
	rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg,~CBUS_PMM_CBUS_PHY_4_sel_cbusb_gpio_rx_mask,0);												// Pinshare to CBUS
	rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg,~CBUS_PMM_CBUS_PHY_4_mhl_bmos_en_rx_mask,CBUS_PMM_CBUS_PHY_4_mhl_bmos_en_rx_mask);		// Enable CBUS_RX BMOS
	rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg,~CBUS_PMM_CBUS_PHY_4_en_res_cal_cbus_rx_mask,0);												// R100K Auto-K Trigger Disable
	rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg,~CBUS_PMM_CBUS_PHY_4_en_res_cal_cbus_rx_mask,CBUS_PMM_CBUS_PHY_4_en_res_cal_cbus_rx_mask);	// R100K Auto-K Trigger
	rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_reg,ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_en_mask,0);								// eCBUS DPHY Disable
	rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_reg,ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_rstn_mask,0);							// eCBUS DPHY Reset
	rtd_maskl(CBUS_oCBUS_CTRL_00_reg,~CBUS_oCBUS_CTRL_00_cbus1_en_mask,0);															// CBUS1 Disable
	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg,~ECBUS_RX_ECBUS_STARTUP_CTRL_ecbus_pwup_mask,0);									// MAC Power Disable
	rtd_maskl(ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_reg,~ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_emsc_reset_mask,ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_emsc_reset_mask);	// eMSC Reset
	if (wakeup_done) {
		rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask));
	} else {
		rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask));
	}
#if 0
	HDMI_PRINTF("Waiting for R100K Auto-K Finish, about 100us...");
	int timeout_cnt = 0;
	while ((CBUS_PMM_CBUS_PHY_4_get_cbus_1kohm_cal_ok(rtd_inl(CBUS_PMM_CBUS_PHY_4)) != 1) && (timeout_cnt <= 15))
	{
		udelay(1);
		timeout_cnt = timeout_cnt + 1;
	}

	if (timeout_cnt > 15)
	{
		HDMI_PRINTF("\nTimeout for R100K Auto-K : > 15us\n");
		return FALSE;
	}
	HDMI_PRINTF("OK!\n");
#endif
	return TRUE;
}

bool drvif_switch_to_eCBUS(void)
{
/*	rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask));*/
	rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg,~CBUS_PMM_CBUS_PHY_4_en_cbus_rx_mask,0);				// Disable CBUS_RX
	rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg,~CBUS_PMM_CBUS_PHY_4_sel_cbusb_gpio_rx_mask,0);		// Pinshare to CBUS
	rtd_maskl(CBUS_PMM_CBUS_PHY_4_reg,~CBUS_PMM_CBUS_PHY_4_mhl_bmos_en_rx_mask,0);		// Disable CBUS_RX BMOS
	rtd_maskl(CBUS_PMM_CBUS_PHY_5_reg,~CBUS_PMM_CBUS_PHY_5_en_buf_ecbusrx_mask,CBUS_PMM_CBUS_PHY_5_en_buf_ecbusrx_mask);			//Enable eCBUS Driver & echo-cancelling circuit
	rtd_maskl(CBUS_PMM_CBUS_PHY_6_reg,~CBUS_PMM_CBUS_PHY_6_pll_pow_ecbusrx_mask,CBUS_PMM_CBUS_PHY_6_pll_pow_ecbusrx_mask);			// Enable eCBUS PLL
	rtd_maskl(CBUS_PMM_CBUS_PHY_6_reg,~CBUS_PMM_CBUS_PHY_6_pll_ldo_pow_ecbusrx_mask,CBUS_PMM_CBUS_PHY_6_pll_ldo_pow_ecbusrx_mask);	// Enable eCBUS LDO
	rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_en_mask,ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_en_mask);		// eCBUS DPHY Enable
	rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_rstn_mask,ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_rstn_mask);	// eCBUS DPHY Reset Release
	rtd_maskl(CBUS_oCBUS_CTRL_00_reg,~CBUS_oCBUS_CTRL_00_cbus1_en_mask,CBUS_oCBUS_CTRL_00_cbus1_en_mask);							// CBUS1 Enable
	return TRUE;
}

bool drvif_eCBUS_Start_Up(void)
{
	int timeout_cnt;
	int rx_edge[3] = {0,0,0};
	int edge_error = 0x20;
	int i;
	timer_7_reset();
	rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_rstn_mask,0);														// DPHY Reset
	rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_rstn_mask,ECBUS_RX_DPHY_ECBUS_DPHY_CTRL_ecbus_dphy_rstn_mask);	// DPHY Reset Release

	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg,~ECBUS_RX_ECBUS_STARTUP_CTRL_ecbus_pwup_mask,0);																// MAC Power Disable
	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg,~ECBUS_RX_ECBUS_STARTUP_CTRL_ecbus_reset_mask,ECBUS_RX_ECBUS_STARTUP_CTRL_ecbus_reset_mask);					// MAC Reset
	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg,~ECBUS_RX_ECBUS_STARTUP_CTRL_ecbus_pwup_mask,ECBUS_RX_ECBUS_STARTUP_CTRL_ecbus_pwup_mask);					// MAC Power Enable
	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg,~ECBUS_RX_ECBUS_STARTUP_CTRL_ecbus_reset_mask,0);																// MAC Reset Release

	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CONFIG_reg,~ECBUS_RX_ECBUS_STARTUP_CONFIG_bwd_type_mask,ECBUS_RX_ECBUS_STARTUP_CONFIG_bwd_type(0));				// BTX = S0
	rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_CALIB_CTRL_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_CALIB_CTRL_tx_calib_en_mask,0);												// DPHY TX edge Auto-K Disable
	rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_edge_pos_manual_mask,ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_edge_pos_manual_mask);	// DPHY RX edge Manual Mode

	/*HDMI_PRINTF("Finding RX Edge Position...");*/

	timeout_cnt = 0;
	while (timeout_cnt <= 1000)
	{
		for (i = 0; i < 3; i++)
		{
			rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_edge_position_m_5_0_mask,ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_edge_position_m_5_0(0x10));	// RX edge initial position set 0x10
			rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_edge_calib_en_mask,0);																			// Auto find RX Edge Disable
			rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_edge_calib_en_mask,ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_edge_calib_en_mask);					// Auto find RX Edge Enable
			hdmi_delayus(5);
			timeout_cnt = timeout_cnt + 5;
			rx_edge[i] = rtd_inl(ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_RESULT_reg) & ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_RESULT_edge_calib_position_5_0_mask;	// find RX Edge
			edge_error = rtd_inl(ECBUS_RX_DPHY_ECBUS_DPHY_FLAG_reg) & ECBUS_RX_DPHY_ECBUS_DPHY_FLAG_edge_error_mask;								// find RX Edge error
			if (edge_error == ECBUS_RX_DPHY_ECBUS_DPHY_FLAG_edge_error_mask)
			{
				i = 0;
				break;
			}
		}
		if ((i != 0) && (rx_edge[0] == rx_edge[1]) && (rx_edge[1] == rx_edge[2]) && (rx_edge[0] != 0))
		{
			break;
		}
	}

	if (timeout_cnt > 1000)
	{
		HDMI_PRINTF("\nTimeout for DPHY Find RX Edge : > 5ms\n");
		return FALSE;
	}

	/*HDMI_PRINTF("OK!\n");*/
	rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_edge_position_m_5_0_mask,ECBUS_RX_DPHY_ECBUS_DPHY_EDGE_CTRL_edge_position_m_5_0(((rx_edge[1] - 3 + 40) % 40)));
	//jtest- mag2: rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_TX_PHASE_CONFIG_2_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_TX_PHASE_CONFIG_2_tx_phase_ini_5_0_mask,ECBUS_RX_DPHY_ECBUS_DPHY_TX_PHASE_CONFIG_2_tx_phase_ini_5_0((14 + 3 + 40) % 40));
	rtd_maskl(ECBUS_RX_DPHY_ECBUS_DPHY_TX_PHASE_CONFIG_2_reg,~ECBUS_RX_DPHY_ECBUS_DPHY_TX_PHASE_CONFIG_2_tx_phase_ini_5_0_mask,ECBUS_RX_DPHY_ECBUS_DPHY_TX_PHASE_CONFIG_2_tx_phase_ini_5_0(35));

#if 1
	HDMI_PRINTF("[mhl3][jtest] find edge(b) = %d (%08x,%08x)\n", rx_edge[1], rtd_inl(0xb8062f00), rtd_inl(0xb8062f08)); /*takes around 8ms*/
	hdmi_delayus(5000); /* 10ms<Tsnk_cal1<30ms*/
#else
	/*HDMI_PRINTF("DPHY RX Edge has Found (from Source send stable clock) : %dms\n",rtd_inl(TC7CVR)/27000);
	i = rtd_inl(TC7CVR)/27000;
	if (i < 12)	{mdelay(12-i);}*/
	hdmi_delayus(10000); /* 10ms<Tsnk_cal1<30ms*/
#endif
	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CONFIG_reg,~ECBUS_RX_ECBUS_STARTUP_CONFIG_bwd_type_mask,ECBUS_RX_ECBUS_STARTUP_CONFIG_bwd_type(3));	// BTX = S1
	/*HDMI_PRINTF("Sink begin to send back clock (from Source send stable clock) : %dms\n",rtd_inl(TC7CVR)/27000);
	timer_7_reset();
	i = rtd_inl(TC7CVR)/27000;
	if (i < 12) {mdelay(12-i);}*/
	hdmi_delayus(9000); /* 10ms<Tsnk_cal<30ms*/
	HDMI_PRINTF("Sink begins to send back COMMA1\n");

	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CONFIG_reg,~ECBUS_RX_ECBUS_STARTUP_CONFIG_bwd_type_mask,ECBUS_RX_ECBUS_STARTUP_CONFIG_bwd_type(1));	// BTX = COMMA1
	timer_7_reset();

	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg,~ECBUS_RX_ECBUS_STARTUP_CTRL_comma2_det_en_mask,0);												// COMMA2 detect disable
	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_DET_reg,~(ECBUS_RX_ECBUS_STARTUP_DET_comma2_loss_irq_mask | ECBUS_RX_ECBUS_STARTUP_DET_comma2_rcv_irq_mask),(ECBUS_RX_ECBUS_STARTUP_DET_comma2_loss_irq_mask | ECBUS_RX_ECBUS_STARTUP_DET_comma2_rcv_irq_mask));	// Clear COMMA1 Detect/Loss Flag
	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CONFIG_reg,~ECBUS_RX_ECBUS_STARTUP_CONFIG_comma2_loss_thd_mask,ECBUS_RX_ECBUS_STARTUP_CONFIG_get_comma2_loss_thd(0));	// COMMA2 Debounce Loss = 1
	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg,~ECBUS_RX_ECBUS_STARTUP_CTRL_comma2_det_en_mask,ECBUS_RX_ECBUS_STARTUP_CTRL_comma2_det_en_mask);				// COMMA2 detect Enable

	HDMI_PRINTF("Detect COMMA2...");
	timeout_cnt = 0;
	while (((rtd_inl(ECBUS_RX_ECBUS_STARTUP_DET_reg) & (ECBUS_RX_ECBUS_STARTUP_DET_comma2_loss_irq_mask | ECBUS_RX_ECBUS_STARTUP_DET_comma2_rcv_irq_mask)) != ECBUS_RX_ECBUS_STARTUP_DET_comma2_rcv_irq_mask) & (timeout_cnt <= 50000))
	{
		hdmi_delayus(50);
		timeout_cnt = timeout_cnt + 5;
		if ((rtd_inl(ECBUS_RX_ECBUS_STARTUP_DET_reg) & (ECBUS_RX_ECBUS_STARTUP_DET_comma2_loss_irq_mask | ECBUS_RX_ECBUS_STARTUP_DET_comma2_rcv_irq_mask)) == (ECBUS_RX_ECBUS_STARTUP_DET_comma2_loss_irq_mask | ECBUS_RX_ECBUS_STARTUP_DET_comma2_rcv_irq_mask))
		{
			rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg,~ECBUS_RX_ECBUS_STARTUP_CTRL_comma2_det_en_mask,0);													// COMMA2 detect Disable
			rtd_maskl(ECBUS_RX_ECBUS_STARTUP_DET_reg,~(ECBUS_RX_ECBUS_STARTUP_DET_comma2_loss_irq_mask | ECBUS_RX_ECBUS_STARTUP_DET_comma2_rcv_irq_mask),(ECBUS_RX_ECBUS_STARTUP_DET_comma2_loss_irq_mask | ECBUS_RX_ECBUS_STARTUP_DET_comma2_rcv_irq_mask));	// Clear Flag
			rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg,~ECBUS_RX_ECBUS_STARTUP_CTRL_comma2_det_en_mask,ECBUS_RX_ECBUS_STARTUP_CTRL_comma2_det_en_mask);	// COMMA2 detect Enable
		}
	}

	if (timeout_cnt > 50000)
	{
		HDMI_PRINTF("\nTimeout for Detect COMMA2 : > 50ms\n");
		return FALSE;
	}

	hdmi_delayus(12000); /* 10ms<Tsnk_balign<30ms*/

	/*HDMI_PRINTF("OK!\nSink has detected COMMA2 (from Sink begin to send COMMA1) : %dms\n",rtd_inl(TC7CVR)/27000);*/

	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CONFIG_reg,~ECBUS_RX_ECBUS_STARTUP_CONFIG_bwd_type_mask,ECBUS_RX_ECBUS_STARTUP_CONFIG_bwd_type(2));	// BTX = COMMA2
	HDMI_PRINTF("Sink begin to send COMMA2 (from Sink begin to send COMMA1) : %dms\n",rtd_inl(TC7CVR)/27000);
	timer_7_reset();

	/*HDMI_PRINTF("Waiting for Source Enter Active State...");*/
	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CONFIG_reg,~ECBUS_RX_ECBUS_STARTUP_CONFIG_comma2_loss_thd_mask,ECBUS_RX_ECBUS_STARTUP_CONFIG_get_comma2_loss_thd(3));        // COMMA2 Debounce Loss = 8
	timeout_cnt = 0;
	while (((rtd_inl(ECBUS_RX_ECBUS_STARTUP_DET_reg) & (ECBUS_RX_ECBUS_STARTUP_DET_comma2_loss_irq_mask | ECBUS_RX_ECBUS_STARTUP_DET_comma2_rcv_irq_mask)) != (ECBUS_RX_ECBUS_STARTUP_DET_comma2_loss_irq_mask | ECBUS_RX_ECBUS_STARTUP_DET_comma2_rcv_irq_mask)) && (timeout_cnt<100)) {
		hdmi_delayus(1000);
		timeout_cnt++;
	}

	if (timeout_cnt>=100) {
		HDMI_PRINTF("\nTimeout for Source Enter Active State\n");
		return FALSE;
	}
	HDMI_PRINTF("Source begin to Enter Active State (from Sink begin to send COMMA2)\n");
	return TRUE;
}

#if 0
bool drvif_eCBUS_Shut_Down(void)
{
	HDMI_PRINTF("\n\nBegin CBUS Discovery !!!\n");
	if(!drvif_switch_to_oCBUS()) {return FAILED;}	/* oCBUS APHY Enable, eCBUS APHY Disable*/

	if(!GET_STATE())
	{
		HDMI_PRINTF("Waiting for Wake-up & Discovery pulse...");
		int timeout_cnt = 0;
		while (((rtd_inl(CBUS_PMM_CBUS_STANDBY_00_reg) & 0xC) != 0xC) && (timeout_cnt <= 1500)) {
			mdelay(1);
			timeout_cnt = timeout_cnt + 1;
		}

		if (timeout_cnt > 1500) {
			HDMI_PRINTF("\nTimeout for waiting Wake-Up & Discovery Pulse : > 1500ms\n");
			return FALSE;
		}

		rtd_outl(CBUS_PMM_CBUS_STANDBY_00_reg, 0xC);	/* Clear Wake-up & Discovery pulse Flag*/
		HDMI_PRINTF("OK!\n");
	}

	return TRUE;
}
#endif

bool drvif_eCBUS_TDM_Slot_Sync(void)
{
              int timeout_cnt = 0;
	timer_7_reset();
	rtd_maskl(ECBUS_RX_ECBUS_STARTUP_CTRL_reg,~ECBUS_RX_ECBUS_STARTUP_CTRL_comma2_det_en_mask,0);	// COMMA2 detect Disable
	HDMI_PRINTF("Start TDM Slot Sync Procedure...\n");
	rtd_outl(ECBUS_RX_ECBUS_TDM_SYNC_CTRL_reg,ECBUS_RX_ECBUS_TDM_SYNC_CTRL_com1_det_en_mask);	// Enable detect COM1 Circuit
	rtd_maskl(ECBUS_RX_ECBUS_TDM_SYNC_DET_2_reg,~(ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_loss_irq_mask | ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_irq_mask),(ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_loss_irq_mask | ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_irq_mask));	// Clear COM1 Detect/Loss Flag
	rtd_outl(ECBUS_RX_ECBUS_TDM_SYNC_CTRL_reg,(ECBUS_RX_ECBUS_TDM_SYNC_CTRL_com1_det_en_mask | ECBUS_RX_ECBUS_TDM_SYNC_CTRL_enter_tdm_active_mask));					// Enter_TDM_Active


	while (((rtd_inl(ECBUS_RX_ECBUS_TDM_SYNC_DET_2_reg) & (ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_loss_irq_mask | ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_irq_mask)) != ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_irq_mask) && (timeout_cnt <= 5))
	{
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;
		if ((rtd_inl(ECBUS_RX_ECBUS_TDM_SYNC_DET_2_reg) & (ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_loss_irq_mask | ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_irq_mask)) == (ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_loss_irq_mask | ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_irq_mask))
		{
			rtd_maskl(ECBUS_RX_ECBUS_TDM_SYNC_DET_2_reg,~(ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_loss_irq_mask | ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_irq_mask),(ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_loss_irq_mask | ECBUS_RX_ECBUS_TDM_SYNC_DET_2_tdm_sync_irq_mask));
			break;
        		}
	}

	if (timeout_cnt > 5)
	{
		HDMI_PRINTF("\nTimeout for TDM Slot Sync : > 5ms\n");
		return FALSE;
	}

	/*HDMI_PRINTF("OK!\nSink has detected IDLE-COM2 (from Source Enate Active State) : %dms\n", rtd_inl(TC7CVR)/27000);*/
	return TRUE;
}

bool drvif_eCBUS_eMSC_Link_Training(void)
{
	int timeout_cnt  = 0;
	unsigned int emsc_pass_mask = ECBUS_RX_ECBUS_EMSC_SYNC_DET_slot_det_done_mask | ECBUS_RX_ECBUS_EMSC_SYNC_DET_emsc_link_done_mask | ECBUS_RX_ECBUS_EMSC_SYNC_DET_mark_rcv_mask | ECBUS_RX_ECBUS_EMSC_SYNC_DET_rx_sync_meet_mask | ECBUS_RX_ECBUS_EMSC_SYNC_DET_sync_rcv_mask;
	unsigned int emsc_fail_mask = ECBUS_RX_ECBUS_EMSC_SYNC_DET_mark_loss_irq_mask | ECBUS_RX_ECBUS_EMSC_SYNC_DET_sync_loss_mask;
	rtd_maskl(ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_reg,~ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_emsc_reset_mask,ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_emsc_reset_mask);	// eMSC Reset
	rtd_maskl(ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_reg,~ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_emsc_reset_mask,0);													// eMSC Reset Release
	HDMI_PRINTF("Waiting for eMSC Link Training...");


	while ((((rtd_inl(ECBUS_RX_ECBUS_EMSC_SYNC_DET_reg) & emsc_pass_mask) != emsc_pass_mask)) && (timeout_cnt <= 5))
	{
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;
		if (((rtd_inl(ECBUS_RX_ECBUS_EMSC_SYNC_DET_reg) & emsc_fail_mask) == ECBUS_RX_ECBUS_EMSC_SYNC_DET_sync_loss_mask) || ((rtd_inl(ECBUS_RX_ECBUS_EMSC_SYNC_DET_reg) & emsc_fail_mask) == ECBUS_RX_ECBUS_EMSC_SYNC_DET_mark_loss_irq_mask))
		{
			rtd_outl(ECBUS_RX_ECBUS_EMSC_SYNC_DET_reg,0xFE);
		}
		HDMI_PRINTF("\neMSC Link Training Fail : 0xb800A53C = %02X\n",rtd_inl(ECBUS_RX_ECBUS_EMSC_SYNC_DET_reg));
	}

	if (timeout_cnt > 5)
	{
		HDMI_PRINTF("\nTimeout for eMSC Link Training : > 5ms\n");
		return FALSE;
	}

	HDMI_PRINTF("OK!\n");
	return TRUE;
}

bool drvif_Enable_MHL_Z0(void)
{
	rtd_maskl(DFE_HDMI_RX_PHY_Z0POW_reg,~DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_b_mask,DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_b(7));
	rtd_maskl(DFE_HDMI_RX_PHY_Z0POW_reg,~DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_ck_mask,DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_ck(7));
	rtd_maskl(DFE_HDMI_RX_PHY_Z0POW_reg,~DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_g_mask,DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_g(7));
	rtd_maskl(DFE_HDMI_RX_PHY_Z0POW_reg,~DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_r_mask,DFE_HDMI_RX_PHY_Z0POW_reg_z0_z0pow_r(7));
	rtd_maskl(DFE_HDMI_RX_PHY_Z0POW_reg,~DFE_HDMI_RX_PHY_Z0POW_reg_z0_z100_en_mask,DFE_HDMI_RX_PHY_Z0POW_reg_z0_z100_en(4));
	rtd_maskl(DFE_HDMI_RX_PHY_Z0POW_reg,~DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300pow_mask,DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300pow(4));
	rtd_maskl(DFE_HDMI_RX_PHY_Z0POW_reg,~DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300_sel_mask,DFE_HDMI_RX_PHY_Z0POW_reg_z0_z300_sel(4));
	return TRUE;
}

bool drvif_Measure_CK_GDI(void)
{
	int timeout_cnt;
	int cnt_start = 0x1;
	int cnt_end = 0x7FF;
	int xtal_cnt = (int)((cnt_end - cnt_start)*27/75);
	rtd_maskl(0xb8060044, 0xFFFFFEFF, 0x00000100);	/* Clock enable bit for HDMI Clock Detection*/
	rtd_maskl(0xb8060058, 0xFFFFFFF7, 0x00000008);	/* Clock Source Select CK_GDI*/
	rtd_maskl(HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_reg, ~HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_dclk_cnt_start_mask, HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_dclk_cnt_start(cnt_start));
	rtd_maskl(HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_reg, ~HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_dclk_cnt_end_mask, HDMI_CLKDET_GDI_TMDSCLK_SETTING_00_dclk_cnt_end(cnt_end));
	rtd_maskl(HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_reg, ~HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_target_for_maximum_clk_counter_mask, HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_target_for_maximum_clk_counter(xtal_cnt+1));	// Result of XTAL Count CK_GDI max
	rtd_maskl(HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_reg, ~HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_target_for_minimum_clk_counter_mask, HDMI_CLKDET_GDI_TMDSCLK_SETTING_01_target_for_minimum_clk_counter(xtal_cnt-1));	// Result of XTAL Count CK_GDI min
	rtd_maskl(HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_reg, ~HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_clk_counter_err_threshold_mask, HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_clk_counter_err_threshold(3));	// Measure  error threshold = 3
	rtd_maskl(HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_reg, ~HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_clk_counter_debounce_mask, HDMI_CLKDET_GDI_TMDSCLK_SETTING_02_clk_counter_debounce(16));			// Measure 16 Time, total need about 1ms

	/*HDMI_PRINTF("Waiting for Source send 75MHz Stable Clock...");*/
	timer_7_reset();

	rtd_maskl(HDMI_CLKDET_CLKDETCR_reg, ~HDMI_CLKDET_CLKDETCR_clock_det_en_mask, 0);	// CK_GDI Clock Detect Disable
	rtd_outl(HDMI_CLKDET_CLKDETSR_reg, (HDMI_CLKDET_CLKDETSR_clk_in_target_mask|HDMI_CLKDET_CLKDETSR_tmds_chg_irq_mask));	// Clear Flag
	rtd_maskl(HDMI_CLKDET_CLKDETCR_reg, ~HDMI_CLKDET_CLKDETCR_clock_det_en_mask, HDMI_CLKDET_CLKDETCR_clock_det_en_mask);	// CK_GDI Clock Detect Enable
	timeout_cnt = 0;
	while (!(HDMI_CLKDET_CLKDETSR_get_clk_in_target(rtd_inl(HDMI_CLKDET_CLKDETSR_reg))) && (timeout_cnt <= 500)) {
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;
	}
#if 0
	while (((HDMI_CLKDET_CLKDETSR_get_clk_in_target(rtd_inl(HDMI_CLKDET_CLKDETSR_reg))) != 1) && (timeout_cnt <= 300)) {
		hdmi_delayus(1000);
		timeout_cnt = timeout_cnt + 1;
		rtd_maskl(HDMI_CLKDET_CLKDETCR_reg, ~HDMI_CLKDET_CLKDETCR_clock_det_en_mask, 0);	// CK_GDI Clock Detect Disable
		rtd_outl(HDMI_CLKDET_CLKDETSR_reg, (HDMI_CLKDET_CLKDETSR_clk_in_target_mask | HDMI_CLKDET_CLKDETSR_tmds_chg_irq_mask));	// Clear Flag
		rtd_maskl(HDMI_CLKDET_CLKDETCR_reg, ~HDMI_CLKDET_CLKDETCR_clock_det_en_mask, HDMI_CLKDET_CLKDETCR_clock_det_en_mask);	// CK_GDI Clock Detect Enable
		while (rtd_inl(HDMI_CLKDET_CLKDETSR_reg) != (HDMI_CLKDET_CLKDETSR_clk_in_target_mask | HDMI_CLKDET_CLKDETSR_tmds_chg_irq_mask)) {}
		rtd_outl(HDMI_CLKDET_CLKDETSR_reg, HDMI_CLKDET_CLKDETSR_tmds_chg_irq_mask);		// Clear Clock Change Flag
	}
#endif
	if (timeout_cnt > 500) {
		HDMI_PRINTF("\nTimeout for Source send 75MHz Stable Clock : > 300ms\n");
		return FALSE;
	}

	rtd_outl(HDMI_CLKDET_CLKDETSR_reg, HDMI_CLKDET_CLKDETSR_tmds_chg_irq_mask);		// Clear Clock Change Flag

	/*HDMI_PRINTF("OK! => Take %dms\n",rtd_inl(TC7CVR)/27000);*/
	rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask)); /* 6.4.12.2 avoid disconn flag */
	return TRUE;
}

bool drvif_Measure_CK_GDI_get(void)
{
	rtd_maskl(HDMI_CLKDET_CLKDETCR_reg,~HDMI_CLKDET_CLKDETCR_clock_det_en_mask,0);	// CK_GDI Clock Detect Disable
	rtd_outl(HDMI_CLKDET_CLKDETSR_reg,(HDMI_CLKDET_CLKDETSR_clk_in_target_mask | HDMI_CLKDET_CLKDETSR_tmds_chg_irq_mask));	// Clear Flag
	rtd_maskl(HDMI_CLKDET_CLKDETCR_reg,~HDMI_CLKDET_CLKDETCR_clock_det_en_mask,HDMI_CLKDET_CLKDETCR_clock_det_en_mask);	// CK_GDI Clock Detect Enable
	hdmi_delayus(1000);
	return (HDMI_CLKDET_CLKDETSR_get_clk_in_target(rtd_inl(HDMI_CLKDET_CLKDETSR_reg)));
}

unsigned int mhl3_slot_assignment(void)
{
	unsigned char N = emsc_slot_size;
	unsigned char M = TOTAL_SLOT_NUM - emsc_slot_size - 1;
	unsigned char slot_num = 1, cnt = 0, N_done = 0;
	unsigned int slot_map = 0;

	while (N_done < N) {
		if (cnt < N) {
			slot_map |= (1<<(slot_num-1));
			N_done ++;
		}
		cnt = (cnt+N)%(N+M);
		slot_num = (slot_num+1)%(1+N+M);
	}
	HDMI_PRINTF("[MHL3] slot map=%x\n", slot_map);
	return slot_map;
}

bool drvif_Set_eMSC_TX_Slot_Map(void)
{
	unsigned int slot_map = mhl3_slot_assignment();
	rtd_maskl(ECBUS_RX_ECBUS_EMSC_SLOT_MAP_1_reg,~ECBUS_RX_ECBUS_EMSC_SLOT_MAP_1_emsc_slot_map_h_mask,ECBUS_RX_ECBUS_EMSC_SLOT_MAP_1_emsc_slot_map_h(slot_map>>16));
	rtd_maskl(ECBUS_RX_ECBUS_EMSC_SLOT_MAP_2_reg,~ECBUS_RX_ECBUS_EMSC_SLOT_MAP_2_emsc_slot_map_m_mask,ECBUS_RX_ECBUS_EMSC_SLOT_MAP_2_emsc_slot_map_m(slot_map>>8));
	rtd_maskl(ECBUS_RX_ECBUS_EMSC_SLOT_MAP_3_reg,~ECBUS_RX_ECBUS_EMSC_SLOT_MAP_3_emsc_slot_map_l_mask,ECBUS_RX_ECBUS_EMSC_SLOT_MAP_3_emsc_slot_map_l(slot_map));
	return TRUE;
}

bool drvif_Check_eMSC_RX_Slot_Map(void)
{
	int timeout_cnt  = 0;
	int emsc_slot_map_h = ECBUS_RX_ECBUS_EMSC_SLOT_MAP_1_get_emsc_slot_map_h(rtd_inl(ECBUS_RX_ECBUS_EMSC_SLOT_MAP_1_reg));
	int emsc_slot_map_m = ECBUS_RX_ECBUS_EMSC_SLOT_MAP_2_get_emsc_slot_map_m(rtd_inl(ECBUS_RX_ECBUS_EMSC_SLOT_MAP_2_reg));
	int emsc_slot_map_l = ECBUS_RX_ECBUS_EMSC_SLOT_MAP_3_get_emsc_slot_map_l(rtd_inl(ECBUS_RX_ECBUS_EMSC_SLOT_MAP_3_reg));
	int source_slot_map_h = ECBUS_RX_ECBUS_EMSC_SOURCE_SLOT_DET_1_get_sourse_slot_map_h(rtd_inl(ECBUS_RX_ECBUS_EMSC_SOURCE_SLOT_DET_1_reg));
	int source_slot_map_m = ECBUS_RX_ECBUS_EMSC_SOURCE_SLOT_DET_2_get_sourse_slot_map_m(rtd_inl(ECBUS_RX_ECBUS_EMSC_SOURCE_SLOT_DET_2_reg));
	int source_slot_map_l = ECBUS_RX_ECBUS_EMSC_SOURCE_SLOT_DET_3_get_sourse_slot_map_l(rtd_inl(ECBUS_RX_ECBUS_EMSC_SOURCE_SLOT_DET_3_reg));
	/*HDMI_PRINTF("Find & Check eMSC TX/RX Slots Position...");*/

	while (((emsc_slot_map_h != source_slot_map_h) || (emsc_slot_map_m != source_slot_map_m) || (emsc_slot_map_l != source_slot_map_l)) && (timeout_cnt <= 5))
	{
		hdmi_delayus(5000);
		timeout_cnt = timeout_cnt + 5;
		source_slot_map_h = rtd_inl(ECBUS_RX_ECBUS_EMSC_SOURCE_SLOT_DET_1_reg);
    		source_slot_map_m = rtd_inl(ECBUS_RX_ECBUS_EMSC_SOURCE_SLOT_DET_2_reg);
    		source_slot_map_l = rtd_inl(ECBUS_RX_ECBUS_EMSC_SOURCE_SLOT_DET_3_reg);
	}

	if (timeout_cnt > 5)
	{
		HDMI_PRINTF("\nTimeout for Find eMSC RX Slots Position : > 5ms\n");
		return FALSE;
	}

	/*HDMI_PRINTF("Correct\n");*/
	return TRUE;
}

bool drvif_List_eMSC_Slot_Map(void)
{
	int i;
	int emsc_slot_map_h = ECBUS_RX_ECBUS_EMSC_SLOT_MAP_1_get_emsc_slot_map_h(rtd_inl(ECBUS_RX_ECBUS_EMSC_SLOT_MAP_1_reg));
	int emsc_slot_map_m = ECBUS_RX_ECBUS_EMSC_SLOT_MAP_2_get_emsc_slot_map_m(rtd_inl(ECBUS_RX_ECBUS_EMSC_SLOT_MAP_2_reg));
	int emsc_slot_map_l = ECBUS_RX_ECBUS_EMSC_SLOT_MAP_3_get_emsc_slot_map_l(rtd_inl(ECBUS_RX_ECBUS_EMSC_SLOT_MAP_3_reg));

	HDMI_PRINTF("Slot[0] is CBUS1\n");

	for (i = 0; i < 8; i++)
	{
		if (((emsc_slot_map_l >> i) & 0x1) == 0x1)
		{
			HDMI_PRINTF("Slot[%d] is eMSC\n",i+1);
		} else
		{
			HDMI_PRINTF("Slot[%d] is <No use> or <T-CBUS> or <Audio Data Tunnel>\n",i+1);
		}
	}

	for (i = 0; i < 8; i++)
	{
		if (((emsc_slot_map_m >> i) & 0x1) == 0x1)
		{
			HDMI_PRINTF("Slot[%d] is eMSC\n",i+9);
		} else
		{
			HDMI_PRINTF("Slot[%d] is <No use> or <T-CBUS> or <Audio Data Tunnel>\n",i+9);
		}
	}

	for (i = 0; i < 8; i++)
	{
		if (((emsc_slot_map_h >> i) & 0x1) == 0x1)
		{
			HDMI_PRINTF("Slot[%d] is eMSC\n",i+17);
		} else
		{
			HDMI_PRINTF("Slot[%d] is <No use> or <T-CBUS> or <Audio Data Tunnel>\n",i+17);
		}
	}
	HDMI_PRINTF("\n\n");
	return TRUE;
}
#if 0
bool drvif_CBUS_Discovery(void)
{
	int i;
	int timeout_cnt;

	// ----------------------------------------------------------------------------------
	//  Begin to connect CBUS
	// ----------------------------------------------------------------------------------
	HDMI_PRINTF("\n\nBegin CBUS Discovery !!!\n");
	if(!drvif_switch_to_oCBUS()) {return FAILED;}	// oCBUS APHY Enable, eCBUS APHY Disable
	if(!drvif_Enable_MHL_Z0()) {return FAILED;}	// MHL Z0 Attach

	HDMI_PRINTF("Waiting for Wake-up & Discovery pulse...");

	timeout_cnt = 0;
	while (((rtd_inl(CBUS_PMM_CBUS_STANDBY_00_reg) & 0xC) != 0xC) && (timeout_cnt <= 1500))
	{
		mdelay(1);
		timeout_cnt = timeout_cnt + 1;
	}

	if (timeout_cnt > 1500)
	{
		HDMI_PRINTF("\nTimeout for waiting Wake-Up & Discovery Pulse : > 1500ms\n");
		return FALSE;
	}

	rtd_outl(CBUS_PMM_CBUS_STANDBY_00_reg,0xC);	// Clear Wake-up & Discovery pulse Flag
	HDMI_PRINTF("OK!\n");

	// ----------------------------------------------------------------------------------
	// MHL3.2 Standard Figure 8-19
	// ----------------------------------------------------------------------------------
	int wr_stat_irq = 0;
	int MHL_VERSION_STAT = 0;
	int CONNECTED_RDY_1_0 = 0;
	int RCHANGE_INT_0 = 0;
	HDMI_PRINTF("Waiting for MHL_VERSION_STAT, DCAP_RDY, XDECCAP_SUPP, DCAP_CHG...");
	timeout_cnt = 0;
	while (((wr_stat_irq != 1) || (MHL_VERSION_STAT < 0x30) || (CONNECTED_RDY_1_0 != 0x3) || (RCHANGE_INT_0 == 0x1)) && (timeout_cnt <= 100))
	{
		mdelay(1);
		timeout_cnt = timeout_cnt + 1;
		wr_stat_irq =	CBUS_CBUS_MSC_06_get_wr_stat_irq(rtd_inl(CBUS_CBUS_MSC_06_reg));		// WRITE_STAT Received Flag
		MHL_VERSION_STAT = rtd_inl(CBUS_MSC_REG_32_reg);										// Received WRITE_STAT{MHL_VERSION}
		CONNECTED_RDY_1_0 = (rtd_inl(CBUS_MSC_REG_30_reg) & 0x3);								// Received WRITE_STAT{DCAP_RDY,XDECCAP_SUPP}
		RCHANGE_INT_0 = CBUS_MSC_REG_20_get_dcap_chg(rtd_inl(CBUS_MSC_REG_20_reg));		// Received SET_INT{DCAP_CHG}
	}
	if (timeout_cnt > 100)
	{
		HDMI_PRINTF("\nTimeout for waiting MHL_VERSION_STAT, DCAP_RDY, XDECCAP_SUPP, DCAP_CHG : > 100ms\n");
		return FALSE;
	}
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_wr_stat_irq_mask);    						// Clear WRITE_STAT Flag
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_allmsc_cmd_irq_mask);					// Clear All MSC_CMD Flag
	HDMI_PRINTF("OK!\n");

	// ----------------------------------------------------------------------------------
	// MHL3.2 Standard Figure 8-20
	// ----------------------------------------------------------------------------------
	if (!WRITE_STAT(0x32,0x32)) {return FAILED;}	// MHL_VERSION_STAT = 3.2
	if (!WRITE_STAT(0x30,0x03)) {return FAILED;}	// CONNECTED_RDY(DCAP_RDY), CONNECTED_RDY(XDEVCAP_SUPP)
	if (!SET_INT(0x20,0x01)) {return FAILED;}		// RCHANGE_INT(DCAP_CHG)

	// Wait for Source send READ_XDEVCAP(ECBUS_SPEEDS)
	HDMI_PRINTF("Waiting for Source send READ_XDEVCAP(ECBUS_SPEEDS)...");
	timeout_cnt = 0;
	while ((CBUS_oCBUS_CTRL_10_get_rd_xdevcap_irq(rtd_inl(CBUS_oCBUS_CTRL_10_reg) ) != 1) && (timeout_cnt <= 50))
	{
		mdelay(1);
		timeout_cnt = timeout_cnt + 1;
	}
	if (timeout_cnt > 50)
	{
		HDMI_PRINTF("\nTimeout for waiting READ_XDEVCAP(ECBUS_SPEEDS) : > 50ms\n");
		return FALSE;
	}
	rtd_outl(CBUS_oCBUS_CTRL_10_reg,CBUS_oCBUS_CTRL_10_rd_xdevcap_irq_mask);					// Clear READ_XDEVCAP Flag
	HDMI_PRINTF("OK!\n");

	// ----------------------------------------------------------------------------------
	// MHL3.2 Standard Figure 8-21 (include eCBUS Start-Up)
	// ----------------------------------------------------------------------------------
	// Wait for Source send RAP(CBUS_MODE_UP)
	HDMI_PRINTF("Waiting for Source send MSC_MSG(RAP){CBUS_MODE_UP}...");
	timeout_cnt = 0;
	while (((CBUS_CBUS_MSC_06_get_rap_irq(rtd_inl(CBUS_CBUS_MSC_06_reg)) != 1) || (rtd_inl(CBUS_CBUS_MSC_12_reg) != 0x21)) && (timeout_cnt <= 50))
	{
		mdelay(1);
		timeout_cnt =  timeout_cnt + 1;
	}
	if (timeout_cnt > 50)
	{
		HDMI_PRINTF("\nTimeout for waiting MSC_MSG(RAP){CBUS_MODE_UP} : > 50ms\n");
		return FALSE;
	}
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_rap_irq_mask);				// Clear RAP Flag
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_get_msg_irq_mask);			// Clear MSC_CMD Flag
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_allmsc_cmd_irq_mask);		// Clear All MSC_CMD Flag
	HDMI_PRINTF("OK!\n");

	if (!MSC_MSG(0x21,0x00)) {return FAILED;}	// Reply MSC_MSG(RAPK{No_Error})

	HDMI_PRINTF("\n\nStart eCBUS Start-Up procedure!!!\n");
	drvif_switch_to_eCBUS();							// oCBUS APHY Disable, eCBUS APHY Enable
	if(!drvif_Measure_CK_GDI()) {return FAILED;}		// Measure CK_GDI
	if(!drvif_eCBUS_Start_Up()) {return FAILED;}		// eCBUS Start-Up
	if(!drvif_eCBUS_TDM_Slot_Sync()) {return FAILED;}	// TDM Slot Sync Procedure
	// Source will send READ_DEVCAP/READ_XDEVCAP to Read Sink's all Cabability Register

	// ----------------------------------------------------------------------------------
	// MHL3.2 Standard Figure 8-22
	// ----------------------------------------------------------------------------------
	if (!SET_HPD()) {return FAILED;}			// SET_HPD()
	if (!SET_INT(0x21,0x02)) {return FAILED;}	// SET_INT(EDID_CHG)
	// Source Read Sink EDID Data
	HDMI_PRINTF("Waiting for Source send SET_INT(FEAT_REQ)...");
	timeout_cnt = 0;
	while ((((rtd_inl(CBUS_CBUS_MSC_06_reg) & CBUS_CBUS_MSC_06_wr_stat_irq_mask) != CBUS_CBUS_MSC_06_wr_stat_irq_mask) || ((rtd_inl(CBUS_MSC_REG_20_reg) & CBUS_MSC_REG_20_feat_req_mask) != CBUS_MSC_REG_20_feat_req_mask)) && (timeout_cnt <= 3000))
	{
		mdelay(1);
		timeout_cnt = timeout_cnt + 1;
	}
	if (timeout_cnt > 3000)
	{
		HDMI_PRINTF("\nTimeout for waiting SET_INT(FEAT_REQ) : > 3000ms\n");
		return FALSE;
	}
	HDMI_PRINTF("OK!\n");
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_wr_stat_irq_mask);		// Clear WRITE_STAT Flag
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_allmsc_cmd_irq_mask);	// Clear All MSC_CMD Flag
	rtd_outl(CBUS_MSC_REG_20_reg,CBUS_MSC_REG_20_feat_req_mask);				// Clear FEAT_REQ_CHG
	// Sink Reply All Feature here
	if (!SET_INT(0x20,0x40)) {return FAILED;}	// SET_INT(FEAT_COMPLETE)

	// ----------------------------------------------------------------------------------
	// MHL3.2 Standard Figure 8-24
	// ----------------------------------------------------------------------------------
	HDMI_PRINTF("Waiting for Source send WRITE_STAT(DCAP_RDY) & SET_INT(DCAP_CHG)...");

	#if 0
	// Waiting for WRITE_STAT(MHL_VERSION_STAT)
	while ((rtd_inl(CBUS_CBUS_MSC_06_reg) & CBUS_CBUS_MSC_06_wr_stat_irq_mask) != CBUS_CBUS_MSC_06_wr_stat_irq_mask) {}
	if (rtd_inl(CBUS_MSC_REG_32_reg) < 0x30)
	{
		HDMI_PRINTF("Source MHL_VERSION_STAT is not 3.x\n\n\n");
		return FAILED;
	}
	#endif

	// Waiting for WRITE_STAT(DCAP_RDY)
	timeout_cnt = 0;
	while (((rtd_inl(CBUS_MSC_REG_30_reg) & CBUS_MSC_REG_30_dcap_rdy_mask) != CBUS_MSC_REG_30_dcap_rdy_mask) && (timeout_cnt <= 500))
	{
		mdelay(1);
		timeout_cnt = timeout_cnt + 1;
	}
	if (timeout_cnt > 500)
	{
		HDMI_PRINTF("\nTimeout for waiting WRITE_STAT(DCAP_RDY) : > 500ms\n");
		return FALSE;
	}

	// Waiting for SET_INT(DCAP_CHG)
	timeout_cnt = 0;
	while ((((rtd_inl(CBUS_CBUS_MSC_06_reg) & CBUS_CBUS_MSC_06_dcap_rdy_chg_mask) != CBUS_CBUS_MSC_06_dcap_rdy_chg_mask) || ((rtd_inl(CBUS_MSC_REG_20_reg) & CBUS_MSC_REG_20_dcap_chg_mask) != CBUS_MSC_REG_20_dcap_chg_mask)) && (timeout_cnt <= 500))
	{
		mdelay(1);
		timeout_cnt = timeout_cnt + 1;
	}
	if (timeout_cnt > 500)
	{
		HDMI_PRINTF("\nTimeout for waiting SET_INT(DCAP_CHG) : > 500ms\n");
		return FALSE;
	}

	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_dcap_rdy_chg_mask);		// Clear DCAP_CHG Flag
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_wr_stat_irq_mask);		// Clear WRITE_STAT Flag
	rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_allmsc_cmd_irq_mask);	// Clear All MSC_CMD Flag
	rtd_outl(CBUS_MSC_REG_20_reg,CBUS_MSC_REG_20_dcap_chg_mask);			// Clear DCAP_CHG
	HDMI_PRINTF("OK!\n\n");

	HDMI_PRINTF("Sink Read Capability Register & Extended Capability Register\n");

	for (i = 0x0; i <= 0xF; i++)
	{
		if (!READ_DEVCAP(i)) {return FAILED;}
	}

	for (i = 0x80; i <= 0x8F; i++)
	{
		if (!READ_XDEVCAP(i)) {return FAILED;}
	}
	HDMI_PRINTF("\n\n");

	// ----------------------------------------------------------------------------------
	// MHL3.2 Standard Figure 8-25
	// ----------------------------------------------------------------------------------
	if(!SET_INT(0x20,0x20)) {return FAILED;}		// SET_INT(FEAT_REQ)
	// Sink Receive All Feature here
	rtd_outl(CBUS_MSC_REG_20_reg,CBUS_MSC_REG_20_feat_complete_mask);	// Clear DCAP_CHG
	HDMI_PRINTF("CBUS Discovery Finish!!!\n\n\n");

	return TRUE;
}
#endif
#if 0
bool drvif_CBUS_EDIDLoad(unsigned char* EDID, UINT16 len)
{
	UINT32 Edid_addr;
	UINT16 i;

	Edid_addr = DDC5_CBUS_DDC_reg ;
	//Disable DDC func, write EDID data to sram
	rtd_maskl(Edid_addr + REG_EDID_CTL_OFFSET, ~DDC1_EDID_CR_edid_en_mask, DDC1_EDID_CR_edid_en(0));

	for(i=0; i< len; i++) //total 0 ~ 127
		rtd_outl(Edid_addr+REG_DDC_SIR_OFFSET, i),
		rtd_outl(Edid_addr+REG_DDC_SAP_OFFSET, EDID[i]);
		//HDMI_PRINTF("drvif_CBUS_EDIDLoad index = %d , value = %d  \n", i,EDID[i]);
	rtd_outl(Edid_addr, 0x30);
	//Enable DDC func
	rtd_maskl(Edid_addr + REG_EDID_CTL_OFFSET, ~DDC1_EDID_CR_edid_en_mask, DDC1_EDID_CR_edid_en(1));
	return TRUE;
}

bool drvif_CBUS_EDIDEnable(UINT8 enable)
{
	UINT32 Edid_addr;
	Edid_addr = DDC5_CBUS_DDC_reg ;
	rtd_maskl(Edid_addr+REG_EDID_CTL_OFFSET, ~DDC1_EDID_CR_edid_en_mask, DDC1_EDID_CR_edid_en((enable)?1:0));
	return TRUE;
}

void drvif_CBUS_EDID_DDC12_AUTO_Enable(UINT8 enable)
{
	UINT32 Edid_addr;

	Edid_addr = DDC5_CBUS_DDC_reg ;
	rtd_maskl(Edid_addr +REG_EDID_CTL_OFFSET, ~(DDC1_EDID_CR_ddc1_force_mask | DDC1_EDID_CR_ddc2b_force_mask),
				(DDC1_EDID_CR_ddc1_force(0) | DDC1_EDID_CR_ddc2b_force((enable)?0:1)));

}

void drvif_CBUS_LoadEDID(unsigned char *EDID, int len)
{
    rtd_maskl(HDMI_HDCP_PCR_reg, ~HDMI_HDCP_PCR_km_clk_sel_mask, 0);
    drvif_CBUS_EDIDLoad(EDID,len);
    drvif_CBUS_EDIDEnable(1);
    drvif_CBUS_EDID_DDC12_AUTO_Enable(0);
}
#endif
/******************************************************************************
*  FROM QC CODE END
*******************************************************************************/






/************************************************************
* CALLING AFTER DISCOVERY DONE, DISCONNECT
************************************************************/
void mhl3_init_state(void)
{
	mhl3_fsm = MHL3_INIT;
	mhl_src_ver = MHLVER_3p0;
	mhl_av_link = MHLVER_2p2;
	mhl3_link_rate = 0;
	mhl3_link_rate_updated = 0;
	rap_mode_up_retry_cnt = 0;
	startup_rety = 0;

	peer_blk_rx_buffer_avail = 256;
	blk_recv_info = 0;
	blk_recv_count = 0;

	emsc_slot_size = 4;
}

unsigned char mhl3_get_src_ver(void)
{
	return mhl_src_ver;
}

unsigned char mhl3_get_version(void) /*AV_LINK is mhl3 or mhl2*/
{
#if MHL3_AVLINK_6G
	return MHLVER_3p2;
#endif
	if ((hdmi_in(HDMI_HDMI_AFCR_reg)&MHL_CTS_TEST_ON) && (hdmi_in(HDMI_HDMI_AFCR_reg)&MHL3_RUN_1p5G)){
		return MHLVER_3p2;
	}
	return mhl_av_link;
}

ENUM_MHL3_FSM mhl3_get_state(void)
{
	return mhl3_fsm;
}

bool mhl3_ocbus_send_cmd(void)
{
	if (MHLMscSendCommand(MHL_MSC_CMD_CODE_WRT_STAT, _MHL_VERSION_STAT, MHLVER_3p2) == _MHL_NG) {
		return FALSE;
	}

	if (MHLMscSendCommand(MHL_MSC_CMD_CODE_WRT_STAT, _MHL_REG_CONNECTED_RDY, (XDEVCAP_SUPP|CONNECT_DCAP_RDY|POW_STAT|(CDF_CR_POW_PLIM<<3))) == _MHL_NG) {
		return FALSE;
	}

	if (MHLMscSendCommand(MHL_MSC_CMD_CODE_SET_INT, _MHL_REG_RCHANGE_INT, DCAP_CHG) == _MHL_NG) {
		return FALSE;
	}

	return TRUE;
}

unsigned char mhl3_extend_discovery(unsigned char *get_mhl_ver)
{
unsigned int timeout_cnt = 0;

	*get_mhl_ver = MHLVER_2p2;

	while (++timeout_cnt < 300) { /*Tsrc_disc_to_dcapchg=60ms*/
		if (CBUS_CBUS_MSC_06_get_wr_stat_irq(rtd_inl(CBUS_CBUS_MSC_06_reg)) && rtd_inl(CBUS_MSC_REG_32_reg))  {
			/*rtd_outl(CBUS_CBUS_MSC_06_reg, CBUS_CBUS_MSC_06_wr_stat_irq_mask);*/ /*don't clear avoid missing other wr_stat*/
			*get_mhl_ver = rtd_inl(CBUS_MSC_REG_32_reg);
			if ((*get_mhl_ver == MHLVER_3p0) || (*get_mhl_ver == MHLVER_3p2)) {
				return SRC_VER_3;
			} else {
				/* 1.x or 2.x ?? */
				rtd_maskl(CBUS_oCBUS_CTRL_00_reg, ~CBUS_oCBUS_CTRL_00_cbus3_en_mask, 0);
				return SRC_VER_2;
			}
		}
		hdmi_delayus(1000);
	}

	rtd_maskl(CBUS_oCBUS_CTRL_00_reg, ~CBUS_oCBUS_CTRL_00_cbus3_en_mask, 0);
	return SRC_VER_TIMEOUT;
}

unsigned char mhl3_wait_for_ecbus_speeds(void)
{
unsigned int timeout_cnt = 0;

	while (++timeout_cnt < 30) {
		if (CBUS_oCBUS_CTRL_10_get_rd_xdevcap_irq(rtd_inl(CBUS_oCBUS_CTRL_10_reg))) {
			rtd_outl(CBUS_oCBUS_CTRL_10_reg, CBUS_oCBUS_CTRL_10_rd_xdevcap_irq_mask);
			return ECBUS_SPEED_OK;
		}
		hdmi_delayus(1000);
	}

	return ECBUS_SPEED_TIMEOUT;
}

unsigned char mhl3_wait_for_rap_mode_up(void)
{
unsigned int timeout_cnt = 0;
	while (++timeout_cnt < 200) { /* Tsrc_first_rap*2= 100ms*/
		if (CBUS_CBUS_MSC_06_get_rap_irq(rtd_inl(CBUS_CBUS_MSC_06_reg)) &&
			(CBUS_CBUS_MSC_12_get_rap_rcv(rtd_inl(CBUS_CBUS_MSC_12_reg)) == _MSC_RAP_MODE_UP)) {
			rtd_outl(CBUS_CBUS_MSC_06_reg, (CBUS_CBUS_MSC_06_get_msg_irq_mask|CBUS_CBUS_MSC_06_rap_irq_mask));
			if (!MSC_MSG(0x21, 0x00)) {
				/* Reply MSC_MSG(RAPK{No_Error})*/
				return RAP_MODE_REPLY_FAIL;
			}
			/*rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_get_msg_irq_mask);	// Clear MSC_CMD Flag*/
			/*rtd_outl(CBUS_CBUS_MSC_06_reg,CBUS_CBUS_MSC_06_allmsc_cmd_irq_mask);	// Clear All MSC_CMD Flag*/
			return RAP_MODE_UP;
		}
		hdmi_delayus(1000);
	}

	return RAP_MODE_TIMEOUT;
}

bool mhl3_emsc_link_training(void)
{
	/* ----------------------------------------------------------------------------------
	 * eMSC Link Training & Maintenance
	 * ----------------------------------------------------------------------------------*/
	if (!drvif_Set_eMSC_TX_Slot_Map()) {
		return FALSE;
	}

	rtd_outl(ECBUS_RX_ECBUS_EMSC_RX_ADDR_reg, 0);			/* Reset eMSC RX Buffet Write Pointer*/
	rtd_outl(ECBUS_RX_ECBUS_EMSC_TX_ADDR_reg, 0);			/* Reset eMSC TX Buffet Write Pointer*/

	if (!drvif_eCBUS_eMSC_Link_Training()) {
		return FALSE;
	}

	if (!drvif_Check_eMSC_RX_Slot_Map()) {
		return FALSE;
	}
	/*if (!drvif_List_eMSC_Slot_Map()) {
		return FALSE;
	}*/
	return TRUE;
}

void mhl3_read_src_cap(void)
{
#if 0
	int i;

	HDMI_PRINTF("Sink Read Capability Register & Extended Capability Register\n");
	for (i = 0x0; i <= 0xF; i++) {
		if (!READ_DEVCAP(i)) {
			return;
		}
	}

	for (i = 0x80; i <= 0x84; i++) {
		if (!mhl3_read_xdevcap(i)) {
			return;
		}
	}

	HDMI_PRINTF("\n\n");

	/* ----------------------------------------------------------------------------------
	* MHL3.2 Standard Figure 8-25
	* ----------------------------------------------------------------------------------*/
	if (!SET_INT(0x20, 0x20)) { /* SET_INT(FEAT_REQ)*/
		return;
	}
	/* Sink Receive All Feature here*/
	rtd_outl(CBUS_MSC_REG_20_reg, CBUS_MSC_REG_20_feat_complete_mask);	/* Clear DCAP_CHG*/
#endif
}

void mhl3_reset(void)
{
	rtd_maskl(CRT_SYS_SRST1_reg, ~CRT_SYS_SRST1_rstn_cbus_mask, 0);
	rtd_maskl(CRT_SYS_SRST1_reg, ~CRT_SYS_SRST1_rstn_cbus_mask, CRT_SYS_SRST1_rstn_cbus_mask); /* it will reset b800a5xx, b800a0xx*/
	rtd_maskl(ECBUS_RX_ECBUS_TDM_SYNC_CTRL_reg,
		~(ECBUS_RX_ECBUS_TDM_SYNC_CTRL_enter_tdm_active_mask|ECBUS_RX_ECBUS_TDM_SYNC_CTRL_com1_det_en_mask|ECBUS_RX_ECBUS_TDM_SYNC_CTRL_ignore_idle_det_mask),
		ECBUS_RX_ECBUS_TDM_SYNC_CTRL_ignore_idle_det_mask);
	rtd_outl(CBUS_oCBUS_CTRL_01_reg, CBUS_oCBUS_CTRL_01_cbus1_retry_num(0x0d)|CBUS_oCBUS_CTRL_01_cbus1_retry_limit_mask|CBUS_oCBUS_CTRL_01_cbus1_coll_mask);
	rtd_outl(CBUS_oCBUS_CTRL_10_reg, CBUS_oCBUS_CTRL_10_wr_xstat_irq_mask|CBUS_oCBUS_CTRL_10_rd_xdevcap_irq_mask);

	MHLTmdsInitial();
	mhl_av_link = MHLVER_2p2;
}

void mhl3_disconnect(void)
{
	mhl3_fsm = MHL3_INIT;
	hdmi_z0_set(GET_HDMI_CHANNEL(), LN_B, 0);
	drvif_mhl3_cbus_switch(0);
}

/************************************************************
* CALLING IN MHL_ISR (EVERY 10MS)
************************************************************/
unsigned char mhl3_ecbus_discovery(void)
{
	unsigned char fstate;

	switch (mhl3_fsm) {
	case MHL3_INIT:
		/*mhl3_init_state();*/
		mhl3_fsm = MHL3_WAIT_SRC_VER;
		/*break;*/
	case MHL3_WAIT_SRC_VER:
		fstate = mhl3_extend_discovery(&mhl_src_ver);
		if (fstate == SRC_VER_3) {
			mhl3_fsm = MHL3_WAIT_RAP_MODE_UP; /* MHL3_WAIT_ECBUS_SPEED;*/
			HDMI_PRINTF("[MHL3] SRC=MHL%x\n", mhl_src_ver);
		} else if (fstate == SRC_VER_2) {
			mhl3_fsm = MHL3_SKIP;
			HDMI_PRINTF("[MHL3] SRC=MHL2 (%x)\n", mhl_src_ver);
			break;
		} else if (fstate == SRC_VER_FAIL) {
			mhl3_fsm = MHL3_SKIP;
			HDMI_PRINTF("[MHL3] SRC_VER_FAIL\n");
			break;
		} else if (fstate == SRC_VER_TIMEOUT) {
			mhl3_fsm = MHL3_SKIP;
			HDMI_PRINTF("[MHL3] SRC_VER_TIMEOUT\n");
			break;
		} else {
			break;
		}
#if 0
	case MHL3_WAIT_ECBUS_SPEED:
		fstate = mhl3_wait_for_ecbus_speeds();
		if (fstate == ECBUS_SPEED_OK) {
			mhl3_fsm = MHL3_WAIT_RAP_MODE_UP;
			HDMI_PRINTF("MHL3_WAIT_ECBUS_SPEED OK\n");
		} else if (fstate == ECBUS_SPEED_TIMEOUT) {
			mhl3_fsm = MHL3_SKIP;
			HDMI_PRINTF("MHL3_WAIT_ECBUS_SPEED TIMEOUT\n");
			break;
		} else {/*else if (fstate == ECBUS_SPEED_WAITING) {*/
			break;
		}
#endif
	case MHL3_WAIT_RAP_MODE_UP:
		fstate = mhl3_wait_for_rap_mode_up();
		if (fstate == RAP_MODE_UP) {
			mhl3_fsm = MHL3_WAIT_CLK;
			/*HDMI_PRINTF("RAP_MODE_UP\n");*/
		} else if (fstate == RAP_MODE_REPLY_FAIL) {
			mhl3_fsm = MHL3_SKIP;
			HDMI_PRINTF("RAP_MODE_REPLY_FAIL\n");
			break;
		} else if (fstate == RAP_MODE_TIMEOUT) {
			if (++rap_mode_up_retry_cnt > 5) {
				mhl3_fsm = MHL3_SKIP;
				HDMI_PRINTF("RAP TIMEOUT\n");
			}
			break;
		} else if (fstate == RAP_MODE_DOWN) {
			mhl3_fsm = MHL3_SKIP;
			HDMI_PRINTF("RAP_MODE_DOWN\n"); /*go to mhl2.0*/
			break;
		} else { /*if (fstate == RAP_MODE_WAITING) {*/
			HDMI_PRINTF("RAP_MODE_WAITING\n");
			break;
		}
	case MHL3_WAIT_CLK:
		if (startup_rety++ > 3) { /*NCbus_retry=4*/
			mhl3_fsm = MHL3_RE_DISCOVERY;
			break;
		}
		/*drvif_switch_to_eCBUS();*/
		drvif_mhl3_cbus_switch(1);
		rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask)); /* 6.4.12.2 avoid disconn flag */ //jtest
		if(!drvif_Measure_CK_GDI()) { /* Measure CK_GDI*/
			break;
		}
		mhl3_fsm = MHL3_STARTUP;
		mhl_av_link = MHLVER_3p0;
		startup_rety = 0;
		break;
	case MHL3_STARTUP:
		if (startup_rety++ > 3) {
			/* go to ?? */
			break;
		}
		if (!drvif_eCBUS_Start_Up()) { 	/* eCBUS Start-Up*/
			break;
		}
		mhl3_fsm = MHL3_TDM_SLOT_SYNC;
		break;
	case MHL3_TDM_SLOT_SYNC:
		if (!drvif_eCBUS_TDM_Slot_Sync()) { 	/* TDM Slot Sync Procedure*/
			break;
		}

		if (!mhl3_emsc_link_training()) {
			//break;
		}
		mhl3_fsm = MHL3_ECBUS_DONE;
		break;
	case MHL3_ECBUS_DONE:
		if (!SET_HPD()) {
			break;
		}
		if (!SET_INT(DCHANGE_INT, EDID_CHG)) {
			break;
		}
		mhl3_fsm = MHL3_PATHEN;
		break;
	case MHL3_PATHEN:
		HDMI_PRINTF("[MHL3] Sending PATH_EN\n");
		if (!WRITE_STAT(_MHL_REG_LINK_MODE, LINK_MODE_PATH_EN)) {	/* LINK_MODE(PATH_EN)*/
			break;
		}
//jtest		if (!mhl3_emsc_link_training()) {
//			break;
//		}
		mhl3_fsm = MHL3_READY;
		HDMI_PRINTF("[MHL3] ****************************** eCBUS DONE ******************************\n");
		break;
	case MHL3_READY:
		break;
	case MHL3_RE_DISCOVERY:
		mhl3_fsm = MHL3_INIT;
		CBUSSwitch(0);
		mhl_disconnect();
		return 0;
		break;
	case MHL3_SKIP:
		mhl_av_link = MHLVER_2p2;
		if (CBUS_CBUS_MSC_06_get_rap_irq(rtd_inl(CBUS_CBUS_MSC_06_reg)) &&
			(CBUS_CBUS_MSC_12_get_rap_rcv(rtd_inl(CBUS_CBUS_MSC_12_reg)) == _MSC_RAP_MODE_UP)) {
			mhl3_fsm = MHL3_WAIT_RAP_MODE_UP;
		}
		break;
	default:
		mhl_av_link = MHLVER_2p2;
		break;
	}

	if ((mhl3_fsm >= MHL3_STARTUP) && (mhl3_fsm <= MHL3_READY)) {
		if (!drvif_Measure_CK_GDI_get()) {
			CBUSSwitch(0);
			mhl_disconnect();
			HDMI_PRINTF("[MHL3] NO CLK, disconnect\n");
			return 0;
		}
	}

	return 1;

}

void mhl3_rap_mode_down(void)
{
	CBUSSwitch(0);
	mhl_disconnect();
	mhl3_fsm = MHL3_SKIP;
}

/************************************************************
* CALLING IN HDMIINIT
************************************************************/
void mhl3_init_phy_mac(void)
{
	drvif_CBUS_RX_APHY_initial();
	drvif_CBUS_RX_DPHY_initial();
	drvif_CBUS_RX_MAC_initial();
	/*drvif_CBUS_RX_Capability_Register_Table(); */
	/*rtd_maskl(PINMUX_PMM_ST_GPIO_CFG_3_reg, ~PINMUX_PMM_ST_GPIO_CFG_3_st_gpio_14_ps_mask, PINMUX_PMM_ST_GPIO_CFG_3_st_gpio_14_ps(0xF));*/
	/*rtd_maskl(ECBUS_RX_ECBUS_EMSC_TRANS_CONFIG_2_reg,
		~(ECBUS_RX_ECBUS_EMSC_TRANS_CONFIG_2_emsc_req_tout_mask|
		ECBUS_RX_ECBUS_EMSC_TRANS_CONFIG_2_retry_num_mask|
		ECBUS_RX_ECBUS_EMSC_TRANS_CONFIG_2_retry_wait_mask),
		(ECBUS_RX_ECBUS_EMSC_TRANS_CONFIG_2_emsc_req_tout(0x0)|
		ECBUS_RX_ECBUS_EMSC_TRANS_CONFIG_2_retry_num(0x2)|
		ECBUS_RX_ECBUS_EMSC_TRANS_CONFIG_2_retry_wait(0xa))
		);*/
	rtd_maskl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_reg,
		~(ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_rxbuf_udfl_irq_mask|
		ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_rxbuf_ovfl_irq_mask|
		ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_rx_reply_nack_mask|
		ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_rxbuf_clr_mask),
		(ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_rxbuf_udfl_irq_mask|
		ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_rxbuf_ovfl_irq_mask|
		ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_rx_reply_nack_mask|
		ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_rxbuf_clr_mask)
		);
}

unsigned char mhl3_get_bits_per_pixel(void)
{
#if MHL3_AVLINK_16bit
	return BPP_16;
#endif
	if (hdmi_in(HDMI_HDMI_AFCR_reg)&MHL_CTS_TEST_ON) {
		if (hdmi_in(HDMI_HDMI_AFCR_reg)&MHL3_RUN_16bit) {
			return BPP_16;
		} else {
			return BPP_24;
		}
	} else {
		if (MHL_MHL3_STATUS_get_bits_per_pixel_mode(hdmi_in(MHL_MHL3_STATUS_reg)) == 0x1) {
			return BPP_16;
		} else {
			return BPP_24;
		}
	}
}

/********************************
*  return value
*  0=1.5G; 1=3G; 2=6G
*
**********************************/
unsigned char mhl3_get_link_rate(void)
{
#if MHL3_AVLINK_6G
	return 2;
#endif
	if (hdmi_in(HDMI_HDMI_AFCR_reg)&MHL_CTS_TEST_ON) {
		if ((hdmi_in(HDMI_HDMI_AFCR_reg)&MHL3_RUN_1p5G) == MHL3_RUN_1p5G) {
			return 0;
		} else if (hdmi_in(HDMI_HDMI_AFCR_reg)&MHL3_RUN_3G) {
			return 1;
		} else {
			return 2;
		}
	} else {
		return mhl3_link_rate;
	}
}

void mhl3_check_link_rate(void)
{
	mhl3_link_rate = mhl3_link_rate_updated?CBUS_MSC_REG_92_get_link_rate(rtd_inl(CBUS_MSC_REG_92_reg)):0;
}

void mhl3_xstat_handler(void)
{
	if (CBUS_oCBUS_CTRL_10_get_rd_xdevcap_irq(rtd_inl(CBUS_oCBUS_CTRL_10_reg))) {
		rtd_outl(CBUS_oCBUS_CTRL_10_reg, CBUS_oCBUS_CTRL_10_rd_xdevcap_irq_mask);
	}

	if (CBUS_oCBUS_CTRL_10_get_wr_xstat_irq(rtd_inl(CBUS_oCBUS_CTRL_10_reg))) { /*old msc cmd also trigger this register*/
		rtd_outl(CBUS_oCBUS_CTRL_10_reg, CBUS_oCBUS_CTRL_10_wr_xstat_irq_mask);
		if (CBUS_CBUS_MSC_02_get_na_msc_offset(rtd_inl(CBUS_CBUS_MSC_02_reg)) == AV_LINK_MODE_CONTROL) {
			WRITE_XSTAT(AV_LINK_MODE_STATUS, LINK_TMDS_NORMAL); /*CTS*/
			mhl3_link_rate_updated = 1;
		}
		HDMI_PRINTF("[MHL3] Receive Write Xstat(70)=%x offset=%x data=%x len=%x\n", rtd_inl(CBUS_CBUS_MSC_01_reg), rtd_inl(CBUS_CBUS_MSC_02_reg), rtd_inl(CBUS_CBUS_MSC_04_reg), CBUS_CBUS_MSC_03_get_na_rx_len(rtd_inl(CBUS_CBUS_MSC_03_reg)));
	}
}

void mhl3_bist_ecbus_set(unsigned char duration, unsigned char pattern, unsigned short fixed)
{
	bist_ecbus.duration = duration;
	bist_ecbus.test_pattern = pattern;
	bist_ecbus.fixed = fixed;
	HDMI_PRINTF("[MHL3][ecbus] dur=%d, pat=%d, fixed=%d\n", duration, pattern, fixed);
	}

void mhl3_bist_avlink_set(unsigned char duration, unsigned char pattern, unsigned short fixed, unsigned char rdm)
{
	bist_avlink.duration = duration;
	bist_avlink.test_pattern = pattern;
	bist_avlink.fixed = fixed;
	bist_avlink.rdm = rdm;
	HDMI_PRINTF("[MHL3][avlink] dur=%d, pat=%d, fixed=%d, rdm=%d\n", duration, pattern, fixed, rdm);
}

void mhl3_bist_ecbus_start(MHL3_BIST_T *p_bist_t)
{
	rtd_outl(ECBUS_RX_ECBUS_BIST_CTRL_reg,
		(ECBUS_RX_ECBUS_BIST_CTRL_bist_err_reset_mask|
		ECBUS_RX_ECBUS_BIST_CTRL_prbs_reset_mask|
		ECBUS_RX_ECBUS_BIST_CTRL_bist_comp_start_mask|
		ECBUS_RX_ECBUS_BIST_CTRL_rx_bist_stop_mask));

	rtd_maskl(ECBUS_RX_ECBUS_BIST_CTRL_reg, ~ECBUS_RX_ECBUS_BIST_CTRL_ecbus_bist_en_mask, ECBUS_RX_ECBUS_BIST_CTRL_ecbus_bist_en_mask);
	rtd_maskl(ECBUS_RX_ECBUS_BIST_CONFIG_reg, ~ECBUS_RX_ECBUS_BIST_CONFIG_tx_bist_mask, ECBUS_RX_ECBUS_BIST_CONFIG_tx_bist(p_bist_t->ecbus_tx));
	rtd_maskl(ECBUS_RX_ECBUS_BIST_CONFIG_reg, ~ECBUS_RX_ECBUS_BIST_CONFIG_rx_bist_mask, ECBUS_RX_ECBUS_BIST_CONFIG_rx_bist(p_bist_t->ecbus_rx));

	rtd_maskl(ECBUS_RX_ECBUS_BIST_CONFIG_reg, ~ECBUS_RX_ECBUS_BIST_CONFIG_bist_pattern_mask, ECBUS_RX_ECBUS_BIST_CONFIG_bist_pattern(p_bist_t->test_pattern));
	rtd_maskl(ECBUS_RX_ECBUS_BIST_FIXED8_reg, ~ECBUS_RX_ECBUS_BIST_FIXED8_fix8_data_mask, ECBUS_RX_ECBUS_BIST_FIXED8_fix8_data(p_bist_t->fixed));



}

void mhl3_bist_avlink_start(MHL3_BIST_T *p_bist_t)
{
	rtd_maskl(MHL_MHL_BIST_CTRL_reg, ~MHL_MHL_BIST_CTRL_bist_en_mask, 0);
	rtd_maskl(MHL_MHL_BIST_CTRL_reg, ~MHL_MHL_BIST_CTRL_bist_frame_num_mask, MHL_MHL_BIST_CTRL_bist_frame_num(p_bist_t->duration));
	rtd_maskl(MHL_MHL_BIST_CTRL_reg, ~MHL_MHL_BIST_CTRL_bist_fixed_mask, MHL_MHL_BIST_CTRL_bist_fixed(p_bist_t->fixed));
	rtd_maskl(MHL_MHL_BIST_CTRL_reg, ~MHL_MHL_BIST_CTRL_bist_pattern_mask, MHL_MHL_BIST_CTRL_bist_pattern(p_bist_t->test_pattern));
	rtd_maskl(MHL_MHL_BIST_CTRL_reg, ~MHL_MHL_BIST_CTRL_bist_rdm_bypass_mask, MHL_MHL_BIST_CTRL_bist_rdm_bypass((p_bist_t->rdm==0)));

	rtd_maskl(MHL_MHL_BIST_CTRL_reg, ~MHL_MHL_BIST_CTRL_bist_en_mask, MHL_MHL_BIST_CTRL_bist_en_mask);
}

void mhl3_bist_ecbus_stop(void)
{
	rtd_maskl(ECBUS_RX_ECBUS_BIST_CTRL_reg, ~ECBUS_RX_ECBUS_BIST_CTRL_rx_bist_stop_mask, ECBUS_RX_ECBUS_BIST_CTRL_rx_bist_stop_mask);
}

void mhl3_bist_avlink_stop(void)
{
	rtd_maskl(MHL_MHL_BIST_CTRL_reg, ~MHL_MHL_BIST_CTRL_bist_stop_mask, MHL_MHL_BIST_CTRL_bist_stop_mask);
}

unsigned short mhl3_bist_ecbus_get_result(void)
{
	return (ECBUS_RX_ECBUS_BIST_ERR_CNT_H_get_bist_err_cnt_15_8(rtd_inl(ECBUS_RX_ECBUS_BIST_ERR_CNT_H_reg))<<8)|
		ECBUS_RX_ECBUS_BIST_ERR_CNT_L_get_bist_err_cnt_7_0(rtd_inl(ECBUS_RX_ECBUS_BIST_ERR_CNT_L_reg));
}

unsigned short mhl3_bist_avlink_get_result(void)
{
	return MHL_MHL_BIST_ERR_CNT_get_bist_err_cnt(rtd_inl(MHL_MHL_BIST_ERR_CNT_reg));
}

void mhl3_bist_handler(void)
{
	unsigned char bist_trigger_op;
	unsigned char bist_stat[16] = {
		BIST_RETURN_STAT_H, BIST_RETURN_STAT_L, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	};

	if (mhl_get_bist_trigger()) {
		bist_trigger_op = CBUS_MSC_0D_get_msg_dat(rtd_inl(CBUS_MSC_0D_reg));
		if (bist_trigger_op&(_BIT1|_BIT0) ) {
			bist_testing = 1;
			drvif_mhl3_cbus_switch(1);
			mhl3_bist_ecbus_start(&bist_ecbus);
			HDMI_PRINTF("[MHL3] BIST_TRIGGER(ecbus) received, change to ecbus, start counting err_cnt\n");
		} else if (bist_trigger_op&_BIT5) {
			bist_testing = 2;
			drvif_mhl3_cbus_switch(1);
			mhl3_bist_avlink_start(&bist_avlink);
			HDMI_PRINTF("[MHL3] BIST_TRIGGER(avlink) received, change to ecbus, start counting err_cnt\n");
		} else {
			bist_testing = 0;
			return;
		}


	}

	if (mhl_get_bist_stop()) {
		if (bist_testing == 1) {
			bist_ecbus.err_cnt = mhl3_bist_ecbus_get_result();
			mhl3_bist_ecbus_stop();
		} else if (bist_testing == 2) {
			bist_avlink.err_cnt = mhl3_bist_avlink_get_result();
			mhl3_bist_avlink_stop();
		}
		drvif_mhl3_cbus_switch(0);
		HDMI_PRINTF("[MHL3] BIST_STOP received, change to ocbus, err_cnt=%d\n", (bist_testing==1)?bist_ecbus.err_cnt:bist_avlink.err_cnt);
	}

	if (mhl_get_bist_request_stat()) {
		if (bist_testing == 1) {
			bist_stat[0xE] = (unsigned char)(bist_ecbus.err_cnt>>8);
			bist_stat[0xF] = (unsigned char)bist_ecbus.err_cnt;
		} else if (bist_testing == 2) {
			bist_stat[0xE] = (unsigned char)(bist_avlink.err_cnt>>8);
			bist_stat[0xF] = (unsigned char)bist_avlink.err_cnt;
		}
		bist_testing = 0;
		HDMI_PRINTF("[MHL3] BIST_REQ received, return err_cnt=%d\n", (bist_testing==1)?bist_ecbus.err_cnt:bist_avlink.err_cnt);

		mhl_fill_burst_chksum(bist_stat);
		if ((MHLMscSendWriteBurst(_MHL_REG_SCRATCH_START, 16, bist_stat, _MHL_WRITE_BURST_WITH_REQ) != _MHL_OK)) {
			HDMI_PRINTF("[MHL3] return bist_return_stat fail\n");
		}
	}
}


void mhl3_virtual_channel_handler(unsigned char *buf)
{
unsigned char i, rtrn_buf[16];
		for (i = 0; i < 16; i++) {
		rtrn_buf[i] = buf[i];
	}

	HDMI_PRINTF("[MHL3] received vc assign, tot=%d, seq=%d, num=%d\n", buf[3], buf[4], buf[5]);
	HDMI_PRINTF("[MHL3] received vc=%d, feature_id=%d, size=%d\n", buf[6], buf[7], buf[8]);
	HDMI_PRINTF("[MHL3] received vc=%d, feature_id=%d, size=%d\n", buf[9], buf[10], buf[11]);
	HDMI_PRINTF("[MHL3] received vc=%d, feature_id=%d, size=%d\n", buf[12], buf[13], buf[14]);

	rtrn_buf[0x0] = VC_CONFIRM_H;
	rtrn_buf[0x1] = VC_CONFIRM_L; /*VC_CONFIRM*/
	rtrn_buf[0x2] = 0x00; /*checksum*/
	rtrn_buf[0x8] = 0x00; /*accept*/
	rtrn_buf[0xb] = 0x00; /*accept*/
	rtrn_buf[0xe] = 0x00; /*accept*/

	mhl_fill_burst_chksum(rtrn_buf);

	if ((MHLMscSendWriteBurst(_MHL_REG_SCRATCH_START, 16, rtrn_buf, _MHL_WRITE_BURST_WITH_REQ) != _MHL_OK)) {
		HDMI_PRINTF("[MHL3] return vc_confirm fail\n");
		return;
	}

	if (buf[6] == 0x01) {
		i = 6;
	} else if (buf[9] == 0x01) {
		i = 9;
	} else if (buf[12] == 0x01) {
		i = 12;
	} else {
		return;
	}

	if (buf[i+1] == 0x00) { /*FEATURE_ID=eMSC, go slot assignment*/
		emsc_slot_size = buf[i+2];
	} else {
		return;
	}


	if (mhl3_get_state() == MHL3_READY) {
		//rtd_maskl(ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_reg,~ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_emsc_reset_mask,ECBUS_RX_ECBUS_EMSC_SYNC_CTRL_emsc_reset_mask);	// eMSC Reset
		rtd_outl(ECBUS_RX_ECBUS_TDM_SYNC_CTRL_reg, ECBUS_RX_ECBUS_TDM_SYNC_CTRL_tdm_sync_retry_mask);

		drvif_eCBUS_TDM_Slot_Sync();

		for (i = 0; i < 100; i++) {
			if (ECBUS_RX_ECBUS_EMSC_SYNC_DET_get_mark_loss_irq(rtd_inl(ECBUS_RX_ECBUS_EMSC_SYNC_DET_reg))) {
				break;
			}
			hdmi_delayus(1000);
		}

		mhl3_emsc_link_training();

	}

}

void mhl3_send_hev_vic(void)
{
	unsigned char hev_vic1[16] = {
		HEV_VIC_H, HEV_VIC_L, 0x00, 0x06, 0x01, 0x05, 0x00, 0x5d,
		0x00, 0x5e, 0x00, 0x5f, 0x00, 0x67, 0x00, 0x68
	};

	unsigned char hev_vic2[16] = {
		HEV_VIC_H, HEV_VIC_L, 0x00, 0x06, 0x02, 0x01, 0x00, 0x69,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	};
	HDMI_PRINTF("[MHL3] SEND HEV_VIC\n");

	mhl_fill_burst_chksum(hev_vic1);

	if ((MHLMscSendWriteBurst(_MHL_REG_SCRATCH_START, 16, hev_vic1, _MHL_WRITE_BURST_WITH_REQ) == _MHL_OK)) {
		mhl_fill_burst_chksum(hev_vic1);
		MHLMscSendWriteBurst(_MHL_REG_SCRATCH_START, 16, hev_vic2, _MHL_WRITE_BURST_WITH_REQ);
	} else {
		HDMI_PRINTF("[MHL3] send hev_vic fail\n");
	}

}

void mhl3_send_emsc_support(void)
{
	unsigned char emsc_buf[16] = {
		EMSC_SUPPORT_H, EMSC_SUPPORT_L, 0x00, 0x05, 0x01, 0x05,
		EMSC_SUPPORT_H, EMSC_SUPPORT_L,
		BLK_RCV_BUFFER_INFO_H, BLK_RCV_BUFFER_INFO_L,
		HEV_VIC_H, HEV_VIC_L,
		VC_ASSIGN_H, VC_ASSIGN_L,
		BIST_SETUP_H, BIST_SETUP_L
	};

	HDMI_PRINTF("[MHL3] SEND EMSC_SUPPORT\n");

	mhl_fill_burst_chksum(emsc_buf);

	if ((MHLMscSendWriteBurst(_MHL_REG_SCRATCH_START, 16, emsc_buf, _MHL_WRITE_BURST_WITH_REQ) == _MHL_OK)) {
		/* do nothing*/
	} else {
		HDMI_PRINTF("[MHL3] send emsc_support fail\n");
	}
}

void mhl3_block_rx_handler(void)
{
	unsigned int i, rx_unload_ack, len_remaining, recv_buf[256];
	unsigned int blk_rcv_buf_size;
	unsigned int reg_a574 = rtd_inl(ECBUS_RX_ECBUS_EMSC_TRANS_CTRL_reg) & ~ECBUS_RX_ECBUS_EMSC_TRANS_CTRL_emsc_tx_sent_mask;

	if (rtd_inl(ECBUS_RX_ECBUS_EMSC_RX_BLK_CNT_reg) != 0 || !ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_get_rxbuf_empty(rtd_inl(ECBUS_RX_ECBUS_EMSC_TRANS_DET_1_reg)))
	{
		rx_unload_ack = rtd_inl(ECBUS_RX_ECBUS_EMSC_RX_DATA_reg);
		len_remaining = rtd_inl(ECBUS_RX_ECBUS_EMSC_RX_DATA_reg);
		HDMI_PRINTF("[MHL3] Recv_RX_UNLOAD_ACK = 0x%02X ; Recv_LENGTH_REMAINING = 0x%02X;\n", rx_unload_ack, len_remaining);
		for (i = 0; i < len_remaining; i++)	{
			recv_buf[i] = rtd_inl(ECBUS_RX_ECBUS_EMSC_RX_DATA_reg);
			/*HDMI_PRINTF("0x%02X ", recv_buf[i]);*/
		}
		rtd_outl(ECBUS_RX_ECBUS_EMSC_TRANS_CTRL_reg, reg_a574|ECBUS_RX_ECBUS_EMSC_TRANS_CTRL_block_fw_done_mask);
		/*HDMI_PRINTF("\n");*/


		PEER_BLK_RX_BUFFER_AVAIL = PEER_BLK_RX_BUFFER_AVAIL + Recv_RX_UNLOAD_ACK;
		Send_RX_UNLOAD_ACK = Send_RX_UNLOAD_ACK + (Recv_LENGTH_REMAINING + 2);

		if (recv_buf[0] == BLK_RCV_BUFFER_INFO_H && recv_buf[1] == BLK_RCV_BUFFER_INFO_L) {
			blk_rcv_buf_size = recv_buf[2] + (recv_buf[3]<<8);
			peer_blk_rx_buffer_avail = blk_rcv_buf_size - (256 - peer_blk_rx_buffer_avail);
			HDMI_PRINTF("[MHL3] PEER_BLK_RX_BUFFER_AVAIL = %d\n", peer_blk_rx_buffer_avail);
			blk_recv_info = 1;
			blk_recv_count = len_remaining + 1;
		} else {
			peer_blk_rx_buffer_avail += rx_unload_ack;
		}
	}
}

void mhl3_block_tx_handler(unsigned char unload_ack, unsigned char len_remaining, unsigned char *subpayload)
{
	unsigned char i, blk_tx[256];

	blk_tx[0] = unload_ack;
	blk_tx[1] = len_remaining;
	for (i = 0; i < len_remaining; i++) {
		blk_tx[i+2] = subpayload[i];
	}

	if (drvif_Send_Block_Transaction(blk_tx, len_remaining+1)) {
		peer_blk_rx_buffer_avail -= (len_remaining+2);
	}
}

void mhl3_init_block_trans(void)
{
	unsigned char blk[4] = {BLK_RCV_BUFFER_INFO_H, BLK_RCV_BUFFER_INFO_L, 0x20, 0x01};
	mhl3_block_tx_handler(0, 4, blk);
}

void mhl3_block_handler(void)
{
	unsigned char blk_buf[256];

	mhl3_block_rx_handler();

	if (blk_recv_info) {
		mhl3_block_tx_handler(blk_recv_count, 0, blk_buf);
		blk_recv_info = 0;
	}

}

#endif
