#include <qc_verify_common.h>

/*
Sophia added for convenient
if test your own ip, follow these steps
1. \uboot\include\configs\rtd299s_qc_verify.h
=> #define CONFIG_QC_item 1
2. QC/FT 
=>
#define CONFIG_EQC 1
#define CONFIG_FT  0
#define CONFIG_RMA 0  //for RMA IC analysis
3. package
=>
#define CONFIG_176_PKG  1   
#define CONFIG_256_PKG  0 
4. Peripheral
=> #define CONFIG_QC_PERIPHERAL 1
5. Your own IP
=> #define EN_Verify_Irda
6. mark dif IC
*/

#define EN_Verify_GPIO
#define EN_Verify_Uart
#define EN_Verify_Timer
#define EN_Verify_RTC
#define EN_Verify_LSADC
#define EN_Verify_Irda
#define EN_Verify_I2C_DDC
//#define EN_Verify_DDC_STATUS
//#define EN_Verify_I2C_GUARD_INT
//#define EN_Verify_I2C_SETUP
//#define EN_Verify_I2C_MultiMaster


extern int Verifier_GPIO(void);
extern int Verifier_LSADC(void);
extern int Verify_Uart(void);
extern int Verify_Timer(UINT8 NSec);
extern int Verify_Irda(void);
extern int Verify_I2C_DDC(void);
extern int Verify_RTC(void);

int QC_Verifier_PERIPHERAL(void)
{
  	UINT32    debug_result=0;
  	UINT32    fail_result = 0;
	printk("Peripheral verifying...\n");
	

    //GPIO HL Freq
#ifdef EN_Verify_GPIOHLFreq
	 Verifier_GPIO_Freq(23,0xb8060218,31,28,0xf,1);//ISO_GPIO23(JP144_3)
     //Verifier_GPIO_Freq(115,0xb80008b4,31,28,0xf,0);//MIS_GPIO115(JP129_3)
#endif


	// GPIO verify	
#ifdef EN_Verify_GPIO
	debug_result =Verifier_GPIO();
	fail_result |= debug_result;
	if (debug_result)
		printk("GPIO failed\n\n");
	else
		printk("GPIO pass\n\n");
#endif
	
	// LSADC verify
#ifdef EN_Verify_LSADC
	debug_result =Verifier_LSADC();
	fail_result |= debug_result;
	if (debug_result)
		printk("LSADC failed\n\n");
	else
		printk("LSADC pass\n\n");
#endif

	// UART verify
#ifdef EN_Verify_Uart
	debug_result = Verify_Uart();	
	fail_result |= debug_result;
	if (debug_result)
		printk("Uart  failed\n\n");
	else
		printk("Uart  pass\n\n");
#endif

	// Timer verify	
#ifdef EN_Verify_Timer
	debug_result = Verify_Timer(2);
	fail_result |= debug_result;
	if (debug_result)
		printk("Timer failed\n\n");
	else
		printk("Timer pass\n\n");
#endif


	// Irda verify	
	// Irda Gen
#ifdef EN_Verify_Irda_TX
	debug_result =irda_tx("NEC", 0x04, 0x5f);
	fail_result |= debug_result;
	if (debug_result)
		printk("Irda tx failed\n");
	else
		printk("Irda tx pass\n");
#endif


	// Irda verify	
#ifdef EN_Verify_Irda
	debug_result =Verify_Irda();
	fail_result |= debug_result;
	if (debug_result)
		printk("Irda failed\n\n");
	else
		printk("Irda pass\n\n");
#endif


	// I2C_DDC verify	
#ifdef EN_Verify_I2C_DDC
	debug_result =Verify_I2C_DDC();	
	fail_result |= debug_result;
	if (debug_result)
		printk("I2C_DDC failed\n\n");
	else
		printk("I2C_DDC pass\n\n");
	
#endif



#ifdef EN_Verify_DDC_STATUS

	debug_result = Verify_I2C_DDC_Status_Main();
	fail_result |= debug_result;
	if (debug_result)
		printk("\x1b[31mDDC Status Verify failed\x1b[0m\n\n");
	else
		printk("\x1b[33mDDC Status Verify pass\x1b[0m\n\n");	

#endif	


#ifdef EN_Verify_I2C_GUARD_INT
      Verify_I2C_DDC_GuardINT(3,1,0);
      Verify_I2C_DDC_GuardINT(3,1,1);
      printk("I2C_Guard INT finish!\n");
#endif

#ifdef EN_Verify_I2C_SETUP
      Verify_I2C_SETUP(2,1,0xff);
      printk("I2C_SETUP finish!\n");
#endif

#ifdef EN_Verify_I2C_MultiMaster
      debug_result = Verify_I2C_MultiMaster_ReStart(0,1,3);
      fail_result |= debug_result;	
      printk("I2C Multi-Mastr verify finish!\n");
#endif




     // RTC verify 
#ifdef EN_Verify_RTC
	debug_result =Verify_RTC();
	fail_result |= debug_result;
	if (debug_result)
		printk("RTC failed\n");
	else
		printk("RTC pass\n");
#endif

    printk("Peripheral Verify finish!\n");
 
	//conclude results
	if(fail_result)   	 //  fail  return 1 ;   pass return 0 ;  
		return FAILED ;
	else
		return SUCCESS;
}
