#include <qc_verify_common.h>
#include <VBI_qc.h>
#include <VBI_verify.h>
#include <rbusCRTReg.h>
#include <rbusVbiReg.h>
#include <rbusVDTopReg.h>

#if showbug
#define dmsg printk
#else
#define dmsg printk
#endif

void vbi_delay(UINT32 count)
{
	UINT32 ulDelay;
	for(ulDelay=0;ulDelay<count;ulDelay++)
	{
        	udelay(100);
	}
}

void initialize_clock_mac5p(void)
{
	dmsg("%s()_%d\n",__FUNCTION__,__LINE__);
	rtd_outl(0xb80004d0,0x0224000a);
	rtd_outl(0xb80004d4,0x88085501);
	rtd_outl(0xb80004d8,0x00000004);
	rtd_outl(0xb80004dc,0x2206fe01);

//	printk("0xb8000114=%x\n", rtd_inl(0xb8000114));
//	printk("0xb8000118=%x\n", rtd_inl(0xb8000118));
//	printk("0xb8000104=%x\n", rtd_inl(0xb8000104));
//	printk("0xb8000108=%x\n", rtd_inl(0xb8000108));

	rtd_outl(0xb8000114,0x00500000);
	rtd_outl(0xb8000118,0x08000000);
	rtd_outl(0xb8000104,0x00700000);
	rtd_outl(0xb8000108,0x0c000000);

	udelay(3000);
// 0xb8000104=fb61adf7
// 0xb8000108=ca017a4
	rtd_outl(0xb8000104,0x00700001);
	rtd_outl(0xb8000108,0x0c000001);
	udelay(5000);
// 0xb8000114=fb6dade7
// 0xb8000118=ce017a4
	rtd_outl(0xb8000114,0x00500001);
	rtd_outl(0xb8000118,0x08000001);

	rtd_maskl(0xb8000204,0xFFFCFFFF,0x00020000);//[17]ATVIN_CLK_SEL] = 0x1, 0x0: IFD, 0x1: VD [16]ATVIN_VD_CLK_SEL = 0x0, 0x0: 108MHz 0x1: 27MHz

	rtd_maskl(0xb80004d4, ~0x00070000, 0x00070000);
	rtd_maskl(0xb80004d8, ~0x17, 0x10);
	rtd_maskl(0xb80004d8, ~0x17, 0x16);
	rtd_maskl(0xb80004d8, ~0x17, 0x17);

	dmsg("%s()_%d\n",__FUNCTION__,__LINE__);
}

void Clock_setting_script(void)
{
	////PLL27x Clock : 108M
	initialize_clock_mac5p();
////////// VBI clock setting //////////
	//rtd_maskl(CRT_SYS_SRST0_reg,~(_BIT6),_BIT6);	//[6]RSTN_VDE=1, set Reset bit of VDE to 1
//	rtd_maskl(0xb8000104,0xFFEFFFFF,0x00100000);	//[20]RSTN_VBIS0=1, set reset bit to 1
	//rtd_maskl(CRT_SYS_SRST1_reg,~(_BIT20),_BIT20);	//[20]RSTN_VBIS0=1, set reset bit to 1
//	rtd_maskl(0xb8000114,0xFFEFFFFF,0x00100000);	//[20]CLKEN_VBIS0=1, VBI clock enable
	//rtd_maskl(CRT_SYS_CLKEN1_reg,~(_BIT20),_BIT20);	//[20]CLKEN_VBIS0=1, VBI clock enable
//	rtd_maskl(0xb8000204,0xFFFFFFDF,0x00000000);	//[5]VBIS0_YPPSEL=0, VBI source, 0: Video Decoder,1: YPBPR
	//rtd_maskl(CRT_SYS_CLKSEL_reg,~(_BIT5),_ZERO);	//[5]VBIS0_YPPSEL=0, VBI source, 0: Video Decoder,1: YPBPR

//	rtd_maskl(0xb8019764,0xFFFFF8FF,0x00000000);	// bit[10:8]=000, select Select the VCO freq = 432M
}

void  Silcer_Initial(void)
{
	printk("[Slicer] Initial...  \n");
//	printk("drvif_module_vdc_Initial done ...  \n");

//----------------       VD setting   start ------------------------------ 
//	rtd_outl(0xb8000508,0x000000B3); 	// enable VDC 27x clock bit[0,1,4,5,7]
//	printk("rtd_inl(0xb8000508)=%x  \n", rtd_inl(0xb8000508));
//	rtd_outl(0xb800050C,0x03031201); 	// select PLL27X_CKOUT_YPPADC_33V = 108M
//	printk("rtd_inl(0xb800050C)=%x  \n", rtd_inl(0xb800050C));
//	rtd_outl(VDTOP_MISC_CONTROL_VADDR,0x0002017F); 	// bit[9:8]=01, select Select the VCO freq = 540M
//	printk("rtd_inl(0xb8019764)=%x  \n", rtd_inl(0xb8019764));
//----------------       VD setting   end ------------------------------

//----------------       CC  setting  start ------------------------------
        //rtd_outl(VBI_VBISL0_VADDR, 0x01600022);  
        //rtd_outl(VBI_TT_VBI_CONTROL_REGISTER_VADDR, 0x005a2717);  //  auto adjust slicer level 
        //rtd_outl(VBI_TT_VBI_NOISY_CTRL1_VADDR, 0x2050a023);  // bit 29  set that data from vd put through 16 tape low pass filter
        rtd_outl(VBI_TT_VBI_NOISY_CTRL4_VADDR, 0x0f141110);  //  resample data don't do "rounding" 
        rtd_outl(VBI_VBISL0_VADDR, 0x90000000);
        rtd_outl(VBI_TT_VBI_CONTROL_REGISTER_VADDR, 0x006c2713);      // fix slicer level =6C 
        rtd_outl(VBI_TT_VBI_DATA_TYPE_CONFIG_REG_FOR_LINE_9_12_VADDR, 0x00000000);	//line 9,10,11,12
        rtd_outl(VBI_TT_VBI_DATA_TYPE_CONFIG_REG_FOR_LINE_13_16_VADDR, 0x00000000);
        rtd_outl(VBI_TT_VBI_DATA_TYPE_CONFIG_REG_FOR_LINE_17_20_VADDR, 0x00000000);	//line 17,18,19,20
        rtd_outl(VBI_TT_VBI_DATA_TYPE_CONFIG_REG_FOR_LINE_21_24_VADDR, 0x00001100);	//line 21,22,23,24
        rtd_outl(VBI_TT_VBI_DTO_REGISTER1_VADDR, 0x00001ad0);
        rtd_outl(VBI_TT_VBI_NOISY_CTRL3_VADDR, 0x005a0100);
        rtd_outl(VBI_TT_VBI_CO_CH_CTRL_VADDR, 0x00000000);
        rtd_outl(VBI_TT_VBI_NOISY_CTRL1_VADDR, 0x0f043110);
        rtd_outl(VBI_TT_VBI_PATTERN_SEL_VADDR, 0x0f001000);

	//rtd_outl(0xb8030800, 0x90000000);
	//rtd_outl(0xb8030a08, 0x00000000);		//line 9,10,11,12
	//rtd_outl(0xb8030a0c, 0x00000000);
	//rtd_outl(0xb8030a10, 0x00000000);		//line 17,18,19,20	
	//rtd_outl(0xb8030a14, 0x00001100);		//line 21,22,23,24
	//rtd_outl(0xb8030a20, 0x00001ad0);
	//rtd_outl(0xb8030a68, 0x005a0100);

        //rtd_outl(0xb8030a00, 0x4b4b2713);   
        //rtd_outl(0xb8030a30, 0x00004600);   
        //rtd_outl(0xb8030a6c, 0x00000000);   
        //rtd_outl(0xb8030a74, 0x0f143110);   
        //rtd_outl(0xb80193c4, 0x00000003); 

        rtd_outl(VBI_VBI_DEBUG_MODE_VADDR, 0x80000109);//CC,CGMS pattern gen enable  
        rtd_outl(VBI_TT_VBI_DATA_TYPE_CONFIG_REG_FOR_LINE_25_26_VADDR, 0x00001111);//designed error ,need select all line except 7~25
//----------------       CC  setting  end ------------------------------
		

//----------------       CGMS  setting  start ------------------------------
	rtd_outl(VBI_VBISL0_VADDR,0x00000080);
	rtd_outl(VBI_VBI_VOUNT_SHIFT_VADDR, 0x00000000);
	rtd_outl(VBI_CGMS_C0_VADDR, 0x07006413);
	rtd_outl(VBI_CGMS_C1_VADDR, 0x000a0027); 
	rtd_outl(VBI_CGMS_C2_VADDR, 0x00300130);
	rtd_outl(VBI_CGMS_C5_VADDR, 0x0010241a);

        //rtd_outl(0xb8030900,0x0700641F);
        //rtd_outl(0xb8030904,0x000a0027);
        //rtd_outl(0xb8030908,0x00300130);
        //rtd_outl(0xb8030914,0x0010241a);
        rtd_outl(VBI_VBI_DEBUG_MODE_VADDR,0x00000100);

// 0x5910=0x01080001  => CGMS T
//----------------       CGMS  setting  end ------------------------------
//	printk("[Slicer] Initial done !!!  \n");
}

void  Silcer_Reset(void)
{
	// reset RSTN_VBIS0
	// reset CLKEN_VBIS0
	rtd_outl(0xb8000114, 0x00100000);
	rtd_outl(0xb8000104, 0x00100000);

	udelay(10);
	
	rtd_outl(0xb8000104, 0x00100001);

	udelay(10);
	
	rtd_outl(0xb8000114, 0x00100001);
}

#ifdef Slicer_CC_test
UINT8 module_Slicer_CC_test(void)
{
	UINT32 i,j;
	UINT32 cc_detect;
	cc_detect = _FAIL;
	////////// check CC //////////
//	printk("Slicer_CC_test start   \n");

	i = 0;
    	while(i<first_delay)
    	{
        	udelay(100);
        	i++;
		if(i == 100)
			printk("0xb8030a30[17]=%x\n", rtd_inl(0xb8030a30));
		if((rtd_inl(VBI_TT_VBI_DATA_STATUS_VADDR)&_BIT17)==_BIT17) // Bit17 = 1
		{
        		printk("VBI_TT_VBI_DATA_STATUS_VADDR=_BIT17   \n");

            		cc_detect = rtd_inl(VBI_TT_VBI_CCWSS_DATA_VADDR)&0x0000ffff;

            		if(cc_detect != CC_VALUE)
            		{
                     	j=0;
                       	while(j<two_delay)
                    		{
	                            udelay(50);
	                            udelay(50);
	                            j++;
	                           if((rtd_inl(VBI_TT_VBI_DATA_STATUS_VADDR)&_BIT17)==_BIT17) // Bit17 = 1
	                           {
						cc_detect = rtd_inl(VBI_TT_VBI_CCWSS_DATA_VADDR)&0x0000ffff;
						if(cc_detect != CC_VALUE)
						{
							printk("[Slicer #1] CC fai,the value==>%x  , j=%d \n", cc_detect,j );
							cc_detect = _FAIL;
						}
						else
						{
//							printk("[Slicer #1] CC pass!!\n");
							cc_detect = _SUCCESS;
							return cc_detect;
						}
	                            }
                            	rtd_maskl(VBI_TT_VBI_DATA_STATUS_VADDR, ~_BIT17, _BIT17);
                             	udelay(50);
                             	udelay(50);
                    		}
			}
			else
			{
				rtd_maskl(VBI_TT_VBI_DATA_STATUS_VADDR, ~_BIT17, _BIT17);
				udelay(50);
				udelay(50);
				udelay(50);
				udelay(50);
				udelay(50);

//				printk("[Slicer #1] CC pass!!\n");
				cc_detect = _SUCCESS;
				return cc_detect;
              	}
			
			rtd_maskl(VBI_TT_VBI_DATA_STATUS_VADDR, ~_BIT17, _BIT17);
			udelay(50);
			udelay(50);
			udelay(50);
			udelay(50);
			udelay(50);
		}
	}

	if(cc_detect == _FAIL)
	{
		printk("the VDC slicer1 detect cc is fail the detect value\n" );
		return cc_detect;
	}
	return cc_detect;
}
#endif

#ifdef Slicer_CGMS_test
UINT8 module_Slicer_CGMS_test(void)
{
	UINT32 i,j;
	UINT32 cgms_detect;
	////////// check CGMS //////////
	i = 0;
	cgms_detect = _FAIL;
	rtd_maskl(VBI_CGMS_C4_VADDR, ~_BIT24, _BIT24);
	udelay(50);
	udelay(50);
	while(i<first_delay)
	{
		udelay(100);
		i++;
		if((rtd_inl(VBI_CGMS_C4_VADDR)&_BIT24)==_BIT24) // Bit24 = 1
		{
			cgms_detect = rtd_inl(VBI_CGMS_C4_VADDR)&0x000fffff;

			if(cgms_detect != CGMS_VALUE)
			{
				j=0;
				while(j<two_delay)
				{
					j++;
					udelay(50);
					udelay(50);
					if((rtd_inl(VBI_CGMS_C4_VADDR)&_BIT24)==_BIT24) // Bit24 = 1
					{
						cgms_detect = rtd_inl(VBI_CGMS_C4_VADDR)&0x000fffff;

						if(cgms_detect != CGMS_VALUE)
						{
							printk("[Slicer #1] CGMS fai,the value==>%x \n", cgms_detect );
							cgms_detect = _FAIL;
						}
						else
						{
//							printk("[Slicer #1] CGMS pass!!\n");
							cgms_detect = _SUCCESS;
							return cgms_detect;
						}
					}
					rtd_maskl(VBI_CGMS_C4_VADDR, ~_BIT24, _BIT24);
					udelay(50);
					udelay(50);
				}
			}
			else
			{	  
				rtd_maskl(VBI_CGMS_C4_VADDR, ~_BIT24, _BIT24);
				udelay(50);
				udelay(50);
				udelay(50);
				udelay(50);
				udelay(50);
//				printk("[Slicer #1] CGMS pass!!\n");
				cgms_detect = _SUCCESS;
				return cgms_detect;		
			}
			rtd_maskl(VBI_CGMS_C4_VADDR, ~_BIT24, _BIT24);
			udelay(50);
			udelay(50);
			udelay(50);
			udelay(50);
			udelay(50);
		}
	}

	if(cgms_detect == _FAIL)
	{
		printk("the VDC slicer1 detect CGMS is fail the detect value\n" );
		return cgms_detect;
	}
	return cgms_detect;
}
#endif

#ifdef Slicer_mbist_test
UINT8 mbist_test(void)
{
	UINT8 i=0;
#if 0
	rtd_maskl(SYSTEM_GROUP1_CK_EN_VADDR, ~_BIT20, 0);//reset VBI
	udelay(10);
	rtd_maskl(SYSTEM_GROUP1_CK_EN_VADDR, ~_BIT20, _BIT20);
	udelay(10);

	rtd_maskl(SYSTEM_SOFT_RESET3_VADDR, ~_BIT9, 0);//reset VBI
	udelay(10);
	rtd_maskl(SYSTEM_SOFT_RESET3_VADDR, ~_BIT9, _BIT9);
#else
	Silcer_Reset();
#endif
  
	rtd_maskl(VBI_BIST_TEST1_VADDR, ~_BIT0, _BIT0);//Sram power on
	rtd_maskl(VBI_BIST_MODE_VADDR, ~_BIT0, _BIT0);//bist_mode ] 1

	for (i=0; i < 50;i++)
	{
		udelay(1000);
		if (rtd_inl(VBI_BIST_DONE_VADDR)&_BIT0)
		{
			break;
		}
	}

	if (i == 50)
		printk("[Slicer] mbist test time out!!\n");
	else
	{
		if((rtd_inl(VBI_BIST_FAIL_VADDR)&_BIT0) == 0)
			return _SUCCESS;
	}
	return _FAIL;
}
#endif

#ifdef Slicer_mbist_drf_test
UINT8 mbist_drf_test(void)
{
	UINT8 i =0;
#if 0
	rtd_maskl(SYSTEM_GROUP1_CK_EN_VADDR, ~_BIT20, 0);//reset VBI clock
	udelay(10);
	rtd_maskl(SYSTEM_GROUP1_CK_EN_VADDR, ~_BIT20, _BIT20);
	udelay(10);

	rtd_maskl(SYSTEM_SOFT_RESET3_VADDR, ~_BIT9, 0);//soft reset VBI
	udelay(10);
	rtd_maskl(SYSTEM_SOFT_RESET3_VADDR, ~_BIT9, _BIT9);
#else
	Silcer_Reset();
#endif

	rtd_maskl(VBI_BIST_TEST1_VADDR, ~_BIT0, _BIT0);//Sram power on
	rtd_maskl(VBI_BIST_DRF_MODE_VADDR, ~_BIT0, _BIT0);//bist_mode_drf ] 1

	for (i=0; i < 50;i++)
	{
		udelay(1000);
		if (rtd_inl(VBI_BIST_DRF_PAUSE_VADDR)&_BIT0)//bist_drf_start_pause |1 
		{
			break;
		}
	}
	if (i == 50)
		printk("[Slicer] mbist_drf  test time out 1!!\n");
	
	rtd_maskl(VBI_BIST_DRF_RESUME_VADDR, ~_BIT0,_BIT0);//Mbist_dma resume
	udelay(1000);
	rtd_maskl(VBI_BIST_DRF_RESUME_VADDR, ~_BIT0,0);
	
	for (i=0; i < 50;i++)
	{
		udelay(1000);
		if (rtd_inl(VBI_BIST_DRF_PAUSE_VADDR)&_BIT0)//bist_drf_start_pause |1 
		{
			break;
		}
	}
	if (i == 50)
		printk("[Slicer] mbist_drf  test time out 2!!\n");	

	rtd_maskl(VBI_BIST_DRF_RESUME_VADDR, ~_BIT0,_BIT0);//Mbist_dma resume
	udelay(1000);
	rtd_maskl(VBI_BIST_DRF_RESUME_VADDR, ~_BIT0,0);

	for (i=0; i < 50;i++)
	{
		udelay(1000);
		if (rtd_inl(VBI_BIST_DONE_DRF_VADDR)&_BIT0)
		{
			break;
		}
	}	

	if (i == 50)
		printk("[Slicer] mbist_drf  test time out 3!!\n");	
	else
	{
		if((rtd_inl(VBI_BIST_FAIL_DRF_VADDR)&_BIT0) == 0)
			return _SUCCESS;
	}
	return _FAIL;		
	

}
#endif







int QC_Verifier_VBI(void)
{
	//UINT32 i;
	printk("[Slicer] QC_Verifier_VBI\n");
	Clock_setting_script();

//== QC_test start ======================================
#ifdef QC_test
	Silcer_Initial();

	vbi_delay(1000);

#ifdef Slicer_CC_test
	if(module_Slicer_CC_test()==_SUCCESS)
		printk("[Slicer] CC pass!!\n");
	else
	{
		printk("[Slicer] CC fail!!\n");
		return _FAIL;
	}
#endif
#ifdef Slicer_CGMS_test
	if(module_Slicer_CGMS_test()==_SUCCESS)
		printk("[Slicer] CGMS pass!!\n");
	else
	{
		printk("[Slicer] CGMS fail!!\n");
		return _FAIL;
	}
#endif 

#ifdef CONFIG_RTD299O_QC
	rtd_maskl(0xb8000ff0, ~_BIT31, _BIT31); //chip_bist_set_on
#endif

#ifdef Slicer_mbist_test	
	if (mbist_test() == _SUCCESS)
		printk("[Slicer] mbist pass!!\n");
	else
	{
		printk("[Slicer] mbist fail!!\n");
		return _FAIL;
	}
#endif
#ifdef Slicer_mbist_drf_test
	if (mbist_drf_test() == _SUCCESS)
		printk("[Slicer] mbist_drf pass!!\n");
	else
	{
		printk("[Slicer] mbist_drf fail!!\n");
		return _FAIL;
	}
#endif

	#ifdef CONFIG_RTD299O_QC
	rtd_maskl(0xb8000ff0, ~_BIT31, 0); //chip_bist_set_on
	#endif
//== QC_test end  ======================================
#else
	vbi_delay(10000);
	Display_Init();
	rtd_outl(VBI_VBI_DEBUG_MODE_VADDR, 0x00000000);//CC,CGMS pattern gen disable
#endif

//== select source ======================================
#ifdef AV_Input
	AV_Init();
#endif
#ifdef IFD_Input
	IFD_Init();
#endif
#ifdef YPP_Input
	YPbPr_Init();
#endif

//== CC_verify_test start ==================================
#ifdef CC_verify_test
	if((rtd_inl(VDTOP_VIDEO_STATUS_REG1_VADDR) & _BIT0) == 0)
	{
		CC_Init();
		vbi_delay(1500);
		CC_verify();
	}
	else
		printk("Error : CC_verify_test no signal ~\n");
#endif
//== CC_verify_test end  ==================================

//== CGMS_test start ====================================
#ifdef CGMS_test
	CGMS_Init();
	CGMS_verify();
#endif
//== CGMS_test end  ====================================

//== TT_WSS_VPS_test start ===============================
#ifdef TT_WSS_VPS_test
	vbi_delay(1500);
	TT_WSS_VPS_Init();
#ifdef TT_DMA_test
	DMA_Init();
#endif
	TT_WSS_VPS_verify();
#endif
//== TT_WSS_VPS_test end  ===============================

	return _SUCCESS;
}




