#include "ve_common.h"
#include "ve_plat.h"
#include "auto_ve_cfg.h"
//#include "ve1_decode_pattern.h"

extern unsigned int _e_v_entry_qc_img;
extern unsigned int _f_v_entry_qc_img;

#ifdef ENABLE_VE1_TRUE
#include VE1_PATTERN_HEADER
unsigned int * const VE1_Pattern_Entry_Ptr = (unsigned int *)MIPS_VIDEO_FW_ENTRY_PTR_V1_ADDR;
#endif

#ifdef ENABLE_VE2_TRUE
#include VE2_PATTERN_HEADER
unsigned int * const VE2_Pattern_Entry_Ptr = (unsigned int *)MIPS_VIDEO_FW_ENTRY_PTR_V2_ADDR;
#endif

int prepare_ve_pattern()
{
	int i;
	int len;
#ifdef ENABLE_VE1_TRUE
	struct hex_data * pPattern1 = pattern_ve_encode1;
	len = sizeof(pattern_ve_encode1)/sizeof(struct hex_data);
	prints("len:0x");print_val(len,8);prints("\n");
	for (i = 0;i < len; i++)
	{
		//prints("addr:0x");print_val(pPattern1[i].addr,8);prints("\n");
		//prints("data:0x");print_val(pPattern1[i].data,8);prints("\n");
		//printf("%08d 0x%08x(0x%08x) = 0x%08x(0x%08x)\n", i, pPattern1[i].addr, &(pPattern1[i].addr), pPattern1[i].data, &(pPattern1[i].data));
		rtd_outl(pPattern1[i].addr, pPattern1[i].data);//io.h only
	}
#endif

#ifdef ENABLE_VE2_TRUE
	struct hex_data * pPattern2 = pattern_ve_encode2;
	len = sizeof(pattern_ve_encode2)/sizeof(struct hex_data);
	for (i = 0;i < len; i++)
	{
		//printf("%08d 0x%08x(0x%08x) = 0x%08x(0x%08x)\n", i, pPattern1[i].addr, &(pPattern1[i].addr), pPattern1[i].data, &(pPattern1[i].data));
		rtd_outl(pPattern2[i].addr, pPattern2[i].data);//io.h only
	}
#endif

	return 0;
}

int prepare_ve_vari()
{

	rtd_outl(0x01fff080,0x00000000); //current MB
	rtd_outl(0x01fff084,0x00000000); //current frame count
	rtd_outl(0x01fff000,0xFFFF0000); //test runing or finish or crc error

	rtd_outl(0x01fff040,0x00000000); //frame decode cnt
	rtd_outl(0x01fff06c,0x00000000); //frame display cnt
	rtd_outl(0x01fff41c,0x00000000); //start_frame
	rtd_outl(0x00002f40,0x20000000); //end_frame
	rtd_outl(0x00002f4c,0x00000000); //0:decoding order
	rtd_outl(0x00002f50,0x14000000); //decoder configuration word
	rtd_outl(0x00002f54,0x01000000); //crc check
#ifdef ENABLE_VE1_TRUE
	rtd_outl(VE1_TEST_RESULT_ADDR,SWAPEND32(VE_TEST_PASS_VAL)); //test result
	//rtd_outl(0x00002104,0x00000000); //
	rtd_outl(VE1_TEST_MODE_ADDR,VE_MODE_VCPU_ONLY); //vcpu-only test;test mode
	rtd_outl(VE1_FINISH_RELOAD_VAL_ADDR,SWAPEND32(V_FINISH_VE_CODE_ADDR_SEG1)); //when finish vcpu will jump to this entry again
	rtd_outl(VE1_RUN_CMD_ADDR,VE_TEST_RUN_CMD); //command start run
#endif

#ifdef ENABLE_VE2_TRUE
	rtd_outl(VE2_TEST_RESULT_ADDR,SWAPEND32(VE_TEST_PASS_VAL)); //test result
	//rtd_outl(0x00002104,0x00000000); //
	rtd_outl(VE2_TEST_MODE_ADDR,VE_MODE_VCPU_ONLY); //vcpu-only test;test mode
	rtd_outl(VE2_FINISH_RELOAD_VAL_ADDR,SWAPEND32(V_FINISH_VE_CODE_ADDR_SEG1)); //when finish vcpu will jump to this entry again
	rtd_outl(VE2_RUN_CMD_ADDR,VE_TEST_RUN_CMD); //command start run
#endif

	return 0;
}


int prepare_ve_entry()
{
#ifdef CFG_PREPARE_VE_ENTRY_TRUE
	unsigned char *a,*b;

	// copy .v_entry_qc  (VCPU)
	a = (unsigned char *)&_e_v_entry_qc_img;
	b = (unsigned char *)&_f_v_entry_qc_img;

	//debug("copy v_entry_qc addr = 0x%x, size = 0x%x\n", MIPS_V_ENTRY_CODE_ADDR, a-b);
	memcpy((unsigned char *)MIPS_V_ENTRY_CODE_ADDR, b, a-b);

	// asign entry from romcode to DDR(small bootcode)
	rtd_outl(VCPU_JUMP_ADDR_reg, MIPS_V_ENTRY_CODE_ADDR | MIPS_KSEG1BASE);

	//debug("video from romcode entry = 0x%08x\n", rtd_inl(VCPU_JUMP_ADDR_reg));
#ifdef ENABLE_VE1_TRUE
	// asign entry from DDR(small bootcode) to DDR(DV)
	*VE1_Pattern_Entry_Ptr = SWAPEND32(MIPS_V_ENTRY_VE1_PARTTEN);
	//print_val(SWAPEND32(MIPS_V_ENTRY_VE1_PARTTEN|MIPS_KSEG1BASE),8);
	//debug("video1 dv entry = 0x%08x\n", *VideoFW_entry_ptr_V1);
#endif

#ifdef ENABLE_VE2_TRUE
	*VE2_Pattern_Entry_Ptr = SWAPEND32(MIPS_V_ENTRY_VE2_PARTTEN);
	prints("video2 dv entry =");
	print_val((UINT32)VE2_Pattern_Entry_Ptr, 8);
	prints(":");
	print_val(*VE2_Pattern_Entry_Ptr,8);
	prints("\n");
#endif
#endif

	return 0;
}

int enable_vcpus(int VE_num)
{
	enable_ve_clock(VE_num);
	udelay(20000);
	return 0;
}

int disable_vcpus(int VE_num)
{

	disable_ve_clock(VE_num);
	udelay(20000);

	return 0;
}
int ve_ddr_debug (int VE_num)
{
	volatile unsigned int check_status_ve1 = 0;
	volatile unsigned int check_status_ve2 = 0;
	unsigned int timeout = 0x00002000;
	unsigned int error = 0;

	while(--timeout)
	{
		if(VE_num == 1)
		{
			invalidate_dcache_range(VE1_STATUS_VAL_ADDR, VE1_STATUS_VAL_ADDR+4);
			check_status_ve1 = rtd_inl(VE1_STATUS_VAL_ADDR); /* VE1 run status addr */
			if ((check_status_ve1 == VE_STATUS_DONE))
			{
				prints("ve1_done\n");
				break;
			}
			else if ((check_status_ve1 == VE_STATUS_CRC_ERROR))
			{
				prints("ve1_crc_err\n");
				error = 1;
				break;
			}
			else
			{
				if(timeout % 400 == 0)
				{
					prints("loop waiting...\n");
				}
				udelay(200);
			}
		}

		if(VE_num == 2)
		{
			invalidate_dcache_range(VE2_STATUS_VAL_ADDR, VE2_STATUS_VAL_ADDR+4);
			check_status_ve2 = rtd_inl(VE2_STATUS_VAL_ADDR);
			if (check_status_ve2 == VE_STATUS_DONE)
			{
				prints("ve2_done\n");
				break;
			}
			else if (check_status_ve2 == VE_STATUS_CRC_ERROR)
			{
				prints("ve2_crc_err\n");
				error = 1;
				break;
			}
			else
			{
				if(timeout % 400 == 0)
				{
					prints("loop waiting...\n");
				}
				udelay(200);
			}
		}

	} /* while(--timeout) */

	if(VE_num == 1)
	{
		 if (error) {
			prints("crc error~!\n");
			return -1;
		}
		else if (timeout){
			prints("no-timeout\n");
			return 0;
		}
		else {
			prints("timeout~!\n");
			return -2;
		}
	}// if(VE_num == 1)
	else if(VE_num == 2)
	{
		if (error) {
			prints("crc error~!\n");
			return -1;
		}
		else if (timeout){
			prints("no-timeout\n");
			return 0;
		}
		else {
			prints("timeout~!\n");
			return -2;
		}
	} // else if(VE_num == 2)

}

int show_result(int VE_num, int ret)
{
	unsigned int result_ve1 = 0;
	unsigned int result_ve2 = 0;
	if(VE_num == 1)
	{
		invalidate_dcache_range(VE1_TEST_RESULT_ADDR, VE1_TEST_RESULT_ADDR+0x4);
		result_ve1 = SWAPEND32(rtd_inl(VE1_TEST_RESULT_ADDR));  // VE1 test pass|fail flag
	//printf("result_VE1 = 0x%x\n", result_ve1);
		prints("result_VE1 = 0x");
		print_val(result_ve1,8);
		prints("\n");

		if (VE_TEST_PASS_VAL != result_ve1 || ret < 0)
		{
	   	 	prints("VE1 FAIL\n");
	    		return 1;
		}
		else
		{
	    		prints("VE1 PASS\n");
	    		return 0;
		}
	}

	if(VE_num == 2)
	{
		invalidate_dcache_range(VE2_TEST_RESULT_ADDR, VE2_TEST_RESULT_ADDR+0x4);
		result_ve2 = SWAPEND32(rtd_inl(VE2_TEST_RESULT_ADDR));  // VE2 test pass|fail flag
		//printf("result_VE2 = 0x%x\n", result_ve2);
		prints("result_VE2 = 0x");
		print_val(result_ve2,8);
		prints("\n");
		if (VE_TEST_PASS_VAL != result_ve2 || ret < 0)
		{
	    		prints("VE2 FAIL\n");
	    		return 1;
		}
		else
		{
	    		prints("VE2 PASS\n");
	    		return 0;
		}
	}
}

int ve_uniform_entry(void)
{
	int ret = 0;
	int debug_ret = 0;

	//prepare ve pattern,write data to ddr by the guide of ve header file
	prepare_ve_pattern();
	prints("\n [prepare_ve_pattern] finish \n");

		//prepare ve vari,init ve result/mode/finish jump addr/command etc.
	prepare_ve_vari();
	prints("\n [prepare_ve_vari] finish \n");

		//prepare ve entry,copy v_entry_qc.img to ddr,and set the v_entry_qc.img address at vcpu jump address reg
	prepare_ve_entry();
	prints("\n [prepare_ve_entry] finish \n");

	//flush cache,make data write back to ddr for vcpu read.
	flush_dcache_all();
	prints("\n [flush_dcache_all] finish \n");

	//enable vcpu
	enable_vcpus(1);
	prints("\n [enable_vcpus] finish \n");

	//monitor result
	debug_ret = ve_ddr_debug(1);
	prints("\n [ve_ddr_debug] finish \n");
	//disable vcpu
	disable_vcpus(1);
	prints("\n [disable_vcpus] finish \n");
	//get result,print test result
	ret = show_result(1, debug_ret);
	prints("\n [show_result] finish \n");

	return ret;


}
