#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#define install_debug printf
#define install_fail printf

static int hexfile2headerfile(const char *pfilename,const char *pheadname,const char *parrayname,const char *vcpu_id)
{
	FILE *fp_r ,*fp_w;
	char filename_output[128] = {0}, newline[512] = {0}, write_string[128] = {0}, write_tmp[128] = {0};
	unsigned int num, addr ,data_0,data_4, data_8,data_c;
	unsigned int count = 0;
	snprintf(filename_output, sizeof(filename_output), pheadname);
	if ((fp_r = fopen(pfilename, "r")) ==NULL) {
		install_fail("cannot open file:%s\r\n",pfilename);
		return -1;
	}
	if ((fp_w = fopen(filename_output, "w")) == NULL) {
		install_fail("cannot open file:%s\r\n", filename_output);
		fclose(fp_r);
		return -1;
	}
	printf("start\r\n");
	if((*vcpu_id) == '0')
	{
		snprintf(write_string, sizeof(write_string), "struct hex_data %s_V1[] =\r\n{\r\n",parrayname);
	}
	else if((*vcpu_id) == '1')
	{
		snprintf(write_string, sizeof(write_string), "struct hex_data %s_V2[] =\r\n{\r\n",parrayname);
	}
	else
	{
		install_fail("vcpu_id:%d is illegal!\n",vcpu_id);
		return -1;
	}
	fwrite(write_string,1, strlen(write_string), fp_w);
	while(NULL!= fgets(newline, sizeof(newline),fp_r))
	{
		sscanf(newline,"%d %x %x %x%x %x", &num, &addr , &data_0, &data_4, &data_8, &data_c);
		count++;
		if (num ==1)
		{
			snprintf(write_string, sizeof(write_string), "\t{0x%08x, 0x%08x},\r\n", addr , data_0);
		}
		else if (num ==4)
		{
			snprintf(write_string, sizeof(write_string), "\t{0x%08x, 0x%08x},\r\n", addr+0x0, data_0);
			snprintf(write_tmp, sizeof(write_tmp), "\t{0x%08x, 0x%08x},\r\n", addr+0x4, data_4);
			strcat(write_string, write_tmp);
			snprintf(write_tmp, sizeof(write_tmp), "\t{0x%08x, 0x%08x},\r\n", addr+0x8, data_8);
			strcat(write_string, write_tmp);
			snprintf(write_tmp, sizeof(write_tmp), "\t{0x%08x, 0x%08x},\r\n", addr+0xc,data_c);
			strcat(write_string, write_tmp);
		}
		else
		{
			printf("error num = %d\r\n", num);
		}
		fwrite(write_string, 1, strlen(write_string), fp_w);
	}
	snprintf(write_string, sizeof(write_string), "};");
	fwrite(write_string,1, strlen(write_string), fp_w);
	printf("total count =%d\r\n", count);
	printf("done\r\n");
	fclose(fp_r);
	fclose(fp_w);
	return 0;
}


int main(int argc, char* argv[])
{
	char filename[128] = {0};
	char headname[128] = {0};
	char arrayname[128] = {0};
	char vcpu_id[2] = {0};
	if (argc < 5)
	{
		printf("Usage: ./hex2header [hex_name] [head_name] [array_name] [vcpu_id]\r\n");
		printf("\tvcpu_id:0/1\r\n");
		return -1;
	}
	snprintf(filename, sizeof(filename),"%s",argv[1]);
	printf("filename : %s\n",filename);
    snprintf(headname, sizeof(headname),"%s",argv[2]);
	printf("headname : %s\n",headname);
	snprintf(arrayname, sizeof(arrayname),"%s",argv[3]);
	printf("arrayname : %s\n",arrayname);
    snprintf(vcpu_id, sizeof(vcpu_id),"%s",argv[4]);
	printf("vcpu_id : %s\n",vcpu_id);

	hexfile2headerfile(filename,headname,arrayname,vcpu_id);
	return 0;
}


