/**
* @file Mac6-DesignSpec-D_Domain_DISP_IF
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2017/10/12
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_PIF_REG_H_
#define _RBUS_PIF_REG_H_

#include "rbusTypes.h"



//  PIF Register Address



#define  PIF_LVDS_CTRL1_VADDR                               	(0xb802d000)
#define  PIF_LVDS_CTRL2_VADDR                               	(0xb802d004)
#define  PIF_LVDS_CTRL3_VADDR                               	(0xb802d008)
#define  PIF_LVDS_CTRL4_VADDR                               	(0xb802d00c)
#define  PIF_LVDS_CTRL5_VADDR                               	(0xb802d010)
#define  PIF_MLVDS_CTRL0_VADDR                              	(0xb802d014)
#define  PIF_MLVDS_RESET_PUL_CTRL_VADDR                     	(0xb802d018)
#define  PIF_MLVDS_CTRL1_VADDR                              	(0xb802d01c)
#define  PIF_MLVDS_CTRL2_VADDR                              	(0xb802d020)
#define  PIF_MLVDS_CTRL3_VADDR                              	(0xb802d024)
#define  PIF_MLVDS_CTRL4_VADDR                              	(0xb802d028)
#define  PIF_LVDS_CTRL0_VADDR                               	(0xb802d02c)
#define  PIF_LVDS_PAIR_SELECT_CTRL_0_VADDR                  	(0xb802d060)
#define  PIF_LVDS_PAIR_SELECT_CTRL_1_VADDR                  	(0xb802d064)
#define  PIF_LVDS_PAIR_SELECT_CTRL_2_VADDR                  	(0xb802d068)
#define  PIF_LVDS_PAIR_SELECT_CTRL_3_VADDR                  	(0xb802d06c)
#define  PIF_LVDS_PAIR_SELECT_CTRL_4_VADDR                  	(0xb802d070)
#define  PIF_LVDS_PAIR_SELECT_CTRL_5_VADDR                  	(0xb802d074)
#define  PIF_LVDS_PAIR_SELECT_CTRL_6_VADDR                  	(0xb802d078)
#define  PIF_PIF_FIFO_EN_VADDR                              	(0xb802d038)
#define  PIF_PIF_FIFO_RST_VADDR                             	(0xb802d03c)
#define  PIF_PIF_FIFO_ERR_STA_VADDR                         	(0xb802d054)
#define  PIF_PIF_FIFO_BIST_PRBS_VADDR                       	(0xb802d040)
#define  PIF_PIF_FIFO_BIST_LEN_VADDR                        	(0xb802d044)
#define  PIF_PIF_FIFO_BIST_RES1_VADDR                       	(0xb802d048)
#define  PIF_PIF_FIFO_BIST_RES2_VADDR                       	(0xb802d04c)
#define  PIF_PIF_FIFO_BIST_CTL_VADDR                        	(0xb802d050)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======PIF register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_arsv1_sel:3;
        RBus_UInt32  lvds_arsv0_sel:3;
        RBus_UInt32  lvds_aden_sel:3;
        RBus_UInt32  lvds_avs_sel:3;
        RBus_UInt32  lvds_ahs_sel:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  lvds_brsv1_sel:3;
        RBus_UInt32  lvds_brsv0_sel:3;
        RBus_UInt32  lvds_bden_sel:3;
        RBus_UInt32  lvds_bvs_sel:3;
        RBus_UInt32  lvds_bhs_sel:3;
        RBus_UInt32  res2:1;
    };
}pif_lvds_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_crsv1_sel:3;
        RBus_UInt32  lvds_crsv0_sel:3;
        RBus_UInt32  lvds_cden_sel:3;
        RBus_UInt32  lvds_cvs_sel:3;
        RBus_UInt32  lvds_chs_sel:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  lvds_drsv1_sel:3;
        RBus_UInt32  lvds_drsv0_sel:3;
        RBus_UInt32  lvds_dden_sel:3;
        RBus_UInt32  lvds_dvs_sel:3;
        RBus_UInt32  lvds_dhs_sel:3;
        RBus_UInt32  res2:1;
    };
}pif_lvds_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  lvds_hsync_inv:1;
        RBus_UInt32  lvds_vsync_inv:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  lvds_map_inv:1;
        RBus_UInt32  lvds_map:2;
        RBus_UInt32  res3:4;
        RBus_UInt32  lvds_aport_en:1;
        RBus_UInt32  lvds_bport_en:1;
        RBus_UInt32  lvds_cport_en:1;
        RBus_UInt32  lvds_dport_en:1;
        RBus_UInt32  res4:4;
    };
}pif_lvds_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d00c_31_0:32;
    };
}pif_lvds_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d010_31_0:32;
    };
}pif_lvds_ctrl5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d014_31_11:21;
        RBus_UInt32  mlvds_map_type_sel:3;
        RBus_UInt32  mlvds_en:1;
        RBus_UInt32  mlvds_map_inv:1;
        RBus_UInt32  dummy1802d014_5_2:4;
        RBus_UInt32  mlvds_mode:2;
    };
}pif_mlvds_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d018_31_24:8;
        RBus_UInt32  mlvds_reset_pul_sel:24;
    };
}pif_mlvds_reset_pul_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tcon_sel:8;
        RBus_UInt32  tcon_delay_sel_7:2;
        RBus_UInt32  tcon_delay_sel_6:2;
        RBus_UInt32  tcon_delay_sel_5:2;
        RBus_UInt32  tcon_delay_sel_4:2;
        RBus_UInt32  tcon_delay_sel_3:2;
        RBus_UInt32  tcon_delay_sel_2:2;
        RBus_UInt32  tcon_delay_sel_1:2;
        RBus_UInt32  tcon_delay_sel_0:2;
        RBus_UInt32  mlvds_rst_tcon_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  mlvds_rst_high:6;
    };
}pif_mlvds_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_low_region:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  mlvds_4ck_inv:1;
        RBus_UInt32  mlvds_3ck_inv:1;
        RBus_UInt32  mlvds_2ck_inv:1;
        RBus_UInt32  mlvds_1ck_inv:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  fw_merge_tcon_en:1;
        RBus_UInt32  p3_tcon_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  p3_tcon_sel:6;
        RBus_UInt32  p2_tcon_en:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  p2_tcon_sel:6;
        RBus_UInt32  p1_tcon_en:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  p1_tcon_sel:6;
    };
}pif_mlvds_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_low_0:32;
    };
}pif_mlvds_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_low_1:32;
    };
}pif_mlvds_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pn_swap:1;
        RBus_UInt32  res1:23;
        RBus_UInt32  pif_debug_sel:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  plt_lvds_mode:3;
    };
}pif_lvds_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_00:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_01:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_02:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  lvds_pair_sel_03:5;
    };
}pif_lvds_pair_select_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_04:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_05:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_06:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  lvds_pair_sel_07:5;
    };
}pif_lvds_pair_select_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_08:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_09:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_10:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  lvds_pair_sel_11:5;
    };
}pif_lvds_pair_select_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_12:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_13:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_14:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  lvds_pair_sel_15:5;
    };
}pif_lvds_pair_select_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_16:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_17:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_18:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  lvds_pair_sel_19:5;
    };
}pif_lvds_pair_select_ctrl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_20:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_21:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_22:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  lvds_pair_sel_23:5;
    };
}pif_lvds_pair_select_ctrl_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_24:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_25:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_26:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  lvds_pair_sel_27:5;
    };
}pif_lvds_pair_select_ctrl_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  pif_fifo_en:1;
    };
}pif_pif_fifo_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_guard_error:12;
        RBus_UInt32  res1:1;
        RBus_UInt32  fifo_vs_rst_type:2;
        RBus_UInt32  fifo_vs_rst_en:1;
        RBus_UInt32  fifo_vs_rst_delay:16;
    };
}pif_pif_fifo_rst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pif_fifo_error_ie:1;
        RBus_UInt32  pif_fifo_error:1;
    };
}pif_pif_fifo_err_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  pif_bist_mode_select:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  pif_bist_pattern_0:27;
    };
}pif_pif_fifo_bist_prbs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  pif_bist_length:24;
    };
}pif_pif_fifo_bist_len_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_done:1;
        RBus_UInt32  res1:30;
        RBus_UInt32  pif_bist_result:1;
    };
}pif_pif_fifo_bist_res1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  pif_bist_result_port:12;
    };
}pif_pif_fifo_bist_res2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  pif_prbs_enable:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  pif_bist_enable:1;
    };
}pif_pif_fifo_bist_ctl_RBUS;

#else //apply LITTLE_ENDIAN

//======PIF register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  lvds_bhs_sel:3;
        RBus_UInt32  lvds_bvs_sel:3;
        RBus_UInt32  lvds_bden_sel:3;
        RBus_UInt32  lvds_brsv0_sel:3;
        RBus_UInt32  lvds_brsv1_sel:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  lvds_ahs_sel:3;
        RBus_UInt32  lvds_avs_sel:3;
        RBus_UInt32  lvds_aden_sel:3;
        RBus_UInt32  lvds_arsv0_sel:3;
        RBus_UInt32  lvds_arsv1_sel:3;
    };
}pif_lvds_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  lvds_dhs_sel:3;
        RBus_UInt32  lvds_dvs_sel:3;
        RBus_UInt32  lvds_dden_sel:3;
        RBus_UInt32  lvds_drsv0_sel:3;
        RBus_UInt32  lvds_drsv1_sel:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  lvds_chs_sel:3;
        RBus_UInt32  lvds_cvs_sel:3;
        RBus_UInt32  lvds_cden_sel:3;
        RBus_UInt32  lvds_crsv0_sel:3;
        RBus_UInt32  lvds_crsv1_sel:3;
    };
}pif_lvds_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  lvds_dport_en:1;
        RBus_UInt32  lvds_cport_en:1;
        RBus_UInt32  lvds_bport_en:1;
        RBus_UInt32  lvds_aport_en:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  lvds_map:2;
        RBus_UInt32  lvds_map_inv:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  lvds_vsync_inv:1;
        RBus_UInt32  lvds_hsync_inv:1;
        RBus_UInt32  res4:14;
    };
}pif_lvds_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d00c_31_0:32;
    };
}pif_lvds_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d010_31_0:32;
    };
}pif_lvds_ctrl5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_mode:2;
        RBus_UInt32  dummy1802d014_5_2:4;
        RBus_UInt32  mlvds_map_inv:1;
        RBus_UInt32  mlvds_en:1;
        RBus_UInt32  mlvds_map_type_sel:3;
        RBus_UInt32  dummy1802d014_31_11:21;
    };
}pif_mlvds_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_reset_pul_sel:24;
        RBus_UInt32  dummy1802d018_31_24:8;
    };
}pif_mlvds_reset_pul_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_high:6;
        RBus_UInt32  res1:1;
        RBus_UInt32  mlvds_rst_tcon_en:1;
        RBus_UInt32  tcon_delay_sel_0:2;
        RBus_UInt32  tcon_delay_sel_1:2;
        RBus_UInt32  tcon_delay_sel_2:2;
        RBus_UInt32  tcon_delay_sel_3:2;
        RBus_UInt32  tcon_delay_sel_4:2;
        RBus_UInt32  tcon_delay_sel_5:2;
        RBus_UInt32  tcon_delay_sel_6:2;
        RBus_UInt32  tcon_delay_sel_7:2;
        RBus_UInt32  tcon_sel:8;
    };
}pif_mlvds_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  p1_tcon_sel:6;
        RBus_UInt32  res1:1;
        RBus_UInt32  p1_tcon_en:1;
        RBus_UInt32  p2_tcon_sel:6;
        RBus_UInt32  res2:1;
        RBus_UInt32  p2_tcon_en:1;
        RBus_UInt32  p3_tcon_sel:6;
        RBus_UInt32  res3:1;
        RBus_UInt32  p3_tcon_en:1;
        RBus_UInt32  fw_merge_tcon_en:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  mlvds_1ck_inv:1;
        RBus_UInt32  mlvds_2ck_inv:1;
        RBus_UInt32  mlvds_3ck_inv:1;
        RBus_UInt32  mlvds_4ck_inv:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  mlvds_rst_low_region:1;
    };
}pif_mlvds_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_low_0:32;
    };
}pif_mlvds_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_low_1:32;
    };
}pif_mlvds_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plt_lvds_mode:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  pif_debug_sel:4;
        RBus_UInt32  res2:23;
        RBus_UInt32  lvds_pn_swap:1;
    };
}pif_lvds_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pair_sel_03:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_02:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_01:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_00:5;
        RBus_UInt32  res4:3;
    };
}pif_lvds_pair_select_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pair_sel_07:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_06:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_05:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_04:5;
        RBus_UInt32  res4:3;
    };
}pif_lvds_pair_select_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pair_sel_11:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_10:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_09:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_08:5;
        RBus_UInt32  res4:3;
    };
}pif_lvds_pair_select_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pair_sel_15:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_14:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_13:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_12:5;
        RBus_UInt32  res4:3;
    };
}pif_lvds_pair_select_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pair_sel_19:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_18:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_17:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_16:5;
        RBus_UInt32  res4:3;
    };
}pif_lvds_pair_select_ctrl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pair_sel_23:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_22:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_21:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_20:5;
        RBus_UInt32  res4:3;
    };
}pif_lvds_pair_select_ctrl_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pair_sel_27:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  lvds_pair_sel_26:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  lvds_pair_sel_25:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  lvds_pair_sel_24:5;
        RBus_UInt32  res4:3;
    };
}pif_lvds_pair_select_ctrl_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_fifo_en:1;
        RBus_UInt32  res1:31;
    };
}pif_pif_fifo_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_vs_rst_delay:16;
        RBus_UInt32  fifo_vs_rst_en:1;
        RBus_UInt32  fifo_vs_rst_type:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  fifo_guard_error:12;
    };
}pif_pif_fifo_rst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_fifo_error:1;
        RBus_UInt32  pif_fifo_error_ie:1;
        RBus_UInt32  res1:30;
    };
}pif_pif_fifo_err_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_pattern_0:27;
        RBus_UInt32  res1:1;
        RBus_UInt32  pif_bist_mode_select:3;
        RBus_UInt32  res2:1;
    };
}pif_pif_fifo_bist_prbs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_length:24;
        RBus_UInt32  res1:8;
    };
}pif_pif_fifo_bist_len_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_result:1;
        RBus_UInt32  res1:30;
        RBus_UInt32  pif_bist_done:1;
    };
}pif_pif_fifo_bist_res1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_result_port:12;
        RBus_UInt32  res1:20;
    };
}pif_pif_fifo_bist_res2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_enable:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  pif_prbs_enable:1;
        RBus_UInt32  res2:27;
    };
}pif_pif_fifo_bist_ctl_RBUS;




#endif 


#endif 
