/**
* @file Mac7p-DesignSpec-D-Domain_STAGE1_TOP_BIST_BISR_control
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_DISPD_WO_OSD_BIST_BISR_REG_H_
#define _RBUS_DISPD_WO_OSD_BIST_BISR_REG_H_

#include "rbusTypes.h"



//  DISPD_WO_OSD_BIST_BISR Register Address



#define  DISPD_WO_OSD_BIST_BISR_DISPD_BIST_MODE_VADDR       	(0xb8029f00)
#define  DISPD_WO_OSD_BIST_BISR_DISPD_BIST_DONE_VADDR       	(0xb8029f04)
#define  DISPD_WO_OSD_BIST_BISR_DISPD_BIST_FAIL_GROUP_VADDR 	(0xb8029f08)
#define  DISPD_WO_OSD_BIST_BISR_DISPD_DRF_MODE_VADDR        	(0xb8029f0c)
#define  DISPD_WO_OSD_BIST_BISR_DISPD_DRF_RESUME_VADDR      	(0xb8029f10)
#define  DISPD_WO_OSD_BIST_BISR_DISPD_DRF_DONE_VADDR        	(0xb8029f14)
#define  DISPD_WO_OSD_BIST_BISR_DISPD_DRF_PAUSE_VADDR       	(0xb8029f18)
#define  DISPD_WO_OSD_BIST_BISR_DISPD_DRF_FAIL_GROUP_VADDR  	(0xb8029f1c)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======DISPD_WO_OSD_BIST_BISR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  su_main_2_bist_mode:1;
        RBus_UInt32  icm_rgb_offset_bist_mode:1;
        RBus_UInt32  dcc_bist_mode_2:1;
        RBus_UInt32  d3d_lut_bist_mode:1;
        RBus_UInt32  lc_con_bist_mode:1;
        RBus_UInt32  su_sub_bist_mode:1;
        RBus_UInt32  inv_gamma_bist_mode:1;
        RBus_UInt32  dmato3dlut_bist_mode:1;
        RBus_UInt32  shpnr_bist_mode:1;
        RBus_UInt32  icm_3d_table_bist_mode:1;
        RBus_UInt32  icm_hist_1p_bist_mode:1;
        RBus_UInt32  icm_hist_2p_bist_mode:1;
        RBus_UInt32  gamma_bist_mode:1;
        RBus_UInt32  su_main_0_bist_mode:1;
        RBus_UInt32  su_main_1_bist_mode:1;
        RBus_UInt32  dcc_bist_mode:1;
    };
}dispd_wo_osd_bist_bisr_dispd_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  su_main_2_bist_done:1;
        RBus_UInt32  icm_rgb_offset_bist_done:1;
        RBus_UInt32  dcc_bist_done_2:1;
        RBus_UInt32  d3d_lut_bist_done:1;
        RBus_UInt32  lc_con_bist_done:1;
        RBus_UInt32  su_sub_bist_done:1;
        RBus_UInt32  inv_gamma_bist_done:1;
        RBus_UInt32  dmato3dlut_bist_done:1;
        RBus_UInt32  shpnr_bist_done:1;
        RBus_UInt32  icm_3d_table_bist_done:1;
        RBus_UInt32  icm_hist_1p_bist_done:1;
        RBus_UInt32  icm_hist_2p_bist_done:1;
        RBus_UInt32  gamma_bist_done:1;
        RBus_UInt32  su_main_0_bist_done:1;
        RBus_UInt32  su_main_1_bist_done:1;
        RBus_UInt32  dcc_bist_done:1;
    };
}dispd_wo_osd_bist_bisr_dispd_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  su_main_2_bist_fail_group:1;
        RBus_UInt32  icm_rgb_offset_bist_fail_group:1;
        RBus_UInt32  dcc_bist_fail_group_2:1;
        RBus_UInt32  d3d_lut_bist_fail_group:1;
        RBus_UInt32  lc_con_bist_fail_group:1;
        RBus_UInt32  su_sub_bist_fail_group:1;
        RBus_UInt32  inv_gamma_bist_fail_group:1;
        RBus_UInt32  dmato3dlut_bist_fail_group:1;
        RBus_UInt32  shpnr_bist_fail_group:1;
        RBus_UInt32  icm_3d_table_bist_fail_group:1;
        RBus_UInt32  icm_hist_1p_bist_fail_group:1;
        RBus_UInt32  icm_hist_2p_bist_fail_group:1;
        RBus_UInt32  gamma_bist_fail_group:1;
        RBus_UInt32  su_main_0_bist_fail_group:1;
        RBus_UInt32  su_main_1_bist_fail_group:1;
        RBus_UInt32  dcc_bist_fail_group:1;
    };
}dispd_wo_osd_bist_bisr_dispd_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  su_main_2_drf_mode:1;
        RBus_UInt32  icm_rgb_offset_drf_bist_mode:1;
        RBus_UInt32  dcc_drf_mode_2:1;
        RBus_UInt32  d3d_lut_drf_mode:1;
        RBus_UInt32  lc_con_drf_mode:1;
        RBus_UInt32  su_sub_drf_mode:1;
        RBus_UInt32  inv_gamma_drf_mode:1;
        RBus_UInt32  dmato3dlut_drf_mode:1;
        RBus_UInt32  shpnr_drf_mode:1;
        RBus_UInt32  icm_3d_table_drf_mode:1;
        RBus_UInt32  icm_hist_1p_drf_mode:1;
        RBus_UInt32  icm_hist_2p_drf_mode:1;
        RBus_UInt32  gamma_drf_mode:1;
        RBus_UInt32  su_main_0_drf_mode:1;
        RBus_UInt32  su_main_1_drf_mode:1;
        RBus_UInt32  dcc_drf_mode:1;
    };
}dispd_wo_osd_bist_bisr_dispd_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  su_main_2_drf_resume:1;
        RBus_UInt32  icm_rgb_offset_drf_test_resume:1;
        RBus_UInt32  dcc_drf_resume_2:1;
        RBus_UInt32  d3d_lut_drf_resume:1;
        RBus_UInt32  lc_con_drf_resume:1;
        RBus_UInt32  su_sub_drf_resume:1;
        RBus_UInt32  inv_gamma_drf_resume:1;
        RBus_UInt32  dmato3dlut_drf_resume:1;
        RBus_UInt32  shpnr_drf_resume:1;
        RBus_UInt32  icm_3d_table_drf_resume:1;
        RBus_UInt32  icm_hist_1p_drf_resume:1;
        RBus_UInt32  icm_hist_2p_drf_resume:1;
        RBus_UInt32  gamma_drf_resume:1;
        RBus_UInt32  su_main_0_drf_resume:1;
        RBus_UInt32  su_main_1_drf_resume:1;
        RBus_UInt32  dcc_drf_resume:1;
    };
}dispd_wo_osd_bist_bisr_dispd_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  su_main_2_drf_done:1;
        RBus_UInt32  icm_rgb_offset_drf_bist_done:1;
        RBus_UInt32  dcc_drf_done_2:1;
        RBus_UInt32  d3d_lut_drf_done:1;
        RBus_UInt32  lc_con_drf_done:1;
        RBus_UInt32  su_sub_drf_done:1;
        RBus_UInt32  inv_gamma_drf_done:1;
        RBus_UInt32  dmato3dlut_drf_done:1;
        RBus_UInt32  shpnr_drf_done:1;
        RBus_UInt32  icm_3d_table_drf_done:1;
        RBus_UInt32  icm_hist_1p_drf_done:1;
        RBus_UInt32  icm_hist_2p_drf_done:1;
        RBus_UInt32  gamma_drf_done:1;
        RBus_UInt32  su_main_0_drf_done:1;
        RBus_UInt32  su_main_1_drf_done:1;
        RBus_UInt32  dcc_drf_done:1;
    };
}dispd_wo_osd_bist_bisr_dispd_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  su_main_2_drf_pause:1;
        RBus_UInt32  icm_rgb_offset_drf_start_pause:1;
        RBus_UInt32  dcc_drf_pause_2:1;
        RBus_UInt32  d3d_lut_drf_pause:1;
        RBus_UInt32  lc_con_drf_pause:1;
        RBus_UInt32  su_sub_drf_pause:1;
        RBus_UInt32  inv_gamma_drf_pause:1;
        RBus_UInt32  dmato3dlut_drf_pause:1;
        RBus_UInt32  shpnr_drf_pause:1;
        RBus_UInt32  icm_3d_table_drf_pause:1;
        RBus_UInt32  icm_hist_1p_drf_pause:1;
        RBus_UInt32  icm_hist_2p_drf_pause:1;
        RBus_UInt32  gamma_drf_pause:1;
        RBus_UInt32  su_main_0_drf_pause:1;
        RBus_UInt32  su_main_1_drf_pause:1;
        RBus_UInt32  dcc_drf_pause:1;
    };
}dispd_wo_osd_bist_bisr_dispd_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  su_main_2_drf_fail_group:1;
        RBus_UInt32  icm_rgb_offset_drf_bist_fail_group:1;
        RBus_UInt32  dcc_drf_fail_group_2:1;
        RBus_UInt32  d3d_lut_drf_fail_group:1;
        RBus_UInt32  lc_con_drf_fail_group:1;
        RBus_UInt32  su_sub_drf_fail_group:1;
        RBus_UInt32  inv_gamma_drf_fail_group:1;
        RBus_UInt32  dmato3dlut_drf_fail_group:1;
        RBus_UInt32  shpnr_drf_fail_group:1;
        RBus_UInt32  icm_3d_table_drf_fail_group:1;
        RBus_UInt32  icm_hist_1p_drf_fail_group:1;
        RBus_UInt32  icm_hist_2p_drf_fail_group:1;
        RBus_UInt32  gamma_drf_fail_group:1;
        RBus_UInt32  su_main_0_drf_fail_group:1;
        RBus_UInt32  su_main_1_drf_fail_group:1;
        RBus_UInt32  dcc_drf_fail_group:1;
    };
}dispd_wo_osd_bist_bisr_dispd_drf_fail_group_RBUS;

#else //apply LITTLE_ENDIAN

//======DISPD_WO_OSD_BIST_BISR register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dcc_bist_mode:1;
        RBus_UInt32  su_main_1_bist_mode:1;
        RBus_UInt32  su_main_0_bist_mode:1;
        RBus_UInt32  gamma_bist_mode:1;
        RBus_UInt32  icm_hist_2p_bist_mode:1;
        RBus_UInt32  icm_hist_1p_bist_mode:1;
        RBus_UInt32  icm_3d_table_bist_mode:1;
        RBus_UInt32  shpnr_bist_mode:1;
        RBus_UInt32  dmato3dlut_bist_mode:1;
        RBus_UInt32  inv_gamma_bist_mode:1;
        RBus_UInt32  su_sub_bist_mode:1;
        RBus_UInt32  lc_con_bist_mode:1;
        RBus_UInt32  d3d_lut_bist_mode:1;
        RBus_UInt32  dcc_bist_mode_2:1;
        RBus_UInt32  icm_rgb_offset_bist_mode:1;
        RBus_UInt32  su_main_2_bist_mode:1;
        RBus_UInt32  res1:16;
    };
}dispd_wo_osd_bist_bisr_dispd_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dcc_bist_done:1;
        RBus_UInt32  su_main_1_bist_done:1;
        RBus_UInt32  su_main_0_bist_done:1;
        RBus_UInt32  gamma_bist_done:1;
        RBus_UInt32  icm_hist_2p_bist_done:1;
        RBus_UInt32  icm_hist_1p_bist_done:1;
        RBus_UInt32  icm_3d_table_bist_done:1;
        RBus_UInt32  shpnr_bist_done:1;
        RBus_UInt32  dmato3dlut_bist_done:1;
        RBus_UInt32  inv_gamma_bist_done:1;
        RBus_UInt32  su_sub_bist_done:1;
        RBus_UInt32  lc_con_bist_done:1;
        RBus_UInt32  d3d_lut_bist_done:1;
        RBus_UInt32  dcc_bist_done_2:1;
        RBus_UInt32  icm_rgb_offset_bist_done:1;
        RBus_UInt32  su_main_2_bist_done:1;
        RBus_UInt32  res1:16;
    };
}dispd_wo_osd_bist_bisr_dispd_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dcc_bist_fail_group:1;
        RBus_UInt32  su_main_1_bist_fail_group:1;
        RBus_UInt32  su_main_0_bist_fail_group:1;
        RBus_UInt32  gamma_bist_fail_group:1;
        RBus_UInt32  icm_hist_2p_bist_fail_group:1;
        RBus_UInt32  icm_hist_1p_bist_fail_group:1;
        RBus_UInt32  icm_3d_table_bist_fail_group:1;
        RBus_UInt32  shpnr_bist_fail_group:1;
        RBus_UInt32  dmato3dlut_bist_fail_group:1;
        RBus_UInt32  inv_gamma_bist_fail_group:1;
        RBus_UInt32  su_sub_bist_fail_group:1;
        RBus_UInt32  lc_con_bist_fail_group:1;
        RBus_UInt32  d3d_lut_bist_fail_group:1;
        RBus_UInt32  dcc_bist_fail_group_2:1;
        RBus_UInt32  icm_rgb_offset_bist_fail_group:1;
        RBus_UInt32  su_main_2_bist_fail_group:1;
        RBus_UInt32  res1:16;
    };
}dispd_wo_osd_bist_bisr_dispd_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dcc_drf_mode:1;
        RBus_UInt32  su_main_1_drf_mode:1;
        RBus_UInt32  su_main_0_drf_mode:1;
        RBus_UInt32  gamma_drf_mode:1;
        RBus_UInt32  icm_hist_2p_drf_mode:1;
        RBus_UInt32  icm_hist_1p_drf_mode:1;
        RBus_UInt32  icm_3d_table_drf_mode:1;
        RBus_UInt32  shpnr_drf_mode:1;
        RBus_UInt32  dmato3dlut_drf_mode:1;
        RBus_UInt32  inv_gamma_drf_mode:1;
        RBus_UInt32  su_sub_drf_mode:1;
        RBus_UInt32  lc_con_drf_mode:1;
        RBus_UInt32  d3d_lut_drf_mode:1;
        RBus_UInt32  dcc_drf_mode_2:1;
        RBus_UInt32  icm_rgb_offset_drf_bist_mode:1;
        RBus_UInt32  su_main_2_drf_mode:1;
        RBus_UInt32  res1:16;
    };
}dispd_wo_osd_bist_bisr_dispd_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dcc_drf_resume:1;
        RBus_UInt32  su_main_1_drf_resume:1;
        RBus_UInt32  su_main_0_drf_resume:1;
        RBus_UInt32  gamma_drf_resume:1;
        RBus_UInt32  icm_hist_2p_drf_resume:1;
        RBus_UInt32  icm_hist_1p_drf_resume:1;
        RBus_UInt32  icm_3d_table_drf_resume:1;
        RBus_UInt32  shpnr_drf_resume:1;
        RBus_UInt32  dmato3dlut_drf_resume:1;
        RBus_UInt32  inv_gamma_drf_resume:1;
        RBus_UInt32  su_sub_drf_resume:1;
        RBus_UInt32  lc_con_drf_resume:1;
        RBus_UInt32  d3d_lut_drf_resume:1;
        RBus_UInt32  dcc_drf_resume_2:1;
        RBus_UInt32  icm_rgb_offset_drf_test_resume:1;
        RBus_UInt32  su_main_2_drf_resume:1;
        RBus_UInt32  res1:16;
    };
}dispd_wo_osd_bist_bisr_dispd_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dcc_drf_done:1;
        RBus_UInt32  su_main_1_drf_done:1;
        RBus_UInt32  su_main_0_drf_done:1;
        RBus_UInt32  gamma_drf_done:1;
        RBus_UInt32  icm_hist_2p_drf_done:1;
        RBus_UInt32  icm_hist_1p_drf_done:1;
        RBus_UInt32  icm_3d_table_drf_done:1;
        RBus_UInt32  shpnr_drf_done:1;
        RBus_UInt32  dmato3dlut_drf_done:1;
        RBus_UInt32  inv_gamma_drf_done:1;
        RBus_UInt32  su_sub_drf_done:1;
        RBus_UInt32  lc_con_drf_done:1;
        RBus_UInt32  d3d_lut_drf_done:1;
        RBus_UInt32  dcc_drf_done_2:1;
        RBus_UInt32  icm_rgb_offset_drf_bist_done:1;
        RBus_UInt32  su_main_2_drf_done:1;
        RBus_UInt32  res1:16;
    };
}dispd_wo_osd_bist_bisr_dispd_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dcc_drf_pause:1;
        RBus_UInt32  su_main_1_drf_pause:1;
        RBus_UInt32  su_main_0_drf_pause:1;
        RBus_UInt32  gamma_drf_pause:1;
        RBus_UInt32  icm_hist_2p_drf_pause:1;
        RBus_UInt32  icm_hist_1p_drf_pause:1;
        RBus_UInt32  icm_3d_table_drf_pause:1;
        RBus_UInt32  shpnr_drf_pause:1;
        RBus_UInt32  dmato3dlut_drf_pause:1;
        RBus_UInt32  inv_gamma_drf_pause:1;
        RBus_UInt32  su_sub_drf_pause:1;
        RBus_UInt32  lc_con_drf_pause:1;
        RBus_UInt32  d3d_lut_drf_pause:1;
        RBus_UInt32  dcc_drf_pause_2:1;
        RBus_UInt32  icm_rgb_offset_drf_start_pause:1;
        RBus_UInt32  su_main_2_drf_pause:1;
        RBus_UInt32  res1:16;
    };
}dispd_wo_osd_bist_bisr_dispd_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dcc_drf_fail_group:1;
        RBus_UInt32  su_main_1_drf_fail_group:1;
        RBus_UInt32  su_main_0_drf_fail_group:1;
        RBus_UInt32  gamma_drf_fail_group:1;
        RBus_UInt32  icm_hist_2p_drf_fail_group:1;
        RBus_UInt32  icm_hist_1p_drf_fail_group:1;
        RBus_UInt32  icm_3d_table_drf_fail_group:1;
        RBus_UInt32  shpnr_drf_fail_group:1;
        RBus_UInt32  dmato3dlut_drf_fail_group:1;
        RBus_UInt32  inv_gamma_drf_fail_group:1;
        RBus_UInt32  su_sub_drf_fail_group:1;
        RBus_UInt32  lc_con_drf_fail_group:1;
        RBus_UInt32  d3d_lut_drf_fail_group:1;
        RBus_UInt32  dcc_drf_fail_group_2:1;
        RBus_UInt32  icm_rgb_offset_drf_bist_fail_group:1;
        RBus_UInt32  su_main_2_drf_fail_group:1;
        RBus_UInt32  res1:16;
    };
}dispd_wo_osd_bist_bisr_dispd_drf_fail_group_RBUS;




#endif 


#endif 
