/**
* @file Mac7p-DesignSpec-I-Domain_ring_filter
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_RINGFILTER_REG_H_
#define _RBUS_RINGFILTER_REG_H_

#include "rbusTypes.h"



//  RINGFILTER Register Address



#define  RINGFILTER_RFILTER_CTRL_VADDR                      	(0xb8023580)
#define  RINGFILTER_RFILTER_THD_VADDR                       	(0xb8023584)
#define  RINGFILTER_RFILTER_OFS_COEF_VADDR                  	(0xb8023588)
#define  RINGFILTER_RFILTER_DIFF_THD_VADDR                  	(0xb802358c)
#define  RINGFILTER_RFILTER_FACTOR_TEST_CTRL_VADDR          	(0xb8023590)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======RINGFILTER register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  rfilter_lsb2_tie0:1;
        RBus_UInt32  rfilter_en:1;
        RBus_UInt32  rfilter_ofs_rng_mode:1;
        RBus_UInt32  rfilter_jj_en:1;
        RBus_UInt32  rfilter_r_unaffected:1;
        RBus_UInt32  rfilter_g_unaffected:1;
        RBus_UInt32  rfilter_b_unaffected:1;
        RBus_UInt32  res2:2;
    };
}ringfilter_rfilter_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  rfilter_thd_rng_exp:3;
        RBus_UInt32  rfilter_thd:8;
    };
}ringfilter_rfilter_thd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  rfilter_ofs_rng_exp:3;
        RBus_UInt32  res2:3;
        RBus_UInt32  rfilter_ofs_coef:5;
    };
}ringfilter_rfilter_ofs_coef_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  rfilter_diff_thd_lb:4;
        RBus_UInt32  res2:6;
        RBus_UInt32  rfilter_diff_thd_ub:2;
    };
}ringfilter_rfilter_diff_thd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  rfilter_diff_fac_2px_set:1;
        RBus_UInt32  rfilter_thd_fac_set:1;
        RBus_UInt32  rfilter_ofs_fac_set:1;
        RBus_UInt32  rfilter_diff_fac_set:1;
    };
}ringfilter_rfilter_factor_test_ctrl_RBUS;

#else //apply LITTLE_ENDIAN

//======RINGFILTER register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  rfilter_b_unaffected:1;
        RBus_UInt32  rfilter_g_unaffected:1;
        RBus_UInt32  rfilter_r_unaffected:1;
        RBus_UInt32  rfilter_jj_en:1;
        RBus_UInt32  rfilter_ofs_rng_mode:1;
        RBus_UInt32  rfilter_en:1;
        RBus_UInt32  rfilter_lsb2_tie0:1;
        RBus_UInt32  res2:23;
    };
}ringfilter_rfilter_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rfilter_thd:8;
        RBus_UInt32  rfilter_thd_rng_exp:3;
        RBus_UInt32  res1:21;
    };
}ringfilter_rfilter_thd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rfilter_ofs_coef:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  rfilter_ofs_rng_exp:3;
        RBus_UInt32  res2:21;
    };
}ringfilter_rfilter_ofs_coef_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rfilter_diff_thd_ub:2;
        RBus_UInt32  res1:6;
        RBus_UInt32  rfilter_diff_thd_lb:4;
        RBus_UInt32  res2:20;
    };
}ringfilter_rfilter_diff_thd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rfilter_diff_fac_set:1;
        RBus_UInt32  rfilter_ofs_fac_set:1;
        RBus_UInt32  rfilter_thd_fac_set:1;
        RBus_UInt32  rfilter_diff_fac_2px_set:1;
        RBus_UInt32  res1:28;
    };
}ringfilter_rfilter_factor_test_ctrl_RBUS;




#endif 


#endif 
