/**
* @file Mac7p-DesignSpec-I-Domain_VGIP
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_SUB_VGIP_REG_H_
#define _RBUS_SUB_VGIP_REG_H_

#include "rbusTypes.h"



//  SUB_VGIP Register Address



#define  SUB_VGIP_SUB_VCLK_CTRL_VADDR                       	(0xb8022700)
#define  SUB_VGIP_SUB_V8_1_CTRL_VADDR                       	(0xb8022704)
#define  SUB_VGIP_SUB_V8_2_CTRL_VADDR                       	(0xb8022708)
#define  SUB_VGIP_SUB_VGIP_GLOBAL_CTRL_VADDR                	(0xb802270c)
#define  SUB_VGIP_VGIP_CHN2_CTRL_VADDR                      	(0xb8022710)
#define  SUB_VGIP_VGIP_CHN2_STATUS_VADDR                    	(0xb8022714)
#define  SUB_VGIP_VGIP_CHN2_ACT_HSTA_WIDTH_VADDR            	(0xb8022718)
#define  SUB_VGIP_VGIP_CHN2_ACT_VSTA_LENGTH_VADDR           	(0xb802271c)
#define  SUB_VGIP_VGIP_CHN2_DELAY_VADDR                     	(0xb8022720)
#define  SUB_VGIP_VGIP_CHN2_MISC_VADDR                      	(0xb8022724)
#define  SUB_VGIP_VGIP_CHN2_PTN_H_VI_VADDR                  	(0xb8022728)
#define  SUB_VGIP_VGIP_CHN2_PTN0_VADDR                      	(0xb802272c)
#define  SUB_VGIP_VGIP_CHN2_PTN1_VADDR                      	(0xb8022730)
#define  SUB_VGIP_VGIP_CHN2_LC_VADDR                        	(0xb8022734)
#define  SUB_VGIP_ICH2_VGIP_CRC_CTRL_VADDR                  	(0xb8022738)
#define  SUB_VGIP_ICH2_VGIP_CRC_RESULT_VADDR                	(0xb802273c)
#define  SUB_VGIP_VGIP_CHN2_WDE_VADDR                       	(0xb8022740)
#define  SUB_VGIP_VGIP_CHN2_PTN2_VADDR                      	(0xb8022760)
#define  SUB_VGIP_VGIP_CHN2_PTN3_VADDR                      	(0xb8022764)
#define  SUB_VGIP_VGIP_CHN2_PTN4_VADDR                      	(0xb8022768)
#define  SUB_VGIP_VGIP_CHN2_PTN5_VADDR                      	(0xb802276c)
#define  SUB_VGIP_VGIP_CHN2_PTN6_VADDR                      	(0xb8022770)
#define  SUB_VGIP_SUB_ADC_RAW_DATA_DMA_VADDR                	(0xb8022778)
#define  SUB_VGIP_SUB_CTS_FIFO_CTL_VADDR                    	(0xb8022790)
#define  SUB_VGIP_SUB_DISPI_TEST_SEL_VADDR                  	(0xb8022794)
#define  SUB_VGIP_VGIP_CHN2_DOUBLE_BUFFER_CTRL_VADDR        	(0xb80227e4)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======SUB_VGIP register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ch2_v8_dummy:8;
    };
}sub_vgip_sub_vclk_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dummy18022704_7_0:8;
    };
}sub_vgip_sub_v8_1_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  ch2_select_duplicate_lsb:1;
    };
}sub_vgip_sub_v8_2_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_auto_l_flag_delay_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  ch2_vs_rise_sample_delay_sel:1;
        RBus_UInt32  ch2_auto_l_flag_delay_num:13;
        RBus_UInt32  ch2_l_flag_delay_en:1;
        RBus_UInt32  ch2_l_flag_field_sample_delay:2;
        RBus_UInt32  ch2_l_flag_delay_num:13;
    };
}sub_vgip_sub_vgip_global_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_ivrun:1;
        RBus_UInt32  ch2_in_sel:3;
        RBus_UInt32  ch2_random_en:1;
        RBus_UInt32  ch2_fdrop_en:1;
        RBus_UInt32  ch2_vact_end_ie:1;
        RBus_UInt32  ch2_vact_start_ie:1;
        RBus_UInt32  ch2_field_hs_inv:1;
        RBus_UInt32  ch2_field_vd_inv:1;
        RBus_UInt32  ch2_field_vd_en:1;
        RBus_UInt32  ch2_3dleft_inv:1;
        RBus_UInt32  ch2_3dleft_sync_edge:1;
        RBus_UInt32  ch2_field_inv:1;
        RBus_UInt32  ch2_field_sync_edge:1;
        RBus_UInt32  ch2_field_det_en:1;
        RBus_UInt32  ch2_hpact_is_hact:1;
        RBus_UInt32  ch2_fcap_str_odd:1;
        RBus_UInt32  ch2_mask_den_inv:1;
        RBus_UInt32  ch2_mask_den_1l:1;
        RBus_UInt32  ch2_3d_mode_en:1;
        RBus_UInt32  ch2_safe_field_inv:1;
        RBus_UInt32  ch2_force_tog:1;
        RBus_UInt32  ch2_safe_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  ch2_vs_syncedge:1;
        RBus_UInt32  ch2_vs_by_hs_en_n:1;
        RBus_UInt32  ch2_vs_inv:1;
        RBus_UInt32  ch2_hs_inv:1;
        RBus_UInt32  ch2_digital_mode:1;
        RBus_UInt32  ch2_in_clk_en:1;
    };
}sub_vgip_vgip_chn2_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ch2_sdnr_vact_end:1;
        RBus_UInt32  ch2_vs_end:1;
        RBus_UInt32  ch2_vs_start:1;
        RBus_UInt32  ch2_vact_end:1;
        RBus_UInt32  ch2_vact_start:1;
        RBus_UInt32  dummy18022714_23_17:7;
        RBus_UInt32  ch2_vlc_status:1;
        RBus_UInt32  ch2_rl_err:1;
        RBus_UInt32  ch2_vs_err:1;
        RBus_UInt32  ch2_hs_err:1;
        RBus_UInt32  ch2_field_err:1;
        RBus_UInt32  ch2_rl_tog:1;
        RBus_UInt32  ch2_l_flag_pol:1;
        RBus_UInt32  ch2_vs_tog:1;
        RBus_UInt32  ch2_hs_tog:1;
        RBus_UInt32  ch2_field_pol:1;
        RBus_UInt32  ch2_field_tog:1;
        RBus_UInt32  ch2_field_vs_lsb:2;
        RBus_UInt32  ch2_more_1line_field:1;
        RBus_UInt32  ch2_bounce_status_2:1;
        RBus_UInt32  ch2_bounce_status_1:1;
        RBus_UInt32  ch2_bounce_status_0:1;
    };
}sub_vgip_vgip_chn2_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  ch2_ih_act_sta:14;
        RBus_UInt32  res2:1;
        RBus_UInt32  ch2_bypass_den:1;
        RBus_UInt32  ch2_ih_act_wid:14;
    };
}sub_vgip_vgip_chn2_act_hsta_width_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ch2_iv_act_sta:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  ch2_iv_act_len:13;
    };
}sub_vgip_vgip_chn2_act_vsta_length_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_hs_width:2;
        RBus_UInt32  ch2_ihs_dly:14;
        RBus_UInt32  res1:3;
        RBus_UInt32  ch2_ivs_dly:13;
    };
}sub_vgip_vgip_chn2_delay_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_de_mask_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch2_vs_dly_1hs:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  ch2_hporch_num_sel:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  ch2_l_flag_force_tog:1;
        RBus_UInt32  ch2_hporch_num:13;
        RBus_UInt32  ch2_auto_ihs_dly:2;
        RBus_UInt32  ch2_auto_ivs_dly:2;
        RBus_UInt32  ch2_hdly_one:1;
        RBus_UInt32  ch2_v1_v2_swap:1;
        RBus_UInt32  ch2_v2_v3_swap:1;
        RBus_UInt32  ch2_v1_v3_swap:1;
    };
}sub_vgip_vgip_chn2_misc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_captst_en:1;
        RBus_UInt32  ch2_captst_mode:2;
        RBus_UInt32  ch2_vcaptst_num:13;
        RBus_UInt32  ch2_captst_field_sel:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  ch2_hcaptst_num:14;
    };
}sub_vgip_vgip_chn2_ptn_h_vi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_captst_r_data:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  ch2_captst_g_data:12;
    };
}sub_vgip_vgip_chn2_ptn0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  ch2_hporch_num_sel:14;
        RBus_UInt32  res2:4;
        RBus_UInt32  ch2_captst_b_data:12;
    };
}sub_vgip_vgip_chn2_ptn1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_vlcen:1;
        RBus_UInt32  ch2_vlc_mode:1;
        RBus_UInt32  ch2_vlc_ie:1;
        RBus_UInt32  ch2_den_crc_sel:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch2_line_cnt:14;
        RBus_UInt32  ch2_vln:12;
    };
}sub_vgip_vgip_chn2_lc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  ch2_crc_mode:1;
        RBus_UInt32  ch2_crc_region:1;
        RBus_UInt32  ch2_crc_ctrl_in:1;
        RBus_UInt32  ch2_crc_field_edge_sel:1;
        RBus_UInt32  ch2_crc_field:1;
        RBus_UInt32  ch2_crc_conti:1;
        RBus_UInt32  ch2_crc_start:1;
    };
}sub_vgip_ich2_vgip_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_crc_result:32;
    };
}sub_vgip_ich2_vgip_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_wd_to_main:1;
        RBus_UInt32  ch2_wd_to_sub:1;
        RBus_UInt32  vgip_wd_debug_mode_s:1;
        RBus_UInt32  vgip_wd_debug_target_s:1;
        RBus_UInt32  dummy18022740_27_19:9;
        RBus_UInt32  ch2_vs_err_wde:1;
        RBus_UInt32  ch2_hs_err_wde:1;
        RBus_UInt32  ch2_field_err_wde:1;
        RBus_UInt32  ch2_rl_err_wde:1;
        RBus_UInt32  dummy18022740_14_5:10;
        RBus_UInt32  ch2_dispi_vact_end_ie:1;
        RBus_UInt32  ch2_rl_err_ie:1;
        RBus_UInt32  ch2_vs_err_ie:1;
        RBus_UInt32  ch2_hs_err_ie:1;
        RBus_UInt32  ch2_field_err_ie:1;
    };
}sub_vgip_vgip_chn2_wde_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_captst_r_data_2:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  ch2_captst_g_data_2:12;
    };
}sub_vgip_vgip_chn2_ptn2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_captst_b_data_3:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  ch2_captst_b_data_2:12;
    };
}sub_vgip_vgip_chn2_ptn3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_captst_r_data_3:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  ch2_captst_g_data_3:12;
    };
}sub_vgip_vgip_chn2_ptn4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_captst_r_data_4:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  ch2_captst_g_data_4:12;
    };
}sub_vgip_vgip_chn2_ptn5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  ch2_captst_b_data_4:12;
    };
}sub_vgip_vgip_chn2_ptn6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_adc_test_dma_count:28;
        RBus_UInt32  res1:1;
        RBus_UInt32  ch2_force_den:1;
        RBus_UInt32  ch2_force_vsync:1;
        RBus_UInt32  ch2_adc_test_dma_mode:1;
    };
}sub_vgip_sub_adc_raw_data_dma_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  ch2_dummy_ctsfifo_sdnr:1;
        RBus_UInt32  ch2_force_ctsfifo_rstn_sdnr:1;
        RBus_UInt32  ch2_en_ctsfifo_vsrst_sdnr:1;
        RBus_UInt32  ch2_en_ctsfifo_bypass_sdnr:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  ch2_toggle_ctsfifo_vgip:1;
        RBus_UInt32  ch2_ctsfifo_gate_vgip:1;
        RBus_UInt32  ch2_force_ctsfifo_rstn_vgip:1;
        RBus_UInt32  ch2_en_ctsfifo_vsrst_vgip:1;
        RBus_UInt32  ch2_en_ctsfifo_bypass_vgip:1;
    };
}sub_vgip_sub_cts_fifo_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}sub_vgip_sub_dispi_test_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_db_rdy:1;
        RBus_UInt32  ch2_db_en:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  ch2_db_read_sel:1;
        RBus_UInt32  res2:15;
    };
}sub_vgip_vgip_chn2_double_buffer_ctrl_RBUS;

#else //apply LITTLE_ENDIAN

//======SUB_VGIP register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_v8_dummy:8;
        RBus_UInt32  res1:24;
    };
}sub_vgip_sub_vclk_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy18022704_7_0:8;
        RBus_UInt32  res1:24;
    };
}sub_vgip_sub_v8_1_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_select_duplicate_lsb:1;
        RBus_UInt32  res1:31;
    };
}sub_vgip_sub_v8_2_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_l_flag_delay_num:13;
        RBus_UInt32  ch2_l_flag_field_sample_delay:2;
        RBus_UInt32  ch2_l_flag_delay_en:1;
        RBus_UInt32  ch2_auto_l_flag_delay_num:13;
        RBus_UInt32  ch2_vs_rise_sample_delay_sel:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  ch2_auto_l_flag_delay_en:1;
    };
}sub_vgip_sub_vgip_global_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_in_clk_en:1;
        RBus_UInt32  ch2_digital_mode:1;
        RBus_UInt32  ch2_hs_inv:1;
        RBus_UInt32  ch2_vs_inv:1;
        RBus_UInt32  ch2_vs_by_hs_en_n:1;
        RBus_UInt32  ch2_vs_syncedge:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  ch2_safe_mode:1;
        RBus_UInt32  ch2_force_tog:1;
        RBus_UInt32  ch2_safe_field_inv:1;
        RBus_UInt32  ch2_3d_mode_en:1;
        RBus_UInt32  ch2_mask_den_1l:1;
        RBus_UInt32  ch2_mask_den_inv:1;
        RBus_UInt32  ch2_fcap_str_odd:1;
        RBus_UInt32  ch2_hpact_is_hact:1;
        RBus_UInt32  ch2_field_det_en:1;
        RBus_UInt32  ch2_field_sync_edge:1;
        RBus_UInt32  ch2_field_inv:1;
        RBus_UInt32  ch2_3dleft_sync_edge:1;
        RBus_UInt32  ch2_3dleft_inv:1;
        RBus_UInt32  ch2_field_vd_en:1;
        RBus_UInt32  ch2_field_vd_inv:1;
        RBus_UInt32  ch2_field_hs_inv:1;
        RBus_UInt32  ch2_vact_start_ie:1;
        RBus_UInt32  ch2_vact_end_ie:1;
        RBus_UInt32  ch2_fdrop_en:1;
        RBus_UInt32  ch2_random_en:1;
        RBus_UInt32  ch2_in_sel:3;
        RBus_UInt32  ch2_ivrun:1;
    };
}sub_vgip_vgip_chn2_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_bounce_status_0:1;
        RBus_UInt32  ch2_bounce_status_1:1;
        RBus_UInt32  ch2_bounce_status_2:1;
        RBus_UInt32  ch2_more_1line_field:1;
        RBus_UInt32  ch2_field_vs_lsb:2;
        RBus_UInt32  ch2_field_tog:1;
        RBus_UInt32  ch2_field_pol:1;
        RBus_UInt32  ch2_hs_tog:1;
        RBus_UInt32  ch2_vs_tog:1;
        RBus_UInt32  ch2_l_flag_pol:1;
        RBus_UInt32  ch2_rl_tog:1;
        RBus_UInt32  ch2_field_err:1;
        RBus_UInt32  ch2_hs_err:1;
        RBus_UInt32  ch2_vs_err:1;
        RBus_UInt32  ch2_rl_err:1;
        RBus_UInt32  ch2_vlc_status:1;
        RBus_UInt32  dummy18022714_23_17:7;
        RBus_UInt32  ch2_vact_start:1;
        RBus_UInt32  ch2_vact_end:1;
        RBus_UInt32  ch2_vs_start:1;
        RBus_UInt32  ch2_vs_end:1;
        RBus_UInt32  ch2_sdnr_vact_end:1;
        RBus_UInt32  res1:3;
    };
}sub_vgip_vgip_chn2_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_ih_act_wid:14;
        RBus_UInt32  ch2_bypass_den:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  ch2_ih_act_sta:14;
        RBus_UInt32  res2:2;
    };
}sub_vgip_vgip_chn2_act_hsta_width_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_iv_act_len:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  ch2_iv_act_sta:13;
        RBus_UInt32  res2:3;
    };
}sub_vgip_vgip_chn2_act_vsta_length_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_ivs_dly:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  ch2_ihs_dly:14;
        RBus_UInt32  ch2_hs_width:2;
    };
}sub_vgip_vgip_chn2_delay_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_v1_v3_swap:1;
        RBus_UInt32  ch2_v2_v3_swap:1;
        RBus_UInt32  ch2_v1_v2_swap:1;
        RBus_UInt32  ch2_hdly_one:1;
        RBus_UInt32  ch2_auto_ivs_dly:2;
        RBus_UInt32  ch2_auto_ihs_dly:2;
        RBus_UInt32  ch2_hporch_num:13;
        RBus_UInt32  ch2_l_flag_force_tog:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch2_hporch_num_sel:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  ch2_vs_dly_1hs:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  ch2_de_mask_en:1;
    };
}sub_vgip_vgip_chn2_misc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_hcaptst_num:14;
        RBus_UInt32  res1:1;
        RBus_UInt32  ch2_captst_field_sel:1;
        RBus_UInt32  ch2_vcaptst_num:13;
        RBus_UInt32  ch2_captst_mode:2;
        RBus_UInt32  ch2_captst_en:1;
    };
}sub_vgip_vgip_chn2_ptn_h_vi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_captst_g_data:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_captst_r_data:12;
        RBus_UInt32  res2:4;
    };
}sub_vgip_vgip_chn2_ptn0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_captst_b_data:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_hporch_num_sel:14;
        RBus_UInt32  res2:2;
    };
}sub_vgip_vgip_chn2_ptn1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_vln:12;
        RBus_UInt32  ch2_line_cnt:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  ch2_den_crc_sel:1;
        RBus_UInt32  ch2_vlc_ie:1;
        RBus_UInt32  ch2_vlc_mode:1;
        RBus_UInt32  ch2_vlcen:1;
    };
}sub_vgip_vgip_chn2_lc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_crc_start:1;
        RBus_UInt32  ch2_crc_conti:1;
        RBus_UInt32  ch2_crc_field:1;
        RBus_UInt32  ch2_crc_field_edge_sel:1;
        RBus_UInt32  ch2_crc_ctrl_in:1;
        RBus_UInt32  ch2_crc_region:1;
        RBus_UInt32  ch2_crc_mode:1;
        RBus_UInt32  res1:25;
    };
}sub_vgip_ich2_vgip_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_crc_result:32;
    };
}sub_vgip_ich2_vgip_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_field_err_ie:1;
        RBus_UInt32  ch2_hs_err_ie:1;
        RBus_UInt32  ch2_vs_err_ie:1;
        RBus_UInt32  ch2_rl_err_ie:1;
        RBus_UInt32  ch2_dispi_vact_end_ie:1;
        RBus_UInt32  dummy18022740_14_5:10;
        RBus_UInt32  ch2_rl_err_wde:1;
        RBus_UInt32  ch2_field_err_wde:1;
        RBus_UInt32  ch2_hs_err_wde:1;
        RBus_UInt32  ch2_vs_err_wde:1;
        RBus_UInt32  dummy18022740_27_19:9;
        RBus_UInt32  vgip_wd_debug_target_s:1;
        RBus_UInt32  vgip_wd_debug_mode_s:1;
        RBus_UInt32  ch2_wd_to_sub:1;
        RBus_UInt32  ch2_wd_to_main:1;
    };
}sub_vgip_vgip_chn2_wde_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_captst_g_data_2:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_captst_r_data_2:12;
        RBus_UInt32  res2:4;
    };
}sub_vgip_vgip_chn2_ptn2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_captst_b_data_2:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_captst_b_data_3:12;
        RBus_UInt32  res2:4;
    };
}sub_vgip_vgip_chn2_ptn3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_captst_g_data_3:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_captst_r_data_3:12;
        RBus_UInt32  res2:4;
    };
}sub_vgip_vgip_chn2_ptn4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_captst_g_data_4:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ch2_captst_r_data_4:12;
        RBus_UInt32  res2:4;
    };
}sub_vgip_vgip_chn2_ptn5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_captst_b_data_4:12;
        RBus_UInt32  res1:20;
    };
}sub_vgip_vgip_chn2_ptn6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_adc_test_dma_mode:1;
        RBus_UInt32  ch2_force_vsync:1;
        RBus_UInt32  ch2_force_den:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  ch2_adc_test_dma_count:28;
    };
}sub_vgip_sub_adc_raw_data_dma_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch2_en_ctsfifo_bypass_vgip:1;
        RBus_UInt32  ch2_en_ctsfifo_vsrst_vgip:1;
        RBus_UInt32  ch2_force_ctsfifo_rstn_vgip:1;
        RBus_UInt32  ch2_ctsfifo_gate_vgip:1;
        RBus_UInt32  ch2_toggle_ctsfifo_vgip:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  ch2_en_ctsfifo_bypass_sdnr:1;
        RBus_UInt32  ch2_en_ctsfifo_vsrst_sdnr:1;
        RBus_UInt32  ch2_force_ctsfifo_rstn_sdnr:1;
        RBus_UInt32  ch2_dummy_ctsfifo_sdnr:1;
        RBus_UInt32  res2:20;
    };
}sub_vgip_sub_cts_fifo_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}sub_vgip_sub_dispi_test_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  ch2_db_read_sel:1;
        RBus_UInt32  res2:14;
        RBus_UInt32  ch2_db_en:1;
        RBus_UInt32  ch2_db_rdy:1;
    };
}sub_vgip_vgip_chn2_double_buffer_ctrl_RBUS;




#endif 


#endif 
