/**
* @file rbusDispd_osd_bistReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2016/6/3
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_DISPD_OSD_BIST_REG_H_
#define _RBUS_DISPD_OSD_BIST_REG_H_

#include "rbusTypes.h"



//  DISPD_OSD_BIST Register Address



#define  DISPD_OSD_BIST_GDMA_BIST_MODE_VADDR                	(0xb8029e00)
#define  DISPD_OSD_BIST_GDMA_BIST_DONE_VADDR                	(0xb8029e04)
#define  DISPD_OSD_BIST_GDMA_BIST_FAIL_GROUP_VADDR          	(0xb8029e08)
#define  DISPD_OSD_BIST_GDMA_DRF_MODE_VADDR                 	(0xb8029e0c)
#define  DISPD_OSD_BIST_GDMA_DRF_RESUME_VADDR               	(0xb8029e10)
#define  DISPD_OSD_BIST_GDMA_DRF_DONE_VADDR                 	(0xb8029e14)
#define  DISPD_OSD_BIST_GDMA_DRF_PAUSE_VADDR                	(0xb8029e18)
#define  DISPD_OSD_BIST_GDMA_DRF_FAIL_GROUP_VADDR           	(0xb8029e1c)
#define  DISPD_OSD_BIST_DISPD_BISR_SECOND_RUN_EN_VADDR      	(0xb8029e20)
#define  DISPD_OSD_BIST_DISPD_BISR_FAIL_GROUP_VADDR         	(0xb8029e24)
#define  DISPD_OSD_BIST_DISPD_BISR_DRF_MODE_VADDR           	(0xb8029e28)
#define  DISPD_OSD_BIST_DISPD_BISR_DRF_RESUME_VADDR         	(0xb8029e2c)
#define  DISPD_OSD_BIST_DISPD_BISR_DRF_DONE_VADDR           	(0xb8029e30)
#define  DISPD_OSD_BIST_DISPD_BISR_DRF_PAUSE_VADDR          	(0xb8029e34)
#define  DISPD_OSD_BIST_DISPD_BISR_DRF_FAIL_GROUP_VADDR     	(0xb8029e38)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======DISPD_OSD_BIST register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  gdma_fbdc_data0_bist_mode:1;
        RBus_UInt32  gdma_fbdc_data1_bist_mode:1;
        RBus_UInt32  gdma_fbdc_dma_bist_mode:1;
        RBus_UInt32  gdma_fbdc_header_bist_mode:1;
        RBus_UInt32  gdma_osd_rbuf_bist_mode:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_mode:1;
        RBus_UInt32  gdma_wdma_bist_mode:1;
        RBus_UInt32  gdma_osd1_clut_bist_mode:1;
        RBus_UInt32  gdma_osd2_clut_bist_mode:1;
        RBus_UInt32  gdma_osd3_clut_bist_mode:1;
        RBus_UInt32  gdma_osd4_clut_bist_mode:1;
        RBus_UInt32  gdma_osd5_clut_bist_mode:1;
        RBus_UInt32  gdma_osd_dispbuf_bist_mode:1;
    };
}dispd_osd_bist_gdma_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  gdma_fbdc_data0_bist_done:1;
        RBus_UInt32  gdma_fbdc_data1_bist_done:1;
        RBus_UInt32  gdma_fbdc_dma_bist_done:1;
        RBus_UInt32  gdma_fbdc_header_bist_done:1;
        RBus_UInt32  gdma_osd_rbuf_bist_done:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_done:1;
        RBus_UInt32  gdma_wdma_bist_done:1;
        RBus_UInt32  gdma_osd1_clut_bist_done:1;
        RBus_UInt32  gdma_osd2_clut_bist_done:1;
        RBus_UInt32  gdma_osd3_clut_bist_done:1;
        RBus_UInt32  gdma_osd4_clut_bist_done:1;
        RBus_UInt32  gdma_osd5_clut_bist_done:1;
        RBus_UInt32  gdma_osd_dispbuf_bist_done:1;
    };
}dispd_osd_bist_gdma_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  gdma_fbdc_data0_bist_fail_group:1;
        RBus_UInt32  gdma_fbdc_data1_bist_fail_group:1;
        RBus_UInt32  gdma_fbdc_dma_bist_fail_group:1;
        RBus_UInt32  gdma_fbdc_header_bist_fail_group:1;
        RBus_UInt32  gdma_osd_rbuf_bist_fail_group:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_fail_group:1;
        RBus_UInt32  gdma_wdma_bist_fail_group:1;
        RBus_UInt32  gdma_osd1_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd2_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd3_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd4_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd5_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd_dispbuf_bist_fail_group:1;
    };
}dispd_osd_bist_gdma_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  gdma_fbdc_data0_drf_mode:1;
        RBus_UInt32  gdma_fbdc_data1_drf_mode:1;
        RBus_UInt32  gdma_fbdc_dma_drf_mode:1;
        RBus_UInt32  gdma_fbdc_header_drf_mode:1;
        RBus_UInt32  gdma_osd_rbuf_drf_mode:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_mode:1;
        RBus_UInt32  gdma_wdma_drf_mode:1;
        RBus_UInt32  gdma_osd1_clut_drf_mode:1;
        RBus_UInt32  gdma_osd2_clut_drf_mode:1;
        RBus_UInt32  gdma_osd3_clut_drf_mode:1;
        RBus_UInt32  gdma_osd4_clut_drf_mode:1;
        RBus_UInt32  gdma_osd5_clut_drf_mode:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_mode:1;
    };
}dispd_osd_bist_gdma_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  gdma_fbdc_data0_drf_resume:1;
        RBus_UInt32  gdma_fbdc_data1_drf_resume:1;
        RBus_UInt32  gdma_fbdc_dma_drf_resume:1;
        RBus_UInt32  gdma_fbdc_header_drf_resume:1;
        RBus_UInt32  gdma_osd_rbuf_drf_resume:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_resume:1;
        RBus_UInt32  gdma_wdma_drf_resume:1;
        RBus_UInt32  gdma_osd1_clut_drf_resume:1;
        RBus_UInt32  gdma_osd2_clut_drf_resume:1;
        RBus_UInt32  gdma_osd3_clut_drf_resume:1;
        RBus_UInt32  gdma_osd4_clut_drf_resume:1;
        RBus_UInt32  gdma_osd5_clut_drf_resume:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_resume:1;
    };
}dispd_osd_bist_gdma_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  gdma_fbdc_data0_drf_done:1;
        RBus_UInt32  gdma_fbdc_data1_drf_done:1;
        RBus_UInt32  gdma_fbdc_dma_drf_done:1;
        RBus_UInt32  gdma_fbdc_header_drf_done:1;
        RBus_UInt32  gdma_osd_rbuf_drf_done:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_done:1;
        RBus_UInt32  gdma_wdma_drf_done:1;
        RBus_UInt32  gdma_osd1_clut_drf_done:1;
        RBus_UInt32  gdma_osd2_clut_drf_done:1;
        RBus_UInt32  gdma_osd3_clut_drf_done:1;
        RBus_UInt32  gdma_osd4_clut_drf_done:1;
        RBus_UInt32  gdma_osd5_clut_drf_done:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_done:1;
    };
}dispd_osd_bist_gdma_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  gdma_fbdc_data0_drf_pause:1;
        RBus_UInt32  gdma_fbdc_data1_drf_pause:1;
        RBus_UInt32  gdma_fbdc_dma_drf_pause:1;
        RBus_UInt32  gdma_fbdc_header_drf_pause:1;
        RBus_UInt32  gdma_osd_rbuf_drf_pause:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_pause:1;
        RBus_UInt32  gdma_wdma_drf_pause:1;
        RBus_UInt32  gdma_osd1_clut_drf_pause:1;
        RBus_UInt32  gdma_osd2_clut_drf_pause:1;
        RBus_UInt32  gdma_osd3_clut_drf_pause:1;
        RBus_UInt32  gdma_osd4_clut_drf_pause:1;
        RBus_UInt32  gdma_osd5_clut_drf_pause:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_pause:1;
    };
}dispd_osd_bist_gdma_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
        RBus_UInt32  gdma_fbdc_data0_drf_fail_group:1;
        RBus_UInt32  gdma_fbdc_data1_drf_fail_group:1;
        RBus_UInt32  gdma_fbdc_dma_drf_fail_group:1;
        RBus_UInt32  gdma_fbdc_header_drf_fail_group:1;
        RBus_UInt32  gdma_osd_rbuf_drf_fail_group:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_fail_group:1;
        RBus_UInt32  gdma_wdma_drf_fail_group:1;
        RBus_UInt32  gdma_osd1_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd2_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd3_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd4_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd5_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd_dispbuf_drf_fail_group:1;
    };
}dispd_osd_bist_gdma_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  gdma_fbdc_bisr_second_run_en_003:1;
        RBus_UInt32  gdma_fbdc_bisr_second_run_en_002:1;
        RBus_UInt32  gdma_fbdc_bisr_second_run_en_001:1;
        RBus_UInt32  gdma_fbdc_bisr_second_run_en_000:1;
    };
}dispd_osd_bist_dispd_bisr_second_run_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  gdma_fbdc_bisr_fail_003_group:1;
        RBus_UInt32  gdma_fbdc_bisr_fail_002_group:1;
        RBus_UInt32  gdma_fbdc_bisr_fail_001_group:1;
        RBus_UInt32  gdma_fbdc_bisr_fail_000_group:1;
    };
}dispd_osd_bist_dispd_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  gdma_fbdc_drf_bisr_mode_003:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_mode_002:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_mode_001:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_mode_000:1;
    };
}dispd_osd_bist_dispd_bisr_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  gdma_fbdc_drf_bisr_test_resume_003:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_test_resume_002:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_test_resume_001:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_test_resume_000:1;
    };
}dispd_osd_bist_dispd_bisr_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  gdma_fbdc_drf_bisr_done_003:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_done_002:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_done_001:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_done_000:1;
    };
}dispd_osd_bist_dispd_bisr_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  gdma_fbdc_drf_bisr_start_pause_003:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_start_pause_002:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_start_pause_001:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_start_pause_000:1;
    };
}dispd_osd_bist_dispd_bisr_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  gdma_fbdc_drf_bisr_fail_003_group:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_fail_002_group:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_fail_001_group:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_fail_000_group:1;
    };
}dispd_osd_bist_dispd_bisr_drf_fail_group_RBUS;

#else //apply LITTLE_ENDIAN

//======DISPD_OSD_BIST register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_bist_mode:1;
        RBus_UInt32  gdma_osd5_clut_bist_mode:1;
        RBus_UInt32  gdma_osd4_clut_bist_mode:1;
        RBus_UInt32  gdma_osd3_clut_bist_mode:1;
        RBus_UInt32  gdma_osd2_clut_bist_mode:1;
        RBus_UInt32  gdma_osd1_clut_bist_mode:1;
        RBus_UInt32  gdma_wdma_bist_mode:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_mode:1;
        RBus_UInt32  gdma_osd_rbuf_bist_mode:1;
        RBus_UInt32  gdma_fbdc_header_bist_mode:1;
        RBus_UInt32  gdma_fbdc_dma_bist_mode:1;
        RBus_UInt32  gdma_fbdc_data1_bist_mode:1;
        RBus_UInt32  gdma_fbdc_data0_bist_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
    };
}dispd_osd_bist_gdma_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_bist_done:1;
        RBus_UInt32  gdma_osd5_clut_bist_done:1;
        RBus_UInt32  gdma_osd4_clut_bist_done:1;
        RBus_UInt32  gdma_osd3_clut_bist_done:1;
        RBus_UInt32  gdma_osd2_clut_bist_done:1;
        RBus_UInt32  gdma_osd1_clut_bist_done:1;
        RBus_UInt32  gdma_wdma_bist_done:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_done:1;
        RBus_UInt32  gdma_osd_rbuf_bist_done:1;
        RBus_UInt32  gdma_fbdc_header_bist_done:1;
        RBus_UInt32  gdma_fbdc_dma_bist_done:1;
        RBus_UInt32  gdma_fbdc_data1_bist_done:1;
        RBus_UInt32  gdma_fbdc_data0_bist_done:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
    };
}dispd_osd_bist_gdma_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_bist_fail_group:1;
        RBus_UInt32  gdma_osd5_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd4_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd3_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd2_clut_bist_fail_group:1;
        RBus_UInt32  gdma_osd1_clut_bist_fail_group:1;
        RBus_UInt32  gdma_wdma_bist_fail_group:1;
        RBus_UInt32  gdma_osd_dma_buf_bist_fail_group:1;
        RBus_UInt32  gdma_osd_rbuf_bist_fail_group:1;
        RBus_UInt32  gdma_fbdc_header_bist_fail_group:1;
        RBus_UInt32  gdma_fbdc_dma_bist_fail_group:1;
        RBus_UInt32  gdma_fbdc_data1_bist_fail_group:1;
        RBus_UInt32  gdma_fbdc_data0_bist_fail_group:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
    };
}dispd_osd_bist_gdma_bist_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_mode:1;
        RBus_UInt32  gdma_osd5_clut_drf_mode:1;
        RBus_UInt32  gdma_osd4_clut_drf_mode:1;
        RBus_UInt32  gdma_osd3_clut_drf_mode:1;
        RBus_UInt32  gdma_osd2_clut_drf_mode:1;
        RBus_UInt32  gdma_osd1_clut_drf_mode:1;
        RBus_UInt32  gdma_wdma_drf_mode:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_mode:1;
        RBus_UInt32  gdma_osd_rbuf_drf_mode:1;
        RBus_UInt32  gdma_fbdc_header_drf_mode:1;
        RBus_UInt32  gdma_fbdc_dma_drf_mode:1;
        RBus_UInt32  gdma_fbdc_data1_drf_mode:1;
        RBus_UInt32  gdma_fbdc_data0_drf_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
    };
}dispd_osd_bist_gdma_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_resume:1;
        RBus_UInt32  gdma_osd5_clut_drf_resume:1;
        RBus_UInt32  gdma_osd4_clut_drf_resume:1;
        RBus_UInt32  gdma_osd3_clut_drf_resume:1;
        RBus_UInt32  gdma_osd2_clut_drf_resume:1;
        RBus_UInt32  gdma_osd1_clut_drf_resume:1;
        RBus_UInt32  gdma_wdma_drf_resume:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_resume:1;
        RBus_UInt32  gdma_osd_rbuf_drf_resume:1;
        RBus_UInt32  gdma_fbdc_header_drf_resume:1;
        RBus_UInt32  gdma_fbdc_dma_drf_resume:1;
        RBus_UInt32  gdma_fbdc_data1_drf_resume:1;
        RBus_UInt32  gdma_fbdc_data0_drf_resume:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
    };
}dispd_osd_bist_gdma_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_done:1;
        RBus_UInt32  gdma_osd5_clut_drf_done:1;
        RBus_UInt32  gdma_osd4_clut_drf_done:1;
        RBus_UInt32  gdma_osd3_clut_drf_done:1;
        RBus_UInt32  gdma_osd2_clut_drf_done:1;
        RBus_UInt32  gdma_osd1_clut_drf_done:1;
        RBus_UInt32  gdma_wdma_drf_done:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_done:1;
        RBus_UInt32  gdma_osd_rbuf_drf_done:1;
        RBus_UInt32  gdma_fbdc_header_drf_done:1;
        RBus_UInt32  gdma_fbdc_dma_drf_done:1;
        RBus_UInt32  gdma_fbdc_data1_drf_done:1;
        RBus_UInt32  gdma_fbdc_data0_drf_done:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
    };
}dispd_osd_bist_gdma_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_pause:1;
        RBus_UInt32  gdma_osd5_clut_drf_pause:1;
        RBus_UInt32  gdma_osd4_clut_drf_pause:1;
        RBus_UInt32  gdma_osd3_clut_drf_pause:1;
        RBus_UInt32  gdma_osd2_clut_drf_pause:1;
        RBus_UInt32  gdma_osd1_clut_drf_pause:1;
        RBus_UInt32  gdma_wdma_drf_pause:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_pause:1;
        RBus_UInt32  gdma_osd_rbuf_drf_pause:1;
        RBus_UInt32  gdma_fbdc_header_drf_pause:1;
        RBus_UInt32  gdma_fbdc_dma_drf_pause:1;
        RBus_UInt32  gdma_fbdc_data1_drf_pause:1;
        RBus_UInt32  gdma_fbdc_data0_drf_pause:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
    };
}dispd_osd_bist_gdma_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_osd_dispbuf_drf_fail_group:1;
        RBus_UInt32  gdma_osd5_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd4_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd3_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd2_clut_drf_fail_group:1;
        RBus_UInt32  gdma_osd1_clut_drf_fail_group:1;
        RBus_UInt32  gdma_wdma_drf_fail_group:1;
        RBus_UInt32  gdma_osd_dma_buf_drf_fail_group:1;
        RBus_UInt32  gdma_osd_rbuf_drf_fail_group:1;
        RBus_UInt32  gdma_fbdc_header_drf_fail_group:1;
        RBus_UInt32  gdma_fbdc_dma_drf_fail_group:1;
        RBus_UInt32  gdma_fbdc_data1_drf_fail_group:1;
        RBus_UInt32  gdma_fbdc_data0_drf_fail_group:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  res7:1;
        RBus_UInt32  res8:1;
        RBus_UInt32  res9:1;
        RBus_UInt32  res10:1;
        RBus_UInt32  res11:1;
        RBus_UInt32  res12:1;
        RBus_UInt32  res13:1;
        RBus_UInt32  res14:1;
        RBus_UInt32  res15:1;
        RBus_UInt32  res16:1;
        RBus_UInt32  res17:1;
        RBus_UInt32  res18:1;
        RBus_UInt32  res19:1;
    };
}dispd_osd_bist_gdma_drf_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_fbdc_bisr_second_run_en_000:1;
        RBus_UInt32  gdma_fbdc_bisr_second_run_en_001:1;
        RBus_UInt32  gdma_fbdc_bisr_second_run_en_002:1;
        RBus_UInt32  gdma_fbdc_bisr_second_run_en_003:1;
        RBus_UInt32  res1:28;
    };
}dispd_osd_bist_dispd_bisr_second_run_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_fbdc_bisr_fail_000_group:1;
        RBus_UInt32  gdma_fbdc_bisr_fail_001_group:1;
        RBus_UInt32  gdma_fbdc_bisr_fail_002_group:1;
        RBus_UInt32  gdma_fbdc_bisr_fail_003_group:1;
        RBus_UInt32  res1:28;
    };
}dispd_osd_bist_dispd_bisr_fail_group_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_fbdc_drf_bisr_mode_000:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_mode_001:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_mode_002:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_mode_003:1;
        RBus_UInt32  res1:28;
    };
}dispd_osd_bist_dispd_bisr_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_fbdc_drf_bisr_test_resume_000:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_test_resume_001:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_test_resume_002:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_test_resume_003:1;
        RBus_UInt32  res1:28;
    };
}dispd_osd_bist_dispd_bisr_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_fbdc_drf_bisr_done_000:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_done_001:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_done_002:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_done_003:1;
        RBus_UInt32  res1:28;
    };
}dispd_osd_bist_dispd_bisr_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_fbdc_drf_bisr_start_pause_000:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_start_pause_001:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_start_pause_002:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_start_pause_003:1;
        RBus_UInt32  res1:28;
    };
}dispd_osd_bist_dispd_bisr_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gdma_fbdc_drf_bisr_fail_000_group:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_fail_001_group:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_fail_002_group:1;
        RBus_UInt32  gdma_fbdc_drf_bisr_fail_003_group:1;
        RBus_UInt32  res1:28;
    };
}dispd_osd_bist_dispd_bisr_drf_fail_group_RBUS;




#endif 


#endif 
