/**
* @file rbusOnmsReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2016/6/3
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_ONMS_REG_H_
#define _RBUS_ONMS_REG_H_

#include "rbusTypes.h"



//  ONMS Register Address



#define  ONMS_ONMS1_CTRL_VADDR                              	(0xb8021200)
#define  ONMS_ONMS1_BLANK_PIXEL_VALUE_GET_0_VADDR           	(0xb8021204)
#define  ONMS_ONMS1_BLANK_PIXEL_VALUE_GET_1_VADDR           	(0xb8021208)
#define  ONMS_ONMS1_BLANK_PIXEL_VALUE_0_VADDR               	(0xb802120c)
#define  ONMS_ONMS1_BLANK_PIXEL_VALUE_1_VADDR               	(0xb8021210)
#define  ONMS_ONMS1_FP_VACT12_VADDR                         	(0xb8021214)
#define  ONMS_ONMS1_FP_VACT34_VADDR                         	(0xb8021218)
#define  ONMS_ONMS1_FP_VACT_SPACE_VADDR                     	(0xb802121c)
#define  ONMS_ONMS1_BLANK_LINE_VADDR                        	(0xb8021220)
#define  ONMS_ONMS1_ACTIVE_SPACE1_LINE_NUMBER_VADDR         	(0xb8021224)
#define  ONMS_ONMS1_ACTIVE_SPACE2_LINE_NUMBER_VADDR         	(0xb8021228)
#define  ONMS_ONMS1_ACTIVE_SPACE3_LINE_NUMBER_VADDR         	(0xb802122c)
#define  ONMS_ONMS1_VS_PERIOD_VADDR                         	(0xb8021230)
#define  ONMS_ONMS1_VSHS_HIGH_PERIOD_VADDR                  	(0xb8021234)
#define  ONMS_ONMS1_HS_PERIOD_VADDR                         	(0xb8021238)
#define  ONMS_ONMS1_VACT_STA_VADDR                          	(0xb802123c)
#define  ONMS_ONMS1_HACT_STA_VADDR                          	(0xb8021240)
#define  ONMS_ONMS1_HACT_VADDR                              	(0xb8021244)
#define  ONMS_ONMS1_L_FLAG_PERIOD_VADDR                     	(0xb8021248)
#define  ONMS_ONMS1_L_FLAG_HIGH_PERIOD_VADDR                	(0xb802124c)
#define  ONMS_ONMS1_FIELD_PERIOD_VADDR                      	(0xb8021250)
#define  ONMS_ONMS1_FIELD_HIGH_PERIOD_VADDR                 	(0xb8021254)
#define  ONMS_ONMS1_STATUS_2_VADDR                          	(0xb8021258)
#define  ONMS_ONMS1_HSYNC_MEAS_CTRL_VADDR                   	(0xb802125c)
#define  ONMS_ONMS1_HSYNC_MEAS_CTRL_2_VADDR                 	(0xb8021260)
#define  ONMS_ONMS1_HSYNC_MEAS_RESULT_VADDR                 	(0xb8021264)
#define  ONMS_ONMS1_STATUS_VADDR                            	(0xb8021268)
#define  ONMS_ONMS1_WATCHDOG_EN_VADDR                       	(0xb802126c)
#define  ONMS_ONMS1_INTERRUPT_EN_VADDR                      	(0xb8021270)
#define  ONMS_ONMS2_CTRL_VADDR                              	(0xb8021300)
#define  ONMS_ONMS2_BLANK_PIXEL_VALUE_GET_0_VADDR           	(0xb8021304)
#define  ONMS_ONMS2_BLANK_PIXEL_VALUE_GET_1_VADDR           	(0xb8021308)
#define  ONMS_ONMS2_BLANK_PIXEL_VALUE_0_VADDR               	(0xb802130c)
#define  ONMS_ONMS2_BLANK_PIXEL_VALUE_1_VADDR               	(0xb8021310)
#define  ONMS_ONMS2_FP_VACT12_VADDR                         	(0xb8021314)
#define  ONMS_ONMS2_FP_VACT34_VADDR                         	(0xb8021318)
#define  ONMS_ONMS2_FP_VACT_SPACE_VADDR                     	(0xb802131c)
#define  ONMS_ONMS2_BLANK_LINE_VADDR                        	(0xb8021320)
#define  ONMS_ONMS2_ACTIVE_SPACE1_LINE_NUMBER_VADDR         	(0xb8021324)
#define  ONMS_ONMS2_ACTIVE_SPACE2_LINE_NUMBER_VADDR         	(0xb8021328)
#define  ONMS_ONMS2_ACTIVE_SPACE3_LINE_NUMBER_VADDR         	(0xb802132c)
#define  ONMS_ONMS2_VS_PERIOD_VADDR                         	(0xb8021330)
#define  ONMS_ONMS2_VSHS_HIGH_PERIOD_VADDR                  	(0xb8021334)
#define  ONMS_ONMS2_HS_PERIOD_VADDR                         	(0xb8021338)
#define  ONMS_ONMS2_VACT_STA_VADDR                          	(0xb802133c)
#define  ONMS_ONMS2_HACT_STA_VADDR                          	(0xb8021340)
#define  ONMS_ONMS2_HACT_VADDR                              	(0xb8021344)
#define  ONMS_ONMS2_HSYNC_MEAS_CTRL_VADDR                   	(0xb802135c)
#define  ONMS_ONMS2_HSYNC_MEAS_CTRL_2_VADDR                 	(0xb8021360)
#define  ONMS_ONMS2_HSYNC_MEAS_RESULT_VADDR                 	(0xb8021364)
#define  ONMS_ONMS2_STATUS_VADDR                            	(0xb8021368)
#define  ONMS_ONMS2_WATCHDOG_EN_VADDR                       	(0xb802136c)
#define  ONMS_ONMS2_INTERRUPT_EN_VADDR                      	(0xb8021370)
#define  ONMS_ONMS3_CTRL_VADDR                              	(0xb8021400)
#define  ONMS_ONMS3_BLANK_PIXEL_VALUE_GET_0_VADDR           	(0xb8021404)
#define  ONMS_ONMS3_BLANK_PIXEL_VALUE_GET_1_VADDR           	(0xb8021408)
#define  ONMS_ONMS3_BLANK_PIXEL_VALUE_0_VADDR               	(0xb802140c)
#define  ONMS_ONMS3_BLANK_PIXEL_VALUE_1_VADDR               	(0xb8021410)
#define  ONMS_ONMS3_FP_VACT12_VADDR                         	(0xb8021414)
#define  ONMS_ONMS3_FP_VACT34_VADDR                         	(0xb8021418)
#define  ONMS_ONMS3_FP_VACT_SPACE_VADDR                     	(0xb802141c)
#define  ONMS_ONMS3_BLANK_LINE_VADDR                        	(0xb8021420)
#define  ONMS_ONMS3_ACTIVE_SPACE1_LINE_NUMBER_VADDR         	(0xb8021424)
#define  ONMS_ONMS3_ACTIVE_SPACE2_LINE_NUMBER_VADDR         	(0xb8021428)
#define  ONMS_ONMS3_ACTIVE_SPACE3_LINE_NUMBER_VADDR         	(0xb802142c)
#define  ONMS_ONMS3_VS_PERIOD_VADDR                         	(0xb8021430)
#define  ONMS_ONMS3_VSHS_HIGH_PERIOD_VADDR                  	(0xb8021434)
#define  ONMS_ONMS3_HS_PERIOD_VADDR                         	(0xb8021438)
#define  ONMS_ONMS3_VACT_STA_VADDR                          	(0xb802143c)
#define  ONMS_ONMS3_HACT_STA_VADDR                          	(0xb8021440)
#define  ONMS_ONMS3_HACT_VADDR                              	(0xb8021444)
#define  ONMS_ONMS3_HSYNC_MEAS_CTRL_VADDR                   	(0xb802145c)
#define  ONMS_ONMS3_HSYNC_MEAS_CTRL_2_VADDR                 	(0xb8021460)
#define  ONMS_ONMS3_HSYNC_MEAS_RESULT_VADDR                 	(0xb8021464)
#define  ONMS_ONMS3_STATUS_VADDR                            	(0xb8021468)
#define  ONMS_ONMS3_WATCHDOG_EN_VADDR                       	(0xb802146c)
#define  ONMS_ONMS3_INTERRUPT_EN_VADDR                      	(0xb8021470)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======ONMS register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_4k2k_mode:2;
        RBus_UInt32  on1_ms_src_sel:1;
        RBus_UInt32  on1_blk_2frame_en:1;
        RBus_UInt32  on1_pixel_get_en:1;
        RBus_UInt32  on1_pixel_get_sel:2;
        RBus_UInt32  on1_progressive:1;
        RBus_UInt32  on1_vtotal_max_delta:4;
        RBus_UInt32  on1_htotal_max_delta:4;
        RBus_UInt32  dummy18021200_15:1;
        RBus_UInt32  dummy18021200_14:1;
        RBus_UInt32  dummy18021200_13:1;
        RBus_UInt32  on1_pixel_encoding:1;
        RBus_UInt32  on1_vact_space_threshold:4;
        RBus_UInt32  on1_vact_space_meas_en:1;
        RBus_UInt32  on1_meas_to_sel:1;
        RBus_UInt32  on1_sycms_clk:1;
        RBus_UInt32  on1_vs_meas_inv:1;
        RBus_UInt32  on1_hs_meas_inv:1;
        RBus_UInt32  on1_popup_meas:1;
        RBus_UInt32  on1_ms_conti:1;
        RBus_UInt32  on1_start_ms:1;
    };
}onms_onms1_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  on1_pixel_ok:1;
        RBus_UInt32  on1_get_r_value:12;
        RBus_UInt32  on1_get_g_value:12;
    };
}onms_onms1_blank_pixel_value_get_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  on1_get_b_value:12;
    };
}onms_onms1_blank_pixel_value_get_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  on1_active_r_value:12;
        RBus_UInt32  on1_active_g_value:12;
    };
}onms_onms1_blank_pixel_value_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  on1_active_b_value:12;
    };
}onms_onms1_blank_pixel_value_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  on1_vact2:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  on1_vact1:11;
    };
}onms_onms1_fp_vact12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  on1_vact4:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  on1_vact3:11;
    };
}onms_onms1_fp_vact34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  on1_fp_vact_space1:10;
        RBus_UInt32  on1_fp_vact_space2:10;
        RBus_UInt32  on1_fp_vact_space3:10;
    };
}onms_onms1_fp_vact_space_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  on1_r_blank_line_start:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  on1_l_blank_line_end:11;
    };
}onms_onms1_blank_line_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  on1_vact_space1_end:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  on1_vact_space1_start:10;
    };
}onms_onms1_active_space1_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  on1_vact_space2_end:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  on1_vact_space2_start:10;
    };
}onms_onms1_active_space2_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  on1_vact_space3_end:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  on1_vact_space3_start:10;
    };
}onms_onms1_active_space3_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on1_vtotalde:13;
        RBus_UInt32  res2:2;
        RBus_UInt32  on1_vtotal:14;
    };
}onms_onms1_vs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  on1_vs_high_period:12;
        RBus_UInt32  res2:2;
        RBus_UInt32  on1_hs_high_period:14;
    };
}onms_onms1_vshs_high_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  on1_htotal_h12b:14;
        RBus_UInt32  on1_htotal_f4b:4;
    };
}onms_onms1_hs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  on1_vblank_len:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  on1_vact_start:12;
    };
}onms_onms1_vact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  on1_hact_start:14;
    };
}onms_onms1_hact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  on1_hact:14;
        RBus_UInt32  on1_hact_fract:4;
    };
}onms_onms1_hact_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  on1_ltotal:24;
    };
}onms_onms1_l_flag_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  on1_l_flag_high_period:24;
    };
}onms_onms1_l_flag_high_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  on1_ftotal:24;
    };
}onms_onms1_field_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  on1_field_high_period:24;
    };
}onms_onms1_field_high_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  on1_ltotal_chg:1;
        RBus_UInt32  on1_ftotal_chg:1;
    };
}onms_onms1_status_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  on1_htotal_max_delta_new:7;
        RBus_UInt32  res2:4;
        RBus_UInt32  on1_average_line:4;
        RBus_UInt32  res3:2;
        RBus_UInt32  on1_target_measure:14;
    };
}onms_onms1_hsync_meas_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  on1_vmeas_end:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  on1_vmeas_start:12;
    };
}onms_onms1_hsync_meas_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  on1_hmax_delta_total:14;
    };
}onms_onms1_hsync_meas_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  on1_hs_meas_over_range:1;
        RBus_UInt32  on1_vs_per_to_long:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  on1_vs_pol_out:1;
        RBus_UInt32  on1_hs_pol_out:1;
        RBus_UInt32  on1_vs_per_over_range:1;
        RBus_UInt32  on1_hs_per_over_range:1;
        RBus_UInt32  on1_vs_per_timeout:1;
        RBus_UInt32  on1_vs_high_timeout:1;
        RBus_UInt32  on1_vs_per_overflow:1;
        RBus_UInt32  on1_hs_per_overflow:1;
        RBus_UInt32  on1_vs_pol_chg:1;
        RBus_UInt32  on1_hs_pol_chg:1;
        RBus_UInt32  on1_vtotalde_chg:1;
        RBus_UInt32  on1_vtotal_chg:1;
        RBus_UInt32  on1_hact_chg:1;
        RBus_UInt32  on1_htotal_chg:1;
        RBus_UInt32  on1_hs_active_pixel_var:1;
        RBus_UInt32  res3:3;
    };
}onms_onms1_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_wd_to_main:1;
        RBus_UInt32  on1_wd_to_sub:1;
        RBus_UInt32  res1:8;
        RBus_UInt32  on1_wd_hs_meas_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on1_wd_vs_per_over_range:1;
        RBus_UInt32  on1_wd_hs_per_over_range:1;
        RBus_UInt32  on1_wd_vs_per_timeout:1;
        RBus_UInt32  on1_wd_vs_high_timeout:1;
        RBus_UInt32  on1_wd_vs_per_overflow:1;
        RBus_UInt32  on1_wd_hs_per_overflow:1;
        RBus_UInt32  on1_wd_vs_pol_chg:1;
        RBus_UInt32  on1_wd_hs_pol_chg:1;
        RBus_UInt32  on1_wd_vtotalde_chg:1;
        RBus_UInt32  on1_wd_vtotal_chg:1;
        RBus_UInt32  on1_wd_hact_chg:1;
        RBus_UInt32  on1_wd_htotal_chg:1;
        RBus_UInt32  on1_wd_hs_active_pixel_var:1;
        RBus_UInt32  res3:3;
    };
}onms_onms1_watchdog_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_ie_to_main:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  on1_ie_hs_meas_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on1_ie_vs_per_over_range:1;
        RBus_UInt32  on1_ie_hs_per_over_range:1;
        RBus_UInt32  on1_ie_vs_per_timeout:1;
        RBus_UInt32  on1_ie_vs_high_timeout:1;
        RBus_UInt32  on1_ie_vs_per_overflow:1;
        RBus_UInt32  on1_ie_hs_per_overflow:1;
        RBus_UInt32  on1_ie_vs_pol_chg:1;
        RBus_UInt32  on1_ie_hs_pol_chg:1;
        RBus_UInt32  on1_ie_vtotalde_chg:1;
        RBus_UInt32  on1_ie_vtotal_chg:1;
        RBus_UInt32  on1_ie_hact_chg:1;
        RBus_UInt32  on1_ie_htotal_chg:1;
        RBus_UInt32  on1_ie_hs_active_pixel_var:1;
        RBus_UInt32  res3:3;
    };
}onms_onms1_interrupt_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_4k2k_mode:2;
        RBus_UInt32  on2_ms_src_sel:1;
        RBus_UInt32  on2_blk_2frame_en:1;
        RBus_UInt32  on2_pixel_get_en:1;
        RBus_UInt32  on2_pixel_get_sel:2;
        RBus_UInt32  on2_progressive:1;
        RBus_UInt32  on2_vtotal_max_delta:4;
        RBus_UInt32  on2_htotal_max_delta:4;
        RBus_UInt32  dummy18021300_15:1;
        RBus_UInt32  dummy18021300_14:1;
        RBus_UInt32  dummy18021300_13:1;
        RBus_UInt32  on2_pixel_encoding:1;
        RBus_UInt32  on2_vact_space_threshold:4;
        RBus_UInt32  on2_vact_space_meas_en:1;
        RBus_UInt32  on2_meas_to_sel:1;
        RBus_UInt32  on2_sycms_clk:1;
        RBus_UInt32  on2_vs_meas_inv:1;
        RBus_UInt32  on2_hs_meas_inv:1;
        RBus_UInt32  on2_popup_meas:1;
        RBus_UInt32  on2_ms_conti:1;
        RBus_UInt32  on2_start_ms:1;
    };
}onms_onms2_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  on2_pixel_ok:1;
        RBus_UInt32  on2_get_r_value:12;
        RBus_UInt32  on2_get_g_value:12;
    };
}onms_onms2_blank_pixel_value_get_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  on2_get_b_value:12;
    };
}onms_onms2_blank_pixel_value_get_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  on2_active_r_value:12;
        RBus_UInt32  on2_active_g_value:12;
    };
}onms_onms2_blank_pixel_value_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  on2_active_b_value:12;
    };
}onms_onms2_blank_pixel_value_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  on2_vact2:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  on2_vact1:11;
    };
}onms_onms2_fp_vact12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  on2_vact4:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  on2_vact3:11;
    };
}onms_onms2_fp_vact34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  on2_fp_vact_space1:10;
        RBus_UInt32  on2_fp_vact_space2:10;
        RBus_UInt32  on2_fp_vact_space3:10;
    };
}onms_onms2_fp_vact_space_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  on2_r_blank_line_start:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  on2_l_blank_line_end:11;
    };
}onms_onms2_blank_line_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  on2_vact_space1_end:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  on2_vact_space1_start:10;
    };
}onms_onms2_active_space1_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  on2_vact_space2_end:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  on2_vact_space2_start:10;
    };
}onms_onms2_active_space2_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  on2_vact_space3_end:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  on2_vact_space3_start:10;
    };
}onms_onms2_active_space3_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on2_vtotalde:13;
        RBus_UInt32  res2:2;
        RBus_UInt32  on2_vtotal:14;
    };
}onms_onms2_vs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  on2_vs_high_period:12;
        RBus_UInt32  res2:2;
        RBus_UInt32  on2_hs_high_period:14;
    };
}onms_onms2_vshs_high_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  on2_htotal_h12b:14;
        RBus_UInt32  on2_htotal_f4b:4;
    };
}onms_onms2_hs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  on2_vblank_len:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  on2_vact_start:12;
    };
}onms_onms2_vact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  on2_hact_start:14;
    };
}onms_onms2_hact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  on2_hact:14;
        RBus_UInt32  on2_hact_fract:4;
    };
}onms_onms2_hact_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  on2_htotal_max_delta_new:7;
        RBus_UInt32  res2:4;
        RBus_UInt32  on2_average_line:4;
        RBus_UInt32  res3:2;
        RBus_UInt32  on2_target_measure:14;
    };
}onms_onms2_hsync_meas_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  on2_vmeas_end:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  on2_vmeas_start:12;
    };
}onms_onms2_hsync_meas_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  on2_hmax_delta_total:14;
    };
}onms_onms2_hsync_meas_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  on2_hs_meas_over_range:1;
        RBus_UInt32  on2_vs_per_to_long:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  on2_vs_pol_out:1;
        RBus_UInt32  on2_hs_pol_out:1;
        RBus_UInt32  on2_vs_per_over_range:1;
        RBus_UInt32  on2_hs_per_over_range:1;
        RBus_UInt32  on2_vs_per_timeout:1;
        RBus_UInt32  on2_vs_high_timeout:1;
        RBus_UInt32  on2_vs_per_overflow:1;
        RBus_UInt32  on2_hs_per_overflow:1;
        RBus_UInt32  on2_vs_pol_chg:1;
        RBus_UInt32  on2_hs_pol_chg:1;
        RBus_UInt32  on2_vtotalde_chg:1;
        RBus_UInt32  on2_vtotal_chg:1;
        RBus_UInt32  on2_hact_chg:1;
        RBus_UInt32  on2_htotal_chg:1;
        RBus_UInt32  on2_hs_active_pixel_var:1;
        RBus_UInt32  res3:3;
    };
}onms_onms2_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_wd_to_main:1;
        RBus_UInt32  on2_wd_to_sub:1;
        RBus_UInt32  res1:8;
        RBus_UInt32  on2_wd_hs_meas_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on2_wd_vs_per_over_range:1;
        RBus_UInt32  on2_wd_hs_per_over_range:1;
        RBus_UInt32  on2_wd_vs_per_timeout:1;
        RBus_UInt32  on2_wd_vs_high_timeout:1;
        RBus_UInt32  on2_wd_vs_per_overflow:1;
        RBus_UInt32  on2_wd_hs_per_overflow:1;
        RBus_UInt32  on2_wd_vs_pol_chg:1;
        RBus_UInt32  on2_wd_hs_pol_chg:1;
        RBus_UInt32  on2_wd_vtotalde_chg:1;
        RBus_UInt32  on2_wd_vtotal_chg:1;
        RBus_UInt32  on2_wd_hact_chg:1;
        RBus_UInt32  on2_wd_htotal_chg:1;
        RBus_UInt32  on2_wd_hs_active_pixel_var:1;
        RBus_UInt32  res3:3;
    };
}onms_onms2_watchdog_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_ie_to_main:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  on2_ie_hs_meas_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on2_ie_vs_per_over_range:1;
        RBus_UInt32  on2_ie_hs_per_over_range:1;
        RBus_UInt32  on2_ie_vs_per_timeout:1;
        RBus_UInt32  on2_ie_vs_high_timeout:1;
        RBus_UInt32  on2_ie_vs_per_overflow:1;
        RBus_UInt32  on2_ie_hs_per_overflow:1;
        RBus_UInt32  on2_ie_vs_pol_chg:1;
        RBus_UInt32  on2_ie_hs_pol_chg:1;
        RBus_UInt32  on2_ie_vtotalde_chg:1;
        RBus_UInt32  on2_ie_vtotal_chg:1;
        RBus_UInt32  on2_ie_hact_chg:1;
        RBus_UInt32  on2_ie_htotal_chg:1;
        RBus_UInt32  on2_ie_hs_active_pixel_var:1;
        RBus_UInt32  res3:3;
    };
}onms_onms2_interrupt_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_4k2k_mode:2;
        RBus_UInt32  on3_ms_src_sel:1;
        RBus_UInt32  on3_blk_2frame_en:1;
        RBus_UInt32  on3_pixel_get_en:1;
        RBus_UInt32  on3_pixel_get_sel:2;
        RBus_UInt32  on3_progressive:1;
        RBus_UInt32  on3_vtotal_max_delta:4;
        RBus_UInt32  on3_htotal_max_delta:4;
        RBus_UInt32  dummy18021400_15:1;
        RBus_UInt32  dummy18021400_14:1;
        RBus_UInt32  dummy18021400_13:1;
        RBus_UInt32  on3_pixel_encoding:1;
        RBus_UInt32  on3_vact_space_threshold:4;
        RBus_UInt32  on3_vact_space_meas_en:1;
        RBus_UInt32  on3_meas_to_sel:1;
        RBus_UInt32  on3_sycms_clk:1;
        RBus_UInt32  on3_vs_meas_inv:1;
        RBus_UInt32  on3_hs_meas_inv:1;
        RBus_UInt32  on3_popup_meas:1;
        RBus_UInt32  on3_ms_conti:1;
        RBus_UInt32  on3_start_ms:1;
    };
}onms_onms3_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  on3_pixel_ok:1;
        RBus_UInt32  on3_get_r_value:12;
        RBus_UInt32  on3_get_g_value:12;
    };
}onms_onms3_blank_pixel_value_get_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  on3_get_b_value:12;
    };
}onms_onms3_blank_pixel_value_get_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  on3_active_r_value:12;
        RBus_UInt32  on3_active_g_value:12;
    };
}onms_onms3_blank_pixel_value_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  on3_active_b_value:12;
    };
}onms_onms3_blank_pixel_value_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  on3_vact2:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  on3_vact1:11;
    };
}onms_onms3_fp_vact12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  on3_vact4:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  on3_vact3:11;
    };
}onms_onms3_fp_vact34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  on3_fp_vact_space1:10;
        RBus_UInt32  on3_fp_vact_space2:10;
        RBus_UInt32  on3_fp_vact_space3:10;
    };
}onms_onms3_fp_vact_space_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  on3_r_blank_line_start:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  on3_l_blank_line_end:11;
    };
}onms_onms3_blank_line_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  on3_vact_space1_end:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  on3_vact_space1_start:10;
    };
}onms_onms3_active_space1_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  on3_vact_space2_end:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  on3_vact_space2_start:10;
    };
}onms_onms3_active_space2_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  on3_vact_space3_end:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  on3_vact_space3_start:10;
    };
}onms_onms3_active_space3_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on3_vtotalde:13;
        RBus_UInt32  res2:2;
        RBus_UInt32  on3_vtotal:14;
    };
}onms_onms3_vs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  on3_vs_high_period:12;
        RBus_UInt32  res2:2;
        RBus_UInt32  on3_hs_high_period:14;
    };
}onms_onms3_vshs_high_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  on3_htotal_h12b:14;
        RBus_UInt32  on3_htotal_f4b:4;
    };
}onms_onms3_hs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  on3_vblank_len:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  on3_vact_start:12;
    };
}onms_onms3_vact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  on3_hact_start:14;
    };
}onms_onms3_hact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  on3_hact:14;
        RBus_UInt32  on3_hact_fract:4;
    };
}onms_onms3_hact_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  on3_htotal_max_delta_new:7;
        RBus_UInt32  res2:4;
        RBus_UInt32  on3_average_line:4;
        RBus_UInt32  res3:2;
        RBus_UInt32  on3_target_measure:14;
    };
}onms_onms3_hsync_meas_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  on3_vmeas_end:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  on3_vmeas_start:12;
    };
}onms_onms3_hsync_meas_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  on3_hmax_delta_total:14;
    };
}onms_onms3_hsync_meas_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  on3_hs_meas_over_range:1;
        RBus_UInt32  on3_vs_per_to_long:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  on3_vs_pol_out:1;
        RBus_UInt32  on3_hs_pol_out:1;
        RBus_UInt32  on3_vs_per_over_range:1;
        RBus_UInt32  on3_hs_per_over_range:1;
        RBus_UInt32  on3_vs_per_timeout:1;
        RBus_UInt32  on3_vs_high_timeout:1;
        RBus_UInt32  on3_vs_per_overflow:1;
        RBus_UInt32  on3_hs_per_overflow:1;
        RBus_UInt32  on3_vs_pol_chg:1;
        RBus_UInt32  on3_hs_pol_chg:1;
        RBus_UInt32  on3_vtotalde_chg:1;
        RBus_UInt32  on3_vtotal_chg:1;
        RBus_UInt32  on3_hact_chg:1;
        RBus_UInt32  on3_htotal_chg:1;
        RBus_UInt32  on3_hs_active_pixel_var:1;
        RBus_UInt32  res3:3;
    };
}onms_onms3_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_wd_to_main:1;
        RBus_UInt32  on3_wd_to_sub:1;
        RBus_UInt32  res1:8;
        RBus_UInt32  on3_wd_hs_meas_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on3_wd_vs_per_over_range:1;
        RBus_UInt32  on3_wd_hs_per_over_range:1;
        RBus_UInt32  on3_wd_vs_per_timeout:1;
        RBus_UInt32  on3_wd_vs_high_timeout:1;
        RBus_UInt32  on3_wd_vs_per_overflow:1;
        RBus_UInt32  on3_wd_hs_per_overflow:1;
        RBus_UInt32  on3_wd_vs_pol_chg:1;
        RBus_UInt32  on3_wd_hs_pol_chg:1;
        RBus_UInt32  on3_wd_vtotalde_chg:1;
        RBus_UInt32  on3_wd_vtotal_chg:1;
        RBus_UInt32  on3_wd_hact_chg:1;
        RBus_UInt32  on3_wd_htotal_chg:1;
        RBus_UInt32  on3_wd_hs_active_pixel_var:1;
        RBus_UInt32  res3:3;
    };
}onms_onms3_watchdog_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_ie_to_main:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  on3_ie_hs_meas_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on3_ie_vs_per_over_range:1;
        RBus_UInt32  on3_ie_hs_per_over_range:1;
        RBus_UInt32  on3_ie_vs_per_timeout:1;
        RBus_UInt32  on3_ie_vs_high_timeout:1;
        RBus_UInt32  on3_ie_vs_per_overflow:1;
        RBus_UInt32  on3_ie_hs_per_overflow:1;
        RBus_UInt32  on3_ie_vs_pol_chg:1;
        RBus_UInt32  on3_ie_hs_pol_chg:1;
        RBus_UInt32  on3_ie_vtotalde_chg:1;
        RBus_UInt32  on3_ie_vtotal_chg:1;
        RBus_UInt32  on3_ie_hact_chg:1;
        RBus_UInt32  on3_ie_htotal_chg:1;
        RBus_UInt32  on3_ie_hs_active_pixel_var:1;
        RBus_UInt32  res3:3;
    };
}onms_onms3_interrupt_en_RBUS;

#else //apply LITTLE_ENDIAN

//======ONMS register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_start_ms:1;
        RBus_UInt32  on1_ms_conti:1;
        RBus_UInt32  on1_popup_meas:1;
        RBus_UInt32  on1_hs_meas_inv:1;
        RBus_UInt32  on1_vs_meas_inv:1;
        RBus_UInt32  on1_sycms_clk:1;
        RBus_UInt32  on1_meas_to_sel:1;
        RBus_UInt32  on1_vact_space_meas_en:1;
        RBus_UInt32  on1_vact_space_threshold:4;
        RBus_UInt32  on1_pixel_encoding:1;
        RBus_UInt32  dummy18021200_13:1;
        RBus_UInt32  dummy18021200_14:1;
        RBus_UInt32  dummy18021200_15:1;
        RBus_UInt32  on1_htotal_max_delta:4;
        RBus_UInt32  on1_vtotal_max_delta:4;
        RBus_UInt32  on1_progressive:1;
        RBus_UInt32  on1_pixel_get_sel:2;
        RBus_UInt32  on1_pixel_get_en:1;
        RBus_UInt32  on1_blk_2frame_en:1;
        RBus_UInt32  on1_ms_src_sel:1;
        RBus_UInt32  on1_4k2k_mode:2;
    };
}onms_onms1_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_get_g_value:12;
        RBus_UInt32  on1_get_r_value:12;
        RBus_UInt32  on1_pixel_ok:1;
        RBus_UInt32  res1:7;
    };
}onms_onms1_blank_pixel_value_get_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_get_b_value:12;
        RBus_UInt32  res1:20;
    };
}onms_onms1_blank_pixel_value_get_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_active_g_value:12;
        RBus_UInt32  on1_active_r_value:12;
        RBus_UInt32  res1:8;
    };
}onms_onms1_blank_pixel_value_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_active_b_value:12;
        RBus_UInt32  res1:20;
    };
}onms_onms1_blank_pixel_value_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_vact1:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  on1_vact2:11;
        RBus_UInt32  res2:5;
    };
}onms_onms1_fp_vact12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_vact3:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  on1_vact4:11;
        RBus_UInt32  res2:5;
    };
}onms_onms1_fp_vact34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_fp_vact_space3:10;
        RBus_UInt32  on1_fp_vact_space2:10;
        RBus_UInt32  on1_fp_vact_space1:10;
        RBus_UInt32  res1:2;
    };
}onms_onms1_fp_vact_space_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_l_blank_line_end:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  on1_r_blank_line_start:11;
        RBus_UInt32  res2:5;
    };
}onms_onms1_blank_line_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_vact_space1_start:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  on1_vact_space1_end:10;
        RBus_UInt32  res2:6;
    };
}onms_onms1_active_space1_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_vact_space2_start:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  on1_vact_space2_end:10;
        RBus_UInt32  res2:6;
    };
}onms_onms1_active_space2_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_vact_space3_start:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  on1_vact_space3_end:10;
        RBus_UInt32  res2:6;
    };
}onms_onms1_active_space3_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_vtotal:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  on1_vtotalde:13;
        RBus_UInt32  res2:3;
    };
}onms_onms1_vs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_hs_high_period:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  on1_vs_high_period:12;
        RBus_UInt32  res2:4;
    };
}onms_onms1_vshs_high_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_htotal_f4b:4;
        RBus_UInt32  on1_htotal_h12b:14;
        RBus_UInt32  res1:14;
    };
}onms_onms1_hs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_vact_start:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  on1_vblank_len:8;
        RBus_UInt32  res2:8;
    };
}onms_onms1_vact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_hact_start:14;
        RBus_UInt32  res1:18;
    };
}onms_onms1_hact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_hact_fract:4;
        RBus_UInt32  on1_hact:14;
        RBus_UInt32  res1:14;
    };
}onms_onms1_hact_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_ltotal:24;
        RBus_UInt32  res1:8;
    };
}onms_onms1_l_flag_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_l_flag_high_period:24;
        RBus_UInt32  res1:8;
    };
}onms_onms1_l_flag_high_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_ftotal:24;
        RBus_UInt32  res1:8;
    };
}onms_onms1_field_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_field_high_period:24;
        RBus_UInt32  res1:8;
    };
}onms_onms1_field_high_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_ftotal_chg:1;
        RBus_UInt32  on1_ltotal_chg:1;
        RBus_UInt32  res1:30;
    };
}onms_onms1_status_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_target_measure:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  on1_average_line:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  on1_htotal_max_delta_new:7;
        RBus_UInt32  res3:1;
    };
}onms_onms1_hsync_meas_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_vmeas_start:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  on1_vmeas_end:12;
        RBus_UInt32  res2:4;
    };
}onms_onms1_hsync_meas_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on1_hmax_delta_total:14;
        RBus_UInt32  res1:18;
    };
}onms_onms1_hsync_meas_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on1_hs_active_pixel_var:1;
        RBus_UInt32  on1_htotal_chg:1;
        RBus_UInt32  on1_hact_chg:1;
        RBus_UInt32  on1_vtotal_chg:1;
        RBus_UInt32  on1_vtotalde_chg:1;
        RBus_UInt32  on1_hs_pol_chg:1;
        RBus_UInt32  on1_vs_pol_chg:1;
        RBus_UInt32  on1_hs_per_overflow:1;
        RBus_UInt32  on1_vs_per_overflow:1;
        RBus_UInt32  on1_vs_high_timeout:1;
        RBus_UInt32  on1_vs_per_timeout:1;
        RBus_UInt32  on1_hs_per_over_range:1;
        RBus_UInt32  on1_vs_per_over_range:1;
        RBus_UInt32  on1_hs_pol_out:1;
        RBus_UInt32  on1_vs_pol_out:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  on1_vs_per_to_long:1;
        RBus_UInt32  on1_hs_meas_over_range:1;
        RBus_UInt32  res3:10;
    };
}onms_onms1_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on1_wd_hs_active_pixel_var:1;
        RBus_UInt32  on1_wd_htotal_chg:1;
        RBus_UInt32  on1_wd_hact_chg:1;
        RBus_UInt32  on1_wd_vtotal_chg:1;
        RBus_UInt32  on1_wd_vtotalde_chg:1;
        RBus_UInt32  on1_wd_hs_pol_chg:1;
        RBus_UInt32  on1_wd_vs_pol_chg:1;
        RBus_UInt32  on1_wd_hs_per_overflow:1;
        RBus_UInt32  on1_wd_vs_per_overflow:1;
        RBus_UInt32  on1_wd_vs_high_timeout:1;
        RBus_UInt32  on1_wd_vs_per_timeout:1;
        RBus_UInt32  on1_wd_hs_per_over_range:1;
        RBus_UInt32  on1_wd_vs_per_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on1_wd_hs_meas_over_range:1;
        RBus_UInt32  res3:8;
        RBus_UInt32  on1_wd_to_sub:1;
        RBus_UInt32  on1_wd_to_main:1;
    };
}onms_onms1_watchdog_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on1_ie_hs_active_pixel_var:1;
        RBus_UInt32  on1_ie_htotal_chg:1;
        RBus_UInt32  on1_ie_hact_chg:1;
        RBus_UInt32  on1_ie_vtotal_chg:1;
        RBus_UInt32  on1_ie_vtotalde_chg:1;
        RBus_UInt32  on1_ie_hs_pol_chg:1;
        RBus_UInt32  on1_ie_vs_pol_chg:1;
        RBus_UInt32  on1_ie_hs_per_overflow:1;
        RBus_UInt32  on1_ie_vs_per_overflow:1;
        RBus_UInt32  on1_ie_vs_high_timeout:1;
        RBus_UInt32  on1_ie_vs_per_timeout:1;
        RBus_UInt32  on1_ie_hs_per_over_range:1;
        RBus_UInt32  on1_ie_vs_per_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on1_ie_hs_meas_over_range:1;
        RBus_UInt32  res3:9;
        RBus_UInt32  on1_ie_to_main:1;
    };
}onms_onms1_interrupt_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_start_ms:1;
        RBus_UInt32  on2_ms_conti:1;
        RBus_UInt32  on2_popup_meas:1;
        RBus_UInt32  on2_hs_meas_inv:1;
        RBus_UInt32  on2_vs_meas_inv:1;
        RBus_UInt32  on2_sycms_clk:1;
        RBus_UInt32  on2_meas_to_sel:1;
        RBus_UInt32  on2_vact_space_meas_en:1;
        RBus_UInt32  on2_vact_space_threshold:4;
        RBus_UInt32  on2_pixel_encoding:1;
        RBus_UInt32  dummy18021300_13:1;
        RBus_UInt32  dummy18021300_14:1;
        RBus_UInt32  dummy18021300_15:1;
        RBus_UInt32  on2_htotal_max_delta:4;
        RBus_UInt32  on2_vtotal_max_delta:4;
        RBus_UInt32  on2_progressive:1;
        RBus_UInt32  on2_pixel_get_sel:2;
        RBus_UInt32  on2_pixel_get_en:1;
        RBus_UInt32  on2_blk_2frame_en:1;
        RBus_UInt32  on2_ms_src_sel:1;
        RBus_UInt32  on2_4k2k_mode:2;
    };
}onms_onms2_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_get_g_value:12;
        RBus_UInt32  on2_get_r_value:12;
        RBus_UInt32  on2_pixel_ok:1;
        RBus_UInt32  res1:7;
    };
}onms_onms2_blank_pixel_value_get_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_get_b_value:12;
        RBus_UInt32  res1:20;
    };
}onms_onms2_blank_pixel_value_get_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_active_g_value:12;
        RBus_UInt32  on2_active_r_value:12;
        RBus_UInt32  res1:8;
    };
}onms_onms2_blank_pixel_value_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_active_b_value:12;
        RBus_UInt32  res1:20;
    };
}onms_onms2_blank_pixel_value_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_vact1:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  on2_vact2:11;
        RBus_UInt32  res2:5;
    };
}onms_onms2_fp_vact12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_vact3:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  on2_vact4:11;
        RBus_UInt32  res2:5;
    };
}onms_onms2_fp_vact34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_fp_vact_space3:10;
        RBus_UInt32  on2_fp_vact_space2:10;
        RBus_UInt32  on2_fp_vact_space1:10;
        RBus_UInt32  res1:2;
    };
}onms_onms2_fp_vact_space_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_l_blank_line_end:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  on2_r_blank_line_start:11;
        RBus_UInt32  res2:5;
    };
}onms_onms2_blank_line_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_vact_space1_start:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  on2_vact_space1_end:10;
        RBus_UInt32  res2:6;
    };
}onms_onms2_active_space1_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_vact_space2_start:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  on2_vact_space2_end:10;
        RBus_UInt32  res2:6;
    };
}onms_onms2_active_space2_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_vact_space3_start:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  on2_vact_space3_end:10;
        RBus_UInt32  res2:6;
    };
}onms_onms2_active_space3_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_vtotal:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  on2_vtotalde:13;
        RBus_UInt32  res2:3;
    };
}onms_onms2_vs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_hs_high_period:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  on2_vs_high_period:12;
        RBus_UInt32  res2:4;
    };
}onms_onms2_vshs_high_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_htotal_f4b:4;
        RBus_UInt32  on2_htotal_h12b:14;
        RBus_UInt32  res1:14;
    };
}onms_onms2_hs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_vact_start:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  on2_vblank_len:8;
        RBus_UInt32  res2:8;
    };
}onms_onms2_vact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_hact_start:14;
        RBus_UInt32  res1:18;
    };
}onms_onms2_hact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_hact_fract:4;
        RBus_UInt32  on2_hact:14;
        RBus_UInt32  res1:14;
    };
}onms_onms2_hact_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_target_measure:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  on2_average_line:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  on2_htotal_max_delta_new:7;
        RBus_UInt32  res3:1;
    };
}onms_onms2_hsync_meas_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_vmeas_start:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  on2_vmeas_end:12;
        RBus_UInt32  res2:4;
    };
}onms_onms2_hsync_meas_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on2_hmax_delta_total:14;
        RBus_UInt32  res1:18;
    };
}onms_onms2_hsync_meas_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on2_hs_active_pixel_var:1;
        RBus_UInt32  on2_htotal_chg:1;
        RBus_UInt32  on2_hact_chg:1;
        RBus_UInt32  on2_vtotal_chg:1;
        RBus_UInt32  on2_vtotalde_chg:1;
        RBus_UInt32  on2_hs_pol_chg:1;
        RBus_UInt32  on2_vs_pol_chg:1;
        RBus_UInt32  on2_hs_per_overflow:1;
        RBus_UInt32  on2_vs_per_overflow:1;
        RBus_UInt32  on2_vs_high_timeout:1;
        RBus_UInt32  on2_vs_per_timeout:1;
        RBus_UInt32  on2_hs_per_over_range:1;
        RBus_UInt32  on2_vs_per_over_range:1;
        RBus_UInt32  on2_hs_pol_out:1;
        RBus_UInt32  on2_vs_pol_out:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  on2_vs_per_to_long:1;
        RBus_UInt32  on2_hs_meas_over_range:1;
        RBus_UInt32  res3:10;
    };
}onms_onms2_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on2_wd_hs_active_pixel_var:1;
        RBus_UInt32  on2_wd_htotal_chg:1;
        RBus_UInt32  on2_wd_hact_chg:1;
        RBus_UInt32  on2_wd_vtotal_chg:1;
        RBus_UInt32  on2_wd_vtotalde_chg:1;
        RBus_UInt32  on2_wd_hs_pol_chg:1;
        RBus_UInt32  on2_wd_vs_pol_chg:1;
        RBus_UInt32  on2_wd_hs_per_overflow:1;
        RBus_UInt32  on2_wd_vs_per_overflow:1;
        RBus_UInt32  on2_wd_vs_high_timeout:1;
        RBus_UInt32  on2_wd_vs_per_timeout:1;
        RBus_UInt32  on2_wd_hs_per_over_range:1;
        RBus_UInt32  on2_wd_vs_per_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on2_wd_hs_meas_over_range:1;
        RBus_UInt32  res3:8;
        RBus_UInt32  on2_wd_to_sub:1;
        RBus_UInt32  on2_wd_to_main:1;
    };
}onms_onms2_watchdog_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on2_ie_hs_active_pixel_var:1;
        RBus_UInt32  on2_ie_htotal_chg:1;
        RBus_UInt32  on2_ie_hact_chg:1;
        RBus_UInt32  on2_ie_vtotal_chg:1;
        RBus_UInt32  on2_ie_vtotalde_chg:1;
        RBus_UInt32  on2_ie_hs_pol_chg:1;
        RBus_UInt32  on2_ie_vs_pol_chg:1;
        RBus_UInt32  on2_ie_hs_per_overflow:1;
        RBus_UInt32  on2_ie_vs_per_overflow:1;
        RBus_UInt32  on2_ie_vs_high_timeout:1;
        RBus_UInt32  on2_ie_vs_per_timeout:1;
        RBus_UInt32  on2_ie_hs_per_over_range:1;
        RBus_UInt32  on2_ie_vs_per_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on2_ie_hs_meas_over_range:1;
        RBus_UInt32  res3:9;
        RBus_UInt32  on2_ie_to_main:1;
    };
}onms_onms2_interrupt_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_start_ms:1;
        RBus_UInt32  on3_ms_conti:1;
        RBus_UInt32  on3_popup_meas:1;
        RBus_UInt32  on3_hs_meas_inv:1;
        RBus_UInt32  on3_vs_meas_inv:1;
        RBus_UInt32  on3_sycms_clk:1;
        RBus_UInt32  on3_meas_to_sel:1;
        RBus_UInt32  on3_vact_space_meas_en:1;
        RBus_UInt32  on3_vact_space_threshold:4;
        RBus_UInt32  on3_pixel_encoding:1;
        RBus_UInt32  dummy18021400_13:1;
        RBus_UInt32  dummy18021400_14:1;
        RBus_UInt32  dummy18021400_15:1;
        RBus_UInt32  on3_htotal_max_delta:4;
        RBus_UInt32  on3_vtotal_max_delta:4;
        RBus_UInt32  on3_progressive:1;
        RBus_UInt32  on3_pixel_get_sel:2;
        RBus_UInt32  on3_pixel_get_en:1;
        RBus_UInt32  on3_blk_2frame_en:1;
        RBus_UInt32  on3_ms_src_sel:1;
        RBus_UInt32  on3_4k2k_mode:2;
    };
}onms_onms3_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_get_g_value:12;
        RBus_UInt32  on3_get_r_value:12;
        RBus_UInt32  on3_pixel_ok:1;
        RBus_UInt32  res1:7;
    };
}onms_onms3_blank_pixel_value_get_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_get_b_value:12;
        RBus_UInt32  res1:20;
    };
}onms_onms3_blank_pixel_value_get_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_active_g_value:12;
        RBus_UInt32  on3_active_r_value:12;
        RBus_UInt32  res1:8;
    };
}onms_onms3_blank_pixel_value_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_active_b_value:12;
        RBus_UInt32  res1:20;
    };
}onms_onms3_blank_pixel_value_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_vact1:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  on3_vact2:11;
        RBus_UInt32  res2:5;
    };
}onms_onms3_fp_vact12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_vact3:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  on3_vact4:11;
        RBus_UInt32  res2:5;
    };
}onms_onms3_fp_vact34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_fp_vact_space3:10;
        RBus_UInt32  on3_fp_vact_space2:10;
        RBus_UInt32  on3_fp_vact_space1:10;
        RBus_UInt32  res1:2;
    };
}onms_onms3_fp_vact_space_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_l_blank_line_end:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  on3_r_blank_line_start:11;
        RBus_UInt32  res2:5;
    };
}onms_onms3_blank_line_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_vact_space1_start:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  on3_vact_space1_end:10;
        RBus_UInt32  res2:6;
    };
}onms_onms3_active_space1_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_vact_space2_start:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  on3_vact_space2_end:10;
        RBus_UInt32  res2:6;
    };
}onms_onms3_active_space2_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_vact_space3_start:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  on3_vact_space3_end:10;
        RBus_UInt32  res2:6;
    };
}onms_onms3_active_space3_line_number_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_vtotal:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  on3_vtotalde:13;
        RBus_UInt32  res2:3;
    };
}onms_onms3_vs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_hs_high_period:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  on3_vs_high_period:12;
        RBus_UInt32  res2:4;
    };
}onms_onms3_vshs_high_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_htotal_f4b:4;
        RBus_UInt32  on3_htotal_h12b:14;
        RBus_UInt32  res1:14;
    };
}onms_onms3_hs_period_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_vact_start:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  on3_vblank_len:8;
        RBus_UInt32  res2:8;
    };
}onms_onms3_vact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_hact_start:14;
        RBus_UInt32  res1:18;
    };
}onms_onms3_hact_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_hact_fract:4;
        RBus_UInt32  on3_hact:14;
        RBus_UInt32  res1:14;
    };
}onms_onms3_hact_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_target_measure:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  on3_average_line:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  on3_htotal_max_delta_new:7;
        RBus_UInt32  res3:1;
    };
}onms_onms3_hsync_meas_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_vmeas_start:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  on3_vmeas_end:12;
        RBus_UInt32  res2:4;
    };
}onms_onms3_hsync_meas_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  on3_hmax_delta_total:14;
        RBus_UInt32  res1:18;
    };
}onms_onms3_hsync_meas_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on3_hs_active_pixel_var:1;
        RBus_UInt32  on3_htotal_chg:1;
        RBus_UInt32  on3_hact_chg:1;
        RBus_UInt32  on3_vtotal_chg:1;
        RBus_UInt32  on3_vtotalde_chg:1;
        RBus_UInt32  on3_hs_pol_chg:1;
        RBus_UInt32  on3_vs_pol_chg:1;
        RBus_UInt32  on3_hs_per_overflow:1;
        RBus_UInt32  on3_vs_per_overflow:1;
        RBus_UInt32  on3_vs_high_timeout:1;
        RBus_UInt32  on3_vs_per_timeout:1;
        RBus_UInt32  on3_hs_per_over_range:1;
        RBus_UInt32  on3_vs_per_over_range:1;
        RBus_UInt32  on3_hs_pol_out:1;
        RBus_UInt32  on3_vs_pol_out:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  on3_vs_per_to_long:1;
        RBus_UInt32  on3_hs_meas_over_range:1;
        RBus_UInt32  res3:10;
    };
}onms_onms3_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on3_wd_hs_active_pixel_var:1;
        RBus_UInt32  on3_wd_htotal_chg:1;
        RBus_UInt32  on3_wd_hact_chg:1;
        RBus_UInt32  on3_wd_vtotal_chg:1;
        RBus_UInt32  on3_wd_vtotalde_chg:1;
        RBus_UInt32  on3_wd_hs_pol_chg:1;
        RBus_UInt32  on3_wd_vs_pol_chg:1;
        RBus_UInt32  on3_wd_hs_per_overflow:1;
        RBus_UInt32  on3_wd_vs_per_overflow:1;
        RBus_UInt32  on3_wd_vs_high_timeout:1;
        RBus_UInt32  on3_wd_vs_per_timeout:1;
        RBus_UInt32  on3_wd_hs_per_over_range:1;
        RBus_UInt32  on3_wd_vs_per_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on3_wd_hs_meas_over_range:1;
        RBus_UInt32  res3:8;
        RBus_UInt32  on3_wd_to_sub:1;
        RBus_UInt32  on3_wd_to_main:1;
    };
}onms_onms3_watchdog_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  on3_ie_hs_active_pixel_var:1;
        RBus_UInt32  on3_ie_htotal_chg:1;
        RBus_UInt32  on3_ie_hact_chg:1;
        RBus_UInt32  on3_ie_vtotal_chg:1;
        RBus_UInt32  on3_ie_vtotalde_chg:1;
        RBus_UInt32  on3_ie_hs_pol_chg:1;
        RBus_UInt32  on3_ie_vs_pol_chg:1;
        RBus_UInt32  on3_ie_hs_per_overflow:1;
        RBus_UInt32  on3_ie_vs_per_overflow:1;
        RBus_UInt32  on3_ie_vs_high_timeout:1;
        RBus_UInt32  on3_ie_vs_per_timeout:1;
        RBus_UInt32  on3_ie_hs_per_over_range:1;
        RBus_UInt32  on3_ie_vs_per_over_range:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  on3_ie_hs_meas_over_range:1;
        RBus_UInt32  res3:9;
        RBus_UInt32  on3_ie_to_main:1;
    };
}onms_onms3_interrupt_en_RBUS;




#endif 


#endif 
