/**
* @file rbusSensioReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2016/6/3
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_SENSIO_REG_H_
#define _RBUS_SENSIO_REG_H_

#include "rbusTypes.h"



//  SENSIO Register Address



#define  SENSIO_SENSIO_CTRL_0_VADDR                         	(0xb806b900)
#define  SENSIO_SENSIO_CTRL_1_VADDR                         	(0xb806b904)
#define  SENSIO_SENSIO_CTRL_2_VADDR                         	(0xb806b908)
#define  SENSIO_SENSIO_CTRL_3_VADDR                         	(0xb806b90c)
#define  SENSIO_DECOMP_CTRL_0_VADDR                         	(0xb806b910)
#define  SENSIO_SUB_VP9_DECOMP_CTRL_0_VADDR                 	(0xb806b920)
#define  SENSIO_SUB_VP9_DECOMP_CTRL_1_VADDR                 	(0xb806b924)
#define  SENSIO_VP9_DECOMP_V_CTRL_VADDR                     	(0xb806b928)
#define  SENSIO_SUB_VP9_DECOMP_V_CTRL_VADDR                 	(0xb806b92c)
#define  SENSIO_SENSIO_TIM_CTRL_0_VADDR                     	(0xb806b930)
#define  SENSIO_SENSIO_TIM_CTRL_1_VADDR                     	(0xb806b934)
#define  SENSIO_SUB_SENSIO_TIM_CTRL_0_VADDR                 	(0xb806b938)
#define  SENSIO_SUB_SENSIO_TIM_CTRL_1_VADDR                 	(0xb806b93c)
#define  SENSIO_SENSIO_DET_CTRL_0_VADDR                     	(0xb806b940)
#define  SENSIO_SENSIO_DET_0_VADDR                          	(0xb806b948)
#define  SENSIO_SENSIO_RESULT_0_VADDR                       	(0xb806b94c)
#define  SENSIO_SENSIO_DET_1_VADDR                          	(0xb806b950)
#define  SENSIO_SENSIO_RESULT_1_VADDR                       	(0xb806b954)
#define  SENSIO_SENSIO_DET_2_VADDR                          	(0xb806b958)
#define  SENSIO_SENSIO_RESULT_2_VADDR                       	(0xb806b95c)
#define  SENSIO_SENSIO_DET_3_VADDR                          	(0xb806b960)
#define  SENSIO_SENSIO_RESULT_3_VADDR                       	(0xb806b964)
#define  SENSIO_SENSIO_DET_4_VADDR                          	(0xb806b968)
#define  SENSIO_SENSIO_RESULT_4_VADDR                       	(0xb806b96c)
#define  SENSIO_SENSIO_RESULT_5_VADDR                       	(0xb806b970)
#define  SENSIO_SENSIO_RESULT_6_VADDR                       	(0xb806b974)
#define  SENSIO_SENSIO_RESULT_7_VADDR                       	(0xb806b978)
#define  SENSIO_SENSIO_RESULT_8_VADDR                       	(0xb806b97c)
#define  SENSIO_SENSIO_SAD_VADDR                            	(0xb806b980)
#define  SENSIO_SENSIO_SAD_RESULT_VADDR                     	(0xb806b984)
#define  SENSIO_SENSIO_RESULT_9_VADDR                       	(0xb806b988)
#define  SENSIO_SENSIO_MBIST_FAIL_0_VADDR                   	(0xb806b990)
#define  SENSIO_SENSIO_MBIST_FAIL_1_VADDR                   	(0xb806b994)
#define  SENSIO_SENSIO_MBIST_FAIL_SUB_0_VADDR               	(0xb806b998)
#define  SENSIO_SENSIO_MBIST_FAIL_SUB_1_VADDR               	(0xb806b99c)
#define  SENSIO_SENSIO_MBIST_DRF_FAIL_0_VADDR               	(0xb806b9a0)
#define  SENSIO_SENSIO_MBIST_DRF_FAIL_1_VADDR               	(0xb806b9a4)
#define  SENSIO_SENSIO_MBIST_DRF_FAIL_SUB_0_VADDR           	(0xb806b9a8)
#define  SENSIO_SENSIO_MBIST_DRF_FAIL_SUB_1_VADDR           	(0xb806b9ac)
#define  SENSIO_SENSIO_MBIST_LS_0_VADDR                     	(0xb806b9b0)
#define  SENSIO_SENSIO_MBIST_LS_1_VADDR                     	(0xb806b9b4)
#define  SENSIO_SENSIO_MBIST_LS_SUB_0_VADDR                 	(0xb806b9b8)
#define  SENSIO_SENSIO_MBIST_LS_SUB_1_VADDR                 	(0xb806b9bc)
#define  SENSIO_SENSIO_MBIST_RM_0_VADDR                     	(0xb806b9c0)
#define  SENSIO_SENSIO_MBIST_RM_1_VADDR                     	(0xb806b9c4)
#define  SENSIO_SENSIO_MBIST_RM_2_VADDR                     	(0xb806b9c8)
#define  SENSIO_SENSIO_MBIST_RM_3_VADDR                     	(0xb806b9cc)
#define  SENSIO_SENSIO_MBIST_RM_4_VADDR                     	(0xb806b9d0)
#define  SENSIO_SENSIO_MBIST_RM_SUB_0_VADDR                 	(0xb806b9d4)
#define  SENSIO_SENSIO_MBIST_RM_SUB_1_VADDR                 	(0xb806b9d8)
#define  SENSIO_SENSIO_MBIST_RM_SUB_2_VADDR                 	(0xb806b9dc)
#define  SENSIO_SENSIO_MBIST_RM_SUB_3_VADDR                 	(0xb806b9e0)
#define  SENSIO_SENSIO_MBIST_RM_SUB_4_VADDR                 	(0xb806b9e4)
#define  SENSIO_SENSIO_MBIST_RME_0_VADDR                    	(0xb806b9f0)
#define  SENSIO_SENSIO_MBIST_RME_1_VADDR                    	(0xb806b9f4)
#define  SENSIO_SENSIO_MBIST_RME_SUB_0_VADDR                	(0xb806b9f8)
#define  SENSIO_SENSIO_MBIST_RME_SUB_1_VADDR                	(0xb806b9fc)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======SENSIO register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sensio_lflag_inv:1;
        RBus_UInt32  sensio_out_format:1;
        RBus_UInt32  re_decom_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  sensio_bndy_g:10;
        RBus_UInt32  sensio_bndy_r:10;
        RBus_UInt32  vflip_en:1;
        RBus_UInt32  force_ctsfifo_rstn_sensio:1;
        RBus_UInt32  en_ctsfifo_vsrst_sensio:1;
        RBus_UInt32  en_ctsfifo_bypass_sensio:1;
        RBus_UInt32  sensio_in_format:2;
        RBus_UInt32  sensio_input_mux:1;
        RBus_UInt32  sensio_en:1;
    };
}sensio_sensio_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  sensio_bndy_b:10;
    };
}sensio_sensio_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  sensio_ivsize:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  sensio_ihsize:12;
    };
}sensio_sensio_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  sensio_algo_type:2;
        RBus_UInt32  sensio_hdmi_vs_inv:1;
        RBus_UInt32  sensio_hdmi_hs_inv:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  sensio_inout_bit:1;
        RBus_UInt32  res3:5;
        RBus_UInt32  sensio_double_apply:1;
        RBus_UInt32  sensio_double_en:1;
        RBus_UInt32  sensio_read_sel:1;
        RBus_UInt32  res4:14;
        RBus_UInt32  sensio_sub_double_apply:1;
        RBus_UInt32  sensio_sub_double_en:1;
    };
}sensio_sensio_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  main_decomp_10bit:2;
    };
}sensio_decomp_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  sub_vflip_en:1;
        RBus_UInt32  sub_decomp_10bit:2;
        RBus_UInt32  sub_re_decom_en:1;
        RBus_UInt32  res2:1;
    };
}sensio_sub_vp9_decomp_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  sub_v_d_ivsize:11;
        RBus_UInt32  res2:4;
        RBus_UInt32  sub_v_d_ihsize:12;
    };
}sensio_sub_vp9_decomp_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  real_vp9_vend:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  real_vp9_vstart:12;
    };
}sensio_vp9_decomp_v_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  sub_real_vp9_vend:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  sub_real_vp9_vstart:11;
    };
}sensio_sub_vp9_decomp_v_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  hs_width:6;
        RBus_UInt32  res2:3;
        RBus_UInt32  h_total:13;
    };
}sensio_sensio_tim_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  v_den_st:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  h_den_st:12;
    };
}sensio_sensio_tim_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  sub_hs_width:6;
        RBus_UInt32  res2:3;
        RBus_UInt32  sub_h_total:13;
    };
}sensio_sub_sensio_tim_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  sub_v_den_st:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  sub_h_den_st:12;
    };
}sensio_sub_sensio_tim_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  detect_result_ready:1;
        RBus_UInt32  detect_mode:1;
        RBus_UInt32  detect_en:1;
    };
}sensio_sensio_det_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  th_edge_hlh:5;
        RBus_UInt32  res2:9;
        RBus_UInt32  th_hlh:7;
    };
}sensio_sensio_det_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_3hlh:20;
    };
}sensio_sensio_result_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  rate_flat:3;
        RBus_UInt32  res2:11;
        RBus_UInt32  th_flat:5;
    };
}sensio_sensio_det_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_3chlh:20;
    };
}sensio_sensio_result_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  th_edge_l5:5;
        RBus_UInt32  res2:1;
        RBus_UInt32  th_hlh_l5:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  rate_min_diff:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  th_min_diff:7;
    };
}sensio_sensio_det_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_5hlh:20;
    };
}sensio_sensio_result_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  th_edge_r:5;
        RBus_UInt32  res2:1;
        RBus_UInt32  th_hlh_r:7;
    };
}sensio_sensio_det_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_2d2hlh:20;
    };
}sensio_sensio_result_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  th_edge_l:5;
        RBus_UInt32  res2:1;
        RBus_UInt32  th_hlh_l:7;
    };
}sensio_sensio_det_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_2d3hlh:20;
    };
}sensio_sensio_result_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_2d2chlh:20;
    };
}sensio_sensio_result_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_d2rhlh:20;
    };
}sensio_sensio_result_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_d3chlh:20;
    };
}sensio_sensio_result_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_d3rhlh:20;
    };
}sensio_sensio_result_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  th_sad:5;
    };
}sensio_sensio_sad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_sad:20;
    };
}sensio_sensio_sad_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  count_vstrip:20;
    };
}sensio_sensio_result_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  bist_fail_1_9:1;
        RBus_UInt32  bist_fail_1_8:1;
        RBus_UInt32  bist_fail_1_7:1;
        RBus_UInt32  bist_fail_1_6:1;
        RBus_UInt32  bist_fail_1_5:1;
        RBus_UInt32  bist_fail_1_4:1;
        RBus_UInt32  bist_fail_1_3:1;
        RBus_UInt32  bist_fail_1_2:1;
        RBus_UInt32  bist_fail_1_1:1;
        RBus_UInt32  bist_fail_1_0:1;
        RBus_UInt32  bist_fail_0_9:1;
        RBus_UInt32  bist_fail_0_8:1;
        RBus_UInt32  bist_fail_0_7:1;
        RBus_UInt32  bist_fail_0_6:1;
        RBus_UInt32  bist_fail_0_5:1;
        RBus_UInt32  bist_fail_0_4:1;
        RBus_UInt32  bist_fail_0_3:1;
        RBus_UInt32  bist_fail_0_2:1;
        RBus_UInt32  bist_fail_0_1:1;
        RBus_UInt32  bist_fail_0_0:1;
    };
}sensio_sensio_mbist_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  bist_fail_3_9:1;
        RBus_UInt32  bist_fail_3_8:1;
        RBus_UInt32  bist_fail_3_7:1;
        RBus_UInt32  bist_fail_3_6:1;
        RBus_UInt32  bist_fail_3_5:1;
        RBus_UInt32  bist_fail_3_4:1;
        RBus_UInt32  bist_fail_3_3:1;
        RBus_UInt32  bist_fail_3_2:1;
        RBus_UInt32  bist_fail_3_1:1;
        RBus_UInt32  bist_fail_3_0:1;
        RBus_UInt32  bist_fail_2_9:1;
        RBus_UInt32  bist_fail_2_8:1;
        RBus_UInt32  bist_fail_2_7:1;
        RBus_UInt32  bist_fail_2_6:1;
        RBus_UInt32  bist_fail_2_5:1;
        RBus_UInt32  bist_fail_2_4:1;
        RBus_UInt32  bist_fail_2_3:1;
        RBus_UInt32  bist_fail_2_2:1;
        RBus_UInt32  bist_fail_2_1:1;
        RBus_UInt32  bist_fail_2_0:1;
    };
}sensio_sensio_mbist_fail_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  bist_fail_sub_1_9:1;
        RBus_UInt32  bist_fail_sub_1_8:1;
        RBus_UInt32  bist_fail_sub_1_7:1;
        RBus_UInt32  bist_fail_sub_1_6:1;
        RBus_UInt32  bist_fail_sub_1_5:1;
        RBus_UInt32  bist_fail_sub_1_4:1;
        RBus_UInt32  bist_fail_sub_1_3:1;
        RBus_UInt32  bist_fail_sub_1_2:1;
        RBus_UInt32  bist_fail_sub_1_1:1;
        RBus_UInt32  bist_fail_sub_1_0:1;
        RBus_UInt32  bist_fail_sub_0_9:1;
        RBus_UInt32  bist_fail_sub_0_8:1;
        RBus_UInt32  bist_fail_sub_0_7:1;
        RBus_UInt32  bist_fail_sub_0_6:1;
        RBus_UInt32  bist_fail_sub_0_5:1;
        RBus_UInt32  bist_fail_sub_0_4:1;
        RBus_UInt32  bist_fail_sub_0_3:1;
        RBus_UInt32  bist_fail_sub_0_2:1;
        RBus_UInt32  bist_fail_sub_0_1:1;
        RBus_UInt32  bist_fail_sub_0_0:1;
    };
}sensio_sensio_mbist_fail_sub_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  bist_fail_sub_3_9:1;
        RBus_UInt32  bist_fail_sub_3_8:1;
        RBus_UInt32  bist_fail_sub_3_7:1;
        RBus_UInt32  bist_fail_sub_3_6:1;
        RBus_UInt32  bist_fail_sub_3_5:1;
        RBus_UInt32  bist_fail_sub_3_4:1;
        RBus_UInt32  bist_fail_sub_3_3:1;
        RBus_UInt32  bist_fail_sub_3_2:1;
        RBus_UInt32  bist_fail_sub_3_1:1;
        RBus_UInt32  bist_fail_sub_3_0:1;
        RBus_UInt32  bist_fail_sub_2_9:1;
        RBus_UInt32  bist_fail_sub_2_8:1;
        RBus_UInt32  bist_fail_sub_2_7:1;
        RBus_UInt32  bist_fail_sub_2_6:1;
        RBus_UInt32  bist_fail_sub_2_5:1;
        RBus_UInt32  bist_fail_sub_2_4:1;
        RBus_UInt32  bist_fail_sub_2_3:1;
        RBus_UInt32  bist_fail_sub_2_2:1;
        RBus_UInt32  bist_fail_sub_2_1:1;
        RBus_UInt32  bist_fail_sub_2_0:1;
    };
}sensio_sensio_mbist_fail_sub_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  drf_bist_fail_1_9:1;
        RBus_UInt32  drf_bist_fail_1_8:1;
        RBus_UInt32  drf_bist_fail_1_7:1;
        RBus_UInt32  drf_bist_fail_1_6:1;
        RBus_UInt32  drf_bist_fail_1_5:1;
        RBus_UInt32  drf_bist_fail_1_4:1;
        RBus_UInt32  drf_bist_fail_1_3:1;
        RBus_UInt32  drf_bist_fail_1_2:1;
        RBus_UInt32  drf_bist_fail_1_1:1;
        RBus_UInt32  drf_bist_fail_1_0:1;
        RBus_UInt32  drf_bist_fail_0_9:1;
        RBus_UInt32  drf_bist_fail_0_8:1;
        RBus_UInt32  drf_bist_fail_0_7:1;
        RBus_UInt32  drf_bist_fail_0_6:1;
        RBus_UInt32  drf_bist_fail_0_5:1;
        RBus_UInt32  drf_bist_fail_0_4:1;
        RBus_UInt32  drf_bist_fail_0_3:1;
        RBus_UInt32  drf_bist_fail_0_2:1;
        RBus_UInt32  drf_bist_fail_0_1:1;
        RBus_UInt32  drf_bist_fail_0_0:1;
    };
}sensio_sensio_mbist_drf_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  drf_bist_fail_3_9:1;
        RBus_UInt32  drf_bist_fail_3_8:1;
        RBus_UInt32  drf_bist_fail_3_7:1;
        RBus_UInt32  drf_bist_fail_3_6:1;
        RBus_UInt32  drf_bist_fail_3_5:1;
        RBus_UInt32  drf_bist_fail_3_4:1;
        RBus_UInt32  drf_bist_fail_3_3:1;
        RBus_UInt32  drf_bist_fail_3_2:1;
        RBus_UInt32  drf_bist_fail_3_1:1;
        RBus_UInt32  drf_bist_fail_3_0:1;
        RBus_UInt32  drf_bist_fail_2_9:1;
        RBus_UInt32  drf_bist_fail_2_8:1;
        RBus_UInt32  drf_bist_fail_2_7:1;
        RBus_UInt32  drf_bist_fail_2_6:1;
        RBus_UInt32  drf_bist_fail_2_5:1;
        RBus_UInt32  drf_bist_fail_2_4:1;
        RBus_UInt32  drf_bist_fail_2_3:1;
        RBus_UInt32  drf_bist_fail_2_2:1;
        RBus_UInt32  drf_bist_fail_2_1:1;
        RBus_UInt32  drf_bist_fail_2_0:1;
    };
}sensio_sensio_mbist_drf_fail_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  drf_bist_fail_sub_1_9:1;
        RBus_UInt32  drf_bist_fail_sub_1_8:1;
        RBus_UInt32  drf_bist_fail_sub_1_7:1;
        RBus_UInt32  drf_bist_fail_sub_1_6:1;
        RBus_UInt32  drf_bist_fail_sub_1_5:1;
        RBus_UInt32  drf_bist_fail_sub_1_4:1;
        RBus_UInt32  drf_bist_fail_sub_1_3:1;
        RBus_UInt32  drf_bist_fail_sub_1_2:1;
        RBus_UInt32  drf_bist_fail_sub_1_1:1;
        RBus_UInt32  drf_bist_fail_sub_1_0:1;
        RBus_UInt32  drf_bist_fail_sub_0_9:1;
        RBus_UInt32  drf_bist_fail_sub_0_8:1;
        RBus_UInt32  drf_bist_fail_sub_0_7:1;
        RBus_UInt32  drf_bist_fail_sub_0_6:1;
        RBus_UInt32  drf_bist_fail_sub_0_5:1;
        RBus_UInt32  drf_bist_fail_sub_0_4:1;
        RBus_UInt32  drf_bist_fail_sub_0_3:1;
        RBus_UInt32  drf_bist_fail_sub_0_2:1;
        RBus_UInt32  drf_bist_fail_sub_0_1:1;
        RBus_UInt32  drf_bist_fail_sub_0_0:1;
    };
}sensio_sensio_mbist_drf_fail_sub_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  drf_bist_fail_sub_3_9:1;
        RBus_UInt32  drf_bist_fail_sub_3_8:1;
        RBus_UInt32  drf_bist_fail_sub_3_7:1;
        RBus_UInt32  drf_bist_fail_sub_3_6:1;
        RBus_UInt32  drf_bist_fail_sub_3_5:1;
        RBus_UInt32  drf_bist_fail_sub_3_4:1;
        RBus_UInt32  drf_bist_fail_sub_3_3:1;
        RBus_UInt32  drf_bist_fail_sub_3_2:1;
        RBus_UInt32  drf_bist_fail_sub_3_1:1;
        RBus_UInt32  drf_bist_fail_sub_3_0:1;
        RBus_UInt32  drf_bist_fail_sub_2_9:1;
        RBus_UInt32  drf_bist_fail_sub_2_8:1;
        RBus_UInt32  drf_bist_fail_sub_2_7:1;
        RBus_UInt32  drf_bist_fail_sub_2_6:1;
        RBus_UInt32  drf_bist_fail_sub_2_5:1;
        RBus_UInt32  drf_bist_fail_sub_2_4:1;
        RBus_UInt32  drf_bist_fail_sub_2_3:1;
        RBus_UInt32  drf_bist_fail_sub_2_2:1;
        RBus_UInt32  drf_bist_fail_sub_2_1:1;
        RBus_UInt32  drf_bist_fail_sub_2_0:1;
    };
}sensio_sensio_mbist_drf_fail_sub_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  ls_1_9:1;
        RBus_UInt32  ls_1_8:1;
        RBus_UInt32  ls_1_7:1;
        RBus_UInt32  ls_1_6:1;
        RBus_UInt32  ls_1_5:1;
        RBus_UInt32  ls_1_4:1;
        RBus_UInt32  ls_1_3:1;
        RBus_UInt32  ls_1_2:1;
        RBus_UInt32  ls_1_1:1;
        RBus_UInt32  ls_1_0:1;
        RBus_UInt32  ls_0_9:1;
        RBus_UInt32  ls_0_8:1;
        RBus_UInt32  ls_0_7:1;
        RBus_UInt32  ls_0_6:1;
        RBus_UInt32  ls_0_5:1;
        RBus_UInt32  ls_0_4:1;
        RBus_UInt32  ls_0_3:1;
        RBus_UInt32  ls_0_2:1;
        RBus_UInt32  ls_0_1:1;
        RBus_UInt32  ls_0_0:1;
    };
}sensio_sensio_mbist_ls_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  ls_3_9:1;
        RBus_UInt32  ls_3_8:1;
        RBus_UInt32  ls_3_7:1;
        RBus_UInt32  ls_3_6:1;
        RBus_UInt32  ls_3_5:1;
        RBus_UInt32  ls_3_4:1;
        RBus_UInt32  ls_3_3:1;
        RBus_UInt32  ls_3_2:1;
        RBus_UInt32  ls_3_1:1;
        RBus_UInt32  ls_3_0:1;
        RBus_UInt32  ls_2_9:1;
        RBus_UInt32  ls_2_8:1;
        RBus_UInt32  ls_2_7:1;
        RBus_UInt32  ls_2_6:1;
        RBus_UInt32  ls_2_5:1;
        RBus_UInt32  ls_2_4:1;
        RBus_UInt32  ls_2_3:1;
        RBus_UInt32  ls_2_2:1;
        RBus_UInt32  ls_2_1:1;
        RBus_UInt32  ls_2_0:1;
    };
}sensio_sensio_mbist_ls_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  ls_sub_1_9:1;
        RBus_UInt32  ls_sub_1_8:1;
        RBus_UInt32  ls_sub_1_7:1;
        RBus_UInt32  ls_sub_1_6:1;
        RBus_UInt32  ls_sub_1_5:1;
        RBus_UInt32  ls_sub_1_4:1;
        RBus_UInt32  ls_sub_1_3:1;
        RBus_UInt32  ls_sub_1_2:1;
        RBus_UInt32  ls_sub_1_1:1;
        RBus_UInt32  ls_sub_1_0:1;
        RBus_UInt32  ls_sub_0_9:1;
        RBus_UInt32  ls_sub_0_8:1;
        RBus_UInt32  ls_sub_0_7:1;
        RBus_UInt32  ls_sub_0_6:1;
        RBus_UInt32  ls_sub_0_5:1;
        RBus_UInt32  ls_sub_0_4:1;
        RBus_UInt32  ls_sub_0_3:1;
        RBus_UInt32  ls_sub_0_2:1;
        RBus_UInt32  ls_sub_0_1:1;
        RBus_UInt32  ls_sub_0_0:1;
    };
}sensio_sensio_mbist_ls_sub_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  ls_sub_3_9:1;
        RBus_UInt32  ls_sub_3_8:1;
        RBus_UInt32  ls_sub_3_7:1;
        RBus_UInt32  ls_sub_3_6:1;
        RBus_UInt32  ls_sub_3_5:1;
        RBus_UInt32  ls_sub_3_4:1;
        RBus_UInt32  ls_sub_3_3:1;
        RBus_UInt32  ls_sub_3_2:1;
        RBus_UInt32  ls_sub_3_1:1;
        RBus_UInt32  ls_sub_3_0:1;
        RBus_UInt32  ls_sub_2_9:1;
        RBus_UInt32  ls_sub_2_8:1;
        RBus_UInt32  ls_sub_2_7:1;
        RBus_UInt32  ls_sub_2_6:1;
        RBus_UInt32  ls_sub_2_5:1;
        RBus_UInt32  ls_sub_2_4:1;
        RBus_UInt32  ls_sub_2_3:1;
        RBus_UInt32  ls_sub_2_2:1;
        RBus_UInt32  ls_sub_2_1:1;
        RBus_UInt32  ls_sub_2_0:1;
    };
}sensio_sensio_mbist_ls_sub_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_0_7:4;
        RBus_UInt32  rm_0_6:4;
        RBus_UInt32  rm_0_5:4;
        RBus_UInt32  rm_0_4:4;
        RBus_UInt32  rm_0_3:4;
        RBus_UInt32  rm_0_2:4;
        RBus_UInt32  rm_0_1:4;
        RBus_UInt32  rm_0_0:4;
    };
}sensio_sensio_mbist_rm_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_1_5:4;
        RBus_UInt32  rm_1_4:4;
        RBus_UInt32  rm_1_3:4;
        RBus_UInt32  rm_1_2:4;
        RBus_UInt32  rm_1_1:4;
        RBus_UInt32  rm_1_0:4;
        RBus_UInt32  rm_0_9:4;
        RBus_UInt32  rm_0_8:4;
    };
}sensio_sensio_mbist_rm_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_2_3:4;
        RBus_UInt32  rm_2_2:4;
        RBus_UInt32  rm_2_1:4;
        RBus_UInt32  rm_2_0:4;
        RBus_UInt32  rm_1_9:4;
        RBus_UInt32  rm_1_8:4;
        RBus_UInt32  rm_1_7:4;
        RBus_UInt32  rm_1_6:4;
    };
}sensio_sensio_mbist_rm_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_3_1:4;
        RBus_UInt32  rm_3_0:4;
        RBus_UInt32  rm_2_9:4;
        RBus_UInt32  rm_2_8:4;
        RBus_UInt32  rm_2_7:4;
        RBus_UInt32  rm_2_6:4;
        RBus_UInt32  rm_2_5:4;
        RBus_UInt32  rm_2_4:4;
    };
}sensio_sensio_mbist_rm_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_3_9:4;
        RBus_UInt32  rm_3_8:4;
        RBus_UInt32  rm_3_7:4;
        RBus_UInt32  rm_3_6:4;
        RBus_UInt32  rm_3_5:4;
        RBus_UInt32  rm_3_4:4;
        RBus_UInt32  rm_3_3:4;
        RBus_UInt32  rm_3_2:4;
    };
}sensio_sensio_mbist_rm_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_sub_0_7:4;
        RBus_UInt32  rm_sub_0_6:4;
        RBus_UInt32  rm_sub_0_5:4;
        RBus_UInt32  rm_sub_0_4:4;
        RBus_UInt32  rm_sub_0_3:4;
        RBus_UInt32  rm_sub_0_2:4;
        RBus_UInt32  rm_sub_0_1:4;
        RBus_UInt32  rm_sub_0_0:4;
    };
}sensio_sensio_mbist_rm_sub_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_sub_1_5:4;
        RBus_UInt32  rm_sub_1_4:4;
        RBus_UInt32  rm_sub_1_3:4;
        RBus_UInt32  rm_sub_1_2:4;
        RBus_UInt32  rm_sub_1_1:4;
        RBus_UInt32  rm_sub_1_0:4;
        RBus_UInt32  rm_sub_0_9:4;
        RBus_UInt32  rm_sub_0_8:4;
    };
}sensio_sensio_mbist_rm_sub_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_sub_2_3:4;
        RBus_UInt32  rm_sub_2_2:4;
        RBus_UInt32  rm_sub_2_1:4;
        RBus_UInt32  rm_sub_2_0:4;
        RBus_UInt32  rm_sub_1_9:4;
        RBus_UInt32  rm_sub_1_8:4;
        RBus_UInt32  rm_sub_1_7:4;
        RBus_UInt32  rm_sub_1_6:4;
    };
}sensio_sensio_mbist_rm_sub_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_sub_3_1:4;
        RBus_UInt32  rm_sub_3_0:4;
        RBus_UInt32  rm_sub_2_9:4;
        RBus_UInt32  rm_sub_2_8:4;
        RBus_UInt32  rm_sub_2_7:4;
        RBus_UInt32  rm_sub_2_6:4;
        RBus_UInt32  rm_sub_2_5:4;
        RBus_UInt32  rm_sub_2_4:4;
    };
}sensio_sensio_mbist_rm_sub_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_sub_3_9:4;
        RBus_UInt32  rm_sub_3_8:4;
        RBus_UInt32  rm_sub_3_7:4;
        RBus_UInt32  rm_sub_3_6:4;
        RBus_UInt32  rm_sub_3_5:4;
        RBus_UInt32  rm_sub_3_4:4;
        RBus_UInt32  rm_sub_3_3:4;
        RBus_UInt32  rm_sub_3_2:4;
    };
}sensio_sensio_mbist_rm_sub_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  rme_1_9:1;
        RBus_UInt32  rme_1_8:1;
        RBus_UInt32  rme_1_7:1;
        RBus_UInt32  rme_1_6:1;
        RBus_UInt32  rme_1_5:1;
        RBus_UInt32  rme_1_4:1;
        RBus_UInt32  rme_1_3:1;
        RBus_UInt32  rme_1_2:1;
        RBus_UInt32  rme_1_1:1;
        RBus_UInt32  rme_1_0:1;
        RBus_UInt32  rme_0_9:1;
        RBus_UInt32  rme_0_8:1;
        RBus_UInt32  rme_0_7:1;
        RBus_UInt32  rme_0_6:1;
        RBus_UInt32  rme_0_5:1;
        RBus_UInt32  rme_0_4:1;
        RBus_UInt32  rme_0_3:1;
        RBus_UInt32  rme_0_2:1;
        RBus_UInt32  rme_0_1:1;
        RBus_UInt32  rme_0_0:1;
    };
}sensio_sensio_mbist_rme_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  rme_3_9:1;
        RBus_UInt32  rme_3_8:1;
        RBus_UInt32  rme_3_7:1;
        RBus_UInt32  rme_3_6:1;
        RBus_UInt32  rme_3_5:1;
        RBus_UInt32  rme_3_4:1;
        RBus_UInt32  rme_3_3:1;
        RBus_UInt32  rme_3_2:1;
        RBus_UInt32  rme_3_1:1;
        RBus_UInt32  rme_3_0:1;
        RBus_UInt32  rme_2_9:1;
        RBus_UInt32  rme_2_8:1;
        RBus_UInt32  rme_2_7:1;
        RBus_UInt32  rme_2_6:1;
        RBus_UInt32  rme_2_5:1;
        RBus_UInt32  rme_2_4:1;
        RBus_UInt32  rme_2_3:1;
        RBus_UInt32  rme_2_2:1;
        RBus_UInt32  rme_2_1:1;
        RBus_UInt32  rme_2_0:1;
    };
}sensio_sensio_mbist_rme_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  rme_sub_1_9:1;
        RBus_UInt32  rme_sub_1_8:1;
        RBus_UInt32  rme_sub_1_7:1;
        RBus_UInt32  rme_sub_1_6:1;
        RBus_UInt32  rme_sub_1_5:1;
        RBus_UInt32  rme_sub_1_4:1;
        RBus_UInt32  rme_sub_1_3:1;
        RBus_UInt32  rme_sub_1_2:1;
        RBus_UInt32  rme_sub_1_1:1;
        RBus_UInt32  rme_sub_1_0:1;
        RBus_UInt32  rme_sub_0_9:1;
        RBus_UInt32  rme_sub_0_8:1;
        RBus_UInt32  rme_sub_0_7:1;
        RBus_UInt32  rme_sub_0_6:1;
        RBus_UInt32  rme_sub_0_5:1;
        RBus_UInt32  rme_sub_0_4:1;
        RBus_UInt32  rme_sub_0_3:1;
        RBus_UInt32  rme_sub_0_2:1;
        RBus_UInt32  rme_sub_0_1:1;
        RBus_UInt32  rme_sub_0_0:1;
    };
}sensio_sensio_mbist_rme_sub_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  rme_sub_3_9:1;
        RBus_UInt32  rme_sub_3_8:1;
        RBus_UInt32  rme_sub_3_7:1;
        RBus_UInt32  rme_sub_3_6:1;
        RBus_UInt32  rme_sub_3_5:1;
        RBus_UInt32  rme_sub_3_4:1;
        RBus_UInt32  rme_sub_3_3:1;
        RBus_UInt32  rme_sub_3_2:1;
        RBus_UInt32  rme_sub_3_1:1;
        RBus_UInt32  rme_sub_3_0:1;
        RBus_UInt32  rme_sub_2_9:1;
        RBus_UInt32  rme_sub_2_8:1;
        RBus_UInt32  rme_sub_2_7:1;
        RBus_UInt32  rme_sub_2_6:1;
        RBus_UInt32  rme_sub_2_5:1;
        RBus_UInt32  rme_sub_2_4:1;
        RBus_UInt32  rme_sub_2_3:1;
        RBus_UInt32  rme_sub_2_2:1;
        RBus_UInt32  rme_sub_2_1:1;
        RBus_UInt32  rme_sub_2_0:1;
    };
}sensio_sensio_mbist_rme_sub_1_RBUS;

#else //apply LITTLE_ENDIAN

//======SENSIO register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sensio_en:1;
        RBus_UInt32  sensio_input_mux:1;
        RBus_UInt32  sensio_in_format:2;
        RBus_UInt32  en_ctsfifo_bypass_sensio:1;
        RBus_UInt32  en_ctsfifo_vsrst_sensio:1;
        RBus_UInt32  force_ctsfifo_rstn_sensio:1;
        RBus_UInt32  vflip_en:1;
        RBus_UInt32  sensio_bndy_r:10;
        RBus_UInt32  sensio_bndy_g:10;
        RBus_UInt32  res1:1;
        RBus_UInt32  re_decom_en:1;
        RBus_UInt32  sensio_out_format:1;
        RBus_UInt32  sensio_lflag_inv:1;
    };
}sensio_sensio_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sensio_bndy_b:10;
        RBus_UInt32  res1:22;
    };
}sensio_sensio_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sensio_ihsize:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  sensio_ivsize:12;
        RBus_UInt32  res2:4;
    };
}sensio_sensio_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sensio_sub_double_en:1;
        RBus_UInt32  sensio_sub_double_apply:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  sensio_read_sel:1;
        RBus_UInt32  sensio_double_en:1;
        RBus_UInt32  sensio_double_apply:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  sensio_inout_bit:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  sensio_hdmi_hs_inv:1;
        RBus_UInt32  sensio_hdmi_vs_inv:1;
        RBus_UInt32  sensio_algo_type:2;
        RBus_UInt32  res4:2;
    };
}sensio_sensio_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_decomp_10bit:2;
        RBus_UInt32  res1:30;
    };
}sensio_decomp_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  sub_re_decom_en:1;
        RBus_UInt32  sub_decomp_10bit:2;
        RBus_UInt32  sub_vflip_en:1;
        RBus_UInt32  res2:27;
    };
}sensio_sub_vp9_decomp_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sub_v_d_ihsize:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  sub_v_d_ivsize:11;
        RBus_UInt32  res2:5;
    };
}sensio_sub_vp9_decomp_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  real_vp9_vstart:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  real_vp9_vend:12;
        RBus_UInt32  res2:4;
    };
}sensio_vp9_decomp_v_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sub_real_vp9_vstart:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  sub_real_vp9_vend:11;
        RBus_UInt32  res2:5;
    };
}sensio_sub_vp9_decomp_v_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  h_total:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  hs_width:6;
        RBus_UInt32  res2:10;
    };
}sensio_sensio_tim_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  h_den_st:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  v_den_st:8;
        RBus_UInt32  res2:8;
    };
}sensio_sensio_tim_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sub_h_total:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  sub_hs_width:6;
        RBus_UInt32  res2:10;
    };
}sensio_sub_sensio_tim_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sub_h_den_st:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  sub_v_den_st:8;
        RBus_UInt32  res2:8;
    };
}sensio_sub_sensio_tim_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  detect_en:1;
        RBus_UInt32  detect_mode:1;
        RBus_UInt32  detect_result_ready:1;
        RBus_UInt32  res1:29;
    };
}sensio_sensio_det_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  th_hlh:7;
        RBus_UInt32  res1:9;
        RBus_UInt32  th_edge_hlh:5;
        RBus_UInt32  res2:11;
    };
}sensio_sensio_det_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_3hlh:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_result_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  th_flat:5;
        RBus_UInt32  res1:11;
        RBus_UInt32  rate_flat:3;
        RBus_UInt32  res2:13;
    };
}sensio_sensio_det_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_3chlh:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_result_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  th_min_diff:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  rate_min_diff:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  th_hlh_l5:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  th_edge_l5:5;
        RBus_UInt32  res4:7;
    };
}sensio_sensio_det_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_5hlh:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_result_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  th_hlh_r:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  th_edge_r:5;
        RBus_UInt32  res2:19;
    };
}sensio_sensio_det_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_2d2hlh:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_result_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  th_hlh_l:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  th_edge_l:5;
        RBus_UInt32  res2:19;
    };
}sensio_sensio_det_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_2d3hlh:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_result_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_2d2chlh:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_result_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_d2rhlh:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_result_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_d3chlh:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_result_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_d3rhlh:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_result_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  th_sad:5;
        RBus_UInt32  res1:27;
    };
}sensio_sensio_sad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_sad:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_sad_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  count_vstrip:20;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_result_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bist_fail_0_0:1;
        RBus_UInt32  bist_fail_0_1:1;
        RBus_UInt32  bist_fail_0_2:1;
        RBus_UInt32  bist_fail_0_3:1;
        RBus_UInt32  bist_fail_0_4:1;
        RBus_UInt32  bist_fail_0_5:1;
        RBus_UInt32  bist_fail_0_6:1;
        RBus_UInt32  bist_fail_0_7:1;
        RBus_UInt32  bist_fail_0_8:1;
        RBus_UInt32  bist_fail_0_9:1;
        RBus_UInt32  bist_fail_1_0:1;
        RBus_UInt32  bist_fail_1_1:1;
        RBus_UInt32  bist_fail_1_2:1;
        RBus_UInt32  bist_fail_1_3:1;
        RBus_UInt32  bist_fail_1_4:1;
        RBus_UInt32  bist_fail_1_5:1;
        RBus_UInt32  bist_fail_1_6:1;
        RBus_UInt32  bist_fail_1_7:1;
        RBus_UInt32  bist_fail_1_8:1;
        RBus_UInt32  bist_fail_1_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bist_fail_2_0:1;
        RBus_UInt32  bist_fail_2_1:1;
        RBus_UInt32  bist_fail_2_2:1;
        RBus_UInt32  bist_fail_2_3:1;
        RBus_UInt32  bist_fail_2_4:1;
        RBus_UInt32  bist_fail_2_5:1;
        RBus_UInt32  bist_fail_2_6:1;
        RBus_UInt32  bist_fail_2_7:1;
        RBus_UInt32  bist_fail_2_8:1;
        RBus_UInt32  bist_fail_2_9:1;
        RBus_UInt32  bist_fail_3_0:1;
        RBus_UInt32  bist_fail_3_1:1;
        RBus_UInt32  bist_fail_3_2:1;
        RBus_UInt32  bist_fail_3_3:1;
        RBus_UInt32  bist_fail_3_4:1;
        RBus_UInt32  bist_fail_3_5:1;
        RBus_UInt32  bist_fail_3_6:1;
        RBus_UInt32  bist_fail_3_7:1;
        RBus_UInt32  bist_fail_3_8:1;
        RBus_UInt32  bist_fail_3_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_fail_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bist_fail_sub_0_0:1;
        RBus_UInt32  bist_fail_sub_0_1:1;
        RBus_UInt32  bist_fail_sub_0_2:1;
        RBus_UInt32  bist_fail_sub_0_3:1;
        RBus_UInt32  bist_fail_sub_0_4:1;
        RBus_UInt32  bist_fail_sub_0_5:1;
        RBus_UInt32  bist_fail_sub_0_6:1;
        RBus_UInt32  bist_fail_sub_0_7:1;
        RBus_UInt32  bist_fail_sub_0_8:1;
        RBus_UInt32  bist_fail_sub_0_9:1;
        RBus_UInt32  bist_fail_sub_1_0:1;
        RBus_UInt32  bist_fail_sub_1_1:1;
        RBus_UInt32  bist_fail_sub_1_2:1;
        RBus_UInt32  bist_fail_sub_1_3:1;
        RBus_UInt32  bist_fail_sub_1_4:1;
        RBus_UInt32  bist_fail_sub_1_5:1;
        RBus_UInt32  bist_fail_sub_1_6:1;
        RBus_UInt32  bist_fail_sub_1_7:1;
        RBus_UInt32  bist_fail_sub_1_8:1;
        RBus_UInt32  bist_fail_sub_1_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_fail_sub_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bist_fail_sub_2_0:1;
        RBus_UInt32  bist_fail_sub_2_1:1;
        RBus_UInt32  bist_fail_sub_2_2:1;
        RBus_UInt32  bist_fail_sub_2_3:1;
        RBus_UInt32  bist_fail_sub_2_4:1;
        RBus_UInt32  bist_fail_sub_2_5:1;
        RBus_UInt32  bist_fail_sub_2_6:1;
        RBus_UInt32  bist_fail_sub_2_7:1;
        RBus_UInt32  bist_fail_sub_2_8:1;
        RBus_UInt32  bist_fail_sub_2_9:1;
        RBus_UInt32  bist_fail_sub_3_0:1;
        RBus_UInt32  bist_fail_sub_3_1:1;
        RBus_UInt32  bist_fail_sub_3_2:1;
        RBus_UInt32  bist_fail_sub_3_3:1;
        RBus_UInt32  bist_fail_sub_3_4:1;
        RBus_UInt32  bist_fail_sub_3_5:1;
        RBus_UInt32  bist_fail_sub_3_6:1;
        RBus_UInt32  bist_fail_sub_3_7:1;
        RBus_UInt32  bist_fail_sub_3_8:1;
        RBus_UInt32  bist_fail_sub_3_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_fail_sub_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drf_bist_fail_0_0:1;
        RBus_UInt32  drf_bist_fail_0_1:1;
        RBus_UInt32  drf_bist_fail_0_2:1;
        RBus_UInt32  drf_bist_fail_0_3:1;
        RBus_UInt32  drf_bist_fail_0_4:1;
        RBus_UInt32  drf_bist_fail_0_5:1;
        RBus_UInt32  drf_bist_fail_0_6:1;
        RBus_UInt32  drf_bist_fail_0_7:1;
        RBus_UInt32  drf_bist_fail_0_8:1;
        RBus_UInt32  drf_bist_fail_0_9:1;
        RBus_UInt32  drf_bist_fail_1_0:1;
        RBus_UInt32  drf_bist_fail_1_1:1;
        RBus_UInt32  drf_bist_fail_1_2:1;
        RBus_UInt32  drf_bist_fail_1_3:1;
        RBus_UInt32  drf_bist_fail_1_4:1;
        RBus_UInt32  drf_bist_fail_1_5:1;
        RBus_UInt32  drf_bist_fail_1_6:1;
        RBus_UInt32  drf_bist_fail_1_7:1;
        RBus_UInt32  drf_bist_fail_1_8:1;
        RBus_UInt32  drf_bist_fail_1_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_drf_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drf_bist_fail_2_0:1;
        RBus_UInt32  drf_bist_fail_2_1:1;
        RBus_UInt32  drf_bist_fail_2_2:1;
        RBus_UInt32  drf_bist_fail_2_3:1;
        RBus_UInt32  drf_bist_fail_2_4:1;
        RBus_UInt32  drf_bist_fail_2_5:1;
        RBus_UInt32  drf_bist_fail_2_6:1;
        RBus_UInt32  drf_bist_fail_2_7:1;
        RBus_UInt32  drf_bist_fail_2_8:1;
        RBus_UInt32  drf_bist_fail_2_9:1;
        RBus_UInt32  drf_bist_fail_3_0:1;
        RBus_UInt32  drf_bist_fail_3_1:1;
        RBus_UInt32  drf_bist_fail_3_2:1;
        RBus_UInt32  drf_bist_fail_3_3:1;
        RBus_UInt32  drf_bist_fail_3_4:1;
        RBus_UInt32  drf_bist_fail_3_5:1;
        RBus_UInt32  drf_bist_fail_3_6:1;
        RBus_UInt32  drf_bist_fail_3_7:1;
        RBus_UInt32  drf_bist_fail_3_8:1;
        RBus_UInt32  drf_bist_fail_3_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_drf_fail_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drf_bist_fail_sub_0_0:1;
        RBus_UInt32  drf_bist_fail_sub_0_1:1;
        RBus_UInt32  drf_bist_fail_sub_0_2:1;
        RBus_UInt32  drf_bist_fail_sub_0_3:1;
        RBus_UInt32  drf_bist_fail_sub_0_4:1;
        RBus_UInt32  drf_bist_fail_sub_0_5:1;
        RBus_UInt32  drf_bist_fail_sub_0_6:1;
        RBus_UInt32  drf_bist_fail_sub_0_7:1;
        RBus_UInt32  drf_bist_fail_sub_0_8:1;
        RBus_UInt32  drf_bist_fail_sub_0_9:1;
        RBus_UInt32  drf_bist_fail_sub_1_0:1;
        RBus_UInt32  drf_bist_fail_sub_1_1:1;
        RBus_UInt32  drf_bist_fail_sub_1_2:1;
        RBus_UInt32  drf_bist_fail_sub_1_3:1;
        RBus_UInt32  drf_bist_fail_sub_1_4:1;
        RBus_UInt32  drf_bist_fail_sub_1_5:1;
        RBus_UInt32  drf_bist_fail_sub_1_6:1;
        RBus_UInt32  drf_bist_fail_sub_1_7:1;
        RBus_UInt32  drf_bist_fail_sub_1_8:1;
        RBus_UInt32  drf_bist_fail_sub_1_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_drf_fail_sub_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drf_bist_fail_sub_2_0:1;
        RBus_UInt32  drf_bist_fail_sub_2_1:1;
        RBus_UInt32  drf_bist_fail_sub_2_2:1;
        RBus_UInt32  drf_bist_fail_sub_2_3:1;
        RBus_UInt32  drf_bist_fail_sub_2_4:1;
        RBus_UInt32  drf_bist_fail_sub_2_5:1;
        RBus_UInt32  drf_bist_fail_sub_2_6:1;
        RBus_UInt32  drf_bist_fail_sub_2_7:1;
        RBus_UInt32  drf_bist_fail_sub_2_8:1;
        RBus_UInt32  drf_bist_fail_sub_2_9:1;
        RBus_UInt32  drf_bist_fail_sub_3_0:1;
        RBus_UInt32  drf_bist_fail_sub_3_1:1;
        RBus_UInt32  drf_bist_fail_sub_3_2:1;
        RBus_UInt32  drf_bist_fail_sub_3_3:1;
        RBus_UInt32  drf_bist_fail_sub_3_4:1;
        RBus_UInt32  drf_bist_fail_sub_3_5:1;
        RBus_UInt32  drf_bist_fail_sub_3_6:1;
        RBus_UInt32  drf_bist_fail_sub_3_7:1;
        RBus_UInt32  drf_bist_fail_sub_3_8:1;
        RBus_UInt32  drf_bist_fail_sub_3_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_drf_fail_sub_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ls_0_0:1;
        RBus_UInt32  ls_0_1:1;
        RBus_UInt32  ls_0_2:1;
        RBus_UInt32  ls_0_3:1;
        RBus_UInt32  ls_0_4:1;
        RBus_UInt32  ls_0_5:1;
        RBus_UInt32  ls_0_6:1;
        RBus_UInt32  ls_0_7:1;
        RBus_UInt32  ls_0_8:1;
        RBus_UInt32  ls_0_9:1;
        RBus_UInt32  ls_1_0:1;
        RBus_UInt32  ls_1_1:1;
        RBus_UInt32  ls_1_2:1;
        RBus_UInt32  ls_1_3:1;
        RBus_UInt32  ls_1_4:1;
        RBus_UInt32  ls_1_5:1;
        RBus_UInt32  ls_1_6:1;
        RBus_UInt32  ls_1_7:1;
        RBus_UInt32  ls_1_8:1;
        RBus_UInt32  ls_1_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_ls_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ls_2_0:1;
        RBus_UInt32  ls_2_1:1;
        RBus_UInt32  ls_2_2:1;
        RBus_UInt32  ls_2_3:1;
        RBus_UInt32  ls_2_4:1;
        RBus_UInt32  ls_2_5:1;
        RBus_UInt32  ls_2_6:1;
        RBus_UInt32  ls_2_7:1;
        RBus_UInt32  ls_2_8:1;
        RBus_UInt32  ls_2_9:1;
        RBus_UInt32  ls_3_0:1;
        RBus_UInt32  ls_3_1:1;
        RBus_UInt32  ls_3_2:1;
        RBus_UInt32  ls_3_3:1;
        RBus_UInt32  ls_3_4:1;
        RBus_UInt32  ls_3_5:1;
        RBus_UInt32  ls_3_6:1;
        RBus_UInt32  ls_3_7:1;
        RBus_UInt32  ls_3_8:1;
        RBus_UInt32  ls_3_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_ls_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ls_sub_0_0:1;
        RBus_UInt32  ls_sub_0_1:1;
        RBus_UInt32  ls_sub_0_2:1;
        RBus_UInt32  ls_sub_0_3:1;
        RBus_UInt32  ls_sub_0_4:1;
        RBus_UInt32  ls_sub_0_5:1;
        RBus_UInt32  ls_sub_0_6:1;
        RBus_UInt32  ls_sub_0_7:1;
        RBus_UInt32  ls_sub_0_8:1;
        RBus_UInt32  ls_sub_0_9:1;
        RBus_UInt32  ls_sub_1_0:1;
        RBus_UInt32  ls_sub_1_1:1;
        RBus_UInt32  ls_sub_1_2:1;
        RBus_UInt32  ls_sub_1_3:1;
        RBus_UInt32  ls_sub_1_4:1;
        RBus_UInt32  ls_sub_1_5:1;
        RBus_UInt32  ls_sub_1_6:1;
        RBus_UInt32  ls_sub_1_7:1;
        RBus_UInt32  ls_sub_1_8:1;
        RBus_UInt32  ls_sub_1_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_ls_sub_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ls_sub_2_0:1;
        RBus_UInt32  ls_sub_2_1:1;
        RBus_UInt32  ls_sub_2_2:1;
        RBus_UInt32  ls_sub_2_3:1;
        RBus_UInt32  ls_sub_2_4:1;
        RBus_UInt32  ls_sub_2_5:1;
        RBus_UInt32  ls_sub_2_6:1;
        RBus_UInt32  ls_sub_2_7:1;
        RBus_UInt32  ls_sub_2_8:1;
        RBus_UInt32  ls_sub_2_9:1;
        RBus_UInt32  ls_sub_3_0:1;
        RBus_UInt32  ls_sub_3_1:1;
        RBus_UInt32  ls_sub_3_2:1;
        RBus_UInt32  ls_sub_3_3:1;
        RBus_UInt32  ls_sub_3_4:1;
        RBus_UInt32  ls_sub_3_5:1;
        RBus_UInt32  ls_sub_3_6:1;
        RBus_UInt32  ls_sub_3_7:1;
        RBus_UInt32  ls_sub_3_8:1;
        RBus_UInt32  ls_sub_3_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_ls_sub_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_0_0:4;
        RBus_UInt32  rm_0_1:4;
        RBus_UInt32  rm_0_2:4;
        RBus_UInt32  rm_0_3:4;
        RBus_UInt32  rm_0_4:4;
        RBus_UInt32  rm_0_5:4;
        RBus_UInt32  rm_0_6:4;
        RBus_UInt32  rm_0_7:4;
    };
}sensio_sensio_mbist_rm_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_0_8:4;
        RBus_UInt32  rm_0_9:4;
        RBus_UInt32  rm_1_0:4;
        RBus_UInt32  rm_1_1:4;
        RBus_UInt32  rm_1_2:4;
        RBus_UInt32  rm_1_3:4;
        RBus_UInt32  rm_1_4:4;
        RBus_UInt32  rm_1_5:4;
    };
}sensio_sensio_mbist_rm_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_1_6:4;
        RBus_UInt32  rm_1_7:4;
        RBus_UInt32  rm_1_8:4;
        RBus_UInt32  rm_1_9:4;
        RBus_UInt32  rm_2_0:4;
        RBus_UInt32  rm_2_1:4;
        RBus_UInt32  rm_2_2:4;
        RBus_UInt32  rm_2_3:4;
    };
}sensio_sensio_mbist_rm_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_2_4:4;
        RBus_UInt32  rm_2_5:4;
        RBus_UInt32  rm_2_6:4;
        RBus_UInt32  rm_2_7:4;
        RBus_UInt32  rm_2_8:4;
        RBus_UInt32  rm_2_9:4;
        RBus_UInt32  rm_3_0:4;
        RBus_UInt32  rm_3_1:4;
    };
}sensio_sensio_mbist_rm_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_3_2:4;
        RBus_UInt32  rm_3_3:4;
        RBus_UInt32  rm_3_4:4;
        RBus_UInt32  rm_3_5:4;
        RBus_UInt32  rm_3_6:4;
        RBus_UInt32  rm_3_7:4;
        RBus_UInt32  rm_3_8:4;
        RBus_UInt32  rm_3_9:4;
    };
}sensio_sensio_mbist_rm_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_sub_0_0:4;
        RBus_UInt32  rm_sub_0_1:4;
        RBus_UInt32  rm_sub_0_2:4;
        RBus_UInt32  rm_sub_0_3:4;
        RBus_UInt32  rm_sub_0_4:4;
        RBus_UInt32  rm_sub_0_5:4;
        RBus_UInt32  rm_sub_0_6:4;
        RBus_UInt32  rm_sub_0_7:4;
    };
}sensio_sensio_mbist_rm_sub_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_sub_0_8:4;
        RBus_UInt32  rm_sub_0_9:4;
        RBus_UInt32  rm_sub_1_0:4;
        RBus_UInt32  rm_sub_1_1:4;
        RBus_UInt32  rm_sub_1_2:4;
        RBus_UInt32  rm_sub_1_3:4;
        RBus_UInt32  rm_sub_1_4:4;
        RBus_UInt32  rm_sub_1_5:4;
    };
}sensio_sensio_mbist_rm_sub_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_sub_1_6:4;
        RBus_UInt32  rm_sub_1_7:4;
        RBus_UInt32  rm_sub_1_8:4;
        RBus_UInt32  rm_sub_1_9:4;
        RBus_UInt32  rm_sub_2_0:4;
        RBus_UInt32  rm_sub_2_1:4;
        RBus_UInt32  rm_sub_2_2:4;
        RBus_UInt32  rm_sub_2_3:4;
    };
}sensio_sensio_mbist_rm_sub_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_sub_2_4:4;
        RBus_UInt32  rm_sub_2_5:4;
        RBus_UInt32  rm_sub_2_6:4;
        RBus_UInt32  rm_sub_2_7:4;
        RBus_UInt32  rm_sub_2_8:4;
        RBus_UInt32  rm_sub_2_9:4;
        RBus_UInt32  rm_sub_3_0:4;
        RBus_UInt32  rm_sub_3_1:4;
    };
}sensio_sensio_mbist_rm_sub_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_sub_3_2:4;
        RBus_UInt32  rm_sub_3_3:4;
        RBus_UInt32  rm_sub_3_4:4;
        RBus_UInt32  rm_sub_3_5:4;
        RBus_UInt32  rm_sub_3_6:4;
        RBus_UInt32  rm_sub_3_7:4;
        RBus_UInt32  rm_sub_3_8:4;
        RBus_UInt32  rm_sub_3_9:4;
    };
}sensio_sensio_mbist_rm_sub_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rme_0_0:1;
        RBus_UInt32  rme_0_1:1;
        RBus_UInt32  rme_0_2:1;
        RBus_UInt32  rme_0_3:1;
        RBus_UInt32  rme_0_4:1;
        RBus_UInt32  rme_0_5:1;
        RBus_UInt32  rme_0_6:1;
        RBus_UInt32  rme_0_7:1;
        RBus_UInt32  rme_0_8:1;
        RBus_UInt32  rme_0_9:1;
        RBus_UInt32  rme_1_0:1;
        RBus_UInt32  rme_1_1:1;
        RBus_UInt32  rme_1_2:1;
        RBus_UInt32  rme_1_3:1;
        RBus_UInt32  rme_1_4:1;
        RBus_UInt32  rme_1_5:1;
        RBus_UInt32  rme_1_6:1;
        RBus_UInt32  rme_1_7:1;
        RBus_UInt32  rme_1_8:1;
        RBus_UInt32  rme_1_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_rme_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rme_2_0:1;
        RBus_UInt32  rme_2_1:1;
        RBus_UInt32  rme_2_2:1;
        RBus_UInt32  rme_2_3:1;
        RBus_UInt32  rme_2_4:1;
        RBus_UInt32  rme_2_5:1;
        RBus_UInt32  rme_2_6:1;
        RBus_UInt32  rme_2_7:1;
        RBus_UInt32  rme_2_8:1;
        RBus_UInt32  rme_2_9:1;
        RBus_UInt32  rme_3_0:1;
        RBus_UInt32  rme_3_1:1;
        RBus_UInt32  rme_3_2:1;
        RBus_UInt32  rme_3_3:1;
        RBus_UInt32  rme_3_4:1;
        RBus_UInt32  rme_3_5:1;
        RBus_UInt32  rme_3_6:1;
        RBus_UInt32  rme_3_7:1;
        RBus_UInt32  rme_3_8:1;
        RBus_UInt32  rme_3_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_rme_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rme_sub_0_0:1;
        RBus_UInt32  rme_sub_0_1:1;
        RBus_UInt32  rme_sub_0_2:1;
        RBus_UInt32  rme_sub_0_3:1;
        RBus_UInt32  rme_sub_0_4:1;
        RBus_UInt32  rme_sub_0_5:1;
        RBus_UInt32  rme_sub_0_6:1;
        RBus_UInt32  rme_sub_0_7:1;
        RBus_UInt32  rme_sub_0_8:1;
        RBus_UInt32  rme_sub_0_9:1;
        RBus_UInt32  rme_sub_1_0:1;
        RBus_UInt32  rme_sub_1_1:1;
        RBus_UInt32  rme_sub_1_2:1;
        RBus_UInt32  rme_sub_1_3:1;
        RBus_UInt32  rme_sub_1_4:1;
        RBus_UInt32  rme_sub_1_5:1;
        RBus_UInt32  rme_sub_1_6:1;
        RBus_UInt32  rme_sub_1_7:1;
        RBus_UInt32  rme_sub_1_8:1;
        RBus_UInt32  rme_sub_1_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_rme_sub_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rme_sub_2_0:1;
        RBus_UInt32  rme_sub_2_1:1;
        RBus_UInt32  rme_sub_2_2:1;
        RBus_UInt32  rme_sub_2_3:1;
        RBus_UInt32  rme_sub_2_4:1;
        RBus_UInt32  rme_sub_2_5:1;
        RBus_UInt32  rme_sub_2_6:1;
        RBus_UInt32  rme_sub_2_7:1;
        RBus_UInt32  rme_sub_2_8:1;
        RBus_UInt32  rme_sub_2_9:1;
        RBus_UInt32  rme_sub_3_0:1;
        RBus_UInt32  rme_sub_3_1:1;
        RBus_UInt32  rme_sub_3_2:1;
        RBus_UInt32  rme_sub_3_3:1;
        RBus_UInt32  rme_sub_3_4:1;
        RBus_UInt32  rme_sub_3_5:1;
        RBus_UInt32  rme_sub_3_6:1;
        RBus_UInt32  rme_sub_3_7:1;
        RBus_UInt32  rme_sub_3_8:1;
        RBus_UInt32  rme_sub_3_9:1;
        RBus_UInt32  res1:12;
    };
}sensio_sensio_mbist_rme_sub_1_RBUS;




#endif 


#endif 
