/**
* @file Merlin3-DesignSpec-D-Domain_Still_Logo_Detection
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2017/6/9
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_COLOR_SLD_REG_H_
#define _RBUS_COLOR_SLD_REG_H_

#include "rbusTypes.h"



//  COLOR_SLD Register Address



#define  COLOR_SLD_SLD_CONTROL_VADDR                        	(0xb802c700)
#define  COLOR_SLD_SLD_SIZE_VADDR                           	(0xb802c704)
#define  COLOR_SLD_SLD_CURVE_MAP_SEG_VADDR                  	(0xb802c708)
#define  COLOR_SLD_SLD_CURVE_MAP_GAIN_VADDR                 	(0xb802c70c)
#define  COLOR_SLD_SLD_CURVE_MAP_OFFSET_0_VADDR             	(0xb802c710)
#define  COLOR_SLD_SLD_CURVE_MAP_OFFSET_1_VADDR             	(0xb802c714)
#define  COLOR_SLD_SLD_DROP_VADDR                           	(0xb802c718)
#define  COLOR_SLD_SLD_CNT_0_VADDR                          	(0xb802c71c)
#define  COLOR_SLD_SLD_CNT_1_VADDR                          	(0xb802c720)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======COLOR_SLD register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802c700_31_21:11;
        RBus_UInt32  sld_scale_mode:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  sld_hpf_thl:8;
        RBus_UInt32  res2:2;
        RBus_UInt32  sld_hpf_type:2;
        RBus_UInt32  sld_global_drop:1;
        RBus_UInt32  sld_blend_en:1;
        RBus_UInt32  sld_debug_mode:1;
        RBus_UInt32  sld_en:1;
    };
}color_sld_sld_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  sld_width:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  sld_height:12;
    };
}color_sld_sld_size_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  sld_curve_seg_1:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  sld_curve_seg_0:10;
    };
}color_sld_sld_curve_map_seg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_curve_gain_2:8;
        RBus_UInt32  res1:4;
        RBus_UInt32  sld_curve_gain_1:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  sld_curve_gain_0:8;
    };
}color_sld_sld_curve_map_gain_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  sld_curve_offset_1:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  sld_curve_offset_0:11;
    };
}color_sld_sld_curve_map_offset_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  sld_curve_offset_2:11;
    };
}color_sld_sld_curve_map_offset_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_pixel_diff_thl:10;
        RBus_UInt32  res1:1;
        RBus_UInt32  sld_hpf_diff_thl:10;
        RBus_UInt32  res2:1;
        RBus_UInt32  sld_cnt_thl:10;
    };
}color_sld_sld_drop_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802c71c_31_17:15;
        RBus_UInt32  sld_logo_cnt:17;
    };
}color_sld_sld_cnt_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802c720_31_17:15;
        RBus_UInt32  sld_drop_cnt:17;
    };
}color_sld_sld_cnt_1_RBUS;

#else //apply LITTLE_ENDIAN

//======COLOR_SLD register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_en:1;
        RBus_UInt32  sld_debug_mode:1;
        RBus_UInt32  sld_blend_en:1;
        RBus_UInt32  sld_global_drop:1;
        RBus_UInt32  sld_hpf_type:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  sld_hpf_thl:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  sld_scale_mode:1;
        RBus_UInt32  dummy1802c700_31_21:11;
    };
}color_sld_sld_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_height:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  sld_width:12;
        RBus_UInt32  res2:4;
    };
}color_sld_sld_size_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_curve_seg_0:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  sld_curve_seg_1:10;
        RBus_UInt32  res2:6;
    };
}color_sld_sld_curve_map_seg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_curve_gain_0:8;
        RBus_UInt32  res1:4;
        RBus_UInt32  sld_curve_gain_1:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  sld_curve_gain_2:8;
    };
}color_sld_sld_curve_map_gain_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_curve_offset_0:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  sld_curve_offset_1:11;
        RBus_UInt32  res2:5;
    };
}color_sld_sld_curve_map_offset_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_curve_offset_2:11;
        RBus_UInt32  res1:21;
    };
}color_sld_sld_curve_map_offset_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_cnt_thl:10;
        RBus_UInt32  res1:1;
        RBus_UInt32  sld_hpf_diff_thl:10;
        RBus_UInt32  res2:1;
        RBus_UInt32  sld_pixel_diff_thl:10;
    };
}color_sld_sld_drop_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_logo_cnt:17;
        RBus_UInt32  dummy1802c71c_31_17:15;
    };
}color_sld_sld_cnt_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sld_drop_cnt:17;
        RBus_UInt32  dummy1802c720_31_17:15;
    };
}color_sld_sld_cnt_1_RBUS;




#endif 


#endif 
