/**
* @file Merlin3-DesignSpec-D_Domain_DISP_IF
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2017/6/9
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_PIF_REG_H_
#define _RBUS_PIF_REG_H_

#include "rbusTypes.h"



//  PIF Register Address



#define  PIF_LVDS_CTRL1_VADDR                               	(0xb802d000)
#define  PIF_LVDS_CTRL2_VADDR                               	(0xb802d004)
#define  PIF_LVDS_CTRL3_VADDR                               	(0xb802d008)
#define  PIF_LVDS_CTRL4_VADDR                               	(0xb802d00c)
#define  PIF_LVDS_CTRL5_VADDR                               	(0xb802d010)
#define  PIF_MLVDS_CTRL0_VADDR                              	(0xb802d014)
#define  PIF_MLVDS_RESET_PUL_CTRL_VADDR                     	(0xb802d018)
#define  PIF_MLVDS_CTRL1_VADDR                              	(0xb802d01c)
#define  PIF_MLVDS_CTRL2_VADDR                              	(0xb802d020)
#define  PIF_MLVDS_CTRL3_VADDR                              	(0xb802d024)
#define  PIF_MLVDS_CTRL4_VADDR                              	(0xb802d028)
#define  PIF_LVDS_CTRL0_VADDR                               	(0xb802d02c)
#define  PIF_LVDS_PAIR_SELECT_CTRL_0_VADDR                  	(0xb802d030)
#define  PIF_LVDS_PAIR_SELECT_CTRL_1_VADDR                  	(0xb802d034)
#define  PIF_PIF_FIFO_EN_VADDR                              	(0xb802d038)
#define  PIF_PIF_FIFO_RST_VADDR                             	(0xb802d03c)
#define  PIF_PIF_FIFO_BIST_PRBS_VADDR                       	(0xb802d040)
#define  PIF_PIF_FIFO_BIST_LEN_VADDR                        	(0xb802d044)
#define  PIF_PIF_FIFO_BIST_RES1_VADDR                       	(0xb802d048)
#define  PIF_PIF_FIFO_BIST_RES2_VADDR                       	(0xb802d04c)
#define  PIF_PIF_FIFO_BIST_CTL_VADDR                        	(0xb802d050)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======PIF register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_arsv1_sel:3;
        RBus_UInt32  lvds_arsv0_sel:3;
        RBus_UInt32  lvds_aden_sel:3;
        RBus_UInt32  lvds_avs_sel:3;
        RBus_UInt32  lvds_ahs_sel:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  lvds_brsv1_sel:3;
        RBus_UInt32  lvds_brsv0_sel:3;
        RBus_UInt32  lvds_bden_sel:3;
        RBus_UInt32  lvds_bvs_sel:3;
        RBus_UInt32  lvds_bhs_sel:3;
        RBus_UInt32  res2:1;
    };
}pif_lvds_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d004_31_0:32;
    };
}pif_lvds_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:17;
        RBus_UInt32  lvds_map_inv:1;
        RBus_UInt32  lvds_map:2;
        RBus_UInt32  res2:4;
        RBus_UInt32  lvds_aport_en:1;
        RBus_UInt32  lvds_bport_en:1;
        RBus_UInt32  res3:6;
    };
}pif_lvds_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d00c_31_0:32;
    };
}pif_lvds_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d010_31_0:32;
    };
}pif_lvds_ctrl5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d014_31_10:22;
        RBus_UInt32  mlvds_map_type_sel:2;
        RBus_UInt32  mlvds_en:1;
        RBus_UInt32  mlvds_map_inv:1;
        RBus_UInt32  dummy1802d014_5_2:4;
        RBus_UInt32  mlvds_mode:2;
    };
}pif_mlvds_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d018_31_12:20;
        RBus_UInt32  mlvds_reset_pul_sel:12;
    };
}pif_mlvds_reset_pul_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tcon_sel:8;
        RBus_UInt32  tcon_delay_sel_7:2;
        RBus_UInt32  tcon_delay_sel_6:2;
        RBus_UInt32  tcon_delay_sel_5:2;
        RBus_UInt32  tcon_delay_sel_4:2;
        RBus_UInt32  tcon_delay_sel_3:2;
        RBus_UInt32  tcon_delay_sel_2:2;
        RBus_UInt32  tcon_delay_sel_1:2;
        RBus_UInt32  tcon_delay_sel_0:2;
        RBus_UInt32  mlvds_rst_tcon_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  mlvds_rst_high:6;
    };
}pif_mlvds_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_low_region:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  mlvds_2ck_inv:1;
        RBus_UInt32  mlvds_1ck_inv:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  fw_merge_tcon_en:1;
        RBus_UInt32  p3_tcon_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  p3_tcon_sel:6;
        RBus_UInt32  p2_tcon_en:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  p2_tcon_sel:6;
        RBus_UInt32  p1_tcon_en:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  p1_tcon_sel:6;
    };
}pif_mlvds_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_low_0:32;
    };
}pif_mlvds_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_low_1:32;
    };
}pif_mlvds_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  plt_lvds_mode_ext:1;
        RBus_UInt32  pif_debug_sel:4;
        RBus_UInt32  plt_lvds_mode:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  lvds_pn_swap:1;
    };
}pif_lvds_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pair_sel_00:4;
        RBus_UInt32  lvds_pair_sel_01:4;
        RBus_UInt32  lvds_pair_sel_02:4;
        RBus_UInt32  lvds_pair_sel_03:4;
        RBus_UInt32  lvds_pair_sel_04:4;
        RBus_UInt32  lvds_pair_sel_05:4;
        RBus_UInt32  lvds_pair_sel_06:4;
        RBus_UInt32  lvds_pair_sel_07:4;
    };
}pif_lvds_pair_select_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pair_sel_08:4;
        RBus_UInt32  lvds_pair_sel_09:4;
        RBus_UInt32  lvds_pair_sel_10:4;
        RBus_UInt32  lvds_pair_sel_11:4;
        RBus_UInt32  lvds_pair_sel_12:4;
        RBus_UInt32  lvds_pair_sel_13:4;
        RBus_UInt32  res1:8;
    };
}pif_lvds_pair_select_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  pif_fifo_en:1;
    };
}pif_pif_fifo_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_guard_error:12;
        RBus_UInt32  res1:1;
        RBus_UInt32  fifo_vs_rst_type:2;
        RBus_UInt32  fifo_vs_rst_en:1;
        RBus_UInt32  fifo_vs_rst_delay:16;
    };
}pif_pif_fifo_rst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  pif_bist_mode_select:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  pif_bist_pattern_0:27;
    };
}pif_pif_fifo_bist_prbs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  pif_bist_length:24;
    };
}pif_pif_fifo_bist_len_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_done:1;
        RBus_UInt32  res1:30;
        RBus_UInt32  pif_bist_result:1;
    };
}pif_pif_fifo_bist_res1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  pif_bist_result_port:12;
    };
}pif_pif_fifo_bist_res2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  pif_prbs_enable:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  pif_bist_enable:1;
    };
}pif_pif_fifo_bist_ctl_RBUS;

#else //apply LITTLE_ENDIAN

//======PIF register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  lvds_bhs_sel:3;
        RBus_UInt32  lvds_bvs_sel:3;
        RBus_UInt32  lvds_bden_sel:3;
        RBus_UInt32  lvds_brsv0_sel:3;
        RBus_UInt32  lvds_brsv1_sel:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  lvds_ahs_sel:3;
        RBus_UInt32  lvds_avs_sel:3;
        RBus_UInt32  lvds_aden_sel:3;
        RBus_UInt32  lvds_arsv0_sel:3;
        RBus_UInt32  lvds_arsv1_sel:3;
    };
}pif_lvds_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d004_31_0:32;
    };
}pif_lvds_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  lvds_bport_en:1;
        RBus_UInt32  lvds_aport_en:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  lvds_map:2;
        RBus_UInt32  lvds_map_inv:1;
        RBus_UInt32  res3:17;
    };
}pif_lvds_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d00c_31_0:32;
    };
}pif_lvds_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d010_31_0:32;
    };
}pif_lvds_ctrl5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_mode:2;
        RBus_UInt32  dummy1802d014_5_2:4;
        RBus_UInt32  mlvds_map_inv:1;
        RBus_UInt32  mlvds_en:1;
        RBus_UInt32  mlvds_map_type_sel:2;
        RBus_UInt32  dummy1802d014_31_10:22;
    };
}pif_mlvds_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_reset_pul_sel:12;
        RBus_UInt32  dummy1802d018_31_12:20;
    };
}pif_mlvds_reset_pul_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_high:6;
        RBus_UInt32  res1:1;
        RBus_UInt32  mlvds_rst_tcon_en:1;
        RBus_UInt32  tcon_delay_sel_0:2;
        RBus_UInt32  tcon_delay_sel_1:2;
        RBus_UInt32  tcon_delay_sel_2:2;
        RBus_UInt32  tcon_delay_sel_3:2;
        RBus_UInt32  tcon_delay_sel_4:2;
        RBus_UInt32  tcon_delay_sel_5:2;
        RBus_UInt32  tcon_delay_sel_6:2;
        RBus_UInt32  tcon_delay_sel_7:2;
        RBus_UInt32  tcon_sel:8;
    };
}pif_mlvds_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  p1_tcon_sel:6;
        RBus_UInt32  res1:1;
        RBus_UInt32  p1_tcon_en:1;
        RBus_UInt32  p2_tcon_sel:6;
        RBus_UInt32  res2:1;
        RBus_UInt32  p2_tcon_en:1;
        RBus_UInt32  p3_tcon_sel:6;
        RBus_UInt32  res3:1;
        RBus_UInt32  p3_tcon_en:1;
        RBus_UInt32  fw_merge_tcon_en:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  mlvds_1ck_inv:1;
        RBus_UInt32  mlvds_2ck_inv:1;
        RBus_UInt32  res5:3;
        RBus_UInt32  mlvds_rst_low_region:1;
    };
}pif_mlvds_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_low_0:32;
    };
}pif_mlvds_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mlvds_rst_low_1:32;
    };
}pif_mlvds_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pn_swap:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  plt_lvds_mode:2;
        RBus_UInt32  pif_debug_sel:4;
        RBus_UInt32  plt_lvds_mode_ext:1;
        RBus_UInt32  res2:23;
    };
}pif_lvds_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lvds_pair_sel_07:4;
        RBus_UInt32  lvds_pair_sel_06:4;
        RBus_UInt32  lvds_pair_sel_05:4;
        RBus_UInt32  lvds_pair_sel_04:4;
        RBus_UInt32  lvds_pair_sel_03:4;
        RBus_UInt32  lvds_pair_sel_02:4;
        RBus_UInt32  lvds_pair_sel_01:4;
        RBus_UInt32  lvds_pair_sel_00:4;
    };
}pif_lvds_pair_select_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  lvds_pair_sel_13:4;
        RBus_UInt32  lvds_pair_sel_12:4;
        RBus_UInt32  lvds_pair_sel_11:4;
        RBus_UInt32  lvds_pair_sel_10:4;
        RBus_UInt32  lvds_pair_sel_09:4;
        RBus_UInt32  lvds_pair_sel_08:4;
    };
}pif_lvds_pair_select_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_fifo_en:1;
        RBus_UInt32  res1:31;
    };
}pif_pif_fifo_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_vs_rst_delay:16;
        RBus_UInt32  fifo_vs_rst_en:1;
        RBus_UInt32  fifo_vs_rst_type:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  fifo_guard_error:12;
    };
}pif_pif_fifo_rst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_pattern_0:27;
        RBus_UInt32  res1:1;
        RBus_UInt32  pif_bist_mode_select:3;
        RBus_UInt32  res2:1;
    };
}pif_pif_fifo_bist_prbs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_length:24;
        RBus_UInt32  res1:8;
    };
}pif_pif_fifo_bist_len_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_result:1;
        RBus_UInt32  res1:30;
        RBus_UInt32  pif_bist_done:1;
    };
}pif_pif_fifo_bist_res1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_result_port:12;
        RBus_UInt32  res1:20;
    };
}pif_pif_fifo_bist_res2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pif_bist_enable:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  pif_prbs_enable:1;
        RBus_UInt32  res2:27;
    };
}pif_pif_fifo_bist_ctl_RBUS;




#endif 


#endif 
