/**
* @file Merlin6-DesignSpec-D-Domain_histogram
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_D_HISTOGRAM_REG_H_
#define _RBUS_D_HISTOGRAM_REG_H_

#include "rbus_types.h"



//  D_HISTOGRAM Register Address
#define  D_HISTOGRAM_D_Hist_IN_CSELECT                                          0x1802ED00
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_reg_addr                                  "0xB802ED00"
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_reg                                       0xB802ED00
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_inst_addr                                 "0x0000"
#define  set_D_HISTOGRAM_D_Hist_IN_CSELECT_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_CSELECT_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_CSELECT_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_CSELECT_reg))
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_even_odd_sel_4k120_shift                  (25)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_updatelockmode_en_shift               (24)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_enable_histog_shift                   (22)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_yuv_sel_shift                         (19)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_mode_sel_shift                        (6)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_even_odd_sel_4k120_mask                   (0x02000000)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_updatelockmode_en_mask                (0x01000000)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_enable_histog_mask                    (0x00400000)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_yuv_sel_mask                          (0x00180000)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_mode_sel_mask                         (0x00000040)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_even_odd_sel_4k120(data)                  (0x02000000&((data)<<25))
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_updatelockmode_en(data)               (0x01000000&((data)<<24))
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_enable_histog(data)                   (0x00400000&((data)<<22))
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_yuv_sel(data)                         (0x00180000&((data)<<19))
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_his_mode_sel(data)                        (0x00000040&((data)<<6))
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_get_even_odd_sel_4k120(data)              ((0x02000000&(data))>>25)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_get_his_updatelockmode_en(data)           ((0x01000000&(data))>>24)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_get_his_enable_histog(data)               ((0x00400000&(data))>>22)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_get_his_yuv_sel(data)                     ((0x00180000&(data))>>19)
#define  D_HISTOGRAM_D_Hist_IN_CSELECT_get_his_mode_sel(data)                    ((0x00000040&(data))>>6)

#define  D_HISTOGRAM_D_Hist_IN_Range_Hor                                        0x1802ED04
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_reg_addr                                "0xB802ED04"
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_reg                                     0xB802ED04
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_inst_addr                               "0x0001"
#define  set_D_HISTOGRAM_D_Hist_IN_Range_Hor_reg(data)                           (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Range_Hor_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Range_Hor_reg                                 (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Range_Hor_reg))
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_his_horend_shift                        (16)
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_his_horstart_shift                      (0)
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_his_horend_mask                         (0x0FFF0000)
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_his_horstart_mask                       (0x00000FFF)
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_his_horend(data)                        (0x0FFF0000&((data)<<16))
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_his_horstart(data)                      (0x00000FFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_get_his_horend(data)                    ((0x0FFF0000&(data))>>16)
#define  D_HISTOGRAM_D_Hist_IN_Range_Hor_get_his_horstart(data)                  (0x00000FFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Range_Ver                                        0x1802ED08
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_reg_addr                                "0xB802ED08"
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_reg                                     0xB802ED08
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_inst_addr                               "0x0002"
#define  set_D_HISTOGRAM_D_Hist_IN_Range_Ver_reg(data)                           (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Range_Ver_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Range_Ver_reg                                 (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Range_Ver_reg))
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_his_verend_shift                        (16)
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_his_verstart_shift                      (0)
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_his_verend_mask                         (0x0FFF0000)
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_his_verstart_mask                       (0x00000FFF)
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_his_verend(data)                        (0x0FFF0000&((data)<<16))
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_his_verstart(data)                      (0x00000FFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_get_his_verend(data)                    ((0x0FFF0000&(data))>>16)
#define  D_HISTOGRAM_D_Hist_IN_Range_Ver_get_his_verstart(data)                  (0x00000FFF&(data))

#define  D_HISTOGRAM_D_Hist_Status                                              0x1802ED0C
#define  D_HISTOGRAM_D_Hist_Status_reg_addr                                      "0xB802ED0C"
#define  D_HISTOGRAM_D_Hist_Status_reg                                           0xB802ED0C
#define  D_HISTOGRAM_D_Hist_Status_inst_addr                                     "0x0003"
#define  set_D_HISTOGRAM_D_Hist_Status_reg(data)                                 (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Status_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_Status_reg                                       (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Status_reg))
#define  D_HISTOGRAM_D_Hist_Status_his_valid_shift                               (1)
#define  D_HISTOGRAM_D_Hist_Status_his_valid_mask                                (0x00000002)
#define  D_HISTOGRAM_D_Hist_Status_his_valid(data)                               (0x00000002&((data)<<1))
#define  D_HISTOGRAM_D_Hist_Status_get_his_valid(data)                           ((0x00000002&(data))>>1)

#define  D_HISTOGRAM_D_Hist_Max_Min                                             0x1802ED10
#define  D_HISTOGRAM_D_Hist_Max_Min_reg_addr                                     "0xB802ED10"
#define  D_HISTOGRAM_D_Hist_Max_Min_reg                                          0xB802ED10
#define  D_HISTOGRAM_D_Hist_Max_Min_inst_addr                                    "0x0004"
#define  set_D_HISTOGRAM_D_Hist_Max_Min_reg(data)                                (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Max_Min_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_Max_Min_reg                                      (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Max_Min_reg))
#define  D_HISTOGRAM_D_Hist_Max_Min_his_max_val_shift                            (16)
#define  D_HISTOGRAM_D_Hist_Max_Min_his_min_val_shift                            (0)
#define  D_HISTOGRAM_D_Hist_Max_Min_his_max_val_mask                             (0x0FFF0000)
#define  D_HISTOGRAM_D_Hist_Max_Min_his_min_val_mask                             (0x00000FFF)
#define  D_HISTOGRAM_D_Hist_Max_Min_his_max_val(data)                            (0x0FFF0000&((data)<<16))
#define  D_HISTOGRAM_D_Hist_Max_Min_his_min_val(data)                            (0x00000FFF&(data))
#define  D_HISTOGRAM_D_Hist_Max_Min_get_his_max_val(data)                        ((0x0FFF0000&(data))>>16)
#define  D_HISTOGRAM_D_Hist_Max_Min_get_his_min_val(data)                        (0x00000FFF&(data))

#define  D_HISTOGRAM_D_Hist_Dummy                                               0x1802ED14
#define  D_HISTOGRAM_D_Hist_Dummy_reg_addr                                       "0xB802ED14"
#define  D_HISTOGRAM_D_Hist_Dummy_reg                                            0xB802ED14
#define  D_HISTOGRAM_D_Hist_Dummy_inst_addr                                      "0x0005"
#define  set_D_HISTOGRAM_D_Hist_Dummy_reg(data)                                  (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Dummy_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_Dummy_reg                                        (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Dummy_reg))
#define  D_HISTOGRAM_D_Hist_Dummy_dummy_31_16_shift                              (16)
#define  D_HISTOGRAM_D_Hist_Dummy_dummy_31_16_mask                               (0xFFFF0000)
#define  D_HISTOGRAM_D_Hist_Dummy_dummy_31_16(data)                              (0xFFFF0000&((data)<<16))
#define  D_HISTOGRAM_D_Hist_Dummy_get_dummy_31_16(data)                          ((0xFFFF0000&(data))>>16)

#define  D_HISTOGRAM_D_Hist_SumVal_High                                         0x1802ED18
#define  D_HISTOGRAM_D_Hist_SumVal_High_reg_addr                                 "0xB802ED18"
#define  D_HISTOGRAM_D_Hist_SumVal_High_reg                                      0xB802ED18
#define  D_HISTOGRAM_D_Hist_SumVal_High_inst_addr                                "0x0006"
#define  set_D_HISTOGRAM_D_Hist_SumVal_High_reg(data)                            (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_SumVal_High_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_SumVal_High_reg                                  (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_SumVal_High_reg))
#define  D_HISTOGRAM_D_Hist_SumVal_High_his_sumval_high_shift                    (0)
#define  D_HISTOGRAM_D_Hist_SumVal_High_his_sumval_high_mask                     (0x000007FF)
#define  D_HISTOGRAM_D_Hist_SumVal_High_his_sumval_high(data)                    (0x000007FF&(data))
#define  D_HISTOGRAM_D_Hist_SumVal_High_get_his_sumval_high(data)                (0x000007FF&(data))

#define  D_HISTOGRAM_D_Hist_SumVal_Low                                          0x1802ED1C
#define  D_HISTOGRAM_D_Hist_SumVal_Low_reg_addr                                  "0xB802ED1C"
#define  D_HISTOGRAM_D_Hist_SumVal_Low_reg                                       0xB802ED1C
#define  D_HISTOGRAM_D_Hist_SumVal_Low_inst_addr                                 "0x0007"
#define  set_D_HISTOGRAM_D_Hist_SumVal_Low_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_SumVal_Low_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_SumVal_Low_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_SumVal_Low_reg))
#define  D_HISTOGRAM_D_Hist_SumVal_Low_his_sumval_low_shift                      (0)
#define  D_HISTOGRAM_D_Hist_SumVal_Low_his_sumval_low_mask                       (0x00FFFFFF)
#define  D_HISTOGRAM_D_Hist_SumVal_Low_his_sumval_low(data)                      (0x00FFFFFF&(data))
#define  D_HISTOGRAM_D_Hist_SumVal_Low_get_his_sumval_low(data)                  (0x00FFFFFF&(data))

#define  D_HISTOGRAM_D_Hist_Bound                                               0x1802ED20
#define  D_HISTOGRAM_D_Hist_Bound_reg_addr                                       "0xB802ED20"
#define  D_HISTOGRAM_D_Hist_Bound_reg                                            0xB802ED20
#define  D_HISTOGRAM_D_Hist_Bound_inst_addr                                      "0x0008"
#define  set_D_HISTOGRAM_D_Hist_Bound_reg(data)                                  (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Bound_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_Bound_reg                                        (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Bound_reg))
#define  D_HISTOGRAM_D_Hist_Bound_upper_bound_shift                              (16)
#define  D_HISTOGRAM_D_Hist_Bound_lower_bound_shift                              (0)
#define  D_HISTOGRAM_D_Hist_Bound_upper_bound_mask                               (0x0FFF0000)
#define  D_HISTOGRAM_D_Hist_Bound_lower_bound_mask                               (0x00000FFF)
#define  D_HISTOGRAM_D_Hist_Bound_upper_bound(data)                              (0x0FFF0000&((data)<<16))
#define  D_HISTOGRAM_D_Hist_Bound_lower_bound(data)                              (0x00000FFF&(data))
#define  D_HISTOGRAM_D_Hist_Bound_get_upper_bound(data)                          ((0x0FFF0000&(data))>>16)
#define  D_HISTOGRAM_D_Hist_Bound_get_lower_bound(data)                          (0x00000FFF&(data))

#define  D_HISTOGRAM_D_Hist_Bound_U                                             0x1802ED24
#define  D_HISTOGRAM_D_Hist_Bound_U_reg_addr                                     "0xB802ED24"
#define  D_HISTOGRAM_D_Hist_Bound_U_reg                                          0xB802ED24
#define  D_HISTOGRAM_D_Hist_Bound_U_inst_addr                                    "0x0009"
#define  set_D_HISTOGRAM_D_Hist_Bound_U_reg(data)                                (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Bound_U_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_Bound_U_reg                                      (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Bound_U_reg))
#define  D_HISTOGRAM_D_Hist_Bound_U_upper_bound_u_shift                          (16)
#define  D_HISTOGRAM_D_Hist_Bound_U_lower_bound_u_shift                          (0)
#define  D_HISTOGRAM_D_Hist_Bound_U_upper_bound_u_mask                           (0x0FFF0000)
#define  D_HISTOGRAM_D_Hist_Bound_U_lower_bound_u_mask                           (0x00000FFF)
#define  D_HISTOGRAM_D_Hist_Bound_U_upper_bound_u(data)                          (0x0FFF0000&((data)<<16))
#define  D_HISTOGRAM_D_Hist_Bound_U_lower_bound_u(data)                          (0x00000FFF&(data))
#define  D_HISTOGRAM_D_Hist_Bound_U_get_upper_bound_u(data)                      ((0x0FFF0000&(data))>>16)
#define  D_HISTOGRAM_D_Hist_Bound_U_get_lower_bound_u(data)                      (0x00000FFF&(data))

#define  D_HISTOGRAM_D_Hist_Bound_V                                             0x1802ED28
#define  D_HISTOGRAM_D_Hist_Bound_V_reg_addr                                     "0xB802ED28"
#define  D_HISTOGRAM_D_Hist_Bound_V_reg                                          0xB802ED28
#define  D_HISTOGRAM_D_Hist_Bound_V_inst_addr                                    "0x000A"
#define  set_D_HISTOGRAM_D_Hist_Bound_V_reg(data)                                (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Bound_V_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_Bound_V_reg                                      (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_Bound_V_reg))
#define  D_HISTOGRAM_D_Hist_Bound_V_upper_bound_v_shift                          (16)
#define  D_HISTOGRAM_D_Hist_Bound_V_lower_bound_v_shift                          (0)
#define  D_HISTOGRAM_D_Hist_Bound_V_upper_bound_v_mask                           (0x0FFF0000)
#define  D_HISTOGRAM_D_Hist_Bound_V_lower_bound_v_mask                           (0x00000FFF)
#define  D_HISTOGRAM_D_Hist_Bound_V_upper_bound_v(data)                          (0x0FFF0000&((data)<<16))
#define  D_HISTOGRAM_D_Hist_Bound_V_lower_bound_v(data)                          (0x00000FFF&(data))
#define  D_HISTOGRAM_D_Hist_Bound_V_get_upper_bound_v(data)                      ((0x0FFF0000&(data))>>16)
#define  D_HISTOGRAM_D_Hist_Bound_V_get_lower_bound_v(data)                      (0x00000FFF&(data))

#define  D_HISTOGRAM_D_Hist_READ_CTR                                            0x1802ED2C
#define  D_HISTOGRAM_D_Hist_READ_CTR_reg_addr                                    "0xB802ED2C"
#define  D_HISTOGRAM_D_Hist_READ_CTR_reg                                         0xB802ED2C
#define  D_HISTOGRAM_D_Hist_READ_CTR_inst_addr                                   "0x000B"
#define  set_D_HISTOGRAM_D_Hist_READ_CTR_reg(data)                               (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_READ_CTR_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_READ_CTR_reg                                     (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_READ_CTR_reg))
#define  D_HISTOGRAM_D_Hist_READ_CTR_sram_read_shift                             (3)
#define  D_HISTOGRAM_D_Hist_READ_CTR_sram_block_shift                            (1)
#define  D_HISTOGRAM_D_Hist_READ_CTR_sram_read_inconsistent_flag_shift           (0)
#define  D_HISTOGRAM_D_Hist_READ_CTR_sram_read_mask                              (0x00000008)
#define  D_HISTOGRAM_D_Hist_READ_CTR_sram_block_mask                             (0x00000006)
#define  D_HISTOGRAM_D_Hist_READ_CTR_sram_read_inconsistent_flag_mask            (0x00000001)
#define  D_HISTOGRAM_D_Hist_READ_CTR_sram_read(data)                             (0x00000008&((data)<<3))
#define  D_HISTOGRAM_D_Hist_READ_CTR_sram_block(data)                            (0x00000006&((data)<<1))
#define  D_HISTOGRAM_D_Hist_READ_CTR_sram_read_inconsistent_flag(data)           (0x00000001&(data))
#define  D_HISTOGRAM_D_Hist_READ_CTR_get_sram_read(data)                         ((0x00000008&(data))>>3)
#define  D_HISTOGRAM_D_Hist_READ_CTR_get_sram_block(data)                        ((0x00000006&(data))>>1)
#define  D_HISTOGRAM_D_Hist_READ_CTR_get_sram_read_inconsistent_flag(data)       (0x00000001&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_00                                          0x1802ED30
#define  D_HISTOGRAM_D_Hist_IN_Data_00_reg_addr                                  "0xB802ED30"
#define  D_HISTOGRAM_D_Hist_IN_Data_00_reg                                       0xB802ED30
#define  D_HISTOGRAM_D_Hist_IN_Data_00_inst_addr                                 "0x000C"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_00_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_00_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_00_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_00_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_00_hist00_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_00_hist00_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_00_hist00(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_00_get_hist00(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_01                                          0x1802ED34
#define  D_HISTOGRAM_D_Hist_IN_Data_01_reg_addr                                  "0xB802ED34"
#define  D_HISTOGRAM_D_Hist_IN_Data_01_reg                                       0xB802ED34
#define  D_HISTOGRAM_D_Hist_IN_Data_01_inst_addr                                 "0x000D"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_01_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_01_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_01_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_01_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_01_hist01_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_01_hist01_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_01_hist01(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_01_get_hist01(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_02                                          0x1802ED38
#define  D_HISTOGRAM_D_Hist_IN_Data_02_reg_addr                                  "0xB802ED38"
#define  D_HISTOGRAM_D_Hist_IN_Data_02_reg                                       0xB802ED38
#define  D_HISTOGRAM_D_Hist_IN_Data_02_inst_addr                                 "0x000E"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_02_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_02_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_02_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_02_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_02_hist02_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_02_hist02_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_02_hist02(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_02_get_hist02(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_03                                          0x1802ED3C
#define  D_HISTOGRAM_D_Hist_IN_Data_03_reg_addr                                  "0xB802ED3C"
#define  D_HISTOGRAM_D_Hist_IN_Data_03_reg                                       0xB802ED3C
#define  D_HISTOGRAM_D_Hist_IN_Data_03_inst_addr                                 "0x000F"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_03_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_03_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_03_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_03_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_03_hist03_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_03_hist03_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_03_hist03(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_03_get_hist03(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_04                                          0x1802ED40
#define  D_HISTOGRAM_D_Hist_IN_Data_04_reg_addr                                  "0xB802ED40"
#define  D_HISTOGRAM_D_Hist_IN_Data_04_reg                                       0xB802ED40
#define  D_HISTOGRAM_D_Hist_IN_Data_04_inst_addr                                 "0x0010"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_04_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_04_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_04_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_04_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_04_hist04_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_04_hist04_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_04_hist04(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_04_get_hist04(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_05                                          0x1802ED44
#define  D_HISTOGRAM_D_Hist_IN_Data_05_reg_addr                                  "0xB802ED44"
#define  D_HISTOGRAM_D_Hist_IN_Data_05_reg                                       0xB802ED44
#define  D_HISTOGRAM_D_Hist_IN_Data_05_inst_addr                                 "0x0011"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_05_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_05_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_05_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_05_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_05_hist05_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_05_hist05_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_05_hist05(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_05_get_hist05(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_06                                          0x1802ED48
#define  D_HISTOGRAM_D_Hist_IN_Data_06_reg_addr                                  "0xB802ED48"
#define  D_HISTOGRAM_D_Hist_IN_Data_06_reg                                       0xB802ED48
#define  D_HISTOGRAM_D_Hist_IN_Data_06_inst_addr                                 "0x0012"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_06_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_06_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_06_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_06_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_06_hist06_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_06_hist06_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_06_hist06(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_06_get_hist06(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_07                                          0x1802ED4C
#define  D_HISTOGRAM_D_Hist_IN_Data_07_reg_addr                                  "0xB802ED4C"
#define  D_HISTOGRAM_D_Hist_IN_Data_07_reg                                       0xB802ED4C
#define  D_HISTOGRAM_D_Hist_IN_Data_07_inst_addr                                 "0x0013"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_07_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_07_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_07_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_07_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_07_hist07_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_07_hist07_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_07_hist07(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_07_get_hist07(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_08                                          0x1802ED50
#define  D_HISTOGRAM_D_Hist_IN_Data_08_reg_addr                                  "0xB802ED50"
#define  D_HISTOGRAM_D_Hist_IN_Data_08_reg                                       0xB802ED50
#define  D_HISTOGRAM_D_Hist_IN_Data_08_inst_addr                                 "0x0014"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_08_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_08_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_08_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_08_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_08_hist08_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_08_hist08_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_08_hist08(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_08_get_hist08(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_09                                          0x1802ED54
#define  D_HISTOGRAM_D_Hist_IN_Data_09_reg_addr                                  "0xB802ED54"
#define  D_HISTOGRAM_D_Hist_IN_Data_09_reg                                       0xB802ED54
#define  D_HISTOGRAM_D_Hist_IN_Data_09_inst_addr                                 "0x0015"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_09_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_09_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_09_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_09_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_09_hist09_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_09_hist09_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_09_hist09(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_09_get_hist09(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_10                                          0x1802ED58
#define  D_HISTOGRAM_D_Hist_IN_Data_10_reg_addr                                  "0xB802ED58"
#define  D_HISTOGRAM_D_Hist_IN_Data_10_reg                                       0xB802ED58
#define  D_HISTOGRAM_D_Hist_IN_Data_10_inst_addr                                 "0x0016"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_10_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_10_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_10_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_10_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_10_hist10_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_10_hist10_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_10_hist10(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_10_get_hist10(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_11                                          0x1802ED5C
#define  D_HISTOGRAM_D_Hist_IN_Data_11_reg_addr                                  "0xB802ED5C"
#define  D_HISTOGRAM_D_Hist_IN_Data_11_reg                                       0xB802ED5C
#define  D_HISTOGRAM_D_Hist_IN_Data_11_inst_addr                                 "0x0017"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_11_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_11_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_11_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_11_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_11_hist11_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_11_hist11_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_11_hist11(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_11_get_hist11(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_12                                          0x1802ED60
#define  D_HISTOGRAM_D_Hist_IN_Data_12_reg_addr                                  "0xB802ED60"
#define  D_HISTOGRAM_D_Hist_IN_Data_12_reg                                       0xB802ED60
#define  D_HISTOGRAM_D_Hist_IN_Data_12_inst_addr                                 "0x0018"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_12_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_12_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_12_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_12_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_12_hist12_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_12_hist12_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_12_hist12(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_12_get_hist12(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_13                                          0x1802ED64
#define  D_HISTOGRAM_D_Hist_IN_Data_13_reg_addr                                  "0xB802ED64"
#define  D_HISTOGRAM_D_Hist_IN_Data_13_reg                                       0xB802ED64
#define  D_HISTOGRAM_D_Hist_IN_Data_13_inst_addr                                 "0x0019"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_13_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_13_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_13_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_13_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_13_hist13_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_13_hist13_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_13_hist13(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_13_get_hist13(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_14                                          0x1802ED68
#define  D_HISTOGRAM_D_Hist_IN_Data_14_reg_addr                                  "0xB802ED68"
#define  D_HISTOGRAM_D_Hist_IN_Data_14_reg                                       0xB802ED68
#define  D_HISTOGRAM_D_Hist_IN_Data_14_inst_addr                                 "0x001A"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_14_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_14_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_14_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_14_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_14_hist14_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_14_hist14_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_14_hist14(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_14_get_hist14(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_15                                          0x1802ED6C
#define  D_HISTOGRAM_D_Hist_IN_Data_15_reg_addr                                  "0xB802ED6C"
#define  D_HISTOGRAM_D_Hist_IN_Data_15_reg                                       0xB802ED6C
#define  D_HISTOGRAM_D_Hist_IN_Data_15_inst_addr                                 "0x001B"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_15_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_15_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_15_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_15_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_15_hist15_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_15_hist15_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_15_hist15(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_15_get_hist15(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_16                                          0x1802ED70
#define  D_HISTOGRAM_D_Hist_IN_Data_16_reg_addr                                  "0xB802ED70"
#define  D_HISTOGRAM_D_Hist_IN_Data_16_reg                                       0xB802ED70
#define  D_HISTOGRAM_D_Hist_IN_Data_16_inst_addr                                 "0x001C"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_16_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_16_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_16_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_16_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_16_hist16_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_16_hist16_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_16_hist16(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_16_get_hist16(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_17                                          0x1802ED74
#define  D_HISTOGRAM_D_Hist_IN_Data_17_reg_addr                                  "0xB802ED74"
#define  D_HISTOGRAM_D_Hist_IN_Data_17_reg                                       0xB802ED74
#define  D_HISTOGRAM_D_Hist_IN_Data_17_inst_addr                                 "0x001D"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_17_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_17_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_17_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_17_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_17_hist17_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_17_hist17_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_17_hist17(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_17_get_hist17(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_18                                          0x1802ED78
#define  D_HISTOGRAM_D_Hist_IN_Data_18_reg_addr                                  "0xB802ED78"
#define  D_HISTOGRAM_D_Hist_IN_Data_18_reg                                       0xB802ED78
#define  D_HISTOGRAM_D_Hist_IN_Data_18_inst_addr                                 "0x001E"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_18_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_18_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_18_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_18_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_18_hist18_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_18_hist18_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_18_hist18(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_18_get_hist18(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_19                                          0x1802ED7C
#define  D_HISTOGRAM_D_Hist_IN_Data_19_reg_addr                                  "0xB802ED7C"
#define  D_HISTOGRAM_D_Hist_IN_Data_19_reg                                       0xB802ED7C
#define  D_HISTOGRAM_D_Hist_IN_Data_19_inst_addr                                 "0x001F"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_19_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_19_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_19_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_19_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_19_hist19_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_19_hist19_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_19_hist19(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_19_get_hist19(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_20                                          0x1802ED80
#define  D_HISTOGRAM_D_Hist_IN_Data_20_reg_addr                                  "0xB802ED80"
#define  D_HISTOGRAM_D_Hist_IN_Data_20_reg                                       0xB802ED80
#define  D_HISTOGRAM_D_Hist_IN_Data_20_inst_addr                                 "0x0020"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_20_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_20_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_20_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_20_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_20_hist20_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_20_hist20_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_20_hist20(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_20_get_hist20(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_21                                          0x1802ED84
#define  D_HISTOGRAM_D_Hist_IN_Data_21_reg_addr                                  "0xB802ED84"
#define  D_HISTOGRAM_D_Hist_IN_Data_21_reg                                       0xB802ED84
#define  D_HISTOGRAM_D_Hist_IN_Data_21_inst_addr                                 "0x0021"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_21_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_21_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_21_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_21_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_21_hist21_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_21_hist21_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_21_hist21(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_21_get_hist21(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_22                                          0x1802ED88
#define  D_HISTOGRAM_D_Hist_IN_Data_22_reg_addr                                  "0xB802ED88"
#define  D_HISTOGRAM_D_Hist_IN_Data_22_reg                                       0xB802ED88
#define  D_HISTOGRAM_D_Hist_IN_Data_22_inst_addr                                 "0x0022"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_22_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_22_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_22_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_22_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_22_hist22_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_22_hist22_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_22_hist22(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_22_get_hist22(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_23                                          0x1802ED8C
#define  D_HISTOGRAM_D_Hist_IN_Data_23_reg_addr                                  "0xB802ED8C"
#define  D_HISTOGRAM_D_Hist_IN_Data_23_reg                                       0xB802ED8C
#define  D_HISTOGRAM_D_Hist_IN_Data_23_inst_addr                                 "0x0023"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_23_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_23_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_23_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_23_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_23_hist23_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_23_hist23_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_23_hist23(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_23_get_hist23(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_24                                          0x1802ED90
#define  D_HISTOGRAM_D_Hist_IN_Data_24_reg_addr                                  "0xB802ED90"
#define  D_HISTOGRAM_D_Hist_IN_Data_24_reg                                       0xB802ED90
#define  D_HISTOGRAM_D_Hist_IN_Data_24_inst_addr                                 "0x0024"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_24_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_24_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_24_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_24_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_24_hist24_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_24_hist24_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_24_hist24(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_24_get_hist24(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_25                                          0x1802ED94
#define  D_HISTOGRAM_D_Hist_IN_Data_25_reg_addr                                  "0xB802ED94"
#define  D_HISTOGRAM_D_Hist_IN_Data_25_reg                                       0xB802ED94
#define  D_HISTOGRAM_D_Hist_IN_Data_25_inst_addr                                 "0x0025"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_25_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_25_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_25_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_25_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_25_hist25_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_25_hist25_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_25_hist25(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_25_get_hist25(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_26                                          0x1802ED98
#define  D_HISTOGRAM_D_Hist_IN_Data_26_reg_addr                                  "0xB802ED98"
#define  D_HISTOGRAM_D_Hist_IN_Data_26_reg                                       0xB802ED98
#define  D_HISTOGRAM_D_Hist_IN_Data_26_inst_addr                                 "0x0026"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_26_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_26_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_26_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_26_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_26_hist26_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_26_hist26_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_26_hist26(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_26_get_hist26(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_27                                          0x1802ED9C
#define  D_HISTOGRAM_D_Hist_IN_Data_27_reg_addr                                  "0xB802ED9C"
#define  D_HISTOGRAM_D_Hist_IN_Data_27_reg                                       0xB802ED9C
#define  D_HISTOGRAM_D_Hist_IN_Data_27_inst_addr                                 "0x0027"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_27_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_27_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_27_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_27_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_27_hist27_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_27_hist27_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_27_hist27(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_27_get_hist27(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_28                                          0x1802EDA0
#define  D_HISTOGRAM_D_Hist_IN_Data_28_reg_addr                                  "0xB802EDA0"
#define  D_HISTOGRAM_D_Hist_IN_Data_28_reg                                       0xB802EDA0
#define  D_HISTOGRAM_D_Hist_IN_Data_28_inst_addr                                 "0x0028"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_28_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_28_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_28_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_28_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_28_hist28_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_28_hist28_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_28_hist28(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_28_get_hist28(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_29                                          0x1802EDA4
#define  D_HISTOGRAM_D_Hist_IN_Data_29_reg_addr                                  "0xB802EDA4"
#define  D_HISTOGRAM_D_Hist_IN_Data_29_reg                                       0xB802EDA4
#define  D_HISTOGRAM_D_Hist_IN_Data_29_inst_addr                                 "0x0029"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_29_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_29_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_29_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_29_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_29_hist29_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_29_hist29_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_29_hist29(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_29_get_hist29(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_30                                          0x1802EDA8
#define  D_HISTOGRAM_D_Hist_IN_Data_30_reg_addr                                  "0xB802EDA8"
#define  D_HISTOGRAM_D_Hist_IN_Data_30_reg                                       0xB802EDA8
#define  D_HISTOGRAM_D_Hist_IN_Data_30_inst_addr                                 "0x002A"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_30_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_30_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_30_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_30_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_30_hist30_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_30_hist30_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_30_hist30(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_30_get_hist30(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_Hist_IN_Data_31                                          0x1802EDAC
#define  D_HISTOGRAM_D_Hist_IN_Data_31_reg_addr                                  "0xB802EDAC"
#define  D_HISTOGRAM_D_Hist_IN_Data_31_reg                                       0xB802EDAC
#define  D_HISTOGRAM_D_Hist_IN_Data_31_inst_addr                                 "0x002B"
#define  set_D_HISTOGRAM_D_Hist_IN_Data_31_reg(data)                             (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_31_reg)=data)
#define  get_D_HISTOGRAM_D_Hist_IN_Data_31_reg                                   (*((volatile unsigned int*)D_HISTOGRAM_D_Hist_IN_Data_31_reg))
#define  D_HISTOGRAM_D_Hist_IN_Data_31_hist31_shift                              (0)
#define  D_HISTOGRAM_D_Hist_IN_Data_31_hist31_mask                               (0x007FFFFF)
#define  D_HISTOGRAM_D_Hist_IN_Data_31_hist31(data)                              (0x007FFFFF&(data))
#define  D_HISTOGRAM_D_Hist_IN_Data_31_get_hist31(data)                          (0x007FFFFF&(data))

#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL                                  0x1802EDB0
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_reg_addr                          "0xB802EDB0"
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_reg                               0xB802EDB0
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_inst_addr                         "0x002C"
#define  set_D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_reg(data)                     (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_reg)=data)
#define  get_D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_reg                           (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_reg))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_mbist_hist_2p_bist_fail_shift     (3)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_mbist_hist_2p_bist_fail_mask      (0x00000008)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_mbist_hist_2p_bist_fail(data)     (0x00000008&((data)<<3))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_FAIL_get_mbist_hist_2p_bist_fail(data) ((0x00000008&(data))>>3)

#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL                                  0x1802EDB4
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_reg_addr                          "0xB802EDB4"
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_reg                               0xB802EDB4
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_inst_addr                         "0x002D"
#define  set_D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_reg(data)                     (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_reg)=data)
#define  get_D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_reg                           (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_reg))
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_mbist_hist_1p_bist_fail_shift     (3)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_mbist_hist_1p_bist_fail_mask      (0x00000008)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_mbist_hist_1p_bist_fail(data)     (0x00000008&((data)<<3))
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_FAIL_get_mbist_hist_1p_bist_fail(data) ((0x00000008&(data))>>3)

#define  D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL                                   0x1802EDB8
#define  D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_reg_addr                           "0xB802EDB8"
#define  D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_reg                                0xB802EDB8
#define  D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_inst_addr                          "0x002E"
#define  set_D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_reg(data)                      (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_reg)=data)
#define  get_D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_reg                            (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_reg))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_mbist_hist_2p_drf_fail_shift       (3)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_mbist_hist_2p_drf_fail_mask        (0x00000008)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_mbist_hist_2p_drf_fail(data)       (0x00000008&((data)<<3))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_DRF_FAIL_get_mbist_hist_2p_drf_fail(data)   ((0x00000008&(data))>>3)

#define  D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL                                   0x1802EDBC
#define  D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_reg_addr                           "0xB802EDBC"
#define  D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_reg                                0xB802EDBC
#define  D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_inst_addr                          "0x002F"
#define  set_D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_reg(data)                      (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_reg)=data)
#define  get_D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_reg                            (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_reg))
#define  D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_mbist_hist_1p_drf_fail_shift       (3)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_mbist_hist_1p_drf_fail_mask        (0x00000008)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_mbist_hist_1p_drf_fail(data)       (0x00000008&((data)<<3))
#define  D_HISTOGRAM_D_MBIST_HIST_1P_DRF_FAIL_get_mbist_hist_1p_drf_fail(data)   ((0x00000008&(data))>>3)

#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE                                  0x1802EDC0
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_reg_addr                          "0xB802EDC0"
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_reg                               0xB802EDC0
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_inst_addr                         "0x0030"
#define  set_D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_reg(data)                     (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_reg)=data)
#define  get_D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_reg                           (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_reg))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_ls_shift       (3)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_testrwm_shift  (2)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_dvse_shift     (1)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_test0_shift    (0)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_ls_mask        (0x00000008)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_testrwm_mask   (0x00000004)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_dvse_mask      (0x00000002)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_test0_mask     (0x00000001)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_ls(data)       (0x00000008&((data)<<3))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_testrwm(data)  (0x00000004&((data)<<2))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_dvse(data)     (0x00000002&((data)<<1))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_mbist_hist_2p_bist_test0(data)    (0x00000001&(data))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_get_mbist_hist_2p_bist_ls(data)   ((0x00000008&(data))>>3)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_get_mbist_hist_2p_bist_testrwm(data) ((0x00000004&(data))>>2)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_get_mbist_hist_2p_bist_dvse(data) ((0x00000002&(data))>>1)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVSE_get_mbist_hist_2p_bist_test0(data) (0x00000001&(data))

#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE                                  0x1802EDC4
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_reg_addr                          "0xB802EDC4"
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_reg                               0xB802EDC4
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_inst_addr                         "0x0031"
#define  set_D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_reg(data)                     (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_reg)=data)
#define  get_D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_reg                           (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_reg))
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_mbist_hist_1p_bist_ls_shift       (2)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_mbist_hist_1p_bist_dvse_shift     (1)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_mbist_hist_1p_bist_test0_shift    (0)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_mbist_hist_1p_bist_ls_mask        (0x00000004)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_mbist_hist_1p_bist_dvse_mask      (0x00000002)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_mbist_hist_1p_bist_test0_mask     (0x00000001)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_mbist_hist_1p_bist_ls(data)       (0x00000004&((data)<<2))
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_mbist_hist_1p_bist_dvse(data)     (0x00000002&((data)<<1))
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_mbist_hist_1p_bist_test0(data)    (0x00000001&(data))
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_get_mbist_hist_1p_bist_ls(data)   ((0x00000004&(data))>>2)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_get_mbist_hist_1p_bist_dvse(data) ((0x00000002&(data))>>1)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVSE_get_mbist_hist_1p_bist_test0(data) (0x00000001&(data))

#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS                                   0x1802EDC8
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_reg_addr                           "0xB802EDC8"
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_reg                                0xB802EDC8
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_inst_addr                          "0x0032"
#define  set_D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_reg(data)                      (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_reg)=data)
#define  get_D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_reg                            (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_reg))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_mbist_hist_2p_bist_dvs_shift       (8)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_mbist_hist_2p_bist_dvs_mask        (0x00000F00)
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_mbist_hist_2p_bist_dvs(data)       (0x00000F00&((data)<<8))
#define  D_HISTOGRAM_D_MBIST_HIST_2P_BIST_DVS_get_mbist_hist_2p_bist_dvs(data)   ((0x00000F00&(data))>>8)

#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS                                   0x1802EDCC
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_reg_addr                           "0xB802EDCC"
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_reg                                0xB802EDCC
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_inst_addr                          "0x0033"
#define  set_D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_reg(data)                      (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_reg)=data)
#define  get_D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_reg                            (*((volatile unsigned int*)D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_reg))
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_mbist_hist_1p_bist_dvs_shift       (12)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_mbist_hist_1p_bist_dvs_mask        (0x0000F000)
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_mbist_hist_1p_bist_dvs(data)       (0x0000F000&((data)<<12))
#define  D_HISTOGRAM_D_MBIST_HIST_1P_BIST_DVS_get_mbist_hist_1p_bist_dvs(data)   ((0x0000F000&(data))>>12)

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======D_HISTOGRAM register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  even_odd_sel_4k120:1;
        RBus_UInt32  his_updatelockmode_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  his_enable_histog:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  his_yuv_sel:2;
        RBus_UInt32  res4:12;
        RBus_UInt32  his_mode_sel:1;
        RBus_UInt32  res5:6;
    };
}d_histogram_d_hist_in_cselect_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  his_horend:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  his_horstart:12;
    };
}d_histogram_d_hist_in_range_hor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  his_verend:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  his_verstart:12;
    };
}d_histogram_d_hist_in_range_ver_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  his_valid:1;
        RBus_UInt32  res2:1;
    };
}d_histogram_d_hist_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  his_max_val:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  his_min_val:12;
    };
}d_histogram_d_hist_max_min_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802ed14_31_16:16;
        RBus_UInt32  res1:16;
    };
}d_histogram_d_hist_dummy_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  his_sumval_high:11;
    };
}d_histogram_d_hist_sumval_high_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  his_sumval_low:24;
    };
}d_histogram_d_hist_sumval_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  upper_bound:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  lower_bound:12;
    };
}d_histogram_d_hist_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  upper_bound_u:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  lower_bound_u:12;
    };
}d_histogram_d_hist_bound_u_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  upper_bound_v:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  lower_bound_v:12;
    };
}d_histogram_d_hist_bound_v_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  sram_read:1;
        RBus_UInt32  sram_block:2;
        RBus_UInt32  sram_read_inconsistent_flag:1;
    };
}d_histogram_d_hist_read_ctr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist00:23;
    };
}d_histogram_d_hist_in_data_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist01:23;
    };
}d_histogram_d_hist_in_data_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist02:23;
    };
}d_histogram_d_hist_in_data_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist03:23;
    };
}d_histogram_d_hist_in_data_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist04:23;
    };
}d_histogram_d_hist_in_data_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist05:23;
    };
}d_histogram_d_hist_in_data_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist06:23;
    };
}d_histogram_d_hist_in_data_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist07:23;
    };
}d_histogram_d_hist_in_data_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist08:23;
    };
}d_histogram_d_hist_in_data_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist09:23;
    };
}d_histogram_d_hist_in_data_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist10:23;
    };
}d_histogram_d_hist_in_data_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist11:23;
    };
}d_histogram_d_hist_in_data_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist12:23;
    };
}d_histogram_d_hist_in_data_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist13:23;
    };
}d_histogram_d_hist_in_data_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist14:23;
    };
}d_histogram_d_hist_in_data_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist15:23;
    };
}d_histogram_d_hist_in_data_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist16:23;
    };
}d_histogram_d_hist_in_data_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist17:23;
    };
}d_histogram_d_hist_in_data_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist18:23;
    };
}d_histogram_d_hist_in_data_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist19:23;
    };
}d_histogram_d_hist_in_data_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist20:23;
    };
}d_histogram_d_hist_in_data_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist21:23;
    };
}d_histogram_d_hist_in_data_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist22:23;
    };
}d_histogram_d_hist_in_data_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist23:23;
    };
}d_histogram_d_hist_in_data_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist24:23;
    };
}d_histogram_d_hist_in_data_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist25:23;
    };
}d_histogram_d_hist_in_data_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist26:23;
    };
}d_histogram_d_hist_in_data_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist27:23;
    };
}d_histogram_d_hist_in_data_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist28:23;
    };
}d_histogram_d_hist_in_data_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist29:23;
    };
}d_histogram_d_hist_in_data_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist30:23;
    };
}d_histogram_d_hist_in_data_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hist31:23;
    };
}d_histogram_d_hist_in_data_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  mbist_hist_2p_bist_fail:1;
        RBus_UInt32  res2:3;
    };
}d_histogram_d_mbist_hist_2p_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  mbist_hist_1p_bist_fail:1;
        RBus_UInt32  res2:3;
    };
}d_histogram_d_mbist_hist_1p_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  mbist_hist_2p_drf_fail:1;
        RBus_UInt32  res2:3;
    };
}d_histogram_d_mbist_hist_2p_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  mbist_hist_1p_drf_fail:1;
        RBus_UInt32  res2:3;
    };
}d_histogram_d_mbist_hist_1p_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  mbist_hist_2p_bist_ls:1;
        RBus_UInt32  mbist_hist_2p_bist_testrwm:1;
        RBus_UInt32  mbist_hist_2p_bist_dvse:1;
        RBus_UInt32  mbist_hist_2p_bist_test0:1;
    };
}d_histogram_d_mbist_hist_2p_bist_dvse_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  mbist_hist_1p_bist_ls:1;
        RBus_UInt32  mbist_hist_1p_bist_dvse:1;
        RBus_UInt32  mbist_hist_1p_bist_test0:1;
    };
}d_histogram_d_mbist_hist_1p_bist_dvse_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  mbist_hist_2p_bist_dvs:4;
        RBus_UInt32  res2:8;
    };
}d_histogram_d_mbist_hist_2p_bist_dvs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  mbist_hist_1p_bist_dvs:4;
        RBus_UInt32  res2:12;
    };
}d_histogram_d_mbist_hist_1p_bist_dvs_RBUS;

#else //apply LITTLE_ENDIAN

//======D_HISTOGRAM register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  his_mode_sel:1;
        RBus_UInt32  res2:12;
        RBus_UInt32  his_yuv_sel:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  his_enable_histog:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  his_updatelockmode_en:1;
        RBus_UInt32  even_odd_sel_4k120:1;
        RBus_UInt32  res5:6;
    };
}d_histogram_d_hist_in_cselect_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  his_horstart:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  his_horend:12;
        RBus_UInt32  res2:4;
    };
}d_histogram_d_hist_in_range_hor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  his_verstart:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  his_verend:12;
        RBus_UInt32  res2:4;
    };
}d_histogram_d_hist_in_range_ver_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  his_valid:1;
        RBus_UInt32  res2:30;
    };
}d_histogram_d_hist_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  his_min_val:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  his_max_val:12;
        RBus_UInt32  res2:4;
    };
}d_histogram_d_hist_max_min_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  dummy1802ed14_31_16:16;
    };
}d_histogram_d_hist_dummy_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  his_sumval_high:11;
        RBus_UInt32  res1:21;
    };
}d_histogram_d_hist_sumval_high_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  his_sumval_low:24;
        RBus_UInt32  res1:8;
    };
}d_histogram_d_hist_sumval_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lower_bound:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  upper_bound:12;
        RBus_UInt32  res2:4;
    };
}d_histogram_d_hist_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lower_bound_u:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  upper_bound_u:12;
        RBus_UInt32  res2:4;
    };
}d_histogram_d_hist_bound_u_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lower_bound_v:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  upper_bound_v:12;
        RBus_UInt32  res2:4;
    };
}d_histogram_d_hist_bound_v_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sram_read_inconsistent_flag:1;
        RBus_UInt32  sram_block:2;
        RBus_UInt32  sram_read:1;
        RBus_UInt32  res1:28;
    };
}d_histogram_d_hist_read_ctr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist00:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist01:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist02:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist03:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist04:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist05:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist06:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist07:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist08:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist09:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist10:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist11:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist12:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist13:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist14:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist15:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist16:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist17:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist18:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist19:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist20:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist21:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist22:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist23:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist24:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist25:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist26:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist27:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist28:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist29:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist30:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hist31:23;
        RBus_UInt32  res1:9;
    };
}d_histogram_d_hist_in_data_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  mbist_hist_2p_bist_fail:1;
        RBus_UInt32  res2:28;
    };
}d_histogram_d_mbist_hist_2p_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  mbist_hist_1p_bist_fail:1;
        RBus_UInt32  res2:28;
    };
}d_histogram_d_mbist_hist_1p_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  mbist_hist_2p_drf_fail:1;
        RBus_UInt32  res2:28;
    };
}d_histogram_d_mbist_hist_2p_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  mbist_hist_1p_drf_fail:1;
        RBus_UInt32  res2:28;
    };
}d_histogram_d_mbist_hist_1p_drf_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_hist_2p_bist_test0:1;
        RBus_UInt32  mbist_hist_2p_bist_dvse:1;
        RBus_UInt32  mbist_hist_2p_bist_testrwm:1;
        RBus_UInt32  mbist_hist_2p_bist_ls:1;
        RBus_UInt32  res1:28;
    };
}d_histogram_d_mbist_hist_2p_bist_dvse_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_hist_1p_bist_test0:1;
        RBus_UInt32  mbist_hist_1p_bist_dvse:1;
        RBus_UInt32  mbist_hist_1p_bist_ls:1;
        RBus_UInt32  res1:29;
    };
}d_histogram_d_mbist_hist_1p_bist_dvse_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  mbist_hist_2p_bist_dvs:4;
        RBus_UInt32  res2:20;
    };
}d_histogram_d_mbist_hist_2p_bist_dvs_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  mbist_hist_1p_bist_dvs:4;
        RBus_UInt32  res2:16;
    };
}d_histogram_d_mbist_hist_1p_bist_dvs_RBUS;




#endif 


#endif 
