#ifndef __QC_VERIFY_H__
#define __QC_VERIFY_H__

#include "qc_verify_common.h"

#if (UART_PORT == 0)
#define GETCHAR_ESC (0x1B == rtd_inl(0x18062300)) //UART0
#else
#define GETCHAR_ESC (0x1B == rtd_inl(0x1801b100)) //UART1
#endif

extern void qc_verify(int option);

//timer
#define TC7TVR 0xb801B61C
#define TC7CVR 0xb801B64C
#define TC7CR  0xb801B67C
#define TCICR  0xb801B6A0
#define TCWCR  0xb8062204
#define TCWTR  0xb8062208
#define TCWOV  0xb8062210


/* extern QC related functions */
#if CONFIG_QC_SCPU
extern int QC_Verifier_SCPU(void);
#endif

#if CONFIG_QC_ACPU
extern int QC_Verifier_ACPU(void);
#endif

#if CONFIG_QC_GPU
extern int QC_Verifier_GPU(void);
#endif

#if CONFIG_QC_VE
extern int QC_Verifier_VE(void);
#endif

#if CONFIG_QC_VDE
extern int QC_Verifier_VDE(void);
#endif

#if CONFIG_QC_VE_Encode
extern int QC_Verifier_VE_Encode(void);
#endif

#if CONFIG_QC_8051
extern int QC_Verifier_8051(void);
#endif

#if CONFIG_QC_SE
extern int QC_Verifier_SE(void);
#endif

#if CONFIG_QC_MD
extern int QC_Verifier_MD(void);
#endif

#if CONFIG_QC_CP
extern int QC_Verifier_CP(void);
#endif

#if CONFIG_QC_AUDIO
extern int QC_Verifier_AUDIO(void);
#endif

#if CONFIG_QC_ETN
extern int QC_Verifier_ETN(void);
#endif

#if CONFIG_QC_HDMI
extern int QC_Verifier_HDMI(void);
#endif

#if CONFIG_QC_HDMI_TX
extern int QC_Verifier_HDMI_TX(void);
#endif

#if CONFIG_QC_CEC
extern int QC_Verifier_CEC(void);
#endif

#if CONFIG_QC_IFD
extern int QC_Verifier_IFD(void);
#endif

#if CONFIG_QC_EMMC
extern int QC_Verifier_EMMC(void);
#endif

#if CONFIG_QC_MEMC
extern int QC_Verifier_MEMC(void);
#endif

#if CONFIG_QC_Dolby_HDR
extern int QC_Verifier_Dolby_HDR(void);
#endif

#if CONFIG_QC_NAND
extern int QC_Verifier_NAND(void);
#endif

#if CONFIG_QC_SPI
extern int QC_Verifier_SPI(void);
#endif

#if CONFIG_QC_USB
extern int QC_Verifier_USB(void);
#endif

#if CONFIG_QC_VIP
extern int QC_Verifier_VIP(void);
#endif

#if CONFIG_QC_VDC_TOP
extern int QC_Verifier_VDC_Top(void);
#endif

#if CONFIG_QC_VDC_PQ
extern int QC_Verifier_VDC_PQ(void);
#endif

#if CONFIG_QC_VBI
extern int QC_Verifier_VBI(void);
#endif

#if CONFIG_QC_I_DOMAIN
extern int QC_Verifier_I_Domain(void);
#endif

#if CONFIG_QC_MD_DOMAIN
extern int QC_Verifier_MD_Domain(void);
#endif

#if CONFIG_QC_PERIPHERAL
extern int QC_Verifier_PERIPHERAL(void);
#endif

#if CONFIG_QC_I3DDMA
extern int QC_Verifier_I3DDMA(void);
#endif

#if CONFIG_QC_BISR
extern int QC_Verifier_BISR(void);
#endif

#if CONFIG_QC_BIST
extern int QC_Verifier_BIST(void);
#endif

#if CONFIG_QC_TVE
extern int QC_Verifier_TVE(void);
#endif

#if CONFIG_QC_MHL
extern int QC_Verifier_MHL(void);
#endif

#if CONFIG_QC_DDR
extern int QC_Verifier_DDR(void);
#endif

#if CONFIG_QC_STANDBY
extern int QC_Verifier_Standby(void);
#endif

#if CONFIG_QC_SPI_NAND
extern int QC_Verifier_SPI_Nand(void);
#endif

#if CONFIG_QC_CARDREADER
extern int QC_Verifier_CardReader(void);
#endif

#if CONFIG_QC_CBUS_RX
extern int QC_Verifier_CBUS_RX(void);
#endif

#if CONFIG_QC_eCBUS_TX_Test
extern int QC_Verifier_eCBUS_TX_Test(void);
#endif

#if CONFIG_QC_MHL_TX_CBUS
extern int QC_Verifier_MHL_TX_CBUS(void);
#endif

#if CONFIG_QC_MULTI_CORE_TEST
extern int QC_Verifier_Multi_Core(void);
#endif

#if CONFIG_QC_OTP
extern int QC_Verifier_OTP(void);
#endif

#if CONFIG_QC_VP9
extern int QC_Verifier_VP9(void);
#endif

#if CONFIG_QC_OTP_SW_KEY
extern int QC_Verifier_OTP_SW_key(void);
#endif

#if CONFIG_QC_I2RND
extern int QC_Verifier_I2Rnd(void);
#endif

#if CONFIG_QC_LZMA
extern int QC_Verifier_LZMA(void);
#endif

typedef struct
{
	char entry_name[64];
	int (*entry_function)(void);
	UINT8 SW_Bin_no;
} QC_IP_VERIFY_ENTRY_T;

#define QC_IP_VERIFY_ENTRY(x)		QC_IP_VERIFY_ENTRY_T __qc_verify_entry__ x##entery = {	\
										#x,						\
										x						\
								};


#endif /* __QC_VERIFY_H__ */
