#include "hdmi_common.h"
#if 0
#include <linux/kernel.h>
#include <linux/delay.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/slab.h>
#include <asm/uaccess.h>
#include <linux/sched.h>
#include <linux/kthread.h>
#include <linux/string.h>
#include <rtk_kdriver/rtk_hdcp_otp_util.h>
#include <mach/rtk_platform.h>
#endif
#include "hdmi_reg.h"
#include "hdmi_hdcp.h"

extern HDMI_PORT_INFO_T hdmi_rx[HDMI_PORT_TOTAL_NUM];

#if HDCP2_2
unsigned int hdcp2_disable = 0;
#else
unsigned int hdcp2_disable = 1;
#endif


#define HDCP_RESET_CNT          30     //The counter for keeping HDCP 1.4 or 2.2 in no signal state, if timeout, turn on both 1.4 & 2.2


void lib_hdmi_hdcp_init(unsigned char nport)
{
	// Disable HDCP and clear HDCP address
	//hdmi_out(HDMI_HDCP_CR_reg, (HDMI_HDCP_CR_maddf_mask|HDMI_HDCP_CR_dkapde_mask));
    hdmi_mask(HDMI_HDCP_CR_reg, ~(HDMI_HDCP_CR_hdcp_clk_switch_auto_mask), HDMI_HDCP_CR_hdcp_clk_switch_auto_mask);

    hdmi_mask(HDMI_HDCP_PCR_reg, ~(HDMI_HDCP_PCR_enc_tog_mask), 0);

#if 1 /*defined (ENABLE_HDMI_1_1_SUPPORT)*/ /* must set in hdcp cts1.4 */
	lib_hdmi_hdcp_port_write(nport, 0x40, HDCP_11_HDMI);				//set OESS for DVI
	lib_hdmi_hdcp_port_write(nport, 0x40, HDCP_11_HDMI|_BIT6);	//Merlin2: bug: default repeater on
	lib_hdmi_hdcp_port_write(nport, 0x43, 0x0);			//Merlin2: bug: default repeater on
	lib_hdmi_hdcp_port_write(nport, 0x40, HDCP_11_HDMI);		//Merlin2: bug: default repeater on
#else
	Hdmi_HdcpPortWrite(0x40,HDCP_10_DVI);				//set OESS for DVI
#endif

#if HDCP2_2
    hdmi_rx[nport].hdcp2_disable = hdcp2_disable;
    lib_hdmi_hdcp_port_write(nport, 0x50, (hdmi_rx[nport].hdcp2_disable) ? 0x00: 0x04);    //support hdcp2.2       
#endif

#if 0
	hdmi_mask(HDMI_HDCP_PCR_reg, ~HDMI_HDCP_PCR_apai_mask, 0);
	hdmi_out(HDMI_HDCP_AP_reg, 0x00);

	for (i = 0; i < 640; i++) {
		hdmi_out(HDMI_HDCP_AP_reg, 0x43 + (i<<8));
		hdmi_out(HDMI_HDCP_DP_reg, 0x00);
	}

	hdmi_out(HDMI_HDCP_AP_reg, 0x00);
	hdmi_mask(HDMI_HDCP_PCR_reg, ~HDMI_HDCP_PCR_apai_mask, HDMI_HDCP_PCR_apai_mask);
#endif

    hdmi_mask(HDMI_HDCP_CR_reg, ~(HDMI_HDCP_CR_namfe_mask), (HDMI_HDCP_CR_namfe_mask)); //for New_AC_Mode Enable,fix simplay bug
}


void lib_hdmi_write_hdcpkey(unsigned char nport, unsigned char *bksv, unsigned char *hdcp_key)
{
	unsigned int i;

	// Disable HDCP and clear HDCP address
	hdmi_mask(HDMI_HDCP_CR_reg,
        ~(HDMI_HDCP_CR_ivspm_mask|
           HDMI_HDCP_CR_invvs_mask|
           HDMI_HDCP_CR_ivsp_mask|
           HDMI_HDCP_CR_rpt_mask|
           HDMI_HDCP_CR_namfe_mask),
           0);

    hdmi_mask(HDMI_STB_HDCP_CR_reg,
        ~(HDMI_STB_HDCP_CR_hdcp_en_mask|
          HDMI_STB_HDCP_CR_dkapde_mask|
          HDMI_STB_HDCP_CR_maddf_mask), 
          HDMI_STB_HDCP_CR_maddf_mask|
          HDMI_STB_HDCP_CR_dkapde_mask);
          

	
         //  HDMI_HDCP_CR_namfe_mask) , HDMI_HDCP_CR_maddf_mask|HDMI_HDCP_CR_dkapde_mask);

	lib_hdmi_hdcp_port_write_conti(nport, 0x00, bksv, 5);	//set KSV 40 bits

	/*Write device private key*/
	for(i=0; i<320; i++) {
#ifdef CONFIG_HDCP_KEY_PRINT
		if (i% 8 == 0) HDMI_PRINTF("\n");
		HDMI_PRINTF("%x ", hdcp_key[i]);
#endif //#ifdef CONFIG_HDCP_KEY_PRINT

		hdmi_out(HDMI_STB_HDCP_DKAP_reg, hdcp_key[i]);
	}

    lib_hdmi_hdcp_toggle_dkapde(nport);

#if 0//def CONFIG_HDCP_KEY_PRINT
	HDMI_PRINTF("\n =================================================== =");

	hdmi_mask(HDMI_HDCP_CR_reg,
    ~(HDMI_HDCP_CR_hdcp_en_mask|HDMI_HDCP_CR_dkapde_mask|HDMI_STB_HDCP_CR_maddf_mask|HDMI_HDCP_CR_ivspm_mask|
    HDMI_HDCP_CR_invvs_mask|HDMI_HDCP_CR_ivsp_mask|HDMI_HDCP_CR_rpt_mask|HDMI_HDCP_CR_namfe_mask)
    ,HDMI_STB_HDCP_CR_maddf_mask|HDMI_HDCP_CR_dkapde_mask);

	HDMI_PRINTF("\n i=%d  HDMI BKSV Flag = %x, %x ,%x ,%x, %x \n",
	       i ,
	       lib_hdmi_hdcp_port_read(nport, 0x00),
	       lib_hdmi_hdcp_port_read(nport, 0x01),
	       lib_hdmi_hdcp_port_read(nport, 0x02),
	       lib_hdmi_hdcp_port_read(nport, 0x03),
	       lib_hdmi_hdcp_port_read(nport, 0x04));
	HDMI_PRINTF("HDCP key 320 byte read ");
	for(i=0; i<320; i++) {
		if (i% 16 == 0) HDMI_PRINTF("\n");
		HDMI_PRINTF("%x ", hdmi_in(HDMI_STB_HDCP_DKAP_reg));
	}

#endif //#ifdef CONFIG_HDCP_KEY_PRINT


    hdmi_mask(HDMI_HDCP_CR_reg,
            ~(HDMI_HDCP_CR_ivspm_mask|
              HDMI_HDCP_CR_invvs_mask|
              HDMI_HDCP_CR_ivsp_mask|
              HDMI_HDCP_CR_rpt_mask|
              HDMI_HDCP_CR_namfe_mask), 
              0x00);
    
    hdmi_mask(HDMI_STB_HDCP_CR_reg,
            ~(HDMI_STB_HDCP_CR_hdcp_en_mask|
              HDMI_STB_HDCP_CR_dkapde_mask|
              HDMI_STB_HDCP_CR_maddf_mask), 0x00);    

    hdmi_mask(HDMI_HDCP_CR_reg, ~(HDMI_HDCP_CR_namfe_mask), (HDMI_HDCP_CR_namfe_mask)); //for New_AC_Mode Enable,fix simplay bug

}

void lib_hdmi_read_hdcpkey(unsigned char nport, unsigned char *bksv, unsigned char *hdcp_key)
{
	unsigned int i;
	unsigned char reg_bak;

	reg_bak = hdmi_in(HDMI_HDCP_CR_reg);
	// Disable HDCP and clear HDCP address

    hdmi_mask(HDMI_HDCP_CR_reg,
            ~(HDMI_HDCP_CR_ivspm_mask|
              HDMI_HDCP_CR_invvs_mask|
              HDMI_HDCP_CR_ivsp_mask|
              HDMI_HDCP_CR_rpt_mask|
              HDMI_HDCP_CR_namfe_mask), 0x00);
    
    hdmi_mask(HDMI_STB_HDCP_CR_reg,
            ~(HDMI_STB_HDCP_CR_hdcp_en_mask|
              HDMI_STB_HDCP_CR_dkapde_mask|
              HDMI_STB_HDCP_CR_maddf_mask), 0x00);

    hdmi_mask(HDMI_STB_HDCP_CR_reg,
            ~(HDMI_STB_HDCP_CR_hdcp_en_mask|
              HDMI_STB_HDCP_CR_dkapde_mask|
              HDMI_STB_HDCP_CR_maddf_mask),
              HDMI_STB_HDCP_CR_maddf_mask|
              HDMI_STB_HDCP_CR_dkapde_mask);

    for (i=0; i<5; i++)
		bksv[i] = lib_hdmi_hdcp_port_read(nport, i);

	bksv[5] = bksv[6] = bksv[7] = 0;

    for(i=0; i<320; i++)
		hdcp_key[i] = hdmi_in(HDMI_STB_HDCP_DKAP_reg);

#if defined(CONFIG_HDCP_KEY_PRINT)
	HDMI_PRINTF("\nHDCP BKSV Flag = %x, %x ,%x ,%x, %x \n",
	            bksv[0],
	            bksv[1],
	            bksv[2],
	            bksv[3],
	            bksv[4]);
	HDMI_PRINTF("HDCP key 320 byte read=\n");
	for(i=0; i<320; i++) {
		if (i% 16 == 0) HDMI_PRINTF("\n");
		HDMI_PRINTF("%x ",  hdcp_key[i]);
	}
#endif //#ifdef CONFIG_HDCP_KEY_PRINT

	hdmi_out(HDMI_HDCP_CR_reg, reg_bak);

    lib_hdmi_hdcp_toggle_dkapde(nport);

}


void lib_hdmi_hdcp14_enable(unsigned char nport, unsigned char on)
{
	if (on) {
        hdmi_mask(HDMI_STB_HDCP_CR_reg, ~HDMI_STB_HDCP_CR_hdcp_en_mask, HDMI_STB_HDCP_CR_hdcp_en_mask);
        lib_hdmi_hdcp_toggle_dkapde(nport);  // toggle dkapde
	} else {
        hdmi_mask(HDMI_STB_HDCP_CR_reg, ~HDMI_STB_HDCP_CR_hdcp_en_mask, 0);
        lib_hdmi_hdcp_toggle_dkapde(nport);  // toggle dkapde
	}
}

unsigned char lib_hdmi_hdcp14_is_onoff(unsigned char nport)
{
    return HDMI_STB_HDCP_CR_get_hdcp_en(hdmi_in(HDMI_STB_HDCP_CR_reg));
}

unsigned char lib_hdmi_hdcp14_check_aksv_reg(unsigned char nport)
{
	return HDMI_STB_HDCP_FLAG1_get_wr_aksv_flag(hdmi_in(HDMI_STB_HDCP_FLAG1_reg));
}

void lib_hdmi_hdcp14_clear_aksv_reg(unsigned char nport)
{
	 hdmi_out(HDMI_STB_HDCP_FLAG1_reg, HDMI_STB_HDCP_FLAG1_wr_aksv_flag_mask);
}

unsigned char lib_hdmi_hdcp14_check_akm_reg(unsigned char nport)
{
    return HDMI_STB_HDCP_FLAG1_get_akm_flag(hdmi_in(HDMI_STB_HDCP_FLAG1_reg));
}

void lib_hdmi_hdcp14_clear_akm_reg(unsigned char nport)
{
    hdmi_out(HDMI_STB_HDCP_FLAG1_reg, HDMI_STB_HDCP_FLAG1_akm_flag_mask);
}

unsigned char lib_hdmi_hdcp14_check_bksv_reg(unsigned char nport)
{
	return HDMI_STB_HDCP_FLAG1_get_rd_bksv_flag(hdmi_in(HDMI_STB_HDCP_FLAG1_reg));
}

void lib_hdmi_hdcp14_clear_bksv_reg(unsigned char nport)
{
    hdmi_out(HDMI_STB_HDCP_FLAG1_reg, HDMI_STB_HDCP_FLAG1_reg);
}

void lib_hdmi_hdcp_port_write_conti(unsigned char nport, unsigned char addr, const unsigned char* value, unsigned char num)
{
   unsigned char bit0_tmp;
    bit0_tmp = HDMI_STB_HDCP_PCR_get_apai(hdmi_in(HDMI_STB_HDCP_PCR_reg));
    hdmi_mask(HDMI_STB_HDCP_PCR_reg, ~HDMI_STB_HDCP_PCR_apai_mask, 0);
    hdmi_out(HDMI_STB_HDCP_AP_reg, addr);

    while(num--)
        hdmi_out(HDMI_STB_HDCP_DP_reg, *(value++));

    hdmi_mask(HDMI_STB_HDCP_PCR_reg, ~HDMI_STB_HDCP_PCR_apai_mask, HDMI_STB_HDCP_PCR_apai(bit0_tmp));
}

void lib_hdmi_hdcp_port_write(unsigned char nport, unsigned char addr ,unsigned char value)
{
	hdmi_out(HDMI_STB_HDCP_AP_reg, addr);
	hdmi_out(HDMI_STB_HDCP_DP_reg, value);
}

unsigned char lib_hdmi_hdcp_port_read(unsigned char nport, unsigned char addr)
{
	hdmi_out(HDMI_STB_HDCP_AP_reg, addr);
	return hdmi_in(HDMI_STB_HDCP_DP_reg);
}


void lib_hdmi_hdcp_toggle_dkapde(unsigned char nport)
{
    hdmi_mask(HDMI_STB_HDCP_CR_reg, ~(HDMI_STB_HDCP_CR_dkapde_mask), 0);  // toggle dkape mask   
    udelay(10); 
    hdmi_mask(HDMI_STB_HDCP_CR_reg, ~(HDMI_STB_HDCP_CR_dkapde_mask), HDMI_STB_HDCP_CR_dkapde_mask);  // toggle dkape mask
    udelay(10);
    hdmi_mask(HDMI_STB_HDCP_CR_reg, ~(HDMI_STB_HDCP_CR_dkapde_mask), 0);  // toggle dkape mask        
    udelay(10);    
}


#if HDCP2_2
void lib_hdmi_hdcp22_enable(unsigned char nport, unsigned char enable)
{
	if (enable) {
		hdmi_mask(HDMI_STB_HDCP_2p2_CR_reg, ~HDMI_STB_HDCP_2p2_CR_hdcp_2p2_en_mask, HDMI_STB_HDCP_2p2_CR_hdcp_2p2_en_mask);
#if HDCP22_PATCH_DEFAULT_EN
		lib_hdmi_hdcp_port_write(nport, 0x50,0x04);
#endif
	} else {
		hdmi_mask(HDMI_STB_HDCP_2p2_CR_reg, ~HDMI_STB_HDCP_2p2_CR_hdcp_2p2_en_mask, 0);
	}
}

unsigned char lib_hdmi_hdcp22_is_onoff(unsigned char nport)
{
	return HDMI_STB_HDCP_2p2_CR_get_hdcp_2p2_en(hdmi_in(HDMI_STB_HDCP_2p2_CR_reg));
}

unsigned char lib_hdmi_hdcp22_get_auth_done(unsigned char nport)
{
	return (HDMI_STB_HDCP_2p2_SR0_get_state(hdmi_in(HDMI_STB_HDCP_2p2_SR0_reg))==0x010);
}
#endif

