#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "generate_config.h"
#include "util.h"
static char *glabal_output = NULL;
static int otp_bitmap_size = 0;

int pre_deal_with_file(char *f_name) {
	char tmp[256] = {0};
	FILE *in = NULL;
	FILE *out = NULL;
	char *input = NULL;
	char *sub_name;
	int quotation_num = 0;
	int is_in_quotation = 0;
	if(f_name == NULL)
		return -1;
	in = fopen(f_name, "r");
	if (in == NULL) {
		printf("open file %s failed\n", f_name);
		return -1;
	}
	sub_name = strrchr(f_name, '/');
	if(sub_name != NULL)
		sub_name++;
	else
		sub_name = f_name;
	sprintf(tmp, OUTPUT_FOLD"%s.pre", sub_name);
	out = fopen(tmp, "w");
	if (out == NULL) {
		printf("open file %s failed\n", tmp);
		fclose(in);
		return -1;
	}
#define LINE_SIZE 4096	
	input = (char *)malloc(LINE_SIZE);
	if (input == NULL) {
		printf("malloc(%d) failed\n", LINE_SIZE);
		fclose(in);
		fclose(out);
		return -1;
	}

	glabal_output = (char *)malloc(LINE_SIZE);
	if (glabal_output == NULL) {
		printf("malloc(%d) failed\n", LINE_SIZE);
		free(input);
		fclose(in);
		fclose(out);
		return -1;
	}
	while (fgets(input, LINE_SIZE, in) != NULL) {
		char *pRead = input;
		while(*pRead != '\0') {
			if(*pRead == '"') {
				quotation_num++;
				is_in_quotation = (is_in_quotation + 1) % 2;
				*pRead =' ';
			} else if(*pRead == '(')
					*pRead = '_';
				else if(*pRead == ')')
					*pRead = ' ';
				else {
				if(is_in_quotation) {
					if(*pRead == '\t')
						*pRead =' ';
					else if(*pRead == '\r')
						*pRead = 0x11;
					else if(*pRead == '\n')
						*pRead = 0x12;
				}
				
			}
			pRead++;
		}
		fprintf(out, "%s", input);
	}
	if(glabal_output) {
		free(glabal_output);
		glabal_output = NULL;
	}
	free(input);
	fclose(in);
	fclose(out);
	debug_print("The number of quotation in config file is %d\n", quotation_num);
	if(quotation_num % 2 != 0) {
		printf("The number of quotation is not even,"
			"Maybe the pre deal with the config will be not right"
			"Please re-check the quotation in config file\n");
		return -1;
	}
	return 0;
	
}

void pasre_element(OTP_ELEMENT *pEle, char *line)
{
	int i = 0;
	int the_first_bit = 0;
	if(pEle == NULL)
		return;
	memset(pEle, 0, sizeof(*pEle));
	if(line == NULL)
		return;
	while(*line != '\0') {
		if(*line !=' ' && *line != '\t' && *line != '\r' && *line != '\n') {
			break;
		}
		else {
			line++;
		}		
	}
	
	if(strneqi(line, "Bank", 4) == 1) {
		debug_print("input : %s\n", line);
		pEle->item_type = OTP_ELEMENT_TYPE_TITLE;
		pEle->item_name = line;
		while(*line != '\0') {
			if(*line == '\t' || *line == '\r' || *line == '\n')
				*line = ' ';
			line++;	
		}
	} else {
		pEle->item_type = OTP_ELEMENT_TYPE_NODE;
		while(*line != '\0') {
			if(*line !=' ' && *line != '\t' && *line != '\r' && *line != '\n') {
				if(the_first_bit == 0) {
					if(i == 0) {
						pEle->end_bits = line;
					} else if(i == 1) {
						pEle->start_bits = line;
					}else if(i == 2) {
						pEle->item_name = line;
					}
#ifdef OTP_CONFIG_OUTPUT_DESCRIPTION
					else if(i == 3) {
						pEle->item_desc = line;
						break;
					}
#endif
					i++;
					the_first_bit = 1;
				}
			}
			else {
				*line ='\0';
				the_first_bit = 0;
			}
			line++;
				
		}
		if(is_str_a_digital(pEle->start_bits) != 0
			|| is_str_a_digital(pEle->end_bits) != 0) {
			memset(pEle, 0, sizeof(*pEle));
		}
		if(pEle->item_name != NULL) {
			int i = 0;
			for(i = 0; i < strlen(pEle->item_name); i++) {
				if(pEle->item_name[i] == 0x11 || pEle->item_name[i] == 0x12)
					pEle->item_name[i] = '\0';
			}
			char *tmp = strchr(pEle->item_name, '(');
			if(tmp != NULL)
				tmp[0] = 0;
		}
#ifdef OTP_CONFIG_OUTPUT_DESCRIPTION
		if(pEle->item_desc != NULL) {
			
			if(strlen(pEle->item_desc) >= 2) {
				if(pEle->item_desc[strlen(pEle->item_desc) - 2] == 0x11
					|| pEle->item_desc[strlen(pEle->item_desc) - 2] == 0x12
					|| pEle->item_desc[strlen(pEle->item_desc) - 2] == '\r'
					|| pEle->item_desc[strlen(pEle->item_desc) - 2] == '\n')
					pEle->item_desc[strlen(pEle->item_desc) - 2] = '\0';
				
				else if(pEle->item_desc[strlen(pEle->item_desc) - 1] == 0x11
					|| pEle->item_desc[strlen(pEle->item_desc) - 1] == 0x12
					|| pEle->item_desc[strlen(pEle->item_desc) - 1] == '\r'
					|| pEle->item_desc[strlen(pEle->item_desc) - 1] == '\n')
					pEle->item_desc[strlen(pEle->item_desc) - 1] = '\0';
			} else if(strlen(pEle->item_desc) >= 1) {
				if(pEle->item_desc[strlen(pEle->item_desc) - 1] == 0x11
					|| pEle->item_desc[strlen(pEle->item_desc) - 1] == 0x12
					|| pEle->item_desc[strlen(pEle->item_desc) - 1] == '\r'
					|| pEle->item_desc[strlen(pEle->item_desc) - 1] == '\n')
					pEle->item_desc[strlen(pEle->item_desc) - 1] = '\0';
			}
			
		}
#endif
	}
}

void generate_config_item(OTP_ELEMENT *pEle, FILE *cp) 
{
	if(!((pEle->item_type == OTP_ELEMENT_TYPE_NODE && pEle->item_name != NULL 
			&& pEle->start_bits != NULL && pEle->end_bits != NULL)
			|| (pEle->item_type == OTP_ELEMENT_TYPE_TITLE && pEle->item_name != NULL)))
		return;
	if(pEle->item_type == OTP_ELEMENT_TYPE_TITLE) {
		debug_print("OTP_ELEMENT_TYPE_TITLE:%s\n", pEle->item_name);
		fprintf(cp, "%s\n", "######################################################################");
		fprintf(cp, "#%s\n", pEle->item_name);
		fprintf(cp, "%s\n", "######################################################################");
		fflush(cp);
	} else {
		int len = 0;
		int start_bit = -1;
		int end_bit = -1;
		start_bit = atoi(pEle->start_bits);
		end_bit = atoi(pEle->end_bits);
		debug_print("OTP_ELEMENT_TYPE_NODE:%s,%s,%s\n",pEle->start_bits, pEle->end_bits, pEle->item_name);
		if(start_bit > end_bit || start_bit < 0 || end_bit < 0)
			return;
		if(strstr(pEle->item_name, "dummy") != NULL ||
			strstr(pEle->item_name, "reserve") != NULL)
			return;
		fprintf(cp,"\n#===============================\n");
		fprintf(cp,"# bit %d~%d (%d bits)\n", end_bit, start_bit, end_bit - start_bit + 1);
		fprintf(cp,"#===============================\n");
#ifdef OTP_CONFIG_OUTPUT_DESCRIPTION
		if(pEle->item_desc != NULL) {
			int i = 0;
			fprintf(cp,"#");
			for(i = 0; i < strlen(pEle->item_desc); i++) {
				if(pEle->item_desc[i] == 0x11)
					;
				else if(pEle->item_desc[i] == 0x12)
					fprintf(cp,"\n#");
				else
					fprintf(cp, "%c", pEle->item_desc[i]);
				
			}	
			fprintf(cp, "\n");
		}
		else {
			fprintf(cp,"#\n");
		}
		
		//fprintf(cp,"#info:%s\n", (pEle->item_desc == NULL) ? "" : pEle->item_desc);
#endif
		fprintf(cp,"#%s\n", pEle->item_name);
		len = (end_bit - start_bit) /4 + 1;
		memset(glabal_output, '0', len);
		glabal_output[len] = 0;
		fprintf(cp,"#CONFIG_%s=\"0x%s\"\n\n", pEle->item_name, glabal_output);
		fflush(cp);
	}
	
}
void generate_bitmap_struct_item(OTP_ELEMENT *pEle, FILE *cp, int *reserve_index, int *dummy_index) 
{
	if(!((pEle->item_type == OTP_ELEMENT_TYPE_NODE && pEle->item_name != NULL 
			&& pEle->start_bits != NULL && pEle->end_bits != NULL)
			|| (pEle->item_type == OTP_ELEMENT_TYPE_TITLE && pEle->item_name != NULL)))
		return;
	if(pEle->item_type == OTP_ELEMENT_TYPE_TITLE) {
		debug_print("OTP_ELEMENT_TYPE_TITLE:%s\n", pEle->item_name);
		fprintf(cp, "\n\t/*%s*/\n\n", pEle->item_name);
		fflush(cp);
	} else {
		int start_bit = -1;
		int end_bit = -1;
		int len = 0;
		start_bit = atoi(pEle->start_bits);
		end_bit = atoi(pEle->end_bits);
		debug_print("OTP_ELEMENT_TYPE_NODE:%s,%s,%s\n",pEle->start_bits, pEle->end_bits, pEle->item_name);
		if(start_bit > end_bit || start_bit < 0 || end_bit < 0)
			return;
		/*if(strstr(pEle->item_name, "dummy") != NULL ||
			strstr(pEle->item_name, "reserve") != NULL)
			return;*/
			
		len = end_bit - start_bit + 1;
		fprintf(cp,"\t/* %s %d %d %d */\n", "bits", start_bit, end_bit, end_bit - start_bit + 1);
		if((start_bit % INT_BIT_SIZE_LEN == 0)
			&& ((end_bit + 1) % INT_BIT_SIZE_LEN == 0)) {
			if((len / INT_BIT_SIZE_LEN) > 1) {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d[%d];\n", *dummy_index, (len / INT_BIT_SIZE_LEN));
					*dummy_index = *dummy_index + 1;
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d[%d];\n", *reserve_index, (len / INT_BIT_SIZE_LEN));
					*reserve_index = *reserve_index + 1;
				}
				else {
					fprintf(cp,"\t unsigned int %s[%d];\n", pEle->item_name, (len / INT_BIT_SIZE_LEN));
				}
			} else {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d;\n", *dummy_index);
					*dummy_index = *dummy_index + 1;
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d;\n", *reserve_index);
					*reserve_index = *reserve_index + 1;
				}
				else {
					fprintf(cp,"\t unsigned int %s;\n", pEle->item_name);
				}
			}
				
		} else if((start_bit % INT_BIT_SIZE_LEN == 0)) {
			if(len < INT_BIT_SIZE_LEN) {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, len);
					*dummy_index = *dummy_index + 1;
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, len);
					*reserve_index = *reserve_index + 1;
				}
				else {
					fprintf(cp,"\t unsigned int %s:%d;\n", pEle->item_name, len);
				}
			} else  if((len / INT_BIT_SIZE_LEN) == 1) {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d;\n", *dummy_index);
					*dummy_index = *dummy_index + 1;
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, len % INT_BIT_SIZE_LEN);
					*dummy_index = *dummy_index + 1;
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d;\n", *reserve_index);
					*reserve_index = *reserve_index + 1;
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, len % INT_BIT_SIZE_LEN);
					*reserve_index = *reserve_index + 1;
				}
				else {
					fprintf(cp,"\t unsigned int %s_L;\n", pEle->item_name);
					fprintf(cp,"\t unsigned int %s_H:%d;\n", pEle->item_name, len % INT_BIT_SIZE_LEN);
				}
			} else {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d[%d];\n", *dummy_index, len/INT_BIT_SIZE_LEN);
					*dummy_index = *dummy_index + 1;
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, len % INT_BIT_SIZE_LEN);
					*dummy_index = *dummy_index + 1;
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d[%d];\n", *reserve_index, len/INT_BIT_SIZE_LEN);
					*reserve_index = *reserve_index + 1;
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, len % INT_BIT_SIZE_LEN);
					*reserve_index = *reserve_index + 1;
				}
				else {
					fprintf(cp,"\t unsigned int %s_L[%d];\n", pEle->item_name, len/INT_BIT_SIZE_LEN);
					fprintf(cp,"\t unsigned int %s_H:%d;\n", pEle->item_name, len % INT_BIT_SIZE_LEN);
				}
			}
		}else if(((end_bit + 1) % INT_BIT_SIZE_LEN == 0)) {
			if(len < INT_BIT_SIZE_LEN) {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, len);
					*dummy_index = *dummy_index + 1;
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, len);
					*reserve_index = *reserve_index + 1;
				}
				else {
					fprintf(cp,"\t unsigned int %s:%d;\n", pEle->item_name, len);
				}
			} else  if((len / INT_BIT_SIZE_LEN) == 1) {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, len % INT_BIT_SIZE_LEN);
					*dummy_index = *dummy_index + 1;
					fprintf(cp,"\t unsigned int dummy_%d;\n", *dummy_index);
					*dummy_index = *dummy_index + 1;
					
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, len % INT_BIT_SIZE_LEN);
					*reserve_index = *reserve_index + 1;
					fprintf(cp,"\t unsigned int reserve_%d;\n", *reserve_index);
					*reserve_index = *reserve_index + 1;
					
				}
				else {
					fprintf(cp,"\t unsigned int %s_L:%d;\n", pEle->item_name, len % INT_BIT_SIZE_LEN);
					fprintf(cp,"\t unsigned int %s_H;\n", pEle->item_name);
					
				}
			} else {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, len % INT_BIT_SIZE_LEN);
					*dummy_index = *dummy_index + 1;
					fprintf(cp,"\t unsigned int dummy_%d[%d];\n", *dummy_index, len/INT_BIT_SIZE_LEN);
					*dummy_index = *dummy_index + 1;
					
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, len % INT_BIT_SIZE_LEN);
					*reserve_index = *reserve_index + 1;
					fprintf(cp,"\t unsigned int reserve_%d[%d];\n", *reserve_index, len/INT_BIT_SIZE_LEN);
					*reserve_index = *reserve_index + 1;
					
				}
				else {
					fprintf(cp,"\t unsigned int %s_L:%d;\n", pEle->item_name, len % INT_BIT_SIZE_LEN);
					fprintf(cp,"\t unsigned int %s_H[%d];\n", pEle->item_name, len/INT_BIT_SIZE_LEN);
					
				}
			}
		}else {
			if((start_bit / INT_BIT_SIZE_LEN) == (end_bit / INT_BIT_SIZE_LEN)) {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, len);
					*dummy_index = *dummy_index + 1;
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, len);
					*reserve_index = *reserve_index + 1;
				}
				else {
					fprintf(cp,"\t unsigned int %s:%d;\n", pEle->item_name, len);
				}
			} else if(((end_bit / INT_BIT_SIZE_LEN) - (start_bit / INT_BIT_SIZE_LEN)) == 1) {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, (INT_BIT_SIZE_LEN - start_bit % INT_BIT_SIZE_LEN));
					*dummy_index = *dummy_index + 1;
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, end_bit % INT_BIT_SIZE_LEN + 1);
					*dummy_index = *dummy_index + 1;
					
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, (INT_BIT_SIZE_LEN - start_bit % INT_BIT_SIZE_LEN));
					*reserve_index = *reserve_index + 1;
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, end_bit % INT_BIT_SIZE_LEN + 1);
					*reserve_index = *reserve_index + 1;
					
				}
				else {
					fprintf(cp,"\t unsigned int %s_L:%d;\n", pEle->item_name, (INT_BIT_SIZE_LEN - start_bit % INT_BIT_SIZE_LEN));
					fprintf(cp,"\t unsigned int %s_H:%d;\n", pEle->item_name, end_bit % INT_BIT_SIZE_LEN + 1);
					
				}
			}else if(((end_bit / INT_BIT_SIZE_LEN) - (start_bit / INT_BIT_SIZE_LEN)) == 2) {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, (INT_BIT_SIZE_LEN - start_bit % INT_BIT_SIZE_LEN));
					*dummy_index = *dummy_index + 1;
					fprintf(cp,"\t unsigned int dummy_%d;\n", *dummy_index);
					*dummy_index = *dummy_index + 1;
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, end_bit % INT_BIT_SIZE_LEN + 1);
					*dummy_index = *dummy_index + 1;
					
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, (INT_BIT_SIZE_LEN - start_bit % INT_BIT_SIZE_LEN));
					*reserve_index = *reserve_index + 1;
					fprintf(cp,"\t unsigned int reserve_%d;\n", *reserve_index);
					*reserve_index = *reserve_index + 1;
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, end_bit % INT_BIT_SIZE_LEN + 1);
					*reserve_index = *reserve_index + 1;
					
				}
				else {
					fprintf(cp,"\t unsigned int %s_L:%d;\n", pEle->item_name, (INT_BIT_SIZE_LEN - start_bit % INT_BIT_SIZE_LEN));
					fprintf(cp,"\t unsigned int %s_M;\n", pEle->item_name);
					fprintf(cp,"\t unsigned int %s_H:%d;\n", pEle->item_name, end_bit % INT_BIT_SIZE_LEN + 1);
					
				}
			}else {
				if(strstr(pEle->item_name, "dummy") != NULL) {
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, (INT_BIT_SIZE_LEN - start_bit % INT_BIT_SIZE_LEN));
					*dummy_index = *dummy_index + 1;
					fprintf(cp,"\t unsigned int dummy_%d[%d];\n", *dummy_index, ((end_bit / INT_BIT_SIZE_LEN) - (start_bit / INT_BIT_SIZE_LEN) -1));
					*dummy_index = *dummy_index + 1;
					fprintf(cp,"\t unsigned int dummy_%d:%d;\n", *dummy_index, end_bit % INT_BIT_SIZE_LEN + 1);
					*dummy_index = *dummy_index + 1;
					
				}
				else if(strstr(pEle->item_name, "reserve") != NULL) {
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, (INT_BIT_SIZE_LEN - start_bit % INT_BIT_SIZE_LEN));
					*reserve_index = *reserve_index + 1;
					fprintf(cp,"\t unsigned int reserve_%d[%d];\n", *reserve_index, ((end_bit / INT_BIT_SIZE_LEN) - (start_bit / INT_BIT_SIZE_LEN) - 1));
					*reserve_index = *reserve_index + 1;
					fprintf(cp,"\t unsigned int reserve_%d:%d;\n", *reserve_index, end_bit % INT_BIT_SIZE_LEN + 1);
					*reserve_index = *reserve_index + 1;
					
				}
				else {
					fprintf(cp,"\t unsigned int %s_L:%d;\n", pEle->item_name, (INT_BIT_SIZE_LEN - start_bit % INT_BIT_SIZE_LEN));
					fprintf(cp,"\t unsigned int %s_M[%d];\n", pEle->item_name, ((end_bit / INT_BIT_SIZE_LEN) - (start_bit / INT_BIT_SIZE_LEN) - 1));
					fprintf(cp,"\t unsigned int %s_H:%d;\n", pEle->item_name, end_bit % INT_BIT_SIZE_LEN + 1);
					
				}
			}
			
		}
		
		fflush(cp);
		
		
	}
	
}
void generate_config_array_item(OTP_ELEMENT *pEle, FILE *cp) 
{
	if(!((pEle->item_type == OTP_ELEMENT_TYPE_NODE && pEle->item_name != NULL 
			&& pEle->start_bits != NULL && pEle->end_bits != NULL)
			|| (pEle->item_type == OTP_ELEMENT_TYPE_TITLE && pEle->item_name != NULL)))
		return;
	if(pEle->item_type == OTP_ELEMENT_TYPE_TITLE) {
		debug_print("OTP_ELEMENT_TYPE_TITLE:%s\n", pEle->item_name);
		fprintf(cp, "\n\t/*%s*/\n", pEle->item_name);
		fflush(cp);
	} else {
		int start_bit = -1;
		int end_bit = -1;
		start_bit = atoi(pEle->start_bits);
		end_bit = atoi(pEle->end_bits);
		debug_print("OTP_ELEMENT_TYPE_NODE:%s,%s,%s\n",pEle->start_bits, pEle->end_bits, pEle->item_name);
		if(start_bit > end_bit || start_bit < 0 || end_bit < 0)
			return;
		if(strstr(pEle->item_name, "dummy") != NULL ||
			strstr(pEle->item_name, "reserve") != NULL)
			return;
		fprintf(cp,"\t\"CONFIG_%s\",\n", pEle->item_name);
		fflush(cp);
	}
	
}
void generate_id_array_item(OTP_ELEMENT *pEle, FILE *cp) 
{
	if(!((pEle->item_type == OTP_ELEMENT_TYPE_NODE && pEle->item_name != NULL 
			&& pEle->start_bits != NULL && pEle->end_bits != NULL)
			|| (pEle->item_type == OTP_ELEMENT_TYPE_TITLE && pEle->item_name != NULL)))
		return;
	if(pEle->item_type == OTP_ELEMENT_TYPE_TITLE) {
		debug_print("OTP_ELEMENT_TYPE_TITLE:%s\n", pEle->item_name);
		fprintf(cp, "\n\t/*%s*/\n", pEle->item_name);
		fflush(cp);
	} else {
		int len = 0;
		int start_bit = -1;
		int end_bit = -1;
		start_bit = atoi(pEle->start_bits);
		end_bit = atoi(pEle->end_bits);
		debug_print("OTP_ELEMENT_TYPE_NODE:%s,%s,%s\n",pEle->start_bits, pEle->end_bits, pEle->item_name);
		if(start_bit > end_bit || start_bit < 0 || end_bit < 0)
			return;
		if(strstr(pEle->item_name, "dummy") != NULL ||
			strstr(pEle->item_name, "reserve") != NULL)
			return;
		for(len = 0; len < strlen(pEle->item_name); len++)
			glabal_output[len] = toupper((unsigned char)pEle->item_name[len]);
		glabal_output[len] = 0;
		fprintf(cp,"\tID_%s,\n", glabal_output);
		fflush(cp);
	}
	
}
void generate_id_header_item(OTP_ELEMENT *pEle, FILE *cp) 
{
	if(!((pEle->item_type == OTP_ELEMENT_TYPE_NODE && pEle->item_name != NULL 
			&& pEle->start_bits != NULL && pEle->end_bits != NULL)
			|| (pEle->item_type == OTP_ELEMENT_TYPE_TITLE && pEle->item_name != NULL)))
		return;
	if(pEle->item_type != OTP_ELEMENT_TYPE_TITLE) {
		int start_bit = -1;
		int end_bit = -1;
		start_bit = atoi(pEle->start_bits);
		end_bit = atoi(pEle->end_bits);
		debug_print("OTP_ELEMENT_TYPE_NODE:%s,%s,%s\n",pEle->start_bits, pEle->end_bits, pEle->item_name);
		if(start_bit > end_bit || start_bit < 0 || end_bit < 0)
			return;
		if(strstr(pEle->item_name, "dummy") != NULL ||
			strstr(pEle->item_name, "reserve") != NULL)
			return;
		fprintf(cp,"#define OTP_%-40s  OTP_ID(%d, %d) \n", pEle->item_name, end_bit, start_bit);
		fflush(cp);
	}
	
}
void generate_param_header_item(OTP_ELEMENT *pEle, FILE *cp) 
{
	if(!((pEle->item_type == OTP_ELEMENT_TYPE_NODE && pEle->item_name != NULL 
			&& pEle->start_bits != NULL && pEle->end_bits != NULL)
			|| (pEle->item_type == OTP_ELEMENT_TYPE_TITLE && pEle->item_name != NULL)))
		return;
	if(pEle->item_type != OTP_ELEMENT_TYPE_TITLE) {
		int start_bit = -1;
		int end_bit = -1;
		start_bit = atoi(pEle->start_bits);
		end_bit = atoi(pEle->end_bits);
		debug_print("OTP_ELEMENT_TYPE_NODE:%s,%s,%s\n",pEle->start_bits, pEle->end_bits, pEle->item_name);
		if(start_bit > end_bit || start_bit < 0 || end_bit < 0)
			return;
		if(strstr(pEle->item_name, "dummy") != NULL ||
			strstr(pEle->item_name, "reserve") != NULL)
			return;
		fprintf(cp,"   {OTP_%-40s, \"%s\", \"%s\" },\n", pEle->item_name, pEle->item_name, (pEle->item_desc == NULL) ? "" : pEle->item_desc); 
		fflush(cp);
	}
	
}
void pre_output_info(FILE *cp, OTP_CONFIG_TYPE type) {
	if(cp == NULL)
		return;
	if(type == OTP_CONFIG_TYPE_CONFIG_ARRAY) {
		fprintf(cp, "%s\n","const char *config_name[] = {");
		fflush(cp);
	} else if(type == OTP_CONFIG_TYPE_ID_ARRAY) {
		fprintf(cp, "%s\n","typedef enum otp_field_id {");
		fflush(cp);
	} else if(type == OTP_CONFIG_TYPE_BITMAP_STRUCT) {
		fprintf(cp, "%s\n","typedef struct {");
		fflush(cp);
	} else if(type == OTP_CONFIG_OTP_ID_HEADER_FILE) {
		fprintf(cp,"#ifndef __OTP_ID_H__\n");
		fprintf(cp,"#define __OTP_ID_H__\n");
		fprintf(cp," \n\n");
		fprintf(cp,"#define OTP_ID(msb,lsb)             ((msb<<16) | (lsb))\n");
		fprintf(cp,"#define OTP_MSB(x)                  ((x>>16) & 0xFFFF)\n");
		fprintf(cp,"#define OTP_LSB(x)                  ((x) & 0xFFFF)\n");   
		fflush(cp);
	} else if(type == OTP_CONFIG_OTP_PARAM_HEADER_FILE) {
		fprintf(cp,"#ifndef __OTP_PARAM_H__\n");
		fprintf(cp,"#define __OTP_PARAM_H__\n");
		fprintf(cp," \n");
		fprintf(cp,"#include \"otp_id.h\"\n");
		fprintf(cp," \n");
		fprintf(cp,"typedef struct {\n");
		fprintf(cp,"unsigned int id;\n");
		fprintf(cp,"const char* name;\n");
		fprintf(cp,"const char* description;\n");
		fprintf(cp,"}OTP_PARAM_DESC;\n\n");
		fprintf(cp,"static OTP_PARAM_DESC gOTPDescList[] = {\n");  
		fflush(cp);
	}
}
void post_output_info(FILE *cp, OTP_CONFIG_TYPE type) {
	if(cp == NULL)
		return;
	if(type == OTP_CONFIG_TYPE_CONFIG_ARRAY) {
		fprintf(cp, "%s\n\n", "};");
		fflush(cp);
	} else if(type == OTP_CONFIG_TYPE_ID_ARRAY) {
		fprintf(cp, "%s\n","} t_otp_field_ids;");
		fflush(cp);
	} else if(type == OTP_CONFIG_TYPE_BITMAP_STRUCT) {
		fprintf(cp, "%s\n","} __attribute__((packed)) otp_bitmap_t;");
		fflush(cp);
	} else if(type == OTP_CONFIG_OTP_ID_HEADER_FILE) {
		fprintf(cp,"#define OTP_BITMAP_SIZE  %d\n\n", otp_bitmap_size +1);   
		fprintf(cp,"#endif // __OTP_ID_H__\n\n"); 
		fflush(cp);
	} else if(type == OTP_CONFIG_OTP_PARAM_HEADER_FILE) {
		fprintf(cp,"}; \n\n");
		fprintf(cp,"#endif // __OTP_PARAM_H__\n\n");
		fflush(cp);
	}
}
int generate_config(char *f_name, OTP_CONFIG_TYPE type)
{

	FILE *fp = NULL;
	FILE *cp = NULL;
	char *input = NULL;
	char input_file_name[64] = {0};
	char output_file_name[64] = {0};
	int reserve_index = 0;
	int dummy_index = 0;
	otp_bitmap_size = 0;
#ifdef OTP_CONFIG_OUTPUT_DESCRIPTION	
	int res = -1;
       char *sub_name;
	res = pre_deal_with_file(f_name);
	if(res != 0) {
		printf("[OTP_CONFIG_GENERATOR]:Pre deal with %s fail\n", f_name);
		return -1;
	}
	sub_name = strrchr(f_name, '/');
	if(sub_name != NULL)
		sub_name++;
	else
		sub_name = f_name;
	sprintf(input_file_name, OUTPUT_FOLD"%s.pre",sub_name);
#else
	sprintf(input_file_name, "%s",f_name);
#endif
	fp = fopen(input_file_name, "r");
	if (fp == NULL) {
		printf("[OTP_CONFIG_GENERATOR]:open file %s failed\n", input_file_name);
		goto FAIL_OPEN_F_FILE;
	}
	
	if(type == OTP_CONFIG_TYPE_CONFIG_FILE)
		sprintf(output_file_name, OUTPUT_FOLD"otp_config.cfg");
	else if(type == OTP_CONFIG_TYPE_BITMAP_STRUCT)
		sprintf(output_file_name, OUTPUT_FOLD"otp_bitmap.h");
	else if(type == OTP_CONFIG_TYPE_CONFIG_ARRAY)
		sprintf(output_file_name, OUTPUT_FOLD"config.array");
	else if(type == OTP_CONFIG_TYPE_ID_ARRAY) 
		sprintf(output_file_name, OUTPUT_FOLD"id.array");
	else if(type == OTP_CONFIG_OTP_ID_HEADER_FILE)
		sprintf(output_file_name, OUTPUT_FOLD"otp_id.h");
	else if(type == OTP_CONFIG_OTP_PARAM_HEADER_FILE)
		sprintf(output_file_name, OUTPUT_FOLD"otp_param.h");
	debug_print("%d %s\n ", type, output_file_name);
	cp = fopen(output_file_name, "w");
	if (cp == NULL) {
		printf("[OTP_CONFIG_GENERATOR]:open file %s failed\n", output_file_name);
		goto FAIL_OPEN_CONFIG_FILE;
	}

	input = (char *)malloc(LINE_SIZE);
	if (input == NULL) {
		printf("[OTP_CONFIG_GENERATOR]:malloc(%d) failed\n", LINE_SIZE);
		goto FAIL_ALLOC_INPUT_MEM;
	}

	glabal_output = (char *)malloc(LINE_SIZE);
	if (glabal_output == NULL) {
		printf("[OTP_CONFIG_GENERATOR]:malloc(%d) failed\n", LINE_SIZE);
		goto FAIL_ALLOC_OUTPUT_MEM;
	}
	pre_output_info(cp, type);
	// get each line
	while (fgets(input, LINE_SIZE, fp) != NULL) {
		OTP_ELEMENT ele;
		pasre_element(&ele, input);
		if(ele.end_bits != NULL) {
		if(atoi(ele.end_bits) > otp_bitmap_size)
			otp_bitmap_size = atoi(ele.end_bits);
		}
		switch(type) {
		case OTP_CONFIG_TYPE_CONFIG_FILE:
			generate_config_item(&ele, cp);
			break;
		case OTP_CONFIG_TYPE_BITMAP_STRUCT:
			generate_bitmap_struct_item(&ele, cp, &reserve_index, &dummy_index);
			break;
		case OTP_CONFIG_TYPE_CONFIG_ARRAY:
			generate_config_array_item(&ele, cp);
			break;
		case OTP_CONFIG_TYPE_ID_ARRAY:
			generate_id_array_item(&ele, cp);
			break;
		case OTP_CONFIG_OTP_ID_HEADER_FILE:
			generate_id_header_item(&ele, cp);
			break;
		case OTP_CONFIG_OTP_PARAM_HEADER_FILE:
			generate_param_header_item(&ele, cp);	
			break;
		default:
			break;
		}
	}
	post_output_info(cp, type);
	if(glabal_output) {
		free(glabal_output);
		glabal_output = NULL;
	}
	if(input) {
		free(input);
		input = NULL;
	}
	if(cp) {
		fclose(cp);
		cp = NULL;
	}
	if(fp) {
		fclose(fp);
		fp = NULL;
	}
	printf("[OTP_CONFIG_GENERATOR]:Output file:%s sucess\n", output_file_name);
	return 0;
FAIL_ALLOC_OUTPUT_MEM:
	if(input) {
		free(input);
		input = NULL;
	}
FAIL_ALLOC_INPUT_MEM:
	if(cp) {
		fclose(cp);
		cp = NULL;
	}
FAIL_OPEN_CONFIG_FILE:
	if(fp) {
		fclose(fp);
		fp = NULL;
	}
FAIL_OPEN_F_FILE:
	return -1;
}

