#include <common.h>
#include <asm/arch/io.h>
#include <panel_config_parameter.h>
#include <asm/arch/fw_info.h>

#include <platform_lib/board/pcb_mgr.h>
#include <platform_lib/board/gpio.h>

void pcb_gen_kernel_cmd_line(char *buffer, PCB_ENUM_T *ppcb_enum) {

	int i;
	char tmp[256];
	unsigned int value;
	i = 0;
	if (ppcb_enum == NULL) {
		ppcb_enum = pcb_enum;
	}
	buffer[0] = 0;
	do {
		if(ppcb_enum[i].name == NULL) break;
		if(ppcb_enum[i].name[0] == 0) break;
		//printf("IO Config = %s@%llx\n", ppcb_enum[i].name, ppcb_enum[i].info);
		sprintf(tmp, "pcb_enum=%s,0x", ppcb_enum[i].name);
		strcat(buffer, tmp);
		value = (unsigned int) (ppcb_enum[i].info >> 32);
		sprintf(tmp,"%08x", value);
		//printf("%s\n", tmp);
		strcat(buffer, tmp);
		value = (unsigned int) (ppcb_enum[i].info & 0xFFFFFFFF);
		sprintf(tmp,"%08x ", value);
		//printf("%s\n", tmp);
		strcat(buffer, tmp);

		//printf("%s\n", buffer);

		i ++;
	} while(1);
}

unsigned int pcb_get_boot_flash_type(void)
{
#if 0 // fixme
	int state;
	int tmp0, tmp1;
	int reg_val;
	int boottype;

	/* save original settings */
	tmp0 = rtd_inl(PINMUX_GPIO_CFG_11_VADDR);
	tmp1 = rtd_inl(PINMUX_GPIO_CFG_9_VADDR);
	state = rtd_inl(0xb801bd04);

	/* set GPIO (44, 36) as GPI */
	rtd_outl(PINMUX_GPIO_CFG_11_VADDR, tmp0 | 0x0000f000);	// set  mux to GPIO44
	rtd_outl(PINMUX_GPIO_CFG_9_VADDR, tmp1 | 0x0000f000);	// set  mux to GPIO36
	rtd_outl(0xb801bd04, state & (~(_BIT12 | _BIT4)));	// set as input pin

	/* get flashtype from GPIO (44, 36) */
	reg_val = rtd_inl(0xb801bd34);
	boottype = ((reg_val >> 12) & 0x1);
	boottype |= (((reg_val >> 4) & 0x1) << 1);

	/* restore setting */
	rtd_outl(0xb801bd04, state);	// restore GPIO(44, 36) direction
	rtd_outl(PINMUX_GPIO_CFG_9_VADDR, tmp1);	// restore pin mux
	rtd_outl(PINMUX_GPIO_CFG_11_VADDR, tmp0);	// restore pin mux

	switch(boottype) {
		case 0:
			return FLASH_TYPE_SPI_NAND;

		case 1:
			return FLASH_TYPE_EMMC;

		case 2:
			return FLASH_TYPE_NAND;

		case 3:
			return FLASH_TYPE_SPI;

		default:	// should be impossible...
			return FLASH_TYPE_UNKNOWN;
	}

	return FLASH_TYPE_UNKNOWN;
#else
	#if defined (CONFIG_SYS_RTK_SPI_FLASH)
		return FLASH_TYPE_SPI;
	#elif defined (CONFIG_SYS_RTK_NAND_FLASH)
		return FLASH_TYPE_NAND;
	#elif defined (CONFIG_SYS_RTK_EMMC_FLASH)
		return FLASH_TYPE_EMMC;
	#elif defined (CONFIG_SYS_RTK_SPI_NAND)
		return FLASH_TYPE_SPI_NAND;
	#else
		return FLASH_TYPE_UNKNOWN;
	#endif
#endif
}

char *pcb_get_boot_flash_type_string(void)
{
	FLASH_TYPE_T flash_type = FLASH_TYPE_UNKNOWN;

	flash_type = pcb_get_boot_flash_type();

	switch(flash_type) {
		case FLASH_TYPE_NAND:
			return FLASH_TYPE_NAND_STRING;

		case FLASH_TYPE_SPI:
			return FLASH_TYPE_SPI_STRING;

		case FLASH_TYPE_EMMC:
			return FLASH_TYPE_EMMC_STRING;

		case FLASH_TYPE_SPI_NAND:
			return FLASH_TYPE_SPI_NAND_STRING;

		default:
			return FLASH_TYPE_UNKNOWN_STRING;
	}

	//return FLASH_TYPE_UNKNOWN_STRING; //[CID-314062]Structurally dead code
}

