/**
* @file Merlin6-DesignSpec-D-Domain_NexGuard
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_NG_WM_REG_H_
#define _RBUS_NG_WM_REG_H_

#include "rbus_types.h"



//  NG_WM Register Address
#define  NG_WM_NG_Config                                                        0x1802C6C0
#define  NG_WM_NG_Config_reg_addr                                                "0xB802C6C0"
#define  NG_WM_NG_Config_reg                                                     0xB802C6C0
#define  NG_WM_NG_Config_inst_addr                                               "0x0000"
#define  set_NG_WM_NG_Config_reg(data)                                           (*((volatile unsigned int*)NG_WM_NG_Config_reg)=data)
#define  get_NG_WM_NG_Config_reg                                                 (*((volatile unsigned int*)NG_WM_NG_Config_reg))
#define  NG_WM_NG_Config_ng_view_port_shift                                      (18)
#define  NG_WM_NG_Config_ng_3d_lr_tab_shift                                      (17)
#define  NG_WM_NG_Config_ng_3d_lr_sbs_shift                                      (16)
#define  NG_WM_NG_Config_ng_frame_rate_shift                                     (8)
#define  NG_WM_NG_Config_ng_frame_type_shift                                     (4)
#define  NG_WM_NG_Config_ng_location_shift                                       (3)
#define  NG_WM_NG_Config_ng_yuvnrgb_shift                                        (2)
#define  NG_WM_NG_Config_ng_debug_enable_shift                                   (1)
#define  NG_WM_NG_Config_ng_enable_service_shift                                 (0)
#define  NG_WM_NG_Config_ng_view_port_mask                                       (0x00040000)
#define  NG_WM_NG_Config_ng_3d_lr_tab_mask                                       (0x00020000)
#define  NG_WM_NG_Config_ng_3d_lr_sbs_mask                                       (0x00010000)
#define  NG_WM_NG_Config_ng_frame_rate_mask                                      (0x0000FF00)
#define  NG_WM_NG_Config_ng_frame_type_mask                                      (0x00000070)
#define  NG_WM_NG_Config_ng_location_mask                                        (0x00000008)
#define  NG_WM_NG_Config_ng_yuvnrgb_mask                                         (0x00000004)
#define  NG_WM_NG_Config_ng_debug_enable_mask                                    (0x00000002)
#define  NG_WM_NG_Config_ng_enable_service_mask                                  (0x00000001)
#define  NG_WM_NG_Config_ng_view_port(data)                                      (0x00040000&((data)<<18))
#define  NG_WM_NG_Config_ng_3d_lr_tab(data)                                      (0x00020000&((data)<<17))
#define  NG_WM_NG_Config_ng_3d_lr_sbs(data)                                      (0x00010000&((data)<<16))
#define  NG_WM_NG_Config_ng_frame_rate(data)                                     (0x0000FF00&((data)<<8))
#define  NG_WM_NG_Config_ng_frame_type(data)                                     (0x00000070&((data)<<4))
#define  NG_WM_NG_Config_ng_location(data)                                       (0x00000008&((data)<<3))
#define  NG_WM_NG_Config_ng_yuvnrgb(data)                                        (0x00000004&((data)<<2))
#define  NG_WM_NG_Config_ng_debug_enable(data)                                   (0x00000002&((data)<<1))
#define  NG_WM_NG_Config_ng_enable_service(data)                                 (0x00000001&(data))
#define  NG_WM_NG_Config_get_ng_view_port(data)                                  ((0x00040000&(data))>>18)
#define  NG_WM_NG_Config_get_ng_3d_lr_tab(data)                                  ((0x00020000&(data))>>17)
#define  NG_WM_NG_Config_get_ng_3d_lr_sbs(data)                                  ((0x00010000&(data))>>16)
#define  NG_WM_NG_Config_get_ng_frame_rate(data)                                 ((0x0000FF00&(data))>>8)
#define  NG_WM_NG_Config_get_ng_frame_type(data)                                 ((0x00000070&(data))>>4)
#define  NG_WM_NG_Config_get_ng_location(data)                                   ((0x00000008&(data))>>3)
#define  NG_WM_NG_Config_get_ng_yuvnrgb(data)                                    ((0x00000004&(data))>>2)
#define  NG_WM_NG_Config_get_ng_debug_enable(data)                               ((0x00000002&(data))>>1)
#define  NG_WM_NG_Config_get_ng_enable_service(data)                             (0x00000001&(data))

#define  NG_WM_NG_KEY                                                           0x1802C6C4
#define  NG_WM_NG_KEY_reg_addr                                                   "0xB802C6C4"
#define  NG_WM_NG_KEY_reg                                                        0xB802C6C4
#define  NG_WM_NG_KEY_inst_addr                                                  "0x0001"
#define  set_NG_WM_NG_KEY_reg(data)                                              (*((volatile unsigned int*)NG_WM_NG_KEY_reg)=data)
#define  get_NG_WM_NG_KEY_reg                                                    (*((volatile unsigned int*)NG_WM_NG_KEY_reg))
#define  NG_WM_NG_KEY_ng_key_shift                                               (0)
#define  NG_WM_NG_KEY_ng_key_mask                                                (0xFFFFFFFF)
#define  NG_WM_NG_KEY_ng_key(data)                                               (0xFFFFFFFF&(data))
#define  NG_WM_NG_KEY_get_ng_key(data)                                           (0xFFFFFFFF&(data))

#define  NG_WM_NG_Setting_0                                                     0x1802C6C8
#define  NG_WM_NG_Setting_0_reg_addr                                             "0xB802C6C8"
#define  NG_WM_NG_Setting_0_reg                                                  0xB802C6C8
#define  NG_WM_NG_Setting_0_inst_addr                                            "0x0002"
#define  set_NG_WM_NG_Setting_0_reg(data)                                        (*((volatile unsigned int*)NG_WM_NG_Setting_0_reg)=data)
#define  get_NG_WM_NG_Setting_0_reg                                              (*((volatile unsigned int*)NG_WM_NG_Setting_0_reg))
#define  NG_WM_NG_Setting_0_ng_setting_31_0_shift                                (0)
#define  NG_WM_NG_Setting_0_ng_setting_31_0_mask                                 (0xFFFFFFFF)
#define  NG_WM_NG_Setting_0_ng_setting_31_0(data)                                (0xFFFFFFFF&(data))
#define  NG_WM_NG_Setting_0_get_ng_setting_31_0(data)                            (0xFFFFFFFF&(data))

#define  NG_WM_NG_Setting_1                                                     0x1802C6CC
#define  NG_WM_NG_Setting_1_reg_addr                                             "0xB802C6CC"
#define  NG_WM_NG_Setting_1_reg                                                  0xB802C6CC
#define  NG_WM_NG_Setting_1_inst_addr                                            "0x0003"
#define  set_NG_WM_NG_Setting_1_reg(data)                                        (*((volatile unsigned int*)NG_WM_NG_Setting_1_reg)=data)
#define  get_NG_WM_NG_Setting_1_reg                                              (*((volatile unsigned int*)NG_WM_NG_Setting_1_reg))
#define  NG_WM_NG_Setting_1_ng_setting_63_32_shift                               (0)
#define  NG_WM_NG_Setting_1_ng_setting_63_32_mask                                (0xFFFFFFFF)
#define  NG_WM_NG_Setting_1_ng_setting_63_32(data)                               (0xFFFFFFFF&(data))
#define  NG_WM_NG_Setting_1_get_ng_setting_63_32(data)                           (0xFFFFFFFF&(data))

#define  NG_WM_NG_Setting_2                                                     0x1802C6D0
#define  NG_WM_NG_Setting_2_reg_addr                                             "0xB802C6D0"
#define  NG_WM_NG_Setting_2_reg                                                  0xB802C6D0
#define  NG_WM_NG_Setting_2_inst_addr                                            "0x0004"
#define  set_NG_WM_NG_Setting_2_reg(data)                                        (*((volatile unsigned int*)NG_WM_NG_Setting_2_reg)=data)
#define  get_NG_WM_NG_Setting_2_reg                                              (*((volatile unsigned int*)NG_WM_NG_Setting_2_reg))
#define  NG_WM_NG_Setting_2_ng_setting_95_64_shift                               (0)
#define  NG_WM_NG_Setting_2_ng_setting_95_64_mask                                (0xFFFFFFFF)
#define  NG_WM_NG_Setting_2_ng_setting_95_64(data)                               (0xFFFFFFFF&(data))
#define  NG_WM_NG_Setting_2_get_ng_setting_95_64(data)                           (0xFFFFFFFF&(data))

#define  NG_WM_NG_Setting_3                                                     0x1802C6D4
#define  NG_WM_NG_Setting_3_reg_addr                                             "0xB802C6D4"
#define  NG_WM_NG_Setting_3_reg                                                  0xB802C6D4
#define  NG_WM_NG_Setting_3_inst_addr                                            "0x0005"
#define  set_NG_WM_NG_Setting_3_reg(data)                                        (*((volatile unsigned int*)NG_WM_NG_Setting_3_reg)=data)
#define  get_NG_WM_NG_Setting_3_reg                                              (*((volatile unsigned int*)NG_WM_NG_Setting_3_reg))
#define  NG_WM_NG_Setting_3_ng_setting_127_96_shift                              (0)
#define  NG_WM_NG_Setting_3_ng_setting_127_96_mask                               (0xFFFFFFFF)
#define  NG_WM_NG_Setting_3_ng_setting_127_96(data)                              (0xFFFFFFFF&(data))
#define  NG_WM_NG_Setting_3_get_ng_setting_127_96(data)                          (0xFFFFFFFF&(data))

#define  NG_WM_NG_Setting_4                                                     0x1802C6D8
#define  NG_WM_NG_Setting_4_reg_addr                                             "0xB802C6D8"
#define  NG_WM_NG_Setting_4_reg                                                  0xB802C6D8
#define  NG_WM_NG_Setting_4_inst_addr                                            "0x0006"
#define  set_NG_WM_NG_Setting_4_reg(data)                                        (*((volatile unsigned int*)NG_WM_NG_Setting_4_reg)=data)
#define  get_NG_WM_NG_Setting_4_reg                                              (*((volatile unsigned int*)NG_WM_NG_Setting_4_reg))
#define  NG_WM_NG_Setting_4_ng_setting_159_128_shift                             (0)
#define  NG_WM_NG_Setting_4_ng_setting_159_128_mask                              (0xFFFFFFFF)
#define  NG_WM_NG_Setting_4_ng_setting_159_128(data)                             (0xFFFFFFFF&(data))
#define  NG_WM_NG_Setting_4_get_ng_setting_159_128(data)                         (0xFFFFFFFF&(data))

#define  NG_WM_NG_Setting_5                                                     0x1802C6DC
#define  NG_WM_NG_Setting_5_reg_addr                                             "0xB802C6DC"
#define  NG_WM_NG_Setting_5_reg                                                  0xB802C6DC
#define  NG_WM_NG_Setting_5_inst_addr                                            "0x0007"
#define  set_NG_WM_NG_Setting_5_reg(data)                                        (*((volatile unsigned int*)NG_WM_NG_Setting_5_reg)=data)
#define  get_NG_WM_NG_Setting_5_reg                                              (*((volatile unsigned int*)NG_WM_NG_Setting_5_reg))
#define  NG_WM_NG_Setting_5_ng_setting_164_160_shift                             (0)
#define  NG_WM_NG_Setting_5_ng_setting_164_160_mask                              (0x0000001F)
#define  NG_WM_NG_Setting_5_ng_setting_164_160(data)                             (0x0000001F&(data))
#define  NG_WM_NG_Setting_5_get_ng_setting_164_160(data)                         (0x0000001F&(data))

#define  NG_WM_NG_Payload_0                                                     0x1802C6E0
#define  NG_WM_NG_Payload_0_reg_addr                                             "0xB802C6E0"
#define  NG_WM_NG_Payload_0_reg                                                  0xB802C6E0
#define  NG_WM_NG_Payload_0_inst_addr                                            "0x0008"
#define  set_NG_WM_NG_Payload_0_reg(data)                                        (*((volatile unsigned int*)NG_WM_NG_Payload_0_reg)=data)
#define  get_NG_WM_NG_Payload_0_reg                                              (*((volatile unsigned int*)NG_WM_NG_Payload_0_reg))
#define  NG_WM_NG_Payload_0_ng_payload_data_31_0_shift                           (0)
#define  NG_WM_NG_Payload_0_ng_payload_data_31_0_mask                            (0xFFFFFFFF)
#define  NG_WM_NG_Payload_0_ng_payload_data_31_0(data)                           (0xFFFFFFFF&(data))
#define  NG_WM_NG_Payload_0_get_ng_payload_data_31_0(data)                       (0xFFFFFFFF&(data))

#define  NG_WM_NG_Payload_1                                                     0x1802C6E4
#define  NG_WM_NG_Payload_1_reg_addr                                             "0xB802C6E4"
#define  NG_WM_NG_Payload_1_reg                                                  0xB802C6E4
#define  NG_WM_NG_Payload_1_inst_addr                                            "0x0009"
#define  set_NG_WM_NG_Payload_1_reg(data)                                        (*((volatile unsigned int*)NG_WM_NG_Payload_1_reg)=data)
#define  get_NG_WM_NG_Payload_1_reg                                              (*((volatile unsigned int*)NG_WM_NG_Payload_1_reg))
#define  NG_WM_NG_Payload_1_ng_payload_format_shift                              (31)
#define  NG_WM_NG_Payload_1_ng_payload_data_55_32_shift                          (0)
#define  NG_WM_NG_Payload_1_ng_payload_format_mask                               (0x80000000)
#define  NG_WM_NG_Payload_1_ng_payload_data_55_32_mask                           (0x00FFFFFF)
#define  NG_WM_NG_Payload_1_ng_payload_format(data)                              (0x80000000&((data)<<31))
#define  NG_WM_NG_Payload_1_ng_payload_data_55_32(data)                          (0x00FFFFFF&(data))
#define  NG_WM_NG_Payload_1_get_ng_payload_format(data)                          ((0x80000000&(data))>>31)
#define  NG_WM_NG_Payload_1_get_ng_payload_data_55_32(data)                      (0x00FFFFFF&(data))

#define  NG_WM_NG_Status                                                        0x1802C6E8
#define  NG_WM_NG_Status_reg_addr                                                "0xB802C6E8"
#define  NG_WM_NG_Status_reg                                                     0xB802C6E8
#define  NG_WM_NG_Status_inst_addr                                               "0x000A"
#define  set_NG_WM_NG_Status_reg(data)                                           (*((volatile unsigned int*)NG_WM_NG_Status_reg)=data)
#define  get_NG_WM_NG_Status_reg                                                 (*((volatile unsigned int*)NG_WM_NG_Status_reg))
#define  NG_WM_NG_Status_ng_error0_shift                                         (28)
#define  NG_WM_NG_Status_ng_error1_shift                                         (24)
#define  NG_WM_NG_Status_ng_version_shift                                        (0)
#define  NG_WM_NG_Status_ng_error0_mask                                          (0xF0000000)
#define  NG_WM_NG_Status_ng_error1_mask                                          (0x0F000000)
#define  NG_WM_NG_Status_ng_version_mask                                         (0x00000FFF)
#define  NG_WM_NG_Status_ng_error0(data)                                         (0xF0000000&((data)<<28))
#define  NG_WM_NG_Status_ng_error1(data)                                         (0x0F000000&((data)<<24))
#define  NG_WM_NG_Status_ng_version(data)                                        (0x00000FFF&(data))
#define  NG_WM_NG_Status_get_ng_error0(data)                                     ((0xF0000000&(data))>>28)
#define  NG_WM_NG_Status_get_ng_error1(data)                                     ((0x0F000000&(data))>>24)
#define  NG_WM_NG_Status_get_ng_version(data)                                    (0x00000FFF&(data))

#define  NG_WM_NG_DB                                                            0x1802C6EC
#define  NG_WM_NG_DB_reg_addr                                                    "0xB802C6EC"
#define  NG_WM_NG_DB_reg                                                         0xB802C6EC
#define  NG_WM_NG_DB_inst_addr                                                   "0x000B"
#define  set_NG_WM_NG_DB_reg(data)                                               (*((volatile unsigned int*)NG_WM_NG_DB_reg)=data)
#define  get_NG_WM_NG_DB_reg                                                     (*((volatile unsigned int*)NG_WM_NG_DB_reg))
#define  NG_WM_NG_DB_db_en_shift                                                 (31)
#define  NG_WM_NG_DB_db_read_level_shift                                         (1)
#define  NG_WM_NG_DB_db_apply_shift                                              (0)
#define  NG_WM_NG_DB_db_en_mask                                                  (0x80000000)
#define  NG_WM_NG_DB_db_read_level_mask                                          (0x00000002)
#define  NG_WM_NG_DB_db_apply_mask                                               (0x00000001)
#define  NG_WM_NG_DB_db_en(data)                                                 (0x80000000&((data)<<31))
#define  NG_WM_NG_DB_db_read_level(data)                                         (0x00000002&((data)<<1))
#define  NG_WM_NG_DB_db_apply(data)                                              (0x00000001&(data))
#define  NG_WM_NG_DB_get_db_en(data)                                             ((0x80000000&(data))>>31)
#define  NG_WM_NG_DB_get_db_read_level(data)                                     ((0x00000002&(data))>>1)
#define  NG_WM_NG_DB_get_db_apply(data)                                          (0x00000001&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======NG_WM register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  ng_view_port:1;
        RBus_UInt32  ng_3d_lr_tab:1;
        RBus_UInt32  ng_3d_lr_sbs:1;
        RBus_UInt32  ng_frame_rate:8;
        RBus_UInt32  res2:1;
        RBus_UInt32  ng_frame_type:3;
        RBus_UInt32  ng_location:1;
        RBus_UInt32  ng_yuvnrgb:1;
        RBus_UInt32  ng_debug_enable:1;
        RBus_UInt32  ng_enable_service:1;
    };
}ng_wm_ng_config_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_key:32;
    };
}ng_wm_ng_key_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_31_0:32;
    };
}ng_wm_ng_setting_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_63_32:32;
    };
}ng_wm_ng_setting_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_95_64:32;
    };
}ng_wm_ng_setting_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_127_96:32;
    };
}ng_wm_ng_setting_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_159_128:32;
    };
}ng_wm_ng_setting_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  ng_setting_164_160:5;
    };
}ng_wm_ng_setting_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_payload_data_31_0:32;
    };
}ng_wm_ng_payload_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_payload_format:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  ng_payload_data_55_32:24;
    };
}ng_wm_ng_payload_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_error0:4;
        RBus_UInt32  ng_error1:4;
        RBus_UInt32  res1:12;
        RBus_UInt32  ng_version:12;
    };
}ng_wm_ng_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_en:1;
        RBus_UInt32  res1:29;
        RBus_UInt32  db_read_level:1;
        RBus_UInt32  db_apply:1;
    };
}ng_wm_ng_db_RBUS;

#else //apply LITTLE_ENDIAN

//======NG_WM register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_enable_service:1;
        RBus_UInt32  ng_debug_enable:1;
        RBus_UInt32  ng_yuvnrgb:1;
        RBus_UInt32  ng_location:1;
        RBus_UInt32  ng_frame_type:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  ng_frame_rate:8;
        RBus_UInt32  ng_3d_lr_sbs:1;
        RBus_UInt32  ng_3d_lr_tab:1;
        RBus_UInt32  ng_view_port:1;
        RBus_UInt32  res2:13;
    };
}ng_wm_ng_config_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_key:32;
    };
}ng_wm_ng_key_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_31_0:32;
    };
}ng_wm_ng_setting_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_63_32:32;
    };
}ng_wm_ng_setting_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_95_64:32;
    };
}ng_wm_ng_setting_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_127_96:32;
    };
}ng_wm_ng_setting_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_159_128:32;
    };
}ng_wm_ng_setting_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_setting_164_160:5;
        RBus_UInt32  res1:27;
    };
}ng_wm_ng_setting_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_payload_data_31_0:32;
    };
}ng_wm_ng_payload_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_payload_data_55_32:24;
        RBus_UInt32  res1:7;
        RBus_UInt32  ng_payload_format:1;
    };
}ng_wm_ng_payload_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ng_version:12;
        RBus_UInt32  res1:12;
        RBus_UInt32  ng_error1:4;
        RBus_UInt32  ng_error0:4;
    };
}ng_wm_ng_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_read_level:1;
        RBus_UInt32  res1:29;
        RBus_UInt32  db_en:1;
    };
}ng_wm_ng_db_RBUS;




#endif 


#endif 
