/**
* @file Merlin6-DesignSpec-D-Domain_SiW_PCLRC
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_SIW_PCLRC_REG_H_
#define _RBUS_SIW_PCLRC_REG_H_

#include "rbus_types.h"



//  SIW_PCLRC Register Address
#define  SIW_PCLRC_PCLRC_db_Ctrl                                                0x1802BF00
#define  SIW_PCLRC_PCLRC_db_Ctrl_reg_addr                                        "0xB802BF00"
#define  SIW_PCLRC_PCLRC_db_Ctrl_reg                                             0xB802BF00
#define  SIW_PCLRC_PCLRC_db_Ctrl_inst_addr                                       "0x0000"
#define  set_SIW_PCLRC_PCLRC_db_Ctrl_reg(data)                                   (*((volatile unsigned int*)SIW_PCLRC_PCLRC_db_Ctrl_reg)=data)
#define  get_SIW_PCLRC_PCLRC_db_Ctrl_reg                                         (*((volatile unsigned int*)SIW_PCLRC_PCLRC_db_Ctrl_reg))
#define  SIW_PCLRC_PCLRC_db_Ctrl_db_apply_shift                                  (2)
#define  SIW_PCLRC_PCLRC_db_Ctrl_db_rd_sel_shift                                 (1)
#define  SIW_PCLRC_PCLRC_db_Ctrl_db_en_shift                                     (0)
#define  SIW_PCLRC_PCLRC_db_Ctrl_db_apply_mask                                   (0x00000004)
#define  SIW_PCLRC_PCLRC_db_Ctrl_db_rd_sel_mask                                  (0x00000002)
#define  SIW_PCLRC_PCLRC_db_Ctrl_db_en_mask                                      (0x00000001)
#define  SIW_PCLRC_PCLRC_db_Ctrl_db_apply(data)                                  (0x00000004&((data)<<2))
#define  SIW_PCLRC_PCLRC_db_Ctrl_db_rd_sel(data)                                 (0x00000002&((data)<<1))
#define  SIW_PCLRC_PCLRC_db_Ctrl_db_en(data)                                     (0x00000001&(data))
#define  SIW_PCLRC_PCLRC_db_Ctrl_get_db_apply(data)                              ((0x00000004&(data))>>2)
#define  SIW_PCLRC_PCLRC_db_Ctrl_get_db_rd_sel(data)                             ((0x00000002&(data))>>1)
#define  SIW_PCLRC_PCLRC_db_Ctrl_get_db_en(data)                                 (0x00000001&(data))

#define  SIW_PCLRC_PCLRC_Ctrl                                                   0x1802BF04
#define  SIW_PCLRC_PCLRC_Ctrl_reg_addr                                           "0xB802BF04"
#define  SIW_PCLRC_PCLRC_Ctrl_reg                                                0xB802BF04
#define  SIW_PCLRC_PCLRC_Ctrl_inst_addr                                          "0x0001"
#define  set_SIW_PCLRC_PCLRC_Ctrl_reg(data)                                      (*((volatile unsigned int*)SIW_PCLRC_PCLRC_Ctrl_reg)=data)
#define  get_SIW_PCLRC_PCLRC_Ctrl_reg                                            (*((volatile unsigned int*)SIW_PCLRC_PCLRC_Ctrl_reg))
#define  SIW_PCLRC_PCLRC_Ctrl_pclrc_bypass_shift                                 (4)
#define  SIW_PCLRC_PCLRC_Ctrl_pclrc_bypass_en_shift                              (0)
#define  SIW_PCLRC_PCLRC_Ctrl_pclrc_bypass_mask                                  (0x00000010)
#define  SIW_PCLRC_PCLRC_Ctrl_pclrc_bypass_en_mask                               (0x00000001)
#define  SIW_PCLRC_PCLRC_Ctrl_pclrc_bypass(data)                                 (0x00000010&((data)<<4))
#define  SIW_PCLRC_PCLRC_Ctrl_pclrc_bypass_en(data)                              (0x00000001&(data))
#define  SIW_PCLRC_PCLRC_Ctrl_get_pclrc_bypass(data)                             ((0x00000010&(data))>>4)
#define  SIW_PCLRC_PCLRC_Ctrl_get_pclrc_bypass_en(data)                          (0x00000001&(data))

#define  SIW_PCLRC_PCLRC_LUT_Ctrl                                               0x1802BF10
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_reg_addr                                       "0xB802BF10"
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_reg                                            0xB802BF10
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_inst_addr                                      "0x0002"
#define  set_SIW_PCLRC_PCLRC_LUT_Ctrl_reg(data)                                  (*((volatile unsigned int*)SIW_PCLRC_PCLRC_LUT_Ctrl_reg)=data)
#define  get_SIW_PCLRC_PCLRC_LUT_Ctrl_reg                                        (*((volatile unsigned int*)SIW_PCLRC_PCLRC_LUT_Ctrl_reg))
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_wr_err_shift                            (31)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_rd_err_shift                            (30)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_fifo_full_shift                         (29)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_fifo_empty_shift                        (28)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_mode_shift                              (2)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_wren_shift                              (1)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_en_shift                                (0)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_wr_err_mask                             (0x80000000)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_rd_err_mask                             (0x40000000)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_fifo_full_mask                          (0x20000000)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_fifo_empty_mask                         (0x10000000)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_mode_mask                               (0x00000004)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_wren_mask                               (0x00000002)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_en_mask                                 (0x00000001)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_wr_err(data)                            (0x80000000&((data)<<31))
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_rd_err(data)                            (0x40000000&((data)<<30))
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_fifo_full(data)                         (0x20000000&((data)<<29))
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_fifo_empty(data)                        (0x10000000&((data)<<28))
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_mode(data)                              (0x00000004&((data)<<2))
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_wren(data)                              (0x00000002&((data)<<1))
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_lut_ax_en(data)                                (0x00000001&(data))
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_get_lut_ax_wr_err(data)                        ((0x80000000&(data))>>31)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_get_lut_ax_rd_err(data)                        ((0x40000000&(data))>>30)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_get_lut_ax_fifo_full(data)                     ((0x20000000&(data))>>29)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_get_lut_ax_fifo_empty(data)                    ((0x10000000&(data))>>28)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_get_lut_ax_mode(data)                          ((0x00000004&(data))>>2)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_get_lut_ax_wren(data)                          ((0x00000002&(data))>>1)
#define  SIW_PCLRC_PCLRC_LUT_Ctrl_get_lut_ax_en(data)                            (0x00000001&(data))

#define  SIW_PCLRC_PCLRC_LUT_Data                                               0x1802BF14
#define  SIW_PCLRC_PCLRC_LUT_Data_reg_addr                                       "0xB802BF14"
#define  SIW_PCLRC_PCLRC_LUT_Data_reg                                            0xB802BF14
#define  SIW_PCLRC_PCLRC_LUT_Data_inst_addr                                      "0x0003"
#define  set_SIW_PCLRC_PCLRC_LUT_Data_reg(data)                                  (*((volatile unsigned int*)SIW_PCLRC_PCLRC_LUT_Data_reg)=data)
#define  get_SIW_PCLRC_PCLRC_LUT_Data_reg                                        (*((volatile unsigned int*)SIW_PCLRC_PCLRC_LUT_Data_reg))
#define  SIW_PCLRC_PCLRC_LUT_Data_lut_ax_data_shift                              (0)
#define  SIW_PCLRC_PCLRC_LUT_Data_lut_ax_data_mask                               (0xFFFFFFFF)
#define  SIW_PCLRC_PCLRC_LUT_Data_lut_ax_data(data)                              (0xFFFFFFFF&(data))
#define  SIW_PCLRC_PCLRC_LUT_Data_get_lut_ax_data(data)                          (0xFFFFFFFF&(data))

#define  SIW_PCLRC_PCLRC_dummy                                                  0x1802BF1C
#define  SIW_PCLRC_PCLRC_dummy_reg_addr                                          "0xB802BF1C"
#define  SIW_PCLRC_PCLRC_dummy_reg                                               0xB802BF1C
#define  SIW_PCLRC_PCLRC_dummy_inst_addr                                         "0x0004"
#define  set_SIW_PCLRC_PCLRC_dummy_reg(data)                                     (*((volatile unsigned int*)SIW_PCLRC_PCLRC_dummy_reg)=data)
#define  get_SIW_PCLRC_PCLRC_dummy_reg                                           (*((volatile unsigned int*)SIW_PCLRC_PCLRC_dummy_reg))
#define  SIW_PCLRC_PCLRC_dummy_dummy_31_0_shift                                  (0)
#define  SIW_PCLRC_PCLRC_dummy_dummy_31_0_mask                                   (0xFFFFFFFF)
#define  SIW_PCLRC_PCLRC_dummy_dummy_31_0(data)                                  (0xFFFFFFFF&(data))
#define  SIW_PCLRC_PCLRC_dummy_get_dummy_31_0(data)                              (0xFFFFFFFF&(data))

#define  SIW_PCLRC_PCLRC_reg00_03                                               0x1802BF20
#define  SIW_PCLRC_PCLRC_reg00_03_reg_addr                                       "0xB802BF20"
#define  SIW_PCLRC_PCLRC_reg00_03_reg                                            0xB802BF20
#define  SIW_PCLRC_PCLRC_reg00_03_inst_addr                                      "0x0005"
#define  set_SIW_PCLRC_PCLRC_reg00_03_reg(data)                                  (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg00_03_reg)=data)
#define  get_SIW_PCLRC_PCLRC_reg00_03_reg                                        (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg00_03_reg))
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg03_shift                                  (24)
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg02_shift                                  (16)
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg01_shift                                  (8)
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg00_shift                                  (0)
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg03_mask                                   (0xFF000000)
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg02_mask                                   (0x00FF0000)
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg01_mask                                   (0x0000FF00)
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg00_mask                                   (0x000000FF)
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg03(data)                                  (0xFF000000&((data)<<24))
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg02(data)                                  (0x00FF0000&((data)<<16))
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg01(data)                                  (0x0000FF00&((data)<<8))
#define  SIW_PCLRC_PCLRC_reg00_03_i_reg00(data)                                  (0x000000FF&(data))
#define  SIW_PCLRC_PCLRC_reg00_03_get_i_reg03(data)                              ((0xFF000000&(data))>>24)
#define  SIW_PCLRC_PCLRC_reg00_03_get_i_reg02(data)                              ((0x00FF0000&(data))>>16)
#define  SIW_PCLRC_PCLRC_reg00_03_get_i_reg01(data)                              ((0x0000FF00&(data))>>8)
#define  SIW_PCLRC_PCLRC_reg00_03_get_i_reg00(data)                              (0x000000FF&(data))

#define  SIW_PCLRC_PCLRC_reg04_07                                               0x1802BF24
#define  SIW_PCLRC_PCLRC_reg04_07_reg_addr                                       "0xB802BF24"
#define  SIW_PCLRC_PCLRC_reg04_07_reg                                            0xB802BF24
#define  SIW_PCLRC_PCLRC_reg04_07_inst_addr                                      "0x0006"
#define  set_SIW_PCLRC_PCLRC_reg04_07_reg(data)                                  (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg04_07_reg)=data)
#define  get_SIW_PCLRC_PCLRC_reg04_07_reg                                        (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg04_07_reg))
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg07_shift                                  (24)
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg06_shift                                  (16)
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg05_shift                                  (8)
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg04_shift                                  (0)
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg07_mask                                   (0xFF000000)
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg06_mask                                   (0x00FF0000)
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg05_mask                                   (0x0000FF00)
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg04_mask                                   (0x000000FF)
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg07(data)                                  (0xFF000000&((data)<<24))
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg06(data)                                  (0x00FF0000&((data)<<16))
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg05(data)                                  (0x0000FF00&((data)<<8))
#define  SIW_PCLRC_PCLRC_reg04_07_i_reg04(data)                                  (0x000000FF&(data))
#define  SIW_PCLRC_PCLRC_reg04_07_get_i_reg07(data)                              ((0xFF000000&(data))>>24)
#define  SIW_PCLRC_PCLRC_reg04_07_get_i_reg06(data)                              ((0x00FF0000&(data))>>16)
#define  SIW_PCLRC_PCLRC_reg04_07_get_i_reg05(data)                              ((0x0000FF00&(data))>>8)
#define  SIW_PCLRC_PCLRC_reg04_07_get_i_reg04(data)                              (0x000000FF&(data))

#define  SIW_PCLRC_PCLRC_reg08_0B                                               0x1802BF28
#define  SIW_PCLRC_PCLRC_reg08_0B_reg_addr                                       "0xB802BF28"
#define  SIW_PCLRC_PCLRC_reg08_0B_reg                                            0xB802BF28
#define  SIW_PCLRC_PCLRC_reg08_0B_inst_addr                                      "0x0007"
#define  set_SIW_PCLRC_PCLRC_reg08_0B_reg(data)                                  (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg08_0B_reg)=data)
#define  get_SIW_PCLRC_PCLRC_reg08_0B_reg                                        (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg08_0B_reg))
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg0b_shift                                  (24)
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg0a_shift                                  (16)
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg09_shift                                  (8)
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg08_shift                                  (0)
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg0b_mask                                   (0xFF000000)
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg0a_mask                                   (0x00FF0000)
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg09_mask                                   (0x0000FF00)
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg08_mask                                   (0x000000FF)
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg0b(data)                                  (0xFF000000&((data)<<24))
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg0a(data)                                  (0x00FF0000&((data)<<16))
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg09(data)                                  (0x0000FF00&((data)<<8))
#define  SIW_PCLRC_PCLRC_reg08_0B_i_reg08(data)                                  (0x000000FF&(data))
#define  SIW_PCLRC_PCLRC_reg08_0B_get_i_reg0b(data)                              ((0xFF000000&(data))>>24)
#define  SIW_PCLRC_PCLRC_reg08_0B_get_i_reg0a(data)                              ((0x00FF0000&(data))>>16)
#define  SIW_PCLRC_PCLRC_reg08_0B_get_i_reg09(data)                              ((0x0000FF00&(data))>>8)
#define  SIW_PCLRC_PCLRC_reg08_0B_get_i_reg08(data)                              (0x000000FF&(data))

#define  SIW_PCLRC_PCLRC_reg0C_0F                                               0x1802BF2C
#define  SIW_PCLRC_PCLRC_reg0C_0F_reg_addr                                       "0xB802BF2C"
#define  SIW_PCLRC_PCLRC_reg0C_0F_reg                                            0xB802BF2C
#define  SIW_PCLRC_PCLRC_reg0C_0F_inst_addr                                      "0x0008"
#define  set_SIW_PCLRC_PCLRC_reg0C_0F_reg(data)                                  (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg0C_0F_reg)=data)
#define  get_SIW_PCLRC_PCLRC_reg0C_0F_reg                                        (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg0C_0F_reg))
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0f_shift                                  (24)
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0e_shift                                  (16)
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0d_shift                                  (8)
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0c_shift                                  (0)
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0f_mask                                   (0xFF000000)
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0e_mask                                   (0x00FF0000)
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0d_mask                                   (0x0000FF00)
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0c_mask                                   (0x000000FF)
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0f(data)                                  (0xFF000000&((data)<<24))
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0e(data)                                  (0x00FF0000&((data)<<16))
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0d(data)                                  (0x0000FF00&((data)<<8))
#define  SIW_PCLRC_PCLRC_reg0C_0F_i_reg0c(data)                                  (0x000000FF&(data))
#define  SIW_PCLRC_PCLRC_reg0C_0F_get_i_reg0f(data)                              ((0xFF000000&(data))>>24)
#define  SIW_PCLRC_PCLRC_reg0C_0F_get_i_reg0e(data)                              ((0x00FF0000&(data))>>16)
#define  SIW_PCLRC_PCLRC_reg0C_0F_get_i_reg0d(data)                              ((0x0000FF00&(data))>>8)
#define  SIW_PCLRC_PCLRC_reg0C_0F_get_i_reg0c(data)                              (0x000000FF&(data))

#define  SIW_PCLRC_PCLRC_reg10_13                                               0x1802BF30
#define  SIW_PCLRC_PCLRC_reg10_13_reg_addr                                       "0xB802BF30"
#define  SIW_PCLRC_PCLRC_reg10_13_reg                                            0xB802BF30
#define  SIW_PCLRC_PCLRC_reg10_13_inst_addr                                      "0x0009"
#define  set_SIW_PCLRC_PCLRC_reg10_13_reg(data)                                  (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg10_13_reg)=data)
#define  get_SIW_PCLRC_PCLRC_reg10_13_reg                                        (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg10_13_reg))
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg13_shift                                  (24)
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg12_shift                                  (16)
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg11_shift                                  (8)
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg10_shift                                  (0)
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg13_mask                                   (0xFF000000)
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg12_mask                                   (0x00FF0000)
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg11_mask                                   (0x0000FF00)
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg10_mask                                   (0x000000FF)
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg13(data)                                  (0xFF000000&((data)<<24))
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg12(data)                                  (0x00FF0000&((data)<<16))
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg11(data)                                  (0x0000FF00&((data)<<8))
#define  SIW_PCLRC_PCLRC_reg10_13_i_reg10(data)                                  (0x000000FF&(data))
#define  SIW_PCLRC_PCLRC_reg10_13_get_i_reg13(data)                              ((0xFF000000&(data))>>24)
#define  SIW_PCLRC_PCLRC_reg10_13_get_i_reg12(data)                              ((0x00FF0000&(data))>>16)
#define  SIW_PCLRC_PCLRC_reg10_13_get_i_reg11(data)                              ((0x0000FF00&(data))>>8)
#define  SIW_PCLRC_PCLRC_reg10_13_get_i_reg10(data)                              (0x000000FF&(data))

#define  SIW_PCLRC_PCLRC_reg14_15                                               0x1802BF34
#define  SIW_PCLRC_PCLRC_reg14_15_reg_addr                                       "0xB802BF34"
#define  SIW_PCLRC_PCLRC_reg14_15_reg                                            0xB802BF34
#define  SIW_PCLRC_PCLRC_reg14_15_inst_addr                                      "0x000A"
#define  set_SIW_PCLRC_PCLRC_reg14_15_reg(data)                                  (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg14_15_reg)=data)
#define  get_SIW_PCLRC_PCLRC_reg14_15_reg                                        (*((volatile unsigned int*)SIW_PCLRC_PCLRC_reg14_15_reg))
#define  SIW_PCLRC_PCLRC_reg14_15_i_reg15_shift                                  (8)
#define  SIW_PCLRC_PCLRC_reg14_15_i_reg14_shift                                  (0)
#define  SIW_PCLRC_PCLRC_reg14_15_i_reg15_mask                                   (0x0000FF00)
#define  SIW_PCLRC_PCLRC_reg14_15_i_reg14_mask                                   (0x000000FF)
#define  SIW_PCLRC_PCLRC_reg14_15_i_reg15(data)                                  (0x0000FF00&((data)<<8))
#define  SIW_PCLRC_PCLRC_reg14_15_i_reg14(data)                                  (0x000000FF&(data))
#define  SIW_PCLRC_PCLRC_reg14_15_get_i_reg15(data)                              ((0x0000FF00&(data))>>8)
#define  SIW_PCLRC_PCLRC_reg14_15_get_i_reg14(data)                              (0x000000FF&(data))

#define  SIW_PCLRC_PCLRC_BIST_CTRL                                              0x1802BFFC
#define  SIW_PCLRC_PCLRC_BIST_CTRL_reg_addr                                      "0xB802BFFC"
#define  SIW_PCLRC_PCLRC_BIST_CTRL_reg                                           0xB802BFFC
#define  SIW_PCLRC_PCLRC_BIST_CTRL_inst_addr                                     "0x000B"
#define  set_SIW_PCLRC_PCLRC_BIST_CTRL_reg(data)                                 (*((volatile unsigned int*)SIW_PCLRC_PCLRC_BIST_CTRL_reg)=data)
#define  get_SIW_PCLRC_PCLRC_BIST_CTRL_reg                                       (*((volatile unsigned int*)SIW_PCLRC_PCLRC_BIST_CTRL_reg))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_d_shift                                    (20)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_c1_shift                                   (16)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_c0_shift                                   (12)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_b1_shift                                   (8)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_b0_shift                                   (4)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_a_shift                                    (0)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_d_mask                                     (0x00F00000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_c1_mask                                    (0x000F0000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_c0_mask                                    (0x0000F000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_b1_mask                                    (0x00000F00)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_b0_mask                                    (0x000000F0)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_a_mask                                     (0x0000000F)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_d(data)                                    (0x00F00000&((data)<<20))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_c1(data)                                   (0x000F0000&((data)<<16))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_c0(data)                                   (0x0000F000&((data)<<12))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_b1(data)                                   (0x00000F00&((data)<<8))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_b0(data)                                   (0x000000F0&((data)<<4))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_rm_a(data)                                    (0x0000000F&(data))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_get_rm_d(data)                                ((0x00F00000&(data))>>20)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_get_rm_c1(data)                               ((0x000F0000&(data))>>16)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_get_rm_c0(data)                               ((0x0000F000&(data))>>12)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_get_rm_b1(data)                               ((0x00000F00&(data))>>8)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_get_rm_b0(data)                               ((0x000000F0&(data))>>4)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_get_rm_a(data)                                (0x0000000F&(data))

#define  SIW_PCLRC_PCLRC_BIST_CTRL_1                                            0x1802BFF8
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_reg_addr                                    "0xB802BFF8"
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_reg                                         0xB802BFF8
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_inst_addr                                   "0x000C"
#define  set_SIW_PCLRC_PCLRC_BIST_CTRL_1_reg(data)                               (*((volatile unsigned int*)SIW_PCLRC_PCLRC_BIST_CTRL_1_reg)=data)
#define  get_SIW_PCLRC_PCLRC_BIST_CTRL_1_reg                                     (*((volatile unsigned int*)SIW_PCLRC_PCLRC_BIST_CTRL_1_reg))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_testrwm_b1_shift                            (25)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_testrwm_b0_shift                            (24)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_d_shift                               (21)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_c1_shift                              (20)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_c0_shift                              (19)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_b1_shift                              (18)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_b0_shift                              (17)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_a_shift                               (16)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_d_shift                                  (13)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_c1_shift                                 (12)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_c0_shift                                 (11)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_b1_shift                                 (10)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_b0_shift                                 (9)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_a_shift                                  (8)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_d_shift                                 (5)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_c1_shift                                (4)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_c0_shift                                (3)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_b1_shift                                (2)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_b0_shift                                (1)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_a_shift                                 (0)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_testrwm_b1_mask                             (0x02000000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_testrwm_b0_mask                             (0x01000000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_d_mask                                (0x00200000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_c1_mask                               (0x00100000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_c0_mask                               (0x00080000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_b1_mask                               (0x00040000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_b0_mask                               (0x00020000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_a_mask                                (0x00010000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_d_mask                                   (0x00002000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_c1_mask                                  (0x00001000)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_c0_mask                                  (0x00000800)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_b1_mask                                  (0x00000400)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_b0_mask                                  (0x00000200)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_a_mask                                   (0x00000100)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_d_mask                                  (0x00000020)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_c1_mask                                 (0x00000010)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_c0_mask                                 (0x00000008)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_b1_mask                                 (0x00000004)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_b0_mask                                 (0x00000002)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_a_mask                                  (0x00000001)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_testrwm_b1(data)                            (0x02000000&((data)<<25))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_testrwm_b0(data)                            (0x01000000&((data)<<24))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_d(data)                               (0x00200000&((data)<<21))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_c1(data)                              (0x00100000&((data)<<20))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_c0(data)                              (0x00080000&((data)<<19))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_b1(data)                              (0x00040000&((data)<<18))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_b0(data)                              (0x00020000&((data)<<17))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_test1_a(data)                               (0x00010000&((data)<<16))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_d(data)                                  (0x00002000&((data)<<13))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_c1(data)                                 (0x00001000&((data)<<12))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_c0(data)                                 (0x00000800&((data)<<11))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_b1(data)                                 (0x00000400&((data)<<10))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_b0(data)                                 (0x00000200&((data)<<9))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_ls_a(data)                                  (0x00000100&((data)<<8))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_d(data)                                 (0x00000020&((data)<<5))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_c1(data)                                (0x00000010&((data)<<4))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_c0(data)                                (0x00000008&((data)<<3))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_b1(data)                                (0x00000004&((data)<<2))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_b0(data)                                (0x00000002&((data)<<1))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_rme_a(data)                                 (0x00000001&(data))
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_testrwm_b1(data)                        ((0x02000000&(data))>>25)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_testrwm_b0(data)                        ((0x01000000&(data))>>24)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_test1_d(data)                           ((0x00200000&(data))>>21)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_test1_c1(data)                          ((0x00100000&(data))>>20)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_test1_c0(data)                          ((0x00080000&(data))>>19)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_test1_b1(data)                          ((0x00040000&(data))>>18)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_test1_b0(data)                          ((0x00020000&(data))>>17)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_test1_a(data)                           ((0x00010000&(data))>>16)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_ls_d(data)                              ((0x00002000&(data))>>13)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_ls_c1(data)                             ((0x00001000&(data))>>12)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_ls_c0(data)                             ((0x00000800&(data))>>11)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_ls_b1(data)                             ((0x00000400&(data))>>10)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_ls_b0(data)                             ((0x00000200&(data))>>9)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_ls_a(data)                              ((0x00000100&(data))>>8)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_rme_d(data)                             ((0x00000020&(data))>>5)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_rme_c1(data)                            ((0x00000010&(data))>>4)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_rme_c0(data)                            ((0x00000008&(data))>>3)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_rme_b1(data)                            ((0x00000004&(data))>>2)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_rme_b0(data)                            ((0x00000002&(data))>>1)
#define  SIW_PCLRC_PCLRC_BIST_CTRL_1_get_rme_a(data)                             (0x00000001&(data))

#define  SIW_PCLRC_PCLRC_BIST_FAIL_0                                            0x1802BFF4
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_reg_addr                                    "0xB802BFF4"
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_reg                                         0xB802BFF4
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_inst_addr                                   "0x000D"
#define  set_SIW_PCLRC_PCLRC_BIST_FAIL_0_reg(data)                               (*((volatile unsigned int*)SIW_PCLRC_PCLRC_BIST_FAIL_0_reg)=data)
#define  get_SIW_PCLRC_PCLRC_BIST_FAIL_0_reg                                     (*((volatile unsigned int*)SIW_PCLRC_PCLRC_BIST_FAIL_0_reg))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_11_shift                        (19)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_10_shift                        (18)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_9_shift                         (17)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_8_shift                         (16)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_7_shift                         (15)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_6_shift                         (14)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_5_shift                         (13)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_4_shift                         (12)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_3_shift                         (11)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_2_shift                         (10)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_1_shift                         (9)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_0_shift                         (8)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_3_shift                         (3)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_2_shift                         (2)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_1_shift                         (1)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_0_shift                         (0)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_11_mask                         (0x00080000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_10_mask                         (0x00040000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_9_mask                          (0x00020000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_8_mask                          (0x00010000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_7_mask                          (0x00008000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_6_mask                          (0x00004000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_5_mask                          (0x00002000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_4_mask                          (0x00001000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_3_mask                          (0x00000800)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_2_mask                          (0x00000400)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_1_mask                          (0x00000200)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_0_mask                          (0x00000100)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_3_mask                          (0x00000008)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_2_mask                          (0x00000004)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_1_mask                          (0x00000002)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_0_mask                          (0x00000001)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_11(data)                        (0x00080000&((data)<<19))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_10(data)                        (0x00040000&((data)<<18))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_9(data)                         (0x00020000&((data)<<17))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_8(data)                         (0x00010000&((data)<<16))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_7(data)                         (0x00008000&((data)<<15))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_6(data)                         (0x00004000&((data)<<14))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_5(data)                         (0x00002000&((data)<<13))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_4(data)                         (0x00001000&((data)<<12))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_3(data)                         (0x00000800&((data)<<11))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_2(data)                         (0x00000400&((data)<<10))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_1(data)                         (0x00000200&((data)<<9))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_b_0(data)                         (0x00000100&((data)<<8))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_3(data)                         (0x00000008&((data)<<3))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_2(data)                         (0x00000004&((data)<<2))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_1(data)                         (0x00000002&((data)<<1))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_bist_fail_a_0(data)                         (0x00000001&(data))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_11(data)                    ((0x00080000&(data))>>19)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_10(data)                    ((0x00040000&(data))>>18)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_9(data)                     ((0x00020000&(data))>>17)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_8(data)                     ((0x00010000&(data))>>16)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_7(data)                     ((0x00008000&(data))>>15)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_6(data)                     ((0x00004000&(data))>>14)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_5(data)                     ((0x00002000&(data))>>13)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_4(data)                     ((0x00001000&(data))>>12)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_3(data)                     ((0x00000800&(data))>>11)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_2(data)                     ((0x00000400&(data))>>10)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_1(data)                     ((0x00000200&(data))>>9)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_b_0(data)                     ((0x00000100&(data))>>8)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_a_3(data)                     ((0x00000008&(data))>>3)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_a_2(data)                     ((0x00000004&(data))>>2)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_a_1(data)                     ((0x00000002&(data))>>1)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_0_get_bist_fail_a_0(data)                     (0x00000001&(data))

#define  SIW_PCLRC_PCLRC_BIST_FAIL_1                                            0x1802BFF0
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_reg_addr                                    "0xB802BFF0"
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_reg                                         0xB802BFF0
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_inst_addr                                   "0x000E"
#define  set_SIW_PCLRC_PCLRC_BIST_FAIL_1_reg(data)                               (*((volatile unsigned int*)SIW_PCLRC_PCLRC_BIST_FAIL_1_reg)=data)
#define  get_SIW_PCLRC_PCLRC_BIST_FAIL_1_reg                                     (*((volatile unsigned int*)SIW_PCLRC_PCLRC_BIST_FAIL_1_reg))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_5_shift                         (21)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_4_shift                         (20)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_3_shift                         (19)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_2_shift                         (18)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_1_shift                         (17)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_0_shift                         (16)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_11_shift                        (11)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_10_shift                        (10)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_9_shift                         (9)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_8_shift                         (8)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_7_shift                         (7)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_6_shift                         (6)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_5_shift                         (5)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_4_shift                         (4)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_3_shift                         (3)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_2_shift                         (2)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_1_shift                         (1)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_0_shift                         (0)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_5_mask                          (0x00200000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_4_mask                          (0x00100000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_3_mask                          (0x00080000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_2_mask                          (0x00040000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_1_mask                          (0x00020000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_0_mask                          (0x00010000)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_11_mask                         (0x00000800)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_10_mask                         (0x00000400)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_9_mask                          (0x00000200)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_8_mask                          (0x00000100)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_7_mask                          (0x00000080)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_6_mask                          (0x00000040)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_5_mask                          (0x00000020)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_4_mask                          (0x00000010)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_3_mask                          (0x00000008)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_2_mask                          (0x00000004)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_1_mask                          (0x00000002)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_0_mask                          (0x00000001)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_5(data)                         (0x00200000&((data)<<21))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_4(data)                         (0x00100000&((data)<<20))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_3(data)                         (0x00080000&((data)<<19))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_2(data)                         (0x00040000&((data)<<18))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_1(data)                         (0x00020000&((data)<<17))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_d_0(data)                         (0x00010000&((data)<<16))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_11(data)                        (0x00000800&((data)<<11))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_10(data)                        (0x00000400&((data)<<10))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_9(data)                         (0x00000200&((data)<<9))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_8(data)                         (0x00000100&((data)<<8))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_7(data)                         (0x00000080&((data)<<7))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_6(data)                         (0x00000040&((data)<<6))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_5(data)                         (0x00000020&((data)<<5))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_4(data)                         (0x00000010&((data)<<4))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_3(data)                         (0x00000008&((data)<<3))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_2(data)                         (0x00000004&((data)<<2))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_1(data)                         (0x00000002&((data)<<1))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_bist_fail_c_0(data)                         (0x00000001&(data))
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_d_5(data)                     ((0x00200000&(data))>>21)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_d_4(data)                     ((0x00100000&(data))>>20)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_d_3(data)                     ((0x00080000&(data))>>19)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_d_2(data)                     ((0x00040000&(data))>>18)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_d_1(data)                     ((0x00020000&(data))>>17)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_d_0(data)                     ((0x00010000&(data))>>16)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_11(data)                    ((0x00000800&(data))>>11)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_10(data)                    ((0x00000400&(data))>>10)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_9(data)                     ((0x00000200&(data))>>9)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_8(data)                     ((0x00000100&(data))>>8)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_7(data)                     ((0x00000080&(data))>>7)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_6(data)                     ((0x00000040&(data))>>6)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_5(data)                     ((0x00000020&(data))>>5)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_4(data)                     ((0x00000010&(data))>>4)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_3(data)                     ((0x00000008&(data))>>3)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_2(data)                     ((0x00000004&(data))>>2)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_1(data)                     ((0x00000002&(data))>>1)
#define  SIW_PCLRC_PCLRC_BIST_FAIL_1_get_bist_fail_c_0(data)                     (0x00000001&(data))

#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0                                        0x1802BFEC
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_reg_addr                                "0xB802BFEC"
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_reg                                     0xB802BFEC
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_inst_addr                               "0x000F"
#define  set_SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_reg(data)                           (*((volatile unsigned int*)SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_reg)=data)
#define  get_SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_reg                                 (*((volatile unsigned int*)SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_reg))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_11_shift                (19)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_10_shift                (18)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_9_shift                 (17)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_8_shift                 (16)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_7_shift                 (15)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_6_shift                 (14)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_5_shift                 (13)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_4_shift                 (12)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_3_shift                 (11)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_2_shift                 (10)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_1_shift                 (9)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_0_shift                 (8)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_3_shift                 (3)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_2_shift                 (2)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_1_shift                 (1)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_0_shift                 (0)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_11_mask                 (0x00080000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_10_mask                 (0x00040000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_9_mask                  (0x00020000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_8_mask                  (0x00010000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_7_mask                  (0x00008000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_6_mask                  (0x00004000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_5_mask                  (0x00002000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_4_mask                  (0x00001000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_3_mask                  (0x00000800)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_2_mask                  (0x00000400)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_1_mask                  (0x00000200)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_0_mask                  (0x00000100)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_3_mask                  (0x00000008)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_2_mask                  (0x00000004)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_1_mask                  (0x00000002)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_0_mask                  (0x00000001)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_11(data)                (0x00080000&((data)<<19))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_10(data)                (0x00040000&((data)<<18))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_9(data)                 (0x00020000&((data)<<17))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_8(data)                 (0x00010000&((data)<<16))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_7(data)                 (0x00008000&((data)<<15))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_6(data)                 (0x00004000&((data)<<14))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_5(data)                 (0x00002000&((data)<<13))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_4(data)                 (0x00001000&((data)<<12))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_3(data)                 (0x00000800&((data)<<11))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_2(data)                 (0x00000400&((data)<<10))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_1(data)                 (0x00000200&((data)<<9))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_b_0(data)                 (0x00000100&((data)<<8))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_3(data)                 (0x00000008&((data)<<3))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_2(data)                 (0x00000004&((data)<<2))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_1(data)                 (0x00000002&((data)<<1))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_drf_bist_fail_a_0(data)                 (0x00000001&(data))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_11(data)            ((0x00080000&(data))>>19)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_10(data)            ((0x00040000&(data))>>18)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_9(data)             ((0x00020000&(data))>>17)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_8(data)             ((0x00010000&(data))>>16)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_7(data)             ((0x00008000&(data))>>15)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_6(data)             ((0x00004000&(data))>>14)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_5(data)             ((0x00002000&(data))>>13)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_4(data)             ((0x00001000&(data))>>12)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_3(data)             ((0x00000800&(data))>>11)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_2(data)             ((0x00000400&(data))>>10)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_1(data)             ((0x00000200&(data))>>9)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_b_0(data)             ((0x00000100&(data))>>8)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_a_3(data)             ((0x00000008&(data))>>3)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_a_2(data)             ((0x00000004&(data))>>2)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_a_1(data)             ((0x00000002&(data))>>1)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_0_get_drf_bist_fail_a_0(data)             (0x00000001&(data))

#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1                                        0x1802BFE8
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_reg_addr                                "0xB802BFE8"
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_reg                                     0xB802BFE8
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_inst_addr                               "0x0010"
#define  set_SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_reg(data)                           (*((volatile unsigned int*)SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_reg)=data)
#define  get_SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_reg                                 (*((volatile unsigned int*)SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_reg))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_5_shift                 (21)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_4_shift                 (20)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_3_shift                 (19)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_2_shift                 (18)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_1_shift                 (17)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_0_shift                 (16)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_11_shift                (11)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_10_shift                (10)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_9_shift                 (9)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_8_shift                 (8)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_7_shift                 (7)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_6_shift                 (6)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_5_shift                 (5)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_4_shift                 (4)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_3_shift                 (3)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_2_shift                 (2)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_1_shift                 (1)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_0_shift                 (0)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_5_mask                  (0x00200000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_4_mask                  (0x00100000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_3_mask                  (0x00080000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_2_mask                  (0x00040000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_1_mask                  (0x00020000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_0_mask                  (0x00010000)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_11_mask                 (0x00000800)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_10_mask                 (0x00000400)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_9_mask                  (0x00000200)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_8_mask                  (0x00000100)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_7_mask                  (0x00000080)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_6_mask                  (0x00000040)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_5_mask                  (0x00000020)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_4_mask                  (0x00000010)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_3_mask                  (0x00000008)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_2_mask                  (0x00000004)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_1_mask                  (0x00000002)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_0_mask                  (0x00000001)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_5(data)                 (0x00200000&((data)<<21))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_4(data)                 (0x00100000&((data)<<20))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_3(data)                 (0x00080000&((data)<<19))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_2(data)                 (0x00040000&((data)<<18))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_1(data)                 (0x00020000&((data)<<17))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_d_0(data)                 (0x00010000&((data)<<16))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_11(data)                (0x00000800&((data)<<11))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_10(data)                (0x00000400&((data)<<10))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_9(data)                 (0x00000200&((data)<<9))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_8(data)                 (0x00000100&((data)<<8))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_7(data)                 (0x00000080&((data)<<7))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_6(data)                 (0x00000040&((data)<<6))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_5(data)                 (0x00000020&((data)<<5))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_4(data)                 (0x00000010&((data)<<4))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_3(data)                 (0x00000008&((data)<<3))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_2(data)                 (0x00000004&((data)<<2))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_1(data)                 (0x00000002&((data)<<1))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_drf_bist_fail_c_0(data)                 (0x00000001&(data))
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_d_5(data)             ((0x00200000&(data))>>21)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_d_4(data)             ((0x00100000&(data))>>20)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_d_3(data)             ((0x00080000&(data))>>19)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_d_2(data)             ((0x00040000&(data))>>18)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_d_1(data)             ((0x00020000&(data))>>17)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_d_0(data)             ((0x00010000&(data))>>16)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_11(data)            ((0x00000800&(data))>>11)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_10(data)            ((0x00000400&(data))>>10)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_9(data)             ((0x00000200&(data))>>9)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_8(data)             ((0x00000100&(data))>>8)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_7(data)             ((0x00000080&(data))>>7)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_6(data)             ((0x00000040&(data))>>6)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_5(data)             ((0x00000020&(data))>>5)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_4(data)             ((0x00000010&(data))>>4)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_3(data)             ((0x00000008&(data))>>3)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_2(data)             ((0x00000004&(data))>>2)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_1(data)             ((0x00000002&(data))>>1)
#define  SIW_PCLRC_PCLRC_DRF_BIST_FAIL_1_get_drf_bist_fail_c_0(data)             (0x00000001&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======SIW_PCLRC register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_rd_sel:1;
        RBus_UInt32  db_en:1;
    };
}siw_pclrc_pclrc_db_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  pclrc_bypass:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  pclrc_bypass_en:1;
    };
}siw_pclrc_pclrc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_ax_wr_err:1;
        RBus_UInt32  lut_ax_rd_err:1;
        RBus_UInt32  lut_ax_fifo_full:1;
        RBus_UInt32  lut_ax_fifo_empty:1;
        RBus_UInt32  res1:25;
        RBus_UInt32  lut_ax_mode:1;
        RBus_UInt32  lut_ax_wren:1;
        RBus_UInt32  lut_ax_en:1;
    };
}siw_pclrc_pclrc_lut_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_ax_data:32;
    };
}siw_pclrc_pclrc_lut_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802bf1c_31_0:32;
    };
}siw_pclrc_pclrc_dummy_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg03:8;
        RBus_UInt32  i_reg02:8;
        RBus_UInt32  i_reg01:8;
        RBus_UInt32  i_reg00:8;
    };
}siw_pclrc_pclrc_reg00_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg07:8;
        RBus_UInt32  i_reg06:8;
        RBus_UInt32  i_reg05:8;
        RBus_UInt32  i_reg04:8;
    };
}siw_pclrc_pclrc_reg04_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg0b:8;
        RBus_UInt32  i_reg0a:8;
        RBus_UInt32  i_reg09:8;
        RBus_UInt32  i_reg08:8;
    };
}siw_pclrc_pclrc_reg08_0b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg0f:8;
        RBus_UInt32  i_reg0e:8;
        RBus_UInt32  i_reg0d:8;
        RBus_UInt32  i_reg0c:8;
    };
}siw_pclrc_pclrc_reg0c_0f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg13:8;
        RBus_UInt32  i_reg12:8;
        RBus_UInt32  i_reg11:8;
        RBus_UInt32  i_reg10:8;
    };
}siw_pclrc_pclrc_reg10_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  i_reg15:8;
        RBus_UInt32  i_reg14:8;
    };
}siw_pclrc_pclrc_reg14_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  rm_d:4;
        RBus_UInt32  rm_c1:4;
        RBus_UInt32  rm_c0:4;
        RBus_UInt32  rm_b1:4;
        RBus_UInt32  rm_b0:4;
        RBus_UInt32  rm_a:4;
    };
}siw_pclrc_pclrc_bist_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  testrwm_b1:1;
        RBus_UInt32  testrwm_b0:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  test1_d:1;
        RBus_UInt32  test1_c1:1;
        RBus_UInt32  test1_c0:1;
        RBus_UInt32  test1_b1:1;
        RBus_UInt32  test1_b0:1;
        RBus_UInt32  test1_a:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  ls_d:1;
        RBus_UInt32  ls_c1:1;
        RBus_UInt32  ls_c0:1;
        RBus_UInt32  ls_b1:1;
        RBus_UInt32  ls_b0:1;
        RBus_UInt32  ls_a:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  rme_d:1;
        RBus_UInt32  rme_c1:1;
        RBus_UInt32  rme_c0:1;
        RBus_UInt32  rme_b1:1;
        RBus_UInt32  rme_b0:1;
        RBus_UInt32  rme_a:1;
    };
}siw_pclrc_pclrc_bist_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  bist_fail_b_11:1;
        RBus_UInt32  bist_fail_b_10:1;
        RBus_UInt32  bist_fail_b_9:1;
        RBus_UInt32  bist_fail_b_8:1;
        RBus_UInt32  bist_fail_b_7:1;
        RBus_UInt32  bist_fail_b_6:1;
        RBus_UInt32  bist_fail_b_5:1;
        RBus_UInt32  bist_fail_b_4:1;
        RBus_UInt32  bist_fail_b_3:1;
        RBus_UInt32  bist_fail_b_2:1;
        RBus_UInt32  bist_fail_b_1:1;
        RBus_UInt32  bist_fail_b_0:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  bist_fail_a_3:1;
        RBus_UInt32  bist_fail_a_2:1;
        RBus_UInt32  bist_fail_a_1:1;
        RBus_UInt32  bist_fail_a_0:1;
    };
}siw_pclrc_pclrc_bist_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  bist_fail_d_5:1;
        RBus_UInt32  bist_fail_d_4:1;
        RBus_UInt32  bist_fail_d_3:1;
        RBus_UInt32  bist_fail_d_2:1;
        RBus_UInt32  bist_fail_d_1:1;
        RBus_UInt32  bist_fail_d_0:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  bist_fail_c_11:1;
        RBus_UInt32  bist_fail_c_10:1;
        RBus_UInt32  bist_fail_c_9:1;
        RBus_UInt32  bist_fail_c_8:1;
        RBus_UInt32  bist_fail_c_7:1;
        RBus_UInt32  bist_fail_c_6:1;
        RBus_UInt32  bist_fail_c_5:1;
        RBus_UInt32  bist_fail_c_4:1;
        RBus_UInt32  bist_fail_c_3:1;
        RBus_UInt32  bist_fail_c_2:1;
        RBus_UInt32  bist_fail_c_1:1;
        RBus_UInt32  bist_fail_c_0:1;
    };
}siw_pclrc_pclrc_bist_fail_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  drf_bist_fail_b_11:1;
        RBus_UInt32  drf_bist_fail_b_10:1;
        RBus_UInt32  drf_bist_fail_b_9:1;
        RBus_UInt32  drf_bist_fail_b_8:1;
        RBus_UInt32  drf_bist_fail_b_7:1;
        RBus_UInt32  drf_bist_fail_b_6:1;
        RBus_UInt32  drf_bist_fail_b_5:1;
        RBus_UInt32  drf_bist_fail_b_4:1;
        RBus_UInt32  drf_bist_fail_b_3:1;
        RBus_UInt32  drf_bist_fail_b_2:1;
        RBus_UInt32  drf_bist_fail_b_1:1;
        RBus_UInt32  drf_bist_fail_b_0:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  drf_bist_fail_a_3:1;
        RBus_UInt32  drf_bist_fail_a_2:1;
        RBus_UInt32  drf_bist_fail_a_1:1;
        RBus_UInt32  drf_bist_fail_a_0:1;
    };
}siw_pclrc_pclrc_drf_bist_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  drf_bist_fail_d_5:1;
        RBus_UInt32  drf_bist_fail_d_4:1;
        RBus_UInt32  drf_bist_fail_d_3:1;
        RBus_UInt32  drf_bist_fail_d_2:1;
        RBus_UInt32  drf_bist_fail_d_1:1;
        RBus_UInt32  drf_bist_fail_d_0:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  drf_bist_fail_c_11:1;
        RBus_UInt32  drf_bist_fail_c_10:1;
        RBus_UInt32  drf_bist_fail_c_9:1;
        RBus_UInt32  drf_bist_fail_c_8:1;
        RBus_UInt32  drf_bist_fail_c_7:1;
        RBus_UInt32  drf_bist_fail_c_6:1;
        RBus_UInt32  drf_bist_fail_c_5:1;
        RBus_UInt32  drf_bist_fail_c_4:1;
        RBus_UInt32  drf_bist_fail_c_3:1;
        RBus_UInt32  drf_bist_fail_c_2:1;
        RBus_UInt32  drf_bist_fail_c_1:1;
        RBus_UInt32  drf_bist_fail_c_0:1;
    };
}siw_pclrc_pclrc_drf_bist_fail_1_RBUS;

#else //apply LITTLE_ENDIAN

//======SIW_PCLRC register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_rd_sel:1;
        RBus_UInt32  db_apply:1;
        RBus_UInt32  res1:29;
    };
}siw_pclrc_pclrc_db_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pclrc_bypass_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  pclrc_bypass:1;
        RBus_UInt32  res2:27;
    };
}siw_pclrc_pclrc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_ax_en:1;
        RBus_UInt32  lut_ax_wren:1;
        RBus_UInt32  lut_ax_mode:1;
        RBus_UInt32  res1:25;
        RBus_UInt32  lut_ax_fifo_empty:1;
        RBus_UInt32  lut_ax_fifo_full:1;
        RBus_UInt32  lut_ax_rd_err:1;
        RBus_UInt32  lut_ax_wr_err:1;
    };
}siw_pclrc_pclrc_lut_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_ax_data:32;
    };
}siw_pclrc_pclrc_lut_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802bf1c_31_0:32;
    };
}siw_pclrc_pclrc_dummy_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg00:8;
        RBus_UInt32  i_reg01:8;
        RBus_UInt32  i_reg02:8;
        RBus_UInt32  i_reg03:8;
    };
}siw_pclrc_pclrc_reg00_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg04:8;
        RBus_UInt32  i_reg05:8;
        RBus_UInt32  i_reg06:8;
        RBus_UInt32  i_reg07:8;
    };
}siw_pclrc_pclrc_reg04_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg08:8;
        RBus_UInt32  i_reg09:8;
        RBus_UInt32  i_reg0a:8;
        RBus_UInt32  i_reg0b:8;
    };
}siw_pclrc_pclrc_reg08_0b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg0c:8;
        RBus_UInt32  i_reg0d:8;
        RBus_UInt32  i_reg0e:8;
        RBus_UInt32  i_reg0f:8;
    };
}siw_pclrc_pclrc_reg0c_0f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg10:8;
        RBus_UInt32  i_reg11:8;
        RBus_UInt32  i_reg12:8;
        RBus_UInt32  i_reg13:8;
    };
}siw_pclrc_pclrc_reg10_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  i_reg14:8;
        RBus_UInt32  i_reg15:8;
        RBus_UInt32  res1:16;
    };
}siw_pclrc_pclrc_reg14_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rm_a:4;
        RBus_UInt32  rm_b0:4;
        RBus_UInt32  rm_b1:4;
        RBus_UInt32  rm_c0:4;
        RBus_UInt32  rm_c1:4;
        RBus_UInt32  rm_d:4;
        RBus_UInt32  res1:8;
    };
}siw_pclrc_pclrc_bist_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rme_a:1;
        RBus_UInt32  rme_b0:1;
        RBus_UInt32  rme_b1:1;
        RBus_UInt32  rme_c0:1;
        RBus_UInt32  rme_c1:1;
        RBus_UInt32  rme_d:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ls_a:1;
        RBus_UInt32  ls_b0:1;
        RBus_UInt32  ls_b1:1;
        RBus_UInt32  ls_c0:1;
        RBus_UInt32  ls_c1:1;
        RBus_UInt32  ls_d:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  test1_a:1;
        RBus_UInt32  test1_b0:1;
        RBus_UInt32  test1_b1:1;
        RBus_UInt32  test1_c0:1;
        RBus_UInt32  test1_c1:1;
        RBus_UInt32  test1_d:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  testrwm_b0:1;
        RBus_UInt32  testrwm_b1:1;
        RBus_UInt32  res4:6;
    };
}siw_pclrc_pclrc_bist_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bist_fail_a_0:1;
        RBus_UInt32  bist_fail_a_1:1;
        RBus_UInt32  bist_fail_a_2:1;
        RBus_UInt32  bist_fail_a_3:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  bist_fail_b_0:1;
        RBus_UInt32  bist_fail_b_1:1;
        RBus_UInt32  bist_fail_b_2:1;
        RBus_UInt32  bist_fail_b_3:1;
        RBus_UInt32  bist_fail_b_4:1;
        RBus_UInt32  bist_fail_b_5:1;
        RBus_UInt32  bist_fail_b_6:1;
        RBus_UInt32  bist_fail_b_7:1;
        RBus_UInt32  bist_fail_b_8:1;
        RBus_UInt32  bist_fail_b_9:1;
        RBus_UInt32  bist_fail_b_10:1;
        RBus_UInt32  bist_fail_b_11:1;
        RBus_UInt32  res2:12;
    };
}siw_pclrc_pclrc_bist_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bist_fail_c_0:1;
        RBus_UInt32  bist_fail_c_1:1;
        RBus_UInt32  bist_fail_c_2:1;
        RBus_UInt32  bist_fail_c_3:1;
        RBus_UInt32  bist_fail_c_4:1;
        RBus_UInt32  bist_fail_c_5:1;
        RBus_UInt32  bist_fail_c_6:1;
        RBus_UInt32  bist_fail_c_7:1;
        RBus_UInt32  bist_fail_c_8:1;
        RBus_UInt32  bist_fail_c_9:1;
        RBus_UInt32  bist_fail_c_10:1;
        RBus_UInt32  bist_fail_c_11:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  bist_fail_d_0:1;
        RBus_UInt32  bist_fail_d_1:1;
        RBus_UInt32  bist_fail_d_2:1;
        RBus_UInt32  bist_fail_d_3:1;
        RBus_UInt32  bist_fail_d_4:1;
        RBus_UInt32  bist_fail_d_5:1;
        RBus_UInt32  res2:10;
    };
}siw_pclrc_pclrc_bist_fail_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drf_bist_fail_a_0:1;
        RBus_UInt32  drf_bist_fail_a_1:1;
        RBus_UInt32  drf_bist_fail_a_2:1;
        RBus_UInt32  drf_bist_fail_a_3:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  drf_bist_fail_b_0:1;
        RBus_UInt32  drf_bist_fail_b_1:1;
        RBus_UInt32  drf_bist_fail_b_2:1;
        RBus_UInt32  drf_bist_fail_b_3:1;
        RBus_UInt32  drf_bist_fail_b_4:1;
        RBus_UInt32  drf_bist_fail_b_5:1;
        RBus_UInt32  drf_bist_fail_b_6:1;
        RBus_UInt32  drf_bist_fail_b_7:1;
        RBus_UInt32  drf_bist_fail_b_8:1;
        RBus_UInt32  drf_bist_fail_b_9:1;
        RBus_UInt32  drf_bist_fail_b_10:1;
        RBus_UInt32  drf_bist_fail_b_11:1;
        RBus_UInt32  res2:12;
    };
}siw_pclrc_pclrc_drf_bist_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drf_bist_fail_c_0:1;
        RBus_UInt32  drf_bist_fail_c_1:1;
        RBus_UInt32  drf_bist_fail_c_2:1;
        RBus_UInt32  drf_bist_fail_c_3:1;
        RBus_UInt32  drf_bist_fail_c_4:1;
        RBus_UInt32  drf_bist_fail_c_5:1;
        RBus_UInt32  drf_bist_fail_c_6:1;
        RBus_UInt32  drf_bist_fail_c_7:1;
        RBus_UInt32  drf_bist_fail_c_8:1;
        RBus_UInt32  drf_bist_fail_c_9:1;
        RBus_UInt32  drf_bist_fail_c_10:1;
        RBus_UInt32  drf_bist_fail_c_11:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  drf_bist_fail_d_0:1;
        RBus_UInt32  drf_bist_fail_d_1:1;
        RBus_UInt32  drf_bist_fail_d_2:1;
        RBus_UInt32  drf_bist_fail_d_3:1;
        RBus_UInt32  drf_bist_fail_d_4:1;
        RBus_UInt32  drf_bist_fail_d_5:1;
        RBus_UInt32  res2:10;
    };
}siw_pclrc_pclrc_drf_bist_fail_1_RBUS;




#endif 


#endif 
