/*
 * CreatePinmuxHeaderFile
 * Total setting number: 235

 * Date: Mar 24 2020 16:38:24
 */
#include <platform_lib/board/pcb_bga_library.h>
#include "pcb_define.h"
#include <input-event-codes.h>
// PAD_NAME: PAD_GPIO_17_IO 2 BALL NUM: D12
#define BGA_PIN_2								(0xF&0xF)//0xB8000810[23:20];
																//0: SPI_FCIC_SCLK,<O>
																//2: SPI_SCLK,<O>,<HS>
																//3: ld_spi0_p2_sck_src0,<I/O>
																//4: TCON_bit13,<O>
																//5: TCON_bit14,<O>
																//6: TCON_bit15,<O>
																//7: TCON_bit19,<O>
																//9: TP0_SYNC_src2,<I>,<HS>
																//A: I2S_IN_Data0_src4,<I>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit17,<I/O>
																//def: MIS_GPIO_bit17,<I/O>
#define BGA_PIN_2_UP							(0&0x01)// 0xB8000810[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_2_PD							(0&0x01)// 0xB8000810[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_2_DS							(0&0x01)// 0xB8000810[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_2_SR							(0&0x01)// 0xB8000810[16]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_19_IO 4 BALL NUM: D11
#define BGA_PIN_4								(0xF&0xF)//0xB8000810[7:4];
																//0: SPI_FCIC_DI_src0,<I/O>
																//2: SPI_HOLD_src1,<I/O>,<HS>
																//3: ld_spi0_p4_sdi_src0,<I>
																//4: TCON_bit9,<O>
																//5: TCON_bit10,<O>
																//6: TCON_bit11,<O>
																//7: TCON_bit12,<O>
																//9: TP0_VAL_src2,<I>,<HS>
																//B: I2C4_SCL_src1,<I/O>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit19,<I/O>
																//def: MIS_GPIO_bit19,<I/O>
#define BGA_PIN_4_UP							(0&0x01)// 0xB8000810[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_4_PD							(0&0x01)// 0xB8000810[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_4_DS							(0&0x01)// 0xB8000810[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_4_SR							(0&0x01)// 0xB8000810[0]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_16_IO 5 BALL NUM: F12
#define BGA_PIN_5								(0xF&0xF)//0xB8000810[31:28];
																//0: SPI_FCIC_CS_N,<O>
																//2: SPI_WP_src1,<I/O>,<HS>
																//3: ld_spi0_p1_cs1,<O>
																//4: TCON_bit11,<O>
																//5: TCON_bit12,<O>
																//6: TCON_bit13,<O>
																//7: TCON_bit27,<O>
																//9: TP0_CLK_src2,<I>,<HS>,<AND>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit16,<I/O>
																//def: MIS_GPIO_bit16,<I/O>
#define BGA_PIN_5_UP							(0&0x01)// 0xB8000810[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_5_PD							(0&0x01)// 0xB8000810[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_5_DS							(0&0x01)// 0xB8000810[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_5_SR							(0&0x01)// 0xB8000810[24]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_02_IO 6 BALL NUM: F11
#define BGA_PIN_6								(0xF&0x2)//0xB8000800[15:12];
																//0: usit_sfc,<ODH>
																//1: vby1_osd_lock_src0,<I>
																//2: VBY1_LOCK_src2,<I>
																//3: TCON_bit5,<O>
																//4: TCON_bit6,<O>
																//5: TCON_bit7,<O>
																//6: TCON_bit17,<O>
																//C: usit_sbc_src3,<I/ODH>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit2,<I/O>
																//def: MIS_GPIO_bit2,<I/O>
#define BGA_PIN_6_UP							(1&0x01)// 0xB8000800[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_6_PD							(0&0x01)// 0xB8000800[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_6_DS							(0&0x01)// 0xB8000800[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_6_SR							(0&0x01)// 0xB8000800[8]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_03_IO 7 BALL NUM: E11
#define BGA_PIN_7								(0xF&0xF)//0xB8000800[7:4];
																//0: usit_sbc_src1,<I/ODH>
																//1: vby1_osd_htpd_src0,<I>
																//2: VBY1_HTPD_src1,<I>
																//3: TCON_bit7,<O>
																//4: TCON_bit8,<O>
																//5: TCON_bit9,<O>
																//6: TCON_bit24,<O>
																//C: usit_sfc,<ODH>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit3,<I/O>
																//def: MIS_GPIO_bit3,<I/O>
#define BGA_PIN_7_UP							(0&0x01)// 0xB8000800[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_7_PD							(0&0x01)// 0xB8000800[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_7_DS							(0&0x01)// 0xB8000800[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_7_SR							(0&0x01)// 0xB8000800[0]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_00_IO 10 BALL NUM: F10
#define BGA_PIN_10								(0xF&0xF)//0xB8000800[31:28];
																//3: TCON_bit1,<O>
																//4: TCON_bit2,<O>
																//5: TCON_bit3,<O>
																//6: TCON_bit12,<O>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit0,<I/O>
																//def: MIS_GPIO_bit0,<I/O>
#define BGA_PIN_10_UP							(0&0x01)// 0xB8000800[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_10_PD							(0&0x01)// 0xB8000800[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_10_DS							(0&0x01)// 0xB8000800[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_10_SR							(0&0x01)// 0xB8000800[24]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_01_IO 11 BALL NUM: E10
#define BGA_PIN_11								(0xF&0xF)//0xB8000800[23:20];
																//3: TCON_bit3,<O>
																//4: TCON_bit4,<O>
																//5: TCON_bit5,<O>
																//6: TCON_bit21,<O>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit1,<I/O>
																//def: MIS_GPIO_bit1,<I/O>
#define BGA_PIN_11_UP							(0&0x01)// 0xB8000800[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_11_PD							(0&0x01)// 0xB8000800[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_11_DS							(0&0x01)// 0xB8000800[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_11_SR							(0&0x01)// 0xB8000800[16]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_05_IO 12 BALL NUM: D10
#define BGA_PIN_12								(0xF&0xF)//0xB8000804[23:20];
																//3: ld_spi1_p1_cs1,<O>
																//4: TCON_bit11,<O>
																//5: TCON_bit12,<O>
																//6: TCON_bit13,<O>
																//7: TCON_bit27,<O>
																//8: TCON_bit19,<O>
																//9: TP0_Data_bit7_src2,<I>,<HS>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit5,<I/O>
																//def: MIS_GPIO_bit5,<I/O>
#define BGA_PIN_12_UP							(0&0x01)// 0xB8000804[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_12_PD							(0&0x01)// 0xB8000804[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_12_DS							(0&0x01)// 0xB8000804[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_12_SR							(0&0x01)// 0xB8000804[16]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_04_IO 13 BALL NUM: E9
#define BGA_PIN_13								(0xF&0xF)//0xB8000804[31:28];
																//3: ld_spi1_p4_sdi_src0,<I>
																//4: TCON_bit9,<O>
																//5: TCON_bit10,<O>
																//6: TCON_bit11,<O>
																//7: TCON_bit12,<O>
																//8: TCON_bit17,<O>
																//9: TP0_Data_bit6_src2,<I>,<HS>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit4,<I/O>
																//def: MIS_GPIO_bit4,<I/O>
#define BGA_PIN_13_UP							(0&0x01)// 0xB8000804[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_13_PD							(0&0x01)// 0xB8000804[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_13_DS							(0&0x01)// 0xB8000804[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_13_SR							(0&0x01)// 0xB8000804[24]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_07_IO 14 BALL NUM: F9
#define BGA_PIN_14								(0xF&0xF)//0xB8000804[7:4];
																//3: ld_spi1_p3_sdo_src0,<I/O>
																//4: TCON_bit15,<O>
																//5: TCON_bit16,<O>
																//6: TCON_bit17,<O>
																//7: TCON_bit18,<O>
																//9: TP0_Data_bit5_src2, <I>,<HS>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit7,<I/O>
																//def: MIS_GPIO_bit7,<I/O>
#define BGA_PIN_14_UP							(0&0x01)// 0xB8000804[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_14_PD							(0&0x01)// 0xB8000804[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_14_DS							(0&0x01)// 0xB8000804[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_14_SR							(0&0x01)// 0xB8000804[0]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_08_IO 15 BALL NUM: D8
#define BGA_PIN_15								(0xF&0xF)//0xB8000808[31:28];
																//3: ld_spi1_p5_v_sync,<O>
																//4: TCON_bit17,<O>
																//5: TCON_bit18,<O>
																//6: TCON_bit19,<O>
																//7: TCON_bit20,<O>
																//9: TP0_Data_bit4_src2, <I>,<HS>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit8,<I/O>
																//def: MIS_GPIO_bit8,<I/O>
#define BGA_PIN_15_UP							(0&0x01)// 0xB8000808[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_15_PD							(0&0x01)// 0xB8000808[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_15_DS							(0&0x01)// 0xB8000808[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_15_SR							(0&0x01)// 0xB8000808[24]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_29_IO 17 BALL NUM: E8
#define BGA_PIN_17								(0xF&0xF)//0xB800081C[23:20];
																//1: ld_spi0_p2_sck_src6,<I/O>
																//4: TCON_bit17,<O>
																//5: TCON_bit18,<O>
																//6: TCON_bit19,<O>
																//7: TCON_bit20,<O>
																//9: TP0_Data_bit3_src2,<I>,<HS>
																//A: I2S_IN_Data0_src2,<I>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit29,<I/O>
																//def: MIS_GPIO_bit29,<I/O>
#define BGA_PIN_17_UP							(0&0x01)// 0xB800081C[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_17_PD							(0&0x01)// 0xB800081C[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_17_DS							(0&0x01)// 0xB800081C[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_17_SR							(0&0x01)// 0xB800081C[16]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_06_IO 18 BALL NUM: D9
#define BGA_PIN_18								(0xF&0xF)//0xB8000804[15:12];
																//3: ld_spi1_p2_sck_src0,<I/O>
																//4: TCON_bit13,<O>
																//5: TCON_bit14,<O>
																//6: TCON_bit15,<O>
																//7: TCON_bit19,<O>
																//9: TP0_Data_bit2_src2,<I>,<HS>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit6,<I/O>
																//def: MIS_GPIO_bit6,<I/O>
#define BGA_PIN_18_UP							(0&0x01)// 0xB8000804[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_18_PD							(0&0x01)// 0xB8000804[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_18_DS							(0&0x01)// 0xB8000804[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_18_SR							(0&0x01)// 0xB8000804[8]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_28_IO 19 BALL NUM: B8
#define BGA_PIN_19								(0xF&0x1)//0xB800081C[31:28];
																//0: usit_sfc,<ODH>
																//1: VBY1_LOCK_src0,<I>
																//2: vby1_osd_lock_src1,<I>
																//3: TCON_bit20,<O>
																//4: TCON_bit0,<O>
																//5: TCON_bit1,<O>
																//6: TCON_bit2,<O>
																//7: EPI_LOCK_src1,<I>
																//8: BOE_BCC_src1,<I/ODH>
																//9: SPDIF_OUT,<O>
																//A: iSP_SDLOCK_src2,<I>
																//C: usit_sbc_src2,<I/ODH>
																//D: misc_pwm_5,<OD>
																//E: test_en_bit6,<I/O>
																//F: MIS_GPIO_bit28,<I/O>
																//def: MIS_GPIO_bit28,<I/O>
#define BGA_PIN_19_UP							(0&0x01)// 0xB800081C[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_19_PD							(0&0x01)// 0xB800081C[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_19_DS							(0&0x01)// 0xB800081C[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_19_SR							(0&0x01)// 0xB800081C[24]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_12_IO 20 BALL NUM: J5
#define BGA_PIN_20								(0xF&0xA)//0xB800080C[31:28];
																//3: ld_spi1_p3_sdo_src1,<I/O>
																//4: TCON_bit25,<O>
																//5: TCON_bit26,<O>
																//6: TCON_bit27,<O>
																//7: TCON_bit0,<O>
																//9: TP0_Data_bit1_src2,<I>,<HS>
																//A: I2S_out_Data0,<O>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit12,<I/O>
																//def: MIS_GPIO_bit12,<I/O>
#define BGA_PIN_20_UP							(0&0x01)// 0xB800080C[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_20_PD							(0&0x01)// 0xB800080C[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_20_DS							(0&0x01)// 0xB800080C[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_20_SR							(0&0x01)// 0xB800080C[24]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_25_IO 21 BALL NUM: B7
#define BGA_PIN_21								(0xF&0xB)//0xB8000818[23:20];
																//1: ld_spi0_p6_h_sync,<O>
																//4: TCON_bit7,<O>
																//5: TCON_bit8,<O>
																//6: TCON_bit9,<O>
																//7: TCON_bit24,<O>
																//B: I2C3_SCL_src0,<I/O>
																//D: misc_pwm_6,<OD>
																//E: test_en_bit5,<I/O>
																//F: MIS_GPIO_bit25,<I/O>
																//def: MIS_GPIO_bit25,<I/O>
#define BGA_PIN_21_UP							(0&0x01)// 0xB8000818[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_21_PD							(0&0x01)// 0xB8000818[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_21_DS							(0&0x01)// 0xB8000818[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_21_SR							(0&0x01)// 0xB8000818[16]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_26_IO 22 BALL NUM: C8
#define BGA_PIN_22								(0xF&0x2)//0xB8000818[15:12];
																//0: usit_sbc_src0,<I/ODH>
																//1: vby1_osd_htpd_src1,<I>
																//2: VBY1_HTPD_src0,<I>
																//3: TCON_bit27,<O>
																//4: TCON_bit26,<O>
																//5: TCON_bit1,<O>
																//6: TCON_bit0,<O>
																//A: iSP_SDLOCK_src1,<I>
																//C: usit_sfc,<ODH>
																//D: misc_pwm_4,<OD>
																//F: MIS_GPIO_bit26,<I/O>
																//def: MIS_GPIO_bit26,<I/O>
#define BGA_PIN_22_UP							(0&0x01)// 0xB8000818[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_22_PD							(0&0x01)// 0xB8000818[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_22_DS							(0&0x01)// 0xB8000818[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_22_SR							(0&0x01)// 0xB8000818[8]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_23_IO 23 BALL NUM: C7
#define BGA_PIN_23								(0xF&0xF)//0xB8000814[7:4];
																//1: ld_spi0_p4_sdi_src4,<I>
																//4: TCON_bit3,<O>
																//5: TCON_bit4,<O>
																//6: TCON_bit5,<O>
																//7: TCON_bit21,<O>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit23,<I/O>
																//def: MIS_GPIO_bit23,<I/O>
#define BGA_PIN_23_UP							(0&0x01)// 0xB8000814[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_23_PD							(0&0x01)// 0xB8000814[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_23_DS							(0&0x01)// 0xB8000814[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_23_SR							(0&0x01)// 0xB8000814[0]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_24_IO 24 BALL NUM: A7
#define BGA_PIN_24								(0xF&0xB)//0xB8000818[31:28];
																//1: ld_spi0_p5_v_sync,<O>
																//4: TCON_bit5,<O>
																//5: TCON_bit6,<O>
																//6: TCON_bit7,<O>
																//7: TCON_bit17,<O>
																//B: I2C3_SDA_src0,<I/O>
																//D: misc_pwm_7,<OD>
																//E: test_en_bit4,<I/O>
																//F: MIS_GPIO_bit24,<I/O>
																//def: MIS_GPIO_bit24,<I/O>
#define BGA_PIN_24_UP							(0&0x01)// 0xB8000818[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_24_PD							(0&0x01)// 0xB8000818[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_24_DS							(0&0x01)// 0xB8000818[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_24_SR							(0&0x01)// 0xB8000818[24]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_20_IO 25 BALL NUM: A6
#define BGA_PIN_25								(0xF&0xF)//0xB8000814[31:28];
																//1: ld_spi0_p1_cs1,<O>
																//3: ld_spi0_p5_v_sync,<O>
																//4: TCON_bit19,<O>
																//5: TCON_bit20,<O>
																//6: TCON_bit21,<O>
																//7: TCON_bit27,<O>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit20,<I/O>
																//def: MIS_GPIO_bit20,<I/O>
#define BGA_PIN_25_UP							(0&0x01)// 0xB8000814[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_25_PD							(0&0x01)// 0xB8000814[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_25_DS							(0&0x01)// 0xB8000814[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_25_SR							(0&0x01)// 0xB8000814[24]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_10_IO 30 BALL NUM: H5
#define BGA_PIN_30								(0xF&0xF)//0xB8000808[15:12];
																//3: ld_spi1_p1_cs1,<O>
																//4: TCON_bit21,<O>
																//5: TCON_bit22,<O>
																//6: TCON_bit23,<O>
																//7: TCON_bit24,<O>
																//9: TP0_Data_bit0_src2,<I>,<HS>
																//A: I2S_out_SCLK,<O>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit10,<I/O>
																//def: MIS_GPIO_bit10,<I/O>
#define BGA_PIN_30_UP							(0&0x01)// 0xB8000808[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_30_PD							(1&0x01)// 0xB8000808[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_30_DS							(0&0x01)// 0xB8000808[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_30_SR							(0&0x01)// 0xB8000808[8]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_21_IO 31 BALL NUM: B6
#define BGA_PIN_31								(0xF&0xF)//0xB8000814[23:20];
																//1: ld_spi0_p2_sck_src4,<I/O>
																//3: ld_spi0_p6_h_sync,<O>
																//4: TCON_bit21,<O>
																//5: TCON_bit22,<O>
																//6: TCON_bit23,<O>
																//7: TCON_bit24,<O>
																//D: misc_pwm_6,<OD>
																//F: MIS_GPIO_bit21,<I/O>
																//def: MIS_GPIO_bit21,<I/O>
#define BGA_PIN_31_UP							(0&0x01)// 0xB8000814[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_31_PD							(0&0x01)// 0xB8000814[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_31_DS							(0&0x01)// 0xB8000814[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_31_SR							(0&0x01)// 0xB8000814[16]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_09_IO 32 BALL NUM: J6
#define BGA_PIN_32								(0xF&0xF)//0xB8000808[23:20];
																//3: ld_spi1_p4_sdi_src1,<I>
																//4: TCON_bit19,<O>
																//5: TCON_bit20,<O>
																//6: TCON_bit21,<O>
																//7: TCON_bit27,<O>
																//9: TP2_CLK_src4,<I>,<HS>,<AND>
																//A: I2S_out_MCLK,<O>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit9,<I/O>
																//def: MIS_GPIO_bit9,<I/O>
#define BGA_PIN_32_UP							(0&0x01)// 0xB8000808[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_32_PD							(1&0x01)// 0xB8000808[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_32_DS							(0&0x01)// 0xB8000808[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_32_SR							(0&0x01)// 0xB8000808[16]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_11_IO 33 BALL NUM: H4
#define BGA_PIN_33								(0xF&0xA)//0xB8000808[7:4];
																//3: ld_spi1_p2_sck_src1,<I/O>
																//4: TCON_bit23,<O>
																//5: TCON_bit24,<O>
																//6: TCON_bit25,<O>
																//7: TCON_bit26,<O>
																//9: TP2_Data_bit0_src4,<I>,<HS>
																//A: I2S_out_WCLK,<O>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit11,<I/O>
																//def: MIS_GPIO_bit11,<I/O>
#define BGA_PIN_33_UP							(0&0x01)// 0xB8000808[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_33_PD							(0&0x01)// 0xB8000808[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_33_DS							(0&0x01)// 0xB8000808[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_33_SR							(0&0x01)// 0xB8000808[0]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_14_IO 34 BALL NUM: J4
#define BGA_PIN_34								(0xF&0xF)//0xB800080C[15:12];
																//0: uart0_tx,<OD>
																//1: uart1_tx, <OD>
																//2: SPI_DI_src1,<I/O>,<HS>
																//3: ld_spi1_p6_h_sync,<O>
																//4: TCON_bit20,<O>
																//5: TCON_bit0,<O>
																//6: TCON_bit1,<O>
																//7: TCON_bit2,<O>
																//A: I2S_out_Data2,<O>
																//D: misc_pwm_3,<OD>
																//E: test_en_bit1,<I/O>
																//F: MIS_GPIO_bit14,<I/O>
																//def: MIS_GPIO_bit14,<I/O>
#define BGA_PIN_34_UP							(0&0x01)// 0xB800080C[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_34_PD							(0&0x01)// 0xB800080C[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_34_DS							(0&0x01)// 0xB800080C[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_34_SR							(0&0x01)// 0xB800080C[8]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_13_IO 35 BALL NUM: D7
#define BGA_PIN_35								(0xF&0xF)//0xB800080C[23:20];
																//0: uart0_rxdi_src6,<I>
																//1: uart1_rxdi_src6,<I>
																//3: ld_spi1_p5_v_sync,<O>
																//4: TCON_bit27,<O>
																//5: TCON_bit26,<O>
																//6: TCON_bit1,<O>
																//7: TCON_bit0,<O>
																//8: DEMOD_DSC_IN_src2,<I>
																//A: I2S_out_Data1,<O>
																//D: misc_pwm_6,<OD>
																//E: test_en_bit0,<I/O>
																//F: MIS_GPIO_bit13,<I/O>
																//def: MIS_GPIO_bit13,<I/O>
#define BGA_PIN_35_UP							(1&0x01)// 0xB800080C[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_35_PD							(0&0x01)// 0xB800080C[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_35_DS							(0&0x01)// 0xB800080C[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_35_SR							(0&0x01)// 0xB800080C[16]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_22_IO 36 BALL NUM: K4
#define BGA_PIN_36								(0xF&0xF)//0xB8000814[15:12];
																//1: ld_spi0_p3_sdo_src4,<I/O>
																//4: TCON_bit1,<O>
																//5: TCON_bit2,<O>
																//6: TCON_bit3,<O>
																//7: TCON_bit12,<O>
																//9: SPDIF_OUT,<O>
																//D: misc_pwm_4,<OD>
																//E: test_en_bit3,<I/O>
																//F: MIS_GPIO_bit22,<I/O>
																//def: MIS_GPIO_bit22,<I/O>
#define BGA_PIN_36_UP							(0&0x01)// 0xB8000814[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_36_PD							(0&0x01)// 0xB8000814[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_36_DS							(0&0x01)// 0xB8000814[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_36_SR							(0&0x01)// 0xB8000814[8]: Slew rate 0:fast 1:slow


// PAD_NAME: PAD_GPIO_15_IO 37 BALL NUM: K6
#define BGA_PIN_37								(0xF&0xF)//0xB800080C[7:4];
																//2: SPI_DO_src1,<I/O>,<HS>
																//3: ld_spi1_p6_h_sync,<O>
																//4: TCON_bit17,<O>
																//5: TCON_bit18,<O>
																//6: TCON_bit19,<O>
																//7: TCON_bit20,<O>
																//9: TP2_VAL_src4, <I>,<HS>
																//A: I2S_out_Data3,<O>
																//D: misc_pwm_4,<OD>
																//E: test_en_bit2,<I/O>
																//F: MIS_GPIO_bit15,<I/O>
																//def: MIS_GPIO_bit15,<I/O>
#define BGA_PIN_37_UP							(0&0x01)// 0xB800080C[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_37_PD							(0&0x01)// 0xB800080C[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_37_DS							(0&0x01)// 0xB800080C[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_37_SR							(0&0x01)// 0xB800080C[0]: Slew rate 0:fast 1:slow


// PAD_NAME: bb_ai2l_v33_apad 115 BALL NUM: L6
#define BGA_PIN_115								(0xF&0xF)//0xB8000828[31:28];
																//C: BB_AI2L,<AI>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit32,<I/O>
																//def: BB_AI2L,<AI>


// PAD_NAME: bb_ai2r_v33_apad 116 BALL NUM: L5
#define BGA_PIN_116								(0xF&0xF)//0xB8000828[27:24];
																//C: BB_AI2R,<AI>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit33,<I/O>
																//def: BB_AI2R,<AI>


// PAD_NAME: bb_ai3l_apad 117 BALL NUM: M5
#define BGA_PIN_117								(0xF&0xB)//0xB8000828[23:20];
																//B: I2C4_SDA_src0,<I/O>
																//C: BB_AI3L,<AO>
																//D: misc_pwm_4,<OD>
																//F: MIS_GPIO_bit34,<I/O>
																//def: BB_AI3L,<AO>


// PAD_NAME: bb_ai3r_apad 118 BALL NUM: M4
#define BGA_PIN_118								(0xF&0xB)//0xB8000828[19:16];
																//B: I2C4_SCL_src0,<I/O>
																//C: BB_AI3R,<AO>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit35,<I/O>
																//def: BB_AI3R,<AO>


// PAD_NAME: bb_aiol_apad 119 BALL NUM: P5
#define BGA_PIN_119								(0xF&0xF)//0xB8000828[15:12];
																//C: BB_AIOL,<AO>
																//D: misc_pwm_6,<OD>
																//F: MIS_GPIO_bit36,<I/O>
																//def: BB_AIOL,<AO>


// PAD_NAME: bb_aior_apad 120 BALL NUM: P4
#define BGA_PIN_120								(0xF&0xF)//0xB8000828[11:8];
																//A: DEMOD_DSC_22_src1,<I/O>
																//C: BB_AIOR,<AO>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit37,<I/O>
																//def: BB_AIOR,<AO>


// PAD_NAME: bb_hpol_v33_apad 127 BALL NUM: N6
#define BGA_PIN_127								(0xF&0xC)//0xB800082C[31:28];
																//C: BB_HPOL,<AO>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit38,<I/O>
																//def: BB_HPOL,<AO>


// PAD_NAME: bb_hpor_v33_apad 129 BALL NUM: N5
#define BGA_PIN_129								(0xF&0xC)//0xB800082C[27:24];
																//C: BB_HPOR,<AO>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit39,<I/O>
																//def: BB_HPOR,<AO>


// PAD_NAME: vsync_apad 131 BALL NUM: F3 for ISDATA0
#define BGA_PIN_131								(0xF&0xA)//0xB8000830[31:28];
																//A: I2S_IN_Data0_src0,<I>
																//C: VSYNC,<AI>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit40,<I/O>
																//def: VSYNC,<AI>


// PAD_NAME: hsync_apad 132 BALL NUM: G4
#define BGA_PIN_132								(0xF&0xF)//0xB8000830[27:24];
																//A: I2S_IN_Data1_src0,<I>
																//C: HSYNC,<AI>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit41,<I/O>
																//def: HSYNC,<AI>


// PAD_NAME: vin_0p_v33_apad 133 BALL NUM: F1
#define BGA_PIN_133								(0xF&0xF)//0xB8000830[23:20];
																//C: VIN_0P,<AI>
																//D: misc_pwm_4,<OD>
																//F: MIS_GPIO_bit42,<I/O>
																//def: VIN_0P,<AI>


// PAD_NAME: vin_bn_v33_apad 134 BALL NUM: G3
#define BGA_PIN_134								(0xF&0xF)//0xB8000830[19:16];
																//6: DEMOD_ANT_TX,<I/O>
																//B: I2C3_SDA_src1,<I/O>
																//C: VIN_BN,<AI>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit43,<I/O>
																//def: VIN_BN,<AI>


// PAD_NAME: vin_1p_v33_apad 135 BALL NUM: G1
#define BGA_PIN_135								(0xF&0xF)//0xB8000830[15:12];
																//C: VIN_1P,<AI>
																//D: misc_pwm_6,<OD>
																//F: MIS_GPIO_bit44,<I/O>
																//def: VIN_1P,<AI>


// PAD_NAME: vin_gn_v33_apad 136 BALL NUM: G2
#define BGA_PIN_136								(0xF&0xF)//0xB8000830[11:8];
																//A: I2S_IN_Data2_src0,<I>
																//C: VIN_GN,<AI>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit45,<I/O>
																//def: VIN_GN,<AI>


// PAD_NAME: vin_2p_v33_apad 137 BALL NUM: H3
#define BGA_PIN_137								(0xF&0xF)//0xB8000834[31:28];
																//C: VIN_2P,<AI>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit46,<I/O>
																//def: VIN_2P,<AI>


// PAD_NAME: vin_rn_v33_apad 138 BALL NUM: H2
#define BGA_PIN_138								(0xF&0xF)//0xB8000834[27:24];
																//6: DEMOD_ANT_OE,<I/O>
																//A: I2S_IN_Data3_src0,<I>
																//B: I2C3_SCL_src1,<I/O>
																//C: VIN_RN,<AI>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit47,<I/O>
																//def: VIN_RN,<AI>


// PAD_NAME: vin_3p_v33_apad 139 BALL NUM: J3
#define BGA_PIN_139								(0xF&0xF)//0xB8000834[23:20];
																//C: VIN_3P,<AI>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit48,<I/O>
																//def: VIN_3P,<AI>


// PAD_NAME: vin_y0n_v33_apad 140 BALL NUM: J2
#define BGA_PIN_140								(0xF&0xF)//0xB8000834[19:16];
																//C: VIN_y0n,<AI>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit49,<I/O>
																//def: VIN_y0n,<AI>


// PAD_NAME: vin_4p_v33_apad 141 BALL NUM: J1
#define BGA_PIN_141								(0xF&0xF)//0xB8000834[15:12];
																//C: VIN_4P,<AI>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit50,<I/O>
																//def: VIN_4P,<AI>


// PAD_NAME: vin_5p_v33_apad 142 BALL NUM: K3
#define BGA_PIN_142								(0xF&0xF)//0xB8000834[11:8];
																//C: VIN_5p,<AI>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit51,<I/O>
																//def: VIN_5p,<AI>


// PAD_NAME: scart_fsw_0_apad 151 BALL NUM: AE2
#define BGA_PIN_151								(0xF&0xF)//0xB8000838[31:28];
																//6: DEMOD_DSC_IN_src1,<I>
																//7: ATV_IF_AGC,<OD>
																//8: ATV_RF_AGC,<OD>
																//A: DEMOD_IF_AGC,<O>
																//C: SCART_FSW_0,<AI>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit52,<I/O>
																//def: SCART_FSW_0,<AI>


// PAD_NAME: vin_10p_v33_apad 153 BALL NUM: K1
#define BGA_PIN_153								(0xF&0xC)//0xB8000838[27:24];
																//C: VIN_10P,<AI>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit53,<I/O>
																//def: VIN_10P,<AI>


// PAD_NAME: vin_a0n_v33_apad 154 BALL NUM: K2
#define BGA_PIN_154								(0xF&0xC)//0xB8000838[23:20];
																//C: VIN_a0n,<AI>
																//D: misc_pwm_4,<OD>
																//F: MIS_GPIO_bit54,<I/O>
																//def: VIN_a0n,<AI>


// PAD_NAME: vid_vdac_apad 157 BALL NUM: R6
#define BGA_PIN_157								(0xF&0xC)//0xB800083C[31:28];
																//C: vid_vdac,<AO>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit55,<I/O>
																//def: vid_vdac,<AO>


// PAD_NAME: vid_vdbs_apad 158 BALL NUM: R5
#define BGA_PIN_158								(0xF&0xF)//0xB800083C[27:24];
																//C: vid_vdbs,<AO>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit56,<I/O>
																//def: vid_vdbs,<AO>


// PAD_NAME: pad_gpio_73_io 319 BALL NUM: V4
#define BGA_PIN_319								(0xF&0x2)//0xB8000850[31:28];
																//1: DTV_DEMOD_AGC_FREEZE,<O>
																//2: SPI_DO_src0,<I/O>,<HS>
																//3: ld_spi0_p1_cs1,<O>
																//4: TCON_bit19,<O>
																//5: TCON_bit20,<O>
																//6: TCON_bit21,<O>
																//7: TCON_bit27,<O>
																//8: ld_spi1_p4_sdi_src3,<I>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit73,<I/O>
																//def: MIS_GPIO_bit73,<I/O>
#define BGA_PIN_319_UP							(0&0x01)// 0xB8000850[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_319_PD							(0&0x01)// 0xB8000850[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_319_DS							(0&0x01)// 0xB8000850[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_319_SR							(0&0x01)// 0xB8000850[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_78_io 322 BALL NUM: W6
#define BGA_PIN_322								(0xF&0x2)//0xB8000854[23:20];
																//2: SPI_SCLK,<O>,<HS>
																//3: ld_spi0_p6_h_sync,<O>
																//4: TCON_bit17,<O>
																//5: TCON_bit18,<O>
																//6: TCON_bit19,<O>
																//7: TCON_bit20,<O>
																//8: ld_spi1_p3_sdo_src3,<I/O>
																//D: misc_pwm_4,<OD>
																//F: MIS_GPIO_bit78,<I/O>
																//def: MIS_GPIO_bit78,<I/O>
#define BGA_PIN_322_UP							(0&0x01)// 0xB8000854[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_322_PD							(0&0x01)// 0xB8000854[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_322_DS							(0&0x01)// 0xB8000854[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_322_SR							(0&0x01)// 0xB8000854[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_79_io 323 BALL NUM: W5
#define BGA_PIN_323								(0xF&0xF)//0xB8000854[15:12];
																//4: DEMOD_DSC_POL,<OD>
																//6: DEMOD_ANT_RX_IN,<I>
																//8: ld_spi1_p5_v_sync,<O>
																//A: ETN_LED_TXRX,<O>
																//D: misc_pwm_6,<OD>
																//F: MIS_GPIO_bit79,<I/O>
																//def: MIS_GPIO_bit79,<I/O>
#define BGA_PIN_323_UP							(0&0x01)// 0xB8000854[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_323_PD							(0&0x01)// 0xB8000854[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_323_DS							(0&0x01)// 0xB8000854[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_323_SR							(0&0x01)// 0xB8000854[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_57_io 324 BALL NUM: W4
#define BGA_PIN_324								(0xF&0xF)//0xB8000840[31:28];
																//A: I2S_IN_Data0_src3,<I>
																//B: I2C2_SDA_src0,<I/O>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit57,<I/O>
																//def: MIS_GPIO_bit57,<I/O>
#define BGA_PIN_324_UP							(0&0x01)// 0xB8000840[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_324_PD							(0&0x01)// 0xB8000840[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_324_DS							(0&0x01)// 0xB8000840[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_324_SR							(0&0x01)// 0xB8000840[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_58_io 326 BALL NUM: Y6
#define BGA_PIN_326								(0xF&0xF)//0xB8000840[23:20];
																//A: I2S_IN_Data1_src3,<I>
																//B: I2C2_SCL_src0,<I/O>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit58,<I/O>
																//def: MIS_GPIO_bit58,<I/O>
#define BGA_PIN_326_UP							(0&0x01)// 0xB8000840[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_326_PD							(0&0x01)// 0xB8000840[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_326_DS							(0&0x01)// 0xB8000840[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_326_SR							(0&0x01)// 0xB8000840[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_75_io 340 BALL NUM: AA7
#define BGA_PIN_340								(0xF&0x2)//0xB8000850[15:12];
																//0: TP0_Data_bit6_src3,<I>,<HS>
																//1: TP2_CLK_src0,<I>,<HS>,<AND>
																//2: SPI_DI_src0,<I/O>,<HS>
																//3: ld_spi0_p3_sdo_src1,<I/O>
																//4: TCON_bit11,<O>
																//5: TCON_bit12,<O>
																//6: TCON_bit13,<O>
																//7: TCON_bit27,<O>
																//A: I2S_IN_Data0_src7,<I>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit75,<I/O>
																//def: MIS_GPIO_bit75,<I/O>
#define BGA_PIN_340_UP							(0&0x01)// 0xB8000850[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_340_PD							(0&0x01)// 0xB8000850[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_340_DS							(0&0x01)// 0xB8000850[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_340_SR							(0&0x01)// 0xB8000850[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_77_io 341 BALL NUM: AC6
#define BGA_PIN_341								(0xF&0x2)//0xB8000854[31:28];
																//1: TP2_Data_bit0_src0,<I>,<HS>
																//2: SPI_HOLD_src0,<I/O>,<HS>
																//3: ld_spi0_p5_v_sync,<O>
																//4: TCON_bit15,<O>
																//5: TCON_bit16,<O>
																//6: TCON_bit17,<O>
																//7: TCON_bit18,<O>
																//A: DEMO_DSC_22_src2,<I/O>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit77,<I/O>
																//def: MIS_GPIO_bit77,<I/O>
#define BGA_PIN_341_UP							(0&0x01)// 0xB8000854[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_341_PD							(0&0x01)// 0xB8000854[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_341_DS							(0&0x01)// 0xB8000854[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_341_SR							(0&0x01)// 0xB8000854[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_76_io 342 BALL NUM: AC5
#define BGA_PIN_342								(0xF&0x2)//0xB8000850[7:4];
																//0: TP0_Data_bit7_src3,<I>,<HS>
																//1: TP2_VAL_src0,<I>,<HS>
																//2: SPI_CS_N,<O>,<HS>
																//3: ld_spi0_p4_sdi_src1,<I>
																//4: TCON_bit13,<O>
																//5: TCON_bit14,<O>
																//6: TCON_bit15,<O>
																//7: TCON_bit19,<O>
																//8: ATV_IF_AGC,<OD>
																//9: DEMOD_IF_AGC,<O>
																//A: ATV_RF_AGC,<OD>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit76,<I/O>
																//def: MIS_GPIO_bit76,<I/O>
#define BGA_PIN_342_UP							(0&0x01)// 0xB8000850[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_342_PD							(0&0x01)// 0xB8000850[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_342_DS							(0&0x01)// 0xB8000850[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_342_SR							(0&0x01)// 0xB8000850[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_74_io 343 BALL NUM: AB7
#define BGA_PIN_343								(0xF&0x2)//0xB8000850[23:20];
																//0: TP0_Data_bit5_src3,<I>,<HS>
																//1: TP2_SYNC_src0,<I>,<HS>
																//2: SPI_WP_src0,<I/O>,<HS>
																//3: ld_spi0_p2_sck_src1,<I/O>
																//4: TCON_bit9,<O>
																//5: TCON_bit10,<O>
																//6: TCON_bit11,<O>
																//7: TCON_bit12,<O>
																//9: I2S_out_Data0,<O>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit74,<I/O>
																//def: MIS_GPIO_bit74,<I/O>
#define BGA_PIN_343_UP							(0&0x01)// 0xB8000850[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_343_PD							(0&0x01)// 0xB8000850[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_343_DS							(0&0x01)// 0xB8000850[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_343_SR							(0&0x01)// 0xB8000850[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_59_io 344 BALL NUM: AA8
#define BGA_PIN_344								(0xF&0xB)//0xB8000840[15:12];
																//B: I2C1_SDA,<I/O>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit59,<I/O>
																//def: MIS_GPIO_bit59,<I/O>
#define BGA_PIN_344_UP							(0&0x01)// 0xB8000840[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_344_PD							(0&0x01)// 0xB8000840[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_344_DS							(0&0x01)// 0xB8000840[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_344_SR							(0&0x01)// 0xB8000840[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_60_io 345 BALL NUM: AC7
#define BGA_PIN_345								(0xF&0xB)//0xB8000840[7:4];
																//B: I2C1_SCL,<I/O>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit60,<I/O>
																//def: MIS_GPIO_bit60,<I/O>
#define BGA_PIN_345_UP							(0&0x01)// 0xB8000840[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_345_PD							(0&0x01)// 0xB8000840[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_345_DS							(0&0x01)// 0xB8000840[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_345_SR							(0&0x01)// 0xB8000840[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_62_io 346 BALL NUM: AA9
#define BGA_PIN_346								(0xF&0xF)//0xB8000844[23:20];
																//1: TP0_SYNC_src0,<I>,<HS>
																//9: I2S_out_SCLK,<O>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit62,<I/O>
																//def: MIS_GPIO_bit62,<I/O>
#define BGA_PIN_346_UP							(0&0x01)// 0xB8000844[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_346_PD							(0&0x01)// 0xB8000844[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_346_DS							(0&0x01)// 0xB8000844[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_346_SR							(0&0x01)// 0xB8000844[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_64_io 348 BALL NUM: AC8
#define BGA_PIN_348								(0xF&0xF)//0xB8000844[7:4];
																//1: TP0_VAL_src0,<I>,<HS>
																//4: ld_spi1_p1_cs1,<O>
																//9: I2S_out_MCLK,<O>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit64,<I/O>
																//def: MIS_GPIO_bit64,<I/O>
#define BGA_PIN_348_UP							(0&0x01)// 0xB8000844[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_348_PD							(0&0x01)// 0xB8000844[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_348_DS							(0&0x01)// 0xB8000844[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_348_SR							(0&0x01)// 0xB8000844[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_63_io 350 BALL NUM: AB8
#define BGA_PIN_350								(0xF&0xF)//0xB8000844[15:12];
																//1: TP0_CLK_src0,<I>,<HS>,<AND>
																//9: I2S_out_WCLK,<O>
																//D: misc_pwm_6,<OD>
																//F: MIS_GPIO_bit63,<I/O>
																//def: MIS_GPIO_bit63,<I/O>
#define BGA_PIN_350_UP							(0&0x01)// 0xB8000844[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_350_PD							(0&0x01)// 0xB8000844[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_350_DS							(0&0x01)// 0xB8000844[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_350_SR							(0&0x01)// 0xB8000844[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_72_io 352 BALL NUM: AB9
#define BGA_PIN_352								(0xF&0xD)//0xB800084C[7:4];
																//1: TP0_Data_bit7_src0,<I>,<HS>
																//9: I2S_out_Data2,<O>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit72,<I/O>
																//def: MIS_GPIO_bit72,<I/O>
#define BGA_PIN_352_UP							(0&0x01)// 0xB800084C[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_352_PD							(0&0x01)// 0xB800084C[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_352_DS							(0&0x01)// 0xB800084C[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_352_SR							(0&0x01)// 0xB800084C[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_71_io 354 BALL NUM: AC9
#define BGA_PIN_354								(0xF&0xF)//0xB800084C[15:12];
																//1: TP0_Data_bit6_src0,<I>,<HS>
																//9: I2S_out_Data1,<O>
																//A: ld_spi0_p3_sdo_src5,<I/O>
																//B: ld_spi1_p4_sdi_src6,<I>
																//D: misc_pwm_6,<OD>
																//F: MIS_GPIO_bit71,<I/O>
																//def: MIS_GPIO_bit71,<I/O>
#define BGA_PIN_354_UP							(0&0x01)// 0xB800084C[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_354_PD							(0&0x01)// 0xB800084C[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_354_DS							(0&0x01)// 0xB800084C[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_354_SR							(0&0x01)// 0xB800084C[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_70_io 356 BALL NUM: AA10
#define BGA_PIN_356								(0xF&0xF)//0xB800084C[23:20];
																//1: TP0_Data_bit5_src0,<I>,<HS>
																//9: I2S_out_Data3,<O>
																//A: ld_spi0_p5_v_sync,<O>
																//B: ld_spi1_p3_sdo_src6,<I/O>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit70,<I/O>
																//def: MIS_GPIO_bit70,<I/O>
#define BGA_PIN_356_UP							(0&0x01)// 0xB800084C[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_356_PD							(1&0x01)// 0xB800084C[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_356_DS							(0&0x01)// 0xB800084C[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_356_SR							(0&0x01)// 0xB800084C[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_69_io 358 BALL NUM: AB10
#define BGA_PIN_358								(0xF&0xD)//0xB800084C[31:28];
																//0: TP1_Data_bit0_src1,<I>,<HS>
																//1: TP0_Data_bit4_src0,<I>,<HS>
																//3: TP2_Data_bit0_src1,<I>,<HS>
																//4: ld_spi1_p6_h_sync,<O>
																//8: ld_spi1_p2_sck_src3,<I/O>
																//A: ld_spi0_p2_sck_src5,<I/O>
																//B: ld_spi1_p5_v_sync,<O>
																//D: misc_pwm_4,<OD>
																//F: MIS_GPIO_bit69,<I/O>
																//def: MIS_GPIO_bit69,<I/O>
#define BGA_PIN_358_UP							(0&0x01)// 0xB800084C[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_358_PD							(0&0x01)// 0xB800084C[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_358_DS							(0&0x01)// 0xB800084C[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_358_SR							(0&0x01)// 0xB800084C[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_68_io 360 BALL NUM: AC10
#define BGA_PIN_360								(0xF&0xD)//0xB8000848[7:4];
																//0: TP1_VAL_src1,<I>,<HS>
																//1: TP0_Data_bit3_src0,<I>,<HS>
																//3: TP2_VAL_src1,<I>,<HS>
																//4: ld_spi1_p5_v_sync,<O>
																//8: ld_spi1_p1_cs1,<O>
																//A: ld_spi0_p1_cs1,<O>
																//B: ld_spi1_p2_sck_src6,<I/O>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit68,<I/O>
																//def: MIS_GPIO_bit68,<I/O>
#define BGA_PIN_360_UP							(0&0x01)// 0xB8000848[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_360_PD							(0&0x01)// 0xB8000848[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_360_DS							(0&0x01)// 0xB8000848[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_360_SR							(0&0x01)// 0xB8000848[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_67_io 366 BALL NUM: AA11
#define BGA_PIN_366								(0xF&0xF)//0xB8000848[15:12];
																//0: TP1_CLK_src1,<I>,<HS>,<AND>
																//1: TP0_Data_bit2_src0,<I>,<HS>
																//3: TP2_CLK_src1,<I>,<HS>,<AND>
																//4: ld_spi1_p4_sdi_src2,<I>
																//A: ld_spi0_p6_h_sync,<O>
																//B: ld_spi1_p1_cs1,<O>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit67,<I/O>
																//def: MIS_GPIO_bit67,<I/O>
#define BGA_PIN_366_UP							(0&0x01)// 0xB8000848[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_366_PD							(0&0x01)// 0xB8000848[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_366_DS							(0&0x01)// 0xB8000848[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_366_SR							(0&0x01)// 0xB8000848[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_66_io 368 BALL NUM: AB11
#define BGA_PIN_368								(0xF&0xD)//0xB8000848[23:20];
																//0: TP1_SYNC_src1,<I>,<HS>
																//1: TP0_Data_bit1_src0,<I>,<HS>
																//3: TP2_SYNC_src1,<I>,<HS>
																//4: ld_spi1_p3_sdo_src2,<I/O>
																//B: ld_spi1_p6_h_sync,<O>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit66,<I/O>
																//def: MIS_GPIO_bit66,<I/O>
#define BGA_PIN_368_UP							(0&0x01)// 0xB8000848[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_368_PD							(0&0x01)// 0xB8000848[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_368_DS							(0&0x01)// 0xB8000848[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_368_SR							(0&0x01)// 0xB8000848[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_65_io 370 BALL NUM: AC11
#define BGA_PIN_370								(0xF&0xF)//0xB8000848[31:28];
																//1: TP0_Data_bit0_src0,<I>,<HS>
																//4: ld_spi1_p2_sck_src2,<I/O>
																//9: ATV_IF_AGC, <OD>
																//A: DEMOD_IF_AGC,<O>
																//B: ATV_RF_AGC,<OD>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit65,<I/O>
																//def: MIS_GPIO_bit65,<I/O>
#define BGA_PIN_370_UP							(0&0x01)// 0xB8000848[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_370_PD							(0&0x01)// 0xB8000848[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_370_DS							(0&0x01)// 0xB8000848[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_370_SR							(0&0x01)// 0xB8000848[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_61_io 372 BALL NUM: AF6
#define BGA_PIN_372								(0xF&0x3)//0xB8000844[31:28];
																//3: ATV_IF_AGC,<OD>
																//4: DEMOD_IF_AGC,<O>
																//6: ATV_RF_AGC,<OD>
																//D: misc_pwm_4,<OD>
																//F: MIS_GPIO_bit61,<I/O>
																//def: MIS_GPIO_bit61,<I/O>
#define BGA_PIN_372_UP							(0&0x01)// 0xB8000844[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_372_PD							(0&0x01)// 0xB8000844[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_372_DS							(0&0x01)// 0xB8000844[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_372_SR							(0&0x01)// 0xB8000844[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_80_io 374 BALL NUM: AC16
#define BGA_PIN_374								(0xF&0xF)//0xB8000854[7:4];
																//4: DEMOD_DSC_IN_src0,<I>
																//6: DTV_DEMOD_AGC_FREEZE,<O>
																//8: ld_spi1_p6_h_sync,<O>
																//A: ETN_LED_LINK,<O>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit80,<I/O>
																//def: MIS_GPIO_bit80,<I/O>
#define BGA_PIN_374_UP							(0&0x01)// 0xB8000854[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_374_PD							(0&0x01)// 0xB8000854[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_374_DS							(0&0x01)// 0xB8000854[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_374_SR							(0&0x01)// 0xB8000854[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_81_io 375 BALL NUM: G27
#define BGA_PIN_375								(0xF&0xF)//0xB8000858[31:28];
																//2: SPI_SCLK,<O>,<HS>
																//4: DEMOD_DSC_22_src0,<I/O>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit81,<I/O>
																//def: MIS_GPIO_bit81,<I/O>
#define BGA_PIN_375_UP							(0&0x01)// 0xB8000858[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_375_PD							(0&0x01)// 0xB8000858[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_375_DS							(0&0x01)// 0xB8000858[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_375_SR							(0&0x01)// 0xB8000858[24]: Slew rate 0:fast 1:slow


// PAD_NAME: lsadc3_apad 560 BALL NUM: U24
#define BGA_PIN_560								(0xF&0xF)//0xB8060204[27:24];
																//A: iso_misc_pwm_2,<OD>
																//C: lsadc3,<AI>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit19,<I/O>
																//def: lsadc3,<AI>


// PAD_NAME: lsadc10_apad 561 BALL NUM: T22
#define BGA_PIN_561								(0xF&0xF)//0xB8060200[31:28];
																//A: iso_misc_pwm_3,<OD>
																//C: lsadc10,<AI>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit12,<I/O>
																//def: lsadc10,<AI>


// PAD_NAME: lsadc9_apad 562 BALL NUM: T23
#define BGA_PIN_562								(0xF&0xF)//0xB8060200[27:24];
																//A: iso_misc_pwm_4,<OD>
																//B: iso_misc_pwm_2,<OD>
																//C: lsadc9,<AI>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit13,<I/O>
																//def: lsadc9,<AI>


// PAD_NAME: lsadc8_apad 563 BALL NUM: T24
#define BGA_PIN_563								(0xF&0xF)//0xB8060200[23:20];
																//B: iso_misc_pwm_3,<OD>
																//C: lsadc8,<AI>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit14,<I/O>
																//def: lsadc8,<AI>


// PAD_NAME: lsadc5_apad 564 BALL NUM: R24
#define BGA_PIN_564								(0xF&0xF)//0xB8060200[11:8];
																//B: iso_misc_pwm_4,<OD>
																//C: lsadc5,<AI>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit17,<I/O>
																//def: lsadc5,<AI>


// PAD_NAME: lsadc0_apad 565 BALL NUM: AB12
#define BGA_PIN_565								(0xF&0xF)//0xB8060204[15:12];
																//A: iso_misc_pwm_2,<OD>
																//C: lsadc0,<AI>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit22,<I/O>
																//def: lsadc0,<AI>


// PAD_NAME: lsadc1_apad 566 BALL NUM: AC14
#define BGA_PIN_566								(0xF&0xF)//0xB8060204[19:16];
																//A: iso_misc_pwm_3,<OD>
																//C: lsadc1,<AI>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit21,<I/O>
																//def: lsadc1,<AI>


// PAD_NAME: lsadc2_apad 567 BALL NUM: P23
#define BGA_PIN_567								(0xF&0xC)//0xB8060204[23:20];
																//A: iso_misc_pwm_4,<OD>
																//C: lsadc2,<AI>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit20,<I/O>
																//def: lsadc2,<AI>


// PAD_NAME: lsadc4_apad 568 BALL NUM: P22
#define BGA_PIN_568								(0xF&0xF)//0xB8060204[31:28];
																//C: lsadc4,<AI>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit18,<I/O>
																//def: lsadc4,<AI>


// PAD_NAME: lsadc6_apad 569 BALL NUM: R23
#define BGA_PIN_569								(0xF&0xF)//0xB8060200[15:12];
																//B: iso_misc_pwm_2,<OD>
																//C: lsadc6,<AI>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit16,<I/O>
																//def: lsadc6,<AI>


// PAD_NAME: lsadc7_apad 570 BALL NUM: R22
#define BGA_PIN_570								(0xF&0xD)//0xB8060200[19:16];
																//B: iso_misc_pwm_3,<OD>
																//C: lsadc7,<AI>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit15,<I/O>
																//def: lsadc7,<AI>


// PAD_NAME: pad_st_gpio_05_io 580 BALL NUM: AB17
#define BGA_PIN_580								(0xF&0xF)//0xB806020C[23:20];
																//0: uart0_tx,<OD>
																//1: TP2_CLK_src2,<I>,<HS>,<AND>
																//2: uart1_tx,<OD>
																//3: TCON_bit26,<O>
																//4: TCON_bit1,<O>
																//5: TCON_bit0,<O>
																//A: iso_misc_pwm_4,<OD>
																//B: I2C2_SDA_src1,<I/O>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit05,<I/O>
																//def: ISO_MIS_GPIO_bit05,<I/O>
#define BGA_PIN_580_UP							(0&0x01)// 0xB806020C[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_580_PD							(0&0x01)// 0xB806020C[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_580_DS							(0&0x01)// 0xB806020C[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_580_SR							(0&0x01)// 0xB806020C[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_42_io 581 BALL NUM: AB14
#define BGA_PIN_581								(0xF&0xF)//0xB8060224[7:4];
																//0: uart0_rxdi_src7,<I>
																//1: TP0_Data_bit2_src1,<I>,<HS>
																//3: TCON_bit13,<O>
																//4: TCON_bit14,<O>
																//5: TCON_bit15,<O>
																//6: TCON_bit19,<O>
																//9: SPDIF_OUT_1,<O>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_0,<OD>
																//E: st_dbg_bit0,<I/O>
																//F: ISO_MIS_GPIO_bit42,<I/O>
																//def: ISO_MIS_GPIO_bit42,<I/O>
#define BGA_PIN_581_UP							(0&0x01)// 0xB8060224[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_581_PD							(0&0x01)// 0xB8060224[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_581_DS							(0&0x01)// 0xB8060224[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_581_SR							(0&0x01)// 0xB8060224[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_37_io 583 BALL NUM: AB13
#define BGA_PIN_583								(0xF&0xF)//0xB8060220[15:12];
																//0: SPI_FCIC_CS_N,<O>
																//1: TP0_SYNC_src1,<I>,<HS>
																//2: uart1_tx,<OD>
																//3: TCON_bit1,<O>
																//4: TCON_bit2,<O>
																//5: TCON_bit3,<O>
																//6: TCON_bit12,<O>
																//7: uart0_tx,<OD>
																//C: iso_misc_pwm_3,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit37,<I/O>
																//def: ISO_MIS_GPIO_bit37,<I/O>
#define BGA_PIN_583_UP							(0&0x01)// 0xB8060220[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_583_PD							(0&0x01)// 0xB8060220[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_583_DS							(0&0x01)// 0xB8060220[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_583_SR							(0&0x01)// 0xB8060220[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_54_io 584 BALL NUM: Y4
#define BGA_PIN_584								(0xF&0xF)//0xB8060230[7:4];
																//0: uart0_rxdi_src8,<I>
																//1: TP2_CLK_src3,<I>,<HS>,<AND>
																//2: uart1_rxdi_src8,<I>
																//3: ld_spi1_p4_sdi_src4,<I>
																//C: iso_misc_pwm_4,<OD>
																//D: iso_misc_pwm_0,<OD>
																//E: st_dbg_bit10,<I/O>
																//F: ISO_MIS_GPIO_bit54,<I/O>
																//def: ISO_MIS_GPIO_bit54,<I/O>
#define BGA_PIN_584_UP							(0&0x01)// 0xB8060230[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_584_PD							(0&0x01)// 0xB8060230[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_584_DS							(0&0x01)// 0xB8060230[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_584_SR							(0&0x01)// 0xB8060230[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_53_io 585 BALL NUM: AA12
#define BGA_PIN_585								(0xF&0xF)//0xB8060230[15:12];
																//0: uart0_tx,<OD>
																//1: TP2_SYNC_src3,<I>,<HS>
																//3: ld_spi1_p1_cs1,<O>
																//9: dmic_clk,<O>
																//D: iso_misc_pwm_1,<OD>
																//E: st_dbg_bit9,<I/O>
																//F: ISO_MIS_GPIO_bit53,<I/O>
																//def: ISO_MIS_GPIO_bit53,<I/O>
#define BGA_PIN_585_UP							(0&0x01)// 0xB8060230[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_585_PD							(0&0x01)// 0xB8060230[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_585_DS							(0&0x01)// 0xB8060230[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_585_SR							(0&0x01)// 0xB8060230[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_45_io 586 BALL NUM: Y5
#define BGA_PIN_586								(0xF&0xF)//0xB8060228[15:12];
																//0: uart0_rxdi_src9,<I>
																//1: TP0_Data_bit5_src1,<I>,<HS>
																//2: uart1_rxdi_src9,<I>
																//3: TCON_bit17,<O>
																//4: TCON_bit18,<O>
																//5: TCON_bit19,<O>
																//6: TCON_bit20,<O>
																//8: IRRX_src1,<I>
																//A: I2S_IN_Data1_src1,<I>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_0,<OD>
																//E: st_dbg_bit3,<I/O>
																//F: ISO_MIS_GPIO_bit45,<I/O>
																//def: ISO_MIS_GPIO_bit45,<I/O>
#define BGA_PIN_586_UP							(0&0x01)// 0xB8060228[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_586_PD							(0&0x01)// 0xB8060228[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_586_DS							(0&0x01)// 0xB8060228[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_586_SR							(0&0x01)// 0xB8060228[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_11_io 587 BALL NUM: AC12
#define BGA_PIN_587								(0xF&0xD)//0xB8060210[7:4];
																//0: uart0_tx,<OD>
																//2: uart1_tx,<OD>
																//A: I2S_out_WCLK,<O>
																//C: iso_misc_pwm_3,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit11,<I/O>
																//def: ISO_MIS_GPIO_bit11,<I/O>
#define BGA_PIN_587_UP							(0&0x01)// 0xB8060210[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_587_PD							(0&0x01)// 0xB8060210[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_587_DS							(0&0x01)// 0xB8060210[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_587_SR							(0&0x01)// 0xB8060210[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_56_io 588 BALL NUM: AC13
#define BGA_PIN_588								(0xF&0xF)//0xB8060234[23:20];
																//0: uart0_rxdi_src10,<I>
																//1: TP2_Data_bit0_src3,<I>,<HS>
																//2: uart1_rxdi_src10,<I>
																//3: ld_spi1_p2_sck_src4,<I/O>
																//C: iso_misc_pwm_4,<OD>
																//D: iso_misc_pwm_0,<OD>
																//E: st_dbg_bit12,<I/O>
																//F: ISO_MIS_GPIO_bit56,<I/O>
																//def: ISO_MIS_GPIO_bit56,<I/O>
#define BGA_PIN_588_UP							(0&0x01)// 0xB8060234[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_588_PD							(0&0x01)// 0xB8060234[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_588_DS							(0&0x01)// 0xB8060234[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_588_SR							(0&0x01)// 0xB8060234[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_59_io 589 BALL NUM: AC15
#define BGA_PIN_589								(0xF&0xF)//0xB8060238[31:28];
																//3: ld_spi1_p5_v_sync,<O>
																//9: dmic_clk_data_0_src2,<I>
																//D: iso_misc_pwm_0,<OD>
																//E: st_dbg_bit14,<I/O>
																//F: ISO_MIS_GPIO_bit59,<I/O>
																//def: ISO_MIS_GPIO_bit59,<I/O>
#define BGA_PIN_589_UP							(0&0x01)// 0xB8060238[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_589_PD							(0&0x01)// 0xB8060238[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_589_DS							(0&0x01)// 0xB8060238[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_589_SR							(0&0x01)// 0xB8060238[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_10_io 593 BALL NUM: AA15
#define BGA_PIN_593								(0xF&0x8)//0xB8060210[15:12];
																//8: IRRX_src0,<I>
																//C: iso_misc_pwm_1,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit10,<I/O>
																//def: ISO_MIS_GPIO_bit10,<I/O>
#define BGA_PIN_593_UP							(0&0x01)// 0xB8060210[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_593_PD							(0&0x01)// 0xB8060210[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_593_DS							(0&0x01)// 0xB8060210[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_593_SR							(0&0x01)// 0xB8060210[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_52_io 594 BALL NUM: AA13
#define BGA_PIN_594								(0xF&0x2)//0xB8060230[23:20];
																//2: SPDIF_OUT,<O>
																//9: dmic_clk_data_1_src2,<I>
																//B: I2C0_SDA_src1,<I/O>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_1,<OD>
																//E: st_dbg_bit8,<I/O>
																//F: ISO_MIS_GPIO_bit52,<I/O>
																//def: ISO_MIS_GPIO_bit52,<I/O>
#define BGA_PIN_594_UP							(0&0x01)// 0xB8060230[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_594_PD							(0&0x01)// 0xB8060230[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_594_DS							(0&0x01)// 0xB8060230[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_594_SR							(0&0x01)// 0xB8060230[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_08_io 595 BALL NUM: AA6
#define BGA_PIN_595								(0xF&0xB)//0xB8060210[31:28];
																//B: I2C0_SDA_src0,<I/O>
																//C: iso_misc_pwm_3,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit08,<I/O>
																//def: ISO_MIS_GPIO_bit08,<I/O>
#define BGA_PIN_595_UP							(0&0x01)// 0xB8060210[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_595_PD							(0&0x01)// 0xB8060210[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_595_DS							(0&0x01)// 0xB8060210[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_595_SR							(0&0x01)// 0xB8060210[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_06_io 596 BALL NUM: AB5
#define BGA_PIN_596								(0xF&0x9)//0xB806020C[15:12];
																//1: TP2_VAL_src2,<I>,<HS>
																//9: dmic_clk_data_1_src0,<I>
																//B: I2C5_SCL_src0,<I/O>
																//C: iso_misc_pwm_4,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit06,<I/O>
																//def: ISO_MIS_GPIO_bit06,<I/O>
#define BGA_PIN_596_UP							(0&0x01)// 0xB806020C[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_596_PD							(0&0x01)// 0xB806020C[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_596_DS							(0&0x01)// 0xB806020C[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_596_SR							(0&0x01)// 0xB806020C[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_07_io 597 BALL NUM: AB6
#define BGA_PIN_597								(0xF&0x9)//0xB806020C[7:4];
																//1: TP2_Data_bit0_src2,<I>,<HS>
																//9: dmic_clk_data_0_src0,<I>
																//B: I2C5_SDA_src0,<I/O>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit07,<I/O>
																//def: ISO_MIS_GPIO_bit07,<I/O>
#define BGA_PIN_597_UP							(0&0x01)// 0xB806020C[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_597_PD							(0&0x01)// 0xB806020C[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_597_DS							(0&0x01)// 0xB806020C[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_597_SR							(0&0x01)// 0xB806020C[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_09_io 598 BALL NUM: AB4
#define BGA_PIN_598								(0xF&0xB)//0xB8060210[23:20];
																//B: I2C0_SCL_src0,<I/O>
																//C: iso_misc_pwm_1,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit09,<I/O>
																//def: ISO_MIS_GPIO_bit09,<I/O>
#define BGA_PIN_598_UP							(0&0x01)// 0xB8060210[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_598_PD							(0&0x01)// 0xB8060210[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_598_DS							(0&0x01)// 0xB8060210[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_598_SR							(0&0x01)// 0xB8060210[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_00_io 599 BALL NUM: AA5
#define BGA_PIN_599								(0xF&0xF)//0xB8060208[31:28];
																//5: VDDC_SCL,<I>
																//6: uart0_rxdi_src1,<I>
																//7: uart1_rxdi_src0,<I>
																//8: UARTRbus_RX_src1,<I>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit00,<I/O>
																//def: ISO_MIS_GPIO_bit00,<I/O>
#define BGA_PIN_599_UP							(0&0x01)// 0xB8060208[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_599_PD							(0&0x01)// 0xB8060208[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_599_DS							(0&0x01)// 0xB8060208[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_599_SR							(0&0x01)// 0xB8060208[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_01_io 600 BALL NUM: AA4
#define BGA_PIN_600								(0xF&0xC)//0xB8060208[23:20];
																//5: VDDC_SDA,<I/O>
																//6: uart0_tx,<OD>
																//7: uart1_tx,<OD>
																//8: UARTRbus_TX,<O>
																//C: iso_misc_pwm_3,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit01,<I/O>
																//def: ISO_MIS_GPIO_bit01,<I/O>
#define BGA_PIN_600_UP							(0&0x01)// 0xB8060208[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_600_PD							(0&0x01)// 0xB8060208[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_600_DS							(0&0x01)// 0xB8060208[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_600_SR							(0&0x01)// 0xB8060208[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_58_io 601 BALL NUM: AB15
#define BGA_PIN_601								(0xF&0xF)//0xB8060234[7:4];
																//C: iso_misc_pwm_4,<OD>
																//D: iso_misc_pwm_1,<OD>
																//E: st_dbg_bit13,<I/O>
																//F: ISO_MIS_GPIO_bit58,<I/O>
																//def: ISO_MIS_GPIO_bit58,<I/O>
#define BGA_PIN_601_UP							(0&0x01)// 0xB8060234[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_601_PD							(0&0x01)// 0xB8060234[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_601_DS							(0&0x01)// 0xB8060234[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_601_SR							(0&0x01)// 0xB8060234[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_36_io 602 BALL NUM: AG24
#define BGA_PIN_602								(0xF&0x5)//0xB8060220[23:20];
																//0: EJTAG_TRST_src1,<I>
																//1: EJTAG_TMS_src0,<I/O>
																//2: emcu_EJTAG_TMS_src1,<I>
																//3: emcu_EJTAG_TRST_src0,<I>
																//4: DTV_DEMOD_SCL,<I>
																//5: HDDC0_SCL,<I>
																//6: uart0_rxdi_src5,<I>
																//7: uart1_rxdi_src5,<I>
																//8: UARTRbus_RX_src5,<I>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit36,<I/O>
																//def: ISO_MIS_GPIO_bit36,<I/O>
#define BGA_PIN_602_UP							(0&0x01)// 0xB8060220[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_602_PD							(0&0x01)// 0xB8060220[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_602_DS							(0&0x01)// 0xB8060220[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_602_SR							(0&0x01)// 0xB8060220[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_31_io 603 BALL NUM: AF25
#define BGA_PIN_603								(0xF&0x5)//0xB806021C[31:28];
																//3: EJTAG_TCLK_CLK_src3,<I>,<AND>
																//5: HDDC1_SDA,<I/O>
																//6: uart0_tx,<OD>
																//7: uart1_tx,<OD>
																//8: UARTRbus_TX,<O>
																//C: iso_misc_pwm_0,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit31,<I/O>
																//def: ISO_MIS_GPIO_bit31,<I/O>
#define BGA_PIN_603_UP							(0&0x01)// 0xB806021C[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_603_PD							(0&0x01)// 0xB806021C[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_603_DS							(0&0x01)// 0xB806021C[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_603_SR							(0&0x01)// 0xB806021C[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_46_io 604 BALL NUM: AA16
#define BGA_PIN_604								(0xF&0xF)//0xB8060228[7:4];
																//1: TP0_Data_bit6_src1,<I>,<HS>
																//3: TCON_bit23,<O>
																//4: TCON_bit24,<O>
																//5: TCON_bit25,<O>
																//6: TCON_bit26,<O>
																//9: I2S_out_Data2,<O>
																//B: I2C5_SDA_src1,<I/O>
																//C: iso_misc_pwm_1,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit46,<I/O>
																//def: ISO_MIS_GPIO_bit46,<I/O>
#define BGA_PIN_604_UP							(0&0x01)// 0xB8060228[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_604_PD							(0&0x01)// 0xB8060228[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_604_DS							(0&0x01)// 0xB8060228[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_604_SR							(0&0x01)// 0xB8060228[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_35_io 605 BALL NUM: AF24
#define BGA_PIN_605								(0xF&0x5)//0xB8060220[31:28];
																//0: EJTAG_TDI_src1,<I>
																//1: EJTAG_TCLK_CLK_src0,<I>,<AND>
																//2: emcu_EJTAG_TCLK_CLK_src1,<I>,<AND>
																//3: emcu_EJTAG_TDI_src0,<I>
																//4: DTV_DEMOD_SDA,<I/ODH>
																//5: HDDC0_SDA,<I/O>
																//6: uart0_tx,<OD>
																//7: uart1_tx,<OD>
																//8: UARTRbus_TX,<O>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit35,<I/O>
																//def: ISO_MIS_GPIO_bit35,<I/O>
#define BGA_PIN_605_UP							(0&0x01)// 0xB8060220[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_605_PD							(0&0x01)// 0xB8060220[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_605_DS							(0&0x01)// 0xB8060220[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_605_SR							(0&0x01)// 0xB8060220[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_47_io 606 BALL NUM: N22
#define BGA_PIN_606								(0xF&0xF)//0xB806022C[31:28];
																//1: TP0_Data_bit7_src1,<I>,<HS>
																//3: TCON_bit19,<O>
																//4: TCON_bit20,<O>
																//5: TCON_bit21,<O>
																//6: TCON_bit27,<O>
																//9: I2S_out_Data3,<O>
																//A: I2S_IN_Data2_src1,<I>
																//D: iso_misc_pwm_1,<OD>
																//E: st_dbg_bit4,<I/O>
																//F: ISO_MIS_GPIO_bit47,<I/O>
																//def: ISO_MIS_GPIO_bit47,<I/O>
#define BGA_PIN_606_UP							(0&0x01)// 0xB806022C[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_606_PD							(0&0x01)// 0xB806022C[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_606_DS							(0&0x01)// 0xB806022C[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_606_SR							(0&0x01)// 0xB806022C[24]: Slew rate 0:fast 1:slow


#if 0
// PAD_NAME: pad_st_gpio_03_io 607 BALL NUM: N23
#define BGA_PIN_607								(0xF&0x7)//0xB8060208[7:4];
																//6: uart0_tx,<OD>
																//7: uart1_tx,<OD>
																//8: UARTRbus_TX,<O>
																//C: iso_misc_pwm_4,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit03,<I/O>
																//def: ISO_MIS_GPIO_bit03,<I/O>
#define BGA_PIN_607_UP							(0&0x01)// 0xB8060208[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_607_PD							(0&0x01)// 0xB8060208[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_607_DS							(0&0x01)// 0xB8060208[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_607_SR							(0&0x01)// 0xB8060208[0]: Slew rate 0:fast 1:slow
#endif


// PAD_NAME: pad_st_gpio_32_io 608 BALL NUM: AG26
#define BGA_PIN_608								(0xF&0x5)//0xB806021C[23:20];
																//3: EJTAG_TMS_src3,<I/O>
																//5: HDDC1_SCL,<I>
																//6: uart0_rxdi_src4,<I>
																//7: uart1_rxdi_src4,<I>
																//8: UARTRbus_RX_src0,<I>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit32,<I/O>
																//def: ISO_MIS_GPIO_bit32,<I/O>
#define BGA_PIN_608_UP							(0&0x01)// 0xB806021C[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_608_PD							(0&0x01)// 0xB806021C[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_608_DS							(0&0x01)// 0xB806021C[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_608_SR							(0&0x01)// 0xB806021C[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_26_io 609 BALL NUM: AE25
#define BGA_PIN_609								(0xF&0x9)//0xB8060214[7:4];
																//9: SPDIF_OUT_1,<O>
																//C: iso_misc_pwm_3,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit26,<I/O>
																//def: ISO_MIS_GPIO_bit26,<I/O>
#define BGA_PIN_609_UP							(0&0x01)// 0xB8060214[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_609_PD							(0&0x01)// 0xB8060214[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_609_DS							(0&0x01)// 0xB8060214[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_609_SR							(0&0x01)// 0xB8060214[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_39_io 610 BALL NUM: M23
#define BGA_PIN_610								(0xF&0xF)//0xB8060224[31:28];
																//0: SPI_FCIC_DO_src1,<I/O>
																//1: TP0_VAL_src1,<I>,<HS>
																//3: TCON_bit3,<O>
																//4: TCON_bit4,<O>
																//5: TCON_bit5,<O>
																//6: TCON_bit21,<O>
																//7: IRTX_OUT,<OD>
																//C: misc_pwm_0,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit39,<I/O>
																//def: ISO_MIS_GPIO_bit39,<I/O>
#define BGA_PIN_610_UP							(0&0x01)// 0xB8060224[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_610_PD							(0&0x01)// 0xB8060224[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_610_DS							(0&0x01)// 0xB8060224[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_610_SR							(0&0x01)// 0xB8060224[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_43_io 611 BALL NUM: M24
#define BGA_PIN_611								(0xF&0xF)//0xB8060228[31:28];
																//1: TP0_Data_bit3_src1,<I>,<HS>
																//3: TCON_bit21,<O>
																//4: TCON_bit22,<O>
																//5: TCON_bit23,<O>
																//6: TCON_bit24,<O>
																//A: I2S_IN_Data3_src1,<I>
																//B: I2C5_SCL_src1,<I/O>
																//D: iso_misc_pwm_0,<OD>
																//E: st_dbg_bit1,<I/O>
																//F: ISO_MIS_GPIO_bit43,<I/O>
																//def: ISO_MIS_GPIO_bit43,<I/O>
#define BGA_PIN_611_UP							(0&0x01)// 0xB8060228[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_611_PD							(0&0x01)// 0xB8060228[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_611_DS							(0&0x01)// 0xB8060228[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_611_SR							(0&0x01)// 0xB8060228[24]: Slew rate 0:fast 1:slow


#if 0
// PAD_NAME: pad_st_gpio_02_io 612 BALL NUM: N24
#define BGA_PIN_612								(0xF&0x7)//0xB8060208[15:12];
																//6: uart0_rxdi_src0,<I>
																//7: uart1_rxdi_src1,<I>
																//8: UARTRbus_RX_src2,<I>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit02,<I/O>
																//def: ISO_MIS_GPIO_bit02,<I/O>
#define BGA_PIN_612_UP							(0&0x01)// 0xB8060208[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_612_PD							(0&0x01)// 0xB8060208[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_612_DS							(0&0x01)// 0xB8060208[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_612_SR							(0&0x01)// 0xB8060208[8]: Slew rate 0:fast 1:slow
#endif


// PAD_NAME: pad_st_gpio_48_io 613 BALL NUM: M22
#define BGA_PIN_613								(0xF&0xF)//0xB806022C[23:20];
																//3: TCON_bit7,<O>
																//4: TCON_bit8,<O>
																//5: TCON_bit9,<O>
																//6: TCON_bit24,<O>
																//A: I2S_out_Data1,<O>
																//C: iso_misc_pwm_3,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit48,<I/O>
																//def: ISO_MIS_GPIO_bit48,<I/O>
#define BGA_PIN_613_UP							(0&0x01)// 0xB806022C[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_613_PD							(0&0x01)// 0xB806022C[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_613_DS							(0&0x01)// 0xB806022C[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_613_SR							(0&0x01)// 0xB806022C[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_44_io 614 BALL NUM: L22
#define BGA_PIN_614								(0xF&0xF)//0xB8060228[23:20];
																//1: TP0_Data_bit4_src1,<I>,<HS>
																//3: TCON_bit15,<O>
																//4: TCON_bit16,<O>
																//5: TCON_bit17,<O>
																//6: TCON_bit18,<O>
																//A: I2S_IN_Data0_src1,<I>
																//C: iso_misc_pwm_4,<OD>
																//D: iso_misc_pwm_1,<OD>
																//E: st_dbg_bit2,<I/O>
																//F: ISO_MIS_GPIO_bit44,<I/O>
																//def: ISO_MIS_GPIO_bit44,<I/O>
#define BGA_PIN_614_UP							(0&0x01)// 0xB8060228[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_614_PD							(0&0x01)// 0xB8060228[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_614_DS							(0&0x01)// 0xB8060228[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_614_SR							(0&0x01)// 0xB8060228[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_38_io 615 BALL NUM: T26
#define BGA_PIN_615								(0xF&0xF)//0xB8060220[7:4];
																//0: SPI_FCIC_SCLK,<O>
																//1: TP0_CLK_src1,<I>,<HS>,<AND>
																//3: TCON_bit5,<O>
																//4: TCON_bit6,<O>
																//5: TCON_bit7,<O>
																//6: TCON_bit17,<O>
																//C: misc_pwm_1,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit38,<I/O>
																//def: ISO_MIS_GPIO_bit38,<I/O>
#define BGA_PIN_615_UP							(0&0x01)// 0xB8060220[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_615_PD							(0&0x01)// 0xB8060220[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_615_DS							(0&0x01)// 0xB8060220[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_615_SR							(0&0x01)// 0xB8060220[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_41_io 616 BALL NUM: L23
#define BGA_PIN_616								(0xF&0xF)//0xB8060224[15:12];
																//1: TP0_Data_bit1_src1,<I>,<HS>
																//3: TCON_bit11,<O>
																//4: TCON_bit12,<O>
																//5: TCON_bit13,<O>
																//6: TCON_bit27,<O>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit41,<I/O>
																//def: ISO_MIS_GPIO_bit41,<I/O>
#define BGA_PIN_616_UP							(0&0x01)// 0xB8060224[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_616_PD							(0&0x01)// 0xB8060224[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_616_DS							(0&0x01)// 0xB8060224[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_616_SR							(0&0x01)// 0xB8060224[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_04_io 617 BALL NUM: L24
#define BGA_PIN_617								(0xF&0xC)//0xB806020C[31:28];
																//1: TP2_SYNC_src2,<I>,<HS>
																//9: dmic_clk,<O>
																//A: I2S_IN_Data0_src5,<I>
																//B: I2C2_SCL_src1,<I/O>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit04,<I/O>
																//def: ISO_MIS_GPIO_bit04,<I/O>
#define BGA_PIN_617_UP							(0&0x01)// 0xB806020C[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_617_PD							(0&0x01)// 0xB806020C[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_617_DS							(0&0x01)// 0xB806020C[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_617_SR							(0&0x01)// 0xB806020C[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_50_io 618 BALL NUM: R27
#define BGA_PIN_618								(0xF&0xF)//0xB806022C[7:4];
																//C: iso_misc_pwm_3,<OD>
																//D: iso_misc_pwm_1,<OD>
																//E: st_dbg_bit6,<I/O>
																//F: ISO_MIS_GPIO_bit50,<I/O>
																//def: ISO_MIS_GPIO_bit50,<I/O>
#define BGA_PIN_618_UP							(0&0x01)// 0xB806022C[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_618_PD							(0&0x01)// 0xB806022C[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_618_DS							(0&0x01)// 0xB806022C[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_618_SR							(0&0x01)// 0xB806022C[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_60_io 619 BALL NUM: R26
#define BGA_PIN_619								(0xF&0xF)//0xB8060238[23:20];
																//3: ld_spi1_p6_h_sync,<O>
																//C: iso_misc_pwm_4,<OD>
																//D: iso_misc_pwm_0,<OD>
																//E: st_dbg_bit15,<I/O>
																//F: ISO_MIS_GPIO_bit60,<I/O>
																//def: ISO_MIS_GPIO_bit60,<I/O>
#define BGA_PIN_619_UP							(0&0x01)// 0xB8060238[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_619_PD							(0&0x01)// 0xB8060238[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_619_DS							(0&0x01)// 0xB8060238[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_619_SR							(0&0x01)// 0xB8060238[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_49_io 620 BALL NUM: T27
#define BGA_PIN_620								(0xF&0xF)//0xB806022C[15:12];
																//9: SPDIF_IN,<I>
																//D: iso_misc_pwm_0,<OD>
																//E: st_dbg_bit5,<I/O>
																//F: ISO_MIS_GPIO_bit49,<I/O>
																//def: ISO_MIS_GPIO_bit49,<I/O>
#define BGA_PIN_620_UP							(0&0x01)// 0xB806022C[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_620_PD							(0&0x01)// 0xB806022C[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_620_DS							(0&0x01)// 0xB806022C[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_620_SR							(0&0x01)// 0xB806022C[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_51_io 621 BALL NUM: R25
#define BGA_PIN_621								(0xF&0xF)//0xB8060230[31:28];
																//B: I2C0_SCL_src1,<I/O>
																//D: iso_misc_pwm_0,<OD>
																//E: st_dbg_bit7,<I/O>
																//F: ISO_MIS_GPIO_bit51,<I/O>
																//def: ISO_MIS_GPIO_bit51,<I/O>
#define BGA_PIN_621_UP							(0&0x01)// 0xB8060230[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_621_PD							(0&0x01)// 0xB8060230[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_621_DS							(0&0x01)// 0xB8060230[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_621_SR							(0&0x01)// 0xB8060230[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_24_io 622 BALL NUM: N26
#define BGA_PIN_622								(0xF&0xA)//0xB8060214[23:20];
																//9: dmic_clk_data_0_src1,<I>
																//A: I2S_out_SCLK,<O>
																//B: I2C5_SCL_src2,<I/O>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit24,<I/O>
																//def: ISO_MIS_GPIO_bit24,<I/O>
#define BGA_PIN_622_UP							(0&0x01)// 0xB8060214[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_622_PD							(0&0x01)// 0xB8060214[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_622_DS							(0&0x01)// 0xB8060214[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_622_SR							(0&0x01)// 0xB8060214[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_55_io 623 BALL NUM: N25
#define BGA_PIN_623								(0xF&0xF)//0xB8060234[31:28];
																//1: TP2_VAL_src3,<I>,<HS>
																//3: ld_spi1_p3_sdo_src4,<I/O>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_1,<OD>
																//E: st_dbg_bit11,<I/O>
																//F: ISO_MIS_GPIO_bit55,<I/O>
																//def: ISO_MIS_GPIO_bit55,<I/O>
#define BGA_PIN_623_UP							(0&0x01)// 0xB8060234[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_623_PD							(0&0x01)// 0xB8060234[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_623_DS							(0&0x01)// 0xB8060234[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_623_SR							(0&0x01)// 0xB8060234[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_40_io 628 BALL NUM: P26
#define BGA_PIN_628								(0xF&0xF)//0xB8060224[23:20];
																//0: SPI_FCIC_DI_src1,<I/O>
																//1: TP0_Data_bit0_src1,<I>,<HS>
																//3: TCON_bit9,<O>
																//4: TCON_bit10,<O>
																//5: TCON_bit11,<O>
																//6: TCON_bit12,<O>
																//C: iso_misc_pwm_3,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit40,<I/O>
																//def: ISO_MIS_GPIO_bit40,<I/O>
#define BGA_PIN_628_UP							(0&0x01)// 0xB8060224[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_628_PD							(1&0x01)// 0xB8060224[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_628_DS							(0&0x01)// 0xB8060224[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_628_SR							(0&0x01)// 0xB8060224[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_57_io 629 BALL NUM: P25
#define BGA_PIN_629								(0xF&0xF)//0xB8060234[15:12];
																//A: I2S_out_MCLK,<O>
																//C: iso_misc_pwm_4,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit57,<I/O>
																//def: ISO_MIS_GPIO_bit57,<I/O>
#define BGA_PIN_629_UP							(0&0x01)// 0xB8060234[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_629_PD							(0&0x01)// 0xB8060234[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_629_DS							(0&0x01)// 0xB8060234[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_629_SR							(0&0x01)// 0xB8060234[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_29_io 630 BALL NUM: V6
#define BGA_PIN_630								(0xF&0x5)//0xB8060218[15:12];
																//1: emcu_EJTAG_TCLK_CLK_src0,<I>,<AND>
																//2: emcu_EJTAG_TDI_src1,<I>
																//3: EJTAG_TDI_src0,<I>
																//4: EJTAG_TCLK_CLK_src2,<I>,<AND>
																//5: HDDC2_SDA,<I/O>
																//6: uart0_tx,<OD>
																//7: uart1_tx,<OD>
																//8: UARTRbus_TX,<O>
																//C: iso_misc_pwm_0,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit29,<I/O>
																//def: ISO_MIS_GPIO_bit29,<I/O>
#define BGA_PIN_630_UP							(0&0x01)// 0xB8060218[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_630_PD							(0&0x01)// 0xB8060218[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_630_DS							(0&0x01)// 0xB8060218[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_630_SR							(0&0x01)// 0xB8060218[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_30_io 631 BALL NUM: V5
#define BGA_PIN_631								(0xF&0x5)//0xB8060218[7:4];
																//1: emcu_EJTAG_TMS_src0,<I>
																//2: emcu_EJTAG_TRST_src1,<I>
																//3: EJTAG_TRST_src0,<I>
																//4: EJTAG_TMS_src2,<I/O>
																//5: HDDC2_SCL,<I>
																//6: uart0_rxdi_src3,<I>
																//7: uart1_rxdi_src3,<I>
																//8: UARTRbus_RX_src4,<I>
																//C: iso_misc_pwm_1,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit30,<I/O>
																//def: ISO_MIS_GPIO_bit30,<I/O>
#define BGA_PIN_631_UP							(0&0x01)// 0xB8060218[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_631_PD							(0&0x01)// 0xB8060218[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_631_DS							(0&0x01)// 0xB8060218[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_631_SR							(0&0x01)// 0xB8060218[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_23_io 632 BALL NUM: M25
#define BGA_PIN_632								(0xF&0x9)//0xB8060214[31:28];
																//9: dmic_clk,<O>
																//A: I2S_out_Data0,<O>
																//B: I2S_IN_Data0_src6,<I>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit23,<I/O>
																//def: ISO_MIS_GPIO_bit23,<I/O>
#define BGA_PIN_632_UP							(0&0x01)// 0xB8060214[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_632_PD							(0&0x01)// 0xB8060214[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_632_DS							(0&0x01)// 0xB8060214[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_632_SR							(0&0x01)// 0xB8060214[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_25_io 633 BALL NUM: N27
#define BGA_PIN_633								(0xF&0xF)//0xB8060214[15:12];
																//9: dmic_clk_data_1_src1,<I>
																//B: I2C5_SDA_src2,<I/O>
																//C: iso_misc_pwm_3,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit25,<I/O>
																//def: ISO_MIS_GPIO_bit25,<I/O>
#define BGA_PIN_633_UP							(0&0x01)// 0xB8060214[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_633_PD							(0&0x01)// 0xB8060214[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_633_DS							(0&0x01)// 0xB8060214[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_633_SR							(0&0x01)// 0xB8060214[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_27_io 634 BALL NUM: T4
#define BGA_PIN_634								(0xF&0xF)//0xB8060218[31:28];
																//3: EJTAG_TCLK_CLK_src1,<I>,<AND>
																//5: HDDC3_SDA,<I/O>
																//6: uart0_tx,<OD>
																//7: uart1_tx,<OD>
																//8: UARTRbus_TX,<O>
																//C: iso_misc_pwm_4,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit27,<I/O>
																//def: ISO_MIS_GPIO_bit27,<I/O>
#define BGA_PIN_634_UP							(0&0x01)// 0xB8060218[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_634_PD							(1&0x01)// 0xB8060218[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_634_DS							(0&0x01)// 0xB8060218[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_634_SR							(0&0x01)// 0xB8060218[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_28_io 635 BALL NUM: U6
#define BGA_PIN_635								(0xF&0xF)//0xB8060218[23:20];
																//3: EJTAG_TMS_src1,<I/O>
																//5: HDDC3_SCL,<I>
																//6: uart0_rxdi_src2,<I>
																//7: uart1_rxdi_src2,<I>
																//8: UARTRbus_RX_src3,<I>
																//C: iso_misc_pwm_2,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit28,<I/O>
																//def: ISO_MIS_GPIO_bit28,<I/O>
#define BGA_PIN_635_UP							(0&0x01)// 0xB8060218[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_635_PD							(0&0x01)// 0xB8060218[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_635_DS							(0&0x01)// 0xB8060218[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_635_SR							(0&0x01)// 0xB8060218[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_33_io 636 BALL NUM: U5
#define BGA_PIN_636								(0xF&0xF)//0xB806021C[15:12];
																//C: iso_misc_pwm_3,<OD>
																//D: iso_misc_pwm_1,<OD>
																//F: ISO_MIS_GPIO_bit33,<I/O>
																//def: ISO_MIS_GPIO_bit33,<I/O>
#define BGA_PIN_636_UP							(0&0x01)// 0xB806021C[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_636_PD							(0&0x01)// 0xB806021C[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_636_DS							(0&0x01)// 0xB806021C[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_636_SR							(0&0x01)// 0xB806021C[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_st_gpio_34_io 637 BALL NUM: U4
#define BGA_PIN_637								(0xF&0xF)//0xB806021C[7:4];
																//2: emcu_EJTAG_TDO,<O>
																//3: EJTAG_TDO,<O>
																//C: iso_misc_pwm_4,<OD>
																//D: iso_misc_pwm_0,<OD>
																//F: ISO_MIS_GPIO_bit34,<I/O>
																//def: ISO_MIS_GPIO_bit34,<I/O>
#define BGA_PIN_637_UP							(0&0x01)// 0xB806021C[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_637_PD							(0&0x01)// 0xB806021C[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_637_DS							(0&0x01)// 0xB806021C[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_637_SR							(0&0x01)// 0xB806021C[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_138_io 655 BALL NUM: AB18
#define BGA_PIN_655								(0xF&0xF)//0xB80008A0[7:4];
																//1: PCMCIA_D_bit3,<I/O>,<HS>
																//D: misc_pwm_4,<OD>
																//E: test_en_bit31,<I/O>
																//F: MIS_GPIO_bit138,<I/O>
																//def: MIS_GPIO_bit138,<I/O>
#define BGA_PIN_655_UP							(0&0x01)// 0xB80008A0[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_655_PD							(0&0x01)// 0xB80008A0[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_655_DS							(0&0x01)// 0xB80008A0[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_655_SR							(0&0x01)// 0xB80008A0[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_137_io 656 BALL NUM: AC17
#define BGA_PIN_656								(0xF&0xF)//0xB80008A0[15:12];
																//1: PCMCIA_CD0_N,<I>,<HS>
																//D: misc_pwm_3,<OD>
																//E: test_en_bit30,<I/O>
																//F: MIS_GPIO_bit137,<I/O>
																//def: MIS_GPIO_bit137,<I/O>
#define BGA_PIN_656_UP							(0&0x01)// 0xB80008A0[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_656_PD							(0&0x01)// 0xB80008A0[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_656_DS							(0&0x01)// 0xB80008A0[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_656_SR							(0&0x01)// 0xB80008A0[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_83_io 658 BALL NUM: AC18
#define BGA_PIN_658								(0xF&0xF)//0xB800086C[31:28];
																//1: TP1_Data_bit3,<I>,<HS>
																//3: TCON_bit1,<O>
																//4: TCON_bit2,<O>
																//5: TCON_bit3,<O>
																//6: TCON_bit12,<O>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit83,<I/O>
																//def: MIS_GPIO_bit83,<I/O>
#define BGA_PIN_658_UP							(0&0x01)// 0xB800086C[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_658_PD							(0&0x01)// 0xB800086C[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_658_DS							(0&0x01)// 0xB800086C[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_658_SR							(0&0x01)// 0xB800086C[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_86_io 659 BALL NUM: AC19
#define BGA_PIN_659								(0xF&0xF)//0xB800086C[7:4];
																//1: PCMCIA_D_bit5,<I/O>,<HS>
																//3: TCON_bit7,<O>
																//4: TCON_bit8,<O>
																//5: TCON_bit9,<O>
																//6: TCON_bit24,<O>
																//D: misc_pwm_0,<OD>
																//E: test_en_bit8,<I/O>
																//F: MIS_GPIO_bit86,<I/O>
																//def: MIS_GPIO_bit86,<I/O>
#define BGA_PIN_659_UP							(0&0x01)// 0xB800086C[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_659_PD							(0&0x01)// 0xB800086C[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_659_DS							(0&0x01)// 0xB800086C[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_659_SR							(0&0x01)// 0xB800086C[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_85_io 660 BALL NUM: AB19
#define BGA_PIN_660								(0xF&0xF)//0xB800086C[15:12];
																//1: TP1_Data_bit4,<I>,<HS>
																//3: TCON_bit5,<O>
																//4: TCON_bit6,<O>
																//5: TCON_bit7,<O>
																//6: TCON_bit17,<O>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit85,<I/O>
																//def: MIS_GPIO_bit85,<I/O>
#define BGA_PIN_660_UP							(0&0x01)// 0xB800086C[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_660_PD							(0&0x01)// 0xB800086C[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_660_DS							(0&0x01)// 0xB800086C[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_660_SR							(0&0x01)// 0xB800086C[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_87_io 662 BALL NUM: AA20
#define BGA_PIN_662								(0xF&0xF)//0xB8000870[31:28];
																//1: TP1_Data_bit5,<I>,<HS>
																//3: TCON_bit9,<O>
																//4: TCON_bit10,<O>
																//5: TCON_bit11,<O>
																//6: TCON_bit12,<O>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit87,<I/O>
																//def: MIS_GPIO_bit87,<I/O>
#define BGA_PIN_662_UP							(0&0x01)// 0xB8000870[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_662_PD							(0&0x01)// 0xB8000870[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_662_DS							(0&0x01)// 0xB8000870[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_662_SR							(0&0x01)// 0xB8000870[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_89_io 663 BALL NUM: AC20
#define BGA_PIN_663								(0xF&0xF)//0xB8000870[15:12];
																//1: TP1_Data_bit6,<I>,<HS>
																//3: TCON_bit13,<O>
																//4: TCON_bit14,<O>
																//5: TCON_bit15,<O>
																//6: TCON_bit19,<O>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit89,<I/O>
																//def: MIS_GPIO_bit89,<I/O>
#define BGA_PIN_663_UP							(0&0x01)// 0xB8000870[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_663_PD							(0&0x01)// 0xB8000870[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_663_DS							(0&0x01)// 0xB8000870[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_663_SR							(0&0x01)// 0xB8000870[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_90_io 664 BALL NUM: AA21
#define BGA_PIN_664								(0xF&0xF)//0xB8000870[7:4];
																//1: PCMCIA_D_bit7,<I/O>,<HS>
																//3: TCON_bit15,<O>
																//4: TCON_bit16,<O>
																//5: TCON_bit17,<O>
																//6: TCON_bit18,<O>
																//D: misc_pwm_4,<OD>
																//E: test_en_bit10,<I/O>
																//F: MIS_GPIO_bit90,<I/O>
																//def: MIS_GPIO_bit90,<I/O>
#define BGA_PIN_664_UP							(0&0x01)// 0xB8000870[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_664_PD							(0&0x01)// 0xB8000870[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_664_DS							(0&0x01)// 0xB8000870[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_664_SR							(0&0x01)// 0xB8000870[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_91_io 665 BALL NUM: AB21
#define BGA_PIN_665								(0xF&0xF)//0xB8000874[31:28];
																//1: TP1_Data_bit7,<I>,<HS>
																//3: TCON_bit17,<O>
																//4: TCON_bit18,<O>
																//5: TCON_bit19,<O>
																//6: TCON_bit20,<O>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit91,<I/O>
																//def: MIS_GPIO_bit91,<I/O>
#define BGA_PIN_665_UP							(0&0x01)// 0xB8000874[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_665_PD							(0&0x01)// 0xB8000874[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_665_DS							(0&0x01)// 0xB8000874[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_665_SR							(0&0x01)// 0xB8000874[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_93_io 667 BALL NUM: AA22
#define BGA_PIN_667								(0xF&0xF)//0xB8000874[15:12];
																//1: PCMCIA_ADDR_bit10,<OD>,<HS>
																//3: TCON_bit21,<O>
																//4: TCON_bit22,<O>
																//5: TCON_bit23,<O>
																//6: TCON_bit24,<O>
																//D: misc_pwm_7,<OD>
																//E: test_en_bit12,<I/O>
																//F: MIS_GPIO_bit93,<I/O>
																//def: MIS_GPIO_bit93,<I/O>
#define BGA_PIN_667_UP							(0&0x01)// 0xB8000874[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_667_PD							(0&0x01)// 0xB8000874[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_667_DS							(0&0x01)// 0xB8000874[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_667_SR							(0&0x01)// 0xB8000874[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_94_io 668 BALL NUM: AB22
#define BGA_PIN_668								(0xF&0xF)//0xB8000874[7:4];
																//1: PCMCIA_OE_N,<O>,<HS>
																//3: TCON_bit23,<O>
																//4: TCON_bit24,<O>
																//5: TCON_bit25,<O>
																//6: TCON_bit26,<O>
																//D: misc_pwm_0,<OD>
																//E: test_en_bit13,<I/O>
																//F: MIS_GPIO_bit94,<I/O>
																//def: MIS_GPIO_bit94,<I/O>
#define BGA_PIN_668_UP							(0&0x01)// 0xB8000874[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_668_PD							(0&0x01)// 0xB8000874[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_668_DS							(0&0x01)// 0xB8000874[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_668_SR							(0&0x01)// 0xB8000874[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_95_io 669 BALL NUM: AC22
#define BGA_PIN_669								(0xF&0xF)//0xB8000878[31:28];
																//1: PCMCIA_IORD_N,<O>,<HS>
																//3: TCON_bit25,<O>
																//4: TCON_bit26,<O>
																//5: TCON_bit27,<O>
																//6: TCON_bit0<O>
																//D: misc_pwm_1,<OD>
																//E: test_en_bit14,<I/O>
																//F: MIS_GPIO_bit95,<I/O>
																//def: MIS_GPIO_bit95,<I/O>
#define BGA_PIN_669_UP							(0&0x01)// 0xB8000878[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_669_PD							(0&0x01)// 0xB8000878[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_669_DS							(0&0x01)// 0xB8000878[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_669_SR							(0&0x01)// 0xB8000878[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_98_io 676 BALL NUM: AC23
#define BGA_PIN_676								(0xF&0xF)//0xB8000878[7:4];
																//1: PCMCIA_ADDR_bit9,<OD>,<HS>
																//D: misc_pwm_4,<OD>
																//E: test_en_bit17,<I/O>
																//F: MIS_GPIO_bit98,<I/O>
																//def: MIS_GPIO_bit98,<I/O>
#define BGA_PIN_676_UP							(0&0x01)// 0xB8000878[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_676_PD							(0&0x01)// 0xB8000878[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_676_DS							(0&0x01)// 0xB8000878[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_676_SR							(0&0x01)// 0xB8000878[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_97_io 677 BALL NUM: AB23
#define BGA_PIN_677								(0xF&0xF)//0xB8000878[15:12];
																//1: PCMCIA_IOWR_N,<O>,<HS>
																//3: TCON_bit20,<O>
																//4: TCON_bit0,<O>
																//5: TCON_bit1,<O>
																//6: TCON_bit2,<O>
																//D: misc_pwm_3,<OD>
																//E: test_en_bit16,<I/O>
																//F: MIS_GPIO_bit97,<I/O>
																//def: MIS_GPIO_bit97,<I/O>
#define BGA_PIN_677_UP							(0&0x01)// 0xB8000878[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_677_PD							(0&0x01)// 0xB8000878[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_677_DS							(0&0x01)// 0xB8000878[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_677_SR							(0&0x01)// 0xB8000878[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_99_io 679 BALL NUM: AA24
#define BGA_PIN_679								(0xF&0xF)//0xB800087C[31:28];
																//1: TPO_sync_pad,<O>,<HS>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit99,<I/O>
																//def: MIS_GPIO_bit99,<I/O>
#define BGA_PIN_679_UP							(0&0x01)// 0xB800087C[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_679_PD							(0&0x01)// 0xB800087C[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_679_DS							(0&0x01)// 0xB800087C[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_679_SR							(0&0x01)// 0xB800087C[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_102_io 680 BALL NUM: Y22
#define BGA_PIN_680								(0xF&0xF)//0xB800087C[7:4];
																//0: PCMCIA_RST1,<OD>,<HS>
																//1: PCMCIA_ADDR_bit13,<OD>,<HS>
																//8: SC_DATA_src0,<I/O>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit102,<I/O>
																//def: MIS_GPIO_bit102,<I/O>
#define BGA_PIN_680_UP							(0&0x01)// 0xB800087C[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_680_PD							(0&0x01)// 0xB800087C[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_680_DS							(0&0x01)// 0xB800087C[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_680_SR							(0&0x01)// 0xB800087C[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_101_io 681 BALL NUM: AC24
#define BGA_PIN_681								(0xF&0xF)//0xB800087C[15:12];
																//1: TPO_data_bit0_pad,<O>,<HS>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit101,<I/O>
																//def: MIS_GPIO_bit101,<I/O>
#define BGA_PIN_681_UP							(0&0x01)// 0xB800087C[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_681_PD							(0&0x01)// 0xB800087C[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_681_DS							(0&0x01)// 0xB800087C[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_681_SR							(0&0x01)// 0xB800087C[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_103_io 683 BALL NUM: Y23
#define BGA_PIN_683								(0xF&0xF)//0xB8000880[31:28];
																//1: TPO_data_bit1_pad,<O>,<HS>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit103,<I/O>
																//def: MIS_GPIO_bit103,<I/O>
#define BGA_PIN_683_UP							(0&0x01)// 0xB8000880[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_683_PD							(0&0x01)// 0xB8000880[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_683_DS							(0&0x01)// 0xB8000880[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_683_SR							(0&0x01)// 0xB8000880[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_105_io 684 BALL NUM: W22
#define BGA_PIN_684								(0xF&0xF)//0xB8000880[15:12];
																//1: TPO_data_bit2_pad,<O>,<HS>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit105,<I/O>
																//def: MIS_GPIO_bit105,<I/O>
#define BGA_PIN_684_UP							(0&0x01)// 0xB8000880[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_684_PD							(0&0x01)// 0xB8000880[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_684_DS							(0&0x01)// 0xB8000880[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_684_SR							(0&0x01)// 0xB8000880[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_106_io 685 BALL NUM: W23
#define BGA_PIN_685								(0xF&0xF)//0xB8000880[7:4];
																//1: PCMCIA_WE_N,<O>,<HS>
																//D: misc_pwm_4,<OD>
																//E: test_en_bit19,<I/O>
																//F: MIS_GPIO_bit106,<I/O>
																//def: MIS_GPIO_bit106,<I/O>
#define BGA_PIN_685_UP							(0&0x01)// 0xB8000880[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_685_PD							(0&0x01)// 0xB8000880[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_685_DS							(0&0x01)// 0xB8000880[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_685_SR							(0&0x01)// 0xB8000880[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_107_io 686 BALL NUM: W24
#define BGA_PIN_686								(0xF&0xF)//0xB8000884[31:28];
																//1: TPO_data_bit3_pad,<O>,<HS>
																//3: TCON_bit1,<O>
																//4: TCON_bit2,<O>
																//5: TCON_bit3,<O>
																//6: TCON_bit12,<O>
																//7: ld_spi0_p1_cs1,<O>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit107,<I/O>
																//def: MIS_GPIO_bit107,<I/O>
#define BGA_PIN_686_UP							(0&0x01)// 0xB8000884[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_686_PD							(0&0x01)// 0xB8000884[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_686_DS							(0&0x01)// 0xB8000884[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_686_SR							(0&0x01)// 0xB8000884[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_109_io 688 BALL NUM: V23
#define BGA_PIN_688								(0xF&0xF)//0xB8000884[15:12];
																//1: TPO_data_bit4_pad,<O>,<HS>
																//3: TCON_bit5,<O>
																//4: TCON_bit6,<O>
																//5: TCON_bit7,<O>
																//6: TCON_bit17,<O>
																//7: ld_spi0_p3_sdo_src2,<I/O>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit109,<I/O>
																//def: MIS_GPIO_bit109,<I/O>
#define BGA_PIN_688_UP							(0&0x01)// 0xB8000884[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_688_PD							(0&0x01)// 0xB8000884[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_688_DS							(0&0x01)// 0xB8000884[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_688_SR							(0&0x01)// 0xB8000884[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_110_io 694 BALL NUM: V24
#define BGA_PIN_694								(0xF&0xF)//0xB8000884[7:4];
																//1: TPO_val_pad,<O>,<HS>
																//3: TCON_bit7,<O>
																//4: TCON_bit8,<O>
																//5: TCON_bit9,<O>
																//6: TCON_bit24,<O>
																//7: ld_spi0_p4_sdi_src2,<I>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit110,<I/O>
																//def: MIS_GPIO_bit110,<I/O>
#define BGA_PIN_694_UP							(0&0x01)// 0xB8000884[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_694_PD							(0&0x01)// 0xB8000884[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_694_DS							(0&0x01)// 0xB8000884[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_694_SR							(0&0x01)// 0xB8000884[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_114_io 695 BALL NUM: AE26
#define BGA_PIN_695								(0xF&0xF)//0xB8000888[7:4];
																//0: PCMCIA_WAIT1_N,<I>
																//1: PCMCIA_ADDR_bit12,<OD>,<HS>
																//8: SC_SCLK,<OD>
																//D: misc_pwm_4,<OD>
																//F: MIS_GPIO_bit114,<I/O>
																//def: MIS_GPIO_bit114,<I/O>
#define BGA_PIN_695_UP							(0&0x01)// 0xB8000888[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_695_PD							(0&0x01)// 0xB8000888[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_695_DS							(0&0x01)// 0xB8000888[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_695_SR							(0&0x01)// 0xB8000888[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_113_io 697 BALL NUM: AF27
#define BGA_PIN_697								(0xF&0xF)//0xB8000888[15:12];
																//1: TPO_data_bit6_pad,<O>,<HS>
																//3: TCON_bit13,<O>
																//4: TCON_bit14,<O>
																//5: TCON_bit15,<O>
																//6: TCON_bit19,<O>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit113,<I/O>
																//def: MIS_GPIO_bit113,<I/O>
#define BGA_PIN_697_UP							(0&0x01)// 0xB8000888[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_697_PD							(0&0x01)// 0xB8000888[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_697_DS							(0&0x01)// 0xB8000888[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_697_SR							(0&0x01)// 0xB8000888[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_111_io 698 BALL NUM: U22
#define BGA_PIN_698								(0xF&0xF)//0xB8000888[31:28];
																//1: TPO_data_bit5_pad,<O>,<HS>
																//3: TCON_bit9,<O>
																//4: TCON_bit10,<O>
																//5: TCON_bit11,<O>
																//6: TCON_bit12,<O>
																//7: ld_spi0_p5_v_sync,<O>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit111,<I/O>
																//def: MIS_GPIO_bit111,<I/O>
#define BGA_PIN_698_UP							(0&0x01)// 0xB8000888[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_698_PD							(0&0x01)// 0xB8000888[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_698_DS							(0&0x01)// 0xB8000888[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_698_SR							(0&0x01)// 0xB8000888[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_117_io 699 BALL NUM: AD27
#define BGA_PIN_699								(0xF&0xF)//0xB800088C[15:12];
																//1: TP1_CLK_src0,<I>,<HS>,<AND>
																//3: TCON_bit19,<O>
																//4: TCON_bit20,<O>
																//5: TCON_bit21,<O>
																//6: TCON_bit27,<O>
																//7: ld_spi1_p3_sdo_src5,<I/O>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit117,<I/O>
																//def: MIS_GPIO_bit117,<I/O>
#define BGA_PIN_699_UP							(0&0x01)// 0xB800088C[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_699_PD							(0&0x01)// 0xB800088C[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_699_DS							(0&0x01)// 0xB800088C[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_699_SR							(0&0x01)// 0xB800088C[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_116_io 700 BALL NUM: AD25
#define BGA_PIN_700								(0xF&0xF)//0xB800088C[23:20];
																//1: PCMCIA_ADDR_bit7,<OD>,<HS>
																//3: TCON_bit17,<O>
																//4: TCON_bit18,<O>
																//5: TCON_bit19,<O>
																//6: TCON_bit20,<O>
																//7: ld_spi1_p2_sck_src5,<I/O>
																//D: misc_pwm_6,<OD>
																//E: test_en_bit21,<I/O>
																//F: MIS_GPIO_bit116,<I/O>
																//def: MIS_GPIO_bit116,<I/O>
#define BGA_PIN_700_UP							(0&0x01)// 0xB800088C[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_700_PD							(0&0x01)// 0xB800088C[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_700_DS							(0&0x01)// 0xB800088C[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_700_SR							(0&0x01)// 0xB800088C[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_119_io 701 BALL NUM: AC25
#define BGA_PIN_701								(0xF&0xF)//0xB8000890[31:28];
																//1: PCMCIA_RST0,<OD>,<HS>
																//3: TCON_bit23,<O>
																//4: TCON_bit24,<O>
																//5: TCON_bit25,<O>
																//6: TCON_bit26,<O>
																//7: ld_spi1_p5_v_sync,<O>
																//D: misc_pwm_1,<OD>
																//E: test_en_bit23,<I/O>
																//F: MIS_GPIO_bit119,<I/O>
																//def: MIS_GPIO_bit119,<I/O>
#define BGA_PIN_701_UP							(0&0x01)// 0xB8000890[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_701_PD							(0&0x01)// 0xB8000890[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_701_DS							(0&0x01)// 0xB8000890[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_701_SR							(0&0x01)// 0xB8000890[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_118_io 702 BALL NUM: AD26
#define BGA_PIN_702								(0xF&0xF)//0xB800088C[7:4];
																//1: PCMCIA_ADDR_bit6,<OD>,<HS>
																//3: TCON_bit21,<O>
																//4: TCON_bit22,<O>
																//5: TCON_bit23,<O>
																//6: TCON_bit24,<O>
																//7: ld_spi1_p4_sdi_src5,<I>
																//D: misc_pwm_0,<OD>
																//E: test_en_bit22,<I/O>
																//F: MIS_GPIO_bit118,<I/O>
																//def: MIS_GPIO_bit118,<I/O>
#define BGA_PIN_702_UP							(0&0x01)// 0xB800088C[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_702_PD							(0&0x01)// 0xB800088C[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_702_DS							(0&0x01)// 0xB800088C[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_702_SR							(0&0x01)// 0xB800088C[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_115_io 703 BALL NUM: AE27
#define BGA_PIN_703								(0xF&0xF)//0xB800088C[31:28];
																//1: TPO_data_bit7_pad,<O>,<HS>
																//3: TCON_bit15,<O>
																//4: TCON_bit16,<O>
																//5: TCON_bit17,<O>
																//6: TCON_bit18,<O>
																//7: ld_spi1_p1_cs1,<O>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit115,<I/O>
																//def: MIS_GPIO_bit115,<I/O>
#define BGA_PIN_703_UP							(0&0x01)// 0xB800088C[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_703_PD							(0&0x01)// 0xB800088C[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_703_DS							(0&0x01)// 0xB800088C[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_703_SR							(0&0x01)// 0xB800088C[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_120_io 704 BALL NUM: AC26
#define BGA_PIN_704								(0xF&0xF)//0xB8000890[23:20];
																//1: PCMCIA_ADDR_bit5,<OD>,<HS>
																//3: TCON_bit25,<O>
																//4: TCON_bit26,<O>
																//5: TCON_bit27,<O>
																//6: TCON_bit0,<O>
																//7: ld_spi1_p6_h_sync,<O>
																//D: misc_pwm_2,<OD>
																//E: test_en_bit24,<I/O>
																//F: MIS_GPIO_bit120,<I/O>
																//def: MIS_GPIO_bit120,<I/O>
#define BGA_PIN_704_UP							(0&0x01)// 0xB8000890[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_704_PD							(0&0x01)// 0xB8000890[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_704_DS							(0&0x01)// 0xB8000890[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_704_SR							(0&0x01)// 0xB8000890[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_121_io 705 BALL NUM: AB25
#define BGA_PIN_705								(0xF&0xF)//0xB8000890[15:12];
																//1: PCMCIA_WAIT0_N,<I>
																//3: TCON_bit27,<O>
																//4: TCON_bit26,<O>
																//5: TCON_bit1,<O>
																//6: TCON_bit0,<O>
																//D: misc_pwm_3,<OD>
																//E: test_en_bit25,<I/O>
																//F: MIS_GPIO_bit121,<I/O>
																//def: MIS_GPIO_bit121,<I/O>
#define BGA_PIN_705_UP							(0&0x01)// 0xB8000890[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_705_PD							(0&0x01)// 0xB8000890[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_705_DS							(0&0x01)// 0xB8000890[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_705_SR							(0&0x01)// 0xB8000890[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_122_io 706 BALL NUM: AB26
#define BGA_PIN_706								(0xF&0xF)//0xB8000890[7:4];
																//1: PCMCIA_ADDR_bit4,<OD>,<HS>
																//3: TCON_bit20,<O>
																//4: TCON_bit0,<O>
																//5: TCON_bit1,<O>
																//6: TCON_bit2,<O>
																//7: ld_spi0_p1_cs1,<O>
																//D: misc_pwm_4,<OD>
																//E: test_en_bit26,<I/O>
																//F: MIS_GPIO_bit122,<I/O>
																//def: MIS_GPIO_bit122,<I/O>
#define BGA_PIN_706_UP							(0&0x01)// 0xB8000890[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_706_PD							(0&0x01)// 0xB8000890[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_706_DS							(0&0x01)// 0xB8000890[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_706_SR							(0&0x01)// 0xB8000890[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_123_io 707 BALL NUM: AB27
#define BGA_PIN_707								(0xF&0xF)//0xB8000894[31:28];
																//0: PCMCIA_CD1_N,<I>,<HS>
																//1: PCMCIA_INPACK0_N,<I>,<HS>
																//8: SC_CD_src0,<I>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit123,<I/O>
																//def: MIS_GPIO_bit123,<I/O>
#define BGA_PIN_707_UP							(0&0x01)// 0xB8000894[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_707_PD							(0&0x01)// 0xB8000894[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_707_DS							(0&0x01)// 0xB8000894[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_707_SR							(0&0x01)// 0xB8000894[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_124_io 708 BALL NUM: AA25
#define BGA_PIN_708								(0xF&0xF)//0xB8000894[23:20];
																//1: PCMCIA_ADDR_bit3,<OD>,<HS>
																//3: TCON_bit1,<O>
																//4: TCON_bit2,<O>
																//5: TCON_bit3,<O>
																//6: TCON_bit12,<O>
																//7: ld_spi0_p2_sck_src3,<I/O>
																//D: misc_pwm_6,<OD>
																//E: test_en_bit27,<I/O>
																//F: MIS_GPIO_bit124,<I/O>
																//def: MIS_GPIO_bit124,<I/O>
#define BGA_PIN_708_UP							(0&0x01)// 0xB8000894[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_708_PD							(0&0x01)// 0xB8000894[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_708_DS							(0&0x01)// 0xB8000894[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_708_SR							(0&0x01)// 0xB8000894[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_127_io 709 BALL NUM: Y25
#define BGA_PIN_709								(0xF&0xF)//0xB8000898[31:28];
																//1: TP1_VAL_src0,<I>,<HS>
																//3: TCON_bit5,<O>
																//4: TCON_bit6,<O>
																//5: TCON_bit7,<O>
																//6: TCON_bit17,<O>
																//7: ld_spi0_p4_sdi_src3,<I>
																//8: SC_DATA_src1,<I/O>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit127,<I/O>
																//def: MIS_GPIO_bit127,<I/O>
#define BGA_PIN_709_UP							(0&0x01)// 0xB8000898[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_709_PD							(0&0x01)// 0xB8000898[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_709_DS							(0&0x01)// 0xB8000898[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_709_SR							(0&0x01)// 0xB8000898[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_126_io 710 BALL NUM: AA26
#define BGA_PIN_710								(0xF&0xF)//0xB8000894[7:4];
																//1: PCMCIA_ADDR_bit2,<OD>,<HS>
																//3: TCON_bit3,<O>
																//4: TCON_bit4,<O>
																//5: TCON_bit5,<O>
																//6: TCON_bit21,<O>
																//7: ld_spi0_p3_sdo_src3,<I/O>
																//D: misc_pwm_0,<OD>
																//E: test_en_bit28,<I/O>
																//F: MIS_GPIO_bit126,<I/O>
																//def: MIS_GPIO_bit126,<I/O>
#define BGA_PIN_710_UP							(0&0x01)// 0xB8000894[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_710_PD							(0&0x01)// 0xB8000894[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_710_DS							(0&0x01)// 0xB8000894[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_710_SR							(0&0x01)// 0xB8000894[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_125_io 711 BALL NUM: AA27
#define BGA_PIN_711								(0xF&0xF)//0xB8000894[15:12];
																//0: PCMCIA_IREQ1_N,<I>,<HS>
																//1: PCMCIA_REG_N,<O>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit125,<I/O>
																//def: MIS_GPIO_bit125,<I/O>
#define BGA_PIN_711_UP							(0&0x01)// 0xB8000894[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_711_PD							(0&0x01)// 0xB8000894[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_711_DS							(0&0x01)// 0xB8000894[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_711_SR							(0&0x01)// 0xB8000894[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_128_io 712 BALL NUM: Y26
#define BGA_PIN_712								(0xF&0xF)//0xB8000898[23:20];
																//1: PCMCIA_ADDR_bit1,<OD>,<HS>
																//3: TCON_bit7,<O>
																//4: TCON_bit8,<O>
																//5: TCON_bit9,<O>
																//6: TCON_bit24,<O>
																//7: ld_spi0_p5_v_sync,<O>
																//8: SC_RST,<OD>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit128,<I/O>
																//def: MIS_GPIO_bit128,<I/O>
#define BGA_PIN_712_UP							(0&0x01)// 0xB8000898[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_712_PD							(0&0x01)// 0xB8000898[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_712_DS							(0&0x01)// 0xB8000898[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_712_SR							(0&0x01)// 0xB8000898[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_129_io 715 BALL NUM: W25
#define BGA_PIN_715								(0xF&0xF)//0xB8000898[15:12];
																//1: TP1_SYNC_src0,<I>,<HS>
																//3: TCON_bit9,<O>
																//4: TCON_bit10,<O>
																//5: TCON_bit11,<O>
																//6: TCON_bit12,<O>
																//7: ld_spi0_p6_h_sync,<O>
																//8: SC_SCLK,<OD>
																//D: misc_pwm_3,<OD>
																//F: MIS_GPIO_bit129,<I/O>
																//def: MIS_GPIO_bit129,<I/O>
#define BGA_PIN_715_UP							(0&0x01)// 0xB8000898[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_715_PD							(0&0x01)// 0xB8000898[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_715_DS							(0&0x01)// 0xB8000898[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_715_SR							(0&0x01)// 0xB8000898[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_130_io 717 BALL NUM: W26
#define BGA_PIN_717								(0xF&0xF)//0xB8000898[7:4];
																//1: PCMCIA_ADDR_bit0,<OD>,<HS>
																//8: SC_CD_src1,<I>
																//D: misc_pwm_4,<OD>
																//F: MIS_GPIO_bit130,<I/O>
																//def: MIS_GPIO_bit130,<I/O>
#define BGA_PIN_717_UP							(0&0x01)// 0xB8000898[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_717_PD							(0&0x01)// 0xB8000898[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_717_DS							(0&0x01)// 0xB8000898[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_717_SR							(0&0x01)// 0xB8000898[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_131_io 718 BALL NUM: W27
#define BGA_PIN_718								(0xF&0xF)//0xB800089C[31:28];
																//1: TP1_Data_bit0_src0,<I>,<HS>
																//8: SC_DATA_src2,<I/O>
																//D: misc_pwm_5,<OD>
																//F: MIS_GPIO_bit131,<I/O>
																//def: MIS_GPIO_bit131,<I/O>
#define BGA_PIN_718_UP							(0&0x01)// 0xB800089C[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_718_PD							(0&0x01)// 0xB800089C[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_718_DS							(0&0x01)// 0xB800089C[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_718_SR							(0&0x01)// 0xB800089C[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_132_io 719 BALL NUM: V25
#define BGA_PIN_719								(0xF&0xF)//0xB800089C[23:20];
																//1: PCMCIA_D_bit0,<I/O>,<HS>
																//8: SC_RST,<OD>
																//D: misc_pwm_6,<OD>
																//F: MIS_GPIO_bit132,<I/O>
																//def: MIS_GPIO_bit132,<I/O>
#define BGA_PIN_719_UP							(0&0x01)// 0xB800089C[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_719_PD							(0&0x01)// 0xB800089C[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_719_DS							(0&0x01)// 0xB800089C[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_719_SR							(0&0x01)// 0xB800089C[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_133_io 720 BALL NUM: V27
#define BGA_PIN_720								(0xF&0xF)//0xB800089C[15:12];
																//1: TP1_Data_bit1,<I>,<HS>
																//8: SC_SCLK,<OD>
																//D: misc_pwm_7,<OD>
																//F: MIS_GPIO_bit133,<I/O>
																//def: MIS_GPIO_bit133,<I/O>
#define BGA_PIN_720_UP							(0&0x01)// 0xB800089C[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_720_PD							(0&0x01)// 0xB800089C[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_720_DS							(0&0x01)// 0xB800089C[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_720_SR							(0&0x01)// 0xB800089C[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_134_io 721 BALL NUM: V26
#define BGA_PIN_721								(0xF&0xF)//0xB800089C[7:4];
																//1: PCMCIA_D_bit1,<I/O>,<HS>
																//8: SC_CD_src2,<I>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit134,<I/O>
																//def: MIS_GPIO_bit134,<I/O>
#define BGA_PIN_721_UP							(0&0x01)// 0xB800089C[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_721_PD							(0&0x01)// 0xB800089C[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_721_DS							(0&0x01)// 0xB800089C[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_721_SR							(0&0x01)// 0xB800089C[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_135_io 722 BALL NUM: U25
#define BGA_PIN_722								(0xF&0xF)//0xB80008A0[31:28];
																//1: TP1_Data_bit2,<I>,<HS>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit135,<I/O>
																//def: MIS_GPIO_bit135,<I/O>
#define BGA_PIN_722_UP							(0&0x01)// 0xB80008A0[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_722_PD							(0&0x01)// 0xB80008A0[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_722_DS							(0&0x01)// 0xB80008A0[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_722_SR							(0&0x01)// 0xB80008A0[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_136_io 723 BALL NUM: U26
#define BGA_PIN_723								(0xF&0xF)//0xB80008A0[23:20];
																//1: PCMCIA_D_bit2,<I/O>,<HS>
																//D: misc_pwm_2,<OD>
																//E: test_en_bit29,<I/O>
																//F: MIS_GPIO_bit136,<I/O>
																//def: MIS_GPIO_bit136,<I/O>
#define BGA_PIN_723_UP							(0&0x01)// 0xB80008A0[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_723_PD							(0&0x01)// 0xB80008A0[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_723_DS							(0&0x01)// 0xB80008A0[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_723_SR							(0&0x01)// 0xB80008A0[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_rst_n_io 747 BALL NUM: L26
#define BGA_PIN_747								(0xF&0x1)//0xB80008B0[31:28];
																//0: nf_tmx_rd_n,<O>,<HS>
																//1: emmc_rst_n,<O>
																//F: MIS_GPIO_bit139,<I/O>
																//def: MIS_GPIO_bit139,<I/O>
#define BGA_PIN_747_UP							(0&0x01)// 0xB80008B0[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_747_PD							(0&0x01)// 0xB80008B0[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_747_DS							(0&0x01)// 0xB80008B0[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_747_SR							(0&0x01)// 0xB80008B0[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_clk_io 750 BALL NUM: M27
#define BGA_PIN_750								(0xF&0x1)//0xB80008B0[23:20];
																//0: nf_tmx_cle,<O>,<HS>
																//1: emmc_clk,<O>
																//F: MIS_GPIO_bit140,<I/O>
																//def: MIS_GPIO_bit140,<I/O>
#define BGA_PIN_750_UP							(0&0x01)// 0xB80008B0[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_750_PD							(0&0x01)// 0xB80008B0[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_750_DS							(0&0x01)// 0xB80008B0[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_750_SR							(0&0x01)// 0xB80008B0[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_cmd_io 753 BALL NUM: L25
#define BGA_PIN_753								(0xF&0x1)//0xB80008B0[15:12];
																//0: nf_tmx_ale,<O>,<HS>
																//1: emmc_cmd,<I/O>
																//F: MIS_GPIO_bit141,<I/O>
																//def: MIS_GPIO_bit141,<I/O>
#define BGA_PIN_753_UP							(0&0x01)// 0xB80008B0[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_753_PD							(0&0x01)// 0xB80008B0[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_753_DS							(0&0x01)// 0xB80008B0[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_753_SR							(0&0x01)// 0xB80008B0[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_ds_io 754 BALL NUM: K25
#define BGA_PIN_754								(0xF&0x1)//0xB80008B4[31:28];
																//0: nf_tmx_wr_n,<O>,<HS>
																//1: emmc_ds,<I>
																//F: MIS_GPIO_bit142,<I/O>
																//def: MIS_GPIO_bit142,<I/O>
#define BGA_PIN_754_UP							(0&0x01)// 0xB80008B4[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_754_PD							(0&0x01)// 0xB80008B4[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_754_DS							(0&0x01)// 0xB80008B4[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_754_SR							(0&0x01)// 0xB80008B4[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_d5_io:IO 756 BALL NUM: K26
#define BGA_PIN_756								(0xF&0x1)//0xB80008B4[23:20];
																//0: nf_tmx_bit7,<I/O>,<HS>
																//1: emmc_data_bit5,<I/O>
																//F: MIS_GPIO_bit143,<I/O>
																//def: MIS_GPIO_bit143,<I/O>
#define BGA_PIN_756_UP							(0&0x01)// 0xB80008B4[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_756_PD							(0&0x01)// 0xB80008B4[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_756_DS							(0&0x01)// 0xB80008B4[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_756_SR							(0&0x01)// 0xB80008B4[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_d3_io 757 BALL NUM: K27
#define BGA_PIN_757								(0xF&0x1)//0xB80008B4[15:12];
																//0: nf_tmx_bit6,<I/O>,<HS>
																//1: emmc_data_bit3,<I/O>
																//F: MIS_GPIO_bit144,<I/O>
																//def: MIS_GPIO_bit144,<I/O>
#define BGA_PIN_757_UP							(0&0x01)// 0xB80008B4[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_757_PD							(0&0x01)// 0xB80008B4[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_757_DS							(0&0x01)// 0xB80008B4[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_757_SR							(0&0x01)// 0xB80008B4[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_d4_io:IO 759 BALL NUM: J27
#define BGA_PIN_759								(0xF&0x1)//0xB80008B4[7:4];
																//0: nf_tmx_bit5,<I/O>,<HS>
																//1: emmc_data_bit4,<I/O>
																//F: MIS_GPIO_bit145,<I/O>
																//def: MIS_GPIO_bit145,<I/O>
#define BGA_PIN_759_UP							(0&0x01)// 0xB80008B4[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_759_PD							(0&0x01)// 0xB80008B4[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_759_DS							(0&0x01)// 0xB80008B4[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_759_SR							(0&0x01)// 0xB80008B4[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_d0_io 760 BALL NUM: J26
#define BGA_PIN_760								(0xF&0x1)//0xB80008B8[31:28];
																//0: nf_tmx_bit4,<I/O>,<HS>
																//1: emmc_data_bit0,<I/O>
																//F: MIS_GPIO_bit146,<I/O>
																//def: MIS_GPIO_bit146,<I/O>
#define BGA_PIN_760_UP							(0&0x01)// 0xB80008B8[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_760_PD							(0&0x01)// 0xB80008B8[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_760_DS							(0&0x01)// 0xB80008B8[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_760_SR							(0&0x01)// 0xB80008B8[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_d1_io:IO 765 BALL NUM: H25
#define BGA_PIN_765								(0xF&0x1)//0xB80008B8[23:20];
																//0: nf_tmx_bit3,<I/O>,<HS>
																//1: emmc_data_bit1,<I/O>
																//F: MIS_GPIO_bit147,<I/O>
																//def: MIS_GPIO_bit147,<I/O>
#define BGA_PIN_765_UP							(0&0x01)// 0xB80008B8[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_765_PD							(0&0x01)// 0xB80008B8[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_765_DS							(0&0x01)// 0xB80008B8[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_765_SR							(0&0x01)// 0xB80008B8[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_d2_io 766 BALL NUM: H26
#define BGA_PIN_766								(0xF&0x1)//0xB80008B8[15:12];
																//0: nf_tmx_bit2,<I/O>,<HS>
																//1: emmc_data_bit2,<I/O>
																//F: MIS_GPIO_bit148,<I/O>
																//def: MIS_GPIO_bit148,<I/O>
#define BGA_PIN_766_UP							(0&0x01)// 0xB80008B8[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_766_PD							(0&0x01)// 0xB80008B8[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_766_DS							(0&0x01)// 0xB80008B8[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_766_SR							(0&0x01)// 0xB80008B8[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_d7_io:IO 768 BALL NUM: G25
#define BGA_PIN_768								(0xF&0x1)//0xB80008B8[7:4];
																//0: nf_tmx_bit1,<I/O>,<HS>
																//1: emmc_data_bit7,<I/O>
																//F: MIS_GPIO_bit149,<I/O>
																//def: MIS_GPIO_bit149,<I/O>
#define BGA_PIN_768_UP							(0&0x01)// 0xB80008B8[3]: Pull Up 0:disable 1:enable
#define BGA_PIN_768_PD							(0&0x01)// 0xB80008B8[2]: Pull Down 0:disable 1:enable
#define BGA_PIN_768_DS							(0&0x01)// 0xB80008B8[1]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_768_SR							(0&0x01)// 0xB80008B8[0]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_emmc_d6_io 769 BALL NUM: G26
#define BGA_PIN_769								(0xF&0x1)//0xB80008BC[31:28];
																//0: nf_tmx_bit0,<I/O>,<HS>
																//1: emmc_data_bit6,<I/O>
																//F: MIS_GPIO_bit150,<I/O>
																//def: MIS_GPIO_bit150,<I/O>
#define BGA_PIN_769_UP							(0&0x01)// 0xB80008BC[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_769_PD							(0&0x01)// 0xB80008BC[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_769_DS							(0&0x01)// 0xB80008BC[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_769_SR							(0&0x01)// 0xB80008BC[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_151_io 774 BALL NUM: F25
#define BGA_PIN_774								(0xF&0xF)//0xB80008A4[31:28];
																//0: tmx_nf_rdy,<I>,<HS>
																//2: SPI_DI_src2,<I/O>,<HS>
																//D: misc_pwm_0,<OD>
																//F: MIS_GPIO_bit151,<I/O>
																//def: MIS_GPIO_bit151,<I/O>
#define BGA_PIN_774_UP							(0&0x01)// 0xB80008A4[27]: Pull Up 0:disable 1:enable
#define BGA_PIN_774_PD							(0&0x01)// 0xB80008A4[26]: Pull Down 0:disable 1:enable
#define BGA_PIN_774_DS							(0&0x01)// 0xB80008A4[25]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_774_SR							(0&0x01)// 0xB80008A4[24]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_152_io 775 BALL NUM: F27
#define BGA_PIN_775								(0xF&0xF)//0xB80008A4[23:20];
																//0: nf_tmx_ce_n_bit0,<O>,<HS>
																//2: SPI_DO_src2,<I/O>,<HS>
																//D: misc_pwm_1,<OD>
																//F: MIS_GPIO_bit152,<I/O>
																//def: MIS_GPIO_bit152,<I/O>
#define BGA_PIN_775_UP							(0&0x01)// 0xB80008A4[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_775_PD							(0&0x01)// 0xB80008A4[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_775_DS							(0&0x01)// 0xB80008A4[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_775_SR							(0&0x01)// 0xB80008A4[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_153_io 776 BALL NUM: F26
#define BGA_PIN_776								(0xF&0xF)//0xB80008A4[15:12];
																//0: nf_tmx_ce_n_bit1,<O>,<HS>
																//2: SPI_CS_N,<O>,<HS>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit153,<I/O>
																//def: MIS_GPIO_bit153,<I/O>
#define BGA_PIN_776_UP							(0&0x01)// 0xB80008A4[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_776_PD							(0&0x01)// 0xB80008A4[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_776_DS							(0&0x01)// 0xB80008A4[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_776_SR							(0&0x01)// 0xB80008A4[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pif_tx11p_33v_apad 1193 BALL NUM: C21
#if defined(CONFIG_TCONLESS_BOE_CEDS) || defined(Config_Panel_Type_FHD)
#define BGA_PIN_1193								(0xF&0xC)//0xB8000CB0[31:28];
#else
#define BGA_PIN_1193								(0xF&0xF)//0xB8000CB0[31:28];
#endif
																//C: PIF_TX11P,<AO>
																//F: MIS_GPI_bit8,<I>
																//def: PIF_TX11P,<AO>


// PAD_NAME: pif_tx11n_33v_apad 1194 BALL NUM: A21
#if defined(CONFIG_TCONLESS_BOE_CEDS) || defined(Config_Panel_Type_FHD)
#define BGA_PIN_1194								(0xF&0xC)//0xB8000CB0[27:24];
#else
#define BGA_PIN_1194								(0xF&0xF)//0xB8000CB0[27:24];
#endif
																//C: PIF_TX11N,<AO>
																//F: MIS_GPI_bit9,<I>
																//def: PIF_TX11N,<AO>


// PAD_NAME: pif_tx10p_33v_apad 1197 BALL NUM: C20
#if defined(CONFIG_TCONLESS_BOE_CEDS) || defined(Config_Panel_Type_FHD)
#define BGA_PIN_1197								(0xF&0xC)//0xB8000CB0[23:20];
#else
#define BGA_PIN_1197								(0xF&0xF)//0xB8000CB0[23:20];
#endif
																//C: PIF_TX10P,<AO>
																//F: MIS_GPI_bit10,<I>
																//def: PIF_TX10P,<AO>


// PAD_NAME: pif_tx10n_33v_apad 1198 BALL NUM: B20
#if defined(CONFIG_TCONLESS_BOE_CEDS) || defined(Config_Panel_Type_FHD)
#define BGA_PIN_1198								(0xF&0xC)//0xB8000CB0[19:16];
#else
#define BGA_PIN_1198								(0xF&0xF)//0xB8000CB0[19:16];
#endif
																//C: PIF_TX10N,<AO>
																//F: MIS_GPI_bit11,<I>
																//def: PIF_TX10N,<AO>


// PAD_NAME: pif_tx9p_33v_apad 1199 BALL NUM: B19
#if defined(CONFIG_TCONLESS_BOE_CEDS) || defined(Config_Panel_Type_FHD)
#define BGA_PIN_1199								(0xF&0xC)//0xB8000CB0[15:12];
#else
#define BGA_PIN_1199								(0xF&0xF)//0xB8000CB0[15:12];
#endif
																//C: PIF_TX9P,<AO>
																//F: MIS_GPI_bit12,<I>
																//def: PIF_TX9P,<AO>


// PAD_NAME: pif_tx9n_33v_apad 1200 BALL NUM: A19
#if defined(CONFIG_TCONLESS_BOE_CEDS) || defined(Config_Panel_Type_FHD)
#define BGA_PIN_1200								(0xF&0xC)//0xB8000CB0[11:8];
#else
#define BGA_PIN_1200								(0xF&0xF)//0xB8000CB0[11:8];
#endif
																//C: PIF_TX9N,<AO>
																//F: MIS_GPI_bit13,<I>
																//def: PIF_TX9N,<AO>


// PAD_NAME: pif_tx8p_33v_apad 1201 BALL NUM: A18
#if defined(CONFIG_TCONLESS_BOE_CEDS) || defined(Config_Panel_Type_FHD)
#define BGA_PIN_1201								(0xF&0xC)//0xB8000CB0[7:4];
#else
#define BGA_PIN_1201								(0xF&0xF)//0xB8000CB0[7:4];
#endif

																//C: PIF_TX8P,<AO>
																//F: MIS_GPI_bit14,<I>
																//def: PIF_TX8P,<AO>


// PAD_NAME: pif_tx8n_33v_apad 1202 BALL NUM: B18
#if defined(CONFIG_TCONLESS_BOE_CEDS) || defined(Config_Panel_Type_FHD)
#define BGA_PIN_1202								(0xF&0xC)//0xB8000CB0[3:0];
#else
#define BGA_PIN_1202								(0xF&0xF)//0xB8000CB0[3:0];
#endif
																//C: PIF_TX8N,<AO>
																//F: MIS_GPI_bit15,<I>
																//def: PIF_TX8N,<AO>


// PAD_NAME: pif_tx7p_33v_apad 1216 BALL NUM: B17
#define BGA_PIN_1216								(0xF&0xC)//0xB8000CB4[31:28];
																//C: PIF_TX7P,<AO>
																//F: MIS_GPI_bit16,<I>
																//def: PIF_TX7P,<AO>


// PAD_NAME: pif_tx7n_33v_apad 1217 BALL NUM: C16
#define BGA_PIN_1217								(0xF&0xC)//0xB8000CB4[27:24];
																//C: PIF_TX7N,<AO>
																//F: MIS_GPI_bit17,<I>
																//def: PIF_TX7N,<AO>


// PAD_NAME: pif_tx6p_33v_apad 1218 BALL NUM: A16
#define BGA_PIN_1218								(0xF&0xC)//0xB8000CB4[23:20];
																//C: PIF_TX6P,<AO>
																//F: MIS_GPI_bit18,<I>
																//def: PIF_TX6P,<AO>


// PAD_NAME: pif_tx6n_33v_apad 1219 BALL NUM: C15
#define BGA_PIN_1219								(0xF&0xC)//0xB8000CB4[19:16];
																//C: PIF_TX6N,<AO>
																//F: MIS_GPI_bit19,<I>
																//def: PIF_TX6N,<AO>


// PAD_NAME: pif_tx5p_33v_apad 1220 BALL NUM: B15
#define BGA_PIN_1220								(0xF&0xC)//0xB8000CB4[15:12];
																//C: PIF_TX5P,<AO>
																//F: MIS_GPI_bit20,<I>
																//def: PIF_TX5P,<AO>


// PAD_NAME: pif_tx5n_33v_apad 1221 BALL NUM: C14
#define BGA_PIN_1221								(0xF&0xC)//0xB8000CB4[11:8];
																//C: PIF_TX5N,<AO>
																//F: MIS_GPI_bit21,<I>
																//def: PIF_TX5N,<AO>


// PAD_NAME: pif_tx4p_33v_apad 1224 BALL NUM: C13
#define BGA_PIN_1224								(0xF&0xC)//0xB8000CB4[7:4];
																//C: PIF_TX4P,<AO>
																//F: MIS_GPI_bit22,<I>
																//def: PIF_TX4P,<AO>


// PAD_NAME: pif_tx4n_33v_apad 1225 BALL NUM: B13
#define BGA_PIN_1225								(0xF&0xC)//0xB8000CB4[3:0];
																//C: PIF_TX4N,<AO>
																//F: MIS_GPI_bit23,<I>
																//def: PIF_TX4N,<AO>


// PAD_NAME: pif_tx3p_33v_apad 1226 BALL NUM: C12
#define BGA_PIN_1226								(0xF&0xC)//0xB8000CB8[31:28];
																//C: PIF_TX3P,<AO>
																//F: MIS_GPI_bit24,<I>
																//def: PIF_TX3P,<AO>


// PAD_NAME: pif_tx3n_33v_apad 1227 BALL NUM: A12
#define BGA_PIN_1227								(0xF&0xC)//0xB8000CB8[27:24];
																//C: PIF_TX3N,<AO>
																//F: MIS_GPI_bit25,<I>
																//def: PIF_TX3N,<AO>


// PAD_NAME: pif_tx2p_33v_apad 1228 BALL NUM: C11
#define BGA_PIN_1228								(0xF&0xC)//0xB8000CB8[23:20];
																//C: PIF_TX2P,<AO>
																//F: MIS_GPI_bit26,<I>
																//def: PIF_TX2P,<AO>


// PAD_NAME: pif_tx2n_33v_apad 1229 BALL NUM: B11
#define BGA_PIN_1229								(0xF&0xC)//0xB8000CB8[19:16];
																//C: PIF_TX2N,<AO>
																//F: MIS_GPI_bit27,<I>
																//def: PIF_TX2N,<AO>


// PAD_NAME: pif_tx1p_15v_apad 1232 BALL NUM: B10
#define BGA_PIN_1232								(0xF&0xC)//0xB8000CB8[15:12];
																//C: PIF_TX1P,<AO>
																//F: MIS_GPI_bit28,<I>
																//def: PIF_TX1P,<AO>


// PAD_NAME: pif_tx1n_15v_apad 1233 BALL NUM: A10
#define BGA_PIN_1233								(0xF&0xC)//0xB8000CB8[11:8];
																//C: PIF_TX1N,<AO>
																//F: MIS_GPI_bit29,<I>
																//def: PIF_TX1N,<AO>


// PAD_NAME: pif_tx0p_15v_apad 1234 BALL NUM: A9
#define BGA_PIN_1234								(0xF&0xC)//0xB8000CB8[7:4];
																//C: PIF_TX0P,<AO>
																//F: MIS_GPI_bit30,<I>
																//def: PIF_TX0P,<AO>


// PAD_NAME: pif_tx0n_15v_apad 1235 BALL NUM: B9
#define BGA_PIN_1235								(0xF&0xC)//0xB8000CB8[3:0];
																//C: PIF_TX0N,<AO>
																//F: MIS_GPI_bit31,<I>
																//def: PIF_TX0N,<AO>


// PAD_NAME: PAD_GPIO_18_IO 1263 BALL NUM: E12
#define BGA_PIN_1263								(0xF&0xF)//0xB8000810[15:12];
																//0: SPI_FCIC_DO_src0,<I/O>
																//2: SPI_CS_N,<O>,<HS>
																//3: ld_spi0_p3_sdo_src0,<I/O>
																//4: TCON_bit15,<O>
																//5: TCON_bit16,<O>
																//6: TCON_bit17,<O>
																//7: TCON_bit18,<O>
																//9: TP2_SYNC_src4,<I>,<HS>
																//B: I2C4_SDA_src1,<I/O>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit18,<I/O>
																//def: MIS_GPIO_bit18,<I/O>
#define BGA_PIN_1263_UP							(0&0x01)// 0xB8000810[11]: Pull Up 0:disable 1:enable
#define BGA_PIN_1263_PD							(0&0x01)// 0xB8000810[10]: Pull Down 0:disable 1:enable
#define BGA_PIN_1263_DS							(0&0x01)// 0xB8000810[9]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_1263_SR							(0&0x01)// 0xB8000810[8]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_100_io 1279 BALL NUM: AB24
#define BGA_PIN_1279								(0xF&0xF)//0xB800087C[23:20];
																//1: PCMCIA_ADDR_bit8,<OD>,<HS>
																//D: misc_pwm_6,<OD>
																//E: test_en_bit18,<I/O>
																//F: MIS_GPIO_bit100,<I/O>
																//def: MIS_GPIO_bit100,<I/O>
#define BGA_PIN_1279_UP							(0&0x01)// 0xB800087C[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_1279_PD							(0&0x01)// 0xB800087C[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_1279_DS							(0&0x01)// 0xB800087C[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_1279_SR							(0&0x01)// 0xB800087C[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_104_io 1280 BALL NUM: Y24
#define BGA_PIN_1280								(0xF&0xF)//0xB8000880[23:20];
																//0: PCMCIA_CE0_1,<O>,<HS>
																//1: PCMCIA_ADDR_bit14,<OD>,<HS>
																//8: SC_RST,<OD>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit104,<I/O>
																//def: MIS_GPIO_bit104,<I/O>
#define BGA_PIN_1280_UP							(0&0x01)// 0xB8000880[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_1280_PD							(0&0x01)// 0xB8000880[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_1280_DS							(0&0x01)// 0xB8000880[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_1280_SR							(0&0x01)// 0xB8000880[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_108_io 1281 BALL NUM: V22
#define BGA_PIN_1281								(0xF&0xF)//0xB8000884[23:20];
																//1: PCMCIA_IREQ0_N,<I>,<HS>
																//3: TCON_bit3,<O>
																//4: TCON_bit4,<O>
																//5: TCON_bit5,<O>
																//6: TCON_bit21,<O>
																//7: ld_spi0_p2_sck_src2,<I/O>
																//D: misc_pwm_6,<OD>
																//E: test_en_bit20,<I/O>
																//F: MIS_GPIO_bit108,<I/O>
																//def: MIS_GPIO_bit108,<I/O>
#define BGA_PIN_1281_UP							(0&0x01)// 0xB8000884[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_1281_PD							(0&0x01)// 0xB8000884[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_1281_DS							(0&0x01)// 0xB8000884[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_1281_SR							(0&0x01)// 0xB8000884[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_112_io 1282 BALL NUM: U23
#define BGA_PIN_1282								(0xF&0xF)//0xB8000888[23:20];
																//1: TPO_clk_pad,<O>,<HS>
																//3: TCON_bit11,<O>
																//4: TCON_bit12,<O>
																//5: TCON_bit13,<O>
																//6: TCON_bit27,<O>
																//7: ld_spi0_p6_h_sync,<O>
																//D: misc_pwm_2,<OD>
																//F: MIS_GPIO_bit112,<I/O>
																//def: MIS_GPIO_bit112,<I/O>
#define BGA_PIN_1282_UP							(0&0x01)// 0xB8000888[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_1282_PD							(0&0x01)// 0xB8000888[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_1282_DS							(0&0x01)// 0xB8000888[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_1282_SR							(0&0x01)// 0xB8000888[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_84_io 1283 BALL NUM: AA19
#define BGA_PIN_1283								(0xF&0xF)//0xB800086C[23:20];
																//1: PCMCIA_D_bit4,<I/O>,<HS>
																//3: TCON_bit3,<O>
																//4: TCON_bit4,<O>
																//5: TCON_bit5,<O>
																//6: TCON_bit21,<O>
																//D: misc_pwm_6,<OD>
																//E: test_en_bit7,<I/O>
																//F: MIS_GPIO_bit84,<I/O>
																//def: MIS_GPIO_bit84,<I/O>
#define BGA_PIN_1283_UP							(0&0x01)// 0xB800086C[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_1283_PD							(0&0x01)// 0xB800086C[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_1283_DS							(0&0x01)// 0xB800086C[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_1283_SR							(0&0x01)// 0xB800086C[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_88_io 1284 BALL NUM: AB20
#define BGA_PIN_1284								(0xF&0xF)//0xB8000870[23:20];
																//1: PCMCIA_D_bit6,<I/O>,<HS>
																//3: TCON_bit11,<O>
																//4: TCON_bit12,<O>
																//5: TCON_bit13,<O>
																//6: TCON_bit27,<O>
																//D: misc_pwm_2,<OD>
																//E: test_en_bit9,<I/O>
																//F: MIS_GPIO_bit88,<I/O>
																//def: MIS_GPIO_bit88,<I/O>
#define BGA_PIN_1284_UP							(0&0x01)// 0xB8000870[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_1284_PD							(0&0x01)// 0xB8000870[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_1284_DS							(0&0x01)// 0xB8000870[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_1284_SR							(0&0x01)// 0xB8000870[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_92_io 1285 BALL NUM: AC21
#define BGA_PIN_1285								(0xF&0xF)//0xB8000874[23:20];
																//1: PCMCIA_CE0_0,<O>,<HS>
																//3: TCON_bit19,<O>
																//4: TCON_bit20,<O>
																//5: TCON_bit21,<O>
																//6: TCON_bit27,<O>
																//D: misc_pwm_6,<OD>
																//E: test_en_bit11,<I/O>
																//F: MIS_GPIO_bit92,<I/O>
																//def: MIS_GPIO_bit92,<I/O>
#define BGA_PIN_1285_UP							(0&0x01)// 0xB8000874[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_1285_PD							(0&0x01)// 0xB8000874[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_1285_DS							(0&0x01)// 0xB8000874[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_1285_SR							(0&0x01)// 0xB8000874[16]: Slew rate 0:fast 1:slow


// PAD_NAME: pad_gpio_96_io 1286 BALL NUM: AA23
#define BGA_PIN_1286								(0xF&0xF)//0xB8000878[23:20];
																//1: PCMCIA_ADDR_bit11,<OD>,<HS>
																//3: TCON_bit27,<O>
																//4: TCON_bit26,<O>
																//5: TCON_bit1,<O>
																//6: TCON_bit0,<O>
																//D: misc_pwm_2,<OD>
																//E: test_en_bit15,<I/O>
																//F: MIS_GPIO_bit96,<I/O>
																//def: MIS_GPIO_bit96,<I/O>
#define BGA_PIN_1286_UP							(0&0x01)// 0xB8000878[19]: Pull Up 0:disable 1:enable
#define BGA_PIN_1286_PD							(0&0x01)// 0xB8000878[18]: Pull Down 0:disable 1:enable
#define BGA_PIN_1286_DS							(0&0x01)// 0xB8000878[17]: Driving Strength 0:4mA 1:8mA
#define BGA_PIN_1286_SR							(0&0x01)// 0xB8000878[16]: Slew rate 0:fast 1:slow


//////////////////////////////////////////////////////////////////////////////
//
//  Define all PIN below !!!
//
//////////////////////////////////////////////////////////////////////////////
/*******************************************************************
 * Param : HDMI_PORT_ORDER
 *
 * Desc  : This parameter is used to specified config of the specified
 *     HDMI channel(e.g. UI channel)
 * Format : HDMI4_CH_SEL(x) : port config of HDMI4
 *          HDMI3_CH_SEL(x) : port_config of HDMI3
 *          HDMI2_CH_SEL(x) : port_config of HDMI2
 *          HDMI1_CH_SEL(x) : port_config of HDMI1
 *
 * Example : HDMI_PORT_ORDER = HDMI4_CH_SEL(1) | HDMI3_CH_SEL(2) | HDMI2_CH_SEL(3) | HDMI1_CH_SEL(4)
 *          HDMI CH1 = HDMI PORT4(HDMI4_CFG)
 *          HDMI CH2 = HDMI PORT3(HDMI3_CFG)
 *          HDMI CH3 = HDMI PORT2(HDMI2_CFG)
 *          HDMI CH4 = HDMI PORT1(HDMI1_CFG)
 *******************************************************************/
#define HDMI_PORT_ORDER		(HDMI3_CH_SEL(1) | HDMI2_CH_SEL(4) | HDMI1_CH_SEL(3))

/*******************************************************************
 * Param : HDMI_FLOW_CFG0
 *
 * Desc  : This parameter is used to specified config of HDMI Driver flow.
 *		It is critical parameter for compatible with device. It should made performance changing of detection flow.
 *
 * Format : HDMI_FLOW_CFG0_VLILD(x)	: Valid (0: not support, 1: support.)
 *          HDMI_STABLE_CNT_THD(x)	: clock stable count threshold (0~255)
 *          HDMI_MEAS_ERR_CNT_THD(x)	: Measure Fail Count Threshold(0~255)
 *          HDMI_TMDS_CLK_TOL_MIN(x)	: Minimum of TMDS clock tolerance (0~15)
 *
 *******************************************************************/
#define HDMI_FLOW_CFG0	(HDMI_TMDS_CLK_TOL_MIN(5) | HDMI_MEAS_ERR_CNT_THD(6) | HDMI_STABLE_CNT_THD(8) | HDMI_FLOW_CFG0_VAILD(1))

/*******************************************************************
 * Param	: HDMI_FLOW_CFG1
 *
 * Desc		: This parameter is used to specified config of HDMI Driver flow.
 *			It is critical parameter for compatible with device.
 *			HPD duration time..
 *
 * Format	: HDMI_FLOW_CFG1_VAILD(x)	: Valid (0: not support, 1: support.)
 *		  HDMI_DEF_HPD_LOW_10MS(x)	: (0~255, Real is 0~255 ms HPD For EDID Change)
 *		  HDMI_DEF_STR_HPD_LOW_10MS(x)	: (0~255, Real is 0~255 ms HPD For DC OFFON STR ReSume.)
 *******************************************************************/
#define HDMI_FLOW_CFG1	(HDMI_DEF_STR_HPD_LOW_10MS(31) | HDMI_DEF_HPD_LOW_10MS(70) | HDMI_FLOW_CFG1_VAILD(1))

/*******************************************************************
 * Param : HDMIx_CFG
 *
 * Desc  : This parameter is used to specified config of a physical
 *         HDMI Port. where x could be 1~4
 *
 * Format : HDMI_PHY(x)    :phy id(0~3)
 *          HDMI_DDC(x)    :DDC channel id(0~3)
 *          HDMI_SUPPORT_ARC(x) : Support ARC or not(0: not support, 1: support)
 *
 *          DEDICATE_HPD_DET : use dedicate hpd/det gpio
 *          DEDICATE_HPD_DET_SEL(x) : dedicate hpd/det channel select(valid when DEDICATE_HPD_DET present)
 *
 *----------- the following setting are valid only when DEDICATE_HPD_DET absents----------------
 *
 *          DET_GPIO_TYPE(x) : gpio type of 5V-DET pin (0:MISC, 1:ISO)
 *          DET_GPIO_ID(x)   : gpio id of 5V-DET pin
 *          HPD_GPIO_TYPE(x) : gpio type of hpd pin (0:MISC, 1:ISO)
 *          HPD_GPIO_ID(x)   : gpio id of hpd pin
 *
 *******************************************************************/
#define HDMI1_CFG       (HDMI_PHY(0) | HDMI_DDC(2) | HDMI_SUPPORT_ARC(1) | HDMI_SUPPORT_EARC(1) | BRSWAP(0) | DEDICATE_HPD_DET | DEDICATE_HPD_DET_SEL(2))
#define HDMI2_CFG       (HDMI_PHY(1) | HDMI_DDC(3) | HDMI_SUPPORT_ARC(0) | HDMI_SUPPORT_EARC(0) | BRSWAP(0) | DEDICATE_HPD_DET | DEDICATE_HPD_DET_SEL(3))
#define HDMI3_CFG       (HDMI_PHY(2) | HDMI_DDC(0) | HDMI_SUPPORT_ARC(0) | HDMI_SUPPORT_EARC(0) | BRSWAP(0) | DEDICATE_HPD_DET | DEDICATE_HPD_DET_SEL(0))
#define HDMI4_CFG       (HDMI_PHY(3) | HDMI_DDC(1) | HDMI_SUPPORT_ARC(0) | HDMI_SUPPORT_EARC(0) | BRSWAP(0) | DEDICATE_HPD_DET | DEDICATE_HPD_DET_SEL(1))

/*******************************************************************
 * ARC_CFG
 *******************************************************************
 D3:2     : default status  (0: default off, 1: default on, 2:default by pass this pinmux)
 D1:0     : ARC SPDIF Channel(now just use channel 1)
          0 : SPDIF_OUT
          1 : SPDIF_OUT_1 (ARC/ST_GPIO22)
 ****************************************/
#define ARC_CFG		0x00000000

/*******************************************************************
 * Z0 CFG
 *******************************************************************/
#define HDMI_EXT_Z0_CFG	0x05050505	//PCB TRACE Z0 (unit: ohm) ex: 5ohm 0x05050505

////////////////////////////////////////////////////////////////////////////////////////////
//
//                      I2C Parameters Definitions as below !!!
//
///////////////////////////////////////////////////////////////////////////////////////////
#define I2C_PORT_0	PCB_HW_I2C(PCB_I2C_PHY_0, PCB_I2C_SUB_SRC_0) // AB4/AA6	tuner I2C0 SDA/SCL for FFM model
#define I2C_PORT_1	PCB_HW_I2C(PCB_I2C_PHY_4, PCB_I2C_SUB_SRC_0) // M5/M4	AMP	I2C4 SDA/SCL
#define I2C_PORT_2	PCB_HW_I2C(PCB_I2C_PHY_3, PCB_I2C_SUB_SRC_0) // A7/B7	TCON	I2C3 SDA/SCL
#define I2C_PORT_3	PCB_HW_I2C(PCB_I2C_PHY_1, PCB_I2C_SUB_SRC_0) // AC7/AA8	theral sensor	I2C1 SDA/SCL

#define I2C_PORT_UNUSED	PCB_HW_I2C(PCB_I2C_PHY_UNUSED, PCB_I2C_SUB_SRC_ANY) //i2c unuseds

//TUNER_I2C
#define TUNER_I2C	PCB_I2C_0

// AMP
#define AMP_I2C		PCB_I2C_1
#define PIN_AMP_MUTE    BGA_PIN_158_GPO_56(0, 0) //X_AUDIO_MUTE1@sony_pcb;
#define PIN_AMP_RESET	PIN_AMP_MUTE			// 0:unmute, 1:mute
#define AMP_DEVICE_ADDR	(0x1B<<1)                            	//REALTEK TAS5707
#define AMP_BOOTCODE_USE_THIS_I2C_PHY 		PCB_I2C_PHY_4
//#define AMP_BOOTCODE_USE_THIS_I2C_ADDRESS	(0x1B)
#define AMP_BOOTCODE_USE_THIS_I2C_ADDRESS 	(0x1A)
#define AMP_AD82010_ADDRESS		  	(0x34)
#define AMP_TAS5751_ADDRESS			(0x2B)
#define AMP_TAS5707_ADDRESS			(0x1B)
#define AMP_TAS5711_ADDRESS			(0x1A)
#define AMP_ALC1312_ADDRESS			(0x2A)
#define AMP_RT9119_ADDRESS			(0x1A)

//TCON
#define TCON_I2C				PCB_I2C_2

//theral sensor
#define SENSOR_I2C				PCB_I2C_3

//--------------------------------------------------------------------------------
// PCMCIA PCB Parameters
//--------------------------------------------------------------------------------

/**************************PCMCIA_CFG format**************************************
 * D63		: skip pcmcia timming configuration (0: set up pcmcia bus timing in driver, 1: don't set up pcmcia timing config in the driver)
 * D62:32	: reserved
 * D31:25	: pcmcia_cd0			(card detection for PCMCIA0)
 * D24		: ce1/ce2 swap			(0: no swap ce1/ce2, 1: swap ce1/ce2)
 * D23		: pcmcia1_enable		(0: don't enable pcmcia1, enable pcmcia1)
 * D22		: pcmcia1_pwr_en_valid		(0: no power_enable_gpio, 1: with power_enable_gpio)
 * D21		: pcmcia1_pwr_en_polarity	(0: negative, 1: postive)
 * D20		: pcmcia1_pwr_en_gpio_type	(0: MISC, 1:ISO)
 * D19		: pcmcia0_enable		(0: don't enable pcmcia1, enable pcmcia1)
 * D18		: pcmcia0_pwr_en_valid		(0: no power_enable_gpio, 1: with power_enable_gpio)
 * D17		: pcmcia0_pwr_en_polarity	(0: negative, 1: positive)
 * D16		: pcmcia0_pwr_en_gpio_type	(0: MISC, 1:ISO)
 * D15:8	: pcmcia1_pwr_en_gpio		(power_enable_gpio for PCMCIA1)
 * D7:0		: pcmcia0_pwr_en_gpio		(power_enable_gpio for PCMCIA0)
 ******************************************************************************/
#define PCMCIA_CFG 0x00080000

/*********************PCMCIA_CFG2 format****************************************
 * D63:0	: reserved
 ******************************************************************************/
#define PCMCIA_CFG2	0x00000000	// for GPIO mode IREQ#

/*********************PCMCIA CFG3 format****************************************
 * D63:6	: reserved
 * D5-3		: pcmcia_reset_pluse_width	(0x001: 114us, 0x010:1ms, 0x011:2ms, 0x100:20ms)
 * D2		: pcmcia_reset_without_ireq_check_en	(0: sw mode, 1:hw mode)
 * D1		: pcmcia_auto_pin_share_mode		(0: sw mode, 1:hw mode)
 * D0		: pcmcia_auto_pin_share_en		(0: disable, 1:enable)
 ******************************************************************************/
#define PCMCIA_CFG3	0x00000003

#define SC0_CFG		(PWR_SEL_GPIO_ID(0) | PWR_SEL_GPIO_TYPE_MISC | PWR_SEL_POLARITY_P | PWR_SEL_EN(1) | \
		CMD_VCC_GPIO_ID(72) | CMD_VCC_GPIO_TYPE_MISC | CMD_VCC_POLARITY_N | CMD_VCC_EN(1))

// MISC
//#define PIN_CORE_VID_0		RTD288O_BGA_PIN_F26_GPO_153(0, 1)
//#define PIN_SCPU_VID_0		RTD288O_BGA_PIN_W4_GPO_57(0, 0)
//#define PIN_SCPU_VID_1		RTD288O_BGA_PIN_Y6_GPO_58(0, 1)
#define PIN_CORE_VID_0	(0)
#define PIN_SCPU_VID_0	(0)
#define PIN_SCPU_VID_1	(0)

// Jack Detection(Same as PIN_HP_DET)
//#define PIN_HP_OUT_JD		RTD288O_BGA_PIN_W6_GPI_78(0)
#define PIN_HP_OUT_JD		BGA_PIN_354_GPI_71(1)
#define PIN_HP_DET              BGA_PIN_354_GPI_71(1) //ref. to PIN_HP_OUT_JD

// USB
//#define PIN_USB_5V_EN		RTD288O_BGA_PIN_N25_ISO_GPO_55(0, 1)
#define USB_CONNECTOR_MAP	\
	(USB_CONNECTOR_N_MAP(1, 1, 1, 0) | \
	 USB_CONNECTOR_N_MAP(2, 1, 2, 0) | \
	 USB_CONNECTOR_N_MAP(3, 1, 2, 1) | \
	 USB_CONNECTOR_N_MAP(4, 2, 1, 0))

//for USB Z0 auto parse ***
#define Z0_XHCI_P1          (0x27)    //prot1 = 2.7R
#define Z0_XHCI_P2          (0x27)    //prot2 = 2.7R
#define Z0_XHCI_P3          (0x00)    //prot3 = none
#define Z0_XHCI_P4          (0x00)    //prot4 = none
#define Z0_EHCI_P1          (0x27)    //prot1 = 2.7R
#define Z0_EHCI_P2          (0x27)    //prot2 = 2.7R
#define Z0_EHCI_P3          (0x00)    //prot3 = none
#define Z0_EHCI_P4          (0x00)    //prot4 = none
#define Z0_XHCI_VALUE       ((Z0_XHCI_P4<<24)|(Z0_XHCI_P3<<16)|(Z0_XHCI_P2<<8)|Z0_XHCI_P1)
#define Z0_EHCI_VALUE       ((Z0_EHCI_P4<<24)|(Z0_EHCI_P3<<16)|(Z0_EHCI_P2<<8)|Z0_EHCI_P1)
//for USB Z0 auto parse &&&

//LED PWM
//#define BGA_PIN_570	(0xF&0xD)//0xB8060200[19:16]; //F: ISO_MIS_GPIO_bit15,<I/O>
#define PIN_PWM_LED_TALLY           BGA_PIN_570_ISO_PWM_0(0, 20000, 255, 0) //TALLY_LED
#define PIN_PWM_LED_TALLY_GPIO_INFO   PCB_PINMUX_GPIO_INFO(0xB8060200, 16, 19, 0xD, 0xF, PCB_PIN_TYPE_GPIO, 1, 15)
//#define BGA_PIN_617	(0xF&0xc)//0xB806020C[31:28]; ISO_MIS_GPIO_bit04,<I/O>
#define PIN_PWM_LED_R               BGA_PIN_617_ISO_PWM_2(0, 20000, 255, 0) //LED_R
#define PIN_PWM_LED_R_GPIO_INFO     PCB_PINMUX_GPIO_INFO(0xB806020C, 28, 31, 0xc, 0xF, PCB_PIN_TYPE_GPIO, 1, 4)
//#define BGA_PIN_587	(0xF&0xD)//0xB8060210[7:4]; ISO_MIS_GPIO_bit11,<I/O>
#define PIN_PWM_LED_G               BGA_PIN_587_ISO_PWM_1(0, 20000, 255, 0) //LED_G
#define PIN_PWM_LED_G_GPIO_INFO     PCB_PINMUX_GPIO_INFO(0xB8060210, 4, 7, 0xD, 0xF, PCB_PIN_TYPE_GPIO, 1, 11)
//#define BGA_PIN_600		(0xF&0xC)//0xB8060208[23:20]; ISO_MIS_GPIO_bit01,<I/O>
#define PIN_PWM_LED_B               BGA_PIN_600_ISO_PWM_3(0, 20000, 255, 0) //LED_B
#define PIN_PWM_LED_B_GPIO_INFO     PCB_PINMUX_GPIO_INFO(0xB8060208, 20, 23, 0xC, 0xF, PCB_PIN_TYPE_GPIO, 1, 1)

// Panel (PWM Dimmer)
#define PIN_BL_ON_OFF		BGA_PIN_366_GPO_67(0, 0)
#define PIN_BL_ADJ              (BGA_PIN_360_PWM_3(0, 20000, 255, 0)|SET_PWM_CLK_SRC(PCB_PWM_D_CLK_DIV4)) //PWM1_DIMMER@sony_pcb;
#define PIN_PWM0_DIMMER         (BGA_PIN_368_PWM_1(0, 120, 255, 0)|SET_PWM_CLK_SRC(PCB_PWM_D_CLK_DIV4))
#define PIN_PWM0_DIMMER_GPIO_INFO   PCB_PINMUX_GPIO_INFO(0xB8000808, 12, 15, 0xD, 0xF, PCB_PIN_TYPE_GPIO, 1, 10)
#define PIN_PWM2_DIMMER         (BGA_PIN_358_PWM_4(0, 20000, 255, 0)|SET_PWM_CLK_SRC(PCB_PWM_D_CLK_DIV4))
#define PIN_PWM2_DIMMER_GPIO_INFO   PCB_PINMUX_GPIO_INFO(0xB800080C, 28, 31, 0xD, 0xF, PCB_PIN_TYPE_GPIO, 1, 12)
#define PIN_DC_DIMMER_IP_REF    (BGA_PIN_352_PWM_7(0, 30100, 255, 0)|SET_PWM_CLK_SRC(PCB_PWM_D_CLK_DIV4))
#define PIN_LVDS_ON_OFF         BGA_PIN_17_GPO_29(0, 0) //PANEL_PWR@sony_pcb; 0:Disable Tcon Power, 1:Enable Tcon Power
//KeyPad
#define PIN_KEYPAD_PWR       	BGA_PIN_610_ISO_GPI_39(0) | ((unsigned long long)KEY_CODE_ONEKEY << 48)
/* irda wakeup key */
#define PIN_IRDA_UKEY_0		PCB_EMCU_IR_Key(KEY_POWER, 0, 0, 0, 0, 0) // power key

// HDMI-MHL select
//FIXME

//Input Source number Settings
//#define INPUT_HDMI		4
//#define INPUT_AV		1
//#define INPUT_USB		4
//#define INPUT_COMPONENT	1
//#define INPUT_VGA		1
#define INPUT_HDMI              3
#define INPUT_AV                1
#define INPUT_USB               3

//Audio Input Settings
#define AV1_AUDIO_PATH		AUDIO_BBADC_SRC_AIN1
//#define YPP1_AUDIO_PATH	AUDIO_BBADC_SRC_AIN1

//Video Input Setting
#define AV1_PATH		VIDEO_INPUT10
#define AV1_PATH_GROUND		VIDEO_GNDA0
//#define AV2_PATH		VIDEO_INPUT4
//#define AV2_PATH_GROUND	VIDEO_Y0N
//#define SCART1_PATH_Y		VIDEO_INPUT13
//#define SCART1_PATH_R		VIDEO_INPUT2
//#define SCART1_PATH_G		VIDEO_INPUT1
//#define SCART1_PATH_B		VIDEO_INPUT0
//#define SCART1_PATH_GROUND	VIDEO_GNDA0

//#define YPP1_DATA		ADC_DATA_INPUT1
//#define YPP1_SOY_MUX		ADC_SOY_MUX_VIN4P
//#define YPP1_SWAP_RGB		ADC_SWAP_RGB

#ifdef ENABLE_PCB_AUDIO_OUTPUT_TYPE
#define AUDIO_OUTPUT_AIO1		PCB_AUDIO_OUPUT_TYPE_DAC0
#define AUDIO_OUTPUT_AIO2		PCB_AUDIO_OUPUT_TYPE_DAC1
#define AUDIO_OUTPUT_HEADPHONE		PCB_AUDIO_OUPUT_TYPE_DAC0

#define ENABLE_DAC
#ifdef ENABLE_DAC
#define DAC0_SRC	DAC_SOURCE_PB_AF_AVC2_CH23
#define DAC1_SRC	DAC_SOURCE_PB_AF_AVC2_CH45
#endif
#endif

#define TP_SRC_INTERNAL_DEMOD	TP_SRC_INTERNAL_DEMOD_SET(TP_SRC_INTERNAL)
#define TP_SRC_EXTERNAL_TUNER0	TP_SRC_EXTERNAL_TUNER0_SET(TP_SRC_2)
#define TP_SRC_EXTERNAL_TUNER1	TP_SRC_EXTERNAL_TUNER1_SET(TP_SRC_UNUSED)
#define TP_SRC_EXTERNAL_CAM0	TP_SRC_EXTERNAL_CAM0_SET(TP_SRC_1)
#define TP_SRC_EXTERNAL_CAM1	TP_SRC_EXTERNAL_CAM1_SET(TP_SRC_UNUSED)

#define TP_SRC	(TP_SRC_INTERNAL_DEMOD | TP_SRC_EXTERNAL_TUNER0 | TP_SRC_EXTERNAL_CAM0 | TP_SRC_EXTERNAL_TUNER1 | TP_SRC_EXTERNAL_CAM1)

/*****************Demod related pin*************************************
* PIN_DEMOD_RESET pcb name: LNB_ENABLE
* PIN_LNB_HV      pcb name: H/V_13V/18V
************************************************************************/
//#define PIN_DEMOD_RESET	RTD288O_BGA_PIN_AA6_ISO_GPO_8(0, 1) //default high
//#define PIN_LNB_HV	RTD288O_BGA_PIN_AB8_GPO_63(0, 0)    //default low

//mic
#define PIN_DMIC_DET			BGA_PIN_599_ISO_GPI_0(0)

//TV002 only
#define PIN_POWER_DETECT      	BGA_PIN_567_LSADC_VOLTAGE_2(0xdf, 0x20) | LSADC_INTERRUPT(ADC_THREDHOLD_MODE) | LSADC_INTERRUPT_TREDHOLD(0x01)
//#define PIN_TU_ID		BGA_PIN_568_LSADC_VOLTAGE_4(0x80,0x7F)
#define PIN_WIFI_HOST_RESET     BGA_PIN_635_ISO_GPO_28(0, 1)
#define PIN_WOWLAN              BGA_PIN_604_ISO_GPI_46(0)
#define PIN_NET_PWR_SHTDWN      BGA_PIN_634_ISO_GPO_27(0, 0)	//add for CVT
#define PIN_DC_MON_SOC          BGA_PIN_614_ISO_GPI_44(0)
//#define PIN_EN_V_STBY           BGA_PIN_616_ISO_GPO_41(0, 0)
#define PIN_USB_EN_P1           BGA_PIN_623_ISO_GPO_55(0, 0)
#define PIN_USB_EN_P0           BGA_PIN_618_ISO_GPO_50(0, 0)
//#define PIN_TUNER_WAKEUP        BGA_PIN_581_ISO_GPI_42(0) 	//Reserved
//#define PIN_EWS_PWR             BGA_PIN_589_ISO_GPO_59(0, 1) 	//Reserved
#define PIN_TU_DET              BGA_PIN_585_ISO_GPI_53(0)
//#define PIN_DEMOD_RST_STBY      BGA_PIN_580_ISO_GPO_5(0, 0)
#define PIN_BL_ERR              BGA_PIN_613_ISO_GPI_48(0)
#define PIN_POWER_EN		BGA_PIN_611_ISO_GPO_43(0,0)
#define PIN_EMMC_PWR_CTRL       BGA_PIN_621_ISO_GPO_51(0, 1) 	//BOOT_MODE
#define PIN_CVBS_IN_DET     	BGA_PIN_136_GPI_45(0)
#define PIN_X_AUDIO_MUTE2       BGA_PIN_119_GPO_36(0, 0)
//#define PIN_X_AUDIO_MUTE1       BGA_PIN_158_GPO_56(0, 0) //ref. to PIN_AMP_MUTE
#define PIN_X_AUDIO_RST_SOC     BGA_PIN_37_GPO_15(0, 0)
#define PIN_X_AUDIO_MON1        BGA_PIN_324_GPI_57(0)
#define PIN_PANEL_LESS      	BGA_PIN_135_GPI_44(0)
#define PIN_PANEL_B_INT         BGA_PIN_23_GPO_23(0, 0)
#define PIN_USB_OCP_P0          BGA_PIN_615_ISO_GPI_38(0)
#define PIN_USB_OCP_P1          BGA_PIN_629_ISO_GPI_57(0)
//#define PIN_USB_OCP_P2          BGA_PIN_717_GPI_130(0)
#define PIN_LEDS_0              BGA_PIN_356_GPO_70(0,0)    //White LED
#define PIN_LED_IR              PIN_LEDS_0
#define PIN_LEDS_1              BGA_PIN_628_ISO_GPO_40(0,0) //LED_R


//#define PIN_CI_EN	        BGA_PIN_620_ISO_GPO_49(0,0)
//#define PIN_CI_OCP	        BGA_PIN_606_ISO_GPI_47(0)
#define PIN_LIGHT_SENSOR        BGA_PIN_566_LSADC_VOLTAGE_1(0x80,0x7F)
//#define PIN_FBFFC_TOP   	BGA_PIN_131_GPI_40(0)
//#define PIN_FBFFC_BOTTOM    	BGA_PIN_133_GPI_42(0)
//#define PIN_TCONLESS_SEL   	BGA_PIN_11_GPI_1(0)
//#define PIN_TRDY		BGA_PIN_7_GPO_3(0,1)
#define PIN_TCONLESS_FAULT	BGA_PIN_35_GPI_13(0)
#define PIN_C4_DISABLE		BGA_PIN_374_GPO_80(0,0)
#define PIN_2K4K_DET		BGA_PIN_586_ISO_GPI_45(0)
#define PIN_HOTEL_CTRL		BGA_PIN_326_GPO_58(0,0)
#define PIN_PANEL_DET0		BGA_PIN_32_GPI_9(0)
#define PIN_PANEL_DET1		BGA_PIN_30_GPI_10(0)
/////////////////////////////////////////////////////////////////////////
//
//   Enumerate all PCB staff below !!!
//
/////////////////////////////////////////////////////////////////////////
PCB_ENUM_START()
PCB_ENUM(PIN_BL_ON_OFF)
PCB_ENUM(PIN_BL_ADJ)
//PCB_ENUM(PIN_BL_ADJ_GPIO_INFO)
PCB_ENUM(PIN_LVDS_ON_OFF)

PCB_ENUM(HDMI_PORT_ORDER)
PCB_ENUM(HDMI_FLOW_CFG0)
PCB_ENUM(HDMI_FLOW_CFG1)
PCB_ENUM(HDMI1_CFG)
//PCB_ENUM(HDMI2_CFG)
PCB_ENUM(HDMI3_CFG)
PCB_ENUM(HDMI4_CFG)
PCB_ENUM(ARC_CFG)
PCB_ENUM(HDMI_EXT_Z0_CFG)

PCB_ENUM(PIN_DMIC_DET)

PCB_ENUM(PIN_HP_OUT_JD)

//PCB_ENUM(PIN_HP_OUT_JD)
PCB_ENUM(I2C_PORT_0)
PCB_ENUM(TUNER_I2C)
PCB_ENUM(I2C_PORT_1)
PCB_ENUM(AMP_I2C)
PCB_ENUM(PIN_AMP_MUTE)
PCB_ENUM(PIN_AMP_RESET)
PCB_ENUM(AMP_DEVICE_ADDR)
//PCB_ENUM(I2C_PORT_2)
//PCB_ENUM(EEP_I2C)
//PCB_ENUM(EEP_DEVICE_ADDR)
//PCB_ENUM(PIN_EEP_WP)
PCB_ENUM(I2C_PORT_2)
PCB_ENUM(TCON_I2C)
PCB_ENUM(I2C_PORT_3)
PCB_ENUM(SENSOR_I2C)

//PCB_ENUM(PCMCIA_CFG)
PCB_ENUM(SC0_CFG)

//PCB_ENUM(PIN_CORE_VID_0)
//PCB_ENUM(PIN_SCPU_VID_0)
//PCB_ENUM(PIN_SCPU_VID_1)


//PCB_ENUM(PIN_USB_5V_EN)
PCB_ENUM(USB_CONNECTOR_MAP)
PCB_ENUM(Z0_XHCI_VALUE)
PCB_ENUM(Z0_EHCI_VALUE)

// Keypad
PCB_ENUM(PIN_KEYPAD_PWR)
//PCB_ENUM(PIN_KEYPAD_UP)
//PCB_ENUM(PIN_KEYPAD_DOWN) /* not used */
//PCB_ENUM(PIN_KEYPAD_SELECT) /* not used */

// HDMI-MHL select
//PCB_ENUM(PIN_HDMI_MHL_SELECT)

// Audio Path
PCB_ENUM(AV1_AUDIO_PATH)
//PCB_ENUM(YPP1_AUDIO_PATH)

// VD source
PCB_ENUM(AV1_PATH)
PCB_ENUM(AV1_PATH_GROUND)
//PCB_ENUM(AV2_PATH)
//PCB_ENUM(AV2_PATH_GROUND)
//PCB_ENUM(SCART1_PATH_Y)
//PCB_ENUM(SCART1_PATH_R)
//PCB_ENUM(SCART1_PATH_G)
//PCB_ENUM(SCART1_PATH_B)
//PCB_ENUM(SCART1_PATH_GROUND)
//PCB_ENUM(YPP1_DATA)
//PCB_ENUM(YPP1_SOY_MUX)
//PCB_ENUM(YPP1_SWAP_RGB)
//TP SRC
PCB_ENUM(TP_SRC)

PCB_ENUM(PIN_POWER_DETECT)
PCB_ENUM(PIN_PWM0_DIMMER)
PCB_ENUM(PIN_PWM0_DIMMER_GPIO_INFO)
PCB_ENUM(PIN_PWM2_DIMMER)
PCB_ENUM(PIN_PWM2_DIMMER_GPIO_INFO)
PCB_ENUM(PIN_DC_DIMMER_IP_REF)
PCB_ENUM(PIN_WIFI_HOST_RESET)
PCB_ENUM(PIN_WOWLAN)
PCB_ENUM(PIN_NET_PWR_SHTDWN)
PCB_ENUM(PIN_DC_MON_SOC)
//PCB_ENUM(PIN_EN_V_STBY)
//PCB_ENUM(PIN_USB_EN_P2)
PCB_ENUM(PIN_USB_EN_P1)
PCB_ENUM(PIN_USB_EN_P0)
//PCB_ENUM(PIN_TUNER_WAKEUP)
//PCB_ENUM(PIN_EWS_PWR)
PCB_ENUM(PIN_TU_DET)
//PCB_ENUM(PIN_TU_ID)
//PCB_ENUM(PIN_DEMOD_RST_STBY)
PCB_ENUM(PIN_BL_ERR)
PCB_ENUM(PIN_POWER_EN)
PCB_ENUM(PIN_EMMC_PWR_CTRL)
PCB_ENUM(PIN_HP_DET)
PCB_ENUM(PIN_CVBS_IN_DET)
PCB_ENUM(PIN_X_AUDIO_MUTE2)
//PCB_ENUM(PIN_X_AUDIO_MUTE1)
PCB_ENUM(PIN_X_AUDIO_RST_SOC)
PCB_ENUM(PIN_X_AUDIO_MON1)
PCB_ENUM(PIN_PANEL_LESS)
PCB_ENUM(PIN_PANEL_B_INT)
PCB_ENUM(PIN_USB_OCP_P0)
PCB_ENUM(PIN_USB_OCP_P1)
PCB_ENUM(PIN_LEDS_0)
PCB_ENUM(PIN_LEDS_1)
PCB_ENUM(PIN_LED_IR)
PCB_ENUM(PIN_PWM_LED_TALLY)
PCB_ENUM(PIN_PWM_LED_R)
PCB_ENUM(PIN_PWM_LED_G)
PCB_ENUM(PIN_PWM_LED_B)
PCB_ENUM(PIN_PWM_LED_TALLY_GPIO_INFO)
PCB_ENUM(PIN_PWM_LED_R_GPIO_INFO)
PCB_ENUM(PIN_PWM_LED_G_GPIO_INFO)
PCB_ENUM(PIN_PWM_LED_B_GPIO_INFO)

//PCB_ENUM(PIN_DEMOD_RESET)
//PCB_ENUM(PIN_LNB_HV)
PCB_ENUM(PIN_IRDA_UKEY_0)
//PCB_ENUM(PIN_FBFFC_TOP)
//PCB_ENUM(PIN_FBFFC_BOTTOM)
//PCB_ENUM(PIN_TCONLESS_SEL)
//PCB_ENUM(PIN_TRDY)
PCB_ENUM(PIN_TCONLESS_FAULT)
PCB_ENUM(PIN_C4_DISABLE)
PCB_ENUM(PIN_2K4K_DET)
PCB_ENUM(PIN_HOTEL_CTRL)
PCB_ENUM(PIN_PANEL_DET0)
PCB_ENUM(PIN_PANEL_DET1)

//INPUT SOURCE
PCB_ENUM(INPUT_AV)
PCB_ENUM(INPUT_HDMI)
PCB_ENUM(INPUT_USB)
//PCB_ENUM(INPUT_COMPONENT)
//PCB_ENUM(INPUT_VGA)
//PCB_ENUM(PIN_CI_EN)
//PCB_ENUM(PIN_CI_OCP)
PCB_ENUM(PIN_LIGHT_SENSOR)
PCB_ENUM_END()


