#include <common.h>
#include <panel_config_parameter.h>
#include <ppoverlay_reg.h>
#include <sys_reg_reg.h>
//#include <pif_reg.h>
#include <sfg_reg.h>
#include <vby1_reg.h>
#include <platform_lib/board/pcb_mgr.h>
#ifndef IS_FPGA
#include <platform_lib/board/pcb.h>
#endif
#include <asm/io.h>
#include <bootparam.h>
#include <asm/arch/factorylib.h>
#include <panel.h>
//#include <asm/arch/rbus/rbusLD_InterfaceReg.h>
#include <asm/arch/ld_interface.h>
#include <drivers/i2c/rtk_g2c_lib.h>
#include <asm/arch/fw_info.h>
#include <drivers/i2c/rtk_i2c_lib.h>
#include <panel_api.h>
#include <outputgamma_reg.h>
#include <pcid_reg.h>
#include <demura_reg.h>
#include <asm/arch/system.h>
#include <exports.h>
#include <od_reg.h>
#include <od_dma_reg.h>

extern struct _PANEL_CONFIG_PARAMETER  default_panel_parameter;
extern int boot_power_on_mode;

//Tcon Control Api
unsigned char panel_Tcon_PA168_Enable(void);
void PA168_i2c_cmd(void);
void Millet4_i2c_cmd(void);
void Millet4_INX8903_i2c_cmd(void);
#if defined(CONFIG_PANEL_SHARP_NT71912_MEMC)
void Sharp_NT71912_i2c_cmd(void);
#endif
void INX8903_8lane_i2c_cmd(void);

extern unsigned char Get_PANEL_TYPE_IS_MILLET3_4K2K_SERIES(void);
extern void rtd_part_outl(unsigned int addr, unsigned int B, unsigned int C, unsigned int D);
#define ScalerTimer_DelayXms(x) udelay(x*1000)

//////////////////////// Panel Interface Related Cunstomized Setting ////////////////////////////////////////

/*************************** Please Be Note The Following Rule ************************************
/////////////////////////////////////////////////////////////////////////////////////////////
The register address of panel interface  TXPHY between  0xb800_0C00 ~ 0xb800_0CC8,
only the follwing are allow to be modify, if your changes are out of this range, please contact with
dick0329@realtek.com, or yungfanmu@realtek.com first.

Allowed Modify Registers:
---------------------------------------------------------------------------------------------
0xb800_0c00[31:20][18:7]
0xb800_0c04[31:20][18:7]
0xb800_0c0c[27:26][25:18]
0xb800_0c10[25:24][18:17]
0xb800_0c14[25:24][18:17]
0xb800_0c18[25:24][18:17]
0xb800_0c1c[25:24][18:17]
0xb800_0c20[25:24][18:17]
0xb800_0c24[25:24][18:17]
0xb800_0c28[25:24][18:17]
0xb800_0c2c[25:24][18:17]
0xb800_0c30[26:19]
0xb800_0c34[25:24][18:17]
0xb800_0c38[25:24][18:17]
0xb800_0c3c[25:24][18:17]
0xb800_0c40[25:24][18:17]
0xb800_0c44[25:24][18:17]
0xb800_0c48[25:24][18:17]
0xb800_0c4c[25:24][18:17]
0xb800_0c50[26:19]
0xb800_0c54[25:22][21:17]
0xb800_0c58[12:5]
0xb800_0c60[14:8]
0xb800_0c78[30:23][22:16][15:8][6:0]
0xb800_0c80[23:20]
0xb800_0c84[23:20]
0xb800_0c88[23:20]
0xb800_0c8c[23:20]
0xb800_0c90[23:20]
0xb800_0c94[23:20]
0xb800_0c98[23:20]
0xb800_0c9c[23:20]
0xb800_0ca4[23:20]
0xb800_0ca8[23:20]
0xb800_0cac[23:20]
0xb800_0cb0[23:20]
0xb800_0cb4[23:20]
0xb800_0cb8[23:20]
0xb800_0cbc[23:20]
0xb800_0cc4[24]

*********************************************************************************************/

//////////////////////// END of Panel Interface Related Cunstomized Setting ////////////////////////////////////////


//////////////////////// Panel TCON I2C Cunstomized Setting ////////////////////////////////////////
#if defined(Config_Board_TV010_PANEL)

void LG_epi_i2c_cmd(LG_EPI_GAMMA_VOLTAGE gamma_voltage)
{
#ifdef CONFIG_REALTEK_I2C

	static unsigned long long m_TCON_I2C_DEVICE_ADDR = 0x20;	//millet4 slave address
	int i=0;
	int ret = 0;
	unsigned short          nSubAddr=1;
	unsigned char          pSubAddr[0];
	unsigned short          nData=0x17 + 1 + 1;
	unsigned char          pData[0x19];
	unsigned char UHD43Table[0x19] = {0x00 /*reg addr*/, 0x21, 0x1, 0x1, 0x8, 0x9, 0x8, 0x20, 0x15,
									0x0, 0x1, 0x1, 0x1, 0xbf, 0x7e,
									0xbd, 0x16, 0xe9, 0x49, 0x86, 0x40, 0x1, 0x0, 0x13, 0x3c};

//	unsigned char UHD49Table[0x19] = {0x00 /*reg addr*/, 0x21, 0x1, 0x1, 0x4, 0x9, 0x8, 0x34, 0x15,
//									0x0, 0x1, 0x1, 0x1, 0xdd, 0x7b,
//									0xb2, 0x11, 0xdc, 0x39, 0x72, 0x11, 0x1, 0x0, 0x28, 0x3c};

//	unsigned char UHD55Table[0x19] = {0x00 /*reg addr*/, 0x21, 0x1, 0x1, 0x6, 0x9, 0x8, 0x34, 0x15,
//									0x0, 0x1, 0x1, 0x1, 0xd9, 0x7e,
//									0xb5, 0x11, 0xee, 0x3e, 0x77, 0x1e, 0x1, 0x0, 0x2f, 0x38};

/* for Skyworth G6 49 inch panel */
	unsigned char UHD49Table[0x19] = {0x00 /*reg addr*/, 0x24, 0x1, 0x2, 0x5, 0x9, 0x8, 0x34, 0x15,
									0x0, 0x1, 0x1, 0x1, 0xdc, 0x79,
									0xb4, 0x12, 0xdc, 0x3e, 0x77, 0x1f, 0x82, 0x0, 0x30, 0x54};

/* for Skyworth G6 55 inch panel */
	unsigned char UHD55Table[0x19] = {0x00 /*reg addr*/, 0x26, 0x1, 0x2, 0x6, 0x9, 0x8, 0x34, 0x15,
									0x0, 0x1, 0x1, 0x1, 0xd7, 0x82,
									0xb7, 0x12, 0xee, 0x3f, 0x73, 0x20, 0x84, 0x0, 0x32, 0xb5};




	memset(pSubAddr, 0, 1);
	memset(pData, 0, 0x19);
	//pSubAddr[0] = 0xFF; //Vcom, Gamma data
	printf("LG_epi_i2c_cmd gamma_voltage=%d\n", gamma_voltage);

#if 0	//Merlin used HW I2C_0
	G2C_Init(m_TCON_I2C_MASTER);
	if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == VBY_ONE_PANEL_INX8903_4K2K_600M_1S_8L){
		printf("mode 4k2k 60\n");
		for(i=0; i<10; i++){
			G2C_Write_EX(m_TCON_I2C_MASTER, m_TCON_I2C_DEVICE_ADDR, 0, 0, 7, ((UINT8*) TCON_IN8903_I2C_CMD_TABLE+(i*7)));
			mdelay(20);
		}
	}
#else
	I2C_Init();
	//B: 0x1806022c[26:24] = 0x4
	// rtd_maskl(0xb806022c, ~(0x07000000), 0x04000000);

#if 0	//no need
	//pSubAddr[0] = 0xFF;
	nData = 2;
	pData[0] = 0xFF; //register addr
	pData[1] = 0x01; //eeprom
	ret = I2C_Write_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nData, pData); //read from EEPROM
	if (ret) {
		printf("LG_epi_i2c_cmd i2c write fail -- line %d\n", __LINE__);
	}
#endif

	pSubAddr[0] = 0x00;
	nData = 0x18;
	memset(pData, 0, 0x18);
	ret = I2C_Read_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nSubAddr, pSubAddr, nData, pData);
	if (ret) {
		printf("LG_epi_i2c_cmd i2c read fail -- line %d\n", __LINE__);
	}
	else {
		for (i=14; i<0x18; i++) {
			printf("LG_epi_i2c_cmd i2c read get SubAddr 0x%x= 0x%x\n", pSubAddr[0]+i, pData[i]);
		}
	}

	bool isDiff = false;
	switch (gamma_voltage) {
		default:
		case LG_EPI_GAMMA_VOLTAGE_55UHD:
			for (i=0; i<0x18; i++) {
				if (pData[i] != UHD55Table[i+1]) {
					isDiff = true;
					printf("pData[%d]=0x%x diff\n", i, pData[i]);
					break;
				}
			}
			if (isDiff) {
				//pSubAddr[0] = 0x00;
				nData = 0x19;
				//pData[0] = LG_EPI_GAMMA_VOLTAGE_1;
				printf("gamma different, i2c write 0x%x\n", UHD55Table[0x17]);
				ret = I2C_Write_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nData, UHD55Table);
				if (ret) {
					printf("LG_epi_i2c_cmd i2c write fail -- line %d\n", __LINE__);
				}
				mdelay(10);
				//pSubAddr[0] = 0xFF;
				nData = 2;
				pData[0] = 0xFF; //register addr
				pData[1] = 0x80; //write register into eeprom
				printf("i2c write register into eeprom\n");
				ret = I2C_Write_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nData, pData);
				if (ret) {
					printf("LG_epi_i2c_cmd i2c write fail -- line %d\n", __LINE__);
				}
				mdelay(500); //need to > 200ms

				//pSubAddr[0] = 0xFF;
				nData = 2;
				pData[0] = 0xFF; //register addr
				pData[1] = 0x01; //eeprom
				ret = I2C_Write_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nData, pData); //read from register
				if (ret) {
					printf("LG_epi_i2c_cmd i2c write fail -- line %d\n", __LINE__);
				}

				pSubAddr[0] = 0x00;
				nData = 0x18;
				memset(pData, 0, 0x18);
				ret = I2C_Read_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nSubAddr, pSubAddr, nData, pData);
				if (ret) {
					printf("LG_epi_i2c_cmd i2c read fail -- line %d\n", __LINE__);
				}
				else {
					for (i=0; i<0x18; i++) {
						printf("LG_epi_i2c_cmd i2c read get SubAddr 0x%x= 0x%x\n", pSubAddr[0]+i, pData[i]);
					}
				}
			}
			break;
		case LG_EPI_GAMMA_VOLTAGE_49UHD:
			for (i=0; i<0x18; i++) {
				if (pData[i] != UHD49Table[i+1]) {
					isDiff = true;
					printf("pData[%d]=0x%x diff\n", i, pData[i]);
					break;
				}
			}
			if (isDiff) {
				//pSubAddr[0] = 0x00;
				nData = 0x19;
				//pData[0] = LG_EPI_GAMMA_VOLTAGE_1;
				printf("gamma different, i2c write  0x%x\n", UHD49Table[0x17]);
				ret = I2C_Write_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nData, UHD49Table);
				if (ret) {
					printf("LG_epi_i2c_cmd i2c write fail -- line %d\n", __LINE__);
				}
				mdelay(10);
				//pSubAddr[0] = 0xFF;
				nData = 2;
				pData[0] = 0xFF; //register addr
				pData[1] = 0x80; //write register into eeprom
				printf("i2c write register into eeprom\n");
				ret = I2C_Write_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nData, pData);
				if (ret) {
					printf("LG_epi_i2c_cmd i2c write fail -- line %d\n", __LINE__);
				}
				mdelay(500); //need to > 200ms

				//pSubAddr[0] = 0xFF;
				nData = 2;
				pData[0] = 0xFF; //register addr
				pData[1] = 0x01; //eeprom
				ret = I2C_Write_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nData, pData); //read from register
				if (ret) {
					printf("LG_epi_i2c_cmd i2c write fail -- line %d\n", __LINE__);
				}

				pSubAddr[0] = 0x00;
				nData = 0x18;
				memset(pData, 0, 0x18);
				ret = I2C_Read_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nSubAddr, pSubAddr, nData, pData);
				if (ret) {
					printf("LG_epi_i2c_cmd i2c read fail -- line %d\n", __LINE__);
				}
				else {
					for (i=0; i<0x18; i++) {
						printf("LG_epi_i2c_cmd i2c read get SubAddr 0x%x= 0x%x\n", pSubAddr[0]+i, pData[i]);
					}
				}
			}
			break;
		case LG_EPI_GAMMA_VOLTAGE_43UHD:
			for (i=0; i<0x18; i++) {
				if (pData[i] != UHD43Table[i+1]) {
					isDiff = true;
					printf("pData[%d]=0x%x diff\n", i, pData[i]);
					break;
				}
			}
			if (isDiff) {
				//pSubAddr[0] = 0x00;
				nData = 0x19;
				//pData[0] = LG_EPI_GAMMA_VOLTAGE_1;
				printf("gamma different, i2c write  0x%x\n", UHD43Table[0x17]);
				ret = I2C_Write_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nData, UHD43Table);
				if (ret) {
					printf("LG_epi_i2c_cmd i2c write fail -- line %d\n", __LINE__);
				}
				mdelay(10);
				//pSubAddr[0] = 0xFF;
				nData = 2;
				pData[0] = 0xFF; //register addr
				pData[1] = 0x80; //write register into eeprom
				printf("i2c write register into eeprom\n");
				ret = I2C_Write_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nData, pData);
				if (ret) {
					printf("LG_epi_i2c_cmd i2c write fail -- line %d\n", __LINE__);
				}
				mdelay(500); //need to > 200ms

				//pSubAddr[0] = 0xFF;
				nData = 2;
				pData[0] = 0xFF; //register addr
				pData[1] = 0x01; //eeprom
				ret = I2C_Write_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nData, pData); //read from register
				if (ret) {
					printf("LG_epi_i2c_cmd i2c write fail -- line %d\n", __LINE__);
				}

				pSubAddr[0] = 0x00;
				nData = 0x18;
				memset(pData, 0, 0x18);
				ret = I2C_Read_EX(LG_EPI_GAMMA_MASTER, m_TCON_I2C_DEVICE_ADDR, nSubAddr, pSubAddr, nData, pData);
				if (ret) {
					printf("LG_epi_i2c_cmd i2c read fail -- line %d\n", __LINE__);
				}
				else {
					for (i=0; i<0x18; i++) {
						printf("LG_epi_i2c_cmd i2c read get SubAddr 0x%x= 0x%x\n", pSubAddr[0]+i, pData[i]);
					}
				}
			}
			break;
	}

#endif
#endif
}
#endif

#if defined(Config_Board_TV010_PANEL)
unsigned char  panel_epi_gamma_i2c_control(void)
{
#if defined(Config_Board_TV010_PANEL)
#ifdef PANEL_CONFIG_FROM_FACTORY_PANEL_BIN
	if(default_panel_parameter.iCONFIG_PANEL_GAMMA_TYPE==P_EPI_LG_43_UHD_1){
		printf("panel_epi_gamma_i2c_control Index : P_EPI_LG_43_UHD setting\n");
		LG_epi_i2c_cmd(LG_EPI_GAMMA_VOLTAGE_43UHD);
	}else if(default_panel_parameter.iCONFIG_PANEL_GAMMA_TYPE==P_EPI_LG_49_UHD_1){
		printf("panel_epi_gamma_i2c_control Index : P_EPI_LG_49_UHD setting\n");
		LG_epi_i2c_cmd(LG_EPI_GAMMA_VOLTAGE_49UHD);
	}else if(default_panel_parameter.iCONFIG_PANEL_GAMMA_TYPE==P_EPI_LG_55_UHD_1){
		printf("panel_epi_gamma_i2c_control Index : P_EPI_LG_55_UHD setting\n");
		LG_epi_i2c_cmd(LG_EPI_GAMMA_VOLTAGE_55UHD);
	}else{
		printf("panel_epi_gamma_i2c_control Index : unknow\n");
		LG_epi_i2c_cmd(LG_EPI_GAMMA_VOLTAGE_55UHD);
	}
#else
	LG_epi_i2c_cmd(LG_EPI_GAMMA_VOLTAGE_55UHD);
#endif
#endif
	return 1;
}
#endif


//////////////////////// Panel TCON I2C Cunstomized Setting ////////////////////////////////////////

UINT8 panel_tcon_i2c_control(void)
{
	// PA168 init via I2C command
	if(panel_Tcon_PA168_Enable()){
		mdelay(500);  // wait TCON ready //500ms
		PA168_i2c_cmd(); // PA168 init via I2C command
	}else if(Get_PANEL_TYPE_IS_MILLET3_4K2K_SERIES()){
		mdelay(500);  // wait TCON ready //500ms
		if((default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_M4_Default_4k2k) ||
			(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_M4_Default_2k1k)){
			//Millet4_i2c_cmd();

		}
	}else if((default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_4K2K) &&
			(default_panel_parameter.iCONFIG_PANEL_TYPE == P_VBY1_2K1K) &&
			(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX ==
			VBY_ONE_PANEL_INX8903_4K2K_600M_1S_8L)){
		mdelay(1500);

	}
#if defined(CONFIG_PANEL_SHARP_NT71912_MEMC)
	else
		Sharp_NT71912_i2c_cmd();
#endif

	return 1;
}

// PixelWorks PA168 MEMC control
#define PA168_I2C_SLAVE_ID			(0x22 >> 1)	// 1 bit R-shift for Darwin I2C bug?
#define PA168_I2C_CMD_LVDS_FMT	(0x18)
// PixelWorks PA168 4k2k TCON control
typedef enum _PA168_LVDS_INPUT_FMT{
	LVDS_FMT_8BIT_JEIDA	= 0,
	LVDS_FMT_8BIT_VESA	= 1,
	LVDS_FMT_10BIT_JEIDA	= 2,
	LVDS_FMT_10BIT_VESA	= 3,
	LVDS_FMT_10BIT_MIX	= 4
}PA168_LVDS_INPUT_FMT;

void PA168_i2c_cmd(void)
{
#ifdef CONFIG_REALTEK_I2C
//	unsigned long long value=0;
	UINT8 msg[2];

	G2C_Init(0x3);

	msg[0] = PA168_I2C_CMD_LVDS_FMT;
	msg[1] = LVDS_FMT_10BIT_VESA; //
	G2C_Write_EX(3, PA168_I2C_SLAVE_ID, 0, 0, 2, msg);
#endif

	printf("[PA168] Send I2C command!\n");

	return;
}

unsigned char panel_Tcon_PA168_Enable(void)
{

	if((default_panel_parameter.iCONFIG_PANEL_TYPE == 2) && (default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_PA168_AU_55))
		return 1;

	return 0;
}

#if defined(CONFIG_PANEL_SHARP_NT71912_MEMC)

#define NT71912_ADDR 0x1a
void Sharp_NT71912_I2C_CFG_UNLOCK(void)
{
	unsigned char UNLOCK1[2] = { 0xFE, 0x31};
	unsigned char UNLOCK2[2] = { 0xFF, 0x72};

	I2C_Write_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 2, ((UINT8*) UNLOCK1));
	I2C_Write_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 2, ((UINT8*) UNLOCK2));
}

bool Sharp_NT71912_I2C_FRC_INIT_STATE_CHECK(void)
{
	unsigned char FRC_INIT_STATE_CHECK[5] = { 0x08, 0x5c, 0x01, 0x0A, 0x9F};
	unsigned char I2C_FRC_STATUS[4] = {0, 0, 0, 0};
	unsigned char w_data = 0;

	w_data = 0x0C;
	I2C_Write_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 5, ((UINT8*) FRC_INIT_STATE_CHECK));
	if(S_OK != I2C_Read_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 1, &w_data, 4, I2C_FRC_STATUS))
	{
		printf("Panel_I2C_FRC_STATE_STATUS_CHECK read NG\n");
		return false;
	}

	if(I2C_FRC_STATUS[0] != 0x01) return false;
	else	return true;
}

bool Sharp_NT71912_I2C_FIFO_STATUS_CHECK(void)
{
	unsigned char FIFO_CHECK[5] = { 0x08, 0x20, 0x01, 0x0A, 0x9F};
	unsigned char READ_FIFO_STATUS[4] = {0, 0, 0, 0};
	unsigned char w_data = 0;
	int i = 0;

	w_data = 0x0C;
	I2C_Write_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 5, ((UINT8*) FIFO_CHECK));
	if(S_OK != I2C_Read_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 1, &w_data, 4, READ_FIFO_STATUS))
	{
		printf("Panel_I2C_FIFO_STATUS_CHECK read NG\n");
		return false;
	}

	for(i=0; i<4; i++)
	{
		if(READ_FIFO_STATUS[i] != 0xFF) return false;
	}

	return true;
}

bool Sharp_NT71912_I2C_STATUS_CHECK(void)
{
	unsigned char STATUS_CHECK[5] = { 0x08, 0x24, 0x01, 0x0A, 0x9F};
	unsigned char I2C_STATUS[4] = {0, 0, 0, 0};
	unsigned char w_data = 0;

	w_data = 0x0C;
	I2C_Write_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 5, ((UINT8*) STATUS_CHECK));
	if(S_OK != I2C_Read_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 1, &w_data, 4, I2C_STATUS))
	{
		printf("Panel_I2C_STATUS_CHECK read NG\n");
		return false;
	}

	if(I2C_STATUS[0] != 0x01) return false;
	else	return true;
}

bool Sharp_NT71912_I2C_ROM_REVISON(UINT32* nDate, UINT32* nInfor)
{
	unsigned char PANEL_ROM_REVISION1_CMD[5] = { 0x08, 0xf0, 0xff, 0x00, 0x00};
	unsigned char PANEL_ROM_REVISION2_CMD[5] = { 0x08, 0xf8, 0xff, 0x00, 0x00};
	unsigned char I2C_INFORMATION_STATUS[4] = {0, 0, 0, 0};
	unsigned char w_data = 0;

	w_data = 0x0C;
	I2C_Write_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 5, ((UINT8*) PANEL_ROM_REVISION1_CMD));
	if(S_OK != I2C_Read_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 1, &w_data, 4, I2C_INFORMATION_STATUS)) {
		printf("PANEL_ROM_REVISION1_CMD read NG\n");
		return false;
	}
	*nDate = I2C_INFORMATION_STATUS[0];
	*nDate = (*nDate << 8) | I2C_INFORMATION_STATUS[1];
	*nDate = (*nDate << 8) | I2C_INFORMATION_STATUS[2];
	*nDate = (*nDate << 8) | I2C_INFORMATION_STATUS[3];
	mdelay(5);

	w_data = 0x0C;
	I2C_Write_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 5, ((UINT8*) PANEL_ROM_REVISION2_CMD));
	if(S_OK != I2C_Read_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 1, &w_data, 4, I2C_INFORMATION_STATUS)) {
		printf("PANEL_ROM_REVISION2_CMD read NG\n");
		return false;
	}

	*nInfor = I2C_INFORMATION_STATUS[0];
	*nInfor = (*nInfor << 8) | I2C_INFORMATION_STATUS[1];
	*nInfor = (*nInfor << 8) | I2C_INFORMATION_STATUS[2];
	*nInfor = (*nInfor << 8) | I2C_INFORMATION_STATUS[3];

	return true;
}

void Sharp_NT71912_i2c_cmd(void)
{
	#define PANEL_WAIT_TIME 10

	int i = 0;
	unsigned char PANEL_MUTE_OFF[9] = { 0x00, 0x20, 0x01, 0x0A, 0x9F, 0x00, 0x00, 0x00, 0x00};
	unsigned char PANEL_BACKLIGHT_ON[9] = { 0x00, 0x20, 0x01, 0x0A, 0x9F, 0xEF, 0x10, 0x31, 0x05};
	UINT32 nDateInformaiton, nSpecInformation;
//	int nYear, nMonth, nDay, nInch, nPanelInfo, nVer;

	printf("Sharp_NT71912_i2c_cmd\n");

	// CFG Unlock
	Sharp_NT71912_I2C_CFG_UNLOCK();

	mdelay(5);
	if(Sharp_NT71912_I2C_ROM_REVISON(&nDateInformaiton, &nSpecInformation) == true) {
//		nYear = (nDateInformaiton & 0xffff0000) >> 16;
//		nMonth = (nDateInformaiton & 0x0000ff00) >> 8;
//		nDay = (nDateInformaiton & 0x000000ff);
//		nInch = (nSpecInformation & 0xff000000) >> 24;
//		nPanelInfo = (nSpecInformation & 0x00ffff00) >> 8;
//		nVer = (nSpecInformation & 0x000000ff);
		printf("ROM_REVISON: Date: 0x%x, Information: 0x%x\n", nDateInformaiton, nSpecInformation);
//		printf("Date: %d/%d/%d\n", nYear, nMonth, nDay);
//		printf("Infomation: inch(%d), Panel(%d), Ver(%d)\n", nInch, nPanelInfo, nVer);
	}

	mdelay(5);
	for(i=0; i<PANEL_WAIT_TIME; i++) {
		if(Sharp_NT71912_I2C_FRC_INIT_STATE_CHECK() == true)
			break;
		else if(i == PANEL_WAIT_TIME -1)
			printf("1.Panel_I2C_FRC_INIT_STATUS_CHECK is NG\n");
		else
			mdelay(100);
	}
	mdelay(5);

	for(i=0; i<PANEL_WAIT_TIME; i++) {
		if(Sharp_NT71912_I2C_FIFO_STATUS_CHECK() == true)
			break;
		else if(i == PANEL_WAIT_TIME -1)
			printf("1.Panel_I2C_FIFO_STATUS_CHECK is NG\n");
		else
			mdelay(100);
	}
	mdelay(5);

	for(i=0; i<PANEL_WAIT_TIME; i++) {
		if(Sharp_NT71912_I2C_STATUS_CHECK() == true)
			break;
		else if(i == PANEL_WAIT_TIME -1)
			printf("1.Panel_I2C_STATUS_CHECK is NG\n");
		else
			mdelay(100);
	}
	mdelay(5);

	// Mute off
	I2C_Write_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 9, ((UINT8*) PANEL_MUTE_OFF));
	for(i=0; i<PANEL_WAIT_TIME; i++) {
		if(Sharp_NT71912_I2C_FIFO_STATUS_CHECK() == true)
			break;
		else if(i == PANEL_WAIT_TIME -1)
			printf("2.Panel_I2C_FIFO_STATUS_CHECK is NG\n");
		else
			mdelay(100);
	}
	mdelay(5);

	for(i=0; i<PANEL_WAIT_TIME; i++) {
		if(Sharp_NT71912_I2C_STATUS_CHECK() == true)
			break;
		else if(i == PANEL_WAIT_TIME -1)
			printf("2.Panel_I2C_STATUS_CHECK is NG\n");
		else
			mdelay(100);
	}
	mdelay(5);

	// BL ON
	I2C_Write_EX(SHARP_NT71912_I2C_MASTER, NT71912_ADDR, 9, ((UINT8*) PANEL_BACKLIGHT_ON));
/*
	if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_M4_Default_2k1k){
		printf("mode 2k1k\n");
		G2C_Write_EX(m_TCON_I2C_MASTER, m_TCON_I2C_DEVICE_ADDR, 0, 0, 9, ((UINT8*) TCON_MILLET4_I2C_CMD_TABLE));
	}else if(default_panel_parameter.iCONFIG_PANEL_CUSTOM_INDEX == P_M4_Default_4k2k){
		printf("mode 4k2k\n");
		G2C_Write_EX(m_TCON_I2C_MASTER, m_TCON_I2C_DEVICE_ADDR, 0, 0, 9, ((UINT8*) TCON_MILLET4_I2C_CMD_TABLE+9));
	}

*/
}
#endif

////////////////////////END of Panel TCON I2C Cunstomized Setting ////////////////////////////////////////

#if defined(Config_Board_TV035) || defined(Config_Board_TV035_INT_DDR)  || defined(Config_Board_TV035_INT_DDR_DCU1_4G4G_DCU2_4G4G)
unsigned char panel_custom_mode(void)
{
	return default_c_panel_param_extend.iCONFIG_CUSTOMER_AMP;
}

SPEAKER_OUTPUT_TYPE panel_custom_amp_volume_table_index(void)
{
	return (SPEAKER_OUTPUT_TYPE)default_c_panel_param_extend.iCONFIG_CUSTOMER_SPEAKER_OUTPUT;
}
#endif

void panel_mLVDS_BOE_default_tcon_tx(void)
{
#if 0
	// Mp_WPR_reg_0714_60Hz_for_mlvds.tbl
	rtd_maskl(0xb800010C,0xffdfffff,0x00200001);  //mplus rst_n
	rtd_maskl(0xb800011C,0xffdfffff,0x00200001);  //mplus clk
	rtd_maskl(0xb8028000,0xfeffffff,0x00000000);	//disp_en disable

	rtd_outl(0xB8028C04, 0xF9F1F0F8);//reg00~reg03
	rtd_outl(0xB8028C08, 0xDF100010);//reg04~reg07
	rtd_outl(0xB8028C0C, 0x00100010);//reg08~reg0B
	rtd_outl(0xB8028C10, 0x00100010);//reg0C~reg0F
	rtd_outl(0xB8028C14, 0x00100010);//reg10~reg13
	rtd_outl(0xB8028C18, 0x00040004);//reg14~reg17
	rtd_outl(0xB8028C1C, 0x00040004);//reg18~reg1B
	rtd_outl(0xB8028C20, 0x00040000);//reg1C~reg1F
	rtd_outl(0xB8028C24, 0x0FD20000);//reg20~reg23
	rtd_outl(0xB8028C28, 0x7E900000);//reg24~reg27
	rtd_outl(0xB8028C2C, 0x0FD20000);//reg28~reg2B
	rtd_outl(0xB8028C30, 0x7E900000);//reg2C~reg2F
	rtd_outl(0xB8028C34, 0x0FD20000);//reg30~reg33
	rtd_outl(0xB8028C38, 0x0FD20000);//reg34~reg37
	rtd_outl(0xB8028C3C, 0x7E900000);//reg38~reg3B
	rtd_outl(0xB8028C40, 0x0FD20000);//reg3C~reg3F
	rtd_outl(0xB8028C44, 0x7E900000);//reg40~reg43
	rtd_outl(0xB8028C48, 0x0FD20000);//reg44~reg47
	rtd_outl(0xB8028C4C, 0x00000000);//reg48~reg4B
	rtd_outl(0xB8028C50, 0x2AAB2000);//reg4C~reg4F
	rtd_outl(0xB8028C54, 0x20003FFF);//reg50~reg53
	rtd_outl(0xB8028C58, 0x30001010);//reg54~reg57
	rtd_outl(0xB8028C5C, 0x10101001);//reg58~reg5B
	rtd_outl(0xB8028C60, 0x00018001);//reg5C~reg5F
	rtd_outl(0xB8028C64, 0x80018001);//reg60~reg63
	rtd_outl(0xB8028C68, 0x80080008);//reg64~reg67
	rtd_outl(0xB8028C6C, 0x00080008);//reg68~reg6B
	rtd_outl(0xB8028C70, 0x00101010);//reg6C~reg6F
	rtd_outl(0xB8028C74, 0x10200015);//reg70~reg73
	rtd_outl(0xB8028C78, 0x55100010);//reg74~reg77
	rtd_outl(0xB8028C7C, 0x00200010);//reg78~reg7B
	rtd_outl(0xB8028C80, 0x00100010);//reg7C~reg7F
	rtd_outl(0xB8028C84, 0x00100010);//reg80~reg83
	rtd_outl(0xB8028C88, 0x001000FF);//reg84~reg87
	rtd_outl(0xB8028C8C, 0xFFFFFFFF);//reg88~reg8B
	rtd_outl(0xB8028C90, 0x01000200);//reg8C~reg8F
	rtd_outl(0xB8028C94, 0x03000400);//reg90~reg93
	rtd_outl(0xB8028C98, 0x05000600);//reg94~reg97
	rtd_outl(0xB8028C9C, 0x07000800);//reg98~reg9B
	rtd_outl(0xB8028CA0, 0x09000A00);//reg9C~reg9F
	rtd_outl(0xB8028CA4, 0x0B000C00);//regA0~regA3
	rtd_outl(0xB8028CA8, 0x0D000E00);//regA4~regA7
	rtd_outl(0xB8028CAC, 0xFF003000);//regA8~regAB
	rtd_outl(0xB8028CB0, 0x08802000);//regAC~regAF
	rtd_outl(0xB8028CB4, 0x10000818);//regB0~regB3
	rtd_outl(0xB8028CB8, 0x08006010);//regB4~regB7
	rtd_outl(0xB8028CBC, 0x00601000);//regB8~regBB
	rtd_outl(0xB8028CC0, 0x20006C04);//regBC~regBF
	rtd_outl(0xB8028CC4, 0x04101011);//regC0~regC3
	rtd_outl(0xB8028CC8, 0x30830E1A);//regC4~regC7
	rtd_outl(0xB8028CCC, 0x23405060);//regC8~regCB
	rtd_outl(0xB8028CD0, 0x708090A0);//regCC~regCF
	rtd_outl(0xB8028CD4, 0xB0C0D0E0);//regD0~regD3
	rtd_outl(0xB8028CD8, 0xF0FFFFFF);//regD4~regD7
	rtd_outl(0xB8028CDC, 0xFFFFFFFF);//regD8~regDB
	rtd_outl(0xB8028CE0, 0xFFFFFFFF);//regDC~regDF
	rtd_outl(0xB8028CE4, 0xFF4A06F0);//regE0~regE3
	rtd_outl(0xB8028CE8, 0x0FF00F08);//regE4~regE7
	rtd_outl(0xB8028CEC, 0x00100000);//regE8~regEB
	rtd_outl(0xB8028CF0, 0x00040004);//regEC~regEF
	rtd_outl(0xB8028D1C, 0x0FF03B2E);//regF0~regF3
	rtd_outl(0xB8028D20, 0x2E3B3B2E);//regF4~regF7
	rtd_outl(0xB8028D24, 0x2E3B0000);//regF8~regFB
	rtd_outl(0xB8028D28, 0x00000000);//regFC~regFF
	rtd_outl(0xB8028D2C, 0x0F200105);//reg100~reg103
	rtd_outl(0xB8028D30, 0x00180008);//reg104~reg107
	rtd_outl(0xB8028D34, 0xC0000000);//reg108~reg10B
	rtd_outl(0xB8028D38, 0x0400100A);//reg10C~reg10F
	rtd_outl(0xB8028D3C, 0x00000010);//reg110~reg113
	rtd_outl(0xB8028D40, 0x0001FF00);//reg114~reg117
	rtd_outl(0xB8028D44, 0x00040000);//reg118~reg11B
	rtd_outl(0xB8028D48, 0x00000000);//reg11C~reg11F
	rtd_outl(0xB8028D4C, 0x10500480);//reg120~reg123
	rtd_outl(0xB8028D50, 0x40210000);//reg124~reg127
	rtd_maskl(0xB8028C00, 0x9FFFFFB0, 0x8000000);

	rtd_maskl(0xB8028C00, 0x7FFFFFB0, 0x80000000);
	rtd_maskl(0xb8028004,0xffc7ffff,0x00080000);	//mplus enable, rgbw disable, BOE-rgbw disable
	rtd_maskl(0xb8028000,0xfeffffff,0x01000000);	//disp_en enable
	//----------------------------------------------------------------//



	//mlvds_uhd_60hz_4port_6pair_8b_k3lpp_ls.tbl"
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG1: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x000008C0);	// pif_clk_sel use sfg clk (for LS APHY), 30-bit Mode, Dout Enable,
										// delay chain pre/delay/post  = no_inverse/0ns/inverse, Pre-R/B Not Swap, Post R/B Not Swap,
	rtd_outl(0xb802D904, 0x07FFFFFF);	// PIF_Clock = Dclk/8, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 4n+0/4n+1/4n+2/4n+3 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D94C, 0x00000000);	// SEG12/SEG13 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x00000000);	// SEG14/SEG15 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x00000307);	// SFG Normal Mode, 4-SEG, 8-Port, H-Flip Disable,
										// ECO for active dummy for DRD Mode disable, 1.5 packet mode disable,
	rtd_outl(0xb802D968, 0x000003C0);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x07800B40);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	rtd_outl(0xb802D980, 0x00000000);	// SEG12/SEG13 Start Address,
	rtd_outl(0xb802D984, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x00000300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x0F000000);	// Final line length (1-pixel mode),
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x01181128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x80000000);	// mini-LVDS Clock Enable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA00, 0x00000000);	// SEG12/SEG13 No middle dummy sub-pixel,
	rtd_outl(0xb802DA04, 0x00000000);	// SEG14/SEG15 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x80000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 4n+0,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 4n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 4n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 4n+3,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA20, 0x00000000);	// Last_ext_pixel_last_flip_line 4n+0/1/2/3 (no use),
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD  1st output sub-pixel (r0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD  2nd output sub-pixel (g0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD  3rd output sub-pixel (b0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD  4th output sub-pixel (r2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD  5th output sub-pixel (g2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD  6th output sub-pixel (b2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD  7th output sub-pixel (r4) for line 4n+0/1/2/3
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD  8th output sub-pixel (g4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD  9th output sub-pixel (b4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD 10th output sub-pixel (r6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD 11th output sub-pixel (g6) for line 4n+0/1/2/3
	rtd_outl(0xb802DACC, 0x16161616);	// DRD 12th output sub-pixel (b6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD 13th output sub-pixel (r1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD 14th output sub-pixel (g1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD 15th output sub-pixel (b1) for line 4n+0/1/2/3
	rtd_outl(0xb802DADC, 0x07070707);	// DRD 16th output sub-pixel (r3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD 17th output sub-pixel (g3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD 18th output sub-pixel (b3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD 19th output sub-pixel (r5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD 20th output sub-pixel (g5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD 21st output sub-pixel (b5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD 22nd output sub-pixel (r7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD 23rd output sub-pixel (g7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD 24th output sub-pixel (b7) for line 4n+0/1/2/3
	rtd_outl(0xb802DB00, 0x00010203);	// Port A~D mapping,
	rtd_outl(0xb802DB04, 0x04050607);	// Port E~H mapping,
	rtd_outl(0xb802DB08, 0x00000000);	// Port I~L mapping,
	rtd_outl(0xb802DB0C, 0x00000000);	// Port M~P mapping,
	rtd_outl(0xb802DB10, 0x00000000);	// Port Q~T mapping,
	rtd_outl(0xb802DB14, 0x00000000);	// Port U~X mapping,
	rtd_outl(0xb802DB18, 0x00000000);	// SEG16/SEG17 No front/back dummy pixel,
	rtd_outl(0xb802DB1C, 0x00000000);	// SEG18/SEG19 No front/back dummy pixel,
	rtd_outl(0xb802DB20, 0x00000000);	// SEG20/SEG21 No front/back dummy pixel,
	rtd_outl(0xb802DB24, 0x00000000);	// SEG22/SEG23 No front/back dummy pixel,
	rtd_outl(0xb802DB28, 0x00000000);	// SEG16/SEG17 Start Address,
	rtd_outl(0xb802DB2C, 0x00000000);	// SEG18/SEG19 Start Address,
	rtd_outl(0xb802DB30, 0x00000000);	// SEG20/SEG21 Start Address,
	rtd_outl(0xb802DB34, 0x00000000);	// SEG22/SEG23 Start Address,
	rtd_outl(0xb802DB38, 0x00000000);	// SEG16/SEG17 No middle dummy sub-pixel,
	rtd_outl(0xb802DB3C, 0x00000000);	// SEG18/SEG19 No middle dummy sub-pixel,
	rtd_outl(0xb802DB40, 0x00000000);	// SEG20/SEG21 No middle dummy sub-pixel,
	rtd_outl(0xb802DB44, 0x00000000);	// SEG22/SEG23 No middle dummy sub-pixel,
	rtd_outl(0xb802DB68, 0x00000000);	// f/w ext_num for each port line 4n+0, all port ext_num = 0,
	rtd_outl(0xb802DB6C, 0x00000000);	// f/w ext_num for each port line 4n+1, all port ext_num = 0,
	rtd_outl(0xb802DB70, 0x00000000);	// f/w ext_num for each port line 4n+2, all port ext_num = 0,
	rtd_outl(0xb802DB74, 0x00000000);	// f/w ext_num for each port line 4n+3, all port ext_num = 0,
	rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+0,
	rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+1,
	rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+2,
	rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+3,

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG2: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802DA30, 0x00000000);	// SFG for OSD disable, data not inverse, not bypass SFG2,
						// auto config mode enable, dout enable, 1-SEG, 1-Port, H-Flip Disable,
	rtd_outl(0xb802DA34, 0x00000000);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802DA38, 0x00000000);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802DA3C, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802DA40, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802DA44, 0x01234567);	// Port A~H mapping,
	rtd_outl(0xb802DA48, 0x000000FF);	// Force to background enable,
	rtd_outl(0xb802DA4C, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802DA50, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802DA74, 0x00000780);	// Final line length (1-pixel mode),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Mini-LVDS use 1-pixel mode for 4K2K
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C80, 0xCCCCCCCC);	// P0(D/E/F/G) Pinshare to Mini-LVDS,
	rtd_outl(0xb8000C84, 0xCCCCCCCC);	// P3(A/B/C/D) Pinshare to Mini-LVDS,
	rtd_outl(0xb8000C88, 0xCCCCCCCC);	// P0(B/C), P3(E) Pinshare to Mini-LVDS,
	rtd_outl(0xb802D000, 0x00000000);	// PIF LVDS/mLVDS Mode,
	rtd_outl(0xb802D010, 0x00000000);	// LVDS Port Disable,
	rtd_outl(0xb802D01C, 0x00000A45);	// Mini-LVDS use 4-Port 6-Pair, P2S LSB first, P/N Swap Disable, 8-Bit Mode,
						// Mini-LVDS Mirror Enable, Mini-LVDS Disable
	rtd_outl(0xb802D020, 0x00FFFFFF);	// Mini-LVDS Reset Pulse Enable for all Lane,
	rtd_outl(0xb802D024, 0x00000000);	// Mini-LVDS Reset Pulse Merge Tcon Disable,
	rtd_outl(0xb802D028, 0x00000000);	// Mini-LVDS Reset Pulse Only in Active Region, Mini-LVDS Clock inverse,
	rtd_outl(0xb802D02C, 0xFFFFFF1F);	// Mini-LVDS Reset Pulse F/W Setting,
	rtd_outl(0xb802D030, 0x00000000);	// Mini-LVDS Reset Pulse F/W Setting,
	rtd_outl(0xb802D100, 0x01234578);	// Any to Any pair assign : P0(A/B/C/D/E/F)/P1(A/B),
	rtd_outl(0xb802D104, 0x9ABC0123);	// Any to Any pair assign : P1(C/D/E/F)/P2(A/B/C/D),
	rtd_outl(0xb802D108, 0x45789ABC);	// Any to Any pair assign : P2(E/F)/P3(A/B/C/D/E/F),
	rtd_outl(0xb802D10C, 0x00006D6D);	// Any to Any pair assign : P0(A)/P1(A)/P2(A)/P3(A),
	rtd_outl(0xb802D01C, 0x00000AC5);	// Mini-LVDS Enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C74, 0x80800000);	// Low Speed APHY Enable, Lane Power Disable,
	rtd_outl(0xb8000C00, 0xC0006020);	// P0 PI_A1 = Phase24, PI_A2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C04, 0xC0006020);	// P1 PI_B1 = Phase24, PI_B2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C08, 0x03080000);	// X_PHY PI_AB = Phase0, CK7X = 1X Current, CK5X Duty Adjust Disable, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C0C, 0x4464F500);	// X_PHY Small Kvco, DIV248 = 2, VCO = 74.25*8*DIV248 = 1.188GHz,
										// X_PHY CKREF Not Inverse, CKPIXEL Inverse, Icp = 2uA, SC1 = 80pF, SC2 = 5.62pF, Rs = 12Kohm, PLLLDO = 2V,
										// X_PHY PI_A Enable, PI_B Enable,
	rtd_outl(0xb8000C10, 0xB4000000);	// P0 A-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm, Power Stage use LVDS Mode,
	rtd_outl(0xb8000C14, 0xB4000000);	// P0 B-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C18, 0xB4000000);	// P0 C-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C1C, 0xB5000000);	// P0 D-Pair mLVDS, Use PI_A2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C20, 0xB4000000);	// P0 E-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C24, 0xB4000000);	// P0 F-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C28, 0x20000000);	// P0 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000C30, 0xB4000000);	// P1 A-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C34, 0xB4000000);	// P1 B-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C38, 0xB4000000);	// P1 C-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C3C, 0xB5000000);	// P1 D-Pair mLVDS, Use PI_B2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C40, 0xB4000000);	// P1 E-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C44, 0xB4000000);	// P1 F-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C48, 0x20000000);	// P1 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000C50, 0x096CE000);	// X_PHY, ISOURCE = IBHX, LDO2V(2.1V) Enable, LDO1V(0.95V) Enable, Swing = 4mA, VCM = 1.25V,
	rtd_outl(0xb8000C54, 0x0000007F);	// P0 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000C58, 0x00000000);	// P0 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000C5C, 0x0000007F);	// P1 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000C60, 0x00000000);	// P1 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000C64, 0x00000000);	// P0 Dummy Register,
	rtd_outl(0xb8000C6C, 0x00000000);	// P1 Dummy Register,
	rtd_outl(0xb8000D00, 0xC0006020);	// P2 PI_A1 = Phase24, PI_A2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D04, 0xC0006020);	// P3 PI_B1 = Phase24, PI_B2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D08, 0x03080000);	// Y_PHY PI_AB = Phase0, CK7X = 1X Current, CK5X Duty Adjust Disable, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D0C, 0x4464F500);	// Y_PHY Small Kvco, DIV248 = 2, VCO = 74.25*8*DIV248 = 1.188GHz,
										// Y_PHY CKREF Inverse, CKPIXEL Inverse, Icp = 2uA, SC1 = 80pF, SC2 = 5.62pF, Rs = 12Kohm, PLLLDO = 2V,
										// Y_PHY PI_A Enable, PI_B Enable,
	rtd_outl(0xb8000D10, 0xB4000000);	// P2 A-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm, Power Stage use LVDS Mode,
	rtd_outl(0xb8000D14, 0xB4000000);	// P2 B-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D18, 0xB4000000);	// P2 C-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D1C, 0xB5000000);	// P2 D-Pair mLVDS, Use PI_A2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D20, 0xB4000000);	// P2 E-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D24, 0xB4000000);	// P2 F-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D28, 0x20000000);	// P2 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000D30, 0xB4000000);	// P3 A-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D34, 0xB4000000);	// P3 B-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D38, 0xB4000000);	// P3 C-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D3C, 0xB5000000);	// P3 D-Pair mLVDS, Use PI_B2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D40, 0xB4000000);	// P3 E-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D44, 0xB4000000);	// P3 F-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D48, 0x20000000);	// P3 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000D50, 0x096CE000);	// Y_PHY, ISOURCE = IBHX, LDO2V(2.1V) Enable, LDO1V(0.95V) Enable, Swing = 4mA, VCM = 1.25V,
	rtd_outl(0xb8000D54, 0x0000007F);	// P2 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000D58, 0x00000000);	// P2 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000D5C, 0x0000007F);	// P3 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000D60, 0x00000000);	// P3 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000D64, 0x00000000);	// P2 Dummy Register,
	rtd_outl(0xb8000D6C, 0x00000000);	// P3 Dummy Register,
	rtd_outl(0xb8000DB0, 0x0AA00AA0);	// P0 G-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
										// P1 G-Pair mLVDS, Use PI_B1, Pre-Emphasis = 0,
										// Y_PHY Not Bypass DIV_M,
	rtd_outl(0xb8000DB4, 0x0B401680);	// P1 G-Pair SR Disable, internal resistor 300ohm,
										// P2 G-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
										// P3 G-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0,
	rtd_outl(0xb8000DB8, 0x010000000);	// P3 G-Pair internal resistor 300ohm, PLT_C_LDO = 0.887V???
	rtd_outl(0xb8000DBC, 0x00000F000);	// TTL 8mA, Not Bypass DIV_CKO,
	rtd_outl(0xb8000C74, 0xFFFF7F7F);	// Low Speed APHY Enable, Lane Power Enable,
	//------------------------------------------------------------------//

    // tcon_mlvds.tbl"
    // Tcon Pinshare
	rtd_maskl(0xb8000848, 0xFF0FFFFF, 0x00500000);	// GPIO_76, use Tcon39, STV1(AG6),
	rtd_maskl(0xb8000800, 0x0FFFFFFF, 0x30000000);	// GPIO_0, use Tcon0, STV2(D8),
	rtd_maskl(0xb8000848, 0x0FFFFFFF, 0x50000000);	// GPIO_75, use Tcon36, TP1(AJ5),
	rtd_maskl(0xb8000800, 0xFFFF0FFF, 0x00003000);	// GPIO_2, use Tcon20, TP2(E7),
	rtd_maskl(0xb8000848, 0xFFFF0FFF, 0x00004000);	// GPIO_77, use Tcon26, CPV(AH6),
	rtd_maskl(0xb8000840, 0xFF0FFFFF, 0x00400000);	// GPIO_68, use Tcon21, OE1(AG4),
	rtd_maskl(0xb8000800, 0xFF0FFFFF, 0x00B00000);	// GPIO_1, use Tcon10, OE2(E8),
	rtd_maskl(0xb8000844, 0xFFFFFF0F, 0x00000040);	// GPIO_74, use Tcon15, POL1(AH5),
	rtd_maskl(0xb8000840, 0xFFFFFF0F, 0x00000040);	// GPIO_70, use Tcon5, POL2(AH3),
	rtd_maskl(0xb8000840, 0xFFFF0FFF, 0x0000F000);	// GPIO_69, use Tcon33, XAO(AG5),

	// Tcon Timing Setting,
	rtd_outl(0xb802D200, 0x40000000);		// External Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb802D42C, 0x00000000);		// External Global Tcon disable,
	rtd_outl(0xb8026804, 0x40000000);		// EPI Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb8026800, 0x00000006);		// EPI Tcon use SFG VS, global Tcon disable,
	rtd_outl(0xb802D9B8, 0xC0000000);		// LVDS/EPI Clock Enable, Data inverse disable,

	// Tcon39 (STV1)
	rtd_outl(0xb8026A44, 0x08970897);		// H_start/H_end,
	rtd_outl(0xb8026A48, 0x089B089D);		// V_start/V_end,
	rtd_outl(0xb8026A4C, 0x00000180);		// Control,

	// Tcon0 (STV2)
	rtd_outl(0xb802D204, 0x08970897);		// H_start/H_end,
	rtd_outl(0xb802D208, 0x002C002E);		// V_start/V_end,
	rtd_outl(0xb802D20C, 0x00000180);		// Control,

	// Tcon36 (TP1)
	//rtd_outl(0xb80269F0, 0x0EE00FB0);		// H_start/H_end,
	rtd_outl(0xb80269F0, 0x004400f0);		// H_start/H_end,
	rtd_outl(0xb80269F4, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb80269F8, 0x00000080);		// Control,

	// Tcon20 (TP2)
	//rtd_outl(0xb8026830, 0x0EE00FB0);		// H_start/H_end,
	rtd_outl(0xb8026830, 0x004400f0);		// H_start/H_end,
	rtd_outl(0xb8026834, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb8026838, 0x00000080);		// Control,

	// Tcon26 (CPV)
	rtd_outl(0xb80268D8, 0x04600E00);		// H_start/H_end,
	rtd_outl(0xb80268DC, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb80268E0, 0x000000C0);		// Control,

	// Tcon21 (OE1)
	rtd_outl(0xb802684C, 0x0BD00F50);		// H_start/H_end,
	rtd_outl(0xb8026850, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb8026854, 0x00000080);		// Control,

	// Tcon10 (OE2)
	rtd_outl(0xb802D320, 0x0BD00F50);		// H_start/H_end,
	rtd_outl(0xb802D324, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb802D328, 0x00000080);		// Control,

	// Tcon15 (POL1)
	rtd_outl(0xb802D444, 0x08970897);		// H_start/H_end,
	rtd_outl(0xb802D448, 0x00240024);		// V_start/V_end,
	rtd_outl(0xb802D44C, 0x00000480);		// Control,
	rtd_outl(0xb802D454, 0x00000000);		// Across Frame Period,

	// Tcon5 (POL2)
	rtd_outl(0xb802D290, 0x08970897);		// H_start/H_end,
	rtd_outl(0xb802D294, 0x00240024);		// V_start/V_end,
	rtd_outl(0xb802D298, 0x00000480);		// Control,
	rtd_outl(0xb802D2A0, 0x00000000);		// Across Frame Period,

	// Tcon33 (XAO)
	//rtd_maskl(0xb801BD08, 0xFFFFFFDF, 0x00000020);	// GPIO_76 as GPO,
	//rtd_maskl(0xb801BD20, 0xFFFFFFDF, 0x00000020);	// GPIO_76 GPO output High,

	rtd_outl(0xb802D42C, 0x00000001);		// External Global Tcon Enable,
	rtd_outl(0xb8026800, 0x00000007);		// EPI Tcon use SFG VS, global Tcon enable,
	//------------------------------------------------------------------//
#endif
}


void panel_mLVDS_BOE_tcon_setting(void)
{
#if 0
	// Mp_WPR_reg_0714_60Hz_for_mlvds.tbl
	rtd_maskl(0xb800010C,0xffdfffff,0x00200001);  //mplus rst_n
	rtd_maskl(0xb800011C,0xffdfffff,0x00200001);  //mplus clk
	rtd_maskl(0xb8028000,0xfeffffff,0x00000000);	//disp_en disable

	rtd_outl(0xB8028C04, 0xF9F1F0F8);//reg00~reg03
	rtd_outl(0xB8028C08, 0xDF100010);//reg04~reg07
	rtd_outl(0xB8028C0C, 0x00100010);//reg08~reg0B
	rtd_outl(0xB8028C10, 0x00100010);//reg0C~reg0F
	rtd_outl(0xB8028C14, 0x00100010);//reg10~reg13
	rtd_outl(0xB8028C18, 0x00040004);//reg14~reg17
	rtd_outl(0xB8028C1C, 0x00040004);//reg18~reg1B
	rtd_outl(0xB8028C20, 0x00040000);//reg1C~reg1F
	rtd_outl(0xB8028C24, 0x0FD20000);//reg20~reg23
	rtd_outl(0xB8028C28, 0x7E900000);//reg24~reg27
	rtd_outl(0xB8028C2C, 0x0FD20000);//reg28~reg2B
	rtd_outl(0xB8028C30, 0x7E900000);//reg2C~reg2F
	rtd_outl(0xB8028C34, 0x0FD20000);//reg30~reg33
	rtd_outl(0xB8028C38, 0x0FD20000);//reg34~reg37
	rtd_outl(0xB8028C3C, 0x7E900000);//reg38~reg3B
	rtd_outl(0xB8028C40, 0x0FD20000);//reg3C~reg3F
	rtd_outl(0xB8028C44, 0x7E900000);//reg40~reg43
	rtd_outl(0xB8028C48, 0x0FD20000);//reg44~reg47
	rtd_outl(0xB8028C4C, 0x00000000);//reg48~reg4B
	rtd_outl(0xB8028C50, 0x2AAB2000);//reg4C~reg4F
	rtd_outl(0xB8028C54, 0x20003FFF);//reg50~reg53
	rtd_outl(0xB8028C58, 0x30001010);//reg54~reg57
	rtd_outl(0xB8028C5C, 0x10101001);//reg58~reg5B
	rtd_outl(0xB8028C60, 0x00018001);//reg5C~reg5F
	rtd_outl(0xB8028C64, 0x80018001);//reg60~reg63
	rtd_outl(0xB8028C68, 0x80080008);//reg64~reg67
	rtd_outl(0xB8028C6C, 0x00080008);//reg68~reg6B
	rtd_outl(0xB8028C70, 0x00101010);//reg6C~reg6F
	rtd_outl(0xB8028C74, 0x10200015);//reg70~reg73
	rtd_outl(0xB8028C78, 0x55100010);//reg74~reg77
	rtd_outl(0xB8028C7C, 0x00200010);//reg78~reg7B
	rtd_outl(0xB8028C80, 0x00100010);//reg7C~reg7F
	rtd_outl(0xB8028C84, 0x00100010);//reg80~reg83
	rtd_outl(0xB8028C88, 0x001000FF);//reg84~reg87
	rtd_outl(0xB8028C8C, 0xFFFFFFFF);//reg88~reg8B
	rtd_outl(0xB8028C90, 0x01000200);//reg8C~reg8F
	rtd_outl(0xB8028C94, 0x03000400);//reg90~reg93
	rtd_outl(0xB8028C98, 0x05000600);//reg94~reg97
	rtd_outl(0xB8028C9C, 0x07000800);//reg98~reg9B
	rtd_outl(0xB8028CA0, 0x09000A00);//reg9C~reg9F
	rtd_outl(0xB8028CA4, 0x0B000C00);//regA0~regA3
	rtd_outl(0xB8028CA8, 0x0D000E00);//regA4~regA7
	rtd_outl(0xB8028CAC, 0xFF003000);//regA8~regAB
	rtd_outl(0xB8028CB0, 0x08802000);//regAC~regAF
	rtd_outl(0xB8028CB4, 0x10000818);//regB0~regB3
	rtd_outl(0xB8028CB8, 0x08006010);//regB4~regB7
	rtd_outl(0xB8028CBC, 0x00601000);//regB8~regBB
	rtd_outl(0xB8028CC0, 0x20006C04);//regBC~regBF
	rtd_outl(0xB8028CC4, 0x04101011);//regC0~regC3
	rtd_outl(0xB8028CC8, 0x30830E1A);//regC4~regC7
	rtd_outl(0xB8028CCC, 0x23405060);//regC8~regCB
	rtd_outl(0xB8028CD0, 0x708090A0);//regCC~regCF
	rtd_outl(0xB8028CD4, 0xB0C0D0E0);//regD0~regD3
	rtd_outl(0xB8028CD8, 0xF0FFFFFF);//regD4~regD7
	rtd_outl(0xB8028CDC, 0xFFFFFFFF);//regD8~regDB
	rtd_outl(0xB8028CE0, 0xFFFFFFFF);//regDC~regDF
	rtd_outl(0xB8028CE4, 0xFF4A06F0);//regE0~regE3
	rtd_outl(0xB8028CE8, 0x0FF00F08);//regE4~regE7
	rtd_outl(0xB8028CEC, 0x00100000);//regE8~regEB
	rtd_outl(0xB8028CF0, 0x00040004);//regEC~regEF
	rtd_outl(0xB8028D1C, 0x0FF03B2E);//regF0~regF3
	rtd_outl(0xB8028D20, 0x2E3B3B2E);//regF4~regF7
	rtd_outl(0xB8028D24, 0x2E3B0000);//regF8~regFB
	rtd_outl(0xB8028D28, 0x00000000);//regFC~regFF
	rtd_outl(0xB8028D2C, 0x0F200105);//reg100~reg103
	rtd_outl(0xB8028D30, 0x00180008);//reg104~reg107
	rtd_outl(0xB8028D34, 0xC0000000);//reg108~reg10B
	rtd_outl(0xB8028D38, 0x0400100A);//reg10C~reg10F
	rtd_outl(0xB8028D3C, 0x00000010);//reg110~reg113
	rtd_outl(0xB8028D40, 0x0001FF00);//reg114~reg117
	rtd_outl(0xB8028D44, 0x00040000);//reg118~reg11B
	rtd_outl(0xB8028D48, 0x00000000);//reg11C~reg11F
	rtd_outl(0xB8028D4C, 0x10500480);//reg120~reg123
	rtd_outl(0xB8028D50, 0x40210000);//reg124~reg127
	rtd_maskl(0xB8028C00, 0x9FFFFFB0, 0x8000000);

	rtd_maskl(0xB8028C00, 0x7FFFFFB0, 0x80000000);
	rtd_maskl(0xb8028004,0xffc7ffff,0x00080000);	//mplus enable, rgbw disable, BOE-rgbw disable
	rtd_maskl(0xb8028000,0xfeffffff,0x01000000);	//disp_en enable
	//----------------------------------------------------------------//

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG1: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x000008C0);	// pif_clk_sel use sfg clk (for LS APHY), 30-bit Mode, Dout Enable,
						// delay chain pre/delay/post  = no_inverse/0ns/inverse, Pre-R/B Not Swap, Post R/B Not Swap,
	rtd_outl(0xb802D904, 0x07FFFFFF);	// PIF_Clock = Dclk/8, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 4n+0/4n+1/4n+2/4n+3 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D94C, 0x00000000);	// SEG12/SEG13 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x00000000);	// SEG14/SEG15 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x00000307);	// SFG Normal Mode, 4-SEG, 8-Port, H-Flip Disable,
						// ECO for active dummy for DRD Mode disable, 1.5 packet mode disable,
	rtd_outl(0xb802D968, 0x000003C0);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x07800B40);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	rtd_outl(0xb802D980, 0x00000000);	// SEG12/SEG13 Start Address,
	rtd_outl(0xb802D984, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x00000300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x0F000000);	// Final line length (1-pixel mode),
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x01181128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x80000000);	// mini-LVDS Clock Enable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA00, 0x00000000);	// SEG12/SEG13 No middle dummy sub-pixel,
	rtd_outl(0xb802DA04, 0x00000000);	// SEG14/SEG15 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x80000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 4n+0,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 4n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 4n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 4n+3,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA20, 0x00000000);	// Last_ext_pixel_last_flip_line 4n+0/1/2/3 (no use),
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD	1st output sub-pixel (r0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD	2nd output sub-pixel (g0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD	3rd output sub-pixel (b0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD	4th output sub-pixel (r2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD	5th output sub-pixel (g2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD	6th output sub-pixel (b2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD	7th output sub-pixel (r4) for line 4n+0/1/2/3
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD	8th output sub-pixel (g4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD	9th output sub-pixel (b4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD 10th output sub-pixel (r6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD 11th output sub-pixel (g6) for line 4n+0/1/2/3
	rtd_outl(0xb802DACC, 0x16161616);	// DRD 12th output sub-pixel (b6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD 13th output sub-pixel (r1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD 14th output sub-pixel (g1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD 15th output sub-pixel (b1) for line 4n+0/1/2/3
	rtd_outl(0xb802DADC, 0x07070707);	// DRD 16th output sub-pixel (r3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD 17th output sub-pixel (g3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD 18th output sub-pixel (b3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD 19th output sub-pixel (r5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD 20th output sub-pixel (g5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD 21st output sub-pixel (b5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD 22nd output sub-pixel (r7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD 23rd output sub-pixel (g7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD 24th output sub-pixel (b7) for line 4n+0/1/2/3
	rtd_outl(0xb802DB00, 0x00010203);	// Port A~D mapping,
	rtd_outl(0xb802DB04, 0x04050607);	// Port E~H mapping,
	rtd_outl(0xb802DB08, 0x00000000);	// Port I~L mapping,
	rtd_outl(0xb802DB0C, 0x00000000);	// Port M~P mapping,
	rtd_outl(0xb802DB10, 0x00000000);	// Port Q~T mapping,
	rtd_outl(0xb802DB14, 0x00000000);	// Port U~X mapping,
	rtd_outl(0xb802DB18, 0x00000000);	// SEG16/SEG17 No front/back dummy pixel,
	rtd_outl(0xb802DB1C, 0x00000000);	// SEG18/SEG19 No front/back dummy pixel,
	rtd_outl(0xb802DB20, 0x00000000);	// SEG20/SEG21 No front/back dummy pixel,
	rtd_outl(0xb802DB24, 0x00000000);	// SEG22/SEG23 No front/back dummy pixel,
	rtd_outl(0xb802DB28, 0x00000000);	// SEG16/SEG17 Start Address,
	rtd_outl(0xb802DB2C, 0x00000000);	// SEG18/SEG19 Start Address,
	rtd_outl(0xb802DB30, 0x00000000);	// SEG20/SEG21 Start Address,
	rtd_outl(0xb802DB34, 0x00000000);	// SEG22/SEG23 Start Address,
	rtd_outl(0xb802DB38, 0x00000000);	// SEG16/SEG17 No middle dummy sub-pixel,
	rtd_outl(0xb802DB3C, 0x00000000);	// SEG18/SEG19 No middle dummy sub-pixel,
	rtd_outl(0xb802DB40, 0x00000000);	// SEG20/SEG21 No middle dummy sub-pixel,
	rtd_outl(0xb802DB44, 0x00000000);	// SEG22/SEG23 No middle dummy sub-pixel,
	rtd_outl(0xb802DB68, 0x00000000);	// f/w ext_num for each port line 4n+0, all port ext_num = 0,
	rtd_outl(0xb802DB6C, 0x00000000);	// f/w ext_num for each port line 4n+1, all port ext_num = 0,
	rtd_outl(0xb802DB70, 0x00000000);	// f/w ext_num for each port line 4n+2, all port ext_num = 0,
	rtd_outl(0xb802DB74, 0x00000000);	// f/w ext_num for each port line 4n+3, all port ext_num = 0,
	rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+0,
	rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+1,
	rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+2,
	rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+3,

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG2: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802DA30, 0x00000000);	// SFG for OSD disable, data not inverse, not bypass SFG2,
						// auto config mode enable, dout enable, 1-SEG, 1-Port, H-Flip Disable,
	rtd_outl(0xb802DA34, 0x00000000);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802DA38, 0x00000000);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802DA3C, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802DA40, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802DA44, 0x01234567);	// Port A~H mapping,
	rtd_outl(0xb802DA48, 0x000000FF);	// Force to background enable,
	rtd_outl(0xb802DA4C, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802DA50, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802DA74, 0x00000780);	// Final line length (1-pixel mode),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Mini-LVDS use 1-pixel mode for 4K2K
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C80, 0xCCCCCCCC);	// P0(D/E/F/G) Pinshare to Mini-LVDS,
	rtd_outl(0xb8000C84, 0xCCCCCCCC);	// P3(A/B/C/D) Pinshare to Mini-LVDS,
	rtd_outl(0xb8000C88, 0xCCCCCCCC);	// P0(B/C), P3(E) Pinshare to Mini-LVDS,
	rtd_outl(0xb802D000, 0x00000000);	// PIF LVDS/mLVDS Mode,
	rtd_outl(0xb802D010, 0x00000000);	// LVDS Port Disable,
	rtd_outl(0xb802D01C, 0x00000A45);	// Mini-LVDS use 4-Port 6-Pair, P2S LSB first, P/N Swap Disable, 8-Bit Mode,
						// Mini-LVDS Mirror Enable, Mini-LVDS Disable
	rtd_outl(0xb802D020, 0x00FFFFFF);	// Mini-LVDS Reset Pulse Enable for all Lane,
	rtd_outl(0xb802D024, 0x00000000);	// Mini-LVDS Reset Pulse Merge Tcon Disable,
	rtd_outl(0xb802D028, 0x00000000);	// Mini-LVDS Reset Pulse Only in Active Region, Mini-LVDS Clock inverse,
	rtd_outl(0xb802D02C, 0xFFFFFF1F);	// Mini-LVDS Reset Pulse F/W Setting,
	rtd_outl(0xb802D030, 0x00000000);	// Mini-LVDS Reset Pulse F/W Setting,
	rtd_outl(0xb802D100, 0x01234578);	// Any to Any pair assign : P0(A/B/C/D/E/F)/P1(A/B),
	rtd_outl(0xb802D104, 0x9ABC0123);	// Any to Any pair assign : P1(C/D/E/F)/P2(A/B/C/D),
	rtd_outl(0xb802D108, 0x45789ABC);	// Any to Any pair assign : P2(E/F)/P3(A/B/C/D/E/F),
	rtd_outl(0xb802D10C, 0x00006D6D);	// Any to Any pair assign : P0(A)/P1(A)/P2(A)/P3(A),
	rtd_outl(0xb802D01C, 0x00000AC5);	// Mini-LVDS Enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C74, 0x80800000);	// Low Speed APHY Enable, Lane Power Disable,
	rtd_outl(0xb8000C00, 0xC0006020);	// P0 PI_A1 = Phase24, PI_A2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C04, 0xC0006020);	// P1 PI_B1 = Phase24, PI_B2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C08, 0x03080000);	// X_PHY PI_AB = Phase0, CK7X = 1X Current, CK5X Duty Adjust Disable, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C0C, 0x4464F500);	// X_PHY Small Kvco, DIV248 = 2, VCO = 74.25*8*DIV248 = 1.188GHz,
						// X_PHY CKREF Not Inverse, CKPIXEL Inverse, Icp = 2uA, SC1 = 80pF, SC2 = 5.62pF, Rs = 12Kohm, PLLLDO = 2V,
						// X_PHY PI_A Enable, PI_B Enable,
	rtd_outl(0xb8000C10, 0xB4000000);	// P0 A-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm, Power Stage use LVDS Mode,
	rtd_outl(0xb8000C14, 0xB4000000);	// P0 B-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C18, 0xB4000000);	// P0 C-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C1C, 0xB5000000);	// P0 D-Pair mLVDS, Use PI_A2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C20, 0xB4000000);	// P0 E-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C24, 0xB4000000);	// P0 F-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C28, 0x20000000);	// P0 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000C30, 0xB4000000);	// P1 A-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C34, 0xB4000000);	// P1 B-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C38, 0xB4000000);	// P1 C-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C3C, 0xB5000000);	// P1 D-Pair mLVDS, Use PI_B2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C40, 0xB4000000);	// P1 E-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C44, 0xB4000000);	// P1 F-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C48, 0x20000000);	// P1 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000C50, 0x096CE000);	// X_PHY, ISOURCE = IBHX, LDO2V(2.1V) Enable, LDO1V(0.95V) Enable, Swing = 4mA, VCM = 1.25V,
	rtd_outl(0xb8000C54, 0x0000007F);	// P0 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000C58, 0x00000000);	// P0 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000C5C, 0x0000007F);	// P1 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000C60, 0x00000000);	// P1 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000C64, 0x00000000);	// P0 Dummy Register,
	rtd_outl(0xb8000C6C, 0x00000000);	// P1 Dummy Register,
	rtd_outl(0xb8000D00, 0xC0006020);	// P2 PI_A1 = Phase24, PI_A2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D04, 0xC0006020);	// P3 PI_B1 = Phase24, PI_B2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D08, 0x03080000);	// Y_PHY PI_AB = Phase0, CK7X = 1X Current, CK5X Duty Adjust Disable, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D0C, 0x4464F500);	// Y_PHY Small Kvco, DIV248 = 2, VCO = 74.25*8*DIV248 = 1.188GHz,
						// Y_PHY CKREF Inverse, CKPIXEL Inverse, Icp = 2uA, SC1 = 80pF, SC2 = 5.62pF, Rs = 12Kohm, PLLLDO = 2V,
						// Y_PHY PI_A Enable, PI_B Enable,
	rtd_outl(0xb8000D10, 0xB4000000);	// P2 A-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm, Power Stage use LVDS Mode,
	rtd_outl(0xb8000D14, 0xB4000000);	// P2 B-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D18, 0xB4000000);	// P2 C-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D1C, 0xB5000000);	// P2 D-Pair mLVDS, Use PI_A2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D20, 0xB4000000);	// P2 E-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D24, 0xB4000000);	// P2 F-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D28, 0x20000000);	// P2 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000D30, 0xB4000000);	// P3 A-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D34, 0xB4000000);	// P3 B-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D38, 0xB4000000);	// P3 C-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D3C, 0xB5000000);	// P3 D-Pair mLVDS, Use PI_B2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D40, 0xB4000000);	// P3 E-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D44, 0xB4000000);	// P3 F-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D48, 0x20000000);	// P3 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000D50, 0x096CE000);	// Y_PHY, ISOURCE = IBHX, LDO2V(2.1V) Enable, LDO1V(0.95V) Enable, Swing = 4mA, VCM = 1.25V,
	rtd_outl(0xb8000D54, 0x0000007F);	// P2 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000D58, 0x00000000);	// P2 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000D5C, 0x0000007F);	// P3 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000D60, 0x00000000);	// P3 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000D64, 0x00000000);	// P2 Dummy Register,
	rtd_outl(0xb8000D6C, 0x00000000);	// P3 Dummy Register,
	rtd_outl(0xb8000DB0, 0x0AA00AA0);	// P0 G-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
						// P1 G-Pair mLVDS, Use PI_B1, Pre-Emphasis = 0,
						// Y_PHY Not Bypass DIV_M,
	rtd_outl(0xb8000DB4, 0x0B401680);	// P1 G-Pair SR Disable, internal resistor 300ohm,
						// P2 G-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
						// P3 G-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0,
	rtd_outl(0xb8000DB8, 0x010000000);	// P3 G-Pair internal resistor 300ohm, PLT_C_LDO = 0.887V???
	rtd_outl(0xb8000DBC, 0x00000F000);	// TTL 8mA, Not Bypass DIV_CKO,
	rtd_outl(0xb8000C74, 0xFFFF7F7F);	// Low Speed APHY Enable, Lane Power Enable,

	// Tcon Pinshare
	rtd_maskl(0xb8000800, 0x0FFFFFFF, 0x30000000);	// GPIO_0, use Tcon0, STVR(A21),
	rtd_maskl(0xB8000834, 0xFFFF0FFF, 0x00005000);	// GPIO_57, use Tcon29, STV(AC1),
	rtd_maskl(0xb800083c, 0x0FFFFFFF, 0x50000000);	// GPIO_63, use Tcon36, TP1(AJ5),
	rtd_maskl(0xb8000800, 0xFFFF0FFF, 0x00003000);	// GPIO_2, use Tcon20, TP2(B20),
	rtd_maskl(0xB8000838, 0xFF0FFFFF, 0x00500000);	// GPIO_60, use Tcon26, CPV(AD2),
	rtd_maskl(0xb8000834, 0xFFFFFF0F, 0x00000040);	// GPIO_58, use Tcon21, OE1(AC2),
	rtd_maskl(0xb8000800, 0xFF0FFFFF, 0x00F00000);	// GPIO_1, use Tcon10, OE2(E8),(TCON10-->3, GPIO1-->F)
	rtd_maskl(0xb8000840, 0xFFFFFF0F, 0x00000030);	// GPIO_70, use Tcon15, POL1(W6),
	rtd_maskl(0xb8000834, 0xFF0FFFFF, 0x00300000);	// GPIO_56, use Tcon5, POL2(AB1),
	rtd_maskl(0xb8000838, 0xFFFFFF0F, 0x000000f0);	// GPIO_62, use Tcon33, CKV(AE2),

	// Tcon Timing Setting,
	rtd_outl(0xb802D200, 0x40000000);		// External Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb802D42C, 0x00000000);		// External Global Tcon disable,
	rtd_outl(0xb8026804, 0x40000000);		// EPI Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb8026800, 0x00000006);		// EPI Tcon use SFG VS, global Tcon disable,
	rtd_outl(0xb802D9B8, 0xC0000000);		// LVDS/EPI Clock Enable, Data inverse disable,

	// Tcon29 (STV1)
	rtd_outl(0xb802692C, 0x08970897);		// H_start/H_end,
	rtd_outl(0xb8026930, 0x089B089D);		// V_start/V_end,
	rtd_outl(0xb8026934, 0x00000180);		// Control,


	// Tcon0 (STV2)
	rtd_outl(0xb802D204, 0x08970897);		// H_start/H_end,
	rtd_outl(0xb802D208, 0x002C002E);		// V_start/V_end,
	rtd_outl(0xb802D20C, 0x00000180);		// Control,

	// Tcon36 (TP1)
	rtd_outl(0xb80269F0, 0x102010F0);		// H_start/H_end,
	rtd_outl(0xb80269F4, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb80269F8, 0x00000080);		// Control,

	// Tcon20 (TP2)
	rtd_outl(0xb8026830, 0x102010F0);		// H_start/H_end,
	rtd_outl(0xb8026834, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb8026838, 0x00000080);		// Control,

	// Tcon26 (CPV)
	rtd_outl(0xb80268D8, 0x06881050);		// H_start/H_end,
	rtd_outl(0xb80268DC, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb80268E0, 0x000000C0);		// Control,

	// Tcon21 (OE1)
	rtd_outl(0xb802684C, 0x0D2010B0);		// H_start/H_end,
	rtd_outl(0xb8026850, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb8026854, 0x00000080);		// Control,

	// Tcon10 (OE2)
	rtd_outl(0xb802D320, 0x0D2010B0);		// H_start/H_end,
	rtd_outl(0xb802D324, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb802D328, 0x00000080);		// Control,

	// Tcon15 (POL1)
	rtd_outl(0xb802D444, 0x08970897);		// H_start/H_end,
	rtd_outl(0xb802D448, 0x00240024);		// V_start/V_end,
	rtd_outl(0xb802D44C, 0x00000480);		// Control,
	rtd_outl(0xb802D454, 0x00000000);		// Across Frame Period,

	// Tcon5 (POL2)
	rtd_outl(0xb802D290, 0x08970897);		// H_start/H_end,
	rtd_outl(0xb802D294, 0x00240024);		// V_start/V_end,
	rtd_outl(0xb802D298, 0x00000480);		// Control,
	rtd_outl(0xb802D2A0, 0x00000000);		// Across Frame Period,

	// Tcon33 (XAO)
	rtd_outl(0xb801bd04, 0x40000000);	// GPIO_62 as GPO,
	rtd_outl(0xb801bd1c, 0x40000000);	// GPIO_62 GPO output High,

	rtd_outl(0xb802D42C, 0x00000001);		// External Global Tcon Enable,
	rtd_outl(0xb8026800, 0x00000007);		// EPI Tcon use SFG VS, global Tcon enable,
#endif
}

void panel_mLVDS_CSOT_tcon_setting(void)
{
#if 0
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG1: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x000008C0);	// pif_clk_sel use sfg clk (for LS APHY), 30-bit Mode, Dout Enable,
						// delay chain pre/delay/post  = no_inverse/0ns/inverse, Pre-R/B Not Swap, Post R/B Not Swap,
	rtd_outl(0xb802D904, 0x07FFFFFF);	// PIF_Clock = Dclk/8, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 4n+0/4n+1/4n+2/4n+3 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D94C, 0x00000000);	// SEG12/SEG13 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x00000000);	// SEG14/SEG15 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x00000307);	// SFG Normal Mode, 4-SEG, 8-Port, H-Flip Disable,
						// ECO for active dummy for DRD Mode disable, 1.5 packet mode disable,
	rtd_outl(0xb802D968, 0x000003C0);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x07800B40);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	rtd_outl(0xb802D980, 0x00000000);	// SEG12/SEG13 Start Address,
	rtd_outl(0xb802D984, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x00000300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x0F000000);	// Final line length (1-pixel mode),
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x01181128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x80000000);	// mini-LVDS Clock Enable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA00, 0x00000000);	// SEG12/SEG13 No middle dummy sub-pixel,
	rtd_outl(0xb802DA04, 0x00000000);	// SEG14/SEG15 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x80000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 4n+0,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 4n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 4n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 4n+3,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA20, 0x00000000);	// Last_ext_pixel_last_flip_line 4n+0/1/2/3 (no use),
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD	1st output sub-pixel (r0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD	2nd output sub-pixel (g0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD	3rd output sub-pixel (b0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD	4th output sub-pixel (r2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD	5th output sub-pixel (g2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD	6th output sub-pixel (b2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD	7th output sub-pixel (r4) for line 4n+0/1/2/3
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD	8th output sub-pixel (g4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD	9th output sub-pixel (b4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD 10th output sub-pixel (r6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD 11th output sub-pixel (g6) for line 4n+0/1/2/3
	rtd_outl(0xb802DACC, 0x16161616);	// DRD 12th output sub-pixel (b6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD 13th output sub-pixel (r1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD 14th output sub-pixel (g1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD 15th output sub-pixel (b1) for line 4n+0/1/2/3
	rtd_outl(0xb802DADC, 0x07070707);	// DRD 16th output sub-pixel (r3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD 17th output sub-pixel (g3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD 18th output sub-pixel (b3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD 19th output sub-pixel (r5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD 20th output sub-pixel (g5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD 21st output sub-pixel (b5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD 22nd output sub-pixel (r7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD 23rd output sub-pixel (g7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD 24th output sub-pixel (b7) for line 4n+0/1/2/3
	rtd_outl(0xb802DB00, 0x01000302);	// Port A~D mapping,
	rtd_outl(0xb802DB04, 0x05040706);	// Port E~H mapping,
	rtd_outl(0xb802DB08, 0x00000000);	// Port I~L mapping,
	rtd_outl(0xb802DB0C, 0x00000000);	// Port M~P mapping,
	rtd_outl(0xb802DB10, 0x00000000);	// Port Q~T mapping,
	rtd_outl(0xb802DB14, 0x00000000);	// Port U~X mapping,
	rtd_outl(0xb802DB18, 0x00000000);	// SEG16/SEG17 No front/back dummy pixel,
	rtd_outl(0xb802DB1C, 0x00000000);	// SEG18/SEG19 No front/back dummy pixel,
	rtd_outl(0xb802DB20, 0x00000000);	// SEG20/SEG21 No front/back dummy pixel,
	rtd_outl(0xb802DB24, 0x00000000);	// SEG22/SEG23 No front/back dummy pixel,
	rtd_outl(0xb802DB28, 0x00000000);	// SEG16/SEG17 Start Address,
	rtd_outl(0xb802DB2C, 0x00000000);	// SEG18/SEG19 Start Address,
	rtd_outl(0xb802DB30, 0x00000000);	// SEG20/SEG21 Start Address,
	rtd_outl(0xb802DB34, 0x00000000);	// SEG22/SEG23 Start Address,
	rtd_outl(0xb802DB38, 0x00000000);	// SEG16/SEG17 No middle dummy sub-pixel,
	rtd_outl(0xb802DB3C, 0x00000000);	// SEG18/SEG19 No middle dummy sub-pixel,
	rtd_outl(0xb802DB40, 0x00000000);	// SEG20/SEG21 No middle dummy sub-pixel,
	rtd_outl(0xb802DB44, 0x00000000);	// SEG22/SEG23 No middle dummy sub-pixel,
	rtd_outl(0xb802DB68, 0x00000000);	// f/w ext_num for each port line 4n+0, all port ext_num = 0,
	rtd_outl(0xb802DB6C, 0x00000000);	// f/w ext_num for each port line 4n+1, all port ext_num = 0,
	rtd_outl(0xb802DB70, 0x00000000);	// f/w ext_num for each port line 4n+2, all port ext_num = 0,
	rtd_outl(0xb802DB74, 0x00000000);	// f/w ext_num for each port line 4n+3, all port ext_num = 0,
	rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+0,
	rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+1,
	rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+2,
	rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+3,

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG2: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802DA30, 0x00000000);	// SFG for OSD disable, data not inverse, not bypass SFG2,
						// auto config mode enable, dout enable, 1-SEG, 1-Port, H-Flip Disable,
	rtd_outl(0xb802DA34, 0x00000000);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802DA38, 0x00000000);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802DA3C, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802DA40, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802DA44, 0x01234567);	// Port A~H mapping,
	rtd_outl(0xb802DA48, 0x000000FF);	// Force to background enable,
	rtd_outl(0xb802DA4C, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802DA50, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802DA74, 0x00000780);	// Final line length (1-pixel mode),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Mini-LVDS use 1-pixel mode for 4K2K
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C80, 0xCCCCCCCC);	// P0(D/E/F/G) Pinshare to Mini-LVDS,
	rtd_outl(0xb8000C84, 0xCCCCCCCC);	// P3(A/B/C/D) Pinshare to Mini-LVDS,
	rtd_outl(0xb8000C88, 0xCCCCCCCC);	// P0(B/C), P3(E) Pinshare to Mini-LVDS,
	rtd_outl(0xb802D000, 0x00000000);	// PIF LVDS/mLVDS Mode,
	rtd_outl(0xb802D010, 0x00000000);	// LVDS Port Disable,
	rtd_outl(0xb802D01C, 0x00000A45);	// Mini-LVDS use 4-Port 6-Pair, P2S LSB first, P/N Swap Disable, 8-Bit Mode,
						// Mini-LVDS Mirror Enable, Mini-LVDS Disable
	rtd_outl(0xb802D020, 0x00FFFFFF);	// Mini-LVDS Reset Pulse Enable for all Lane,
	rtd_outl(0xb802D024, 0x00000000);	// Mini-LVDS Reset Pulse Merge Tcon Disable,
	rtd_outl(0xb802D028, 0x3c000000);	// Mini-LVDS Reset Pulse Only in Active Region, Mini-LVDS Clock inverse,
	rtd_outl(0xb802D02C, 0xFFFFFF1F);	// Mini-LVDS Reset Pulse F/W Setting,
	rtd_outl(0xb802D030, 0x00000000);	// Mini-LVDS Reset Pulse F/W Setting,
	rtd_outl(0xb802D100, 0x01234578);	// Any to Any pair assign : P0(A/B/C/D/E/F)/P1(A/B),
	rtd_outl(0xb802D104, 0x9ABC0123);	// Any to Any pair assign : P1(C/D/E/F)/P2(A/B/C/D),
	rtd_outl(0xb802D108, 0x45789ABC);	// Any to Any pair assign : P2(E/F)/P3(A/B/C/D/E/F),
	rtd_outl(0xb802D10C, 0x00006D6D);	// Any to Any pair assign : P0(A)/P1(A)/P2(A)/P3(A),
	rtd_outl(0xb802D01C, 0x00000AC5);	// Mini-LVDS Enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C74, 0x80800000);	// Low Speed APHY Enable, Lane Power Disable,
	rtd_outl(0xb8000C00, 0xC0006020);	// P0 PI_A1 = Phase24, PI_A2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C04, 0xC0006020);	// P1 PI_B1 = Phase24, PI_B2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C08, 0x03080000);	// X_PHY PI_AB = Phase0, CK7X = 1X Current, CK5X Duty Adjust Disable, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C0C, 0x4464F500);	// X_PHY Small Kvco, DIV248 = 2, VCO = 74.25*8*DIV248 = 1.188GHz,
						// X_PHY CKREF Not Inverse, CKPIXEL Inverse, Icp = 2uA, SC1 = 80pF, SC2 = 5.62pF, Rs = 12Kohm, PLLLDO = 2V,
						// X_PHY PI_A Enable, PI_B Enable,
	rtd_outl(0xb8000C10, 0xB4000000);	// P0 A-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm, Power Stage use LVDS Mode,
	rtd_outl(0xb8000C14, 0xB4000000);	// P0 B-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C18, 0xB4000000);	// P0 C-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C1C, 0xB5000000);	// P0 D-Pair mLVDS, Use PI_A2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C20, 0xB4000000);	// P0 E-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C24, 0xB4000000);	// P0 F-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C28, 0x20000000);	// P0 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000C30, 0xB4000000);	// P1 A-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C34, 0xB4000000);	// P1 B-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C38, 0xB4000000);	// P1 C-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C3C, 0xB5000000);	// P1 D-Pair mLVDS, Use PI_B2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C40, 0xB4000000);	// P1 E-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C44, 0xB4000000);	// P1 F-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C48, 0x20000000);	// P1 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000C50, 0x096CE000);	// X_PHY, ISOURCE = IBHX, LDO2V(2.1V) Enable, LDO1V(0.95V) Enable, Swing = 4mA, VCM = 1.25V,
	rtd_outl(0xb8000C54, 0x0000007F);	// P0 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000C58, 0x00000000);	// P0 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000C5C, 0x0000007F);	// P1 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000C60, 0x00000000);	// P1 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000C64, 0x00000000);	// P0 Dummy Register,
	rtd_outl(0xb8000C6C, 0x00000000);	// P1 Dummy Register,
	rtd_outl(0xb8000D00, 0xC0006020);	// P2 PI_A1 = Phase24, PI_A2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D04, 0xC0006020);	// P3 PI_B1 = Phase24, PI_B2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D08, 0x03080000);	// Y_PHY PI_AB = Phase0, CK7X = 1X Current, CK5X Duty Adjust Disable, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D0C, 0x4464F500);	// Y_PHY Small Kvco, DIV248 = 2, VCO = 74.25*8*DIV248 = 1.188GHz,
						// Y_PHY CKREF Inverse, CKPIXEL Inverse, Icp = 2uA, SC1 = 80pF, SC2 = 5.62pF, Rs = 12Kohm, PLLLDO = 2V,
						// Y_PHY PI_A Enable, PI_B Enable,
	rtd_outl(0xb8000D10, 0xB4000000);	// P2 A-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm, Power Stage use LVDS Mode,
	rtd_outl(0xb8000D14, 0xB4000000);	// P2 B-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D18, 0xB4000000);	// P2 C-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D1C, 0xB5000000);	// P2 D-Pair mLVDS, Use PI_A2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D20, 0xB4000000);	// P2 E-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D24, 0xB4000000);	// P2 F-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D28, 0x20000000);	// P2 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000D30, 0xB4000000);	// P3 A-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D34, 0xB4000000);	// P3 B-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D38, 0xB4000000);	// P3 C-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D3C, 0xB5000000);	// P3 D-Pair mLVDS, Use PI_B2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D40, 0xB4000000);	// P3 E-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D44, 0xB4000000);	// P3 F-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D48, 0x20000000);	// P3 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000D50, 0x096CE000);	// Y_PHY, ISOURCE = IBHX, LDO2V(2.1V) Enable, LDO1V(0.95V) Enable, Swing = 4mA, VCM = 1.25V,
	rtd_outl(0xb8000D54, 0x0000007F);	// P2 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000D58, 0x00000000);	// P2 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000D5C, 0x0000007F);	// P3 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000D60, 0x00000000);	// P3 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000D64, 0x00000000);	// P2 Dummy Register,
	rtd_outl(0xb8000D6C, 0x00000000);	// P3 Dummy Register,
	rtd_outl(0xb8000DB0, 0x0AA00AA0);	// P0 G-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
						// P1 G-Pair mLVDS, Use PI_B1, Pre-Emphasis = 0,
						// Y_PHY Not Bypass DIV_M,
	rtd_outl(0xb8000DB4, 0x0B401680);	// P1 G-Pair SR Disable, internal resistor 300ohm,
						// P2 G-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
						// P3 G-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0,
	rtd_outl(0xb8000DB8, 0x010000000);	// P3 G-Pair internal resistor 300ohm, PLT_C_LDO = 0.887V???
	rtd_outl(0xb8000DBC, 0x00000F000);	// TTL 8mA, Not Bypass DIV_CKO,
	rtd_outl(0xb8000C74, 0xFFFF7F7F);	// Low Speed APHY Enable, Lane Power Enable,

	// Tcon Pinshare
	rtd_maskl(0xb8000800, 0x0FFFFFFF, 0x30000000);	// GPIO_0, use Tcon0, STVR(A21),
	rtd_maskl(0xB8000834, 0xFFFF0FFF, 0x00005000);	// GPIO_57, use Tcon29, STV(AC1),
	rtd_maskl(0xb800083c, 0x0FFFFFFF, 0x50000000);	// GPIO_63, use Tcon36, TP1(AJ5),
	rtd_maskl(0xb8000800, 0xFFFF0FFF, 0x00003000);	// GPIO_2, use Tcon20, TP2(B20),
	rtd_maskl(0xB8000838, 0xFF0FFFFF, 0x00500000);	// GPIO_60, use Tcon26, CPV(AD2),
	rtd_maskl(0xb8000834, 0xFFFFFF0F, 0x00000040);	// GPIO_58, use Tcon21, OE1(AC2),
	rtd_maskl(0xb8000800, 0xFF0FFFFF, 0x00300000);	// GPIO_1, use Tcon10, OE2(E8),
	rtd_maskl(0xb8000840, 0xFFFFFF0F, 0x00000030);	// GPIO_70, use Tcon15, POL1(W6),
	rtd_maskl(0xb8000834, 0xFF0FFFFF, 0x00300000);	// GPIO_56, use Tcon5, POL2(AB1),
	rtd_maskl(0xb8000838, 0xFFFFFF0F, 0x00000050);	// GPIO_62, use Tcon33, CKV(AE2),


	// Tcon Timing Setting,
	rtd_outl(0xb802D200, 0x40000000);		// External Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb802D42C, 0x00000000);		// External Global Tcon disable,
	rtd_outl(0xb8026804, 0x40000000);		// EPI Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb8026800, 0x00000006);		// EPI Tcon use SFG VS, global Tcon disable,
	rtd_outl(0xb802D9B8, 0xC0000000);		// LVDS/EPI Clock Enable, Data inverse disable,
	// Tcon0 (STVR)
	rtd_outl(0xb802D204, 0x078C078C);		// H_start/H_end,
	rtd_outl(0xb802D208, 0x002d002e);		// V_start/V_end,
	rtd_outl(0xb802D20C, 0x00000180);		// Control,
	// Tcon29 (STV)
	rtd_outl(0xb802692C, 0x04CC04CC);		// H_start/H_end,
	rtd_outl(0xb8026930, 0x089e089f);		// V_start/V_end,
	rtd_outl(0xb8026934, 0x00000180);		// Control,
	// Tcon36 (TP1)
	rtd_outl(0xb80269F0, 0x102010F0);		// H_start/H_end,
	rtd_outl(0xb80269F4, 0x000008C9);		// V_start/V_end,
	rtd_outl(0xb80269F8, 0x00000080);		// Control,
	// Tcon14 (POL1)
	rtd_outl(0xB802D398, 0x08970897);		// H_start/H_end,
	rtd_outl(0xB802D39C, 0x00240024);		// V_start/V_end,
	rtd_outl(0xb802D3A0, 0x00000480);		// Control,
	rtd_outl(0xb802D3A8, 0x00000000);		// Across Frame CTRL,
	// Tcon15 (POL1)
	rtd_outl(0xb802D444, 0x0D470D37);		// H_start/H_end,
	rtd_outl(0xb802D448, 0x000008a4);		// V_start/V_end,
	rtd_outl(0xb802D44C, 0x00000183);		// Control,(00000383-->2 line inv)
	rtd_outl(0xb802D450, 0x00040002);		// Across Frame CTRL,
	// Tcon33 (CKV)
	rtd_outl(0xb802699C, 0x0dc0043a);		// H_start/H_end,
	rtd_outl(0xb80269A0, 0x002e089f);		// V_start/V_end,
	rtd_outl(0xb80269A4, 0x00000280);
	rtd_outl(0xb802D42C, 0x00000001);		// External Global Tcon Enable,
	rtd_outl(0xb8026800, 0x00000007);		// EPI Tcon use SFG VS, global Tcon enable,
	//OE1-->H(bit26)  SQINV-->H(bit28)
	rtd_maskl(0xB8000838, 0xFF0FFFFF, 0x00F00000);  // GPIO_60, use Tcon26, CPV(AD2),
	rtd_maskl(0xb8000834, 0xFFFFFF0F, 0x000000F0);	// GPIO_58, use Tcon21, OE1(AC2),
	rtd_outl(0xB801bd04, 0x04000000);		// GPIO_58,60 Output,
	rtd_outl(0xb801bd1c, 0x04000000);		// GPIO_58,60 Output H,
	rtd_outl(0xb802D01C, 0x00000ACd);               //PN swap for CSOT panel
#endif
}

void panel_mLVDS_Sharp_70_Inch_tcon_setting(void)
{
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG1: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x000008C0);	// pif_clk_sel use sfg clk (for LS APHY), 30-bit Mode, Dout Enable,
						// delay chain pre/delay/post  = no_inverse/0ns/inverse, Pre-R/B Not Swap, Post R/B Not Swap,
	rtd_outl(0xb802D904, 0x07FFFFFF);	// PIF_Clock = Dclk/8, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 4n+0/4n+1/4n+2/4n+3 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D94C, 0x00000000);	// SEG12/SEG13 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x00000000);	// SEG14/SEG15 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x00000387);	// SFG Normal Mode, 4-SEG, 8-Port, H-Flip Enable,
						// ECO for active dummy for DRD Mode disable, 1.5 packet mode disable,
	rtd_outl(0xb802D968, 0x000003C0);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x0B3F0B40);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	rtd_outl(0xb802D980, 0x00000000);	// SEG12/SEG13 Start Address,
	rtd_outl(0xb802D984, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x00000300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x0000000C);	// Segement-flip Port2/3 Enable,
	rtd_outl(0xb802D99C, 0x0F000000);	// Final line length (1-pixel mode),
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x01181128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0xC0000000);	// LVDS/EPI Clock Enable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA00, 0x00000000);	// SEG12/SEG13 No middle dummy sub-pixel,
	rtd_outl(0xb802DA04, 0x00000000);	// SEG14/SEG15 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x80000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 4n+0,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 4n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 4n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 4n+3,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA20, 0x00000000);	// Last_ext_pixel_last_flip_line 4n+0/1/2/3 (no use),
	rtd_outl(0xb802DA94, 0x0EFF0EFF);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x0EFF0EFF);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD  1st output sub-pixel (r0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD  2nd output sub-pixel (g0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD  3rd output sub-pixel (b0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD  4th output sub-pixel (r2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD  5th output sub-pixel (g2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD  6th output sub-pixel (b2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD  7th output sub-pixel (r4) for line 4n+0/1/2/3
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD  8th output sub-pixel (g4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD  9th output sub-pixel (b4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD 10th output sub-pixel (r6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD 11th output sub-pixel (g6) for line 4n+0/1/2/3
	rtd_outl(0xb802DACC, 0x16161616);	// DRD 12th output sub-pixel (b6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD 13th output sub-pixel (r1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD 14th output sub-pixel (g1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD 15th output sub-pixel (b1) for line 4n+0/1/2/3
	rtd_outl(0xb802DADC, 0x07070707);	// DRD 16th output sub-pixel (r3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD 17th output sub-pixel (g3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD 18th output sub-pixel (b3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD 19th output sub-pixel (r5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD 20th output sub-pixel (g5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD 21st output sub-pixel (b5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD 22nd output sub-pixel (r7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD 23rd output sub-pixel (g7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD 24th output sub-pixel (b7) for line 4n+0/1/2/3
	rtd_outl(0xb802DB00, 0x00010203);	// Port A~D mapping,
	rtd_outl(0xb802DB04, 0x04050607);	// Port E~H mapping,
	rtd_outl(0xb802DB08, 0x00000000);	// Port I~L mapping,
	rtd_outl(0xb802DB0C, 0x00000000);	// Port M~P mapping,
	rtd_outl(0xb802DB10, 0x00000000);	// Port Q~T mapping,
	rtd_outl(0xb802DB14, 0x00000000);	// Port U~X mapping,
	rtd_outl(0xb802DB18, 0x00000000);	// SEG16/SEG17 No front/back dummy pixel,
	rtd_outl(0xb802DB1C, 0x00000000);	// SEG18/SEG19 No front/back dummy pixel,
	rtd_outl(0xb802DB20, 0x00000000);	// SEG20/SEG21 No front/back dummy pixel,
	rtd_outl(0xb802DB24, 0x00000000);	// SEG22/SEG23 No front/back dummy pixel,
	rtd_outl(0xb802DB28, 0x00000000);	// SEG16/SEG17 Start Address,
	rtd_outl(0xb802DB2C, 0x00000000);	// SEG18/SEG19 Start Address,
	rtd_outl(0xb802DB30, 0x00000000);	// SEG20/SEG21 Start Address,
	rtd_outl(0xb802DB34, 0x00000000);	// SEG22/SEG23 Start Address,
	rtd_outl(0xb802DB38, 0x00000000);	// SEG16/SEG17 No middle dummy sub-pixel,
	rtd_outl(0xb802DB3C, 0x00000000);	// SEG18/SEG19 No middle dummy sub-pixel,
	rtd_outl(0xb802DB40, 0x00000000);	// SEG20/SEG21 No middle dummy sub-pixel,
	rtd_outl(0xb802DB44, 0x00000000);	// SEG22/SEG23 No middle dummy sub-pixel,
	rtd_outl(0xb802DB68, 0x00000000);	// f/w ext_num for each port line 4n+0, all port ext_num = 0,
	rtd_outl(0xb802DB6C, 0x00000000);	// f/w ext_num for each port line 4n+1, all port ext_num = 0,
	rtd_outl(0xb802DB70, 0x00000000);	// f/w ext_num for each port line 4n+2, all port ext_num = 0,
	rtd_outl(0xb802DB74, 0x00000000);	// f/w ext_num for each port line 4n+3, all port ext_num = 0,
	rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+0,
	rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+1,
	rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+2,
	rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+3,

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG2: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802DA30, 0x00000000);	// SFG for OSD disable, data not inverse, not bypass SFG2,
						// auto config mode enable, dout enable, 1-SEG, 1-Port, H-Flip Disable,
	rtd_outl(0xb802DA34, 0x00000000);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802DA38, 0x00000000);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802DA3C, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802DA40, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802DA44, 0x01234567);	// Port A~H mapping,
	rtd_outl(0xb802DA48, 0x000000FF);	// Force to background enable,
	rtd_outl(0xb802DA4C, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802DA50, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802DA74, 0x00000780);	// Final line length (1-pixel mode),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Mini-LVDS use 1-pixel mode for 4K2K
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C80, 0xCCCCCCCC);	// P0(D/E/F/G) Pinshare to Mini-LVDS,
	rtd_outl(0xb8000C84, 0xCCCCCCCC);	// P3(A/B/C/D) Pinshare to Mini-LVDS,
	rtd_outl(0xb8000C88, 0xCCCCCCCC);	// P0(B/C), P3(E) Pinshare to Mini-LVDS,
	rtd_outl(0xb802D000, 0x00000000);	// PIF LVDS/mLVDS Mode,
	rtd_outl(0xb802D010, 0x00000000);	// LVDS Port Disable,
	rtd_outl(0xb802D01C, 0x00000ACD);	// Mini-LVDS use 4-Port 6-Pair, P2S LSB first, P/N Swap Enable, 8-Bit Mode,
						// Mini-LVDS Mirror Enable, Mini-LVDS Disable
	rtd_outl(0xb802D020, 0x00FFFFFF);	// Mini-LVDS Reset Pulse Enable for all Lane,
	rtd_outl(0xb802D024, 0x00000000);	// Mini-LVDS Reset Pulse Merge Tcon Disable,
	rtd_outl(0xb802D028, 0x00000000);	// Mini-LVDS Reset Pulse Only in Active Region, Mini-LVDS Clock inverse,
	rtd_outl(0xb802D02C, 0xFFFFFF1F);	// Mini-LVDS Reset Pulse F/W Setting,
	rtd_outl(0xb802D030, 0x00000000);	// Mini-LVDS Reset Pulse F/W Setting,
	rtd_outl(0xb802D100, 0x01234578);	// Any to Any pair assign : P0(A/B/C/D/E/F)/P1(A/B),
	rtd_outl(0xb802D104, 0x9ABC0123);	// Any to Any pair assign : P1(C/D/E/F)/P2(A/B/C/D),
	rtd_outl(0xb802D108, 0x45789ABC);	// Any to Any pair assign : P2(E/F)/P3(A/B/C/D/E/F),
	rtd_outl(0xb802D10C, 0x00006D6D);	// Any to Any pair assign : P0(A)/P1(A)/P2(A)/P3(A),
	rtd_outl(0xb802D01C, 0x00000AC5);	// Mini-LVDS Enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C74, 0x80800000);	// Low Speed APHY Enable, Lane Power Disable,
	rtd_outl(0xb8000C00, 0xC0006020);	// P0 PI_A1 = Phase24, PI_A2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C04, 0xC0006020);	// P1 PI_B1 = Phase24, PI_B2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C08, 0x03080000);	// X_PHY PI_AB = Phase0, CK7X = 1X Current, CK5X Duty Adjust Disable, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C0C, 0x4460F700);	// X_PHY Small Kvco, DIV248 = 2, VCO = 74.25*8*DIV248 = 1.188GHz,
						// X_PHY CKREF Not Inverse, CKPIXEL Inverse, Icp = 2uA, SC1 = 80pF, SC2 = 5.62pF, Rs = 12Kohm, PLLLDO = 2V,
						// X_PHY PI_A Enable, PI_B Enable,
	rtd_outl(0xb8000C10, 0xB4000000);	// P0 A-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm, Power Stage use LVDS Mode,
	rtd_outl(0xb8000C14, 0xB4000000);	// P0 B-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C18, 0xB4000000);	// P0 C-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C1C, 0xB5000000);	// P0 D-Pair mLVDS, Use PI_A2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C20, 0xB4000000);	// P0 E-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C24, 0xB4000000);	// P0 F-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C28, 0x00000000);	// P0 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000C30, 0xB4000000);	// P1 A-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C34, 0xB4000000);	// P1 B-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C38, 0xB4000000);	// P1 C-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C3C, 0xB5000000);	// P1 D-Pair mLVDS, Use PI_B2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C40, 0xB4000000);	// P1 E-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C44, 0xB4000000);	// P1 F-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000C48, 0x00000000);	// P1 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000C50, 0x096CD000);	// X_PHY, ISOURCE = IBHX, LDO2V(2.1V) Enable, LDO1V(0.95V) Enable, Swing = 4mA, VCM = 1.25V,
	rtd_outl(0xb8000C54, 0x0000007F);	// P0 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000C58, 0x00000000);	// P0 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000C5C, 0x0000007F);	// P1 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000C60, 0x00000000);	// P1 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000C64, 0x00000000);	// P0 Dummy Register,
	rtd_outl(0xb8000C6C, 0x00000000);	// P1 Dummy Register,
	rtd_outl(0xb8000D00, 0xC0006020);	// P2 PI_A1 = Phase24, PI_A2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D04, 0xC0006020);	// P3 PI_B1 = Phase24, PI_B2 = Phase08, CK7X = 1X Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D08, 0x03080000);	// Y_PHY PI_AB = Phase0, CK7X = 1X Current, CK5X Duty Adjust Disable, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000D0C, 0x4460F700);	// Y_PHY Small Kvco, DIV248 = 2, VCO = 74.25*8*DIV248 = 1.188GHz,
						// Y_PHY CKREF Inverse, CKPIXEL Inverse, Icp = 2uA, SC1 = 80pF, SC2 = 5.62pF, Rs = 12Kohm, PLLLDO = 2V,
						// Y_PHY PI_A Enable, PI_B Enable,
	rtd_outl(0xb8000D10, 0xB4000000);	// P2 A-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm, Power Stage use LVDS Mode,
	rtd_outl(0xb8000D14, 0xB4000000);	// P2 B-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D18, 0xB4000000);	// P2 C-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D1C, 0xB5000000);	// P2 D-Pair mLVDS, Use PI_A2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D20, 0xB4000000);	// P2 E-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D24, 0xB4000000);	// P2 F-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D28, 0x00000000);	// P2 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000D30, 0xB4000000);	// P3 A-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D34, 0xB4000000);	// P3 B-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D38, 0xB4000000);	// P3 C-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D3C, 0xB5000000);	// P3 D-Pair mLVDS, Use PI_B2, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D40, 0xB4000000);	// P3 E-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D44, 0xB4000000);	// P3 F-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
	rtd_outl(0xb8000D48, 0x00000000);	// P3 CK7X Not Inverse, PI CK7X Not Lag 0.5UI, Double Driving disable,
	rtd_outl(0xb8000D50, 0x096CD000);	// Y_PHY, ISOURCE = IBHX, LDO2V(2.1V) Enable, LDO1V(0.95V) Enable, Swing = 4mA, VCM = 1.25V,
	rtd_outl(0xb8000D54, 0x0000007F);	// P2 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000D58, 0x00000000);	// P2 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000D5C, 0x0000007F);	// P3 CML Pre-driver Current 1.2mA, Pre-Emphasis Disable, Internal Resistor Enable,
	rtd_outl(0xb8000D60, 0x00000000);	// P3 Pre-Driver use CMOS Mode,
	rtd_outl(0xb8000D64, 0x00000000);	// P2 Dummy Register,
	rtd_outl(0xb8000D6C, 0x00000000);	// P3 Dummy Register,
	rtd_outl(0xb8000DB0, 0x0AA00AA0);	// P0 G-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
						// P1 G-Pair mLVDS, Use PI_B1, Pre-Emphasis = 0,
						// Y_PHY Not Bypass DIV_M,
	rtd_outl(0xb8000DB4, 0x0B401680);	// P1 G-Pair SR Disable, internal resistor 300ohm,
						// P2 G-Pair mLVDS, Use PI_A1, SR Disable, Pre-Emphasis = 0, internal resistor 300ohm,
						// P3 G-Pair mLVDS, Use PI_B1, SR Disable, Pre-Emphasis = 0,
	rtd_outl(0xb8000DB8, 0x10000000);	// P3 G-Pair internal resistor 300ohm, PLT_C_LDO = 0.887V???
	rtd_outl(0xb8000DBC, 0x0000F000);	// TTL 8mA, Not Bypass DIV_CKO,
	rtd_outl(0xb8000C74, 0xFFFF7F7F);	// Low Speed APHY Enable, Lane Power Enable,
}

void panel_mLVDS_CSOT_GOA_tcon_setting(void)
{
	ppoverlay_double_buffer_ctrl_RBUS double_buffer_ctrl_reg;
	unsigned int count = 0x3fffff;

	printf(">>>>>>>>>>>>>>>> panel_mLVDS_CSOT_GOA_tcon_setting\n");

	double_buffer_ctrl_reg.regValue = rtd_inl(PPOVERLAY_Double_Buffer_CTRL_reg);
	double_buffer_ctrl_reg.dreg_dbuf_en = 1;
	rtd_outl(PPOVERLAY_Double_Buffer_CTRL_reg, double_buffer_ctrl_reg.regValue);
	double_buffer_ctrl_reg.dreg_dbuf_set = 1;
	rtd_outl(PPOVERLAY_Double_Buffer_CTRL_reg, double_buffer_ctrl_reg.regValue);
	while((double_buffer_ctrl_reg.dreg_dbuf_set)&& --count){
		double_buffer_ctrl_reg.regValue = rtd_inl(PPOVERLAY_Double_Buffer_CTRL_reg);
	}
	if(count==0){
		printf("wait double buffer timeout\n");
	}

	if (boot_power_on_mode != POWER_OFF)
		IO_Set(PIN_LVDS_ON_OFF, 1);

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x00100840);	// Common fifo use sfg_clk, 30-bit Mode, Dout Enable, Pre-R/B Swap disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x07FFFFFF);	// PIF_Clock = Dclk/8, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 8n+0/8n+1/8n+2/8n+3 no sub-pixel,
	rtd_outl(0xb802DBA8, 0x00000000);	// Line 8n+4/8n+5/8n+6/8n+7 no sub-pixel,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	//rtd_outl(0xb802D938, 0x00000000); // SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000); // SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000); // SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000); // SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x00000307);	// SFG Normal Mode, 4-SEG, 8-Port, H-Flip Disable,
	rtd_outl(0xb802D968, 0x000003C0);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x07800B40);	// SEG2/SEG3 Start Address,
	//rtd_outl(0xb802D970, 0x0A000C80); // SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000); // SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000); // SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000); // SEG10/SEG11 Start Address,
	//rtd_outl(0xb802D980, 0x00000000); // Front dummy line(4N+0) data,
	//rtd_outl(0xb802D984, 0x00000000); // Front dummy line(4N+1) data,
	//rtd_outl(0xb802D94C, 0x00000000); // Front dummy line(4N+2) data,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x0F000000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x01181128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F0, 0x00000000); // SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000); // SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000); // SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000); // SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);		// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	rtd_outl(0xb802DA10, 0x00000000);		// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00000000);		// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00000000);		// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00000000);		// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00000000);		// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00000000);		// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00000000);		// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	//rtd_outl(0xb802DAA0, 0x01010101); // DRD Data Mapping,
	//rtd_outl(0xb802DAA4, 0x05050505); // DRD Data Mapping,
	//rtd_outl(0xb802DAA8, 0x03030303); // DRD Data Mapping,
	//rtd_outl(0xb802DAAC, 0x07070707); // DRD Data Mapping,
	//rtd_outl(0xb802DAB0, 0x0B0B0B0B); // DRD Data Mapping,
	//rtd_outl(0xb802DAB4, 0x09090909); // DRD Data Mapping,
	//rtd_outl(0xb802DAB8, 0x0D0D0D0D); // DRD Data Mapping,
	//rtd_outl(0xb802DABC, 0x11111111); // DRD Data Mapping,
	//rtd_outl(0xb802DAC0, 0x0F0F0F0F); // DRD Data Mapping,
	//rtd_outl(0xb802DAC4, 0x13131313); // DRD Data Mapping,
	//rtd_outl(0xb802DAC8, 0x17171717); // DRD Data Mapping,
	//rtd_outl(0xb802DACC, 0x15151515); // DRD Data Mapping,
	//rtd_outl(0xb802DAD0, 0x02020202); // DRD Data Mapping,
	//rtd_outl(0xb802DAD4, 0x00000000); // DRD Data Mapping,
	//rtd_outl(0xb802DAD8, 0x04040404); // DRD Data Mapping,
	//rtd_outl(0xb802DADC, 0x08080808); // DRD Data Mapping,
	//rtd_outl(0xb802DAE0, 0x06060606); // DRD Data Mapping,
	//rtd_outl(0xb802DAE4, 0x0A0A0A0A); // DRD Data Mapping,
	//rtd_outl(0xb802DAE8, 0x0E0E0E0E); // DRD Data Mapping,
	//rtd_outl(0xb802DAEC, 0x0C0C0C0C); // DRD Data Mapping,
	//rtd_outl(0xb802DAF0, 0x10101010); // DRD Data Mapping,
	//rtd_outl(0xb802DAF4, 0x14141414); // DRD Data Mapping,
	//rtd_outl(0xb802DAF8, 0x12121212); // DRD Data Mapping,
	//rtd_outl(0xb802DAFC, 0x16161616); // DRD Data Mapping,
	rtd_outl(0xb802DB68, 0x55550000);	// ext_num setting for case_a and case_b,
	//rtd_outl(0xb802DB78, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E38);	// SFG Pattern Gen. Disable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	rtd_outl(0xb802DC1C, 0x00000000);	// Pattern Detect Function Disable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//Mini-LVDS MAC & DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D014, 0x00000441);	// Mini-LVDS disable, 4-Port 6-Pair, P2S LSB first, 8-Bit Mode,
	rtd_outl(0xb802D018, 0x00FFFFFF);	// Mini-LVDS Reset Pulse Enable for all Lane,
	rtd_outl(0xb802D01C, 0x00000000);	// Mini-LVDS Reset Pulse Merge Tcon Disable,
	rtd_outl(0xb802D020, 0x00000000);	// Mini-LVDS Reset Pulse Only in Active Region, Mini-LVDS Clock inverse,
	rtd_outl(0xb802D024, 0xFFFFFF1F);	// Mini-LVDS Reset Pulse F/W Setting,
	rtd_outl(0xb802D028, 0x00000000);	// Mini-LVDS Reset Pulse F/W Setting,
	rtd_outl(0xb802D02C, 0x80000000);	// Async FIFO use LVDS/mLVDS Mode, P/N Swap enable,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO Disable,
	rtd_outl(0xb802D03C, 0x00010010);	// Async FIFO reset enable, every vsync, apply after 16-clock,
	//rtd_outl(0xb802D060, 0x06050403); // Lane 0~3 pair assign,
	//rtd_outl(0xb802D064, 0x0201000d); // Lane 4~7 pair assign,
	//rtd_outl(0xb802D068, 0x0c0b0A09); // Lane 8~11 pair assign,
	//rtd_outl(0xb802D06C, 0x08071413); // Lane 12~15 pair assign,
	//rtd_outl(0xb802D070, 0x1211100f); // Lane 16~19 pair assign,
	//rtd_outl(0xb802D074, 0x0e1b1a19); // Lane 20~23 pair assign,
	//rtd_outl(0xb802D078, 0x18171615); // Lane 24~27 pair assign,
	rtd_outl(0xb802D060, 0x191a1b18);	// Lane 0~3 pair assign,
	rtd_outl(0xb802D064, 0x15161712);	// Lane 4~7 pair assign,
	rtd_outl(0xb802D068, 0x1314110e);	// Lane 8~11 pair assign,
	rtd_outl(0xb802D06C, 0x0f100b0c);	// Lane 12~15 pair assign,
	rtd_outl(0xb802D070, 0x0d0a0708);	// Lane 16~19 pair assign,
	rtd_outl(0xb802D074, 0x09040506);	// Lane 20~23 pair assign,
	rtd_outl(0xb802D078, 0x03000102);	// Lane 24~27 pair assign,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(1),
	rtd_outl(0xb8000C0C, 0x0005E380);	// Small KVCO, Through PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x0C000000);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_LS(1), EPI_DIVM(8),
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000002);	// TXPLL use LVDS/mLVDS feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F4C000);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C78, 0x00000600);	// CKIN_DIVN(8),
	//
	rtd_outl(0xb8000D00, 0x33002152);	// Lane0 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D10, 0x33002152);	// Lane1 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D20, 0x33002152);	// Lane2 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D30, 0x33000152);	// Lane3 : LS Mode, PI_SEL(PI_B1), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D40, 0x33002152);	// Lane4 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D50, 0x33002152);	// Lane5 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D60, 0x33002152);	// Lane6 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D70, 0x33002152);	// Lane7 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D80, 0x33002152);	// Lane8 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D90, 0x33002152);	// Lane9 : LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DA0, 0x33002152);	// Lane10: LS Mode, PI_SEL(PI_B2), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DB0, 0x33002152);	// Lane11: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DC0, 0x33002152);	// Lane12: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DD0, 0x33002152);	// Lane13: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E00, 0x33002152);	// Lane14: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E10, 0x33002152);	// Lane15: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E20, 0x33002152);	// Lane16: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E30, 0x33000152);	// Lane17: LS Mode, PI_SEL(PI_A1), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E40, 0x33002152);	// Lane18: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E50, 0x33002152);	// Lane19: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E60, 0x33002152);	// Lane20: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E70, 0x33002152);	// Lane21: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E80, 0x33002152);	// Lane22: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E90, 0x33002152);	// Lane23: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EA0, 0x33002152);	// Lane24: LS Mode, PI_SEL(PI_A2), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EB0, 0x33002152);	// Lane25: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EC0, 0x33002152);	// Lane26: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000ED0, 0x33002152);	// Lane27: LS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	//
	rtd_outl(0xb8000D04, 0x44000008);	// Lane0 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D14, 0x44000008);	// Lane1 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D24, 0x44000008);	// Lane2 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D34, 0x44000000);	// Lane3 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_B1),
	rtd_outl(0xb8000D44, 0x44000008);	// Lane4 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D54, 0x44000008);	// Lane5 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D64, 0x44000008);	// Lane6 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D74, 0x44000008);	// Lane7 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D84, 0x44000000);	// Lane8 : CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000D94, 0x44000000);	// Lane9 : CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DA4, 0x44000000);	// Lane10: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DB4, 0x44000000);	// Lane11: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DC4, 0x44000000);	// Lane12: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DD4, 0x44000000);	// Lane13: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E04, 0x44000000);	// Lane14: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E14, 0x44000000);	// Lane15: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E24, 0x44000000);	// Lane16: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E34, 0x44000000);	// Lane17: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E44, 0x44000000);	// Lane18: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E54, 0x44000000);	// Lane19: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E64, 0x44000008);	// Lane20: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E74, 0x44000008);	// Lane21: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E84, 0x44000008);	// Lane22: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E94, 0x44000008);	// Lane23: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EA4, 0x44000000);	// Lane24: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_A2),
	rtd_outl(0xb8000EB4, 0x44000008);	// Lane25: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EC4, 0x44000008);	// Lane26: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000ED4, 0x44000008);	// Lane27: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	//
	rtd_outl(0xb8000D88, 0x0000000A);	// Lane8 : PI_SEL(PI_DM), CMFB_EN(1),
	rtd_outl(0xb8000D98, 0x0000000A);	// Lane9 : PI_SEL(PI_DM), CMFB_EN(1),
	rtd_outl(0xb8000DA8, 0x00000002);	// Lane10: PI_SEL(PI_B2), CMFB_EN(1),
	rtd_outl(0xb8000DB8, 0x0000000A);	// Lane11: PI_SEL(PI_DM), CMFB_EN(1),
	rtd_outl(0xb8000DC8, 0x0000000A);	// Lane12: PI_SEL(PI_DM), CMFB_EN(1),
	rtd_outl(0xb8000DD8, 0x0000000A);	// Lane13: PI_SEL(PI_DM), CMFB_EN(1),
	rtd_outl(0xb8000E08, 0x0000000A);	// Lane14: PI_SEL(PI_DM), CMFB_EN(1),
	rtd_outl(0xb8000E18, 0x0000000A);	// Lane15: PI_SEL(PI_DM), CMFB_EN(1),
	rtd_outl(0xb8000E28, 0x0000000A);	// Lane16: PI_SEL(PI_DM), CMFB_EN(1),
	rtd_outl(0xb8000E38, 0x00000002);	// Lane17: PI_SEL(PI_A1), CMFB_EN(1),
	rtd_outl(0xb8000E48, 0x0000000A);	// Lane18: PI_SEL(PI_DM), CMFB_EN(1),
	rtd_outl(0xb8000E58, 0x0000000A);	// Lane19: PI_SEL(PI_DM), CMFB_EN(1),


	rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,
	////////////////////////////////////////////////////////////////////////////

	mdelay(80);
	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) LVDS/mLVDS Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x80000000);
	//
	// (8) mLVDS MAC Enable (Below Setting)
	rtd_part_outl(0xb802D014, 7, 7, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_part_outl(0xb8000D04, 27, 27, 0x1); // LANE0
	rtd_part_outl(0xb8000D14, 27, 27, 0x1); // LANE1
	rtd_part_outl(0xb8000D24, 27, 27, 0x1); // LANE2
	rtd_part_outl(0xb8000D34, 27, 27, 0x1); // LANE3
	rtd_part_outl(0xb8000D44, 27, 27, 0x1); // LANE4
	rtd_part_outl(0xb8000D54, 27, 27, 0x1); // LANE5
	rtd_part_outl(0xb8000D64, 27, 27, 0x1); // LANE6
	rtd_part_outl(0xb8000D74, 27, 27, 0x1); // LANE7
	rtd_part_outl(0xb8000D84, 27, 27, 0x1); // LANE8
	rtd_part_outl(0xb8000D94, 27, 27, 0x1); // LANE9
	rtd_part_outl(0xb8000DA4, 27, 27, 0x1); // LANE10
	rtd_part_outl(0xb8000DB4, 27, 27, 0x1); // LANE11
	rtd_part_outl(0xb8000DC4, 27, 27, 0x1); // LANE12
	rtd_part_outl(0xb8000DD4, 27, 27, 0x1); // LANE13
	rtd_part_outl(0xb8000E04, 27, 27, 0x1); // LANE14
	rtd_part_outl(0xb8000E14, 27, 27, 0x1); // LANE15
	rtd_part_outl(0xb8000E24, 27, 27, 0x1); // LANE16
	rtd_part_outl(0xb8000E34, 27, 27, 0x1); // LANE17
	rtd_part_outl(0xb8000E44, 27, 27, 0x1); // LANE18
	rtd_part_outl(0xb8000E54, 27, 27, 0x1); // LANE19
	rtd_part_outl(0xb8000E64, 27, 27, 0x1); // LANE20
	rtd_part_outl(0xb8000E74, 27, 27, 0x1); // LANE21
	rtd_part_outl(0xb8000E84, 27, 27, 0x1); // LANE22
	rtd_part_outl(0xb8000E94, 27, 27, 0x1); // LANE23
	rtd_part_outl(0xb8000EA4, 27, 27, 0x1); // LANE24
	rtd_part_outl(0xb8000EB4, 27, 27, 0x1); // LANE25
	rtd_part_outl(0xb8000EC4, 27, 27, 0x1); // LANE26
	rtd_part_outl(0xb8000ED4, 27, 27, 0x1); // LANE27
	//
	// (11) Panel Power Enable (SW Control),

	mdelay(80);
	////////////////////////////////////////////////////////////////////////////
	rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
	rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,
	////////////////////////////////////////////////////////////////////////////
	// Tcon23 (TP)
	rtd_outl(0xb802D4f0, 0x10580164);			   // H_start/H_end,
	rtd_outl(0xb802D4f4, 0x000008C9);			   // V_start/V_end,
	rtd_outl(0xb802D4f8, 0x00000080);			   // Control,
	////////////////////////////////////////////////////////////////////////////
	// Tcon7 (POL2)
	rtd_outl(0xB802D2f0, 0x08970897);			   // H_start/H_end,
	rtd_outl(0xB802D2f4, 0x00240024);			   // V_start/V_end,
	rtd_outl(0xb802D2f8, 0x00000480);			   // Control,
	rtd_outl(0xb802D300, 0x00000000);			   // Across Frame CTRL,
	// Tcon8 (POL1)
	rtd_outl(0xb802D310, 0x08970897);			   // H_start/H_end,
	rtd_outl(0xb802D314, 0x00001192);			   // V_start/V_end,
	rtd_outl(0xb802D318, 0x00000383);			   // Control,(00000383-->2 line inv,  -->1 frame inv)
	rtd_outl(0xb802D31c, 0x00040002);			   // Across Frame CTRL,
	////////////////////////////////////////////////////////////////////////////
	mdelay(25);
	// Tcon25 (CLK1)
	rtd_outl(0xb802d530, 0x0c0005f0);				// H_start/H_end,
	rtd_outl(0xb802d534, 0x002A08a6);			   // V_start/V_end,
	rtd_outl(0xb802d538, 0x00000380);					   // Control,
	rtd_outl(0xb802d53c, 0x00020001);					   // RP,HP
	////////////////////////////////////////////////////////////////////////////
	// Tcon2 (CLK2)
	rtd_outl(0xb802d250, 0x10FF0B00);			   // H_start/H_end,
	rtd_outl(0xb802d254, 0x002D08a6);			   // V_start/V_end,
	rtd_outl(0xb802d258, 0x00000380);			   // Control,
	rtd_outl(0xb802d25c, 0x00020001);					   // RP,HP
	////////////////////////////////////////////////////////////////////////////
	// Tcon19 (CLK3)
	rtd_outl(0xb802d470, 0x0C0005F0);			   // H_start/H_end,
	rtd_outl(0xb802d474, 0x002B08a6);			   // V_start/V_end,
	rtd_outl(0xb802d478, 0x00000380);
	rtd_outl(0xb802d47c, 0x00020001);					   // RP,HP
	////////////////////////////////////////////////////////////////////////////
	// Tcon4 (CLK4)
	rtd_outl(0xb802D290, 0x10FF0B00);			   // H_start/H_end,(0DC00260)
	rtd_outl(0xb802D294, 0x002E08a6);			   // V_start/V_end,
	rtd_outl(0xb802D298, 0x00000380);			   // Control,
	rtd_outl(0xb802D29C, 0x00020001);					  // RP,HP
	////////////////////////////////////////////////////////////////////////////
	mdelay(5);
	// Tcon1 (STV)
	rtd_outl(0xb802D230, 0x027E027E);			   // H_start/H_end,
	rtd_outl(0xb802D234, 0x0029002d);			   // V_start/V_end,
	rtd_outl(0xb802D238, 0x00000180);			   // Control,
	////////////////////////////////////////////////////////////////////////////
	// Tcon21 (LC)
	rtd_outl(0xb802d4b0, 0x04CC04CC);			  // H_start/H_end,
	rtd_outl(0xb802d4b4, 0x08C708C7);			   // V_start/V_end,
	rtd_outl(0xb802d4b8, 0x00000480);			   // Control,
	rtd_outl(0xb802d4c0, 0x00000064);			   // cross frame control,
	////////////////////////////////////////////////////////////////////////////
}

void panel_chpi_55inch_uhd60_6lane_himax(void)
{
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x00100840);	// Common fifo use sfg_clk, 30-bit Mode, Dout Enable, Pre-R/B Swap disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00005000);	// Line 8n+0/8n+1 shift 1 sub-pixel, Line 8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00005000);	// Line 8n+4/8n+5 shift 1 sub-pixel, Line 8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x10000585);	// SFG DRD Mode, 1.5 packet mode disable, H-Flip enable, 6-SEG, 6-Port,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	//rtd_outl(0xb802D980, 0x00000000);	// Front dummy line(4N+0) data,
	//rtd_outl(0xb802D984, 0x00000000);	// Front dummy line(4N+1) data,
	//rtd_outl(0xb802D94C, 0x00000000);	// Front dummy line(4N+2) data,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00400000);     	// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	rtd_outl(0xb802DA10, 0x00400000);     	// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00030000);     	// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00030000);     	// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00400000);     	// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00400000);     	// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00030000);     	// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00030000);     	// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	rtd_outl(0xb802DAA0, 0x01010101);	// DRD Data Mapping,
	rtd_outl(0xb802DAA4, 0x05050505);	// DRD Data Mapping,
	rtd_outl(0xb802DAA8, 0x03030303);	// DRD Data Mapping,
	rtd_outl(0xb802DAAC, 0x07070707);	// DRD Data Mapping,
	rtd_outl(0xb802DAB0, 0x0B0B0B0B);	// DRD Data Mapping,
	rtd_outl(0xb802DAB4, 0x09090909);	// DRD Data Mapping,
	rtd_outl(0xb802DAB8, 0x0D0D0D0D);	// DRD Data Mapping,
	rtd_outl(0xb802DABC, 0x11111111);	// DRD Data Mapping,
	rtd_outl(0xb802DAC0, 0x0F0F0F0F);	// DRD Data Mapping,
	rtd_outl(0xb802DAC4, 0x13131313);	// DRD Data Mapping,
	rtd_outl(0xb802DAC8, 0x17171717);	// DRD Data Mapping,
	rtd_outl(0xb802DACC, 0x15151515);	// DRD Data Mapping,
	rtd_outl(0xb802DAD0, 0x02020202);	// DRD Data Mapping,
	rtd_outl(0xb802DAD4, 0x00000000);	// DRD Data Mapping,
	rtd_outl(0xb802DAD8, 0x04040404);	// DRD Data Mapping,
	rtd_outl(0xb802DADC, 0x08080808);	// DRD Data Mapping,
	rtd_outl(0xb802DAE0, 0x06060606);	// DRD Data Mapping,
	rtd_outl(0xb802DAE4, 0x0A0A0A0A);	// DRD Data Mapping,
	rtd_outl(0xb802DAE8, 0x0E0E0E0E);	// DRD Data Mapping,
	rtd_outl(0xb802DAEC, 0x0C0C0C0C);	// DRD Data Mapping,
	rtd_outl(0xb802DAF0, 0x10101010);	// DRD Data Mapping,
	rtd_outl(0xb802DAF4, 0x14141414);	// DRD Data Mapping,
	rtd_outl(0xb802DAF8, 0x12121212);	// DRD Data Mapping,
	rtd_outl(0xb802DAFC, 0x16161616);	// DRD Data Mapping,
	rtd_outl(0xb802DB68, 0x55550000);	// ext_num setting for case_a and case_b,
	//rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E38);	// SFG Pattern Gen. Disable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	#if 0
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	rtd_outl(0xb802DC1C, 0x00000000);	// Pattern Detect Function Disable,
	#endif
	rtd_outl(0xb802D904, 0x05FFFFFF);	// PIF_Clock = Dclk/6, Force to background enable,
	//
	//---------------------------------------------------------------------------------------------------------------------------------
	//CHPI_BCC Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb8000800, 0xFFFFFF0F, 0x00000060);	// GPIO_3 pinshare to BOE_BCC_src0,
	rtd_maskl(0xb8000CBC, 0xFFFFFF3F, 0x00000000);	// BOE_BCC use epi_lock_src0,
	rtd_maskl(0xb8000814, 0x7FFFFFFF, 0x80000000);	// GPIO_3 use input Vth 1.8V,
	//
	//---------------------------------------------------------------------------------------------------------------------------------
	//CHPI MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802DD00, 0x36000000);	// phy_clk setting (ns), dec2hex(round(10^9/297M*16)) = 0x36, 8-bit mode, 1-pair mode, CHPI disable,
	rtd_outl(0xb802DD04, 0x001F1F4F);	// standby_time = 31us (spec 10us), LT_time = 500us, LSP = 15-time,
	rtd_outl(0xb802DD08, 0x01F00000);	// CDR Pattern = 10'b0000011111, insert K3 every 16-lane at active_line(n+1) for port(n), n = [11,0],
	rtd_outl(0xb802DD0C, 0x01FA01FB);	// K1_prime/K2_prime symbol code definition,
	rtd_outl(0xb802DD10, 0x01F901F8);	// K3_prime/K4_prime symbol code definition,
	rtd_outl(0xb802DD14, 0x0157011F);	// G1_prime/G2_prime symbol code definition,
	rtd_outl(0xb802DD18, 0x018F01C7);	// G3_prime/G4_prime symbol code definition,
	rtd_outl(0xb802DD1C, 0x00010203);	// insert K3 at LSP_byte(n) for port(n), n = [3,0],
	rtd_outl(0xb802DD20, 0x04050607);	// insert K3 at LSP_byte(n) for port(n), n = [7,4],
	rtd_outl(0xb802DD24, 0x08090A0B);	// insert K3 at LSP_byte(n) for port(n), n = [11,8],
	rtd_outl(0xb802DD28, 0x001A1500);	// CTRL_L(FSYNC) use TCON25, CTRL_L(POL) use TCON20, CTRL_L(POLC) use register setting,
	rtd_outl(0xb802DD2C, 0x00001400);	// CTRL_L(BKDU) use register setting, CTRL_L(POL2) use TCON19, CTRL_L(POL3) use register setting,
	rtd_outl(0xb802DD30, 0x00000000);	// CTRL_L(byte0) for port00~port03 setting,
	rtd_outl(0xb802DD34, 0x00000000);	// CTRL_L(byte0) for port04~port07 setting,
	rtd_outl(0xb802DD38, 0x00000000);	// CTRL_L(byte0) for port08~port11 setting,
	rtd_outl(0xb802DD3C, 0x0A0A0A0A);	// CTRL_L(byte1) for port00~port03 even line setting,
	rtd_outl(0xb802DD40, 0x0A0A0A0A);	// CTRL_L(byte1) for port04~port07 even line setting,
	rtd_outl(0xb802DD44, 0x0A0A0A0A);	// CTRL_L(byte1) for port08~port11 even line setting,
	rtd_outl(0xb802DD48, 0x0A0A0A0A);	// CTRL_L(byte1) for port00~port03 odd line setting,
	rtd_outl(0xb802DD4C, 0x0A0A0A0A);	// CTRL_L(byte1) for port04~port07 odd line setting,
	rtd_outl(0xb802DD50, 0x0A0A0A0A);	// CTRL_L(byte1) for port08~port11 odd line setting,
	rtd_outl(0xb802DD54, 0x27272727);	// CTRL_L(byte2) for port00~port03 even line setting,
	rtd_outl(0xb802DD58, 0x27272727);	// CTRL_L(byte2) for port04~port07 even line setting,
	rtd_outl(0xb802DD5C, 0x27272727);	// CTRL_L(byte2) for port08~port11 even line setting,
	rtd_outl(0xb802DD60, 0x27272727);	// CTRL_L(byte2) for port00~port03 odd line setting,
	rtd_outl(0xb802DD64, 0x27272727);	// CTRL_L(byte2) for port04~port07 odd line setting,
	rtd_outl(0xb802DD68, 0x27272727);	// CTRL_L(byte2) for port08~port11 odd line setting,
	rtd_outl(0xb802DD6C, 0x00000000);	// CTRL_L(byte3) for port00~port03 setting,
	rtd_outl(0xb802DD70, 0x00000000);	// CTRL_L(byte3) for port04~port07 setting,
	rtd_outl(0xb802DD74, 0x00000000);	// CTRL_L(byte3) for port08~port11 setting,
	rtd_outl(0xb802DD78, 0x00000000);	// CTRL_L(byte4) for port00~port03 setting,
	rtd_outl(0xb802DD7C, 0x00000000);	// CTRL_L(byte4) for port04~port07 setting,
	rtd_outl(0xb802DD80, 0x00000000);	// CTRL_L(byte4) for port08~port11 setting,
	rtd_outl(0xb802DD84, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port0,
	rtd_outl(0xb802DD88, 0xC0000303);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port0,
	rtd_outl(0xb802DD8C, 0x00000000);	// CTRL_F(byte8~byte11) setting,
	rtd_outl(0xb802DD90, 0xFCAB9376);	// CTRL_F(byte12~byte15) setting,
	rtd_outl(0xb802DD94, 0x5B440400);	// CTRL_F(byte16~byte19) setting,
	rtd_outl(0xb802DD98, 0x0004444B);	// CTRL_F(byte20~byte23) setting,
	rtd_outl(0xb802DD9C, 0x7995A9D0);	// CTRL_F(byte24~byte27) setting,
	rtd_outl(0xb802DDA0, 0x02271A74);	// CTRL_F(byte28~byte31) setting,
	rtd_outl(0xb802DDA4, 0x00000000);	// CTRL_F(byte32~byte35) setting,
	rtd_outl(0xb802DDA8, 0x00000000);	// CTRL_F(byte36~byte39) setting,
	rtd_outl(0xb802DDAC, 0x00000000);	// CTRL_F(byte40~byte43) setting,
	rtd_outl(0xb802DDB0, 0x00000000);	// CTRL_F(byte44~byte47) setting,
	rtd_outl(0xb802DDB4, 0x00000000);	// CTRL_F(byte48~byte51) setting,
	rtd_outl(0xb802DDB8, 0x00000000);	// CTRL_F(byte52~byte55) setting,
	rtd_outl(0xb802DDBC, 0x00000000);	// CTRL_F(byte56~byte59) setting,
	rtd_outl(0xb802DDC0, 0xFFF00000);	// Each port extend 1-pixel, use G16(X) for scrambler,
	//
	rtd_outl(0xb802DE00, 0x46000000);	// hs_to_den_distance = (280/2)*24/(6*8) = 0x46, dummy line number setting, Mac6 not support dummy line,
	rtd_outl(0xb802DE04, 0x00000000);	// Dummy line color select, not support dummy line Mac6,
	rtd_outl(0xb802DE08, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port1, others no use,
	rtd_outl(0xb802DE0C, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port1, others no use,
	rtd_outl(0xb802DE10, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port2, others no use,
	rtd_outl(0xb802DE14, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port2, others no use,
	rtd_outl(0xb802DE18, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port3, others no use,
	rtd_outl(0xb802DE1C, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port3, others no use,
	rtd_outl(0xb802DE20, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port4, others no use,
	rtd_outl(0xb802DE24, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port4, others no use,
	rtd_outl(0xb802DE28, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port5, others no use,
	rtd_outl(0xb802DE2C, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port5, others no use,
	rtd_outl(0xb802DE30, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port6, others no use,
	rtd_outl(0xb802DE34, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port6, others no use,
	rtd_outl(0xb802DE38, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port7, others no use,
	rtd_outl(0xb802DE3C, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port7, others no use,
	rtd_outl(0xb802DE40, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port8, others no use,
	rtd_outl(0xb802DE44, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port8, others no use,
	rtd_outl(0xb802DE48, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port9, others no use,
	rtd_outl(0xb802DE4C, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port9, others no use,
	rtd_outl(0xb802DE50, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port10, others no use,
	rtd_outl(0xb802DE54, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port10, others no use,
	rtd_outl(0xb802DE58, 0x186041C0);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port11, others no use,
	rtd_outl(0xb802DE5C, 0x0000C000);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port11, others no use,
	//
	//*****************************************************
	//0xb802DDC4~0xb802DDC8 for BBC TX,
	//0xb802DDCC for BBC RX,
	//*****************************************************
	rtd_outl(0xb802DDD0, 0x0FA12C08);	// BCC RX wait time 250us after received portocol error,
						// BCC RX wait timeout 300us (10us < spec < 300us),
						// BCC Preamble number 8ea (spec >= 8)
	rtd_outl(0xb802DDD4, 0x000000FA);	// 1MHz (1us) divider for RBUS_CLK (250MHz),
	rtd_outl(0xb802DDD8, 0x00000801);	// BCC reset disable, BCC IRQ Low 8us (spec 8us), use BCC mode1 when in BCC mode1/2 case,
						// BCC HW auto change to Training Period for BCC Mode1/2, BCC enable,
	//0xb802DDE4 for IRQ setting,
	rtd_outl(0xb802DDE8, 0x900000C8);	// BCC debounce enable, BCC use hw mode,
	rtd_outl(0xb802DDF0, 0x0000FFF3);	// BCC debounce enable, BCC use hw mode,
	//
	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D02C, 0x00000004);	// Async FIFO use CHPI Mode, P/N Swap Disable,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO Disable,
	rtd_outl(0xb802D03C, 0x00050010);	// Async FIFO reset enable, r/w collision reset, apply after 16-clock,
	rtd_outl(0xb802D060, 0xFFFFFFFF);	// Lane 0~3 pair assign,
	rtd_outl(0xb802D064, 0xFFFFFFFF);	// Lane 4~7 pair assign,
	rtd_outl(0xb802D068, 0x11FF12FF);	// Lane 8~11 pair assign,
	rtd_outl(0xb802D06C, 0x13FF0EFF);	// Lane 12~15 pair assign,
	rtd_outl(0xb802D070, 0x0FFF10FF);	// Lane 16~19 pair assign,
	rtd_outl(0xb802D074, 0xFFFFFFFF);	// Lane 20~23 pair assign,
	rtd_outl(0xb802D078, 0xFFFFFFFF);	// Lane 24~27 pair assign,
	//
	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(1),
	rtd_outl(0xb8000C0C, 0x8005E3B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000000);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(1),
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000023);	// TXPLL use CHPI feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01D2C001);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(1),
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C78, 0x00000E00);	// CKIN_DIVN(16),
	//
	rtd_outl(0xb8000D00, 0x77002000);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D10, 0x77002000);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D20, 0x77002000);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D30, 0x77002000);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D40, 0x77002000);	// Lane4 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D50, 0x77002000);	// Lane5 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D60, 0x77002000);	// Lane6 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D70, 0x77002000);	// Lane7 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D80, 0x66002841);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D90, 0x66002841);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DA0, 0x66002868);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DB0, 0x66002868);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DC0, 0x6600286A);	// Lane12: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DD0, 0x6600286A);	// Lane13: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E00, 0x6600286A);	// Lane14: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E10, 0x6600286A);	// Lane15: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E20, 0x66002868);	// Lane16: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E30, 0x66002868);	// Lane17: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E40, 0x66002841);	// Lane18: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E50, 0x66002841);	// Lane19: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E60, 0x77002000);	// Lane20: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E70, 0x77002000);	// Lane21: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E80, 0x77002000);	// Lane22: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E90, 0x77002000);	// Lane23: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EA0, 0x77002000);	// Lane24: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EB0, 0x77002000);	// Lane25: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EC0, 0x77002000);	// Lane26: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000ED0, 0x77002000);	// Lane27: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	//
	rtd_outl(0xb8000D04, 0x44000008);	// Lane0 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D14, 0x44000008);	// Lane1 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D24, 0x44000008);	// Lane2 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D34, 0x44000008);	// Lane3 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D44, 0x44000008);	// Lane4 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D54, 0x44000008);	// Lane5 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D64, 0x44000008);	// Lane6 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D74, 0x44000008);	// Lane7 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D84, 0x44000000);	// Lane8 : CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000D94, 0x44000000);	// Lane9 : CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DA4, 0x44000000);	// Lane10: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DB4, 0x44000000);	// Lane11: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DC4, 0x44000000);	// Lane12: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DD4, 0x44000000);	// Lane13: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E04, 0x44000000);	// Lane14: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E14, 0x44000000);	// Lane15: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E24, 0x44000000);	// Lane16: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E34, 0x44000000);	// Lane17: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E44, 0x44000000);	// Lane18: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E54, 0x44000000);	// Lane19: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E64, 0x44000008);	// Lane20: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E74, 0x44000008);	// Lane21: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E84, 0x44000008);	// Lane22: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E94, 0x44000008);	// Lane23: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EA4, 0x44000008);	// Lane24: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EB4, 0x44000008);	// Lane25: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EC4, 0x44000008);	// Lane26: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000ED4, 0x44000008);	// Lane27: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	//
	rtd_outl(0xb8000D88, 0x0000000A);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x0000000A);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x0000000A);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x0000000A);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DC8, 0x0000000A);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DD8, 0x0000000A);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E08, 0x0000000A);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E18, 0x0000000A);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E28, 0x0000000A);	// Lane16: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E38, 0x0000000A);	// Lane17: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E48, 0x0000000A);	// Lane18: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E58, 0x0000000A);	// Lane19: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	//
	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) CHPI/LVDS Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x80008000);
	//
	// (8) CHPI MAC Enable (Below Setting)
	rtd_part_outl(0xb802DD00, 0, 0, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_part_outl(0xb8000D84, 27, 27, 0x1);	// LANE8
	rtd_part_outl(0xb8000DA4, 27, 27, 0x1);	// LANE10
	rtd_part_outl(0xb8000DC4, 27, 27, 0x1);	// LANE12
	rtd_part_outl(0xb8000E04, 27, 27, 0x1);	// LANE14
	rtd_part_outl(0xb8000E24, 27, 27, 0x1);	// LANE16
	rtd_part_outl(0xb8000E44, 27, 27, 0x1);	// LANE18
	ScalerTimer_DelayXms(0x1);		// Wait 1ms,
	//
	// (11) Panel Power Enable (SW Control),
	//
	// (12) BCC BC Transaction (with link training start),
	rtd_outl(0xb802DDC4, 0x00C80001);	// BCC BC Transaction Byte3~Byte0,
	rtd_outl(0xb802DDC8, 0x0000C900);	// BCC BC Transaction Byte5~Byte4,
	rtd_part_outl(0xb802DDD8, 1, 1, 0x1);
	rtd_part_outl(0xb802DDD4, 31, 31, 0x1);
}

void panel_chpi_55inch_uhd60_6lane_ilitek(void)
{
		//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x00100840);	// Common fifo use sfg_clk, 30-bit Mode, Dout Enable, Pre-R/B Swap disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x05FFFFFF);	// PIF_Clock = Dclk/6, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00005000);	// Line 8n+0/8n+1 shift 1 sub-pixel, Line 8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00005000);	// Line 8n+4/8n+5 shift 1 sub-pixel, Line 8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x10000585);	// SFG DRD Mode, 1.5 packet mode disable, H-Flip enable, 6-SEG, 6-Port,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x80000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00400000);     	// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	rtd_outl(0xb802DA10, 0x00400000);     	// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00030000);     	// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00030000);     	// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00400000);     	// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00400000);     	// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00030000);     	// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00030000);     	// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	rtd_outl(0xb802DAA0, 0x01010101);	// DRD  1st output sub-pixel (r0) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAA4, 0x05050505);	// DRD  2nd output sub-pixel (g0) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAA8, 0x03030303);	// DRD  3rd output sub-pixel (b0) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAAC, 0x07070707);	// DRD  4th output sub-pixel (r2) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAB0, 0x0B0B0B0B);	// DRD  5th output sub-pixel (g2) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAB4, 0x09090909);	// DRD  6th output sub-pixel (b2) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAB8, 0x0D0D0D0D);	// DRD  7th output sub-pixel (r4) for line 4n+0/1/2/3,
	rtd_outl(0xb802DABC, 0x11111111);	// DRD  8th output sub-pixel (g4) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAC0, 0x0F0F0F0F);	// DRD  9th output sub-pixel (b4) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAC4, 0x13131313);	// DRD 10th output sub-pixel (r6) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAC8, 0x17171717);	// DRD 11th output sub-pixel (g6) for line 4n+0/1/2/3,
	rtd_outl(0xb802DACC, 0x15151515);	// DRD 12th output sub-pixel (b6) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAD0, 0x02020202);	// DRD 13th output sub-pixel (r1) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAD4, 0x00000000);	// DRD 14th output sub-pixel (g1) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAD8, 0x04040404);	// DRD 15th output sub-pixel (b1) for line 4n+0/1/2/3,
	rtd_outl(0xb802DADC, 0x08080808);	// DRD 16th output sub-pixel (r3) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAE0, 0x06060606);	// DRD 17th output sub-pixel (g3) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAE4, 0x0A0A0A0A);	// DRD 18th output sub-pixel (b3) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAE8, 0x0E0E0E0E);	// DRD 19th output sub-pixel (r5) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAEC, 0x0C0C0C0C);	// DRD 20th output sub-pixel (g5) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAF0, 0x10101010);	// DRD 21st output sub-pixel (b5) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAF4, 0x14141414);	// DRD 22nd output sub-pixel (r7) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAF8, 0x12121212);	// DRD 23rd output sub-pixel (g7) for line 4n+0/1/2/3,
	rtd_outl(0xb802DAFC, 0x16161616);	// DRD 24th output sub-pixel (b7) for line 4n+0/1/2/3,
	rtd_outl(0xb802DB68, 0x55550000);	// ext_num setting for case_a and case_b,
	//rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E38);	// SFG Pattern Gen. Disable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	rtd_outl(0xb802DC1C, 0x00000000);	// Pattern Detect Function Disable,
	rtd_outl(0xb802DCA0, 0x00000000);	// V18 EPI AVCOM Delay Function Disable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCK Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb80008B0, 0xFFFFFF0F, 0x00000080);	// GPIO_114 pinshare to BOE_BBC,
	rtd_maskl(0xb80008CC, 0xBFFFFFFF, 0x40000000);	// GPIO_114 use input Vth 1.8V,

	//---------------------------------------------------------------------------------------------------------------------------------
	//CHPI MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D800, 0x36000000);	// phy_clk setting (ns), dec2hex(round(10^9/297M*16)) = 0x36, CHPI disable,
	rtd_outl(0xb802D804, 0x001F1F48);	// standby_time = 31us (spec 10us), LT_time = 500us, LSP = 8-time,
	rtd_outl(0xb802D808, 0x01F00000);	// CDR Pattern = 10'b0000011111, insert K3 every 16-lane at active_line(n+1) for port(n), n = [11,0],
	rtd_outl(0xb802D80C, 0x01FA01FB);	// K1_prime/K2_prime symbol code definition,
	rtd_outl(0xb802D810, 0x01F901F8);	// K3_prime/K4_prime symbol code definition,
	rtd_outl(0xb802D814, 0x0157011F);	// G1_prime/G2_prime symbol code definition,
	rtd_outl(0xb802D818, 0x018F01C7);	// G3_prime/G4_prime symbol code definition,
	rtd_outl(0xb802D81C, 0x00010203);	// insert K3 at LSP_byte(n) for port(n), n = [3,0],
	rtd_outl(0xb802D820, 0x04050607);	// insert K3 at LSP_byte(n) for port(n), n = [7,4],
	rtd_outl(0xb802D824, 0x08090A0B);	// insert K3 at LSP_byte(n) for port(n), n = [11,8],
	rtd_outl(0xb802D828, 0x001A1500);	// CTRL_L(FSYNC) use TCON25, CTRL_L(POL) use TCON20, CTRL_L(POLC) use register setting,
	rtd_outl(0xb802D82C, 0x00001400);	// CTRL_L(POL2) use TCON19, CTRL_L(POL3) use register setting,
	rtd_outl(0xb802D830, 0x17171717);	// CTRL_L(byte0) for port00~port03 setting,
	rtd_outl(0xb802D834, 0x17171717);	// CTRL_L(byte0) for port04~port07 setting,
	rtd_outl(0xb802D838, 0x17171717);	// CTRL_L(byte0) for port08~port11 setting,
	rtd_outl(0xb802D83C, 0x00000000);	// CTRL_L(byte1) for port00~port03 even line setting,
	rtd_outl(0xb802D840, 0x00000000);	// CTRL_L(byte1) for port04~port07 even line setting,
	rtd_outl(0xb802D844, 0x00000000);	// CTRL_L(byte1) for port08~port11 even line setting,
	rtd_outl(0xb802D848, 0x00000000);	// CTRL_L(byte1) for port00~port03 odd line setting,
	rtd_outl(0xb802D84C, 0x00000000);	// CTRL_L(byte1) for port04~port07 odd line setting,
	rtd_outl(0xb802D850, 0x00000000);	// CTRL_L(byte1) for port08~port11 odd line setting,
	rtd_outl(0xb802D854, 0x26262626);	// CTRL_L(byte2) for port00~port03 even line setting,
	rtd_outl(0xb802D858, 0x26262626);	// CTRL_L(byte2) for port04~port07 even line setting,
	rtd_outl(0xb802D85C, 0x26262626);	// CTRL_L(byte2) for port08~port11 even line setting,
	rtd_outl(0xb802D860, 0x26262626);	// CTRL_L(byte2) for port00~port03 odd line setting,
	rtd_outl(0xb802D864, 0x26262626);	// CTRL_L(byte2) for port04~port07 odd line setting,
	rtd_outl(0xb802D868, 0x26262626);	// CTRL_L(byte2) for port08~port11 odd line setting,
	rtd_outl(0xb802D86C, 0x10101010);	// CTRL_L(byte3) for port00~port03 setting,
	rtd_outl(0xb802D870, 0x10101010);	// CTRL_L(byte3) for port04~port07 setting,
	rtd_outl(0xb802D874, 0x10101010);	// CTRL_L(byte3) for port08~port11 setting,
	rtd_outl(0xb802D878, 0x06060606);	// CTRL_L(byte4) for port00~port03 setting,
	rtd_outl(0xb802D87C, 0x06060606);	// CTRL_L(byte4) for port04~port07 setting,
	rtd_outl(0xb802D880, 0x06060606);	// CTRL_L(byte4) for port08~port11 setting,
	rtd_outl(0xb802D884, 0x143D0000);	// CTRL_F(byte0~byte3) setting,
	rtd_outl(0xb802D888, 0x00600204);	// CTRL_F(byte4~byte7) setting, enable customer configuration byte29~byte31, scrambler use LFSR16,
	rtd_outl(0xb802D88C, 0x120000BC);	// CTRL_F(byte8~byte11) setting, disable customer special byte, PGMA setting,
	rtd_outl(0xb802D890, 0x50980000);	// CTRL_F(byte12~byte15) setting, PGMA setting,
	rtd_outl(0xb802D894, 0x00000000);	// CTRL_F(byte16~byte19) setting, PGMA setting,
	rtd_outl(0xb802D898, 0x00000000);	// CTRL_F(byte20~byte23) setting, PGMA setting,
	rtd_outl(0xb802D89C, 0x00000000);	// CTRL_F(byte24~byte27) setting, PGMA setting,
	rtd_outl(0xb802D8A0, 0x00000000);	// CTRL_F(byte28~byte31) setting, PGMA setting, customer configuration byte setting,
	rtd_outl(0xb802D8A4, 0x00000000);	// CTRL_F(byte32~byte35) setting,
	rtd_outl(0xb802D8A8, 0x00000000);	// CTRL_F(byte36~byte39) setting,
	rtd_outl(0xb802D8AC, 0x00000000);	// CTRL_F(byte40~byte43) setting,
	rtd_outl(0xb802D8B0, 0x00000000);	// CTRL_F(byte44~byte47) setting,
	rtd_outl(0xb802D8B4, 0x00000000);	// CTRL_F(byte48~byte51) setting,
	rtd_outl(0xb802D8B8, 0x00000000);	// CTRL_F(byte52~byte55) setting,
	rtd_outl(0xb802D8BC, 0x00000000);	// CTRL_F(byte56~byte59) setting,
	rtd_outl(0xb802D8C0, 0xFFF00000);	// Each port extend 1-pixel, use G16(X) for scrambler,
	//*****************************************************
	//0xb802D8C4~0xb802D8C8 for BBC TX,
	//0xb802D8CC for BBC RX,
	//*****************************************************
	rtd_outl(0xb802D8D0, 0x0FA12C08);	// BCC RX wait time 250us after received portocol error,
						// BCC RX wait timeout 300us (10us < spec < 300us),
						// BCC Preamble number 8ea (spec >= 8)
	rtd_outl(0xb802D8D4, 0x000000FA);	// 1MHz (1us) divider for RBUS_CLK (250MHz),
	rtd_outl(0xb802D8D8, 0x00000801);	// BCC reset disable, BCC IRQ Low 8us (spec 8us), use BCC mode1 when in BCC mode1/2 case,
						// BCC HW auto change to Training Period for BCC Mode1/2, BCC enable,
	rtd_outl(0xb802D8DC, 0x2715DC7D);	// BCC sample parameter setting,
	//0xb802D8E4 for IRQ setting,
	rtd_outl(0xb802D8E8, 0x900000C8);	// BCC debounce enable, BCC use hw mode,
	rtd_outl(0xb802D8F0, 0x0000FFF3);	// BCC debounce enable, BCC use hw mode,

	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D02C, 0x00000100);	// Async FIFO for EPI Mode, P/N Swap Disable,
	rtd_outl(0xb802D030, 0x2F1F0F5F);	// Lane 0~7 pair assign,
	rtd_outl(0xb802D034, 0x4F3FFF00);	// Lane 8~13 pair assign,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO Disable,
	rtd_outl(0xb802D03C, 0x00050010);	// Async FIFO reset enable, r/w collision reset, apply after 16-clock,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1 = Phase16, PI_A2 = Phase16, PI_A 1x Current, PI_Clock = 300~600MHz, VBG = 1.223V,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1 = Phase16, PI_B 1x Current, PI_Clock = 300~600MHz,
	rtd_outl(0xb8000C08, 0x03080130);	// PI_AB = Phase0, PI_AB 1x Current, PI_Clock = 300~600MHz,
						// LDO_1V = 0.988V, TXPLL use BOE(HS) Path, DIVB = 1,
	rtd_outl(0xb8000C0C, 0x8005E3B0);	// Big KVCO, Bypass PI, LDO_2V = 2.14V, CKREF not inverse, PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SCR,
	rtd_outl(0xb8000C10, 0x00000020);	// CK1X not inverse, CK20X not inverse, MACPLL_CKO not inverse, PRESCALERDIV_HS = 1, MACPLL_DIVM = 4,
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C20, 0x00010200);	// VCM_Shift enable, TXPLL enable and reset,
	rtd_outl(0xb8000C50, 0x0186C000);	// IBN Current, VCM, LDO1V enable, LDO2V enable,
	rtd_outl(0xb8000C74, 0x80000000);	// Global Power enable,
	rtd_outl(0xb8000C78, 0x00000E00);	// CKIN_DIVN = 14,
	rtd_outl(0xb8000D00, 0x66002841);	// Lane0 : HS Driver Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000D04, 0x4400000A);	// Lane0 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000D10, 0x77002841);	// Lane1 : Hi-Z Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000D14, 0x4400000A);	// Lane1 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000D20, 0x66002868);	// Lane2 : HS Driver Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000D24, 0x4400000A);	// Lane2 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000D30, 0x77002868);	// Lane3 : Hi-Z Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000D34, 0x4400000A);	// Lane3 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000D40, 0x6600286A);	// Lane4 : HS Driver Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000D44, 0x4400000A);	// Lane4 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000D50, 0x7700286A);	// Lane5 : Hi-Z Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000D54, 0x4400000A);	// Lane5 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000D60, 0x6600286A);	// Lane6 : HS Driver Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000D64, 0x4400000A);	// Lane6 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000D70, 0x7700286A);	// Lane7 : Hi-Z Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000D74, 0x4400000A);	// Lane7 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000D80, 0x66002868);	// Lane8 : HS Driver Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000D84, 0x4400000A);	// Lane8 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000D90, 0x77002868);	// Lane9 : Hi-Z Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000D94, 0x4400000A);	// Lane9 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000DA0, 0x66002841);	// Lane10 : HS Driver Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000DA4, 0x4400000A);	// Lane10 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000DB0, 0x77002841);	// Lane11 : Hi-Z Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000DB4, 0x4400000A);	// Lane11 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000DC0, 0x77002800);	// Lane12 : Hi-Z Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000DC4, 0x4400000A);	// Lane12 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,
	rtd_outl(0xb8000DD0, 0x77002800);	// Lane13 : Hi-Z Mode, PI<1>, SR, Rterm<3:0>, Swing<3:0>, Pre-emphasis<3:0>,
	rtd_outl(0xb8000DD4, 0x4400000A);	// Lane13 : CKMX not inverse, NDRV, PI<0>, Pre-emphasis enable, Swing<3:0>, RT enable, RP disable, Push-Pull Mode, lane power disable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) CHPI/LVDS Clock Enable (Below Setting)
	rtd_part_outl(0xb802D9B8, 31, 29, 0x4);
	rtd_part_outl(0xb802D9B8, 15, 15, 0x1);
	//
	// (8) CHPI MAC Enable (Below Setting)
	rtd_part_outl(0xb802D800, 0, 0, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_part_outl(0xb8000D04, 27, 27, 0x1);	// LANE0
	rtd_part_outl(0xb8000D24, 27, 27, 0x1);	// LANE2
	rtd_part_outl(0xb8000D44, 27, 27, 0x1);	// LANE4
	rtd_part_outl(0xb8000D64, 27, 27, 0x1);	// LANE6
	rtd_part_outl(0xb8000D84, 27, 27, 0x1);	// LANE8
	rtd_part_outl(0xb8000DA4, 27, 27, 0x1);	// LANE10
	ScalerTimer_DelayXms(0x1);		// Wait 1ms,
	//
	// (11) Panel Power Enable (SW Control),
	//
	// (19) BCC BC Transaction (with link training start),
	rtd_outl(0xb802D8C4, 0x08C00001);	// BCC BC Transaction Byte3~Byte0,
	rtd_outl(0xb802D8C8, 0x0000DE17);	// BCC BC Transaction Byte5~Byte4,
	rtd_part_outl(0xb802D8D8, 1, 1, 0x1);
	rtd_part_outl(0xb802D8D4, 31, 31, 0x1);
}

void panel_chpi_55inch_uhd60_6lane_raydium(void)
{
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x00100840);	// Common fifo use sfg_clk, 30-bit Mode, Dout Enable, Pre-R/B Swap disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x05FFFFFF);	// PIF_Clock = Dclk/6, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00005000);	// Line 8n+0/8n+1 shift 1 sub-pixel, Line 8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00005000);	// Line 8n+4/8n+5 shift 1 sub-pixel, Line 8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000); // SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000); // SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000); // SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x10000585);	// SFG DRD Mode, 1.5 packet mode disable, H-Flip enable, 6-SEG, 6-Port,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000); // SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000); // SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000); // SEG10/SEG11 Start Address,
	//rtd_outl(0xb802D980, 0x00000000); // Front dummy line(4N+0) data,
	//rtd_outl(0xb802D984, 0x00000000); // Front dummy line(4N+1) data,
	//rtd_outl(0xb802D94C, 0x00000000); // Front dummy line(4N+2) data,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000); // SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000); // SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000); // SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00400000);		// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	rtd_outl(0xb802DA10, 0x00400000);		// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00030000);		// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00030000);		// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00400000);		// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00400000);		// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00030000);		// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00030000);		// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	rtd_outl(0xb802DAA0, 0x01010101);	// DRD Data Mapping,
	rtd_outl(0xb802DAA4, 0x05050505);	// DRD Data Mapping,
	rtd_outl(0xb802DAA8, 0x03030303);	// DRD Data Mapping,
	rtd_outl(0xb802DAAC, 0x07070707);	// DRD Data Mapping,
	rtd_outl(0xb802DAB0, 0x0B0B0B0B);	// DRD Data Mapping,
	rtd_outl(0xb802DAB4, 0x09090909);	// DRD Data Mapping,
	rtd_outl(0xb802DAB8, 0x0D0D0D0D);	// DRD Data Mapping,
	rtd_outl(0xb802DABC, 0x11111111);	// DRD Data Mapping,
	rtd_outl(0xb802DAC0, 0x0F0F0F0F);	// DRD Data Mapping,
	rtd_outl(0xb802DAC4, 0x13131313);	// DRD Data Mapping,
	rtd_outl(0xb802DAC8, 0x17171717);	// DRD Data Mapping,
	rtd_outl(0xb802DACC, 0x15151515);	// DRD Data Mapping,
	rtd_outl(0xb802DAD0, 0x02020202);	// DRD Data Mapping,
	rtd_outl(0xb802DAD4, 0x00000000);	// DRD Data Mapping,
	rtd_outl(0xb802DAD8, 0x04040404);	// DRD Data Mapping,
	rtd_outl(0xb802DADC, 0x08080808);	// DRD Data Mapping,
	rtd_outl(0xb802DAE0, 0x06060606);	// DRD Data Mapping,
	rtd_outl(0xb802DAE4, 0x0A0A0A0A);	// DRD Data Mapping,
	rtd_outl(0xb802DAE8, 0x0E0E0E0E);	// DRD Data Mapping,
	rtd_outl(0xb802DAEC, 0x0C0C0C0C);	// DRD Data Mapping,
	rtd_outl(0xb802DAF0, 0x10101010);	// DRD Data Mapping,
	rtd_outl(0xb802DAF4, 0x14141414);	// DRD Data Mapping,
	rtd_outl(0xb802DAF8, 0x12121212);	// DRD Data Mapping,
	rtd_outl(0xb802DAFC, 0x16161616);	// DRD Data Mapping,
	rtd_outl(0xb802DB68, 0x55550000);	// ext_num setting for case_a and case_b,
	//rtd_outl(0xb802DB78, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000); // Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E38);	// SFG Pattern Gen. Disable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	rtd_outl(0xb802DC1C, 0x00000000);	// Pattern Detect Function Disable,
	//
	//---------------------------------------------------------------------------------------------------------------------------------
	//CHPI_BCC Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb8000800, 0xFFFFFF0F, 0x00000060);	// GPIO_3 pinshare to BOE_BCC_src0,
	rtd_maskl(0xb8000CBC, 0xFFFFFF3F, 0x00000000);	// BOE_BCC use epi_lock_src0,
	rtd_maskl(0xb8000814, 0x7FFFFFFF, 0x80000000);	// GPIO_3 use input Vth 1.8V,
	//
	//---------------------------------------------------------------------------------------------------------------------------------
	//CHPI MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802DD00, 0x36000000);	// phy_clk setting (ns), dec2hex(round(10^9/297M*16)) = 0x36, 8-bit mode, 1-pair mode, CHPI disable,
	rtd_outl(0xb802DD04, 0x001F1F4F);	// standby_time = 31us (spec 10us), LT_time = 500us, LSP = 15-time,
	rtd_outl(0xb802DD08, 0x01F00000);	// CDR Pattern = 10'b0000011111, insert K3 every 16-lane at active_line(n+1) for port(n), n = [11,0],
	rtd_outl(0xb802DD0C, 0x01FA01FB);	// K1_prime/K2_prime symbol code definition,
	rtd_outl(0xb802DD10, 0x01F901F8);	// K3_prime/K4_prime symbol code definition,
	rtd_outl(0xb802DD14, 0x0157011F);	// G1_prime/G2_prime symbol code definition,
	rtd_outl(0xb802DD18, 0x018F01C7);	// G3_prime/G4_prime symbol code definition,
	rtd_outl(0xb802DD1C, 0x00010203);	// insert K3 at LSP_byte(n) for port(n), n = [3,0],
	rtd_outl(0xb802DD20, 0x04050607);	// insert K3 at LSP_byte(n) for port(n), n = [7,4],
	rtd_outl(0xb802DD24, 0x08090A0B);	// insert K3 at LSP_byte(n) for port(n), n = [11,8],
	rtd_outl(0xb802DD28, 0x001A1500);	// CTRL_L(FSYNC) use TCON25, CTRL_L(POL) use TCON20, CTRL_L(POLC) use register setting,
	rtd_outl(0xb802DD2C, 0x00001400);	// CTRL_L(BKDU) use register setting, CTRL_L(POL2) use TCON19, CTRL_L(POL3) use register setting,
	rtd_outl(0xb802DD30, 0x00000000);	// CTRL_L(byte0) for port00~port03 setting,
	rtd_outl(0xb802DD34, 0x00000000);	// CTRL_L(byte0) for port04~port07 setting,
	rtd_outl(0xb802DD38, 0x00000000);	// CTRL_L(byte0) for port08~port11 setting,
	rtd_outl(0xb802DD3C, 0x04040404);	// CTRL_L(byte1) for port00~port03 even line setting,
	rtd_outl(0xb802DD40, 0x04040404);	// CTRL_L(byte1) for port04~port07 even line setting,
	rtd_outl(0xb802DD44, 0x04040404);	// CTRL_L(byte1) for port08~port11 even line setting,
	rtd_outl(0xb802DD48, 0x04040404);	// CTRL_L(byte1) for port00~port03 odd line setting,
	rtd_outl(0xb802DD4C, 0x04040404);	// CTRL_L(byte1) for port04~port07 odd line setting,
	rtd_outl(0xb802DD50, 0x04040404);	// CTRL_L(byte1) for port08~port11 odd line setting,
	rtd_outl(0xb802DD54, 0x0A0A0A0A);	// CTRL_L(byte2) for port00~port03 even line setting,
	rtd_outl(0xb802DD58, 0x0A0A0A0A);	// CTRL_L(byte2) for port04~port07 even line setting,
	rtd_outl(0xb802DD5C, 0x0A0A0A0A);	// CTRL_L(byte2) for port08~port11 even line setting,
	rtd_outl(0xb802DD60, 0x0A0A0A0A);	// CTRL_L(byte2) for port00~port03 odd line setting,
	rtd_outl(0xb802DD64, 0x0A0A0A0A);	// CTRL_L(byte2) for port04~port07 odd line setting,
	rtd_outl(0xb802DD68, 0x0A0A0A0A);	// CTRL_L(byte2) for port08~port11 odd line setting,
	rtd_outl(0xb802DD6C, 0x02020202);	// CTRL_L(byte3) for port00~port03 setting,
	rtd_outl(0xb802DD70, 0x02020202);	// CTRL_L(byte3) for port04~port07 setting,
	rtd_outl(0xb802DD74, 0x02020202);	// CTRL_L(byte3) for port08~port11 setting,
	rtd_outl(0xb802DD78, 0x00000000);	// CTRL_L(byte4) for port00~port03 setting,
	rtd_outl(0xb802DD7C, 0x00000000);	// CTRL_L(byte4) for port04~port07 setting,
	rtd_outl(0xb802DD80, 0x00000000);	// CTRL_L(byte4) for port08~port11 setting,
	rtd_outl(0xb802DD84, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port0,
	rtd_outl(0xb802DD88, 0x09E0030F);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port0,
	rtd_outl(0xb802DD8C, 0x0C0000FF);	// CTRL_F(byte8~byte11) setting,
	rtd_outl(0xb802DD90, 0xFBAA9376);	// CTRL_F(byte12~byte15) setting,
	rtd_outl(0xb802DD94, 0x5B440500);	// CTRL_F(byte16~byte19) setting,
	rtd_outl(0xb802DD98, 0x0004444A);	// CTRL_F(byte20~byte23) setting,
	rtd_outl(0xb802DD9C, 0x7894A8CF);	// CTRL_F(byte24~byte27) setting,
	rtd_outl(0xb802DDA0, 0xFF00000B);	// CTRL_F(byte28~byte31) setting,
	rtd_outl(0xb802DDA4, 0x00000202);	// CTRL_F(byte32~byte35) setting,
	rtd_outl(0xb802DDA8, 0x8F20100B);	// CTRL_F(byte36~byte39) setting,
	rtd_outl(0xb802DDAC, 0x10480065);	// CTRL_F(byte40~byte43) setting,
	rtd_outl(0xb802DDB0, 0x28A41A10);	// CTRL_F(byte44~byte47) setting,
	rtd_outl(0xb802DDB4, 0x231FF296);	// CTRL_F(byte48~byte51) setting,
	rtd_outl(0xb802DDB8, 0x40480380);	// CTRL_F(byte52~byte55) setting,
	rtd_outl(0xb802DDBC, 0x74210000);	// CTRL_F(byte56~byte59) setting,
	rtd_outl(0xb802DDC0, 0xFFF00000);	// Each port extend 1-pixel, use G16(X) for scrambler,
	//
	rtd_outl(0xb802DE00, 0x46000000);	// hs_to_den_distance = (280/2)*24/(6*8) = 0x46, dummy line number setting, Mac6 not support dummy line,
	rtd_outl(0xb802DE04, 0x00000000);	// Dummy line color select, not support dummy line Mac6,
	rtd_outl(0xb802DE08, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port1, others no use,
	rtd_outl(0xb802DE0C, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port1, others no use,
	rtd_outl(0xb802DE10, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port2, others no use,
	rtd_outl(0xb802DE14, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port2, others no use,
	rtd_outl(0xb802DE18, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port3, others no use,
	rtd_outl(0xb802DE1C, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port3, others no use,
	rtd_outl(0xb802DE20, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port4, others no use,
	rtd_outl(0xb802DE24, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port4, others no use,
	rtd_outl(0xb802DE28, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port5, others no use,
	rtd_outl(0xb802DE2C, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port5, others no use,
	rtd_outl(0xb802DE30, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port6, others no use,
	rtd_outl(0xb802DE34, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port6, others no use,
	rtd_outl(0xb802DE38, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port7, others no use,
	rtd_outl(0xb802DE3C, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port7, others no use,
	rtd_outl(0xb802DE40, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port8, others no use,
	rtd_outl(0xb802DE44, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port8, others no use,
	rtd_outl(0xb802DE48, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port9, others no use,
	rtd_outl(0xb802DE4C, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port9, others no use,
	rtd_outl(0xb802DE50, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port10, others no use,
	rtd_outl(0xb802DE54, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port10, others no use,
	rtd_outl(0xb802DE58, 0x045F4209);	// CTRL_F(byte0~byte3) setting, byte1[7:6]/byte2/byte3 only for port11, others no use,
	rtd_outl(0xb802DE5C, 0x000009E0);	// CTRL_F(byte4~byte7) setting, byte4/byte5 only for port11, others no use,
	//
	//*****************************************************
	//0xb802DDC4~0xb802DDC8 for BBC TX,
	//0xb802D8CC for BBC RX,
	//*****************************************************
	rtd_outl(0xb802DDD0, 0x0FA12C08);	// BCC RX wait time 250us after received portocol error,
						// BCC RX wait timeout 300us (10us < spec < 300us),
						// BCC Preamble number 8ea (spec >= 8)
	rtd_outl(0xb802DDD4, 0x000000FA);	// 1MHz (1us) divider for RBUS_CLK (250MHz),
	rtd_outl(0xb802DDD8, 0x00000801);	// BCC reset disable, BCC IRQ Low 8us (spec 8us), use BCC mode1 when in BCC mode1/2 case,
						// BCC HW auto change to Training Period for BCC Mode1/2, BCC enable,
	//0xb802D8E4 for IRQ setting,
	rtd_outl(0xb802DDE8, 0x900000C8);	// BCC debounce enable, BCC use hw mode,
	rtd_outl(0xb802DDF0, 0x0000FFF3);	// BCC debounce enable, BCC use hw mode,
	//
	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D02C, 0x00000004);	// Async FIFO use CHPI Mode, P/N Swap Disable,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO Disable,
	rtd_outl(0xb802D03C, 0x00050010);	// Async FIFO reset enable, r/w collision reset, apply after 16-clock,
	rtd_outl(0xb802D060, 0xFFFFFFFF);	// Lane 0~3 pair assign,
	rtd_outl(0xb802D064, 0xFFFFFFFF);	// Lane 4~7 pair assign,
	rtd_outl(0xb802D068, 0x11FF12FF);	// Lane 8~11 pair assign,
	rtd_outl(0xb802D06C, 0x13FF0EFF);	// Lane 12~15 pair assign,
	rtd_outl(0xb802D070, 0x0FFF10FF);	// Lane 16~19 pair assign,
	rtd_outl(0xb802D074, 0xFFFFFFFF);	// Lane 20~23 pair assign,
	rtd_outl(0xb802D078, 0xFFFFFFFF);	// Lane 24~27 pair assign,
	//
	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(1),
	rtd_outl(0xb8000C0C, 0x8005E3B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000000);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(1),
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000023);	// TXPLL use CHPI feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01D2C001);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(1),
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C78, 0x00000E00);	// CKIN_DIVN(16),
	//
	rtd_outl(0xb8000D00, 0x77002000);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D10, 0x77002000);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D20, 0x77002000);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D30, 0x77002000);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D40, 0x77002000);	// Lane4 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D50, 0x77002000);	// Lane5 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D60, 0x77002000);	// Lane6 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D70, 0x77002000);	// Lane7 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D80, 0x66002841);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D90, 0x66002841);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DA0, 0x66002868);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DB0, 0x66002868);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DC0, 0x6600286A);	// Lane12: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DD0, 0x6600286A);	// Lane13: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E00, 0x6600286A);	// Lane14: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E10, 0x6600286A);	// Lane15: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E20, 0x66002868);	// Lane16: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E30, 0x66002868);	// Lane17: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E40, 0x66002841);	// Lane18: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E50, 0x66002841);	// Lane19: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E60, 0x77002000);	// Lane20: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E70, 0x77002000);	// Lane21: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E80, 0x77002000);	// Lane22: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E90, 0x77002000);	// Lane23: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EA0, 0x77002000);	// Lane24: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EB0, 0x77002000);	// Lane25: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EC0, 0x77002000);	// Lane26: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000ED0, 0x77002000);	// Lane27: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	//
	rtd_outl(0xb8000D04, 0x44000008);	// Lane0 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D14, 0x44000008);	// Lane1 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D24, 0x44000008);	// Lane2 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D34, 0x44000008);	// Lane3 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D44, 0x44000008);	// Lane4 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D54, 0x44000008);	// Lane5 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D64, 0x44000008);	// Lane6 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D74, 0x44000008);	// Lane7 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D84, 0x44000000);	// Lane8 : CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000D94, 0x44000000);	// Lane9 : CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DA4, 0x44000000);	// Lane10: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DB4, 0x44000000);	// Lane11: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DC4, 0x44000000);	// Lane12: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000DD4, 0x44000000);	// Lane13: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E04, 0x44000000);	// Lane14: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E14, 0x44000000);	// Lane15: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E24, 0x44000000);	// Lane16: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E34, 0x44000000);	// Lane17: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E44, 0x44000000);	// Lane18: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E54, 0x44000000);	// Lane19: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LANE_POW(0),
	rtd_outl(0xb8000E64, 0x44000008);	// Lane20: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E74, 0x44000008);	// Lane21: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E84, 0x44000008);	// Lane22: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E94, 0x44000008);	// Lane23: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EA4, 0x44000008);	// Lane24: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EB4, 0x44000008);	// Lane25: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EC4, 0x44000008);	// Lane26: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000ED4, 0x44000008);	// Lane27: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	//
	rtd_outl(0xb8000D88, 0x0000000A);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x0000000A);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x0000000A);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x0000000A);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DC8, 0x0000000A);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DD8, 0x0000000A);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E08, 0x0000000A);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E18, 0x0000000A);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E28, 0x0000000A);	// Lane16: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E38, 0x0000000A);	// Lane17: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E48, 0x0000000A);	// Lane18: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E58, 0x0000000A);	// Lane19: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),

	// Tcon Pinshare Setting,
	rtd_part_outl(0xb8000CA0, 31, 28, 0xB);		// TX27P for ON_CLK, use Tcon12,
	rtd_part_outl(0xb8000CA0, 19, 16, 0xA);		// TX26N for TCLK, use Tcon17,
	rtd_part_outl(0xb8000CA4, 23, 20, 0xB);		// TX22P for SCLK, use Tcon2,
	rtd_part_outl(0xb8000CA0, 7, 4, 0xB);		// TX24P for OFF_CLK, use Tcon24,

	rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// SCLK, Tcon2,
	// Tcon2 (Frame Start Pulse),
	rtd_outl(0xb802D250, 0x000107FC);		// H_start/H_end,
	rtd_outl(0xb802D254, 0x00510057);		// V_start/V_end,
	rtd_outl(0xb802D258, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// OFF_CLK, Tcon24,
	// Tocn23 (ODD Line),
	rtd_outl(0xb802D4F0, 0x027206E8);		// H_start/H_end,
	rtd_outl(0xb802D4F4, 0x005c1144);		// V_start/V_end,
	rtd_outl(0xb802D4F8, 0x00000380);		// Control,
	rtd_outl(0xb802D4FC, 0x00020000);		// Across Line3 RP/HP,
	// Tcon24 (EVEN Line),
	rtd_outl(0xb802D510, 0x027206E8);		// H_start/H_end,
	rtd_outl(0xb802D514, 0x005B1143);		// V_start/V_end,
	rtd_outl(0xb802D518, 0x00000382);		// Control,
	rtd_outl(0xb802D51C, 0x00020000);		// Across Line3 RP/HP,
	////////////////////////////////////////////////////////////////////////////
	// ON_CLK, Tcon12,
	// Tcon11 (ODD Line),
	rtd_outl(0xb802D370, 0x05c00856);		// H_start/H_end,
	rtd_outl(0xb802D374, 0x0058113E);		// V_start/V_end,
	rtd_outl(0xb802D378, 0x00000380);		// Control,
	rtd_outl(0xb802D37C, 0x00020000);		// Across Line3 RP/HP,
	// Tcon12 (EVEN Line),
	rtd_outl(0xb802D390, 0x05C00856);		// H_start/H_end,
	rtd_outl(0xb802D394, 0x0057113D);		// V_start/V_end,
	rtd_outl(0xb802D398, 0x00000382);		// Control,
	rtd_outl(0xb802D39C, 0x00020000);		// Across Line3 RP/HP,
	////////////////////////////////////////////////////////////////////////////
	// TCLK, Tcon17,
	// TCON16,
	rtd_outl(0xb802D410, 0x00F800F8);		// H_start/H_end,
	rtd_outl(0xb802D414, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D418, 0x00000480);		// Control,
	rtd_outl(0xb802D420, 0x0000007E);		// Across Frame Period,
	// Tcon17,
	rtd_outl(0xb802D430, 0x01A801A8);		// H_start/H_end,
	rtd_outl(0xb802D434, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D438, 0x00000483);		// Control,
	rtd_outl(0xb802D440, 0x0000007E);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////
	// POL, TCON19/Tcon20,
	// Tcon19 (POL2),
	rtd_outl(0xb802D470, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D474, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D478, 0x00000480);		// Control,
	rtd_outl(0xb802D480, 0x00000000);		// Across Frame Period,
	// Tcon20 (POL1),
	rtd_outl(0xb802D490, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D494, 0x00011180);		// V_start/V_end,
	rtd_outl(0xb802D498, 0x00000183);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// FSYNC, Tcon25,
	// Tcon25,
	rtd_outl(0xb802D530, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D534, 0x00570058);		// V_start/V_end,
	rtd_outl(0xb802D538, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// DE (Tcon17, EO), for debug,
	//rtd_outl(0xb802D430, 0x00B40836);		// H_start/H_end,
	//rtd_outl(0xb802D434, 0x005A1139);		// V_start/V_end,
	//rtd_outl(0xb802D438, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// DE (Tcon17, EO), for debug,
	//rtd_outl(0xb802D430, 0x00B40836);		// H_start/H_end,
	//rtd_outl(0xb802D434, 0x005A005A);		// V_start/V_end,
	//rtd_outl(0xb802D438, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////
	rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
	rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,

	//
	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) CHPI/LVDS Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x80008000);
	//
	// (8) CHPI MAC Enable (Below Setting)
	rtd_part_outl(0xb802DD00, 0, 0, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_part_outl(0xb8000D84, 27, 27, 0x1); // LANE8
	rtd_part_outl(0xb8000DA4, 27, 27, 0x1); // LANE10
	rtd_part_outl(0xb8000DC4, 27, 27, 0x1); // LANE12
	rtd_part_outl(0xb8000E04, 27, 27, 0x1); // LANE14
	rtd_part_outl(0xb8000E24, 27, 27, 0x1); // LANE16
	rtd_part_outl(0xb8000E44, 27, 27, 0x1); // LANE18
	ScalerTimer_DelayXms(0x1);		// Wait 1ms,
	//
	// (11) Panel Power Enable (SW Control),
	//
	// (12) BCC BC Transaction (with link training start),
	rtd_outl(0xb802DDC4, 0x007F4801);	// BCC BC Transaction Byte3~Byte0,
	rtd_outl(0xb802DDC8, 0x00003600);	// BCC BC Transaction Byte5~Byte4,
	rtd_part_outl(0xb802DDD8, 1, 1, 0x1);
	rtd_part_outl(0xb802DDD4, 31, 31, 0x1);
}

void panel_chpi_bc_trigger(void)
{
		//CML Mode
	//rtd_outl(0xb8000D04, 0x4C003009);
	//rtd_outl(0xb8000D14, 0x4C003009);
	//rtd_outl(0xb8000D24, 0x4C003009);
	//rtd_outl(0xb8000D34, 0x4C003009);
	//rtd_outl(0xb8000D44, 0x4C003009);
	//rtd_outl(0xb8000D54, 0x4C003009);
	//rtd_outl(0xb8000D64, 0x4C003009);
	//rtd_outl(0xb8000D74, 0x4C003009);
	//rtd_outl(0xb8000D84, 0x4C003009);
	//rtd_outl(0xb8000D94, 0x4C003009);
	//rtd_outl(0xb8000DA4, 0x4C003009);
	//rtd_outl(0xb8000DB4, 0x4C003009);


	//Eye Open
	rtd_outl(0xb8000D00, 0x66002862);
	rtd_outl(0xb8000D20, 0x66002862);
	rtd_outl(0xb8000D40, 0x66002862);
	rtd_outl(0xb8000D60, 0x66002862);
	rtd_outl(0xb8000D80, 0x66002862);
	rtd_outl(0xb8000DA0, 0x66002862);

	rtd_part_outl(0xb802D800, 0, 0, 0x0);
	//ScalerTimer_DelayXms(0x5);  // Wait 5ms
	rtd_part_outl(0xb802D800, 0, 0, 0x1);
	rtd_part_outl(0xb802D8D8, 1, 1, 0x1);

	// (19) BCC BC Transaction (with link training start), Himax
	rtd_outl(0xb802D8C4, 0x00C80001);	// BCC BC Transaction Byte3~Byte0,
	rtd_outl(0xb802D8C8, 0x0000C900);	// BCC BC Transaction Byte5~Byte4,

	// (19) BCC BC Transaction (with link training start), Ilitek
	//rtd_outl(0xb802D8C4, 0x08A00001);	// BCC BC Transaction Byte3~Byte0,
	//rtd_outl(0xb802D8C8, 0x0000DE17);	// BCC BC Transaction Byte5~Byte4,


	rtd_part_outl(0xb802D8D8, 1, 1, 0x1);
	rtd_part_outl(0xb802D8D4, 31, 31, 0x1);
}

void panel_isp_50inch_uhd60_12lane(void)
{
	// Tcon Pinshare Setting, B16_DEMO
	//rtd_part_outl(0xb8000CA0, 31, 28, 0xB); 	// TX27P for VCE, use Tcon12,
	//rtd_part_outl(0xb8000CA0, 19, 16, 0xA); 	// TX26N for LC, use Tcon17,
	rtd_part_outl(0xb8000800, 15, 12, 0x8); 	// gpio_02 for VST, use Tcon3,
	rtd_part_outl(0xb8000804, 15, 12, 0xA); 	// gpio_06 for TEND, use Tcon7,

	rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// VST, Tcon3,
	// Tcon2,
	rtd_outl(0xb802D270, 0x01201110);		// H_start/H_end,
	rtd_outl(0xb802D274, 0x002A002E);		// V_start/V_end,
	rtd_outl(0xb802D278, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// TEND, Tcon7,
	// Tcon24,
	rtd_outl(0xb802D2F0, 0x08A81010);		// H_start/H_end,
	rtd_outl(0xb802D2F4, 0x08A508A5);		// V_start/V_end,
	rtd_outl(0xb802D2F8, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// VCE, Tcon12,
	// Tcon12,
	rtd_outl(0xb802D390, 0x0C080780);		// H_start/H_end,
	rtd_outl(0xb802D394, 0x002B08A5);		// V_start/V_end,
	rtd_outl(0xb802D398, 0x00000280);		// Control,
	////////////////////////////////////////////////////////////////////////////
	// LC, Tcon17,
	// Tcon17,
	rtd_outl(0xb802D430, 0x08900890);		// H_start/H_end,
	rtd_outl(0xb802D434, 0x08A708A7);		// V_start/V_end,
	rtd_outl(0xb802D438, 0x00000480);		// Control,
	rtd_outl(0xb802D440, 0x00000077);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////
	// POL, Tcon20,
	// Tcon20 (POL),
	rtd_outl(0xb802D490, 0x08970897);		// H_start/H_end,
	rtd_outl(0xb802D494, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D498, 0x00000480);		// Control,
	rtd_outl(0xb802D4A0, 0x00000000);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////
	// DE (Tcon17, LC), for debug,
	//rtd_outl(0xb802D430, 0x01521044); 	// H_start/H_end,
	//rtd_outl(0xb802D434, 0x002D089C); 	// V_start/V_end,
	//rtd_outl(0xb802D438, 0x00000180); 	// Control,
	////////////////////////////////////////////////////////////////////////////
	// DE (Tcon17, LC), for debug,
	//rtd_outl(0xb802D430, 0x01521044); 	// H_start/H_end,
	//rtd_outl(0xb802D434, 0x002D002D); 	// V_start/V_end,
	//rtd_outl(0xb802D438, 0x00000180); 	// Control,
	////////////////////////////////////////////////////////////////////////////
	rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
	rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,

	//---------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x00100840);	// Common fifo use sfg_clk, 30-bit Mode, Dout Enable, Pre-R/B Swap
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x0BFFFFFF);	// PIF_Clock = Dclk/12, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 8n+0/8n+1/8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00000000);	// Line 8n+4/8n+5/8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x00000B8B);	// SFG Normal Mode, 1.5 packet mode disable, H-Flip enable, 12-SEG,
	rtd_outl(0xb802D968, 0x00000140);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x028003C0);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x05000640);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802D974, 0x078008C0);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802D978, 0x0A000B40);	// SEG8/SEG9 Start Address,
	rtd_outl(0xb802D97C, 0x0C800DC0);	// SEG10/SEG11 Start Address,
	rtd_outl(0xb802D980, 0x00000000);	// Front dummy line(4N+0) data,
	rtd_outl(0xb802D984, 0x00000000);	// Front dummy line(4N+1) data,
	rtd_outl(0xb802D988, 0x40000040);	// Bypass SFG disable, Auto config enable, downsample disable, fron
	rtd_outl(0xb802D990, 0x00000300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x0F000000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x01181128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel,
	rtd_outl(0xb802DA0C, 0x00400000);		// G-dummy sub-pixel for line 8n+0, G-dummy data select from
	rtd_outl(0xb802DA10, 0x00030000);		// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00400000);		// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00030000);		// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00400000);		// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00030000);		// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00400000);		// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00030000);		// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	rtd_outl(0xb802DB68, 0x55550000);	// ext_num setting for case_a and case_b,
	rtd_outl(0xb802DBF0, 0x1DF10E21);	// SFG Pattern Gen. Disable, RGB Mode, Width = 480, Hight = 270, pa
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	rtd_outl(0xb802DC1C, 0x00000000);	// Pattern Detect Function Disable,

	//---------------------------------------------------------------------------------------------------
	//LOCK Pin share
	//---------------------------------------------------------------------------------------------------
	rtd_maskl(0xb8000800, 0xFFFFFF0F, 0x00000050);	// GPIO_3 pinshare to iSP_SDLOCK_src0,
	rtd_maskl(0xb8000CBC, 0xFFFFF8FF, 0x00000000);	// iSP_LOCK use iSP_SDLOCK_src0,
	rtd_maskl(0xb8000814, 0x7FFFFFFF, 0x00000000);	// GPIO_3 use input Vth 3.3V,

	//---------------------------------------------------------------------------------------------------
	//iSP MAC
	//---------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D100, 0x00000000);	// 1-Pair Mode, iSP disable,
	rtd_outl(0xb802D104, 0x91141400);	// PN swap enable, scrambler use pixel base, scrambler enable with
						// BKPOL use TCON20, pol_bit1_sel sel TCON20, pol_bit0_sel keep low,
	rtd_outl(0xb802D108, 0x00460129);	// hs_to_den_distance = 280*24/12/8 = 0x46, iSP lock use hw mode, d
	rtd_outl(0xb802D10C, 0x00000001);	// send SD_CONFIG_DATA for each frame,
	rtd_outl(0xb802D110, 0x5E11E100);	// send TBK1/TBK2 for CDR and Blanking, send dummy data in porch (a
	rtd_outl(0xb802D114, 0x001E0181);	// BAC/SET Pattern setting,
	rtd_outl(0xb802D118, 0x0000007E);	// EOL Pattern setting,
	rtd_outl(0xb802D11C, 0x01EE0011);	// BKPOLP/BKPOLN Pattern setting,
	rtd_outl(0xb802D120, 0x01E601E6);	// POLP_GSELN/POLP_GSELP Pattern setting,
	rtd_outl(0xb802D124, 0x00190019);	// POLN_GSELN/POLN_GSELP Pattern setting,
	// Scrambler Enable with Package mode
	//rtd_outl(0xb802D128, 0xFAFAFAFA); // SD_CONFIG_DATA byte0 for port 0~3,
	//rtd_outl(0xb802D12C, 0xFAFAFAFA); // SD_CONFIG_DATA byte0 for port 4~7,
	//rtd_outl(0xb802D130, 0xFAFAFAFA); // SD_CONFIG_DATA byte0 for port 8~11,
	//rtd_outl(0xb802D134, 0x18181818); // SD_CONFIG_DATA byte1 for port 0~3,
	//rtd_outl(0xb802D138, 0x18181818); // SD_CONFIG_DATA byte1 for port 4~7,
	//rtd_outl(0xb802D13C, 0x18181818); // SD_CONFIG_DATA byte1 for port 8~11,
	//rtd_outl(0xb802D140, 0xF3F3F3F3); // SD_CONFIG_DATA byte2 for port 0~3,
	//rtd_outl(0xb802D144, 0xF3F3F3F3); // SD_CONFIG_DATA byte2 for port 4~7,
	//rtd_outl(0xb802D148, 0xF3F3F3F3); // SD_CONFIG_DATA byte2 for port 8~11,
	//rtd_outl(0xb802D14C, 0x4B4B4B4B); // SD_CONFIG_DATA byte3 for port 0~3,
	//rtd_outl(0xb802D150, 0x4B4B4B4B); // SD_CONFIG_DATA byte3 for port 4~7,
	//rtd_outl(0xb802D154, 0x4B4B4B4B); // SD_CONFIG_DATA byte3 for port 8~11,
	//rtd_outl(0xb802D158, 0xA9731E05); // SD_CONFIG_DATA byte4~7,
	//rtd_outl(0xb802D15C, 0x360E8000); // SD_CONFIG_DATA byte8~11,
	//rtd_outl(0xb802D160, 0x80C05443); // SD_CONFIG_DATA byte12~15,
	//rtd_outl(0xb802D164, 0xE42CD5C4); // SD_CONFIG_DATA byte16~19,
	//rtd_outl(0xb802D168, 0x4B91950D); // SD_CONFIG_DATA byte20~23,
	//rtd_outl(0xb802D16C, 0xD4DF6FC8); // SD_CONFIG_DATA byte24~27,
	//rtd_outl(0xb802D170, 0x64B2D9EC); // SD_CONFIG_DATA byte28~31,
	//rtd_outl(0xb802D174, 0xF67B3D9E); // SD_CONFIG_DATA byte32~35,
	//rtd_outl(0xb802D178, 0xCFE773B9); // SD_CONFIG_DATA byte36~39,
	//rtd_outl(0xb802D17C, 0x5C2E170B); // SD_CONFIG_DATA byte40~43,
	//rtd_outl(0xb802D180, 0x05020180); // SD_CONFIG_DATA byte44~47,
	//rtd_outl(0xb802D184, 0x40201008); // SD_CONFIG_DATA byte48~51,
	//rtd_outl(0xb802D188, 0x048241A0); // SD_CONFIG_DATA byte52~55,
	//rtd_outl(0xb802D18C, 0x502894CA); // SD_CONFIG_DATA byte56~59,
	// Scrambler Enable with Pixel mode
	rtd_outl(0xb802D128, 0xFAFAFAFA);	// SD_CONFIG_DATA byte0 for port 0~3,
	rtd_outl(0xb802D12C, 0xFAFAFAFA);	// SD_CONFIG_DATA byte0 for port 4~7,
	rtd_outl(0xb802D130, 0xFAFAFAFA);	// SD_CONFIG_DATA byte0 for port 8~11,
	rtd_outl(0xb802D134, 0x98989898);	// SD_CONFIG_DATA byte1 for port 0~3,
	rtd_outl(0xb802D138, 0x98989898);	// SD_CONFIG_DATA byte1 for port 4~7,
	rtd_outl(0xb802D13C, 0x98989898);	// SD_CONFIG_DATA byte1 for port 8~11,
	rtd_outl(0xb802D140, 0xB3B3B3B3);	// SD_CONFIG_DATA byte2 for port 0~3,
	rtd_outl(0xb802D144, 0xB3B3B3B3);	// SD_CONFIG_DATA byte2 for port 4~7,
	rtd_outl(0xb802D148, 0xB3B3B3B3);	// SD_CONFIG_DATA byte2 for port 8~11,
	rtd_outl(0xb802D14C, 0x6B6B6B6B);	// SD_CONFIG_DATA byte3 for port 0~3,
	rtd_outl(0xb802D150, 0x6B6B6B6B);	// SD_CONFIG_DATA byte3 for port 4~7,
	rtd_outl(0xb802D154, 0x6B6B6B6B);	// SD_CONFIG_DATA byte3 for port 8~11,
	rtd_outl(0xb802D158, 0xF91BAABF);	// SD_CONFIG_DATA byte4~7,
	rtd_outl(0xb802D15C, 0x8B50DF5F);	// SD_CONFIG_DATA byte8~11,
	rtd_outl(0xb802D160, 0x2F2F1B64);	// SD_CONFIG_DATA byte12~15,
	rtd_outl(0xb802D164, 0x6B77789C);	// SD_CONFIG_DATA byte16~19,
	rtd_outl(0xb802D168, 0x69809A8D);	// SD_CONFIG_DATA byte20~23,
	rtd_outl(0xb802D16C, 0x94FCFD01);	// SD_CONFIG_DATA byte24~27,
	rtd_outl(0xb802D170, 0x01010000);	// SD_CONFIG_DATA byte28~31,
	rtd_outl(0xb802D174, 0x00000000);	// SD_CONFIG_DATA byte32~35,
	rtd_outl(0xb802D178, 0x808080C0);	// SD_CONFIG_DATA byte36~39,
	rtd_outl(0xb802D17C, 0xC0C06060);	// SD_CONFIG_DATA byte40~43,
	rtd_outl(0xb802D180, 0x60303030);	// SD_CONFIG_DATA byte44~47,
	rtd_outl(0xb802D184, 0x9898984C);	// SD_CONFIG_DATA byte48~51,
	rtd_outl(0xb802D188, 0x4C4CA6A6);	// SD_CONFIG_DATA byte52~55,
	rtd_outl(0xb802D18C, 0xA6535353);	// SD_CONFIG_DATA byte56~59,
	// Scrambler Disable
	//rtd_outl(0xb802D128, 0x05050505); // SD_CONFIG_DATA byte0 for port 0~3,
	//rtd_outl(0xb802D12C, 0x05050505); // SD_CONFIG_DATA byte0 for port 4~7,
	//rtd_outl(0xb802D130, 0x05050505); // SD_CONFIG_DATA byte0 for port 8~11,
	//rtd_outl(0xb802D134, 0x67676767); // SD_CONFIG_DATA byte1 for port 0~3,
	//rtd_outl(0xb802D138, 0x67676767); // SD_CONFIG_DATA byte1 for port 4~7,
	//rtd_outl(0xb802D13C, 0x67676767); // SD_CONFIG_DATA byte1 for port 8~11,
	//rtd_outl(0xb802D140, 0x4C4C4C4C); // SD_CONFIG_DATA byte2 for port 0~3,
	//rtd_outl(0xb802D144, 0x4C4C4C4C); // SD_CONFIG_DATA byte2 for port 4~7,
	//rtd_outl(0xb802D148, 0x4C4C4C4C); // SD_CONFIG_DATA byte2 for port 8~11,
	//rtd_outl(0xb802D14C, 0x14141414); // SD_CONFIG_DATA byte3 for port 0~3,
	//rtd_outl(0xb802D150, 0x14141414); // SD_CONFIG_DATA byte3 for port 4~7,
	//rtd_outl(0xb802D154, 0x14141414); // SD_CONFIG_DATA byte3 for port 8~11,
	//rtd_outl(0xb802D158, 0x86641500); // SD_CONFIG_DATA byte4~7,
	//rtd_outl(0xb802D15C, 0x340F8000); // SD_CONFIG_DATA byte8~11,
	//rtd_outl(0xb802D160, 0x00003473); // SD_CONFIG_DATA byte12~15,
	//rtd_outl(0xb802D164, 0x7C607397); // SD_CONFIG_DATA byte16~19,
	//rtd_outl(0xb802D168, 0x62859F88); // SD_CONFIG_DATA byte20~23,
	//rtd_outl(0xb802D16C, 0x96FEFF00); // SD_CONFIG_DATA byte24~27,
	//rtd_outl(0xb802D170, 0x00000000); // SD_CONFIG_DATA byte28~31,
	//rtd_outl(0xb802D174, 0x00000000); // SD_CONFIG_DATA byte32~35,
	//rtd_outl(0xb802D178, 0x00000000); // SD_CONFIG_DATA byte36~39,
	//rtd_outl(0xb802D17C, 0x00000000); // SD_CONFIG_DATA byte40~43,
	//rtd_outl(0xb802D180, 0x00000000); // SD_CONFIG_DATA byte44~47,
	//rtd_outl(0xb802D184, 0x00000000); // SD_CONFIG_DATA byte48~51,
	//rtd_outl(0xb802D188, 0x00000000); // SD_CONFIG_DATA byte52~55,
	//rtd_outl(0xb802D18C, 0x00000000); // SD_CONFIG_DATA byte56~59,
	//
	rtd_outl(0xb802D190, 0x01234567);	// Any to any port assign for port0~7,
	rtd_outl(0xb802D194, 0x89AB0000);	// Any to any port assign for port8~11,
	rtd_outl(0xb802D1A0, 0x0000FFF3);	// CRC enable,

	//---------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D02C, 0x00000005);	// Async FIFO use iSP Mode, P/N Swap Disable,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO Disable,
	rtd_outl(0xb802D03C, 0x00050010);	// Async FIFO reset enable, r/w collision reset, apply after 16-clo
	rtd_outl(0xb802D060, 0xFFFFFFFF);	// Lane 0~3 pair assign,
	rtd_outl(0xb802D064, 0xFFFFFFFF);	// Lane 4~7 pair assign,
	rtd_outl(0xb802D068, 0x08090A0B);	// Lane 8~11 pair assign,
	rtd_outl(0xb802D06C, 0x0C0D0E0F);	// Lane 12~15 pair assign,
	rtd_outl(0xb802D070, 0x10111213);	// Lane 16~19 pair assign,
	rtd_outl(0xb802D074, 0xFFFFFFFF);	// Lane 20~23 pair assign,
	rtd_outl(0xb802D078, 0xFFFFFFFF);	// Lane 24~27 pair assign,

	//---------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(1),
	rtd_outl(0xb8000C0C, 0x8005E3B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC
	rtd_outl(0xb8000C10, 0x00000100);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(2)
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000004);	// TXPLL use iSP feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F4C000);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C78, 0x00000600);	// CKIN_DIVN(8),
	//
	rtd_outl(0xb8000D00, 0x77002000);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D10, 0x77002000);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D20, 0x77002000);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D30, 0x77002000);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D40, 0x77002000);	// Lane4 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D50, 0x77002000);	// Lane5 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D60, 0x77002000);	// Lane6 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D70, 0x77002000);	// Lane7 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D80, 0x66002852);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000D90, 0x66002852);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000DA0, 0x66002852);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000DB0, 0x66002852);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000DC0, 0x66002852);	// Lane12: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000DD0, 0x66002852);	// Lane13: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000E00, 0x66002852);	// Lane14: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000E10, 0x66002852);	// Lane15: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000E20, 0x66002852);	// Lane16: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000E30, 0x66002852);	// Lane17: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000E40, 0x66002852);	// Lane18: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000E50, 0x66002852);	// Lane19: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, I
	rtd_outl(0xb8000E60, 0x77002000);	// Lane20: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000E70, 0x77002000);	// Lane21: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000E80, 0x77002000);	// Lane22: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000E90, 0x77002000);	// Lane23: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000EA0, 0x77002000);	// Lane24: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000EB0, 0x77002000);	// Lane25: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000EC0, 0x77002000);	// Lane26: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000ED0, 0x77002000);	// Lane27: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	//
	rtd_outl(0xb8000D04, 0x44000008);	// Lane0 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000D14, 0x44000008);	// Lane1 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000D24, 0x44000008);	// Lane2 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000D34, 0x44000008);	// Lane3 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000D44, 0x44000008);	// Lane4 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000D54, 0x44000008);	// Lane5 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000D64, 0x44000008);	// Lane6 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000D74, 0x44000008);	// Lane7 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000D84, 0x44000000);	// Lane8 : CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000D94, 0x44000000);	// Lane9 : CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000DA4, 0x44000000);	// Lane10: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000DB4, 0x44000000);	// Lane11: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000DC4, 0x44000000);	// Lane12: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000DD4, 0x44000000);	// Lane13: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000E04, 0x44000000);	// Lane14: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000E14, 0x44000000);	// Lane15: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000E24, 0x44000000);	// Lane16: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000E34, 0x44000000);	// Lane17: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000E44, 0x44000000);	// Lane18: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000E54, 0x44000000);	// Lane19: CKMX_INV(0), NDRV(0), IEM_EN(1), RT_EN(1), RP_EN(0), LAN
	rtd_outl(0xb8000E64, 0x44000008);	// Lane20: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000E74, 0x44000008);	// Lane21: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000E84, 0x44000008);	// Lane22: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000E94, 0x44000008);	// Lane23: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000EA4, 0x44000008);	// Lane24: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000EB4, 0x44000008);	// Lane25: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000EC4, 0x44000008);	// Lane26: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	rtd_outl(0xb8000ED4, 0x44000008);	// Lane27: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI
	//
	rtd_outl(0xb8000D88, 0x0000000A);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000D98, 0x0000000A);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000DA8, 0x0000000A);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000DB8, 0x0000000A);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000DC8, 0x0000000A);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000DD8, 0x0000000A);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000E08, 0x0000000A);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000E18, 0x0000000A);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000E28, 0x0000000A);	// Lane16: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000E38, 0x0000000A);	// Lane17: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000E48, 0x0000000A);	// Lane18: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE
	rtd_outl(0xb8000E58, 0x0000000A);	// Lane19: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SE

	//---------------------------------------------------------------------------------------------------
	//Initial Flow
	//---------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) iSP/EPI Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x40004000);
	//
	// (8) iSP MAC Enable (Below Setting)
	rtd_part_outl(0xb802D100, 0, 0, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_part_outl(0xb8000D84, 27, 27, 0x1); // LANE8
	rtd_part_outl(0xb8000D94, 27, 27, 0x1); // LANE9
	rtd_part_outl(0xb8000DA4, 27, 27, 0x1); // LANE10
	rtd_part_outl(0xb8000DB4, 27, 27, 0x1); // LANE11
	rtd_part_outl(0xb8000DC4, 27, 27, 0x1); // LANE12
	rtd_part_outl(0xb8000DD4, 27, 27, 0x1); // LANE13
	rtd_part_outl(0xb8000E04, 27, 27, 0x1); // LANE14
	rtd_part_outl(0xb8000E14, 27, 27, 0x1); // LANE15
	rtd_part_outl(0xb8000E24, 27, 27, 0x1); // LANE16
	rtd_part_outl(0xb8000E34, 27, 27, 0x1); // LANE17
	rtd_part_outl(0xb8000E44, 27, 27, 0x1); // LANE18
	rtd_part_outl(0xb8000E54, 27, 27, 0x1); // LANE19
	//
	// (11) Panel Power Enable (SW Control),

}

void panel_isp_43inch_uhd60_12lane(void)
{
	// Tcon Pinshare Setting,
	rtd_part_outl(0xb8000800, 07, 04, 0x3); 	// gpio_03 for VST1, use Tcon7,
	rtd_part_outl(0xb8000800, 31, 28, 0x3); 	// gpio_00 for LC, use Tcon1,
	rtd_part_outl(0xb800080C, 31, 28, 0x7); 	// gpio_12 for VCE, use Tcon0,
	rtd_part_outl(0xb8000814, 31, 28, 0x4); 	// gpio_20 for TEND, use Tcon19,


	rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	//VST TCON7
	rtd_outl(0xB802D2F0,0x10110D2E);	// H_start/H_end,
	rtd_outl(0xB802D2F4,0x0026002C);	// V_start/V_end,
	rtd_outl(0xB802D2F8,0x00000180);	// across line control mode 1
	rtd_outl(0xB802D2FC,0x00000000);	// ACROSS_LINE_CONTROL3
	rtd_outl(0xB802D300,0x00000000);	// ACROSS_FRAME_CONTROL
	rtd_outl(0xB802D304,0x00000000);	// FRAME_HL_CONTROL
	//VCK TCON0
	rtd_outl(0xB802D210,0x0B5C09F3);	// H_start/H_end,
	rtd_outl(0xB802D214,0x002A08A4);	// V_start/V_end,
	rtd_outl(0xB802D218,0x00000280);	// across line control mode 2
	rtd_outl(0xB802D21C,0x00000000);	// ACROSS_LINE_CONTROL4
	rtd_outl(0xB802D220,0x00000000);	// ACROSS_FRAME_CONTROL
	rtd_outl(0xB802D224,0x00000000);	// FRAME_HL_CONTROL
	//TEND TCON19
	rtd_outl(0xB802D470,0x0B40017C);	// H_start/H_end,
	rtd_outl(0xB802D474,0x08A408A5);	// V_start/V_end,
	rtd_outl(0xB802D478,0x00000180);	// across line control mode 1
	rtd_outl(0xB802D47C,0x00000000);	// ACROSS_LINE_CONTROL5
	rtd_outl(0xB802D480,0x00000000);	// ACROSS_FRAME_CONTROL
	rtd_outl(0xB802D484,0x00000000);	// FRAME_HL_CONTROL
	//LC TCON1
	rtd_outl(0xB802D230,0x0F090F09);	// H_start/H_end,
	rtd_outl(0xB802D234,0x08A508A5);	// V_start/V_end,
	rtd_outl(0xB802D238,0x00000480);	// across frame control mode
	rtd_outl(0xB802D23C,0x00000000);	// ACROSS_LINE_CONTROL6
	rtd_outl(0xB802D240,0x00630063);	// ACROSS_FRAME_CONTROL
	rtd_outl(0xB802D244,0x00000000);	// FRAME_HL_CONTROL
	////////////////////////////////////////////////////////////////////////////
	// POL, Tcon20,
	// Tcon20 (POL),
	rtd_outl(0xb802D490, 0x08970897);		// H_start/H_end,
	rtd_outl(0xb802D494, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D498, 0x00000480);		// Control,
	rtd_outl(0xb802D4A0, 0x00000000);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////

	rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
	rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG Setting
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------

	// ----------------------- Insert Dummy Line Function & Auto Config SFG Timing Gen -----------------------
	rtd_outl(0xb802D988, 0x40000000);	// bypass SFG disable[31], auto config sfg timing gen [30], insert dummy line[22:20]/[18:16]/[14:12]/[10:8], downsample v disable [0]
	rtd_outl(0xb802D980, 0x00000000);	// gray dummy line data 0 [29:0]
	rtd_outl(0xb802D984, 0x00000000);	// gray dummy line data 1 [29:0]
	rtd_outl(0xb802D94C, 0x00000000);	// gray dummy line data 2 [29:0]
	rtd_outl(0xb802DA28, 0x00000000);	// gray dummy line data 3 [29:0]
	rtd_outl(0xb802DA24, 0x00000000);	// dummy line data selection

	// ----------------------- SFG Timing -----------------------
	rtd_outl(0xb802D900, 0x01140040);
	// tcon_clk=dclk [27], sfg_clk=dclk [26], SFG_OSD path disable[25], SFG path enable [24],
	// fixed DTG last line hsync period [22], any to any subpixel disable [21], PIF clk selection vby1 [18],
	// pre rb swap disable[17], display 30bit RGB mode[13:12], dclk/aclk enable [6], post rb swap disable[5],
	rtd_outl(0xb802D9B8, 0x00000000);	// PIF clock enable / disable control (LVDS/LVDS[31], EPI[30], Vby1[29], Vby1 OSD[28], P2P[15], iSP[14], USIT[13]), Data inverse disable [16],
	rtd_outl(0xb802D950, 0x089D002D);	// Dv_den_end[29:16] = 2205, Dv_den_sta[13:0] = 45
	rtd_outl(0xb802D954, 0x10180118);	// Dh_den_end[29:16] = 4120, Dh_den_sta[13:0] = 280
	rtd_outl(0xb802D958, 0x057F112F);	// Dv_width[31:24] = 5, Dh_width[23:16] = 127, Dh_total[12:0] = 4399
	rtd_outl(0xb802D99C, 0x0F000000);	// Final Line Length[28:16] = 3840
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode[18:16], Final_addr_split_mode[12:0],
	rtd_outl(0xb802D9A4, 0x01181128);	// hs_den_io_dist (auto config)[28:16], hs_io_dist (auto config)[12:0]
	rtd_outl(0xb802D98C, 0x00000000);	// hsync_width(auto config)[23:16], hsync_delay(auto config)[15:0]
	rtd_outl(0xb802D990, 0x00000000);	// Hs_distance (for DRD&RGB Split mode) [29:16], vsync_end(auto config)[15:8], vsync_start(auto config)[7:0]
	rtd_outl(0xb802D994, 0x00000000);	// sfg_dh_den_sta (auto config)[31:16], req_start (auto config)[15:0]

	// ------------------------ Force SFG Data as background color -------------------------
	rtd_outl(0xb802D928, 0x00000000);	// bypass sfg data[31], dif background R [29:30], G[19:10], B[9:0]
	rtd_outl(0xb802D904, 0x0BFFFF00);	// PIF_Clock = Dclk / (11+1) [27:24], Force A~P port to background enable [23][22]...[8]

	// ------------------------ SFG Control -------------------------
	rtd_outl(0xb802D964, 0x00000B0B);	// SFG normal mode[29:28], 1 pixel mode[17:16], 11+1 Segment[12:8], H-Flip disable[7], 11+1 Port[4:0]
	rtd_outl(0xb802D910, 0x00000003);	// CRC normal mode[31], CRC continuous mode [1], CRC control start[0]

	// -------------------------- Segment Setting ---------------------------
	rtd_outl(0xb802D968, 0x00000140);	// Seg 0 Start [28:16] = 0, Seg 1 Start [12:0] = 320
	rtd_outl(0xb802D96C, 0x028003C0);	// Seg 2 Start [28:16] = 640, Seg 3 Start [12:0] = 960
	rtd_outl(0xb802D970, 0x05000640);	// Seg 4 Start [28:16] = 1280, Seg 5 Start [12:0] = 1600
	rtd_outl(0xb802D974, 0x078008C0);	// Seg 6 Start [28:16] = 1920, Seg 7 Start [12:0] = 2240
	rtd_outl(0xb802D978, 0x0A000B40);	// Seg 8 Start [28:16] = 2560, Seg 9 Start [12:0] = 2880
	rtd_outl(0xb802D97C, 0x0C800DC0);	// Seg 10 Start [28:16] = 3200, Seg 11 Start [12:0] = 3520
	rtd_outl(0xb802D998, 0x00000000);	// Segment 15~0 Flip [15][14]�K[0]
	rtd_outl(0xb802DA94, 0x00000000);	// Line 0 last segment start [28:16] = 0, Line 1 last segment start [12:0] = 0
	rtd_outl(0xb802DA98, 0x00000000);	// Line 2 last segment start [28:16] = 0, Line 3 last segment start [12:0] = 0
	rtd_outl(0xb802DBE0, 0x00000000);	// Line 4 last segment start [28:16] = 0, Line 5 last segment start [12:0] = 0
	rtd_outl(0xb802DBE4, 0x00000000);	// Line 6 last segment start [28:16] = 0, Line 7 last segment start [12:0] = 0

	// -------------------------- Zig-Zag Mode ---------------------------
	rtd_outl(0xb802D92C, 0x00000000);	// 8n+0~8n+3 line ZZ mode control
	rtd_outl(0xb802DBA8, 0x00000000);	// 8n+4~8n+7 line ZZ mode control
	rtd_outl(0xb802DA0C, 0x00000000);	// 8n+0 line ZZ mode virtual dummy content selection, virtual duumy selection
	rtd_outl(0xb802DA10, 0x00000000);	// 8n+1 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DA14, 0x00000000);	// 8n+2 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DA18, 0x00000000);	// 8n+3 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DBAC, 0x00000000);	// 8n+4 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DBB0, 0x00000000);	// 8n+5 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DBB4, 0x00000000);	// 8n+6 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DBB8, 0x00000000);	// 8n+7 line ZZ mode virtual dummy content selection

	// -------------------------- Add Segment dummy front / back pixels or mid subpixel ---------------------------
	rtd_outl(0xb802D930, 0x00000000);	// Seg 0 / Seg 1 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D934, 0x00000000);	// Seg 2 / Seg 3 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D938, 0x00000000);	// Seg 4 / Seg 5 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D940, 0x00000000);	// Seg 6 / Seg 7 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D944, 0x00000000);	// Seg 8 / Seg 9 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D948, 0x00000000);	// Seg 10 / Seg 11 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D9E8, 0x00000000);	// Seg 0 / Seg 1 place and number of middle dummy subpixel
	rtd_outl(0xb802D9EC, 0x00000000);	// Seg 2 / Seg 3 place and number of middle dummy subpixel
	rtd_outl(0xb802D9F0, 0x00000000);	// Seg 4 / Seg 5 place and number of middle dummy subpixel
	rtd_outl(0xb802D9F4, 0x00000000);	// Seg 6 / Seg 7 place and number of middle dummy subpixel
	rtd_outl(0xb802D9F8, 0x00000000);	// Seg 8 / Seg 9 place and number of middle dummy subpixel
	rtd_outl(0xb802D9FC, 0x00000000);	// Seg 10 / Seg 11 place and number of middle dummy subpixel
	rtd_outl(0xb802DA1C, 0x00000000);	// front/back/middle dummy content [28], double buffer[20]

	// -------------------------- SFG_Pattern Generate ---------------------------
	rtd_outl(0xb802DBF0, 0x1DF10E20);	// width[28:20] = 479+1, height[16:8] = 270+1, [5] pattern reset not by hs, [3] rgb mode, [2:1] v color bar, [0] SFG ptn gen disable
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// color bar 0 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// color bar 1 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// color bar 2 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC00, 0x0000FF00);	// color bar 3 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC04, 0x00FF00FF);	// color bar 4 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC08, 0x00FF0000);	// color bar 5 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC0C, 0x000000FF);	// color bar 6 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC10, 0x00000000);	// color bar 7 content W[31:24], R[23:16], G[15:8], B[7:0]

	// -------------------------- SFG_Pattern Detect ---------------------------
	rtd_outl(0xb802DC38, 0x00000000);	// frame thershold [15:8], pattern detection disable

	// -------------------------- PIF FIFO Control ---------------------------
	rtd_outl(0xb802DC94, 0x50000000);	// PIF_FIFO disable[31], TX PHY iSP mode[30:28]
	rtd_outl(0xb802DC98, 0x9C000FFF);	// PIF_FIFO auto reset enable [31] ,Lane 15~0 [15:0] enable / disable control
	rtd_outl(0xb802DC9C, 0x76543210);	// Lane 7~0 pair assign
	rtd_outl(0xb802DCA0, 0xFFFFBA98);	// Lane 15~8 pair assign
	rtd_outl(0xb802DCA4, 0x00000000);	// BIST_FIFO disable[31]
	rtd_outl(0xb802DCC8, 0x00000FFF);	// 16 lane video[30:28], phy lane15~0 enable / disable control [15:0]
	rtd_outl(0xb802DCCC, 0x00000000);	// fix pattern disable [31], fix pattern content [26:0]
	rtd_outl(0xb802DCD0, 0x00000FFF);	// Lane 15~0  [15:0] PN swap disable / enable control
	rtd_outl(0xb802DCD4, 0x00000000);	// send prbs to phy disable, PRBS7 mode

	rtd_part_outl(0xb802D900, 11, 11, 0x1);	// SFG out enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCK Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb800081C, 0x0FFFFFFF, 0xA0000000);	// GPIO_28 pinshare to iSP_SDLCOK_scr2,
	rtd_maskl(0xb8000CBC, 0xFFFFFCFF, 0x00000200);	// iSP_LOCK use iSP_SDLOCK_src2,
	rtd_maskl(0xb8000824, 0xEFFFFFFF, 0x00000000);	// GPIO_28 use 3.3V GPI,

	//---------------------------------------------------------------------------------------------------------------------------------
	//iSP MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D100, 0x00000000);	// sdlock unlock IRQ disable[30], extend subpixel numbr[15:4], 1 pair mode[1], iSP disable[0]
	rtd_outl(0xb802D104, 0x11141400);	// scrm select[5:12] as key[30], scrm pixel type[29], scrm on[28], iSP 8bits[25:24], BKPOL use TCON20 [20:16], POL[1] use TCON20 [12:8], POL[0] use TCON0 [4:0]
	rtd_outl(0xb802D108, 0x3B4F0129);	// send SD setting 59+1 bytes[29:24], hs_to_den_distanece[23:16]= (dh_den_sta / port + 3 ) * bit * 3 / 8=79, SDLOCK use hw mode[12], td[10:0]=297 / 148.5MHz
	rtd_outl(0xb802D10C, 0x00000001);	// send SD setting data every 1 frames[7:0]
	rtd_outl(0xb802D110, 0x5E11E100);	// sd_lock_type[31] = TBK1, TBK2,.., TBK_EN[30]=0: output TBK, TBK1[28:20]= 9d481=9b111100001, TBK2[16:8]=9d481=9b111100001, dummy[7:0]=0
	rtd_outl(0xb802D114, 0x001E0181);	// BAC[24:16] = 9d30 = 9b000011110, SET[8:0] = 9d385 = 9b110000001
	rtd_outl(0xb802D118, 0x0000007E);	// EOL[8:0] = 9d126 = 9b001111110
	rtd_outl(0xb802D11C, 0x01EE0011);	// BKPOLP[24:16] = 9d494= 9b111101110, BKPOLN[8:0] = 9d17 = 9b000010001
	rtd_outl(0xb802D120, 0x01E601E6);	// POLP_geseln[24:16] = 9d486 = 9b111100110, POLP_geselp[8:0] = 9d486 = 9b111100110
	rtd_outl(0xb802D124, 0x00190019);	// POLN_geseln[24:16] = 9d25 = 9b000011001, POLN_geselp[24:16] = 9d25 = 9b000011001
	rtd_outl(0xb802D128, 0x05050505);	// set0_p0[31:24]=5, set0_p1[23:16]=5, set0_p2[15:8]=5, set0_p3[7:0]=5
	rtd_outl(0xb802D12C, 0x05050505);	// set0_p4=5, set0_p5=5, set0_p6=5, set0_p7=5
	rtd_outl(0xb802D130, 0x05050505);	// set0_p8=5, set0_p9=5, set0_p10=5, set0_p11=5
	rtd_outl(0xb802D134, 0x65656565);	// set1_p0=103, set1_p1=103, set1_p2=103, set1_p3=103
	rtd_outl(0xb802D138, 0x65656565);	// set1_p4=103, set1_p5=103, set1_p6=103, set1_p7=103
	rtd_outl(0xb802D13C, 0x65656565);	// set1_p8=103, set1_p9=103, set1_p10=103, set1_p11=103
	rtd_outl(0xb802D140, 0x4C4C4C4C);	// set2_p0=76, set2_p1=76, set2_p2=76, set2_p3=76
	rtd_outl(0xb802D144, 0x4C4C4C4C);	// set2_p4=76, set2_p5=76, set2_p6=76, set2_p7=76
	rtd_outl(0xb802D148, 0x4C4C4C4C);	// set2_p8=76, set2_p9=76, set2_p10=76, set2_p11=76
	rtd_outl(0xb802D14C, 0x14141414);	// set3_p0=20, set3_p1=20, set3_p2=20, set3_p3=20
	rtd_outl(0xb802D150, 0x14141414);	// set3_p4=20, set3_p5=20, set3_p6=20, set3_p7=20
	rtd_outl(0xb802D154, 0x14141414);	// set3_p8=20, set3_p9=20, set3_p10=20, set3_p11=20
	rtd_outl(0xb802D158, 0x86868686);	// set4_p0=134, set4_p1=134, set4_p2=134, set4_p3=134
	rtd_outl(0xb802D15C, 0x86868686);	// set4_p4=134, set4_p5=134, set4_p6=134, set4_p7=134
	rtd_outl(0xb802D160, 0x86868686);	// set4_p8=134, set4_p9=134, set4_p10=134, set4_p11=134
	rtd_outl(0xb802D164, 0x64646464);	// set5_p0=100, set5_p1=100, set5_p2=100, set5_p3=100
	rtd_outl(0xb802D168, 0x64646464);	// set5_p4=100, set5_p5=100, set5_p6=100, set5_p7=100
	rtd_outl(0xb802D16C, 0x64646464);	// set5_p8=100, set5_p9=100, set5_p10=100, set5_p11=100
	rtd_outl(0xb802D170, 0x15151515);	// set6_p0=21, set6_p1=21, set6_p2=21, set6_p3=21
	rtd_outl(0xb802D174, 0x15151515);	// set6_p4=21, set6_p5=21, set6_p6=21, set6_p7=21
	rtd_outl(0xb802D178, 0x15151515);	// set6_p8=21, set6_p9=21, set6_p10=21, set6_p11=21
	rtd_outl(0xb802D17C, 0x00000000);	// set7_p0=0, set7_p1=0, set7_p2=0, set7_p3=0
	rtd_outl(0xb802D180, 0x00000000);	// set7_p4=0, set7_p5=0, set7_p6=0, set7_p7=0
	rtd_outl(0xb802D184, 0x00000000);	// set7_p8=0, set7_p9=0, set7_p10=0, set7_p11=0
	rtd_outl(0xb802D188, 0x34343434);	// set8_p0=52, set8_p1=52, set8_p2=52, set8_p3=52
	rtd_outl(0xb802D18C, 0x34343434);	// set8_p4=52, set8_p5=52, set8_p6=52, set8_p7=52
	rtd_outl(0xb802D190, 0x34343434);	// set8_p8=52, set8_p9=52, set8_p10=52, set8_p11=52
	rtd_outl(0xb802D194, 0x0F0F0F0F);	// set9_p0=15, set9_p1=15, set9_p2=15, set9_p3=15
	rtd_outl(0xb802D198, 0x0F0F0F0F);	// set9_p4=15, set9_p5=15, set9_p6=15, set9_p7=15
	rtd_outl(0xb802D19C, 0x0F0F0F0F);	// set9_p8=15, set9_p9=15, set9_p10=15, set9_p11=15
	rtd_outl(0xb802D1A0, 0x80000000);	// set10[31:24]=128,
	rtd_outl(0xb802D1AC, 0x00000000);	// set11[31:24]=0,
	rtd_outl(0xb802D1B8, 0x00000F49);	// set12=0, set13=0, set14=15, set15=73
	rtd_outl(0xb802D1BC, 0x5A45416E);	// set16=90, set17=69, set18=65, set19=110
	rtd_outl(0xb802D1C0, 0x82B2BBAC);	// set20=130, set21=178, set22=187, set23=172
	rtd_outl(0xb802D1C4, 0xC5F2FF1B);	// set24=197, set25=242, set26=255, set27=27
	rtd_outl(0xb802D1C8, 0x1C1D1E1F);	// set28=28, set29=29, set30=30, set31=31
	rtd_outl(0xb802D1CC, 0x20212223);	// set32=32, set33=33, set34=34, set35=35
	rtd_outl(0xb802D1D0, 0x24252627);	// set36=36, set37=37, set38=38, set39=39
	rtd_outl(0xb802D1D4, 0x28292A2B);	// set40=40, set41=41, set42=42, set43=43
	rtd_outl(0xb802D1D8, 0x2C2D2E2F);	// set44=44, set45=45, set46=46, set47=47
	rtd_outl(0xb802D1DC, 0x30313233);	// set48=48, set49=49, set50=50, set51=51
	rtd_outl(0xb802D1E0, 0x34353637);	// set52=52, set53=53, set54=54, set55=55
	rtd_outl(0xb802D1E4, 0x38393A3B);	// set56=56, set57=57, set58=58, set59=59
	rtd_outl(0xb802D1E8, 0x0000FFF3);	// crc_port0~11 enable/disable[15:4], crc continuous mode[1], crc enable[0]

	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(1),
	rtd_outl(0xb8000C0C, 0x8000E4B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000100);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(2),
	rtd_outl(0xb8000C14, 0x00000001);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000004);	// TXPLL use iSP feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	//rtd_outl(0xb8000C50, 0x01F4C000);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C50, 0x01D08000);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(0),

	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C78, 0x00000600);	// CKIN_DIVN(8),
	//
	rtd_outl(0xb8000D00, 0x66002A01);	// Lane0 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D10, 0x66002A01);	// Lane1 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D20, 0x66002A01);	// Lane2 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D30, 0x66002A01);	// Lane3 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D40, 0x66002A01);	// Lane4 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	//rtd_outl(0xb8000D50, 0x66002A01);	// Lane5 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	//rtd_outl(0xb8000D60, 0x66002A01);	// Lane6 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D50, 0x6600231F);	// Lane5 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D60, 0x6600231F);	// Lane6 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D70, 0x66002A01);	// Lane7 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D80, 0x66002A01);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D90, 0x66002A01);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000DA0, 0x66002A01);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000DB0, 0x66002A01);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000DC0, 0x77002000);	// Lane12: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DD0, 0x77002000);	// Lane13: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DE0, 0x77002000);	// Lane14: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DF0, 0x77002000);	// Lane15: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,

	//
	rtd_outl(0xb8000D04, 0x44000000);	// Lane0 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D14, 0x44000000);	// Lane1 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D24, 0x44000000);	// Lane2 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D34, 0x44000000);	// Lane3 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D44, 0x44000000);	// Lane4 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D54, 0x44000000);	// Lane5 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D64, 0x44000000);	// Lane6 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D74, 0x44000000);	// Lane7 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D84, 0x44000000);	// Lane8 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D94, 0x44000000);	// Lane9 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DA4, 0x44000000);	// Lane10: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DB4, 0x44000000);	// Lane11: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DC4, 0x44000000);	// Lane12: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DD4, 0x44000000);	// Lane13: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DE4, 0x44000000);	// Lane14: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DF4, 0x44000000);	// Lane15: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,

	//
	rtd_outl(0xb8000D08, 0x0000000A);	// Lane0 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D18, 0x0000000A);	// Lane1 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D28, 0x0000000A);	// Lane2 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D38, 0x0000000A);	// Lane3 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D48, 0x0000000A);	// Lane4 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D58, 0x0000000A);	// Lane5 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D68, 0x0000000A);	// Lane6 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D78, 0x0000000A);	// Lane7 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D88, 0x0000000A);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D98, 0x0000000A);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DA8, 0x0000000A);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DB8, 0x0000000A);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DC8, 0x0000000A);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DD8, 0x0000000A);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DE8, 0x0000000A);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DF8, 0x0000000A);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) iSP/EPI Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x40004000);
	//
	// (8) iSP MAC Enable (Below Setting)
	rtd_part_outl(0xb802D100, 0, 0, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_part_outl(0xb802DC94, 31, 31, 0x1);

	//rtd_outl(0xb802D038, 0x00000001);
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_outl(0xb8000CC0, 0x00000FFF);
	//
	// (11) Panel Power Enable (SW Control),

}

void panel_usit_50inch_uhd60_12lane(void)
{
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG Setting
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------

	// ----------------------- Insert Dummy Line Function & Auto Config SFG Timing Gen -----------------------
	rtd_outl(0xb802D988, 0x40300190);	// bypass SFG disable[31], auto config sfg timing gen [30], insert dummy line[22:20]/[18:16]/[14:12]/[10:8], downsample v disable [0]
	rtd_outl(0xb802D980, 0x00000000);	// gray dummy line data 0 [29:0]
	rtd_outl(0xb802D984, 0x0000003F);	// gray dummy line data 1 [29:0]
	rtd_outl(0xb802D94C, 0x0000005F);	// gray dummy line data 2 [29:0]
	rtd_outl(0xb802DA28, 0x0000007F);	// gray dummy line data 3 [29:0]
	rtd_outl(0xb802DA24, 0x0000FFE4);	// dummy line data selection

	// ----------------------- SFG Timing -----------------------
	rtd_outl(0xb802D900, 0x01160040);	// tcon_clk=dclk [27], sfg_clk=dclk [26], SFG_OSD path disable[25], SFG path enable [24],
	//fixed DTG last line hsync period [22], any to any subpixel disable [21], PIF clk selection vby1 [18], pre rb swap enable[17],
	//display 30bit RGB mode[13:12], dclk/aclk enable [6], post rb swap disable[5],
	rtd_outl(0xb802D9B8, 0x00000000);	// PIF clock enable / disable control (LVDS/LVDS[31], EPI[30], Vby1[29], Vby1 OSD[28], P2P[15], iSP[14], USIT[13]), Data inverse disable [16],
	rtd_outl(0xb802D950, 0x089D002D);	// Dv_den_end[29:16] = 2205, Dv_den_sta[13:0] = 45
	rtd_outl(0xb802D954, 0x10180118);	// Dh_den_end[29:16] = 4120, Dh_den_sta[13:0] = 280
	rtd_outl(0xb802D958, 0x057F112F);	// Dv_width[31:24] = 5, Dh_width[23:16] = 127, Dh_total[12:0] = 4399
	rtd_outl(0xb802D99C, 0x0F000000);	// Final Line Length[28:16] = 3840
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode[18:16], Final_addr_split_mode[12:0],
	rtd_outl(0xb802D9A4, 0x00000000);	// hs_den_io_dist (auto config)[28:16], hs_io_dist (auto config)[12:0]
	rtd_outl(0xb802D98C, 0x00000000);	// hsync_width(auto config)[23:16], hsync_delay(auto config)[15:0]
	rtd_outl(0xb802D990, 0x00000000);	// Hs_distance (for DRD&RGB Split mode) [29:16], vsync_end(auto config)[15:8], vsync_start(auto config)[7:0]
	rtd_outl(0xb802D994, 0x00000000);	// sfg_dh_den_sta (auto config)[31:16], req_start (auto config)[15:0]

	// ------------------------ Force SFG Data as background color -------------------------
	rtd_outl(0xb802D928, 0x00000000);	// bypass sfg data[31], dif background R [29:30], G[19:10], B[9:0]
	rtd_outl(0xb802D904, 0x0BFFFF00);	// PIF_Clock = Dclk / (11+1) [27:24], Force A~P port to background enable [23][22]...[8]

	// ------------------------ SFG Control -------------------------
	rtd_outl(0xb802D964, 0x00000B0B);	// SFG normal mode[29:28], 1 pixel mode[17:16], 11+1 Segment[12:8], H-Flip disable[7], 11+1 Port[4:0]
	rtd_outl(0xb802D910, 0x00000003);	// CRC normal mode[31], CRC continuous mode [1], CRC control start[0]

	// -------------------------- Segment Setting ---------------------------
	rtd_outl(0xb802D968, 0x00000140);	// Seg 0 Start [28:16] = 0, Seg 1 Start [12:0] = 320
	rtd_outl(0xb802D96C, 0x028003C0);	// Seg 2 Start [28:16] = 640, Seg 3 Start [12:0] = 960
	rtd_outl(0xb802D970, 0x05000640);	// Seg 4 Start [28:16] = 1280, Seg 5 Start [12:0] = 1600
	rtd_outl(0xb802D974, 0x078008C0);	// Seg 6 Start [28:16] = 1920, Seg 7 Start [12:0] = 2240
	rtd_outl(0xb802D978, 0x0A000B40);	// Seg 8 Start [28:16] = 2560, Seg 9 Start [12:0] = 2880
	rtd_outl(0xb802D97C, 0x0C800DC0);	// Seg 10 Start [28:16] = 3200, Seg 11 Start [12:0] = 3520
	rtd_outl(0xb802D998, 0x00000000);	// Segment 15~0 Flip [15][14]�K[0]
	rtd_outl(0xb802DA94, 0x00000000);	// Line 0 last segment start [28:16] = 0, Line 1 last segment start [12:0] = 0
	rtd_outl(0xb802DA98, 0x00000000);	// Line 2 last segment start [28:16] = 0, Line 3 last segment start [12:0] = 0
	rtd_outl(0xb802DBE0, 0x00000000);	// Line 4 last segment start [28:16] = 0, Line 5 last segment start [12:0] = 0
	rtd_outl(0xb802DBE4, 0x00000000);	// Line 6 last segment start [28:16] = 0, Line 7 last segment start [12:0] = 0

	// -------------------------- Zig-Zag Mode ---------------------------
	rtd_outl(0xb802D92C, 0x00101000);	// 8n+0~8n+3 line ZZ mode control
	rtd_outl(0xb802DBA8, 0x00101000);	// 8n+4~8n+7 line ZZ mode control
	rtd_outl(0xb802DA0C, 0x12345600);	// 8n+0 line ZZ mode virtual dummy content selection, virtual duumy selection
	rtd_outl(0xb802DA10, 0x12345600);	// 8n+1 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DA14, 0x12345600);	// 8n+2 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DA18, 0x12345600);	// 8n+3 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DBAC, 0x12345600);	// 8n+4 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DBB0, 0x12345600);	// 8n+5 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DBB4, 0x12345600);	// 8n+6 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DBB8, 0x12345600);	// 8n+7 line ZZ mode virtual dummy content selection
	rtd_outl(0xb802DB78, 0x00000000);	// Line 0 dummy data 1/0 content [25:16] / [9:0]
	rtd_outl(0xb802DB7C, 0x00000000);	// Line 1 dummy data 1/0 content [25:16] / [9:0]
	rtd_outl(0xb802DB80, 0x00000000);	// Line 2 dummy data 1/0 content [25:16] / [9:0]
	rtd_outl(0xb802DB84, 0x00000000);	// Line 3 dummy data 1/0 content [25:16] / [9:0]
	rtd_outl(0xb802DB88, 0x00000000);	// Line 4 dummy data 1/0 content [25:16] / [9:0]
	rtd_outl(0xb802DB8C, 0x00000000);	// Line 5 dummy data 1/0 content [25:16] / [9:0]
	rtd_outl(0xb802DB90, 0x00000000);	// Line 6 dummy data 1/0 content [25:16] / [9:0]
	rtd_outl(0xb802DB94, 0x00000000);	// Line 7 dummy data 1/0 content [25:16] / [9:0]

	// -------------------------- Add Segment dummy front / back pixels or mid subpixel ---------------------------
	rtd_outl(0xb802D930, 0x00000000);	// Seg 0 / Seg 1 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D934, 0x00000000);	// Seg 2 / Seg 3 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D938, 0x00000000);	// Seg 4 / Seg 5 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D940, 0x00000000);	// Seg 6 / Seg 7 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D944, 0x00000000);	// Seg 8 / Seg 9 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D948, 0x00000000);	// Seg 10 / Seg 11 Line 0~3 front/back dummy pixel number
	rtd_outl(0xb802D9E8, 0x00000000);	// Seg 0 / Seg 1 place and number of middle dummy subpixel
	rtd_outl(0xb802D9EC, 0x00000000);	// Seg 2 / Seg 3 place and number of middle dummy subpixel
	rtd_outl(0xb802D9F0, 0x00000000);	// Seg 4 / Seg 5 place and number of middle dummy subpixel
	rtd_outl(0xb802D9F4, 0x00000000);	// Seg 6 / Seg 7 place and number of middle dummy subpixel
	rtd_outl(0xb802D9F8, 0x00000000);	// Seg 8 / Seg 9 place and number of middle dummy subpixel
	rtd_outl(0xb802D9FC, 0x00000000);	// Seg 10 / Seg 11 place and number of middle dummy subpixel
	rtd_outl(0xb802DA1C, 0x00000000);	// front/back/middle dummy content [28], double buffer[20]

	// -------------------------- SFG_Pattern Generate ---------------------------
	rtd_outl(0xb802DBF0, 0x1DF10E00);	// width[28:20] = 479+1, height[16:8] = 270+1, [5] pattern reset by hs, [3] rgb mode, [2:1] v color bar, [0] SFG ptn gen disable
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// color bar 0 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// color bar 1 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// color bar 2 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC00, 0x0000FF00);	// color bar 3 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC04, 0x00FF00FF);	// color bar 4 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC08, 0x00FF0000);	// color bar 5 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC0C, 0x000000FF);	// color bar 6 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC10, 0x00000000);	// color bar 7 content W[31:24], R[23:16], G[15:8], B[7:0]
	rtd_outl(0xb802DC14, 0x03FF0000);	// manual pettern supixel 1 [123:16] / subpixel 0 [7:0] content
	rtd_outl(0xb802DC18, 0x001C71C7);	// manual pettern 24 supixels on/off at line 0 [23:0]
	rtd_outl(0xb802DC1C, 0x00E38E38);	// manual pettern 24 supixels on/off at line 1 [23:0]
	rtd_outl(0xb802DC20, 0x001C71C7);	// manual pettern 24 supixels on/off at line 2 [23:0]
	rtd_outl(0xb802DC24, 0x00E38E38);	// manual pettern 24 supixels on/off at line 3 [23:0]

	// -------------------------- SFG_Pattern Detect ---------------------------
	rtd_outl(0xb802DC38, 0x00000000);	// frame thershold [15:8], pattern detection disable

	// -------------------------- PIF FIFO Control ---------------------------
	rtd_outl(0xb802DC94, 0x60000000);	// PIF_FIFO disable[31], TX PHY P2P mode[30:28]
	rtd_outl(0xb802DC98, 0x9C000FFF);	// PIF_FIFO auto reset enable [31] ,Lane 15~0 [15:0] enable / disable control
	rtd_outl(0xb802DC9C, 0x456789AB);	// Lane 7~0 pair assign
	rtd_outl(0xb802DCA0, 0xFFFF0123);	// Lane 15~8 pair assign
	rtd_outl(0xb802DCA4, 0x00000000);	// BIST_FIFO disable[31]
	rtd_outl(0xb802DCC8, 0x00000FFF);	// 16 lane video[30:28], phy lane15~0 enable / disable control [15:0]
	rtd_outl(0xb802DCCC, 0x00000000);	// fix pattern disable [31], fix pattern content [26:0]
	rtd_outl(0xb802DCD0, 0x00000000);	// Lane 15~0  [15:0] PN swap disable / enable control
	rtd_outl(0xb802DCD4, 0x00000000);	// send prbs to phy disable, PRBS7 mode

	rtd_part_outl(0xb802D900, 11, 11, 0x1); // SFG out enable

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFC Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb800081C, 0x0FFFFFFF, 0x00000000);	// GPIO_28 pinshare to usit_sfc,
	rtd_maskl(0xb8000824, 0xEFFFFFFF, 0x00000000);	// GPIO_28 use 3.3V GPI,

	//---------------------------------------------------------------------------------------------------------------------------------
	//SBC Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb8000800, 0xFFFF0FFF, 0x0000C000);	// GPIO_02 pinshare to usit_sbc_src3,
	rtd_maskl(0xb8000CBC, 0xFFFF0FFF, 0x0000C000);	// usit_sbc_sel use usit_sbc_src3_in,
	rtd_maskl(0xb8000824, 0xDFFFFFFF, 0x00000000);	// GPIO_02 use 3.3V GPI,

	//---------------------------------------------------------------------------------------------------------------------------------
	//USI-T MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8026A00, 0x1F1F11F0);	// IRQ Setting [28:24] / [20:16],  1 pair mode[3], 8 bit[1], USIT disable[0]
	rtd_outl(0xb8026A04, 0x43000000);	// hs_to_rdata0[31:24] = ((280/12-1)*8* /9 -3)+8*3/2=69,
	//send GAM/FRM_CONF before first dummy line[16], back[15:8] / front[7:0] dummy line num = 0 / 0
	rtd_outl(0xb8026A08, 0x000F0B10);
	//rtd_outl(0xb8026A08, 0x000F0010); // disable force send training ptn[28], 2T training ptn[25:24], training ptn offset[22:16] = 10,
	//send training ptn every 0+1 frm[15:12], output sfc by reg_sfc_training_pat_offset[11:8], send gma/frm_conf every 0+1 frm[1:0]
	rtd_outl(0xb8026A0C, 0x12300FFF);	// PACMOD[2:0]=1 for rgb mode[30:28], PACMOD[2:0]=2 for digital-gam mode[26:24],
	//PACMOD[2:0]=3 for gam+frm mode[22:20], gam(value=0) or gam+frm config(value=1) for all lane [11:0]
	rtd_outl(0xb8026A10, 0x0D03FFFF);	// disable force scrm initial HBP[29], scrm off[28], scrm rst[27:24] @ first fronrt dummy line,
	//scrm initial key[17:0] = 18b111111111111111111
	rtd_outl(0xb8026A14, 0x000F003F);	// trainint_ptn_1 [25:16] = 10d15= 10b0000001111, trainint_ptn_0 [9:0] = 10d63 = 10b0000111111
	rtd_outl(0xb8026A18, 0x000F003F);	// trainint_ptn_3 [25:16] = 10d15= 10b0000001111, trainint_ptn_2 [9:0] = 10d63 = 10b0000111111
	rtd_outl(0xb8026A1C, 0x00000067);	// dummy line data value[25:16]=0, HBP[9:0] = 10d103 = 10b0001100111
	rtd_outl(0xb8026A20, 0x03C10710);	// Lane 0 config <31:0> value[31:0]
	rtd_outl(0xb8026A24, 0x039F3C2A);	// Lane 0 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 0 config <47:32> value[15:0]
	rtd_outl(0xb8026A28, 0x03C10510);	// Lane 1 config <31:0> value[31:0]
	rtd_outl(0xb8026A2C, 0x039F3C2A);	// Lane 1 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 1 config <47:32> value[15:0]
	rtd_outl(0xb8026A30, 0x03C10510);	// Lane 2 config <31:0> value[31:0]
	rtd_outl(0xb8026A34, 0x039F3C2A);	// Lane 2 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 2 config <47:32> value[15:0]
	rtd_outl(0xb8026A38, 0x03C10510);	// Lane 3 config <31:0> value[31:0]
	rtd_outl(0xb8026A3C, 0x039F3C2A);	// Lane 3 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 3 config <47:32> value[15:0]
	rtd_outl(0xb8026A40, 0x03C10510);	// Lane 4 config <31:0> value[31:0]
	rtd_outl(0xb8026A44, 0x039F3C2A);	// Lane 4 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 4 config <47:32> value[15:0]
	rtd_outl(0xb8026A48, 0x03C10510);	// Lane 5 config <31:0> value[31:0]
	rtd_outl(0xb8026A4C, 0x039F3C2A);	// Lane 5 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 5 config <47:32> value[15:0]
	rtd_outl(0xb8026A50, 0x03C10510);	// Lane 6 config <31:0> value[31:0]
	rtd_outl(0xb8026A54, 0x039F3C2A);	// Lane 6 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 6 config <47:32> value[15:0]
	rtd_outl(0xb8026A58, 0x03C10510);	// Lane 7 config <31:0> value[31:0]
	rtd_outl(0xb8026A5C, 0x039F3C2A);	// Lane 7 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 7 config <47:32> value[15:0]
	rtd_outl(0xb8026A60, 0x03C10510);	// Lane 8 config <31:0> value[31:0]
	rtd_outl(0xb8026A64, 0x039F3C2A);	// Lane 8 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 8 config <47:32> value[15:0]
	rtd_outl(0xb8026A68, 0x03C10510);	// Lane 9 config <31:0> value[31:0]
	rtd_outl(0xb8026A6C, 0x039F3C2A);	// Lane 9 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 9 config <47:32> value[15:0]
	rtd_outl(0xb8026A70, 0x03C10510);	// Lane 10 config <31:0> value[31:0]
	rtd_outl(0xb8026A74, 0x039F3C2A);	// Lane 10 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 10 config <47:32> value[15:0]
	rtd_outl(0xb8026A78, 0x03C10510);	// Lane 11 config <31:0> value[31:0]
	rtd_outl(0xb8026A7C, 0x039F3C2A);	// Lane 11 packet number = reg_hs_to_rdata0 + packet_num =927, Lane 11 config <47:32> value[15:0]
	rtd_outl(0xb8026AA0, 0x7093AFF7);	// VGMA[31:24]=112, VGMA[23:16]=147, VGMA[15:8]=175, VGMA[7:0]=247
	rtd_outl(0xb8026AA4, 0x0D0D334D);	// VGMA[63:56]=13, VGMA[55:48]=13, VGMA[47:40]=51, VGMA[39:32]=77
	rtd_outl(0xb8026AA8, 0x93704F33);	// VGMA[95:88]=147, VGMA[87:80]=112, VGMA[79:72]=79, VGMA[71:64]=51
	rtd_outl(0xb8026AAC, 0x0000F7AF);	// VGMA[127:120]=0, VGMA[119:112]=0, VGMA[111:104]=247, VGMA[103:96]=175
	rtd_outl(0xb8026AB0, 0x00000000);	// VGMA[159:152]=0, VGMA[151:144]=0, VGMA[143:136]=0, VGMA[135:128]=0
	rtd_outl(0xb8026AB4, 0x00000000);	// VGMA[191:184]=0, VGMA[183:176]=0, VGMA[175:168]=0, VGMA[167:160]=0
	rtd_outl(0xb8026AB8, 0x00000000);	// VGMA[223:216]=0, VGMA[215:208]=0, VGMA[207:200]=0, VGMA[199:192]=0
	rtd_outl(0xb8026ABC, 0x00000000);	// VGMA[255:248]=0, VGMA[247:240]=0, VGMA[239:232]=0, VGMA[231:224]=0
	rtd_outl(0xb8026AC0, 0x00000000);	// VGMA[287:280]=0, VGMA[279:272]=0, VGMA[271:264]=0, VGMA[263:256]=0
	rtd_outl(0xb8026AC4, 0x00000000);	// VGMA[351:344]=0, VGMA[311:304]=0, VGMA[303:296]=0, VGMA[295:288]=0
	rtd_outl(0xb8026AC8, 0x00000000);	// VGMA[319:312]=0, VGMA[343:336]=0, VGMA[335:328]=0, VGMA[327:320]=0
	rtd_outl(0xb8026ACC, 0x00000000);	// VGMA[351:344]=0, VGMA[375:368]=0, VGMA[367:360]=0, VGMA[359:352]=0
	rtd_outl(0xb8026AD0, 0x00000000);	// frm_conmfig[31:0] setting value
	rtd_outl(0xb8026AD4, 0x00000000);	// frm_conmfig[63:32] setting value
	rtd_outl(0xb8026AD8, 0x00000000);	// frm_conmfig[63:32] setting value
	//rtd_outl(0xb8026B00, 0x00131914); // tcon D sel tcon 0, C sel tcon 19, B sel tcon 25, A sel tcon 20,
	rtd_outl(0xb8026B00, 0x01131914);
	rtd_outl(0xb8026B04, 0x00000000);	// tcon H sel tcon 0, G sel tcon 0, F sel tcon 0, E sel tcon 0,
	rtd_outl(0xb8026B10, 0x0BA90000);	// conf<7> sel	reg setting_xx_l/m [31:28], conf<6> sel PACMOD[2] [27:24],
	//conf<5> sel PACMOD[1] [23:20], conf<4> sel PACMOD[0] [19:16], conf<3> sel  reg setting_xx_l/m [15:12],
	//conf<2> sel  reg setting_xx_l/m [11:8], conf<1> sel  reg setting_xx_l/m [7:4], conf<0> sel  reg setting_xx_l/m [3:0],
	rtd_outl(0xb8026B14, 0x00000000);	// conf<15> sel  reg setting_xx_l/m [31:28], conf<14> sel  reg setting_xx_l/m [27:24],
	//conf<13> sel	reg setting_xx_l/m [23:20], conf<12> sel  reg setting_xx_l/m [19:16],
	//conf<11> sel	reg setting_xx_l/m [15:12], conf<10> sel  reg setting_xx_l/m [11:8],
	//conf<9> sel  reg setting_xx_l/m [7:4], conf<8> sel  reg setting_xx_l/m [3:0],
	rtd_outl(0xb8026B18, 0x00000000);	// conf<23> sel  reg setting_xx_l/m [31:28], conf<22> sel  reg setting_xx_l/m [27:24],
	//conf<21> sel	reg setting_xx_l/m [23:20], conf<20> sel  reg setting_xx_l/m [19:16], conf<19> sel	reg setting_xx_l/m [15:12],
	//conf<18> sel	reg setting_xx_l/m [11:8], conf<17> sel  reg setting_xx_l/m [7:4], conf<16> sel  reg setting_xx_l/m [3:0],
	rtd_outl(0xb8026B1C, 0x00000000);	// conf<31> sel  reg setting_xx_l/m [31:28], conf<30> sel  reg setting_xx_l/m [27:24],
	//conf<29> sel	reg setting_xx_l/m [23:20], conf<28> sel  reg setting_xx_l/m [19:16], conf<27> sel	reg setting_xx_l/m [15:12],
	//conf<26> sel	reg setting_xx_l/m [11:8], conf<25> sel  reg setting_xx_l/m [7:4], conf<24> sel  reg setting_xx_l/m [3:0],
	rtd_outl(0xb8026B20, 0x0000100D);	// conf<39> sel  reg setting_xx_l/m [31:28], conf<38> sel  reg setting_xx_l/m [27:24],
	//conf<37> sel	reg setting_xx_l/m [23:20], conf<36> sel  reg setting_xx_l/m [19:16], conf<35> sel TCON A [15:12],
	//conf<34> sel	reg setting_xx_l/m [11:8], conf<33> sel  reg setting_xx_l/m [7:4], conf<32> sel  first_fdmy_line, [3:0],
	rtd_outl(0xb8026B24, 0x00000000);	// conf<47> sel  reg setting_xx_l/m [31:28], conf<46> sel  reg setting_xx_l/m [27:24],
	//conf<45> sel	reg setting_xx_l/m [23:20], conf<44> sel  reg setting_xx_l/m [19:16], conf<43> sel	reg setting_xx_l/m [15:12],
	//conf<42> sel	reg setting_xx_l/m [11:8], conf<41> sel  reg setting_xx_l/m [7:4], conf<40> sel  reg setting_xx_l/m [3:0],
	rtd_outl(0xb8026B2C, 0x00000FFF);	// USIT P11 enable[11], P10 enable[10], P9 enable[9], P8 enable[8], P7 enable[7],
	//P6 enable[6], P5 enable[5], P4 enable[4], P11 enable[3], P2 enable[2], P1 enable[1], P0 enable[0],

	// -------------------------- Below for USI-T 2.0 Only ---------------------------
	rtd_outl(0xb8026B30, 0x00040108);	// send sbc_payload0-->1-->2-->3 [18:16], disable trigger and send SBC cmd for each port[12], sbc debounce value = 264[9:0] / packet clock
	rtd_outl(0xb8026B34, 0x37000414);	// t7= 64*(3[31:28]+1)+1=257, t6= 64*(7[27:24]+1)+1=513, t4=0[23:16]+1=1, t3= 64*(4+1)+1=320, t1= 64*(20+1)+1=1344
	rtd_outl(0xb8026B38, 0x0FFF0000);	// send sbc command for each port [27:16] (0: disable, 1:enable), sbc output mannual value[3] = 0,
	//sbc output manual mode from SBC_FSM[2], sbc input mannual value[1] = 0, sbc input manual mode from SBC_FSM[0],
	rtd_outl(0xb8026B3C, 0x00000108);	// Half bit time period[9:0] for SBC CMD mode
	rtd_outl(0xb8026B40, 0xAABBCCDD);	// Lane 0 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B48, 0xAABBCCDD);	// Lane 1 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B50, 0xAABBCCDD);	// Lane 2 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B58, 0xAABBCCDD);	// Lane 3 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B60, 0xAABBCCDD);	// Lane 4 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B68, 0xAABBCCDD);	// Lane 5 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B70, 0xAABBCCDD);	// Lane 6 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B78, 0xAABBCCDD);	// Lane 7 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B80, 0xAABBCCDD);	// Lane 8 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B88, 0xAABBCCDD);	// Lane 9 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B90, 0xAABBCCDD);	// Lane 10 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_outl(0xb8026B98, 0xAABBCCDD);	// Lane 11 payload byte 3 [31:24] = 170, byte 2 [23:16] = 187, byte 1 [15:8] = 204, byte 0 [7:0] = 221,
	rtd_maskl(0xb8026B30, 0xFFFFEFFF, 0x00001000);		// sbc_cmd trigger
	// -------------------------- Above for USI-T 2.0 Only ---------------------------

	rtd_outl(0xb8026BC0, 0x0000FFF3);	// crc each port enable/disable [15:4], crc auto compare disable[2], crc continuous mode[1], crc enable[0]
	rtd_outl(0xb8026BC8, 0x00000000);	// crc golden value[31:0]
	rtd_outl(0xb8026BD0, 0x80000000);	// debug port enable[31], debug video data sel flip-flop output[9:8],
	//debug port source sel 3n+0/+1/+2 for sel port(n) r/g/b[5:0]
	rtd_outl(0xb8026BE0, 0x00000FFF);	// bist disable[31], bist length[19:0] = 4095

	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0x30030020);	// PI_A1(phase16) [31:20], A2(phase16) [19:8], A_freq 300~600MHz [5:4], A1 1X current [3], A2 1X current [2], VBG 1.223V [1:0]
	rtd_outl(0xb8000C04, 0x30030020);	// PI_B1(phase16) [31:20], B2(phase16) [19:8], B_freq 300~600MHz [5:4], B1 1X current [3], B2 1X current [2]
	rtd_outl(0xb8000C08, 0x03080100);	// PI_AB(phase0) [31:20], AB_freq 300~600MHz [19:18], AB 1X current [17], LDO_1V [9:8]= 1.0V, DIB_PFD [1:0] = /(0+1)
	rtd_outl(0xb8000C0C, 0x8010E4B0);	// big KVCO [31], PLL_clk non-inverted [29], bypass PLL_divM [20], PLL_ICP[18:16], PLL_SC1[15:13], PLL_SC2[12:11], PLL_SR[10:8], PLL_LDO [7:6]= 2.0V, bypass PI_A [5], bypass PI_B [5]
	rtd_outl(0xb8000C10, 0x00000100);	// LVDS/mLVDS divM [30:25] = 0+2, MACPLL_CKO non-inverted [23], CK20X non-inverted [21], CK1X non-inverted [20], Pre-scaler_LS[14:12] = 1, Pre-scaler_HS[9:8] = 1+1, EPI_divM[2:0] = /11
	rtd_outl(0xb8000C14, 0x00000001);	// normal VCO [2], test pad sel TXPLL_LOOPCK_TST [1], PLL_ICP<3>[0] = 1
	rtd_outl(0xb8000C18, 0x00000003);	// MACPLL_divM [7:4] = 0+2, TXPLL use BOE feedback path [2:0]
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_RSTN [10] = 0, TXPLL power on [9]
	rtd_outl(0xb8000C50, 0x01808000);	// TX Current = 1.6+(7 [25:22]*0.32) = 3.84mA, TX VCM = 0.7+(0 [21:17]*25mV) = 900mV, LDO_1V enable [15], VCM shif down disable [0]
	rtd_outl(0xb8000C74, 0x80000000);	// Global power enable [31]
	rtd_outl(0xb8000C78, 0x00000700);	// TXPLL_CKIN_DIV_N = 7[13:8]+2, TXPLL_PREDIVN_BYPASS[5] = 0

	rtd_outl(0xb8000D00, 0x66002A01);	// Lane0 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D10, 0x66002A01);	// Lane1 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D20, 0x66002A01);	// Lane2 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D30, 0x66002A01);	// Lane3 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D40, 0x66002A01);	// Lane4 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D50, 0x66002A01);	// Lane5 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D60, 0x66002A01);	// Lane6 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D70, 0x66002A01);	// Lane7 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D80, 0x66002A01);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000D90, 0x66002A01);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000DA0, 0x66002A01);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000DB0, 0x66002A01);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL,
	rtd_outl(0xb8000DC0, 0x77002000);	// Lane12: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DD0, 0x77002000);	// Lane13: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DE0, 0x77002000);	// Lane14: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DF0, 0x77002000);	// Lane15: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,

	rtd_outl(0xb8000D04, 0x04000000);	// Lane0 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D14, 0x04000000);	// Lane1 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D24, 0x04000000);	// Lane2 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D34, 0x04000000);	// Lane3 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D44, 0x04000000);	// Lane4 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D54, 0x04000000);	// Lane5 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D64, 0x04000000);	// Lane6 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D74, 0x04000000);	// Lane7 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D84, 0x04000000);	// Lane8 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000D94, 0x04000000);	// Lane9 : CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DA4, 0x04000000);	// Lane10: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DB4, 0x04000000);	// Lane11: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DC4, 0x04000000);	// Lane12: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DD4, 0x04000000);	// Lane13: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DE4, 0x04000000);	// Lane14: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,
	rtd_outl(0xb8000DF4, 0x04000000);	// Lane15: CKMX_INV(0), IEM_EN(1), RT_EN(1), RP_EN(0), IEM_SEL,

	rtd_outl(0xb8000D08, 0x0000000A);	// Lane0 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D18, 0x0000000A);	// Lane1 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D28, 0x0000000A);	// Lane2 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D38, 0x0000000A);	// Lane3 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D48, 0x0000000A);	// Lane4 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D58, 0x0000000A);	// Lane5 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D68, 0x0000000A);	// Lane6 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D78, 0x0000000A);	// Lane7 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D88, 0x0000000A);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000D98, 0x0000000A);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DA8, 0x0000000A);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DB8, 0x0000000A);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DC8, 0x0000000A);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DD8, 0x0000000A);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DE8, 0x0000000A);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),
	rtd_outl(0xb8000DF8, 0x0000000A);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(1), DRV_MODE_SEL(PP_MODE),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) EPI/USI-T Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x40002000);
	//
	// (8) USI-T MAC Enable (Below Setting)
	rtd_part_outl(0xb8026A00, 0, 0, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_part_outl(0xb802DC94, 31, 31, 0x1);

	// (10) APHY Lane Power Enable (Below Setting)
	rtd_outl(0xb8000CC0, 0x00000FFF);
	//
	// (11) Panel Power Enable (SW Control),

	// Tcon Pinshare Setting,
	rtd_part_outl(0xb800080C, 15, 12, 0x5);		// gpio_14 for VST, use Tcon0, 0x4/5/6/7_TCON_20/0/1/2
	rtd_part_outl(0xb8000814, 31, 28, 0x6);		// gpio_20 for CK1, use Tcon21, 0x4/5/6/7_TCON_19/20/21/27
	rtd_part_outl(0xb8000814, 23, 20, 0x5);		// gpio_21 for CK2, use Tcon22, 0x4/5/6/7_TCON_21/22/23/24
	rtd_part_outl(0xb8000818, 15, 12, 0x4);		// gpio_26 for CK3, use Tcon26, 0x3/4/5/6_TCON_27/26/1/0
	rtd_part_outl(0xb8000808, 31, 28, 0x4);		// gpio_08 for CK4, use Tcon17, 0x4/5/6/7_TCON_17/18/19/20
	rtd_part_outl(0xb8000804, 15, 12, 0x4);		// gpio_06 for CK5, use Tcon13, 0x4/5/6/7_TCON_13/14/15/19
	rtd_part_outl(0xb8000804, 31, 28, 0x4);		// gpio_04 for CK6, use Tcon9, 0x4/5/6/7/8_TCON_9/10/11/12/17
	rtd_part_outl(0xb806022C, 23, 20, 0x3);		// st_gpio_48 for LC, use Tcon7, 0x3/4/5/6_TCON_7/8/9/24

	rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// Tcon0 (Frame Start Pulse),
	rtd_outl(0xb802D210, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D214, 0x002A002D);		// V_start/V_end,
	rtd_outl(0xb802D218, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////

	// Tocn_21 (CK1),
	rtd_outl(0xb802D4B0, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D4B4, 0x002B08A7);		// V_start/V_end,
	rtd_outl(0xb802D4B8, 0x00000380);		// Control,
	rtd_outl(0xb802D4BC, 0x00060003);		// Across Line3 RP/HP,

	// Tcon_22 (CK2),
	rtd_outl(0xb802D4D0, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D4D4, 0x002C08A8);		// V_start/V_end,
	rtd_outl(0xb802D4D8, 0x00000380);		// Control,
	rtd_outl(0xb802D4DC, 0x00060003);		// Across Line3 RP/HP,

	// Tcon_26 (CK3),
	rtd_outl(0xb802D550, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D554, 0x002D08A9);		// V_start/V_end,
	rtd_outl(0xb802D558, 0x00000380);		// Control,
	rtd_outl(0xb802D55C, 0x00060003);		// Across Line3 RP/HP,

	// Tcon_17 (CK4),
	rtd_outl(0xb802D430, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D434, 0x002E08AA);		// V_start/V_end,
	rtd_outl(0xb802D438, 0x00000380);		// Control,
	rtd_outl(0xb802D43C, 0x00060003);		// Across Line3 RP/HP,

	// Tcon1_13 (CK5),
	rtd_outl(0xb802D3B0, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D3B4, 0x002F08AB);		// V_start/V_end,
	rtd_outl(0xb802D3B8, 0x00000380);		// Control,
	rtd_outl(0xb802D3BC, 0x00060003);		// Across Line3 RP/HP,

	// Tcon_9 (CK6),
	rtd_outl(0xb802D330, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D334, 0x003008AC);		// V_start/V_end,
	rtd_outl(0xb802D338, 0x00000380);		// Control,
	rtd_outl(0xb802D33C, 0x00060003);		// Across Line3 RP/HP,

	// TCON_7 (LC),
	rtd_outl(0xb802D2F0, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D2F4, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D2F8, 0x00000480);		// Control,
	rtd_outl(0xb802D300, 0x00B300B3);		// Across Frame LP, Across Frame HP

	// POL, TCON19/Tcon20,

	// Tcon18,
	rtd_outl(0xb802D450, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D454, 0x000108A8);		// V_start/V_end,
	rtd_outl(0xb802D458, 0x00000008);		// Control,
	rtd_outl(0xb802D460, 0x068F068F);		// Across Frame LP, Across Frame HP

	//Tcon19 (POL2),
	rtd_outl(0xb802D470, 0x00010003);		// H_start/H_end,
	rtd_outl(0xb802D474, 0x00010003);		// V_start/V_end,
	rtd_outl(0xb802D478, 0x000001c0);		// Control,
	rtd_outl(0xb802D480, 0x00000000);		// Across Frame LP, Across Frame HP

	//// Tcon20 (POL1),
	rtd_outl(0xb802D490, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D494, 0x000108A8);		// V_start/V_end,
	rtd_outl(0xb802D498, 0x00000188);		// Control,
	rtd_outl(0xb802D4A0, 0x00000000);		// Across Frame LP, Across Frame HP

	//////////////////////////////////////////////////////////////////////////////
	// Scrambler Reset, Tcon24,
	// Tcon24,
	rtd_outl(0xb802D510, 0x00100020);		// H_start/H_end,
	rtd_outl(0xb802D514, 0x00010002);		// V_start/V_end,
	rtd_outl(0xb802D518, 0x000001C0);		// Control,
	//////////////////////////////////////////////////////////////////////////////
	//// GSP, Tcon25,
	//// Tcon25,
	rtd_outl(0xb802D530, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D534, 0x00270028);		// V_start/V_end,
	rtd_outl(0xb802D538, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////

	////////////////////////////////////////////////////////////////////////////
	// Tcon1 (Frame Start Pulse),
	rtd_outl(0xb802D230, 0x07000700);		// H_start/H_end,
	rtd_outl(0xb802D234, 0x001A08B0);		// V_start/V_end,
	rtd_outl(0xb802D238, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////

	rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
	rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,

}

void panel_epi_lc430dgg_uhd60_12lane_tcon_setting(void)
{
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG1: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x000008C0);	// pif_clk_sel use sfg clk (for LS APHY), 30-bit Mode, Dout Enable,
						// delay chain pre/delay/post  = no_inverse/0ns/inverse, Pre-R/B Swap disable,
	rtd_outl(0xb802D904, 0x05FFFFFF);	// PIF_Clock = Dclk/6, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// No sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D94C, 0x00000000);	// SEG12/SEG13 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x00000000);	// SEG14/SEG15 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x1000058B);	// SFG DRD Mode, 6-SEG, 12-Port, H-Flip enable,
						// ECO for active dummy for DRD Mode disable, 1.5 packet mode disable,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	rtd_outl(0xb802D980, 0x00000000);	// SEG12/SEG13 Start Address,
	rtd_outl(0xb802D984, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length (1-pixel mode),
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	//rtd_outl(0xb802D9B8, 0x40000000);	// EPI Clock Enable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA00, 0x00000000);	// SEG12/SEG13 No middle dummy sub-pixel,
	rtd_outl(0xb802DA04, 0x00000000);	// SEG14/SEG15 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x80000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 4n+0,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 4n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 4n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 4n+3,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA20, 0x00000000);	// Last_ext_pixel_last_flip_line 4n+0/1/2/3 (no use),
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD	1st output sub-pixel (r0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD	2nd output sub-pixel (g0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD	3rd output sub-pixel (b0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD	4th output sub-pixel (r2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD	5th output sub-pixel (g2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD	6th output sub-pixel (b2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD	7th output sub-pixel (r4) for line 4n+0/1/2/3
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD	8th output sub-pixel (g4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD	9th output sub-pixel (b4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD 10th output sub-pixel (r6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD 11th output sub-pixel (g6) for line 4n+0/1/2/3
	rtd_outl(0xb802DACC, 0x16161616);	// DRD 12th output sub-pixel (b6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD 13th output sub-pixel (r1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD 14th output sub-pixel (g1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD 15th output sub-pixel (b1) for line 4n+0/1/2/3
	rtd_outl(0xb802DADC, 0x07070707);	// DRD 16th output sub-pixel (r3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD 17th output sub-pixel (g3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD 18th output sub-pixel (b3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD 19th output sub-pixel (r5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD 20th output sub-pixel (g5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD 21st output sub-pixel (b5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD 22nd output sub-pixel (r7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD 23rd output sub-pixel (g7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD 24th output sub-pixel (b7) for line 4n+0/1/2/3
	rtd_outl(0xb802DB00, 0x05040302);	// Port A~D mapping,
	rtd_outl(0xb802DB04, 0x01000B0A);	// Port E~H mapping,
	rtd_outl(0xb802DB08, 0x09080706);	// Port I~L mapping,
	rtd_outl(0xb802DB0C, 0x05040302);	// Port M~P mapping,
	rtd_outl(0xb802DB10, 0x01000B0A);	// Port Q~T mapping,
	rtd_outl(0xb802DB14, 0x09080706);	// Port U~X mapping,
	rtd_outl(0xb802DB18, 0x00000000);	// SEG16/SEG17 No front/back dummy pixel,
	rtd_outl(0xb802DB1C, 0x00000000);	// SEG18/SEG19 No front/back dummy pixel,
	rtd_outl(0xb802DB20, 0x00000000);	// SEG20/SEG21 No front/back dummy pixel,
	rtd_outl(0xb802DB24, 0x00000000);	// SEG22/SEG23 No front/back dummy pixel,
	rtd_outl(0xb802DB28, 0x00000000);	// SEG16/SEG17 Start Address,
	rtd_outl(0xb802DB2C, 0x00000000);	// SEG18/SEG19 Start Address,
	rtd_outl(0xb802DB30, 0x00000000);	// SEG20/SEG21 Start Address,
	rtd_outl(0xb802DB34, 0x00000000);	// SEG22/SEG23 Start Address,
	rtd_outl(0xb802DB38, 0x00000000);	// SEG16/SEG17 No middle dummy sub-pixel,
	rtd_outl(0xb802DB3C, 0x00000000);	// SEG18/SEG19 No middle dummy sub-pixel,
	rtd_outl(0xb802DB40, 0x00000000);	// SEG20/SEG21 No middle dummy sub-pixel,
	rtd_outl(0xb802DB44, 0x00000000);	// SEG22/SEG23 No middle dummy sub-pixel,
	rtd_outl(0xb802DB68, 0x00000000);	// f/w ext_num for each port line 4n+0, port_11 ext_num = 0,
	rtd_outl(0xb802DB6C, 0x00000000);	// f/w ext_num for each port line 4n+1, all port ext_num = 0,
	rtd_outl(0xb802DB70, 0x00000000);	// f/w ext_num for each port line 4n+2, port_11 ext_num = 0,
	rtd_outl(0xb802DB74, 0x00000000);	// f/w ext_num for each port line 4n+3, all port ext_num = 0,
	rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+0,
	rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+1,
	rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+2,
	rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+3,

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG2: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802DA30, 0x00000000);	// SFG for OSD disable, data not inverse, not bypass SFG2,
						// auto config mode enable, dout enable, 1-SEG, 1-Port, H-Flip Disable,
	rtd_outl(0xb802DA34, 0x00000000);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802DA38, 0x00000000);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802DA3C, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802DA40, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802DA44, 0x01234567);	// Port A~H mapping,
	rtd_outl(0xb802DA48, 0x000000FF);	// Force to background enable,
	rtd_outl(0xb802DA4C, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802DA50, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802DA74, 0x00000780);	// Final line length (1-pixel mode),

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCKN Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb8000804, 0xF0F0F060);	// EPI LOCK (GPIO_5) Pinshare,
	//rtd_outl(0xb8000810, 0x10000000);	// GPIO_5 use 1.8V input Vth,
	//rtd_outl(0xb80008B4, 0x00000001);	// EP1 LOCK use src0 (GPIO_5),

	//---------------------------------------------------------------------------------------------------------------------------------
	//EPI Mac use 1-pixel mode for 4K2K
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8026000, 0x00000004);	// Lane0 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026004, 0x00000004);	// Lane1 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026008, 0x00000004);	// Lane2 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802600C, 0x00000004);	// Lane3 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026010, 0x00000004);	// Lane4 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026014, 0x00000004);	// Lane5 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026018, 0x00000004);	// Lane6 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802601C, 0x00000004);	// Lane7 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026020, 0x00000004);	// Lane8 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026024, 0x00000004);	// Lane9 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026028, 0x00000004);	// Lane10 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802602C, 0x00000004);	// Lane11 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026030, 0x00000004);	// Lane12 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026034, 0x00000004);	// Lane13 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026038, 0x00000004);	// Lane14 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802603C, 0x00000004);	// Lane15 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026040, 0x00000004);	// Lane16 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026044, 0x00000004);	// Lane17 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026048, 0x00000004);	// Lane18 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802604C, 0x00000004);	// Lane19 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026050, 0x00000004);	// Lane20 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026054, 0x00000004);	// Lane21 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026058, 0x00000004);	// Lane22 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802605C, 0x00000004);	// Lane23 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026060, 0x08000000);	// EPI 1.54Gbps 8-bit mode, prbs_tx disable,
	rtd_outl(0xb8026064, 0x95000000);	// EPI reset enable, C3 packet disable, EPI lock HW mode,
	rtd_outl(0xb8026068, 0x00000000);	// A-VCOM POL/H2DOT selector,
	rtd_outl(0xb802606C, 0x40C13000);	// 1-Pixel Mode, ext_num unit sub-pixel, 12-port EPI, normal mode, packet delimiter,
	rtd_outl(0xb8026070, 0x00000645);	// CMPI CMD/DATA delimiter, run length conding delimiter,
	rtd_outl(0xb8026074, 0x00020001);	// Front/Back dummy line number,
	rtd_outl(0xb8026078, 0x00000000);	// Front dummy line color select color_0,
	rtd_outl(0xb802607C, 0x55555555);	// Back dummy line color select color_1,
	rtd_outl(0xb8026080, 0x05415054);	// Dummy line color 0 (L15),
	rtd_outl(0xb8026084, 0x00000000);	// Dummy line color 1 (L0),
	rtd_outl(0xb8026088, 0x00000000);	// Dummy line color 2 (L0),
	rtd_outl(0xb802608C, 0x00000000);	// Dummy line color 3 (L0),
	rtd_outl(0xb8026090, 0x00000183);	// CRC Enable, select EPI all lane to CRC,
	rtd_outl(0xb802609C, 0x00000000);	// EPI Data from SFG, EPI register settiing,
	rtd_outl(0xb80260A0, 0x00000000);	// Double buffer disable,
	rtd_outl(0xb80260A4, 0x00000070);	// INV4 LUT use 8 line cycle,
	rtd_outl(0xb80260A8, 0x500AAFF5);	// INV4 LUT for line 0~8,
	rtd_outl(0xb80260AC, 0x00000000);	// INV4 LUT for line 9~16,
	rtd_outl(0xb80260B0, 0x00000000);	// INV4 LUT for line 17~24,
	rtd_outl(0xb80260B4, 0x00000000);	// INV4 LUT for line 25~32,
	rtd_outl(0xb8026110, 0x00000000);	// CMPI RLC Function for 10bit mode disable,
	rtd_outl(0xb802617C, 0x00000000);	// Scrambler reset setting (no use),
	rtd_outl(0xb8026180, 0x00000012);	// Scrambler SCR8 for LGD disable,
	rtd_outl(0xb8026184, 0x00FFFFFF);	// Scrambler SCR8 for LGD initial value,
	rtd_outl(0xb8026188, 0x00000012);	// Scrambler SCR10 for LGD disable,
	rtd_outl(0xb802618C, 0x000FFFFF);	// Scrambler SCR10 for LGD initial value,
	rtd_outl(0xb8026190, 0x00000002);	// Scrambler SCR8 for INX disable,
	rtd_outl(0xb8026194, 0x00000FFF);	// Scrambler SCR8 for INX initial value,
	rtd_outl(0xb8026198, 0x00000002);	// Scrambler SCR10 for INX disable,
	rtd_outl(0xb802619C, 0x000003FF);	// Scrambler SCR10 for INX initial value,
	rtd_outl(0xb80261A0, 0x00000000);	// CMPI F/M/B color select, Pgamma for CMPI disable,
	rtd_outl(0xb80261A4, 0x00000000);	// CMPI Pgamma CST packet,
	rtd_outl(0xb80261A8, 0x00000000);	// CMPI Pgamma C1 packet,
	rtd_outl(0xb80261AC, 0x00000000);	// CMPI Pgamma C2 packet,
	rtd_outl(0xb80261B0, 0x00000000);	// CMPI Pgamma C3 packet,
	rtd_outl(0xb80261B4, 0x00000000);	// CMPI Pgamma PG_ST packet,
	rtd_outl(0xb80261B8, 0x00000000);	// CMPI Pgamma Data0 packet,
	rtd_outl(0xb80261BC, 0x00000000);	// CMPI Pgamma Data1 packet,
	rtd_outl(0xb80261C0, 0x00000000);	// CMPI Pgamma Data2 packet,
	rtd_outl(0xb80261C4, 0x00000000);	// CMPI Pgamma Data3 packet,
	rtd_outl(0xb80261C8, 0x00000000);	// CMPI Pgamma Data4 packet,
	rtd_outl(0xb80261CC, 0x00000000);	// CMPI Pgamma Data5 packet,
	rtd_outl(0xb80261D0, 0x00000000);	// CMPI Pgamma Data6 packet,
	rtd_outl(0xb80261D4, 0x00000000);	// CMPI Pgamma Data7 packet,
	rtd_outl(0xb80261D8, 0x00000000);	// CMPI Pgamma Data8 packet,
	rtd_outl(0xb80261DC, 0x00000000);	// CMPI Pgamma Data9 packet,
	rtd_outl(0xb80261E0, 0x00000000);	// CMPI Pgamma PG_END packet,
	rtd_outl(0xb80261E4, 0x00000000);	// EPI Port to Low Speed APHY disable,
	rtd_outl(0xb80261E8, 0x00FFF000);	// EPI Port 12~23 to High Speed APHY, others disable,
	rtd_outl(0xb80261EC, 0x00FFF000);	// EPI constant_update_mode : EPI Port 12~23 update by TDM (for power save),
	rtd_outl(0xb80263F8, 0x00000000);	// EPI update first ctrl packet time : hs_den_io_dist + den_length (compute by hw),
	rtd_outl(0xb80261F0, 0x0000000D);	// SOE LUT use 4-line repeat, SOE LUT apply to C1[17:0],
	rtd_outl(0xb8026200, 0x00000000);	// SOE line 0 LUT for lane 0,
	rtd_outl(0xb8026204, 0x00000000);	// SOE line 1 LUT for lane 0,
	rtd_outl(0xb8026208, 0x00000000);	// SOE line 2 LUT for lane 0,
	rtd_outl(0xb802620C, 0x00000000);	// SOE line 3 LUT for lane 0,
	rtd_outl(0xb8026210, 0x00000000);	// SOE line 0 LUT for lane 1,
	rtd_outl(0xb8026214, 0x00000000);	// SOE line 1 LUT for lane 1,
	rtd_outl(0xb8026218, 0x00000000);	// SOE line 2 LUT for lane 1,
	rtd_outl(0xb802621C, 0x00000000);	// SOE line 3 LUT for lane 1,
	rtd_outl(0xb8026220, 0x00000000);	// SOE line 0 LUT for lane 2,
	rtd_outl(0xb8026224, 0x00000000);	// SOE line 1 LUT for lane 2,
	rtd_outl(0xb8026228, 0x00000000);	// SOE line 2 LUT for lane 2,
	rtd_outl(0xb802622C, 0x00000000);	// SOE line 3 LUT for lane 2,
	rtd_outl(0xb8026230, 0x00000000);	// SOE line 0 LUT for lane 3,
	rtd_outl(0xb8026234, 0x00000000);	// SOE line 1 LUT for lane 3,
	rtd_outl(0xb8026238, 0x00000000);	// SOE line 2 LUT for lane 3,
	rtd_outl(0xb802623C, 0x00000000);	// SOE line 3 LUT for lane 3,
	rtd_outl(0xb8026240, 0x00000000);	// SOE line 0 LUT for lane 4,
	rtd_outl(0xb8026244, 0x00000000);	// SOE line 1 LUT for lane 4,
	rtd_outl(0xb8026248, 0x00000000);	// SOE line 2 LUT for lane 4,
	rtd_outl(0xb802624C, 0x00000000);	// SOE line 3 LUT for lane 4,
	rtd_outl(0xb8026250, 0x00000000);	// SOE line 0 LUT for lane 5,
	rtd_outl(0xb8026254, 0x00000000);	// SOE line 1 LUT for lane 5,
	rtd_outl(0xb8026258, 0x00000000);	// SOE line 2 LUT for lane 5,
	rtd_outl(0xb802625C, 0x00000000);	// SOE line 3 LUT for lane 5,
	rtd_outl(0xb8026260, 0x00000000);	// SOE line 0 LUT for lane 6,
	rtd_outl(0xb8026264, 0x00000000);	// SOE line 1 LUT for lane 6,
	rtd_outl(0xb8026268, 0x00000000);	// SOE line 2 LUT for lane 6,
	rtd_outl(0xb802626C, 0x00000000);	// SOE line 3 LUT for lane 6,
	rtd_outl(0xb8026270, 0x00000000);	// SOE line 0 LUT for lane 7,
	rtd_outl(0xb8026274, 0x00000000);	// SOE line 1 LUT for lane 7,
	rtd_outl(0xb8026278, 0x00000000);	// SOE line 2 LUT for lane 7,
	rtd_outl(0xb802627C, 0x00000000);	// SOE line 3 LUT for lane 7,
	rtd_outl(0xb8026280, 0x00000000);	// SOE line 0 LUT for lane 8,
	rtd_outl(0xb8026284, 0x00000000);	// SOE line 1 LUT for lane 8,
	rtd_outl(0xb8026288, 0x00000000);	// SOE line 2 LUT for lane 8,
	rtd_outl(0xb802628C, 0x00000000);	// SOE line 3 LUT for lane 8,
	rtd_outl(0xb8026290, 0x00000000);	// SOE line 0 LUT for lane 9,
	rtd_outl(0xb8026294, 0x00000000);	// SOE line 1 LUT for lane 9,
	rtd_outl(0xb8026298, 0x00000000);	// SOE line 2 LUT for lane 9,
	rtd_outl(0xb802629C, 0x00000000);	// SOE line 3 LUT for lane 9,
	rtd_outl(0xb80262A0, 0x00000000);	// SOE line 0 LUT for lane 10,
	rtd_outl(0xb80262A4, 0x00000000);	// SOE line 1 LUT for lane 10,
	rtd_outl(0xb80262A8, 0x00000000);	// SOE line 2 LUT for lane 10,
	rtd_outl(0xb80262AC, 0x00000000);	// SOE line 3 LUT for lane 10,
	rtd_outl(0xb80262B0, 0x00000000);	// SOE line 0 LUT for lane 11,
	rtd_outl(0xb80262B4, 0x00000000);	// SOE line 1 LUT for lane 11,
	rtd_outl(0xb80262B8, 0x00000000);	// SOE line 2 LUT for lane 11,
	rtd_outl(0xb80262BC, 0x00000000);	// SOE line 3 LUT for lane 11,
	rtd_outl(0xb80262C0, 0x00001A00);	// SOE line 0 LUT for lane 12 (RX lane_6),
	rtd_outl(0xb80262C4, 0x00001A00);	// SOE line 1 LUT for lane 12 (RX lane_6),
	rtd_outl(0xb80262C8, 0x00001A00);	// SOE line 2 LUT for lane 12 (RX lane_6),
	rtd_outl(0xb80262CC, 0x00001A00);	// SOE line 3 LUT for lane 12 (RX lane_6),
	rtd_outl(0xb80262D0, 0x00001A00);	// SOE line 0 LUT for lane 13 (RX lane_5),
	rtd_outl(0xb80262D4, 0x00001A00);	// SOE line 1 LUT for lane 13 (RX lane_5),
	rtd_outl(0xb80262D8, 0x00001A00);	// SOE line 2 LUT for lane 13 (RX lane_5),
	rtd_outl(0xb80262DC, 0x00001A00);	// SOE line 3 LUT for lane 13 (RX lane_5),
	rtd_outl(0xb80262E0, 0x00001900);	// SOE line 0 LUT for lane 14 (RX lane_4),
	rtd_outl(0xb80262E4, 0x00001900);	// SOE line 1 LUT for lane 14 (RX lane_4),
	rtd_outl(0xb80262E8, 0x00001900);	// SOE line 2 LUT for lane 14 (RX lane_4),
	rtd_outl(0xb80262EC, 0x00001900);	// SOE line 3 LUT for lane 14 (RX lane_4),
	rtd_outl(0xb80262F0, 0x00001900);	// SOE line 0 LUT for lane 15 (RX lane_3),
	rtd_outl(0xb80262F4, 0x00001900);	// SOE line 1 LUT for lane 15 (RX lane_3),
	rtd_outl(0xb80262F8, 0x00001900);	// SOE line 2 LUT for lane 15 (RX lane_3),
	rtd_outl(0xb80262FC, 0x00001900);	// SOE line 3 LUT for lane 15 (RX lane_3),
	rtd_outl(0xb8026300, 0x00001800);	// SOE line 0 LUT for lane 16 (RX lane_2),
	rtd_outl(0xb8026304, 0x00001800);	// SOE line 1 LUT for lane 16 (RX lane_2),
	rtd_outl(0xb8026308, 0x00001800);	// SOE line 2 LUT for lane 16 (RX lane_2),
	rtd_outl(0xb802630C, 0x00001800);	// SOE line 3 LUT for lane 16 (RX lane_2),
	rtd_outl(0xb8026310, 0x00001800);	// SOE line 0 LUT for lane 17 (RX lane_1),
	rtd_outl(0xb8026314, 0x00001800);	// SOE line 1 LUT for lane 17 (RX lane_1),
	rtd_outl(0xb8026318, 0x00001800);	// SOE line 2 LUT for lane 17 (RX lane_1),
	rtd_outl(0xb802631C, 0x00001800);	// SOE line 3 LUT for lane 17 (RX lane_1),
	rtd_outl(0xb8026320, 0x00001800);	// SOE line 0 LUT for lane 18 (RX lane_12),
	rtd_outl(0xb8026324, 0x00001800);	// SOE line 1 LUT for lane 18 (RX lane_12),
	rtd_outl(0xb8026328, 0x00001800);	// SOE line 2 LUT for lane 18 (RX lane_12),
	rtd_outl(0xb802632C, 0x00001800);	// SOE line 3 LUT for lane 18 (RX lane_12),
	rtd_outl(0xb8026330, 0x00001800);	// SOE line 0 LUT for lane 19 (RX lane_11),
	rtd_outl(0xb8026334, 0x00001800);	// SOE line 1 LUT for lane 19 (RX lane_11),
	rtd_outl(0xb8026338, 0x00001800);	// SOE line 2 LUT for lane 19 (RX lane_11),
	rtd_outl(0xb802633C, 0x00001800);	// SOE line 3 LUT for lane 19 (RX lane_11),
	rtd_outl(0xb8026340, 0x00001900);	// SOE line 0 LUT for lane 20 (RX lane_10),
	rtd_outl(0xb8026344, 0x00001900);	// SOE line 1 LUT for lane 20 (RX lane_10),
	rtd_outl(0xb8026348, 0x00001900);	// SOE line 2 LUT for lane 20 (RX lane_10),
	rtd_outl(0xb802634C, 0x00001900);	// SOE line 3 LUT for lane 20 (RX lane_10),
	rtd_outl(0xb8026350, 0x00001900);	// SOE line 0 LUT for lane 21 (RX lane_9),
	rtd_outl(0xb8026354, 0x00001900);	// SOE line 1 LUT for lane 21 (RX lane_9),
	rtd_outl(0xb8026358, 0x00001900);	// SOE line 2 LUT for lane 21 (RX lane_9),
	rtd_outl(0xb802635C, 0x00001900);	// SOE line 3 LUT for lane 21 (RX lane_9),
	rtd_outl(0xb8026360, 0x00001A00);	// SOE line 0 LUT for lane 22 (RX lane_8),
	rtd_outl(0xb8026364, 0x00001A00);	// SOE line 1 LUT for lane 22 (RX lane_8),
	rtd_outl(0xb8026368, 0x00001A00);	// SOE line 2 LUT for lane 22 (RX lane_8),
	rtd_outl(0xb802636C, 0x00001A00);	// SOE line 3 LUT for lane 22 (RX lane_8),
	rtd_outl(0xb8026370, 0x00001A00);	// SOE line 0 LUT for lane 23 (RX lane_7),
	rtd_outl(0xb8026374, 0x00001A00);	// SOE line 1 LUT for lane 23 (RX lane_7),
	rtd_outl(0xb8026378, 0x00001A00);	// SOE line 2 LUT for lane 23 (RX lane_7),
	rtd_outl(0xb802637C, 0x00001A00);	// SOE line 3 LUT for lane 23 (RX lane_7),
	rtd_outl(0xb8026380, 0x00000000);	// DST(C4~C0) MUX use register config,
	rtd_outl(0xb8026384, 0x00000000);	// DST(C9~C5) MUX use register config,
	rtd_outl(0xb8026388, 0x00000000);	// DST(C14~C10) MUX use register config,
	rtd_outl(0xb802638C, 0x00000000);	// DST(C19~C15) MUX use register config,
	rtd_outl(0xb8026390, 0x00000000);	// DST(C24~C20) MUX use register config,
	rtd_outl(0xb8026394, 0x00000000);	// DST(C29~C25) MUX use register config,
	rtd_outl(0xb8026398, 0x00000000);	// CST(C4~C0) MUX use register config,
	rtd_outl(0xb802639C, 0x00000000);	// CST(C9~C5) MUX use register config,
	rtd_outl(0xb80263A0, 0x00000000);	// CST(C14~C10) MUX use register config,
	rtd_outl(0xb80263A4, 0x00000000);	// CST(C19~C15) MUX use register config,
	rtd_outl(0xb80263A8, 0x00000000);	// CST(C24~C20) MUX use register config,
	rtd_outl(0xb80263AC, 0x00000000);	// CST(C29~C25) MUX use register config,
	rtd_outl(0xb80263B0, 0x00000000);	// C1(C4~C0) MUX use register config,
	rtd_outl(0xb80263B4, 0x00000000);	// C1(C9~C5) MUX use register config,
	rtd_outl(0xb80263B8, 0x00000000);	// C1(C14~C10) MUX use register config,
	rtd_outl(0xb80263BC, 0x0A000000);	// C1(C19~C15) MUX use register config (C19 use INV4_1 LUT),
	rtd_outl(0xb80263C0, 0x00007209);	// C1(C24~C20) MUX use register config (C20/C21/C22 use INV4_2/3/4 LUT),
	rtd_outl(0xb80263C4, 0x00000000);	// C1(C29~C25) MUX use register config,
	rtd_outl(0xb80263C8, 0x00000001);	// C2(C4~C0) MUX use register config (C0 use Tcon_A),
	rtd_outl(0xb80263CC, 0x02000000);	// C2(C9~C5) MUX use register config (C9 use Tcon_B),
	rtd_outl(0xb80263D0, 0x00000000);	// C2(C14~C10) MUX use register config,
	rtd_outl(0xb80263D4, 0x00000000);	// C2(C19~C15) MUX use register config,
	rtd_outl(0xb80263D8, 0x00000000);	// C2(C24~C20) MUX use register config,
	rtd_outl(0xb80263DC, 0x00000000);	// C2(C29~C25) MUX use register config,
	rtd_outl(0xb80263E0, 0x00000000);	// C3(C4~C0) MUX use register config,
	rtd_outl(0xb80263E4, 0x00000000);	// C3(C9~C5) MUX use register config,
	rtd_outl(0xb80263E8, 0x00000000);	// C3(C14~C10) MUX use register config,
	rtd_outl(0xb80263EC, 0x00000000);	// C3(C19~C15) MUX use register config,
	rtd_outl(0xb80263F0, 0x00000000);	// C3(C24~C20) MUX use register config,
	rtd_outl(0xb80263F4, 0x00000000);	// C3(C29~C25) MUX use register config,
	rtd_outl(0xb8026500, 0x00000F0B);	// Tcon_a/b/c sel ext_tcon_11/15/0,
	rtd_outl(0xb8026504, 0x00000000);	// Tcon_d/e/f sel ext_tcon_0/0/0,
	rtd_outl(0xb8026508, 0x00000000);	// Tcon_g/h/i sel ext_tcon_0/0/0,
	rtd_outl(0xb802650C, 0x00000000);	// Tcon_j/k sel ext_tcon_0/0,
	rtd_outl(0xb8026528, 0x0000002A);	// DST register config value,
	rtd_outl(0xb802653C, 0x00000015);	// CST register config value,
	rtd_outl(0xb8026550, 0x00000000);	// Lane0 : C1 even register config value, only use even value,
	rtd_outl(0xb8026554, 0x00000000);	// Lane0 : C1 odd register config value (no use),
	rtd_outl(0xb8026558, 0x00000000);	// Lane1 : C1 even register config value, only use even value,
	rtd_outl(0xb802655C, 0x00000000);	// Lane1 : C1 odd register config value (no use),
	rtd_outl(0xb8026560, 0x00000000);	// Lane2 : C1 even register config value, only use even value,
	rtd_outl(0xb8026564, 0x00000000);	// Lane2 : C1 odd register config value (no use),
	rtd_outl(0xb8026568, 0x00000000);	// Lane3 : C1 even register config value, only use even value,
	rtd_outl(0xb802656C, 0x00000000);	// Lane3 : C1 odd register config value (no use),
	rtd_outl(0xb8026570, 0x00000000);	// Lane4 : C1 even register config value, only use even value,
	rtd_outl(0xb8026574, 0x00000000);	// Lane4 : C1 odd register config value (no use),
	rtd_outl(0xb8026578, 0x00000000);	// Lane5 : C1 even register config value, only use even value,
	rtd_outl(0xb802657C, 0x00000000);	// Lane5 : C1 odd register config value (no use),
	rtd_outl(0xb8026580, 0x00000000);	// Lane6 : C1 even register config value, only use even value,
	rtd_outl(0xb8026584, 0x00000000);	// Lane6 : C1 odd register config value (no use),
	rtd_outl(0xb8026588, 0x00000000);	// Lane7 : C1 even register config value, only use even value,
	rtd_outl(0xb802658C, 0x00000000);	// Lane7 : C1 odd register config value (no use),
	rtd_outl(0xb8026590, 0x00000000);	// Lane8 : C1 even register config value, only use even value,
	rtd_outl(0xb8026594, 0x00000000);	// Lane8 : C1 odd register config value (no use),
	rtd_outl(0xb8026598, 0x00000000);	// Lane9 : C1 even register config value, only use even value,
	rtd_outl(0xb802659C, 0x00000000);	// Lane9 : C1 odd register config value (no use),
	rtd_outl(0xb80265A0, 0x00000000);	// Lane10 : C1 even register config value, only use even value,
	rtd_outl(0xb80265A4, 0x00000000);	// Lane10 : C1 odd register config value (no use),
	rtd_outl(0xb80265A8, 0x00000000);	// Lane11 : C1 even register config value, only use even value,
	rtd_outl(0xb80265AC, 0x00000000);	// Lane11 : C1 odd register config value (no use),
	rtd_outl(0xb80265B0, 0x00040000);	// Lane12 : C1 even register config value, only use even value,
	rtd_outl(0xb80265B4, 0x00000000);	// Lane12 : C1 odd register config value (no use),
	rtd_outl(0xb80265B8, 0x00040000);	// Lane13 : C1 even register config value, only use even value,
	rtd_outl(0xb80265BC, 0x00000000);	// Lane13 : C1 odd register config value (no use),
	rtd_outl(0xb80265C0, 0x00040000);	// Lane14 : C1 even register config value, only use even value,
	rtd_outl(0xb80265C4, 0x00000000);	// Lane14 : C1 odd register config value (no use),
	rtd_outl(0xb80265C8, 0x00040000);	// Lane15 : C1 even register config value, only use even value,
	rtd_outl(0xb80265CC, 0x00000000);	// Lane15 : C1 odd register config value (no use),
	rtd_outl(0xb80265D0, 0x00040000);	// Lane16 : C1 even register config value, only use even value,
	rtd_outl(0xb80265D4, 0x00000000);	// Lane16 : C1 odd register config value (no use),
	rtd_outl(0xb80265D8, 0x00040000);	// Lane17 : C1 even register config value, only use even value,
	rtd_outl(0xb80265DC, 0x00000000);	// Lane17 : C1 odd register config value (no use),
	rtd_outl(0xb80265E0, 0x00040000);	// Lane18 : C1 even register config value, only use even value,
	rtd_outl(0xb80265E4, 0x00000000);	// Lane18 : C1 odd register config value (no use),
	rtd_outl(0xb80265E8, 0x00040000);	// Lane19 : C1 even register config value, only use even value,
	rtd_outl(0xb80265EC, 0x00000000);	// Lane19 : C1 odd register config value (no use),
	rtd_outl(0xb80265F0, 0x00040000);	// Lane20 : C1 even register config value, only use even value,
	rtd_outl(0xb80265F4, 0x00000000);	// Lane20 : C1 odd register config value (no use),
	rtd_outl(0xb80265F8, 0x00040000);	// Lane21 : C1 even register config value, only use even value,
	rtd_outl(0xb80265FC, 0x00000000);	// Lane21 : C1 odd register config value (no use),
	rtd_outl(0xb8026600, 0x00040000);	// Lane22 : C1 even register config value, only use even value,
	rtd_outl(0xb8026604, 0x00000000);	// Lane22 : C1 odd register config value (no use),
	rtd_outl(0xb8026608, 0x00040000);	// Lane23 : C1 even register config value, only use even value,
	rtd_outl(0xb802660C, 0x00000000);	// Lane23 : C1 odd register config value (no use),
	rtd_outl(0xb8026620, 0x00000000);	// Lane0 : C2 even register config value, only use even value,
	rtd_outl(0xb8026624, 0x00000000);	// Lane0 : C2 odd register config value (no use),
	rtd_outl(0xb8026628, 0x00000000);	// Lane1 : C2 even register config value, only use even value,
	rtd_outl(0xb802662C, 0x00000000);	// Lane1 : C2 odd register config value (no use),
	rtd_outl(0xb8026630, 0x00000000);	// Lane2 : C2 even register config value, only use even value,
	rtd_outl(0xb8026634, 0x00000000);	// Lane2 : C2 odd register config value (no use),
	rtd_outl(0xb8026638, 0x00000000);	// Lane3 : C2 even register config value, only use even value,
	rtd_outl(0xb802663C, 0x00000000);	// Lane3 : C2 odd register config value (no use),
	rtd_outl(0xb8026640, 0x00000000);	// Lane4 : C2 even register config value, only use even value,
	rtd_outl(0xb8026644, 0x00000000);	// Lane4 : C2 odd register config value (no use),
	rtd_outl(0xb8026648, 0x00000000);	// Lane5 : C2 even register config value, only use even value,
	rtd_outl(0xb802664C, 0x00000000);	// Lane5 : C2 odd register config value (no use),
	rtd_outl(0xb8026650, 0x00000000);	// Lane6 : C2 even register config value, only use even value,
	rtd_outl(0xb8026654, 0x00000000);	// Lane6 : C2 odd register config value (no use),
	rtd_outl(0xb8026658, 0x00000000);	// Lane7 : C2 even register config value, only use even value,
	rtd_outl(0xb802665C, 0x00000000);	// Lane7 : C2 odd register config value (no use),
	rtd_outl(0xb8026660, 0x00000000);	// Lane8 : C2 even register config value, only use even value,
	rtd_outl(0xb8026664, 0x00000000);	// Lane8 : C2 odd register config value (no use),
	rtd_outl(0xb8026668, 0x00000000);	// Lane9 : C2 even register config value, only use even value,
	rtd_outl(0xb802666C, 0x00000000);	// Lane9 : C2 odd register config value (no use),
	rtd_outl(0xb8026670, 0x00000000);	// Lane10 : C2 even register config value, only use even value,
	rtd_outl(0xb8026674, 0x00000000);	// Lane10 : C2 odd register config value (no use),
	rtd_outl(0xb8026678, 0x00000000);	// Lane11 : C2 even register config value, only use even value,
	rtd_outl(0xb802667C, 0x00000000);	// Lane11 : C2 odd register config value (no use),
	rtd_outl(0xb8026680, 0x0000203C);	// Lane12 : C2 even register config value, only use even value,
	rtd_outl(0xb8026684, 0x00000000);	// Lane12 : C2 odd register config value (no use),
	rtd_outl(0xb8026688, 0x0000203C);	// Lane13 : C2 even register config value, only use even value,
	rtd_outl(0xb802668C, 0x00000000);	// Lane13 : C2 odd register config value (no use),
	rtd_outl(0xb8026690, 0x0000203C);	// Lane14 : C2 even register config value, only use even value,
	rtd_outl(0xb8026694, 0x00000000);	// Lane14 : C2 odd register config value (no use),
	rtd_outl(0xb8026698, 0x0000203C);	// Lane15 : C2 even register config value, only use even value,
	rtd_outl(0xb802669C, 0x00000000);	// Lane15 : C2 odd register config value (no use),
	rtd_outl(0xb80266A0, 0x0000203C);	// Lane16 : C2 even register config value, only use even value,
	rtd_outl(0xb80266A4, 0x00000000);	// Lane16 : C2 odd register config value (no use),
	rtd_outl(0xb80266A8, 0x0000203C);	// Lane17 : C2 even register config value, only use even value,
	rtd_outl(0xb80266AC, 0x00000000);	// Lane17 : C2 odd register config value (no use),
	rtd_outl(0xb80266B0, 0x0000203C);	// Lane18 : C2 even register config value, only use even value,
	rtd_outl(0xb80266B4, 0x00000000);	// Lane18 : C2 odd register config value (no use),
	rtd_outl(0xb80266B8, 0x0000203C);	// Lane19 : C2 even register config value, only use even value,
	rtd_outl(0xb80266BC, 0x00000000);	// Lane19 : C2 odd register config value (no use),
	rtd_outl(0xb80266C0, 0x0000203C);	// Lane20 : C2 even register config value, only use even value,
	rtd_outl(0xb80266C4, 0x00000000);	// Lane20 : C2 odd register config value (no use),
	rtd_outl(0xb80266C8, 0x0000203C);	// Lane21 : C2 even register config value, only use even value,
	rtd_outl(0xb80266CC, 0x00000000);	// Lane21 : C2 odd register config value (no use),
	rtd_outl(0xb80266D0, 0x0000203C);	// Lane22 : C2 even register config value, only use even value,
	rtd_outl(0xb80266D4, 0x00000000);	// Lane22 : C2 odd register config value (no use),
	rtd_outl(0xb80266D8, 0x0000203C);	// Lane23 : C2 even register config value, only use even value,
	rtd_outl(0xb80266DC, 0x00000000);	// Lane23 : C2 odd register config value (no use),
	rtd_outl(0xb80266F0, 0x00000000);	// Lane0 : C3 even register config value, only use even value,
	rtd_outl(0xb80266F4, 0x00000000);	// Lane0 : C3 odd register config value (no use),
	rtd_outl(0xb80266F8, 0x00000000);	// Lane1 : C3 even register config value, only use even value,
	rtd_outl(0xb80266FC, 0x00000000);	// Lane1 : C3 odd register config value (no use),
	rtd_outl(0xb8026700, 0x00000000);	// Lane2 : C3 even register config value, only use even value,
	rtd_outl(0xb8026704, 0x00000000);	// Lane2 : C3 odd register config value (no use),
	rtd_outl(0xb8026708, 0x00000000);	// Lane3 : C3 even register config value, only use even value,
	rtd_outl(0xb802670C, 0x00000000);	// Lane3 : C3 odd register config value (no use),
	rtd_outl(0xb8026710, 0x00000000);	// Lane4 : C3 even register config value, only use even value,
	rtd_outl(0xb8026714, 0x00000000);	// Lane4 : C3 odd register config value (no use),
	rtd_outl(0xb8026718, 0x00000000);	// Lane5 : C3 even register config value, only use even value,
	rtd_outl(0xb802671C, 0x00000000);	// Lane5 : C3 odd register config value (no use),
	rtd_outl(0xb8026720, 0x00000000);	// Lane6 : C3 even register config value, only use even value,
	rtd_outl(0xb8026724, 0x00000000);	// Lane6 : C3 odd register config value (no use),
	rtd_outl(0xb8026728, 0x00000000);	// Lane7 : C3 even register config value, only use even value,
	rtd_outl(0xb802672C, 0x00000000);	// Lane7 : C3 odd register config value (no use),
	rtd_outl(0xb8026730, 0x00000000);	// Lane8 : C3 even register config value, only use even value,
	rtd_outl(0xb8026734, 0x00000000);	// Lane8 : C3 odd register config value (no use),
	rtd_outl(0xb8026738, 0x00000000);	// Lane9 : C3 even register config value, only use even value,
	rtd_outl(0xb802673C, 0x00000000);	// Lane9 : C3 odd register config value (no use),
	rtd_outl(0xb8026740, 0x00000000);	// Lane10 : C3 even register config value, only use even value,
	rtd_outl(0xb8026744, 0x00000000);	// Lane10 : C3 odd register config value (no use),
	rtd_outl(0xb8026748, 0x00000000);	// Lane11 : C3 even register config value, only use even value,
	rtd_outl(0xb802674C, 0x00000000);	// Lane11 : C3 odd register config value (no use),
	rtd_outl(0xb8026750, 0x00000000);	// Lane12 : C3 even register config value, only use even value,
	rtd_outl(0xb8026754, 0x00000000);	// Lane12 : C3 odd register config value (no use),
	rtd_outl(0xb8026758, 0x00000000);	// Lane13 : C3 even register config value, only use even value,
	rtd_outl(0xb802675C, 0x00000000);	// Lane13 : C3 odd register config value (no use),
	rtd_outl(0xb8026760, 0x00000000);	// Lane14 : C3 even register config value, only use even value,
	rtd_outl(0xb8026764, 0x00000000);	// Lane14 : C3 odd register config value (no use),
	rtd_outl(0xb8026768, 0x00000000);	// Lane15 : C3 even register config value, only use even value,
	rtd_outl(0xb802676C, 0x00000000);	// Lane15 : C3 odd register config value (no use),
	rtd_outl(0xb8026770, 0x00000000);	// Lane16 : C3 even register config value, only use even value,
	rtd_outl(0xb8026774, 0x00000000);	// Lane16 : C3 odd register config value (no use),
	rtd_outl(0xb8026778, 0x00000000);	// Lane17 : C3 even register config value, only use even value,
	rtd_outl(0xb802677C, 0x00000000);	// Lane17 : C3 odd register config value (no use),
	rtd_outl(0xb8026780, 0x00000000);	// Lane18 : C3 even register config value, only use even value,
	rtd_outl(0xb8026784, 0x00000000);	// Lane18 : C3 odd register config value (no use),
	rtd_outl(0xb8026788, 0x00000000);	// Lane19 : C3 even register config value, only use even value,
	rtd_outl(0xb802678C, 0x00000000);	// Lane19 : C3 odd register config value (no use),
	rtd_outl(0xb8026790, 0x00000000);	// Lane20 : C3 even register config value, only use even value,
	rtd_outl(0xb8026794, 0x00000000);	// Lane20 : C3 odd register config value (no use),
	rtd_outl(0xb8026798, 0x00000000);	// Lane21 : C3 even register config value, only use even value,
	rtd_outl(0xb802679C, 0x00000000);	// Lane21 : C3 odd register config value (no use),
	rtd_outl(0xb80267A0, 0x00000000);	// Lane22 : C3 even register config value, only use even value,
	rtd_outl(0xb80267A4, 0x00000000);	// Lane22 : C3 odd register config value (no use),
	rtd_outl(0xb80267A8, 0x00000000);	// Lane23 : C3 even register config value, only use even value,
	rtd_outl(0xb80267AC, 0x00000000);	// Lane23 : C3 odd register config value (no use),
	rtd_outl(0xb802D700, 0x0F000000);	// lane 0~7 disable, lane 8~15 use EPI 8~15, lane 16~23 use EPI 16~23,
	rtd_outl(0xb8026064, 0x85000000);	// EPI reset release, C3 packet disable, EPI lock HW mode,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000E90, 0x00000000);	// TX lane power disable,
	rtd_outl(0xb8000EC8, 0x00000000);	// For test and scan chain use (all bypass), TXPLL Reset enable,
	rtd_outl(0xb8000E00, 0x11240000);	// VBy1 Bandgap enable, VBy1 Power enable,
	rtd_outl(0xb8000E08, 0x00000000);	// TX lane 0~7 dummy register,
	rtd_outl(0xb8000E10, 0x00000000);	// TX lane 8~15 dummy register,
	rtd_outl(0xb8000E18, 0x00000000);	// TX lane 16~23 dummy register,
	rtd_outl(0xb8000E20, 0xCCCCCCCC);	// TX output driver current for lane 0~7,
	rtd_outl(0xb8000E28, 0xCCCCCCCC);	// TX output driver current for lane 8~15,
	rtd_outl(0xb8000E30, 0xCCCCCCCC);	// TX output driver current for lane 16~23,
	rtd_outl(0xb8000E38, 0x00000000);	// TX pre-emphasis driver current for lane 0~7,
	rtd_outl(0xb8000E40, 0x00000000);	// TX pre-emphasis driver current for lane 8~15,
	rtd_outl(0xb8000E48, 0x00000000);	// TX pre-emphasis driver current for lane 16~23,
	rtd_outl(0xb8000E60, 0xFFFFFFFF);	// TX lane 0~15 is CML Mode,
	rtd_outl(0xb8000E68, 0xFFFF0000);	// TX lane 16~23 is CML Mode,
	rtd_outl(0xb8000E88, 0x00FFF000);	// TX lane 12~23 pre-emphasis enable,
	rtd_outl(0xb8000E98, 0x00FFF000);	// TX lane 12~23 Rt connect to Vterm,
	rtd_outl(0xb8000EA0, 0x00FFF000);	// TX lane 12~23 Rt enable,
	rtd_outl(0xb8000EA8, 0x00088800);	// TX lane 12~23 Pull mode, CMFB disable, VCM Vref 0.56V,
	rtd_outl(0xb8000EB0, 0x01110211);	// TXPLL LDO1V enable, TXPLL enable, DIVM = 4 (no use), DIVP = 2, EPI Mode,
	rtd_outl(0xb8000EB8, 0x10000500);	// TXPLL VCO use low gain, not bypass DIVM (no use), Rs, DIVB = 2,
	rtd_outl(0xb8000EC0, 0x00035004);	// TXPLL clk_in not inverse and use dclk, Cp, Icp, DIVN = 6,
	rtd_outl(0xb8000EC4, 0x00000100);	// TXPLL not bypass DIVN, MAC_CKO not inverse, CK1X/XK20X for P2S not inverse, EPI use DIV14,
	rtd_outl(0xb8000ECC, 0x0000AAAA);	// TX lane 16~23 TX offset current for TX/EM driver,
	rtd_outl(0xb8000ED0, 0xAA000000);	// TX lane 12~15 offset current for TX/EM driver,
	rtd_outl(0xb8000ED4, 0x88888888);	// TX lane 23~16 for 2*Rt setting,
	rtd_outl(0xb8000ED8, 0x88888888);	// TX lane 15~8 for 2*Rt setting,
	rtd_outl(0xb8000EDC, 0x88888888);	// TX lane 7~0 for 2*Rt setting,
	rtd_outl(0xb8000EC8, 0x00010000);	// After POW_VBY1_TOP = 1 and wait 15us, TXPLL Reset release,
	//rtd_outl(0xb8000E90, 0x00FFF000);	// After TXPLL Reset release and wait >150us, TX lane 12~23 power enable,

	rtd_outl(0xb8000C74, 0x80800000);		// Low Speed APHY Power Enable
	rtd_maskl(0xb8000C84, 0xFFFFF0FF, 0x00000500);	// K3 for GST, use Tcon18,
	rtd_maskl(0xb8000804, 0xFFFF0FFF, 0x00004000);	// gpio_4_ps for MCLK, use Tcon14,
	//rtd_maskl(0xb8000824, 0xF0FFFFFF, 0x03000000);         // gpo_1_ps for GCLK, use Tcon9,
	rtd_maskl(0xb8000c80, 0xFFFFFFF0, 0x00000003);   //D14 for GCLK,use Tcon9
	rtd_maskl(0xb8000C84, 0xFFFFFFF0,0x00000003);    // p3_txan for Tcon35


	// Tcon Timing Setting,
	rtd_outl(0xb802D200, 0x40000000);		// External Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb802D42C, 0x00000000);		// External Global Tcon disable,
	rtd_outl(0xb8026804, 0x40000000);		// EPI Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb8026800, 0x00000006);		// EPI Tcon use SFG VS, global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// GST, LGE(C3), pimmux(plt_p3_txbn_apad), Tcon18,
	// Tcon17 (Frane Start Pulse),
	rtd_outl(0xb802D47C, 0x00CD0734);		// H_start/H_end,
	rtd_outl(0xb802D480, 0x004F0051);		// V_start/V_end,
	rtd_outl(0xb802D484, 0x00000180);		// Control,
	// Tcon18 (Frane End Pulse),
	rtd_outl(0xb802D498, 0x08840884);		// H_start/H_end,
	rtd_outl(0xb802D49C, 0x11411144);		// V_start/V_end,
	rtd_outl(0xb802D4A0, 0x00000182);		// Control,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// MCLK, LGE(GPIO_4), pimmux(gpio_4_ps), Tcon14,
	// Tocn13 (EVEN Line),
	rtd_outl(0xb802D37C, 0x06020654);		// H_start/H_end,
	rtd_outl(0xb802D380, 0x00560876);		// V_start/V_end,
	rtd_outl(0xb802D384, 0x00000380);		// Control,
	rtd_outl(0xb802D388, 0x00020000);		// Across Line3 RP/HP,
	// Tcon14 (ODD Line),
	rtd_outl(0xb802D398, 0x06020654);		// H_start/H_end,
	rtd_outl(0xb802D39C, 0x00570876);		// V_start/V_end,
	rtd_outl(0xb802D3A0, 0x00000382);		// Control,
	rtd_outl(0xb802D3A4, 0x00020000);		// Across Line3 RP/HP,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// GCLK, LGE(GPO_1), pimmux(gpo_1_ps), Tcon9,
	// Tcon6 (Last Long Pulse),
	rtd_outl(0xb802D2AC, 0x08840884);		// H_start/H_end,
	rtd_outl(0xb802D2B0, 0x113C1144);		// V_start/V_end,
	rtd_outl(0xb802D2B4, 0x00000180);		// Control,
	// Tcon7 (EVEN Line),
	rtd_outl(0xb802D2C8, 0x08840464);		// H_start/H_end,
	rtd_outl(0xb802D2CC, 0x00510876);		// V_start/V_end,
	rtd_outl(0xb802D2D0, 0x00000382);		// Control,
	rtd_outl(0xb802D2D4, 0x00020001);		// Across Line3 RP/HP,
	// Tcon8 (ODD Line),
	rtd_outl(0xb802D2E4, 0x08840464);		// H_start/H_end,
	rtd_outl(0xb802D2E8, 0x00520876);		// V_start/V_end,
	rtd_outl(0xb802D2EC, 0x00000382);		// Control,
	rtd_outl(0xb802D2F0, 0x00020001);		// Across Line3 RP/HP,
	// Tcon9 (First Pulse Mask),
	rtd_outl(0xb802D300, 0x00000000);		// H_start/H_end,
	rtd_outl(0xb802D304, 0x00000000);		// V_start/V_end,
	rtd_outl(0xb802D308, 0x00000182);		// Control,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// EO, LGE(B2), pimmux(plt_p3_txcp_apad), Tcon35,
	// TCON34,
	rtd_outl(0xb80269B8, 0x00020002);		// H_start/H_end,
	rtd_outl(0xb80269BC, 0x11461146);		// V_start/V_end,
	rtd_outl(0xb80269C0, 0x00000480);		// Control,
	rtd_outl(0xb80269C8, 0x00000077);		// Across Frame Period,
	// Tcon35,
	rtd_outl(0xb80269D4, 0x017E017E);		// H_start/H_end,
	rtd_outl(0xb80269D8, 0x11461146);		// V_start/V_end,
	rtd_outl(0xb80269DC, 0x00000483);		// Control,
	rtd_outl(0xb80269E4, 0x00000077);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// POL, Tcon11,
	// Tcon10 (Reserved),
	rtd_outl(0xb802D320, 0x00000000);		// H_start/H_end,
	rtd_outl(0xb802D324, 0x00000000);		// V_start/V_end,
	rtd_outl(0xb802D328, 0x00000000);		// Control,
	// Tcon11,
	rtd_outl(0xb802D340, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D344, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D348, 0x00000480);		// Control,
	rtd_outl(0xb802D350, 0x00000000);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// GSP, Tcon15,
	// Tcon15,
	rtd_outl(0xb802D444, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D448, 0x00570058);		// V_start/V_end,
	rtd_outl(0xb802D44C, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////

	rtd_outl(0xb8000c88,0xFF335F03);       // Demo Board TCON setting

	rtd_outl(0xb802D42C, 0x00000001);		// External Global Tcon disable,
	rtd_outl(0xb8026800, 0x00000007);		// EPI Tcon use SFG VS, global Tcon enable,

}

void panel_epi_lc550dgg_uhd60_12lane_tcon_setting(void)
{
#if defined(Config_Board_TV010_PANEL)
#if 0
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG1: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x000008C0);	// pif_clk_sel use sfg clk (for LS APHY), 30-bit Mode, Dout Enable,
						// delay chain pre/delay/post  = no_inverse/0ns/inverse, Pre-R/B Swap disable,
	rtd_outl(0xb802D904, 0x05FFFFFF);	// PIF_Clock = Dclk/6, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// No sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D94C, 0x00000000);	// SEG12/SEG13 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x00000000);	// SEG14/SEG15 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x1000058B);	// SFG DRD Mode, 6-SEG, 12-Port, H-Flip enable,
						// ECO for active dummy for DRD Mode disable, 1.5 packet mode disable,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	rtd_outl(0xb802D980, 0x00000000);	// SEG12/SEG13 Start Address,
	rtd_outl(0xb802D984, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length (1-pixel mode),
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	//rtd_outl(0xb802D9B8, 0x40000000);	// EPI Clock Enable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA00, 0x00000000);	// SEG12/SEG13 No middle dummy sub-pixel,
	rtd_outl(0xb802DA04, 0x00000000);	// SEG14/SEG15 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x80000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 4n+0,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 4n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 4n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 4n+3,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA20, 0x00000000);	// Last_ext_pixel_last_flip_line 4n+0/1/2/3 (no use),
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD	1st output sub-pixel (r0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD	2nd output sub-pixel (g0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD	3rd output sub-pixel (b0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD	4th output sub-pixel (r2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD	5th output sub-pixel (g2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD	6th output sub-pixel (b2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD	7th output sub-pixel (r4) for line 4n+0/1/2/3
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD	8th output sub-pixel (g4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD	9th output sub-pixel (b4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD 10th output sub-pixel (r6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD 11th output sub-pixel (g6) for line 4n+0/1/2/3
	rtd_outl(0xb802DACC, 0x16161616);	// DRD 12th output sub-pixel (b6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD 13th output sub-pixel (r1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD 14th output sub-pixel (g1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD 15th output sub-pixel (b1) for line 4n+0/1/2/3
	rtd_outl(0xb802DADC, 0x07070707);	// DRD 16th output sub-pixel (r3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD 17th output sub-pixel (g3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD 18th output sub-pixel (b3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD 19th output sub-pixel (r5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD 20th output sub-pixel (g5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD 21st output sub-pixel (b5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD 22nd output sub-pixel (r7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD 23rd output sub-pixel (g7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD 24th output sub-pixel (b7) for line 4n+0/1/2/3
	rtd_outl(0xb802DB00, 0x05040302);	// Port A~D mapping,
	rtd_outl(0xb802DB04, 0x01000B0A);	// Port E~H mapping,
	rtd_outl(0xb802DB08, 0x09080706);	// Port I~L mapping,
	rtd_outl(0xb802DB0C, 0x05040302);	// Port M~P mapping,
	rtd_outl(0xb802DB10, 0x01000B0A);	// Port Q~T mapping,
	rtd_outl(0xb802DB14, 0x09080706);	// Port U~X mapping,
	rtd_outl(0xb802DB18, 0x00000000);	// SEG16/SEG17 No front/back dummy pixel,
	rtd_outl(0xb802DB1C, 0x00000000);	// SEG18/SEG19 No front/back dummy pixel,
	rtd_outl(0xb802DB20, 0x00000000);	// SEG20/SEG21 No front/back dummy pixel,
	rtd_outl(0xb802DB24, 0x00000000);	// SEG22/SEG23 No front/back dummy pixel,
	rtd_outl(0xb802DB28, 0x00000000);	// SEG16/SEG17 Start Address,
	rtd_outl(0xb802DB2C, 0x00000000);	// SEG18/SEG19 Start Address,
	rtd_outl(0xb802DB30, 0x00000000);	// SEG20/SEG21 Start Address,
	rtd_outl(0xb802DB34, 0x00000000);	// SEG22/SEG23 Start Address,
	rtd_outl(0xb802DB38, 0x00000000);	// SEG16/SEG17 No middle dummy sub-pixel,
	rtd_outl(0xb802DB3C, 0x00000000);	// SEG18/SEG19 No middle dummy sub-pixel,
	rtd_outl(0xb802DB40, 0x00000000);	// SEG20/SEG21 No middle dummy sub-pixel,
	rtd_outl(0xb802DB44, 0x00000000);	// SEG22/SEG23 No middle dummy sub-pixel,
	rtd_outl(0xb802DB68, 0x00000000);	// f/w ext_num for each port line 4n+0, port_11 ext_num = 0,
	rtd_outl(0xb802DB6C, 0x00000000);	// f/w ext_num for each port line 4n+1, all port ext_num = 0,
	rtd_outl(0xb802DB70, 0x00000000);	// f/w ext_num for each port line 4n+2, port_11 ext_num = 0,
	rtd_outl(0xb802DB74, 0x00000000);	// f/w ext_num for each port line 4n+3, all port ext_num = 0,
	rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+0,
	rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+1,
	rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+2,
	rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+3,

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG2: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802DA30, 0x00000000);	// SFG for OSD disable, data not inverse, not bypass SFG2,
						// auto config mode enable, dout enable, 1-SEG, 1-Port, H-Flip Disable,
	rtd_outl(0xb802DA34, 0x00000000);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802DA38, 0x00000000);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802DA3C, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802DA40, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802DA44, 0x01234567);	// Port A~H mapping,
	rtd_outl(0xb802DA48, 0x000000FF);	// Force to background enable,
	rtd_outl(0xb802DA4C, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802DA50, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802DA74, 0x00000780);	// Final line length (1-pixel mode),

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCKN Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb8000804, 0xF0F0F060);	// EPI LOCK (GPIO_5) Pinshare,
	//rtd_outl(0xb8000810, 0x10000000);	// GPIO_5 use 1.8V input Vth,
	//rtd_outl(0xb80008B4, 0x00000001);	// EP1 LOCK use src0 (GPIO_5),

	//---------------------------------------------------------------------------------------------------------------------------------
	//EPI Mac use 1-pixel mode for 4K2K
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8026000, 0x00000004);	// Lane0 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026004, 0x00000004);	// Lane1 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026008, 0x00000004);	// Lane2 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802600C, 0x00000004);	// Lane3 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026010, 0x00000004);	// Lane4 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026014, 0x00000004);	// Lane5 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026018, 0x00000004);	// Lane6 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802601C, 0x00000004);	// Lane7 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026020, 0x00000004);	// Lane8 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026024, 0x00000004);	// Lane9 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026028, 0x00000004);	// Lane10 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802602C, 0x00000004);	// Lane11 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026030, 0x00000004);	// Lane12 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026034, 0x00000004);	// Lane13 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026038, 0x00000004);	// Lane14 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802603C, 0x00000004);	// Lane15 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026040, 0x00000004);	// Lane16 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026044, 0x00000004);	// Lane17 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026048, 0x00000004);	// Lane18 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802604C, 0x00000004);	// Lane19 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026050, 0x00000004);	// Lane20 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026054, 0x00000004);	// Lane21 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026058, 0x00000004);	// Lane22 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802605C, 0x00000004);	// Lane23 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026060, 0x08000000);	// EPI 1.54Gbps 8-bit mode, prbs_tx disable,
	rtd_outl(0xb8026064, 0x95000000);	// EPI reset enable, C3 packet disable, EPI lock HW mode,
	rtd_outl(0xb8026068, 0x00000000);	// A-VCOM POL/H2DOT selector,
	rtd_outl(0xb802606C, 0x40C13000);	// 1-Pixel Mode, ext_num unit sub-pixel, 12-port EPI, normal mode, packet delimiter,
	rtd_outl(0xb8026070, 0x00000645);	// CMPI CMD/DATA delimiter, run length conding delimiter,
	rtd_outl(0xb8026074, 0x00020001);	// Front/Back dummy line number,
	rtd_outl(0xb8026078, 0x00000000);	// Front dummy line color select color_0,
	rtd_outl(0xb802607C, 0x55555555);	// Back dummy line color select color_1,
	rtd_outl(0xb8026080, 0x05415054);	// Dummy line color 0 (L15),
	rtd_outl(0xb8026084, 0x00000000);	// Dummy line color 1 (L0),
	rtd_outl(0xb8026088, 0x00000000);	// Dummy line color 2 (L0),
	rtd_outl(0xb802608C, 0x00000000);	// Dummy line color 3 (L0),
	rtd_outl(0xb8026090, 0x00000183);	// CRC Enable, select EPI all lane to CRC,
	rtd_outl(0xb802609C, 0x00000000);	// EPI Data from SFG, EPI register settiing,
	rtd_outl(0xb80260A0, 0x00000000);	// Double buffer disable,
	rtd_outl(0xb80260A4, 0x00000070);	// INV4 LUT use 8 line cycle,
	rtd_outl(0xb80260A8, 0x500AAFF5);	// INV4 LUT for line 0~8,
	rtd_outl(0xb80260AC, 0x00000000);	// INV4 LUT for line 9~16,
	rtd_outl(0xb80260B0, 0x00000000);	// INV4 LUT for line 17~24,
	rtd_outl(0xb80260B4, 0x00000000);	// INV4 LUT for line 25~32,
	rtd_outl(0xb8026110, 0x00000000);	// CMPI RLC Function for 10bit mode disable,
	rtd_outl(0xb802617C, 0x00000000);	// Scrambler reset setting (no use),
	rtd_outl(0xb8026180, 0x00000012);	// Scrambler SCR8 for LGD disable,
	rtd_outl(0xb8026184, 0x00FFFFFF);	// Scrambler SCR8 for LGD initial value,
	rtd_outl(0xb8026188, 0x00000012);	// Scrambler SCR10 for LGD disable,
	rtd_outl(0xb802618C, 0x000FFFFF);	// Scrambler SCR10 for LGD initial value,
	rtd_outl(0xb8026190, 0x00000002);	// Scrambler SCR8 for INX disable,
	rtd_outl(0xb8026194, 0x00000FFF);	// Scrambler SCR8 for INX initial value,
	rtd_outl(0xb8026198, 0x00000002);	// Scrambler SCR10 for INX disable,
	rtd_outl(0xb802619C, 0x000003FF);	// Scrambler SCR10 for INX initial value,
	rtd_outl(0xb80261A0, 0x00000000);	// CMPI F/M/B color select, Pgamma for CMPI disable,
	rtd_outl(0xb80261A4, 0x00000000);	// CMPI Pgamma CST packet,
	rtd_outl(0xb80261A8, 0x00000000);	// CMPI Pgamma C1 packet,
	rtd_outl(0xb80261AC, 0x00000000);	// CMPI Pgamma C2 packet,
	rtd_outl(0xb80261B0, 0x00000000);	// CMPI Pgamma C3 packet,
	rtd_outl(0xb80261B4, 0x00000000);	// CMPI Pgamma PG_ST packet,
	rtd_outl(0xb80261B8, 0x00000000);	// CMPI Pgamma Data0 packet,
	rtd_outl(0xb80261BC, 0x00000000);	// CMPI Pgamma Data1 packet,
	rtd_outl(0xb80261C0, 0x00000000);	// CMPI Pgamma Data2 packet,
	rtd_outl(0xb80261C4, 0x00000000);	// CMPI Pgamma Data3 packet,
	rtd_outl(0xb80261C8, 0x00000000);	// CMPI Pgamma Data4 packet,
	rtd_outl(0xb80261CC, 0x00000000);	// CMPI Pgamma Data5 packet,
	rtd_outl(0xb80261D0, 0x00000000);	// CMPI Pgamma Data6 packet,
	rtd_outl(0xb80261D4, 0x00000000);	// CMPI Pgamma Data7 packet,
	rtd_outl(0xb80261D8, 0x00000000);	// CMPI Pgamma Data8 packet,
	rtd_outl(0xb80261DC, 0x00000000);	// CMPI Pgamma Data9 packet,
	rtd_outl(0xb80261E0, 0x00000000);	// CMPI Pgamma PG_END packet,
	rtd_outl(0xb80261E4, 0x00000000);	// EPI Port to Low Speed APHY disable,
	rtd_outl(0xb80261E8, 0x00FFF000);	// EPI Port 12~23 to High Speed APHY, others disable,
	rtd_outl(0xb80261EC, 0x00FFF000);	// EPI constant_update_mode : EPI Port 12~23 update by TDM (for power save),
	rtd_outl(0xb80263F8, 0x00000000);	// EPI update first ctrl packet time : hs_den_io_dist + den_length (compute by hw),
	rtd_outl(0xb80261F0, 0x0000000D);	// SOE LUT use 4-line repeat, SOE LUT apply to C1[17:0],
	rtd_outl(0xb8026200, 0x00000000);	// SOE line 0 LUT for lane 0,
	rtd_outl(0xb8026204, 0x00000000);	// SOE line 1 LUT for lane 0,
	rtd_outl(0xb8026208, 0x00000000);	// SOE line 2 LUT for lane 0,
	rtd_outl(0xb802620C, 0x00000000);	// SOE line 3 LUT for lane 0,
	rtd_outl(0xb8026210, 0x00000000);	// SOE line 0 LUT for lane 1,
	rtd_outl(0xb8026214, 0x00000000);	// SOE line 1 LUT for lane 1,
	rtd_outl(0xb8026218, 0x00000000);	// SOE line 2 LUT for lane 1,
	rtd_outl(0xb802621C, 0x00000000);	// SOE line 3 LUT for lane 1,
	rtd_outl(0xb8026220, 0x00000000);	// SOE line 0 LUT for lane 2,
	rtd_outl(0xb8026224, 0x00000000);	// SOE line 1 LUT for lane 2,
	rtd_outl(0xb8026228, 0x00000000);	// SOE line 2 LUT for lane 2,
	rtd_outl(0xb802622C, 0x00000000);	// SOE line 3 LUT for lane 2,
	rtd_outl(0xb8026230, 0x00000000);	// SOE line 0 LUT for lane 3,
	rtd_outl(0xb8026234, 0x00000000);	// SOE line 1 LUT for lane 3,
	rtd_outl(0xb8026238, 0x00000000);	// SOE line 2 LUT for lane 3,
	rtd_outl(0xb802623C, 0x00000000);	// SOE line 3 LUT for lane 3,
	rtd_outl(0xb8026240, 0x00000000);	// SOE line 0 LUT for lane 4,
	rtd_outl(0xb8026244, 0x00000000);	// SOE line 1 LUT for lane 4,
	rtd_outl(0xb8026248, 0x00000000);	// SOE line 2 LUT for lane 4,
	rtd_outl(0xb802624C, 0x00000000);	// SOE line 3 LUT for lane 4,
	rtd_outl(0xb8026250, 0x00000000);	// SOE line 0 LUT for lane 5,
	rtd_outl(0xb8026254, 0x00000000);	// SOE line 1 LUT for lane 5,
	rtd_outl(0xb8026258, 0x00000000);	// SOE line 2 LUT for lane 5,
	rtd_outl(0xb802625C, 0x00000000);	// SOE line 3 LUT for lane 5,
	rtd_outl(0xb8026260, 0x00000000);	// SOE line 0 LUT for lane 6,
	rtd_outl(0xb8026264, 0x00000000);	// SOE line 1 LUT for lane 6,
	rtd_outl(0xb8026268, 0x00000000);	// SOE line 2 LUT for lane 6,
	rtd_outl(0xb802626C, 0x00000000);	// SOE line 3 LUT for lane 6,
	rtd_outl(0xb8026270, 0x00000000);	// SOE line 0 LUT for lane 7,
	rtd_outl(0xb8026274, 0x00000000);	// SOE line 1 LUT for lane 7,
	rtd_outl(0xb8026278, 0x00000000);	// SOE line 2 LUT for lane 7,
	rtd_outl(0xb802627C, 0x00000000);	// SOE line 3 LUT for lane 7,
	rtd_outl(0xb8026280, 0x00000000);	// SOE line 0 LUT for lane 8,
	rtd_outl(0xb8026284, 0x00000000);	// SOE line 1 LUT for lane 8,
	rtd_outl(0xb8026288, 0x00000000);	// SOE line 2 LUT for lane 8,
	rtd_outl(0xb802628C, 0x00000000);	// SOE line 3 LUT for lane 8,
	rtd_outl(0xb8026290, 0x00000000);	// SOE line 0 LUT for lane 9,
	rtd_outl(0xb8026294, 0x00000000);	// SOE line 1 LUT for lane 9,
	rtd_outl(0xb8026298, 0x00000000);	// SOE line 2 LUT for lane 9,
	rtd_outl(0xb802629C, 0x00000000);	// SOE line 3 LUT for lane 9,
	rtd_outl(0xb80262A0, 0x00000000);	// SOE line 0 LUT for lane 10,
	rtd_outl(0xb80262A4, 0x00000000);	// SOE line 1 LUT for lane 10,
	rtd_outl(0xb80262A8, 0x00000000);	// SOE line 2 LUT for lane 10,
	rtd_outl(0xb80262AC, 0x00000000);	// SOE line 3 LUT for lane 10,
	rtd_outl(0xb80262B0, 0x00000000);	// SOE line 0 LUT for lane 11,
	rtd_outl(0xb80262B4, 0x00000000);	// SOE line 1 LUT for lane 11,
	rtd_outl(0xb80262B8, 0x00000000);	// SOE line 2 LUT for lane 11,
	rtd_outl(0xb80262BC, 0x00000000);	// SOE line 3 LUT for lane 11,
	rtd_outl(0xb80262C0, 0x00000F00);	// SOE line 0 LUT for lane 12 (RX lane_6),
	rtd_outl(0xb80262C4, 0x00000F00);	// SOE line 1 LUT for lane 12 (RX lane_6),
	rtd_outl(0xb80262C8, 0x00000F00);	// SOE line 2 LUT for lane 12 (RX lane_6),
	rtd_outl(0xb80262CC, 0x00000F00);	// SOE line 3 LUT for lane 12 (RX lane_6),
	rtd_outl(0xb80262D0, 0x00000F00);	// SOE line 0 LUT for lane 13 (RX lane_5),
	rtd_outl(0xb80262D4, 0x00000F00);	// SOE line 1 LUT for lane 13 (RX lane_5),
	rtd_outl(0xb80262D8, 0x00000F00);	// SOE line 2 LUT for lane 13 (RX lane_5),
	rtd_outl(0xb80262DC, 0x00000F00);	// SOE line 3 LUT for lane 13 (RX lane_5),
	rtd_outl(0xb80262E0, 0x00000E00);	// SOE line 0 LUT for lane 14 (RX lane_4),
	rtd_outl(0xb80262E4, 0x00000E00);	// SOE line 1 LUT for lane 14 (RX lane_4),
	rtd_outl(0xb80262E8, 0x00000E00);	// SOE line 2 LUT for lane 14 (RX lane_4),
	rtd_outl(0xb80262EC, 0x00000E00);	// SOE line 3 LUT for lane 14 (RX lane_4),
	rtd_outl(0xb80262F0, 0x00000E00);	// SOE line 0 LUT for lane 15 (RX lane_3),
	rtd_outl(0xb80262F4, 0x00000E00);	// SOE line 1 LUT for lane 15 (RX lane_3),
	rtd_outl(0xb80262F8, 0x00000E00);	// SOE line 2 LUT for lane 15 (RX lane_3),
	rtd_outl(0xb80262FC, 0x00000E00);	// SOE line 3 LUT for lane 15 (RX lane_3),
	rtd_outl(0xb8026300, 0x00000D00);	// SOE line 0 LUT for lane 16 (RX lane_2),
	rtd_outl(0xb8026304, 0x00000D00);	// SOE line 1 LUT for lane 16 (RX lane_2),
	rtd_outl(0xb8026308, 0x00000D00);	// SOE line 2 LUT for lane 16 (RX lane_2),
	rtd_outl(0xb802630C, 0x00000D00);	// SOE line 3 LUT for lane 16 (RX lane_2),
	rtd_outl(0xb8026310, 0x00000D00);	// SOE line 0 LUT for lane 17 (RX lane_1),
	rtd_outl(0xb8026314, 0x00000D00);	// SOE line 1 LUT for lane 17 (RX lane_1),
	rtd_outl(0xb8026318, 0x00000D00);	// SOE line 2 LUT for lane 17 (RX lane_1),
	rtd_outl(0xb802631C, 0x00000D00);	// SOE line 3 LUT for lane 17 (RX lane_1),
	rtd_outl(0xb8026320, 0x00000D00);	// SOE line 0 LUT for lane 18 (RX lane_12),
	rtd_outl(0xb8026324, 0x00000D00);	// SOE line 1 LUT for lane 18 (RX lane_12),
	rtd_outl(0xb8026328, 0x00000D00);	// SOE line 2 LUT for lane 18 (RX lane_12),
	rtd_outl(0xb802632C, 0x00000D00);	// SOE line 3 LUT for lane 18 (RX lane_12),
	rtd_outl(0xb8026330, 0x00000D00);	// SOE line 0 LUT for lane 19 (RX lane_11),
	rtd_outl(0xb8026334, 0x00000D00);	// SOE line 1 LUT for lane 19 (RX lane_11),
	rtd_outl(0xb8026338, 0x00000D00);	// SOE line 2 LUT for lane 19 (RX lane_11),
	rtd_outl(0xb802633C, 0x00000D00);	// SOE line 3 LUT for lane 19 (RX lane_11),
	rtd_outl(0xb8026340, 0x00000E00);	// SOE line 0 LUT for lane 20 (RX lane_10),
	rtd_outl(0xb8026344, 0x00000E00);	// SOE line 1 LUT for lane 20 (RX lane_10),
	rtd_outl(0xb8026348, 0x00000E00);	// SOE line 2 LUT for lane 20 (RX lane_10),
	rtd_outl(0xb802634C, 0x00000E00);	// SOE line 3 LUT for lane 20 (RX lane_10),
	rtd_outl(0xb8026350, 0x00000E00);	// SOE line 0 LUT for lane 21 (RX lane_9),
	rtd_outl(0xb8026354, 0x00000E00);	// SOE line 1 LUT for lane 21 (RX lane_9),
	rtd_outl(0xb8026358, 0x00000E00);	// SOE line 2 LUT for lane 21 (RX lane_9),
	rtd_outl(0xb802635C, 0x00000E00);	// SOE line 3 LUT for lane 21 (RX lane_9),
	rtd_outl(0xb8026360, 0x00000F00);	// SOE line 0 LUT for lane 22 (RX lane_8),
	rtd_outl(0xb8026364, 0x00000F00);	// SOE line 1 LUT for lane 22 (RX lane_8),
	rtd_outl(0xb8026368, 0x00000F00);	// SOE line 2 LUT for lane 22 (RX lane_8),
	rtd_outl(0xb802636C, 0x00000F00);	// SOE line 3 LUT for lane 22 (RX lane_8),
	rtd_outl(0xb8026370, 0x00000F00);	// SOE line 0 LUT for lane 23 (RX lane_7),
	rtd_outl(0xb8026374, 0x00000F00);	// SOE line 1 LUT for lane 23 (RX lane_7),
	rtd_outl(0xb8026378, 0x00000F00);	// SOE line 2 LUT for lane 23 (RX lane_7),
	rtd_outl(0xb802637C, 0x00000F00);	// SOE line 3 LUT for lane 23 (RX lane_7),
	rtd_outl(0xb8026380, 0x00000000);	// DST(C4~C0) MUX use register config,
	rtd_outl(0xb8026384, 0x00000000);	// DST(C9~C5) MUX use register config,
	rtd_outl(0xb8026388, 0x00000000);	// DST(C14~C10) MUX use register config,
	rtd_outl(0xb802638C, 0x00000000);	// DST(C19~C15) MUX use register config,
	rtd_outl(0xb8026390, 0x00000000);	// DST(C24~C20) MUX use register config,
	rtd_outl(0xb8026394, 0x00000000);	// DST(C29~C25) MUX use register config,
	rtd_outl(0xb8026398, 0x00000000);	// CST(C4~C0) MUX use register config,
	rtd_outl(0xb802639C, 0x00000000);	// CST(C9~C5) MUX use register config,
	rtd_outl(0xb80263A0, 0x00000000);	// CST(C14~C10) MUX use register config,
	rtd_outl(0xb80263A4, 0x00000000);	// CST(C19~C15) MUX use register config,
	rtd_outl(0xb80263A8, 0x00000000);	// CST(C24~C20) MUX use register config,
	rtd_outl(0xb80263AC, 0x00000000);	// CST(C29~C25) MUX use register config,
	rtd_outl(0xb80263B0, 0x00000000);	// C1(C4~C0) MUX use register config,
	rtd_outl(0xb80263B4, 0x00000000);	// C1(C9~C5) MUX use register config,
	rtd_outl(0xb80263B8, 0x00000000);	// C1(C14~C10) MUX use register config,
	rtd_outl(0xb80263BC, 0x0A000000);	// C1(C19~C15) MUX use register config (C19 use INV4_1 LUT),
	rtd_outl(0xb80263C0, 0x00007209);	// C1(C24~C20) MUX use register config (C20/C21/C22 use INV4_2/3/4 LUT),
	rtd_outl(0xb80263C4, 0x00000000);	// C1(C29~C25) MUX use register config,
	rtd_outl(0xb80263C8, 0x00000001);	// C2(C4~C0) MUX use register config (C0 use Tcon_A),
	rtd_outl(0xb80263CC, 0x02000000);	// C2(C9~C5) MUX use register config (C9 use Tcon_B),
	rtd_outl(0xb80263D0, 0x00000000);	// C2(C14~C10) MUX use register config,
	rtd_outl(0xb80263D4, 0x00000000);	// C2(C19~C15) MUX use register config,
	rtd_outl(0xb80263D8, 0x00000000);	// C2(C24~C20) MUX use register config,
	rtd_outl(0xb80263DC, 0x00000000);	// C2(C29~C25) MUX use register config,
	rtd_outl(0xb80263E0, 0x00000000);	// C3(C4~C0) MUX use register config,
	rtd_outl(0xb80263E4, 0x00000000);	// C3(C9~C5) MUX use register config,
	rtd_outl(0xb80263E8, 0x00000000);	// C3(C14~C10) MUX use register config,
	rtd_outl(0xb80263EC, 0x00000000);	// C3(C19~C15) MUX use register config,
	rtd_outl(0xb80263F0, 0x00000000);	// C3(C24~C20) MUX use register config,
	rtd_outl(0xb80263F4, 0x00000000);	// C3(C29~C25) MUX use register config,
	rtd_outl(0xb8026500, 0x00000F0B);	// Tcon_a/b/c sel ext_tcon_11/15/0,
	rtd_outl(0xb8026504, 0x00000000);	// Tcon_d/e/f sel ext_tcon_0/0/0,
	rtd_outl(0xb8026508, 0x00000000);	// Tcon_g/h/i sel ext_tcon_0/0/0,
	rtd_outl(0xb802650C, 0x00000000);	// Tcon_j/k sel ext_tcon_0/0,
	rtd_outl(0xb8026528, 0x0000002A);	// DST register config value,
	rtd_outl(0xb802653C, 0x00000015);	// CST register config value,
	rtd_outl(0xb8026550, 0x00000000);	// Lane0 : C1 even register config value, only use even value,
	rtd_outl(0xb8026554, 0x00000000);	// Lane0 : C1 odd register config value (no use),
	rtd_outl(0xb8026558, 0x00000000);	// Lane1 : C1 even register config value, only use even value,
	rtd_outl(0xb802655C, 0x00000000);	// Lane1 : C1 odd register config value (no use),
	rtd_outl(0xb8026560, 0x00000000);	// Lane2 : C1 even register config value, only use even value,
	rtd_outl(0xb8026564, 0x00000000);	// Lane2 : C1 odd register config value (no use),
	rtd_outl(0xb8026568, 0x00000000);	// Lane3 : C1 even register config value, only use even value,
	rtd_outl(0xb802656C, 0x00000000);	// Lane3 : C1 odd register config value (no use),
	rtd_outl(0xb8026570, 0x00000000);	// Lane4 : C1 even register config value, only use even value,
	rtd_outl(0xb8026574, 0x00000000);	// Lane4 : C1 odd register config value (no use),
	rtd_outl(0xb8026578, 0x00000000);	// Lane5 : C1 even register config value, only use even value,
	rtd_outl(0xb802657C, 0x00000000);	// Lane5 : C1 odd register config value (no use),
	rtd_outl(0xb8026580, 0x00000000);	// Lane6 : C1 even register config value, only use even value,
	rtd_outl(0xb8026584, 0x00000000);	// Lane6 : C1 odd register config value (no use),
	rtd_outl(0xb8026588, 0x00000000);	// Lane7 : C1 even register config value, only use even value,
	rtd_outl(0xb802658C, 0x00000000);	// Lane7 : C1 odd register config value (no use),
	rtd_outl(0xb8026590, 0x00000000);	// Lane8 : C1 even register config value, only use even value,
	rtd_outl(0xb8026594, 0x00000000);	// Lane8 : C1 odd register config value (no use),
	rtd_outl(0xb8026598, 0x00000000);	// Lane9 : C1 even register config value, only use even value,
	rtd_outl(0xb802659C, 0x00000000);	// Lane9 : C1 odd register config value (no use),
	rtd_outl(0xb80265A0, 0x00000000);	// Lane10 : C1 even register config value, only use even value,
	rtd_outl(0xb80265A4, 0x00000000);	// Lane10 : C1 odd register config value (no use),
	rtd_outl(0xb80265A8, 0x00000000);	// Lane11 : C1 even register config value, only use even value,
	rtd_outl(0xb80265AC, 0x00000000);	// Lane11 : C1 odd register config value (no use),
	rtd_outl(0xb80265B0, 0x00040000);	// Lane12 : C1 even register config value, only use even value,
	rtd_outl(0xb80265B4, 0x00000000);	// Lane12 : C1 odd register config value (no use),
	rtd_outl(0xb80265B8, 0x00040000);	// Lane13 : C1 even register config value, only use even value,
	rtd_outl(0xb80265BC, 0x00000000);	// Lane13 : C1 odd register config value (no use),
	rtd_outl(0xb80265C0, 0x00040000);	// Lane14 : C1 even register config value, only use even value,
	rtd_outl(0xb80265C4, 0x00000000);	// Lane14 : C1 odd register config value (no use),
	rtd_outl(0xb80265C8, 0x00040000);	// Lane15 : C1 even register config value, only use even value,
	rtd_outl(0xb80265CC, 0x00000000);	// Lane15 : C1 odd register config value (no use),
	rtd_outl(0xb80265D0, 0x00040000);	// Lane16 : C1 even register config value, only use even value,
	rtd_outl(0xb80265D4, 0x00000000);	// Lane16 : C1 odd register config value (no use),
	rtd_outl(0xb80265D8, 0x00040000);	// Lane17 : C1 even register config value, only use even value,
	rtd_outl(0xb80265DC, 0x00000000);	// Lane17 : C1 odd register config value (no use),
	rtd_outl(0xb80265E0, 0x00040000);	// Lane18 : C1 even register config value, only use even value,
	rtd_outl(0xb80265E4, 0x00000000);	// Lane18 : C1 odd register config value (no use),
	rtd_outl(0xb80265E8, 0x00040000);	// Lane19 : C1 even register config value, only use even value,
	rtd_outl(0xb80265EC, 0x00000000);	// Lane19 : C1 odd register config value (no use),
	rtd_outl(0xb80265F0, 0x00040000);	// Lane20 : C1 even register config value, only use even value,
	rtd_outl(0xb80265F4, 0x00000000);	// Lane20 : C1 odd register config value (no use),
	rtd_outl(0xb80265F8, 0x00040000);	// Lane21 : C1 even register config value, only use even value,
	rtd_outl(0xb80265FC, 0x00000000);	// Lane21 : C1 odd register config value (no use),
	rtd_outl(0xb8026600, 0x00040000);	// Lane22 : C1 even register config value, only use even value,
	rtd_outl(0xb8026604, 0x00000000);	// Lane22 : C1 odd register config value (no use),
	rtd_outl(0xb8026608, 0x00040000);	// Lane23 : C1 even register config value, only use even value,
	rtd_outl(0xb802660C, 0x00000000);	// Lane23 : C1 odd register config value (no use),
	rtd_outl(0xb8026620, 0x00000000);	// Lane0 : C2 even register config value, only use even value,
	rtd_outl(0xb8026624, 0x00000000);	// Lane0 : C2 odd register config value (no use),
	rtd_outl(0xb8026628, 0x00000000);	// Lane1 : C2 even register config value, only use even value,
	rtd_outl(0xb802662C, 0x00000000);	// Lane1 : C2 odd register config value (no use),
	rtd_outl(0xb8026630, 0x00000000);	// Lane2 : C2 even register config value, only use even value,
	rtd_outl(0xb8026634, 0x00000000);	// Lane2 : C2 odd register config value (no use),
	rtd_outl(0xb8026638, 0x00000000);	// Lane3 : C2 even register config value, only use even value,
	rtd_outl(0xb802663C, 0x00000000);	// Lane3 : C2 odd register config value (no use),
	rtd_outl(0xb8026640, 0x00000000);	// Lane4 : C2 even register config value, only use even value,
	rtd_outl(0xb8026644, 0x00000000);	// Lane4 : C2 odd register config value (no use),
	rtd_outl(0xb8026648, 0x00000000);	// Lane5 : C2 even register config value, only use even value,
	rtd_outl(0xb802664C, 0x00000000);	// Lane5 : C2 odd register config value (no use),
	rtd_outl(0xb8026650, 0x00000000);	// Lane6 : C2 even register config value, only use even value,
	rtd_outl(0xb8026654, 0x00000000);	// Lane6 : C2 odd register config value (no use),
	rtd_outl(0xb8026658, 0x00000000);	// Lane7 : C2 even register config value, only use even value,
	rtd_outl(0xb802665C, 0x00000000);	// Lane7 : C2 odd register config value (no use),
	rtd_outl(0xb8026660, 0x00000000);	// Lane8 : C2 even register config value, only use even value,
	rtd_outl(0xb8026664, 0x00000000);	// Lane8 : C2 odd register config value (no use),
	rtd_outl(0xb8026668, 0x00000000);	// Lane9 : C2 even register config value, only use even value,
	rtd_outl(0xb802666C, 0x00000000);	// Lane9 : C2 odd register config value (no use),
	rtd_outl(0xb8026670, 0x00000000);	// Lane10 : C2 even register config value, only use even value,
	rtd_outl(0xb8026674, 0x00000000);	// Lane10 : C2 odd register config value (no use),
	rtd_outl(0xb8026678, 0x00000000);	// Lane11 : C2 even register config value, only use even value,
	rtd_outl(0xb802667C, 0x00000000);	// Lane11 : C2 odd register config value (no use),
	rtd_outl(0xb8026680, 0x0004201C);	// Lane12 : C2 even register config value, only use even value,
	rtd_outl(0xb8026684, 0x00000000);	// Lane12 : C2 odd register config value (no use),
	rtd_outl(0xb8026688, 0x0004201C);	// Lane13 : C2 even register config value, only use even value,
	rtd_outl(0xb802668C, 0x00000000);	// Lane13 : C2 odd register config value (no use),
	rtd_outl(0xb8026690, 0x0004201C);	// Lane14 : C2 even register config value, only use even value,
	rtd_outl(0xb8026694, 0x00000000);	// Lane14 : C2 odd register config value (no use),
	rtd_outl(0xb8026698, 0x0004201C);	// Lane15 : C2 even register config value, only use even value,
	rtd_outl(0xb802669C, 0x00000000);	// Lane15 : C2 odd register config value (no use),
	rtd_outl(0xb80266A0, 0x0004201C);	// Lane16 : C2 even register config value, only use even value,
	rtd_outl(0xb80266A4, 0x00000000);	// Lane16 : C2 odd register config value (no use),
	rtd_outl(0xb80266A8, 0x0000201C);	// Lane17 : C2 even register config value, only use even value,
	rtd_outl(0xb80266AC, 0x00000000);	// Lane17 : C2 odd register config value (no use),
	rtd_outl(0xb80266B0, 0x0004201C);	// Lane18 : C2 even register config value, only use even value,
	rtd_outl(0xb80266B4, 0x00000000);	// Lane18 : C2 odd register config value (no use),
	rtd_outl(0xb80266B8, 0x0004201C);	// Lane19 : C2 even register config value, only use even value,
	rtd_outl(0xb80266BC, 0x00000000);	// Lane19 : C2 odd register config value (no use),
	rtd_outl(0xb80266C0, 0x0004201C);	// Lane20 : C2 even register config value, only use even value,
	rtd_outl(0xb80266C4, 0x00000000);	// Lane20 : C2 odd register config value (no use),
	rtd_outl(0xb80266C8, 0x0004201C);	// Lane21 : C2 even register config value, only use even value,
	rtd_outl(0xb80266CC, 0x00000000);	// Lane21 : C2 odd register config value (no use),
	rtd_outl(0xb80266D0, 0x0004201C);	// Lane22 : C2 even register config value, only use even value,
	rtd_outl(0xb80266D4, 0x00000000);	// Lane22 : C2 odd register config value (no use),
	rtd_outl(0xb80266D8, 0x0004201C);	// Lane23 : C2 even register config value, only use even value,
	rtd_outl(0xb80266DC, 0x00000000);	// Lane23 : C2 odd register config value (no use),
	rtd_outl(0xb80266F0, 0x00000000);	// Lane0 : C3 even register config value, only use even value,
	rtd_outl(0xb80266F4, 0x00000000);	// Lane0 : C3 odd register config value (no use),
	rtd_outl(0xb80266F8, 0x00000000);	// Lane1 : C3 even register config value, only use even value,
	rtd_outl(0xb80266FC, 0x00000000);	// Lane1 : C3 odd register config value (no use),
	rtd_outl(0xb8026700, 0x00000000);	// Lane2 : C3 even register config value, only use even value,
	rtd_outl(0xb8026704, 0x00000000);	// Lane2 : C3 odd register config value (no use),
	rtd_outl(0xb8026708, 0x00000000);	// Lane3 : C3 even register config value, only use even value,
	rtd_outl(0xb802670C, 0x00000000);	// Lane3 : C3 odd register config value (no use),
	rtd_outl(0xb8026710, 0x00000000);	// Lane4 : C3 even register config value, only use even value,
	rtd_outl(0xb8026714, 0x00000000);	// Lane4 : C3 odd register config value (no use),
	rtd_outl(0xb8026718, 0x00000000);	// Lane5 : C3 even register config value, only use even value,
	rtd_outl(0xb802671C, 0x00000000);	// Lane5 : C3 odd register config value (no use),
	rtd_outl(0xb8026720, 0x00000000);	// Lane6 : C3 even register config value, only use even value,
	rtd_outl(0xb8026724, 0x00000000);	// Lane6 : C3 odd register config value (no use),
	rtd_outl(0xb8026728, 0x00000000);	// Lane7 : C3 even register config value, only use even value,
	rtd_outl(0xb802672C, 0x00000000);	// Lane7 : C3 odd register config value (no use),
	rtd_outl(0xb8026730, 0x00000000);	// Lane8 : C3 even register config value, only use even value,
	rtd_outl(0xb8026734, 0x00000000);	// Lane8 : C3 odd register config value (no use),
	rtd_outl(0xb8026738, 0x00000000);	// Lane9 : C3 even register config value, only use even value,
	rtd_outl(0xb802673C, 0x00000000);	// Lane9 : C3 odd register config value (no use),
	rtd_outl(0xb8026740, 0x00000000);	// Lane10 : C3 even register config value, only use even value,
	rtd_outl(0xb8026744, 0x00000000);	// Lane10 : C3 odd register config value (no use),
	rtd_outl(0xb8026748, 0x00000000);	// Lane11 : C3 even register config value, only use even value,
	rtd_outl(0xb802674C, 0x00000000);	// Lane11 : C3 odd register config value (no use),
	rtd_outl(0xb8026750, 0x00000000);	// Lane12 : C3 even register config value, only use even value,
	rtd_outl(0xb8026754, 0x00000000);	// Lane12 : C3 odd register config value (no use),
	rtd_outl(0xb8026758, 0x00000000);	// Lane13 : C3 even register config value, only use even value,
	rtd_outl(0xb802675C, 0x00000000);	// Lane13 : C3 odd register config value (no use),
	rtd_outl(0xb8026760, 0x00000000);	// Lane14 : C3 even register config value, only use even value,
	rtd_outl(0xb8026764, 0x00000000);	// Lane14 : C3 odd register config value (no use),
	rtd_outl(0xb8026768, 0x00000000);	// Lane15 : C3 even register config value, only use even value,
	rtd_outl(0xb802676C, 0x00000000);	// Lane15 : C3 odd register config value (no use),
	rtd_outl(0xb8026770, 0x00000000);	// Lane16 : C3 even register config value, only use even value,
	rtd_outl(0xb8026774, 0x00000000);	// Lane16 : C3 odd register config value (no use),
	rtd_outl(0xb8026778, 0x00000000);	// Lane17 : C3 even register config value, only use even value,
	rtd_outl(0xb802677C, 0x00000000);	// Lane17 : C3 odd register config value (no use),
	rtd_outl(0xb8026780, 0x00000000);	// Lane18 : C3 even register config value, only use even value,
	rtd_outl(0xb8026784, 0x00000000);	// Lane18 : C3 odd register config value (no use),
	rtd_outl(0xb8026788, 0x00000000);	// Lane19 : C3 even register config value, only use even value,
	rtd_outl(0xb802678C, 0x00000000);	// Lane19 : C3 odd register config value (no use),
	rtd_outl(0xb8026790, 0x00000000);	// Lane20 : C3 even register config value, only use even value,
	rtd_outl(0xb8026794, 0x00000000);	// Lane20 : C3 odd register config value (no use),
	rtd_outl(0xb8026798, 0x00000000);	// Lane21 : C3 even register config value, only use even value,
	rtd_outl(0xb802679C, 0x00000000);	// Lane21 : C3 odd register config value (no use),
	rtd_outl(0xb80267A0, 0x00000000);	// Lane22 : C3 even register config value, only use even value,
	rtd_outl(0xb80267A4, 0x00000000);	// Lane22 : C3 odd register config value (no use),
	rtd_outl(0xb80267A8, 0x00000000);	// Lane23 : C3 even register config value, only use even value,
	rtd_outl(0xb80267AC, 0x00000000);	// Lane23 : C3 odd register config value (no use),
	rtd_outl(0xb802D700, 0x0F000000);	// lane 0~7 disable, lane 8~15 use EPI 8~15, lane 16~23 use EPI 16~23,
	rtd_outl(0xb8026064, 0x85000000);	// EPI reset release, C3 packet disable, EPI lock HW mode,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000E90, 0x00000000);	// TX lane power disable,
	rtd_outl(0xb8000EC8, 0x00000000);	// For test and scan chain use (all bypass), TXPLL Reset enable,
	rtd_outl(0xb8000E00, 0x11240000);	// VBy1 Bandgap enable, VBy1 Power enable,
	rtd_outl(0xb8000E08, 0x00000000);	// TX lane 0~7 dummy register,
	rtd_outl(0xb8000E10, 0x00000000);	// TX lane 8~15 dummy register,
	rtd_outl(0xb8000E18, 0x00000000);	// TX lane 16~23 dummy register,
	rtd_outl(0xb8000E20, 0xCCCCCCCC);	// TX output driver current for lane 0~7,
	rtd_outl(0xb8000E28, 0xCCCCCCCC);	// TX output driver current for lane 8~15,
	rtd_outl(0xb8000E30, 0xCCCCCCCC);	// TX output driver current for lane 16~23,
	rtd_outl(0xb8000E38, 0x00000000);	// TX pre-emphasis driver current for lane 0~7,
	rtd_outl(0xb8000E40, 0x00000000);	// TX pre-emphasis driver current for lane 8~15,
	rtd_outl(0xb8000E48, 0x00000000);	// TX pre-emphasis driver current for lane 16~23,
	rtd_outl(0xb8000E60, 0xFFFFFFFF);	// TX lane 0~15 is CML Mode,
	rtd_outl(0xb8000E68, 0xFFFF0000);	// TX lane 16~23 is CML Mode,
	rtd_outl(0xb8000E88, 0x00FFF000);	// TX lane 12~23 pre-emphasis enable,
	rtd_outl(0xb8000E98, 0x00FFF000);	// TX lane 12~23 Rt connect to Vterm,
	rtd_outl(0xb8000EA0, 0x00FFF000);	// TX lane 12~23 Rt enable,
	rtd_outl(0xb8000EA8, 0x00088800);	// TX lane 12~23 Pull mode, CMFB disable, VCM Vref 0.56V,
	rtd_outl(0xb8000EB0, 0x01110211);	// TXPLL LDO1V enable, TXPLL enable, DIVM = 4 (no use), DIVP = 2, EPI Mode,
	rtd_outl(0xb8000EB8, 0x10000500);	// TXPLL VCO use low gain, not bypass DIVM (no use), Rs, DIVB = 2,
	rtd_outl(0xb8000EC0, 0x00035004);	// TXPLL clk_in not inverse and use dclk, Cp, Icp, DIVN = 6,
	rtd_outl(0xb8000EC4, 0x00000100);	// TXPLL not bypass DIVN, MAC_CKO not inverse, CK1X/XK20X for P2S not inverse, EPI use DIV14,
	rtd_outl(0xb8000ECC, 0x0000AAAA);	// TX lane 16~23 TX offset current for TX/EM driver,
	rtd_outl(0xb8000ED0, 0xAA000000);	// TX lane 12~15 offset current for TX/EM driver,
	rtd_outl(0xb8000ED4, 0x88888888);	// TX lane 23~16 for 2*Rt setting,
	rtd_outl(0xb8000ED8, 0x88888888);	// TX lane 15~8 for 2*Rt setting,
	rtd_outl(0xb8000EDC, 0x88888888);	// TX lane 7~0 for 2*Rt setting,
	rtd_outl(0xb8000EC8, 0x00010000);	// After POW_VBY1_TOP = 1 and wait 15us, TXPLL Reset release,
	//rtd_outl(0xb8000E90, 0x00FFF000);	// After TXPLL Reset release and wait >150us, TX lane 12~23 power enable,

	rtd_outl(0xb8000C74, 0x80800000);		// Low Speed APHY Power Enable
	rtd_maskl(0xb8000840, 0x0FFFFFFF, 0x40000000);	// AF7 for GST, use Tcon18,
	rtd_maskl(0xb8000804, 0xFFFF0FFF, 0x00004000);	// D6 for MCLK, use Tcon14,
	rtd_maskl(0xb8000c80, 0xFF0FFFFF, 0x00300000);	// E4 for GCLK, use Tcon9,
	rtd_maskl(0xb8000c84, 0xFFFFFFF0, 0x00000003);	// K4 for EO, use Tcon35,

	// Tcon Timing Setting,
	rtd_outl(0xb802D200, 0x40000000);		// External Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb802D42C, 0x00000000);		// External Global Tcon disable,
	rtd_outl(0xb8026804, 0x40000000);		// EPI Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb8026800, 0x00000006);		// EPI Tcon use SFG VS, global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// GST, LGE(C3), pimmux(plt_p3_txbn_apad), Tcon18,
	// Tcon17 (Frane Start Pulse),
	rtd_outl(0xb802D47C, 0x069f06a0);		// H_start/H_end,
	rtd_outl(0xb802D480, 0x004d0051);		// V_start/V_end,
	rtd_outl(0xb802D484, 0x00000180);		// Control,
	// Tcon18 (Frane End Pulse),
	rtd_outl(0xb802D498, 0x08840884);		// H_start/H_end,
	rtd_outl(0xb802D49C, 0x11421145);		// V_start/V_end,
	rtd_outl(0xb802D4A0, 0x00000182);		// Control,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// MCLK, LGE(GPIO_4), pimmux(gpio_4_ps), Tcon14,
	// Tocn13 (EVEN Line),
	rtd_outl(0xb802D37C, 0x05a605fe);		// H_start/H_end,
	rtd_outl(0xb802D380, 0x00560877);		// V_start/V_end,
	rtd_outl(0xb802D384, 0x00000380);		// Control,
	rtd_outl(0xb802D388, 0x00020000);		// Across Line3 RP/HP,
	// Tcon14 (ODD Line),
	rtd_outl(0xb802D398, 0x061c0672);		// H_start/H_end,
	rtd_outl(0xb802D39C, 0x00570876);		// V_start/V_end,
	rtd_outl(0xb802D3A0, 0x00000382);		// Control,
	rtd_outl(0xb802D3A4, 0x00020000);		// Across Line3 RP/HP,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// GCLK, LGE(GPO_1), pimmux(gpo_1_ps), Tcon9,
	// Tcon6 (Last Long Pulse),
	rtd_outl(0xb802D2AC, 0x08840884);		// H_start/H_end,
	rtd_outl(0xb802D2B0, 0x113d1145);		// V_start/V_end,
	rtd_outl(0xb802D2B4, 0x00000180);		// Control,
	// Tcon7 (EVEN Line),
	rtd_outl(0xb802D2C8, 0x07ce06f6);		// H_start/H_end,
	rtd_outl(0xb802D2CC, 0x00510876);		// V_start/V_end,
	rtd_outl(0xb802D2D0, 0x00000382);		// Control,
	rtd_outl(0xb802D2D4, 0x00020001);		// Across Line3 RP/HP,
	// Tcon8 (ODD Line),
	rtd_outl(0xb802D2E4, 0x075e06e4);		// H_start/H_end,
	rtd_outl(0xb802D2E8, 0x00520876);		// V_start/V_end,
	rtd_outl(0xb802D2EC, 0x00000382);		// Control,
	rtd_outl(0xb802D2F0, 0x00020001);		// Across Line3 RP/HP,
	// Tcon9 (First Pulse Mask),
	rtd_outl(0xb802D300, 0x00000000);		// H_start/H_end,
	rtd_outl(0xb802D304, 0x00000000);		// V_start/V_end,
	rtd_outl(0xb802D308, 0x00000182);		// Control,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// EO, LGE(B2), pimmux(plt_p3_txcp_apad), Tcon35,
	// TCON34,
	rtd_outl(0xb80269B8, 0x00020002);		// H_start/H_end,
	rtd_outl(0xb80269BC, 0x11471147);		// V_start/V_end,
	rtd_outl(0xb80269C0, 0x00000480);		// Control,
	rtd_outl(0xb80269C8, 0x00000077);		// Across Frame Period,
	// Tcon35,
	rtd_outl(0xb80269D4, 0x017E017E);		// H_start/H_end,
	rtd_outl(0xb80269D8, 0x11471147);		// V_start/V_end,
	rtd_outl(0xb80269DC, 0x00000483);		// Control,
	rtd_outl(0xb80269E4, 0x00000077);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// POL, Tcon11,
	// Tcon10 (Reserved),
	rtd_outl(0xb802D320, 0x00000000);		// H_start/H_end,
	rtd_outl(0xb802D324, 0x00000000);		// V_start/V_end,
	rtd_outl(0xb802D328, 0x00000000);		// Control,
	// Tcon11,
	rtd_outl(0xb802D340, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D344, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D348, 0x00000480);		// Control,
	rtd_outl(0xb802D350, 0x00000000);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// GSP, Tcon15,
	// Tcon15,
	rtd_outl(0xb802D444, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D448, 0x00570058);		// V_start/V_end,
	rtd_outl(0xb802D44C, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////

	rtd_outl(0xb8000c88,0xFF335F03);       // Demo Board TCON setting

	rtd_outl(0xb802D42C, 0x00000001);		// External Global Tcon disable,
	rtd_outl(0xb8026800, 0x00000007);		// EPI Tcon use SFG VS, global Tcon enable,
#else
	printf("panel_epi_lc550dgg_uhd60_12lane_tcon_setting no verify at 287x\n");
#endif
#endif
}

void panel_epi_lc430egg_uhd60_6lane_tcon_setting(void)
{
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG1: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x000008C0);	// pif_clk_sel use sfg clk (for LS APHY), 30-bit Mode, Dout Enable,
						// delay chain pre/delay/post  = no_inverse/0ns/inverse, Pre-R/B Swap disable,
	rtd_outl(0xb802D904, 0x02FFFFFF);	// PIF_Clock = Dclk/3, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// No sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D94C, 0x00000000);	// SEG12/SEG13 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x00000000);	// SEG14/SEG15 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x10000585);	// SFG DRD Mode, 6-SEG, 6-Port, H-Flip enable,
						// ECO for active dummy for DRD Mode disable, 1.5 packet mode disable,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	rtd_outl(0xb802D980, 0x00000000);	// SEG12/SEG13 Start Address,
	rtd_outl(0xb802D984, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable,
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length (1-pixel mode),
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x40000000);	// EPI Clock Enable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA00, 0x00000000);	// SEG12/SEG13 No middle dummy sub-pixel,
	rtd_outl(0xb802DA04, 0x00000000);	// SEG14/SEG15 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x80000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 4n+0,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 4n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 4n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 4n+3,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA20, 0x00000000);	// Last_ext_pixel_last_flip_line 4n+0/1/2/3 (no use),
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD	1st output sub-pixel (r0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD	2nd output sub-pixel (g0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD	3rd output sub-pixel (b0) for line 4n+0/1/2/3
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD	4th output sub-pixel (r2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD	5th output sub-pixel (g2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD	6th output sub-pixel (b2) for line 4n+0/1/2/3
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD	7th output sub-pixel (r4) for line 4n+0/1/2/3
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD	8th output sub-pixel (g4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD	9th output sub-pixel (b4) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD 10th output sub-pixel (r6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD 11th output sub-pixel (g6) for line 4n+0/1/2/3
	rtd_outl(0xb802DACC, 0x16161616);	// DRD 12th output sub-pixel (b6) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD 13th output sub-pixel (r1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD 14th output sub-pixel (g1) for line 4n+0/1/2/3
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD 15th output sub-pixel (b1) for line 4n+0/1/2/3
	rtd_outl(0xb802DADC, 0x07070707);	// DRD 16th output sub-pixel (r3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD 17th output sub-pixel (g3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD 18th output sub-pixel (b3) for line 4n+0/1/2/3
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD 19th output sub-pixel (r5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD 20th output sub-pixel (g5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD 21st output sub-pixel (b5) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD 22nd output sub-pixel (r7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD 23rd output sub-pixel (g7) for line 4n+0/1/2/3
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD 24th output sub-pixel (b7) for line 4n+0/1/2/3
	rtd_outl(0xb802DB00, 0x00000002);	// Port A~D mapping,
	rtd_outl(0xb802DB04, 0x01000504);	// Port E~H mapping,
	rtd_outl(0xb802DB08, 0x03000000);	// Port I~L mapping,
	rtd_outl(0xb802DB0C, 0x00000002);	// Port M~P mapping,
	rtd_outl(0xb802DB10, 0x01000504);	// Port Q~T mapping,
	rtd_outl(0xb802DB14, 0x03000000);	// Port U~X mapping,
	rtd_outl(0xb802DB18, 0x00000000);	// SEG16/SEG17 No front/back dummy pixel,
	rtd_outl(0xb802DB1C, 0x00000000);	// SEG18/SEG19 No front/back dummy pixel,
	rtd_outl(0xb802DB20, 0x00000000);	// SEG20/SEG21 No front/back dummy pixel,
	rtd_outl(0xb802DB24, 0x00000000);	// SEG22/SEG23 No front/back dummy pixel,
	rtd_outl(0xb802DB28, 0x00000000);	// SEG16/SEG17 Start Address,
	rtd_outl(0xb802DB2C, 0x00000000);	// SEG18/SEG19 Start Address,
	rtd_outl(0xb802DB30, 0x00000000);	// SEG20/SEG21 Start Address,
	rtd_outl(0xb802DB34, 0x00000000);	// SEG22/SEG23 Start Address,
	rtd_outl(0xb802DB38, 0x00000000);	// SEG16/SEG17 No middle dummy sub-pixel,
	rtd_outl(0xb802DB3C, 0x00000000);	// SEG18/SEG19 No middle dummy sub-pixel,
	rtd_outl(0xb802DB40, 0x00000000);	// SEG20/SEG21 No middle dummy sub-pixel,
	rtd_outl(0xb802DB44, 0x00000000);	// SEG22/SEG23 No middle dummy sub-pixel,
	rtd_outl(0xb802DB68, 0x00000000);	// f/w ext_num for each port line 4n+0, port_11 ext_num = 0,
	rtd_outl(0xb802DB6C, 0x00000000);	// f/w ext_num for each port line 4n+1, all port ext_num = 0,
	rtd_outl(0xb802DB70, 0x00000000);	// f/w ext_num for each port line 4n+2, port_11 ext_num = 0,
	rtd_outl(0xb802DB74, 0x00000000);	// f/w ext_num for each port line 4n+3, all port ext_num = 0,
	rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+0,
	rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+1,
	rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+2,
	rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 4n+3,

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG2: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802DA30, 0x00000000);	// SFG for OSD disable, data not inverse, not bypass SFG2,
						// auto config mode enable, dout enable, 1-SEG, 1-Port, H-Flip Disable,
	rtd_outl(0xb802DA34, 0x00000000);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802DA38, 0x00000000);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802DA3C, 0x00000000);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802DA40, 0x00000000);	// SEG6/SEG7 Start Address,
	rtd_outl(0xb802DA44, 0x01234567);	// Port A~H mapping,
	rtd_outl(0xb802DA48, 0x000000FF);	// Force to background enable,
	rtd_outl(0xb802DA4C, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802DA50, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802DA74, 0x00000780);	// Final line length (1-pixel mode),

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCKN Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb8000804, 0xF0F0F060);	// EPI LOCK (GPIO_5) Pinshare,
	//rtd_outl(0xb8000810, 0x10000000);	// GPIO_5 use 1.8V input Vth,
	//rtd_outl(0xb80008B4, 0x00000001);	// EP1 LOCK use src0 (GPIO_5),

	//---------------------------------------------------------------------------------------------------------------------------------
	//EPI Mac use 1-pixel mode for 4K2K
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8026000, 0x00000004);	// Lane0 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026004, 0x00000004);	// Lane1 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026008, 0x00000004);	// Lane2 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802600C, 0x00000004);	// Lane3 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026010, 0x00000004);	// Lane4 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026014, 0x00000004);	// Lane5 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026018, 0x00000004);	// Lane6 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802601C, 0x00000004);	// Lane7 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026020, 0x00000004);	// Lane8 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026024, 0x00000004);	// Lane9 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026028, 0x00000004);	// Lane10 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802602C, 0x00000004);	// Lane11 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026030, 0x00000004);	// Lane12 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026034, 0x00000004);	// Lane13 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026038, 0x00000004);	// Lane14 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802603C, 0x00000004);	// Lane15 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026040, 0x00000004);	// Lane16 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026044, 0x00000004);	// Lane17 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026048, 0x00000004);	// Lane18 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802604C, 0x00000004);	// Lane19 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026050, 0x00000004);	// Lane20 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026054, 0x00000004);	// Lane21 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026058, 0x00000004);	// Lane22 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb802605C, 0x00000004);	// Lane23 : Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026060, 0x08000002);	// EPI 3.05Gbps 8-bit mode, prbs_tx disable,
	rtd_outl(0xb8026064, 0x80000008);	// EPI reset enable, CST/C3/DST packet disable, EPI lock HW mode,
	rtd_outl(0xb8026068, 0x00000000);	// A-VCOM POL/H2DOT selector,
	rtd_outl(0xb802606C, 0x40613000);	// 1-Pixel Mode, ext_num unit sub-pixel, 6-port EPI, normal mode, packet delimiter,
	rtd_outl(0xb8026070, 0x00000645);	// CMPI CMD/DATA delimiter, run length conding delimiter,
	rtd_outl(0xb8026074, 0x00020001);	// Front/Back dummy line number,
	rtd_outl(0xb8026078, 0x00000000);	// Front dummy line color select color_0,
	rtd_outl(0xb802607C, 0x55555555);	// Back dummy line color select color_1,
	rtd_outl(0xb8026080, 0x1FC7F1FC);	// Dummy line color 0 (L127),// dummy line color setting
	rtd_outl(0xb8026084, 0x00000000);	// Dummy line color 1 (L0),
	rtd_outl(0xb8026088, 0x00000000);	// Dummy line color 2 (L0),
	rtd_outl(0xb802608C, 0x00000000);	// Dummy line color 3 (L0),
	rtd_outl(0xb8026090, 0x00000183);	// CRC Enable, select EPI all lane to CRC,
	rtd_outl(0xb802609C, 0x00000000);	// EPI Data from SFG, EPI register settiing,
	rtd_outl(0xb80260A0, 0x00000000);	// Double buffer disable,
	rtd_outl(0xb80260A4, 0x00000070);	// INV4 LUT use 8 line cycle,
	rtd_outl(0xb80260A8, 0x500AAFF5);	// INV4 LUT for line 0~8, // 43"--->500AAFF5 49"--->500AAFF5
	rtd_outl(0xb80260AC, 0x00000000);	// INV4 LUT for line 9~16,
	rtd_outl(0xb80260B0, 0x00000000);	// INV4 LUT for line 17~24,
	rtd_outl(0xb80260B4, 0x00000000);	// INV4 LUT for line 25~32,
	rtd_outl(0xb8026110, 0x00000000);	// CMPI RLC Function for 10bit mode disable,
	rtd_outl(0xb802617C, 0x00009D42);	// Scrambler reset/enable by Tcon_C/39, But disable,
	rtd_outl(0xb8026180, 0x00000017);	// Scrambler SCR8 for LGD Enable,
	rtd_outl(0xb8026184, 0x00FFFFFF);	// Scrambler SCR8 for LGD initial value,
	rtd_outl(0xb8026188, 0x00000012);	// Scrambler SCR10 for LGD disable,
	rtd_outl(0xb802618C, 0x000FFFFF);	// Scrambler SCR10 for LGD initial value,
	rtd_outl(0xb8026190, 0x00000002);	// Scrambler SCR8 for INX disable,
	rtd_outl(0xb8026194, 0x00000FFF);	// Scrambler SCR8 for INX initial value,
	rtd_outl(0xb8026198, 0x00000002);	// Scrambler SCR10 for INX disable,
	rtd_outl(0xb802619C, 0x000003FF);	// Scrambler SCR10 for INX initial value,
	rtd_outl(0xb80261A0, 0x00000000);	// CMPI F/M/B color select, Pgamma for CMPI disable,
	rtd_outl(0xb80261A4, 0x00000000);	// CMPI Pgamma CST packet,
	rtd_outl(0xb80261A8, 0x00000000);	// CMPI Pgamma C1 packet,
	rtd_outl(0xb80261AC, 0x00000000);	// CMPI Pgamma C2 packet,
	rtd_outl(0xb80261B0, 0x00000000);	// CMPI Pgamma C3 packet,
	rtd_outl(0xb80261B4, 0x00000000);	// CMPI Pgamma PG_ST packet,
	rtd_outl(0xb80261B8, 0x00000000);	// CMPI Pgamma Data0 packet,
	rtd_outl(0xb80261BC, 0x00000000);	// CMPI Pgamma Data1 packet,
	rtd_outl(0xb80261C0, 0x00000000);	// CMPI Pgamma Data2 packet,
	rtd_outl(0xb80261C4, 0x00000000);	// CMPI Pgamma Data3 packet,
	rtd_outl(0xb80261C8, 0x00000000);	// CMPI Pgamma Data4 packet,
	rtd_outl(0xb80261CC, 0x00000000);	// CMPI Pgamma Data5 packet,
	rtd_outl(0xb80261D0, 0x00000000);	// CMPI Pgamma Data6 packet,
	rtd_outl(0xb80261D4, 0x00000000);	// CMPI Pgamma Data7 packet,
	rtd_outl(0xb80261D8, 0x00000000);	// CMPI Pgamma Data8 packet,
	rtd_outl(0xb80261DC, 0x00000000);	// CMPI Pgamma Data9 packet,
	rtd_outl(0xb80261E0, 0x00000000);	// CMPI Pgamma PG_END packet,
	rtd_outl(0xb80261E4, 0x00000000);	// EPI Port to Low Speed APHY disable,
	rtd_outl(0xb80261E8, 0x001F8000);	// EPI Port 15~20 to High Speed, others disable,
	rtd_outl(0xb80261EC, 0x001F8000);	// EPI constant_update_mode : EPI Port 15~20 update by TDM (for power save),
	rtd_outl(0xb80263F8, 0x00000000);	// EPI update first ctrl packet time : hs_den_io_dist + den_length (compute by hw),
	rtd_outl(0xb80261F0, 0x0000000E);	// SOE LUT use 4-line repeat, SOE LUT apply to C2[17:0],
	rtd_outl(0xb8026200, 0x00000000);	// SOE line 0 LUT for lane 0,
	rtd_outl(0xb8026204, 0x00000000);	// SOE line 1 LUT for lane 0,
	rtd_outl(0xb8026208, 0x00000000);	// SOE line 2 LUT for lane 0,
	rtd_outl(0xb802620C, 0x00000000);	// SOE line 3 LUT for lane 0,
	rtd_outl(0xb8026210, 0x00000000);	// SOE line 0 LUT for lane 1,
	rtd_outl(0xb8026214, 0x00000000);	// SOE line 1 LUT for lane 1,
	rtd_outl(0xb8026218, 0x00000000);	// SOE line 2 LUT for lane 1,
	rtd_outl(0xb802621C, 0x00000000);	// SOE line 3 LUT for lane 1,
	rtd_outl(0xb8026220, 0x00000000);	// SOE line 0 LUT for lane 2,
	rtd_outl(0xb8026224, 0x00000000);	// SOE line 1 LUT for lane 2,
	rtd_outl(0xb8026228, 0x00000000);	// SOE line 2 LUT for lane 2,
	rtd_outl(0xb802622C, 0x00000000);	// SOE line 3 LUT for lane 2,
	rtd_outl(0xb8026230, 0x00000000);	// SOE line 0 LUT for lane 3,
	rtd_outl(0xb8026234, 0x00000000);	// SOE line 1 LUT for lane 3,
	rtd_outl(0xb8026238, 0x00000000);	// SOE line 2 LUT for lane 3,
	rtd_outl(0xb802623C, 0x00000000);	// SOE line 3 LUT for lane 3,
	rtd_outl(0xb8026240, 0x00000000);	// SOE line 0 LUT for lane 4,
	rtd_outl(0xb8026244, 0x00000000);	// SOE line 1 LUT for lane 4,
	rtd_outl(0xb8026248, 0x00000000);	// SOE line 2 LUT for lane 4,
	rtd_outl(0xb802624C, 0x00000000);	// SOE line 3 LUT for lane 4,
	rtd_outl(0xb8026250, 0x00000000);	// SOE line 0 LUT for lane 5,
	rtd_outl(0xb8026254, 0x00000000);	// SOE line 1 LUT for lane 5,
	rtd_outl(0xb8026258, 0x00000000);	// SOE line 2 LUT for lane 5,
	rtd_outl(0xb802625C, 0x00000000);	// SOE line 3 LUT for lane 5,
	rtd_outl(0xb8026260, 0x00000000);	// SOE line 0 LUT for lane 6,
	rtd_outl(0xb8026264, 0x00000000);	// SOE line 1 LUT for lane 6,
	rtd_outl(0xb8026268, 0x00000000);	// SOE line 2 LUT for lane 6,
	rtd_outl(0xb802626C, 0x00000000);	// SOE line 3 LUT for lane 6,
	rtd_outl(0xb8026270, 0x00000000);	// SOE line 0 LUT for lane 7,
	rtd_outl(0xb8026274, 0x00000000);	// SOE line 1 LUT for lane 7,
	rtd_outl(0xb8026278, 0x00000000);	// SOE line 2 LUT for lane 7,
	rtd_outl(0xb802627C, 0x00000000);	// SOE line 3 LUT for lane 7,
	rtd_outl(0xb8026280, 0x00000000);	// SOE line 0 LUT for lane 8,
	rtd_outl(0xb8026284, 0x00000000);	// SOE line 1 LUT for lane 8,
	rtd_outl(0xb8026288, 0x00000000);	// SOE line 2 LUT for lane 8,
	rtd_outl(0xb802628C, 0x00000000);	// SOE line 3 LUT for lane 8,
	rtd_outl(0xb8026290, 0x00000000);	// SOE line 0 LUT for lane 9,
	rtd_outl(0xb8026294, 0x00000000);	// SOE line 1 LUT for lane 9,
	rtd_outl(0xb8026298, 0x00000000);	// SOE line 2 LUT for lane 9,
	rtd_outl(0xb802629C, 0x00000000);	// SOE line 3 LUT for lane 9,
	rtd_outl(0xb80262A0, 0x00000000);	// SOE line 0 LUT for lane 10,
	rtd_outl(0xb80262A4, 0x00000000);	// SOE line 1 LUT for lane 10,
	rtd_outl(0xb80262A8, 0x00000000);	// SOE line 2 LUT for lane 10,
	rtd_outl(0xb80262AC, 0x00000000);	// SOE line 3 LUT for lane 10,
	rtd_outl(0xb80262B0, 0x00000000);	// SOE line 0 LUT for lane 11,
	rtd_outl(0xb80262B4, 0x00000000);	// SOE line 1 LUT for lane 11,
	rtd_outl(0xb80262B8, 0x00000000);	// SOE line 2 LUT for lane 11,
	rtd_outl(0xb80262BC, 0x00000000);	// SOE line 3 LUT for lane 11,
	rtd_outl(0xb80262C0, 0x00000000);	// SOE line 0 LUT for lane 12,
	rtd_outl(0xb80262C4, 0x00000000);	// SOE line 1 LUT for lane 12,
	rtd_outl(0xb80262C8, 0x00000000);	// SOE line 2 LUT for lane 12,
	rtd_outl(0xb80262CC, 0x00000000);	// SOE line 3 LUT for lane 12,
	rtd_outl(0xb80262D0, 0x00000000);	// SOE line 0 LUT for lane 13,
	rtd_outl(0xb80262D4, 0x00000000);	// SOE line 1 LUT for lane 13,
	rtd_outl(0xb80262D8, 0x00000000);	// SOE line 2 LUT for lane 13,
	rtd_outl(0xb80262DC, 0x00000000);	// SOE line 3 LUT for lane 13,
	rtd_outl(0xb80262E0, 0x00000000);	// SOE line 0 LUT for lane 14,
	rtd_outl(0xb80262E4, 0x00000000);	// SOE line 1 LUT for lane 14,
	rtd_outl(0xb80262E8, 0x00000000);	// SOE line 2 LUT for lane 14,
	rtd_outl(0xb80262EC, 0x00000000);	// SOE line 3 LUT for lane 14,
	rtd_outl(0xb80262F0, 0x0000813b);	// SOE line 0 LUT for lane 15 (RX lane_3), for 49" bit5~bit0 101000 no change for bit10~17 for 43" bit9~0=100111100//316
	rtd_outl(0xb80262F4, 0x0000813b);	// SOE line 1 LUT for lane 15 (RX lane_3), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111100
	rtd_outl(0xb80262F8, 0x0000813b);	// SOE line 2 LUT for lane 15 (RX lane_3), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111100
	rtd_outl(0xb80262FC, 0x00007D3B);	// SOE line 3 LUT for lane 15 (RX lane_3), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111100
	rtd_outl(0xb8026300, 0x00007D3B);	// SOE line 0 LUT for lane 16 (RX lane_2), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111011//315
	rtd_outl(0xb8026304, 0x00007D3B);	// SOE line 1 LUT for lane 16 (RX lane_2), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111011
	rtd_outl(0xb8026308, 0x00007D3B);	// SOE line 2 LUT for lane 16 (RX lane_2), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111011
	rtd_outl(0xb802630C, 0x0000793B);	// SOE line 3 LUT for lane 16 (RX lane_2), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111011
	rtd_outl(0xb8026310, 0x0000793B);	// SOE line 0 LUT for lane 17 (RX lane_1), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111011
	rtd_outl(0xb8026314, 0x0000793B);	// SOE line 1 LUT for lane 17 (RX lane_1), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111011
	rtd_outl(0xb8026318, 0x0000793B);	// SOE line 2 LUT for lane 17 (RX lane_1), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111011
	rtd_outl(0xb802631C, 0x0000793B);	// SOE line 3 LUT for lane 17 (RX lane_1), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111011
	rtd_outl(0xb8026320, 0x0000793B);	// SOE line 0 LUT for lane 18 (RX lane_6), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111100//316
	rtd_outl(0xb8026324, 0x0000793B);	// SOE line 1 LUT for lane 18 (RX lane_6), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111100//316
	rtd_outl(0xb8026328, 0x0000793B);	// SOE line 2 LUT for lane 18 (RX lane_6), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111100//316
	rtd_outl(0xb802632C, 0x0000793B);	// SOE line 3 LUT for lane 18 (RX lane_6), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111100//316
	rtd_outl(0xb8026330, 0x00007D3B);	// SOE line 0 LUT for lane 19 (RX lane_5), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111101
	rtd_outl(0xb8026334, 0x00007D3B);	// SOE line 1 LUT for lane 19 (RX lane_5), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111101
	rtd_outl(0xb8026338, 0x00007D38);	// SOE line 2 LUT for lane 19 (RX lane_5), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111101
	rtd_outl(0xb802633C, 0x00007D38);	// SOE line 3 LUT for lane 19 (RX lane_5), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111101
	rtd_outl(0xb8026340, 0x0000813b);	// SOE line 0 LUT for lane 20 (RX lane_4), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111101
	rtd_outl(0xb8026344, 0x0000813b);	// SOE line 1 LUT for lane 20 (RX lane_4), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111101
	rtd_outl(0xb8026348, 0x0000813b);	// SOE line 2 LUT for lane 20 (RX lane_4), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111101
	rtd_outl(0xb802634C, 0x0000813b);	// SOE line 3 LUT for lane 20 (RX lane_4), for 49" bit5~bit0 101000 					   for 43" bit9~0=100111101//317
	rtd_outl(0xb8026350, 0x00000000);	// SOE line 0 LUT for lane 21,
	rtd_outl(0xb8026354, 0x00000000);	// SOE line 1 LUT for lane 21,
	rtd_outl(0xb8026358, 0x00000000);	// SOE line 2 LUT for lane 21,
	rtd_outl(0xb802635C, 0x00000000);	// SOE line 3 LUT for lane 21,
	rtd_outl(0xb8026360, 0x00000000);	// SOE line 0 LUT for lane 22,
	rtd_outl(0xb8026364, 0x00000000);	// SOE line 1 LUT for lane 22,
	rtd_outl(0xb8026368, 0x00000000);	// SOE line 2 LUT for lane 22,
	rtd_outl(0xb802636C, 0x00000000);	// SOE line 3 LUT for lane 22,
	rtd_outl(0xb8026370, 0x00000000);	// SOE line 0 LUT for lane 23,
	rtd_outl(0xb8026374, 0x00000000);	// SOE line 1 LUT for lane 23,
	rtd_outl(0xb8026378, 0x00000000);	// SOE line 2 LUT for lane 23,
	rtd_outl(0xb802637C, 0x00000000);	// SOE line 3 LUT for lane 23,
	rtd_outl(0xb8026380, 0x00000000);	// DST(C4~C0) MUX use register config,
	rtd_outl(0xb8026384, 0x00000000);	// DST(C9~C5) MUX use register config,
	rtd_outl(0xb8026388, 0x00000000);	// DST(C14~C10) MUX use register config,
	rtd_outl(0xb802638C, 0x00000000);	// DST(C19~C15) MUX use register config,
	rtd_outl(0xb8026390, 0x00000000);	// DST(C24~C20) MUX use register config,
	rtd_outl(0xb8026394, 0x00000000);	// DST(C29~C25) MUX use register config,
	rtd_outl(0xb8026398, 0x00000000);	// CST(C4~C0) MUX use register config,
	rtd_outl(0xb802639C, 0x00000000);	// CST(C9~C5) MUX use register config,
	rtd_outl(0xb80263A0, 0x00000000);	// CST(C14~C10) MUX use register config,
	rtd_outl(0xb80263A4, 0x00000000);	// CST(C19~C15) MUX use register config,
	rtd_outl(0xb80263A8, 0x00000000);	// CST(C24~C20) MUX use register config,
	rtd_outl(0xb80263AC, 0x00000000);	// CST(C29~C25) MUX use register config,
	rtd_outl(0xb80263B0, 0x00000000);	// C1(C4~C0) MUX use register config,
	rtd_outl(0xb80263B4, 0x00002040);	// C1(C9~C5) MUX use register config (C6/C7 use Tcon_A/B), // no change
	rtd_outl(0xb80263B8, 0x09280000);	// C1(C14~C10) MUX use register config (C13/C14 use INV4_1/2 LUT),// no change
	rtd_outl(0xb80263BC, 0x000001C8);	// C1(C19~C15) MUX use register config (C15/C16 use INV4_3/4 LUT), // no change
	rtd_outl(0xb80263C0, 0x00000000);	// C1(C24~C20) MUX use register config,
	rtd_outl(0xb80263C4, 0x00000000);	// C1(C29~C25) MUX use register config,
	rtd_outl(0xb80263C8, 0x00000000);	// C2(C4~C0) MUX use register config,
	rtd_outl(0xb80263CC, 0x00000000);	// C2(C9~C5) MUX use register config,
	rtd_outl(0xb80263D0, 0x00000000);	// C2(C14~C10) MUX use register config,
	rtd_outl(0xb80263D4, 0x238C0000);	// C2(C19~C15) MUX use register config (C18/C19 use Tcon_39),
	rtd_outl(0xb80263D8, 0x000C30E3);	// C2(C24~C20) MUX use register config (C20/C21/C22/C23 use Tcon_39/C/C/C), c18 and C19 and C20 use the same Tcon.
	rtd_outl(0xb80263DC, 0x00000000);	// C2(C29~C25) MUX use register config,
	rtd_outl(0xb80263E0, 0x00000000);	// C3(C4~C0) MUX use register config,
	rtd_outl(0xb80263E4, 0x00000000);	// C3(C9~C5) MUX use register config,
	rtd_outl(0xb80263E8, 0x00000000);	// C3(C14~C10) MUX use register config,
	rtd_outl(0xb80263EC, 0x00000000);	// C3(C19~C15) MUX use register config,
	rtd_outl(0xb80263F0, 0x00000000);	// C3(C24~C20) MUX use register config,
	rtd_outl(0xb80263F4, 0x00000000);	// C3(C29~C25) MUX use register config,
	rtd_outl(0xb8026500, 0x00030F0B);	// Tcon_A/B/C sel ext_tcon_11/15/3,
	rtd_outl(0xb8026504, 0x00000001);	// Tcon_D/E/F sel ext_tcon_0/1/0,
	rtd_outl(0xb8026508, 0x00000000);	// Tcon_G/H/I sel ext_tcon_0/0/0,
	rtd_outl(0xb802650C, 0x00000000);	// Tcon_J/K sel ext_tcon_0/0,
	rtd_outl(0xb8026528, 0x0000002A);	// DST register config value,
	rtd_outl(0xb802653C, 0x00000015);	// CST register config value,
	rtd_outl(0xb8026550, 0x00000000);	// Lane0 : C1 even register config value, only use even value,
	rtd_outl(0xb8026554, 0x00000000);	// Lane0 : C1 odd register config value (no use),
	rtd_outl(0xb8026558, 0x00000000);	// Lane1 : C1 even register config value, only use even value,
	rtd_outl(0xb802655C, 0x00000000);	// Lane1 : C1 odd register config value (no use),
	rtd_outl(0xb8026560, 0x00000000);	// Lane2 : C1 even register config value, only use even value,
	rtd_outl(0xb8026564, 0x00000000);	// Lane2 : C1 odd register config value (no use),
	rtd_outl(0xb8026568, 0x00000000);	// Lane3 : C1 even register config value, only use even value,
	rtd_outl(0xb802656C, 0x00000000);	// Lane3 : C1 odd register config value (no use),
	rtd_outl(0xb8026570, 0x00000000);	// Lane4 : C1 even register config value, only use even value,
	rtd_outl(0xb8026574, 0x00000000);	// Lane4 : C1 odd register config value (no use),
	rtd_outl(0xb8026578, 0x00000000);	// Lane5 : C1 even register config value, only use even value,
	rtd_outl(0xb802657C, 0x00000000);	// Lane5 : C1 odd register config value (no use),
	rtd_outl(0xb8026580, 0x00000000);	// Lane6 : C1 even register config value, only use even value,
	rtd_outl(0xb8026584, 0x00000000);	// Lane6 : C1 odd register config value (no use),
	rtd_outl(0xb8026588, 0x00000000);	// Lane7 : C1 even register config value, only use even value,
	rtd_outl(0xb802658C, 0x00000000);	// Lane7 : C1 odd register config value (no use),
	rtd_outl(0xb8026590, 0x00000000);	// Lane8 : C1 even register config value, only use even value,
	rtd_outl(0xb8026594, 0x00000000);	// Lane8 : C1 odd register config value (no use),
	rtd_outl(0xb8026598, 0x00000000);	// Lane9 : C1 even register config value, only use even value,
	rtd_outl(0xb802659C, 0x00000000);	// Lane9 : C1 odd register config value (no use),
	rtd_outl(0xb80265A0, 0x00000000);	// Lane10 : C1 even register config value, only use even value,
	rtd_outl(0xb80265A4, 0x00000000);	// Lane10 : C1 odd register config value (no use),
	rtd_outl(0xb80265A8, 0x00000000);	// Lane11 : C1 even register config value, only use even value,
	rtd_outl(0xb80265AC, 0x00000000);	// Lane11 : C1 odd register config value (no use),
	rtd_outl(0xb80265B0, 0x00000000);	// Lane12 : C1 even register config value, only use even value,
	rtd_outl(0xb80265B4, 0x00000000);	// Lane12 : C1 odd register config value (no use),
	rtd_outl(0xb80265B8, 0x00000000);	// Lane13 : C1 even register config value, only use even value,
	rtd_outl(0xb80265BC, 0x00000000);	// Lane13 : C1 odd register config value (no use),
	rtd_outl(0xb80265C0, 0x00000000);	// Lane14 : C1 even register config value, only use even value,
	rtd_outl(0xb80265C4, 0x00000000);	// Lane14 : C1 odd register config value (no use),
	rtd_outl(0xb80265C8, 0x00001600);	// Lane15 : C1 even register config value, only use even value, // for 49", 43" bit20 low.
	rtd_outl(0xb80265CC, 0x00000000);	// Lane15 : C1 odd register config value (no use),
	rtd_outl(0xb80265D0, 0x00001600);	// Lane16 : C1 even register config value, only use even value,// for 49" 43" bit20 low.
	rtd_outl(0xb80265D4, 0x00000000);	// Lane16 : C1 odd register config value (no use),
	rtd_outl(0xb80265D8, 0x00001600);	// Lane17 : C1 even register config value, only use even value,// for 49" 43"bit20 low.
	rtd_outl(0xb80265DC, 0x00000000);	// Lane17 : C1 odd register config value (no use),
	rtd_outl(0xb80265E0, 0x00001600);	// Lane18 : C1 even register config value, only use even value,// for 49" 43" bit20 low.
	rtd_outl(0xb80265E4, 0x00000000);	// Lane18 : C1 odd register config value (no use),
	rtd_outl(0xb80265E8, 0x00001600);	// Lane19 : C1 even register config value, only use even value,// for 49" 43"bit20 low.
	rtd_outl(0xb80265EC, 0x00000000);	// Lane19 : C1 odd register config value (no use),
	rtd_outl(0xb80265F0, 0x00001600);	// Lane20 : C1 even register config value, only use even value,// for 49" 43"bit20 low.
	rtd_outl(0xb80265F4, 0x00000000);	// Lane20 : C1 odd register config value (no use),
	rtd_outl(0xb80265F8, 0x00000000);	// Lane21 : C1 even register config value, only use even value,
	rtd_outl(0xb80265FC, 0x00000000);	// Lane21 : C1 odd register config value (no use),
	rtd_outl(0xb8026600, 0x00000000);	// Lane22 : C1 even register config value, only use even value,
	rtd_outl(0xb8026604, 0x00000000);	// Lane22 : C1 odd register config value (no use),
	rtd_outl(0xb8026608, 0x00000000);	// Lane23 : C1 even register config value, only use even value,
	rtd_outl(0xb802660C, 0x00000000);	// Lane23 : C1 odd register config value (no use),
	rtd_outl(0xb8026620, 0x00000000);	// Lane0 : C2 even register config value, only use even value,
	rtd_outl(0xb8026624, 0x00000000);	// Lane0 : C2 odd register config value (no use),
	rtd_outl(0xb8026628, 0x00000000);	// Lane1 : C2 even register config value, only use even value,
	rtd_outl(0xb802662C, 0x00000000);	// Lane1 : C2 odd register config value (no use),
	rtd_outl(0xb8026630, 0x00000000);	// Lane2 : C2 even register config value, only use even value,
	rtd_outl(0xb8026634, 0x00000000);	// Lane2 : C2 odd register config value (no use),
	rtd_outl(0xb8026638, 0x00000000);	// Lane3 : C2 even register config value, only use even value,
	rtd_outl(0xb802663C, 0x00000000);	// Lane3 : C2 odd register config value (no use),
	rtd_outl(0xb8026640, 0x00000000);	// Lane4 : C2 even register config value, only use even value,
	rtd_outl(0xb8026644, 0x00000000);	// Lane4 : C2 odd register config value (no use),
	rtd_outl(0xb8026648, 0x00000000);	// Lane5 : C2 even register config value, only use even value,
	rtd_outl(0xb802664C, 0x00000000);	// Lane5 : C2 odd register config value (no use),
	rtd_outl(0xb8026650, 0x00000000);	// Lane6 : C2 even register config value, only use even value,
	rtd_outl(0xb8026654, 0x00000000);	// Lane6 : C2 odd register config value (no use),
	rtd_outl(0xb8026658, 0x00000000);	// Lane7 : C2 even register config value, only use even value,
	rtd_outl(0xb802665C, 0x00000000);	// Lane7 : C2 odd register config value (no use),
	rtd_outl(0xb8026660, 0x00000000);	// Lane8 : C2 even register config value, only use even value,
	rtd_outl(0xb8026664, 0x00000000);	// Lane8 : C2 odd register config value (no use),
	rtd_outl(0xb8026668, 0x00000000);	// Lane9 : C2 even register config value, only use even value,
	rtd_outl(0xb802666C, 0x00000000);	// Lane9 : C2 odd register config value (no use),
	rtd_outl(0xb8026670, 0x00000000);	// Lane10 : C2 even register config value, only use even value,
	rtd_outl(0xb8026674, 0x00000000);	// Lane10 : C2 odd register config value (no use),
	rtd_outl(0xb8026678, 0x00000000);	// Lane11 : C2 even register config value, only use even value,
	rtd_outl(0xb802667C, 0x00000000);	// Lane11 : C2 odd register config value (no use),
	rtd_outl(0xb8026680, 0x00000000);	// Lane12 : C2 even register config value, only use even value,
	rtd_outl(0xb8026684, 0x00000000);	// Lane12 : C2 odd register config value (no use),
	rtd_outl(0xb8026688, 0x00000000);	// Lane13 : C2 even register config value, only use even value,
	rtd_outl(0xb802668C, 0x00000000);	// Lane13 : C2 odd register config value (no use),
	rtd_outl(0xb8026690, 0x00000000);	// Lane14 : C2 even register config value, only use even value,
	rtd_outl(0xb8026694, 0x00000000);	// Lane14 : C2 odd register config value (no use),
	rtd_outl(0xb8026698, 0x00000000);	// Lane15 : C2 even register config value, only use even value,
	rtd_outl(0xb802669C, 0x00000000);	// Lane15 : C2 odd register config value (no use),
	rtd_outl(0xb80266A0, 0x00000000);	// Lane16 : C2 even register config value, only use even value,
	rtd_outl(0xb80266A4, 0x00000000);	// Lane16 : C2 odd register config value (no use),
	rtd_outl(0xb80266A8, 0x00000000);	// Lane17 : C2 even register config value, only use even value,
	rtd_outl(0xb80266AC, 0x00000000);	// Lane17 : C2 odd register config value (no use),
	rtd_outl(0xb80266B0, 0x00000000);	// Lane18 : C2 even register config value, only use even value,
	rtd_outl(0xb80266B4, 0x00000000);	// Lane18 : C2 odd register config value (no use),
	rtd_outl(0xb80266B8, 0x00000000);	// Lane19 : C2 even register config value, only use even value,
	rtd_outl(0xb80266BC, 0x00000000);	// Lane19 : C2 odd register config value (no use),
	rtd_outl(0xb80266C0, 0x00000000);	// Lane20 : C2 even register config value, only use even value,
	rtd_outl(0xb80266C4, 0x00000000);	// Lane20 : C2 odd register config value (no use),
	rtd_outl(0xb80266C8, 0x00000000);	// Lane21 : C2 even register config value, only use even value,
	rtd_outl(0xb80266CC, 0x00000000);	// Lane21 : C2 odd register config value (no use),
	rtd_outl(0xb80266D0, 0x00000000);	// Lane22 : C2 even register config value, only use even value,
	rtd_outl(0xb80266D4, 0x00000000);	// Lane22 : C2 odd register config value (no use),
	rtd_outl(0xb80266D8, 0x00000000);	// Lane23 : C2 even register config value, only use even value,
	rtd_outl(0xb80266DC, 0x00000000);	// Lane23 : C2 odd register config value (no use),
	rtd_outl(0xb80266F0, 0x00000000);	// Lane0 : C3 even register config value, only use even value,
	rtd_outl(0xb80266F4, 0x00000000);	// Lane0 : C3 odd register config value (no use),
	rtd_outl(0xb80266F8, 0x00000000);	// Lane1 : C3 even register config value, only use even value,
	rtd_outl(0xb80266FC, 0x00000000);	// Lane1 : C3 odd register config value (no use),
	rtd_outl(0xb8026700, 0x00000000);	// Lane2 : C3 even register config value, only use even value,
	rtd_outl(0xb8026704, 0x00000000);	// Lane2 : C3 odd register config value (no use),
	rtd_outl(0xb8026708, 0x00000000);	// Lane3 : C3 even register config value, only use even value,
	rtd_outl(0xb802670C, 0x00000000);	// Lane3 : C3 odd register config value (no use),
	rtd_outl(0xb8026710, 0x00000000);	// Lane4 : C3 even register config value, only use even value,
	rtd_outl(0xb8026714, 0x00000000);	// Lane4 : C3 odd register config value (no use),
	rtd_outl(0xb8026718, 0x00000000);	// Lane5 : C3 even register config value, only use even value,
	rtd_outl(0xb802671C, 0x00000000);	// Lane5 : C3 odd register config value (no use),
	rtd_outl(0xb8026720, 0x00000000);	// Lane6 : C3 even register config value, only use even value,
	rtd_outl(0xb8026724, 0x00000000);	// Lane6 : C3 odd register config value (no use),
	rtd_outl(0xb8026728, 0x00000000);	// Lane7 : C3 even register config value, only use even value,
	rtd_outl(0xb802672C, 0x00000000);	// Lane7 : C3 odd register config value (no use),
	rtd_outl(0xb8026730, 0x00000000);	// Lane8 : C3 even register config value, only use even value,
	rtd_outl(0xb8026734, 0x00000000);	// Lane8 : C3 odd register config value (no use),
	rtd_outl(0xb8026738, 0x00000000);	// Lane9 : C3 even register config value, only use even value,
	rtd_outl(0xb802673C, 0x00000000);	// Lane9 : C3 odd register config value (no use),
	rtd_outl(0xb8026740, 0x00000000);	// Lane10 : C3 even register config value, only use even value,
	rtd_outl(0xb8026744, 0x00000000);	// Lane10 : C3 odd register config value (no use),
	rtd_outl(0xb8026748, 0x00000000);	// Lane11 : C3 even register config value, only use even value,
	rtd_outl(0xb802674C, 0x00000000);	// Lane11 : C3 odd register config value (no use),
	rtd_outl(0xb8026750, 0x00000000);	// Lane12 : C3 even register config value, only use even value,
	rtd_outl(0xb8026754, 0x00000000);	// Lane12 : C3 odd register config value (no use),
	rtd_outl(0xb8026758, 0x00000000);	// Lane13 : C3 even register config value, only use even value,
	rtd_outl(0xb802675C, 0x00000000);	// Lane13 : C3 odd register config value (no use),
	rtd_outl(0xb8026760, 0x00000000);	// Lane14 : C3 even register config value, only use even value,
	rtd_outl(0xb8026764, 0x00000000);	// Lane14 : C3 odd register config value (no use),
	rtd_outl(0xb8026768, 0x00000000);	// Lane15 : C3 even register config value, only use even value,
	rtd_outl(0xb802676C, 0x00000000);	// Lane15 : C3 odd register config value (no use),
	rtd_outl(0xb8026770, 0x00000000);	// Lane16 : C3 even register config value, only use even value,
	rtd_outl(0xb8026774, 0x00000000);	// Lane16 : C3 odd register config value (no use),
	rtd_outl(0xb8026778, 0x00000000);	// Lane17 : C3 even register config value, only use even value,
	rtd_outl(0xb802677C, 0x00000000);	// Lane17 : C3 odd register config value (no use),
	rtd_outl(0xb8026780, 0x00000000);	// Lane18 : C3 even register config value, only use even value,
	rtd_outl(0xb8026784, 0x00000000);	// Lane18 : C3 odd register config value (no use),
	rtd_outl(0xb8026788, 0x00000000);	// Lane19 : C3 even register config value, only use even value,
	rtd_outl(0xb802678C, 0x00000000);	// Lane19 : C3 odd register config value (no use),
	rtd_outl(0xb8026790, 0x00000000);	// Lane20 : C3 even register config value, only use even value,
	rtd_outl(0xb8026794, 0x00000000);	// Lane20 : C3 odd register config value (no use),
	rtd_outl(0xb8026798, 0x00000000);	// Lane21 : C3 even register config value, only use even value,
	rtd_outl(0xb802679C, 0x00000000);	// Lane21 : C3 odd register config value (no use),
	rtd_outl(0xb80267A0, 0x00000000);	// Lane22 : C3 even register config value, only use even value,
	rtd_outl(0xb80267A4, 0x00000000);	// Lane22 : C3 odd register config value (no use),
	rtd_outl(0xb80267A8, 0x00000000);	// Lane23 : C3 even register config value, only use even value,
	rtd_outl(0xb80267AC, 0x00000000);	// Lane23 : C3 odd register config value (no use),
	rtd_outl(0xb802D700, 0x0F000000);	// lane 0~7 disable, lane 8~15 use EPI 8~15, lane 16~23 use EPI 16~23,
	rtd_outl(0xb8026064, 0x80000008);	// EPI reset release, CST/C3/DST packet disable, EPI lock HW mode,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000E90, 0x00000000);	// TX lane power disable,
	rtd_outl(0xb8000EC8, 0x00000000);	// For test and scan chain use (all bypass), TXPLL Reset enable,
	rtd_outl(0xb8000E00, 0x11240000);	// VBy1 Bandgap enable, VBy1 Power enable,
	rtd_outl(0xb8000E08, 0x00000000);	// TX lane 0~7 dummy register,
	rtd_outl(0xb8000E10, 0x00000000);	// TX lane 8~15 dummy register,
	rtd_outl(0xb8000E18, 0x00000000);	// TX lane 16~23 dummy register,
	rtd_outl(0xb8000E20, 0x00000000);	// TX output driver current for lane 0~7,
	rtd_outl(0xb8000E28, 0x00000006);	// TX output driver current for lane 8~15,
	rtd_outl(0xb8000E30, 0x8cc86000);	// TX output driver current for lane 16~23,
	rtd_outl(0xb8000E38, 0x00000000);	// TX pre-emphasis driver current for lane 0~7,
	rtd_outl(0xb8000E40, 0x00000000);	// TX pre-emphasis driver current for lane 8~15,
	rtd_outl(0xb8000E48, 0x00000000);	// TX pre-emphasis driver current for lane 16~23,
	rtd_outl(0xb8000E60, 0xFFFFFFFF);	// TX lane 0~15 is CML Mode,
	rtd_outl(0xb8000E68, 0xFFFF0000);	// TX lane 16~23 is CML Mode,
	rtd_outl(0xb8000E88, 0x000F0000);	// TX lane 15~20 pre-emphasis enable,
	rtd_outl(0xb8000E98, 0x001F8000);	// TX lane 15~20 Rt connect to Vterm,
	rtd_outl(0xb8000EA0, 0x001F8000);	// TX lane 15~20 Rt enable,
	rtd_outl(0xb8000EA8, 0x00088800);	// TX lane 12~23 Pull mode, CMFB disable, VCM Vref 0.56V,
	rtd_outl(0xb8000EB0, 0x01110201);	// TXPLL LDO1V enable, TXPLL enable, DIVM = 4 (no use), DIVP = 1, EPI Mode,
	rtd_outl(0xb8000EB8, 0x30000500);	// TXPLL VCO use low gain, not bypass DIVM (no use), Rs, DIVB = 4,
	rtd_outl(0xb8000EC0, 0x00035001);	// TXPLL clk_in not inverse and use dclk, Cp, Icp, DIVN = 3,
	rtd_outl(0xb8000EC4, 0x00000100);	// TXPLL not bypass DIVN, MAC_CKO not inverse, CK1X/XK20X for P2S not inverse, EPI use DIV14,
	rtd_outl(0xb8000ECC, 0x000003FF);	// TX lane 16~20 TX offset current for TX/EM driver,
	rtd_outl(0xb8000ED0, 0xC0000000);	// TX lane 15 offset current for TX/EM driver,
	rtd_outl(0xb8000ED4, 0x88888888);	// TX lane 23~16 for 2*Rt setting,
	rtd_outl(0xb8000ED8, 0x88888888);	// TX lane 15~8 for 2*Rt setting,
	rtd_outl(0xb8000EDC, 0x88888888);	// TX lane 7~0 for 2*Rt setting,
	rtd_outl(0xb8000EC8, 0x00010000);	// After POW_VBY1_TOP = 1 and wait 15us, TXPLL Reset release,
	rtd_outl(0xb8000E90, 0x001F8000);	// After TXPLL Reset release and wait >150us, TX lane 15~20 power enable,

	rtd_outl(0xb8000C74, 0x80800000);		// Low Speed APHY Power Enable
	rtd_maskl(0xb8000C84, 0xFFFFF0FF, 0x00000500);	// plt_p3_txbn_apad for GST, use Tcon18,
	rtd_maskl(0xb8000804, 0xFFFF0FFF, 0x00004000);	// gpio_4_ps for MCLK, use Tcon14,
	rtd_maskl(0xb8000804, 0xFF0FFFFF, 0x00500000);	// gpo_1_ps for GCLK, use Tcon9,
	rtd_maskl(0xb8000C84, 0xFF0FFFFF, 0x00500000);	// plt_p3_txcp_apad for EO, use Tcon35,

	// Tcon Timing Setting,
	rtd_outl(0xb802D200, 0x40000000);		// External Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb802D42C, 0x00000000);		// External Global Tcon disable,
	rtd_outl(0xb8026804, 0x40000000);		// EPI Tcon Across frame and Across line 3 Function enable,
	rtd_outl(0xb8026800, 0x00000006);		// EPI Tcon use SFG VS, global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// GST, LGE(C3), pimmux(plt_p3_txbn_apad), Tcon18,
	// Tcon17 (Frame Start Pulse),
	rtd_outl(0xb802D47C, 0x05d005bc);		// H_start/H_end,
	rtd_outl(0xb802D480, 0x004d0051);		// V_start/V_end,
	rtd_outl(0xb802D484, 0x00000180);		// Control,
	// Tcon18 (Frame End Pulse),
	rtd_outl(0xb802D498, 0x00E800E8);		// H_start/H_end,
	rtd_outl(0xb802D49C, 0x11411144);		// V_start/V_end,
	rtd_outl(0xb802D4A0, 0x00000182);		// Control,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// MCLK, LGE(GPIO_4), pimmux(gpio_4_ps), Tcon14,
	// Tocn13 (EVEN Line),
	rtd_outl(0xb802D37C, 0x00520575);		// H_start/H_end,
	rtd_outl(0xb802D380, 0x00570876);		// V_start/V_end,
	rtd_outl(0xb802D384, 0x00000380);		// Control,
	rtd_outl(0xb802D388, 0x00020000);		// Across Line3 RP/HP,
	// Tcon14 (ODD Line),
	rtd_outl(0xb802D398, 0x04b004fa);		// H_start/H_end,
	rtd_outl(0xb802D39C, 0x00560876);		// V_start/V_end,
	rtd_outl(0xb802D3A0, 0x00000382);		// Control,
	rtd_outl(0xb802D3A4, 0x00020000);		// Across Line3 RP/HP,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// GCLK, LGE(GPO_1), pimmux(gpo_1_ps), Tcon9,
	// Tcon6 (Last Long Pulse),
	rtd_outl(0xb802D2AC, 0x00F800F8);		// H_start/H_end,
	rtd_outl(0xb802D2B0, 0x113D1144);		// V_start/V_end,
	rtd_outl(0xb802D2B4, 0x00000180);		// Control,
	// Tcon7 (EVEN Line),
	rtd_outl(0xb802D2C8, 0x0795065d);		// H_start/H_end,
	rtd_outl(0xb802D2CC, 0x00510876);		// V_start/V_end,
	rtd_outl(0xb802D2D0, 0x00000382);		// Control,
	rtd_outl(0xb802D2D4, 0x00020001);		// Across Line3 RP/HP,
	// Tcon8 (ODD Line),
	rtd_outl(0xb802D2E4, 0x07300701);		// H_start/H_end,
	rtd_outl(0xb802D2E8, 0x00520875);		// V_start/V_end,
	rtd_outl(0xb802D2EC, 0x00000382);		// Control,
	rtd_outl(0xb802D2F0, 0x00020001);		// Across Line3 RP/HP,
	// Tcon9 (First Pulse),
	rtd_outl(0xb802D300, 0x00000000);		// H_start/H_end,
	rtd_outl(0xb802D304, 0x00000000);		// V_start/V_end,
	rtd_outl(0xb802D308, 0x00000182);		// Control,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// EO, LGE(B2), pimmux(plt_p3_txcp_apad), Tcon35,
	// TCON34,
	rtd_outl(0xb80269B8, 0x00F800F8);		// H_start/H_end,
	rtd_outl(0xb80269BC, 0x11451145);		// V_start/V_end,
	rtd_outl(0xb80269C0, 0x00000480);		// Control,
	rtd_outl(0xb80269C8, 0x0000007E);		// Across Frame Period,
	// Tcon35,
	rtd_outl(0xb80269D4, 0x01b001b0);		// H_start/H_end,
	rtd_outl(0xb80269D8, 0x11451145);		// V_start/V_end,
	rtd_outl(0xb80269DC, 0x00000483);		// Control,
	rtd_outl(0xb80269E4, 0x0000007E);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// POL, Tcon11, use frame inversion
	// Tcon10,
	rtd_outl(0xb802D320, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D324, 0x000008CA);		// V_start/V_end,
	rtd_outl(0xb802D328, 0x00000380);		// Control,
	rtd_outl(0xb802D32C, 0x00020001);		// Across Line 3 RP/HP,
	// Tcon11,
	rtd_outl(0xb802D340, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D344, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D348, 0x00000480);		// Control,
	rtd_outl(0xb802D350, 0x00000000);		// Across Frame Period,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// GSP, Tcon15,
	// Tcon15,
	rtd_outl(0xb802D444, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D448, 0x00570058);		// V_start/V_end,
	rtd_outl(0xb802D44C, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// Scrambler Reset, Tcon3,
	// Tcon3,
	rtd_outl(0xb802D258, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D25C, 0x00011150);		// V_start/V_end,
	rtd_outl(0xb802D260, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////


	////////////////////////////////////////////////////////////////////////////
	// Scrambler Enable, Tcon39,
	// Tcon39,
	rtd_outl(0xb8026A44, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb8026A48, 0x00011150);		// V_start/V_end,
	rtd_outl(0xb8026A4C, 0x00000180);		// Control,
	////////////////////////////////////////////////////////////////////////////


	rtd_outl(0xb802D42C, 0x00000001);		// External Global Tcon disable,
	rtd_outl(0xb8026800, 0x00000007);		// EPI Tcon use SFG VS, global Tcon enable,


}


void panel_epi_lc550egg_uhd60_6lane_tcon_setting(void)
{
	// Tcon Pinshare Setting,
	rtd_part_outl(0xb800088C, 31, 28, 0x9);		// gpio_75 for GST, use Tcon7,
	rtd_part_outl(0xb80008A4,  7,  4, 0xA);		// gpio_92 for MCLK, use Tcon24,
	rtd_part_outl(0xb80008A8,  7,  4, 0x9);		// gpio_96 for GCLK, use Tcon17,
	rtd_part_outl(0xb800088C, 23, 20, 0x9);		// gpio_76 for EO, use Tcon5,

	rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// GST, gpio_75, Tcon7,
	// Tcon6 (Frame Start Pulse),
	rtd_outl(0xb802D2D0, 0x00400040);		// H_start/H_end,
	rtd_outl(0xb802D2D4, 0x004E0052);		// V_start/V_end,
	rtd_outl(0xb802D2D8, 0x00000180);		// Control,
	// Tcon7 (Frame End Pulse),
	rtd_outl(0xb802D2F0, 0x02000200);		// H_start/H_end,
	rtd_outl(0xb802D2F4, 0x11431146);		// V_start/V_end,
	rtd_outl(0xb802D2F8, 0x00000182);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// MCLK, gpio_92, Tcon24,
	// Tocn23 (Line 2/4/6/...),
	rtd_outl(0xb802D4F0, 0x05340584);		// H_start/H_end,
	rtd_outl(0xb802D4F4, 0x00571143);		// V_start/V_end,
	rtd_outl(0xb802D4F8, 0x00000380);		// Control,
	rtd_outl(0xb802D4FC, 0x00020000);		// Across Line3 RP/HP,
	// Tcon24 (Line 1/3/5/...),
	rtd_outl(0xb802D510, 0x05340600);		// H_start/H_end,
	rtd_outl(0xb802D514, 0x00561143);		// V_start/V_end,
	rtd_outl(0xb802D518, 0x00000382);		// Control,
	rtd_outl(0xb802D51C, 0x00020000);		// Across Line3 RP/HP,


	////////////////////////////////////////////////////////////////////////////
	// GCLK, gpio_96, Tcon17,
	// Tcon14 (Frame End Pulse),
	rtd_outl(0xb802D3D0, 0x02000200);		// H_start/H_end,
	rtd_outl(0xb802D3D4, 0x113E1146);		// V_start/V_end,
	rtd_outl(0xb802D3D8, 0x00000180);		// Control,
	// Tcon15 (Line 2/4/6/...),
	rtd_outl(0xb802D3F0, 0x02000370);		// H_start/H_end,
	rtd_outl(0xb802D3F4, 0x0053113E);		// V_start/V_end,
	rtd_outl(0xb802D3F8, 0x00000382);		// Control,
	rtd_outl(0xb802D3FC, 0x00020000);		// Across Line3 RP/HP,
	// Tcon16 (Line 1/3/5/...),
	rtd_outl(0xb802D410, 0x02000370);		// H_start/H_end,
	rtd_outl(0xb802D414, 0x0054113E);		// V_start/V_end,
	rtd_outl(0xb802D418, 0x00000382);		// Control,
	rtd_outl(0xb802D41C, 0x00020000);		// Across Line3 RP/HP,
	// Tcon17 (Frame Start Pulse),
	rtd_outl(0xb802D430, 0x02000370);		// H_start/H_end,
	rtd_outl(0xb802D434, 0x00520052);		// V_start/V_end,
	rtd_outl(0xb802D438, 0x00000182);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// EO, gpio_76, Tcon5,
	// TCON4,
	rtd_outl(0xb802D290, 0x02000200);		// H_start/H_end,
	rtd_outl(0xb802D294, 0x11471147);		// V_start/V_end,
	rtd_outl(0xb802D298, 0x00000480);		// Control,
	rtd_outl(0xb802D2A0, 0x007D007D);		// Across Frame LP, Across Frame HP
	// Tcon5,
	rtd_outl(0xb802D2B0, 0x02BC02BC);		// H_start/H_end,
	rtd_outl(0xb802D2B4, 0x11471147);		// V_start/V_end,
	rtd_outl(0xb802D2B8, 0x00000483);		// Control,
	rtd_outl(0xb802D2C0, 0x007D007D);		// Across Frame LP, Across Frame HP


	////////////////////////////////////////////////////////////////////////////
	// POL, Tcon20,
	// Tcon18, flag_28s
	rtd_outl(0xb802D450, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D454, 0x00011146);		// V_start/V_end,
	rtd_outl(0xb802D458, 0x00000108);		// Control,
	rtd_outl(0xb802D460, 0x068F068F);		// Across Frame LP, Across Frame HP
	// Tcon19,
	rtd_outl(0xb802D470, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D474, 0x00011146);		// V_start/V_end,
	rtd_outl(0xb802D478, 0x0000018B);		// Control,
	rtd_outl(0xb802D47C, 0x00000000);		// Across Line 3 HP/RP,
	rtd_outl(0xb802D480, 0x00000000);		// Across Frame LP, Across Frame HP
	// Tcon20,
	rtd_outl(0xb802D490, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D494, 0x00011146);		// V_start/V_end,
	rtd_outl(0xb802D498, 0x00000183);		// Control,
	rtd_outl(0xb802D4A0, 0x00000000);		// Across Frame LP, Across Frame HP


	////////////////////////////////////////////////////////////////////////////
	// GSP, Tcon25,
	// Tcon25,
	rtd_outl(0xb802D530, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D534, 0x00570058);		// V_start/V_end,
	rtd_outl(0xb802D538, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// Scrambler Enable, Tcon26,
	rtd_outl(0xb802D550, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D554, 0x00011150);		// V_start/V_end,
	rtd_outl(0xb802D558, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// Scrambler Reset, Tcon27,
	rtd_outl(0xb802D570, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D574, 0x00011150);		// V_start/V_end,
	rtd_outl(0xb802D578, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// DE (Tcon8, EO), for debug,
	//rtd_outl(0xb802D310, 0x00A30820);		// H_start/H_end,
	//rtd_outl(0xb802D314, 0x005A1139);		// V_start/V_end,
	//rtd_outl(0xb802D318, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// 1st Line DE (Tcon8, EO), for debug,
	//rtd_outl(0xb802D310, 0x00A30820);		// H_start/H_end,
	//rtd_outl(0xb802D314, 0x005A005A);		// V_start/V_end,
	//rtd_outl(0xb802D318, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////

	rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
	rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x01100040);	// SFG path enable, Common fifo use sfg_clk, 30-bit Mode, SFG out disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x02FFFFFF);	// PIF_Clock = Dclk/3, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 8n+0/8n+1/8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00000000);	// Line 8n+4/8n+5/8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x089D002D);	// DV_Den_end,DV_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D954, 0x10180118);	// DH_Den_end,DH_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D958, 0x057F112F);	// DV_width,Dh_width,Dh_total (follow DTG timing)
	rtd_outl(0xb802D964, 0x10000585);	// SFG DRD Mode, 1.5 packet mode disable, 1P mode, H-Flip enable, 6-SEG, 6-Port,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	//rtd_outl(0xb802DB00, 0x00000000);	// SEG12/SEG13 Start Address,
	//rtd_outl(0xb802DB04, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D980, 0x03C0F03C);	// Gray dummy line data0 (L15 in 8-bit),
	rtd_outl(0xb802D984, 0x00000000);	// Gray dummy line data1 (L0),
	//rtd_outl(0xb802D94C, 0x00000000);	// Gray dummy line data2,
	//rtd_outl(0xb802DA28, 0x00000000);	// Gray dummy line data3,
	rtd_outl(0xb802DA24, 0x00010000);	// front dummuy line use gray data0, back dummuy line use gray data1,
	rtd_outl(0xb802D988, 0x40100090);	// Bypass SFG disable, Auto config enable, downsample disable,
						// front_dummy_line_num(2), back_dummy_line_num(1),
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00000000);	// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00000000);	// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00000000);	// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00000000);	// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD Data Mapping,
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD Data Mapping,
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD Data Mapping,
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD Data Mapping,
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD Data Mapping,
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD Data Mapping,
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD Data Mapping,
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD Data Mapping,
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD Data Mapping,
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD Data Mapping,
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD Data Mapping,
	rtd_outl(0xb802DACC, 0x16161616);	// DRD Data Mapping,
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD Data Mapping,
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD Data Mapping,
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD Data Mapping,
	rtd_outl(0xb802DADC, 0x07070707);	// DRD Data Mapping,
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD Data Mapping,
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD Data Mapping,
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD Data Mapping,
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD Data Mapping,
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD Data Mapping,
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD Data Mapping,
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD Data Mapping,
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD Data Mapping,
	rtd_outl(0xb802DB68, 0x00000000);	// ext_num setting for case_a line7~0,
	rtd_outl(0xb802DB6C, 0x00000000);	// ext_num setting for case_b line7~0,
	//rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E20);	// SFG Pattern Gen. Enable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	//rtd_outl(0xb802DC14, 0x00000000);	// SFG Pattern Gen. gray_data0 and gray_data1 for manmal pattern,
	//rtd_outl(0xb802DC18, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+0,
	//rtd_outl(0xb802DC1C, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+1,
	//rtd_outl(0xb802DC20, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+2,
	//rtd_outl(0xb802DC24, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+3,
	// Merlin-serial FIFO start
	//rtd_outl(0xb802DC94, 0x20000000);	// Aysnc FIFO disble, Async FIFO use EPI Mode,
	//rtd_outl(0xb802DC98, 0x9C00FFFF);	// 15~0 Lane_en
	//rtd_outl(0xb802DC9C, 0x45012FFF);	// Lane 7~0 pair assign,  2K using lane2~lane14 for LSphy
	//rtd_outl(0xb802DCA0, 0xFFFFFFF3);	// Lane 15~8 pair assign,  2K using lane2~lane14 for LSphy
	//rtd_outl(0xb802DCC8, 0x000001F8);	// VIDEO_OSD_SEL 16lane video, phy lane8~lane3 enable
	//rtd_outl(0xb802DCD0, 0x00000000);	// P/N Swap enable ,
	// Merlin-serial FIFO end
	rtd_part_outl(0xb802D900, 11, 11, 0x1);	// SFG out enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCK Pin share
	//---------------------------------------------------------------------------------------------------------------------------------

	rtd_maskl(0xb80008A4, 0x0F0FFFFF, 0x00500000);	// GPIO_90 pinshare to EPI_LOCK_SRC0,
	rtd_maskl(0xb8000CBC, 0xFFFFFFFC, 0x00000000);	// VEPI MAC use EPI_LOCK_SRC0,
	rtd_maskl(0xb80008BC, 0x7FFFFFFF, 0x80000000);	// GPIO_90 use 1.8V GPI,

	//---------------------------------------------------------------------------------------------------------------------------------
	//EPI MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb8026000, 0x00000004);	// Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026060, 0x08000002);	// EPI 3.05Gbps 8-bit mode,
	rtd_outl(0xb8026064, 0x80000000);	// EPI reset disable, CST/C3/C4/C5/DST packet disable, EPI lock HW mode,
	rtd_outl(0xb802606C, 0x40603000);	// EPI disable, ext_num unit is sub-pixel, 6-port EPI, packet delimiter,
	//rtd_outl(0xb8026070, 0x00000645);	// CMPI CMD/DATA delimiter, run length conding delimiter,
	//rtd_outl(0xb8026080, 0x00000000);	// Dummy line color 0 (L0) for CMPI,
	//rtd_outl(0xb8026084, 0x00000000);	// Dummy line color 1 (L0) for CMPI,
	//rtd_outl(0xb8026088, 0x00000000);	// Dummy line color 2 (L0) for CMPI,
	//rtd_outl(0xb802608C, 0x00000000);	// Dummy line color 3 (L0) for CMPI,
	rtd_outl(0xb8026090, 0x000003F3);	// CRC Enable, select lane 0~5 to CRC,
	rtd_outl(0xb802609C, 0x00000000);	// EPI Data from SFG, EPI packet data setting,
	rtd_outl(0xb80260A4, 0x00000071);	// INV4 LUT use 8 line cycle, POD2_INV4 initial phase select bypass (2'b00),
	rtd_outl(0xb80260A8, 0x500AAFF5);	// INV4 LUT for line 0~8,
	//rtd_outl(0xb80260AC, 0x00000000);	// INV4 LUT for line 9~16,
	//rtd_outl(0xb8026110, 0x00000000);	// CMPI RLC Function for 10bit mode disable,
	//rtd_outl(0xb8026114, 0x00000000);	// CMPI CDR type mode select,
	//rtd_outl(0xb8026118, 0x00000000);	// CMPI CDR clock training2 insert in type1 and type2,
	rtd_outl(0xb802617C, 0x00000023);	// Scrambler reset/enable control by tcon_c/tcon_d,
	rtd_outl(0xb8026180, 0x00000003);	// EPI_SCR8 enable, HVBP_SCR disable, EDGE_SCR disable,
	rtd_outl(0xb8026184, 0x00FFFFFF);	// EPI_SCR8 initial value,
	//rtd_outl(0xb8026188, 0x00000002);	// EPI_SCR10 disable,
	//rtd_outl(0xb802618C, 0x000FFFFF);	// EPI_SCR10 initial value,
	//rtd_outl(0xb8026190, 0x00000000);	// CMPI_SCR8 disable,
	//rtd_outl(0xb8026194, 0x00000FFF);	// CMPI_SCR8 initial value,
	//rtd_outl(0xb8026198, 0x00000000);	// CMPI_SCR10 disable,
	//rtd_outl(0xb802619C, 0x000003FF);	// CMPI_SCR10 initial value,
	//rtd_outl(0xb80261A0, 0x00000000);	// CMPI F/M/B color select, Pgamma for CMPI disable,
	//rtd_outl(0xb80261A4, 0x00000000);	// CMPI Pgamma CST packet,
	//rtd_outl(0xb80261A8, 0x00000000);	// CMPI Pgamma C1 packet,
	//rtd_outl(0xb80261AC, 0x00000000);	// CMPI Pgamma C2 packet,
	//rtd_outl(0xb80261B0, 0x00000000);	// CMPI Pgamma C3 packet,
	//rtd_outl(0xb8026300, 0x00000000);	// CMPI Pgamma C4 packet,
	//rtd_outl(0xb8026304, 0x00000000);	// CMPI Pgamma C5 packet,
	//rtd_outl(0xb80261B4, 0x00000000);	// CMPI Pgamma PG_ST packet,
	//rtd_outl(0xb80261B8, 0x00000000);	// CMPI Pgamma Data0 packet,
	//rtd_outl(0xb80261BC, 0x00000000);	// CMPI Pgamma Data1 packet,
	//rtd_outl(0xb80261C0, 0x00000000);	// CMPI Pgamma Data2 packet,
	//rtd_outl(0xb80261C4, 0x00000000);	// CMPI Pgamma Data3 packet,
	//rtd_outl(0xb80261C8, 0x00000000);	// CMPI Pgamma Data4 packet,
	//rtd_outl(0xb80261CC, 0x00000000);	// CMPI Pgamma Data5 packet,
	//rtd_outl(0xb80261D0, 0x00000000);	// CMPI Pgamma Data6 packet,
	//rtd_outl(0xb80261D4, 0x00000000);	// CMPI Pgamma Data7 packet,
	//rtd_outl(0xb80261D8, 0x00000000);	// CMPI Pgamma Data8 packet,
	//rtd_outl(0xb80261DC, 0x00000000);	// CMPI Pgamma Data9 packet,
	//rtd_outl(0xb8026308, 0x00000000);	// CMPI Pgamma Data10 packet,
	//rtd_outl(0xb802630C, 0x00000000);	// CMPI Pgamma Data11 packet,
	//rtd_outl(0xb8026310, 0x00000000);	// CMPI Pgamma Data12 packet,
	//rtd_outl(0xb8026314, 0x00000000);	// CMPI Pgamma Data13 packet,
	//rtd_outl(0xb8026318, 0x00000000);	// CMPI Pgamma Data14 packet,
	//rtd_outl(0xb802631C, 0x00000000);	// CMPI Pgamma Data15 packet,
	//rtd_outl(0xb8026320, 0x00000000);	// CMPI Pgamma Data16 packet,
	//rtd_outl(0xb8026324, 0x00000000);	// CMPI Pgamma Data17 packet,
	//rtd_outl(0xb8026328, 0x00000000);	// CMPI Pgamma Data18 packet,
	//rtd_outl(0xb802632C, 0x00000000);	// CMPI Pgamma Data19 packet,
	//rtd_outl(0xb8026330, 0x00000000);	// CMPI Pgamma Data20 packet,
	//rtd_outl(0xb8026334, 0x00000000);	// CMPI Pgamma Data21 packet,
	//rtd_outl(0xb8026338, 0x00000000);	// CMPI Pgamma Data22 packet,
	//rtd_outl(0xb802633C, 0x00000000);	// CMPI Pgamma Data23 packet,
	//rtd_outl(0xb8026340, 0x00000000);	// CMPI Pgamma Data24 packet,
	//rtd_outl(0xb8026344, 0x00000000);	// CMPI Pgamma Data25 packet,
	//rtd_outl(0xb8026348, 0x00000000);	// CMPI Pgamma Data26 packet,
	//rtd_outl(0xb802634C, 0x00000000);	// CMPI Pgamma Data27 packet,
	//rtd_outl(0xb8026350, 0x00000000);	// CMPI Pgamma Data28 packet,
	//rtd_outl(0xb8026354, 0x00000000);	// CMPI Pgamma Data29 packet,
	//rtd_outl(0xb8026358, 0x00000000);	// CMPI Pgamma Data30 packet,
	//rtd_outl(0xb802635C, 0x00000000);	// CMPI Pgamma Data31 packet,
	//rtd_outl(0xb8026360, 0x00000000);	// CMPI Pgamma Data32 packet,
	//rtd_outl(0xb8026364, 0x00000000);	// CMPI Pgamma Data33 packet,
	//rtd_outl(0xb8026368, 0x00000000);	// CMPI Pgamma Data34 packet,
	//rtd_outl(0xb802636C, 0x00000000);	// CMPI Pgamma Data35 packet,
	//rtd_outl(0xb8026370, 0x00000000);	// CMPI Pgamma Data36 packet,
	//rtd_outl(0xb8026374, 0x00000000);	// CMPI Pgamma Data37 packet,
	//rtd_outl(0xb8026378, 0x00000000);	// CMPI Pgamma Data38 packet,
	//rtd_outl(0xb802637C, 0x00000000);	// CMPI Pgamma Data39 packet,
	//rtd_outl(0xb8026400, 0x00000000);	// CMPI Pgamma Data40 packet,
	//rtd_outl(0xb8026404, 0x00000000);	// CMPI Pgamma Data41 packet,
	//rtd_outl(0xb8026408, 0x00000000);	// CMPI Pgamma Data42 packet,
	//rtd_outl(0xb802640C, 0x00000000);	// CMPI Pgamma Data43 packet,
	//rtd_outl(0xb8026410, 0x00000000);	// CMPI Pgamma Data44 packet,
	//rtd_outl(0xb8026414, 0x00000000);	// CMPI Pgamma Data45 packet,
	//rtd_outl(0xb8026418, 0x00000000);	// CMPI Pgamma Data46 packet,
	//rtd_outl(0xb802641C, 0x00000000);	// CMPI Pgamma Data47 packet,
	//rtd_outl(0xb8026420, 0x00000000);	// CMPI Pgamma Data48 packet,
	//rtd_outl(0xb8026424, 0x00000000);	// CMPI Pgamma Data49 packet,
	//rtd_outl(0xb8026428, 0x00000000);	// CMPI Pgamma Data50 packet,
	//rtd_outl(0xb802642C, 0x00000000);	// CMPI Pgamma Data51 packet,
	//rtd_outl(0xb8026430, 0x00000000);	// CMPI Pgamma Data52 packet,
	//rtd_outl(0xb8026434, 0x00000000);	// CMPI Pgamma Data53 packet,
	//rtd_outl(0xb8026438, 0x00000000);	// CMPI Pgamma Data54 packet,
	//rtd_outl(0xb802643C, 0x00000000);	// CMPI Pgamma Data55 packet,
	//rtd_outl(0xb8026440, 0x00000000);	// CMPI Pgamma Data56 packet,
	//rtd_outl(0xb8026444, 0x00000000);	// CMPI Pgamma Data57 packet,
	//rtd_outl(0xb8026448, 0x00000000);	// CMPI Pgamma Data58 packet,
	//rtd_outl(0xb802644C, 0x00000000);	// CMPI Pgamma Data59 packet,
	//rtd_outl(0xb80261E0, 0x00000000);	// CMPI Pgamma PG_END packet,
	rtd_outl(0xb80261E4, 0x0000003F);	// EPI MAC output Port 0~5 transmit to APHY, others disable,
	rtd_outl(0xb80261E8, 0x0000003F);	// EPI Port 0~5 extend subpixel use sfg case_a,
	rtd_outl(0xb80261EC, 0x0000003F);	// EPI constant_update_mode : EPI Port 0~5 update by TDM (for power save),
	rtd_outl(0xb80263F8, 0x00000000);	// EPI update first ctrl packet time : hs_den_io_dist + den_length (compute by hw),
	rtd_outl(0xb80263FC, 0x007D00FB);	// LOCK debounce enable and setting,
	rtd_outl(0xb80261F4, 0x0000000F);	// Check SFG output timing enable,
	rtd_outl(0xb80261FC, 0x0000000E);	// SOE LUT use 4-line repeat, SOE LUT apply to C2[17:0],
	rtd_outl(0xb8026200, 0x00007936);	// SOE line 0 LUT for lane 0,
	rtd_outl(0xb8026204, 0x00007936);	// SOE line 1 LUT for lane 0,
	rtd_outl(0xb8026208, 0x00007936);	// SOE line 2 LUT for lane 0,
	rtd_outl(0xb802620C, 0x00007936);	// SOE line 3 LUT for lane 0,
	rtd_outl(0xb8026210, 0x00007937);	// SOE line 0 LUT for lane 1,
	rtd_outl(0xb8026214, 0x00007937);	// SOE line 1 LUT for lane 1,
	rtd_outl(0xb8026218, 0x00007937);	// SOE line 2 LUT for lane 1,
	rtd_outl(0xb802621C, 0x00007937);	// SOE line 3 LUT for lane 1,
	rtd_outl(0xb8026220, 0x00007938);	// SOE line 0 LUT for lane 2,
	rtd_outl(0xb8026224, 0x00007938);	// SOE line 1 LUT for lane 2,
	rtd_outl(0xb8026228, 0x00007938);	// SOE line 2 LUT for lane 2,
	rtd_outl(0xb802622C, 0x00007938);	// SOE line 3 LUT for lane 2,
	rtd_outl(0xb8026230, 0x00007938);	// SOE line 0 LUT for lane 3,
	rtd_outl(0xb8026234, 0x00007938);	// SOE line 1 LUT for lane 3,
	rtd_outl(0xb8026238, 0x00007938);	// SOE line 2 LUT for lane 3,
	rtd_outl(0xb802623C, 0x00007938);	// SOE line 3 LUT for lane 3,
	rtd_outl(0xb8026240, 0x00007937);	// SOE line 0 LUT for lane 4,
	rtd_outl(0xb8026244, 0x00007937);	// SOE line 1 LUT for lane 4,
	rtd_outl(0xb8026248, 0x00007937);	// SOE line 2 LUT for lane 4,
	rtd_outl(0xb802624C, 0x00007937);	// SOE line 3 LUT for lane 4,
	rtd_outl(0xb8026250, 0x00007936);	// SOE line 0 LUT for lane 5,
	rtd_outl(0xb8026254, 0x00007936);	// SOE line 1 LUT for lane 5,
	rtd_outl(0xb8026258, 0x00007936);	// SOE line 2 LUT for lane 5,
	rtd_outl(0xb802625C, 0x00007936);	// SOE line 3 LUT for lane 5,
	//rtd_outl(0xb8026260, 0x00000000);	// SOE line 0 LUT for lane 6,
	//rtd_outl(0xb8026264, 0x00000000);	// SOE line 1 LUT for lane 6,
	//rtd_outl(0xb8026268, 0x00000000);	// SOE line 2 LUT for lane 6,
	//rtd_outl(0xb802626C, 0x00000000);	// SOE line 3 LUT for lane 6,
	//rtd_outl(0xb8026270, 0x00000000);	// SOE line 0 LUT for lane 7,
	//rtd_outl(0xb8026274, 0x00000000);	// SOE line 1 LUT for lane 7,
	//rtd_outl(0xb8026278, 0x00000000);	// SOE line 2 LUT for lane 7,
	//rtd_outl(0xb802627C, 0x00000000);	// SOE line 3 LUT for lane 7,
	//rtd_outl(0xb8026280, 0x00000000);	// SOE line 0 LUT for lane 8,
	//rtd_outl(0xb8026284, 0x00000000);	// SOE line 1 LUT for lane 8,
	//rtd_outl(0xb8026288, 0x00000000);	// SOE line 2 LUT for lane 8,
	//rtd_outl(0xb802628C, 0x00000000);	// SOE line 3 LUT for lane 8,
	//rtd_outl(0xb8026290, 0x00000000);	// SOE line 0 LUT for lane 9,
	//rtd_outl(0xb8026294, 0x00000000);	// SOE line 1 LUT for lane 9,
	//rtd_outl(0xb8026298, 0x00000000);	// SOE line 2 LUT for lane 9,
	//rtd_outl(0xb802629C, 0x00000000);	// SOE line 3 LUT for lane 9,
	//rtd_outl(0xb80262A0, 0x00000000);	// SOE line 0 LUT for lane 10,
	//rtd_outl(0xb80262A4, 0x00000000);	// SOE line 1 LUT for lane 10,
	//rtd_outl(0xb80262A8, 0x00000000);	// SOE line 2 LUT for lane 10,
	//rtd_outl(0xb80262AC, 0x00000000);	// SOE line 3 LUT for lane 10,
	//rtd_outl(0xb80262B0, 0x00000000);	// SOE line 0 LUT for lane 11,
	//rtd_outl(0xb80262B4, 0x00000000);	// SOE line 1 LUT for lane 11,
	//rtd_outl(0xb80262B8, 0x00000000);	// SOE line 2 LUT for lane 11,
	//rtd_outl(0xb80262BC, 0x00000000);	// SOE line 3 LUT for lane 11,
	//rtd_outl(0xb8026380, 0x00000000);	// DST(C4~C0) MUX use register config,
	//rtd_outl(0xb8026384, 0x00000000);	// DST(C9~C5) MUX use register config,
	//rtd_outl(0xb8026388, 0x00000000);	// DST(C14~C10) MUX use register config,
	//rtd_outl(0xb802638C, 0x00000000);	// DST(C19~C15) MUX use register config,
	//rtd_outl(0xb8026390, 0x00000000);	// DST(C24~C20) MUX use register config,
	//rtd_outl(0xb8026394, 0x00000000);	// DST(C29~C25) MUX use register config,
	//rtd_outl(0xb8026398, 0x00000000);	// CST(C4~C0) MUX use register config,
	//rtd_outl(0xb802639C, 0x00000000);	// CST(C9~C5) MUX use register config,
	//rtd_outl(0xb80263A0, 0x00000000);	// CST(C14~C10) MUX use register config,
	//rtd_outl(0xb80263A4, 0x00000000);	// CST(C19~C15) MUX use register config,
	//rtd_outl(0xb80263A8, 0x00000000);	// CST(C24~C20) MUX use register config,
	//rtd_outl(0xb80263AC, 0x00000000);	// CST(C29~C25) MUX use register config,
	rtd_outl(0xb80263B0, 0x00000000);	// C1(C4~C0) MUX use register config,
	rtd_outl(0xb80263B4, 0x00000210);	// C1(C9~C5) MUX use register config (C6/C7 use Tcon_A/B),
	rtd_outl(0xb80263B8, 0x0009A000);	// C1(C14~C10) MUX use register config (C13/C14 use INV4_1/2 LUT),
	rtd_outl(0xb80263BC, 0x00000078);	// C1(C19~C15) MUX use register config (C15/C16 use INV4_3/4 LUT),
	rtd_outl(0xb80263C0, 0x00000000);	// C1(C24~C20) MUX use register config,
	rtd_outl(0xb80263C4, 0x00000000);	// C1(C29~C25) MUX use register config,
	rtd_outl(0xb80263C8, 0x00000000);	// C2(C4~C0) MUX use register config,
	rtd_outl(0xb80263CC, 0x00000000);	// C2(C9~C5) MUX use register config,
	rtd_outl(0xb80263D0, 0x00000000);	// C2(C14~C10) MUX use register config,
	rtd_outl(0xb80263D4, 0x00033000);	// C2(C19~C15) MUX use register config (C18/C19 use Tcon_C/C),
	rtd_outl(0xb80263D8, 0x00004443);	// C2(C24~C20) MUX use register config (C20/C21/C22/C23 use Tcon_C/D/D/D),
	rtd_outl(0xb80263DC, 0x00000000);	// C2(C29~C25) MUX use register config,
	//rtd_outl(0xb80263E0, 0x00000000);	// C3(C4~C0) MUX use register config,
	//rtd_outl(0xb80263E4, 0x00000000);	// C3(C9~C5) MUX use register config,
	//rtd_outl(0xb80263E8, 0x00000000);	// C3(C14~C10) MUX use register config,
	//rtd_outl(0xb80263EC, 0x00000000);	// C3(C19~C15) MUX use register config,
	//rtd_outl(0xb80263F0, 0x00000000);	// C3(C24~C20) MUX use register config,
	//rtd_outl(0xb80263F4, 0x00000000);	// C3(C29~C25) MUX use register config,
	rtd_outl(0xb8026500, 0x001A1914);	// Tcon_A/B/C sel ext_tcon_20/25/26,
	rtd_outl(0xb8026504, 0x0000001B);	// Tcon_D ext_tcon_27/0/0,
	//rtd_outl(0xb8026508, 0x00000000);	// Tcon_G/H/I sel ext_tcon_0/0/0,
	//rtd_outl(0xb802650C, 0x00000000);	// Tcon_J/K sel ext_tcon_0/0,
	rtd_outl(0xb8026524, 0x00000000);	// SOE1/SOE2 LUT switch every 28 second is disbale,
						// CEDS POL in CTRL1(C6) for all lane is not invert,
						// CEDS POL2 in CTRL1(C12) for all lane is not invert,
	//rtd_outl(0xb8026528, 0x0000002A);	// DST register config value,
	//rtd_outl(0xb802653C, 0x00000015);	// CST register config value,
	//rtd_outl(0xb80266F0, 0x00000000);	// C3 register config value,
	//rtd_outl(0xb8026A60, 0x00000000);	// C4 register config value,
	//rtd_outl(0xb8026AA0, 0x00000000);	// C5 register config value,
	rtd_outl(0xb8026554, 0x000C1600);	// Lane0 : C1 register config value,
	rtd_outl(0xb802655C, 0x000C1600);	// Lane1 : C1 register config value,
	rtd_outl(0xb8026564, 0x000C1600);	// Lane2 : C1 register config value,
	rtd_outl(0xb802656C, 0x000C1600);	// Lane3 : C1 register config value,
	rtd_outl(0xb8026574, 0x000C1600);	// Lane4 : C1 register config value,
	rtd_outl(0xb802657C, 0x000C1600);	// Lane5 : C1 register config value,
	//rtd_outl(0xb8026584, 0x00000000);	// Lane6 : C1 register config value,
	//rtd_outl(0xb802658C, 0x00000000);	// Lane7 : C1 register config value,
	//rtd_outl(0xb8026594, 0x00000000);	// Lane8 : C1 register config value,
	//rtd_outl(0xb802659C, 0x00000000);	// Lane9 : C1 register config value,
	//rtd_outl(0xb80265A4, 0x00000000);	// Lane10: C1 register config value,
	//rtd_outl(0xb80265AC, 0x00000000);	// Lane11: C1 register config value,
	//rtd_outl(0xb8026624, 0x00000000);	// Lane0 : C2 register config value,
	//rtd_outl(0xb802662C, 0x00000000);	// Lane1 : C2 register config value,
	//rtd_outl(0xb8026634, 0x00000000);	// Lane2 : C2 register config value,
	//rtd_outl(0xb802663C, 0x00000000);	// Lane3 : C2 register config value,
	//rtd_outl(0xb8026644, 0x00000000);	// Lane4 : C2 register config value,
	//rtd_outl(0xb802664C, 0x00000000);	// Lane5 : C2 register config value,
	//rtd_outl(0xb8026654, 0x00000000);	// Lane6 : C2 register config value,
	//rtd_outl(0xb802665C, 0x00000000);	// Lane7 : C2 register config value,
	//rtd_outl(0xb8026664, 0x00000000);	// Lane8 : C2 register config value,
	//rtd_outl(0xb802666C, 0x00000000);	// Lane9 : C2 register config value,
	//rtd_outl(0xb8026674, 0x00000000);	// Lane10: C2 register config value,
	//rtd_outl(0xb802667C, 0x00000000);	// Lane11: C2 register config value,
	//rtd_outl(0xb80266F4, 0x00000000);	// Lane0 : C3 register config value,
	//rtd_outl(0xb80266FC, 0x00000000);	// Lane1 : C3 register config value,
	//rtd_outl(0xb8026704, 0x00000000);	// Lane2 : C3 register config value,
	//rtd_outl(0xb802670C, 0x00000000);	// Lane3 : C3 register config value,
	//rtd_outl(0xb8026714, 0x00000000);	// Lane4 : C3 register config value,
	//rtd_outl(0xb802671C, 0x00000000);	// Lane5 : C3 register config value,
	//rtd_outl(0xb8026724, 0x00000000);	// Lane6 : C3 register config value,
	//rtd_outl(0xb802672C, 0x00000000);	// Lane7 : C3 register config value,
	//rtd_outl(0xb8026734, 0x00000000);	// Lane8 : C3 register config value,
	//rtd_outl(0xb802673C, 0x00000000);	// Lane9 : C3 register config value,
	//rtd_outl(0xb8026744, 0x00000000);	// Lane10: C3 register config value,
	//rtd_outl(0xb802674C, 0x00000000);	// Lane11: C3 register config value,
	//rtd_outl(0xb8026450, 0x00000000);	// General propose LUT use 1 line cycle,
	//rtd_outl(0xb8026454, 0x00000000);	// General propose LUT for line 0~1,
	//rtd_outl(0xb8026458, 0x00000000);	// General propose LUT for line 2~3,
	//rtd_outl(0xb802645C, 0x00000000);	// General propose LUT for line 4~5,
	//rtd_outl(0xb8026460, 0x00000000);	// General propose LUT for line 6~7,

	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D02C, 0x00000002);	// Async FIFO use EPI Mode,
	rtd_outl(0xb802D030, 0x00000000);	// P/N Swap disable,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO disable,
	rtd_outl(0xb802D03C, 0x00030010);	// Async FIFO reset enable, adaptive reset, apply after 16-clock,
	rtd_outl(0xb802D060, 0xFFFFFFFF);	// Lane 0~3 pair assign,
	rtd_outl(0xb802D064, 0xFFFFFFFF);	// Lane 4~7 pair assign,
	rtd_outl(0xb802D068, 0xFF111213);	// Lane 8~11 pair assign,
	rtd_outl(0xb802D06C, 0x0E0F10FF);	// Lane 12~15 pair assign,
	rtd_outl(0xb802D070, 0xFFFFFFFF);	// Lane 16~19 pair assign,
	rtd_outl(0xb802D074, 0xFFFFFFFF);	// Lane 20~23 pair assign,
	rtd_outl(0xb802D078, 0xFFFFFFFF);	// Lane 24~27 pair assign,

	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080103);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(4),
	rtd_outl(0xb8000C0C, 0x8005E3B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000001);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(1), EPI_DIVM(14),
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000021);	// TXPLL use EPI feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F4C000);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C78, 0x00000100);	// CKIN_DIVN(3),

	//
	//rtd_outl(0xb8000D00, 0x77002815);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D10, 0x77002815);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D20, 0x77002815);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D30, 0x77002815);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D40, 0x77002815);	// Lane4 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D50, 0x77002815);	// Lane5 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D60, 0x77002815);	// Lane6 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D70, 0x77002815);	// Lane7 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D80, 0x77002815);	// Lane8 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D90, 0x66002815);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DA0, 0x66002815);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DB0, 0x66002815);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DC0, 0x66002815);	// Lane12: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DD0, 0x66002815);	// Lane13: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DE0, 0x66002815);	// Lane14: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000DF0, 0x77002815);	// Lane15: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E00, 0x77002815);	// Lane16: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E10, 0x77002815);	// Lane17: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E20, 0x77002815);	// Lane18: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E30, 0x77002815);	// Lane19: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E40, 0x77002815);	// Lane20: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E50, 0x77002815);	// Lane21: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E60, 0x77002815);	// Lane22: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E70, 0x77002815);	// Lane23: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E80, 0x77002815);	// Lane24: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E90, 0x77002815);	// Lane25: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000EA0, 0x77002815);	// Lane26: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000EB0, 0x77002815);	// Lane27: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),

	//
	rtd_outl(0xb8000D04, 0x44003006);	// Lane0 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D14, 0x44003006);	// Lane1 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D24, 0x44003006);	// Lane2 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D34, 0x44003006);	// Lane3 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D44, 0x44003006);	// Lane4 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D54, 0x44003006);	// Lane5 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D64, 0x44003006);	// Lane6 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D74, 0x44003006);	// Lane7 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D84, 0x44003006);	// Lane8 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D94, 0x44003006);	// Lane9 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DA4, 0x44003006);	// Lane10: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DB4, 0x44003006);	// Lane11: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DC4, 0x44003006);	// Lane12: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DD4, 0x44003006);	// Lane13: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DE4, 0x44003006);	// Lane14: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DF4, 0x44003006);	// Lane15: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E04, 0x44003006);	// Lane16: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E14, 0x44003006);	// Lane17: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E24, 0x44003006);	// Lane18: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E34, 0x44003006);	// Lane19: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E44, 0x44003006);	// Lane20: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E54, 0x44003006);	// Lane21: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E64, 0x44003006);	// Lane22: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E74, 0x44003006);	// Lane23: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E84, 0x44003006);	// Lane24: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E94, 0x44003006);	// Lane25: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000EA4, 0x44003006);	// Lane26: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000EB4, 0x44003006);	// Lane27: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),

	//
	rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DC8, 0x00000009);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DD8, 0x00000009);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DE8, 0x00000009);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DF8, 0x00000009);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E08, 0x00000009);	// Lane16: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E18, 0x00000009);	// Lane17: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E28, 0x00000009);	// Lane18: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E38, 0x00000009);	// Lane19: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),





	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) EPI Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x40000000);
	//
	// (8) EPI MAC Enable (Below Setting)
	rtd_part_outl(0xb802606C, 16, 16, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_outl(0xb8000CC0, 0x00007E00); //Lane 9~14 power enable

	//
	// (11) Panel Power Enable (SW Control),
	rtd_part_outl(0x1806023C, 31, 28, 0xF); 	// Pinshare LSADC4->GPIO
	rtd_outl(0x18061100, 0x40000001); 	      // LSADC4/ST_GPIO_29 DDR 1V5_1V2/PIV1V5 power
	rtd_outl(0x18061108, 0x40000001); 	      // LSADC4/ST_GPIO_29 DDR 1V5_1V2/PIV1V5 power
	rtd_outl(0x1801bd00, 0x08000081); 	// GPIO_06 (PANEL_EN)panel power control
	rtd_outl(0x1801bd18, 0x08000081); 	// GPIO_06 (PANEL_EN)panel power controlrtd_part_outl(0x18060238, 23, 20, 0xF); 	// Pinshare LSADC5-> GPIO
	rtd_outl(0x18061104, 0x00000009); 	// LSADC6/ST_GPIO_33 (BL_EN)backlight control
	rtd_outl(0x1806110C, 0x00000009); 	// LSADC6/ST_GPIO_33 (BL_EN)backlight control

	rtd_outl(0x1801bd00, 0x00000041); 	// GPIO_05(BL_ADJ) PWM control
	rtd_outl(0x1801bd18, 0x00000041); 	// GPIO_05(BL_ADJ) PWM control
}

void panel_epi_lc490egg_uhd60_6lane_tcon_setting(void)
{
	// Tcon Pinshare Setting,
	rtd_part_outl(0xb800088C, 31, 28, 0x9);		// gpio_75 for GST, use Tcon7,
	rtd_part_outl(0xb80008A4,  7,  4, 0xA);		// gpio_92 for MCLK, use Tcon24,
	rtd_part_outl(0xb80008A8,  7,  4, 0x9);		// gpio_96 for GCLK, use Tcon17,
	rtd_part_outl(0xb800088C, 23, 20, 0x9);		// gpio_76 for EO, use Tcon5,

	rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// GST, gpio_75, Tcon7,
	// Tcon6 (Frame Start Pulse),
	rtd_outl(0xb802D2D0, 0x00400040);		// H_start/H_end,
	rtd_outl(0xb802D2D4, 0x004E0052);		// V_start/V_end,
	rtd_outl(0xb802D2D8, 0x00000180);		// Control,
	// Tcon7 (Frame End Pulse),
	rtd_outl(0xb802D2F0, 0x02000200);		// H_start/H_end,
	rtd_outl(0xb802D2F4, 0x11431146);		// V_start/V_end,
	rtd_outl(0xb802D2F8, 0x00000182);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// MCLK, gpio_92, Tcon24,
	// Tocn23 (Line 2/4/6/...),
	rtd_outl(0xb802D4F0, 0x05340584);		// H_start/H_end,
	rtd_outl(0xb802D4F4, 0x00571143);		// V_start/V_end,
	rtd_outl(0xb802D4F8, 0x00000380);		// Control,
	rtd_outl(0xb802D4FC, 0x00020000);		// Across Line3 RP/HP,
	// Tcon24 (Line 1/3/5/...),
	rtd_outl(0xb802D510, 0x05340600);		// H_start/H_end,
	rtd_outl(0xb802D514, 0x00561143);		// V_start/V_end,
	rtd_outl(0xb802D518, 0x00000382);		// Control,
	rtd_outl(0xb802D51C, 0x00020000);		// Across Line3 RP/HP,


	////////////////////////////////////////////////////////////////////////////
	// GCLK, gpio_96, Tcon17,
	// Tcon14 (Frame End Pulse),
	rtd_outl(0xb802D3D0, 0x02000200);		// H_start/H_end,
	rtd_outl(0xb802D3D4, 0x113E1146);		// V_start/V_end,
	rtd_outl(0xb802D3D8, 0x00000180);		// Control,
	// Tcon15 (Line 2/4/6/...),
	rtd_outl(0xb802D3F0, 0x02000370);		// H_start/H_end,
	rtd_outl(0xb802D3F4, 0x0053113E);		// V_start/V_end,
	rtd_outl(0xb802D3F8, 0x00000382);		// Control,
	rtd_outl(0xb802D3FC, 0x00020000);		// Across Line3 RP/HP,
	// Tcon16 (Line 1/3/5/...),
	rtd_outl(0xb802D410, 0x02000370);		// H_start/H_end,
	rtd_outl(0xb802D414, 0x0054113E);		// V_start/V_end,
	rtd_outl(0xb802D418, 0x00000382);		// Control,
	rtd_outl(0xb802D41C, 0x00020000);		// Across Line3 RP/HP,
	// Tcon17 (Frame Start Pulse),
	rtd_outl(0xb802D430, 0x02000370);		// H_start/H_end,
	rtd_outl(0xb802D434, 0x00520052);		// V_start/V_end,
	rtd_outl(0xb802D438, 0x00000182);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// EO, gpio_76, Tcon5,
	// TCON4,
	rtd_outl(0xb802D290, 0x02000200);		// H_start/H_end,
	rtd_outl(0xb802D294, 0x11471147);		// V_start/V_end,
	rtd_outl(0xb802D298, 0x00000480);		// Control,
	rtd_outl(0xb802D2A0, 0x007D007D);		// Across Frame LP, Across Frame HP
	// Tcon5,
	rtd_outl(0xb802D2B0, 0x02BC02BC);		// H_start/H_end,
	rtd_outl(0xb802D2B4, 0x11471147);		// V_start/V_end,
	rtd_outl(0xb802D2B8, 0x00000483);		// Control,
	rtd_outl(0xb802D2C0, 0x007D007D);		// Across Frame LP, Across Frame HP


	////////////////////////////////////////////////////////////////////////////
	// POL, Tcon20,
	// Tcon19,
	rtd_outl(0xb802D470, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D474, 0x000008CA);		// V_start/V_end,
	rtd_outl(0xb802D478, 0x00000380);		// Control,
	rtd_outl(0xb802D47C, 0x00020001);		// Across Line 3 HP/RP,
	// Tcon20,
	rtd_outl(0xb802D490, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D494, 0x00010001);		// V_start/V_end,
	rtd_outl(0xb802D498, 0x00000480);		// Control,
	rtd_outl(0xb802D4A0, 0x00000000);		// Across Frame Period,


	////////////////////////////////////////////////////////////////////////////
	// GSP, Tcon25,
	// Tcon25,
	rtd_outl(0xb802D530, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D534, 0x00570058);		// V_start/V_end,
	rtd_outl(0xb802D538, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// Scrambler Enable, Tcon26,
	rtd_outl(0xb802D550, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D554, 0x00011150);		// V_start/V_end,
	rtd_outl(0xb802D558, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// Scrambler Reset, Tcon27,
	rtd_outl(0xb802D570, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D574, 0x00011150);		// V_start/V_end,
	rtd_outl(0xb802D578, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// DE (Tcon8, EO), for debug,
	//rtd_outl(0xb802D310, 0x00A30820);		// H_start/H_end,
	//rtd_outl(0xb802D314, 0x005A1139);		// V_start/V_end,
	//rtd_outl(0xb802D318, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// 1st Line DE (Tcon8, EO), for debug,
	//rtd_outl(0xb802D310, 0x00A30820);		// H_start/H_end,
	//rtd_outl(0xb802D314, 0x005A005A);		// V_start/V_end,
	//rtd_outl(0xb802D318, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////

	rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
	rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x01100040);	// SFG path enable, Common fifo use sfg_clk, 30-bit Mode, SFG out disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x02FFFFFF);	// PIF_Clock = Dclk/3, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 8n+0/8n+1/8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00000000);	// Line 8n+4/8n+5/8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x089D002D);	// DV_Den_end,DV_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D954, 0x10180118);	// DH_Den_end,DH_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D958, 0x057F112F);	// DV_width,Dh_width,Dh_total (follow DTG timing)
	rtd_outl(0xb802D964, 0x10000585);	// SFG DRD Mode, 1.5 packet mode disable, 1P mode, H-Flip enable, 6-SEG, 6-Port,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	//rtd_outl(0xb802DB00, 0x00000000);	// SEG12/SEG13 Start Address,
	//rtd_outl(0xb802DB04, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D980, 0x03C0F03C);	// Gray dummy line data0 (L15 in 8-bit),
	rtd_outl(0xb802D984, 0x00000000);	// Gray dummy line data1 (L0),
	//rtd_outl(0xb802D94C, 0x00000000);	// Gray dummy line data2,
	//rtd_outl(0xb802DA28, 0x00000000);	// Gray dummy line data3,
	rtd_outl(0xb802DA24, 0x00010000);	// front dummuy line use gray data0, back dummuy line use gray data1,
	rtd_outl(0xb802D988, 0x40100090);	// Bypass SFG disable, Auto config enable, downsample disable,
						// front_dummy_line_num(2), back_dummy_line_num(1),
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00000000);	// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00000000);	// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00000000);	// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00000000);	// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD Data Mapping,
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD Data Mapping,
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD Data Mapping,
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD Data Mapping,
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD Data Mapping,
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD Data Mapping,
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD Data Mapping,
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD Data Mapping,
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD Data Mapping,
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD Data Mapping,
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD Data Mapping,
	rtd_outl(0xb802DACC, 0x16161616);	// DRD Data Mapping,
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD Data Mapping,
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD Data Mapping,
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD Data Mapping,
	rtd_outl(0xb802DADC, 0x07070707);	// DRD Data Mapping,
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD Data Mapping,
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD Data Mapping,
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD Data Mapping,
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD Data Mapping,
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD Data Mapping,
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD Data Mapping,
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD Data Mapping,
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD Data Mapping,
	rtd_outl(0xb802DB68, 0x00000000);	// ext_num setting for case_a line7~0,
	rtd_outl(0xb802DB6C, 0x00000000);	// ext_num setting for case_b line7~0,
	//rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E19);	// SFG Pattern Gen. Enable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	//rtd_outl(0xb802DC14, 0x00000000);	// SFG Pattern Gen. gray_data0 and gray_data1 for manmal pattern,
	//rtd_outl(0xb802DC18, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+0,
	//rtd_outl(0xb802DC1C, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+1,
	//rtd_outl(0xb802DC20, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+2,
	//rtd_outl(0xb802DC24, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+3,
	// Merlin-serial FIFO start
	//rtd_outl(0xb802DC94, 0x20000000);	// Aysnc FIFO disble, Async FIFO use EPI Mode,
	//rtd_outl(0xb802DC98, 0x9C00FFFF);	// 15~0 Lane_en
	//rtd_outl(0xb802DC9C, 0x45012FFF);	// Lane 7~0 pair assign,  2K using lane2~lane14 for LSphy
	//rtd_outl(0xb802DCA0, 0xFFFFFFF3);	// Lane 15~8 pair assign,  2K using lane2~lane14 for LSphy
	//rtd_outl(0xb802DCC8, 0x000001F8);	// VIDEO_OSD_SEL 16lane video, phy lane8~lane3 enable
	//rtd_outl(0xb802DCD0, 0x00000000);	// P/N Swap enable ,
	// Merlin-serial FIFO end
	rtd_part_outl(0xb802D900, 11, 11, 0x1);	// SFG out enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCK Pin share
	//---------------------------------------------------------------------------------------------------------------------------------

	rtd_maskl(0xb80008A4, 0x0F0FFFFF, 0x00500000);	// GPIO_90 pinshare to EPI_LOCK_SRC0,
	rtd_maskl(0xb8000CBC, 0xFFFFFFFC, 0x00000000);	// VEPI MAC use EPI_LOCK_SRC0,
	rtd_maskl(0xb80008BC, 0x7FFFFFFF, 0x80000000);	// GPIO_90 use 1.8V GPI,

	//---------------------------------------------------------------------------------------------------------------------------------
	//EPI MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb8026000, 0x00000004);	// Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026060, 0x08000002);	// EPI 3.05Gbps 8-bit mode,
	rtd_outl(0xb8026064, 0x80000000);	// EPI reset disable, CST/C3/C4/C5/DST packet disable, EPI lock HW mode,
	rtd_outl(0xb802606C, 0x40603000);	// EPI disable, ext_num unit is sub-pixel, 6-port EPI, packet delimiter,
	//rtd_outl(0xb8026070, 0x00000645);	// CMPI CMD/DATA delimiter, run length conding delimiter,
	//rtd_outl(0xb8026080, 0x00000000);	// Dummy line color 0 (L0) for CMPI,
	//rtd_outl(0xb8026084, 0x00000000);	// Dummy line color 1 (L0) for CMPI,
	//rtd_outl(0xb8026088, 0x00000000);	// Dummy line color 2 (L0) for CMPI,
	//rtd_outl(0xb802608C, 0x00000000);	// Dummy line color 3 (L0) for CMPI,
	rtd_outl(0xb8026090, 0x000003F3);	// CRC Enable, select lane 0~5 to CRC,
	rtd_outl(0xb802609C, 0x00000000);	// EPI Data from SFG, EPI packet data setting,
	rtd_outl(0xb80260A4, 0x00000071);	// INV4 LUT use 8 line cycle, POD2_INV4 initial phase select bypass (2'b00),
	rtd_outl(0xb80260A8, 0x500AAFF5);	// INV4 LUT for line 0~8,
	//rtd_outl(0xb80260AC, 0x00000000);	// INV4 LUT for line 9~16,
	//rtd_outl(0xb8026110, 0x00000000);	// CMPI RLC Function for 10bit mode disable,
	//rtd_outl(0xb8026114, 0x00000000);	// CMPI CDR type mode select,
	//rtd_outl(0xb8026118, 0x00000000);	// CMPI CDR clock training2 insert in type1 and type2,
	rtd_outl(0xb802617C, 0x00000023);	// Scrambler reset/enable control by tcon_c/tcon_d,
	rtd_outl(0xb8026180, 0x00000003);	// EPI_SCR8 enable, HVBP_SCR disable, EDGE_SCR disable,
	rtd_outl(0xb8026184, 0x00FFFFFF);	// EPI_SCR8 initial value,
	//rtd_outl(0xb8026188, 0x00000002);	// EPI_SCR10 disable,
	//rtd_outl(0xb802618C, 0x000FFFFF);	// EPI_SCR10 initial value,
	//rtd_outl(0xb8026190, 0x00000000);	// CMPI_SCR8 disable,
	//rtd_outl(0xb8026194, 0x00000FFF);	// CMPI_SCR8 initial value,
	//rtd_outl(0xb8026198, 0x00000000);	// CMPI_SCR10 disable,
	//rtd_outl(0xb802619C, 0x000003FF);	// CMPI_SCR10 initial value,
	//rtd_outl(0xb80261A0, 0x00000000);	// CMPI F/M/B color select, Pgamma for CMPI disable,
	//rtd_outl(0xb80261A4, 0x00000000);	// CMPI Pgamma CST packet,
	//rtd_outl(0xb80261A8, 0x00000000);	// CMPI Pgamma C1 packet,
	//rtd_outl(0xb80261AC, 0x00000000);	// CMPI Pgamma C2 packet,
	//rtd_outl(0xb80261B0, 0x00000000);	// CMPI Pgamma C3 packet,
	//rtd_outl(0xb8026300, 0x00000000);	// CMPI Pgamma C4 packet,
	//rtd_outl(0xb8026304, 0x00000000);	// CMPI Pgamma C5 packet,
	//rtd_outl(0xb80261B4, 0x00000000);	// CMPI Pgamma PG_ST packet,
	//rtd_outl(0xb80261B8, 0x00000000);	// CMPI Pgamma Data0 packet,
	//rtd_outl(0xb80261BC, 0x00000000);	// CMPI Pgamma Data1 packet,
	//rtd_outl(0xb80261C0, 0x00000000);	// CMPI Pgamma Data2 packet,
	//rtd_outl(0xb80261C4, 0x00000000);	// CMPI Pgamma Data3 packet,
	//rtd_outl(0xb80261C8, 0x00000000);	// CMPI Pgamma Data4 packet,
	//rtd_outl(0xb80261CC, 0x00000000);	// CMPI Pgamma Data5 packet,
	//rtd_outl(0xb80261D0, 0x00000000);	// CMPI Pgamma Data6 packet,
	//rtd_outl(0xb80261D4, 0x00000000);	// CMPI Pgamma Data7 packet,
	//rtd_outl(0xb80261D8, 0x00000000);	// CMPI Pgamma Data8 packet,
	//rtd_outl(0xb80261DC, 0x00000000);	// CMPI Pgamma Data9 packet,
	//rtd_outl(0xb8026308, 0x00000000);	// CMPI Pgamma Data10 packet,
	//rtd_outl(0xb802630C, 0x00000000);	// CMPI Pgamma Data11 packet,
	//rtd_outl(0xb8026310, 0x00000000);	// CMPI Pgamma Data12 packet,
	//rtd_outl(0xb8026314, 0x00000000);	// CMPI Pgamma Data13 packet,
	//rtd_outl(0xb8026318, 0x00000000);	// CMPI Pgamma Data14 packet,
	//rtd_outl(0xb802631C, 0x00000000);	// CMPI Pgamma Data15 packet,
	//rtd_outl(0xb8026320, 0x00000000);	// CMPI Pgamma Data16 packet,
	//rtd_outl(0xb8026324, 0x00000000);	// CMPI Pgamma Data17 packet,
	//rtd_outl(0xb8026328, 0x00000000);	// CMPI Pgamma Data18 packet,
	//rtd_outl(0xb802632C, 0x00000000);	// CMPI Pgamma Data19 packet,
	//rtd_outl(0xb8026330, 0x00000000);	// CMPI Pgamma Data20 packet,
	//rtd_outl(0xb8026334, 0x00000000);	// CMPI Pgamma Data21 packet,
	//rtd_outl(0xb8026338, 0x00000000);	// CMPI Pgamma Data22 packet,
	//rtd_outl(0xb802633C, 0x00000000);	// CMPI Pgamma Data23 packet,
	//rtd_outl(0xb8026340, 0x00000000);	// CMPI Pgamma Data24 packet,
	//rtd_outl(0xb8026344, 0x00000000);	// CMPI Pgamma Data25 packet,
	//rtd_outl(0xb8026348, 0x00000000);	// CMPI Pgamma Data26 packet,
	//rtd_outl(0xb802634C, 0x00000000);	// CMPI Pgamma Data27 packet,
	//rtd_outl(0xb8026350, 0x00000000);	// CMPI Pgamma Data28 packet,
	//rtd_outl(0xb8026354, 0x00000000);	// CMPI Pgamma Data29 packet,
	//rtd_outl(0xb8026358, 0x00000000);	// CMPI Pgamma Data30 packet,
	//rtd_outl(0xb802635C, 0x00000000);	// CMPI Pgamma Data31 packet,
	//rtd_outl(0xb8026360, 0x00000000);	// CMPI Pgamma Data32 packet,
	//rtd_outl(0xb8026364, 0x00000000);	// CMPI Pgamma Data33 packet,
	//rtd_outl(0xb8026368, 0x00000000);	// CMPI Pgamma Data34 packet,
	//rtd_outl(0xb802636C, 0x00000000);	// CMPI Pgamma Data35 packet,
	//rtd_outl(0xb8026370, 0x00000000);	// CMPI Pgamma Data36 packet,
	//rtd_outl(0xb8026374, 0x00000000);	// CMPI Pgamma Data37 packet,
	//rtd_outl(0xb8026378, 0x00000000);	// CMPI Pgamma Data38 packet,
	//rtd_outl(0xb802637C, 0x00000000);	// CMPI Pgamma Data39 packet,
	//rtd_outl(0xb8026400, 0x00000000);	// CMPI Pgamma Data40 packet,
	//rtd_outl(0xb8026404, 0x00000000);	// CMPI Pgamma Data41 packet,
	//rtd_outl(0xb8026408, 0x00000000);	// CMPI Pgamma Data42 packet,
	//rtd_outl(0xb802640C, 0x00000000);	// CMPI Pgamma Data43 packet,
	//rtd_outl(0xb8026410, 0x00000000);	// CMPI Pgamma Data44 packet,
	//rtd_outl(0xb8026414, 0x00000000);	// CMPI Pgamma Data45 packet,
	//rtd_outl(0xb8026418, 0x00000000);	// CMPI Pgamma Data46 packet,
	//rtd_outl(0xb802641C, 0x00000000);	// CMPI Pgamma Data47 packet,
	//rtd_outl(0xb8026420, 0x00000000);	// CMPI Pgamma Data48 packet,
	//rtd_outl(0xb8026424, 0x00000000);	// CMPI Pgamma Data49 packet,
	//rtd_outl(0xb8026428, 0x00000000);	// CMPI Pgamma Data50 packet,
	//rtd_outl(0xb802642C, 0x00000000);	// CMPI Pgamma Data51 packet,
	//rtd_outl(0xb8026430, 0x00000000);	// CMPI Pgamma Data52 packet,
	//rtd_outl(0xb8026434, 0x00000000);	// CMPI Pgamma Data53 packet,
	//rtd_outl(0xb8026438, 0x00000000);	// CMPI Pgamma Data54 packet,
	//rtd_outl(0xb802643C, 0x00000000);	// CMPI Pgamma Data55 packet,
	//rtd_outl(0xb8026440, 0x00000000);	// CMPI Pgamma Data56 packet,
	//rtd_outl(0xb8026444, 0x00000000);	// CMPI Pgamma Data57 packet,
	//rtd_outl(0xb8026448, 0x00000000);	// CMPI Pgamma Data58 packet,
	//rtd_outl(0xb802644C, 0x00000000);	// CMPI Pgamma Data59 packet,
	//rtd_outl(0xb80261E0, 0x00000000);	// CMPI Pgamma PG_END packet,
	rtd_outl(0xb80261E4, 0x0000003F);	// EPI MAC output Port 0~5 transmit to APHY, others disable,
	rtd_outl(0xb80261E8, 0x0000003F);	// EPI Port 0~5 extend subpixel use sfg case_a,
	rtd_outl(0xb80261EC, 0x0000003F);	// EPI constant_update_mode : EPI Port 0~5 update by TDM (for power save),
	rtd_outl(0xb80263F8, 0x00000000);	// EPI update first ctrl packet time : hs_den_io_dist + den_length (compute by hw),
	rtd_outl(0xb80263FC, 0x007D00FB);	// LOCK debounce enable and setting,
	rtd_outl(0xb80261F4, 0x0000000F);	// Check SFG output timing enable,
	rtd_outl(0xb80261FC, 0x0000000E);	// SOE LUT use 4-line repeat, SOE LUT apply to C2[17:0],
	rtd_outl(0xb8026200, 0x00007936);	// SOE line 0 LUT for lane 0,
	rtd_outl(0xb8026204, 0x00007936);	// SOE line 1 LUT for lane 0,
	rtd_outl(0xb8026208, 0x00007936);	// SOE line 2 LUT for lane 0,
	rtd_outl(0xb802620C, 0x00007936);	// SOE line 3 LUT for lane 0,
	rtd_outl(0xb8026210, 0x00007937);	// SOE line 0 LUT for lane 1,
	rtd_outl(0xb8026214, 0x00007937);	// SOE line 1 LUT for lane 1,
	rtd_outl(0xb8026218, 0x00007937);	// SOE line 2 LUT for lane 1,
	rtd_outl(0xb802621C, 0x00007937);	// SOE line 3 LUT for lane 1,
	rtd_outl(0xb8026220, 0x00007938);	// SOE line 0 LUT for lane 2,
	rtd_outl(0xb8026224, 0x00007938);	// SOE line 1 LUT for lane 2,
	rtd_outl(0xb8026228, 0x00007938);	// SOE line 2 LUT for lane 2,
	rtd_outl(0xb802622C, 0x00007938);	// SOE line 3 LUT for lane 2,
	rtd_outl(0xb8026230, 0x00007938);	// SOE line 0 LUT for lane 3,
	rtd_outl(0xb8026234, 0x00007938);	// SOE line 1 LUT for lane 3,
	rtd_outl(0xb8026238, 0x00007938);	// SOE line 2 LUT for lane 3,
	rtd_outl(0xb802623C, 0x00007938);	// SOE line 3 LUT for lane 3,
	rtd_outl(0xb8026240, 0x00007937);	// SOE line 0 LUT for lane 4,
	rtd_outl(0xb8026244, 0x00007937);	// SOE line 1 LUT for lane 4,
	rtd_outl(0xb8026248, 0x00007937);	// SOE line 2 LUT for lane 4,
	rtd_outl(0xb802624C, 0x00007937);	// SOE line 3 LUT for lane 4,
	rtd_outl(0xb8026250, 0x00007936);	// SOE line 0 LUT for lane 5,
	rtd_outl(0xb8026254, 0x00007936);	// SOE line 1 LUT for lane 5,
	rtd_outl(0xb8026258, 0x00007936);	// SOE line 2 LUT for lane 5,
	rtd_outl(0xb802625C, 0x00007936);	// SOE line 3 LUT for lane 5,
	//rtd_outl(0xb8026260, 0x00000000);	// SOE line 0 LUT for lane 6,
	//rtd_outl(0xb8026264, 0x00000000);	// SOE line 1 LUT for lane 6,
	//rtd_outl(0xb8026268, 0x00000000);	// SOE line 2 LUT for lane 6,
	//rtd_outl(0xb802626C, 0x00000000);	// SOE line 3 LUT for lane 6,
	//rtd_outl(0xb8026270, 0x00000000);	// SOE line 0 LUT for lane 7,
	//rtd_outl(0xb8026274, 0x00000000);	// SOE line 1 LUT for lane 7,
	//rtd_outl(0xb8026278, 0x00000000);	// SOE line 2 LUT for lane 7,
	//rtd_outl(0xb802627C, 0x00000000);	// SOE line 3 LUT for lane 7,
	//rtd_outl(0xb8026280, 0x00000000);	// SOE line 0 LUT for lane 8,
	//rtd_outl(0xb8026284, 0x00000000);	// SOE line 1 LUT for lane 8,
	//rtd_outl(0xb8026288, 0x00000000);	// SOE line 2 LUT for lane 8,
	//rtd_outl(0xb802628C, 0x00000000);	// SOE line 3 LUT for lane 8,
	//rtd_outl(0xb8026290, 0x00000000);	// SOE line 0 LUT for lane 9,
	//rtd_outl(0xb8026294, 0x00000000);	// SOE line 1 LUT for lane 9,
	//rtd_outl(0xb8026298, 0x00000000);	// SOE line 2 LUT for lane 9,
	//rtd_outl(0xb802629C, 0x00000000);	// SOE line 3 LUT for lane 9,
	//rtd_outl(0xb80262A0, 0x00000000);	// SOE line 0 LUT for lane 10,
	//rtd_outl(0xb80262A4, 0x00000000);	// SOE line 1 LUT for lane 10,
	//rtd_outl(0xb80262A8, 0x00000000);	// SOE line 2 LUT for lane 10,
	//rtd_outl(0xb80262AC, 0x00000000);	// SOE line 3 LUT for lane 10,
	//rtd_outl(0xb80262B0, 0x00000000);	// SOE line 0 LUT for lane 11,
	//rtd_outl(0xb80262B4, 0x00000000);	// SOE line 1 LUT for lane 11,
	//rtd_outl(0xb80262B8, 0x00000000);	// SOE line 2 LUT for lane 11,
	//rtd_outl(0xb80262BC, 0x00000000);	// SOE line 3 LUT for lane 11,
	//rtd_outl(0xb8026380, 0x00000000);	// DST(C4~C0) MUX use register config,
	//rtd_outl(0xb8026384, 0x00000000);	// DST(C9~C5) MUX use register config,
	//rtd_outl(0xb8026388, 0x00000000);	// DST(C14~C10) MUX use register config,
	//rtd_outl(0xb802638C, 0x00000000);	// DST(C19~C15) MUX use register config,
	//rtd_outl(0xb8026390, 0x00000000);	// DST(C24~C20) MUX use register config,
	//rtd_outl(0xb8026394, 0x00000000);	// DST(C29~C25) MUX use register config,
	//rtd_outl(0xb8026398, 0x00000000);	// CST(C4~C0) MUX use register config,
	//rtd_outl(0xb802639C, 0x00000000);	// CST(C9~C5) MUX use register config,
	//rtd_outl(0xb80263A0, 0x00000000);	// CST(C14~C10) MUX use register config,
	//rtd_outl(0xb80263A4, 0x00000000);	// CST(C19~C15) MUX use register config,
	//rtd_outl(0xb80263A8, 0x00000000);	// CST(C24~C20) MUX use register config,
	//rtd_outl(0xb80263AC, 0x00000000);	// CST(C29~C25) MUX use register config,
	rtd_outl(0xb80263B0, 0x00000000);	// C1(C4~C0) MUX use register config,
	rtd_outl(0xb80263B4, 0x00000210);	// C1(C9~C5) MUX use register config (C6/C7 use Tcon_A/B),
	rtd_outl(0xb80263B8, 0x0009A000);	// C1(C14~C10) MUX use register config (C13/C14 use INV4_1/2 LUT),
	rtd_outl(0xb80263BC, 0x00000078);	// C1(C19~C15) MUX use register config (C15/C16 use INV4_3/4 LUT),
	rtd_outl(0xb80263C0, 0x00000000);	// C1(C24~C20) MUX use register config,
	rtd_outl(0xb80263C4, 0x00000000);	// C1(C29~C25) MUX use register config,
	rtd_outl(0xb80263C8, 0x00000000);	// C2(C4~C0) MUX use register config,
	rtd_outl(0xb80263CC, 0x00000000);	// C2(C9~C5) MUX use register config,
	rtd_outl(0xb80263D0, 0x00000000);	// C2(C14~C10) MUX use register config,
	rtd_outl(0xb80263D4, 0x00033000);	// C2(C19~C15) MUX use register config (C18/C19 use Tcon_C/C),
	rtd_outl(0xb80263D8, 0x00004443);	// C2(C24~C20) MUX use register config (C20/C21/C22/C23 use Tcon_C/D/D/D),
	rtd_outl(0xb80263DC, 0x00000000);	// C2(C29~C25) MUX use register config,
	//rtd_outl(0xb80263E0, 0x00000000);	// C3(C4~C0) MUX use register config,
	//rtd_outl(0xb80263E4, 0x00000000);	// C3(C9~C5) MUX use register config,
	//rtd_outl(0xb80263E8, 0x00000000);	// C3(C14~C10) MUX use register config,
	//rtd_outl(0xb80263EC, 0x00000000);	// C3(C19~C15) MUX use register config,
	//rtd_outl(0xb80263F0, 0x00000000);	// C3(C24~C20) MUX use register config,
	//rtd_outl(0xb80263F4, 0x00000000);	// C3(C29~C25) MUX use register config,
	rtd_outl(0xb8026500, 0x001A1914);	// Tcon_A/B/C sel ext_tcon_20/25/26,
	rtd_outl(0xb8026504, 0x0000001B);	// Tcon_D ext_tcon_27/0/0,
	//rtd_outl(0xb8026508, 0x00000000);	// Tcon_G/H/I sel ext_tcon_0/0/0,
	//rtd_outl(0xb802650C, 0x00000000);	// Tcon_J/K sel ext_tcon_0/0,
	rtd_outl(0xb8026524, 0x00000000);	// SOE1/SOE2 LUT switch every 28 second is disbale,
						// CEDS POL in CTRL1(C6) for all lane is not invert,
						// CEDS POL2 in CTRL1(C12) for all lane is not invert,
	//rtd_outl(0xb8026528, 0x0000002A);	// DST register config value,
	//rtd_outl(0xb802653C, 0x00000015);	// CST register config value,
	//rtd_outl(0xb80266F0, 0x00000000);	// C3 register config value,
	//rtd_outl(0xb8026A60, 0x00000000);	// C4 register config value,
	//rtd_outl(0xb8026AA0, 0x00000000);	// C5 register config value,
	rtd_outl(0xb8026554, 0x000C1600);	// Lane0 : C1 register config value,
	rtd_outl(0xb802655C, 0x000C1600);	// Lane1 : C1 register config value,
	rtd_outl(0xb8026564, 0x000C1600);	// Lane2 : C1 register config value,
	rtd_outl(0xb802656C, 0x001C1600);	// Lane3 : C1 register config value,
	rtd_outl(0xb8026574, 0x001C1600);	// Lane4 : C1 register config value,
	rtd_outl(0xb802657C, 0x001C1600);	// Lane5 : C1 register config value,
	//rtd_outl(0xb8026584, 0x00000000);	// Lane6 : C1 register config value,
	//rtd_outl(0xb802658C, 0x00000000);	// Lane7 : C1 register config value,
	//rtd_outl(0xb8026594, 0x00000000);	// Lane8 : C1 register config value,
	//rtd_outl(0xb802659C, 0x00000000);	// Lane9 : C1 register config value,
	//rtd_outl(0xb80265A4, 0x00000000);	// Lane10: C1 register config value,
	//rtd_outl(0xb80265AC, 0x00000000);	// Lane11: C1 register config value,
	//rtd_outl(0xb8026624, 0x00000000);	// Lane0 : C2 register config value,
	//rtd_outl(0xb802662C, 0x00000000);	// Lane1 : C2 register config value,
	//rtd_outl(0xb8026634, 0x00000000);	// Lane2 : C2 register config value,
	//rtd_outl(0xb802663C, 0x00000000);	// Lane3 : C2 register config value,
	//rtd_outl(0xb8026644, 0x00000000);	// Lane4 : C2 register config value,
	//rtd_outl(0xb802664C, 0x00000000);	// Lane5 : C2 register config value,
	//rtd_outl(0xb8026654, 0x00000000);	// Lane6 : C2 register config value,
	//rtd_outl(0xb802665C, 0x00000000);	// Lane7 : C2 register config value,
	//rtd_outl(0xb8026664, 0x00000000);	// Lane8 : C2 register config value,
	//rtd_outl(0xb802666C, 0x00000000);	// Lane9 : C2 register config value,
	//rtd_outl(0xb8026674, 0x00000000);	// Lane10: C2 register config value,
	//rtd_outl(0xb802667C, 0x00000000);	// Lane11: C2 register config value,
	//rtd_outl(0xb80266F4, 0x00000000);	// Lane0 : C3 register config value,
	//rtd_outl(0xb80266FC, 0x00000000);	// Lane1 : C3 register config value,
	//rtd_outl(0xb8026704, 0x00000000);	// Lane2 : C3 register config value,
	//rtd_outl(0xb802670C, 0x00000000);	// Lane3 : C3 register config value,
	//rtd_outl(0xb8026714, 0x00000000);	// Lane4 : C3 register config value,
	//rtd_outl(0xb802671C, 0x00000000);	// Lane5 : C3 register config value,
	//rtd_outl(0xb8026724, 0x00000000);	// Lane6 : C3 register config value,
	//rtd_outl(0xb802672C, 0x00000000);	// Lane7 : C3 register config value,
	//rtd_outl(0xb8026734, 0x00000000);	// Lane8 : C3 register config value,
	//rtd_outl(0xb802673C, 0x00000000);	// Lane9 : C3 register config value,
	//rtd_outl(0xb8026744, 0x00000000);	// Lane10: C3 register config value,
	//rtd_outl(0xb802674C, 0x00000000);	// Lane11: C3 register config value,
	//rtd_outl(0xb8026450, 0x00000000);	// General propose LUT use 1 line cycle,
	//rtd_outl(0xb8026454, 0x00000000);	// General propose LUT for line 0~1,
	//rtd_outl(0xb8026458, 0x00000000);	// General propose LUT for line 2~3,
	//rtd_outl(0xb802645C, 0x00000000);	// General propose LUT for line 4~5,
	//rtd_outl(0xb8026460, 0x00000000);	// General propose LUT for line 6~7,

	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D02C, 0x00000002);	// Async FIFO use EPI Mode,
	rtd_outl(0xb802D030, 0x00000000);	// P/N Swap disable,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO disable,
	rtd_outl(0xb802D03C, 0x00030010);	// Async FIFO reset enable, adaptive reset, apply after 16-clock,
	rtd_outl(0xb802D060, 0xFFFFFFFF);	// Lane 0~3 pair assign,
	rtd_outl(0xb802D064, 0xFFFFFFFF);	// Lane 4~7 pair assign,
	rtd_outl(0xb802D068, 0xFF111213);	// Lane 8~11 pair assign,
	rtd_outl(0xb802D06C, 0x0E0F10FF);	// Lane 12~15 pair assign,
	rtd_outl(0xb802D070, 0xFFFFFFFF);	// Lane 16~19 pair assign,
	rtd_outl(0xb802D074, 0xFFFFFFFF);	// Lane 20~23 pair assign,
	rtd_outl(0xb802D078, 0xFFFFFFFF);	// Lane 24~27 pair assign,

	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080103);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(4),
	rtd_outl(0xb8000C0C, 0x8005E3B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000001);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(1), EPI_DIVM(14),
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000021);	// TXPLL use EPI feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F4C000);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C78, 0x00000100);	// CKIN_DIVN(3),

	//
	//rtd_outl(0xb8000D00, 0x77002815);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D10, 0x77002815);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D20, 0x77002815);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D30, 0x77002815);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D40, 0x77002815);	// Lane4 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D50, 0x77002815);	// Lane5 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D60, 0x77002815);	// Lane6 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D70, 0x77002815);	// Lane7 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D80, 0x77002815);	// Lane8 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D90, 0x66002815);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DA0, 0x66002815);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DB0, 0x66002815);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DC0, 0x66002815);	// Lane12: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DD0, 0x66002815);	// Lane13: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DE0, 0x66002815);	// Lane14: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000DF0, 0x77002815);	// Lane15: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E00, 0x77002815);	// Lane16: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E10, 0x77002815);	// Lane17: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E20, 0x77002815);	// Lane18: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E30, 0x77002815);	// Lane19: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E40, 0x77002815);	// Lane20: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E50, 0x77002815);	// Lane21: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E60, 0x77002815);	// Lane22: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E70, 0x77002815);	// Lane23: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E80, 0x77002815);	// Lane24: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E90, 0x77002815);	// Lane25: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000EA0, 0x77002815);	// Lane26: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000EB0, 0x77002815);	// Lane27: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),

	//
	rtd_outl(0xb8000D04, 0x44003006);	// Lane0 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D14, 0x44003006);	// Lane1 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D24, 0x44003006);	// Lane2 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D34, 0x44003006);	// Lane3 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D44, 0x44003006);	// Lane4 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D54, 0x44003006);	// Lane5 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D64, 0x44003006);	// Lane6 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D74, 0x44003006);	// Lane7 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D84, 0x44003006);	// Lane8 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D94, 0x44003006);	// Lane9 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DA4, 0x44003006);	// Lane10: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DB4, 0x44003006);	// Lane11: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DC4, 0x44003006);	// Lane12: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DD4, 0x44003006);	// Lane13: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DE4, 0x44003006);	// Lane14: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DF4, 0x44003006);	// Lane15: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E04, 0x44003006);	// Lane16: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E14, 0x44003006);	// Lane17: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E24, 0x44003006);	// Lane18: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E34, 0x44003006);	// Lane19: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E44, 0x44003006);	// Lane20: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E54, 0x44003006);	// Lane21: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E64, 0x44003006);	// Lane22: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E74, 0x44003006);	// Lane23: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E84, 0x44003006);	// Lane24: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E94, 0x44003006);	// Lane25: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000EA4, 0x44003006);	// Lane26: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000EB4, 0x44003006);	// Lane27: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),

	//
	rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DC8, 0x00000009);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DD8, 0x00000009);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DE8, 0x00000009);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DF8, 0x00000009);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E08, 0x00000009);	// Lane16: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E18, 0x00000009);	// Lane17: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E28, 0x00000009);	// Lane18: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E38, 0x00000009);	// Lane19: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),





	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) EPI Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x40000000);
	//
	// (8) EPI MAC Enable (Below Setting)
	rtd_part_outl(0xb802606C, 16, 16, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_outl(0xb8000CC0, 0x00007E00); //Lane 9~14 power enable

	//
	// (11) Panel Power Enable (SW Control),
	rtd_part_outl(0x1806023C, 31, 28, 0xF); 	// Pinshare LSADC4->GPIO
	rtd_outl(0x18061100, 0x40000001); 	      // LSADC4/ST_GPIO_29 DDR 1V5_1V2/PIV1V5 power
	rtd_outl(0x18061108, 0x40000001); 	      // LSADC4/ST_GPIO_29 DDR 1V5_1V2/PIV1V5 power
	rtd_outl(0x1801bd00, 0x08000081); 	// GPIO_06 (PANEL_EN)panel power control
	rtd_outl(0x1801bd18, 0x08000081); 	// GPIO_06 (PANEL_EN)panel power control
	rtd_part_outl(0x18060238, 23, 20, 0xF); 	// Pinshare LSADC5-> GPIO
	rtd_outl(0x18061104, 0x00000009); 	// LSADC6/ST_GPIO_33 (BL_EN)backlight control
	rtd_outl(0x1806110C, 0x00000009); 	// LSADC6/ST_GPIO_33 (BL_EN)backlight control

	rtd_outl(0x1801bd00, 0x00000041); 	// GPIO_05(BL_ADJ) PWM control
	rtd_outl(0x1801bd18, 0x00000041); 	// GPIO_05(BL_ADJ) PWM control
}

void panel_epi_v18_65inch_uhd60_8lane_tcon_setting(void)
{
	// Tcon Pinshare Setting,
	rtd_part_outl(0xb800088C, 31, 28, 0x9);		// gpio_75 for GST, use Tcon7,
	rtd_part_outl(0xb80008A4,  7,  4, 0xA);		// gpio_92 for MCLK, use Tcon24,
	rtd_part_outl(0xb80008A8,  7,  4, 0x9);		// gpio_96 for GCLK, use Tcon17,
	rtd_part_outl(0xb800088C, 23, 20, 0x9);		// gpio_76 for EO, use Tcon5,

	rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// GST, gpio_75, Tcon7,
	// Tcon6 (Frame Start Pulse),
	rtd_outl(0xb802D2D0, 0x08550855);		// H_start/H_end,
	rtd_outl(0xb802D2D4, 0x004D0051);		// V_start/V_end,
	rtd_outl(0xb802D2D8, 0x00000180);		// Control,
	// Tcon7 (Frame End Pulse),
	rtd_outl(0xb802D2F0, 0x02F402F4);		// H_start/H_end,
	rtd_outl(0xb802D2F4, 0x11431146);		// V_start/V_end,
	rtd_outl(0xb802D2F8, 0x00000182);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// MCLK, gpio_92, Tcon24,
	// Tocn23 (Line 2/4/6/...),
	rtd_outl(0xb802D4F0, 0x04E0058B);		// H_start/H_end,
	rtd_outl(0xb802D4F4, 0x00571142);		// V_start/V_end,
	rtd_outl(0xb802D4F8, 0x00000380);		// Control,
	rtd_outl(0xb802D4FC, 0x00020000);		// Across Line3 RP/HP,
	// Tcon24 (Line 1/3/5/...),
	rtd_outl(0xb802D510, 0x04E0058B);		// H_start/H_end,
	rtd_outl(0xb802D514, 0x00561143);		// V_start/V_end,
	rtd_outl(0xb802D518, 0x00000382);		// Control,
	rtd_outl(0xb802D51C, 0x00020000);		// Across Line3 RP/HP,


	////////////////////////////////////////////////////////////////////////////
	// GCLK, gpio_96, Tcon17,
	// Tcon14 (Frame End Pulse),
	rtd_outl(0xb802D3D0, 0x017F02F4);		// H_start/H_end,
	rtd_outl(0xb802D3D4, 0x113E1146);		// V_start/V_end,
	rtd_outl(0xb802D3D8, 0x00000180);		// Control,
	// Tcon15 (Line 2/4/6/...),
	rtd_outl(0xb802D3F0, 0x017F02F4);		// H_start/H_end,
	rtd_outl(0xb802D3F4, 0x0054113D);		// V_start/V_end,
	rtd_outl(0xb802D3F8, 0x00000382);		// Control,
	rtd_outl(0xb802D3FC, 0x00020000);		// Across Line3 RP/HP,
	// Tcon16 (Line 1/3/5/...),
	rtd_outl(0xb802D410, 0x017F02F4);		// H_start/H_end,
	rtd_outl(0xb802D414, 0x0053113E);		// V_start/V_end,
	rtd_outl(0xb802D418, 0x00000382);		// Control,
	rtd_outl(0xb802D41C, 0x00020000);		// Across Line3 RP/HP,
	// Tcon17 (Frame Start Pulse),
	rtd_outl(0xb802D430, 0x017F02F4);		// H_start/H_end,
	rtd_outl(0xb802D434, 0x00520052);		// V_start/V_end,
	rtd_outl(0xb802D438, 0x00000182);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// EO, gpio_76, Tcon5,
	// TCON4,
	rtd_outl(0xb802D290, 0x03B103B1);		// H_start/H_end,
	rtd_outl(0xb802D294, 0x11471147);		// V_start/V_end,
	rtd_outl(0xb802D298, 0x00000480);		// Control,
	rtd_outl(0xb802D2A0, 0x00780078);		// Across Frame LP, Across Frame HP
	// Tcon5,
	rtd_outl(0xb802D2B0, 0x02F402F4);		// H_start/H_end,
	rtd_outl(0xb802D2B4, 0x11471147);		// V_start/V_end,
	rtd_outl(0xb802D2B8, 0x00000483);		// Control,
	rtd_outl(0xb802D2C0, 0x00780078);		// Across Frame LP, Across Frame HP


	////////////////////////////////////////////////////////////////////////////
	// POL, Tcon20,
	// Tcon18, flag_28s
	rtd_outl(0xb802D450, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D454, 0x00011146);		// V_start/V_end,
	rtd_outl(0xb802D458, 0x00000108);		// Control,
	rtd_outl(0xb802D460, 0x068F068F);		// Across Frame LP, Across Frame HP
	// Tcon19,
	rtd_outl(0xb802D470, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D474, 0x00011146);		// V_start/V_end,
	rtd_outl(0xb802D478, 0x0000018B);		// Control,
	rtd_outl(0xb802D47C, 0x00000000);		// Across Line 3 HP/RP,
	rtd_outl(0xb802D480, 0x00000000);		// Across Frame LP, Across Frame HP
	// Tcon20,
	rtd_outl(0xb802D490, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D494, 0x00011146);		// V_start/V_end,
	rtd_outl(0xb802D498, 0x00000183);		// Control,
	rtd_outl(0xb802D4A0, 0x00000000);		// Across Frame LP, Across Frame HP


	////////////////////////////////////////////////////////////////////////////
	// GSP, Tcon25,
	// Tcon25,
	rtd_outl(0xb802D530, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D534, 0x00570058);		// V_start/V_end,
	rtd_outl(0xb802D538, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// Scrambler Enable, Tcon26,
	rtd_outl(0xb802D550, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D554, 0x00011150);		// V_start/V_end,
	rtd_outl(0xb802D558, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// Scrambler Reset, Tcon27,
	rtd_outl(0xb802D570, 0x044C044C);		// H_start/H_end,
	rtd_outl(0xb802D574, 0x00011150);		// V_start/V_end,
	rtd_outl(0xb802D578, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// DE (Tcon8, EO), for debug,
	//rtd_outl(0xb802D310, 0x00A30820);		// H_start/H_end,
	//rtd_outl(0xb802D314, 0x005A1139);		// V_start/V_end,
	//rtd_outl(0xb802D318, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// 1st Line DE (Tcon8, EO), for debug,
	//rtd_outl(0xb802D310, 0x00A30820);		// H_start/H_end,
	//rtd_outl(0xb802D314, 0x005A005A);		// V_start/V_end,
	//rtd_outl(0xb802D318, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////

	rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
	rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x01100040);	// SFG path enable, Common fifo use sfg_clk, 30-bit Mode, SFG out disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x03FFFFFF);	// PIF_Clock = Dclk/4, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 8n+0/8n+1/8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00000000);	// Line 8n+4/8n+5/8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x089D002D);	// DV_Den_end,DV_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D954, 0x10180118);	// DH_Den_end,DH_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D958, 0x057F112F);	// DV_width,Dh_width,Dh_total (follow DTG timing)
	rtd_outl(0xb802D964, 0x10000787);	// SFG DRD Mode, 1.5 packet mode disable, 1P mode, H-Flip enable, 8-SEG, 8-Port,
	rtd_outl(0xb802D968, 0x000001E0);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x03C005A0);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x07800960);	// SEG4/SEG5 Start Address,
	rtd_outl(0xb802D974, 0x0B400D20);	// SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	//rtd_outl(0xb802DB00, 0x00000000);	// SEG12/SEG13 Start Address,
	//rtd_outl(0xb802DB04, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D980, 0x03C0F03C);	// Gray dummy line data0 (L15 in 8-bit),
	rtd_outl(0xb802D984, 0x00000000);	// Gray dummy line data1 (L0),
	//rtd_outl(0xb802D94C, 0x00000000);	// Gray dummy line data2,
	//rtd_outl(0xb802DA28, 0x00000000);	// Gray dummy line data3,
	rtd_outl(0xb802DA24, 0x00010000);	// front dummuy line use gray data0, back dummuy line use gray data1,
	rtd_outl(0xb802D988, 0x40100090);	// Bypass SFG disable, Auto config enable, downsample disable,
						// front_dummy_line_num(2), back_dummy_line_num(1),
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00000000);	// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00000000);	// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00000000);	// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00000000);	// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD Data Mapping,
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD Data Mapping,
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD Data Mapping,
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD Data Mapping,
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD Data Mapping,
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD Data Mapping,
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD Data Mapping,
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD Data Mapping,
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD Data Mapping,
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD Data Mapping,
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD Data Mapping,
	rtd_outl(0xb802DACC, 0x16161616);	// DRD Data Mapping,
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD Data Mapping,
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD Data Mapping,
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD Data Mapping,
	rtd_outl(0xb802DADC, 0x07070707);	// DRD Data Mapping,
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD Data Mapping,
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD Data Mapping,
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD Data Mapping,
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD Data Mapping,
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD Data Mapping,
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD Data Mapping,
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD Data Mapping,
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD Data Mapping,
	rtd_outl(0xb802DB68, 0x00000000);	// ext_num setting for case_a line7~0,
	rtd_outl(0xb802DB6C, 0x00000000);	// ext_num setting for case_b line7~0,
	//rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E20);	// SFG Pattern Gen. Enable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	//rtd_outl(0xb802DC14, 0x00000000);	// SFG Pattern Gen. gray_data0 and gray_data1 for manmal pattern,
	//rtd_outl(0xb802DC18, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+0,
	//rtd_outl(0xb802DC1C, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+1,
	//rtd_outl(0xb802DC20, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+2,
	//rtd_outl(0xb802DC24, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+3,
	// Merlin-serial FIFO start
	//rtd_outl(0xb802DC94, 0x20000000);	// Aysnc FIFO disble, Async FIFO use EPI Mode,
	//rtd_outl(0xb802DC98, 0x9C00FFFF);	// 15~0 Lane_en
	//rtd_outl(0xb802DC9C, 0x45012FFF);	// Lane 7~0 pair assign,  2K using lane2~lane14 for LSphy
	//rtd_outl(0xb802DCA0, 0xFFFFFFF3);	// Lane 15~8 pair assign,  2K using lane2~lane14 for LSphy
	//rtd_outl(0xb802DCC8, 0x000001F8);	// VIDEO_OSD_SEL 16lane video, phy lane8~lane3 enable
	//rtd_outl(0xb802DCD0, 0x00000000);	// P/N Swap enable ,
	// Merlin-serial FIFO end
	rtd_part_outl(0xb802D900, 11, 11, 0x1);	// SFG out enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCK Pin share
	//---------------------------------------------------------------------------------------------------------------------------------

	rtd_maskl(0xb80008A4, 0x0F0FFFFF, 0x00500000);	// GPIO_90 pinshare to EPI_LOCK_SRC0,
	rtd_maskl(0xb8000CBC, 0xFFFFFFFC, 0x00000000);	// VEPI MAC use EPI_LOCK_SRC0,
	rtd_maskl(0xb80008BC, 0x7FFFFFFF, 0x80000000);	// GPIO_90 use 1.8V GPI,

	//---------------------------------------------------------------------------------------------------------------------------------
	//EPI MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb8026000, 0x00000004);	// Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026060, 0x0800000A);	// EPI 3.05Gbps 8-bit mode, lock_dmy_line
	rtd_outl(0xb8026064, 0x80000000);	// EPI reset disable, CST/C3/C4/C5/DST packet disable, EPI lock HW mode,
	rtd_outl(0xb802606C, 0x40803000);	// 1 Pixel, EPI disable, ext_num unit is sub-pixel, 8-port EPI, packet delimiter,28s_soe off
	//rtd_outl(0xb8026070, 0x00000645);	// CMPI CMD/DATA delimiter, run length conding delimiter,
	//rtd_outl(0xb8026080, 0x00000000);	// Dummy line color 0 (L0) for CMPI,
	//rtd_outl(0xb8026084, 0x00000000);	// Dummy line color 1 (L0) for CMPI,
	//rtd_outl(0xb8026088, 0x00000000);	// Dummy line color 2 (L0) for CMPI,
	//rtd_outl(0xb802608C, 0x00000000);	// Dummy line color 3 (L0) for CMPI,
	rtd_outl(0xb8026090, 0x000FFFF3);	// CRC Enable, select lane 0~15 to CRC,
	rtd_outl(0xb802609C, 0x00000000);	// EPI Data from SFG, EPI packet data setting,
	rtd_outl(0xb80260A4, 0x00000071);	// INV4 LUT use 8 line cycle, POD2_INV4 initial phase select bypass (2'b00),
	rtd_outl(0xb80260A8, 0x0055FFAA);	// INV4 LUT for line 0~8, {INV1/INV2/INV3/INV4}
	//rtd_outl(0xb80260AC, 0x00000000);	// INV4 LUT for line 9~16,
	//rtd_outl(0xb8026110, 0x00000000);	// CMPI RLC Function for 10bit mode disable,
	//rtd_outl(0xb8026114, 0x00000000);	// CMPI CDR type mode select,
	//rtd_outl(0xb8026118, 0x00000000);	// CMPI CDR clock training2 insert in type1 and type2,
	rtd_outl(0xb802617C, 0x00000023);	// Scrambler reset/enable control by tcon_c/tcon_d,
	rtd_outl(0xb8026180, 0x00000003);	// EPI_SCR8 enable, HVBP_SCR disable, EDGE_SCR disable,
	rtd_outl(0xb8026184, 0x00FFFFFF);	// EPI_SCR8 initial value,
	//rtd_outl(0xb8026188, 0x00000002);	// EPI_SCR10 disable,
	//rtd_outl(0xb802618C, 0x000FFFFF);	// EPI_SCR10 initial value,
	//rtd_outl(0xb8026190, 0x00000000);	// CMPI_SCR8 disable,
	//rtd_outl(0xb8026194, 0x00000FFF);	// CMPI_SCR8 initial value,
	//rtd_outl(0xb8026198, 0x00000000);	// CMPI_SCR10 disable,
	//rtd_outl(0xb802619C, 0x000003FF);	// CMPI_SCR10 initial value,
	//rtd_outl(0xb80261A0, 0x00000000);	// CMPI F/M/B color select, Pgamma for CMPI disable,
	//rtd_outl(0xb80261A4, 0x00000000);	// CMPI Pgamma CST packet,
	//rtd_outl(0xb80261A8, 0x00000000);	// CMPI Pgamma C1 packet,
	//rtd_outl(0xb80261AC, 0x00000000);	// CMPI Pgamma C2 packet,
	//rtd_outl(0xb80261B0, 0x00000000);	// CMPI Pgamma C3 packet,
	//rtd_outl(0xb8026300, 0x00000000);	// CMPI Pgamma C4 packet,
	//rtd_outl(0xb8026304, 0x00000000);	// CMPI Pgamma C5 packet,
	//rtd_outl(0xb80261B4, 0x00000000);	// CMPI Pgamma PG_ST packet,
	//rtd_outl(0xb80261B8, 0x00000000);	// CMPI Pgamma Data0 packet,
	//rtd_outl(0xb80261BC, 0x00000000);	// CMPI Pgamma Data1 packet,
	//rtd_outl(0xb80261C0, 0x00000000);	// CMPI Pgamma Data2 packet,
	//rtd_outl(0xb80261C4, 0x00000000);	// CMPI Pgamma Data3 packet,
	//rtd_outl(0xb80261C8, 0x00000000);	// CMPI Pgamma Data4 packet,
	//rtd_outl(0xb80261CC, 0x00000000);	// CMPI Pgamma Data5 packet,
	//rtd_outl(0xb80261D0, 0x00000000);	// CMPI Pgamma Data6 packet,
	//rtd_outl(0xb80261D4, 0x00000000);	// CMPI Pgamma Data7 packet,
	//rtd_outl(0xb80261D8, 0x00000000);	// CMPI Pgamma Data8 packet,
	//rtd_outl(0xb80261DC, 0x00000000);	// CMPI Pgamma Data9 packet,
	//rtd_outl(0xb8026308, 0x00000000);	// CMPI Pgamma Data10 packet,
	//rtd_outl(0xb802630C, 0x00000000);	// CMPI Pgamma Data11 packet,
	//rtd_outl(0xb8026310, 0x00000000);	// CMPI Pgamma Data12 packet,
	//rtd_outl(0xb8026314, 0x00000000);	// CMPI Pgamma Data13 packet,
	//rtd_outl(0xb8026318, 0x00000000);	// CMPI Pgamma Data14 packet,
	//rtd_outl(0xb802631C, 0x00000000);	// CMPI Pgamma Data15 packet,
	//rtd_outl(0xb8026320, 0x00000000);	// CMPI Pgamma Data16 packet,
	//rtd_outl(0xb8026324, 0x00000000);	// CMPI Pgamma Data17 packet,
	//rtd_outl(0xb8026328, 0x00000000);	// CMPI Pgamma Data18 packet,
	//rtd_outl(0xb802632C, 0x00000000);	// CMPI Pgamma Data19 packet,
	//rtd_outl(0xb8026330, 0x00000000);	// CMPI Pgamma Data20 packet,
	//rtd_outl(0xb8026334, 0x00000000);	// CMPI Pgamma Data21 packet,
	//rtd_outl(0xb8026338, 0x00000000);	// CMPI Pgamma Data22 packet,
	//rtd_outl(0xb802633C, 0x00000000);	// CMPI Pgamma Data23 packet,
	//rtd_outl(0xb8026340, 0x00000000);	// CMPI Pgamma Data24 packet,
	//rtd_outl(0xb8026344, 0x00000000);	// CMPI Pgamma Data25 packet,
	//rtd_outl(0xb8026348, 0x00000000);	// CMPI Pgamma Data26 packet,
	//rtd_outl(0xb802634C, 0x00000000);	// CMPI Pgamma Data27 packet,
	//rtd_outl(0xb8026350, 0x00000000);	// CMPI Pgamma Data28 packet,
	//rtd_outl(0xb8026354, 0x00000000);	// CMPI Pgamma Data29 packet,
	//rtd_outl(0xb8026358, 0x00000000);	// CMPI Pgamma Data30 packet,
	//rtd_outl(0xb802635C, 0x00000000);	// CMPI Pgamma Data31 packet,
	//rtd_outl(0xb8026360, 0x00000000);	// CMPI Pgamma Data32 packet,
	//rtd_outl(0xb8026364, 0x00000000);	// CMPI Pgamma Data33 packet,
	//rtd_outl(0xb8026368, 0x00000000);	// CMPI Pgamma Data34 packet,
	//rtd_outl(0xb802636C, 0x00000000);	// CMPI Pgamma Data35 packet,
	//rtd_outl(0xb8026370, 0x00000000);	// CMPI Pgamma Data36 packet,
	//rtd_outl(0xb8026374, 0x00000000);	// CMPI Pgamma Data37 packet,
	//rtd_outl(0xb8026378, 0x00000000);	// CMPI Pgamma Data38 packet,
	//rtd_outl(0xb802637C, 0x00000000);	// CMPI Pgamma Data39 packet,
	//rtd_outl(0xb8026400, 0x00000000);	// CMPI Pgamma Data40 packet,
	//rtd_outl(0xb8026404, 0x00000000);	// CMPI Pgamma Data41 packet,
	//rtd_outl(0xb8026408, 0x00000000);	// CMPI Pgamma Data42 packet,
	//rtd_outl(0xb802640C, 0x00000000);	// CMPI Pgamma Data43 packet,
	//rtd_outl(0xb8026410, 0x00000000);	// CMPI Pgamma Data44 packet,
	//rtd_outl(0xb8026414, 0x00000000);	// CMPI Pgamma Data45 packet,
	//rtd_outl(0xb8026418, 0x00000000);	// CMPI Pgamma Data46 packet,
	//rtd_outl(0xb802641C, 0x00000000);	// CMPI Pgamma Data47 packet,
	//rtd_outl(0xb8026420, 0x00000000);	// CMPI Pgamma Data48 packet,
	//rtd_outl(0xb8026424, 0x00000000);	// CMPI Pgamma Data49 packet,
	//rtd_outl(0xb8026428, 0x00000000);	// CMPI Pgamma Data50 packet,
	//rtd_outl(0xb802642C, 0x00000000);	// CMPI Pgamma Data51 packet,
	//rtd_outl(0xb8026430, 0x00000000);	// CMPI Pgamma Data52 packet,
	//rtd_outl(0xb8026434, 0x00000000);	// CMPI Pgamma Data53 packet,
	//rtd_outl(0xb8026438, 0x00000000);	// CMPI Pgamma Data54 packet,
	//rtd_outl(0xb802643C, 0x00000000);	// CMPI Pgamma Data55 packet,
	//rtd_outl(0xb8026440, 0x00000000);	// CMPI Pgamma Data56 packet,
	//rtd_outl(0xb8026444, 0x00000000);	// CMPI Pgamma Data57 packet,
	//rtd_outl(0xb8026448, 0x00000000);	// CMPI Pgamma Data58 packet,
	//rtd_outl(0xb802644C, 0x00000000);	// CMPI Pgamma Data59 packet,
	//rtd_outl(0xb80261E0, 0x00000000);	// CMPI Pgamma PG_END packet,
	rtd_outl(0xb80261E4, 0x000000FF);	// EPI MAC output Port 0~7 transmit to APHY, others disable,
	rtd_outl(0xb80261E8, 0x000000FF);	// EPI Port 0~7 extend subpixel use sfg case_a,
	rtd_outl(0xb80261EC, 0x000000FF);	// EPI constant_update_mode : EPI Port 0~7 update by TDM (for power save),
	rtd_outl(0xb80263F8, 0x00000000);	// EPI update first ctrl packet time : hs_den_io_dist + den_length (compute by hw),
	rtd_outl(0xb80263FC, 0x007D00FB);	// LOCK debounce enable and setting,
	rtd_outl(0xb80261F4, 0x0000000F);	// Check SFG output timing enable,
	rtd_outl(0xb80261FC, 0x0000000E);	// SOE LUT use 4-line repeat, SOE LUT apply to C2[17:0],
	rtd_outl(0xb8026200, 0x000034DE);	// SOE line 0 LUT for lane 0,
	rtd_outl(0xb8026204, 0x000034DE);	// SOE line 1 LUT for lane 0,
	rtd_outl(0xb8026208, 0x000034DE);	// SOE line 2 LUT for lane 0,
	rtd_outl(0xb802620C, 0x000034DE);	// SOE line 3 LUT for lane 0,
	rtd_outl(0xb8026210, 0x000038DF);	// SOE line 0 LUT for lane 1,
	rtd_outl(0xb8026214, 0x000038DF);	// SOE line 1 LUT for lane 1,
	rtd_outl(0xb8026218, 0x000038DF);	// SOE line 2 LUT for lane 1,
	rtd_outl(0xb802621C, 0x000038DF);	// SOE line 3 LUT for lane 1,
	rtd_outl(0xb8026220, 0x00003CE0);	// SOE line 0 LUT for lane 2,
	rtd_outl(0xb8026224, 0x00003CE0);	// SOE line 1 LUT for lane 2,
	rtd_outl(0xb8026228, 0x00003CE0);	// SOE line 2 LUT for lane 2,
	rtd_outl(0xb802622C, 0x00003CE0);	// SOE line 3 LUT for lane 2,
	rtd_outl(0xb8026230, 0x000040E1);	// SOE line 0 LUT for lane 3,
	rtd_outl(0xb8026234, 0x000040E1);	// SOE line 1 LUT for lane 3,
	rtd_outl(0xb8026238, 0x000040E1);	// SOE line 2 LUT for lane 3,
	rtd_outl(0xb802623C, 0x000040E1);	// SOE line 3 LUT for lane 3,
	rtd_outl(0xb8026240, 0x000040E1);	// SOE line 0 LUT for lane 4,
	rtd_outl(0xb8026244, 0x000040E1);	// SOE line 1 LUT for lane 4,
	rtd_outl(0xb8026248, 0x000040E1);	// SOE line 2 LUT for lane 4,
	rtd_outl(0xb802624C, 0x000040E1);	// SOE line 3 LUT for lane 4,
	rtd_outl(0xb8026250, 0x00003CE0);	// SOE line 0 LUT for lane 5,
	rtd_outl(0xb8026254, 0x00003CE0);	// SOE line 1 LUT for lane 5,
	rtd_outl(0xb8026258, 0x00003CE0);	// SOE line 2 LUT for lane 5,
	rtd_outl(0xb802625C, 0x00003CE0);	// SOE line 3 LUT for lane 5,
	rtd_outl(0xb8026260, 0x000038DF);	// SOE line 0 LUT for lane 6,
	rtd_outl(0xb8026264, 0x000038DF);	// SOE line 1 LUT for lane 6,
	rtd_outl(0xb8026268, 0x000038DF);	// SOE line 2 LUT for lane 6,
	rtd_outl(0xb802626C, 0x000038DF);	// SOE line 3 LUT for lane 6,
	rtd_outl(0xb8026270, 0x000034DE);	// SOE line 0 LUT for lane 7,
	rtd_outl(0xb8026274, 0x000034DE);	// SOE line 1 LUT for lane 7,
	rtd_outl(0xb8026278, 0x000034DE);	// SOE line 2 LUT for lane 7,
	rtd_outl(0xb802627C, 0x000034DE);	// SOE line 3 LUT for lane 7,
	//rtd_outl(0xb8026280, 0x00000000);	// SOE line 0 LUT for lane 8,
	//rtd_outl(0xb8026284, 0x00000000);	// SOE line 1 LUT for lane 8,
	//rtd_outl(0xb8026288, 0x00000000);	// SOE line 2 LUT for lane 8,
	//rtd_outl(0xb802628C, 0x00000000);	// SOE line 3 LUT for lane 8,
	//rtd_outl(0xb8026290, 0x00000000);	// SOE line 0 LUT for lane 9,
	//rtd_outl(0xb8026294, 0x00000000);	// SOE line 1 LUT for lane 9,
	//rtd_outl(0xb8026298, 0x00000000);	// SOE line 2 LUT for lane 9,
	//rtd_outl(0xb802629C, 0x00000000);	// SOE line 3 LUT for lane 9,
	//rtd_outl(0xb80262A0, 0x00000000);	// SOE line 0 LUT for lane 10,
	//rtd_outl(0xb80262A4, 0x00000000);	// SOE line 1 LUT for lane 10,
	//rtd_outl(0xb80262A8, 0x00000000);	// SOE line 2 LUT for lane 10,
	//rtd_outl(0xb80262AC, 0x00000000);	// SOE line 3 LUT for lane 10,
	//rtd_outl(0xb80262B0, 0x00000000);	// SOE line 0 LUT for lane 11,
	//rtd_outl(0xb80262B4, 0x00000000);	// SOE line 1 LUT for lane 11,
	//rtd_outl(0xb80262B8, 0x00000000);	// SOE line 2 LUT for lane 11,
	//rtd_outl(0xb80262BC, 0x00000000);	// SOE line 3 LUT for lane 11,
	//rtd_outl(0xb8026380, 0x00000000);	// DST(C4~C0) MUX use register config,
	//rtd_outl(0xb8026384, 0x00000000);	// DST(C9~C5) MUX use register config,
	//rtd_outl(0xb8026388, 0x00000000);	// DST(C14~C10) MUX use register config,
	//rtd_outl(0xb802638C, 0x00000000);	// DST(C19~C15) MUX use register config,
	//rtd_outl(0xb8026390, 0x00000000);	// DST(C24~C20) MUX use register config,
	//rtd_outl(0xb8026394, 0x00000000);	// DST(C29~C25) MUX use register config,
	//rtd_outl(0xb8026398, 0x00000000);	// CST(C4~C0) MUX use register config,
	//rtd_outl(0xb802639C, 0x00000000);	// CST(C9~C5) MUX use register config,
	//rtd_outl(0xb80263A0, 0x00000000);	// CST(C14~C10) MUX use register config,
	//rtd_outl(0xb80263A4, 0x00000000);	// CST(C19~C15) MUX use register config,
	//rtd_outl(0xb80263A8, 0x00000000);	// CST(C24~C20) MUX use register config,
	//rtd_outl(0xb80263AC, 0x00000000);	// CST(C29~C25) MUX use register config,
	rtd_outl(0xb80263B0, 0x00000000);	// C1(C4~C0) MUX use register config,
	rtd_outl(0xb80263B4, 0x00000210);	// C1(C9~C5) MUX use register config (C6/C7 use Tcon_A/B),
	rtd_outl(0xb80263B8, 0x0009A000);	// C1(C14~C10) MUX use register config (C13/C14 use INV4_1/2 LUT),
	rtd_outl(0xb80263BC, 0x00000078);	// C1(C19~C15) MUX use register config (C15/C16 use INV4_3/4 LUT),
	rtd_outl(0xb80263C0, 0x00000000);	// C1(C24~C20) MUX use register config,
	rtd_outl(0xb80263C4, 0x00000000);	// C1(C29~C25) MUX use register config,
	rtd_outl(0xb80263C8, 0x00000000);	// C2(C4~C0) MUX use register config,
	rtd_outl(0xb80263CC, 0x00000000);	// C2(C9~C5) MUX use register config,
	rtd_outl(0xb80263D0, 0x00000000);	// C2(C14~C10) MUX use register config,
	rtd_outl(0xb80263D4, 0x00033000);	// C2(C19~C15) MUX use register config (C18/C19 use Tcon_C/C),
	rtd_outl(0xb80263D8, 0x00004443);	// C2(C24~C20) MUX use register config (C20/C21/C22/C23 use Tcon_C/D/D/D),
	rtd_outl(0xb80263DC, 0x00000000);	// C2(C29~C25) MUX use register config,
	//rtd_outl(0xb80263E0, 0x00000000);	// C3(C4~C0) MUX use register config,
	//rtd_outl(0xb80263E4, 0x00000000);	// C3(C9~C5) MUX use register config,
	//rtd_outl(0xb80263E8, 0x00000000);	// C3(C14~C10) MUX use register config,
	//rtd_outl(0xb80263EC, 0x00000000);	// C3(C19~C15) MUX use register config,
	//rtd_outl(0xb80263F0, 0x00000000);	// C3(C24~C20) MUX use register config,
	//rtd_outl(0xb80263F4, 0x00000000);	// C3(C29~C25) MUX use register config,
	rtd_outl(0xb8026500, 0x001A1914);	// Tcon_A/B/C sel ext_tcon_20/25/26,
	rtd_outl(0xb8026504, 0x0000001B);	// Tcon_D ext_tcon_27/0/0,
	//rtd_outl(0xb8026508, 0x00000000);	// Tcon_G/H/I sel ext_tcon_0/0/0,
	//rtd_outl(0xb802650C, 0x00000000);	// Tcon_J/K sel ext_tcon_0/0,
	rtd_outl(0xb8026524, 0x00000000);	// SOE1/SOE2 LUT switch every 28 second is disbale,
						// CEDS POL in CTRL1(C6) for all lane is not invert,
						// CEDS POL2 in CTRL1(C12) for all lane is not invert,
	//rtd_outl(0xb8026528, 0x0000002A);	// DST register config value,
	//rtd_outl(0xb802653C, 0x00000015);	// CST register config value,
	//rtd_outl(0xb80266F0, 0x00000000);	// C3 register config value,
	//rtd_outl(0xb8026A60, 0x00000000);	// C4 register config value,
	//rtd_outl(0xb8026AA0, 0x00000000);	// C5 register config value,
	rtd_outl(0xb8026554, 0x001C1600);	// Lane0 : C1 register config value,
	rtd_outl(0xb802655C, 0x001C1600);	// Lane1 : C1 register config value,
	rtd_outl(0xb8026564, 0x001C1600);	// Lane2 : C1 register config value,
	rtd_outl(0xb802656C, 0x001C1600);	// Lane3 : C1 register config value,
	rtd_outl(0xb8026574, 0x000C1600);	// Lane4 : C1 register config value,
	rtd_outl(0xb802657C, 0x000C1600);	// Lane5 : C1 register config value,
	rtd_outl(0xb8026584, 0x000C1600);	// Lane6 : C1 register config value,
	rtd_outl(0xb802658C, 0x000C1600);	// Lane7 : C1 register config value,
	//rtd_outl(0xb8026594, 0x00000000);	// Lane8 : C1 register config value,
	//rtd_outl(0xb802659C, 0x00000000);	// Lane9 : C1 register config value,
	//rtd_outl(0xb80265A4, 0x00000000);	// Lane10: C1 register config value,
	//rtd_outl(0xb80265AC, 0x00000000);	// Lane11: C1 register config value,
	//rtd_outl(0xb8026624, 0x00000000);	// Lane0 : C2 register config value,
	//rtd_outl(0xb802662C, 0x00000000);	// Lane1 : C2 register config value,
	//rtd_outl(0xb8026634, 0x00000000);	// Lane2 : C2 register config value,
	//rtd_outl(0xb802663C, 0x00000000);	// Lane3 : C2 register config value,
	//rtd_outl(0xb8026644, 0x00000000);	// Lane4 : C2 register config value,
	//rtd_outl(0xb802664C, 0x00000000);	// Lane5 : C2 register config value,
	//rtd_outl(0xb8026654, 0x00000000);	// Lane6 : C2 register config value,
	//rtd_outl(0xb802665C, 0x00000000);	// Lane7 : C2 register config value,
	//rtd_outl(0xb8026664, 0x00000000);	// Lane8 : C2 register config value,
	//rtd_outl(0xb802666C, 0x00000000);	// Lane9 : C2 register config value,
	//rtd_outl(0xb8026674, 0x00000000);	// Lane10: C2 register config value,
	//rtd_outl(0xb802667C, 0x00000000);	// Lane11: C2 register config value,
	//rtd_outl(0xb80266F4, 0x00000000);	// Lane0 : C3 register config value,
	//rtd_outl(0xb80266FC, 0x00000000);	// Lane1 : C3 register config value,
	//rtd_outl(0xb8026704, 0x00000000);	// Lane2 : C3 register config value,
	//rtd_outl(0xb802670C, 0x00000000);	// Lane3 : C3 register config value,
	//rtd_outl(0xb8026714, 0x00000000);	// Lane4 : C3 register config value,
	//rtd_outl(0xb802671C, 0x00000000);	// Lane5 : C3 register config value,
	//rtd_outl(0xb8026724, 0x00000000);	// Lane6 : C3 register config value,
	//rtd_outl(0xb802672C, 0x00000000);	// Lane7 : C3 register config value,
	//rtd_outl(0xb8026734, 0x00000000);	// Lane8 : C3 register config value,
	//rtd_outl(0xb802673C, 0x00000000);	// Lane9 : C3 register config value,
	//rtd_outl(0xb8026744, 0x00000000);	// Lane10: C3 register config value,
	//rtd_outl(0xb802674C, 0x00000000);	// Lane11: C3 register config value,
	//rtd_outl(0xb8026450, 0x00000000);	// General propose LUT use 1 line cycle,
	//rtd_outl(0xb8026454, 0x00000000);	// General propose LUT for line 0~1,
	//rtd_outl(0xb8026458, 0x00000000);	// General propose LUT for line 2~3,
	//rtd_outl(0xb802645C, 0x00000000);	// General propose LUT for line 4~5,
	//rtd_outl(0xb8026460, 0x00000000);	// General propose LUT for line 6~7,

	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D02C, 0x00000002);	// Async FIFO use EPI Mode,
	rtd_outl(0xb802D030, 0x00000000);	// P/N Swap disable,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO disable,
	rtd_outl(0xb802D03C, 0x00030010);	// Async FIFO reset enable, adaptive reset, apply after 16-clock,
	rtd_outl(0xb802D060, 0xFFFFFFFF);	// Lane 0~3 pair assign,
	rtd_outl(0xb802D064, 0xFFFFFFFF);	// Lane 4~7 pair assign,
	rtd_outl(0xb802D068, 0x10111213);	// Lane 8~11 pair assign,
	rtd_outl(0xb802D06C, 0x0C0D0E0F);	// Lane 12~15 pair assign,
	rtd_outl(0xb802D070, 0xFFFFFFFF);	// Lane 16~19 pair assign,
	rtd_outl(0xb802D074, 0xFFFFFFFF);	// Lane 20~23 pair assign,
	rtd_outl(0xb802D078, 0xFFFFFFFF);	// Lane 24~27 pair assign,

	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000CC0, 0x00000000);	// Lane Power disable,
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C00, 0x30030020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30030020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080101);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(2),
	rtd_outl(0xb8000C0C, 0x8000E4B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000001);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(1), EPI_DIVM(14),
	rtd_outl(0xb8000C14, 0x00000001);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000021);	// TXPLL use EPI feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F4C000);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C78, 0x00000200);	// CKIN_DIVN(4),

	//
	//rtd_outl(0xb8000D00, 0x77002815);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D10, 0x77002815);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D20, 0x77002815);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D30, 0x77002815);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D40, 0x77002815);	// Lane4 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D50, 0x77002815);	// Lane5 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D60, 0x77002815);	// Lane6 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D70, 0x77002815);	// Lane7 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D80, 0x66002815);	// Lane8 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D90, 0x66002815);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DA0, 0x66002815);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DB0, 0x66002815);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DC0, 0x66002815);	// Lane12: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DD0, 0x66002815);	// Lane13: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DE0, 0x66002815);	// Lane14: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DF0, 0x66002815);	// Lane15: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E00, 0x77002815);	// Lane16: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E10, 0x77002815);	// Lane17: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E20, 0x77002815);	// Lane18: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E30, 0x77002815);	// Lane19: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E40, 0x77002815);	// Lane20: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E50, 0x77002815);	// Lane21: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E60, 0x77002815);	// Lane22: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E70, 0x77002815);	// Lane23: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E80, 0x77002815);	// Lane24: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E90, 0x77002815);	// Lane25: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000EA0, 0x77002815);	// Lane26: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000EB0, 0x77002815);	// Lane27: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),

	//
	rtd_outl(0xb8000D04, 0x44003006);	// Lane0 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D14, 0x44003006);	// Lane1 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D24, 0x44003006);	// Lane2 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D34, 0x44003006);	// Lane3 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D44, 0x44003006);	// Lane4 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D54, 0x44003006);	// Lane5 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D64, 0x44003006);	// Lane6 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D74, 0x44003006);	// Lane7 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D84, 0x44003006);	// Lane8 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D94, 0x44003006);	// Lane9 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DA4, 0x44003006);	// Lane10: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DB4, 0x44003006);	// Lane11: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DC4, 0x44003006);	// Lane12: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DD4, 0x44003006);	// Lane13: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DE4, 0x44003006);	// Lane14: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DF4, 0x44003006);	// Lane15: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E04, 0x44003006);	// Lane16: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E14, 0x44003006);	// Lane17: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E24, 0x44003006);	// Lane18: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E34, 0x44003006);	// Lane19: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E44, 0x44003006);	// Lane20: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E54, 0x44003006);	// Lane21: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E64, 0x44003006);	// Lane22: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E74, 0x44003006);	// Lane23: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E84, 0x44003006);	// Lane24: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E94, 0x44003006);	// Lane25: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000EA4, 0x44003006);	// Lane26: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000EB4, 0x44003006);	// Lane27: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),

	//
	rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DC8, 0x00000009);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DD8, 0x00000009);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DE8, 0x00000009);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DF8, 0x00000009);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E08, 0x00000009);	// Lane16: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E18, 0x00000009);	// Lane17: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E28, 0x00000009);	// Lane18: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E38, 0x00000009);	// Lane19: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) EPI Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x40000000);
	//
	// (8) EPI MAC Enable (Below Setting)
	rtd_part_outl(0xb802606C, 16, 16, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_outl(0xb8000CC0, 0x0000FF00); //Lane 8~15 power enable
	//
	// (11) Panel Power Enable (SW Control),
	rtd_part_outl(0x1806023C, 31, 28, 0xF); 	// Pinshare LSADC4->GPIO
	rtd_outl(0x18061100, 0x40000001); 	      // LSADC4/ST_GPIO_29 DDR 1V5_1V2/PIV1V5 power
	rtd_outl(0x18061108, 0x40000001); 	      // LSADC4/ST_GPIO_29 DDR 1V5_1V2/PIV1V5 power
	rtd_outl(0x1801bd00, 0x08000081); 	// GPIO_06 (PANEL_EN)panel power control
	rtd_outl(0x1801bd18, 0x08000081); 	// GPIO_06 (PANEL_EN)panel power control
	rtd_part_outl(0x18060238, 23, 20, 0xF); 	// Pinshare LSADC5-> GPIO
	rtd_outl(0x18061104, 0x00000009); 	// LSADC6/ST_GPIO_33 (BL_EN)backlight control
	rtd_outl(0x1806110C, 0x00000009); 	// LSADC6/ST_GPIO_33 (BL_EN)backlight control

	rtd_outl(0x1801bd00, 0x00000041); 	// GPIO_05(BL_ADJ) PWM control
	rtd_outl(0x1801bd18, 0x00000041); 	// GPIO_05(BL_ADJ) PWM control
}

void panel_epi_v20_49inch_uhd60_6lane_tcon_setting(void)
{
	rtd_outl(0xb8028000,0x00000000); // [24] disable disp
	rtd_outl(0xb8028004,0x02160008); // [22:19] 0x0010: enable rtk rgbw
	rtd_outl(0xb8028000,0x01000000); // [24] enable disp
	// Tcon Pinshare Setting,
	rtd_part_outl(0xb800088C, 31, 28, 0x9);		// gpio_75 for GST, use Tcon7,
	rtd_part_outl(0xb80008A4,  7,  4, 0xA);		// gpio_92 for MCLK, use Tcon24,
	rtd_part_outl(0xb80008A8,  7,  4, 0x9);		// gpio_96 for GCLK, use Tcon17,
	rtd_part_outl(0xb800088C, 23, 20, 0x8);		// gpio_76 for EO, use Tcon4,

	rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

	////////////////////////////////////////////////////////////////////////////
	// GST, gpio_75, Tcon7,
	// Tcon5 (Frame Start Pulse),
	rtd_outl(0xb802D2B0, 0x0399018d);		// H_start/H_end,
	rtd_outl(0xb802D2B4, 0x0049004e);		// V_start/V_end,
	rtd_outl(0xb802D2B8, 0x00000180);		// Control,
	// Tcon6 (Frame Second Pulse),
	rtd_outl(0xb802D2D0, 0x03a403a4);		// H_start/H_end,
	rtd_outl(0xb802D2D4, 0x004e0052);		// V_start/V_end,
	rtd_outl(0xb802D2D8, 0x00000182);		// Control,
	// Tcon7 (Frame End Pulse),
	rtd_outl(0xb802D2F0, 0x05630563);		// H_start/H_end,
	rtd_outl(0xb802D2F4, 0x113b113f);		// V_start/V_end,
	rtd_outl(0xb802D2F8, 0x00000182);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// MCLK, gpio_92, Tcon24,
	// Tocn22 (Frame Start Pulse),
	rtd_outl(0xb802D4D0, 0x02b60493);		// H_start/H_end,
	rtd_outl(0xb802D4D4, 0x004e0052);		// V_start/V_end,
	rtd_outl(0xb802D4D8, 0x00000180);		// Control,
	// Tocn23 (Line 2/4/6/...),
	rtd_outl(0xb802D4F0, 0x05a605d1);		// H_start/H_end,
	rtd_outl(0xb802D4F4, 0x0057113a);		// V_start/V_end,
	rtd_outl(0xb802D4F8, 0x00000382);		// Control,
	rtd_outl(0xb802D4FC, 0x00020000);		// Across Line3 RP/HP,
	// Tcon24 (Line 1/3/5/...),
	rtd_outl(0xb802D510, 0x05270552);		// H_start/H_end,
	rtd_outl(0xb802D514, 0x0056113b);		// V_start/V_end,
	rtd_outl(0xb802D518, 0x00000382);		// Control,
	rtd_outl(0xb802D51C, 0x00020000);		// Across Line3 RP/HP,


	////////////////////////////////////////////////////////////////////////////
	// GCLK, gpio_96, Tcon17,
	// Tcon14 (Frame End Pulse),
	rtd_outl(0xb802D3D0, 0x05630563);		// H_start/H_end,
	rtd_outl(0xb802D3D4, 0x1136113f);		// V_start/V_end,
	rtd_outl(0xb802D3D8, 0x00000180);		// Control,
	// Tcon15 (Line 2/4/6/...),
	rtd_outl(0xb802D3F0, 0x05e201d6);		// H_start/H_end,
	rtd_outl(0xb802D3F4, 0x00531136);		// V_start/V_end,
	rtd_outl(0xb802D3F8, 0x00000382);		// Control,
	rtd_outl(0xb802D3FC, 0x00020001);		// Across Line3 RP/HP,
	// Tcon16 (Line 1/3/5/...),
	rtd_outl(0xb802D410, 0x056301d6);		// H_start/H_end,
	rtd_outl(0xb802D414, 0x00541135);		// V_start/V_end,
	rtd_outl(0xb802D418, 0x00000382);		// Control,
	rtd_outl(0xb802D41C, 0x00020001);		// Across Line3 RP/HP,
	// Tcon17 (Frame Start Pulse),
	rtd_outl(0xb802D430, 0x056301d6);		// H_start/H_end,
	rtd_outl(0xb802D434, 0x00520053);		// V_start/V_end,
	rtd_outl(0xb802D438, 0x00000182);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// EO, gpio_76, Tcon4,
	// TCON3,
	rtd_outl(0xb802D270, 0x03d20565);		// H_start/H_end,
	rtd_outl(0xb802D274, 0x11401140);		// V_start/V_end,
	rtd_outl(0xb802D278, 0x00000180);		// Control,
	rtd_outl(0xb802D280, 0x00000191);		// Across Frame LP, Across Frame HP
	// Tcon4,
	rtd_outl(0xb802D290, 0x02fa0399);		// H_start/H_end,
	rtd_outl(0xb802D294, 0x00480048);		// V_start/V_end,
	rtd_outl(0xb802D298, 0x00000182);		// Control,
	rtd_outl(0xb802D2A0, 0x00000000);		// Across Frame LP, Across Frame HP


	////////////////////////////////////////////////////////////////////////////
	// POL, Tcon20,
	// Tcon18 28s,
	rtd_outl(0xb802D450, 0x044b044b);
	rtd_outl(0xb802D454, 0x00010001);
	rtd_outl(0xb802D458, 0x00000400);
	rtd_outl(0xb802D460, 0x068f068f);
	// Tcon19,
	rtd_outl(0xb802D470, 0x044b044b);		// H_start/H_end,
	rtd_outl(0xb802D474, 0x00011fff);		// V_start/V_end,
	rtd_outl(0xb802D478, 0x00000188);		// Control,
	// Tcon20,
	rtd_outl(0xb802D490, 0x044b044b);		// H_start/H_end,
	rtd_outl(0xb802D494, 0x00001fff);		// V_start/V_end,
	rtd_outl(0xb802D498, 0x00000183);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// GSP, Tcon25,
	// Tcon25,
	rtd_outl(0xb802D530, 0x844b044b);
	rtd_outl(0xb802D534, 0x00570058);
	rtd_outl(0xb802D538, 0x00000180);


	////////////////////////////////////////////////////////////////////////////
	// SCR_EN(EPI), Tcon26,
	rtd_outl(0xb802D550, 0x044b044b);
	rtd_outl(0xb802D554, 0x00011150);
	rtd_outl(0xb802D558, 0x00000000);


	////////////////////////////////////////////////////////////////////////////
	// SCR_RST(EPI), Tcon27,
	rtd_outl(0xb802D570, 0x044b044b);
	rtd_outl(0xb802D574, 0x00011150);
	rtd_outl(0xb802D578, 0x00000180);


	////////////////////////////////////////////////////////////////////////////
	// DE (Tcon8, EO), for debug,
	//rtd_outl(0xb802D310, 0x00A30820);		// H_start/H_end,
	//rtd_outl(0xb802D314, 0x005A1139);		// V_start/V_end,
	//rtd_outl(0xb802D318, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////
	// 1st Line DE (Tcon8, EO), for debug,
	//rtd_outl(0xb802D310, 0x00A30820);		// H_start/H_end,
	//rtd_outl(0xb802D314, 0x005A005A);		// V_start/V_end,
	//rtd_outl(0xb802D318, 0x00000180);		// Control,


	////////////////////////////////////////////////////////////////////////////

	rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
	rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x01100040);	// SFG path enable, Common fifo use sfg_clk, 30-bit Mode, SFG out disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x02FFFFFF);	// PIF_Clock = Dclk/3, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00000000);	// Line 8n+0/8n+1/8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00000000);	// Line 8n+4/8n+5/8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D950, 0x089D002D);	// DV_Den_end,DV_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D954, 0x10180118);	// DH_Den_end,DH_Den_sta, (follow DTG timing)
	rtd_outl(0xb802D958, 0x057F112F);	// DV_width,Dh_width,Dh_total (follow DTG timing)
	rtd_outl(0xb802D964, 0x10000585);	// SFG DRD Mode, 1.5 packet mode disable, 1P mode, H-Flip enable, 6-SEG, 6-Port,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	//rtd_outl(0xb802DB00, 0x00000000);	// SEG12/SEG13 Start Address,
	//rtd_outl(0xb802DB04, 0x00000000);	// SEG14/SEG15 Start Address,
	rtd_outl(0xb802D980, 0x03C0F03C);	// Gray dummy line data0 (L15 in 8-bit),
	rtd_outl(0xb802D984, 0x00000000);	// Gray dummy line data1 (L0),
	//rtd_outl(0xb802D94C, 0x00000000);	// Gray dummy line data2,
	//rtd_outl(0xb802DA28, 0x00000000);	// Gray dummy line data3,
	rtd_outl(0xb802DA24, 0x00010000);	// front dummuy line use gray data0, back dummuy line use gray data1,
	rtd_outl(0xb802D988, 0x40100090);	// Bypass SFG disable, Auto config enable, downsample disable,
						// front_dummy_line_num(2), back_dummy_line_num(1),
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00000000);	// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	rtd_outl(0xb802DA10, 0x00000000);	// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00000000);	// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00000000);	// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00000000);	// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00000000);	// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00000000);	// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00000000);	// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	rtd_outl(0xb802DAA0, 0x02020202);	// DRD Data Mapping,
	rtd_outl(0xb802DAA4, 0x04040404);	// DRD Data Mapping,
	rtd_outl(0xb802DAA8, 0x00000000);	// DRD Data Mapping,
	rtd_outl(0xb802DAAC, 0x08080808);	// DRD Data Mapping,
	rtd_outl(0xb802DAB0, 0x06060606);	// DRD Data Mapping,
	rtd_outl(0xb802DAB4, 0x0E0E0E0E);	// DRD Data Mapping,
	rtd_outl(0xb802DAB8, 0x0A0A0A0A);	// DRD Data Mapping,
	rtd_outl(0xb802DABC, 0x0C0C0C0C);	// DRD Data Mapping,
	rtd_outl(0xb802DAC0, 0x10101010);	// DRD Data Mapping,
	rtd_outl(0xb802DAC4, 0x12121212);	// DRD Data Mapping,
	rtd_outl(0xb802DAC8, 0x14141414);	// DRD Data Mapping,
	rtd_outl(0xb802DACC, 0x16161616);	// DRD Data Mapping,
	rtd_outl(0xb802DAD0, 0x01010101);	// DRD Data Mapping,
	rtd_outl(0xb802DAD4, 0x03030303);	// DRD Data Mapping,
	rtd_outl(0xb802DAD8, 0x05050505);	// DRD Data Mapping,
	rtd_outl(0xb802DADC, 0x07070707);	// DRD Data Mapping,
	rtd_outl(0xb802DAE0, 0x0B0B0B0B);	// DRD Data Mapping,
	rtd_outl(0xb802DAE4, 0x0D0D0D0D);	// DRD Data Mapping,
	rtd_outl(0xb802DAE8, 0x09090909);	// DRD Data Mapping,
	rtd_outl(0xb802DAEC, 0x11111111);	// DRD Data Mapping,
	rtd_outl(0xb802DAF0, 0x0F0F0F0F);	// DRD Data Mapping,
	rtd_outl(0xb802DAF4, 0x17171717);	// DRD Data Mapping,
	rtd_outl(0xb802DAF8, 0x13131313);	// DRD Data Mapping,
	rtd_outl(0xb802DAFC, 0x15151515);	// DRD Data Mapping,
	rtd_outl(0xb802DB68, 0x00000000);	// ext_num setting for case_a line7~0,
	rtd_outl(0xb802DB6C, 0x00000000);	// ext_num setting for case_b line7~0,
	//rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E19);	// SFG Pattern Gen. Enable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	//rtd_outl(0xb802DC14, 0x00000000);	// SFG Pattern Gen. gray_data0 and gray_data1 for manmal pattern,
	//rtd_outl(0xb802DC18, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+0,
	//rtd_outl(0xb802DC1C, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+1,
	//rtd_outl(0xb802DC20, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+2,
	//rtd_outl(0xb802DC24, 0x00000000);	// SFG Pattern Gen. manmal pattern sub-pixel data select for line 4n+3,
	// Merlin-serial FIFO start
	//rtd_outl(0xb802DC94, 0x20000000);	// Aysnc FIFO disble, Async FIFO use EPI Mode,
	//rtd_outl(0xb802DC98, 0x9C00FFFF);	// 15~0 Lane_en
	//rtd_outl(0xb802DC9C, 0x45012FFF);	// Lane 7~0 pair assign,  2K using lane2~lane14 for LSphy
	//rtd_outl(0xb802DCA0, 0xFFFFFFF3);	// Lane 15~8 pair assign,  2K using lane2~lane14 for LSphy
	//rtd_outl(0xb802DCC8, 0x000001F8);	// VIDEO_OSD_SEL 16lane video, phy lane8~lane3 enable
	//rtd_outl(0xb802DCD0, 0x00000000);	// P/N Swap enable ,
	// Merlin-serial FIFO end
	rtd_part_outl(0xb802D900, 11, 11, 0x1);	// SFG out enable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCK Pin share
	//---------------------------------------------------------------------------------------------------------------------------------

	rtd_maskl(0xb80008A4, 0x0F0FFFFF, 0x00500000);	// GPIO_90 pinshare to EPI_LOCK_SRC0,
	rtd_maskl(0xb8000CBC, 0xFFFFFFFC, 0x00000000);	// VEPI MAC use EPI_LOCK_SRC0,
	rtd_maskl(0xb80008BC, 0x7FFFFFFF, 0x80000000);	// GPIO_90 use 1.8V GPI,

	//---------------------------------------------------------------------------------------------------------------------------------
	//EPI MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb8026000, 0x00000004);	// Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026060, 0x08000002);	// EPI 3.05Gbps 8-bit mode,
	rtd_outl(0xb8026064, 0x80000000);	// EPI reset disable, CST/C3/C4/C5/DST packet disable, EPI lock HW mode,
	rtd_outl(0xb802606C, 0x40603000);	// EPI disable, ext_num unit is sub-pixel, 6-port EPI, packet delimiter,
	//rtd_outl(0xb8026070, 0x00000645);	// CMPI CMD/DATA delimiter, run length conding delimiter,
	//rtd_outl(0xb8026080, 0x00000000);	// Dummy line color 0 (L0) for CMPI,
	//rtd_outl(0xb8026084, 0x00000000);	// Dummy line color 1 (L0) for CMPI,
	//rtd_outl(0xb8026088, 0x00000000);	// Dummy line color 2 (L0) for CMPI,
	//rtd_outl(0xb802608C, 0x00000000);	// Dummy line color 3 (L0) for CMPI,
	rtd_outl(0xb8026090, 0x000003F3);	// CRC Enable, select lane 0~5 to CRC,
	rtd_outl(0xb802609C, 0x00000000);	// EPI Data from SFG, EPI packet data setting,
	rtd_outl(0xb80260A4, 0x00000071);	// INV4 LUT use 8 line cycle, POD2_INV4 initial phase select bypass (2'b00),
	rtd_outl(0xb80260A8, 0x500AAFF5);	// INV4 LUT for line 0~8,
	//rtd_outl(0xb80260AC, 0x00000000);	// INV4 LUT for line 9~16,
	//rtd_outl(0xb8026110, 0x00000000);	// CMPI RLC Function for 10bit mode disable,
	//rtd_outl(0xb8026114, 0x00000000);	// CMPI CDR type mode select,
	//rtd_outl(0xb8026118, 0x00000000);	// CMPI CDR clock training2 insert in type1 and type2,
	rtd_outl(0xb802617C, 0x00000023);	// Scrambler reset/enable control by tcon_c/tcon_d,
	rtd_outl(0xb8026180, 0x00000003);	// EPI_SCR8 enable, HVBP_SCR disable, EDGE_SCR disable,
	rtd_outl(0xb8026184, 0x00FFFFFF);	// EPI_SCR8 initial value,
	//rtd_outl(0xb8026188, 0x00000002);	// EPI_SCR10 disable,
	//rtd_outl(0xb802618C, 0x000FFFFF);	// EPI_SCR10 initial value,
	//rtd_outl(0xb8026190, 0x00000000);	// CMPI_SCR8 disable,
	//rtd_outl(0xb8026194, 0x00000FFF);	// CMPI_SCR8 initial value,
	//rtd_outl(0xb8026198, 0x00000000);	// CMPI_SCR10 disable,
	//rtd_outl(0xb802619C, 0x000003FF);	// CMPI_SCR10 initial value,
	//rtd_outl(0xb80261A0, 0x00000000);	// CMPI F/M/B color select, Pgamma for CMPI disable,
	//rtd_outl(0xb80261A4, 0x00000000);	// CMPI Pgamma CST packet,
	//rtd_outl(0xb80261A8, 0x00000000);	// CMPI Pgamma C1 packet,
	//rtd_outl(0xb80261AC, 0x00000000);	// CMPI Pgamma C2 packet,
	//rtd_outl(0xb80261B0, 0x00000000);	// CMPI Pgamma C3 packet,
	//rtd_outl(0xb8026300, 0x00000000);	// CMPI Pgamma C4 packet,
	//rtd_outl(0xb8026304, 0x00000000);	// CMPI Pgamma C5 packet,
	//rtd_outl(0xb80261B4, 0x00000000);	// CMPI Pgamma PG_ST packet,
	//rtd_outl(0xb80261B8, 0x00000000);	// CMPI Pgamma Data0 packet,
	//rtd_outl(0xb80261BC, 0x00000000);	// CMPI Pgamma Data1 packet,
	//rtd_outl(0xb80261C0, 0x00000000);	// CMPI Pgamma Data2 packet,
	//rtd_outl(0xb80261C4, 0x00000000);	// CMPI Pgamma Data3 packet,
	//rtd_outl(0xb80261C8, 0x00000000);	// CMPI Pgamma Data4 packet,
	//rtd_outl(0xb80261CC, 0x00000000);	// CMPI Pgamma Data5 packet,
	//rtd_outl(0xb80261D0, 0x00000000);	// CMPI Pgamma Data6 packet,
	//rtd_outl(0xb80261D4, 0x00000000);	// CMPI Pgamma Data7 packet,
	//rtd_outl(0xb80261D8, 0x00000000);	// CMPI Pgamma Data8 packet,
	//rtd_outl(0xb80261DC, 0x00000000);	// CMPI Pgamma Data9 packet,
	//rtd_outl(0xb8026308, 0x00000000);	// CMPI Pgamma Data10 packet,
	//rtd_outl(0xb802630C, 0x00000000);	// CMPI Pgamma Data11 packet,
	//rtd_outl(0xb8026310, 0x00000000);	// CMPI Pgamma Data12 packet,
	//rtd_outl(0xb8026314, 0x00000000);	// CMPI Pgamma Data13 packet,
	//rtd_outl(0xb8026318, 0x00000000);	// CMPI Pgamma Data14 packet,
	//rtd_outl(0xb802631C, 0x00000000);	// CMPI Pgamma Data15 packet,
	//rtd_outl(0xb8026320, 0x00000000);	// CMPI Pgamma Data16 packet,
	//rtd_outl(0xb8026324, 0x00000000);	// CMPI Pgamma Data17 packet,
	//rtd_outl(0xb8026328, 0x00000000);	// CMPI Pgamma Data18 packet,
	//rtd_outl(0xb802632C, 0x00000000);	// CMPI Pgamma Data19 packet,
	//rtd_outl(0xb8026330, 0x00000000);	// CMPI Pgamma Data20 packet,
	//rtd_outl(0xb8026334, 0x00000000);	// CMPI Pgamma Data21 packet,
	//rtd_outl(0xb8026338, 0x00000000);	// CMPI Pgamma Data22 packet,
	//rtd_outl(0xb802633C, 0x00000000);	// CMPI Pgamma Data23 packet,
	//rtd_outl(0xb8026340, 0x00000000);	// CMPI Pgamma Data24 packet,
	//rtd_outl(0xb8026344, 0x00000000);	// CMPI Pgamma Data25 packet,
	//rtd_outl(0xb8026348, 0x00000000);	// CMPI Pgamma Data26 packet,
	//rtd_outl(0xb802634C, 0x00000000);	// CMPI Pgamma Data27 packet,
	//rtd_outl(0xb8026350, 0x00000000);	// CMPI Pgamma Data28 packet,
	//rtd_outl(0xb8026354, 0x00000000);	// CMPI Pgamma Data29 packet,
	//rtd_outl(0xb8026358, 0x00000000);	// CMPI Pgamma Data30 packet,
	//rtd_outl(0xb802635C, 0x00000000);	// CMPI Pgamma Data31 packet,
	//rtd_outl(0xb8026360, 0x00000000);	// CMPI Pgamma Data32 packet,
	//rtd_outl(0xb8026364, 0x00000000);	// CMPI Pgamma Data33 packet,
	//rtd_outl(0xb8026368, 0x00000000);	// CMPI Pgamma Data34 packet,
	//rtd_outl(0xb802636C, 0x00000000);	// CMPI Pgamma Data35 packet,
	//rtd_outl(0xb8026370, 0x00000000);	// CMPI Pgamma Data36 packet,
	//rtd_outl(0xb8026374, 0x00000000);	// CMPI Pgamma Data37 packet,
	//rtd_outl(0xb8026378, 0x00000000);	// CMPI Pgamma Data38 packet,
	//rtd_outl(0xb802637C, 0x00000000);	// CMPI Pgamma Data39 packet,
	//rtd_outl(0xb8026400, 0x00000000);	// CMPI Pgamma Data40 packet,
	//rtd_outl(0xb8026404, 0x00000000);	// CMPI Pgamma Data41 packet,
	//rtd_outl(0xb8026408, 0x00000000);	// CMPI Pgamma Data42 packet,
	//rtd_outl(0xb802640C, 0x00000000);	// CMPI Pgamma Data43 packet,
	//rtd_outl(0xb8026410, 0x00000000);	// CMPI Pgamma Data44 packet,
	//rtd_outl(0xb8026414, 0x00000000);	// CMPI Pgamma Data45 packet,
	//rtd_outl(0xb8026418, 0x00000000);	// CMPI Pgamma Data46 packet,
	//rtd_outl(0xb802641C, 0x00000000);	// CMPI Pgamma Data47 packet,
	//rtd_outl(0xb8026420, 0x00000000);	// CMPI Pgamma Data48 packet,
	//rtd_outl(0xb8026424, 0x00000000);	// CMPI Pgamma Data49 packet,
	//rtd_outl(0xb8026428, 0x00000000);	// CMPI Pgamma Data50 packet,
	//rtd_outl(0xb802642C, 0x00000000);	// CMPI Pgamma Data51 packet,
	//rtd_outl(0xb8026430, 0x00000000);	// CMPI Pgamma Data52 packet,
	//rtd_outl(0xb8026434, 0x00000000);	// CMPI Pgamma Data53 packet,
	//rtd_outl(0xb8026438, 0x00000000);	// CMPI Pgamma Data54 packet,
	//rtd_outl(0xb802643C, 0x00000000);	// CMPI Pgamma Data55 packet,
	//rtd_outl(0xb8026440, 0x00000000);	// CMPI Pgamma Data56 packet,
	//rtd_outl(0xb8026444, 0x00000000);	// CMPI Pgamma Data57 packet,
	//rtd_outl(0xb8026448, 0x00000000);	// CMPI Pgamma Data58 packet,
	//rtd_outl(0xb802644C, 0x00000000);	// CMPI Pgamma Data59 packet,
	//rtd_outl(0xb80261E0, 0x00000000);	// CMPI Pgamma PG_END packet,
	rtd_outl(0xb80261E4, 0x0000003F);	// EPI MAC output Port 0~5 transmit to APHY, others disable,
	rtd_outl(0xb80261E8, 0x0000003F);	// EPI Port 0~5 extend subpixel use sfg case_a,
	rtd_outl(0xb80261EC, 0x0000003F);	// EPI constant_update_mode : EPI Port 0~5 update by TDM (for power save),
	rtd_outl(0xb80263F8, 0x00000000);	// EPI update first ctrl packet time : hs_den_io_dist + den_length (compute by hw),
	rtd_outl(0xb80263FC, 0x007D00FB);	// LOCK debounce enable and setting,
	rtd_outl(0xb80261F4, 0x0000000F);	// Check SFG output timing enable,
	rtd_outl(0xb80261FC, 0x0000000E);	// SOE LUT use 4-line repeat, SOE LUT apply to C2[17:0],
	rtd_outl(0xb8026200, 0x00007936);	// SOE line 0 LUT for lane 0,
	rtd_outl(0xb8026204, 0x00007936);	// SOE line 1 LUT for lane 0,
	rtd_outl(0xb8026208, 0x00007936);	// SOE line 2 LUT for lane 0,
	rtd_outl(0xb802620C, 0x00007936);	// SOE line 3 LUT for lane 0,
	rtd_outl(0xb8026210, 0x00007937);	// SOE line 0 LUT for lane 1,
	rtd_outl(0xb8026214, 0x00007937);	// SOE line 1 LUT for lane 1,
	rtd_outl(0xb8026218, 0x00007937);	// SOE line 2 LUT for lane 1,
	rtd_outl(0xb802621C, 0x00007937);	// SOE line 3 LUT for lane 1,
	rtd_outl(0xb8026220, 0x00007938);	// SOE line 0 LUT for lane 2,
	rtd_outl(0xb8026224, 0x00007938);	// SOE line 1 LUT for lane 2,
	rtd_outl(0xb8026228, 0x00007938);	// SOE line 2 LUT for lane 2,
	rtd_outl(0xb802622C, 0x00007938);	// SOE line 3 LUT for lane 2,
	rtd_outl(0xb8026230, 0x00007938);	// SOE line 0 LUT for lane 3,
	rtd_outl(0xb8026234, 0x00007938);	// SOE line 1 LUT for lane 3,
	rtd_outl(0xb8026238, 0x00007938);	// SOE line 2 LUT for lane 3,
	rtd_outl(0xb802623C, 0x00007938);	// SOE line 3 LUT for lane 3,
	rtd_outl(0xb8026240, 0x00007937);	// SOE line 0 LUT for lane 4,
	rtd_outl(0xb8026244, 0x00007937);	// SOE line 1 LUT for lane 4,
	rtd_outl(0xb8026248, 0x00007937);	// SOE line 2 LUT for lane 4,
	rtd_outl(0xb802624C, 0x00007937);	// SOE line 3 LUT for lane 4,
	rtd_outl(0xb8026250, 0x00007936);	// SOE line 0 LUT for lane 5,
	rtd_outl(0xb8026254, 0x00007936);	// SOE line 1 LUT for lane 5,
	rtd_outl(0xb8026258, 0x00007936);	// SOE line 2 LUT for lane 5,
	rtd_outl(0xb802625C, 0x00007936);	// SOE line 3 LUT for lane 5,
	//rtd_outl(0xb8026260, 0x00000000);	// SOE line 0 LUT for lane 6,
	//rtd_outl(0xb8026264, 0x00000000);	// SOE line 1 LUT for lane 6,
	//rtd_outl(0xb8026268, 0x00000000);	// SOE line 2 LUT for lane 6,
	//rtd_outl(0xb802626C, 0x00000000);	// SOE line 3 LUT for lane 6,
	//rtd_outl(0xb8026270, 0x00000000);	// SOE line 0 LUT for lane 7,
	//rtd_outl(0xb8026274, 0x00000000);	// SOE line 1 LUT for lane 7,
	//rtd_outl(0xb8026278, 0x00000000);	// SOE line 2 LUT for lane 7,
	//rtd_outl(0xb802627C, 0x00000000);	// SOE line 3 LUT for lane 7,
	//rtd_outl(0xb8026280, 0x00000000);	// SOE line 0 LUT for lane 8,
	//rtd_outl(0xb8026284, 0x00000000);	// SOE line 1 LUT for lane 8,
	//rtd_outl(0xb8026288, 0x00000000);	// SOE line 2 LUT for lane 8,
	//rtd_outl(0xb802628C, 0x00000000);	// SOE line 3 LUT for lane 8,
	//rtd_outl(0xb8026290, 0x00000000);	// SOE line 0 LUT for lane 9,
	//rtd_outl(0xb8026294, 0x00000000);	// SOE line 1 LUT for lane 9,
	//rtd_outl(0xb8026298, 0x00000000);	// SOE line 2 LUT for lane 9,
	//rtd_outl(0xb802629C, 0x00000000);	// SOE line 3 LUT for lane 9,
	//rtd_outl(0xb80262A0, 0x00000000);	// SOE line 0 LUT for lane 10,
	//rtd_outl(0xb80262A4, 0x00000000);	// SOE line 1 LUT for lane 10,
	//rtd_outl(0xb80262A8, 0x00000000);	// SOE line 2 LUT for lane 10,
	//rtd_outl(0xb80262AC, 0x00000000);	// SOE line 3 LUT for lane 10,
	//rtd_outl(0xb80262B0, 0x00000000);	// SOE line 0 LUT for lane 11,
	//rtd_outl(0xb80262B4, 0x00000000);	// SOE line 1 LUT for lane 11,
	//rtd_outl(0xb80262B8, 0x00000000);	// SOE line 2 LUT for lane 11,
	//rtd_outl(0xb80262BC, 0x00000000);	// SOE line 3 LUT for lane 11,
	//rtd_outl(0xb8026380, 0x00000000);	// DST(C4~C0) MUX use register config,
	//rtd_outl(0xb8026384, 0x00000000);	// DST(C9~C5) MUX use register config,
	//rtd_outl(0xb8026388, 0x00000000);	// DST(C14~C10) MUX use register config,
	//rtd_outl(0xb802638C, 0x00000000);	// DST(C19~C15) MUX use register config,
	//rtd_outl(0xb8026390, 0x00000000);	// DST(C24~C20) MUX use register config,
	//rtd_outl(0xb8026394, 0x00000000);	// DST(C29~C25) MUX use register config,
	//rtd_outl(0xb8026398, 0x00000000);	// CST(C4~C0) MUX use register config,
	//rtd_outl(0xb802639C, 0x00000000);	// CST(C9~C5) MUX use register config,
	//rtd_outl(0xb80263A0, 0x00000000);	// CST(C14~C10) MUX use register config,
	//rtd_outl(0xb80263A4, 0x00000000);	// CST(C19~C15) MUX use register config,
	//rtd_outl(0xb80263A8, 0x00000000);	// CST(C24~C20) MUX use register config,
	//rtd_outl(0xb80263AC, 0x00000000);	// CST(C29~C25) MUX use register config,
	rtd_outl(0xb80263B0, 0x00000000);	// C1(C4~C0) MUX use register config,
	rtd_outl(0xb80263B4, 0x00000210);	// C1(C9~C5) MUX use register config (C6/C7 use Tcon_A/B),
	rtd_outl(0xb80263B8, 0x0009A000);	// C1(C14~C10) MUX use register config (C13/C14 use INV4_1/2 LUT),
	rtd_outl(0xb80263BC, 0x00000078);	// C1(C19~C15) MUX use register config (C15/C16 use INV4_3/4 LUT),
	rtd_outl(0xb80263C0, 0x00000000);	// C1(C24~C20) MUX use register config,
	rtd_outl(0xb80263C4, 0x00000000);	// C1(C29~C25) MUX use register config,
	rtd_outl(0xb80263C8, 0x00000000);	// C2(C4~C0) MUX use register config,
	rtd_outl(0xb80263CC, 0x00000000);	// C2(C9~C5) MUX use register config,
	rtd_outl(0xb80263D0, 0x00000000);	// C2(C14~C10) MUX use register config,
	rtd_outl(0xb80263D4, 0x00033000);	// C2(C19~C15) MUX use register config (C18/C19 use Tcon_C/C),
	rtd_outl(0xb80263D8, 0x00004443);	// C2(C24~C20) MUX use register config (C20/C21/C22/C23 use Tcon_C/D/D/D),
	rtd_outl(0xb80263DC, 0x00000000);	// C2(C29~C25) MUX use register config,
	//rtd_outl(0xb80263E0, 0x00000000);	// C3(C4~C0) MUX use register config,
	//rtd_outl(0xb80263E4, 0x00000000);	// C3(C9~C5) MUX use register config,
	//rtd_outl(0xb80263E8, 0x00000000);	// C3(C14~C10) MUX use register config,
	//rtd_outl(0xb80263EC, 0x00000000);	// C3(C19~C15) MUX use register config,
	//rtd_outl(0xb80263F0, 0x00000000);	// C3(C24~C20) MUX use register config,
	//rtd_outl(0xb80263F4, 0x00000000);	// C3(C29~C25) MUX use register config,
	rtd_outl(0xb8026500, 0x001A1914);	// Tcon_A/B/C sel ext_tcon_20/25/26,
	rtd_outl(0xb8026504, 0x0000001B);	// Tcon_D ext_tcon_27/0/0,
	//rtd_outl(0xb8026508, 0x00000000);	// Tcon_G/H/I sel ext_tcon_0/0/0,
	//rtd_outl(0xb802650C, 0x00000000);	// Tcon_J/K sel ext_tcon_0/0,
	rtd_outl(0xb8026524, 0x00000000);	// SOE1/SOE2 LUT switch every 28 second is disbale,
						// CEDS POL in CTRL1(C6) for all lane is not invert,
						// CEDS POL2 in CTRL1(C12) for all lane is not invert,
	//rtd_outl(0xb8026528, 0x0000002A);	// DST register config value,
	//rtd_outl(0xb802653C, 0x00000015);	// CST register config value,
	//rtd_outl(0xb80266F0, 0x00000000);	// C3 register config value,
	//rtd_outl(0xb8026A60, 0x00000000);	// C4 register config value,
	//rtd_outl(0xb8026AA0, 0x00000000);	// C5 register config value,
	rtd_outl(0xb8026554, 0x00001600);	// Lane0 : C1 register config value,
	rtd_outl(0xb802655C, 0x00001600);	// Lane1 : C1 register config value,
	rtd_outl(0xb8026564, 0x00001600);	// Lane2 : C1 register config value,
	rtd_outl(0xb802656C, 0x00101600);	// Lane3 : C1 register config value,
	rtd_outl(0xb8026574, 0x00101600);	// Lane4 : C1 register config value,
	rtd_outl(0xb802657C, 0x00101600);	// Lane5 : C1 register config value,
	//rtd_outl(0xb8026584, 0x00000000);	// Lane6 : C1 register config value,
	//rtd_outl(0xb802658C, 0x00000000);	// Lane7 : C1 register config value,
	//rtd_outl(0xb8026594, 0x00000000);	// Lane8 : C1 register config value,
	//rtd_outl(0xb802659C, 0x00000000);	// Lane9 : C1 register config value,
	//rtd_outl(0xb80265A4, 0x00000000);	// Lane10: C1 register config value,
	//rtd_outl(0xb80265AC, 0x00000000);	// Lane11: C1 register config value,
	//rtd_outl(0xb8026624, 0x00000000);	// Lane0 : C2 register config value,
	//rtd_outl(0xb802662C, 0x00000000);	// Lane1 : C2 register config value,
	//rtd_outl(0xb8026634, 0x00000000);	// Lane2 : C2 register config value,
	//rtd_outl(0xb802663C, 0x00000000);	// Lane3 : C2 register config value,
	//rtd_outl(0xb8026644, 0x00000000);	// Lane4 : C2 register config value,
	//rtd_outl(0xb802664C, 0x00000000);	// Lane5 : C2 register config value,
	//rtd_outl(0xb8026654, 0x00000000);	// Lane6 : C2 register config value,
	//rtd_outl(0xb802665C, 0x00000000);	// Lane7 : C2 register config value,
	//rtd_outl(0xb8026664, 0x00000000);	// Lane8 : C2 register config value,
	//rtd_outl(0xb802666C, 0x00000000);	// Lane9 : C2 register config value,
	//rtd_outl(0xb8026674, 0x00000000);	// Lane10: C2 register config value,
	//rtd_outl(0xb802667C, 0x00000000);	// Lane11: C2 register config value,
	//rtd_outl(0xb80266F4, 0x00000000);	// Lane0 : C3 register config value,
	//rtd_outl(0xb80266FC, 0x00000000);	// Lane1 : C3 register config value,
	//rtd_outl(0xb8026704, 0x00000000);	// Lane2 : C3 register config value,
	//rtd_outl(0xb802670C, 0x00000000);	// Lane3 : C3 register config value,
	//rtd_outl(0xb8026714, 0x00000000);	// Lane4 : C3 register config value,
	//rtd_outl(0xb802671C, 0x00000000);	// Lane5 : C3 register config value,
	//rtd_outl(0xb8026724, 0x00000000);	// Lane6 : C3 register config value,
	//rtd_outl(0xb802672C, 0x00000000);	// Lane7 : C3 register config value,
	//rtd_outl(0xb8026734, 0x00000000);	// Lane8 : C3 register config value,
	//rtd_outl(0xb802673C, 0x00000000);	// Lane9 : C3 register config value,
	//rtd_outl(0xb8026744, 0x00000000);	// Lane10: C3 register config value,
	//rtd_outl(0xb802674C, 0x00000000);	// Lane11: C3 register config value,
	//rtd_outl(0xb8026450, 0x00000000);	// General propose LUT use 1 line cycle,
	//rtd_outl(0xb8026454, 0x00000000);	// General propose LUT for line 0~1,
	//rtd_outl(0xb8026458, 0x00000000);	// General propose LUT for line 2~3,
	//rtd_outl(0xb802645C, 0x00000000);	// General propose LUT for line 4~5,
	//rtd_outl(0xb8026460, 0x00000000);	// General propose LUT for line 6~7,

	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D02C, 0x00000002);	// Async FIFO use EPI Mode,
	rtd_outl(0xb802D030, 0x00000000);	// P/N Swap disable,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO disable,
	rtd_outl(0xb802D03C, 0x00030010);	// Async FIFO reset enable, adaptive reset, apply after 16-clock,
	rtd_outl(0xb802D060, 0xFFFFFFFF);	// Lane 0~3 pair assign,
	rtd_outl(0xb802D064, 0xFFFFFFFF);	// Lane 4~7 pair assign,
	rtd_outl(0xb802D068, 0xFF111213);	// Lane 8~11 pair assign,
	rtd_outl(0xb802D06C, 0x0E0F10FF);	// Lane 12~15 pair assign,
	rtd_outl(0xb802D070, 0xFFFFFFFF);	// Lane 16~19 pair assign,
	rtd_outl(0xb802D074, 0xFFFFFFFF);	// Lane 20~23 pair assign,
	rtd_outl(0xb802D078, 0xFFFFFFFF);	// Lane 24~27 pair assign,

	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080103);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(4),
	rtd_outl(0xb8000C0C, 0x8005E3B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000001);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(1), EPI_DIVM(14),
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000021);	// TXPLL use EPI feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F4C000);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C78, 0x00000100);	// CKIN_DIVN(3),

	//
	//rtd_outl(0xb8000D00, 0x77002815);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D10, 0x77002815);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D20, 0x77002815);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D30, 0x77002815);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D40, 0x77002815);	// Lane4 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D50, 0x77002815);	// Lane5 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D60, 0x77002815);	// Lane6 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D70, 0x77002815);	// Lane7 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000D80, 0x77002815);	// Lane8 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000D90, 0x66002815);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DA0, 0x66002815);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DB0, 0x66002815);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DC0, 0x66002815);	// Lane12: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DD0, 0x66002815);	// Lane13: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	rtd_outl(0xb8000DE0, 0x66002815);	// Lane14: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000DF0, 0x77002815);	// Lane15: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E00, 0x77002815);	// Lane16: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E10, 0x77002815);	// Lane17: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E20, 0x77002815);	// Lane18: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E30, 0x77002815);	// Lane19: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E40, 0x77002815);	// Lane20: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E50, 0x77002815);	// Lane21: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E60, 0x77002815);	// Lane22: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E70, 0x77002815);	// Lane23: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E80, 0x77002815);	// Lane24: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000E90, 0x77002815);	// Lane25: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000EA0, 0x77002815);	// Lane26: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),
	//rtd_outl(0xb8000EB0, 0x77002815);	// Lane27: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL(15),

	//
	rtd_outl(0xb8000D04, 0x44003006);	// Lane0 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D14, 0x44003006);	// Lane1 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D24, 0x44003006);	// Lane2 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D34, 0x44003006);	// Lane3 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D44, 0x44003006);	// Lane4 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D54, 0x44003006);	// Lane5 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D64, 0x44003006);	// Lane6 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D74, 0x44003006);	// Lane7 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D84, 0x44003006);	// Lane8 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000D94, 0x44003006);	// Lane9 : CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DA4, 0x44003006);	// Lane10: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DB4, 0x44003006);	// Lane11: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DC4, 0x44003006);	// Lane12: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DD4, 0x44003006);	// Lane13: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DE4, 0x44003006);	// Lane14: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000DF4, 0x44003006);	// Lane15: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E04, 0x44003006);	// Lane16: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E14, 0x44003006);	// Lane17: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E24, 0x44003006);	// Lane18: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E34, 0x44003006);	// Lane19: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E44, 0x44003006);	// Lane20: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E54, 0x44003006);	// Lane21: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E64, 0x44003006);	// Lane22: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E74, 0x44003006);	// Lane23: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E84, 0x44003006);	// Lane24: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000E94, 0x44003006);	// Lane25: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000EA4, 0x44003006);	// Lane26: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),
	rtd_outl(0xb8000EB4, 0x44003006);	// Lane27: CKMX_INV(0), RT_EN(1), RP_EN(1), CML1.2V, IEM_SEL(6),

	//
	rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DC8, 0x00000009);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DD8, 0x00000009);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DE8, 0x00000009);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DF8, 0x00000009);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E08, 0x00000009);	// Lane16: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E18, 0x00000009);	// Lane17: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E28, 0x00000009);	// Lane18: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E38, 0x00000009);	// Lane19: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),





	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) EPI Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x40000000);
	//
	// (8) EPI MAC Enable (Below Setting)
	rtd_part_outl(0xb802606C, 16, 16, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	//
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_outl(0xb8000CC0, 0x00007E00); //Lane 9~14 power enable

	//
	// (11) Panel Power Enable (SW Control),
	rtd_part_outl(0x1806023C, 31, 28, 0xF); 	// Pinshare LSADC4->GPIO
	rtd_outl(0x18061100, 0x40000001); 	      // LSADC4/ST_GPIO_29 DDR 1V5_1V2/PIV1V5 power
	rtd_outl(0x18061108, 0x40000001); 	      // LSADC4/ST_GPIO_29 DDR 1V5_1V2/PIV1V5 power
	rtd_outl(0x1801bd00, 0x08000081); 	// GPIO_06 (PANEL_EN)panel power control
	rtd_outl(0x1801bd18, 0x08000081); 	// GPIO_06 (PANEL_EN)panel power controlrtd_part_outl(0x18060238, 23, 20, 0xF); 	// Pinshare LSADC5-> GPIO
	rtd_outl(0x18061104, 0x00000009); 	// LSADC6/ST_GPIO_33 (BL_EN)backlight control
	rtd_outl(0x1806110C, 0x00000009); 	// LSADC6/ST_GPIO_33 (BL_EN)backlight control

	rtd_outl(0x1801bd00, 0x00000041); 	// GPIO_05(BL_ADJ) PWM control
	rtd_outl(0x1801bd18, 0x00000041); 	// GPIO_05(BL_ADJ) PWM control
}

void panel_ceds_hv490qub_uhd60_12lane_tcon_setting(void)
{
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x00100840);	// Common fifo use sfg_clk, 30-bit Mode, Dout Enable, Pre-R/B Swap disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D904, 0x05FFFFFF);	// PIF_Clock = Dclk/6, Force to background enable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00005000);	// Line 8n+0/8n+1 shift 1 sub-pixel, Line 8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00005000);	// Line 8n+4/8n+5 shift 1 sub-pixel, Line 8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x1000058B);	// SFG DRD Mode, 1.5 packet mode disable, H-Flip enable, 6-SEG, 12-Port,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	//rtd_outl(0xb802D980, 0x00000000);	// Front dummy line(4N+0) data,
	//rtd_outl(0xb802D984, 0x00000000);	// Front dummy line(4N+1) data,
	//rtd_outl(0xb802D94C, 0x00000000);	// Front dummy line(4N+2) data,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable, front_dmy_line_num(0), front_dmy_line_sel = dray_data,
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00400000);     	// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	rtd_outl(0xb802DA10, 0x00400000);     	// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00030000);     	// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00030000);     	// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00400000);     	// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00400000);     	// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00030000);     	// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00030000);     	// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	rtd_outl(0xb802DAA0, 0x01010101);	// DRD Data Mapping,
	rtd_outl(0xb802DAA4, 0x05050505);	// DRD Data Mapping,
	rtd_outl(0xb802DAA8, 0x03030303);	// DRD Data Mapping,
	rtd_outl(0xb802DAAC, 0x07070707);	// DRD Data Mapping,
	rtd_outl(0xb802DAB0, 0x0B0B0B0B);	// DRD Data Mapping,
	rtd_outl(0xb802DAB4, 0x09090909);	// DRD Data Mapping,
	rtd_outl(0xb802DAB8, 0x0D0D0D0D);	// DRD Data Mapping,
	rtd_outl(0xb802DABC, 0x11111111);	// DRD Data Mapping,
	rtd_outl(0xb802DAC0, 0x0F0F0F0F);	// DRD Data Mapping,
	rtd_outl(0xb802DAC4, 0x13131313);	// DRD Data Mapping,
	rtd_outl(0xb802DAC8, 0x17171717);	// DRD Data Mapping,
	rtd_outl(0xb802DACC, 0x15151515);	// DRD Data Mapping,
	rtd_outl(0xb802DAD0, 0x02020202);	// DRD Data Mapping,
	rtd_outl(0xb802DAD4, 0x00000000);	// DRD Data Mapping,
	rtd_outl(0xb802DAD8, 0x04040404);	// DRD Data Mapping,
	rtd_outl(0xb802DADC, 0x08080808);	// DRD Data Mapping,
	rtd_outl(0xb802DAE0, 0x06060606);	// DRD Data Mapping,
	rtd_outl(0xb802DAE4, 0x0A0A0A0A);	// DRD Data Mapping,
	rtd_outl(0xb802DAE8, 0x0E0E0E0E);	// DRD Data Mapping,
	rtd_outl(0xb802DAEC, 0x0C0C0C0C);	// DRD Data Mapping,
	rtd_outl(0xb802DAF0, 0x10101010);	// DRD Data Mapping,
	rtd_outl(0xb802DAF4, 0x14141414);	// DRD Data Mapping,
	rtd_outl(0xb802DAF8, 0x12121212);	// DRD Data Mapping,
	rtd_outl(0xb802DAFC, 0x16161616);	// DRD Data Mapping,
	rtd_outl(0xb802DB68, 0x55550000);	// ext_num setting for case_a and case_b,
	//rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E38);	// SFG Pattern Gen. Disable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	rtd_outl(0xb802DC1C, 0x00000000);	// Pattern Detect Function Disable,

	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCK Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb8000800, 0xFFFFFF0F, 0x00000070);	// GPIO_3 pinshare to epi_lock_src0,
	rtd_maskl(0xb8000CBC, 0xFFFFFFFC, 0x00000000);	// EPI_LOCK use epi_lock_src0,

	//---------------------------------------------------------------------------------------------------------------------------------
	//EPI MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb8026000, 0x00000004);	// Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026060, 0x08000002);	// EPI 1.5Gbps 8-bit mode,
	rtd_outl(0xb8026064, 0x80000001);	// EPI reset disable, CST/C3/C4/C5/DST packet disable, EPI lock HW mode,
	rtd_outl(0xb802606C, 0x40C03000);	// EPI disable, ext_num unit is sub-pixel, 12-port EPI, packet delimiter,
	//rtd_outl(0xb8026070, 0x00000645);	// CMPI CMD/DATA delimiter, run length conding delimiter,
	rtd_outl(0xb8026074, 0x00000000);	// Front/Back dummy line number,
	//rtd_outl(0xb8026078, 0x00000000);	// Front dummy line color select color_0,
	//rtd_outl(0xb802607C, 0x00000000);	// Back dummy line color select color_1,
	//rtd_outl(0xb8026080, 0x00000000);	// Dummy line color 0 (L0),
	//rtd_outl(0xb8026084, 0x00000000);	// Dummy line color 1 (L0),
	//rtd_outl(0xb8026088, 0x00000000);	// Dummy line color 2 (L0),
	//rtd_outl(0xb802608C, 0x00000000);	// Dummy line color 3 (L0),
	rtd_outl(0xb8026090, 0x0000FFF3);	// CRC Enable, select lane 0~11 to CRC,
	rtd_outl(0xb802609C, 0x00000000);	// EPI Data from SFG, EPI packet data setting,
	//rtd_outl(0xb80260A4, 0x00000071);	// INV4 LUT use 8 line cycle, POD2_INV4 initial phase select bypass (2'b00),
	//rtd_outl(0xb80260A8, 0x00000000);	// INV4 LUT for line 0~8,
	//rtd_outl(0xb80260AC, 0x00000000);	// INV4 LUT for line 9~16,
	//rtd_outl(0xb8026110, 0x00000000);	// CMPI RLC Function for 10bit mode disable,
	//rtd_outl(0xb8026114, 0x00000000);	// CMPI CDR type mode select,
	//rtd_outl(0xb8026118, 0x00000000);	// CMPI CDR clock training2 insert in type1 and type2,
	//rtd_outl(0xb802617C, 0x00000100);	// Scrambler reset/enable control by hw,
	//rtd_outl(0xb8026180, 0x00000002);	// EPI_SCR8 disable,
	//rtd_outl(0xb8026184, 0x00FFFFFF);	// EPI_SCR8 initial value,
	//rtd_outl(0xb8026188, 0x00000002);	// EPI_SCR10 disable,
	//rtd_outl(0xb802618C, 0x000FFFFF);	// EPI_SCR10 initial value,
	//rtd_outl(0xb8026190, 0x00000000);	// CMPI_SCR8 disable,
	//rtd_outl(0xb8026194, 0x00000FFF);	// CMPI_SCR8 initial value,
	//rtd_outl(0xb8026198, 0x00000000);	// CMPI_SCR10 disable,
	//rtd_outl(0xb802619C, 0x000003FF);	// CMPI_SCR10 initial value,
	//rtd_outl(0xb80261A0, 0x00000000);	// CMPI F/M/B color select, Pgamma for CMPI disable,
	//rtd_outl(0xb80261A4, 0x00000000);	// CMPI Pgamma CST packet,
	//rtd_outl(0xb80261A8, 0x00000000);	// CMPI Pgamma C1 packet,
	//rtd_outl(0xb80261AC, 0x00000000);	// CMPI Pgamma C2 packet,
	//rtd_outl(0xb80261B0, 0x00000000);	// CMPI Pgamma C3 packet,
	//rtd_outl(0xb8026300, 0x00000000);	// CMPI Pgamma C4 packet,
	//rtd_outl(0xb8026304, 0x00000000);	// CMPI Pgamma C5 packet,
	//rtd_outl(0xb80261B4, 0x00000000);	// CMPI Pgamma PG_ST packet,
	//rtd_outl(0xb80261B8, 0x00000000);	// CMPI Pgamma Data0 packet,
	//rtd_outl(0xb80261BC, 0x00000000);	// CMPI Pgamma Data1 packet,
	//rtd_outl(0xb80261C0, 0x00000000);	// CMPI Pgamma Data2 packet,
	//rtd_outl(0xb80261C4, 0x00000000);	// CMPI Pgamma Data3 packet,
	//rtd_outl(0xb80261C8, 0x00000000);	// CMPI Pgamma Data4 packet,
	//rtd_outl(0xb80261CC, 0x00000000);	// CMPI Pgamma Data5 packet,
	//rtd_outl(0xb80261D0, 0x00000000);	// CMPI Pgamma Data6 packet,
	//rtd_outl(0xb80261D4, 0x00000000);	// CMPI Pgamma Data7 packet,
	//rtd_outl(0xb80261D8, 0x00000000);	// CMPI Pgamma Data8 packet,
	//rtd_outl(0xb80261DC, 0x00000000);	// CMPI Pgamma Data9 packet,
	//rtd_outl(0xb8026308, 0x00000000);	// CMPI Pgamma Data10 packet,
	//rtd_outl(0xb802630C, 0x00000000);	// CMPI Pgamma Data11 packet,
	//rtd_outl(0xb8026310, 0x00000000);	// CMPI Pgamma Data12 packet,
	//rtd_outl(0xb8026314, 0x00000000);	// CMPI Pgamma Data13 packet,
	//rtd_outl(0xb8026318, 0x00000000);	// CMPI Pgamma Data14 packet,
	//rtd_outl(0xb802631C, 0x00000000);	// CMPI Pgamma Data15 packet,
	//rtd_outl(0xb8026320, 0x00000000);	// CMPI Pgamma Data16 packet,
	//rtd_outl(0xb8026324, 0x00000000);	// CMPI Pgamma Data17 packet,
	//rtd_outl(0xb8026328, 0x00000000);	// CMPI Pgamma Data18 packet,
	//rtd_outl(0xb802632C, 0x00000000);	// CMPI Pgamma Data19 packet,
	//rtd_outl(0xb8026330, 0x00000000);	// CMPI Pgamma Data20 packet,
	//rtd_outl(0xb8026334, 0x00000000);	// CMPI Pgamma Data21 packet,
	//rtd_outl(0xb8026338, 0x00000000);	// CMPI Pgamma Data22 packet,
	//rtd_outl(0xb802633C, 0x00000000);	// CMPI Pgamma Data23 packet,
	//rtd_outl(0xb8026340, 0x00000000);	// CMPI Pgamma Data24 packet,
	//rtd_outl(0xb8026344, 0x00000000);	// CMPI Pgamma Data25 packet,
	//rtd_outl(0xb8026348, 0x00000000);	// CMPI Pgamma Data26 packet,
	//rtd_outl(0xb802634C, 0x00000000);	// CMPI Pgamma Data27 packet,
	//rtd_outl(0xb8026350, 0x00000000);	// CMPI Pgamma Data28 packet,
	//rtd_outl(0xb8026354, 0x00000000);	// CMPI Pgamma Data29 packet,
	//rtd_outl(0xb8026358, 0x00000000);	// CMPI Pgamma Data30 packet,
	//rtd_outl(0xb802635C, 0x00000000);	// CMPI Pgamma Data31 packet,
	//rtd_outl(0xb8026360, 0x00000000);	// CMPI Pgamma Data32 packet,
	//rtd_outl(0xb8026364, 0x00000000);	// CMPI Pgamma Data33 packet,
	//rtd_outl(0xb8026368, 0x00000000);	// CMPI Pgamma Data34 packet,
	//rtd_outl(0xb802636C, 0x00000000);	// CMPI Pgamma Data35 packet,
	//rtd_outl(0xb8026370, 0x00000000);	// CMPI Pgamma Data36 packet,
	//rtd_outl(0xb8026374, 0x00000000);	// CMPI Pgamma Data37 packet,
	//rtd_outl(0xb8026378, 0x00000000);	// CMPI Pgamma Data38 packet,
	//rtd_outl(0xb802637C, 0x00000000);	// CMPI Pgamma Data39 packet,
	//rtd_outl(0xb8026400, 0x00000000);	// CMPI Pgamma Data40 packet,
	//rtd_outl(0xb8026404, 0x00000000);	// CMPI Pgamma Data41 packet,
	//rtd_outl(0xb8026408, 0x00000000);	// CMPI Pgamma Data42 packet,
	//rtd_outl(0xb802640C, 0x00000000);	// CMPI Pgamma Data43 packet,
	//rtd_outl(0xb8026410, 0x00000000);	// CMPI Pgamma Data44 packet,
	//rtd_outl(0xb8026414, 0x00000000);	// CMPI Pgamma Data45 packet,
	//rtd_outl(0xb8026418, 0x00000000);	// CMPI Pgamma Data46 packet,
	//rtd_outl(0xb802641C, 0x00000000);	// CMPI Pgamma Data47 packet,
	//rtd_outl(0xb8026420, 0x00000000);	// CMPI Pgamma Data48 packet,
	//rtd_outl(0xb8026424, 0x00000000);	// CMPI Pgamma Data49 packet,
	//rtd_outl(0xb8026428, 0x00000000);	// CMPI Pgamma Data50 packet,
	//rtd_outl(0xb802642C, 0x00000000);	// CMPI Pgamma Data51 packet,
	//rtd_outl(0xb8026430, 0x00000000);	// CMPI Pgamma Data52 packet,
	//rtd_outl(0xb8026434, 0x00000000);	// CMPI Pgamma Data53 packet,
	//rtd_outl(0xb8026438, 0x00000000);	// CMPI Pgamma Data54 packet,
	//rtd_outl(0xb802643C, 0x00000000);	// CMPI Pgamma Data55 packet,
	//rtd_outl(0xb8026440, 0x00000000);	// CMPI Pgamma Data56 packet,
	//rtd_outl(0xb8026444, 0x00000000);	// CMPI Pgamma Data57 packet,
	//rtd_outl(0xb8026448, 0x00000000);	// CMPI Pgamma Data58 packet,
	//rtd_outl(0xb802644C, 0x00000000);	// CMPI Pgamma Data59 packet,
	//rtd_outl(0xb80261E0, 0x00000000);	// CMPI Pgamma PG_END packet,
	rtd_outl(0xb80261E4, 0x00000FFF);	// EPI MAC output Port 0~11 transmit to APHY, others disable,
	rtd_outl(0xb80261E8, 0x00000FFF);	// EPI all Port extend subpixel use sfg case_a,
	rtd_outl(0xb80261EC, 0x00000FFF);	// EPI constant_update_mode : EPI Port 0~11 update by TDM (for power save),
	rtd_outl(0xb80263F8, 0x00000000);	// EPI update first ctrl packet time : hs_den_io_dist + den_length (compute by hw),
	rtd_outl(0xb80263FC, 0x007D00FB);	// LOCK debounce enable and setting,
	rtd_outl(0xb80261F4, 0x0000000F);	// Check SFG output timing enable,
	rtd_outl(0xb80261FC, 0x00000000);	// SOE LUT use 4-line repeat disable,
	//rtd_outl(0xb8026200, 0x00000000);	// SOE line 0 LUT for lane 0,
	//rtd_outl(0xb8026204, 0x00000000);	// SOE line 1 LUT for lane 0,
	//rtd_outl(0xb8026208, 0x00000000);	// SOE line 2 LUT for lane 0,
	//rtd_outl(0xb802620C, 0x00000000);	// SOE line 3 LUT for lane 0,
	//rtd_outl(0xb8026210, 0x00000000);	// SOE line 0 LUT for lane 1,
	//rtd_outl(0xb8026214, 0x00000000);	// SOE line 1 LUT for lane 1,
	//rtd_outl(0xb8026218, 0x00000000);	// SOE line 2 LUT for lane 1,
	//rtd_outl(0xb802621C, 0x00000000);	// SOE line 3 LUT for lane 1,
	//rtd_outl(0xb8026220, 0x00000000);	// SOE line 0 LUT for lane 2,
	//rtd_outl(0xb8026224, 0x00000000);	// SOE line 1 LUT for lane 2,
	//rtd_outl(0xb8026228, 0x00000000);	// SOE line 2 LUT for lane 2,
	//rtd_outl(0xb802622C, 0x00000000);	// SOE line 3 LUT for lane 2,
	//rtd_outl(0xb8026230, 0x00000000);	// SOE line 0 LUT for lane 3,
	//rtd_outl(0xb8026234, 0x00000000);	// SOE line 1 LUT for lane 3,
	//rtd_outl(0xb8026238, 0x00000000);	// SOE line 2 LUT for lane 3,
	//rtd_outl(0xb802623C, 0x00000000);	// SOE line 3 LUT for lane 3,
	//rtd_outl(0xb8026240, 0x00000000);	// SOE line 0 LUT for lane 4,
	//rtd_outl(0xb8026244, 0x00000000);	// SOE line 1 LUT for lane 4,
	//rtd_outl(0xb8026248, 0x00000000);	// SOE line 2 LUT for lane 4,
	//rtd_outl(0xb802624C, 0x00000000);	// SOE line 3 LUT for lane 4,
	//rtd_outl(0xb8026250, 0x00000000);	// SOE line 0 LUT for lane 5,
	//rtd_outl(0xb8026254, 0x00000000);	// SOE line 1 LUT for lane 5,
	//rtd_outl(0xb8026258, 0x00000000);	// SOE line 2 LUT for lane 5,
	//rtd_outl(0xb802625C, 0x00000000);	// SOE line 3 LUT for lane 5,
	//rtd_outl(0xb8026260, 0x00000000);	// SOE line 0 LUT for lane 6,
	//rtd_outl(0xb8026264, 0x00000000);	// SOE line 1 LUT for lane 6,
	//rtd_outl(0xb8026268, 0x00000000);	// SOE line 2 LUT for lane 6,
	//rtd_outl(0xb802626C, 0x00000000);	// SOE line 3 LUT for lane 6,
	//rtd_outl(0xb8026270, 0x00000000);	// SOE line 0 LUT for lane 7,
	//rtd_outl(0xb8026274, 0x00000000);	// SOE line 1 LUT for lane 7,
	//rtd_outl(0xb8026278, 0x00000000);	// SOE line 2 LUT for lane 7,
	//rtd_outl(0xb802627C, 0x00000000);	// SOE line 3 LUT for lane 7,
	//rtd_outl(0xb8026280, 0x00000000);	// SOE line 0 LUT for lane 8,
	//rtd_outl(0xb8026284, 0x00000000);	// SOE line 1 LUT for lane 8,
	//rtd_outl(0xb8026288, 0x00000000);	// SOE line 2 LUT for lane 8,
	//rtd_outl(0xb802628C, 0x00000000);	// SOE line 3 LUT for lane 8,
	//rtd_outl(0xb8026290, 0x00000000);	// SOE line 0 LUT for lane 9,
	//rtd_outl(0xb8026294, 0x00000000);	// SOE line 1 LUT for lane 9,
	//rtd_outl(0xb8026298, 0x00000000);	// SOE line 2 LUT for lane 9,
	//rtd_outl(0xb802629C, 0x00000000);	// SOE line 3 LUT for lane 9,
	//rtd_outl(0xb80262A0, 0x00000000);	// SOE line 0 LUT for lane 10,
	//rtd_outl(0xb80262A4, 0x00000000);	// SOE line 1 LUT for lane 10,
	//rtd_outl(0xb80262A8, 0x00000000);	// SOE line 2 LUT for lane 10,
	//rtd_outl(0xb80262AC, 0x00000000);	// SOE line 3 LUT for lane 10,
	//rtd_outl(0xb80262B0, 0x00000000);	// SOE line 0 LUT for lane 11,
	//rtd_outl(0xb80262B4, 0x00000000);	// SOE line 1 LUT for lane 11,
	//rtd_outl(0xb80262B8, 0x00000000);	// SOE line 2 LUT for lane 11,
	//rtd_outl(0xb80262BC, 0x00000000);	// SOE line 3 LUT for lane 11,
	//rtd_outl(0xb8026380, 0x00000000);	// DST(C4~C0) MUX use register config,
	//rtd_outl(0xb8026384, 0x00000000);	// DST(C9~C5) MUX use register config,
	//rtd_outl(0xb8026388, 0x00000000);	// DST(C14~C10) MUX use register config,
	//rtd_outl(0xb802638C, 0x00000000);	// DST(C19~C15) MUX use register config,
	//rtd_outl(0xb8026390, 0x00000000);	// DST(C24~C20) MUX use register config,
	//rtd_outl(0xb8026394, 0x00000000);	// DST(C29~C25) MUX use register config,
	//rtd_outl(0xb8026398, 0x00000000);	// CST(C4~C0) MUX use register config,
	//rtd_outl(0xb802639C, 0x00000000);	// CST(C9~C5) MUX use register config,
	//rtd_outl(0xb80263A0, 0x00000000);	// CST(C14~C10) MUX use register config,
	//rtd_outl(0xb80263A4, 0x00000000);	// CST(C19~C15) MUX use register config,
	//rtd_outl(0xb80263A8, 0x00000000);	// CST(C24~C20) MUX use register config,
	//rtd_outl(0xb80263AC, 0x00000000);	// CST(C29~C25) MUX use register config,
	rtd_outl(0xb80263B0, 0x00000000);	// C1(C4~C0) MUX use register config,
	rtd_outl(0xb80263B4, 0x00002040);	// C1(C9~C5) MUX use register config (C6/C7 use Tcon_A/B),
	rtd_outl(0xb80263B8, 0x00003000);	// C1(C14~C10) MUX use register config (C12 use Tcon_C),
	rtd_outl(0xb80263BC, 0x00000000);	// C1(C19~C15) MUX use register config,
	rtd_outl(0xb80263C0, 0x00000000);	// C1(C24~C20) MUX use register config,
	rtd_outl(0xb80263C4, 0x00000000);	// C1(C29~C25) MUX use register config,
	rtd_outl(0xb80263C8, 0x00000000);	// C2(C4~C0) MUX use register config,
	rtd_outl(0xb80263CC, 0x00000000);	// C2(C9~C5) MUX use register config,
	rtd_outl(0xb80263D0, 0x00000000);	// C2(C14~C10) MUX use register config,
	rtd_outl(0xb80263D4, 0x00000000);	// C2(C19~C15) MUX use register config,
	rtd_outl(0xb80263D8, 0x00000000);	// C2(C24~C20) MUX use register config,
	rtd_outl(0xb80263DC, 0x00000000);	// C2(C29~C25) MUX use register config,
	//rtd_outl(0xb80263E0, 0x00000000);	// C3(C4~C0) MUX use register config,
	//rtd_outl(0xb80263E4, 0x00000000);	// C3(C9~C5) MUX use register config,
	//rtd_outl(0xb80263E8, 0x00000000);	// C3(C14~C10) MUX use register config,
	//rtd_outl(0xb80263EC, 0x00000000);	// C3(C19~C15) MUX use register config,
	//rtd_outl(0xb80263F0, 0x00000000);	// C3(C24~C20) MUX use register config,
	//rtd_outl(0xb80263F4, 0x00000000);	// C3(C29~C25) MUX use register config,
	rtd_outl(0xb8026500, 0x00131914);	// Tcon_A/B/C sel ext_tcon_20/25/19,
	//rtd_outl(0xb8026504, 0x00000000);	// Tcon_D/E/F sel ext_tcon_0/0/0,
	//rtd_outl(0xb8026508, 0x00000000);	// Tcon_G/H/I sel ext_tcon_0/0/0,
	//rtd_outl(0xb802650C, 0x00000000);	// Tcon_J/K sel ext_tcon_0/0,
	//rtd_outl(0xb8026528, 0x0000002A);	// DST register config value,
	//rtd_outl(0xb802653C, 0x00000015);	// CST register config value,
	//rtd_outl(0xb80266F0, 0x00000000);	// C3 register config value,
	//rtd_outl(0xb8026A60, 0x00000000);	// C4 register config value,
	//rtd_outl(0xb8026AA0, 0x00000000);	// C5 register config value,
	rtd_outl(0xb8026554, 0x00142800);	// Lane0 : C1 register config value,
	rtd_outl(0xb802655C, 0x00142800);	// Lane1 : C1 register config value,
	rtd_outl(0xb8026564, 0x00142800);	// Lane2 : C1 register config value,
	rtd_outl(0xb802656C, 0x00142800);	// Lane3 : C1 register config value,
	rtd_outl(0xb8026574, 0x00142800);	// Lane4 : C1 register config value,
	rtd_outl(0xb802657C, 0x00142800);	// Lane5 : C1 register config value,
	rtd_outl(0xb8026584, 0x00142800);	// Lane6 : C1 register config value,
	rtd_outl(0xb802658C, 0x00142800);	// Lane7 : C1 register config value,
	rtd_outl(0xb8026594, 0x00142800);	// Lane8 : C1 register config value,
	rtd_outl(0xb802659C, 0x00142800);	// Lane9 : C1 register config value,
	rtd_outl(0xb80265A4, 0x00142800);	// Lane10 : C1 register config value,
	rtd_outl(0xb80265AC, 0x00142800);	// Lane11 : C1 register config value,
	rtd_outl(0xb8026624, 0x00002C8F);	// Lane0 : C2 register config value,
	rtd_outl(0xb802662C, 0x00002C8F);	// Lane1 : C2 register config value,
	rtd_outl(0xb8026634, 0x00002C8F);	// Lane2 : C2 register config value,
	rtd_outl(0xb802663C, 0x00002C8F);	// Lane3 : C2 register config value,
	rtd_outl(0xb8026644, 0x00002C8F);	// Lane4 : C2 register config value,
	rtd_outl(0xb802664C, 0x00002C8F);	// Lane5 : C2 register config value,
	rtd_outl(0xb8026654, 0x00002C8F);	// Lane6 : C2 register config value,
	rtd_outl(0xb802665C, 0x00002C8F);	// Lane7 : C2 register config value,
	rtd_outl(0xb8026664, 0x00002C8F);	// Lane8 : C2 register config value,
	rtd_outl(0xb802666C, 0x00002C8F);	// Lane9 : C2 register config value,
	rtd_outl(0xb8026674, 0x00002C8F);	// Lane10 : C2 register config value,
	rtd_outl(0xb802667C, 0x00002C8F);	// Lane11 : C2 register config value,
	//rtd_outl(0xb8026450, 0x00000000);	// General propose LUT use 1 line cycle,
	//rtd_outl(0xb8026454, 0x00000000);	// General propose LUT for line 0~1,
	//rtd_outl(0xb8026458, 0x00000000);	// General propose LUT for line 2~3,
	//rtd_outl(0xb802645C, 0x00000000);	// General propose LUT for line 4~5,
	//rtd_outl(0xb8026460, 0x00000000);	// General propose LUT for line 6~7,
	//rtd_outl(0xb8026464, 0x00000000);	// General propose LUT for line 8~9,
	//rtd_outl(0xb8026468, 0x00000000);	// General propose LUT for line 10~11,
	//rtd_outl(0xb802646C, 0x00000000);	// General propose LUT for line 12~13,
	//rtd_outl(0xb8026470, 0x00000000);	// General propose LUT for line 14~15,

	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D02C, 0x00000002);	// Async FIFO use EPI Mode, P/N Swap Disable,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO Disable,
	rtd_outl(0xb802D03C, 0x00050010);	// Async FIFO reset enable, r/w collision reset, apply after 16-clock,
	rtd_outl(0xb802D060, 0xFFFFFFFF);	// Lane 0~3 pair assign,
	rtd_outl(0xb802D064, 0xFFFFFFFF);	// Lane 4~7 pair assign,
	rtd_outl(0xb802D068, 0x0C0D0A0B);	// Lane 8~11 pair assign,
	rtd_outl(0xb802D06C, 0x08091213);	// Lane 12~15 pair assign,
	rtd_outl(0xb802D070, 0x10110E0F);	// Lane 16~19 pair assign,
	rtd_outl(0xb802D074, 0xFFFFFFFF);	// Lane 20~23 pair assign,
	rtd_outl(0xb802D078, 0xFFFFFFFF);	// Lane 24~27 pair assign,

	//---------------------------------------------------------------------------------------------------------------------------------
	//VBy1 APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080101);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(2),
	rtd_outl(0xb8000C0C, 0x8005E3B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000101);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(2), EPI_DIVM(14),
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000021);	// TXPLL use EPI feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F4C000);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C78, 0x00000400);	// CKIN_DIVN(6),
	//
	rtd_outl(0xb8000D00, 0x77002000);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D10, 0x77002000);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D20, 0x77002000);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D30, 0x77002000);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D40, 0x77002000);	// Lane4 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D50, 0x77002000);	// Lane5 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D60, 0x77002000);	// Lane6 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D70, 0x77002000);	// Lane7 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D80, 0x66002852);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D90, 0x66002852);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DA0, 0x66002852);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DB0, 0x66002852);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DC0, 0x66002852);	// Lane12: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DD0, 0x66002852);	// Lane13: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E00, 0x66002852);	// Lane14: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E10, 0x66002852);	// Lane15: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E20, 0x66002852);	// Lane16: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E30, 0x66002852);	// Lane17: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E40, 0x66002852);	// Lane18: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E50, 0x66002852);	// Lane19: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E60, 0x77002000);	// Lane20: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E70, 0x77002000);	// Lane21: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E80, 0x77002000);	// Lane22: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E90, 0x77002000);	// Lane23: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EA0, 0x77002000);	// Lane24: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EB0, 0x77002000);	// Lane25: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EC0, 0x77002000);	// Lane26: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000ED0, 0x77002000);	// Lane27: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	//
	rtd_outl(0xb8000D04, 0x44000008);	// Lane0 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D14, 0x44000008);	// Lane1 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D24, 0x44000008);	// Lane2 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D34, 0x44000008);	// Lane3 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D44, 0x44000008);	// Lane4 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D54, 0x44000008);	// Lane5 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D64, 0x44000008);	// Lane6 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D74, 0x44000008);	// Lane7 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D84, 0x44023000);	// Lane8 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000D94, 0x44023000);	// Lane9 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000DA4, 0x44023000);	// Lane10: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000DB4, 0x44023000);	// Lane11: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000DC4, 0x44023000);	// Lane12: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000DD4, 0x44023000);	// Lane13: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E04, 0x44023000);	// Lane14: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E14, 0x44023000);	// Lane15: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E24, 0x44023000);	// Lane16: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E34, 0x44023000);	// Lane17: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E44, 0x44023000);	// Lane18: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E54, 0x44023000);	// Lane19: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E64, 0x44000008);	// Lane20: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E74, 0x44000008);	// Lane21: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E84, 0x44000008);	// Lane22: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E94, 0x44000008);	// Lane23: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EA4, 0x44000008);	// Lane24: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EB4, 0x44000008);	// Lane25: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EC4, 0x44000008);	// Lane26: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000ED4, 0x44000008);	// Lane27: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	//
	rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DC8, 0x00000009);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DD8, 0x00000009);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E08, 0x00000009);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E18, 0x00000009);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E28, 0x00000009);	// Lane16: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E38, 0x00000009);	// Lane17: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E48, 0x00000009);	// Lane18: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E58, 0x00000009);	// Lane19: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) EPI Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x40000000);
	//
	// (8) EPI MAC Enable (Below Setting)
	rtd_part_outl(0xb802606C, 16, 16, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_part_outl(0xb8000D84, 27, 27, 0x1);	// LANE8
	rtd_part_outl(0xb8000D94, 27, 27, 0x1);	// LANE9
	rtd_part_outl(0xb8000DA4, 27, 27, 0x1);	// LANE10
	rtd_part_outl(0xb8000DB4, 27, 27, 0x1);	// LANE11
	rtd_part_outl(0xb8000DC4, 27, 27, 0x1);	// LANE12
	rtd_part_outl(0xb8000DD4, 27, 27, 0x1);	// LANE13
	rtd_part_outl(0xb8000E04, 27, 27, 0x1);	// LANE14
	rtd_part_outl(0xb8000E14, 27, 27, 0x1);	// LANE15
	rtd_part_outl(0xb8000E24, 27, 27, 0x1);	// LANE16
	rtd_part_outl(0xb8000E34, 27, 27, 0x1);	// LANE17
	rtd_part_outl(0xb8000E44, 27, 27, 0x1);	// LANE18
	rtd_part_outl(0xb8000E54, 27, 27, 0x1);	// LANE19
	//
	// (11) Panel Power Enable (SW Control),
}

#ifdef CONFIG_TCONLESS_BOE_CEDS
void panel_ceds_BOE_43UHD60HZ_12lane_8b_DualGate_tcon_setting(void)
{
        //tcon_ceds_43inch_uhd_60hz_12lane_8b_Dual_Gate_SONY.tbl
        // Tcon Pinshare Setting,
        rtd_part_outl(0xb8000804, 31, 28, 0x5);		// gpio_4 for STV1, use Tcon10, 0x4/5/6/7/8_TCON_9/10/11/12/17
        rtd_part_outl(0xb8000814, 23, 20, 0x4);		// gpio_21 for ON_CLK, use Tcon21, 0x4/5/6/7/8_TCON_21/22/23/24
        rtd_part_outl(0xb800080C, 15, 12, 0x5);		// gpio_14 for OFF_CLK, use Tcon0, 0x4/5/6/7_TCON_20/0/1/2
        rtd_part_outl(0xb8000808, 31, 28, 0x4);		// gpio_08 for LC, use Tcon17, 0x4/5/6/7/8_TCON_17/18/19/20

        rtd_outl(0xb802D208, 0x00000000);		// Global Tcon disable,

        ////////////////////////////////////////////////////////////////////////////
        // STV1, GPIO_4, Tcon10,
        rtd_outl(0xb802D350, 0x06D606D6);		// H_start/H_end,
        rtd_outl(0xb802D354, 0x0053005A);		// V_start/V_end,
        rtd_outl(0xb802D358, 0x00000180);		// Control,
        ////////////////////////////////////////////////////////////////////////////

        ////////////////////////////////////////////////////////////////////////////
        // ON_CLK, GPIO_21, Tcon21,
        rtd_outl(0xb802D4B0, 0x06A400F2);		// H_start/H_end,
        rtd_outl(0xb802D4B4, 0x00571137);		// V_start/V_end,
        rtd_outl(0xb802D4B8, 0x00000280);		// Control,
        ////////////////////////////////////////////////////////////////////////////

        ////////////////////////////////////////////////////////////////////////////
        // OFF_CLK, GPIO_14, Tcon0,
        rtd_outl(0xb802D210, 0x06A400F2);		// H_start/H_end,
        rtd_outl(0xb802D214, 0x005b113b);		// V_start/V_end,
        rtd_outl(0xb802D218, 0x00000280);		// Control,

        ////////////////////////////////////////////////////////////////////////////

        // LC, GPIO_04 Tcon9,
        // TCON14,
        //rtd_outl(0xb802D3D0, 0x0A2C0A2C);		// H_start/H_end,
        //rtd_outl(0xb802D3D4, 0x08AF08AF);		// V_start/V_end,
        //rtd_outl(0xb802D3D8, 0x00000480);		// Control,
        //rtd_outl(0xb802D3E0, 0x000000B3);		// Across Frame Period,
        // Tcon17, GPIO_08
        rtd_outl(0xb802D430, 0x07f007f0);		// H_start/H_end,
        rtd_outl(0xb802D434, 0x00130013);		// V_start/V_end,
        rtd_outl(0xb802D438, 0x00000480);		// Control,
        rtd_outl(0xb802D440, 0x00fa00fa);		// Across Frame Period,

        ////////////////////////////////////////////////////////////////////////////
        // POL, TCON19/Tcon20,
        // Tcon18,
        rtd_outl(0xb802D450, 0x00500100);		// H_start/H_end,
        rtd_outl(0xb802D454, 0x00000001);		// V_start/V_end,
        rtd_outl(0xb802D458, 0x00000180);		// Control,
        // Tcon19 (POL2),
        rtd_outl(0xb802D470, 0x044C044C);		// H_start/H_end,
        rtd_outl(0xb802D474, 0x00010001);		// V_start/V_end,
        rtd_outl(0xb802D478, 0x00000480);		// Control,
        rtd_outl(0xb802D480, 0x00000000);		// Across Frame Period,
        // Tcon20 (POL1),
        rtd_outl(0xb802D490, 0x044C044C);		// H_start/H_end,
        rtd_outl(0xb802D494, 0x00010001);		// V_start/V_end,
        rtd_outl(0xb802D498, 0x00000480);		// Control,
        //rtd_outl(0xb802D494, 0x00011180);		// V_start/V_end,
        //rtd_outl(0xb802D498, 0x00000183);		// Control,
        ////////////////////////////////////////////////////////////////////////////

        // CS0, Tcon24,
        // Tcon24,
        rtd_outl(0xb802D510, 0x00500100);		// H_start/H_end,
        rtd_outl(0xb802D514, 0x00000001);		// V_start/V_end,
        rtd_outl(0xb802D518, 0x00000180);		// Control,
        ////////////////////////////////////////////////////////////////////////////
        // GSP, Tcon25,
        // Tcon25,
        rtd_outl(0xb802D530, 0x044C044C);		// H_start/H_end,
        rtd_outl(0xb802D534, 0x00570058);		// V_start/V_end,
        rtd_outl(0xb802D538, 0x00000180);		// Control,
        ////////////////////////////////////////////////////////////////////////////
        // DE (Tcon8, TCLK), for debug,
        //rtd_outl(0xb802D310, 0x008C080C);		// H_start/H_end,
        //rtd_outl(0xb802D314, 0x005A113A);		// V_start/V_end,
        //rtd_outl(0xb802D318, 0x00000180);		// Control,
        ////////////////////////////////////////////////////////////////////////////

        rtd_part_outl(0xb802D208, 1, 1, 0x1);		// Across frame and Across line 3 enable,
        rtd_part_outl(0xb802D208, 0, 0, 0x1);		// Global Tcon enable,

        //ceds_43inch_uhd_60hz_12lane_8b_Dual_Gate_SONY.tbl"
        //---------------------------------------------------------------------------------------------------------------------------------
        //SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
        //---------------------------------------------------------------------------------------------------------------------------------
        // ----------------------- Insert Dummy Line Function & Auto Config SFG Timing Gen -----------------------
        rtd_outl(0xb802D988,0x40100090);	// bypass SFG disable[31], auto config sfg timing gen [30], insert dummy line[22:20]/[18:16]/[14:12]/[10:8], downsample v disable [0]
        rtd_outl(0xb802D980,0x00000000);	// gray dummy line data 0 [29:0]
        rtd_outl(0xb802D984,0x00000000);	// gray dummy line data 1 [29:0]
        rtd_outl(0xb802D94C,0x00000000);	// gray dummy line data 2 [29:0]
        rtd_outl(0xb802DA28,0x00000000);	// gray dummy line data 3 [29:0]
        rtd_outl(0xb802DA24,0x00000000);	// dummy line data selection

        // ----------------------- SFG Timing -----------------------
        rtd_outl(0xb802D900,0x01100040);	// tcon_clk=dclk [27], sfg_clk=dclk [26], SFG_OSD path disable[25], SFG path enable [24],
        	// fixed DTG last line hsync period [22], any to any subpixel disable [21], PIF clk selection epi/lvds [18],
        	// pre rb swap disable[17], display 30bit RGB mode[13:12], dclk/aclk enable [6], post rb swap disable[5],
        rtd_outl(0xb802D9B8,0x00000000);	// PIF clock enable / disable control (LVDS/LVDS[31], EPI[30], Vby1[29], Vby1 OSD[28], P2P[15], iSP[14], USIT[13]), Data inverse disable [16],
        rtd_outl(0xb802D950,0x089D002D);	// Dv_den_end[29:16] = 2205, Dv_den_sta[13:0] = 45
        rtd_outl(0xb802D954,0x10180118);	// Dh_den_end[29:16] = 4120, Dh_den_sta[13:0] = 280
        rtd_outl(0xb802D958,0x057F112F);	// Dv_width[31:24] = 5, Dh_width[23:16] = 127, Dh_total[12:0] = 4399
        rtd_outl(0xb802D99C,0x07800000);	// Final Line Length[28:16] = 1920
        rtd_outl(0xb802D9A0,0x00000000);	// Residue_pix_split_mode[18:16], Final_addr_split_mode[12:0],
        rtd_outl(0xb802D9A4,0x008C1128);	// hs_den_io_dist (auto config)[28:16], hs_io_dist (auto config)[12:0]
        rtd_outl(0xb802D98C,0x00000000);	// hsync_width(auto config)[23:16], hsync_delay(auto config)[15:0]
        rtd_outl(0xb802D990,0x08980300);	// Hs_distance (for DRD&RGB Split mode) [29:16], vsync_end(auto config)[15:8], vsync_start(auto config)[7:0]
        rtd_outl(0xb802D994,0x00000000);	// sfg_dh_den_sta (auto config)[31:16], req_start (auto config)[15:0]

        // ------------------------ Force SFG Data as background color -------------------------
        rtd_outl(0xb802D928,0x00000000);	// bypass sfg data[31], dif background R [29:30], G[19:10], B[9:0]
        rtd_outl(0xb802D904,0x05FFFF00);	// PIF_Clock = Dclk / (5+1) [27:24], Force A~P port to background enable [23][22]...[8]

        // ------------------------ SFG Control -------------------------
        rtd_outl(0xb802D964,0x1000058B);	// SFG DRD mode[29:28], 1 pixel mode[17:16], 5+1 Segment[12:8], H-Flip enable[7], 11+1 Port[4:0]
        rtd_outl(0xb802D910,0x00000003);	// CRC normal mode[31], CRC continuous mode [1], CRC control start[0]

        // -------------------------- Segment Setting ---------------------------
        rtd_outl(0xb802D968,0x00000280);	// Seg 0 Start [28:16] = 0, Seg 1 Start [12:0] = 640
        rtd_outl(0xb802D96C,0x05000780);	// Seg 2 Start [28:16] = 1280, Seg 3 Start [12:0] = 1920
        rtd_outl(0xb802D970,0x0A000C80);	// Seg 4 Start [28:16] = 2560, Seg 5 Start [12:0] = 3200
        rtd_outl(0xb802D998,0x00000000);	// Segment 15~0 Flip [15][14]?�[0]
        rtd_outl(0xb802DA94,0x00000000);	// Line 0 last segment start [28:16] = 0, Line 1 last segment start [12:0] = 0
        rtd_outl(0xb802DA98,0x00000000);	// Line 2 last segment start [28:16] = 0, Line 3 last segment start [12:0] = 0
        rtd_outl(0xb802DBE0,0x00000000);	// Line 4 last segment start [28:16] = 0, Line 5 last segment start [12:0] = 0
        rtd_outl(0xb802DBE4,0x00000000);	// Line 6 last segment start [28:16] = 0, Line 7 last segment start [12:0] = 0

        // -------------------------- Zig-Zag Mode ---------------------------
        rtd_outl(0xb802D92C,0x00001100);	// 8n+0~8n+3 line ZZ mode control
        rtd_outl(0xb802DBA8,0x00001100);	// 8n+4~8n+7 line ZZ mode control
        rtd_outl(0xb802DA0C,0x00000000);	// 8n+0 line ZZ mode virtual dummy content selection, virtual duumy selection
        rtd_outl(0xb802DA10,0x00000000);	// 8n+1 line ZZ mode virtual dummy content selection
        rtd_outl(0xb802DA14,0x00000000);	// 8n+2 line ZZ mode virtual dummy content selection
        rtd_outl(0xb802DA18,0x00000000);	// 8n+3 line ZZ mode virtual dummy content selection
        rtd_outl(0xb802DBAC,0x00000000);	// 8n+4 line ZZ mode virtual dummy content selection
        rtd_outl(0xb802DBB0,0x00000000);	// 8n+5 line ZZ mode virtual dummy content selection
        rtd_outl(0xb802DBB4,0x00000000);	// 8n+6 line ZZ mode virtual dummy content selection
        rtd_outl(0xb802DBB8,0x00000000);	// 8n+7 line ZZ mode virtual dummy content selection

        // -------------------------- Add Segment dummy front / back pixels or mid subpixel ---------------------------
        rtd_outl(0xb802D930,0x00000000);	// Seg 0 / Seg 1 Line 0~3 front/back dummy pixel number
        rtd_outl(0xb802D934,0x00000000);	// Seg 2 / Seg 3 Line 0~3 front/back dummy pixel number
        rtd_outl(0xb802D938,0x00000000);	// Seg 4 / Seg 5 Line 0~3 front/back dummy pixel number
        rtd_outl(0xb802D9E8,0x00000000);	// Seg 0 / Seg 1 place and number of middle dummy subpixel
        rtd_outl(0xb802D9EC,0x00000000);	// Seg 2 / Seg 3 place and number of middle dummy subpixel
        rtd_outl(0xb802D9F0,0x00000000);	// Seg 4 / Seg 5 place and number of middle dummy subpixel
        rtd_outl(0xb802DA1C,0x00000000);	// front/back/middle dummy content [28], double buffer[20]

        // -------------------------- DRD Mode ---------------------------
        rtd_outl(0xb802DAA0,0x01010101);	// Subpixel R0 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAA4,0x05050505);	// Subpixel G0 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAA8,0x03030303);	// Subpixel B0 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAAC,0x07070707);	// Subpixel R2 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAB0,0x0B0B0B0B);	// Subpixel G2 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAB4,0x09090909);	// Subpixel B2 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAB8,0x0D0D0D0D);	// Subpixel R4 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DABC,0x11111111);	// Subpixel G4 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAC0,0x0F0F0F0F);	// Subpixel B4 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAC4,0x13131313);	// Subpixel R6 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAC8,0x17171717);	// Subpixel G6 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DACC,0x15151515);	// Subpixel B6 of 1st output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAD0,0x02020202);	// Subpixel R1 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAD4,0x00000000);	// Subpixel G1 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAD8,0x04040404);	// Subpixel B1 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DADC,0x08080808);	// Subpixel R3 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAE0,0x06060606);	// Subpixel G3 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAE4,0x0A0A0A0A);	// Subpixel B3 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAE8,0x0E0E0E0E);	// Subpixel R5 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAEC,0x0C0C0C0C);	// Subpixel G5 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAF0,0x10101010);	// Subpixel B5 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAF4,0x14141414);	// Subpixel R7 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAF8,0x12121212);	// Subpixel G7 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode
        rtd_outl(0xb802DAFC,0x16161616);	// Subpixel B7 of 2nd output line corresponding to input line 8n+0~8n+7 of DRD mode

        // -------------------------- FW Setting for EPI ---------------------------
        rtd_outl(0xb802DB68,0x11111111);	// Firmware setting for EPI ext_sub_pixel_a setting
        rtd_outl(0xb802DB6C,0x00000000);	// Firmware setting for EPI ext_sub_pixel_b setting

        //Merlin6 can't find below register
        rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel

        // -------------------------- SFG_Pattern Generate ---------------------------
        rtd_outl(0xb802DBF0,0x1DF10E00);	// width[28:20] = 479+1, height[16:8] = 270+1, [5] pattern reset by hs, [3] rgb mode, [2:1] v color bar, [0] SFG ptn gen disable
        rtd_outl(0xb802DBF4,0x00FFFFFF);	// color bar 0 content W[31:24], R[23:16], G[15:8], B[7:0]
        rtd_outl(0xb802DBF8,0x00FFFF00);	// color bar 1 content W[31:24], R[23:16], G[15:8], B[7:0]
        rtd_outl(0xb802DBFC,0x0000FFFF);	// color bar 2 content W[31:24], R[23:16], G[15:8], B[7:0]
        rtd_outl(0xb802DC00,0x0000FF00);	// color bar 3 content W[31:24], R[23:16], G[15:8], B[7:0]
        rtd_outl(0xb802DC04,0x00FF00FF);	// color bar 4 content W[31:24], R[23:16], G[15:8], B[7:0]
        rtd_outl(0xb802DC08,0x00FF0000);	// color bar 5 content W[31:24], R[23:16], G[15:8], B[7:0]
        rtd_outl(0xb802DC0C,0x000000FF);	// color bar 6 content W[31:24], R[23:16], G[15:8], B[7:0]
        rtd_outl(0xb802DC10,0x00000000);	// color bar 7 content W[31:24], R[23:16], G[15:8], B[7:0]

        // -------------------------- SFG_Pattern Detect ---------------------------
        rtd_outl(0xb802DC38,0x00000000);	// frame thershold [15:8], pattern detection disable

        // -------------------------- PIF FIFO Control ---------------------------
        rtd_outl(0xb802DC94,0x20000000);	// PIF_FIFO disable[31], TX PHY EPI mode[30:28]
        rtd_outl(0xb802DC98,0x9C00FFFF);	// PIF_FIFO auto reset enable [31] ,Lane 15~0 [15:0] enable / disable control
        rtd_outl(0xb802DC9C,0x456789AB);	// Lane 7~0 pair assign
        rtd_outl(0xb802DCA0,0xFFFF0123);	// Lane 15~8 pair assign
        rtd_outl(0xb802DCA4,0x00000000);	// BIST_FIFO disable[31]
        rtd_outl(0xb802DCC8,0x00000FFF);	// 16 lane video[30:28], phy lane15~0 enable / disable control [15:0]
        rtd_outl(0xb802DCCC,0x00000000);	// fix pattern disable [31], fix pattern content [26:0]
        rtd_outl(0xb802DCD0,0x0000FFFF);	// Lane 15~0  [15:0] PN swap disable / enable control
        rtd_outl(0xb802DCD4,0x00000000);	// send prbs to phy disable, PRBS7 mode

        rtd_part_outl(0xb802D900, 11, 11, 0x1);	// SFG out enable

        //---------------------------------------------------------------------------------------------------------------------------------
        //LOCK Pin share
        //---------------------------------------------------------------------------------------------------------------------------------
        rtd_maskl(0xb800081C, 0x0FFFFFFF, 0x70000000);	// GPIO_28 pinshare to epi_lock_src1,
        rtd_maskl(0xb8000CBC, 0xFFFFFFFC, 0x00000001);	// EPI_LOCK use epi_lock_src1,
        rtd_maskl(0xb8000824, 0xEFFFFFFF, 0x10000000);	// GPIO_28 use 1.8V GPI,

        //---------------------------------------------------------------------------------------------------------------------------------
        //EPI MAC
        //---------------------------------------------------------------------------------------------------------------------------------
        rtd_outl(0xb8026060, 0x08000000);	// EPI 1.5Gbps 8-bit mode,
        rtd_outl(0xb8026064, 0x80000001);	// EPI reset disable, CST/C3/C4/C5/DST packet disable, EPI lock HW mode,
        rtd_outl(0xb802606C, 0x40C03000);	// EPI disable, ext_num unit is sub-pixel, 12-port EPI, packet delimiter,
        rtd_outl(0xb8026090, 0x0000FFF3);	// CRC Enable, select lane 0~11 to CRC,
        rtd_outl(0xb802609C, 0x00000000);	// EPI Data from SFG, EPI packet data setting,
        //rtd_outl(0xb80260A4, 0x00000071);	// INV4 LUT use 8 line cycle, POD2_INV4 initial phase select bypass (2'b00),
        //rtd_outl(0xb80260A8, 0x00000000);	// INV4 LUT for line 0~8,
        //rtd_outl(0xb80260AC, 0x00000000);	// INV4 LUT for line 9~16,
        //rtd_outl(0xb802617C, 0x00000100);	// Scrambler reset/enable control by hw,
        //rtd_outl(0xb8026180, 0x00000002);	// EPI_SCR8 disable,
        //rtd_outl(0xb8026184, 0x00FFFFFF);	// EPI_SCR8 initial value,
        //rtd_outl(0xb8026188, 0x00000002);	// EPI_SCR10 disable,
        //rtd_outl(0xb802618C, 0x000FFFFF);	// EPI_SCR10 initial value,
        rtd_outl(0xb80261E4, 0x00000FFF);	// EPI MAC output Port 0~11 transmit to APHY, others disable,
        rtd_outl(0xb80261E8, 0x00000FFF);	// EPI all Port extend subpixel use sfg case_a,
        rtd_outl(0xb80261EC, 0x00000FFF);	// EPI constant_update_mode : EPI Port 0~11 update by TDM (for power save),
        rtd_outl(0xb80263F8, 0x00000000);	// EPI update first ctrl packet time : hs_den_io_dist + den_length (compute by hw),
        rtd_outl(0xb80263FC, 0x007D00FB);	// LOCK debounce enable and setting,
        rtd_outl(0xb80261F4, 0x0000000F);	// Check SFG output timing enable,
        rtd_outl(0xb80261FC, 0x0000000E);	// SOE LUT use 4-line repeat, SOE LUT apply to C2[17:0],
        rtd_outl(0xb8026200, 0x00007C9b);	// SOE line 0 LUT for lane 0,
        rtd_outl(0xb8026204, 0x00007C9b);	// SOE line 1 LUT for lane 0,
        rtd_outl(0xb8026208, 0x00007C9b);	// SOE line 2 LUT for lane 0,
        rtd_outl(0xb802620C, 0x00007C9b);	// SOE line 3 LUT for lane 0,
        rtd_outl(0xb8026210, 0x00007C9b);	// SOE line 0 LUT for lane 1,
        rtd_outl(0xb8026214, 0x00007C9b);	// SOE line 1 LUT for lane 1,
        rtd_outl(0xb8026218, 0x00007C9b);	// SOE line 2 LUT for lane 1,
        rtd_outl(0xb802621C, 0x00007C9b);	// SOE line 3 LUT for lane 1,
        rtd_outl(0xb8026220, 0x00007C9b);	// SOE line 0 LUT for lane 2,
        rtd_outl(0xb8026224, 0x00007C9b);	// SOE line 1 LUT for lane 2,
        rtd_outl(0xb8026228, 0x00007C9b);	// SOE line 2 LUT for lane 2,
        rtd_outl(0xb802622C, 0x00007C9b);	// SOE line 3 LUT for lane 2,
        rtd_outl(0xb8026230, 0x00007C9b);	// SOE line 0 LUT for lane 3,
        rtd_outl(0xb8026234, 0x00007C9b);	// SOE line 1 LUT for lane 3,
        rtd_outl(0xb8026238, 0x00007C9b);	// SOE line 2 LUT for lane 3,
        rtd_outl(0xb802623C, 0x00007C9b);	// SOE line 3 LUT for lane 3,
        rtd_outl(0xb8026240, 0x00007C9b);	// SOE line 0 LUT for lane 4,
        rtd_outl(0xb8026244, 0x00007C9b);	// SOE line 1 LUT for lane 4,
        rtd_outl(0xb8026248, 0x00007C9b);	// SOE line 2 LUT for lane 4,
        rtd_outl(0xb802624C, 0x00007C9b);	// SOE line 3 LUT for lane 4,
        rtd_outl(0xb8026250, 0x00007C9b);	// SOE line 0 LUT for lane 5,
        rtd_outl(0xb8026254, 0x00007C9b);	// SOE line 1 LUT for lane 5,
        rtd_outl(0xb8026258, 0x00007C9b);	// SOE line 2 LUT for lane 5,
        rtd_outl(0xb802625C, 0x00007C9b);	// SOE line 3 LUT for lane 5,
        rtd_outl(0xb8026260, 0x00007C9b);	// SOE line 0 LUT for lane 6,
        rtd_outl(0xb8026264, 0x00007C9b);	// SOE line 1 LUT for lane 6,
        rtd_outl(0xb8026268, 0x00007C9b);	// SOE line 2 LUT for lane 6,
        rtd_outl(0xb802626C, 0x00007C9b);	// SOE line 3 LUT for lane 6,
        rtd_outl(0xb8026270, 0x00007C9b);	// SOE line 0 LUT for lane 7,
        rtd_outl(0xb8026274, 0x00007C9b);	// SOE line 1 LUT for lane 7,
        rtd_outl(0xb8026278, 0x00007C9b);	// SOE line 2 LUT for lane 7,
        rtd_outl(0xb802627C, 0x00007C9b);	// SOE line 3 LUT for lane 7,
        rtd_outl(0xb8026280, 0x00007C9b);	// SOE line 0 LUT for lane 8,
        rtd_outl(0xb8026284, 0x00007C9b);	// SOE line 1 LUT for lane 8,
        rtd_outl(0xb8026288, 0x00007C9b);	// SOE line 2 LUT for lane 8,
        rtd_outl(0xb802628C, 0x00007C9b);	// SOE line 3 LUT for lane 8,
        rtd_outl(0xb8026290, 0x00007C9b);	// SOE line 0 LUT for lane 9,
        rtd_outl(0xb8026294, 0x00007C9b);	// SOE line 1 LUT for lane 9,
        rtd_outl(0xb8026298, 0x00007C9b);	// SOE line 2 LUT for lane 9,
        rtd_outl(0xb802629C, 0x00007C9b);	// SOE line 3 LUT for lane 9,
        rtd_outl(0xb80262A0, 0x00007C9b);	// SOE line 0 LUT for lane 10,
        rtd_outl(0xb80262A4, 0x00007C9b);	// SOE line 1 LUT for lane 10,
        rtd_outl(0xb80262A8, 0x00007C9b);	// SOE line 2 LUT for lane 10,
        rtd_outl(0xb80262AC, 0x00007C9b);	// SOE line 3 LUT for lane 10,
        rtd_outl(0xb80262B0, 0x0000789b);	// SOE line 0 LUT for lane 11,
        rtd_outl(0xb80262B4, 0x0000789b);	// SOE line 1 LUT for lane 11,
        rtd_outl(0xb80262B8, 0x0000789b);	// SOE line 2 LUT for lane 11,
        rtd_outl(0xb80262BC, 0x0000789b);	// SOE line 3 LUT for lane 11,

        //rtd_outl(0xb8026380, 0x00000000);	// DST(C4~C0) MUX use register config,
        //rtd_outl(0xb8026384, 0x00000000);	// DST(C9~C5) MUX use register config,
        //rtd_outl(0xb8026388, 0x00000000);	// DST(C14~C10) MUX use register config,
        //rtd_outl(0xb802638C, 0x00000000);	// DST(C19~C15) MUX use register config,
        //rtd_outl(0xb8026390, 0x00000000);	// DST(C24~C20) MUX use register config,
        //rtd_outl(0xb8026394, 0x00000000);	// DST(C29~C25) MUX use register config,
        //rtd_outl(0xb8026398, 0x00000000);	// CST(C4~C0) MUX use register config,
        //rtd_outl(0xb802639C, 0x00000000);	// CST(C9~C5) MUX use register config,
        //rtd_outl(0xb80263A0, 0x00000000);	// CST(C14~C10) MUX use register config,
        //rtd_outl(0xb80263A4, 0x00000000);	// CST(C19~C15) MUX use register config,
        //rtd_outl(0xb80263A8, 0x00000000);	// CST(C24~C20) MUX use register config,
        //rtd_outl(0xb80263AC, 0x00000000);	// CST(C29~C25) MUX use register config,
        rtd_outl(0xb80263B0, 0x00000000);	// C1(C4~C0) MUX use register config,
        rtd_outl(0xb80263B4, 0x00000210);	// C1(C9~C5) MUX use register config (C6/C7 use Tcon_A/B),
        rtd_outl(0xb80263B8, 0x00000300);	// C1(C14~C10) MUX use register config (C12 use Tcon_C),
        rtd_outl(0xb80263BC, 0x00000400);	// C1(C19~C15) MUX use register config (C17 use Tcon_D),
        rtd_outl(0xb80263C0, 0x00000000);	// C1(C24~C20) MUX use register config,
        rtd_outl(0xb80263C4, 0x00000000);	// C1(C29~C25) MUX use register config,
        rtd_outl(0xb80263C8, 0x00000000);	// C2(C4~C0) MUX use register config,
        rtd_outl(0xb80263CC, 0x00000000);	// C2(C9~C5) MUX use register config,
        rtd_outl(0xb80263D0, 0x00000000);	// C2(C14~C10) MUX use register config,
        rtd_outl(0xb80263D4, 0x00000000);	// C2(C19~C15) MUX use register config,
        rtd_outl(0xb80263D8, 0x00000000);	// C2(C24~C20) MUX use register config,
        rtd_outl(0xb80263DC, 0x00000000);	// C2(C29~C25) MUX use register config,
        //rtd_outl(0xb80263E0, 0x00000000);	// C3(C4~C0) MUX use register config,
        //rtd_outl(0xb80263E4, 0x00000000);	// C3(C9~C5) MUX use register config,
        //rtd_outl(0xb80263E8, 0x00000000);	// C3(C14~C10) MUX use register config,
        //rtd_outl(0xb80263EC, 0x00000000);	// C3(C19~C15) MUX use register config,
        //rtd_outl(0xb80263F0, 0x00000000);	// C3(C24~C20) MUX use register config,
        //rtd_outl(0xb80263F4, 0x00000000);	// C3(C29~C25) MUX use register config,
        rtd_outl(0xb8026500, 0x00131914);	// Tcon_A/B/C sel ext_tcon_20/25/19,
        rtd_outl(0xb8026504, 0x00120018);	// Tcon_D/E/F sel ext_tcon_24/0/18,
        //rtd_outl(0xb8026508, 0x00000000);	// Tcon_G/H/I sel ext_tcon_0/0/0,
        //rtd_outl(0xb802650C, 0x00000000);	// Tcon_J/K sel ext_tcon_0/0,
        rtd_outl(0xb8026524, 0x80000000);	// SOE1/SOE2 LUT switch every 28 second is enable,
        					// CEDS POL in CTRL1(C6) for all lane is not invert,
        					// CEDS POL2 in CTRL1(C12) for all lane is not invert,
        //rtd_outl(0xb8026528, 0x0000002A);	// DST register config value,
        //rtd_outl(0xb802653C, 0x00000015);	// CST register config value,
        //rtd_outl(0xb8026A60, 0x00000000);	// C4 register config value,
        //rtd_outl(0xb8026AA0, 0x00000000);	// C5 register config value,
        rtd_outl(0xb8026554, 0x00142800);	// Lane0 : C1 register config value,
        rtd_outl(0xb802655C, 0x00143840);	// Lane1 : C1 register config value,
        rtd_outl(0xb8026564, 0x00143840);	// Lane2 : C1 register config value,
        rtd_outl(0xb802656C, 0x00143840);	// Lane3 : C1 register config value,
        rtd_outl(0xb8026574, 0x00143840);	// Lane4 : C1 register config value,
        rtd_outl(0xb802657C, 0x00143840);	// Lane5 : C1 register config value,
        rtd_outl(0xb8026584, 0x00143840);	// Lane6 : C1 register config value,
        rtd_outl(0xb802658C, 0x00143840);	// Lane7 : C1 register config value,
        rtd_outl(0xb8026594, 0x00143840);	// Lane8 : C1 register config value,
        rtd_outl(0xb802659C, 0x00143840);	// Lane9 : C1 register config value,
        rtd_outl(0xb80265A4, 0x00143840);	// Lane10: C1 register config value,
        rtd_outl(0xb80265AC, 0x00143840);	// Lane11: C1 register config value,
        //rtd_outl(0xb8026624, 0x00000000);	// Lane0 : C2 register config value,
        //rtd_outl(0xb802662C, 0x00000000);	// Lane1 : C2 register config value,
        //rtd_outl(0xb8026634, 0x00000000);	// Lane2 : C2 register config value,
        //rtd_outl(0xb802663C, 0x00000000);	// Lane3 : C2 register config value,
        //rtd_outl(0xb8026644, 0x00000000);	// Lane4 : C2 register config value,
        //rtd_outl(0xb802664C, 0x00000000);	// Lane5 : C2 register config value,
        //rtd_outl(0xb8026654, 0x00000000);	// Lane6 : C2 register config value,
        //rtd_outl(0xb802665C, 0x00000000);	// Lane7 : C2 register config value,
        //rtd_outl(0xb8026664, 0x00000000);	// Lane8 : C2 register config value,
        //rtd_outl(0xb802666C, 0x00000000);	// Lane9 : C2 register config value,
        //rtd_outl(0xb8026674, 0x00000000);	// Lane10: C2 register config value,
        //rtd_outl(0xb802667C, 0x00000000);	// Lane11: C2 register config value,
        //rtd_outl(0xb80266F4, 0x00000000);	// Lane0 : C3 register config value,
        //rtd_outl(0xb80266FC, 0x00000000);	// Lane1 : C3 register config value,
        //rtd_outl(0xb8026704, 0x00000000);	// Lane2 : C3 register config value,
        //rtd_outl(0xb802670C, 0x00000000);	// Lane3 : C3 register config value,
        //rtd_outl(0xb8026714, 0x00000000);	// Lane4 : C3 register config value,
        //rtd_outl(0xb802671C, 0x00000000);	// Lane5 : C3 register config value,
        //rtd_outl(0xb8026724, 0x00000000);	// Lane6 : C3 register config value,
        //rtd_outl(0xb802672C, 0x00000000);	// Lane7 : C3 register config value,
        //rtd_outl(0xb8026734, 0x00000000);	// Lane8 : C3 register config value,
        //rtd_outl(0xb802673C, 0x00000000);	// Lane9 : C3 register config value,
        //rtd_outl(0xb8026744, 0x00000000);	// Lane10: C3 register config value,
        //rtd_outl(0xb802674C, 0x00000000);	// Lane11: C3 register config value,
        //rtd_outl(0xb8026450, 0x00000000);	// General propose LUT use 1 line cycle,
        //rtd_outl(0xb8026454, 0x00000000);	// General propose LUT for line 0~1,
        //rtd_outl(0xb8026458, 0x00000000);	// General propose LUT for line 2~3,
        //rtd_outl(0xb802645C, 0x00000000);	// General propose LUT for line 4~5,
        //rtd_outl(0xb8026460, 0x00000000);	// General propose LUT for line 6~7,

        //---------------------------------------------------------------------------------------------------------------------------------
        //PIF_APHY
        //---------------------------------------------------------------------------------------------------------------------------------
        rtd_outl(0xb8000CC0, 0x00000000);	// Lane Power disable,
        rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
        rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
        rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
        rtd_outl(0xb8000C08, 0x03080101);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(2),
        rtd_outl(0xb8000C0C, 0x8005E3B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
        rtd_outl(0xb8000C10, 0x00000101);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(2), EPI_DIVM(14),
        rtd_outl(0xb8000C14, 0x00000001);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
        rtd_outl(0xb8000C18, 0x00000021);	// TXPLL use EPI feedback path,
        rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
        rtd_outl(0xb8000C50, 0x01F48000);	// IBN Current, VCM Level, LDO1V_EN(1), VCM_SHIFT_DOWN(0),
        rtd_outl(0xb8000C78, 0x00000400);	// CKIN_DIVN(6),

        //
        rtd_outl(0xb8000D00, 0x66002852);	// Lane0 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000D10, 0x66002852);	// Lane1 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000D20, 0x66002852);	// Lane2 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000D30, 0x66002852);	// Lane3 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000D40, 0x66002852);	// Lane4 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000D50, 0x66002852);	// Lane5 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000D60, 0x66002852);	// Lane6 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000D70, 0x66002852);	// Lane7 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000D80, 0x66002852);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000D90, 0x66002852);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000DA0, 0x66002852);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
        rtd_outl(0xb8000DB0, 0x66002852);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,

        //
        rtd_outl(0xb8000D04, 0x44003000);	// Lane0 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000D14, 0x44003000);	// Lane1 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000D24, 0x44003000);	// Lane2 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000D34, 0x44003000);	// Lane3 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000D44, 0x44003000);	// Lane4 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000D54, 0x44003000);	// Lane5 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000D64, 0x44003000);	// Lane6 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000D74, 0x44003000);	// Lane7 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000D84, 0x44003000);	// Lane8 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000D94, 0x44003000);	// Lane9 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000DA4, 0x44003000);	// Lane10: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),
        rtd_outl(0xb8000DB4, 0x44003000);	// Lane11: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1),

        //
        rtd_outl(0xb8000D08, 0x00000009);	// Lane0 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000D18, 0x00000009);	// Lane1 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000D28, 0x00000009);	// Lane2 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000D38, 0x00000009);	// Lane3 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000D48, 0x00000009);	// Lane4 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000D58, 0x00000009);	// Lane5 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000D68, 0x00000009);	// Lane6 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000D78, 0x00000009);	// Lane7 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
        rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),

        //---------------------------------------------------------------------------------------------------------------------------------
        //Initial Flow
        //--------------------------------------------------------------------------------------------------------------------------------
        // (1) DPLL Power Enable  (As above Script)
        //
        // (2) Wait DPLL stable at least 150us (SW Control)
        //
        // (3) Release DCLK Gating (SW Control)
        //
        // (4) TXPLL power up TXPLL during reset state (As above Script)
        //
        // (5) TXPLL reset release (Below Setting)
        rtd_part_outl(0xb8000C20, 10, 10, 0x1);
        //
        // (6) Wait TXPLL stable at least 150us (SW Control)
        //
        // (7) EPI Clock Enable (Below Setting)
        rtd_outl(0xb802D9B8, 0x40000000);
        //
        // (8) EPI MAC Enable (Below Setting)
        rtd_part_outl(0xb802606C, 16, 16, 0x1);
        //
        // (9) Enable Async FIFO,
        rtd_part_outl(0xb802DC94, 31, 31, 0x1);
        //
        // (10) APHY Lane Power Enable (Below Setting)
        rtd_outl(0xb8000CC0, 0x00000FFF);
        //
        // (11) Panel Power Enable (SW Control)
}
#endif

void panel_ceds_BOE_HV550QUB_H81_tcon_setting(void)
{
	//---------------------------------------------------------------------------------------------------------------------------------
	//SFG: DH_ST_END = 0x01181018, DTG_HS_Width = 32, DTG_VS_Width = 12
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D900, 0x00100840);	// Common fifo use sfg_clk, 30-bit Mode, Dout Enable, Pre-R/B Swap disable,
						// Remove last too short dhs, any to any sub-pixel assign disable,
	rtd_outl(0xb802D910, 0x00000003);	// CRC Enable,
	rtd_outl(0xb802D928, 0x00000000);	// PIF Forcre to BG disable,
	rtd_outl(0xb802D92C, 0x00005000);	// Line 8n+0/8n+1 shift 1 sub-pixel, Line 8n+2/8n+3 not sub-pixel shift,
	rtd_outl(0xb802DBA8, 0x00005000);	// Line 8n+4/8n+5 shift 1 sub-pixel, Line 8n+6/8n+7 not sub-pixel shift,
	rtd_outl(0xb802D930, 0x00000000);	// SEG0/SEG1 No front/back dummy pixel,
	rtd_outl(0xb802D934, 0x00000000);	// SEG2/SEG3 No front/back dummy pixel,
	rtd_outl(0xb802D938, 0x00000000);	// SEG4/SEG5 No front/back dummy pixel,
	//rtd_outl(0xb802D940, 0x00000000);	// SEG6/SEG7 No front/back dummy pixel,
	//rtd_outl(0xb802D944, 0x00000000);	// SEG8/SEG9 No front/back dummy pixel,
	//rtd_outl(0xb802D948, 0x00000000);	// SEG10/SEG11 No front/back dummy pixel,
	rtd_outl(0xb802D964, 0x1000058B);	// SFG DRD Mode, 1.5 packet mode disable, H-Flip enable, 6-SEG, 12-Port,
	rtd_outl(0xb802D968, 0x00000280);	// SEG0/SEG1 Start Address,
	rtd_outl(0xb802D96C, 0x05000780);	// SEG2/SEG3 Start Address,
	rtd_outl(0xb802D970, 0x0A000C80);	// SEG4/SEG5 Start Address,
	//rtd_outl(0xb802D974, 0x00000000);	// SEG6/SEG7 Start Address,
	//rtd_outl(0xb802D978, 0x00000000);	// SEG8/SEG9 Start Address,
	//rtd_outl(0xb802D97C, 0x00000000);	// SEG10/SEG11 Start Address,
	//rtd_outl(0xb802D980, 0x00000000);	// Front dummy line(4N+0) data,
	//rtd_outl(0xb802D984, 0x00000000);	// Front dummy line(4N+1) data,
	//rtd_outl(0xb802D94C, 0x00000000);	// Front dummy line(4N+2) data,
	rtd_outl(0xb802D988, 0x40000000);	// Bypass SFG disable, Auto config enable, downsample disable, front_dmy_line_num(0), front_dmy_line_sel = dray_data,
	rtd_outl(0xb802D990, 0x08980300);	// Hs_distance, Vsync Start/End,
	rtd_outl(0xb802D998, 0x00000000);	// Segement-flip Disable,
	rtd_outl(0xb802D99C, 0x07800000);	// Final line length,
	rtd_outl(0xb802D9A0, 0x00000000);	// Residue_pix_split_mode, Final_addr_split_mode,
	rtd_outl(0xb802D9A4, 0x008C1128);	// hs_den_io_dist, hs_io_dist,
	rtd_outl(0xb802D9B8, 0x00000000);	// All PIF Clock disable, Data inverse disable,
	rtd_outl(0xb802D9E8, 0x00000000);	// SEG0/SEG1 No middle dummy sub-pixel,
	rtd_outl(0xb802D9EC, 0x00000000);	// SEG2/SEG3 No middle dummy sub-pixel,
	rtd_outl(0xb802D9F0, 0x00000000);	// SEG4/SEG5 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F4, 0x00000000);	// SEG6/SEG7 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9F8, 0x00000000);	// SEG8/SEG9 No middle dummy sub-pixel,
	//rtd_outl(0xb802D9FC, 0x00000000);	// SEG10/SEG11 No middle dummy sub-pixel,
	rtd_outl(0xb802DA08, 0x81000000);	// Active_pixel_RGB, ext_num use fw mode, unit is sub-pixel
	rtd_outl(0xb802DA0C, 0x00400000);     	// G-dummy sub-pixel for line 8n+0, G-dummy data select from SFG input,
	rtd_outl(0xb802DA10, 0x00400000);     	// G-dummy sub-pixel for line 8n+1,
	rtd_outl(0xb802DA14, 0x00030000);     	// G-dummy sub-pixel for line 8n+2,
	rtd_outl(0xb802DA18, 0x00030000);     	// G-dummy sub-pixel for line 8n+3,
	rtd_outl(0xb802DBAC, 0x00400000);     	// G-dummy sub-pixel for line 8n+4,
	rtd_outl(0xb802DBB0, 0x00400000);     	// G-dummy sub-pixel for line 8n+5,
	rtd_outl(0xb802DBB4, 0x00030000);     	// G-dummy sub-pixel for line 8n+6,
	rtd_outl(0xb802DBB8, 0x00030000);     	// G-dummy sub-pixel for line 8n+7,
	rtd_outl(0xb802DA1C, 0x00000000);	// dummy_pixel_data is black,
	rtd_outl(0xb802DA94, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+0/1,
	rtd_outl(0xb802DA98, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+2/3,
	rtd_outl(0xb802DBE0, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+4/5,
	rtd_outl(0xb802DBE4, 0x00000000);	// Last_seg_start, last_seg_start_res for line 4n+6/7,
	rtd_outl(0xb802DAA0, 0x01010101);	// DRD Data Mapping,
	rtd_outl(0xb802DAA4, 0x05050505);	// DRD Data Mapping,
	rtd_outl(0xb802DAA8, 0x03030303);	// DRD Data Mapping,
	rtd_outl(0xb802DAAC, 0x07070707);	// DRD Data Mapping,
	rtd_outl(0xb802DAB0, 0x0B0B0B0B);	// DRD Data Mapping,
	rtd_outl(0xb802DAB4, 0x09090909);	// DRD Data Mapping,
	rtd_outl(0xb802DAB8, 0x0D0D0D0D);	// DRD Data Mapping,
	rtd_outl(0xb802DABC, 0x11111111);	// DRD Data Mapping,
	rtd_outl(0xb802DAC0, 0x0F0F0F0F);	// DRD Data Mapping,
	rtd_outl(0xb802DAC4, 0x13131313);	// DRD Data Mapping,
	rtd_outl(0xb802DAC8, 0x17171717);	// DRD Data Mapping,
	rtd_outl(0xb802DACC, 0x15151515);	// DRD Data Mapping,
	rtd_outl(0xb802DAD0, 0x02020202);	// DRD Data Mapping,
	rtd_outl(0xb802DAD4, 0x00000000);	// DRD Data Mapping,
	rtd_outl(0xb802DAD8, 0x04040404);	// DRD Data Mapping,
	rtd_outl(0xb802DADC, 0x08080808);	// DRD Data Mapping,
	rtd_outl(0xb802DAE0, 0x06060606);	// DRD Data Mapping,
	rtd_outl(0xb802DAE4, 0x0A0A0A0A);	// DRD Data Mapping,
	rtd_outl(0xb802DAE8, 0x0E0E0E0E);	// DRD Data Mapping,
	rtd_outl(0xb802DAEC, 0x0C0C0C0C);	// DRD Data Mapping,
	rtd_outl(0xb802DAF0, 0x10101010);	// DRD Data Mapping,
	rtd_outl(0xb802DAF4, 0x14141414);	// DRD Data Mapping,
	rtd_outl(0xb802DAF8, 0x12121212);	// DRD Data Mapping,
	rtd_outl(0xb802DAFC, 0x16161616);	// DRD Data Mapping,
	rtd_outl(0xb802DB68, 0x55550000);	// ext_num setting for case_a and case_b,

	//rtd_outl(0xb802DB78, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+0,
	//rtd_outl(0xb802DB7C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+1,
	//rtd_outl(0xb802DB80, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+2,
	//rtd_outl(0xb802DB84, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+3,
	//rtd_outl(0xb802DB88, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+4,
	//rtd_outl(0xb802DB8C, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+5,
	//rtd_outl(0xb802DB90, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+6,
	//rtd_outl(0xb802DB94, 0x00000000);	// Virtual data_0/1 for G-dummy line 8n+7,
	rtd_outl(0xb802DBF0, 0x1DF10E38);	// SFG Pattern Gen. Disable, RGB Mode, Width = 480, Hight = 270, pattern reset by hs,
	rtd_outl(0xb802DBF4, 0x00FFFFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar0,
	rtd_outl(0xb802DBF8, 0x00FFFF00);	// SFG Pattern Gen. R/G/B/W Color for Bar1,
	rtd_outl(0xb802DBFC, 0x0000FFFF);	// SFG Pattern Gen. R/G/B/W Color for Bar2,
	rtd_outl(0xb802DC00, 0x0000FF00);	// SFG Pattern Gen. R/G/B/W Color for Bar3,
	rtd_outl(0xb802DC04, 0x00FF00FF);	// SFG Pattern Gen. R/G/B/W Color for Bar4,
	rtd_outl(0xb802DC08, 0x00FF0000);	// SFG Pattern Gen. R/G/B/W Color for Bar5,
	rtd_outl(0xb802DC0C, 0x000000FF);	// SFG Pattern Gen. R/G/B/W Color for Bar6,
	rtd_outl(0xb802DC10, 0x00000000);	// SFG Pattern Gen. R/G/B/W Color for Bar7,
	rtd_outl(0xb802DC1C, 0x00000000);	// Pattern Detect Function Disable,

	rtd_outl(0xb802D904, 0x05FFFFFF);	// PIF_Clock = Dclk/6, Force to background enable,
	//---------------------------------------------------------------------------------------------------------------------------------
	//LOCK Pin share
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_maskl(0xb8000800, 0xFFFFFF0F, 0x00000070);	// GPIO_3 pinshare to epi_lock_src0,
	rtd_maskl(0xb8000CBC, 0xFFFFFFFC, 0x00000000);	// EPI_LOCK use epi_lock_src0,
	rtd_maskl(0xb8000814, 0x7FFFFFFF, 0x80000000);	// GPIO_3 use input Vth 1.8V,

	//---------------------------------------------------------------------------------------------------------------------------------
	//EPI MAC
	//---------------------------------------------------------------------------------------------------------------------------------
	//rtd_outl(0xb8026000, 0x00000004);	// Preamble Number in Phase2, Preamble Number before P-gamma line for CMPI (no use),
	rtd_outl(0xb8026060, 0x08000002);	// EPI 1.5Gbps 8-bit mode,
	rtd_outl(0xb8026064, 0x80000001);	// EPI reset disable, CST/C3/C4/C5/DST packet disable, EPI lock HW mode,
	rtd_outl(0xb802606C, 0x40C03000);	// EPI disable, ext_num unit is sub-pixel, 12-port EPI, packet delimiter,
	//rtd_outl(0xb8026070, 0x00000645);	// CMPI CMD/DATA delimiter, run length conding delimiter,
	rtd_outl(0xb8026074, 0x00000000);	// Front/Back dummy line number,
	//rtd_outl(0xb8026078, 0x00000000);	// Front dummy line color select color_0,
	//rtd_outl(0xb802607C, 0x00000000);	// Back dummy line color select color_1,
	//rtd_outl(0xb8026080, 0x00000000);	// Dummy line color 0 (L0),
	//rtd_outl(0xb8026084, 0x00000000);	// Dummy line color 1 (L0),
	//rtd_outl(0xb8026088, 0x00000000);	// Dummy line color 2 (L0),
	//rtd_outl(0xb802608C, 0x00000000);	// Dummy line color 3 (L0),
	rtd_outl(0xb8026090, 0x0000FFF3);	// CRC Enable, select lane 0~11 to CRC,
	rtd_outl(0xb802609C, 0x00000000);	// EPI Data from SFG, EPI packet data setting,
	//rtd_outl(0xb80260A4, 0x00000071);	// INV4 LUT use 8 line cycle, POD2_INV4 initial phase select bypass (2'b00),
	//rtd_outl(0xb80260A8, 0x00000000);	// INV4 LUT for line 0~8,
	//rtd_outl(0xb80260AC, 0x00000000);	// INV4 LUT for line 9~16,
	//rtd_outl(0xb8026110, 0x00000000);	// CMPI RLC Function for 10bit mode disable,
	//rtd_outl(0xb8026114, 0x00000000);	// CMPI CDR type mode select,
	//rtd_outl(0xb8026118, 0x00000000);	// CMPI CDR clock training2 insert in type1 and type2,
	//rtd_outl(0xb802617C, 0x00000100);	// Scrambler reset/enable control by hw,
	//rtd_outl(0xb8026180, 0x00000002);	// EPI_SCR8 disable,
	//rtd_outl(0xb8026184, 0x00FFFFFF);	// EPI_SCR8 initial value,
	//rtd_outl(0xb8026188, 0x00000002);	// EPI_SCR10 disable,
	//rtd_outl(0xb802618C, 0x000FFFFF);	// EPI_SCR10 initial value,
	//rtd_outl(0xb8026190, 0x00000000);	// CMPI_SCR8 disable,
	//rtd_outl(0xb8026194, 0x00000FFF);	// CMPI_SCR8 initial value,
	//rtd_outl(0xb8026198, 0x00000000);	// CMPI_SCR10 disable,
	//rtd_outl(0xb802619C, 0x000003FF);	// CMPI_SCR10 initial value,
	//rtd_outl(0xb80261A0, 0x00000000);	// CMPI F/M/B color select, Pgamma for CMPI disable,
	//rtd_outl(0xb80261A4, 0x00000000);	// CMPI Pgamma CST packet,
	//rtd_outl(0xb80261A8, 0x00000000);	// CMPI Pgamma C1 packet,
	//rtd_outl(0xb80261AC, 0x00000000);	// CMPI Pgamma C2 packet,
	//rtd_outl(0xb80261B0, 0x00000000);	// CMPI Pgamma C3 packet,
	//rtd_outl(0xb8026300, 0x00000000);	// CMPI Pgamma C4 packet,
	//rtd_outl(0xb8026304, 0x00000000);	// CMPI Pgamma C5 packet,
	//rtd_outl(0xb80261B4, 0x00000000);	// CMPI Pgamma PG_ST packet,
	//rtd_outl(0xb80261B8, 0x00000000);	// CMPI Pgamma Data0 packet,
	//rtd_outl(0xb80261BC, 0x00000000);	// CMPI Pgamma Data1 packet,
	//rtd_outl(0xb80261C0, 0x00000000);	// CMPI Pgamma Data2 packet,
	//rtd_outl(0xb80261C4, 0x00000000);	// CMPI Pgamma Data3 packet,
	//rtd_outl(0xb80261C8, 0x00000000);	// CMPI Pgamma Data4 packet,
	//rtd_outl(0xb80261CC, 0x00000000);	// CMPI Pgamma Data5 packet,
	//rtd_outl(0xb80261D0, 0x00000000);	// CMPI Pgamma Data6 packet,
	//rtd_outl(0xb80261D4, 0x00000000);	// CMPI Pgamma Data7 packet,
	//rtd_outl(0xb80261D8, 0x00000000);	// CMPI Pgamma Data8 packet,
	//rtd_outl(0xb80261DC, 0x00000000);	// CMPI Pgamma Data9 packet,
	//rtd_outl(0xb8026308, 0x00000000);	// CMPI Pgamma Data10 packet,
	//rtd_outl(0xb802630C, 0x00000000);	// CMPI Pgamma Data11 packet,
	//rtd_outl(0xb8026310, 0x00000000);	// CMPI Pgamma Data12 packet,
	//rtd_outl(0xb8026314, 0x00000000);	// CMPI Pgamma Data13 packet,
	//rtd_outl(0xb8026318, 0x00000000);	// CMPI Pgamma Data14 packet,
	//rtd_outl(0xb802631C, 0x00000000);	// CMPI Pgamma Data15 packet,
	//rtd_outl(0xb8026320, 0x00000000);	// CMPI Pgamma Data16 packet,
	//rtd_outl(0xb8026324, 0x00000000);	// CMPI Pgamma Data17 packet,
	//rtd_outl(0xb8026328, 0x00000000);	// CMPI Pgamma Data18 packet,
	//rtd_outl(0xb802632C, 0x00000000);	// CMPI Pgamma Data19 packet,
	//rtd_outl(0xb8026330, 0x00000000);	// CMPI Pgamma Data20 packet,
	//rtd_outl(0xb8026334, 0x00000000);	// CMPI Pgamma Data21 packet,
	//rtd_outl(0xb8026338, 0x00000000);	// CMPI Pgamma Data22 packet,
	//rtd_outl(0xb802633C, 0x00000000);	// CMPI Pgamma Data23 packet,
	//rtd_outl(0xb8026340, 0x00000000);	// CMPI Pgamma Data24 packet,
	//rtd_outl(0xb8026344, 0x00000000);	// CMPI Pgamma Data25 packet,
	//rtd_outl(0xb8026348, 0x00000000);	// CMPI Pgamma Data26 packet,
	//rtd_outl(0xb802634C, 0x00000000);	// CMPI Pgamma Data27 packet,
	//rtd_outl(0xb8026350, 0x00000000);	// CMPI Pgamma Data28 packet,
	//rtd_outl(0xb8026354, 0x00000000);	// CMPI Pgamma Data29 packet,
	//rtd_outl(0xb8026358, 0x00000000);	// CMPI Pgamma Data30 packet,
	//rtd_outl(0xb802635C, 0x00000000);	// CMPI Pgamma Data31 packet,
	//rtd_outl(0xb8026360, 0x00000000);	// CMPI Pgamma Data32 packet,
	//rtd_outl(0xb8026364, 0x00000000);	// CMPI Pgamma Data33 packet,
	//rtd_outl(0xb8026368, 0x00000000);	// CMPI Pgamma Data34 packet,
	//rtd_outl(0xb802636C, 0x00000000);	// CMPI Pgamma Data35 packet,
	//rtd_outl(0xb8026370, 0x00000000);	// CMPI Pgamma Data36 packet,
	//rtd_outl(0xb8026374, 0x00000000);	// CMPI Pgamma Data37 packet,
	//rtd_outl(0xb8026378, 0x00000000);	// CMPI Pgamma Data38 packet,
	//rtd_outl(0xb802637C, 0x00000000);	// CMPI Pgamma Data39 packet,
	//rtd_outl(0xb8026400, 0x00000000);	// CMPI Pgamma Data40 packet,
	//rtd_outl(0xb8026404, 0x00000000);	// CMPI Pgamma Data41 packet,
	//rtd_outl(0xb8026408, 0x00000000);	// CMPI Pgamma Data42 packet,
	//rtd_outl(0xb802640C, 0x00000000);	// CMPI Pgamma Data43 packet,
	//rtd_outl(0xb8026410, 0x00000000);	// CMPI Pgamma Data44 packet,
	//rtd_outl(0xb8026414, 0x00000000);	// CMPI Pgamma Data45 packet,
	//rtd_outl(0xb8026418, 0x00000000);	// CMPI Pgamma Data46 packet,
	//rtd_outl(0xb802641C, 0x00000000);	// CMPI Pgamma Data47 packet,
	//rtd_outl(0xb8026420, 0x00000000);	// CMPI Pgamma Data48 packet,
	//rtd_outl(0xb8026424, 0x00000000);	// CMPI Pgamma Data49 packet,
	//rtd_outl(0xb8026428, 0x00000000);	// CMPI Pgamma Data50 packet,
	//rtd_outl(0xb802642C, 0x00000000);	// CMPI Pgamma Data51 packet,
	//rtd_outl(0xb8026430, 0x00000000);	// CMPI Pgamma Data52 packet,
	//rtd_outl(0xb8026434, 0x00000000);	// CMPI Pgamma Data53 packet,
	//rtd_outl(0xb8026438, 0x00000000);	// CMPI Pgamma Data54 packet,
	//rtd_outl(0xb802643C, 0x00000000);	// CMPI Pgamma Data55 packet,
	//rtd_outl(0xb8026440, 0x00000000);	// CMPI Pgamma Data56 packet,
	//rtd_outl(0xb8026444, 0x00000000);	// CMPI Pgamma Data57 packet,
	//rtd_outl(0xb8026448, 0x00000000);	// CMPI Pgamma Data58 packet,
	//rtd_outl(0xb802644C, 0x00000000);	// CMPI Pgamma Data59 packet,
	//rtd_outl(0xb80261E0, 0x00000000);	// CMPI Pgamma PG_END packet,
	rtd_outl(0xb80261E4, 0x00000FFF);	// EPI MAC output Port 0~11 transmit to APHY, others disable,
	rtd_outl(0xb80261E8, 0x00000FFF);	// EPI all Port extend subpixel use sfg case_a,
	rtd_outl(0xb80261EC, 0x00000FFF);	// EPI constant_update_mode : EPI Port 0~11 update by TDM (for power save),
	rtd_outl(0xb80263F8, 0x00000000);	// EPI update first ctrl packet time : hs_den_io_dist + den_length (compute by hw),
	rtd_outl(0xb80263FC, 0x007D00FB);	// LOCK debounce enable and setting,
	rtd_outl(0xb80261F4, 0x0000000F);	// Check SFG output timing enable,
	rtd_outl(0xb80261FC, 0x00000000);	// SOE LUT use 4-line repeat disable,
	//rtd_outl(0xb8026200, 0x00000000);	// SOE line 0 LUT for lane 0,
	//rtd_outl(0xb8026204, 0x00000000);	// SOE line 1 LUT for lane 0,
	//rtd_outl(0xb8026208, 0x00000000);	// SOE line 2 LUT for lane 0,
	//rtd_outl(0xb802620C, 0x00000000);	// SOE line 3 LUT for lane 0,
	//rtd_outl(0xb8026210, 0x00000000);	// SOE line 0 LUT for lane 1,
	//rtd_outl(0xb8026214, 0x00000000);	// SOE line 1 LUT for lane 1,
	//rtd_outl(0xb8026218, 0x00000000);	// SOE line 2 LUT for lane 1,
	//rtd_outl(0xb802621C, 0x00000000);	// SOE line 3 LUT for lane 1,
	//rtd_outl(0xb8026220, 0x00000000);	// SOE line 0 LUT for lane 2,
	//rtd_outl(0xb8026224, 0x00000000);	// SOE line 1 LUT for lane 2,
	//rtd_outl(0xb8026228, 0x00000000);	// SOE line 2 LUT for lane 2,
	//rtd_outl(0xb802622C, 0x00000000);	// SOE line 3 LUT for lane 2,
	//rtd_outl(0xb8026230, 0x00000000);	// SOE line 0 LUT for lane 3,
	//rtd_outl(0xb8026234, 0x00000000);	// SOE line 1 LUT for lane 3,
	//rtd_outl(0xb8026238, 0x00000000);	// SOE line 2 LUT for lane 3,
	//rtd_outl(0xb802623C, 0x00000000);	// SOE line 3 LUT for lane 3,
	//rtd_outl(0xb8026240, 0x00000000);	// SOE line 0 LUT for lane 4,
	//rtd_outl(0xb8026244, 0x00000000);	// SOE line 1 LUT for lane 4,
	//rtd_outl(0xb8026248, 0x00000000);	// SOE line 2 LUT for lane 4,
	//rtd_outl(0xb802624C, 0x00000000);	// SOE line 3 LUT for lane 4,
	//rtd_outl(0xb8026250, 0x00000000);	// SOE line 0 LUT for lane 5,
	//rtd_outl(0xb8026254, 0x00000000);	// SOE line 1 LUT for lane 5,
	//rtd_outl(0xb8026258, 0x00000000);	// SOE line 2 LUT for lane 5,
	//rtd_outl(0xb802625C, 0x00000000);	// SOE line 3 LUT for lane 5,
	//rtd_outl(0xb8026260, 0x00000000);	// SOE line 0 LUT for lane 6,
	//rtd_outl(0xb8026264, 0x00000000);	// SOE line 1 LUT for lane 6,
	//rtd_outl(0xb8026268, 0x00000000);	// SOE line 2 LUT for lane 6,
	//rtd_outl(0xb802626C, 0x00000000);	// SOE line 3 LUT for lane 6,
	//rtd_outl(0xb8026270, 0x00000000);	// SOE line 0 LUT for lane 7,
	//rtd_outl(0xb8026274, 0x00000000);	// SOE line 1 LUT for lane 7,
	//rtd_outl(0xb8026278, 0x00000000);	// SOE line 2 LUT for lane 7,
	//rtd_outl(0xb802627C, 0x00000000);	// SOE line 3 LUT for lane 7,
	//rtd_outl(0xb8026280, 0x00000000);	// SOE line 0 LUT for lane 8,
	//rtd_outl(0xb8026284, 0x00000000);	// SOE line 1 LUT for lane 8,
	//rtd_outl(0xb8026288, 0x00000000);	// SOE line 2 LUT for lane 8,
	//rtd_outl(0xb802628C, 0x00000000);	// SOE line 3 LUT for lane 8,
	//rtd_outl(0xb8026290, 0x00000000);	// SOE line 0 LUT for lane 9,
	//rtd_outl(0xb8026294, 0x00000000);	// SOE line 1 LUT for lane 9,
	//rtd_outl(0xb8026298, 0x00000000);	// SOE line 2 LUT for lane 9,
	//rtd_outl(0xb802629C, 0x00000000);	// SOE line 3 LUT for lane 9,
	//rtd_outl(0xb80262A0, 0x00000000);	// SOE line 0 LUT for lane 10,
	//rtd_outl(0xb80262A4, 0x00000000);	// SOE line 1 LUT for lane 10,
	//rtd_outl(0xb80262A8, 0x00000000);	// SOE line 2 LUT for lane 10,
	//rtd_outl(0xb80262AC, 0x00000000);	// SOE line 3 LUT for lane 10,
	//rtd_outl(0xb80262B0, 0x00000000);	// SOE line 0 LUT for lane 11,
	//rtd_outl(0xb80262B4, 0x00000000);	// SOE line 1 LUT for lane 11,
	//rtd_outl(0xb80262B8, 0x00000000);	// SOE line 2 LUT for lane 11,
	//rtd_outl(0xb80262BC, 0x00000000);	// SOE line 3 LUT for lane 11,
	//rtd_outl(0xb8026380, 0x00000000);	// DST(C4~C0) MUX use register config,
	//rtd_outl(0xb8026384, 0x00000000);	// DST(C9~C5) MUX use register config,
	//rtd_outl(0xb8026388, 0x00000000);	// DST(C14~C10) MUX use register config,
	//rtd_outl(0xb802638C, 0x00000000);	// DST(C19~C15) MUX use register config,
	//rtd_outl(0xb8026390, 0x00000000);	// DST(C24~C20) MUX use register config,
	//rtd_outl(0xb8026394, 0x00000000);	// DST(C29~C25) MUX use register config,
	//rtd_outl(0xb8026398, 0x00000000);	// CST(C4~C0) MUX use register config,
	//rtd_outl(0xb802639C, 0x00000000);	// CST(C9~C5) MUX use register config,
	//rtd_outl(0xb80263A0, 0x00000000);	// CST(C14~C10) MUX use register config,
	//rtd_outl(0xb80263A4, 0x00000000);	// CST(C19~C15) MUX use register config,
	//rtd_outl(0xb80263A8, 0x00000000);	// CST(C24~C20) MUX use register config,
	//rtd_outl(0xb80263AC, 0x00000000);	// CST(C29~C25) MUX use register config,
	rtd_outl(0xb80263B0, 0x00000000);	// C1(C4~C0) MUX use register config,
	rtd_outl(0xb80263B4, 0x00002040);	// C1(C9~C5) MUX use register config (C6/C7 use Tcon_A/B),
	rtd_outl(0xb80263B8, 0x00003000);	// C1(C14~C10) MUX use register config (C12 use Tcon_C),
	rtd_outl(0xb80263BC, 0x00000000);	// C1(C19~C15) MUX use register config,
	rtd_outl(0xb80263C0, 0x00000000);	// C1(C24~C20) MUX use register config,
	rtd_outl(0xb80263C4, 0x00000000);	// C1(C29~C25) MUX use register config,
	rtd_outl(0xb80263C8, 0x00000000);	// C2(C4~C0) MUX use register config,
	rtd_outl(0xb80263CC, 0x00000000);	// C2(C9~C5) MUX use register config,
	rtd_outl(0xb80263D0, 0x00000000);	// C2(C14~C10) MUX use register config,
	rtd_outl(0xb80263D4, 0x00000000);	// C2(C19~C15) MUX use register config,
	rtd_outl(0xb80263D8, 0x00000000);	// C2(C24~C20) MUX use register config,
	rtd_outl(0xb80263DC, 0x00000000);	// C2(C29~C25) MUX use register config,
	//rtd_outl(0xb80263E0, 0x00000000);	// C3(C4~C0) MUX use register config,
	//rtd_outl(0xb80263E4, 0x00000000);	// C3(C9~C5) MUX use register config,
	//rtd_outl(0xb80263E8, 0x00000000);	// C3(C14~C10) MUX use register config,
	//rtd_outl(0xb80263EC, 0x00000000);	// C3(C19~C15) MUX use register config,
	//rtd_outl(0xb80263F0, 0x00000000);	// C3(C24~C20) MUX use register config,
	//rtd_outl(0xb80263F4, 0x00000000);	// C3(C29~C25) MUX use register config,
	rtd_outl(0xb8026500, 0x00131914);	// Tcon_A/B/C sel ext_tcon_20/25/19,
	//rtd_outl(0xb8026504, 0x00000000);	// Tcon_D/E/F sel ext_tcon_0/0/0,
	//rtd_outl(0xb8026508, 0x00000000);	// Tcon_G/H/I sel ext_tcon_0/0/0,
	//rtd_outl(0xb802650C, 0x00000000);	// Tcon_J/K sel ext_tcon_0/0,
	//rtd_outl(0xb8026528, 0x0000002A);	// DST register config value,
	//rtd_outl(0xb802653C, 0x00000015);	// CST register config value,
	//rtd_outl(0xb80266F0, 0x00000000);	// C3 register config value,
	//rtd_outl(0xb8026A60, 0x00000000);	// C4 register config value,
	//rtd_outl(0xb8026AA0, 0x00000000);	// C5 register config value,
	rtd_outl(0xb8026554, 0x00142800);	// Lane0 : C1 register config value,
	rtd_outl(0xb802655C, 0x00142800);	// Lane1 : C1 register config value,
	rtd_outl(0xb8026564, 0x00142800);	// Lane2 : C1 register config value,
	rtd_outl(0xb802656C, 0x00142800);	// Lane3 : C1 register config value,
	rtd_outl(0xb8026574, 0x00142800);	// Lane4 : C1 register config value,
	rtd_outl(0xb802657C, 0x00142800);	// Lane5 : C1 register config value,
	rtd_outl(0xb8026584, 0x00142800);	// Lane6 : C1 register config value,
	rtd_outl(0xb802658C, 0x00142800);	// Lane7 : C1 register config value,
	rtd_outl(0xb8026594, 0x00142800);	// Lane8 : C1 register config value,
	rtd_outl(0xb802659C, 0x00142800);	// Lane9 : C1 register config value,
	rtd_outl(0xb80265A4, 0x00142800);	// Lane10 : C1 register config value,
	rtd_outl(0xb80265AC, 0x00142800);	// Lane11 : C1 register config value,
	rtd_outl(0xb8026624, 0x00002C8F);	// Lane0 : C2 register config value,
	rtd_outl(0xb802662C, 0x00002C8F);	// Lane1 : C2 register config value,
	rtd_outl(0xb8026634, 0x00002C8F);	// Lane2 : C2 register config value,
	rtd_outl(0xb802663C, 0x00002C8F);	// Lane3 : C2 register config value,
	rtd_outl(0xb8026644, 0x00002C8F);	// Lane4 : C2 register config value,
	rtd_outl(0xb802664C, 0x00002C8F);	// Lane5 : C2 register config value,
	rtd_outl(0xb8026654, 0x00002C8F);	// Lane6 : C2 register config value,
	rtd_outl(0xb802665C, 0x00002C8F);	// Lane7 : C2 register config value,
	rtd_outl(0xb8026664, 0x00002C8F);	// Lane8 : C2 register config value,
	rtd_outl(0xb802666C, 0x00002C8F);	// Lane9 : C2 register config value,
	rtd_outl(0xb8026674, 0x00002C8F);	// Lane10 : C2 register config value,
	rtd_outl(0xb802667C, 0x00002C8F);	// Lane11 : C2 register config value,
	//rtd_outl(0xb8026450, 0x00000000);	// General propose LUT use 1 line cycle,
	//rtd_outl(0xb8026454, 0x00000000);	// General propose LUT for line 0~1,
	//rtd_outl(0xb8026458, 0x00000000);	// General propose LUT for line 2~3,
	//rtd_outl(0xb802645C, 0x00000000);	// General propose LUT for line 4~5,
	//rtd_outl(0xb8026460, 0x00000000);	// General propose LUT for line 6~7,
	//rtd_outl(0xb8026464, 0x00000000);	// General propose LUT for line 8~9,
	//rtd_outl(0xb8026468, 0x00000000);	// General propose LUT for line 10~11,
	//rtd_outl(0xb802646C, 0x00000000);	// General propose LUT for line 12~13,
	//rtd_outl(0xb8026470, 0x00000000);	// General propose LUT for line 14~15,

	//---------------------------------------------------------------------------------------------------------------------------------
	//DISP_IF
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb802D02C, 0x00000002);	// Async FIFO use EPI Mode, P/N Swap Disable,
	rtd_outl(0xb802D038, 0x00000000);	// Async FIFO Disable,
	rtd_outl(0xb802D03C, 0x00050010);	// Async FIFO reset enable, r/w collision reset, apply after 16-clock,
	rtd_outl(0xb802D060, 0xFFFFFFFF);	// Lane 0~3 pair assign,
	rtd_outl(0xb802D064, 0xFFFFFFFF);	// Lane 4~7 pair assign,
	rtd_outl(0xb802D068, 0x0E0F1011);	// Lane 8~11 pair assign,
	rtd_outl(0xb802D06C, 0x12130809);	// Lane 12~15 pair assign,
	rtd_outl(0xb802D070, 0x0A0B0C0D);	// Lane 16~19 pair assign,
	rtd_outl(0xb802D074, 0xFFFFFFFF);	// Lane 20~23 pair assign,
	rtd_outl(0xb802D078, 0xFFFFFFFF);	// Lane 24~27 pair assign,

	//---------------------------------------------------------------------------------------------------------------------------------
	//PIF_APHY
	//---------------------------------------------------------------------------------------------------------------------------------
	rtd_outl(0xb8000C00, 0x30018020);	// PI_A1(Phase16), PI_A2(Phase16), VBG,
	rtd_outl(0xb8000C04, 0x30018020);	// PI_B1(Phase16), PI_B2(Phase16),
	rtd_outl(0xb8000C08, 0x03080101);	// PI_AB(Phase0), LDO_1V = 0.988V, TXPLL use VBy1 Path, DIVB(2),
	rtd_outl(0xb8000C0C, 0x8005E3B0);	// Big KVCO, Bypass PI, CKREF_INV(0), PLL_ICP<2:0>, PLL_SC1, PLL_SC2, PLL_SR,
	rtd_outl(0xb8000C10, 0x00000101);	// CK1X_INV(0), CK20X_INV(0), MACPLL_CKO_INV(0), PRESCALERDIV_HS(2), EPI_DIVM(14),
	rtd_outl(0xb8000C14, 0x00000000);	// Normal VCO, PLL Test PAD select, PLL_ICP<3>,
	rtd_outl(0xb8000C18, 0x00000021);	// TXPLL use EPI feedback path,
	rtd_outl(0xb8000C20, 0x00000200);	// TXPLL_EN(1), TXPLL_RSTN(0),
	rtd_outl(0xb8000C50, 0x01F4C000);	// IBN Current, VCM Level, LDO1V_EN(1), LDO2V_EN(1), VCM_SHIFT_DOWN(0),
	rtd_outl(0xb8000C74, 0x80000000);	// GLOBAL_POW_EN(1),
	rtd_outl(0xb8000C78, 0x00000400);	// CKIN_DIVN(6),
	//
	rtd_outl(0xb8000D00, 0x77002000);	// Lane0 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D10, 0x77002000);	// Lane1 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D20, 0x77002000);	// Lane2 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D30, 0x77002000);	// Lane3 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D40, 0x77002000);	// Lane4 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D50, 0x77002000);	// Lane5 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D60, 0x77002000);	// Lane6 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D70, 0x77002000);	// Lane7 : Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D80, 0x66002852);	// Lane8 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000D90, 0x66002852);	// Lane9 : HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DA0, 0x66002852);	// Lane10: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DB0, 0x66002852);	// Lane11: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DC0, 0x66002852);	// Lane12: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000DD0, 0x66002852);	// Lane13: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E00, 0x66002852);	// Lane14: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E10, 0x66002852);	// Lane15: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E20, 0x66002852);	// Lane16: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E30, 0x66002852);	// Lane17: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E40, 0x66002852);	// Lane18: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E50, 0x66002852);	// Lane19: HS Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E60, 0x77002000);	// Lane20: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E70, 0x77002000);	// Lane21: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E80, 0x77002000);	// Lane22: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000E90, 0x77002000);	// Lane23: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EA0, 0x77002000);	// Lane24: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EB0, 0x77002000);	// Lane25: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000EC0, 0x77002000);	// Lane26: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	rtd_outl(0xb8000ED0, 0x77002000);	// Lane27: Hi-Z Mode, PI_SEL(PI_DM), SR_SEL(0), TERM_SEL, IDRV_SEL, IEM_SEL,
	//
	rtd_outl(0xb8000D04, 0x44000008);	// Lane0 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D14, 0x44000008);	// Lane1 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D24, 0x44000008);	// Lane2 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D34, 0x44000008);	// Lane3 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D44, 0x44000008);	// Lane4 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D54, 0x44000008);	// Lane5 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D64, 0x44000008);	// Lane6 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D74, 0x44000008);	// Lane7 : CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000D84, 0x44023000);	// Lane8 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000D94, 0x44023000);	// Lane9 : CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000DA4, 0x44023000);	// Lane10: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000DB4, 0x44023000);	// Lane11: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000DC4, 0x44023000);	// Lane12: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000DD4, 0x44023000);	// Lane13: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E04, 0x44023000);	// Lane14: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E14, 0x44023000);	// Lane15: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E24, 0x44023000);	// Lane16: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E34, 0x44023000);	// Lane17: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E44, 0x44023000);	// Lane18: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E54, 0x44023000);	// Lane19: CKMX_INV(0), NDRV(2), IEM_EN(1), RT_EN(1), RP_EN(1), LANE_POW(0),
	rtd_outl(0xb8000E64, 0x44000008);	// Lane20: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E74, 0x44000008);	// Lane21: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E84, 0x44000008);	// Lane22: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000E94, 0x44000008);	// Lane23: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EA4, 0x44000008);	// Lane24: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EB4, 0x44000008);	// Lane25: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000EC4, 0x44000008);	// Lane26: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	rtd_outl(0xb8000ED4, 0x44000008);	// Lane27: CKMX_INV(0), IEM_EN(1), RT_EN(1), LANE_POW(0), PI_SEL(PI_DM),
	//
	rtd_outl(0xb8000D88, 0x00000009);	// Lane8 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000D98, 0x00000009);	// Lane9 : PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DA8, 0x00000009);	// Lane10: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DB8, 0x00000009);	// Lane11: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DC8, 0x00000009);	// Lane12: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000DD8, 0x00000009);	// Lane13: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E08, 0x00000009);	// Lane14: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E18, 0x00000009);	// Lane15: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E28, 0x00000009);	// Lane16: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E38, 0x00000009);	// Lane17: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E48, 0x00000009);	// Lane18: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),
	rtd_outl(0xb8000E58, 0x00000009);	// Lane19: PI_SEL(PI_DM), DIFF_PULL_LOW(0), CMFB_EN(0), DRV_MODE_SEL(CML_MODE),

	//---------------------------------------------------------------------------------------------------------------------------------
	//Initial Flow
	//--------------------------------------------------------------------------------------------------------------------------------
	// (1) DPLL Power Enable  (As above Script)
	//
	// (2) Wait DPLL stable at least 150us (SW Control)
	//
	// (3) Release DCLK Gating (SW Control)
	//
	// (4) TXPLL power up TXPLL during reset state (As above Script)
	//
	// (5) TXPLL reset release (Below Setting)
	rtd_part_outl(0xb8000C20, 10, 10, 0x1);
	//
	// (6) Wait TXPLL stable at least 150us (SW Control)
	//
	// (7) EPI Clock Enable (Below Setting)
	rtd_outl(0xb802D9B8, 0x40000000);
	//
	// (8) EPI MAC Enable (Below Setting)
	rtd_part_outl(0xb802606C, 16, 16, 0x1);
	//
	// (9) Enable Async FIFO,
	rtd_outl(0xb802D038, 0x00000001);
	// (10) APHY Lane Power Enable (Below Setting)
	rtd_part_outl(0xb8000D84, 27, 27, 0x1);	// LANE8
	rtd_part_outl(0xb8000D94, 27, 27, 0x1);	// LANE9
	rtd_part_outl(0xb8000DA4, 27, 27, 0x1);	// LANE10
	rtd_part_outl(0xb8000DB4, 27, 27, 0x1);	// LANE11
	rtd_part_outl(0xb8000DC4, 27, 27, 0x1);	// LANE12
	rtd_part_outl(0xb8000DD4, 27, 27, 0x1);	// LANE13
	rtd_part_outl(0xb8000E04, 27, 27, 0x1);	// LANE14
	rtd_part_outl(0xb8000E14, 27, 27, 0x1);	// LANE15
	rtd_part_outl(0xb8000E24, 27, 27, 0x1);	// LANE16
	rtd_part_outl(0xb8000E34, 27, 27, 0x1);	// LANE17
	rtd_part_outl(0xb8000E44, 27, 27, 0x1);	// LANE18
	rtd_part_outl(0xb8000E54, 27, 27, 0x1);	// LANE19
	//
	// (11) Panel Power Enable (SW Control),
	// (11) Panel Power Enable (SW Control),
	// (11) Panel Power Enable (SW Control),
	// (11) Panel Power Enable (SW Control),
	// (11) Panel Power Enable (SW Control),
	// (11) Panel Power Enable (SW Control),
	// (11) Panel Power Enable (SW Control),
	// (11) Panel Power Enable (SW Control),
	// (11) Panel Power Enable (SW Control),
	// (11) Panel Power Enable (SW Control),
	// (11) Panel Power Enable (SW Control),
}

#if 0
void panel_spi_read_Nbyte(unsigned int reg_addr,char num,char * data)
{
	unsigned int read_status = 0;
	unsigned int pre_reg_data = 0;
	unsigned int cur_reg_data = 0;

	//char data[29];
	char rt_done_cnt = 0;
	char i;
       printf("\n reg_addrr=%x num=%d \n",reg_addr,num);

	if(num>28)
	{
		printf("max read 29 bytes\n");
		num = 28;
	}

	rtd_part_outl(0xb802C900,0,0,0x0); //Ld_spi disable
	rtd_part_outl(0xb802C904,13,4,(0x4+num)); //Output Unit = set+1
	rtd_part_outl(0xb802C904,1,0,0x0);   //Output_Data_format:8 bit

	rtd_part_outl(0xb802C91c,25,16,0x0); //SRAM index
	rtd_part_outl(0xb802C920,9,0,0x00);
	rtd_part_outl(0xb802C920,9,0,0x01);
	rtd_part_outl(0xb802C920,9,0,0x02);
	rtd_part_outl(0xb802C920,9,0,0x03);
	rtd_part_outl(0xb802C920,9,0,0x04);

	rtd_part_outl(0xb802C924,25,16,0x0); //Data index
	rtd_part_outl(0xb802C928,15,0,0x01); //01 + Device Address
	rtd_part_outl(0xb802C928,15,0,num); //read byte num
	rtd_part_outl(0xb802C928,15,0,reg_addr); //Start Regesiter Address
	rtd_part_outl(0xb802C928,15,0,0x00); // M chip = 1
	for(i=0;i<num;i++)
	{
		//printf(" %d byte \n",i);
		rtd_part_outl(0xb802C928,15,0,0x00);
	}

	rtd_part_outl(0xb802C92c, 8, 8,0x1);			//doesn't look at command bit
	rtd_part_outl(0xb802C92c, 7, 7,0x1);			//write cmd RX
	//rtd_part_outl(0xb802C92c, 6, 6,0x0);
	//rtd_part_outl(0xb802C92c, 5, 5,0x0);
	//rtd_part_outl(0xb802C92c, 4, 4,0x0);
	//rtd_part_outl(0xb802C92c, 3, 0,0x1);

	rtd_part_outl(0xb802C930, 8, 4,(num+2)); //input Unit = set+1

	rtd_part_outl(0xb801bd18,0,0,0x0);    //7 D8: cs gpo low
	rtd_part_outl(0xb802C900,27,27,0x1); // As led reset=1
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi start enable
	rtd_part_outl(0xb802C900,1,1,0x1); //Send_trigger
	//mdelay(5);
	udelay(20*num);
	rtd_part_outl(0xb801bd18,0,0,0x1);    //7 D8: cs gpo high

	rtd_part_outl(0xb802C900,27,27,0x0); // As led reset=0

	read_status = rtd_inl(0xb802C960);
	printf("read_status = %x\n",read_status);
	while((!(read_status & _BIT31))&&(rt_done_cnt < 5))
	{
		printf("\n read_status%d = %x\n",rt_done_cnt,read_status);
		rt_done_cnt ++;
		mdelay(20);
		read_status = rtd_inl(0xb802C960);
	}

	cur_reg_data = rtd_inl(0xb802C934);
	pre_reg_data = cur_reg_data;

	cur_reg_data = rtd_inl(0xb802C938);
	read_status =  (cur_reg_data >> 1) | ((pre_reg_data & 0x00000001) << 31);
	pre_reg_data	= cur_reg_data;
	data[0] = (char)((read_status >> 24) & 0x00ff);
	data[1] = (char)((read_status >> 16) & 0x00ff);
	data[2] = (char)((read_status >> 8) & 0x00ff);
	data[3] = (char)(read_status& 0x00ff);

	cur_reg_data = rtd_inl(0xb802C93c);
	read_status =  (cur_reg_data >> 1) | ((pre_reg_data & 0x00000001) << 31);
	pre_reg_data	= cur_reg_data;
	data[4] = (char)((read_status >> 24) & 0x00ff);
	data[5] = (char)((read_status >> 16) & 0x00ff);
	data[6] = (char)((read_status >> 8) & 0x00ff);
	data[7] = (char)(read_status& 0x00ff);

	cur_reg_data = rtd_inl(0xb802C940);
	read_status =  (cur_reg_data >> 1) | ((pre_reg_data & 0x00000001) << 31);
	pre_reg_data	= cur_reg_data;
	data[8] = (char)((read_status >> 24) & 0x00ff);
	data[9] = (char)((read_status >> 16) & 0x00ff);
	data[10] = (char)((read_status >> 8) & 0x00ff);
	data[11] = (char)(read_status& 0x00ff);

	cur_reg_data = rtd_inl(0xb802C944);
	read_status =  (cur_reg_data >> 1) | ((pre_reg_data & 0x00000001) << 31);
	pre_reg_data	= cur_reg_data;
	data[12] = (char)((read_status >> 24) & 0x00ff);
	data[13] = (char)((read_status >> 16) & 0x00ff);
	data[14] = (char)((read_status >> 8) & 0x00ff);
	data[15] = (char)(read_status& 0x00ff);

	cur_reg_data = rtd_inl(0xb802C948);
	read_status =  (cur_reg_data >> 1) | ((pre_reg_data & 0x00000001) << 31);
	pre_reg_data	= cur_reg_data;
	data[16] = (char)((read_status >> 24) & 0x00ff);
	data[17] = (char)((read_status >> 16) & 0x00ff);
	data[18] = (char)((read_status >> 8) & 0x00ff);
	data[19] = (char)(read_status& 0x00ff);

	cur_reg_data = rtd_inl(0xb802C94c);
	read_status =  (cur_reg_data >> 1) | ((pre_reg_data & 0x00000001) << 31);
	pre_reg_data	= cur_reg_data;
	data[20] = (char)((read_status >> 24) & 0x00ff);
	data[21] = (char)((read_status >> 16) & 0x00ff);
	data[22] = (char)((read_status >> 8) & 0x00ff);
	data[23] = (char)(read_status& 0x00ff);

	cur_reg_data = rtd_inl(0xb802C950);
	read_status =  (cur_reg_data >> 1) | ((pre_reg_data & 0x00000001) << 31);
	pre_reg_data	= cur_reg_data;
	data[24] = (char)((read_status >> 24) & 0x00ff);
	data[25] = (char)((read_status >> 16) & 0x00ff);
	data[26] = (char)((read_status >> 8) & 0x00ff);
	data[27] = (char)(read_status& 0x00ff);

	for(i=0;i<num;i++)
		printf(" data[%x] = 0x%x \n",(reg_addr-0x80+i),data[i]);

	rtd_part_outl(0xb802C92c, 8, 8,0x1);			//doesn't look at command bit
	rtd_part_outl(0xb802C92c, 7, 7,0x0);			//write cmd back to TX

}
#endif
#if 0
void panel_spi_iw7027_reg_config_test(void)
{
	rtd_part_outl(0xb802C900,0,0,0x0); //Ld_spi disable
	rtd_part_outl(0xb802C904,13,4,0x3c); //Output Unit:60 unit(= set+1)

	rtd_part_outl(0xb802C91c,25,16,0x0); //SRAM index
	rtd_part_outl(0xb802C920,9,0,0x3a);
	rtd_part_outl(0xb802C920,9,0,0x3b);
	rtd_part_outl(0xb802C920,9,0,0x3c);
	rtd_part_outl(0xb802C920,9,0,0x0); //data register 0x00
	rtd_part_outl(0xb802C920,9,0,0x1); //data register 0x01
	rtd_part_outl(0xb802C920,9,0,0x2);
	rtd_part_outl(0xb802C920,9,0,0x3);
	rtd_part_outl(0xb802C920,9,0,0x4);
	rtd_part_outl(0xb802C920,9,0,0x5);
	rtd_part_outl(0xb802C920,9,0,0x6);
	rtd_part_outl(0xb802C920,9,0,0x7);
	rtd_part_outl(0xb802C920,9,0,0x8);
	rtd_part_outl(0xb802C920,9,0,0x9);
	rtd_part_outl(0xb802C920,9,0,0xa);
	rtd_part_outl(0xb802C920,9,0,0xb);
	rtd_part_outl(0xb802C920,9,0,0xc);
	rtd_part_outl(0xb802C920,9,0,0xd);
	rtd_part_outl(0xb802C920,9,0,0xe);
	rtd_part_outl(0xb802C920,9,0,0xf);
	rtd_part_outl(0xb802C920,9,0,0x10);
	rtd_part_outl(0xb802C920,9,0,0x11);
	rtd_part_outl(0xb802C920,9,0,0x12);
	rtd_part_outl(0xb802C920,9,0,0x13);
	rtd_part_outl(0xb802C920,9,0,0x14);
	rtd_part_outl(0xb802C920,9,0,0x15);
	rtd_part_outl(0xb802C920,9,0,0x16);
	rtd_part_outl(0xb802C920,9,0,0x17);
	rtd_part_outl(0xb802C920,9,0,0x18);
	rtd_part_outl(0xb802C920,9,0,0x19);
	rtd_part_outl(0xb802C920,9,0,0x1a);
	rtd_part_outl(0xb802C920,9,0,0x1b);
	rtd_part_outl(0xb802C920,9,0,0x1c);
	rtd_part_outl(0xb802C920,9,0,0x1d);
	rtd_part_outl(0xb802C920,9,0,0x1e);
	rtd_part_outl(0xb802C920,9,0,0x1f);
	rtd_part_outl(0xb802C920,9,0,0x20);
	rtd_part_outl(0xb802C920,9,0,0x21);
	rtd_part_outl(0xb802C920,9,0,0x22);
	rtd_part_outl(0xb802C920,9,0,0x23);
	rtd_part_outl(0xb802C920,9,0,0x24);
	rtd_part_outl(0xb802C920,9,0,0x25);
	rtd_part_outl(0xb802C920,9,0,0x26);
	rtd_part_outl(0xb802C920,9,0,0x27);
	rtd_part_outl(0xb802C920,9,0,0x28);
	rtd_part_outl(0xb802C920,9,0,0x29);
	rtd_part_outl(0xb802C920,9,0,0x2a);
	rtd_part_outl(0xb802C920,9,0,0x2b);
	rtd_part_outl(0xb802C920,9,0,0x2c);
	rtd_part_outl(0xb802C920,9,0,0x2d);
	rtd_part_outl(0xb802C920,9,0,0x2e);
	rtd_part_outl(0xb802C920,9,0,0x2f);
	rtd_part_outl(0xb802C920,9,0,0x30);
	rtd_part_outl(0xb802C920,9,0,0x31);
	rtd_part_outl(0xb802C920,9,0,0x32);
	rtd_part_outl(0xb802C920,9,0,0x33);
	rtd_part_outl(0xb802C920,9,0,0x34);
	rtd_part_outl(0xb802C920,9,0,0x35);
	rtd_part_outl(0xb802C920,9,0,0x36);
	rtd_part_outl(0xb802C920,9,0,0x37);
	rtd_part_outl(0xb802C920,9,0,0x38);
	rtd_part_outl(0xb802C920,9,0,0x39);


	//////////////////////////////////////////////////////// init register data
	rtd_part_outl(0xb802C924,25,16,0x0); //Data index
	rtd_part_outl(0xb802C928,15,0,0x06); //Data 0x00 //1. ic in reset state . 2.head shift 3.spi mode  // ??????? why  0x06??? // must bit[0]=1
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x01
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x02
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x3F);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x7F);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0xBF);
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x09
	rtd_part_outl(0xb802C928,15,0,0xFF);
	rtd_part_outl(0xb802C928,15,0,0x01);
	rtd_part_outl(0xb802C928,15,0,0x3F);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x0F
	rtd_part_outl(0xb802C928,15,0,0x3F); //Data 0x10
	rtd_part_outl(0xb802C928,15,0,0x01);
	rtd_part_outl(0xb802C928,15,0,0x7F);
	rtd_part_outl(0xb802C928,15,0,0xBF);
	rtd_part_outl(0xb802C928,15,0,0xFF);
	rtd_part_outl(0xb802C928,15,0,0x3F);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x1a
	rtd_part_outl(0xb802C928,15,0,0x1F);
	rtd_part_outl(0xb802C928,15,0,0xFF);
	rtd_part_outl(0xb802C928,15,0,0xC7);
	rtd_part_outl(0xb802C928,15,0,0xFF);
	rtd_part_outl(0xb802C928,15,0,0xF0); //Data 0x1f
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x20
	rtd_part_outl(0xb802C928,15,0,0xEF); //Data 0x21  // PWM PER 0xEF --> 0x00 bcoz only support 8 bit pwm
	rtd_part_outl(0xb802C928,15,0,0xFF); //Data 0x22  // PWM PER
	rtd_part_outl(0xb802C928,15,0,0x0F); //Data 0x23 // ?????????????? why 0x0F  ???? bcoz 12 zone
	rtd_part_outl(0xb802C928,15,0,0xFF); //Data 0x24
	rtd_part_outl(0xb802C928,15,0,0xFF);
	rtd_part_outl(0xb802C928,15,0,0xC0);
	rtd_part_outl(0xb802C928,15,0,0x3C);	//0x57	//4f
	rtd_part_outl(0xb802C928,15,0,0x44);
	rtd_part_outl(0xb802C928,15,0,0x00);	//0x0f	//00
	rtd_part_outl(0xb802C928,15,0,0x13); //Data 0x2a
	rtd_part_outl(0xb802C928,15,0,0x60);
	rtd_part_outl(0xb802C928,15,0,0xa0);
	rtd_part_outl(0xb802C928,15,0,0xE0);
	rtd_part_outl(0xb802C928,15,0,0xE4);
	rtd_part_outl(0xb802C928,15,0,0xBC); //Data 0x2f
	rtd_part_outl(0xb802C928,15,0,0x7D); //Data 0x30
	rtd_part_outl(0xb802C928,15,0,0xC4);
	rtd_part_outl(0xb802C928,15,0,0x65);
	rtd_part_outl(0xb802C928,15,0,0x16);
	rtd_part_outl(0xb802C928,15,0,0x88);
	rtd_part_outl(0xb802C928,15,0,0xA0);
	rtd_part_outl(0xb802C928,15,0,0x64);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0xC0);
	rtd_part_outl(0xb802C928,15,0,0xe0); //Data 0x39
	rtd_part_outl(0xb802C928,15,0,0x01); //00 + Device Address
	rtd_part_outl(0xb802C928,15,0,0x3a); //nNum_of_Data
	rtd_part_outl(0xb802C928,15,0,0x00); //Start Regesiter Address

	rtd_part_outl(0xb801bd18,0,0,0x0);    //7 D8: cs gpo low
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi start enable
	rtd_part_outl(0xb802C900,1,1,0x1); //Send_trigger
	udelay(1000);
	rtd_part_outl(0xb801bd18,0,0,0x1);    //7 D8: cs gpo high
}


void panel_spi_iw7027_reg_config(void)
{
	// init control regster
	rtd_part_outl(0xb802C900,0,0,0x0); //Ld_spi disable
	rtd_part_outl(0xb802C904,13,4,0x3c); //Output Unit:60 unit(= set+1)

	rtd_part_outl(0xb802C91c,25,16,0x0); //SRAM index
	rtd_part_outl(0xb802C920,9,0,0x3a);
	rtd_part_outl(0xb802C920,9,0,0x3b);
	rtd_part_outl(0xb802C920,9,0,0x3c);
	rtd_part_outl(0xb802C920,9,0,0x0); //data register 0x00
	rtd_part_outl(0xb802C920,9,0,0x1); //data register 0x01
	rtd_part_outl(0xb802C920,9,0,0x2);
	rtd_part_outl(0xb802C920,9,0,0x3);
	rtd_part_outl(0xb802C920,9,0,0x4);
	rtd_part_outl(0xb802C920,9,0,0x5);
	rtd_part_outl(0xb802C920,9,0,0x6);
	rtd_part_outl(0xb802C920,9,0,0x7);
	rtd_part_outl(0xb802C920,9,0,0x8);
	rtd_part_outl(0xb802C920,9,0,0x9);
	rtd_part_outl(0xb802C920,9,0,0xa);
	rtd_part_outl(0xb802C920,9,0,0xb);
	rtd_part_outl(0xb802C920,9,0,0xc);
	rtd_part_outl(0xb802C920,9,0,0xd);
	rtd_part_outl(0xb802C920,9,0,0xe);
	rtd_part_outl(0xb802C920,9,0,0xf);
	rtd_part_outl(0xb802C920,9,0,0x10);
	rtd_part_outl(0xb802C920,9,0,0x11);
	rtd_part_outl(0xb802C920,9,0,0x12);
	rtd_part_outl(0xb802C920,9,0,0x13);
	rtd_part_outl(0xb802C920,9,0,0x14);
	rtd_part_outl(0xb802C920,9,0,0x15);
	rtd_part_outl(0xb802C920,9,0,0x16);
	rtd_part_outl(0xb802C920,9,0,0x17);
	rtd_part_outl(0xb802C920,9,0,0x18);
	rtd_part_outl(0xb802C920,9,0,0x19);
	rtd_part_outl(0xb802C920,9,0,0x1a);
	rtd_part_outl(0xb802C920,9,0,0x1b);
	rtd_part_outl(0xb802C920,9,0,0x1c);
	rtd_part_outl(0xb802C920,9,0,0x1d);
	rtd_part_outl(0xb802C920,9,0,0x1e);
	rtd_part_outl(0xb802C920,9,0,0x1f);
	rtd_part_outl(0xb802C920,9,0,0x20);
	rtd_part_outl(0xb802C920,9,0,0x21);
	rtd_part_outl(0xb802C920,9,0,0x22);
	rtd_part_outl(0xb802C920,9,0,0x23);
	rtd_part_outl(0xb802C920,9,0,0x24);
	rtd_part_outl(0xb802C920,9,0,0x25);
	rtd_part_outl(0xb802C920,9,0,0x26);
	rtd_part_outl(0xb802C920,9,0,0x27);
	rtd_part_outl(0xb802C920,9,0,0x28);
	rtd_part_outl(0xb802C920,9,0,0x29);
	rtd_part_outl(0xb802C920,9,0,0x2a);
	rtd_part_outl(0xb802C920,9,0,0x2b);
	rtd_part_outl(0xb802C920,9,0,0x2c);
	rtd_part_outl(0xb802C920,9,0,0x2d);
	rtd_part_outl(0xb802C920,9,0,0x2e);
	rtd_part_outl(0xb802C920,9,0,0x2f);
	rtd_part_outl(0xb802C920,9,0,0x30);
	rtd_part_outl(0xb802C920,9,0,0x31);
	rtd_part_outl(0xb802C920,9,0,0x32);
	rtd_part_outl(0xb802C920,9,0,0x33);
	rtd_part_outl(0xb802C920,9,0,0x34);
	rtd_part_outl(0xb802C920,9,0,0x35);
	rtd_part_outl(0xb802C920,9,0,0x36);
	rtd_part_outl(0xb802C920,9,0,0x37);
	rtd_part_outl(0xb802C920,9,0,0x38);
	rtd_part_outl(0xb802C920,9,0,0x39);


	//////////////////////////////////////////////////////// init register data
	rtd_part_outl(0xb802C924,25,16,0x0); //Data index
	rtd_part_outl(0xb802C928,15,0,0x06); //Data 0x00 //1. ic in reset state . 2.head shift 3.spi mode  // ??????? why  0x06??? // must bit[0]=1
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x01
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x02
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x3F);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x7F);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0xBF);
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x09
	rtd_part_outl(0xb802C928,15,0,0xFF);
	rtd_part_outl(0xb802C928,15,0,0x01);
	rtd_part_outl(0xb802C928,15,0,0x3F);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x0F
	rtd_part_outl(0xb802C928,15,0,0x3F); //Data 0x10
	rtd_part_outl(0xb802C928,15,0,0x01);
	rtd_part_outl(0xb802C928,15,0,0x7F);
	rtd_part_outl(0xb802C928,15,0,0xBF);
	rtd_part_outl(0xb802C928,15,0,0xFF);
	rtd_part_outl(0xb802C928,15,0,0x3F);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x1a
	rtd_part_outl(0xb802C928,15,0,0x1F);
	rtd_part_outl(0xb802C928,15,0,0xFF);
	rtd_part_outl(0xb802C928,15,0,0xC7);
	rtd_part_outl(0xb802C928,15,0,0xFF);
	rtd_part_outl(0xb802C928,15,0,0xF0); //Data 0x1f
	rtd_part_outl(0xb802C928,15,0,0x00); //Data 0x20
	rtd_part_outl(0xb802C928,15,0,0xEF); //Data 0x21  // PWM PER 0xEF --> 0x00 bcoz only support 8 bit pwm
	rtd_part_outl(0xb802C928,15,0,0xFF); //Data 0x22  // PWM PER
	rtd_part_outl(0xb802C928,15,0,0x0F); //Data 0x23 // ?????????????? why 0x0F  ???? bcoz 12 zone
	rtd_part_outl(0xb802C928,15,0,0xFF); //Data 0x24
	rtd_part_outl(0xb802C928,15,0,0xFF);
	rtd_part_outl(0xb802C928,15,0,0xC0);
	rtd_part_outl(0xb802C928,15,0,0x3F);	//0x57	//4f
	rtd_part_outl(0xb802C928,15,0,0x44);
	rtd_part_outl(0xb802C928,15,0,0x0F);	//0x0f	//00
	rtd_part_outl(0xb802C928,15,0,0x13); //Data 0x2a
	rtd_part_outl(0xb802C928,15,0,0x60);
	rtd_part_outl(0xb802C928,15,0,0xa0);
	rtd_part_outl(0xb802C928,15,0,0xE0);
	rtd_part_outl(0xb802C928,15,0,0xE4);
	rtd_part_outl(0xb802C928,15,0,0xBC); //Data 0x2f
	rtd_part_outl(0xb802C928,15,0,0xDD); //Data 0x30
	rtd_part_outl(0xb802C928,15,0,0xC4);
	rtd_part_outl(0xb802C928,15,0,0x65);
	rtd_part_outl(0xb802C928,15,0,0x16);
	rtd_part_outl(0xb802C928,15,0,0x88);
	rtd_part_outl(0xb802C928,15,0,0xA0);
	rtd_part_outl(0xb802C928,15,0,0x44);
	rtd_part_outl(0xb802C928,15,0,0x00);
	rtd_part_outl(0xb802C928,15,0,0xC0);
	rtd_part_outl(0xb802C928,15,0,0xe0); //Data 0x39
	rtd_part_outl(0xb802C928,15,0,0x01); //00 + Device Address
	rtd_part_outl(0xb802C928,15,0,0x3a); //nNum_of_Data
	rtd_part_outl(0xb802C928,15,0,0x00); //Start Regesiter Address

	rtd_part_outl(0xb801bd18,0,0,0x0);    //7 D8: cs gpo low
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi start enable
	rtd_part_outl(0xb802C900,1,1,0x1); //Send_trigger
	udelay(1000);
	rtd_part_outl(0xb801bd18,0,0,0x1);    //7 D8: cs gpo high

	mdelay(50);
	// init backlight data regster
	rtd_part_outl(0xb802C900,0,0,0x0); //Ld_spi disable
	rtd_part_outl(0xb802C904,13,4,0x1a); //Output Unit:27 unit(= set+1)

	rtd_part_outl(0xb802C91c,25,16,0x0); //SRAM index
	rtd_part_outl(0xb802C920,9,0,0x18);
	rtd_part_outl(0xb802C920,9,0,0x19);
	rtd_part_outl(0xb802C920,9,0,0x1a);
	rtd_part_outl(0xb802C920,9,0,0x0); //data register 0x00
	rtd_part_outl(0xb802C920,9,0,0x1); //data register 0x01
	rtd_part_outl(0xb802C920,9,0,0x2);
	rtd_part_outl(0xb802C920,9,0,0x3);
	rtd_part_outl(0xb802C920,9,0,0x4);
	rtd_part_outl(0xb802C920,9,0,0x5);
	rtd_part_outl(0xb802C920,9,0,0x6);
	rtd_part_outl(0xb802C920,9,0,0x7);
	rtd_part_outl(0xb802C920,9,0,0x8);
	rtd_part_outl(0xb802C920,9,0,0x9);
	rtd_part_outl(0xb802C920,9,0,0xa);
	rtd_part_outl(0xb802C920,9,0,0xb);
	rtd_part_outl(0xb802C920,9,0,0xc);
	rtd_part_outl(0xb802C920,9,0,0xd);
	rtd_part_outl(0xb802C920,9,0,0xe);
	rtd_part_outl(0xb802C920,9,0,0xf);
	rtd_part_outl(0xb802C920,9,0,0x10);
	rtd_part_outl(0xb802C920,9,0,0x11);
	rtd_part_outl(0xb802C920,9,0,0x12);
	rtd_part_outl(0xb802C920,9,0,0x13);
	rtd_part_outl(0xb802C920,9,0,0x14);
	rtd_part_outl(0xb802C920,9,0,0x15);
	rtd_part_outl(0xb802C920,9,0,0x16);
	rtd_part_outl(0xb802C920,9,0,0x17);

	//////////////////////////////////////////////////////// init register data
	rtd_part_outl(0xb802C924,25,16,0x0); //Data index
	rtd_part_outl(0xb802C928,15,0,0x0D); //Data 0x40
	rtd_part_outl(0xb802C928,15,0,0xB0); //Data 0x41
	rtd_part_outl(0xb802C928,15,0,0x0D); //Data 0x42
	rtd_part_outl(0xb802C928,15,0,0xB0); //Data 0x43
	rtd_part_outl(0xb802C928,15,0,0x0D); //Data 0x44
	rtd_part_outl(0xb802C928,15,0,0xB0); //Data 0x45
	rtd_part_outl(0xb802C928,15,0,0x0D); //Data 0x46
	rtd_part_outl(0xb802C928,15,0,0xB0); //Data 0x47
	rtd_part_outl(0xb802C928,15,0,0x0F); //Data 0x48
	rtd_part_outl(0xb802C928,15,0,0x20); //Data 0x49
	rtd_part_outl(0xb802C928,15,0,0x0F); //Data 0x4a
	rtd_part_outl(0xb802C928,15,0,0x24); //Data 0x4b
	rtd_part_outl(0xb802C928,15,0,0x0F); //Data 0x4c
	rtd_part_outl(0xb802C928,15,0,0x1C); //Data 0x4d
	rtd_part_outl(0xb802C928,15,0,0x0F); //Data 0x4e
	rtd_part_outl(0xb802C928,15,0,0x20); //Data 0x4f
	rtd_part_outl(0xb802C928,15,0,0x0D); //Data 0x50
	rtd_part_outl(0xb802C928,15,0,0xB0); //Data 0x51
	rtd_part_outl(0xb802C928,15,0,0x0D); //Data 0x52
	rtd_part_outl(0xb802C928,15,0,0xB0); //Data 0x53
	rtd_part_outl(0xb802C928,15,0,0x0D); //Data 0x54
	rtd_part_outl(0xb802C928,15,0,0xB0); //Data 0x55
	rtd_part_outl(0xb802C928,15,0,0x0D); //Data 0x56
	rtd_part_outl(0xb802C928,15,0,0xB0); //Data 0x57

	rtd_part_outl(0xb802C928,15,0,0x01); //00 + Device Address
	rtd_part_outl(0xb802C928,15,0,0x18); //nNum_of_Data
	rtd_part_outl(0xb802C928,15,0,0x40); //Start Regesiter Address

	rtd_part_outl(0xb801bd18,0,0,0x0);    //7 D8: cs gpo low
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi start enable
	rtd_part_outl(0xb802C900,1,1,0x1); //Send_trigger
	udelay(1000);
	rtd_part_outl(0xb801bd18,0,0,0x1);    //7 D8: cs gpo high


}


void panel_ld_12R_nomcu_spi_init(void)
{
	unsigned char reg00_1B[0x1c] = {0x06,0x00,0x00,0x00,0x3F,0x00,0x7F,0x00,0xBF,0x00,0xFF,0x01,0x3F,0x00,
		0x00,0x00,0x3F,0x01,0x7F,0xBF,0xFF,0x3F,0x00,0x00,0x00,0x00,0x00,0x1F};
	unsigned char reg1C_37[0x1c] = {0xFF,0xC7,0xFF,0xF0,0x00,0xEF,0xFF,0x0F,0xFF,0xFF,0xC0,0x3F,0x44,0x0F,
		0x13,0x60,0xa0,0xE0,0xE4,0xBC,0xDD,0xC4,0x65,0x16,0x88,0xA0,0x44,0x00};
	unsigned char reg38_39[2] = {0xc0,0xe0};
       unsigned char reg_tmp1[0x1c];
	//unsigned char reg_tmp2[0x1c];
	//unsigned char reg_tmp3[2];
	unsigned char i;
	unsigned char j;

	//===================== step 0 : Local Dimming spi interface init =====================
	//src1
	rtd_part_outl(0xb802c268,9,9,0x0);  // ld algo off

	//---pin mux setting---
	rtd_part_outl(0xb8000c74,31,31,0x1);		//lvds pad power enable
	rtd_part_outl(0xb8000d74,31,31,0x1);

	rtd_part_outl(0xb80008b8,29,28,0x1);	//ld_spi0_p2_sck_src0/src1
	rtd_part_outl(0xb80008b8,25,24,0x1);	//ld_spi0_p3_sdo_src0/src1
	rtd_part_outl(0xb80008b8,21,20,0x1);	//ld_spi0_p4_sdi_src0/src1

	//rtd_part_outl(0xb80008b8,9,8,0x1);	//ld_spi1_p4_sdi_src0/src1

	//rtd_part_outl(0xb8000800,31,28,0x7);	  //7 D8: ld_spi0_p1_cs1,<O>		   gpio_0
	rtd_part_outl(0xb8000800,31,28,0xF);	//7 D8: ld_spi0_p1_cs1,<O>			 gpio_0
	rtd_part_outl(0xb801bd00,0,0,0x1);	  //7 D8: cs gpo
	rtd_part_outl(0xb801bd18,0,0,0x1);	  //7 D8: cs gpo high

	rtd_part_outl(0xb8000800,23,20,0x7);	//7 E8: ld_spi0_p2_sck_src1,<I/O>	 gpio_1
	rtd_part_outl(0xb8000800,15,12,0x7);	//7 E7: ld_spi0_p3_sdo_SRC1,<I/O>	 gpio_2
	rtd_part_outl(0xb8000c80,31,28,0x7);	//7 E5: ld_spi0_p4_sdi_SRC1,<I> 	 gpio_7  lvds_p0_txgp
	//rtd_part_outl(0xb8000c80,27,24,0x7);	//7 D4: ld_spi0_p5_v_sync,<O>		 gpio_8  lvds_p0_txgn
	//rtd_part_outl(0xb8000c80,23,20,0x7);	  //7 ??: ld_spi0_p6_h_sync,<O> 	   gpio_9  lvds_p0_txfp

	//rtd_part_outl(0xb8000c84,31,28,0x3);	  //7 H6: ld_spi1_p4_sdi_SRC1,<I>	   gpio_15	lvds_p0_txgp

	rtd_part_outl(0xb802C900,0,0,0x0); //Ld_spi start disabel
	rtd_part_outl(0xb802C900,28,28,0x1); //Ld_spi enable
	rtd_part_outl(0xb802C900,2,2,0x0); // no Send_follow_Vsync

	rtd_part_outl(0xb802C900,31,30,0x3); //AS led driver mode
	rtd_part_outl(0xb802C900,4,4,0x0); //LD_SPI0
	rtd_part_outl(0xb802C900,10,10,0x0);	//TX CLK no inverse for AS led driver mode
	rtd_part_outl(0xb802C900,15,15,0x1); //RX_SDI inverse

	rtd_part_outl(0xb802C900,3,3,0x0); //one SPI local dimming block
	//rtd_part_outl(0xb802C900,3,3,0x1); //two SPI local dimming block

	//rtd_part_outl(0xb802C900,27,27,0x1); // As led reset

	rtd_part_outl(0xb802C904,31,31,0x1); //First received bit or transmitted bit is in the MSB of SRAM or register
	//rtd_part_outl(0xb802C904,13,4,0x13); //Output Unit:126 unit(= set+1)
	//rtd_part_outl(0xb802C904,13,4,0x2); //Output Unit:16 unit(= set+1)
	rtd_part_outl(0xb802C904,1,0,0x0); //Output_Data_format:8 bit
	//rtd_part_outl(0xb802C904,1,0,0x2); //Output_Data_format:16 bit  AS mode can select 8bit or 16bit data format

	//rtd_part_outl(0xb802C90c,31,8,0x4a9); //Data_send_Delay  T1=(data_send_delay+CS_hold+SCKL+10)*4 = 10us
	rtd_part_outl(0xb802C958,31,8,0xc); //CS_hold_time
	rtd_part_outl(0xb802C908,23,16,0xC0); //SCK_H			 T2=(SCK_H+SCK_L+2)*4= 0.84us
	rtd_part_outl(0xb802C908,7,0,0xC0);   //SCK_L			 T3=T2/2 = 0.42us
	//rtd_part_outl(0xb802C910,31,8,0x10b); //Each_unit_delay  T4=(Each_unit_delay+SCK_H+SCK_L)*4 = 1.9us
	//rtd_part_outl(0xb802C914,31,24,0x3a); //Vsync_d		   T5=(Vsync_d+1)*128*4 = 30.2us

	rtd_part_outl(0xb802C918,24,16,0xC0); //Data_hold_time, must to set equal SCK_H!!!
	//rtd_part_outl(0xb802C918,24,16,0xBE); //Data_hold_time


	//===================== step 1 : [Soft_rst_n]=0 =====================

	mdelay(20);
	rtd_part_outl(0xb802C900,0,0,0x0); //Ld_spi disable
	rtd_part_outl(0xb802C92c, 8, 8,0x1);			//doesn't look at command bit
	rtd_part_outl(0xb802C92c, 7, 7,0x0);			//write cmd TX

	rtd_part_outl(0xb802C904,13,4,0x3); //Output Unit = set+1

	rtd_part_outl(0xb802C91c,25,16,0x0); //SRAM index
	rtd_part_outl(0xb802C920,9,0,0x01);
	rtd_part_outl(0xb802C920,9,0,0x02);
	rtd_part_outl(0xb802C920,9,0,0x03);
	rtd_part_outl(0xb802C920,9,0,0x00); //data register 0x00

	rtd_part_outl(0xb802C924,25,16,0x0); //Data index
	rtd_part_outl(0xb802C928,15,0,0x06); //Data 0x00 //[Soft_rst_n=0]
	rtd_part_outl(0xb802C928,15,0,0x01); //00 + Device Address
	rtd_part_outl(0xb802C928,15,0,0x01); //nNum_of_Data
	rtd_part_outl(0xb802C928,15,0,0x00); //Start Regesiter Address

	rtd_part_outl(0xb801bd18,0,0,0x0);    //7 D8: cs gpo low
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi start enable
	rtd_part_outl(0xb802C900,1,1,0x1); //Send_trigger
	//mdelay(5);
	udelay(100);
	rtd_part_outl(0xb801bd18,0,0,0x1);    //7 D8: cs gpo high

	//===================== step 2 : spi communication check =====================

	mdelay(100);
       char reg00_data = panel_spi_read_byte(0x80,0);
	char spi_chk_cnt = 0;

	while((reg00_data != 0x06)&&(spi_chk_cnt < 5))
	{
		printf("reg00_data%d = 0x%x\n",spi_chk_cnt,reg00_data);
		mdelay(100);
		reg00_data = panel_spi_read_byte(0x80,0);
		spi_chk_cnt++;
	}
       if(spi_chk_cnt==5)
		printf("spi check timeout\n");
	else
		printf("spi check pass\n");

       //===================== step 3 : supply stable vsync =====================

	rtd_part_outl(0xb8000c80,27,24,0x7);	//7 D4: ld_spi0_p5_v_sync,<O>		 gpio_8  lvds_p0_txgn

	//===================== step 4 : Register Configure =====================

	//panel_spi_iw7027_reg_config_test();
	panel_spi_iw7027_reg_config();

	mdelay(100);
	panel_spi_read_Nbyte(0x80,0x1C,reg_tmp1);

	 // check reg config
       mdelay(100);
	for(j=0;j<3;j++)
	{
		// 0x00 - 0x1B
		for(i=0;i<0x1c;i++)
		{
			if(reg_tmp1[i] != reg00_1B[i])
			{
				printf("\n reg[%x] error\n",i);
				printf("\comp 0x%x -- 0x%x  \n",reg_tmp1[i],reg00_1B[i]);
				break;
			}
		}
		if(i < 0x1c)
		{
			panel_spi_iw7027_reg_config();
			mdelay(100);
			panel_spi_read_Nbyte(0x80,0x1C,reg_tmp1);
			continue;
		}

		// 0x1C - 0x37
		mdelay(100);
		panel_spi_read_Nbyte(0x9C,0x1C,reg_tmp1);
		for(i=0;i<0x1c;i++)
		{

			if(reg_tmp1[i] != reg1C_37[i])
			{
				printf("\n reg[%x] error\n",(i+0x1c));
				printf("\comp 0x%x -- 0x%x  \n",reg_tmp1[i],reg1C_37[i]);
				break;
			}
		}
		if(i < 0x1c)
		{
			panel_spi_iw7027_reg_config();
			mdelay(100);
			panel_spi_read_Nbyte(0x80,0x1C,reg_tmp1);
			continue;
		}

		// 0x38 - 0x39
		mdelay(100);
		panel_spi_read_Nbyte(0xB8,0x8,reg_tmp1);
		for(i=0;i<2;i++)
		{
			if(reg_tmp1[i] != reg38_39[i])
			{
				printf("\n reg[%x] error\n",(i+0x38));
				printf("\comp 0x%x -- 0x%x  \n",reg_tmp1[i],reg38_39[i]);
				break;
			}
		}
		if(i < 2)
		{
			panel_spi_iw7027_reg_config();
			mdelay(100);
			panel_spi_read_Nbyte(0x80,0x1C,reg_tmp1);
			continue;
		}
		else
		{
			printf("\n check reg config ok\n");
			break;
		}
	}
	if(j == 3)
		printf(" check reg config error \n");

	//===================== step 5 : Waiting system clock and Light bar PSU stable  ============

	mdelay(500);


       //===================== step 6 : [Soft_rst_n]=1 =====================

	rtd_part_outl(0xb802C900,0,0,0x0); //Ld_spi disable
	rtd_part_outl(0xb802C904,13,4,0x3); //Output Unit = set+1

	rtd_part_outl(0xb802C91c,25,16,0x0); //SRAM index
	rtd_part_outl(0xb802C920,9,0,0x01);
	rtd_part_outl(0xb802C920,9,0,0x02);
	rtd_part_outl(0xb802C920,9,0,0x03);
	rtd_part_outl(0xb802C920,9,0,0x00); //data register 0x00

	rtd_part_outl(0xb802C924,25,16,0x0); //Data index
	rtd_part_outl(0xb802C928,15,0,0x07); //Data 0x00 //1. ic in reset state . 2.head shift 3.spi mode  // ??????? why  0x06??? // must bit[0]=1
	rtd_part_outl(0xb802C928,15,0,0x01); //00 + Device Address
	rtd_part_outl(0xb802C928,15,0,0x01); //nNum_of_Data
	rtd_part_outl(0xb802C928,15,0,0x00); //Start Regesiter Address

	rtd_part_outl(0xb801bd18,0,0,0x0);    //7 D8: cs gpo low
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi start enable
	rtd_part_outl(0xb802C900,1,1,0x1); //Send_trigger
	udelay(100);
	rtd_part_outl(0xb801bd18,0,0,0x1);    //7 D8: cs gpo high

	//===================== step 7 : Wait Calibration Done =====================
#if 1
	//read reg addr > 0x80 need 0x78[7]=1
	mdelay(100);
	rtd_part_outl(0xb802C92c, 8, 8,0x1);			//doesn't look at command bit
	rtd_part_outl(0xb802C92c, 7, 7,0x0);			//write cmd TX

	rtd_part_outl(0xb802C900,0,0,0x0); //Ld_spi disable
	rtd_part_outl(0xb802C904,13,4,0x3); //Output Unit = set+1

	rtd_part_outl(0xb802C91c,25,16,0x0); //SRAM index
	rtd_part_outl(0xb802C920,9,0,0x01);
	rtd_part_outl(0xb802C920,9,0,0x02);
	rtd_part_outl(0xb802C920,9,0,0x03);
	rtd_part_outl(0xb802C920,9,0,0x00); //data register 0x00

	rtd_part_outl(0xb802C924,25,16,0x0); //Data index
	rtd_part_outl(0xb802C928,15,0,0x80); // set 0x78[7]=1
	rtd_part_outl(0xb802C928,15,0,0x01); //00 + Device Address
	rtd_part_outl(0xb802C928,15,0,0x01); //nNum_of_Data
	rtd_part_outl(0xb802C928,15,0,0x78); //Start Regesiter Address

	rtd_part_outl(0xb801bd18,0,0,0x0);    //7 D8: cs gpo low
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi start enable
	rtd_part_outl(0xb802C900,1,1,0x1); //Send_trigger
	udelay(100);
	rtd_part_outl(0xb801bd18,0,0,0x1);    //7 D8: cs gpo high

	mdelay(100);
	char calibration_cnt = 0;
       char regB3_data = panel_spi_read_byte(0xB3,0);
	while((regB3_data != 0x55)&& calibration_cnt < 8)
	{
		printf("\n regB3_data%d = 0x%x \n",calibration_cnt,regB3_data);
		mdelay(200);
		WATCHDOG_KICK();
		regB3_data = panel_spi_read_byte(0xB3,0);
		calibration_cnt++;
	}
	if(calibration_cnt==8)
		printf("calibration check timeout\n");
	else
		printf("calibration finish\n");

	//read reg addr < 0x80 need 0x78[7] back to 0
       mdelay(100);
	rtd_part_outl(0xb802C900,0,0,0x0); //Ld_spi disable
	rtd_part_outl(0xb802C904,13,4,0x3); //Output Unit = set+1

	rtd_part_outl(0xb802C91c,25,16,0x0); //SRAM index
	rtd_part_outl(0xb802C920,9,0,0x01);
	rtd_part_outl(0xb802C920,9,0,0x02);
	rtd_part_outl(0xb802C920,9,0,0x03);
	rtd_part_outl(0xb802C920,9,0,0x00); //data register 0x00

	rtd_part_outl(0xb802C924,25,16,0x0); //Data index
	rtd_part_outl(0xb802C928,15,0,0x00); // set 0x78[7]=1
	rtd_part_outl(0xb802C928,15,0,0x01); //00 + Device Address
	rtd_part_outl(0xb802C928,15,0,0x01); //nNum_of_Data
	rtd_part_outl(0xb802C928,15,0,0x78); //Start Regesiter Address

	rtd_part_outl(0xb801bd18,0,0,0x0);    //7 D8: cs gpo low
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi start enable
	rtd_part_outl(0xb802C900,1,1,0x1); //Send_trigger
	udelay(100);
	rtd_part_outl(0xb801bd18,0,0,0x1);    //7 D8: cs gpo high
#else
	mdelay(300);
	WATCHDOG_KICK();
		mdelay(300);
	WATCHDOG_KICK();
		mdelay(300);
	WATCHDOG_KICK();
		mdelay(300);
	WATCHDOG_KICK();
		mdelay(300);
	WATCHDOG_KICK();
		mdelay(300);
	WATCHDOG_KICK();
		mdelay(300);
	WATCHDOG_KICK();
#endif
	//===================== step 8 : Local Dimmig 16bit data output =====================

	mdelay(100);
	rtd_part_outl(0xb802C900, 0, 0,0x00);			//Ld_spi disable


	rtd_part_outl(0xb802C268, 7, 0,0xff);			//shift ld algo result to 12 bits
	rtd_part_outl(0xb802C904,13, 4,0x0d);			//Output Unit:13 unit(= set+1)	every time sent 2 Byte when SPI is 16 bits mode (12*2+4)/2-1
	rtd_part_outl(0xb802C904, 1, 0,0x02);			//Set SPI out data format 16 bits

	rtd_part_outl(0xb802C91c,25,16,0x00);			//SRAM index
	rtd_part_outl(0xb802C920, 9, 0,0x18);			//Device Address + Num_of_data
	rtd_part_outl(0xb802C920, 9, 0,0x19);			//Start Reg Address + default value of REG_0x3f
	rtd_part_outl(0xb802C920, 9, 0,0x00);			//LED 0
	rtd_part_outl(0xb802C920, 9, 0,0x02);			//LED 1
	rtd_part_outl(0xb802C920, 9, 0,0x04);			//LED 2
	rtd_part_outl(0xb802C920, 9, 0,0x06);			//LED 3
	rtd_part_outl(0xb802C920, 9, 0,0x08);			//LED 4
	rtd_part_outl(0xb802C920, 9, 0,0x0a);			//LED 5
	rtd_part_outl(0xb802C920, 9, 0,0x0c);			//LED 6
	rtd_part_outl(0xb802C920, 9, 0,0x0e);			//LED 7
	rtd_part_outl(0xb802C920, 9, 0,0x10);			//LED 8
	rtd_part_outl(0xb802C920, 9, 0,0x12);			//LED 9
	rtd_part_outl(0xb802C920, 9, 0,0x14);			//LED 10
	rtd_part_outl(0xb802C920, 9, 0,0x16);			//LED 11


	rtd_part_outl(0xb802C924,25,16,0x00);			//Data index
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//MSB:Reg40 				LSB:Reg41
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//MSB:Reg42 				LSB:Reg43
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//MSB:Reg44 				LSB:Reg45
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//MSB:Reg46 				LSB:Reg47
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0F20); 		//MSB:Reg48 				LSB:Reg49
	rtd_part_outl(0xb802C928,15, 0,0x0F20); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0F24); 		//MSB:Reg4a 				LSB:Reg4b
	rtd_part_outl(0xb802C928,15, 0,0x0F24); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0F1C); 		//MSB:Reg4c 				LSB:Reg4d
	rtd_part_outl(0xb802C928,15, 0,0x0F1C); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0F20); 		//MSB:Reg4e 				LSB:Reg4f
	rtd_part_outl(0xb802C928,15, 0,0x0F20); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//MSB:Reg50 				LSB:Reg51
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//MSB:Reg52 				LSB:Reg53
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//MSB:Reg54 				LSB:Reg55
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//MSB:Reg56 				LSB:Reg57
	rtd_part_outl(0xb802C928,15, 0,0x0DB0); 		//Not Use
	rtd_part_outl(0xb802C928,15, 0,0x0119); 		//MSB:Device Address		LSB:Num_of_data
	rtd_part_outl(0xb802C928,15, 0,0x3f88); 		//MSB:Start Reg Address 	LSB:default value of REG_0x3f


	rtd_part_outl(0xb802C900,2,2,0x1); //Send_follow_Vsync
	rtd_part_outl(0xb802C900,0,0,0x1); //Ld_spi start enable

	// CS use tcon 0
	//rtd_outl(0xb8000C74, 0x80800000);		// Low Speed APHY Power Enable
	rtd_maskl(0xb8000800, 0x0FFFFFFF, 0x30000000);	// D8, use Tcon0,

	//rtd_outl(0xb8000c88,0xFF335F03);	   // Demo Board TCON setting
	// Tcon Timing Setting,
	//rtd_outl(0xb802D200, 0x40000000);		// External Tcon Across frame and Across line 3 Function enable,
	//rtd_outl(0xb802D42C, 0x00000000);		// External Global Tcon disable,
	//rtd_outl(0xb8026804, 0x40000000);		// EPI Tcon Across frame and Across line 3 Function enable,
	//rtd_outl(0xb8026800, 0x00000006);		// EPI Tcon use SFG VS, global Tcon disable,

	// CS,
	// Tcon0
	rtd_outl(0xb802D204, 0x00700070);		// H_start/H_end,
	//rtd_outl(0xb802D208, 0x00030036);		// V_start/V_end,
	rtd_outl(0xb802D208, 0x0001006C);		// V_start/V_end,
	rtd_outl(0xb802D20C, 0x000001C0);		// Control,

	//rtd_outl(0xb802D42C, 0x00000001);		// External Global Tcon enable,
	//rtd_outl(0xb8026800, 0x00000007);		// EPI Tcon use SFG VS, global Tcon enable,

	//rtd_part_outl(0xb802c268,9,9,0x1);  // ld algo on

}

void panel_ld_18R_algo_init(void)
{

	// This script is for skyworth Edge type 18 regions local dimming

	// LD algo setting
	rtd_part_outl(0xb802C268,31,25,0x3); 	// BLU WR NUM = 3
	rtd_part_outl(0xb802C268,24,16,0x23); 	// SPI total = 36
	rtd_part_outl(0xb802C268,7,0,0x10); 	// BLU gain = 16
	rtd_part_outl(0xb802C208,0,0,0x1); 		// LD valid

	rtd_part_outl(0xb802C268,9,9,0x1); 		// SPI enable
	rtd_part_outl(0xb802C294,1,1,0x0); 		// SW off
	rtd_part_outl(0xb802c200,31,31,0x0); 	// Comp off

	rtd_part_outl(0xb802c208,1,1,0x1); 		// LD_T_Enable
	rtd_part_outl(0xb802c208,5,4,0x1); 		// edge top-buttom type
	rtd_part_outl(0xb802c204,31,31,0x0); 	// db off
	rtd_part_outl(0xb802c208,28,24,0x11); 	// Hunm
	rtd_part_outl(0xb802c208,20,16,0x0); 	// Vunm
	rtd_part_outl(0xb802c208,3,2,0x2); 		// LD_Hist_Mode?????????????????????????
	rtd_part_outl(0xb802c20c,28,16,0xd5); 	// Hsize 3840/18 = 0xd5
	rtd_part_outl(0xb802c20c,11,0,0x870); 	// Vsize 2160/1 = 2160

	// backlight decision
	rtd_outl(0xb802c23c, 0x160a0004);
	rtd_outl(0xb802c240, 0x00000000);
	rtd_outl(0xb802c244, 0x00000000);

	// temporal filter
	rtd_outl(0xb802c25c, 0x08300418);
	rtd_outl(0xb802c260, 0x08300210);
	rtd_outl(0xb802c264, 0x00400400);

	// spatial filter
	rtd_outl(0xb802c250, 0x00770220);
 	rtd_outl(0xb802c254, 0x00000001);

	rtd_part_outl(0xb802c2e8,9,0,0x00000000);
	rtd_outl(0xb802c258,0x00071039);
	rtd_outl(0xb802c258,0x010e00a8);
	rtd_outl(0xb802c258,0x0214f117);
	rtd_outl(0xb802c258,0x031be186);
	rtd_outl(0xb802c258,0x0422d1f5);
 	rtd_outl(0xb802c258,0x0526b264);
	rtd_outl(0xb802c258,0x06278272);
	rtd_outl(0xb802c258,0x0728627f);
	rtd_outl(0xb802c258,0x0829428d);
	rtd_outl(0xb802c258,0x092a229b);
	rtd_outl(0xb802c258,0x0a2b02a9);
	rtd_outl(0xb802c258,0x0b2be2b7);
	rtd_outl(0xb802c258,0x0c2cd2c6);
 	rtd_outl(0xb802c258,0x0d2db2d4);
	rtd_outl(0xb802c258,0x0e2ea2e3);
	rtd_outl(0xb802c258,0x0f2f92f2);
	rtd_outl(0xb802c258,0x10308301);
	rtd_outl(0xb802c258,0x11318310);
	rtd_outl(0xb802c258,0x1232731f);
	rtd_outl(0xb802c258,0x1333732f);
	rtd_outl(0xb802c258,0x1434633e);
 	rtd_outl(0xb802c258,0x1535634e);
	rtd_outl(0xb802c258,0x1636635e);
	rtd_outl(0xb802c258,0x1737736e);
	rtd_outl(0xb802c258,0x1838737f);
	rtd_outl(0xb802c258,0x1939838f);
	rtd_outl(0xb802c258,0x1a3a83a0);
	rtd_outl(0xb802c258,0x1b3b93b1);
	rtd_outl(0xb802c258,0x1c3ca3c2);
	rtd_outl(0xb802c258,0x1d3dc3d3);
	rtd_outl(0xb802c258,0x1e3ed3e4);
	rtd_outl(0xb802c258,0x1f3ff3f6);

}

void panel_ld_12R_algo_init(void)
{

	// This script is for skyworth Edge type 12 regions backlight test

	//rtd_part_outl(0xb802C900,0,0,0x0); // Ld_spi disable



	// LD algo setting
	rtd_part_outl(0xb802C268,31,25,0x3);	// BLU WR NUM = 3
	rtd_part_outl(0xb802C268,24,16,0x17);	// SPI total = 24
	rtd_part_outl(0xb802C268,7,0,0x10); 	// BLU gain = 16
	rtd_part_outl(0xb802C208,0,0,0x1);		// LD valid

	rtd_part_outl(0xb802C268,9,9,0x1);		// SPI enable
	rtd_part_outl(0xb802C294,1,1,0x0);		// SW off
	rtd_part_outl(0xb802c200,31,31,0x0);	// Comp off

	rtd_part_outl(0xb802c208,1,1,0x1);		// LD_T_Enable
	rtd_part_outl(0xb802c208,5,4,0x1);		// edge top-buttom type
	rtd_part_outl(0xb802c204,31,31,0x0);	// db off
	rtd_part_outl(0xb802c208,28,24,0xb);	// Hunm
	rtd_part_outl(0xb802c208,20,16,0x0);	// Vunm
	rtd_part_outl(0xb802c208,3,2,0x2);		// LD_Hist_Mode?????????????????????????
	rtd_part_outl(0xb802c20c,28,16,0x140);	// Hsize 3840/12 = 320
	rtd_part_outl(0xb802c20c,11,0,0x870);	// Vsize 2160/1 = 2160

	// backlight decision
	rtd_outl(0xb802c23c, 0x160a0004);
	rtd_outl(0xb802c240, 0x00000000);
	rtd_outl(0xb802c244, 0x00000000);

	// temporal filter
	rtd_outl(0xb802c25c, 0x08300418);
	rtd_outl(0xb802c260, 0x08300210);
	rtd_outl(0xb802c264, 0x00400400);

	// spatial filter
	rtd_outl(0xb802c250, 0x00770220);
	rtd_outl(0xb802c254, 0x00000001);

	rtd_part_outl(0xb802c2e8,9,0,0x00000000);
	rtd_outl(0xb802c258,0x00071039);
	rtd_outl(0xb802c258,0x010e00a8);
	rtd_outl(0xb802c258,0x0214f117);
	rtd_outl(0xb802c258,0x031be186);
	rtd_outl(0xb802c258,0x0422d1f5);
	rtd_outl(0xb802c258,0x0526b264);
	rtd_outl(0xb802c258,0x06278272);
	rtd_outl(0xb802c258,0x0728627f);
	rtd_outl(0xb802c258,0x0829428d);
	rtd_outl(0xb802c258,0x092a229b);
	rtd_outl(0xb802c258,0x0a2b02a9);
	rtd_outl(0xb802c258,0x0b2be2b7);
	rtd_outl(0xb802c258,0x0c2cd2c6);
	rtd_outl(0xb802c258,0x0d2db2d4);
	rtd_outl(0xb802c258,0x0e2ea2e3);
	rtd_outl(0xb802c258,0x0f2f92f2);
	rtd_outl(0xb802c258,0x10308301);
	rtd_outl(0xb802c258,0x11318310);
	rtd_outl(0xb802c258,0x1232731f);
	rtd_outl(0xb802c258,0x1333732f);
	rtd_outl(0xb802c258,0x1434633e);
	rtd_outl(0xb802c258,0x1535634e);
	rtd_outl(0xb802c258,0x1636635e);
	rtd_outl(0xb802c258,0x1737736e);
	rtd_outl(0xb802c258,0x1838737f);
	rtd_outl(0xb802c258,0x1939838f);
	rtd_outl(0xb802c258,0x1a3a83a0);
	rtd_outl(0xb802c258,0x1b3b93b1);
	rtd_outl(0xb802c258,0x1c3ca3c2);
	rtd_outl(0xb802c258,0x1d3dc3d3);
	rtd_outl(0xb802c258,0x1e3ed3e4);
	rtd_outl(0xb802c258,0x1f3ff3f6);


	//rtd_part_outl(0xb802C900,0,0,0x1); // Ld_spi enable

}
#endif

#ifdef CONFIG_PANEL_APPLY_TCON_SETTING//yuan::OutputGammaFormBin
void GetOutputGamma_BinFileParameters(void)
{
	char *dst_addr = NULL;
	int dst_length;
	unsigned char display = 0;
	unsigned int *OutputGamma_ptr = NULL;
	unsigned int OutputGammaBinSize =0;

	//get outputgamma table
	if(factory_read("tmp/factory/Tcon_OutputGamma.bin", &dst_addr, &dst_length)) {
		printf("tmp/factory/ there is no Tcon_OutputGamma.bin \n");
		return;
	}
	else{
		OutputGammaBinSize =sizeof(VIP_Output_InvOutput_Gamma_CTRL_ITEM)+(Bin_Num_Output_InvOutput_Gamma/2*4)*sizeof(unsigned int);
		OutputGamma_ptr = malloc(OutputGammaBinSize);
		if(dst_length- sizeof(TconTable_HEADER) != OutputGammaBinSize )
		{
		printf("[OutputGamma]dst_length=%d,Header=%d\n",dst_length,sizeof(TconTable_HEADER));
		printf("OutputGammaCtrlBinSize=%d,OutputGammaTBLSize=%d\n",sizeof(VIP_Output_InvOutput_Gamma_CTRL_ITEM),(Bin_Num_Output_InvOutput_Gamma/2*4)*sizeof(unsigned int));
			return;
		}
		else
		{
			if(!OutputGamma_ptr){
				printf("OutputGamma:Malloc failed\n");
				return;
			}
			else{
					memcpy(OutputGamma_ptr,(dst_addr+sizeof(TconTable_HEADER)),OutputGammaBinSize);
					#if 0//for debug
					int k=0;
					for(k=0;k<OutputGammaBinSize;k++)
						printf("B[%d]=0x0%x\n",k,*(OutputGamma_ptr+k));
					#endif

					fwif_color_ChangeUINT32Endian_Copy(OutputGamma_ptr,OutputGammaBinSize, OutputGamma_ptr,1);

			#if 0//for debug
				int k=0;
				char i=0;
				for(i=0;i<OutputGammaTBLSize;i++)
				printf("ctrl[%d]:%d\n",i,*(OutputGamma_ptr+i));
				for(k=OutputGammaTBLSize;k<OutputGammaBinSize;k++)
				printf("TBL[%d]:%d\n",k,*(OutputGamma_ptr+k));

			#endif
			}
		}
	}


	//sync Driver
	kdrvif_color_output_gamma_control_front(display);
	kdrvif_color_colorwrite_output_gamma(OutputGamma_ptr+4, GAMMA_CHANNEL_R);
	kdrvif_color_colorwrite_output_gamma(OutputGamma_ptr+4+Bin_Num_Output_InvOutput_Gamma/2, GAMMA_CHANNEL_G);
	kdrvif_color_colorwrite_output_gamma(OutputGamma_ptr+4+(Bin_Num_Output_InvOutput_Gamma/2)*2, GAMMA_CHANNEL_B);
	kdrvif_color_colorwrite_output_gamma(OutputGamma_ptr+4+(Bin_Num_Output_InvOutput_Gamma/2)*3, GAMMA_CHANNEL_W);
	kdrvif_color_output_gamma_control_back(display);
	kdrvif_color_set_output_gamma_format(*OutputGamma_ptr,*(OutputGamma_ptr+2),*(OutputGamma_ptr+1), 0);
	free(OutputGamma_ptr);
	printf("GetOutputGamma_BinFileParameters Finish!!\n");

}
void kdrvif_color_output_gamma_control_front(unsigned char display)
{
	outputgamma_out_gamma_ctrl_1_RBUS out_gamma_ctrl_1_REG;

	out_gamma_ctrl_1_REG.regValue = rtd_inl(OUTPUTGAMMA_OUT_GAMMA_CTRL_1_reg);

	if (display == SLR_MAIN_DISPLAY) {
		out_gamma_ctrl_1_REG.out_gamma_en = 0;
		out_gamma_ctrl_1_REG.out_gamma_ax_rw_sel = 1; /* writing table*/
	}

	rtd_outl(OUTPUTGAMMA_OUT_GAMMA_CTRL_1_reg, out_gamma_ctrl_1_REG.regValue);
}

void kdrvif_color_output_gamma_control_back(unsigned char display)
{
	outputgamma_out_gamma_ctrl_1_RBUS out_gamma_ctrl_1_REG;

	out_gamma_ctrl_1_REG.regValue = rtd_inl(OUTPUTGAMMA_OUT_GAMMA_CTRL_1_reg);

	if (display == SLR_MAIN_DISPLAY) {
		out_gamma_ctrl_1_REG.out_gamma_ax_rw_sel = 0; /* read table*/
		out_gamma_ctrl_1_REG.out_gamma_en = 1;
	}

	rtd_outl(OUTPUTGAMMA_OUT_GAMMA_CTRL_1_reg, out_gamma_ctrl_1_REG.regValue);

}
void kdrvif_color_colorwrite_output_gamma(UINT32 *pArray, VIP_GAMMA_CHANNEL_RGB RGB_chanel_idx)
{
	unsigned short ii, cnt = 10000;
	outputgamma_out_gamma_port_RBUS out_gamma_port_REG;
	outputgamma_out_gamma_ctrl_1_RBUS out_gamma_ctrl_1_REG;
	unsigned char status = 1;


	out_gamma_ctrl_1_REG.regValue = rtd_inl(OUTPUTGAMMA_OUT_GAMMA_CTRL_1_reg);
	out_gamma_ctrl_1_REG.out_gamma_ax_ch_sel = RGB_chanel_idx; // 0:R, 1:G, 2:B, 3:RGB, 4:W
	rtd_outl(OUTPUTGAMMA_OUT_GAMMA_CTRL_1_reg, out_gamma_ctrl_1_REG.regValue);
	for (ii = 0; ii < (Bin_Num_Output_InvOutput_Gamma>>1); ii++) {

		status = 1;
		cnt = 10000;

		out_gamma_port_REG.regValue = pArray[ii];
		rtd_outl(OUTPUTGAMMA_OUT_GAMMA_PORT_reg, out_gamma_port_REG.regValue);

		while ((cnt--) && (status) && ((ii % 16) == 15)) {/*20071217 jason(jeffery) modified*/
			out_gamma_ctrl_1_REG.regValue = rtd_inl(OUTPUTGAMMA_OUT_GAMMA_PORT_reg);
			status =  (out_gamma_ctrl_1_REG.out_gamma_fifo_empty == 1) ? 0 : 1;
		}
	}

}

void kdrvif_color_set_output_gamma_format(unsigned char Enable, unsigned char fmt, unsigned char loc, unsigned char ch_order)
{

	outputgamma_out_gamma_ctrl_1_RBUS outputgamma_out_gamma_ctrl_1_reg;
	outputgamma_out_gamma_ctrl_2_RBUS out_gamma_ctrl_2_REG;
	//printf("yuan,Enable=%d,fmt=%d,loc=%d,ch_order=%d\n",Enable,fmt,loc,ch_order);
	unsigned char order_lst[2][8] = {
	// 0:even_R, 1:even_G, 2:even_B, 3:even_W, 4:odd_R, 5:odd_G, 6:odd_B, 7:odd_W,
	/*0*/{ 0, 1, 2, 3, 2, 3, 0, 1,}, // hw default
	/*1*/{ 2, 3, 0, 1, 0, 1, 2, 3,},
	};
	unsigned char order_sel[8];
	memcpy(order_sel, &order_lst[ch_order][0], sizeof(order_sel));

	outputgamma_out_gamma_ctrl_1_reg.regValue = rtd_inl(OUTPUTGAMMA_OUT_GAMMA_CTRL_1_reg);
	outputgamma_out_gamma_ctrl_1_reg.out_gamma_en = Enable;
	outputgamma_out_gamma_ctrl_1_reg.out_gamma_location = loc; // 0: After Demura (RGB),	1: After HCIC/FCIC (RGB or RGBW)
	rtd_outl(OUTPUTGAMMA_OUT_GAMMA_CTRL_1_reg, outputgamma_out_gamma_ctrl_1_reg.regValue);

	out_gamma_ctrl_2_REG.regValue = rtd_inl(OUTPUTGAMMA_OUT_GAMMA_CTRL_2_reg);
	out_gamma_ctrl_2_REG.out_gamma_format =  fmt; // 0:RGB, 1:RGBW
	out_gamma_ctrl_2_REG.even_ch_r =  order_sel[0];
	out_gamma_ctrl_2_REG.even_ch_g = order_sel[1] ;
	out_gamma_ctrl_2_REG.even_ch_b =  order_sel[2];
	out_gamma_ctrl_2_REG.even_ch_w =  order_sel[3];
	out_gamma_ctrl_2_REG.odd_ch_r =  order_sel[4];
	out_gamma_ctrl_2_REG.odd_ch_g =  order_sel[5];
	out_gamma_ctrl_2_REG.odd_ch_b =  order_sel[6];
	out_gamma_ctrl_2_REG.odd_ch_w =  order_sel[7];

	rtd_outl(OUTPUTGAMMA_OUT_GAMMA_CTRL_2_reg, out_gamma_ctrl_2_REG.regValue);
}

void fwif_color_ChangeUINT32Endian_Copy(unsigned int *pwTemp, int nSize, unsigned int *pwCopyTemp, unsigned char convert_endian_flag)
{
	int i;
	if (pwTemp && pwCopyTemp) {
		for (i = 0; i < (nSize); i++){
			pwCopyTemp[i] = convert_endian_flag?Scaler_ChangeUINT32Endian(pwTemp[i]):pwTemp[i];

			}

	} else {
		printf("Warring!! %s's pwTemp = %x, size = %d\n", __FUNCTION__, (unsigned int)pwTemp, nSize);
	}
}

unsigned int Scaler_ChangeUINT32Endian(unsigned int a_ulLittleIndian)
{
    unsigned int ulBigIndian = 0;
    unsigned char *pucBigIndian = (unsigned char *)(&ulBigIndian);
    unsigned char *pucLittleIndian = (unsigned char *)(&a_ulLittleIndian);

    pucBigIndian[0] = pucLittleIndian[3];
    pucBigIndian[1] = pucLittleIndian[2];
    pucBigIndian[2] = pucLittleIndian[1];
    pucBigIndian[3] = pucLittleIndian[0];

    return ulBigIndian;

}
#endif

#ifdef CONFIG_PANEL_APPLY_TCON_SETTING//yuan::VALCFormBin

void GetVALC_BinFileParameters(void)
{
	char *dst_addr = NULL;
	int dst_length;

	unsigned char *valc_ptr = NULL;
	unsigned int valcBinSize =0;
	unsigned int valcTBLSize =0;

	//get VALC table
	if(factory_read("tmp/factory/Tcon_VALC.bin", &dst_addr, &dst_length)) {
		printf("tmp/factory/ there is no Tcon_VALC.bin \n");
		return;
	}
	else{

		valcBinSize =sizeof(VIP_valc_CTRL_ITEM)+sizeof(DRV_POD_DATA_table_t)+(6*17*17*sizeof(unsigned char));//512/2*4*4
		valcTBLSize =sizeof(VIP_valc_CTRL_ITEM)+sizeof(DRV_POD_DATA_table_t);
		valc_ptr = malloc(valcBinSize);
		if(dst_length - sizeof(TconTable_HEADER) != valcBinSize)
		{
		printf("[VALC]dst_length=%d,Header=%d,POD:%d\n",dst_length,sizeof(TconTable_HEADER),sizeof(DRV_POD_DATA_table_t));
		printf("VALCCtrlBinSize=%d,VALCTBLSize=%d\n",sizeof(VIP_valc_CTRL_ITEM),(6*17*17*sizeof(unsigned char)));
			return;
		}
		else
		{
			if(!valc_ptr){
				printf("valc_ptr:Malloc failed\n");
				return;
			}
			else{
			memcpy(valc_ptr,(dst_addr+sizeof(TconTable_HEADER)),valcBinSize);

			#if 0//for debug
				int k=0;
				char i=0;
				for(i=0;i<valcTBLSize;i++)
				printf("ctrl[%d]:%d\n",i,*(valc_ptr+i));
				for(k=valcTBLSize;k<valcBinSize;k++)
				printf("TBL[%d]:%d\n",k,*(valc_ptr+k));

			#endif
			}
		}
	}
	//sync Driver
		kdrvif_color_pcid2_enable(*valc_ptr);
		kfwif_color_set_PCID_VALCSetting();
		kfwif_color_set_pcid2_valuetable_bycolor(valc_ptr+valcTBLSize, _PCID2_COLOR_R);
	    	kfwif_color_set_pcid2_valuetable_bycolor(valc_ptr+valcTBLSize+289*2, _PCID2_COLOR_G);
	    	kfwif_color_set_pcid2_valuetable_bycolor(valc_ptr+valcTBLSize+289*4, _PCID2_COLOR_B);
		kdrvif_color_pcid_enable(*(valc_ptr+1)); // PCID and PCID2 cannot enable at the same time
		kdrvif_color_pcid_VALC_protection();//drvif_color_pcid_VALC_protection(pVALCprotectSetting);
		kdrvif_color_pcid_VALC_enable(*(valc_ptr+2));
		free(valc_ptr);
		printf("GetVALC_BinFileParameters Finish!!\n");

}
void kdrvif_color_pcid2_enable(unsigned char bpcid2)
{
#if 0 //fix me
	//printf("yuan,bpcid2=%d\n",bpcid2);
	//unsigned long flags;//for spin_lock_irqsave
	ppoverlay_display_timing_ctrl2_RBUS display_timing_ctrl2_reg;
	display_timing_ctrl2_reg.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL2_reg);
	display_timing_ctrl2_reg.pcid2_en = bpcid2;
	rtd_outl(PPOVERLAY_Display_Timing_CTRL2_reg, display_timing_ctrl2_reg.regValue);

	//down(get_forcebg_semaphore());/*semaphore must added for not effect mute function when setting b8028300*/
	//spin_lock_irqsave(get_DBreg_spinlock(SLR_MAIN_DISPLAY), flags);//lock double buffer spinlock
	rtd_setbits(PPOVERLAY_Double_Buffer_CTRL_reg, _BIT8); // Set double buffer apply bit
	//spin_unlock_irqrestore(get_DBreg_spinlock(SLR_MAIN_DISPLAY), flags);//unlock double buffer spinlock
	//up(get_forcebg_semaphore());/*semaphore must added for not effect mute function when setting b8028300*/
#endif
}

void kfwif_color_set_PCID_VALCSetting(void)
{
	// VALC setting, all subpixel refer to the upper line, current subpixel
	rtd_outl(0xb802ef40, 0x00001010); // basic setting
	rtd_outl(0xb802ef44, 0xc0000000); // basic setting
	rtd_outl(0xb802ef48, 0x00000000); // basic setting
	rtd_outl(0xb802ef50, 0x91509150); // line 1 pixel setting
	rtd_outl(0xb802ef54, 0x91509150); // line 2 pixel setting
	rtd_outl(0xb802ef58, 0x91509150); // line 3 pixel setting
	rtd_outl(0xb802ef5c, 0x91509150); // line 3 pixel setting
	rtd_outl(0xb802ef70, 0x0000aaaa); // R [ line2, line1 ]
	rtd_outl(0xb802ef74, 0xffff5555); // R [ line4, line3 ]
	rtd_outl(0xb802ef78, 0x0000aaaa); // R [ line6, line5 ]
	rtd_outl(0xb802ef7c, 0xffff5555); // R [ line8, line7 ]
	rtd_outl(0xb802ef80, 0x00005555); // G [ line2, line1 ]
	rtd_outl(0xb802ef84, 0xffffaaaa); // G [ line4, line3 ]
	rtd_outl(0xb802ef88, 0x00005555); // G [ line6, line5 ]
	rtd_outl(0xb802ef8c, 0xffffaaaa); // G [ line8, line7 ]
	rtd_outl(0xb802ef90, 0x0000aaaa); // B [ line2, line1 ]
	rtd_outl(0xb802ef94, 0xffff5555); // B [ line4, line3 ]
	rtd_outl(0xb802ef98, 0x0000aaaa); // B [ line6, line5 ]
	rtd_outl(0xb802ef9c, 0xffff5555); // B [ line8, line7 ]

}
void kfwif_color_set_pcid2_valuetable_bycolor(unsigned char* InputLUT, DRV_pcid2_channel_t Channel)
{
    // Transfer the value to register value
    bool isSameTbl_1 = true, isSameTbl_2 = true;
    int Row = 0, Col = 0;
    unsigned int TblValue = 0;
    unsigned int POD_ValueTBL_1[81] = {0};
    unsigned int POD_ValueTBL_2[81] = {0};
    for(Row=0; Row<9; Row++)
    {
        for(Col=0; Col<9; Col++)
        {
            //-------------------
            // Value1 | Value3 |
            //-------------------     will be transform to {Value1, Value2, Value3, Value4} {MSB, LSB}
            // Value2 | Value4 |
            //-------------------
            unsigned int Value1 = 0, Value2 = 0, Value3 = 0, Value4 = 0;
            if( Row<8 && Col<8 )
            {
                Value1 = InputLUT[Row*34   +Col*2  ];
                Value2 = InputLUT[Row*34+17+Col*2  ];
                Value3 = InputLUT[Row*34   +Col*2+1];
                Value4 = InputLUT[Row*34+17+Col*2+1];
            }
            else if( Row < 8 )
            {
                Value1 = InputLUT[Row*34   +Col*2  ];
                Value2 = InputLUT[Row*34+17+Col*2  ];
                Value3 = Value1;
                Value4 = Value2;
            }
            else if( Col < 8 )
            {
                Value1 = InputLUT[Row*34   +Col*2  ];
                Value2 = Value1;
                Value3 = InputLUT[Row*34   +Col*2+1];
                Value4 = Value3;
            }
            else
            {
                Value1 = InputLUT[Row*34   +Col*2  ];
                Value2 = Value1;
                Value3 = Value1;
                Value4 = Value1;
            }
            TblValue = ( (Value1 << 24) + (Value2 << 16) + (Value3 << 8) + Value4 );
			if( POD_ValueTBL_1[Row*9+Col] != TblValue )
			{
				POD_ValueTBL_1[Row*9+Col] = TblValue;
				isSameTbl_1 = false;
			}
        }
    }

    for(Row=0; Row<9; Row++)
    {
        for(Col=0; Col<9; Col++)
        {
            //-------------------
            // Value1 | Value3 |
            //-------------------     will be transform to {Value1, Value2, Value3, Value4} {MSB, LSB}
            // Value2 | Value4 |
            //-------------------
            unsigned int Value1 = 0, Value2 = 0, Value3 = 0, Value4 = 0;
            if( Row<8 && Col<8 )
            {
                Value1 = InputLUT[289+Row*34   +Col*2  ];
                Value2 = InputLUT[289+Row*34+17+Col*2  ];
                Value3 = InputLUT[289+Row*34   +Col*2+1];
                Value4 = InputLUT[289+Row*34+17+Col*2+1];
            }
            else if( Row < 8 )
            {
                Value1 = InputLUT[289+Row*34   +Col*2  ];
                Value2 = InputLUT[289+Row*34+17+Col*2  ];
                Value3 = Value1;
                Value4 = Value2;
            }
            else if( Col < 8 )
            {
                Value1 = InputLUT[289+Row*34   +Col*2  ];
                Value2 = Value1;
                Value3 = InputLUT[289+Row*34   +Col*2+1];
                Value4 = Value3;
            }
            else
            {
                Value1 = InputLUT[289+Row*34   +Col*2  ];
                Value2 = Value1;
                Value3 = Value1;
                Value4 = Value1;
            }
            TblValue = ( (Value1 << 24) + (Value2 << 16) + (Value3 << 8) + Value4 );
			if( POD_ValueTBL_2[Row*9+Col] != TblValue )
			{
				POD_ValueTBL_2[Row*9+Col] = TblValue;
				isSameTbl_2 = false;
			}
        }
    }

	if( isSameTbl_1 == false || isSameTbl_2 == false )
	{
		//fwif_color_WaitFor_DEN_STOP_MEMCDTG();//20170927

		if( isSameTbl_1 == false ){
			//fwif_color_WaitFor_SYNC_START_MEMCDTG();//20170927
			kdrvif_color_pcid2_valuetable(POD_ValueTBL_1, 0, Channel);
			}
		if( isSameTbl_2 == false ){
			//fwif_color_WaitFor_SYNC_START_MEMCDTG();//20170927
			kdrvif_color_pcid2_valuetable(POD_ValueTBL_2, 1, Channel);
			}
	}


}
void kdrvif_color_pcid2_valuetable(unsigned int * ValueTBL, unsigned int TblSel, DRV_pcid2_channel_t Channel)
{
#if 0	//fix me
	//unsigned long flags;//for spin_lock_irqsave
	int i=0;
	ppoverlay_display_timing_ctrl2_RBUS display_timing_ctrl2_reg;
	pcid_pcid_lut_addr_RBUS pcid_lut_addr_reg;
	pcid_pcid_lut_data_RBUS pcid_pcid_lut_data_reg;

	if(!ValueTBL)
	{
		printf("[Error][%s][%s] Table Ptr is null!\n", __FILE__, __func__);
		return;
	}

	// ------------------------------------------------------------------------------------------------------
	// Enable module
	rtd_clearbits(PPOVERLAY_Double_Buffer_CTRL_reg, _BIT10); // disable DTG double buffer
	display_timing_ctrl2_reg.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL2_reg);
	display_timing_ctrl2_reg.pcid2_en = 1;
	rtd_outl(PPOVERLAY_Display_Timing_CTRL2_reg, display_timing_ctrl2_reg.regValue);
	rtd_setbits(PPOVERLAY_Double_Buffer_CTRL_reg, _BIT10); // enable DTG double buffer
	// ------------------------------------------------------------------------------------------------------

	// Setup table access setting
	pcid_lut_addr_reg.regValue = rtd_inl(PCID_PCID_LUT_ADDR_reg);
	pcid_lut_addr_reg.pcid_lut_sel = Channel;
	pcid_lut_addr_reg.pcid_lut_adr_mode = 0;	/* Increase Current (column) Index first */
	pcid_lut_addr_reg.pcid_lut_ax_en = 1;		/* access en */
	pcid_lut_addr_reg.pcid_lut_row_addr = TblSel;
	pcid_lut_addr_reg.pcid_lut_column_addr = TblSel;

	rtd_outl(PCID_PCID_LUT_ADDR_reg, pcid_lut_addr_reg.regValue);

	// Write the value into table
	for(i=0; i<81; i++)
	{
		pcid_pcid_lut_data_reg.pcid_lut_data = ValueTBL[i];
		rtd_outl(PCID_PCID_LUT_DATA_reg, pcid_pcid_lut_data_reg.regValue);
	}

	// Disable the table access
	pcid_lut_addr_reg.regValue = rtd_inl(PCID_PCID_LUT_ADDR_reg);
	pcid_lut_addr_reg.pcid_lut_ax_en = 0;
	rtd_outl(PCID_PCID_LUT_ADDR_reg, pcid_lut_addr_reg.regValue);

	// Disable the PCID enable
	rtd_clearbits(PPOVERLAY_Double_Buffer_CTRL_reg, _BIT10); // disable DTG double buffer
	display_timing_ctrl2_reg.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL2_reg);
	display_timing_ctrl2_reg.pcid2_en = 0;
	rtd_outl(PPOVERLAY_Display_Timing_CTRL2_reg, display_timing_ctrl2_reg.regValue);
	rtd_setbits(PPOVERLAY_Double_Buffer_CTRL_reg, _BIT10); // enable DTG double buffer
#endif
}

void kdrvif_color_pcid_enable(unsigned char bpcid_enable)
{
#if 0	//fix me
	//printf("yuan,bpcid_enable=%d\n",bpcid_enable);

	//unsigned long flags;//for spin_lock_irqsave
	ppoverlay_display_timing_ctrl2_RBUS display_timing_ctrl2_reg;
	display_timing_ctrl2_reg.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL2_reg);
	display_timing_ctrl2_reg.pcid_en = bpcid_enable;
	rtd_outl(PPOVERLAY_Display_Timing_CTRL2_reg, display_timing_ctrl2_reg.regValue);
	//down(get_forcebg_semaphore());/*semaphore must added for not effect mute function when setting b8028300*/
	//spin_lock_irqsave(get_DBreg_spinlock(SLR_MAIN_DISPLAY), flags);//lock double buffer spinlock
	rtd_setbits(PPOVERLAY_Double_Buffer_CTRL_reg, _BIT8); // Set double buffer apply bit
	//spin_unlock_irqrestore(get_DBreg_spinlock(SLR_MAIN_DISPLAY), flags);//unlock double buffer spinlock
	//up(get_forcebg_semaphore());/*semaphore must added for not effect mute function when setting b8028300*/
#endif
}

void kdrvif_color_pcid_VALC_enable(unsigned char ucEnable)
{
#if 0	//fix me
	pcid_pcid_valc_ctrl_RBUS pcid_pcid_valc_ctrl_reg;
	ppoverlay_display_timing_ctrl2_RBUS display_timing_ctrl2_reg;
	display_timing_ctrl2_reg.regValue = rtd_inl(PPOVERLAY_Display_Timing_CTRL2_reg);
	if(ucEnable != 0 && (display_timing_ctrl2_reg.pcid2_en!= 0 || display_timing_ctrl2_reg.pcid_en != 0))
	{
		if(display_timing_ctrl2_reg.pcid2_en!= 0 || display_timing_ctrl2_reg.pcid_en != 0)
		{
			pcid_pcid_valc_ctrl_reg.regValue = rtd_inl(PCID_PCID_VALC_CTRL_reg);
			pcid_pcid_valc_ctrl_reg.valc_en = 1;
			rtd_outl(PCID_PCID_VALC_CTRL_reg, pcid_pcid_valc_ctrl_reg.regValue);
		}
		else
			printf("VALC cannot be enabled when pcid/pcid2 are disable\n");
	}
#endif
}

void kdrvif_color_pcid_VALC_protection(void)
{
	rtd_outl(0xb802efa0, 0x00000006);
	rtd_outl(0xb802efa4, 0xfca87642);
	rtd_outl(0xb802efa8, 0x10000000);
	rtd_outl(0xb802efac, 0x00000000);
	rtd_outl(0xb802efb0, 0x00000000);

}
#endif


void GetMemaddr_demur_od(void)
{
#if 0	//fix me
	unsigned int od_addr=0;
	unsigned int demura_addr=0;
		od_addr=OD_UBOOT_RESERVED_ADDR;
		demura_addr=VIP_UBOOT_RESERVED_ADDR;

	od_od_ctrl_RBUS od_ctrl_reg;
	od_ctrl_reg.regValue = rtd_inl(OD_OD_CTRL_reg);
	od_ctrl_reg.dummy1802ca00_31_7 = od_addr>>7;
	rtd_outl(OD_OD_CTRL_reg, od_ctrl_reg.regValue);

	demura_demura_control_RBUS demura_demura_control_reg;
	demura_demura_control_reg.regValue = rtd_inl(DEMURA_DEMURA_CONTROL_reg);
	demura_demura_control_reg.dummy1802eb00_31_14 = demura_addr>>14;
	rtd_outl(DEMURA_DEMURA_CONTROL_reg, demura_demura_control_reg.regValue);

	//printf("Demura 31_7addr:0x%x,OD 31_2addr:0x%x\n",demura_addr,od_addr);
#endif
}

#ifdef CONFIG_PANEL_APPLY_TCON_SETTING//yuan::DemuraFormBin

void GetDemura_BinFileParameters(void)
{
	char *dst_addr = NULL;
	int dst_length;
	unsigned int DemuraTBLSize =0;
	unsigned int DemuraCtrlBinSize =0;
	unsigned int *DemuraCtrl_ptr = NULL;
	unsigned int *DemuraTBL_ptr = NULL;

	unsigned char DemuraTBLformat =0;
	unsigned int DemuraTBLSize_136 =0;
	unsigned int Demura_BINTBLSize =0;


	//get Demura table
	if(factory_read("tmp/factory/Tcon_Demura.bin", &dst_addr, &dst_length)) {
		printf("tmp/factory/ there is no Tcon_Demura.bin \n");
		return;
	}
	else{
		//detect table format is 136*241 or 271*481
		DemuraTBLSize_136 = sizeof(unsigned char)*VIP_Demura_Encode_TBL_ROW*VIP_Demura_Encode_TBL_COL;//136*1680*sizeof(unsigned int);
		Demura_BINTBLSize = dst_length- sizeof(TconTable_HEADER)-sizeof(DRV_DeMura_CTRL_TBL);

		if(Demura_BINTBLSize==DemuraTBLSize_136){
			DemuraTBLSize = DemuraTBLSize_136;
			DemuraTBLformat =0;
		}
		else{
			DemuraTBLSize =  sizeof(unsigned char)*VIP_Demura_Encode_TBL_ROW_B*VIP_Demura_Encode_TBL_COL_B;
			DemuraTBLformat =1;
			if(Demura_BINTBLSize!=DemuraTBLSize){
				printf("[Demura]dst_length=%d,Header=%d\n",dst_length,sizeof(TconTable_HEADER));
				printf("DemuraCtrlBinSize=%d,DemuraTBLSize=%d,DemuraTBLformat=%d\n",DemuraCtrlBinSize,DemuraTBLSize,DemuraTBLformat);

				return;
				}
		}


		DemuraCtrlBinSize = sizeof(DRV_DeMura_CTRL_TBL);
		DemuraCtrl_ptr = malloc(DemuraCtrlBinSize);
		DemuraTBL_ptr = malloc(DemuraTBLSize);

		if(!DemuraCtrl_ptr){
				printf("DemuraCtrl_ptr:Malloc failed\n");
				free(DemuraTBL_ptr);
				return;
			}
		if(!DemuraTBL_ptr){
			printf("DemuraTBL_ptr:Malloc failed\n");
			free(DemuraCtrl_ptr); //[CID-314115]: copy-paste error
			return;
		}

			memcpy(DemuraCtrl_ptr,(dst_addr+sizeof(TconTable_HEADER)),DemuraCtrlBinSize);
			memcpy(DemuraTBL_ptr,(dst_addr+sizeof(TconTable_HEADER)-sizeof(DRV_DeMura_CTRL_TBL)),DemuraTBLSize);

			#if 0//for debug
			int i=0;
			for(i=0;i<sizeof(DRV_DeMura_CTRL_TBL)/4;i++)
				printf("Ctrl[%d]=%d\n",i,*(Demura_ptr+i));
			for(i=sizeof(DRV_DeMura_CTRL_TBL)/4;i<100;i++)
				printf("Tbl[%d]=0x0%x\n",i,*(Demura_ptr+i));

			#endif
			fwif_color_ChangeUINT32Endian_Copy(DemuraCtrl_ptr,31, DemuraCtrl_ptr,1);
			fwif_color_ChangeUINT32Endian_Copy(DemuraTBL_ptr,DemuraTBLSize, DemuraTBL_ptr,1);

			#if 0//for debug
			int k=0;
			for(k=0;k<31;k++)
				printf("Ctrl[%d]=%d\n",k,*(DemuraCtrl_ptr+k));
			for(k=0;k<10;k++)
				printf("Tbl[%d]=0x%x\n",k,*(DemuraTBL_ptr+k));

			#endif


	}


	//sync Driver
	kdrvif_color_set_DeMura(DemuraCtrl_ptr,DemuraTBL_ptr,DemuraTBLformat);
	fwif_color_set_DeMura_En(*(DemuraCtrl_ptr+3));
	free(DemuraCtrl_ptr);
	free(DemuraTBL_ptr);
	printf("GetDemura_BinFileParameters Finish!!\n");

}

char kdrvif_color_set_DeMura(unsigned int *ptr, unsigned int *pArray, unsigned char DemuraTBLformat)
{

	demura_demura_control_RBUS demura_demura_control_reg;
	demura_demura_r_plane_1_control_RBUS demura_demura_r_plane_1_control_reg;
	demura_demura_r_plane_2_control_RBUS demura_demura_r_plane_2_control_reg;
	demura_demura_r_plane_3_control_RBUS demura_demura_r_plane_3_control_reg;
	demura_demura_r_plane_4_control_RBUS demura_demura_r_plane_4_control_reg;
	demura_demura_r_plane_5_control_RBUS demura_demura_r_plane_5_control_reg;
	demura_demura_g_plane_1_control_RBUS demura_demura_g_plane_1_control_reg;
	demura_demura_g_plane_2_control_RBUS demura_demura_g_plane_2_control_reg;
	demura_demura_g_plane_3_control_RBUS demura_demura_g_plane_3_control_reg;
	demura_demura_g_plane_4_control_RBUS demura_demura_g_plane_4_control_reg;
	demura_demura_g_plane_5_control_RBUS demura_demura_g_plane_5_control_reg;
	demura_demura_b_plane_1_control_RBUS demura_demura_b_plane_1_control_reg;
	demura_demura_b_plane_2_control_RBUS demura_demura_b_plane_2_control_reg;
	demura_demura_b_plane_3_control_RBUS demura_demura_b_plane_3_control_reg;
	demura_demura_b_plane_4_control_RBUS demura_demura_b_plane_4_control_reg;
	demura_demura_b_plane_5_control_RBUS demura_demura_b_plane_5_control_reg;

	demura_demura_dma_ctrl_1_RBUS demura_demura_dma_ctrl_1_reg;
	demura_demura_dma_wrap_line_step_RBUS demura_demura_dma_wrap_line_step_reg;

	demura_demura_dma_wrap_len_RBUS demura_demura_dma_wrap_len_reg;
	demura_demura_dma_wrap_word_RBUS demura_demura_dma_wrap_word_reg;

	//unsigned int k=0;
	unsigned int base_addr = VIP_UBOOT_RESERVED_ADDR;
	unsigned short panel_width, panel_heigth;
	unsigned int sizeDemuraTbl =0;//sizeof(unsigned int)*VIP_Demura_Encode_TBL_ROW*VIP_Demura_Encode_TBL_COL;
	//unsigned char *pArray_8=NULL;

	sizeDemuraTbl = sizeof(unsigned char)*VIP_Demura_Encode_TBL_ROW*VIP_Demura_Encode_TBL_COL;

	if ((ptr == NULL) || (pArray == NULL) || (base_addr == 0)) {
		printf("drvif_color_set_DeMura tab;e NULL, ptr=%p,pArray=%p,NULL,addr=%x\n", ptr, pArray, base_addr);
		return -1;
	}

	/* address setting*/
	memcpy((unsigned char *)base_addr, pArray, sizeDemuraTbl);
	flush_cache(base_addr, sizeDemuraTbl);


	printf("DeMura_MemStartAddr_phys = %x,size=%d\n", base_addr,sizeDemuraTbl);
	rtd_outl(DEMURA_DEMURA_DMA_WRAP_ADDR_reg, base_addr);

	//DMA===============================================================================
	demura_demura_dma_wrap_len_reg.regValue = rtd_inl(DEMURA_DEMURA_DMA_WRAP_LEN_reg);
	demura_demura_dma_wrap_word_reg.regValue = rtd_inl(DEMURA_DEMURA_DMA_WRAP_WORD_reg);
	demura_demura_dma_wrap_line_step_reg.regValue = rtd_inl(DEMURA_DEMURA_DMA_WRAP_LINE_STEP_reg);
	demura_demura_dma_ctrl_1_reg.regValue = rtd_inl(DEMURA_DEMURA_DMA_CTRL_1_reg);

	if(DemuraTBLformat== DeMura_TBL_241x136){
	demura_demura_dma_wrap_len_reg.burst_len = 32;//pDMA_TBL->burst_len;
	/*real line step in unit of 128 bit*/
	demura_demura_dma_wrap_word_reg.line_128_num = 104;//pDMA_TBL->line_128_num;


	demura_demura_dma_wrap_line_step_reg.line_step = (1680 >> 4);//pDMA_TBL->line_step;
	demura_demura_dma_ctrl_1_reg.table_height = 136;//pDMA_TBL->table_height;
	demura_demura_dma_ctrl_1_reg.table_width = 241;//pDMA_TBL->table_width;
		}
	else{
	demura_demura_dma_wrap_len_reg.burst_len = 32;//pDMA_TBL->burst_len;
	/*real line step in unit of 128 bit*/
	demura_demura_dma_wrap_word_reg.line_128_num = 207;//pDMA_TBL->line_128_num;
	demura_demura_dma_wrap_line_step_reg.line_step = (3312 >> 4);//pDMA_TBL->line_step;
	demura_demura_dma_ctrl_1_reg.table_height = 271;//pDMA_TBL->table_height;
	demura_demura_dma_ctrl_1_reg.table_width = 481;//pDMA_TBL->table_width;
		}
	rtd_outl(DEMURA_DEMURA_DMA_WRAP_LEN_reg, demura_demura_dma_wrap_len_reg.regValue);
	rtd_outl(DEMURA_DEMURA_DMA_WRAP_WORD_reg, demura_demura_dma_wrap_word_reg.regValue);

	rtd_outl(DEMURA_DEMURA_DMA_CTRL_1_reg, demura_demura_dma_ctrl_1_reg.regValue);
	rtd_outl(DEMURA_DEMURA_DMA_WRAP_LINE_STEP_reg, demura_demura_dma_wrap_line_step_reg.regValue);
	//===============================================================================





	demura_demura_control_reg.regValue = rtd_inl(DEMURA_DEMURA_CONTROL_reg);
	demura_demura_r_plane_1_control_reg.regValue = rtd_inl(DEMURA_DEMURA_R_PLANE_1_CONTROL_reg);
	demura_demura_r_plane_2_control_reg.regValue = rtd_inl(DEMURA_DEMURA_R_PLANE_2_CONTROL_reg);
	demura_demura_r_plane_3_control_reg.regValue = rtd_inl(DEMURA_DEMURA_R_PLANE_3_CONTROL_reg);
	demura_demura_r_plane_4_control_reg.regValue = rtd_inl(DEMURA_DEMURA_R_PLANE_4_CONTROL_reg);
	demura_demura_r_plane_5_control_reg.regValue = rtd_inl(DEMURA_DEMURA_R_PLANE_5_CONTROL_reg);
	demura_demura_g_plane_1_control_reg.regValue = rtd_inl(DEMURA_DEMURA_G_PLANE_1_CONTROL_reg);
	demura_demura_g_plane_2_control_reg.regValue = rtd_inl(DEMURA_DEMURA_G_PLANE_2_CONTROL_reg);
	demura_demura_g_plane_3_control_reg.regValue = rtd_inl(DEMURA_DEMURA_G_PLANE_3_CONTROL_reg);
	demura_demura_g_plane_4_control_reg.regValue = rtd_inl(DEMURA_DEMURA_G_PLANE_4_CONTROL_reg);
	demura_demura_g_plane_5_control_reg.regValue = rtd_inl(DEMURA_DEMURA_G_PLANE_5_CONTROL_reg);
	demura_demura_b_plane_1_control_reg.regValue = rtd_inl(DEMURA_DEMURA_B_PLANE_1_CONTROL_reg);
	demura_demura_b_plane_2_control_reg.regValue = rtd_inl(DEMURA_DEMURA_B_PLANE_2_CONTROL_reg);
	demura_demura_b_plane_3_control_reg.regValue = rtd_inl(DEMURA_DEMURA_B_PLANE_3_CONTROL_reg);
	demura_demura_b_plane_4_control_reg.regValue = rtd_inl(DEMURA_DEMURA_B_PLANE_4_CONTROL_reg);
	demura_demura_b_plane_5_control_reg.regValue = rtd_inl(DEMURA_DEMURA_B_PLANE_5_CONTROL_reg);

	//dispV = Get_DISP_ACT_END_VPOS()-Get_DISP_ACT_STA_VPOS();
	panel_heigth = default_panel_parameter .iCONFIG_DISP_ACT_END_VPOS  - default_panel_parameter .iCONFIG_DISP_ACT_STA_VPOS ;
	//dispH = Get_DISP_ACT_END_HPOS()-Get_DISP_ACT_STA_HPOS();
	panel_width = default_panel_parameter .iCONFIG_DISP_ACT_END_HPOS  - default_panel_parameter .iCONFIG_DISP_ACT_STA_HPOS ;

	if(DemuraTBLformat== DeMura_TBL_241x136){
			if (panel_heigth == 2160 && panel_width == 3840)	/* 4k panel*/
				demura_demura_control_reg.demura_block_size = 1;//ptr->demura_block_size;
			else if (panel_heigth == 1080 && panel_width == 1920)/* 2k panel*/
				demura_demura_control_reg.demura_block_size = 0;//ptr->demura_block_size;
	}
	else{
		if (panel_heigth == 2160 && panel_width == 3840)	/* 4k panel*/
			demura_demura_control_reg.demura_block_size = 0;//ptr->demura_block_size;
		else if (panel_heigth == 1080 && panel_width == 1920)/* 2k panel*/
			demura_demura_control_reg.demura_block_size = 2;//ptr->demura_block_size;
	}

	 printf("panel_width=%d,panel_heigth=%d,demura_block_size=%d\n",panel_width,panel_heigth,demura_demura_control_reg.demura_block_size);

	demura_demura_control_reg.demura_table_scale = ptr[0];
	demura_demura_control_reg.demura_rgb_table_seperate = ptr[2];//ptr->demura_rgb_table_seperate;
	//demura_demura_control_reg.demura_en = ptr->demura_en;
	demura_demura_r_plane_1_control_reg.demura_r_upper_cutoff = ptr[4];//ptr->demura_r_upper_cutoff;
	demura_demura_r_plane_1_control_reg.demura_r_lower_cutoff = ptr[5];//ptr->demura_r_lower_cutoff;
	demura_demura_r_plane_2_control_reg.demura_r_m_level = ptr[6];//ptr->demura_r_m_level;
	demura_demura_r_plane_2_control_reg.demura_r_l_level = ptr[7];//ptr->demura_r_l_level;
	demura_demura_r_plane_3_control_reg.demura_r_h_level = ptr[8];//ptr->demura_r_h_level;
	demura_demura_r_plane_4_control_reg.r_div_factor_l_m = ptr[9];//ptr->r_div_factor_l_m;
	demura_demura_r_plane_4_control_reg.r_div_factor_l = ptr[10];//ptr->r_div_factor_l;
	demura_demura_r_plane_5_control_reg.r_div_factor_h = ptr[11];//ptr->r_div_factor_h;
	demura_demura_r_plane_5_control_reg.r_div_factor_m_h = ptr[12];//ptr->r_div_factor_m_h;

	demura_demura_g_plane_1_control_reg.demura_g_upper_cutoff  = ptr[13];//ptr->demura_g_upper_cutoff;
	demura_demura_g_plane_1_control_reg.demura_g_lower_cutoff	 = ptr[14];//ptr->demura_g_lower_cutoff;
	demura_demura_g_plane_2_control_reg.demura_g_m_level		 = ptr[15];//ptr->demura_g_m_level;
	demura_demura_g_plane_2_control_reg.demura_g_l_level 	 = ptr[16];//ptr->demura_g_l_level;
	demura_demura_g_plane_3_control_reg.demura_g_h_level 	= ptr[17];//ptr->demura_g_h_level;
	demura_demura_g_plane_4_control_reg.g_div_factor_l_m 	 = ptr[18];//ptr->g_div_factor_l_m;
	demura_demura_g_plane_4_control_reg.g_div_factor_l 		= ptr[19];//ptr->g_div_factor_l;
	demura_demura_g_plane_5_control_reg.g_div_factor_h 			 = ptr[20];//ptr->g_div_factor_h;
	demura_demura_g_plane_5_control_reg.g_div_factor_m_h 		 = ptr[21];//ptr->g_div_factor_m_h;

	demura_demura_b_plane_1_control_reg.demura_b_upper_cutoff  = ptr[22];//ptr->demura_b_upper_cutoff;
	demura_demura_b_plane_1_control_reg.demura_b_lower_cutoff	 = ptr[23];//ptr->demura_b_lower_cutoff;
	demura_demura_b_plane_2_control_reg.demura_b_m_level		 = ptr[24];//ptr->demura_b_m_level;
	demura_demura_b_plane_2_control_reg.demura_b_l_level 	 = ptr[25];//ptr->demura_b_l_level;
	demura_demura_b_plane_3_control_reg.demura_b_h_level 	= ptr[26];//ptr->demura_b_h_level;
	demura_demura_b_plane_4_control_reg.b_div_factor_l_m 	 = ptr[27];//ptr->b_div_factor_l_m;
	demura_demura_b_plane_4_control_reg.b_div_factor_l 		= ptr[28];//ptr->b_div_factor_l;
	demura_demura_b_plane_5_control_reg.b_div_factor_h 			 = ptr[29];//ptr->b_div_factor_h;
	demura_demura_b_plane_5_control_reg.b_div_factor_m_h 		 = ptr[30];//ptr->b_div_factor_m_h;

	rtd_outl(DEMURA_DEMURA_CONTROL_reg, demura_demura_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_R_PLANE_1_CONTROL_reg, demura_demura_r_plane_1_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_R_PLANE_2_CONTROL_reg, demura_demura_r_plane_2_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_R_PLANE_3_CONTROL_reg, demura_demura_r_plane_3_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_R_PLANE_4_CONTROL_reg, demura_demura_r_plane_4_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_R_PLANE_5_CONTROL_reg, demura_demura_r_plane_5_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_G_PLANE_1_CONTROL_reg, demura_demura_g_plane_1_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_G_PLANE_2_CONTROL_reg, demura_demura_g_plane_2_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_G_PLANE_3_CONTROL_reg, demura_demura_g_plane_3_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_G_PLANE_4_CONTROL_reg, demura_demura_g_plane_4_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_G_PLANE_5_CONTROL_reg, demura_demura_g_plane_5_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_B_PLANE_1_CONTROL_reg, demura_demura_b_plane_1_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_B_PLANE_2_CONTROL_reg, demura_demura_b_plane_2_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_B_PLANE_3_CONTROL_reg, demura_demura_b_plane_3_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_B_PLANE_4_CONTROL_reg, demura_demura_b_plane_4_control_reg.regValue);
	rtd_outl(DEMURA_DEMURA_B_PLANE_5_CONTROL_reg, demura_demura_b_plane_5_control_reg.regValue);

	return 0;
}

char fwif_color_set_DeMura_En(unsigned char enable)
{
	kdrvif_color_set_DeMura_En(enable);
	return 0;
}

void kdrvif_color_set_DeMura_En(unsigned char enable)
{
	demura_demura_control_RBUS demura_demura_control_reg;
	demura_demura_control_reg.regValue = rtd_inl(DEMURA_DEMURA_CONTROL_reg);

	demura_demura_control_reg.demura_en = enable;
	rtd_outl(DEMURA_DEMURA_CONTROL_reg, demura_demura_control_reg.regValue);
}

unsigned int drvif_memory_get_data_align(unsigned int Value, unsigned int unit)
{
	unsigned int AlignVal;

	AlignVal = Value;
	unit -= 1;
	if (Value & unit)
		AlignVal = (Value & (~unit)) + unit + 1;
	return AlignVal;
}

#endif

#ifdef CONFIG_PANEL_APPLY_TCON_SETTING
unsigned char bODInited = false;

void GetOD_BinFileParameters(void)
{
	char *dst_addr = NULL;
	int dst_length;
	unsigned int *ODTBL_ptr = NULL;
	unsigned int *ODCtrl_ptr = NULL;
	unsigned int ODTBLSize =0;
	unsigned int ODCtrlSize =0;

	//get OD table
	if(factory_read("tmp/factory/Tcon_OD.bin", &dst_addr, &dst_length)) {
		printf("tmp/factory/ there is no Tcon_OD.bin \n");
		return;
	}
	else{
			ODTBLSize =sizeof(unsigned int)*17*17;

			if(dst_length- sizeof(TconTable_HEADER) -sizeof(VIP_OD_CTRL_ITEM) != ODTBLSize )
			{
				printf("[OD]dst_length=%d,Header=%d\n",dst_length,sizeof(TconTable_HEADER));
				printf("ODCtrlBinSize=%d,ODTBLSize=%d\n",sizeof(VIP_OD_CTRL_ITEM),ODTBLSize);
					return;
			}else{

				ODCtrlSize = sizeof(VIP_OD_CTRL_ITEM);
				ODCtrl_ptr = malloc(ODCtrlSize);
				ODTBL_ptr = malloc(ODTBLSize);

			if(!ODCtrl_ptr){
					printf("ODCtrl_ptr:Malloc failed\n");
					free(ODTBL_ptr);
					return;
				}
			if(!ODTBL_ptr){
				printf("ODTBL_ptr:Malloc failed\n");
				free(ODCtrl_ptr);
				return;
			}


			memcpy(ODCtrl_ptr,(dst_addr+sizeof(TconTable_HEADER)),ODCtrlSize);
			memcpy(ODTBL_ptr,(dst_addr+sizeof(TconTable_HEADER)+sizeof(VIP_OD_CTRL_ITEM)),ODTBLSize);

			fwif_color_ChangeUINT32Endian_Copy(ODCtrl_ptr,16, ODCtrl_ptr,1);
			fwif_color_ChangeUINT32Endian_Copy(ODTBL_ptr,289, ODTBL_ptr,1);

			#if 0//for debug
			int i=0;
			//for(i=0;i<16;i++)
				//printf("Ctrl[%d]=%d\n",i,*(ODCtrl_ptr+i));
			for(i=0;i<17;i++)
				printf("Tbl[%d]=%d\n",i,*(ODTBL_ptr+i));

			#endif


		}
	}


	//sync Driver
	fwif_color_od_init(10, 0, 60);
	fwif_color_set_od_table(ODTBL_ptr,ODTBLSize);
	//fwif_color_set_linear_od_table();
	kdrvif_color_od(ODCtrl_ptr);

	free(ODCtrl_ptr);
	free(ODTBL_ptr);
	printf("GetOD_BinFileParameters Finish!!\n");

}


void kdrvif_color_od(unsigned int *ptr)
{
	od_od_ctrl_RBUS od_ctrl_reg;
	od_od_ctrl2_RBUS od_ctrl2_reg;
	od_od_noise_reduction_ctrl_RBUS noise_reduction_ctrl_reg;
	unsigned char bOD=ptr[0];

	od_ctrl2_reg.regValue = rtd_inl(OD_OD_CTRL2_reg);
	od_ctrl2_reg.od_delta_gain_b = ptr[4];
	od_ctrl2_reg.od_delta_gain_g = ptr[3];
	od_ctrl2_reg.od_delta_gain_r = ptr[2];
	od_ctrl2_reg.od_delta_gain_w = ptr[5];
	rtd_outl(OD_OD_CTRL2_reg, od_ctrl2_reg.regValue);


	od_ctrl_reg.regValue = rtd_inl(OD_OD_CTRL_reg);
	if (bOD == 0) {
		//od_ctrl_reg.od_fun_sel = 0;
		od_ctrl_reg.od_en = 0;
	} else {
		//od_ctrl_reg.od_fun_sel = 1;
		od_ctrl_reg.od_en = 1;
	}
	rtd_outl(OD_OD_CTRL_reg, od_ctrl_reg.regValue);

	/* default nr*/
	noise_reduction_ctrl_reg.regValue = rtd_inl(OD_od_Noise_reduction_ctrl_reg);
	noise_reduction_ctrl_reg.od_nr_mode = ptr[7];
	noise_reduction_ctrl_reg.od_r_nr_en = ptr[8];
	noise_reduction_ctrl_reg.od_g_nr_en = ptr[9];

	noise_reduction_ctrl_reg.od_b_nr_en = ptr[10];
	noise_reduction_ctrl_reg.od_r_nr_thd = ptr[12];
	noise_reduction_ctrl_reg.od_g_nr_thd = ptr[13];
	noise_reduction_ctrl_reg.od_b_nr_thd = ptr[14];
	rtd_outl(OD_od_Noise_reduction_ctrl_reg, noise_reduction_ctrl_reg.regValue);

}

bool fwif_color_od_init(UINT8 color_depth_bits, UINT8 dma_mode, UINT8 freq)
{
	unsigned short dispH;
	unsigned short dispV;
	UINT8 bit_sel = 2;

	//dispV = Get_DISP_ACT_END_VPOS()-Get_DISP_ACT_STA_VPOS();
	dispV = default_panel_parameter .iCONFIG_DISP_ACT_END_VPOS  - default_panel_parameter .iCONFIG_DISP_ACT_STA_VPOS ;
	//dispH = Get_DISP_ACT_END_HPOS()-Get_DISP_ACT_STA_HPOS();
	dispH = default_panel_parameter .iCONFIG_DISP_ACT_END_HPOS  - default_panel_parameter .iCONFIG_DISP_ACT_STA_HPOS ;

	//printf("OD_Height=%d,OD_Width=%d\n",dispV,dispH);

	// y mode
	drvif_color_od_Ymode();

	if(color_depth_bits == 6)
		bit_sel = 0;
	else if(color_depth_bits == 8)
		bit_sel = 1;
	else
		bit_sel = 2;

	if (drvif_color_od_pqc(dispV, dispH, bit_sel, dma_mode, 4, 1, 3))
		bODInited = true;
	else
		return false;

	return true;
}

void drvif_color_od_Ymode(void)
{
	// 170524 henry Merlin3
	od_ymode_ctrl_RBUS od_ymode_ctrl_reg;
	od_ymode_ctrl_reg.regValue = rtd_inl(OD_YMODE_CTRL_reg);
	od_ymode_ctrl_reg.od_ymode_en = 1;
	od_ymode_ctrl_reg.od_ymode_sat_en = 0;
	od_ymode_ctrl_reg.r_coeff = 0x4D;
	od_ymode_ctrl_reg.g_coeff = 0x96;
	od_ymode_ctrl_reg.b_coeff = 0x1D;
	rtd_outl(OD_YMODE_CTRL_reg, od_ymode_ctrl_reg.regValue);
}

bool drvif_color_od_pqc(UINT16 height, UINT16 width, UINT8 bit_sel, UINT8 dma_mode, UINT8 FrameLimitBit, int dataColor, int dataFormat)
{

	unsigned int od_size = 0;
	unsigned int od_addr = OD_UBOOT_RESERVED_ADDR;//0x30000000;//OD_UBOOT_RESERVED_ADDR;
	unsigned int burst_length = 0x20; //0x40

	od_dma_od_dma_ctrl_RBUS od_dma_od_dma_ctrl_reg;
	od_dma_od_dma_ctrl_2_RBUS od_dma_od_dma_ctrl_2_reg;
	od_dma_oddma_pq_cmp_allocate_RBUS od_dma_oddma_pq_cmp_allocate_reg;
	od_dma_oddma_pq_cmp_blk0_add0_RBUS od_dma_oddma_pq_cmp_blk0_add0_reg;
	od_dma_oddma_pq_cmp_blk0_add1_RBUS od_dma_oddma_pq_cmp_blk0_add1_reg;
	od_dma_oddma_pq_cmp_RBUS oddma_pq_cmp_reg;
	od_dma_oddma_pq_cmp_bit_RBUS oddma_pq_cmp_bit_reg;
	od_dma_oddma_pq_decmp_RBUS oddma_pq_decmp_reg;
	od_dma_oddma_pq_decmp_sat_en_RBUS oddma_pq_decmp_sat_en_reg;
	od_dma_oddma_wr_num_bl_wrap_ctl_RBUS od_dma_oddma_wr_num_bl_wrap_ctl_reg;
	od_dma_oddma_rd_num_bl_wrap_ctl_RBUS od_dma_oddma_rd_num_bl_wrap_ctl_reg;
	od_dma_oddma_wr_num_bl_wrap_rolling_RBUS od_dma_oddma_wr_num_bl_wrap_rolling_reg;
	od_dma_oddma_rd_num_bl_wrap_rolling_RBUS od_dma_oddma_rd_num_bl_wrap_rolling_reg;
	od_dma_oddma_wr_num_bl_wrap_word_RBUS od_dma_oddma_wr_num_bl_wrap_word_reg;
	od_dma_oddma_rd_num_bl_wrap_word_RBUS od_dma_oddma_rd_num_bl_wrap_word_reg;
	od_dma_oddma_pq_cmp_st_RBUS od_dma_oddma_pq_cmp_st_reg;
	od_dma_oddma_wr_num_bl_wrap_line_step_RBUS od_dma_oddma_cap_linestep_reg;
	od_dma_oddma_rd_num_bl_wrap_line_step_RBUS od_dma_oddma_rd_num_bl_wrap_line_step_reg;
	od_dma_oddma_pq_cmp_enable_RBUS od_dma_oddma_pq_cmp_enable_reg;
	od_dma_oddma_pq_cmp_pair_RBUS oddma_pq_cmp_pair_reg;
	od_dma_oddma_pq_decmp_pair_RBUS oddma_pq_decmp_pair_reg;
	od_dma_oddma_pqc_pqdc_compensation_RBUS od_dma_oddma_pqc_pqdc_compensation_reg;
	od_dma_oddma_wr_ctrl_RBUS od_dma_oddma_wr_ctrl_reg;
	od_dma_oddma_rd_ctrl_RBUS od_dma_oddma_rd_ctrl_reg;
	od_dma_oddma_pqc_pqdc_compensation_RBUS od_dma_oddma_pqc_decmp_compensation_reg;



	//printf("[OD] Gibi_od.cpp::drvif_color_od_pqc() calling...\n");

	od_size = OD_UBOOT_RESERVED_SIZE;//carvedout_buf_query(CARVEDOUT_SCALER_OD,(void*) &od_addr);
#if 0 //[CID-313927]: Logically dead code
	if (od_addr == 0 || od_size == 0) {
		printf("[%s %d] ERR : %x %x\n", __func__, __LINE__, od_addr, od_size);
		return false;
	}
#endif
	// cmp, decmp pair setting
	//
	// dataFormat = 0: 444
	//			  = 1: 422
	//			  = 2: 420 --> not support RGB compression
	//			  = 3: 400 --> not support RGB compression
	//
	// dataColor = 0: RGB Compression
	//			 = 1: YUV Compression
	//
	if (dataColor == 0 && (dataFormat == 2 || dataFormat == 3))
	{
		printf("[OD] Gibi_od.cpp::input value conflict...\n");
		printf("420 or 400 doesn't support RGB compression\n");
		return false;
	}
	// b802cdc0 dma ctrl
	od_dma_od_dma_ctrl_reg.regValue = rtd_inl(OD_DMA_OD_DMA_CTRL_reg);
	//od_dma_od_dma_ctrl_reg.bit_sel = bit_sel;
	od_dma_od_dma_ctrl_reg.oddma_mode_sel = dma_mode;
	rtd_outl(OD_DMA_OD_DMA_CTRL_reg, od_dma_od_dma_ctrl_reg.regValue);

	// b802cdb8 vact and hact
	od_dma_od_dma_ctrl_2_reg.regValue = rtd_inl(OD_DMA_OD_DMA_CTRL_2_reg);
	od_dma_od_dma_ctrl_2_reg.hact = width;
	od_dma_od_dma_ctrl_2_reg.vact = height;
	rtd_outl(OD_DMA_OD_DMA_CTRL_2_reg, od_dma_od_dma_ctrl_2_reg.regValue);

	// b802cd14 PQC constraint
	od_dma_oddma_pq_cmp_allocate_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_CMP_ALLOCATE_reg);
	od_dma_oddma_pq_cmp_allocate_reg.dynamic_allocate_ratio_max = 16;
	od_dma_oddma_pq_cmp_allocate_reg.dynamic_allocate_ratio_min = 12;
	rtd_outl(OD_DMA_ODDMA_PQ_CMP_ALLOCATE_reg, od_dma_oddma_pq_cmp_allocate_reg.regValue);

	// b802cd60 PQC constraint
	od_dma_oddma_pq_cmp_blk0_add0_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_CMP_BLK0_ADD0_reg);
	od_dma_oddma_pq_cmp_blk0_add1_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_CMP_BLK0_ADD1_reg);
	od_dma_oddma_pq_cmp_blk0_add0_reg.blk0_add_value32 = 1;
	od_dma_oddma_pq_cmp_blk0_add0_reg.blk0_add_value16 = 1;
	od_dma_oddma_pq_cmp_blk0_add1_reg.blk0_add_value8 = 1;
	od_dma_oddma_pq_cmp_blk0_add1_reg.blk0_add_value4 = 1;
	od_dma_oddma_pq_cmp_blk0_add1_reg.blk0_add_value2 = 1;
	od_dma_oddma_pq_cmp_blk0_add1_reg.blk0_add_value1 = 0;
	rtd_outl(OD_DMA_ODDMA_PQ_CMP_BLK0_ADD0_reg, od_dma_oddma_pq_cmp_blk0_add0_reg.regValue);
	rtd_outl(OD_DMA_ODDMA_PQ_CMP_BLK0_ADD1_reg, od_dma_oddma_pq_cmp_blk0_add1_reg.regValue);

	// b802CD00 PQ_CMP enable
	oddma_pq_cmp_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_CMP_reg);
	oddma_pq_cmp_reg.cmp_en = 1;
	oddma_pq_cmp_reg.cmp_width_div32 = width >> 5;
	oddma_pq_cmp_reg.cmp_height = height;
	rtd_outl(OD_DMA_ODDMA_PQ_CMP_reg, oddma_pq_cmp_reg.regValue);

	// b802cd08 Compression ratio
	oddma_pq_cmp_bit_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_CMP_BIT_reg);
	oddma_pq_cmp_bit_reg.frame_limit_bit = FrameLimitBit;
    oddma_pq_cmp_bit_reg.block_limit_bit = 0x3F;

	// DMA buffer line limit clamp
	if(dma_mode == 0)
		oddma_pq_cmp_bit_reg.line_limit_bit = oddma_pq_cmp_bit_reg.frame_limit_bit;
	else if(dma_mode == 1)
		oddma_pq_cmp_bit_reg.line_limit_bit = FrameLimitBit + 6;
	rtd_outl(OD_DMA_ODDMA_PQ_CMP_BIT_reg, oddma_pq_cmp_bit_reg.regValue);

	// b802cd80 PQ_DECMP enable
	oddma_pq_decmp_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_DECMP_reg);
	oddma_pq_decmp_reg.decmp_en = 1;
	oddma_pq_decmp_reg.decmp_width_div32 = width >> 5;
	oddma_pq_decmp_reg.decmp_height = height;
	rtd_outl(OD_DMA_ODDMA_PQ_DECMP_reg, oddma_pq_decmp_reg.regValue);

	oddma_pq_cmp_pair_reg.regValue =  rtd_inl(OD_DMA_ODDMA_PQ_CMP_PAIR_reg);
	oddma_pq_decmp_pair_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_DECMP_PAIR_reg);

	oddma_pq_cmp_pair_reg.cmp_data_format = dataFormat;
	oddma_pq_decmp_pair_reg.decmp_data_format = dataFormat;
	oddma_pq_cmp_pair_reg.cmp_data_color = dataColor;
	oddma_pq_decmp_pair_reg.decmp_data_color = dataColor;

	if(FrameLimitBit <= 6) {
		oddma_pq_cmp_pair_reg.cmp_data_bit_width = 0;
		oddma_pq_decmp_pair_reg.decmp_data_bit_width = 0;
	} else {
		oddma_pq_cmp_pair_reg.cmp_data_bit_width = 1;
		oddma_pq_decmp_pair_reg.decmp_data_bit_width = 1;
	}

	if(dma_mode == 0) {
		oddma_pq_cmp_pair_reg.cmp_line_sum_bit = (width * oddma_pq_cmp_bit_reg.line_limit_bit + 256) / 128;
		oddma_pq_decmp_pair_reg.decmp_line_sum_bit = oddma_pq_cmp_pair_reg.cmp_line_sum_bit;
	}

	rtd_outl(OD_DMA_ODDMA_PQ_CMP_PAIR_reg, oddma_pq_cmp_pair_reg.regValue);
	rtd_outl(OD_DMA_ODDMA_PQ_DECMP_PAIR_reg, oddma_pq_decmp_pair_reg.regValue);

	// b802cd88 Saturation enable
	oddma_pq_decmp_sat_en_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_DECMP_SAT_EN_reg);
	oddma_pq_decmp_sat_en_reg.saturation_en = 1;
	rtd_outl(OD_DMA_ODDMA_PQ_DECMP_SAT_EN_reg, oddma_pq_decmp_sat_en_reg.regValue);

	// b802ce3c b802cebc cap disp line_num, burst_length
	od_dma_oddma_wr_num_bl_wrap_ctl_reg.regValue = rtd_inl(OD_DMA_ODDMA_WR_num_bl_wrap_ctl_reg);
	od_dma_oddma_wr_num_bl_wrap_ctl_reg.cap_burst_len = burst_length;
	od_dma_oddma_wr_num_bl_wrap_ctl_reg.cap_line_num = height;
	rtd_outl(OD_DMA_ODDMA_WR_num_bl_wrap_ctl_reg, od_dma_oddma_wr_num_bl_wrap_ctl_reg.regValue);
	od_dma_oddma_rd_num_bl_wrap_ctl_reg.regValue = rtd_inl(OD_DMA_ODDMA_RD_num_bl_wrap_ctl_reg);
	od_dma_oddma_rd_num_bl_wrap_ctl_reg.disp_burst_len = burst_length;
	od_dma_oddma_rd_num_bl_wrap_ctl_reg.disp_line_num = height;
	rtd_outl(OD_DMA_ODDMA_RD_num_bl_wrap_ctl_reg, od_dma_oddma_rd_num_bl_wrap_ctl_reg.regValue);

	od_dma_oddma_wr_num_bl_wrap_rolling_reg.regValue = rtd_inl(OD_DMA_ODDMA_WR_num_bl_wrap_rolling_reg);
	od_dma_oddma_rd_num_bl_wrap_rolling_reg.regValue = rtd_inl(OD_DMA_ODDMA_RD_num_bl_wrap_rolling_reg);
	od_dma_oddma_wr_num_bl_wrap_word_reg.regValue = rtd_inl(OD_DMA_ODDMA_WR_num_bl_wrap_word_reg);
	od_dma_oddma_rd_num_bl_wrap_word_reg.regValue = rtd_inl(OD_DMA_ODDMA_RD_num_bl_wrap_word_reg);

	if(dma_mode == 0) { // LINE MODE
		// b802cd0c Merlin3 first_line_more_en = 0 when line mode
		od_dma_oddma_pq_cmp_enable_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_CMP_ENABLE_reg);
		od_dma_oddma_pq_cmp_enable_reg.fisrt_line_more_en = 0;
		//od_dma_oddma_pq_cmp_enable_reg.force_last2blk_pe_mode0 = 0;
		od_dma_oddma_pq_cmp_enable_reg.guarantee_max_qp_en = 0;
		od_dma_oddma_pq_cmp_enable_reg.g_ratio = 14;
		rtd_outl(OD_DMA_ODDMA_PQ_CMP_ENABLE_reg, od_dma_oddma_pq_cmp_enable_reg.regValue);

		// b802cd14 setting g_ratio_max g_ratio_min
		od_dma_oddma_pq_cmp_allocate_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_CMP_ALLOCATE_reg);
		od_dma_oddma_pq_cmp_allocate_reg.dynamic_allocate_ratio_max = 16;
		od_dma_oddma_pq_cmp_allocate_reg.dynamic_allocate_ratio_min = 13;
		rtd_outl(OD_DMA_ODDMA_PQ_CMP_ALLOCATE_reg, od_dma_oddma_pq_cmp_allocate_reg.regValue);

		// b802cd2c 10 bits 400 SW aggressive table
		od_dma_oddma_pq_cmp_st_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_CMP_ST_reg);
		rtd_outl(OD_DMA_ODDMA_PQ_CMP_ST_reg, od_dma_oddma_pq_cmp_st_reg.regValue);

		// b802ce38 Cap LineStep
		od_dma_oddma_cap_linestep_reg.regValue = rtd_inl(OD_DMA_ODDMA_WR_num_bl_wrap_line_step_reg);
		od_dma_oddma_cap_linestep_reg.cap_line_step = oddma_pq_cmp_pair_reg.cmp_line_sum_bit;
		rtd_outl(OD_DMA_ODDMA_WR_num_bl_wrap_line_step_reg, od_dma_oddma_cap_linestep_reg.regValue);

		// b802ceac Disp LineStep
		od_dma_oddma_rd_num_bl_wrap_line_step_reg.regValue = rtd_inl(OD_DMA_ODDMA_RD_num_bl_wrap_line_step_reg);
		od_dma_oddma_rd_num_bl_wrap_line_step_reg.disp_line_step = oddma_pq_decmp_pair_reg.decmp_line_sum_bit;
		rtd_outl(OD_DMA_ODDMA_RD_num_bl_wrap_line_step_reg, od_dma_oddma_rd_num_bl_wrap_line_step_reg.regValue);

		// b802ce44 cap_line_128_num
		od_dma_oddma_wr_num_bl_wrap_word_reg.cap_line_128_num = oddma_pq_cmp_pair_reg.cmp_line_sum_bit;

		// b802cec4 disp_line_128_num
		od_dma_oddma_rd_num_bl_wrap_word_reg.disp_line_128_num = oddma_pq_decmp_pair_reg.decmp_line_sum_bit;

		// b802ce40 b802cec0 cap disp line rolling space
		od_dma_oddma_wr_num_bl_wrap_rolling_reg.cap_rolling_space = height + 2;
		od_dma_oddma_rd_num_bl_wrap_rolling_reg.disp_rolling_space = height + 2;
		rtd_outl(OD_DMA_ODDMA_WR_num_bl_wrap_rolling_reg, od_dma_oddma_wr_num_bl_wrap_rolling_reg.regValue);
		rtd_outl(OD_DMA_ODDMA_RD_num_bl_wrap_rolling_reg, od_dma_oddma_rd_num_bl_wrap_rolling_reg.regValue);

		// b802ce40 b802cec0 cap disp line rolling enable
		od_dma_oddma_wr_num_bl_wrap_rolling_reg.cap_rolling_enable = 1;
		od_dma_oddma_rd_num_bl_wrap_rolling_reg.disp_rolling_enable = 1;

		// b802cd04 b802cd84 cmp decmp line mode en
		oddma_pq_cmp_pair_reg.regValue =  rtd_inl(OD_DMA_ODDMA_PQ_CMP_PAIR_reg);
		oddma_pq_decmp_pair_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQ_DECMP_PAIR_reg);
		oddma_pq_cmp_pair_reg.cmp_line_mode = 1;
		oddma_pq_decmp_pair_reg.decmp_line_mode = 1;
		oddma_pq_cmp_pair_reg.two_line_prediction_en = 1;
		oddma_pq_decmp_pair_reg.decmp_two_line_prediction_en = 1;
		rtd_outl(OD_DMA_ODDMA_PQ_CMP_PAIR_reg, oddma_pq_cmp_pair_reg.regValue);
		rtd_outl(OD_DMA_ODDMA_PQ_DECMP_PAIR_reg, oddma_pq_decmp_pair_reg.regValue);
	}
	else if(dma_mode == 1) { // FRAME MODE
		// b802ce40 cap line rolling space and enable
		od_dma_oddma_wr_num_bl_wrap_rolling_reg.cap_rolling_enable = 0;

		// b802cec0 disp line rolling space and enable
		od_dma_oddma_rd_num_bl_wrap_rolling_reg.disp_rolling_enable = 0;

		// b802ce44 cap_line_128_num = 0xffff
		od_dma_oddma_wr_num_bl_wrap_word_reg.cap_line_128_num = 0xffff;

		// b802cec4 disp_line_128_num = 0xffff
		od_dma_oddma_rd_num_bl_wrap_word_reg.disp_line_128_num = 0xffff;
	}

	rtd_outl(OD_DMA_ODDMA_WR_num_bl_wrap_rolling_reg, od_dma_oddma_wr_num_bl_wrap_rolling_reg.regValue);
	rtd_outl(OD_DMA_ODDMA_RD_num_bl_wrap_rolling_reg, od_dma_oddma_rd_num_bl_wrap_rolling_reg.regValue);
	rtd_outl(OD_DMA_ODDMA_WR_num_bl_wrap_word_reg, od_dma_oddma_wr_num_bl_wrap_word_reg.regValue);
	rtd_outl(OD_DMA_ODDMA_RD_num_bl_wrap_word_reg, od_dma_oddma_rd_num_bl_wrap_word_reg.regValue);

	// b802ce30 b802ce34 b802ced4 b802ced8 start address
	rtd_outl(OD_DMA_ODDMA_WR_num_bl_wrap_addr_0_reg, od_addr + burst_length);
	rtd_outl(OD_DMA_ODDMA_WR_Rule_check_up_reg, od_addr + od_size - burst_length);
	rtd_outl(OD_DMA_ODDMA_WR_Rule_check_low_reg, od_addr);
	rtd_outl(OD_DMA_ODDMA_RD_num_bl_wrap_addr_0_reg, od_addr + burst_length);
	rtd_outl(OD_DMA_ODDMA_RD_Rule_check_up_reg, od_addr + od_size - burst_length);
	rtd_outl(OD_DMA_ODDMA_RD_Rule_check_low_reg, od_addr);

	// pqc pqdc bypass disable
	od_dma_oddma_pqc_pqdc_compensation_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQC_PQDC_COMPENSATION_reg);
	//od_dma_oddma_pqc_pqdc_compensation_reg.comp_de_comp_bypass = 0;
	rtd_outl(OD_DMA_ODDMA_PQC_PQDC_COMPENSATION_reg, od_dma_oddma_pqc_pqdc_compensation_reg.regValue);

	// b802ce08 cap enable
	od_dma_oddma_wr_ctrl_reg.regValue = rtd_inl(OD_DMA_ODDMA_WR_Ctrl_reg);
	od_dma_oddma_wr_ctrl_reg.cap_en = 1;
	rtd_outl(OD_DMA_ODDMA_WR_Ctrl_reg, od_dma_oddma_wr_ctrl_reg.regValue);

	// b802ce88 disp enable
	od_dma_oddma_rd_ctrl_reg.regValue = rtd_inl(OD_DMA_ODDMA_RD_Ctrl_reg);
	od_dma_oddma_rd_ctrl_reg.disp_en = 1;
	rtd_outl(OD_DMA_ODDMA_RD_Ctrl_reg, od_dma_oddma_rd_ctrl_reg.regValue);

	od_dma_oddma_pqc_decmp_compensation_reg.regValue = rtd_inl(OD_DMA_ODDMA_PQC_PQDC_COMPENSATION_reg);
	od_dma_oddma_pqc_decmp_compensation_reg.tr_en = 1;
	rtd_outl(OD_DMA_ODDMA_PQC_PQDC_COMPENSATION_reg, od_dma_oddma_pqc_decmp_compensation_reg.regValue);
	// end henry

	//printf("[OD] Gibi_od.cpp::drvif_color_od_pqc() finished...\n");

	return true;
}

unsigned char fwif_color_set_od_table(unsigned int *ptr,unsigned int size)
{
		unsigned char od_table_store[OD_table_length];
		unsigned int od_delta_table[OD_table_length];
		unsigned char od_table_store_a[OD_table_length*4];
		int i=0;

		// 17x17 target table input
		memcpy(od_table_store_a, ptr, size);

		#if 0//for debug
		for(i=0;i<size;i++)
			printf("od_table_store_a[%d]=%d\n",i,od_table_store_a[i]);
		#endif

		for(i=0;i<OD_table_length;i++)
			od_table_store[i]=od_table_store_a[i*4];

		#if 0//for debug
		for(i=0;i<OD_table_length;i++)
			printf("od_table_tv006_store[%d]=%d\n",i,od_table_store[i]);
		#endif

   		 // Mac5p 17x17 henry
		fwif_color_od_table_17x17_transform(0, od_table_store, od_delta_table);

		#if 0//for debug
		 for(i=0;i<17;i++)
			printf("od_delta_table[%d]=%d\n",i,od_delta_table[i]);
		#endif

		drvif_color_od_table_seperate(od_delta_table, 0);// 0:delta mode 1:target mode(output mode)

	return true;
}
void fwif_color_od_table_17x17_transform(bool transType, unsigned char *pTableIn, unsigned int *pTableOut)
{
#define targer2delta 0
#define delta2target 1

	int i, j;

	unsigned int tmp = 0, tmp_p = 0;
	if (pTableIn == NULL || pTableOut == NULL)
		return;


	for(i = 0; i < 17; i++)	{ // y: pre
		for(j = 0; j < 17; j++) { // x: cur

			tmp = (unsigned int)pTableIn[i*17+j] & 0xFF;

			if(transType == targer2delta) {

				if(j == 16) {
					tmp_p = tmp - 255;
				}
				else {
					tmp_p = tmp - 16 * j;
				}

				pTableOut[i*17+j] = tmp_p;
			}
			else if(transType == delta2target) {
				// not implemented yet
			}
		}
	}

}

void drvif_color_od_table_seperate(unsigned int *pODtable, unsigned char tableType)
{
	int i;//, count = 30;
	od_od_lut_addr_RBUS lut_addr_reg;

	lut_addr_reg.regValue = rtd_inl(OD_OD_LUT_ADDR_reg);
	lut_addr_reg.table_type = tableType;
	lut_addr_reg.od_lut_ax_en = 1;
	lut_addr_reg.od_lut_ax_mode = 0;
	lut_addr_reg.od_lut_adr_mode = 0; //col(cur) indexfirst
	lut_addr_reg.od_lut_column_addr = 0;
	lut_addr_reg.od_lut_row_addr = 0;
	rtd_outl(OD_OD_LUT_ADDR_reg, lut_addr_reg.regValue);

	for (i = 0; i < OD_table_length; i++) {
		rtd_outl(OD_OD_LUT_DATA_reg, *(pODtable+i));
	}
	rtd_clearbits(OD_OD_LUT_ADDR_reg, _BIT16);
}

#endif

