/**
* @file Merlin6_DesignSpec_I_Domain_DI
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_DI_REG_H_
#define _RBUS_DI_REG_H_

#include "rbus_types.h"



//  DI Register Address
#define  DI_IM_DI_CONTROL                                                       0x18024000
#define  DI_IM_DI_CONTROL_reg_addr                                               "0xB8024000"
#define  DI_IM_DI_CONTROL_reg                                                    0xB8024000
#define  DI_IM_DI_CONTROL_inst_addr                                              "0x0000"
#define  set_DI_IM_DI_CONTROL_reg(data)                                          (*((volatile unsigned int*)DI_IM_DI_CONTROL_reg)=data)
#define  get_DI_IM_DI_CONTROL_reg                                                (*((volatile unsigned int*)DI_IM_DI_CONTROL_reg))
#define  DI_IM_DI_CONTROL_ma_smoothintra90_shift                                 (28)
#define  DI_IM_DI_CONTROL_ma_onedirectionweaveen_shift                           (27)
#define  DI_IM_DI_CONTROL_ccdinr_h_flip_en_shift                                 (26)
#define  DI_IM_DI_CONTROL_cp_tresultweight_shift                                 (23)
#define  DI_IM_DI_CONTROL_write_enable_8_shift                                   (22)
#define  DI_IM_DI_CONTROL_ip_enable_shift                                        (21)
#define  DI_IM_DI_CONTROL_write_enable_7_shift                                   (20)
#define  DI_IM_DI_CONTROL_di444to422lowpass_shift                                (19)
#define  DI_IM_DI_CONTROL_write_enable_6_shift                                   (18)
#define  DI_IM_DI_CONTROL_cp_temporalenable_shift                                (17)
#define  DI_IM_DI_CONTROL_write_enable_5_shift                                   (16)
#define  DI_IM_DI_CONTROL_film_enable_shift                                      (11)
#define  DI_IM_DI_CONTROL_write_enable_4_shift                                   (10)
#define  DI_IM_DI_CONTROL_ma_horicomen_shift                                     (9)
#define  DI_IM_DI_CONTROL_write_enable_2_shift                                   (6)
#define  DI_IM_DI_CONTROL_ma_messintra90_shift                                   (5)
#define  DI_IM_DI_CONTROL_write_enable_1_shift                                   (4)
#define  DI_IM_DI_CONTROL_ma_3aenable_shift                                      (3)
#define  DI_IM_DI_CONTROL_write_enable_0_shift                                   (2)
#define  DI_IM_DI_CONTROL_ma_controlmode_shift                                   (0)
#define  DI_IM_DI_CONTROL_ma_smoothintra90_mask                                  (0x10000000)
#define  DI_IM_DI_CONTROL_ma_onedirectionweaveen_mask                            (0x08000000)
#define  DI_IM_DI_CONTROL_ccdinr_h_flip_en_mask                                  (0x04000000)
#define  DI_IM_DI_CONTROL_cp_tresultweight_mask                                  (0x03800000)
#define  DI_IM_DI_CONTROL_write_enable_8_mask                                    (0x00400000)
#define  DI_IM_DI_CONTROL_ip_enable_mask                                         (0x00200000)
#define  DI_IM_DI_CONTROL_write_enable_7_mask                                    (0x00100000)
#define  DI_IM_DI_CONTROL_di444to422lowpass_mask                                 (0x00080000)
#define  DI_IM_DI_CONTROL_write_enable_6_mask                                    (0x00040000)
#define  DI_IM_DI_CONTROL_cp_temporalenable_mask                                 (0x00020000)
#define  DI_IM_DI_CONTROL_write_enable_5_mask                                    (0x00010000)
#define  DI_IM_DI_CONTROL_film_enable_mask                                       (0x0000F800)
#define  DI_IM_DI_CONTROL_write_enable_4_mask                                    (0x00000400)
#define  DI_IM_DI_CONTROL_ma_horicomen_mask                                      (0x00000200)
#define  DI_IM_DI_CONTROL_write_enable_2_mask                                    (0x00000040)
#define  DI_IM_DI_CONTROL_ma_messintra90_mask                                    (0x00000020)
#define  DI_IM_DI_CONTROL_write_enable_1_mask                                    (0x00000010)
#define  DI_IM_DI_CONTROL_ma_3aenable_mask                                       (0x00000008)
#define  DI_IM_DI_CONTROL_write_enable_0_mask                                    (0x00000004)
#define  DI_IM_DI_CONTROL_ma_controlmode_mask                                    (0x00000003)
#define  DI_IM_DI_CONTROL_ma_smoothintra90(data)                                 (0x10000000&((data)<<28))
#define  DI_IM_DI_CONTROL_ma_onedirectionweaveen(data)                           (0x08000000&((data)<<27))
#define  DI_IM_DI_CONTROL_ccdinr_h_flip_en(data)                                 (0x04000000&((data)<<26))
#define  DI_IM_DI_CONTROL_cp_tresultweight(data)                                 (0x03800000&((data)<<23))
#define  DI_IM_DI_CONTROL_write_enable_8(data)                                   (0x00400000&((data)<<22))
#define  DI_IM_DI_CONTROL_ip_enable(data)                                        (0x00200000&((data)<<21))
#define  DI_IM_DI_CONTROL_write_enable_7(data)                                   (0x00100000&((data)<<20))
#define  DI_IM_DI_CONTROL_di444to422lowpass(data)                                (0x00080000&((data)<<19))
#define  DI_IM_DI_CONTROL_write_enable_6(data)                                   (0x00040000&((data)<<18))
#define  DI_IM_DI_CONTROL_cp_temporalenable(data)                                (0x00020000&((data)<<17))
#define  DI_IM_DI_CONTROL_write_enable_5(data)                                   (0x00010000&((data)<<16))
#define  DI_IM_DI_CONTROL_film_enable(data)                                      (0x0000F800&((data)<<11))
#define  DI_IM_DI_CONTROL_write_enable_4(data)                                   (0x00000400&((data)<<10))
#define  DI_IM_DI_CONTROL_ma_horicomen(data)                                     (0x00000200&((data)<<9))
#define  DI_IM_DI_CONTROL_write_enable_2(data)                                   (0x00000040&((data)<<6))
#define  DI_IM_DI_CONTROL_ma_messintra90(data)                                   (0x00000020&((data)<<5))
#define  DI_IM_DI_CONTROL_write_enable_1(data)                                   (0x00000010&((data)<<4))
#define  DI_IM_DI_CONTROL_ma_3aenable(data)                                      (0x00000008&((data)<<3))
#define  DI_IM_DI_CONTROL_write_enable_0(data)                                   (0x00000004&((data)<<2))
#define  DI_IM_DI_CONTROL_ma_controlmode(data)                                   (0x00000003&(data))
#define  DI_IM_DI_CONTROL_get_ma_smoothintra90(data)                             ((0x10000000&(data))>>28)
#define  DI_IM_DI_CONTROL_get_ma_onedirectionweaveen(data)                       ((0x08000000&(data))>>27)
#define  DI_IM_DI_CONTROL_get_ccdinr_h_flip_en(data)                             ((0x04000000&(data))>>26)
#define  DI_IM_DI_CONTROL_get_cp_tresultweight(data)                             ((0x03800000&(data))>>23)
#define  DI_IM_DI_CONTROL_get_write_enable_8(data)                               ((0x00400000&(data))>>22)
#define  DI_IM_DI_CONTROL_get_ip_enable(data)                                    ((0x00200000&(data))>>21)
#define  DI_IM_DI_CONTROL_get_write_enable_7(data)                               ((0x00100000&(data))>>20)
#define  DI_IM_DI_CONTROL_get_di444to422lowpass(data)                            ((0x00080000&(data))>>19)
#define  DI_IM_DI_CONTROL_get_write_enable_6(data)                               ((0x00040000&(data))>>18)
#define  DI_IM_DI_CONTROL_get_cp_temporalenable(data)                            ((0x00020000&(data))>>17)
#define  DI_IM_DI_CONTROL_get_write_enable_5(data)                               ((0x00010000&(data))>>16)
#define  DI_IM_DI_CONTROL_get_film_enable(data)                                  ((0x0000F800&(data))>>11)
#define  DI_IM_DI_CONTROL_get_write_enable_4(data)                               ((0x00000400&(data))>>10)
#define  DI_IM_DI_CONTROL_get_ma_horicomen(data)                                 ((0x00000200&(data))>>9)
#define  DI_IM_DI_CONTROL_get_write_enable_2(data)                               ((0x00000040&(data))>>6)
#define  DI_IM_DI_CONTROL_get_ma_messintra90(data)                               ((0x00000020&(data))>>5)
#define  DI_IM_DI_CONTROL_get_write_enable_1(data)                               ((0x00000010&(data))>>4)
#define  DI_IM_DI_CONTROL_get_ma_3aenable(data)                                  ((0x00000008&(data))>>3)
#define  DI_IM_DI_CONTROL_get_write_enable_0(data)                               ((0x00000004&(data))>>2)
#define  DI_IM_DI_CONTROL_get_ma_controlmode(data)                               (0x00000003&(data))

#define  DI_Color_Recovery_Option                                               0x18024004
#define  DI_Color_Recovery_Option_reg_addr                                       "0xB8024004"
#define  DI_Color_Recovery_Option_reg                                            0xB8024004
#define  DI_Color_Recovery_Option_inst_addr                                      "0x0001"
#define  set_DI_Color_Recovery_Option_reg(data)                                  (*((volatile unsigned int*)DI_Color_Recovery_Option_reg)=data)
#define  get_DI_Color_Recovery_Option_reg                                        (*((volatile unsigned int*)DI_Color_Recovery_Option_reg))
#define  DI_Color_Recovery_Option_fun_y_en_shift                                 (31)
#define  DI_Color_Recovery_Option_y10bitsin_shift                                (30)
#define  DI_Color_Recovery_Option_c10bitsin_shift                                (29)
#define  DI_Color_Recovery_Option_game_mode_3a_shift                             (28)
#define  DI_Color_Recovery_Option_cr_fh_switch_shift                             (17)
#define  DI_Color_Recovery_Option_cr_autoimg_enable_shift                        (16)
#define  DI_Color_Recovery_Option_di_r_drop_odd_line_shift                       (14)
#define  DI_Color_Recovery_Option_di_l_drop_odd_line_shift                       (13)
#define  DI_Color_Recovery_Option_dma_force_4buf_shift                           (4)
#define  DI_Color_Recovery_Option_framemotion_pxs_sel_shift                      (3)
#define  DI_Color_Recovery_Option_di_clock_gating_disable_shift                  (2)
#define  DI_Color_Recovery_Option_fun_y_en_mask                                  (0x80000000)
#define  DI_Color_Recovery_Option_y10bitsin_mask                                 (0x40000000)
#define  DI_Color_Recovery_Option_c10bitsin_mask                                 (0x20000000)
#define  DI_Color_Recovery_Option_game_mode_3a_mask                              (0x10000000)
#define  DI_Color_Recovery_Option_cr_fh_switch_mask                              (0x00020000)
#define  DI_Color_Recovery_Option_cr_autoimg_enable_mask                         (0x00010000)
#define  DI_Color_Recovery_Option_di_r_drop_odd_line_mask                        (0x00004000)
#define  DI_Color_Recovery_Option_di_l_drop_odd_line_mask                        (0x00002000)
#define  DI_Color_Recovery_Option_dma_force_4buf_mask                            (0x00000010)
#define  DI_Color_Recovery_Option_framemotion_pxs_sel_mask                       (0x00000008)
#define  DI_Color_Recovery_Option_di_clock_gating_disable_mask                   (0x00000004)
#define  DI_Color_Recovery_Option_fun_y_en(data)                                 (0x80000000&((data)<<31))
#define  DI_Color_Recovery_Option_y10bitsin(data)                                (0x40000000&((data)<<30))
#define  DI_Color_Recovery_Option_c10bitsin(data)                                (0x20000000&((data)<<29))
#define  DI_Color_Recovery_Option_game_mode_3a(data)                             (0x10000000&((data)<<28))
#define  DI_Color_Recovery_Option_cr_fh_switch(data)                             (0x00020000&((data)<<17))
#define  DI_Color_Recovery_Option_cr_autoimg_enable(data)                        (0x00010000&((data)<<16))
#define  DI_Color_Recovery_Option_di_r_drop_odd_line(data)                       (0x00004000&((data)<<14))
#define  DI_Color_Recovery_Option_di_l_drop_odd_line(data)                       (0x00002000&((data)<<13))
#define  DI_Color_Recovery_Option_dma_force_4buf(data)                           (0x00000010&((data)<<4))
#define  DI_Color_Recovery_Option_framemotion_pxs_sel(data)                      (0x00000008&((data)<<3))
#define  DI_Color_Recovery_Option_di_clock_gating_disable(data)                  (0x00000004&((data)<<2))
#define  DI_Color_Recovery_Option_get_fun_y_en(data)                             ((0x80000000&(data))>>31)
#define  DI_Color_Recovery_Option_get_y10bitsin(data)                            ((0x40000000&(data))>>30)
#define  DI_Color_Recovery_Option_get_c10bitsin(data)                            ((0x20000000&(data))>>29)
#define  DI_Color_Recovery_Option_get_game_mode_3a(data)                         ((0x10000000&(data))>>28)
#define  DI_Color_Recovery_Option_get_cr_fh_switch(data)                         ((0x00020000&(data))>>17)
#define  DI_Color_Recovery_Option_get_cr_autoimg_enable(data)                    ((0x00010000&(data))>>16)
#define  DI_Color_Recovery_Option_get_di_r_drop_odd_line(data)                   ((0x00004000&(data))>>14)
#define  DI_Color_Recovery_Option_get_di_l_drop_odd_line(data)                   ((0x00002000&(data))>>13)
#define  DI_Color_Recovery_Option_get_dma_force_4buf(data)                       ((0x00000010&(data))>>4)
#define  DI_Color_Recovery_Option_get_framemotion_pxs_sel(data)                  ((0x00000008&(data))>>3)
#define  DI_Color_Recovery_Option_get_di_clock_gating_disable(data)              ((0x00000004&(data))>>2)

#define  DI_IM_DI_DEBUG_MODE                                                    0x18024008
#define  DI_IM_DI_DEBUG_MODE_reg_addr                                            "0xB8024008"
#define  DI_IM_DI_DEBUG_MODE_reg                                                 0xB8024008
#define  DI_IM_DI_DEBUG_MODE_inst_addr                                           "0x0002"
#define  set_DI_IM_DI_DEBUG_MODE_reg(data)                                       (*((volatile unsigned int*)DI_IM_DI_DEBUG_MODE_reg)=data)
#define  get_DI_IM_DI_DEBUG_MODE_reg                                             (*((volatile unsigned int*)DI_IM_DI_DEBUG_MODE_reg))
#define  DI_IM_DI_DEBUG_MODE_field_confuse_shift                                 (31)
#define  DI_IM_DI_DEBUG_MODE_di_3d_l_flag_shift                                  (30)
#define  DI_IM_DI_DEBUG_MODE_field_confuse_i2rnd_shift                           (29)
#define  DI_IM_DI_DEBUG_MODE_readstart_shift                                     (16)
#define  DI_IM_DI_DEBUG_MODE_unfreeze_polarity_shift                             (12)
#define  DI_IM_DI_DEBUG_MODE_auto_frz_num_shift                                  (9)
#define  DI_IM_DI_DEBUG_MODE_auto_freeze_shift                                   (8)
#define  DI_IM_DI_DEBUG_MODE_film_debugmode_shift                                (5)
#define  DI_IM_DI_DEBUG_MODE_ma_debugmode_shift                                  (2)
#define  DI_IM_DI_DEBUG_MODE_ma_modeselect_shift                                 (1)
#define  DI_IM_DI_DEBUG_MODE_cp_tnrdebugmode_shift                               (0)
#define  DI_IM_DI_DEBUG_MODE_field_confuse_mask                                  (0x80000000)
#define  DI_IM_DI_DEBUG_MODE_di_3d_l_flag_mask                                   (0x40000000)
#define  DI_IM_DI_DEBUG_MODE_field_confuse_i2rnd_mask                            (0x20000000)
#define  DI_IM_DI_DEBUG_MODE_readstart_mask                                      (0x1FFF0000)
#define  DI_IM_DI_DEBUG_MODE_unfreeze_polarity_mask                              (0x00001000)
#define  DI_IM_DI_DEBUG_MODE_auto_frz_num_mask                                   (0x00000E00)
#define  DI_IM_DI_DEBUG_MODE_auto_freeze_mask                                    (0x00000100)
#define  DI_IM_DI_DEBUG_MODE_film_debugmode_mask                                 (0x00000020)
#define  DI_IM_DI_DEBUG_MODE_ma_debugmode_mask                                   (0x0000001C)
#define  DI_IM_DI_DEBUG_MODE_ma_modeselect_mask                                  (0x00000002)
#define  DI_IM_DI_DEBUG_MODE_cp_tnrdebugmode_mask                                (0x00000001)
#define  DI_IM_DI_DEBUG_MODE_field_confuse(data)                                 (0x80000000&((data)<<31))
#define  DI_IM_DI_DEBUG_MODE_di_3d_l_flag(data)                                  (0x40000000&((data)<<30))
#define  DI_IM_DI_DEBUG_MODE_field_confuse_i2rnd(data)                           (0x20000000&((data)<<29))
#define  DI_IM_DI_DEBUG_MODE_readstart(data)                                     (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_DEBUG_MODE_unfreeze_polarity(data)                             (0x00001000&((data)<<12))
#define  DI_IM_DI_DEBUG_MODE_auto_frz_num(data)                                  (0x00000E00&((data)<<9))
#define  DI_IM_DI_DEBUG_MODE_auto_freeze(data)                                   (0x00000100&((data)<<8))
#define  DI_IM_DI_DEBUG_MODE_film_debugmode(data)                                (0x00000020&((data)<<5))
#define  DI_IM_DI_DEBUG_MODE_ma_debugmode(data)                                  (0x0000001C&((data)<<2))
#define  DI_IM_DI_DEBUG_MODE_ma_modeselect(data)                                 (0x00000002&((data)<<1))
#define  DI_IM_DI_DEBUG_MODE_cp_tnrdebugmode(data)                               (0x00000001&(data))
#define  DI_IM_DI_DEBUG_MODE_get_field_confuse(data)                             ((0x80000000&(data))>>31)
#define  DI_IM_DI_DEBUG_MODE_get_di_3d_l_flag(data)                              ((0x40000000&(data))>>30)
#define  DI_IM_DI_DEBUG_MODE_get_field_confuse_i2rnd(data)                       ((0x20000000&(data))>>29)
#define  DI_IM_DI_DEBUG_MODE_get_readstart(data)                                 ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_DEBUG_MODE_get_unfreeze_polarity(data)                         ((0x00001000&(data))>>12)
#define  DI_IM_DI_DEBUG_MODE_get_auto_frz_num(data)                              ((0x00000E00&(data))>>9)
#define  DI_IM_DI_DEBUG_MODE_get_auto_freeze(data)                               ((0x00000100&(data))>>8)
#define  DI_IM_DI_DEBUG_MODE_get_film_debugmode(data)                            ((0x00000020&(data))>>5)
#define  DI_IM_DI_DEBUG_MODE_get_ma_debugmode(data)                              ((0x0000001C&(data))>>2)
#define  DI_IM_DI_DEBUG_MODE_get_ma_modeselect(data)                             ((0x00000002&(data))>>1)
#define  DI_IM_DI_DEBUG_MODE_get_cp_tnrdebugmode(data)                           (0x00000001&(data))

#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL                                         0x1802400C
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_reg_addr                                 "0xB802400C"
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_reg                                      0xB802400C
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_inst_addr                                "0x0003"
#define  set_DI_IM_DI_ACTIVE_WINDOW_CONTROL_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_ACTIVE_WINDOW_CONTROL_reg)=data)
#define  get_DI_IM_DI_ACTIVE_WINDOW_CONTROL_reg                                  (*((volatile unsigned int*)DI_IM_DI_ACTIVE_WINDOW_CONTROL_reg))
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_singlefieldintra_shift                   (31)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_hsize_shift                              (20)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_vsize_shift                              (10)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_hblksize_shift                           (0)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_singlefieldintra_mask                    (0x80000000)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_hsize_mask                               (0x7FF00000)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_vsize_mask                               (0x000FFC00)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_hblksize_mask                            (0x000003FF)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_singlefieldintra(data)                   (0x80000000&((data)<<31))
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_hsize(data)                              (0x7FF00000&((data)<<20))
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_vsize(data)                              (0x000FFC00&((data)<<10))
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_hblksize(data)                           (0x000003FF&(data))
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_get_singlefieldintra(data)               ((0x80000000&(data))>>31)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_get_hsize(data)                          ((0x7FF00000&(data))>>20)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_get_vsize(data)                          ((0x000FFC00&(data))>>10)
#define  DI_IM_DI_ACTIVE_WINDOW_CONTROL_get_hblksize(data)                       (0x000003FF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_CONTROL                                          0x18024010
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_reg_addr                                  "0xB8024010"
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_reg                                       0xB8024010
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_inst_addr                                 "0x0004"
#define  set_DI_IM_DI_WEAVE_WINDOW_CONTROL_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_CONTROL_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_CONTROL_reg                                   (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_CONTROL_reg))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindowmode_shift                     (30)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_nxt_rpt_flag_disable_shift                (28)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_hsize_msb_shift                           (25)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_vsize_msb_shift                           (23)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_hblksize_msb_shift                        (21)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_freeze_shift                              (20)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_force2d_shift                             (19)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_force2d_i2rnd_shift                       (18)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_field_confuse_error_shift                 (12)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_field_confuse_i2rnd_error_shift           (8)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_delpixelen_shift                          (7)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_dellineen_shift                           (6)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow5_shift                        (5)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow4_shift                        (4)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow3_shift                        (3)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow2_shift                        (2)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow1_shift                        (1)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow0_shift                        (0)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindowmode_mask                      (0xC0000000)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_nxt_rpt_flag_disable_mask                 (0x10000000)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_hsize_msb_mask                            (0x06000000)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_vsize_msb_mask                            (0x01800000)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_hblksize_msb_mask                         (0x00200000)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_freeze_mask                               (0x00100000)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_force2d_mask                              (0x00080000)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_force2d_i2rnd_mask                        (0x00040000)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_field_confuse_error_mask                  (0x0000F000)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_field_confuse_i2rnd_error_mask            (0x00000F00)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_delpixelen_mask                           (0x00000080)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_dellineen_mask                            (0x00000040)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow5_mask                         (0x00000020)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow4_mask                         (0x00000010)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow3_mask                         (0x00000008)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow2_mask                         (0x00000004)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow1_mask                         (0x00000002)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow0_mask                         (0x00000001)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindowmode(data)                     (0xC0000000&((data)<<30))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_nxt_rpt_flag_disable(data)                (0x10000000&((data)<<28))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_hsize_msb(data)                           (0x06000000&((data)<<25))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_vsize_msb(data)                           (0x01800000&((data)<<23))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_hblksize_msb(data)                        (0x00200000&((data)<<21))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_freeze(data)                              (0x00100000&((data)<<20))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_force2d(data)                             (0x00080000&((data)<<19))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_force2d_i2rnd(data)                       (0x00040000&((data)<<18))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_field_confuse_error(data)                 (0x0000F000&((data)<<12))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_field_confuse_i2rnd_error(data)           (0x00000F00&((data)<<8))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_delpixelen(data)                          (0x00000080&((data)<<7))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_dellineen(data)                           (0x00000040&((data)<<6))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow5(data)                        (0x00000020&((data)<<5))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow4(data)                        (0x00000010&((data)<<4))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow3(data)                        (0x00000008&((data)<<3))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow2(data)                        (0x00000004&((data)<<2))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow1(data)                        (0x00000002&((data)<<1))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_fixedwindow0(data)                        (0x00000001&(data))
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_fixedwindowmode(data)                 ((0xC0000000&(data))>>30)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_nxt_rpt_flag_disable(data)            ((0x10000000&(data))>>28)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_hsize_msb(data)                       ((0x06000000&(data))>>25)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_vsize_msb(data)                       ((0x01800000&(data))>>23)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_hblksize_msb(data)                    ((0x00200000&(data))>>21)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_freeze(data)                          ((0x00100000&(data))>>20)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_force2d(data)                         ((0x00080000&(data))>>19)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_force2d_i2rnd(data)                   ((0x00040000&(data))>>18)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_field_confuse_error(data)             ((0x0000F000&(data))>>12)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_field_confuse_i2rnd_error(data)       ((0x00000F00&(data))>>8)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_delpixelen(data)                      ((0x00000080&(data))>>7)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_dellineen(data)                       ((0x00000040&(data))>>6)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_fixedwindow5(data)                    ((0x00000020&(data))>>5)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_fixedwindow4(data)                    ((0x00000010&(data))>>4)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_fixedwindow3(data)                    ((0x00000008&(data))>>3)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_fixedwindow2(data)                    ((0x00000004&(data))>>2)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_fixedwindow1(data)                    ((0x00000002&(data))>>1)
#define  DI_IM_DI_WEAVE_WINDOW_CONTROL_get_fixedwindow0(data)                    (0x00000001&(data))

#define  DI_IM_DI_WEAVE_WINDOW_0_START                                          0x18024014
#define  DI_IM_DI_WEAVE_WINDOW_0_START_reg_addr                                  "0xB8024014"
#define  DI_IM_DI_WEAVE_WINDOW_0_START_reg                                       0xB8024014
#define  DI_IM_DI_WEAVE_WINDOW_0_START_inst_addr                                 "0x0005"
#define  set_DI_IM_DI_WEAVE_WINDOW_0_START_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_0_START_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_0_START_reg                                   (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_0_START_reg))
#define  DI_IM_DI_WEAVE_WINDOW_0_START_ystart_12_0_shift                         (16)
#define  DI_IM_DI_WEAVE_WINDOW_0_START_xstart_12_0_shift                         (0)
#define  DI_IM_DI_WEAVE_WINDOW_0_START_ystart_12_0_mask                          (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_0_START_xstart_12_0_mask                          (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_0_START_ystart_12_0(data)                         (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_0_START_xstart_12_0(data)                         (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_0_START_get_ystart_12_0(data)                     ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_0_START_get_xstart_12_0(data)                     (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_0_END                                            0x18024018
#define  DI_IM_DI_WEAVE_WINDOW_0_END_reg_addr                                    "0xB8024018"
#define  DI_IM_DI_WEAVE_WINDOW_0_END_reg                                         0xB8024018
#define  DI_IM_DI_WEAVE_WINDOW_0_END_inst_addr                                   "0x0006"
#define  set_DI_IM_DI_WEAVE_WINDOW_0_END_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_0_END_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_0_END_reg                                     (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_0_END_reg))
#define  DI_IM_DI_WEAVE_WINDOW_0_END_yend_12_0_shift                             (16)
#define  DI_IM_DI_WEAVE_WINDOW_0_END_xend_12_0_shift                             (0)
#define  DI_IM_DI_WEAVE_WINDOW_0_END_yend_12_0_mask                              (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_0_END_xend_12_0_mask                              (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_0_END_yend_12_0(data)                             (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_0_END_xend_12_0(data)                             (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_0_END_get_yend_12_0(data)                         ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_0_END_get_xend_12_0(data)                         (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_1_START                                          0x1802401C
#define  DI_IM_DI_WEAVE_WINDOW_1_START_reg_addr                                  "0xB802401C"
#define  DI_IM_DI_WEAVE_WINDOW_1_START_reg                                       0xB802401C
#define  DI_IM_DI_WEAVE_WINDOW_1_START_inst_addr                                 "0x0007"
#define  set_DI_IM_DI_WEAVE_WINDOW_1_START_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_1_START_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_1_START_reg                                   (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_1_START_reg))
#define  DI_IM_DI_WEAVE_WINDOW_1_START_ystart_25_13_shift                        (16)
#define  DI_IM_DI_WEAVE_WINDOW_1_START_xstart_25_13_shift                        (0)
#define  DI_IM_DI_WEAVE_WINDOW_1_START_ystart_25_13_mask                         (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_1_START_xstart_25_13_mask                         (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_1_START_ystart_25_13(data)                        (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_1_START_xstart_25_13(data)                        (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_1_START_get_ystart_25_13(data)                    ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_1_START_get_xstart_25_13(data)                    (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_1_END                                            0x18024020
#define  DI_IM_DI_WEAVE_WINDOW_1_END_reg_addr                                    "0xB8024020"
#define  DI_IM_DI_WEAVE_WINDOW_1_END_reg                                         0xB8024020
#define  DI_IM_DI_WEAVE_WINDOW_1_END_inst_addr                                   "0x0008"
#define  set_DI_IM_DI_WEAVE_WINDOW_1_END_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_1_END_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_1_END_reg                                     (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_1_END_reg))
#define  DI_IM_DI_WEAVE_WINDOW_1_END_yend_25_13_shift                            (16)
#define  DI_IM_DI_WEAVE_WINDOW_1_END_xend_25_13_shift                            (0)
#define  DI_IM_DI_WEAVE_WINDOW_1_END_yend_25_13_mask                             (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_1_END_xend_25_13_mask                             (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_1_END_yend_25_13(data)                            (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_1_END_xend_25_13(data)                            (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_1_END_get_yend_25_13(data)                        ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_1_END_get_xend_25_13(data)                        (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_2_START                                          0x18024024
#define  DI_IM_DI_WEAVE_WINDOW_2_START_reg_addr                                  "0xB8024024"
#define  DI_IM_DI_WEAVE_WINDOW_2_START_reg                                       0xB8024024
#define  DI_IM_DI_WEAVE_WINDOW_2_START_inst_addr                                 "0x0009"
#define  set_DI_IM_DI_WEAVE_WINDOW_2_START_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_2_START_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_2_START_reg                                   (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_2_START_reg))
#define  DI_IM_DI_WEAVE_WINDOW_2_START_ystart_38_26_shift                        (16)
#define  DI_IM_DI_WEAVE_WINDOW_2_START_xstart_38_26_shift                        (0)
#define  DI_IM_DI_WEAVE_WINDOW_2_START_ystart_38_26_mask                         (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_2_START_xstart_38_26_mask                         (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_2_START_ystart_38_26(data)                        (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_2_START_xstart_38_26(data)                        (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_2_START_get_ystart_38_26(data)                    ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_2_START_get_xstart_38_26(data)                    (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_2_END                                            0x18024028
#define  DI_IM_DI_WEAVE_WINDOW_2_END_reg_addr                                    "0xB8024028"
#define  DI_IM_DI_WEAVE_WINDOW_2_END_reg                                         0xB8024028
#define  DI_IM_DI_WEAVE_WINDOW_2_END_inst_addr                                   "0x000A"
#define  set_DI_IM_DI_WEAVE_WINDOW_2_END_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_2_END_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_2_END_reg                                     (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_2_END_reg))
#define  DI_IM_DI_WEAVE_WINDOW_2_END_yend_38_26_shift                            (16)
#define  DI_IM_DI_WEAVE_WINDOW_2_END_xend_38_26_shift                            (0)
#define  DI_IM_DI_WEAVE_WINDOW_2_END_yend_38_26_mask                             (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_2_END_xend_38_26_mask                             (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_2_END_yend_38_26(data)                            (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_2_END_xend_38_26(data)                            (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_2_END_get_yend_38_26(data)                        ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_2_END_get_xend_38_26(data)                        (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_3_START                                          0x1802402C
#define  DI_IM_DI_WEAVE_WINDOW_3_START_reg_addr                                  "0xB802402C"
#define  DI_IM_DI_WEAVE_WINDOW_3_START_reg                                       0xB802402C
#define  DI_IM_DI_WEAVE_WINDOW_3_START_inst_addr                                 "0x000B"
#define  set_DI_IM_DI_WEAVE_WINDOW_3_START_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_3_START_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_3_START_reg                                   (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_3_START_reg))
#define  DI_IM_DI_WEAVE_WINDOW_3_START_ystart_51_39_shift                        (16)
#define  DI_IM_DI_WEAVE_WINDOW_3_START_xstart_51_39_shift                        (0)
#define  DI_IM_DI_WEAVE_WINDOW_3_START_ystart_51_39_mask                         (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_3_START_xstart_51_39_mask                         (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_3_START_ystart_51_39(data)                        (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_3_START_xstart_51_39(data)                        (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_3_START_get_ystart_51_39(data)                    ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_3_START_get_xstart_51_39(data)                    (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_3_END                                            0x18024030
#define  DI_IM_DI_WEAVE_WINDOW_3_END_reg_addr                                    "0xB8024030"
#define  DI_IM_DI_WEAVE_WINDOW_3_END_reg                                         0xB8024030
#define  DI_IM_DI_WEAVE_WINDOW_3_END_inst_addr                                   "0x000C"
#define  set_DI_IM_DI_WEAVE_WINDOW_3_END_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_3_END_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_3_END_reg                                     (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_3_END_reg))
#define  DI_IM_DI_WEAVE_WINDOW_3_END_yend_51_39_shift                            (16)
#define  DI_IM_DI_WEAVE_WINDOW_3_END_xend_51_39_shift                            (0)
#define  DI_IM_DI_WEAVE_WINDOW_3_END_yend_51_39_mask                             (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_3_END_xend_51_39_mask                             (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_3_END_yend_51_39(data)                            (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_3_END_xend_51_39(data)                            (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_3_END_get_yend_51_39(data)                        ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_3_END_get_xend_51_39(data)                        (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_4_START                                          0x18024034
#define  DI_IM_DI_WEAVE_WINDOW_4_START_reg_addr                                  "0xB8024034"
#define  DI_IM_DI_WEAVE_WINDOW_4_START_reg                                       0xB8024034
#define  DI_IM_DI_WEAVE_WINDOW_4_START_inst_addr                                 "0x000D"
#define  set_DI_IM_DI_WEAVE_WINDOW_4_START_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_4_START_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_4_START_reg                                   (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_4_START_reg))
#define  DI_IM_DI_WEAVE_WINDOW_4_START_ystart_64_52_shift                        (16)
#define  DI_IM_DI_WEAVE_WINDOW_4_START_xstart_64_52_shift                        (0)
#define  DI_IM_DI_WEAVE_WINDOW_4_START_ystart_64_52_mask                         (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_4_START_xstart_64_52_mask                         (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_4_START_ystart_64_52(data)                        (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_4_START_xstart_64_52(data)                        (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_4_START_get_ystart_64_52(data)                    ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_4_START_get_xstart_64_52(data)                    (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_4_END                                            0x18024038
#define  DI_IM_DI_WEAVE_WINDOW_4_END_reg_addr                                    "0xB8024038"
#define  DI_IM_DI_WEAVE_WINDOW_4_END_reg                                         0xB8024038
#define  DI_IM_DI_WEAVE_WINDOW_4_END_inst_addr                                   "0x000E"
#define  set_DI_IM_DI_WEAVE_WINDOW_4_END_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_4_END_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_4_END_reg                                     (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_4_END_reg))
#define  DI_IM_DI_WEAVE_WINDOW_4_END_yend_64_52_shift                            (16)
#define  DI_IM_DI_WEAVE_WINDOW_4_END_xend_64_52_shift                            (0)
#define  DI_IM_DI_WEAVE_WINDOW_4_END_yend_64_52_mask                             (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_4_END_xend_64_52_mask                             (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_4_END_yend_64_52(data)                            (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_4_END_xend_64_52(data)                            (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_4_END_get_yend_64_52(data)                        ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_4_END_get_xend_64_52(data)                        (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_5_START                                          0x1802403C
#define  DI_IM_DI_WEAVE_WINDOW_5_START_reg_addr                                  "0xB802403C"
#define  DI_IM_DI_WEAVE_WINDOW_5_START_reg                                       0xB802403C
#define  DI_IM_DI_WEAVE_WINDOW_5_START_inst_addr                                 "0x000F"
#define  set_DI_IM_DI_WEAVE_WINDOW_5_START_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_5_START_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_5_START_reg                                   (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_5_START_reg))
#define  DI_IM_DI_WEAVE_WINDOW_5_START_ystart_77_65_shift                        (16)
#define  DI_IM_DI_WEAVE_WINDOW_5_START_xstart_77_65_shift                        (0)
#define  DI_IM_DI_WEAVE_WINDOW_5_START_ystart_77_65_mask                         (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_5_START_xstart_77_65_mask                         (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_5_START_ystart_77_65(data)                        (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_5_START_xstart_77_65(data)                        (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_5_START_get_ystart_77_65(data)                    ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_5_START_get_xstart_77_65(data)                    (0x00001FFF&(data))

#define  DI_IM_DI_WEAVE_WINDOW_5_END                                            0x18024040
#define  DI_IM_DI_WEAVE_WINDOW_5_END_reg_addr                                    "0xB8024040"
#define  DI_IM_DI_WEAVE_WINDOW_5_END_reg                                         0xB8024040
#define  DI_IM_DI_WEAVE_WINDOW_5_END_inst_addr                                   "0x0010"
#define  set_DI_IM_DI_WEAVE_WINDOW_5_END_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_5_END_reg)=data)
#define  get_DI_IM_DI_WEAVE_WINDOW_5_END_reg                                     (*((volatile unsigned int*)DI_IM_DI_WEAVE_WINDOW_5_END_reg))
#define  DI_IM_DI_WEAVE_WINDOW_5_END_yend_77_65_shift                            (16)
#define  DI_IM_DI_WEAVE_WINDOW_5_END_xend_77_65_shift                            (0)
#define  DI_IM_DI_WEAVE_WINDOW_5_END_yend_77_65_mask                             (0x1FFF0000)
#define  DI_IM_DI_WEAVE_WINDOW_5_END_xend_77_65_mask                             (0x00001FFF)
#define  DI_IM_DI_WEAVE_WINDOW_5_END_yend_77_65(data)                            (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_WEAVE_WINDOW_5_END_xend_77_65(data)                            (0x00001FFF&(data))
#define  DI_IM_DI_WEAVE_WINDOW_5_END_get_yend_77_65(data)                        ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_WEAVE_WINDOW_5_END_get_xend_77_65(data)                        (0x00001FFF&(data))

#define  DI_IM_DI_CLASSIFY_THClassify_Threshold                                 0x18024044
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_reg_addr                         "0xB8024044"
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_reg                              0xB8024044
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_inst_addr                        "0x0011"
#define  set_DI_IM_DI_CLASSIFY_THClassify_Threshold_reg(data)                    (*((volatile unsigned int*)DI_IM_DI_CLASSIFY_THClassify_Threshold_reg)=data)
#define  get_DI_IM_DI_CLASSIFY_THClassify_Threshold_reg                          (*((volatile unsigned int*)DI_IM_DI_CLASSIFY_THClassify_Threshold_reg))
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_pseudo_memc_film22_sequence_shift (28)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_ma_class_h_th1_cmp_shift         (16)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_ma_class_h_th1_shift             (8)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_ma_class_h_th2_shift             (0)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_pseudo_memc_film22_sequence_mask (0x30000000)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_ma_class_h_th1_cmp_mask          (0x001F0000)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_ma_class_h_th1_mask              (0x00001F00)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_ma_class_h_th2_mask              (0x0000001F)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_pseudo_memc_film22_sequence(data) (0x30000000&((data)<<28))
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_ma_class_h_th1_cmp(data)         (0x001F0000&((data)<<16))
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_ma_class_h_th1(data)             (0x00001F00&((data)<<8))
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_ma_class_h_th2(data)             (0x0000001F&(data))
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_get_pseudo_memc_film22_sequence(data) ((0x30000000&(data))>>28)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_get_ma_class_h_th1_cmp(data)     ((0x001F0000&(data))>>16)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_get_ma_class_h_th1(data)         ((0x00001F00&(data))>>8)
#define  DI_IM_DI_CLASSIFY_THClassify_Threshold_get_ma_class_h_th2(data)         (0x0000001F&(data))

#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD                                    0x18024048
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_reg_addr                            "0xB8024048"
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_reg                                 0xB8024048
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_inst_addr                           "0x0012"
#define  set_DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_reg)=data)
#define  get_DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_reg                             (*((volatile unsigned int*)DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_reg))
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb3_shift              (16)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb2_shift              (14)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb1_hor_shift          (12)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb1_shift              (10)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb0_shift              (8)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend10_weight_shift             (4)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend01_weight_shift             (0)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb3_mask               (0x00030000)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb2_mask               (0x0000C000)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb1_hor_mask           (0x00003000)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb1_mask               (0x00000C00)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb0_mask               (0x00000300)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend10_weight_mask              (0x00000070)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend01_weight_mask              (0x00000007)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb3(data)              (0x00030000&((data)<<16))
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb2(data)              (0x0000C000&((data)<<14))
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb1_hor(data)          (0x00003000&((data)<<12))
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb1(data)              (0x00000C00&((data)<<10))
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend_fmcomb0(data)              (0x00000300&((data)<<8))
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend10_weight(data)             (0x00000070&((data)<<4))
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_ma_blend01_weight(data)             (0x00000007&(data))
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_get_ma_blend_fmcomb3(data)          ((0x00030000&(data))>>16)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_get_ma_blend_fmcomb2(data)          ((0x0000C000&(data))>>14)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_get_ma_blend_fmcomb1_hor(data)      ((0x00003000&(data))>>12)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_get_ma_blend_fmcomb1(data)          ((0x00000C00&(data))>>10)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_get_ma_blend_fmcomb0(data)          ((0x00000300&(data))>>8)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_get_ma_blend10_weight(data)         ((0x00000070&(data))>>4)
#define  DI_IM_DI_BLEND_AND_WEIGHTING_METHOD_get_ma_blend01_weight(data)         (0x00000007&(data))

#define  DI_IM_DI_MPEG_SEQUENCE_APP                                             0x1802404C
#define  DI_IM_DI_MPEG_SEQUENCE_APP_reg_addr                                     "0xB802404C"
#define  DI_IM_DI_MPEG_SEQUENCE_APP_reg                                          0xB802404C
#define  DI_IM_DI_MPEG_SEQUENCE_APP_inst_addr                                    "0x0013"
#define  set_DI_IM_DI_MPEG_SEQUENCE_APP_reg(data)                                (*((volatile unsigned int*)DI_IM_DI_MPEG_SEQUENCE_APP_reg)=data)
#define  get_DI_IM_DI_MPEG_SEQUENCE_APP_reg                                      (*((volatile unsigned int*)DI_IM_DI_MPEG_SEQUENCE_APP_reg))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_dummy_31_shift                               (31)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_ma_sobelthm_shift                            (21)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_ma_sobelths_shift                            (11)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_2d_timing_en_shift                     (10)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_2d_timing_mode_shift                   (9)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_vodma_film_en_shift                          (7)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_dummy_6_3_shift                              (3)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_di_nxt_shift                           (2)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_dma_intra_shift                        (1)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_dma_2d_shift                           (0)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_dummy_31_mask                                (0x80000000)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_ma_sobelthm_mask                             (0x7FE00000)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_ma_sobelths_mask                             (0x001FF800)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_2d_timing_en_mask                      (0x00000400)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_2d_timing_mode_mask                    (0x00000200)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_vodma_film_en_mask                           (0x00000080)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_dummy_6_3_mask                               (0x00000078)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_di_nxt_mask                            (0x00000004)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_dma_intra_mask                         (0x00000002)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_dma_2d_mask                            (0x00000001)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_dummy_31(data)                               (0x80000000&((data)<<31))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_ma_sobelthm(data)                            (0x7FE00000&((data)<<21))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_ma_sobelths(data)                            (0x001FF800&((data)<<11))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_2d_timing_en(data)                     (0x00000400&((data)<<10))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_2d_timing_mode(data)                   (0x00000200&((data)<<9))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_vodma_film_en(data)                          (0x00000080&((data)<<7))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_dummy_6_3(data)                              (0x00000078&((data)<<3))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_di_nxt(data)                           (0x00000004&((data)<<2))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_dma_intra(data)                        (0x00000002&((data)<<1))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_force_dma_2d(data)                           (0x00000001&(data))
#define  DI_IM_DI_MPEG_SEQUENCE_APP_get_dummy_31(data)                           ((0x80000000&(data))>>31)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_get_ma_sobelthm(data)                        ((0x7FE00000&(data))>>21)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_get_ma_sobelths(data)                        ((0x001FF800&(data))>>11)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_get_force_2d_timing_en(data)                 ((0x00000400&(data))>>10)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_get_force_2d_timing_mode(data)               ((0x00000200&(data))>>9)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_get_vodma_film_en(data)                      ((0x00000080&(data))>>7)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_get_dummy_6_3(data)                          ((0x00000078&(data))>>3)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_get_force_di_nxt(data)                       ((0x00000004&(data))>>2)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_get_force_dma_intra(data)                    ((0x00000002&(data))>>1)
#define  DI_IM_DI_MPEG_SEQUENCE_APP_get_force_dma_2d(data)                       (0x00000001&(data))

#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold                                0x18024050
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_reg_addr                        "0xB8024050"
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_reg                             0xB8024050
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_inst_addr                       "0x0014"
#define  set_DI_IM_DI_CLASSIFY2_THClassify_Threshold_reg(data)                   (*((volatile unsigned int*)DI_IM_DI_CLASSIFY2_THClassify_Threshold_reg)=data)
#define  get_DI_IM_DI_CLASSIFY2_THClassify_Threshold_reg                         (*((volatile unsigned int*)DI_IM_DI_CLASSIFY2_THClassify_Threshold_reg))
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_vedge_nolp_en_shift          (29)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_s_th2_shift            (24)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_rlv_th1_cmp_shift      (16)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_rlv_th1_shift          (8)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_rlv_th2_shift          (0)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_vedge_nolp_en_mask           (0xE0000000)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_s_th2_mask             (0x1F000000)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_rlv_th1_cmp_mask       (0x001F0000)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_rlv_th1_mask           (0x00001F00)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_rlv_th2_mask           (0x0000001F)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_vedge_nolp_en(data)          (0xE0000000&((data)<<29))
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_s_th2(data)            (0x1F000000&((data)<<24))
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_rlv_th1_cmp(data)      (0x001F0000&((data)<<16))
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_rlv_th1(data)          (0x00001F00&((data)<<8))
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_ma_class_rlv_th2(data)          (0x0000001F&(data))
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_get_ma_vedge_nolp_en(data)      ((0xE0000000&(data))>>29)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_get_ma_class_s_th2(data)        ((0x1F000000&(data))>>24)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_get_ma_class_rlv_th1_cmp(data)  ((0x001F0000&(data))>>16)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_get_ma_class_rlv_th1(data)      ((0x00001F00&(data))>>8)
#define  DI_IM_DI_CLASSIFY2_THClassify_Threshold_get_ma_class_rlv_th2(data)      (0x0000001F&(data))

#define  DI_IM_DI_NEW_CLASS                                                     0x18024054
#define  DI_IM_DI_NEW_CLASS_reg_addr                                             "0xB8024054"
#define  DI_IM_DI_NEW_CLASS_reg                                                  0xB8024054
#define  DI_IM_DI_NEW_CLASS_inst_addr                                            "0x0015"
#define  set_DI_IM_DI_NEW_CLASS_reg(data)                                        (*((volatile unsigned int*)DI_IM_DI_NEW_CLASS_reg)=data)
#define  get_DI_IM_DI_NEW_CLASS_reg                                              (*((volatile unsigned int*)DI_IM_DI_NEW_CLASS_reg))
#define  DI_IM_DI_NEW_CLASS_ma_new_class_en_shift                                (31)
#define  DI_IM_DI_NEW_CLASS_ma_vedge_add_rlv_shift                               (4)
#define  DI_IM_DI_NEW_CLASS_ma_vedge_nonlpfm_en_shift                            (2)
#define  DI_IM_DI_NEW_CLASS_ma_vedge_force90_en_shift                            (1)
#define  DI_IM_DI_NEW_CLASS_ma_vedge_force_intra_en_shift                        (0)
#define  DI_IM_DI_NEW_CLASS_ma_new_class_en_mask                                 (0x80000000)
#define  DI_IM_DI_NEW_CLASS_ma_vedge_add_rlv_mask                                (0x00000030)
#define  DI_IM_DI_NEW_CLASS_ma_vedge_nonlpfm_en_mask                             (0x00000004)
#define  DI_IM_DI_NEW_CLASS_ma_vedge_force90_en_mask                             (0x00000002)
#define  DI_IM_DI_NEW_CLASS_ma_vedge_force_intra_en_mask                         (0x00000001)
#define  DI_IM_DI_NEW_CLASS_ma_new_class_en(data)                                (0x80000000&((data)<<31))
#define  DI_IM_DI_NEW_CLASS_ma_vedge_add_rlv(data)                               (0x00000030&((data)<<4))
#define  DI_IM_DI_NEW_CLASS_ma_vedge_nonlpfm_en(data)                            (0x00000004&((data)<<2))
#define  DI_IM_DI_NEW_CLASS_ma_vedge_force90_en(data)                            (0x00000002&((data)<<1))
#define  DI_IM_DI_NEW_CLASS_ma_vedge_force_intra_en(data)                        (0x00000001&(data))
#define  DI_IM_DI_NEW_CLASS_get_ma_new_class_en(data)                            ((0x80000000&(data))>>31)
#define  DI_IM_DI_NEW_CLASS_get_ma_vedge_add_rlv(data)                           ((0x00000030&(data))>>4)
#define  DI_IM_DI_NEW_CLASS_get_ma_vedge_nonlpfm_en(data)                        ((0x00000004&(data))>>2)
#define  DI_IM_DI_NEW_CLASS_get_ma_vedge_force90_en(data)                        ((0x00000002&(data))>>1)
#define  DI_IM_DI_NEW_CLASS_get_ma_vedge_force_intra_en(data)                    (0x00000001&(data))

#define  DI_IM_DI_DMA                                                           0x18024058
#define  DI_IM_DI_DMA_reg_addr                                                   "0xB8024058"
#define  DI_IM_DI_DMA_reg                                                        0xB8024058
#define  DI_IM_DI_DMA_inst_addr                                                  "0x0016"
#define  set_DI_IM_DI_DMA_reg(data)                                              (*((volatile unsigned int*)DI_IM_DI_DMA_reg)=data)
#define  get_DI_IM_DI_DMA_reg                                                    (*((volatile unsigned int*)DI_IM_DI_DMA_reg))
#define  DI_IM_DI_DMA_dma_420_en_shift                                           (30)
#define  DI_IM_DI_DMA_rdma_random_en_shift                                       (29)
#define  DI_IM_DI_DMA_linesize_even_shift                                        (12)
#define  DI_IM_DI_DMA_linesize_odd_shift                                         (0)
#define  DI_IM_DI_DMA_dma_420_en_mask                                            (0xC0000000)
#define  DI_IM_DI_DMA_rdma_random_en_mask                                        (0x20000000)
#define  DI_IM_DI_DMA_linesize_even_mask                                         (0x007FF000)
#define  DI_IM_DI_DMA_linesize_odd_mask                                          (0x000007FF)
#define  DI_IM_DI_DMA_dma_420_en(data)                                           (0xC0000000&((data)<<30))
#define  DI_IM_DI_DMA_rdma_random_en(data)                                       (0x20000000&((data)<<29))
#define  DI_IM_DI_DMA_linesize_even(data)                                        (0x007FF000&((data)<<12))
#define  DI_IM_DI_DMA_linesize_odd(data)                                         (0x000007FF&(data))
#define  DI_IM_DI_DMA_get_dma_420_en(data)                                       ((0xC0000000&(data))>>30)
#define  DI_IM_DI_DMA_get_rdma_random_en(data)                                   ((0x20000000&(data))>>29)
#define  DI_IM_DI_DMA_get_linesize_even(data)                                    ((0x007FF000&(data))>>12)
#define  DI_IM_DI_DMA_get_linesize_odd(data)                                     (0x000007FF&(data))

#define  DI_IM_DI_XC_AUTO_BALANCE_TH                                            0x18024068
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_reg_addr                                    "0xB8024068"
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_reg                                         0xB8024068
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_inst_addr                                   "0x0017"
#define  set_DI_IM_DI_XC_AUTO_BALANCE_TH_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_XC_AUTO_BALANCE_TH_reg)=data)
#define  get_DI_IM_DI_XC_AUTO_BALANCE_TH_reg                                     (*((volatile unsigned int*)DI_IM_DI_XC_AUTO_BALANCE_TH_reg))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var4thl_shift                            (24)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var3thl_shift                            (16)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var2thl_shift                            (8)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var1thl_shift                            (0)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var4thl_mask                             (0xFF000000)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var3thl_mask                             (0x00FF0000)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var2thl_mask                             (0x0000FF00)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var1thl_mask                             (0x000000FF)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var4thl(data)                            (0xFF000000&((data)<<24))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var3thl(data)                            (0x00FF0000&((data)<<16))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var2thl(data)                            (0x0000FF00&((data)<<8))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_cr_var1thl(data)                            (0x000000FF&(data))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_get_cr_var4thl(data)                        ((0xFF000000&(data))>>24)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_get_cr_var3thl(data)                        ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_get_cr_var2thl(data)                        ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH_get_cr_var1thl(data)                        (0x000000FF&(data))

#define  DI_IM_DI_XC_AUTO_BALANCE_TH2                                           0x1802406C
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_reg_addr                                   "0xB802406C"
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_reg                                        0xB802406C
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_inst_addr                                  "0x0018"
#define  set_DI_IM_DI_XC_AUTO_BALANCE_TH2_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_XC_AUTO_BALANCE_TH2_reg)=data)
#define  get_DI_IM_DI_XC_AUTO_BALANCE_TH2_reg                                    (*((volatile unsigned int*)DI_IM_DI_XC_AUTO_BALANCE_TH2_reg))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_bcclowpassyenablecontrol_shift             (31)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_autoimg_lpf_enable_shift                   (30)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_autoimg_debug_enable_shift                 (29)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_cr_transitionthl_shift                     (8)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_cr_meanthl_shift                           (0)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_bcclowpassyenablecontrol_mask              (0x80000000)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_autoimg_lpf_enable_mask                    (0x40000000)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_autoimg_debug_enable_mask                  (0x20000000)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_cr_transitionthl_mask                      (0x0000FF00)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_cr_meanthl_mask                            (0x000000FF)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_bcclowpassyenablecontrol(data)             (0x80000000&((data)<<31))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_autoimg_lpf_enable(data)                   (0x40000000&((data)<<30))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_autoimg_debug_enable(data)                 (0x20000000&((data)<<29))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_cr_transitionthl(data)                     (0x0000FF00&((data)<<8))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_cr_meanthl(data)                           (0x000000FF&(data))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_get_bcclowpassyenablecontrol(data)         ((0x80000000&(data))>>31)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_get_autoimg_lpf_enable(data)               ((0x40000000&(data))>>30)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_get_autoimg_debug_enable(data)             ((0x20000000&(data))>>29)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_get_cr_transitionthl(data)                 ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH2_get_cr_meanthl(data)                       (0x000000FF&(data))

#define  DI_IM_DI_XC_AUTO_BALANCE_TH3                                           0x18024070
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_reg_addr                                   "0xB8024070"
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_reg                                        0xB8024070
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_inst_addr                                  "0x0019"
#define  set_DI_IM_DI_XC_AUTO_BALANCE_TH3_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_XC_AUTO_BALANCE_TH3_reg)=data)
#define  get_DI_IM_DI_XC_AUTO_BALANCE_TH3_reg                                    (*((volatile unsigned int*)DI_IM_DI_XC_AUTO_BALANCE_TH3_reg))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_cr_thl_mainbalance_shift                   (16)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_cr_thl_subbalance_shift                    (0)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_cr_thl_mainbalance_mask                    (0x00FF0000)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_cr_thl_subbalance_mask                     (0x0000FFFF)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_cr_thl_mainbalance(data)                   (0x00FF0000&((data)<<16))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_cr_thl_subbalance(data)                    (0x0000FFFF&(data))
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_get_cr_thl_mainbalance(data)               ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_XC_AUTO_BALANCE_TH3_get_cr_thl_subbalance(data)                (0x0000FFFF&(data))

#define  DI_IM_DI_INTRA_TH                                                      0x1802407C
#define  DI_IM_DI_INTRA_TH_reg_addr                                              "0xB802407C"
#define  DI_IM_DI_INTRA_TH_reg                                                   0xB802407C
#define  DI_IM_DI_INTRA_TH_inst_addr                                             "0x001A"
#define  set_DI_IM_DI_INTRA_TH_reg(data)                                         (*((volatile unsigned int*)DI_IM_DI_INTRA_TH_reg)=data)
#define  get_DI_IM_DI_INTRA_TH_reg                                               (*((volatile unsigned int*)DI_IM_DI_INTRA_TH_reg))
#define  DI_IM_DI_INTRA_TH_ma_follow_new_intra_en_shift                          (25)
#define  DI_IM_DI_INTRA_TH_intra_ma_mess_enable_shift                            (24)
#define  DI_IM_DI_INTRA_TH_ma_follow_new_intra_en_mask                           (0x02000000)
#define  DI_IM_DI_INTRA_TH_intra_ma_mess_enable_mask                             (0x01000000)
#define  DI_IM_DI_INTRA_TH_ma_follow_new_intra_en(data)                          (0x02000000&((data)<<25))
#define  DI_IM_DI_INTRA_TH_intra_ma_mess_enable(data)                            (0x01000000&((data)<<24))
#define  DI_IM_DI_INTRA_TH_get_ma_follow_new_intra_en(data)                      ((0x02000000&(data))>>25)
#define  DI_IM_DI_INTRA_TH_get_intra_ma_mess_enable(data)                        ((0x01000000&(data))>>24)

#define  DI_IM_DI_MA_FRAME_MOTION_TH_A                                          0x18024080
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_reg_addr                                  "0xB8024080"
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_reg                                       0xB8024080
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_inst_addr                                 "0x001B"
#define  set_DI_IM_DI_MA_FRAME_MOTION_TH_A_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_MA_FRAME_MOTION_TH_A_reg)=data)
#define  get_DI_IM_DI_MA_FRAME_MOTION_TH_A_reg                                   (*((volatile unsigned int*)DI_IM_DI_MA_FRAME_MOTION_TH_A_reg))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framemtha_shift                        (24)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framehtha_shift                        (16)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framerlvtha_shift                      (8)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framestha_shift                        (0)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framemtha_mask                         (0xFF000000)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framehtha_mask                         (0x00FF0000)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framerlvtha_mask                       (0x0000FF00)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framestha_mask                         (0x000000FF)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framemtha(data)                        (0xFF000000&((data)<<24))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framehtha(data)                        (0x00FF0000&((data)<<16))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framerlvtha(data)                      (0x0000FF00&((data)<<8))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_ma_framestha(data)                        (0x000000FF&(data))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_get_ma_framemtha(data)                    ((0xFF000000&(data))>>24)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_get_ma_framehtha(data)                    ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_get_ma_framerlvtha(data)                  ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_A_get_ma_framestha(data)                    (0x000000FF&(data))

#define  DI_IM_DI_MA_FRAME_MOTION_TH_B                                          0x18024084
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_reg_addr                                  "0xB8024084"
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_reg                                       0xB8024084
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_inst_addr                                 "0x001C"
#define  set_DI_IM_DI_MA_FRAME_MOTION_TH_B_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_MA_FRAME_MOTION_TH_B_reg)=data)
#define  get_DI_IM_DI_MA_FRAME_MOTION_TH_B_reg                                   (*((volatile unsigned int*)DI_IM_DI_MA_FRAME_MOTION_TH_B_reg))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framemthb_shift                        (24)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framehthb_shift                        (16)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framerlvthb_shift                      (8)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framesthb_shift                        (0)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framemthb_mask                         (0xFF000000)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framehthb_mask                         (0x00FF0000)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framerlvthb_mask                       (0x0000FF00)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framesthb_mask                         (0x000000FF)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framemthb(data)                        (0xFF000000&((data)<<24))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framehthb(data)                        (0x00FF0000&((data)<<16))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framerlvthb(data)                      (0x0000FF00&((data)<<8))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_ma_framesthb(data)                        (0x000000FF&(data))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_get_ma_framemthb(data)                    ((0xFF000000&(data))>>24)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_get_ma_framehthb(data)                    ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_get_ma_framerlvthb(data)                  ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_B_get_ma_framesthb(data)                    (0x000000FF&(data))

#define  DI_IM_DI_MA_FRAME_MOTION_TH_C                                          0x18024088
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_reg_addr                                  "0xB8024088"
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_reg                                       0xB8024088
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_inst_addr                                 "0x001D"
#define  set_DI_IM_DI_MA_FRAME_MOTION_TH_C_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_MA_FRAME_MOTION_TH_C_reg)=data)
#define  get_DI_IM_DI_MA_FRAME_MOTION_TH_C_reg                                   (*((volatile unsigned int*)DI_IM_DI_MA_FRAME_MOTION_TH_C_reg))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framemthc_shift                        (24)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framehthc_shift                        (16)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framerlvthc_shift                      (8)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framesthc_shift                        (0)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framemthc_mask                         (0xFF000000)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framehthc_mask                         (0x00FF0000)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framerlvthc_mask                       (0x0000FF00)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framesthc_mask                         (0x000000FF)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framemthc(data)                        (0xFF000000&((data)<<24))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framehthc(data)                        (0x00FF0000&((data)<<16))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framerlvthc(data)                      (0x0000FF00&((data)<<8))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_ma_framesthc(data)                        (0x000000FF&(data))
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_get_ma_framemthc(data)                    ((0xFF000000&(data))>>24)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_get_ma_framehthc(data)                    ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_get_ma_framerlvthc(data)                  ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_MA_FRAME_MOTION_TH_C_get_ma_framesthc(data)                    (0x000000FF&(data))

#define  DI_IM_DI_MA_FIELD_TEETH_TH_A                                           0x1802408C
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_reg_addr                                   "0xB802408C"
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_reg                                        0xB802408C
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_inst_addr                                  "0x001E"
#define  set_DI_IM_DI_MA_FIELD_TEETH_TH_A_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_MA_FIELD_TEETH_TH_A_reg)=data)
#define  get_DI_IM_DI_MA_FIELD_TEETH_TH_A_reg                                    (*((volatile unsigned int*)DI_IM_DI_MA_FIELD_TEETH_TH_A_reg))
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethstha_shift                    (24)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethmtha_shift                    (16)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethhtha_shift                    (8)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethrlvtha_shift                  (0)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethstha_mask                     (0xFF000000)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethmtha_mask                     (0x00FF0000)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethhtha_mask                     (0x0000FF00)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethrlvtha_mask                   (0x000000FF)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethstha(data)                    (0xFF000000&((data)<<24))
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethmtha(data)                    (0x00FF0000&((data)<<16))
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethhtha(data)                    (0x0000FF00&((data)<<8))
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_ma_fieldteethrlvtha(data)                  (0x000000FF&(data))
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_get_ma_fieldteethstha(data)                ((0xFF000000&(data))>>24)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_get_ma_fieldteethmtha(data)                ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_get_ma_fieldteethhtha(data)                ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_MA_FIELD_TEETH_TH_A_get_ma_fieldteethrlvtha(data)              (0x000000FF&(data))

#define  DI_IM_DI_MA_OTHERS_TH                                                  0x18024090
#define  DI_IM_DI_MA_OTHERS_TH_reg_addr                                          "0xB8024090"
#define  DI_IM_DI_MA_OTHERS_TH_reg                                               0xB8024090
#define  DI_IM_DI_MA_OTHERS_TH_inst_addr                                         "0x001F"
#define  set_DI_IM_DI_MA_OTHERS_TH_reg(data)                                     (*((volatile unsigned int*)DI_IM_DI_MA_OTHERS_TH_reg)=data)
#define  get_DI_IM_DI_MA_OTHERS_TH_reg                                           (*((volatile unsigned int*)DI_IM_DI_MA_OTHERS_TH_reg))
#define  DI_IM_DI_MA_OTHERS_TH_ma_horicomth_shift                                (24)
#define  DI_IM_DI_MA_OTHERS_TH_ma_ydiffth_shift                                  (8)
#define  DI_IM_DI_MA_OTHERS_TH_ma_fieldteeththb_shift                            (0)
#define  DI_IM_DI_MA_OTHERS_TH_ma_horicomth_mask                                 (0xFF000000)
#define  DI_IM_DI_MA_OTHERS_TH_ma_ydiffth_mask                                   (0x0000FF00)
#define  DI_IM_DI_MA_OTHERS_TH_ma_fieldteeththb_mask                             (0x000000FF)
#define  DI_IM_DI_MA_OTHERS_TH_ma_horicomth(data)                                (0xFF000000&((data)<<24))
#define  DI_IM_DI_MA_OTHERS_TH_ma_ydiffth(data)                                  (0x0000FF00&((data)<<8))
#define  DI_IM_DI_MA_OTHERS_TH_ma_fieldteeththb(data)                            (0x000000FF&(data))
#define  DI_IM_DI_MA_OTHERS_TH_get_ma_horicomth(data)                            ((0xFF000000&(data))>>24)
#define  DI_IM_DI_MA_OTHERS_TH_get_ma_ydiffth(data)                              ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_MA_OTHERS_TH_get_ma_fieldteeththb(data)                        (0x000000FF&(data))

#define  DI_IM_DI_MA_SAWTOOTH_TH                                                0x18024094
#define  DI_IM_DI_MA_SAWTOOTH_TH_reg_addr                                        "0xB8024094"
#define  DI_IM_DI_MA_SAWTOOTH_TH_reg                                             0xB8024094
#define  DI_IM_DI_MA_SAWTOOTH_TH_inst_addr                                       "0x0020"
#define  set_DI_IM_DI_MA_SAWTOOTH_TH_reg(data)                                   (*((volatile unsigned int*)DI_IM_DI_MA_SAWTOOTH_TH_reg)=data)
#define  get_DI_IM_DI_MA_SAWTOOTH_TH_reg                                         (*((volatile unsigned int*)DI_IM_DI_MA_SAWTOOTH_TH_reg))
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothmth_shift                            (24)
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothhth_shift                            (16)
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothrlvth_shift                          (8)
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothsth_shift                            (0)
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothmth_mask                             (0xFF000000)
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothhth_mask                             (0x00FF0000)
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothrlvth_mask                           (0x0000FF00)
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothsth_mask                             (0x000000FF)
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothmth(data)                            (0xFF000000&((data)<<24))
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothhth(data)                            (0x00FF0000&((data)<<16))
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothrlvth(data)                          (0x0000FF00&((data)<<8))
#define  DI_IM_DI_MA_SAWTOOTH_TH_ma_sawtoothsth(data)                            (0x000000FF&(data))
#define  DI_IM_DI_MA_SAWTOOTH_TH_get_ma_sawtoothmth(data)                        ((0xFF000000&(data))>>24)
#define  DI_IM_DI_MA_SAWTOOTH_TH_get_ma_sawtoothhth(data)                        ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_MA_SAWTOOTH_TH_get_ma_sawtoothrlvth(data)                      ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_MA_SAWTOOTH_TH_get_ma_sawtoothsth(data)                        (0x000000FF&(data))

#define  DI_IM_DI_FILM_TEETH                                                    0x18024098
#define  DI_IM_DI_FILM_TEETH_reg_addr                                            "0xB8024098"
#define  DI_IM_DI_FILM_TEETH_reg                                                 0xB8024098
#define  DI_IM_DI_FILM_TEETH_inst_addr                                           "0x0021"
#define  set_DI_IM_DI_FILM_TEETH_reg(data)                                       (*((volatile unsigned int*)DI_IM_DI_FILM_TEETH_reg)=data)
#define  get_DI_IM_DI_FILM_TEETH_reg                                             (*((volatile unsigned int*)DI_IM_DI_FILM_TEETH_reg))
#define  DI_IM_DI_FILM_TEETH_film_teethth_en_shift                               (30)
#define  DI_IM_DI_FILM_TEETH_film_teethth_ratio_shift                            (24)
#define  DI_IM_DI_FILM_TEETH_film_teethth_prog_lb_shift                          (16)
#define  DI_IM_DI_FILM_TEETH_film_teethth_moving_lb_shift                        (8)
#define  DI_IM_DI_FILM_TEETH_film_teethth_teeth_lb_shift                         (0)
#define  DI_IM_DI_FILM_TEETH_film_teethth_en_mask                                (0xC0000000)
#define  DI_IM_DI_FILM_TEETH_film_teethth_ratio_mask                             (0x3F000000)
#define  DI_IM_DI_FILM_TEETH_film_teethth_prog_lb_mask                           (0x00FF0000)
#define  DI_IM_DI_FILM_TEETH_film_teethth_moving_lb_mask                         (0x0000FF00)
#define  DI_IM_DI_FILM_TEETH_film_teethth_teeth_lb_mask                          (0x000000FF)
#define  DI_IM_DI_FILM_TEETH_film_teethth_en(data)                               (0xC0000000&((data)<<30))
#define  DI_IM_DI_FILM_TEETH_film_teethth_ratio(data)                            (0x3F000000&((data)<<24))
#define  DI_IM_DI_FILM_TEETH_film_teethth_prog_lb(data)                          (0x00FF0000&((data)<<16))
#define  DI_IM_DI_FILM_TEETH_film_teethth_moving_lb(data)                        (0x0000FF00&((data)<<8))
#define  DI_IM_DI_FILM_TEETH_film_teethth_teeth_lb(data)                         (0x000000FF&(data))
#define  DI_IM_DI_FILM_TEETH_get_film_teethth_en(data)                           ((0xC0000000&(data))>>30)
#define  DI_IM_DI_FILM_TEETH_get_film_teethth_ratio(data)                        ((0x3F000000&(data))>>24)
#define  DI_IM_DI_FILM_TEETH_get_film_teethth_prog_lb(data)                      ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_FILM_TEETH_get_film_teethth_moving_lb(data)                    ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_FILM_TEETH_get_film_teethth_teeth_lb(data)                     (0x000000FF&(data))

#define  DI_IM_DI_MA_VERTEXT_TH_B                                               0x1802409C
#define  DI_IM_DI_MA_VERTEXT_TH_B_reg_addr                                       "0xB802409C"
#define  DI_IM_DI_MA_VERTEXT_TH_B_reg                                            0xB802409C
#define  DI_IM_DI_MA_VERTEXT_TH_B_inst_addr                                      "0x0022"
#define  set_DI_IM_DI_MA_VERTEXT_TH_B_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_MA_VERTEXT_TH_B_reg)=data)
#define  get_DI_IM_DI_MA_VERTEXT_TH_B_reg                                        (*((volatile unsigned int*)DI_IM_DI_MA_VERTEXT_TH_B_reg))
#define  DI_IM_DI_MA_VERTEXT_TH_B_forfw_1_shift                                  (0)
#define  DI_IM_DI_MA_VERTEXT_TH_B_forfw_1_mask                                   (0xFFFFFFFF)
#define  DI_IM_DI_MA_VERTEXT_TH_B_forfw_1(data)                                  (0xFFFFFFFF&(data))
#define  DI_IM_DI_MA_VERTEXT_TH_B_get_forfw_1(data)                              (0xFFFFFFFF&(data))

#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH                                    0x180240A0
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_reg_addr                            "0xB80240A0"
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_reg                                 0xB80240A0
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_inst_addr                           "0x0023"
#define  set_DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_reg)=data)
#define  get_DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_reg                             (*((volatile unsigned int*)DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_reg))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_leavequick_en_shift            (31)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_verscrollingtext_en_shift      (30)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_thumbnail_en_shift             (29)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_pair1_en_shift                 (28)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_pair2_en_shift                 (27)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_pair_en_auto_shift             (26)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_violate_strict_en_shift        (25)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film22_sawtooththl_shift            (16)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_sawtooththl_shift              (8)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_frmotionthl_shift              (0)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_leavequick_en_mask             (0x80000000)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_verscrollingtext_en_mask       (0x40000000)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_thumbnail_en_mask              (0x20000000)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_pair1_en_mask                  (0x10000000)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_pair2_en_mask                  (0x08000000)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_pair_en_auto_mask              (0x04000000)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_violate_strict_en_mask         (0x02000000)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film22_sawtooththl_mask             (0x00FF0000)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_sawtooththl_mask               (0x0000FF00)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_frmotionthl_mask               (0x000000FF)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_leavequick_en(data)            (0x80000000&((data)<<31))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_verscrollingtext_en(data)      (0x40000000&((data)<<30))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_thumbnail_en(data)             (0x20000000&((data)<<29))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_pair1_en(data)                 (0x10000000&((data)<<28))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_pair2_en(data)                 (0x08000000&((data)<<27))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_pair_en_auto(data)             (0x04000000&((data)<<26))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_violate_strict_en(data)        (0x02000000&((data)<<25))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film22_sawtooththl(data)            (0x00FF0000&((data)<<16))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_sawtooththl(data)              (0x0000FF00&((data)<<8))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_film_frmotionthl(data)              (0x000000FF&(data))
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_get_film_leavequick_en(data)        ((0x80000000&(data))>>31)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_get_film_verscrollingtext_en(data)  ((0x40000000&(data))>>30)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_get_film_thumbnail_en(data)         ((0x20000000&(data))>>29)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_get_film_pair1_en(data)             ((0x10000000&(data))>>28)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_get_film_pair2_en(data)             ((0x08000000&(data))>>27)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_get_film_pair_en_auto(data)         ((0x04000000&(data))>>26)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_get_film_violate_strict_en(data)    ((0x02000000&(data))>>25)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_get_film22_sawtooththl(data)        ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_get_film_sawtooththl(data)          ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_FILM_SAWTOOTH_FILMFRAME_TH_get_film_frmotionthl(data)          (0x000000FF&(data))

#define  DI_IM_DI_FILM_STATIC_SUM_TH                                            0x180240A4
#define  DI_IM_DI_FILM_STATIC_SUM_TH_reg_addr                                    "0xB80240A4"
#define  DI_IM_DI_FILM_STATIC_SUM_TH_reg                                         0xB80240A4
#define  DI_IM_DI_FILM_STATIC_SUM_TH_inst_addr                                   "0x0024"
#define  set_DI_IM_DI_FILM_STATIC_SUM_TH_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_FILM_STATIC_SUM_TH_reg)=data)
#define  get_DI_IM_DI_FILM_STATIC_SUM_TH_reg                                     (*((volatile unsigned int*)DI_IM_DI_FILM_STATIC_SUM_TH_reg))
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film_fieldmotionsumthl_shift                (24)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film22_fistaticsthl_shift                   (16)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film_frstaticsthl_shift                     (8)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film_fistaticsthl_shift                     (0)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film_fieldmotionsumthl_mask                 (0xFF000000)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film22_fistaticsthl_mask                    (0x00FF0000)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film_frstaticsthl_mask                      (0x0000FF00)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film_fistaticsthl_mask                      (0x000000FF)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film_fieldmotionsumthl(data)                (0xFF000000&((data)<<24))
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film22_fistaticsthl(data)                   (0x00FF0000&((data)<<16))
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film_frstaticsthl(data)                     (0x0000FF00&((data)<<8))
#define  DI_IM_DI_FILM_STATIC_SUM_TH_film_fistaticsthl(data)                     (0x000000FF&(data))
#define  DI_IM_DI_FILM_STATIC_SUM_TH_get_film_fieldmotionsumthl(data)            ((0xFF000000&(data))>>24)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_get_film22_fistaticsthl(data)               ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_get_film_frstaticsthl(data)                 ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_FILM_STATIC_SUM_TH_get_film_fistaticsthl(data)                 (0x000000FF&(data))

#define  DI_IM_DI_FILM_FIELD_JUDGE_TH                                           0x180240A8
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_reg_addr                                   "0xB80240A8"
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_reg                                        0xB80240A8
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_inst_addr                                  "0x0025"
#define  set_DI_IM_DI_FILM_FIELD_JUDGE_TH_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_FILM_FIELD_JUDGE_TH_reg)=data)
#define  get_DI_IM_DI_FILM_FIELD_JUDGE_TH_reg                                    (*((volatile unsigned int*)DI_IM_DI_FILM_FIELD_JUDGE_TH_reg))
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_pairratio_all1_shift                  (28)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_pairratio_all2_shift                  (24)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_fiminsthl_shift                       (16)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_fimaxsthl_shift                       (0)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_pairratio_all1_mask                   (0xF0000000)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_pairratio_all2_mask                   (0x0F000000)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_fiminsthl_mask                        (0x00FF0000)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_fimaxsthl_mask                        (0x0000FFFF)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_pairratio_all1(data)                  (0xF0000000&((data)<<28))
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_pairratio_all2(data)                  (0x0F000000&((data)<<24))
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_fiminsthl(data)                       (0x00FF0000&((data)<<16))
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_film_fimaxsthl(data)                       (0x0000FFFF&(data))
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_get_film_pairratio_all1(data)              ((0xF0000000&(data))>>28)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_get_film_pairratio_all2(data)              ((0x0F000000&(data))>>24)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_get_film_fiminsthl(data)                   ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_FILM_FIELD_JUDGE_TH_get_film_fimaxsthl(data)                   (0x0000FFFF&(data))

#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH                                        0x180240AC
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_reg_addr                                "0xB80240AC"
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_reg                                     0xB80240AC
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_inst_addr                               "0x0026"
#define  set_DI_IM_DI_FILM_STATIC_SUM_SUB_TH_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_FILM_STATIC_SUM_SUB_TH_reg)=data)
#define  get_DI_IM_DI_FILM_STATIC_SUM_SUB_TH_reg                                 (*((volatile unsigned int*)DI_IM_DI_FILM_STATIC_SUM_SUB_TH_reg))
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film_subfieldmotionsumthl_shift         (24)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film22_subfistaticsthl_shift            (16)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film_subfrstaticsthl_shift              (8)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film_subfistaticsthl_shift              (0)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film_subfieldmotionsumthl_mask          (0xFF000000)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film22_subfistaticsthl_mask             (0x00FF0000)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film_subfrstaticsthl_mask               (0x0000FF00)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film_subfistaticsthl_mask               (0x000000FF)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film_subfieldmotionsumthl(data)         (0xFF000000&((data)<<24))
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film22_subfistaticsthl(data)            (0x00FF0000&((data)<<16))
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film_subfrstaticsthl(data)              (0x0000FF00&((data)<<8))
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_film_subfistaticsthl(data)              (0x000000FF&(data))
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_get_film_subfieldmotionsumthl(data)     ((0xFF000000&(data))>>24)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_get_film22_subfistaticsthl(data)        ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_get_film_subfrstaticsthl(data)          ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_FILM_STATIC_SUM_SUB_TH_get_film_subfistaticsthl(data)          (0x000000FF&(data))

#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH                                       0x180240B0
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_reg_addr                               "0xB80240B0"
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_reg                                    0xB80240B0
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_inst_addr                              "0x0027"
#define  set_DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_reg)=data)
#define  get_DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_reg                                (*((volatile unsigned int*)DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_reg))
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_pairratio_sub1_shift              (28)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_pairratio_sub2_shift              (24)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_subfiminsthl_shift                (16)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_subfimaxsthl_shift                (0)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_pairratio_sub1_mask               (0xF0000000)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_pairratio_sub2_mask               (0x0F000000)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_subfiminsthl_mask                 (0x00FF0000)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_subfimaxsthl_mask                 (0x0000FFFF)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_pairratio_sub1(data)              (0xF0000000&((data)<<28))
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_pairratio_sub2(data)              (0x0F000000&((data)<<24))
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_subfiminsthl(data)                (0x00FF0000&((data)<<16))
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_film_subfimaxsthl(data)                (0x0000FFFF&(data))
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_get_film_pairratio_sub1(data)          ((0xF0000000&(data))>>28)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_get_film_pairratio_sub2(data)          ((0x0F000000&(data))>>24)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_get_film_subfiminsthl(data)            ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_FILM_FIELD_JUDGE_SUB_TH_get_film_subfimaxsthl(data)            (0x0000FFFF&(data))

#define  DI_IM_DI_FILM_MOTION_SUM_TH                                            0x180240B4
#define  DI_IM_DI_FILM_MOTION_SUM_TH_reg_addr                                    "0xB80240B4"
#define  DI_IM_DI_FILM_MOTION_SUM_TH_reg                                         0xB80240B4
#define  DI_IM_DI_FILM_MOTION_SUM_TH_inst_addr                                   "0x0028"
#define  set_DI_IM_DI_FILM_MOTION_SUM_TH_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_FILM_MOTION_SUM_TH_reg)=data)
#define  get_DI_IM_DI_FILM_MOTION_SUM_TH_reg                                     (*((volatile unsigned int*)DI_IM_DI_FILM_MOTION_SUM_TH_reg))
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_debounce_fieldnum_shift              (28)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film32_debounce_fieldnum_shift              (24)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_dummy_23_19_shift                           (19)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_filter_andor_shift                   (18)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film_sawtooth_choose_shift                  (16)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_subfieldmotionsumthl_shift           (8)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_fieldmotionsumthl_shift              (0)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_debounce_fieldnum_mask               (0xF0000000)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film32_debounce_fieldnum_mask               (0x0F000000)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_dummy_23_19_mask                            (0x00F80000)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_filter_andor_mask                    (0x00040000)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film_sawtooth_choose_mask                   (0x00030000)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_subfieldmotionsumthl_mask            (0x0000FF00)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_fieldmotionsumthl_mask               (0x000000FF)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_debounce_fieldnum(data)              (0xF0000000&((data)<<28))
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film32_debounce_fieldnum(data)              (0x0F000000&((data)<<24))
#define  DI_IM_DI_FILM_MOTION_SUM_TH_dummy_23_19(data)                           (0x00F80000&((data)<<19))
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_filter_andor(data)                   (0x00040000&((data)<<18))
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film_sawtooth_choose(data)                  (0x00030000&((data)<<16))
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_subfieldmotionsumthl(data)           (0x0000FF00&((data)<<8))
#define  DI_IM_DI_FILM_MOTION_SUM_TH_film22_fieldmotionsumthl(data)              (0x000000FF&(data))
#define  DI_IM_DI_FILM_MOTION_SUM_TH_get_film22_debounce_fieldnum(data)          ((0xF0000000&(data))>>28)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_get_film32_debounce_fieldnum(data)          ((0x0F000000&(data))>>24)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_get_dummy_23_19(data)                       ((0x00F80000&(data))>>19)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_get_film22_filter_andor(data)               ((0x00040000&(data))>>18)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_get_film_sawtooth_choose(data)              ((0x00030000&(data))>>16)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_get_film22_subfieldmotionsumthl(data)       ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_FILM_MOTION_SUM_TH_get_film22_fieldmotionsumthl(data)          (0x000000FF&(data))

#define  DI_IM_DI_SI_FILM_BOUND                                                 0x180240B8
#define  DI_IM_DI_SI_FILM_BOUND_reg_addr                                         "0xB80240B8"
#define  DI_IM_DI_SI_FILM_BOUND_reg                                              0xB80240B8
#define  DI_IM_DI_SI_FILM_BOUND_inst_addr                                        "0x0029"
#define  set_DI_IM_DI_SI_FILM_BOUND_reg(data)                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_BOUND_reg)=data)
#define  get_DI_IM_DI_SI_FILM_BOUND_reg                                          (*((volatile unsigned int*)DI_IM_DI_SI_FILM_BOUND_reg))
#define  DI_IM_DI_SI_FILM_BOUND_film22_quick_decision_en_shift                   (30)
#define  DI_IM_DI_SI_FILM_BOUND_film_bot_margin_shift                            (4)
#define  DI_IM_DI_SI_FILM_BOUND_film_top_margin_shift                            (0)
#define  DI_IM_DI_SI_FILM_BOUND_film22_quick_decision_en_mask                    (0xC0000000)
#define  DI_IM_DI_SI_FILM_BOUND_film_bot_margin_mask                             (0x000000F0)
#define  DI_IM_DI_SI_FILM_BOUND_film_top_margin_mask                             (0x0000000F)
#define  DI_IM_DI_SI_FILM_BOUND_film22_quick_decision_en(data)                   (0xC0000000&((data)<<30))
#define  DI_IM_DI_SI_FILM_BOUND_film_bot_margin(data)                            (0x000000F0&((data)<<4))
#define  DI_IM_DI_SI_FILM_BOUND_film_top_margin(data)                            (0x0000000F&(data))
#define  DI_IM_DI_SI_FILM_BOUND_get_film22_quick_decision_en(data)               ((0xC0000000&(data))>>30)
#define  DI_IM_DI_SI_FILM_BOUND_get_film_bot_margin(data)                        ((0x000000F0&(data))>>4)
#define  DI_IM_DI_SI_FILM_BOUND_get_film_top_margin(data)                        (0x0000000F&(data))

#define  DI_FILM_DUMMY_1                                                        0x180240BC
#define  DI_FILM_DUMMY_1_reg_addr                                                "0xB80240BC"
#define  DI_FILM_DUMMY_1_reg                                                     0xB80240BC
#define  DI_FILM_DUMMY_1_inst_addr                                               "0x002A"
#define  set_DI_FILM_DUMMY_1_reg(data)                                           (*((volatile unsigned int*)DI_FILM_DUMMY_1_reg)=data)
#define  get_DI_FILM_DUMMY_1_reg                                                 (*((volatile unsigned int*)DI_FILM_DUMMY_1_reg))
#define  DI_FILM_DUMMY_1_forfw_2_shift                                           (0)
#define  DI_FILM_DUMMY_1_forfw_2_mask                                            (0xFFFFFFFF)
#define  DI_FILM_DUMMY_1_forfw_2(data)                                           (0xFFFFFFFF&(data))
#define  DI_FILM_DUMMY_1_get_forfw_2(data)                                       (0xFFFFFFFF&(data))

#define  DI_IM_DI_SI_FILM_HB_COUT                                               0x180240C0
#define  DI_IM_DI_SI_FILM_HB_COUT_reg_addr                                       "0xB80240C0"
#define  DI_IM_DI_SI_FILM_HB_COUT_reg                                            0xB80240C0
#define  DI_IM_DI_SI_FILM_HB_COUT_inst_addr                                      "0x002B"
#define  set_DI_IM_DI_SI_FILM_HB_COUT_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_SI_FILM_HB_COUT_reg)=data)
#define  get_DI_IM_DI_SI_FILM_HB_COUT_reg                                        (*((volatile unsigned int*)DI_IM_DI_SI_FILM_HB_COUT_reg))
#define  DI_IM_DI_SI_FILM_HB_COUT_film_hifreq_thl_shift                          (16)
#define  DI_IM_DI_SI_FILM_HB_COUT_film_hifreq_cnt_thl_shift                      (12)
#define  DI_IM_DI_SI_FILM_HB_COUT_film_3d_mode_shift                             (10)
#define  DI_IM_DI_SI_FILM_HB_COUT_film_motionstatus_choose_shift                 (8)
#define  DI_IM_DI_SI_FILM_HB_COUT_film_hbcounter_shift                           (0)
#define  DI_IM_DI_SI_FILM_HB_COUT_film_hifreq_thl_mask                           (0xFFFF0000)
#define  DI_IM_DI_SI_FILM_HB_COUT_film_hifreq_cnt_thl_mask                       (0x0000F000)
#define  DI_IM_DI_SI_FILM_HB_COUT_film_3d_mode_mask                              (0x00000C00)
#define  DI_IM_DI_SI_FILM_HB_COUT_film_motionstatus_choose_mask                  (0x00000100)
#define  DI_IM_DI_SI_FILM_HB_COUT_film_hbcounter_mask                            (0x000000FF)
#define  DI_IM_DI_SI_FILM_HB_COUT_film_hifreq_thl(data)                          (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_SI_FILM_HB_COUT_film_hifreq_cnt_thl(data)                      (0x0000F000&((data)<<12))
#define  DI_IM_DI_SI_FILM_HB_COUT_film_3d_mode(data)                             (0x00000C00&((data)<<10))
#define  DI_IM_DI_SI_FILM_HB_COUT_film_motionstatus_choose(data)                 (0x00000100&((data)<<8))
#define  DI_IM_DI_SI_FILM_HB_COUT_film_hbcounter(data)                           (0x000000FF&(data))
#define  DI_IM_DI_SI_FILM_HB_COUT_get_film_hifreq_thl(data)                      ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_SI_FILM_HB_COUT_get_film_hifreq_cnt_thl(data)                  ((0x0000F000&(data))>>12)
#define  DI_IM_DI_SI_FILM_HB_COUT_get_film_3d_mode(data)                         ((0x00000C00&(data))>>10)
#define  DI_IM_DI_SI_FILM_HB_COUT_get_film_motionstatus_choose(data)             ((0x00000100&(data))>>8)
#define  DI_IM_DI_SI_FILM_HB_COUT_get_film_hbcounter(data)                       (0x000000FF&(data))

#define  DI_IM_DI_SI_FILM_FINAL_RESULT                                          0x180240C4
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_reg_addr                                  "0xB80240C4"
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_reg                                       0xB80240C4
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_inst_addr                                 "0x002C"
#define  set_DI_IM_DI_SI_FILM_FINAL_RESULT_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_SI_FILM_FINAL_RESULT_reg)=data)
#define  get_DI_IM_DI_SI_FILM_FINAL_RESULT_reg                                   (*((volatile unsigned int*)DI_IM_DI_SI_FILM_FINAL_RESULT_reg))
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_dummy_31_10_shift                         (10)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_top_field_shift                           (9)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_hifreq_flag_shift                    (8)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_detected_shift                       (7)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_subdetected_shift                    (6)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_confuse_shift                        (5)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_sequence_shift                       (0)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_dummy_31_10_mask                          (0xFFFFFC00)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_top_field_mask                            (0x00000200)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_hifreq_flag_mask                     (0x00000100)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_detected_mask                        (0x00000080)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_subdetected_mask                     (0x00000040)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_confuse_mask                         (0x00000020)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_sequence_mask                        (0x0000001F)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_dummy_31_10(data)                         (0xFFFFFC00&((data)<<10))
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_top_field(data)                           (0x00000200&((data)<<9))
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_hifreq_flag(data)                    (0x00000100&((data)<<8))
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_detected(data)                       (0x00000080&((data)<<7))
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_subdetected(data)                    (0x00000040&((data)<<6))
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_confuse(data)                        (0x00000020&((data)<<5))
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_film_sequence(data)                       (0x0000001F&(data))
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_get_dummy_31_10(data)                     ((0xFFFFFC00&(data))>>10)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_get_top_field(data)                       ((0x00000200&(data))>>9)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_get_film_hifreq_flag(data)                ((0x00000100&(data))>>8)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_get_film_detected(data)                   ((0x00000080&(data))>>7)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_get_film_subdetected(data)                ((0x00000040&(data))>>6)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_get_film_confuse(data)                    ((0x00000020&(data))>>5)
#define  DI_IM_DI_SI_FILM_FINAL_RESULT_get_film_sequence(data)                   (0x0000001F&(data))

#define  DI_IM_DI_SI_FILM_PATTERN_A                                             0x180240C8
#define  DI_IM_DI_SI_FILM_PATTERN_A_reg_addr                                     "0xB80240C8"
#define  DI_IM_DI_SI_FILM_PATTERN_A_reg                                          0xB80240C8
#define  DI_IM_DI_SI_FILM_PATTERN_A_inst_addr                                    "0x002D"
#define  set_DI_IM_DI_SI_FILM_PATTERN_A_reg(data)                                (*((volatile unsigned int*)DI_IM_DI_SI_FILM_PATTERN_A_reg)=data)
#define  get_DI_IM_DI_SI_FILM_PATTERN_A_reg                                      (*((volatile unsigned int*)DI_IM_DI_SI_FILM_PATTERN_A_reg))
#define  DI_IM_DI_SI_FILM_PATTERN_A_film_framestatic_shift                       (24)
#define  DI_IM_DI_SI_FILM_PATTERN_A_film_framepair_shift                         (8)
#define  DI_IM_DI_SI_FILM_PATTERN_A_film_prefistatic1_shift                      (0)
#define  DI_IM_DI_SI_FILM_PATTERN_A_film_framestatic_mask                        (0xFF000000)
#define  DI_IM_DI_SI_FILM_PATTERN_A_film_framepair_mask                          (0x00FFFF00)
#define  DI_IM_DI_SI_FILM_PATTERN_A_film_prefistatic1_mask                       (0x000000FF)
#define  DI_IM_DI_SI_FILM_PATTERN_A_film_framestatic(data)                       (0xFF000000&((data)<<24))
#define  DI_IM_DI_SI_FILM_PATTERN_A_film_framepair(data)                         (0x00FFFF00&((data)<<8))
#define  DI_IM_DI_SI_FILM_PATTERN_A_film_prefistatic1(data)                      (0x000000FF&(data))
#define  DI_IM_DI_SI_FILM_PATTERN_A_get_film_framestatic(data)                   ((0xFF000000&(data))>>24)
#define  DI_IM_DI_SI_FILM_PATTERN_A_get_film_framepair(data)                     ((0x00FFFF00&(data))>>8)
#define  DI_IM_DI_SI_FILM_PATTERN_A_get_film_prefistatic1(data)                  (0x000000FF&(data))

#define  DI_IM_DI_SI_FILM_PATTERN_B                                             0x180240CC
#define  DI_IM_DI_SI_FILM_PATTERN_B_reg_addr                                     "0xB80240CC"
#define  DI_IM_DI_SI_FILM_PATTERN_B_reg                                          0xB80240CC
#define  DI_IM_DI_SI_FILM_PATTERN_B_inst_addr                                    "0x002E"
#define  set_DI_IM_DI_SI_FILM_PATTERN_B_reg(data)                                (*((volatile unsigned int*)DI_IM_DI_SI_FILM_PATTERN_B_reg)=data)
#define  get_DI_IM_DI_SI_FILM_PATTERN_B_reg                                      (*((volatile unsigned int*)DI_IM_DI_SI_FILM_PATTERN_B_reg))
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_nxtfistatic1_shift                      (24)
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_prefistatic2_shift                      (16)
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_nxtfistatic2_shift                      (8)
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_nxtfimotion_shift                       (0)
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_nxtfistatic1_mask                       (0xFF000000)
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_prefistatic2_mask                       (0x00FF0000)
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_nxtfistatic2_mask                       (0x0000FF00)
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_nxtfimotion_mask                        (0x000000FF)
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_nxtfistatic1(data)                      (0xFF000000&((data)<<24))
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_prefistatic2(data)                      (0x00FF0000&((data)<<16))
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_nxtfistatic2(data)                      (0x0000FF00&((data)<<8))
#define  DI_IM_DI_SI_FILM_PATTERN_B_film_nxtfimotion(data)                       (0x000000FF&(data))
#define  DI_IM_DI_SI_FILM_PATTERN_B_get_film_nxtfistatic1(data)                  ((0xFF000000&(data))>>24)
#define  DI_IM_DI_SI_FILM_PATTERN_B_get_film_prefistatic2(data)                  ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_SI_FILM_PATTERN_B_get_film_nxtfistatic2(data)                  ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_SI_FILM_PATTERN_B_get_film_nxtfimotion(data)                   (0x000000FF&(data))

#define  DI_IM_DI_SI_FILM_32_RESULT_1_A                                         0x180240D0
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_reg_addr                                 "0xB80240D0"
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_reg                                      0xB80240D0
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_inst_addr                                "0x002F"
#define  set_DI_IM_DI_SI_FILM_32_RESULT_1_A_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_SI_FILM_32_RESULT_1_A_reg)=data)
#define  get_DI_IM_DI_SI_FILM_32_RESULT_1_A_reg                                  (*((volatile unsigned int*)DI_IM_DI_SI_FILM_32_RESULT_1_A_reg))
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_detected321_shift                   (24)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_match321_shift                      (16)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_violate321_shift                    (8)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_sequence321_39_32_shift             (0)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_detected321_mask                    (0xFF000000)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_match321_mask                       (0x00FF0000)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_violate321_mask                     (0x0000FF00)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_sequence321_39_32_mask              (0x000000FF)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_detected321(data)                   (0xFF000000&((data)<<24))
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_match321(data)                      (0x00FF0000&((data)<<16))
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_violate321(data)                    (0x0000FF00&((data)<<8))
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_film_sequence321_39_32(data)             (0x000000FF&(data))
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_get_film_detected321(data)               ((0xFF000000&(data))>>24)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_get_film_match321(data)                  ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_get_film_violate321(data)                ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_A_get_film_sequence321_39_32(data)         (0x000000FF&(data))

#define  DI_IM_DI_SI_FILM_32_RESULT_1_B                                         0x180240D4
#define  DI_IM_DI_SI_FILM_32_RESULT_1_B_reg_addr                                 "0xB80240D4"
#define  DI_IM_DI_SI_FILM_32_RESULT_1_B_reg                                      0xB80240D4
#define  DI_IM_DI_SI_FILM_32_RESULT_1_B_inst_addr                                "0x0030"
#define  set_DI_IM_DI_SI_FILM_32_RESULT_1_B_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_SI_FILM_32_RESULT_1_B_reg)=data)
#define  get_DI_IM_DI_SI_FILM_32_RESULT_1_B_reg                                  (*((volatile unsigned int*)DI_IM_DI_SI_FILM_32_RESULT_1_B_reg))
#define  DI_IM_DI_SI_FILM_32_RESULT_1_B_film_sequence321_31_0_shift              (0)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_B_film_sequence321_31_0_mask               (0xFFFFFFFF)
#define  DI_IM_DI_SI_FILM_32_RESULT_1_B_film_sequence321_31_0(data)              (0xFFFFFFFF&(data))
#define  DI_IM_DI_SI_FILM_32_RESULT_1_B_get_film_sequence321_31_0(data)          (0xFFFFFFFF&(data))

#define  DI_IM_DI_SI_FILM_32_RESULT_2_A                                         0x180240D8
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_reg_addr                                 "0xB80240D8"
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_reg                                      0xB80240D8
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_inst_addr                                "0x0031"
#define  set_DI_IM_DI_SI_FILM_32_RESULT_2_A_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_SI_FILM_32_RESULT_2_A_reg)=data)
#define  get_DI_IM_DI_SI_FILM_32_RESULT_2_A_reg                                  (*((volatile unsigned int*)DI_IM_DI_SI_FILM_32_RESULT_2_A_reg))
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_detected322_shift                   (24)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_match322_shift                      (16)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_violate322_shift                    (8)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_sequence322_39_32_shift             (0)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_detected322_mask                    (0xFF000000)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_match322_mask                       (0x00FF0000)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_violate322_mask                     (0x0000FF00)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_sequence322_39_32_mask              (0x000000FF)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_detected322(data)                   (0xFF000000&((data)<<24))
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_match322(data)                      (0x00FF0000&((data)<<16))
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_violate322(data)                    (0x0000FF00&((data)<<8))
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_film_sequence322_39_32(data)             (0x000000FF&(data))
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_get_film_detected322(data)               ((0xFF000000&(data))>>24)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_get_film_match322(data)                  ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_get_film_violate322(data)                ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_A_get_film_sequence322_39_32(data)         (0x000000FF&(data))

#define  DI_IM_DI_SI_FILM_32_RESULT_2_B                                         0x180240DC
#define  DI_IM_DI_SI_FILM_32_RESULT_2_B_reg_addr                                 "0xB80240DC"
#define  DI_IM_DI_SI_FILM_32_RESULT_2_B_reg                                      0xB80240DC
#define  DI_IM_DI_SI_FILM_32_RESULT_2_B_inst_addr                                "0x0032"
#define  set_DI_IM_DI_SI_FILM_32_RESULT_2_B_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_SI_FILM_32_RESULT_2_B_reg)=data)
#define  get_DI_IM_DI_SI_FILM_32_RESULT_2_B_reg                                  (*((volatile unsigned int*)DI_IM_DI_SI_FILM_32_RESULT_2_B_reg))
#define  DI_IM_DI_SI_FILM_32_RESULT_2_B_film_sequence322_31_0_shift              (0)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_B_film_sequence322_31_0_mask               (0xFFFFFFFF)
#define  DI_IM_DI_SI_FILM_32_RESULT_2_B_film_sequence322_31_0(data)              (0xFFFFFFFF&(data))
#define  DI_IM_DI_SI_FILM_32_RESULT_2_B_get_film_sequence322_31_0(data)          (0xFFFFFFFF&(data))

#define  DI_IM_DI_SI_FILM_22_RESULT_A                                           0x180240E0
#define  DI_IM_DI_SI_FILM_22_RESULT_A_reg_addr                                   "0xB80240E0"
#define  DI_IM_DI_SI_FILM_22_RESULT_A_reg                                        0xB80240E0
#define  DI_IM_DI_SI_FILM_22_RESULT_A_inst_addr                                  "0x0033"
#define  set_DI_IM_DI_SI_FILM_22_RESULT_A_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_22_RESULT_A_reg)=data)
#define  get_DI_IM_DI_SI_FILM_22_RESULT_A_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_22_RESULT_A_reg))
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_detected22_shift                      (24)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_match22_shift                         (16)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_violate22_shift                       (8)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_sequence22_39_32_shift                (0)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_detected22_mask                       (0xFF000000)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_match22_mask                          (0x00FF0000)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_violate22_mask                        (0x0000FF00)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_sequence22_39_32_mask                 (0x000000FF)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_detected22(data)                      (0xFF000000&((data)<<24))
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_match22(data)                         (0x00FF0000&((data)<<16))
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_violate22(data)                       (0x0000FF00&((data)<<8))
#define  DI_IM_DI_SI_FILM_22_RESULT_A_film_sequence22_39_32(data)                (0x000000FF&(data))
#define  DI_IM_DI_SI_FILM_22_RESULT_A_get_film_detected22(data)                  ((0xFF000000&(data))>>24)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_get_film_match22(data)                     ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_get_film_violate22(data)                   ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_SI_FILM_22_RESULT_A_get_film_sequence22_39_32(data)            (0x000000FF&(data))

#define  DI_IM_DI_SI_FILM_22_RESULT_B                                           0x180240E4
#define  DI_IM_DI_SI_FILM_22_RESULT_B_reg_addr                                   "0xB80240E4"
#define  DI_IM_DI_SI_FILM_22_RESULT_B_reg                                        0xB80240E4
#define  DI_IM_DI_SI_FILM_22_RESULT_B_inst_addr                                  "0x0034"
#define  set_DI_IM_DI_SI_FILM_22_RESULT_B_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_22_RESULT_B_reg)=data)
#define  get_DI_IM_DI_SI_FILM_22_RESULT_B_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_22_RESULT_B_reg))
#define  DI_IM_DI_SI_FILM_22_RESULT_B_film_sequence22_31_0_shift                 (0)
#define  DI_IM_DI_SI_FILM_22_RESULT_B_film_sequence22_31_0_mask                  (0xFFFFFFFF)
#define  DI_IM_DI_SI_FILM_22_RESULT_B_film_sequence22_31_0(data)                 (0xFFFFFFFF&(data))
#define  DI_IM_DI_SI_FILM_22_RESULT_B_get_film_sequence22_31_0(data)             (0xFFFFFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_NEXT                                           0x180240E8
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_reg_addr                                   "0xB80240E8"
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_reg                                        0xB80240E8
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_inst_addr                                  "0x0035"
#define  set_DI_IM_DI_SI_FILM_MOTION_NEXT_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_NEXT_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_reg))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_film_motionstatus_719_700_shift            (0)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_film_motionstatus_719_700_mask             (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_film_motionstatus_719_700(data)            (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_get_film_motionstatus_719_700(data)        (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_T                                       0x180240EC
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_reg_addr                               "0xB80240EC"
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_reg                                    0xB80240EC
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_inst_addr                              "0x0036"
#define  set_DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_reg                                (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_reg))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_film_motionstatus_699_680_shift        (0)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_film_motionstatus_699_680_mask         (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_film_motionstatus_699_680(data)        (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_T_get_film_motionstatus_699_680(data)    (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_M                                       0x180240F0
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_reg_addr                               "0xB80240F0"
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_reg                                    0xB80240F0
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_inst_addr                              "0x0037"
#define  set_DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_reg                                (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_reg))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_film_motionstatus_679_660_shift        (0)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_film_motionstatus_679_660_mask         (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_film_motionstatus_679_660(data)        (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_M_get_film_motionstatus_679_660(data)    (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_B                                       0x180240F4
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_reg_addr                               "0xB80240F4"
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_reg                                    0xB80240F4
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_inst_addr                              "0x0038"
#define  set_DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_reg                                (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_reg))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_film_motionstatus_659_640_shift        (0)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_film_motionstatus_659_640_mask         (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_film_motionstatus_659_640(data)        (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_H_B_get_film_motionstatus_659_640(data)    (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_L                                       0x180240F8
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_reg_addr                               "0xB80240F8"
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_reg                                    0xB80240F8
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_inst_addr                              "0x0039"
#define  set_DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_reg                                (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_reg))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_film_motionstatus_639_620_shift        (0)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_film_motionstatus_639_620_mask         (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_film_motionstatus_639_620(data)        (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_L_get_film_motionstatus_639_620(data)    (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_M                                       0x180240FC
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_reg_addr                               "0xB80240FC"
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_reg                                    0xB80240FC
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_inst_addr                              "0x003A"
#define  set_DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_reg                                (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_reg))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_film_motionstatus_619_600_shift        (0)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_film_motionstatus_619_600_mask         (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_film_motionstatus_619_600(data)        (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_M_get_film_motionstatus_619_600(data)    (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_R                                       0x18024100
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_reg_addr                               "0xB8024100"
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_reg                                    0xB8024100
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_inst_addr                              "0x003B"
#define  set_DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_reg                                (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_reg))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_film_motionstatus_599_580_shift        (0)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_film_motionstatus_599_580_mask         (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_film_motionstatus_599_580(data)        (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_V_R_get_film_motionstatus_599_580(data)    (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_NEXT_C                                         0x18024104
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_C_reg_addr                                 "0xB8024104"
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_C_reg                                      0xB8024104
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_C_inst_addr                                "0x003C"
#define  set_DI_IM_DI_SI_FILM_MOTION_NEXT_C_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_C_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_NEXT_C_reg                                  (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_NEXT_C_reg))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_C_film_motionstatus_579_560_shift          (0)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_C_film_motionstatus_579_560_mask           (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_C_film_motionstatus_579_560(data)          (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_NEXT_C_get_film_motionstatus_579_560(data)      (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_PRE                                            0x18024108
#define  DI_IM_DI_SI_FILM_MOTION_PRE_reg_addr                                    "0xB8024108"
#define  DI_IM_DI_SI_FILM_MOTION_PRE_reg                                         0xB8024108
#define  DI_IM_DI_SI_FILM_MOTION_PRE_inst_addr                                   "0x003D"
#define  set_DI_IM_DI_SI_FILM_MOTION_PRE_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_PRE_reg                                     (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_reg))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_film_motionstatus_559_540_shift             (0)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_film_motionstatus_559_540_mask              (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_film_motionstatus_559_540(data)             (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_get_film_motionstatus_559_540(data)         (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_T                                        0x1802410C
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_T_reg_addr                                "0xB802410C"
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_T_reg                                     0xB802410C
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_T_inst_addr                               "0x003E"
#define  set_DI_IM_DI_SI_FILM_MOTION_PRE_H_T_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_H_T_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_PRE_H_T_reg                                 (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_H_T_reg))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_T_film_motionstatus_539_520_shift         (0)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_T_film_motionstatus_539_520_mask          (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_T_film_motionstatus_539_520(data)         (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_T_get_film_motionstatus_539_520(data)     (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_M                                        0x18024110
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_M_reg_addr                                "0xB8024110"
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_M_reg                                     0xB8024110
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_M_inst_addr                               "0x003F"
#define  set_DI_IM_DI_SI_FILM_MOTION_PRE_H_M_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_H_M_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_PRE_H_M_reg                                 (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_H_M_reg))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_M_film_motionstatus_519_500_shift         (0)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_M_film_motionstatus_519_500_mask          (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_M_film_motionstatus_519_500(data)         (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_M_get_film_motionstatus_519_500(data)     (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_B                                        0x18024114
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_B_reg_addr                                "0xB8024114"
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_B_reg                                     0xB8024114
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_B_inst_addr                               "0x0040"
#define  set_DI_IM_DI_SI_FILM_MOTION_PRE_H_B_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_H_B_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_PRE_H_B_reg                                 (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_H_B_reg))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_B_film_motionstatus_499_480_shift         (0)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_B_film_motionstatus_499_480_mask          (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_B_film_motionstatus_499_480(data)         (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_H_B_get_film_motionstatus_499_480(data)     (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_L                                        0x18024118
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_L_reg_addr                                "0xB8024118"
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_L_reg                                     0xB8024118
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_L_inst_addr                               "0x0041"
#define  set_DI_IM_DI_SI_FILM_MOTION_PRE_V_L_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_V_L_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_PRE_V_L_reg                                 (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_V_L_reg))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_L_film_motionstatus_479_460_shift         (0)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_L_film_motionstatus_479_460_mask          (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_L_film_motionstatus_479_460(data)         (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_L_get_film_motionstatus_479_460(data)     (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_M                                        0x1802411C
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_M_reg_addr                                "0xB802411C"
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_M_reg                                     0xB802411C
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_M_inst_addr                               "0x0042"
#define  set_DI_IM_DI_SI_FILM_MOTION_PRE_V_M_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_V_M_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_PRE_V_M_reg                                 (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_V_M_reg))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_M_film_motionstatus_459_440_shift         (0)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_M_film_motionstatus_459_440_mask          (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_M_film_motionstatus_459_440(data)         (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_M_get_film_motionstatus_459_440(data)     (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_R                                        0x18024120
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_R_reg_addr                                "0xB8024120"
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_R_reg                                     0xB8024120
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_R_inst_addr                               "0x0043"
#define  set_DI_IM_DI_SI_FILM_MOTION_PRE_V_R_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_V_R_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_PRE_V_R_reg                                 (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_V_R_reg))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_R_film_motionstatus_439_420_shift         (0)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_R_film_motionstatus_439_420_mask          (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_R_film_motionstatus_439_420(data)         (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_V_R_get_film_motionstatus_439_420(data)     (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_PRE_C                                          0x18024124
#define  DI_IM_DI_SI_FILM_MOTION_PRE_C_reg_addr                                  "0xB8024124"
#define  DI_IM_DI_SI_FILM_MOTION_PRE_C_reg                                       0xB8024124
#define  DI_IM_DI_SI_FILM_MOTION_PRE_C_inst_addr                                 "0x0044"
#define  set_DI_IM_DI_SI_FILM_MOTION_PRE_C_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_C_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_PRE_C_reg                                   (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_PRE_C_reg))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_C_film_motionstatus_419_400_shift           (0)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_C_film_motionstatus_419_400_mask            (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_PRE_C_film_motionstatus_419_400(data)           (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_PRE_C_get_film_motionstatus_419_400(data)       (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION                                                0x18024128
#define  DI_IM_DI_SI_FILM_MOTION_reg_addr                                        "0xB8024128"
#define  DI_IM_DI_SI_FILM_MOTION_reg                                             0xB8024128
#define  DI_IM_DI_SI_FILM_MOTION_inst_addr                                       "0x0045"
#define  set_DI_IM_DI_SI_FILM_MOTION_reg(data)                                   (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_reg                                         (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_reg))
#define  DI_IM_DI_SI_FILM_MOTION_film_motionstatus_399_380_shift                 (0)
#define  DI_IM_DI_SI_FILM_MOTION_film_motionstatus_399_380_mask                  (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_film_motionstatus_399_380(data)                 (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_get_film_motionstatus_399_380(data)             (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_T                                            0x1802412C
#define  DI_IM_DI_SI_FILM_MOTION_H_T_reg_addr                                    "0xB802412C"
#define  DI_IM_DI_SI_FILM_MOTION_H_T_reg                                         0xB802412C
#define  DI_IM_DI_SI_FILM_MOTION_H_T_inst_addr                                   "0x0046"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_T_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_T_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_T_reg                                     (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_T_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_T_film_motionstatus_379_360_shift             (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_T_film_motionstatus_379_360_mask              (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_T_film_motionstatus_379_360(data)             (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_T_get_film_motionstatus_379_360(data)         (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_M                                            0x18024130
#define  DI_IM_DI_SI_FILM_MOTION_H_M_reg_addr                                    "0xB8024130"
#define  DI_IM_DI_SI_FILM_MOTION_H_M_reg                                         0xB8024130
#define  DI_IM_DI_SI_FILM_MOTION_H_M_inst_addr                                   "0x0047"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_M_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_M_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_M_reg                                     (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_M_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_M_film_motionstatus_359_340_shift             (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_M_film_motionstatus_359_340_mask              (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_M_film_motionstatus_359_340(data)             (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_M_get_film_motionstatus_359_340(data)         (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_B                                            0x18024134
#define  DI_IM_DI_SI_FILM_MOTION_H_B_reg_addr                                    "0xB8024134"
#define  DI_IM_DI_SI_FILM_MOTION_H_B_reg                                         0xB8024134
#define  DI_IM_DI_SI_FILM_MOTION_H_B_inst_addr                                   "0x0048"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_B_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_B_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_B_reg                                     (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_B_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_B_film_motionstatus_339_320_shift             (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_B_film_motionstatus_339_320_mask              (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_B_film_motionstatus_339_320(data)             (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_B_get_film_motionstatus_339_320(data)         (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_V_L                                            0x18024138
#define  DI_IM_DI_SI_FILM_MOTION_V_L_reg_addr                                    "0xB8024138"
#define  DI_IM_DI_SI_FILM_MOTION_V_L_reg                                         0xB8024138
#define  DI_IM_DI_SI_FILM_MOTION_V_L_inst_addr                                   "0x0049"
#define  set_DI_IM_DI_SI_FILM_MOTION_V_L_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_V_L_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_V_L_reg                                     (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_V_L_reg))
#define  DI_IM_DI_SI_FILM_MOTION_V_L_film_motionstatus_319_300_shift             (0)
#define  DI_IM_DI_SI_FILM_MOTION_V_L_film_motionstatus_319_300_mask              (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_V_L_film_motionstatus_319_300(data)             (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_V_L_get_film_motionstatus_319_300(data)         (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_V_M                                            0x1802413C
#define  DI_IM_DI_SI_FILM_MOTION_V_M_reg_addr                                    "0xB802413C"
#define  DI_IM_DI_SI_FILM_MOTION_V_M_reg                                         0xB802413C
#define  DI_IM_DI_SI_FILM_MOTION_V_M_inst_addr                                   "0x004A"
#define  set_DI_IM_DI_SI_FILM_MOTION_V_M_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_V_M_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_V_M_reg                                     (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_V_M_reg))
#define  DI_IM_DI_SI_FILM_MOTION_V_M_film_motionstatus_299_280_shift             (0)
#define  DI_IM_DI_SI_FILM_MOTION_V_M_film_motionstatus_299_280_mask              (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_V_M_film_motionstatus_299_280(data)             (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_V_M_get_film_motionstatus_299_280(data)         (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_V_R                                            0x18024140
#define  DI_IM_DI_SI_FILM_MOTION_V_R_reg_addr                                    "0xB8024140"
#define  DI_IM_DI_SI_FILM_MOTION_V_R_reg                                         0xB8024140
#define  DI_IM_DI_SI_FILM_MOTION_V_R_inst_addr                                   "0x004B"
#define  set_DI_IM_DI_SI_FILM_MOTION_V_R_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_V_R_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_V_R_reg                                     (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_V_R_reg))
#define  DI_IM_DI_SI_FILM_MOTION_V_R_film_motionstatus_279_260_shift             (0)
#define  DI_IM_DI_SI_FILM_MOTION_V_R_film_motionstatus_279_260_mask              (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_V_R_film_motionstatus_279_260(data)             (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_V_R_get_film_motionstatus_279_260(data)         (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_C                                              0x18024144
#define  DI_IM_DI_SI_FILM_MOTION_C_reg_addr                                      "0xB8024144"
#define  DI_IM_DI_SI_FILM_MOTION_C_reg                                           0xB8024144
#define  DI_IM_DI_SI_FILM_MOTION_C_inst_addr                                     "0x004C"
#define  set_DI_IM_DI_SI_FILM_MOTION_C_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_C_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_C_reg                                       (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_C_reg))
#define  DI_IM_DI_SI_FILM_MOTION_C_film_motionstatus_259_240_shift               (0)
#define  DI_IM_DI_SI_FILM_MOTION_C_film_motionstatus_259_240_mask                (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_C_film_motionstatus_259_240(data)               (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_C_get_film_motionstatus_259_240(data)           (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_11                                           0x18024148
#define  DI_IM_DI_SI_FILM_MOTION_H_11_reg_addr                                   "0xB8024148"
#define  DI_IM_DI_SI_FILM_MOTION_H_11_reg                                        0xB8024148
#define  DI_IM_DI_SI_FILM_MOTION_H_11_inst_addr                                  "0x004D"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_11_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_11_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_11_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_11_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_11_film_motionstatus_239_220_shift            (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_11_film_motionstatus_239_220_mask             (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_11_film_motionstatus_239_220(data)            (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_11_get_film_motionstatus_239_220(data)        (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_10                                           0x1802414C
#define  DI_IM_DI_SI_FILM_MOTION_H_10_reg_addr                                   "0xB802414C"
#define  DI_IM_DI_SI_FILM_MOTION_H_10_reg                                        0xB802414C
#define  DI_IM_DI_SI_FILM_MOTION_H_10_inst_addr                                  "0x004E"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_10_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_10_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_10_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_10_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_10_film_motionstatus_219_200_shift            (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_10_film_motionstatus_219_200_mask             (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_10_film_motionstatus_219_200(data)            (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_10_get_film_motionstatus_219_200(data)        (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_09                                           0x18024150
#define  DI_IM_DI_SI_FILM_MOTION_H_09_reg_addr                                   "0xB8024150"
#define  DI_IM_DI_SI_FILM_MOTION_H_09_reg                                        0xB8024150
#define  DI_IM_DI_SI_FILM_MOTION_H_09_inst_addr                                  "0x004F"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_09_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_09_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_09_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_09_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_09_film_motionstatus_199_180_shift            (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_09_film_motionstatus_199_180_mask             (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_09_film_motionstatus_199_180(data)            (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_09_get_film_motionstatus_199_180(data)        (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_08                                           0x18024154
#define  DI_IM_DI_SI_FILM_MOTION_H_08_reg_addr                                   "0xB8024154"
#define  DI_IM_DI_SI_FILM_MOTION_H_08_reg                                        0xB8024154
#define  DI_IM_DI_SI_FILM_MOTION_H_08_inst_addr                                  "0x0050"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_08_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_08_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_08_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_08_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_08_film_motionstatus_179_160_shift            (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_08_film_motionstatus_179_160_mask             (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_08_film_motionstatus_179_160(data)            (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_08_get_film_motionstatus_179_160(data)        (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_07                                           0x18024158
#define  DI_IM_DI_SI_FILM_MOTION_H_07_reg_addr                                   "0xB8024158"
#define  DI_IM_DI_SI_FILM_MOTION_H_07_reg                                        0xB8024158
#define  DI_IM_DI_SI_FILM_MOTION_H_07_inst_addr                                  "0x0051"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_07_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_07_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_07_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_07_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_07_film_motionstatus_159_140_shift            (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_07_film_motionstatus_159_140_mask             (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_07_film_motionstatus_159_140(data)            (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_07_get_film_motionstatus_159_140(data)        (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_06                                           0x1802415C
#define  DI_IM_DI_SI_FILM_MOTION_H_06_reg_addr                                   "0xB802415C"
#define  DI_IM_DI_SI_FILM_MOTION_H_06_reg                                        0xB802415C
#define  DI_IM_DI_SI_FILM_MOTION_H_06_inst_addr                                  "0x0052"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_06_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_06_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_06_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_06_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_06_film_motionstatus_139_120_shift            (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_06_film_motionstatus_139_120_mask             (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_06_film_motionstatus_139_120(data)            (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_06_get_film_motionstatus_139_120(data)        (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_05                                           0x18024160
#define  DI_IM_DI_SI_FILM_MOTION_H_05_reg_addr                                   "0xB8024160"
#define  DI_IM_DI_SI_FILM_MOTION_H_05_reg                                        0xB8024160
#define  DI_IM_DI_SI_FILM_MOTION_H_05_inst_addr                                  "0x0053"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_05_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_05_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_05_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_05_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_05_film_motionstatus_119_100_shift            (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_05_film_motionstatus_119_100_mask             (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_05_film_motionstatus_119_100(data)            (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_05_get_film_motionstatus_119_100(data)        (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_04                                           0x18024164
#define  DI_IM_DI_SI_FILM_MOTION_H_04_reg_addr                                   "0xB8024164"
#define  DI_IM_DI_SI_FILM_MOTION_H_04_reg                                        0xB8024164
#define  DI_IM_DI_SI_FILM_MOTION_H_04_inst_addr                                  "0x0054"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_04_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_04_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_04_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_04_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_04_film_motionstatus_99_80_shift              (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_04_film_motionstatus_99_80_mask               (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_04_film_motionstatus_99_80(data)              (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_04_get_film_motionstatus_99_80(data)          (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_03                                           0x18024168
#define  DI_IM_DI_SI_FILM_MOTION_H_03_reg_addr                                   "0xB8024168"
#define  DI_IM_DI_SI_FILM_MOTION_H_03_reg                                        0xB8024168
#define  DI_IM_DI_SI_FILM_MOTION_H_03_inst_addr                                  "0x0055"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_03_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_03_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_03_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_03_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_03_film_motionstatus_79_60_shift              (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_03_film_motionstatus_79_60_mask               (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_03_film_motionstatus_79_60(data)              (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_03_get_film_motionstatus_79_60(data)          (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_02                                           0x1802416C
#define  DI_IM_DI_SI_FILM_MOTION_H_02_reg_addr                                   "0xB802416C"
#define  DI_IM_DI_SI_FILM_MOTION_H_02_reg                                        0xB802416C
#define  DI_IM_DI_SI_FILM_MOTION_H_02_inst_addr                                  "0x0056"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_02_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_02_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_02_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_02_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_02_film_motionstatus_59_40_shift              (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_02_film_motionstatus_59_40_mask               (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_02_film_motionstatus_59_40(data)              (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_02_get_film_motionstatus_59_40(data)          (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_01                                           0x18024170
#define  DI_IM_DI_SI_FILM_MOTION_H_01_reg_addr                                   "0xB8024170"
#define  DI_IM_DI_SI_FILM_MOTION_H_01_reg                                        0xB8024170
#define  DI_IM_DI_SI_FILM_MOTION_H_01_inst_addr                                  "0x0057"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_01_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_01_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_01_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_01_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_01_film_motionstatus_39_20_shift              (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_01_film_motionstatus_39_20_mask               (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_01_film_motionstatus_39_20(data)              (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_01_get_film_motionstatus_39_20(data)          (0x000FFFFF&(data))

#define  DI_IM_DI_SI_FILM_MOTION_H_00                                           0x18024174
#define  DI_IM_DI_SI_FILM_MOTION_H_00_reg_addr                                   "0xB8024174"
#define  DI_IM_DI_SI_FILM_MOTION_H_00_reg                                        0xB8024174
#define  DI_IM_DI_SI_FILM_MOTION_H_00_inst_addr                                  "0x0058"
#define  set_DI_IM_DI_SI_FILM_MOTION_H_00_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_00_reg)=data)
#define  get_DI_IM_DI_SI_FILM_MOTION_H_00_reg                                    (*((volatile unsigned int*)DI_IM_DI_SI_FILM_MOTION_H_00_reg))
#define  DI_IM_DI_SI_FILM_MOTION_H_00_film_motionstatus_19_0_shift               (0)
#define  DI_IM_DI_SI_FILM_MOTION_H_00_film_motionstatus_19_0_mask                (0x000FFFFF)
#define  DI_IM_DI_SI_FILM_MOTION_H_00_film_motionstatus_19_0(data)               (0x000FFFFF&(data))
#define  DI_IM_DI_SI_FILM_MOTION_H_00_get_film_motionstatus_19_0(data)           (0x000FFFFF&(data))

#define  DI_IM_DI_SI_MA_TOTAL_FM_SUM                                            0x18024178
#define  DI_IM_DI_SI_MA_TOTAL_FM_SUM_reg_addr                                    "0xB8024178"
#define  DI_IM_DI_SI_MA_TOTAL_FM_SUM_reg                                         0xB8024178
#define  DI_IM_DI_SI_MA_TOTAL_FM_SUM_inst_addr                                   "0x0059"
#define  set_DI_IM_DI_SI_MA_TOTAL_FM_SUM_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_SI_MA_TOTAL_FM_SUM_reg)=data)
#define  get_DI_IM_DI_SI_MA_TOTAL_FM_SUM_reg                                     (*((volatile unsigned int*)DI_IM_DI_SI_MA_TOTAL_FM_SUM_reg))
#define  DI_IM_DI_SI_MA_TOTAL_FM_SUM_total_frame_motion_sum_shift                (0)
#define  DI_IM_DI_SI_MA_TOTAL_FM_SUM_total_frame_motion_sum_mask                 (0x00FFFFFF)
#define  DI_IM_DI_SI_MA_TOTAL_FM_SUM_total_frame_motion_sum(data)                (0x00FFFFFF&(data))
#define  DI_IM_DI_SI_MA_TOTAL_FM_SUM_get_total_frame_motion_sum(data)            (0x00FFFFFF&(data))

#define  DI_IM_DI_SI_MA_LARGE_FM_PIXEL                                          0x1802417C
#define  DI_IM_DI_SI_MA_LARGE_FM_PIXEL_reg_addr                                  "0xB802417C"
#define  DI_IM_DI_SI_MA_LARGE_FM_PIXEL_reg                                       0xB802417C
#define  DI_IM_DI_SI_MA_LARGE_FM_PIXEL_inst_addr                                 "0x005A"
#define  set_DI_IM_DI_SI_MA_LARGE_FM_PIXEL_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_SI_MA_LARGE_FM_PIXEL_reg)=data)
#define  get_DI_IM_DI_SI_MA_LARGE_FM_PIXEL_reg                                   (*((volatile unsigned int*)DI_IM_DI_SI_MA_LARGE_FM_PIXEL_reg))
#define  DI_IM_DI_SI_MA_LARGE_FM_PIXEL_large_frame_motion_pixel_shift            (0)
#define  DI_IM_DI_SI_MA_LARGE_FM_PIXEL_large_frame_motion_pixel_mask             (0x00FFFFFF)
#define  DI_IM_DI_SI_MA_LARGE_FM_PIXEL_large_frame_motion_pixel(data)            (0x00FFFFFF&(data))
#define  DI_IM_DI_SI_MA_LARGE_FM_PIXEL_get_large_frame_motion_pixel(data)        (0x00FFFFFF&(data))

#define  DI_IM_DI_SI_MA_LARGE_FM_SUM                                            0x18024180
#define  DI_IM_DI_SI_MA_LARGE_FM_SUM_reg_addr                                    "0xB8024180"
#define  DI_IM_DI_SI_MA_LARGE_FM_SUM_reg                                         0xB8024180
#define  DI_IM_DI_SI_MA_LARGE_FM_SUM_inst_addr                                   "0x005B"
#define  set_DI_IM_DI_SI_MA_LARGE_FM_SUM_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_SI_MA_LARGE_FM_SUM_reg)=data)
#define  get_DI_IM_DI_SI_MA_LARGE_FM_SUM_reg                                     (*((volatile unsigned int*)DI_IM_DI_SI_MA_LARGE_FM_SUM_reg))
#define  DI_IM_DI_SI_MA_LARGE_FM_SUM_large_frame_motion_sum_shift                (0)
#define  DI_IM_DI_SI_MA_LARGE_FM_SUM_large_frame_motion_sum_mask                 (0x00FFFFFF)
#define  DI_IM_DI_SI_MA_LARGE_FM_SUM_large_frame_motion_sum(data)                (0x00FFFFFF&(data))
#define  DI_IM_DI_SI_MA_LARGE_FM_SUM_get_large_frame_motion_sum(data)            (0x00FFFFFF&(data))

#define  DI_IM_DI_SI_MA_MESS_H_PIXEL                                            0x18024184
#define  DI_IM_DI_SI_MA_MESS_H_PIXEL_reg_addr                                    "0xB8024184"
#define  DI_IM_DI_SI_MA_MESS_H_PIXEL_reg                                         0xB8024184
#define  DI_IM_DI_SI_MA_MESS_H_PIXEL_inst_addr                                   "0x005C"
#define  set_DI_IM_DI_SI_MA_MESS_H_PIXEL_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_SI_MA_MESS_H_PIXEL_reg)=data)
#define  get_DI_IM_DI_SI_MA_MESS_H_PIXEL_reg                                     (*((volatile unsigned int*)DI_IM_DI_SI_MA_MESS_H_PIXEL_reg))
#define  DI_IM_DI_SI_MA_MESS_H_PIXEL_mess_horizontal_pixel_shift                 (0)
#define  DI_IM_DI_SI_MA_MESS_H_PIXEL_mess_horizontal_pixel_mask                  (0x00FFFFFF)
#define  DI_IM_DI_SI_MA_MESS_H_PIXEL_mess_horizontal_pixel(data)                 (0x00FFFFFF&(data))
#define  DI_IM_DI_SI_MA_MESS_H_PIXEL_get_mess_horizontal_pixel(data)             (0x00FFFFFF&(data))

#define  DI_IM_DI_SI_IMAGE_BALANCE                                              0x18024188
#define  DI_IM_DI_SI_IMAGE_BALANCE_reg_addr                                      "0xB8024188"
#define  DI_IM_DI_SI_IMAGE_BALANCE_reg                                           0xB8024188
#define  DI_IM_DI_SI_IMAGE_BALANCE_inst_addr                                     "0x005D"
#define  set_DI_IM_DI_SI_IMAGE_BALANCE_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_SI_IMAGE_BALANCE_reg)=data)
#define  get_DI_IM_DI_SI_IMAGE_BALANCE_reg                                       (*((volatile unsigned int*)DI_IM_DI_SI_IMAGE_BALANCE_reg))
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_subbal_status_shift                        (25)
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_enable_mainbalance_shift                   (24)
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_mean3_status_shift                         (16)
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_mean2_status_shift                         (8)
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_mean1_status_shift                         (0)
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_subbal_status_mask                         (0x0E000000)
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_enable_mainbalance_mask                    (0x01000000)
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_mean3_status_mask                          (0x00FF0000)
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_mean2_status_mask                          (0x0000FF00)
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_mean1_status_mask                          (0x000000FF)
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_subbal_status(data)                        (0x0E000000&((data)<<25))
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_enable_mainbalance(data)                   (0x01000000&((data)<<24))
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_mean3_status(data)                         (0x00FF0000&((data)<<16))
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_mean2_status(data)                         (0x0000FF00&((data)<<8))
#define  DI_IM_DI_SI_IMAGE_BALANCE_cr_mean1_status(data)                         (0x000000FF&(data))
#define  DI_IM_DI_SI_IMAGE_BALANCE_get_cr_subbal_status(data)                    ((0x0E000000&(data))>>25)
#define  DI_IM_DI_SI_IMAGE_BALANCE_get_cr_enable_mainbalance(data)               ((0x01000000&(data))>>24)
#define  DI_IM_DI_SI_IMAGE_BALANCE_get_cr_mean3_status(data)                     ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_SI_IMAGE_BALANCE_get_cr_mean2_status(data)                     ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_SI_IMAGE_BALANCE_get_cr_mean1_status(data)                     (0x000000FF&(data))

#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE                                        0x1802418C
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_reg_addr                                "0xB802418C"
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_reg                                     0xB802418C
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_inst_addr                               "0x005E"
#define  set_DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_reg)=data)
#define  get_DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_reg                                 (*((volatile unsigned int*)DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_reg))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_crc_i2rnd_sel_shift                     (31)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_compare_en_shift               (30)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_continous_mode_shift           (29)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_compare_done_shift             (28)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r1_compare_fail_shift          (27)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r2_compare_fail_shift          (26)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r3_compare_fail_shift          (25)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r4_compare_fail_shift          (24)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r1_compare_fail_3d_shift       (23)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r2_compare_fail_3d_shift       (22)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r3_compare_fail_3d_shift       (21)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r4_compare_fail_3d_shift       (20)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_info_r1_compare_fail_shift     (19)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_info_r2_compare_fail_shift     (18)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_di_crc_ctrl_conti_shift                 (17)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_di_crc_ctrl_start_shift                 (16)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_cr_amount_subbalance_shift              (0)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_crc_i2rnd_sel_mask                      (0x80000000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_compare_en_mask                (0x40000000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_continous_mode_mask            (0x20000000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_compare_done_mask              (0x10000000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r1_compare_fail_mask           (0x08000000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r2_compare_fail_mask           (0x04000000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r3_compare_fail_mask           (0x02000000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r4_compare_fail_mask           (0x01000000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r1_compare_fail_3d_mask        (0x00800000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r2_compare_fail_3d_mask        (0x00400000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r3_compare_fail_3d_mask        (0x00200000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r4_compare_fail_3d_mask        (0x00100000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_info_r1_compare_fail_mask      (0x00080000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_info_r2_compare_fail_mask      (0x00040000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_di_crc_ctrl_conti_mask                  (0x00020000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_di_crc_ctrl_start_mask                  (0x00010000)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_cr_amount_subbalance_mask               (0x0000FFFF)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_crc_i2rnd_sel(data)                     (0x80000000&((data)<<31))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_compare_en(data)               (0x40000000&((data)<<30))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_continous_mode(data)           (0x20000000&((data)<<29))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_compare_done(data)             (0x10000000&((data)<<28))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r1_compare_fail(data)          (0x08000000&((data)<<27))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r2_compare_fail(data)          (0x04000000&((data)<<26))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r3_compare_fail(data)          (0x02000000&((data)<<25))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r4_compare_fail(data)          (0x01000000&((data)<<24))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r1_compare_fail_3d(data)       (0x00800000&((data)<<23))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r2_compare_fail_3d(data)       (0x00400000&((data)<<22))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r3_compare_fail_3d(data)       (0x00200000&((data)<<21))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_r4_compare_fail_3d(data)       (0x00100000&((data)<<20))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_info_r1_compare_fail(data)     (0x00080000&((data)<<19))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_fbuf_crc_info_r2_compare_fail(data)     (0x00040000&((data)<<18))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_di_crc_ctrl_conti(data)                 (0x00020000&((data)<<17))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_di_crc_ctrl_start(data)                 (0x00010000&((data)<<16))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_cr_amount_subbalance(data)              (0x0000FFFF&(data))
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_crc_i2rnd_sel(data)                 ((0x80000000&(data))>>31)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_compare_en(data)           ((0x40000000&(data))>>30)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_continous_mode(data)       ((0x20000000&(data))>>29)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_compare_done(data)         ((0x10000000&(data))>>28)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_r1_compare_fail(data)      ((0x08000000&(data))>>27)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_r2_compare_fail(data)      ((0x04000000&(data))>>26)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_r3_compare_fail(data)      ((0x02000000&(data))>>25)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_r4_compare_fail(data)      ((0x01000000&(data))>>24)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_r1_compare_fail_3d(data)   ((0x00800000&(data))>>23)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_r2_compare_fail_3d(data)   ((0x00400000&(data))>>22)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_r3_compare_fail_3d(data)   ((0x00200000&(data))>>21)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_r4_compare_fail_3d(data)   ((0x00100000&(data))>>20)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_info_r1_compare_fail(data) ((0x00080000&(data))>>19)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_fbuf_crc_info_r2_compare_fail(data) ((0x00040000&(data))>>18)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_di_crc_ctrl_conti(data)             ((0x00020000&(data))>>17)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_di_crc_ctrl_start(data)             ((0x00010000&(data))>>16)
#define  DI_IM_DI_SI_SUB_IN_AUTO_BALANCE_get_cr_amount_subbalance(data)          (0x0000FFFF&(data))

#define  DI_IM_DI_CRC_RESULT                                                    0x18024190
#define  DI_IM_DI_CRC_RESULT_reg_addr                                            "0xB8024190"
#define  DI_IM_DI_CRC_RESULT_reg                                                 0xB8024190
#define  DI_IM_DI_CRC_RESULT_inst_addr                                           "0x005F"
#define  set_DI_IM_DI_CRC_RESULT_reg(data)                                       (*((volatile unsigned int*)DI_IM_DI_CRC_RESULT_reg)=data)
#define  get_DI_IM_DI_CRC_RESULT_reg                                             (*((volatile unsigned int*)DI_IM_DI_CRC_RESULT_reg))
#define  DI_IM_DI_CRC_RESULT_di_crc_result_shift                                 (0)
#define  DI_IM_DI_CRC_RESULT_di_crc_result_mask                                  (0xFFFFFFFF)
#define  DI_IM_DI_CRC_RESULT_di_crc_result(data)                                 (0xFFFFFFFF&(data))
#define  DI_IM_DI_CRC_RESULT_get_di_crc_result(data)                             (0xFFFFFFFF&(data))

#define  DI_IM_DI_SI_STILL_INFO_FOR_NE                                          0x18024194
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_reg_addr                                  "0xB8024194"
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_reg                                       0xB8024194
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_inst_addr                                 "0x0060"
#define  set_DI_IM_DI_SI_STILL_INFO_FOR_NE_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_SI_STILL_INFO_FOR_NE_reg)=data)
#define  get_DI_IM_DI_SI_STILL_INFO_FOR_NE_reg                                   (*((volatile unsigned int*)DI_IM_DI_SI_STILL_INFO_FOR_NE_reg))
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_cp_partialstill_shift                     (1)
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_cp_partialstillnew_shift                  (0)
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_cp_partialstill_mask                      (0x00000002)
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_cp_partialstillnew_mask                   (0x00000001)
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_cp_partialstill(data)                     (0x00000002&((data)<<1))
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_cp_partialstillnew(data)                  (0x00000001&(data))
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_get_cp_partialstill(data)                 ((0x00000002&(data))>>1)
#define  DI_IM_DI_SI_STILL_INFO_FOR_NE_get_cp_partialstillnew(data)              (0x00000001&(data))

#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN                                    0x18024198
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_reg_addr                            "0xB8024198"
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_reg                                 0xB8024198
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_inst_addr                           "0x0061"
#define  set_DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_reg)=data)
#define  get_DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_reg                             (*((volatile unsigned int*)DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_reg))
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_film22_nxtfistatic1_shift           (8)
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_film22_nxtfimotion_shift            (0)
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_film22_nxtfistatic1_mask            (0x0000FF00)
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_film22_nxtfimotion_mask             (0x000000FF)
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_film22_nxtfistatic1(data)           (0x0000FF00&((data)<<8))
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_film22_nxtfimotion(data)            (0x000000FF&(data))
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_get_film22_nxtfistatic1(data)       ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_SI_FILM22_DETECTOR_PATTERN_get_film22_nxtfimotion(data)        (0x000000FF&(data))

#define  DI_IM_DI_TNR_TH                                                        0x1802419C
#define  DI_IM_DI_TNR_TH_reg_addr                                                "0xB802419C"
#define  DI_IM_DI_TNR_TH_reg                                                     0xB802419C
#define  DI_IM_DI_TNR_TH_inst_addr                                               "0x0062"
#define  set_DI_IM_DI_TNR_TH_reg(data)                                           (*((volatile unsigned int*)DI_IM_DI_TNR_TH_reg)=data)
#define  get_DI_IM_DI_TNR_TH_reg                                                 (*((volatile unsigned int*)DI_IM_DI_TNR_TH_reg))
#define  DI_IM_DI_TNR_TH_cp_temporalthly_shift                                   (8)
#define  DI_IM_DI_TNR_TH_cp_temporalthlc_shift                                   (0)
#define  DI_IM_DI_TNR_TH_cp_temporalthly_mask                                    (0x0000FF00)
#define  DI_IM_DI_TNR_TH_cp_temporalthlc_mask                                    (0x000000FF)
#define  DI_IM_DI_TNR_TH_cp_temporalthly(data)                                   (0x0000FF00&((data)<<8))
#define  DI_IM_DI_TNR_TH_cp_temporalthlc(data)                                   (0x000000FF&(data))
#define  DI_IM_DI_TNR_TH_get_cp_temporalthly(data)                               ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_TNR_TH_get_cp_temporalthlc(data)                               (0x000000FF&(data))

#define  DI_IM_DI_RTNR_CONTROL                                                  0x180241A0
#define  DI_IM_DI_RTNR_CONTROL_reg_addr                                          "0xB80241A0"
#define  DI_IM_DI_RTNR_CONTROL_reg                                               0xB80241A0
#define  DI_IM_DI_RTNR_CONTROL_inst_addr                                         "0x0063"
#define  set_DI_IM_DI_RTNR_CONTROL_reg(data)                                     (*((volatile unsigned int*)DI_IM_DI_RTNR_CONTROL_reg)=data)
#define  get_DI_IM_DI_RTNR_CONTROL_reg                                           (*((volatile unsigned int*)DI_IM_DI_RTNR_CONTROL_reg))
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_rgb444_enable_shift                       (30)
#define  DI_IM_DI_RTNR_CONTROL_cp_progressive_line_dma_shift                     (29)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_rgb444_8bit_mode_shift                    (28)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_output_previous_shift                     (27)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_updatelockflg_shift                       (7)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_updatelocken_shift                        (6)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_mad_window_shift                          (4)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_rounding_correction_shift                 (3)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_progressive_shift                         (2)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_c_enable_shift                            (1)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_y_enable_shift                            (0)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_rgb444_enable_mask                        (0x40000000)
#define  DI_IM_DI_RTNR_CONTROL_cp_progressive_line_dma_mask                      (0x20000000)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_rgb444_8bit_mode_mask                     (0x10000000)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_output_previous_mask                      (0x08000000)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_updatelockflg_mask                        (0x00000080)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_updatelocken_mask                         (0x00000040)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_mad_window_mask                           (0x00000030)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_rounding_correction_mask                  (0x00000008)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_progressive_mask                          (0x00000004)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_c_enable_mask                             (0x00000002)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_y_enable_mask                             (0x00000001)
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_rgb444_enable(data)                       (0x40000000&((data)<<30))
#define  DI_IM_DI_RTNR_CONTROL_cp_progressive_line_dma(data)                     (0x20000000&((data)<<29))
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_rgb444_8bit_mode(data)                    (0x10000000&((data)<<28))
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_output_previous(data)                     (0x08000000&((data)<<27))
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_updatelockflg(data)                       (0x00000080&((data)<<7))
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_updatelocken(data)                        (0x00000040&((data)<<6))
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_mad_window(data)                          (0x00000030&((data)<<4))
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_rounding_correction(data)                 (0x00000008&((data)<<3))
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_progressive(data)                         (0x00000004&((data)<<2))
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_c_enable(data)                            (0x00000002&((data)<<1))
#define  DI_IM_DI_RTNR_CONTROL_cp_rtnr_y_enable(data)                            (0x00000001&(data))
#define  DI_IM_DI_RTNR_CONTROL_get_cp_rtnr_rgb444_enable(data)                   ((0x40000000&(data))>>30)
#define  DI_IM_DI_RTNR_CONTROL_get_cp_progressive_line_dma(data)                 ((0x20000000&(data))>>29)
#define  DI_IM_DI_RTNR_CONTROL_get_cp_rtnr_rgb444_8bit_mode(data)                ((0x10000000&(data))>>28)
#define  DI_IM_DI_RTNR_CONTROL_get_cp_rtnr_output_previous(data)                 ((0x08000000&(data))>>27)
#define  DI_IM_DI_RTNR_CONTROL_get_cp_rtnr_updatelockflg(data)                   ((0x00000080&(data))>>7)
#define  DI_IM_DI_RTNR_CONTROL_get_cp_rtnr_updatelocken(data)                    ((0x00000040&(data))>>6)
#define  DI_IM_DI_RTNR_CONTROL_get_cp_rtnr_mad_window(data)                      ((0x00000030&(data))>>4)
#define  DI_IM_DI_RTNR_CONTROL_get_cp_rtnr_rounding_correction(data)             ((0x00000008&(data))>>3)
#define  DI_IM_DI_RTNR_CONTROL_get_cp_rtnr_progressive(data)                     ((0x00000004&(data))>>2)
#define  DI_IM_DI_RTNR_CONTROL_get_cp_rtnr_c_enable(data)                        ((0x00000002&(data))>>1)
#define  DI_IM_DI_RTNR_CONTROL_get_cp_rtnr_y_enable(data)                        (0x00000001&(data))

#define  DI_IM_DI_RTNR_K_FORCE_MODIFY                                           0x180241A4
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_reg_addr                                   "0xB80241A4"
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_reg                                        0xB80241A4
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_inst_addr                                  "0x0064"
#define  set_DI_IM_DI_RTNR_K_FORCE_MODIFY_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_RTNR_K_FORCE_MODIFY_reg)=data)
#define  get_DI_IM_DI_RTNR_K_FORCE_MODIFY_reg                                    (*((volatile unsigned int*)DI_IM_DI_RTNR_K_FORCE_MODIFY_reg))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_dummy_31_27_shift                          (27)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_index_shift         (24)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_mode_shift          (23)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_ne_follow_k_modify_shift           (22)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_en_c_shift          (21)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_en_y_shift          (20)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_offset_shift        (16)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_24_shift          (14)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_23_shift          (13)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_22_shift          (12)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_21_shift          (11)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_20_shift          (10)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_14_shift          (9)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_13_shift          (8)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_12_shift          (7)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_11_shift          (6)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_10_shift          (5)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_04_shift          (4)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_03_shift          (3)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_02_shift          (2)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_01_shift          (1)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_00_shift          (0)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_dummy_31_27_mask                           (0xF8000000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_index_mask          (0x07000000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_mode_mask           (0x00800000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_ne_follow_k_modify_mask            (0x00400000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_en_c_mask           (0x00200000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_en_y_mask           (0x00100000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_offset_mask         (0x000F0000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_24_mask           (0x00004000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_23_mask           (0x00002000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_22_mask           (0x00001000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_21_mask           (0x00000800)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_20_mask           (0x00000400)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_14_mask           (0x00000200)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_13_mask           (0x00000100)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_12_mask           (0x00000080)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_11_mask           (0x00000040)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_10_mask           (0x00000020)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_04_mask           (0x00000010)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_03_mask           (0x00000008)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_02_mask           (0x00000004)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_01_mask           (0x00000002)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_00_mask           (0x00000001)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_dummy_31_27(data)                          (0xF8000000&((data)<<27))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_index(data)         (0x07000000&((data)<<24))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_mode(data)          (0x00800000&((data)<<23))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_ne_follow_k_modify(data)           (0x00400000&((data)<<22))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_en_c(data)          (0x00200000&((data)<<21))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_en_y(data)          (0x00100000&((data)<<20))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_offset(data)        (0x000F0000&((data)<<16))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_24(data)          (0x00004000&((data)<<14))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_23(data)          (0x00002000&((data)<<13))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_22(data)          (0x00001000&((data)<<12))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_21(data)          (0x00000800&((data)<<11))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_20(data)          (0x00000400&((data)<<10))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_14(data)          (0x00000200&((data)<<9))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_13(data)          (0x00000100&((data)<<8))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_12(data)          (0x00000080&((data)<<7))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_11(data)          (0x00000040&((data)<<6))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_10(data)          (0x00000020&((data)<<5))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_04(data)          (0x00000010&((data)<<4))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_03(data)          (0x00000008&((data)<<3))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_02(data)          (0x00000004&((data)<<2))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_01(data)          (0x00000002&((data)<<1))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_cp_rtnr_k_force_modify_0_00(data)          (0x00000001&(data))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_dummy_31_27(data)                      ((0xF8000000&(data))>>27)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_index(data)     ((0x07000000&(data))>>24)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_mode(data)      ((0x00800000&(data))>>23)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_ne_follow_k_modify(data)       ((0x00400000&(data))>>22)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_en_c(data)      ((0x00200000&(data))>>21)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_en_y(data)      ((0x00100000&(data))>>20)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_offset(data)    ((0x000F0000&(data))>>16)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_24(data)      ((0x00004000&(data))>>14)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_23(data)      ((0x00002000&(data))>>13)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_22(data)      ((0x00001000&(data))>>12)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_21(data)      ((0x00000800&(data))>>11)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_20(data)      ((0x00000400&(data))>>10)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_14(data)      ((0x00000200&(data))>>9)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_13(data)      ((0x00000100&(data))>>8)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_12(data)      ((0x00000080&(data))>>7)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_11(data)      ((0x00000040&(data))>>6)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_10(data)      ((0x00000020&(data))>>5)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_04(data)      ((0x00000010&(data))>>4)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_03(data)      ((0x00000008&(data))>>3)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_02(data)      ((0x00000004&(data))>>2)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_01(data)      ((0x00000002&(data))>>1)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_get_cp_rtnr_k_force_modify_0_00(data)      (0x00000001&(data))

#define  DI_tr2to1                                                              0x180241A8
#define  DI_tr2to1_reg_addr                                                      "0xB80241A8"
#define  DI_tr2to1_reg                                                           0xB80241A8
#define  DI_tr2to1_inst_addr                                                     "0x0065"
#define  set_DI_tr2to1_reg(data)                                                 (*((volatile unsigned int*)DI_tr2to1_reg)=data)
#define  get_DI_tr2to1_reg                                                       (*((volatile unsigned int*)DI_tr2to1_reg))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_24_shift                             (30)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_23_shift                             (29)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_22_shift                             (28)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_21_shift                             (27)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_20_shift                             (26)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_14_shift                             (25)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_13_shift                             (24)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_12_shift                             (23)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_11_shift                             (22)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_10_shift                             (21)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_04_shift                             (20)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_03_shift                             (19)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_02_shift                             (18)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_01_shift                             (17)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_00_shift                             (16)
#define  DI_tr2to1_tr2to1_dist_shift                                             (0)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_24_mask                              (0x40000000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_23_mask                              (0x20000000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_22_mask                              (0x10000000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_21_mask                              (0x08000000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_20_mask                              (0x04000000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_14_mask                              (0x02000000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_13_mask                              (0x01000000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_12_mask                              (0x00800000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_11_mask                              (0x00400000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_10_mask                              (0x00200000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_04_mask                              (0x00100000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_03_mask                              (0x00080000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_02_mask                              (0x00040000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_01_mask                              (0x00020000)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_00_mask                              (0x00010000)
#define  DI_tr2to1_tr2to1_dist_mask                                              (0x000007FF)
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_24(data)                             (0x40000000&((data)<<30))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_23(data)                             (0x20000000&((data)<<29))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_22(data)                             (0x10000000&((data)<<28))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_21(data)                             (0x08000000&((data)<<27))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_20(data)                             (0x04000000&((data)<<26))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_14(data)                             (0x02000000&((data)<<25))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_13(data)                             (0x01000000&((data)<<24))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_12(data)                             (0x00800000&((data)<<23))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_11(data)                             (0x00400000&((data)<<22))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_10(data)                             (0x00200000&((data)<<21))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_04(data)                             (0x00100000&((data)<<20))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_03(data)                             (0x00080000&((data)<<19))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_02(data)                             (0x00040000&((data)<<18))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_01(data)                             (0x00020000&((data)<<17))
#define  DI_tr2to1_cp_rtnr_k_force_modify_1_00(data)                             (0x00010000&((data)<<16))
#define  DI_tr2to1_tr2to1_dist(data)                                             (0x000007FF&(data))
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_24(data)                         ((0x40000000&(data))>>30)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_23(data)                         ((0x20000000&(data))>>29)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_22(data)                         ((0x10000000&(data))>>28)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_21(data)                         ((0x08000000&(data))>>27)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_20(data)                         ((0x04000000&(data))>>26)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_14(data)                         ((0x02000000&(data))>>25)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_13(data)                         ((0x01000000&(data))>>24)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_12(data)                         ((0x00800000&(data))>>23)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_11(data)                         ((0x00400000&(data))>>22)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_10(data)                         ((0x00200000&(data))>>21)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_04(data)                         ((0x00100000&(data))>>20)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_03(data)                         ((0x00080000&(data))>>19)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_02(data)                         ((0x00040000&(data))>>18)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_01(data)                         ((0x00020000&(data))>>17)
#define  DI_tr2to1_get_cp_rtnr_k_force_modify_1_00(data)                         ((0x00010000&(data))>>16)
#define  DI_tr2to1_get_tr2to1_dist(data)                                         (0x000007FF&(data))

#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH                                        0x180241AC
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_reg_addr                                "0xB80241AC"
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_reg                                     0xB80241AC
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_inst_addr                               "0x0066"
#define  set_DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_reg)=data)
#define  get_DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_reg))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_24_shift       (30)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_23_shift       (29)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_22_shift       (28)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_21_shift       (27)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_20_shift       (26)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_14_shift       (25)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_13_shift       (24)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_12_shift       (23)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_11_shift       (22)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_10_shift       (21)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_04_shift       (20)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_03_shift       (19)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_02_shift       (18)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_01_shift       (17)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_00_shift       (16)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_24_shift       (14)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_23_shift       (13)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_22_shift       (12)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_21_shift       (11)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_20_shift       (10)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_14_shift       (9)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_13_shift       (8)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_12_shift       (7)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_11_shift       (6)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_10_shift       (5)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_04_shift       (4)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_03_shift       (3)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_02_shift       (2)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_01_shift       (1)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_00_shift       (0)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_24_mask        (0x40000000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_23_mask        (0x20000000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_22_mask        (0x10000000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_21_mask        (0x08000000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_20_mask        (0x04000000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_14_mask        (0x02000000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_13_mask        (0x01000000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_12_mask        (0x00800000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_11_mask        (0x00400000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_10_mask        (0x00200000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_04_mask        (0x00100000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_03_mask        (0x00080000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_02_mask        (0x00040000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_01_mask        (0x00020000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_00_mask        (0x00010000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_24_mask        (0x00004000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_23_mask        (0x00002000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_22_mask        (0x00001000)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_21_mask        (0x00000800)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_20_mask        (0x00000400)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_14_mask        (0x00000200)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_13_mask        (0x00000100)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_12_mask        (0x00000080)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_11_mask        (0x00000040)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_10_mask        (0x00000020)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_04_mask        (0x00000010)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_03_mask        (0x00000008)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_02_mask        (0x00000004)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_01_mask        (0x00000002)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_00_mask        (0x00000001)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_24(data)       (0x40000000&((data)<<30))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_23(data)       (0x20000000&((data)<<29))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_22(data)       (0x10000000&((data)<<28))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_21(data)       (0x08000000&((data)<<27))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_20(data)       (0x04000000&((data)<<26))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_14(data)       (0x02000000&((data)<<25))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_13(data)       (0x01000000&((data)<<24))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_12(data)       (0x00800000&((data)<<23))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_11(data)       (0x00400000&((data)<<22))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_10(data)       (0x00200000&((data)<<21))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_04(data)       (0x00100000&((data)<<20))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_03(data)       (0x00080000&((data)<<19))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_02(data)       (0x00040000&((data)<<18))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_01(data)       (0x00020000&((data)<<17))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_3_00(data)       (0x00010000&((data)<<16))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_24(data)       (0x00004000&((data)<<14))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_23(data)       (0x00002000&((data)<<13))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_22(data)       (0x00001000&((data)<<12))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_21(data)       (0x00000800&((data)<<11))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_20(data)       (0x00000400&((data)<<10))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_14(data)       (0x00000200&((data)<<9))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_13(data)       (0x00000100&((data)<<8))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_12(data)       (0x00000080&((data)<<7))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_11(data)       (0x00000040&((data)<<6))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_10(data)       (0x00000020&((data)<<5))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_04(data)       (0x00000010&((data)<<4))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_03(data)       (0x00000008&((data)<<3))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_02(data)       (0x00000004&((data)<<2))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_01(data)       (0x00000002&((data)<<1))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_cp_rtnr_k_force_modify_2_00(data)       (0x00000001&(data))
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_24(data)   ((0x40000000&(data))>>30)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_23(data)   ((0x20000000&(data))>>29)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_22(data)   ((0x10000000&(data))>>28)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_21(data)   ((0x08000000&(data))>>27)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_20(data)   ((0x04000000&(data))>>26)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_14(data)   ((0x02000000&(data))>>25)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_13(data)   ((0x01000000&(data))>>24)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_12(data)   ((0x00800000&(data))>>23)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_11(data)   ((0x00400000&(data))>>22)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_10(data)   ((0x00200000&(data))>>21)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_04(data)   ((0x00100000&(data))>>20)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_03(data)   ((0x00080000&(data))>>19)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_02(data)   ((0x00040000&(data))>>18)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_01(data)   ((0x00020000&(data))>>17)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_3_00(data)   ((0x00010000&(data))>>16)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_24(data)   ((0x00004000&(data))>>14)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_23(data)   ((0x00002000&(data))>>13)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_22(data)   ((0x00001000&(data))>>12)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_21(data)   ((0x00000800&(data))>>11)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_20(data)   ((0x00000400&(data))>>10)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_14(data)   ((0x00000200&(data))>>9)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_13(data)   ((0x00000100&(data))>>8)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_12(data)   ((0x00000080&(data))>>7)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_11(data)   ((0x00000040&(data))>>6)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_10(data)   ((0x00000020&(data))>>5)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_04(data)   ((0x00000010&(data))>>4)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_03(data)   ((0x00000008&(data))>>3)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_02(data)   ((0x00000004&(data))>>2)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_01(data)   ((0x00000002&(data))>>1)
#define  DI_IM_DI_RTNR_K_FORCE_MODIFY_TH_get_cp_rtnr_k_force_modify_2_00(data)   (0x00000001&(data))

#define  DI_IM_DI_RTNR_MAD_Y_TH                                                 0x180241B0
#define  DI_IM_DI_RTNR_MAD_Y_TH_reg_addr                                         "0xB80241B0"
#define  DI_IM_DI_RTNR_MAD_Y_TH_reg                                              0xB80241B0
#define  DI_IM_DI_RTNR_MAD_Y_TH_inst_addr                                        "0x0067"
#define  set_DI_IM_DI_RTNR_MAD_Y_TH_reg(data)                                    (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_Y_TH_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_Y_TH_reg                                          (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_Y_TH_reg))
#define  DI_IM_DI_RTNR_MAD_Y_TH_cp_temporal_mad_y_th1_shift                      (16)
#define  DI_IM_DI_RTNR_MAD_Y_TH_cp_temporal_mad_y_th2_shift                      (0)
#define  DI_IM_DI_RTNR_MAD_Y_TH_cp_temporal_mad_y_th1_mask                       (0x07FF0000)
#define  DI_IM_DI_RTNR_MAD_Y_TH_cp_temporal_mad_y_th2_mask                       (0x000007FF)
#define  DI_IM_DI_RTNR_MAD_Y_TH_cp_temporal_mad_y_th1(data)                      (0x07FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MAD_Y_TH_cp_temporal_mad_y_th2(data)                      (0x000007FF&(data))
#define  DI_IM_DI_RTNR_MAD_Y_TH_get_cp_temporal_mad_y_th1(data)                  ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MAD_Y_TH_get_cp_temporal_mad_y_th2(data)                  (0x000007FF&(data))

#define  DI_IM_DI_RTNR_MAD_C_TH                                                 0x180241B4
#define  DI_IM_DI_RTNR_MAD_C_TH_reg_addr                                         "0xB80241B4"
#define  DI_IM_DI_RTNR_MAD_C_TH_reg                                              0xB80241B4
#define  DI_IM_DI_RTNR_MAD_C_TH_inst_addr                                        "0x0068"
#define  set_DI_IM_DI_RTNR_MAD_C_TH_reg(data)                                    (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_C_TH_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_C_TH_reg                                          (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_C_TH_reg))
#define  DI_IM_DI_RTNR_MAD_C_TH_cp_temporal_mad_c_th1_shift                      (16)
#define  DI_IM_DI_RTNR_MAD_C_TH_cp_temporal_mad_c_th2_shift                      (0)
#define  DI_IM_DI_RTNR_MAD_C_TH_cp_temporal_mad_c_th1_mask                       (0x07FF0000)
#define  DI_IM_DI_RTNR_MAD_C_TH_cp_temporal_mad_c_th2_mask                       (0x000007FF)
#define  DI_IM_DI_RTNR_MAD_C_TH_cp_temporal_mad_c_th1(data)                      (0x07FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MAD_C_TH_cp_temporal_mad_c_th2(data)                      (0x000007FF&(data))
#define  DI_IM_DI_RTNR_MAD_C_TH_get_cp_temporal_mad_c_th1(data)                  ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MAD_C_TH_get_cp_temporal_mad_c_th2(data)                  (0x000007FF&(data))

#define  DI_IM_DI_RTNR_MAD_Y_COUNTER                                            0x180241B8
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_reg_addr                                    "0xB80241B8"
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_reg                                         0xB80241B8
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_inst_addr                                   "0x0069"
#define  set_DI_IM_DI_RTNR_MAD_Y_COUNTER_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_Y_COUNTER_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_Y_COUNTER_reg                                     (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_Y_COUNTER_reg))
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_cp_temporal_mad_countery_shift              (0)
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_cp_temporal_mad_countery_mask               (0x001FFFFF)
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_cp_temporal_mad_countery(data)              (0x001FFFFF&(data))
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_get_cp_temporal_mad_countery(data)          (0x001FFFFF&(data))

#define  DI_IM_DI_RTNR_MAD_U_COUNTER                                            0x180241BC
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_reg_addr                                    "0xB80241BC"
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_reg                                         0xB80241BC
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_inst_addr                                   "0x006A"
#define  set_DI_IM_DI_RTNR_MAD_U_COUNTER_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_U_COUNTER_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_U_COUNTER_reg                                     (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_U_COUNTER_reg))
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_cp_temporal_mad_counteru_shift              (0)
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_cp_temporal_mad_counteru_mask               (0x001FFFFF)
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_cp_temporal_mad_counteru(data)              (0x001FFFFF&(data))
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_get_cp_temporal_mad_counteru(data)          (0x001FFFFF&(data))

#define  DI_IM_DI_RTNR_MAD_V_COUNTER                                            0x180241C0
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_reg_addr                                    "0xB80241C0"
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_reg                                         0xB80241C0
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_inst_addr                                   "0x006B"
#define  set_DI_IM_DI_RTNR_MAD_V_COUNTER_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_V_COUNTER_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_V_COUNTER_reg                                     (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_V_COUNTER_reg))
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_cp_temporal_mad_counterv_shift              (0)
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_cp_temporal_mad_counterv_mask               (0x001FFFFF)
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_cp_temporal_mad_counterv(data)              (0x001FFFFF&(data))
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_get_cp_temporal_mad_counterv(data)          (0x001FFFFF&(data))

#define  DI_IM_DI_RTNR_EDIFF_CONTROL                                            0x180241C4
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_reg_addr                                    "0xB80241C4"
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_reg                                         0xB80241C4
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_inst_addr                                   "0x006C"
#define  set_DI_IM_DI_RTNR_EDIFF_CONTROL_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_RTNR_EDIFF_CONTROL_reg)=data)
#define  get_DI_IM_DI_RTNR_EDIFF_CONTROL_reg                                     (*((volatile unsigned int*)DI_IM_DI_RTNR_EDIFF_CONTROL_reg))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_24_shift           (30)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_23_shift           (29)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_22_shift           (28)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_21_shift           (27)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_20_shift           (26)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_14_shift           (25)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_13_shift           (24)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_12_shift           (23)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_11_shift           (22)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_10_shift           (21)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_04_shift           (20)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_03_shift           (19)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_02_shift           (18)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_01_shift           (17)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_00_shift           (16)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_dummy_15_13_shift                           (13)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_num_match_l_shift               (9)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_l_qlfy_th_shift                 (5)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_c_k_decision_shift              (2)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_edge_crct_en_shift              (1)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_24_mask            (0x40000000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_23_mask            (0x20000000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_22_mask            (0x10000000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_21_mask            (0x08000000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_20_mask            (0x04000000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_14_mask            (0x02000000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_13_mask            (0x01000000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_12_mask            (0x00800000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_11_mask            (0x00400000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_10_mask            (0x00200000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_04_mask            (0x00100000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_03_mask            (0x00080000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_02_mask            (0x00040000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_01_mask            (0x00020000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_00_mask            (0x00010000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_dummy_15_13_mask                            (0x0000E000)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_num_match_l_mask                (0x00001E00)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_l_qlfy_th_mask                  (0x000001E0)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_c_k_decision_mask               (0x0000001C)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_edge_crct_en_mask               (0x00000002)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_24(data)           (0x40000000&((data)<<30))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_23(data)           (0x20000000&((data)<<29))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_22(data)           (0x10000000&((data)<<28))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_21(data)           (0x08000000&((data)<<27))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_20(data)           (0x04000000&((data)<<26))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_14(data)           (0x02000000&((data)<<25))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_13(data)           (0x01000000&((data)<<24))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_12(data)           (0x00800000&((data)<<23))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_11(data)           (0x00400000&((data)<<22))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_10(data)           (0x00200000&((data)<<21))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_04(data)           (0x00100000&((data)<<20))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_03(data)           (0x00080000&((data)<<19))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_02(data)           (0x00040000&((data)<<18))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_01(data)           (0x00020000&((data)<<17))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_rtnr_k_force_modify_4_00(data)           (0x00010000&((data)<<16))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_dummy_15_13(data)                           (0x0000E000&((data)<<13))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_num_match_l(data)               (0x00001E00&((data)<<9))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_l_qlfy_th(data)                 (0x000001E0&((data)<<5))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_c_k_decision(data)              (0x0000001C&((data)<<2))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_cp_temporal_edge_crct_en(data)              (0x00000002&((data)<<1))
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_24(data)       ((0x40000000&(data))>>30)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_23(data)       ((0x20000000&(data))>>29)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_22(data)       ((0x10000000&(data))>>28)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_21(data)       ((0x08000000&(data))>>27)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_20(data)       ((0x04000000&(data))>>26)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_14(data)       ((0x02000000&(data))>>25)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_13(data)       ((0x01000000&(data))>>24)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_12(data)       ((0x00800000&(data))>>23)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_11(data)       ((0x00400000&(data))>>22)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_10(data)       ((0x00200000&(data))>>21)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_04(data)       ((0x00100000&(data))>>20)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_03(data)       ((0x00080000&(data))>>19)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_02(data)       ((0x00040000&(data))>>18)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_01(data)       ((0x00020000&(data))>>17)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_rtnr_k_force_modify_4_00(data)       ((0x00010000&(data))>>16)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_dummy_15_13(data)                       ((0x0000E000&(data))>>13)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_temporal_num_match_l(data)           ((0x00001E00&(data))>>9)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_temporal_l_qlfy_th(data)             ((0x000001E0&(data))>>5)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_temporal_c_k_decision(data)          ((0x0000001C&(data))>>2)
#define  DI_IM_DI_RTNR_EDIFF_CONTROL_get_cp_temporal_edge_crct_en(data)          ((0x00000002&(data))>>1)

#define  DI_IM_DI_RTNR_SAD_OFFSET                                               0x180241C8
#define  DI_IM_DI_RTNR_SAD_OFFSET_reg_addr                                       "0xB80241C8"
#define  DI_IM_DI_RTNR_SAD_OFFSET_reg                                            0xB80241C8
#define  DI_IM_DI_RTNR_SAD_OFFSET_inst_addr                                      "0x006D"
#define  set_DI_IM_DI_RTNR_SAD_OFFSET_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_RTNR_SAD_OFFSET_reg)=data)
#define  get_DI_IM_DI_RTNR_SAD_OFFSET_reg                                        (*((volatile unsigned int*)DI_IM_DI_RTNR_SAD_OFFSET_reg))
#define  DI_IM_DI_RTNR_SAD_OFFSET_cp_temporal_sad_offset_y_shift                 (16)
#define  DI_IM_DI_RTNR_SAD_OFFSET_cp_temporal_sad_offset_u_shift                 (8)
#define  DI_IM_DI_RTNR_SAD_OFFSET_cp_temporal_sad_offset_v_shift                 (0)
#define  DI_IM_DI_RTNR_SAD_OFFSET_cp_temporal_sad_offset_y_mask                  (0x00FF0000)
#define  DI_IM_DI_RTNR_SAD_OFFSET_cp_temporal_sad_offset_u_mask                  (0x0000FF00)
#define  DI_IM_DI_RTNR_SAD_OFFSET_cp_temporal_sad_offset_v_mask                  (0x000000FF)
#define  DI_IM_DI_RTNR_SAD_OFFSET_cp_temporal_sad_offset_y(data)                 (0x00FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_SAD_OFFSET_cp_temporal_sad_offset_u(data)                 (0x0000FF00&((data)<<8))
#define  DI_IM_DI_RTNR_SAD_OFFSET_cp_temporal_sad_offset_v(data)                 (0x000000FF&(data))
#define  DI_IM_DI_RTNR_SAD_OFFSET_get_cp_temporal_sad_offset_y(data)             ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_SAD_OFFSET_get_cp_temporal_sad_offset_u(data)             ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_RTNR_SAD_OFFSET_get_cp_temporal_sad_offset_v(data)             (0x000000FF&(data))

#define  DI_IM_DI_RTNR_EDIFF_TH                                                 0x180241CC
#define  DI_IM_DI_RTNR_EDIFF_TH_reg_addr                                         "0xB80241CC"
#define  DI_IM_DI_RTNR_EDIFF_TH_reg                                              0xB80241CC
#define  DI_IM_DI_RTNR_EDIFF_TH_inst_addr                                        "0x006E"
#define  set_DI_IM_DI_RTNR_EDIFF_TH_reg(data)                                    (*((volatile unsigned int*)DI_IM_DI_RTNR_EDIFF_TH_reg)=data)
#define  get_DI_IM_DI_RTNR_EDIFF_TH_reg                                          (*((volatile unsigned int*)DI_IM_DI_RTNR_EDIFF_TH_reg))
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th1_y_shift                        (24)
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th2_y_shift                        (16)
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th1_c_shift                        (8)
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th2_c_shift                        (0)
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th1_y_mask                         (0xFF000000)
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th2_y_mask                         (0x00FF0000)
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th1_c_mask                         (0x0000FF00)
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th2_c_mask                         (0x000000FF)
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th1_y(data)                        (0xFF000000&((data)<<24))
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th2_y(data)                        (0x00FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th1_c(data)                        (0x0000FF00&((data)<<8))
#define  DI_IM_DI_RTNR_EDIFF_TH_cp_temporal_e_th2_c(data)                        (0x000000FF&(data))
#define  DI_IM_DI_RTNR_EDIFF_TH_get_cp_temporal_e_th1_y(data)                    ((0xFF000000&(data))>>24)
#define  DI_IM_DI_RTNR_EDIFF_TH_get_cp_temporal_e_th2_y(data)                    ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_EDIFF_TH_get_cp_temporal_e_th1_c(data)                    ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_RTNR_EDIFF_TH_get_cp_temporal_e_th2_c(data)                    (0x000000FF&(data))

#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH                                           0x180241D0
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_reg_addr                                   "0xB80241D0"
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_reg                                        0xB80241D0
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_inst_addr                                  "0x006F"
#define  set_DI_IM_DI_RTNR_EDIFF_SOBEL_TH_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_RTNR_EDIFF_SOBEL_TH_reg)=data)
#define  get_DI_IM_DI_RTNR_EDIFF_SOBEL_TH_reg                                    (*((volatile unsigned int*)DI_IM_DI_RTNR_EDIFF_SOBEL_TH_reg))
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_dummy_31_22_shift                          (22)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_cp_temporal_sbl_thm_y_shift                (12)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_dummy_11_10_shift                          (10)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_cp_temporal_sbl_ths_y_shift                (0)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_dummy_31_22_mask                           (0xFFC00000)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_cp_temporal_sbl_thm_y_mask                 (0x003FF000)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_dummy_11_10_mask                           (0x00000C00)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_cp_temporal_sbl_ths_y_mask                 (0x000003FF)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_dummy_31_22(data)                          (0xFFC00000&((data)<<22))
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_cp_temporal_sbl_thm_y(data)                (0x003FF000&((data)<<12))
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_dummy_11_10(data)                          (0x00000C00&((data)<<10))
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_cp_temporal_sbl_ths_y(data)                (0x000003FF&(data))
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_get_dummy_31_22(data)                      ((0xFFC00000&(data))>>22)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_get_cp_temporal_sbl_thm_y(data)            ((0x003FF000&(data))>>12)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_get_dummy_11_10(data)                      ((0x00000C00&(data))>>10)
#define  DI_IM_DI_RTNR_EDIFF_SOBEL_TH_get_cp_temporal_sbl_ths_y(data)            (0x000003FF&(data))

#define  DI_IM_DI_RTNR_LEVEL_BOUND                                              0x180241D4
#define  DI_IM_DI_RTNR_LEVEL_BOUND_reg_addr                                      "0xB80241D4"
#define  DI_IM_DI_RTNR_LEVEL_BOUND_reg                                           0xB80241D4
#define  DI_IM_DI_RTNR_LEVEL_BOUND_inst_addr                                     "0x0070"
#define  set_DI_IM_DI_RTNR_LEVEL_BOUND_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_LEVEL_BOUND_reg)=data)
#define  get_DI_IM_DI_RTNR_LEVEL_BOUND_reg                                       (*((volatile unsigned int*)DI_IM_DI_RTNR_LEVEL_BOUND_reg))
#define  DI_IM_DI_RTNR_LEVEL_BOUND_cp_temporal_nl_up_bnd_y_shift                 (8)
#define  DI_IM_DI_RTNR_LEVEL_BOUND_cp_temporal_nl_low_bnd_y_shift                (0)
#define  DI_IM_DI_RTNR_LEVEL_BOUND_cp_temporal_nl_up_bnd_y_mask                  (0x0000FF00)
#define  DI_IM_DI_RTNR_LEVEL_BOUND_cp_temporal_nl_low_bnd_y_mask                 (0x000000FF)
#define  DI_IM_DI_RTNR_LEVEL_BOUND_cp_temporal_nl_up_bnd_y(data)                 (0x0000FF00&((data)<<8))
#define  DI_IM_DI_RTNR_LEVEL_BOUND_cp_temporal_nl_low_bnd_y(data)                (0x000000FF&(data))
#define  DI_IM_DI_RTNR_LEVEL_BOUND_get_cp_temporal_nl_up_bnd_y(data)             ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_RTNR_LEVEL_BOUND_get_cp_temporal_nl_low_bnd_y(data)            (0x000000FF&(data))

#define  DI_IM_DI_RTNR_ET_COUNT_Y                                               0x180241D8
#define  DI_IM_DI_RTNR_ET_COUNT_Y_reg_addr                                       "0xB80241D8"
#define  DI_IM_DI_RTNR_ET_COUNT_Y_reg                                            0xB80241D8
#define  DI_IM_DI_RTNR_ET_COUNT_Y_inst_addr                                      "0x0071"
#define  set_DI_IM_DI_RTNR_ET_COUNT_Y_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_RTNR_ET_COUNT_Y_reg)=data)
#define  get_DI_IM_DI_RTNR_ET_COUNT_Y_reg                                        (*((volatile unsigned int*)DI_IM_DI_RTNR_ET_COUNT_Y_reg))
#define  DI_IM_DI_RTNR_ET_COUNT_Y_cp_temporal_same_et_cnt_y_shift                (0)
#define  DI_IM_DI_RTNR_ET_COUNT_Y_cp_temporal_same_et_cnt_y_mask                 (0x00FFFFFF)
#define  DI_IM_DI_RTNR_ET_COUNT_Y_cp_temporal_same_et_cnt_y(data)                (0x00FFFFFF&(data))
#define  DI_IM_DI_RTNR_ET_COUNT_Y_get_cp_temporal_same_et_cnt_y(data)            (0x00FFFFFF&(data))

#define  DI_IM_DI_RTNR_ET_SUM_Y                                                 0x180241DC
#define  DI_IM_DI_RTNR_ET_SUM_Y_reg_addr                                         "0xB80241DC"
#define  DI_IM_DI_RTNR_ET_SUM_Y_reg                                              0xB80241DC
#define  DI_IM_DI_RTNR_ET_SUM_Y_inst_addr                                        "0x0072"
#define  set_DI_IM_DI_RTNR_ET_SUM_Y_reg(data)                                    (*((volatile unsigned int*)DI_IM_DI_RTNR_ET_SUM_Y_reg)=data)
#define  get_DI_IM_DI_RTNR_ET_SUM_Y_reg                                          (*((volatile unsigned int*)DI_IM_DI_RTNR_ET_SUM_Y_reg))
#define  DI_IM_DI_RTNR_ET_SUM_Y_cp_temporal_same_et_sad_sum_y_shift              (0)
#define  DI_IM_DI_RTNR_ET_SUM_Y_cp_temporal_same_et_sad_sum_y_mask               (0xFFFFFFFF)
#define  DI_IM_DI_RTNR_ET_SUM_Y_cp_temporal_same_et_sad_sum_y(data)              (0xFFFFFFFF&(data))
#define  DI_IM_DI_RTNR_ET_SUM_Y_get_cp_temporal_same_et_sad_sum_y(data)          (0xFFFFFFFF&(data))

#define  DI_IM_DI_RTNR_ET_SUM_U                                                 0x180241E0
#define  DI_IM_DI_RTNR_ET_SUM_U_reg_addr                                         "0xB80241E0"
#define  DI_IM_DI_RTNR_ET_SUM_U_reg                                              0xB80241E0
#define  DI_IM_DI_RTNR_ET_SUM_U_inst_addr                                        "0x0073"
#define  set_DI_IM_DI_RTNR_ET_SUM_U_reg(data)                                    (*((volatile unsigned int*)DI_IM_DI_RTNR_ET_SUM_U_reg)=data)
#define  get_DI_IM_DI_RTNR_ET_SUM_U_reg                                          (*((volatile unsigned int*)DI_IM_DI_RTNR_ET_SUM_U_reg))
#define  DI_IM_DI_RTNR_ET_SUM_U_cp_temporal_same_et_sad_sum_u_shift              (0)
#define  DI_IM_DI_RTNR_ET_SUM_U_cp_temporal_same_et_sad_sum_u_mask               (0xFFFFFFFF)
#define  DI_IM_DI_RTNR_ET_SUM_U_cp_temporal_same_et_sad_sum_u(data)              (0xFFFFFFFF&(data))
#define  DI_IM_DI_RTNR_ET_SUM_U_get_cp_temporal_same_et_sad_sum_u(data)          (0xFFFFFFFF&(data))

#define  DI_IM_DI_RTNR_ET_SUM_V                                                 0x180241E4
#define  DI_IM_DI_RTNR_ET_SUM_V_reg_addr                                         "0xB80241E4"
#define  DI_IM_DI_RTNR_ET_SUM_V_reg                                              0xB80241E4
#define  DI_IM_DI_RTNR_ET_SUM_V_inst_addr                                        "0x0074"
#define  set_DI_IM_DI_RTNR_ET_SUM_V_reg(data)                                    (*((volatile unsigned int*)DI_IM_DI_RTNR_ET_SUM_V_reg)=data)
#define  get_DI_IM_DI_RTNR_ET_SUM_V_reg                                          (*((volatile unsigned int*)DI_IM_DI_RTNR_ET_SUM_V_reg))
#define  DI_IM_DI_RTNR_ET_SUM_V_cp_temporal_same_et_sad_sum_v_shift              (0)
#define  DI_IM_DI_RTNR_ET_SUM_V_cp_temporal_same_et_sad_sum_v_mask               (0xFFFFFFFF)
#define  DI_IM_DI_RTNR_ET_SUM_V_cp_temporal_same_et_sad_sum_v(data)              (0xFFFFFFFF&(data))
#define  DI_IM_DI_RTNR_ET_SUM_V_get_cp_temporal_same_et_sad_sum_v(data)          (0xFFFFFFFF&(data))

#define  DI_IM_DI_TNR_XC_CONTROL                                                0x180241E8
#define  DI_IM_DI_TNR_XC_CONTROL_reg_addr                                        "0xB80241E8"
#define  DI_IM_DI_TNR_XC_CONTROL_reg                                             0xB80241E8
#define  DI_IM_DI_TNR_XC_CONTROL_inst_addr                                       "0x0075"
#define  set_DI_IM_DI_TNR_XC_CONTROL_reg(data)                                   (*((volatile unsigned int*)DI_IM_DI_TNR_XC_CONTROL_reg)=data)
#define  get_DI_IM_DI_TNR_XC_CONTROL_reg                                         (*((volatile unsigned int*)DI_IM_DI_TNR_XC_CONTROL_reg))
#define  DI_IM_DI_TNR_XC_CONTROL_set_sobeledgetypeen_shift                       (31)
#define  DI_IM_DI_TNR_XC_CONTROL_set_stillmotion_tha_shift                       (27)
#define  DI_IM_DI_TNR_XC_CONTROL_set_stillmotion_thb_shift                       (23)
#define  DI_IM_DI_TNR_XC_CONTROL_set_stillmotion_thc_shift                       (19)
#define  DI_IM_DI_TNR_XC_CONTROL_set_classifysmooth_shift                        (16)
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_verystill_shift                (12)
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_still_shift                    (9)
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_motion_shift                   (6)
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_verymotion_shift               (2)
#define  DI_IM_DI_TNR_XC_CONTROL_cp_temporal_xc_switch_shift                     (1)
#define  DI_IM_DI_TNR_XC_CONTROL_cp_temporal_xc_en_shift                         (0)
#define  DI_IM_DI_TNR_XC_CONTROL_set_sobeledgetypeen_mask                        (0x80000000)
#define  DI_IM_DI_TNR_XC_CONTROL_set_stillmotion_tha_mask                        (0x78000000)
#define  DI_IM_DI_TNR_XC_CONTROL_set_stillmotion_thb_mask                        (0x07800000)
#define  DI_IM_DI_TNR_XC_CONTROL_set_stillmotion_thc_mask                        (0x00780000)
#define  DI_IM_DI_TNR_XC_CONTROL_set_classifysmooth_mask                         (0x00070000)
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_verystill_mask                 (0x0000F000)
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_still_mask                     (0x00000E00)
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_motion_mask                    (0x000001C0)
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_verymotion_mask                (0x0000003C)
#define  DI_IM_DI_TNR_XC_CONTROL_cp_temporal_xc_switch_mask                      (0x00000002)
#define  DI_IM_DI_TNR_XC_CONTROL_cp_temporal_xc_en_mask                          (0x00000001)
#define  DI_IM_DI_TNR_XC_CONTROL_set_sobeledgetypeen(data)                       (0x80000000&((data)<<31))
#define  DI_IM_DI_TNR_XC_CONTROL_set_stillmotion_tha(data)                       (0x78000000&((data)<<27))
#define  DI_IM_DI_TNR_XC_CONTROL_set_stillmotion_thb(data)                       (0x07800000&((data)<<23))
#define  DI_IM_DI_TNR_XC_CONTROL_set_stillmotion_thc(data)                       (0x00780000&((data)<<19))
#define  DI_IM_DI_TNR_XC_CONTROL_set_classifysmooth(data)                        (0x00070000&((data)<<16))
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_verystill(data)                (0x0000F000&((data)<<12))
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_still(data)                    (0x00000E00&((data)<<9))
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_motion(data)                   (0x000001C0&((data)<<6))
#define  DI_IM_DI_TNR_XC_CONTROL_set_frame_offset_verymotion(data)               (0x0000003C&((data)<<2))
#define  DI_IM_DI_TNR_XC_CONTROL_cp_temporal_xc_switch(data)                     (0x00000002&((data)<<1))
#define  DI_IM_DI_TNR_XC_CONTROL_cp_temporal_xc_en(data)                         (0x00000001&(data))
#define  DI_IM_DI_TNR_XC_CONTROL_get_set_sobeledgetypeen(data)                   ((0x80000000&(data))>>31)
#define  DI_IM_DI_TNR_XC_CONTROL_get_set_stillmotion_tha(data)                   ((0x78000000&(data))>>27)
#define  DI_IM_DI_TNR_XC_CONTROL_get_set_stillmotion_thb(data)                   ((0x07800000&(data))>>23)
#define  DI_IM_DI_TNR_XC_CONTROL_get_set_stillmotion_thc(data)                   ((0x00780000&(data))>>19)
#define  DI_IM_DI_TNR_XC_CONTROL_get_set_classifysmooth(data)                    ((0x00070000&(data))>>16)
#define  DI_IM_DI_TNR_XC_CONTROL_get_set_frame_offset_verystill(data)            ((0x0000F000&(data))>>12)
#define  DI_IM_DI_TNR_XC_CONTROL_get_set_frame_offset_still(data)                ((0x00000E00&(data))>>9)
#define  DI_IM_DI_TNR_XC_CONTROL_get_set_frame_offset_motion(data)               ((0x000001C0&(data))>>6)
#define  DI_IM_DI_TNR_XC_CONTROL_get_set_frame_offset_verymotion(data)           ((0x0000003C&(data))>>2)
#define  DI_IM_DI_TNR_XC_CONTROL_get_cp_temporal_xc_switch(data)                 ((0x00000002&(data))>>1)
#define  DI_IM_DI_TNR_XC_CONTROL_get_cp_temporal_xc_en(data)                     (0x00000001&(data))

#define  DI_IM_DI_HFD_CONTROL                                                   0x180241EC
#define  DI_IM_DI_HFD_CONTROL_reg_addr                                           "0xB80241EC"
#define  DI_IM_DI_HFD_CONTROL_reg                                                0xB80241EC
#define  DI_IM_DI_HFD_CONTROL_inst_addr                                          "0x0076"
#define  set_DI_IM_DI_HFD_CONTROL_reg(data)                                      (*((volatile unsigned int*)DI_IM_DI_HFD_CONTROL_reg)=data)
#define  get_DI_IM_DI_HFD_CONTROL_reg                                            (*((volatile unsigned int*)DI_IM_DI_HFD_CONTROL_reg))
#define  DI_IM_DI_HFD_CONTROL_set_sobeledgetype_sel_shift                        (30)
#define  DI_IM_DI_HFD_CONTROL_hfd_highfrequencydetectoren_shift                  (24)
#define  DI_IM_DI_HFD_CONTROL_hfd_highlowhighdiff_thl_shift                      (16)
#define  DI_IM_DI_HFD_CONTROL_hfd_highlowhighdiff_count_thl_shift                (8)
#define  DI_IM_DI_HFD_CONTROL_hfd_3x3blockteethcount_thl_shift                   (0)
#define  DI_IM_DI_HFD_CONTROL_set_sobeledgetype_sel_mask                         (0xC0000000)
#define  DI_IM_DI_HFD_CONTROL_hfd_highfrequencydetectoren_mask                   (0x01000000)
#define  DI_IM_DI_HFD_CONTROL_hfd_highlowhighdiff_thl_mask                       (0x00FF0000)
#define  DI_IM_DI_HFD_CONTROL_hfd_highlowhighdiff_count_thl_mask                 (0x00000F00)
#define  DI_IM_DI_HFD_CONTROL_hfd_3x3blockteethcount_thl_mask                    (0x0000000F)
#define  DI_IM_DI_HFD_CONTROL_set_sobeledgetype_sel(data)                        (0xC0000000&((data)<<30))
#define  DI_IM_DI_HFD_CONTROL_hfd_highfrequencydetectoren(data)                  (0x01000000&((data)<<24))
#define  DI_IM_DI_HFD_CONTROL_hfd_highlowhighdiff_thl(data)                      (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HFD_CONTROL_hfd_highlowhighdiff_count_thl(data)                (0x00000F00&((data)<<8))
#define  DI_IM_DI_HFD_CONTROL_hfd_3x3blockteethcount_thl(data)                   (0x0000000F&(data))
#define  DI_IM_DI_HFD_CONTROL_get_set_sobeledgetype_sel(data)                    ((0xC0000000&(data))>>30)
#define  DI_IM_DI_HFD_CONTROL_get_hfd_highfrequencydetectoren(data)              ((0x01000000&(data))>>24)
#define  DI_IM_DI_HFD_CONTROL_get_hfd_highlowhighdiff_thl(data)                  ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HFD_CONTROL_get_hfd_highlowhighdiff_count_thl(data)            ((0x00000F00&(data))>>8)
#define  DI_IM_DI_HFD_CONTROL_get_hfd_3x3blockteethcount_thl(data)               (0x0000000F&(data))

#define  DI_IM_DI_HFD_LINE_MOTION_COUNT                                         0x180241F0
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_reg_addr                                 "0xB80241F0"
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_reg                                      0xB80241F0
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_inst_addr                                "0x0077"
#define  set_DI_IM_DI_HFD_LINE_MOTION_COUNT_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_HFD_LINE_MOTION_COUNT_reg)=data)
#define  get_DI_IM_DI_HFD_LINE_MOTION_COUNT_reg                                  (*((volatile unsigned int*)DI_IM_DI_HFD_LINE_MOTION_COUNT_reg))
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_checklinemotioncounten_shift         (31)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_framekcombineoflinemotion_shift      (29)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_linemotioncount_thl2_shift           (16)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_linemotioncount_thl_shift            (0)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_checklinemotioncounten_mask          (0x80000000)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_framekcombineoflinemotion_mask       (0x60000000)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_linemotioncount_thl2_mask            (0x07FF0000)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_linemotioncount_thl_mask             (0x000007FF)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_checklinemotioncounten(data)         (0x80000000&((data)<<31))
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_framekcombineoflinemotion(data)      (0x60000000&((data)<<29))
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_linemotioncount_thl2(data)           (0x07FF0000&((data)<<16))
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_hfd_linemotioncount_thl(data)            (0x000007FF&(data))
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_get_hfd_checklinemotioncounten(data)     ((0x80000000&(data))>>31)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_get_hfd_framekcombineoflinemotion(data)  ((0x60000000&(data))>>29)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_get_hfd_linemotioncount_thl2(data)       ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_HFD_LINE_MOTION_COUNT_get_hfd_linemotioncount_thl(data)        (0x000007FF&(data))

#define  DI_IM_DI_HFD_STATISTIC                                                 0x180241F4
#define  DI_IM_DI_HFD_STATISTIC_reg_addr                                         "0xB80241F4"
#define  DI_IM_DI_HFD_STATISTIC_reg                                              0xB80241F4
#define  DI_IM_DI_HFD_STATISTIC_inst_addr                                        "0x0078"
#define  set_DI_IM_DI_HFD_STATISTIC_reg(data)                                    (*((volatile unsigned int*)DI_IM_DI_HFD_STATISTIC_reg)=data)
#define  get_DI_IM_DI_HFD_STATISTIC_reg                                          (*((volatile unsigned int*)DI_IM_DI_HFD_STATISTIC_reg))
#define  DI_IM_DI_HFD_STATISTIC_hfd_statistic_shift                              (0)
#define  DI_IM_DI_HFD_STATISTIC_hfd_statistic_mask                               (0x00FFFFFF)
#define  DI_IM_DI_HFD_STATISTIC_hfd_statistic(data)                              (0x00FFFFFF&(data))
#define  DI_IM_DI_HFD_STATISTIC_get_hfd_statistic(data)                          (0x00FFFFFF&(data))

#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY                                         0x180241F8
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_reg_addr                                 "0xB80241F8"
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_reg                                      0xB80241F8
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_inst_addr                                "0x0079"
#define  set_DI_IM_DI_HFD_MA_ERROR_RECOVERY_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_HFD_MA_ERROR_RECOVERY_reg)=data)
#define  get_DI_IM_DI_HFD_MA_ERROR_RECOVERY_reg                                  (*((volatile unsigned int*)DI_IM_DI_HFD_MA_ERROR_RECOVERY_reg))
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_hmc_window_en_shift                      (28)
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_hmc_window_top_shift                     (18)
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_hmc_window_bot_shift                     (8)
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_hmc_window_en_mask                       (0x10000000)
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_hmc_window_top_mask                      (0x0FFC0000)
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_hmc_window_bot_mask                      (0x0003FF00)
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_hmc_window_en(data)                      (0x10000000&((data)<<28))
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_hmc_window_top(data)                     (0x0FFC0000&((data)<<18))
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_hmc_window_bot(data)                     (0x0003FF00&((data)<<8))
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_get_hmc_window_en(data)                  ((0x10000000&(data))>>28)
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_get_hmc_window_top(data)                 ((0x0FFC0000&(data))>>18)
#define  DI_IM_DI_HFD_MA_ERROR_RECOVERY_get_hmc_window_bot(data)                 ((0x0003FF00&(data))>>8)

#define  DI_IM_DI_BTR_CONTROL                                                   0x18024208
#define  DI_IM_DI_BTR_CONTROL_reg_addr                                           "0xB8024208"
#define  DI_IM_DI_BTR_CONTROL_reg                                                0xB8024208
#define  DI_IM_DI_BTR_CONTROL_inst_addr                                          "0x007A"
#define  set_DI_IM_DI_BTR_CONTROL_reg(data)                                      (*((volatile unsigned int*)DI_IM_DI_BTR_CONTROL_reg)=data)
#define  get_DI_IM_DI_BTR_CONTROL_reg                                            (*((volatile unsigned int*)DI_IM_DI_BTR_CONTROL_reg))
#define  DI_IM_DI_BTR_CONTROL_btr_hmc_blendchoose_shift                          (26)
#define  DI_IM_DI_BTR_CONTROL_btr_blendtemporaldebugmode_shift                   (24)
#define  DI_IM_DI_BTR_CONTROL_btr_solb_cur1_count_shift                          (20)
#define  DI_IM_DI_BTR_CONTROL_btr_solb_cur0_count_shift                          (16)
#define  DI_IM_DI_BTR_CONTROL_btr_solb_temporallength_shift                      (12)
#define  DI_IM_DI_BTR_CONTROL_btr_info_save_mode_shift                           (10)
#define  DI_IM_DI_BTR_CONTROL_btr_blendtemporalrecovery_dma_en_shift             (9)
#define  DI_IM_DI_BTR_CONTROL_btr_sola_method0_blendtype_shift                   (8)
#define  DI_IM_DI_BTR_CONTROL_btr_sola_method0_successtime_shift                 (5)
#define  DI_IM_DI_BTR_CONTROL_btr_sola_method_shift                              (4)
#define  DI_IM_DI_BTR_CONTROL_btr_sola_temporallength_shift                      (2)
#define  DI_IM_DI_BTR_CONTROL_btr_solutiontype_shift                             (1)
#define  DI_IM_DI_BTR_CONTROL_btr_blendtemporalrecoveryen_shift                  (0)
#define  DI_IM_DI_BTR_CONTROL_btr_hmc_blendchoose_mask                           (0x04000000)
#define  DI_IM_DI_BTR_CONTROL_btr_blendtemporaldebugmode_mask                    (0x03000000)
#define  DI_IM_DI_BTR_CONTROL_btr_solb_cur1_count_mask                           (0x00700000)
#define  DI_IM_DI_BTR_CONTROL_btr_solb_cur0_count_mask                           (0x00070000)
#define  DI_IM_DI_BTR_CONTROL_btr_solb_temporallength_mask                       (0x00007000)
#define  DI_IM_DI_BTR_CONTROL_btr_info_save_mode_mask                            (0x00000C00)
#define  DI_IM_DI_BTR_CONTROL_btr_blendtemporalrecovery_dma_en_mask              (0x00000200)
#define  DI_IM_DI_BTR_CONTROL_btr_sola_method0_blendtype_mask                    (0x00000100)
#define  DI_IM_DI_BTR_CONTROL_btr_sola_method0_successtime_mask                  (0x000000E0)
#define  DI_IM_DI_BTR_CONTROL_btr_sola_method_mask                               (0x00000010)
#define  DI_IM_DI_BTR_CONTROL_btr_sola_temporallength_mask                       (0x0000000C)
#define  DI_IM_DI_BTR_CONTROL_btr_solutiontype_mask                              (0x00000002)
#define  DI_IM_DI_BTR_CONTROL_btr_blendtemporalrecoveryen_mask                   (0x00000001)
#define  DI_IM_DI_BTR_CONTROL_btr_hmc_blendchoose(data)                          (0x04000000&((data)<<26))
#define  DI_IM_DI_BTR_CONTROL_btr_blendtemporaldebugmode(data)                   (0x03000000&((data)<<24))
#define  DI_IM_DI_BTR_CONTROL_btr_solb_cur1_count(data)                          (0x00700000&((data)<<20))
#define  DI_IM_DI_BTR_CONTROL_btr_solb_cur0_count(data)                          (0x00070000&((data)<<16))
#define  DI_IM_DI_BTR_CONTROL_btr_solb_temporallength(data)                      (0x00007000&((data)<<12))
#define  DI_IM_DI_BTR_CONTROL_btr_info_save_mode(data)                           (0x00000C00&((data)<<10))
#define  DI_IM_DI_BTR_CONTROL_btr_blendtemporalrecovery_dma_en(data)             (0x00000200&((data)<<9))
#define  DI_IM_DI_BTR_CONTROL_btr_sola_method0_blendtype(data)                   (0x00000100&((data)<<8))
#define  DI_IM_DI_BTR_CONTROL_btr_sola_method0_successtime(data)                 (0x000000E0&((data)<<5))
#define  DI_IM_DI_BTR_CONTROL_btr_sola_method(data)                              (0x00000010&((data)<<4))
#define  DI_IM_DI_BTR_CONTROL_btr_sola_temporallength(data)                      (0x0000000C&((data)<<2))
#define  DI_IM_DI_BTR_CONTROL_btr_solutiontype(data)                             (0x00000002&((data)<<1))
#define  DI_IM_DI_BTR_CONTROL_btr_blendtemporalrecoveryen(data)                  (0x00000001&(data))
#define  DI_IM_DI_BTR_CONTROL_get_btr_hmc_blendchoose(data)                      ((0x04000000&(data))>>26)
#define  DI_IM_DI_BTR_CONTROL_get_btr_blendtemporaldebugmode(data)               ((0x03000000&(data))>>24)
#define  DI_IM_DI_BTR_CONTROL_get_btr_solb_cur1_count(data)                      ((0x00700000&(data))>>20)
#define  DI_IM_DI_BTR_CONTROL_get_btr_solb_cur0_count(data)                      ((0x00070000&(data))>>16)
#define  DI_IM_DI_BTR_CONTROL_get_btr_solb_temporallength(data)                  ((0x00007000&(data))>>12)
#define  DI_IM_DI_BTR_CONTROL_get_btr_info_save_mode(data)                       ((0x00000C00&(data))>>10)
#define  DI_IM_DI_BTR_CONTROL_get_btr_blendtemporalrecovery_dma_en(data)         ((0x00000200&(data))>>9)
#define  DI_IM_DI_BTR_CONTROL_get_btr_sola_method0_blendtype(data)               ((0x00000100&(data))>>8)
#define  DI_IM_DI_BTR_CONTROL_get_btr_sola_method0_successtime(data)             ((0x000000E0&(data))>>5)
#define  DI_IM_DI_BTR_CONTROL_get_btr_sola_method(data)                          ((0x00000010&(data))>>4)
#define  DI_IM_DI_BTR_CONTROL_get_btr_sola_temporallength(data)                  ((0x0000000C&(data))>>2)
#define  DI_IM_DI_BTR_CONTROL_get_btr_solutiontype(data)                         ((0x00000002&(data))>>1)
#define  DI_IM_DI_BTR_CONTROL_get_btr_blendtemporalrecoveryen(data)              (0x00000001&(data))

#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX                                      0x1802420C
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_reg_addr                              "0xB802420C"
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_reg                                   0xB802420C
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_inst_addr                             "0x007B"
#define  set_DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_reg(data)                         (*((volatile unsigned int*)DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_reg)=data)
#define  get_DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_reg                               (*((volatile unsigned int*)DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_reg))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre4_max_shift  (30)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre4_min_shift  (28)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre3_max_shift  (26)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre3_min_shift  (24)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre2_max_shift  (22)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre2_min_shift  (20)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre1_max_shift  (18)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre1_min_shift  (16)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre4_max_shift  (14)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre4_min_shift  (12)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre3_max_shift  (10)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre3_min_shift  (8)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre2_max_shift  (6)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre2_min_shift  (4)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre1_max_shift  (2)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre1_min_shift  (0)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre4_max_mask   (0xC0000000)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre4_min_mask   (0x30000000)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre3_max_mask   (0x0C000000)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre3_min_mask   (0x03000000)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre2_max_mask   (0x00C00000)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre2_min_mask   (0x00300000)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre1_max_mask   (0x000C0000)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre1_min_mask   (0x00030000)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre4_max_mask   (0x0000C000)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre4_min_mask   (0x00003000)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre3_max_mask   (0x00000C00)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre3_min_mask   (0x00000300)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre2_max_mask   (0x000000C0)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre2_min_mask   (0x00000030)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre1_max_mask   (0x0000000C)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre1_min_mask   (0x00000003)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre4_max(data)  (0xC0000000&((data)<<30))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre4_min(data)  (0x30000000&((data)<<28))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre3_max(data)  (0x0C000000&((data)<<26))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre3_min(data)  (0x03000000&((data)<<24))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre2_max(data)  (0x00C00000&((data)<<22))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre2_min(data)  (0x00300000&((data)<<20))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre1_max(data)  (0x000C0000&((data)<<18))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur1_pre1_min(data)  (0x00030000&((data)<<16))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre4_max(data)  (0x0000C000&((data)<<14))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre4_min(data)  (0x00003000&((data)<<12))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre3_max(data)  (0x00000C00&((data)<<10))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre3_min(data)  (0x00000300&((data)<<8))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre2_max(data)  (0x000000C0&((data)<<6))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre2_min(data)  (0x00000030&((data)<<4))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre1_max(data)  (0x0000000C&((data)<<2))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_btr_sola_method0_cur0_pre1_min(data)  (0x00000003&(data))
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur1_pre4_max(data) ((0xC0000000&(data))>>30)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur1_pre4_min(data) ((0x30000000&(data))>>28)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur1_pre3_max(data) ((0x0C000000&(data))>>26)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur1_pre3_min(data) ((0x03000000&(data))>>24)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur1_pre2_max(data) ((0x00C00000&(data))>>22)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur1_pre2_min(data) ((0x00300000&(data))>>20)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur1_pre1_max(data) ((0x000C0000&(data))>>18)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur1_pre1_min(data) ((0x00030000&(data))>>16)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur0_pre4_max(data) ((0x0000C000&(data))>>14)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur0_pre4_min(data) ((0x00003000&(data))>>12)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur0_pre3_max(data) ((0x00000C00&(data))>>10)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur0_pre3_min(data) ((0x00000300&(data))>>8)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur0_pre2_max(data) ((0x000000C0&(data))>>6)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur0_pre2_min(data) ((0x00000030&(data))>>4)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur0_pre1_max(data) ((0x0000000C&(data))>>2)
#define  DI_IM_DI_BTR_SOLA_METHOD0_MIN_MAX_get_btr_sola_method0_cur0_pre1_min(data) (0x00000003&(data))

#define  DI_IM_DI_BTR_LONGWEAVE_STATISTIC                                       0x18024210
#define  DI_IM_DI_BTR_LONGWEAVE_STATISTIC_reg_addr                               "0xB8024210"
#define  DI_IM_DI_BTR_LONGWEAVE_STATISTIC_reg                                    0xB8024210
#define  DI_IM_DI_BTR_LONGWEAVE_STATISTIC_inst_addr                              "0x007C"
#define  set_DI_IM_DI_BTR_LONGWEAVE_STATISTIC_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_BTR_LONGWEAVE_STATISTIC_reg)=data)
#define  get_DI_IM_DI_BTR_LONGWEAVE_STATISTIC_reg                                (*((volatile unsigned int*)DI_IM_DI_BTR_LONGWEAVE_STATISTIC_reg))
#define  DI_IM_DI_BTR_LONGWEAVE_STATISTIC_btr_longweavesum_shift                 (0)
#define  DI_IM_DI_BTR_LONGWEAVE_STATISTIC_btr_longweavesum_mask                  (0x00FFFFFF)
#define  DI_IM_DI_BTR_LONGWEAVE_STATISTIC_btr_longweavesum(data)                 (0x00FFFFFF&(data))
#define  DI_IM_DI_BTR_LONGWEAVE_STATISTIC_get_btr_longweavesum(data)             (0x00FFFFFF&(data))

#define  DI_IM_DI_BER_LOWPASS_STATISTIC                                         0x18024214
#define  DI_IM_DI_BER_LOWPASS_STATISTIC_reg_addr                                 "0xB8024214"
#define  DI_IM_DI_BER_LOWPASS_STATISTIC_reg                                      0xB8024214
#define  DI_IM_DI_BER_LOWPASS_STATISTIC_inst_addr                                "0x007D"
#define  set_DI_IM_DI_BER_LOWPASS_STATISTIC_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_BER_LOWPASS_STATISTIC_reg)=data)
#define  get_DI_IM_DI_BER_LOWPASS_STATISTIC_reg                                  (*((volatile unsigned int*)DI_IM_DI_BER_LOWPASS_STATISTIC_reg))
#define  DI_IM_DI_BER_LOWPASS_STATISTIC_ber_lowpasssum_shift                     (0)
#define  DI_IM_DI_BER_LOWPASS_STATISTIC_ber_lowpasssum_mask                      (0x00FFFFFF)
#define  DI_IM_DI_BER_LOWPASS_STATISTIC_ber_lowpasssum(data)                     (0x00FFFFFF&(data))
#define  DI_IM_DI_BER_LOWPASS_STATISTIC_get_ber_lowpasssum(data)                 (0x00FFFFFF&(data))

#define  DI_IM_DI_BER_SPATIAL_CONTROL                                           0x18024218
#define  DI_IM_DI_BER_SPATIAL_CONTROL_reg_addr                                   "0xB8024218"
#define  DI_IM_DI_BER_SPATIAL_CONTROL_reg                                        0xB8024218
#define  DI_IM_DI_BER_SPATIAL_CONTROL_inst_addr                                  "0x007E"
#define  set_DI_IM_DI_BER_SPATIAL_CONTROL_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_BER_SPATIAL_CONTROL_reg)=data)
#define  get_DI_IM_DI_BER_SPATIAL_CONTROL_reg                                    (*((volatile unsigned int*)DI_IM_DI_BER_SPATIAL_CONTROL_reg))
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_closeclevel_max_shift                  (16)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_closeclevel_min_shift                  (4)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_blendspatial_lpf_blendingtype_shift    (3)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_blendspatialclassify_shift             (1)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_blendspatialrecoveryen_shift           (0)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_closeclevel_max_mask                   (0x00FF0000)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_closeclevel_min_mask                   (0x00000FF0)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_blendspatial_lpf_blendingtype_mask     (0x00000008)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_blendspatialclassify_mask              (0x00000002)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_blendspatialrecoveryen_mask            (0x00000001)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_closeclevel_max(data)                  (0x00FF0000&((data)<<16))
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_closeclevel_min(data)                  (0x00000FF0&((data)<<4))
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_blendspatial_lpf_blendingtype(data)    (0x00000008&((data)<<3))
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_blendspatialclassify(data)             (0x00000002&((data)<<1))
#define  DI_IM_DI_BER_SPATIAL_CONTROL_ber_blendspatialrecoveryen(data)           (0x00000001&(data))
#define  DI_IM_DI_BER_SPATIAL_CONTROL_get_ber_closeclevel_max(data)              ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_get_ber_closeclevel_min(data)              ((0x00000FF0&(data))>>4)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_get_ber_blendspatial_lpf_blendingtype(data) ((0x00000008&(data))>>3)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_get_ber_blendspatialclassify(data)         ((0x00000002&(data))>>1)
#define  DI_IM_DI_BER_SPATIAL_CONTROL_get_ber_blendspatialrecoveryen(data)       (0x00000001&(data))

#define  DI_IM_DI_BER_SPATIAL_DIFFY                                             0x1802421C
#define  DI_IM_DI_BER_SPATIAL_DIFFY_reg_addr                                     "0xB802421C"
#define  DI_IM_DI_BER_SPATIAL_DIFFY_reg                                          0xB802421C
#define  DI_IM_DI_BER_SPATIAL_DIFFY_inst_addr                                    "0x007F"
#define  set_DI_IM_DI_BER_SPATIAL_DIFFY_reg(data)                                (*((volatile unsigned int*)DI_IM_DI_BER_SPATIAL_DIFFY_reg)=data)
#define  get_DI_IM_DI_BER_SPATIAL_DIFFY_reg                                      (*((volatile unsigned int*)DI_IM_DI_BER_SPATIAL_DIFFY_reg))
#define  DI_IM_DI_BER_SPATIAL_DIFFY_ber_diffylevel_max_shift                     (16)
#define  DI_IM_DI_BER_SPATIAL_DIFFY_ber_diffylevel_min_shift                     (0)
#define  DI_IM_DI_BER_SPATIAL_DIFFY_ber_diffylevel_max_mask                      (0x03FF0000)
#define  DI_IM_DI_BER_SPATIAL_DIFFY_ber_diffylevel_min_mask                      (0x000003FF)
#define  DI_IM_DI_BER_SPATIAL_DIFFY_ber_diffylevel_max(data)                     (0x03FF0000&((data)<<16))
#define  DI_IM_DI_BER_SPATIAL_DIFFY_ber_diffylevel_min(data)                     (0x000003FF&(data))
#define  DI_IM_DI_BER_SPATIAL_DIFFY_get_ber_diffylevel_max(data)                 ((0x03FF0000&(data))>>16)
#define  DI_IM_DI_BER_SPATIAL_DIFFY_get_ber_diffylevel_min(data)                 (0x000003FF&(data))

#define  DI_IM_DI_BER_TEMPORAL_CONTROL                                          0x18024220
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_reg_addr                                  "0xB8024220"
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_reg                                       0xB8024220
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_inst_addr                                 "0x0080"
#define  set_DI_IM_DI_BER_TEMPORAL_CONTROL_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_BER_TEMPORAL_CONTROL_reg)=data)
#define  get_DI_IM_DI_BER_TEMPORAL_CONTROL_reg                                   (*((volatile unsigned int*)DI_IM_DI_BER_TEMPORAL_CONTROL_reg))
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_totalcontinuesum_shift                (8)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_spatialcontinuelength_shift           (4)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_blendtemporaltype_shift               (3)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_blendtemporalblock_shift              (1)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_blendtemporalrevoeryen_shift          (0)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_totalcontinuesum_mask                 (0xFFFFFF00)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_spatialcontinuelength_mask            (0x000000F0)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_blendtemporaltype_mask                (0x00000008)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_blendtemporalblock_mask               (0x00000006)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_blendtemporalrevoeryen_mask           (0x00000001)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_totalcontinuesum(data)                (0xFFFFFF00&((data)<<8))
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_spatialcontinuelength(data)           (0x000000F0&((data)<<4))
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_blendtemporaltype(data)               (0x00000008&((data)<<3))
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_blendtemporalblock(data)              (0x00000006&((data)<<1))
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_ber_blendtemporalrevoeryen(data)          (0x00000001&(data))
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_get_ber_totalcontinuesum(data)            ((0xFFFFFF00&(data))>>8)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_get_ber_spatialcontinuelength(data)       ((0x000000F0&(data))>>4)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_get_ber_blendtemporaltype(data)           ((0x00000008&(data))>>3)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_get_ber_blendtemporalblock(data)          ((0x00000006&(data))>>1)
#define  DI_IM_DI_BER_TEMPORAL_CONTROL_get_ber_blendtemporalrevoeryen(data)      (0x00000001&(data))

#define  DI_IM_DI_HMC_LINE_CNT                                                  0x18024224
#define  DI_IM_DI_HMC_LINE_CNT_reg_addr                                          "0xB8024224"
#define  DI_IM_DI_HMC_LINE_CNT_reg                                               0xB8024224
#define  DI_IM_DI_HMC_LINE_CNT_inst_addr                                         "0x0081"
#define  set_DI_IM_DI_HMC_LINE_CNT_reg(data)                                     (*((volatile unsigned int*)DI_IM_DI_HMC_LINE_CNT_reg)=data)
#define  get_DI_IM_DI_HMC_LINE_CNT_reg                                           (*((volatile unsigned int*)DI_IM_DI_HMC_LINE_CNT_reg))
#define  DI_IM_DI_HMC_LINE_CNT_hmc_info_line_count2_shift                        (10)
#define  DI_IM_DI_HMC_LINE_CNT_hmc_info_line_count1_shift                        (0)
#define  DI_IM_DI_HMC_LINE_CNT_hmc_info_line_count2_mask                         (0x000FFC00)
#define  DI_IM_DI_HMC_LINE_CNT_hmc_info_line_count1_mask                         (0x000003FF)
#define  DI_IM_DI_HMC_LINE_CNT_hmc_info_line_count2(data)                        (0x000FFC00&((data)<<10))
#define  DI_IM_DI_HMC_LINE_CNT_hmc_info_line_count1(data)                        (0x000003FF&(data))
#define  DI_IM_DI_HMC_LINE_CNT_get_hmc_info_line_count2(data)                    ((0x000FFC00&(data))>>10)
#define  DI_IM_DI_HMC_LINE_CNT_get_hmc_info_line_count1(data)                    (0x000003FF&(data))

#define  DI_IM_DI_HMC_TEETH_CNT                                                 0x18024228
#define  DI_IM_DI_HMC_TEETH_CNT_reg_addr                                         "0xB8024228"
#define  DI_IM_DI_HMC_TEETH_CNT_reg                                              0xB8024228
#define  DI_IM_DI_HMC_TEETH_CNT_inst_addr                                        "0x0082"
#define  set_DI_IM_DI_HMC_TEETH_CNT_reg(data)                                    (*((volatile unsigned int*)DI_IM_DI_HMC_TEETH_CNT_reg)=data)
#define  get_DI_IM_DI_HMC_TEETH_CNT_reg                                          (*((volatile unsigned int*)DI_IM_DI_HMC_TEETH_CNT_reg))
#define  DI_IM_DI_HMC_TEETH_CNT_hmc_info_teeth_count2_shift                      (16)
#define  DI_IM_DI_HMC_TEETH_CNT_hmc_info_teeth_count1_shift                      (0)
#define  DI_IM_DI_HMC_TEETH_CNT_hmc_info_teeth_count2_mask                       (0xFFFF0000)
#define  DI_IM_DI_HMC_TEETH_CNT_hmc_info_teeth_count1_mask                       (0x0000FFFF)
#define  DI_IM_DI_HMC_TEETH_CNT_hmc_info_teeth_count2(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_HMC_TEETH_CNT_hmc_info_teeth_count1(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_HMC_TEETH_CNT_get_hmc_info_teeth_count2(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_HMC_TEETH_CNT_get_hmc_info_teeth_count1(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_HMC_INFO_RANGE_1                                              0x1802422C
#define  DI_IM_DI_HMC_INFO_RANGE_1_reg_addr                                      "0xB802422C"
#define  DI_IM_DI_HMC_INFO_RANGE_1_reg                                           0xB802422C
#define  DI_IM_DI_HMC_INFO_RANGE_1_inst_addr                                     "0x0083"
#define  set_DI_IM_DI_HMC_INFO_RANGE_1_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_HMC_INFO_RANGE_1_reg)=data)
#define  get_DI_IM_DI_HMC_INFO_RANGE_1_reg                                       (*((volatile unsigned int*)DI_IM_DI_HMC_INFO_RANGE_1_reg))
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_debug_en_shift                       (28)
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_vdiff_th_shift                       (20)
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_end1_shift                           (10)
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_start1_shift                         (0)
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_debug_en_mask                        (0x10000000)
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_vdiff_th_mask                        (0x0FF00000)
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_end1_mask                            (0x000FFC00)
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_start1_mask                          (0x000003FF)
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_debug_en(data)                       (0x10000000&((data)<<28))
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_vdiff_th(data)                       (0x0FF00000&((data)<<20))
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_end1(data)                           (0x000FFC00&((data)<<10))
#define  DI_IM_DI_HMC_INFO_RANGE_1_hmc_info_start1(data)                         (0x000003FF&(data))
#define  DI_IM_DI_HMC_INFO_RANGE_1_get_hmc_info_debug_en(data)                   ((0x10000000&(data))>>28)
#define  DI_IM_DI_HMC_INFO_RANGE_1_get_hmc_info_vdiff_th(data)                   ((0x0FF00000&(data))>>20)
#define  DI_IM_DI_HMC_INFO_RANGE_1_get_hmc_info_end1(data)                       ((0x000FFC00&(data))>>10)
#define  DI_IM_DI_HMC_INFO_RANGE_1_get_hmc_info_start1(data)                     (0x000003FF&(data))

#define  DI_IM_DI_HMC_INFO_RANGE_2                                              0x18024230
#define  DI_IM_DI_HMC_INFO_RANGE_2_reg_addr                                      "0xB8024230"
#define  DI_IM_DI_HMC_INFO_RANGE_2_reg                                           0xB8024230
#define  DI_IM_DI_HMC_INFO_RANGE_2_inst_addr                                     "0x0084"
#define  set_DI_IM_DI_HMC_INFO_RANGE_2_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_HMC_INFO_RANGE_2_reg)=data)
#define  get_DI_IM_DI_HMC_INFO_RANGE_2_reg                                       (*((volatile unsigned int*)DI_IM_DI_HMC_INFO_RANGE_2_reg))
#define  DI_IM_DI_HMC_INFO_RANGE_2_hmc_info_end2_shift                           (10)
#define  DI_IM_DI_HMC_INFO_RANGE_2_hmc_info_start2_shift                         (0)
#define  DI_IM_DI_HMC_INFO_RANGE_2_hmc_info_end2_mask                            (0x000FFC00)
#define  DI_IM_DI_HMC_INFO_RANGE_2_hmc_info_start2_mask                          (0x000003FF)
#define  DI_IM_DI_HMC_INFO_RANGE_2_hmc_info_end2(data)                           (0x000FFC00&((data)<<10))
#define  DI_IM_DI_HMC_INFO_RANGE_2_hmc_info_start2(data)                         (0x000003FF&(data))
#define  DI_IM_DI_HMC_INFO_RANGE_2_get_hmc_info_end2(data)                       ((0x000FFC00&(data))>>10)
#define  DI_IM_DI_HMC_INFO_RANGE_2_get_hmc_info_start2(data)                     (0x000003FF&(data))

#define  DI_IM_DI_FILM_MASK_DETECTION                                           0x18024270
#define  DI_IM_DI_FILM_MASK_DETECTION_reg_addr                                   "0xB8024270"
#define  DI_IM_DI_FILM_MASK_DETECTION_reg                                        0xB8024270
#define  DI_IM_DI_FILM_MASK_DETECTION_inst_addr                                  "0x0085"
#define  set_DI_IM_DI_FILM_MASK_DETECTION_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_FILM_MASK_DETECTION_reg)=data)
#define  get_DI_IM_DI_FILM_MASK_DETECTION_reg                                    (*((volatile unsigned int*)DI_IM_DI_FILM_MASK_DETECTION_reg))
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_frmdif_thd_shift                 (16)
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_fiedif_thd_shift                 (8)
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_pass_thd_shift                   (1)
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_en_shift                         (0)
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_frmdif_thd_mask                  (0x00FF0000)
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_fiedif_thd_mask                  (0x0000FF00)
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_pass_thd_mask                    (0x0000001E)
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_en_mask                          (0x00000001)
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_frmdif_thd(data)                 (0x00FF0000&((data)<<16))
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_fiedif_thd(data)                 (0x0000FF00&((data)<<8))
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_pass_thd(data)                   (0x0000001E&((data)<<1))
#define  DI_IM_DI_FILM_MASK_DETECTION_film_mask_en(data)                         (0x00000001&(data))
#define  DI_IM_DI_FILM_MASK_DETECTION_get_film_mask_frmdif_thd(data)             ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_FILM_MASK_DETECTION_get_film_mask_fiedif_thd(data)             ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_FILM_MASK_DETECTION_get_film_mask_pass_thd(data)               ((0x0000001E&(data))>>1)
#define  DI_IM_DI_FILM_MASK_DETECTION_get_film_mask_en(data)                     (0x00000001&(data))

#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK                                          0x18024274
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_reg_addr                                  "0xB8024274"
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_reg                                       0xB8024274
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_inst_addr                                 "0x0086"
#define  set_DI_IM_DI_FILM_EDGE_TYPE_CHECK_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_FILM_EDGE_TYPE_CHECK_reg)=data)
#define  get_DI_IM_DI_FILM_EDGE_TYPE_CHECK_reg                                   (*((volatile unsigned int*)DI_IM_DI_FILM_EDGE_TYPE_CHECK_reg))
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_sobelthm_shift              (18)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_sobelths_shift              (8)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_n_pass_shift                (4)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_l_pass_shift                (3)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_h_pass_shift                (2)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_r_pass_shift                (1)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_v_pass_shift                (0)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_sobelthm_mask               (0x0FFC0000)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_sobelths_mask               (0x0003FF00)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_n_pass_mask                 (0x00000010)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_l_pass_mask                 (0x00000008)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_h_pass_mask                 (0x00000004)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_r_pass_mask                 (0x00000002)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_v_pass_mask                 (0x00000001)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_sobelthm(data)              (0x0FFC0000&((data)<<18))
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_sobelths(data)              (0x0003FF00&((data)<<8))
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_n_pass(data)                (0x00000010&((data)<<4))
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_l_pass(data)                (0x00000008&((data)<<3))
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_h_pass(data)                (0x00000004&((data)<<2))
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_r_pass(data)                (0x00000002&((data)<<1))
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_film_edgetype_v_pass(data)                (0x00000001&(data))
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_get_film_edgetype_sobelthm(data)          ((0x0FFC0000&(data))>>18)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_get_film_edgetype_sobelths(data)          ((0x0003FF00&(data))>>8)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_get_film_edgetype_n_pass(data)            ((0x00000010&(data))>>4)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_get_film_edgetype_l_pass(data)            ((0x00000008&(data))>>3)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_get_film_edgetype_h_pass(data)            ((0x00000004&(data))>>2)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_get_film_edgetype_r_pass(data)            ((0x00000002&(data))>>1)
#define  DI_IM_DI_FILM_EDGE_TYPE_CHECK_get_film_edgetype_v_pass(data)            (0x00000001&(data))

#define  DI_IM_DI_HMC_3A                                                        0x18024280
#define  DI_IM_DI_HMC_3A_reg_addr                                                "0xB8024280"
#define  DI_IM_DI_HMC_3A_reg                                                     0xB8024280
#define  DI_IM_DI_HMC_3A_inst_addr                                               "0x0087"
#define  set_DI_IM_DI_HMC_3A_reg(data)                                           (*((volatile unsigned int*)DI_IM_DI_HMC_3A_reg)=data)
#define  get_DI_IM_DI_HMC_3A_reg                                                 (*((volatile unsigned int*)DI_IM_DI_HMC_3A_reg))
#define  DI_IM_DI_HMC_3A_hmc_startline_shift                                     (0)
#define  DI_IM_DI_HMC_3A_hmc_startline_mask                                      (0x000003FF)
#define  DI_IM_DI_HMC_3A_hmc_startline(data)                                     (0x000003FF&(data))
#define  DI_IM_DI_HMC_3A_get_hmc_startline(data)                                 (0x000003FF&(data))

#define  DI_IM_DI_HMC_STATISTIC1                                                0x18024288
#define  DI_IM_DI_HMC_STATISTIC1_reg_addr                                        "0xB8024288"
#define  DI_IM_DI_HMC_STATISTIC1_reg                                             0xB8024288
#define  DI_IM_DI_HMC_STATISTIC1_inst_addr                                       "0x0088"
#define  set_DI_IM_DI_HMC_STATISTIC1_reg(data)                                   (*((volatile unsigned int*)DI_IM_DI_HMC_STATISTIC1_reg)=data)
#define  get_DI_IM_DI_HMC_STATISTIC1_reg                                         (*((volatile unsigned int*)DI_IM_DI_HMC_STATISTIC1_reg))
#define  DI_IM_DI_HMC_STATISTIC1_ma_hmc_botline_shift                            (20)
#define  DI_IM_DI_HMC_STATISTIC1_ma_hmc_topline_shift                            (8)
#define  DI_IM_DI_HMC_STATISTIC1_ma_hmc_lineratio_shift                          (0)
#define  DI_IM_DI_HMC_STATISTIC1_ma_hmc_botline_mask                             (0xFFF00000)
#define  DI_IM_DI_HMC_STATISTIC1_ma_hmc_topline_mask                             (0x000FFF00)
#define  DI_IM_DI_HMC_STATISTIC1_ma_hmc_lineratio_mask                           (0x000000FF)
#define  DI_IM_DI_HMC_STATISTIC1_ma_hmc_botline(data)                            (0xFFF00000&((data)<<20))
#define  DI_IM_DI_HMC_STATISTIC1_ma_hmc_topline(data)                            (0x000FFF00&((data)<<8))
#define  DI_IM_DI_HMC_STATISTIC1_ma_hmc_lineratio(data)                          (0x000000FF&(data))
#define  DI_IM_DI_HMC_STATISTIC1_get_ma_hmc_botline(data)                        ((0xFFF00000&(data))>>20)
#define  DI_IM_DI_HMC_STATISTIC1_get_ma_hmc_topline(data)                        ((0x000FFF00&(data))>>8)
#define  DI_IM_DI_HMC_STATISTIC1_get_ma_hmc_lineratio(data)                      (0x000000FF&(data))

#define  DI_IM_DI_HMC_STATISTIC2                                                0x1802428C
#define  DI_IM_DI_HMC_STATISTIC2_reg_addr                                        "0xB802428C"
#define  DI_IM_DI_HMC_STATISTIC2_reg                                             0xB802428C
#define  DI_IM_DI_HMC_STATISTIC2_inst_addr                                       "0x0089"
#define  set_DI_IM_DI_HMC_STATISTIC2_reg(data)                                   (*((volatile unsigned int*)DI_IM_DI_HMC_STATISTIC2_reg)=data)
#define  get_DI_IM_DI_HMC_STATISTIC2_reg                                         (*((volatile unsigned int*)DI_IM_DI_HMC_STATISTIC2_reg))
#define  DI_IM_DI_HMC_STATISTIC2_ma_hmc_botline2_shift                           (16)
#define  DI_IM_DI_HMC_STATISTIC2_ma_hmc_topline2_shift                           (0)
#define  DI_IM_DI_HMC_STATISTIC2_ma_hmc_botline2_mask                            (0x0FFF0000)
#define  DI_IM_DI_HMC_STATISTIC2_ma_hmc_topline2_mask                            (0x00000FFF)
#define  DI_IM_DI_HMC_STATISTIC2_ma_hmc_botline2(data)                           (0x0FFF0000&((data)<<16))
#define  DI_IM_DI_HMC_STATISTIC2_ma_hmc_topline2(data)                           (0x00000FFF&(data))
#define  DI_IM_DI_HMC_STATISTIC2_get_ma_hmc_botline2(data)                       ((0x0FFF0000&(data))>>16)
#define  DI_IM_DI_HMC_STATISTIC2_get_ma_hmc_topline2(data)                       (0x00000FFF&(data))

#define  DI_IM_DI_NO_HS_MODE                                                    0x18024294
#define  DI_IM_DI_NO_HS_MODE_reg_addr                                            "0xB8024294"
#define  DI_IM_DI_NO_HS_MODE_reg                                                 0xB8024294
#define  DI_IM_DI_NO_HS_MODE_inst_addr                                           "0x008A"
#define  set_DI_IM_DI_NO_HS_MODE_reg(data)                                       (*((volatile unsigned int*)DI_IM_DI_NO_HS_MODE_reg)=data)
#define  get_DI_IM_DI_NO_HS_MODE_reg                                             (*((volatile unsigned int*)DI_IM_DI_NO_HS_MODE_reg))
#define  DI_IM_DI_NO_HS_MODE_hsd_in_hsize_shift                                  (16)
#define  DI_IM_DI_NO_HS_MODE_no_hs_mode_shift                                    (12)
#define  DI_IM_DI_NO_HS_MODE_hsd_in_vsize_shift                                  (0)
#define  DI_IM_DI_NO_HS_MODE_hsd_in_hsize_mask                                   (0x1FFF0000)
#define  DI_IM_DI_NO_HS_MODE_no_hs_mode_mask                                     (0x00001000)
#define  DI_IM_DI_NO_HS_MODE_hsd_in_vsize_mask                                   (0x00000FFF)
#define  DI_IM_DI_NO_HS_MODE_hsd_in_hsize(data)                                  (0x1FFF0000&((data)<<16))
#define  DI_IM_DI_NO_HS_MODE_no_hs_mode(data)                                    (0x00001000&((data)<<12))
#define  DI_IM_DI_NO_HS_MODE_hsd_in_vsize(data)                                  (0x00000FFF&(data))
#define  DI_IM_DI_NO_HS_MODE_get_hsd_in_hsize(data)                              ((0x1FFF0000&(data))>>16)
#define  DI_IM_DI_NO_HS_MODE_get_no_hs_mode(data)                                ((0x00001000&(data))>>12)
#define  DI_IM_DI_NO_HS_MODE_get_hsd_in_vsize(data)                              (0x00000FFF&(data))

#define  DI_IM_DI_HMC_STATISTIC3                                                0x18024290
#define  DI_IM_DI_HMC_STATISTIC3_reg_addr                                        "0xB8024290"
#define  DI_IM_DI_HMC_STATISTIC3_reg                                             0xB8024290
#define  DI_IM_DI_HMC_STATISTIC3_inst_addr                                       "0x008B"
#define  set_DI_IM_DI_HMC_STATISTIC3_reg(data)                                   (*((volatile unsigned int*)DI_IM_DI_HMC_STATISTIC3_reg)=data)
#define  get_DI_IM_DI_HMC_STATISTIC3_reg                                         (*((volatile unsigned int*)DI_IM_DI_HMC_STATISTIC3_reg))
#define  DI_IM_DI_HMC_STATISTIC3_ma_hmc_botline3_shift                           (16)
#define  DI_IM_DI_HMC_STATISTIC3_ma_hmc_topline3_shift                           (0)
#define  DI_IM_DI_HMC_STATISTIC3_ma_hmc_botline3_mask                            (0x0FFF0000)
#define  DI_IM_DI_HMC_STATISTIC3_ma_hmc_topline3_mask                            (0x00000FFF)
#define  DI_IM_DI_HMC_STATISTIC3_ma_hmc_botline3(data)                           (0x0FFF0000&((data)<<16))
#define  DI_IM_DI_HMC_STATISTIC3_ma_hmc_topline3(data)                           (0x00000FFF&(data))
#define  DI_IM_DI_HMC_STATISTIC3_get_ma_hmc_botline3(data)                       ((0x0FFF0000&(data))>>16)
#define  DI_IM_DI_HMC_STATISTIC3_get_ma_hmc_topline3(data)                       (0x00000FFF&(data))

#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL                                     0x18024298
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_reg_addr                             "0xB8024298"
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_reg                                  0xB8024298
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_inst_addr                            "0x008C"
#define  set_DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_reg)=data)
#define  get_DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_reg                              (*((volatile unsigned int*)DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_reg))
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_cnt_for_porch_size_shift             (16)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_tnrxc_pixel_counter_shift            (0)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_cnt_for_porch_size_mask              (0x007F0000)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_tnrxc_pixel_counter_mask             (0x0000FFFF)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_cnt_for_porch_size(data)             (0x007F0000&((data)<<16))
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_tnrxc_pixel_counter(data)            (0x0000FFFF&(data))
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_get_cnt_for_porch_size(data)         ((0x007F0000&(data))>>16)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_CTRL_get_tnrxc_pixel_counter(data)        (0x0000FFFF&(data))

#define  DI_IM_DI_FRAMESOBEL_STATISTIC                                          0x1802429C
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_reg_addr                                  "0xB802429C"
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_reg                                       0xB802429C
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_inst_addr                                 "0x008D"
#define  set_DI_IM_DI_FRAMESOBEL_STATISTIC_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_FRAMESOBEL_STATISTIC_reg)=data)
#define  get_DI_IM_DI_FRAMESOBEL_STATISTIC_reg                                   (*((volatile unsigned int*)DI_IM_DI_FRAMESOBEL_STATISTIC_reg))
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_vector_follow_pan_en_shift            (29)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_dynamic_threshold_max_clip_shift      (16)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_dynamic_threshold_bias_shift          (10)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_dynamic_threshold_en_shift            (9)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_vector_follow_pan_en_mask             (0x20000000)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_dynamic_threshold_max_clip_mask       (0x00FF0000)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_dynamic_threshold_bias_mask           (0x0000FC00)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_dynamic_threshold_en_mask             (0x00000200)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_vector_follow_pan_en(data)            (0x20000000&((data)<<29))
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_dynamic_threshold_max_clip(data)      (0x00FF0000&((data)<<16))
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_dynamic_threshold_bias(data)          (0x0000FC00&((data)<<10))
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_hmc_dynamic_threshold_en(data)            (0x00000200&((data)<<9))
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_get_hmc_vector_follow_pan_en(data)        ((0x20000000&(data))>>29)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_get_hmc_dynamic_threshold_max_clip(data)  ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_get_hmc_dynamic_threshold_bias(data)      ((0x0000FC00&(data))>>10)
#define  DI_IM_DI_FRAMESOBEL_STATISTIC_get_hmc_dynamic_threshold_en(data)        ((0x00000200&(data))>>9)

#define  DI_TNRXC_MkII_CTRL                                                     0x180242A0
#define  DI_TNRXC_MkII_CTRL_reg_addr                                             "0xB80242A0"
#define  DI_TNRXC_MkII_CTRL_reg                                                  0xB80242A0
#define  DI_TNRXC_MkII_CTRL_inst_addr                                            "0x008E"
#define  set_DI_TNRXC_MkII_CTRL_reg(data)                                        (*((volatile unsigned int*)DI_TNRXC_MkII_CTRL_reg)=data)
#define  get_DI_TNRXC_MkII_CTRL_reg                                              (*((volatile unsigned int*)DI_TNRXC_MkII_CTRL_reg))
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_thc2_shift                                (24)
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_thc1_shift                                (16)
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_thy_shift                                 (8)
#define  DI_TNRXC_MkII_CTRL_dummy_7_2_shift                                      (2)
#define  DI_TNRXC_MkII_CTRL_tnrxc_dbguvmode_shift                                (1)
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_en_shift                                  (0)
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_thc2_mask                                 (0xFF000000)
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_thc1_mask                                 (0x00FF0000)
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_thy_mask                                  (0x0000FF00)
#define  DI_TNRXC_MkII_CTRL_dummy_7_2_mask                                       (0x000000FC)
#define  DI_TNRXC_MkII_CTRL_tnrxc_dbguvmode_mask                                 (0x00000002)
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_en_mask                                   (0x00000001)
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_thc2(data)                                (0xFF000000&((data)<<24))
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_thc1(data)                                (0x00FF0000&((data)<<16))
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_thy(data)                                 (0x0000FF00&((data)<<8))
#define  DI_TNRXC_MkII_CTRL_dummy_7_2(data)                                      (0x000000FC&((data)<<2))
#define  DI_TNRXC_MkII_CTRL_tnrxc_dbguvmode(data)                                (0x00000002&((data)<<1))
#define  DI_TNRXC_MkII_CTRL_tnrxc_mkii_en(data)                                  (0x00000001&(data))
#define  DI_TNRXC_MkII_CTRL_get_tnrxc_mkii_thc2(data)                            ((0xFF000000&(data))>>24)
#define  DI_TNRXC_MkII_CTRL_get_tnrxc_mkii_thc1(data)                            ((0x00FF0000&(data))>>16)
#define  DI_TNRXC_MkII_CTRL_get_tnrxc_mkii_thy(data)                             ((0x0000FF00&(data))>>8)
#define  DI_TNRXC_MkII_CTRL_get_dummy_7_2(data)                                  ((0x000000FC&(data))>>2)
#define  DI_TNRXC_MkII_CTRL_get_tnrxc_dbguvmode(data)                            ((0x00000002&(data))>>1)
#define  DI_TNRXC_MkII_CTRL_get_tnrxc_mkii_en(data)                              (0x00000001&(data))

#define  DI_IM_DI_RTNR_K_Dark                                                   0x180242A4
#define  DI_IM_DI_RTNR_K_Dark_reg_addr                                           "0xB80242A4"
#define  DI_IM_DI_RTNR_K_Dark_reg                                                0xB80242A4
#define  DI_IM_DI_RTNR_K_Dark_inst_addr                                          "0x008F"
#define  set_DI_IM_DI_RTNR_K_Dark_reg(data)                                      (*((volatile unsigned int*)DI_IM_DI_RTNR_K_Dark_reg)=data)
#define  get_DI_IM_DI_RTNR_K_Dark_reg                                            (*((volatile unsigned int*)DI_IM_DI_RTNR_K_Dark_reg))
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kout_dark_2_shift                    (28)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kin_dark_2_shift                     (24)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_dark_th_shift                        (16)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kout_dark_shift                      (8)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kin_dark_shift                       (4)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_dark_k_en_shift                      (0)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kout_dark_2_mask                     (0xF0000000)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kin_dark_2_mask                      (0x0F000000)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_dark_th_mask                         (0x00FF0000)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kout_dark_mask                       (0x00000F00)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kin_dark_mask                        (0x000000F0)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_dark_k_en_mask                       (0x00000001)
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kout_dark_2(data)                    (0xF0000000&((data)<<28))
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kin_dark_2(data)                     (0x0F000000&((data)<<24))
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_dark_th(data)                        (0x00FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kout_dark(data)                      (0x00000F00&((data)<<8))
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_kin_dark(data)                       (0x000000F0&((data)<<4))
#define  DI_IM_DI_RTNR_K_Dark_cp_temporal_y_dark_k_en(data)                      (0x00000001&(data))
#define  DI_IM_DI_RTNR_K_Dark_get_cp_temporal_y_kout_dark_2(data)                ((0xF0000000&(data))>>28)
#define  DI_IM_DI_RTNR_K_Dark_get_cp_temporal_y_kin_dark_2(data)                 ((0x0F000000&(data))>>24)
#define  DI_IM_DI_RTNR_K_Dark_get_cp_temporal_y_dark_th(data)                    ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_K_Dark_get_cp_temporal_y_kout_dark(data)                  ((0x00000F00&(data))>>8)
#define  DI_IM_DI_RTNR_K_Dark_get_cp_temporal_y_kin_dark(data)                   ((0x000000F0&(data))>>4)
#define  DI_IM_DI_RTNR_K_Dark_get_cp_temporal_y_dark_k_en(data)                  (0x00000001&(data))

#define  DI_IM_DI_RTNR_REFINED_CTRL                                             0x180242A8
#define  DI_IM_DI_RTNR_REFINED_CTRL_reg_addr                                     "0xB80242A8"
#define  DI_IM_DI_RTNR_REFINED_CTRL_reg                                          0xB80242A8
#define  DI_IM_DI_RTNR_REFINED_CTRL_inst_addr                                    "0x0090"
#define  set_DI_IM_DI_RTNR_REFINED_CTRL_reg(data)                                (*((volatile unsigned int*)DI_IM_DI_RTNR_REFINED_CTRL_reg)=data)
#define  get_DI_IM_DI_RTNR_REFINED_CTRL_reg                                      (*((volatile unsigned int*)DI_IM_DI_RTNR_REFINED_CTRL_reg))
#define  DI_IM_DI_RTNR_REFINED_CTRL_dummy_31_29_shift                            (29)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_refined_c_en_shift                      (28)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_th_localedgediff_shift                  (16)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_stilledge_debug_shift                   (15)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_stilledge_bonusbias_shift               (12)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_localedge_debug_shift                   (11)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_act_bias_shift                          (8)
#define  DI_IM_DI_RTNR_REFINED_CTRL_dummy_7_shift                                (7)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_crct_bias_shift                         (4)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_crct_debug_shift                        (3)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_stilledge_en_shift                      (2)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_localedge_en_shift                      (1)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_new_formula_en_shift                    (0)
#define  DI_IM_DI_RTNR_REFINED_CTRL_dummy_31_29_mask                             (0xE0000000)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_refined_c_en_mask                       (0x10000000)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_th_localedgediff_mask                   (0x0FFF0000)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_stilledge_debug_mask                    (0x00008000)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_stilledge_bonusbias_mask                (0x00007000)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_localedge_debug_mask                    (0x00000800)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_act_bias_mask                           (0x00000700)
#define  DI_IM_DI_RTNR_REFINED_CTRL_dummy_7_mask                                 (0x00000080)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_crct_bias_mask                          (0x00000070)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_crct_debug_mask                         (0x00000008)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_stilledge_en_mask                       (0x00000004)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_localedge_en_mask                       (0x00000002)
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_new_formula_en_mask                     (0x00000001)
#define  DI_IM_DI_RTNR_REFINED_CTRL_dummy_31_29(data)                            (0xE0000000&((data)<<29))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_refined_c_en(data)                      (0x10000000&((data)<<28))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_th_localedgediff(data)                  (0x0FFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_stilledge_debug(data)                   (0x00008000&((data)<<15))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_stilledge_bonusbias(data)               (0x00007000&((data)<<12))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_localedge_debug(data)                   (0x00000800&((data)<<11))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_act_bias(data)                          (0x00000700&((data)<<8))
#define  DI_IM_DI_RTNR_REFINED_CTRL_dummy_7(data)                                (0x00000080&((data)<<7))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_crct_bias(data)                         (0x00000070&((data)<<4))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_crct_debug(data)                        (0x00000008&((data)<<3))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_stilledge_en(data)                      (0x00000004&((data)<<2))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_localedge_en(data)                      (0x00000002&((data)<<1))
#define  DI_IM_DI_RTNR_REFINED_CTRL_rtnr_new_formula_en(data)                    (0x00000001&(data))
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_dummy_31_29(data)                        ((0xE0000000&(data))>>29)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_refined_c_en(data)                  ((0x10000000&(data))>>28)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_th_localedgediff(data)              ((0x0FFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_stilledge_debug(data)               ((0x00008000&(data))>>15)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_stilledge_bonusbias(data)           ((0x00007000&(data))>>12)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_localedge_debug(data)               ((0x00000800&(data))>>11)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_act_bias(data)                      ((0x00000700&(data))>>8)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_dummy_7(data)                            ((0x00000080&(data))>>7)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_crct_bias(data)                     ((0x00000070&(data))>>4)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_crct_debug(data)                    ((0x00000008&(data))>>3)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_stilledge_en(data)                  ((0x00000004&(data))>>2)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_localedge_en(data)                  ((0x00000002&(data))>>1)
#define  DI_IM_DI_RTNR_REFINED_CTRL_get_rtnr_new_formula_en(data)                (0x00000001&(data))

#define  DI_IM_DI_RTNR_REFINED_CTRL2                                            0x180242AC
#define  DI_IM_DI_RTNR_REFINED_CTRL2_reg_addr                                    "0xB80242AC"
#define  DI_IM_DI_RTNR_REFINED_CTRL2_reg                                         0xB80242AC
#define  DI_IM_DI_RTNR_REFINED_CTRL2_inst_addr                                   "0x0091"
#define  set_DI_IM_DI_RTNR_REFINED_CTRL2_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_RTNR_REFINED_CTRL2_reg)=data)
#define  get_DI_IM_DI_RTNR_REFINED_CTRL2_reg                                     (*((volatile unsigned int*)DI_IM_DI_RTNR_REFINED_CTRL2_reg))
#define  DI_IM_DI_RTNR_REFINED_CTRL2_dummy_31_17_shift                           (17)
#define  DI_IM_DI_RTNR_REFINED_CTRL2_rtnr_stilledge_th_edgdiff_shift             (8)
#define  DI_IM_DI_RTNR_REFINED_CTRL2_rtnr_stilledge_th_edg_shift                 (0)
#define  DI_IM_DI_RTNR_REFINED_CTRL2_dummy_31_17_mask                            (0xFFFE0000)
#define  DI_IM_DI_RTNR_REFINED_CTRL2_rtnr_stilledge_th_edgdiff_mask              (0x0001FF00)
#define  DI_IM_DI_RTNR_REFINED_CTRL2_rtnr_stilledge_th_edg_mask                  (0x000000FF)
#define  DI_IM_DI_RTNR_REFINED_CTRL2_dummy_31_17(data)                           (0xFFFE0000&((data)<<17))
#define  DI_IM_DI_RTNR_REFINED_CTRL2_rtnr_stilledge_th_edgdiff(data)             (0x0001FF00&((data)<<8))
#define  DI_IM_DI_RTNR_REFINED_CTRL2_rtnr_stilledge_th_edg(data)                 (0x000000FF&(data))
#define  DI_IM_DI_RTNR_REFINED_CTRL2_get_dummy_31_17(data)                       ((0xFFFE0000&(data))>>17)
#define  DI_IM_DI_RTNR_REFINED_CTRL2_get_rtnr_stilledge_th_edgdiff(data)         ((0x0001FF00&(data))>>8)
#define  DI_IM_DI_RTNR_REFINED_CTRL2_get_rtnr_stilledge_th_edg(data)             (0x000000FF&(data))

#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C                                           0x180242C4
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_reg_addr                                   "0xB80242C4"
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_reg                                        0xB80242C4
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_inst_addr                                  "0x0092"
#define  set_DI_IM_DI_RTNR_EDIFF_ENABLE_C_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_RTNR_EDIFF_ENABLE_C_reg)=data)
#define  get_DI_IM_DI_RTNR_EDIFF_ENABLE_C_reg                                    (*((volatile unsigned int*)DI_IM_DI_RTNR_EDIFF_ENABLE_C_reg))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en6_shift              (6)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en5_shift              (5)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en4_shift              (4)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en3_shift              (3)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en2_shift              (2)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en1_shift              (1)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en0_shift              (0)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en6_mask               (0x00000040)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en5_mask               (0x00000020)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en4_mask               (0x00000010)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en3_mask               (0x00000008)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en2_mask               (0x00000004)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en1_mask               (0x00000002)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en0_mask               (0x00000001)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en6(data)              (0x00000040&((data)<<6))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en5(data)              (0x00000020&((data)<<5))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en4(data)              (0x00000010&((data)<<4))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en3(data)              (0x00000008&((data)<<3))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en2(data)              (0x00000004&((data)<<2))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en1(data)              (0x00000002&((data)<<1))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_cp_temporal_ediff_c_en0(data)              (0x00000001&(data))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_get_cp_temporal_ediff_c_en6(data)          ((0x00000040&(data))>>6)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_get_cp_temporal_ediff_c_en5(data)          ((0x00000020&(data))>>5)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_get_cp_temporal_ediff_c_en4(data)          ((0x00000010&(data))>>4)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_get_cp_temporal_ediff_c_en3(data)          ((0x00000008&(data))>>3)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_get_cp_temporal_ediff_c_en2(data)          ((0x00000004&(data))>>2)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_get_cp_temporal_ediff_c_en1(data)          ((0x00000002&(data))>>1)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_C_get_cp_temporal_ediff_c_en0(data)          (0x00000001&(data))

#define  DI_IM_DI_RTNR_EDIFF_ENABLE                                             0x180242C8
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_reg_addr                                     "0xB80242C8"
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_reg                                          0xB80242C8
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_inst_addr                                    "0x0093"
#define  set_DI_IM_DI_RTNR_EDIFF_ENABLE_reg(data)                                (*((volatile unsigned int*)DI_IM_DI_RTNR_EDIFF_ENABLE_reg)=data)
#define  get_DI_IM_DI_RTNR_EDIFF_ENABLE_reg                                      (*((volatile unsigned int*)DI_IM_DI_RTNR_EDIFF_ENABLE_reg))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_y_k_decision_shift               (16)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en14_shift                 (14)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en13_shift                 (13)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en12_shift                 (12)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en11_shift                 (11)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en10_shift                 (10)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en9_shift                  (9)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en8_shift                  (8)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en7_shift                  (7)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en6_shift                  (6)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en5_shift                  (5)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en4_shift                  (4)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en3_shift                  (3)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en2_shift                  (2)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en1_shift                  (1)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en0_shift                  (0)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_y_k_decision_mask                (0x00010000)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en14_mask                  (0x00004000)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en13_mask                  (0x00002000)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en12_mask                  (0x00001000)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en11_mask                  (0x00000800)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en10_mask                  (0x00000400)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en9_mask                   (0x00000200)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en8_mask                   (0x00000100)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en7_mask                   (0x00000080)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en6_mask                   (0x00000040)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en5_mask                   (0x00000020)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en4_mask                   (0x00000010)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en3_mask                   (0x00000008)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en2_mask                   (0x00000004)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en1_mask                   (0x00000002)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en0_mask                   (0x00000001)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_y_k_decision(data)               (0x00010000&((data)<<16))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en14(data)                 (0x00004000&((data)<<14))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en13(data)                 (0x00002000&((data)<<13))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en12(data)                 (0x00001000&((data)<<12))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en11(data)                 (0x00000800&((data)<<11))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en10(data)                 (0x00000400&((data)<<10))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en9(data)                  (0x00000200&((data)<<9))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en8(data)                  (0x00000100&((data)<<8))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en7(data)                  (0x00000080&((data)<<7))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en6(data)                  (0x00000040&((data)<<6))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en5(data)                  (0x00000020&((data)<<5))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en4(data)                  (0x00000010&((data)<<4))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en3(data)                  (0x00000008&((data)<<3))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en2(data)                  (0x00000004&((data)<<2))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en1(data)                  (0x00000002&((data)<<1))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_cp_temporal_ediff_en0(data)                  (0x00000001&(data))
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_y_k_decision(data)           ((0x00010000&(data))>>16)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en14(data)             ((0x00004000&(data))>>14)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en13(data)             ((0x00002000&(data))>>13)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en12(data)             ((0x00001000&(data))>>12)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en11(data)             ((0x00000800&(data))>>11)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en10(data)             ((0x00000400&(data))>>10)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en9(data)              ((0x00000200&(data))>>9)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en8(data)              ((0x00000100&(data))>>8)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en7(data)              ((0x00000080&(data))>>7)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en6(data)              ((0x00000040&(data))>>6)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en5(data)              ((0x00000020&(data))>>5)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en4(data)              ((0x00000010&(data))>>4)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en3(data)              ((0x00000008&(data))>>3)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en2(data)              ((0x00000004&(data))>>2)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en1(data)              ((0x00000002&(data))>>1)
#define  DI_IM_DI_RTNR_EDIFF_ENABLE_get_cp_temporal_ediff_en0(data)              (0x00000001&(data))

#define  DI_IM_DI_RTNR_HMCNR                                                    0x180242CC
#define  DI_IM_DI_RTNR_HMCNR_reg_addr                                            "0xB80242CC"
#define  DI_IM_DI_RTNR_HMCNR_reg                                                 0xB80242CC
#define  DI_IM_DI_RTNR_HMCNR_inst_addr                                           "0x0094"
#define  set_DI_IM_DI_RTNR_HMCNR_reg(data)                                       (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_reg)=data)
#define  get_DI_IM_DI_RTNR_HMCNR_reg                                             (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_reg))
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_mad_window_shift                  (22)
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_weight_shift                      (19)
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_y_en_shift                        (7)
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_debug_progressive_shift           (6)
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_uv_with_y_shift                   (4)
#define  DI_IM_DI_RTNR_HMCNR_hmcnr_mvx_avg_en_shift                              (3)
#define  DI_IM_DI_RTNR_HMCNR_hmcnr_mvy_avg_en_shift                              (2)
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_mad_window_mask                   (0x00C00000)
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_weight_mask                       (0x00380000)
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_y_en_mask                         (0x00000080)
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_debug_progressive_mask            (0x00000040)
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_uv_with_y_mask                    (0x00000010)
#define  DI_IM_DI_RTNR_HMCNR_hmcnr_mvx_avg_en_mask                               (0x00000008)
#define  DI_IM_DI_RTNR_HMCNR_hmcnr_mvy_avg_en_mask                               (0x00000004)
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_mad_window(data)                  (0x00C00000&((data)<<22))
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_weight(data)                      (0x00380000&((data)<<19))
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_y_en(data)                        (0x00000080&((data)<<7))
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_debug_progressive(data)           (0x00000040&((data)<<6))
#define  DI_IM_DI_RTNR_HMCNR_cp_temporal_hmcnr_uv_with_y(data)                   (0x00000010&((data)<<4))
#define  DI_IM_DI_RTNR_HMCNR_hmcnr_mvx_avg_en(data)                              (0x00000008&((data)<<3))
#define  DI_IM_DI_RTNR_HMCNR_hmcnr_mvy_avg_en(data)                              (0x00000004&((data)<<2))
#define  DI_IM_DI_RTNR_HMCNR_get_cp_temporal_hmcnr_mad_window(data)              ((0x00C00000&(data))>>22)
#define  DI_IM_DI_RTNR_HMCNR_get_cp_temporal_hmcnr_weight(data)                  ((0x00380000&(data))>>19)
#define  DI_IM_DI_RTNR_HMCNR_get_cp_temporal_hmcnr_y_en(data)                    ((0x00000080&(data))>>7)
#define  DI_IM_DI_RTNR_HMCNR_get_cp_temporal_hmcnr_debug_progressive(data)       ((0x00000040&(data))>>6)
#define  DI_IM_DI_RTNR_HMCNR_get_cp_temporal_hmcnr_uv_with_y(data)               ((0x00000010&(data))>>4)
#define  DI_IM_DI_RTNR_HMCNR_get_hmcnr_mvx_avg_en(data)                          ((0x00000008&(data))>>3)
#define  DI_IM_DI_RTNR_HMCNR_get_hmcnr_mvy_avg_en(data)                          ((0x00000004&(data))>>2)

#define  DI_IM_DI_RTNR_NEW_CONTROL                                              0x180242D0
#define  DI_IM_DI_RTNR_NEW_CONTROL_reg_addr                                      "0xB80242D0"
#define  DI_IM_DI_RTNR_NEW_CONTROL_reg                                           0xB80242D0
#define  DI_IM_DI_RTNR_NEW_CONTROL_inst_addr                                     "0x0095"
#define  set_DI_IM_DI_RTNR_NEW_CONTROL_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_NEW_CONTROL_reg)=data)
#define  get_DI_IM_DI_RTNR_NEW_CONTROL_reg                                       (*((volatile unsigned int*)DI_IM_DI_RTNR_NEW_CONTROL_reg))
#define  DI_IM_DI_RTNR_NEW_CONTROL_rtnr_k_debugmode_shift                        (20)
#define  DI_IM_DI_RTNR_NEW_CONTROL_prtnr_4k2k_shift                              (19)
#define  DI_IM_DI_RTNR_NEW_CONTROL_rtnr_new_method_k_extend_en_shift             (3)
#define  DI_IM_DI_RTNR_NEW_CONTROL_rtnr_k_debugmode_mask                         (0x00100000)
#define  DI_IM_DI_RTNR_NEW_CONTROL_prtnr_4k2k_mask                               (0x00080000)
#define  DI_IM_DI_RTNR_NEW_CONTROL_rtnr_new_method_k_extend_en_mask              (0x00000008)
#define  DI_IM_DI_RTNR_NEW_CONTROL_rtnr_k_debugmode(data)                        (0x00100000&((data)<<20))
#define  DI_IM_DI_RTNR_NEW_CONTROL_prtnr_4k2k(data)                              (0x00080000&((data)<<19))
#define  DI_IM_DI_RTNR_NEW_CONTROL_rtnr_new_method_k_extend_en(data)             (0x00000008&((data)<<3))
#define  DI_IM_DI_RTNR_NEW_CONTROL_get_rtnr_k_debugmode(data)                    ((0x00100000&(data))>>20)
#define  DI_IM_DI_RTNR_NEW_CONTROL_get_prtnr_4k2k(data)                          ((0x00080000&(data))>>19)
#define  DI_IM_DI_RTNR_NEW_CONTROL_get_rtnr_new_method_k_extend_en(data)         ((0x00000008&(data))>>3)

#define  DI_IM_DI_PAN_TEETH_1                                                   0x180242F4
#define  DI_IM_DI_PAN_TEETH_1_reg_addr                                           "0xB80242F4"
#define  DI_IM_DI_PAN_TEETH_1_reg                                                0xB80242F4
#define  DI_IM_DI_PAN_TEETH_1_inst_addr                                          "0x0096"
#define  set_DI_IM_DI_PAN_TEETH_1_reg(data)                                      (*((volatile unsigned int*)DI_IM_DI_PAN_TEETH_1_reg)=data)
#define  get_DI_IM_DI_PAN_TEETH_1_reg                                            (*((volatile unsigned int*)DI_IM_DI_PAN_TEETH_1_reg))
#define  DI_IM_DI_PAN_TEETH_1_pan_teeth_statistic_pre_near_shift                 (16)
#define  DI_IM_DI_PAN_TEETH_1_pan_teeth_statistic_nxt_near_shift                 (0)
#define  DI_IM_DI_PAN_TEETH_1_pan_teeth_statistic_pre_near_mask                  (0xFFFF0000)
#define  DI_IM_DI_PAN_TEETH_1_pan_teeth_statistic_nxt_near_mask                  (0x0000FFFF)
#define  DI_IM_DI_PAN_TEETH_1_pan_teeth_statistic_pre_near(data)                 (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_TEETH_1_pan_teeth_statistic_nxt_near(data)                 (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_TEETH_1_get_pan_teeth_statistic_pre_near(data)             ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_TEETH_1_get_pan_teeth_statistic_nxt_near(data)             (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_TEETH_2                                                   0x180242F8
#define  DI_IM_DI_PAN_TEETH_2_reg_addr                                           "0xB80242F8"
#define  DI_IM_DI_PAN_TEETH_2_reg                                                0xB80242F8
#define  DI_IM_DI_PAN_TEETH_2_inst_addr                                          "0x0097"
#define  set_DI_IM_DI_PAN_TEETH_2_reg(data)                                      (*((volatile unsigned int*)DI_IM_DI_PAN_TEETH_2_reg)=data)
#define  get_DI_IM_DI_PAN_TEETH_2_reg                                            (*((volatile unsigned int*)DI_IM_DI_PAN_TEETH_2_reg))
#define  DI_IM_DI_PAN_TEETH_2_pan_teeth_statistic_pre_far_shift                  (16)
#define  DI_IM_DI_PAN_TEETH_2_pan_teeth_statistic_nxt_far_shift                  (0)
#define  DI_IM_DI_PAN_TEETH_2_pan_teeth_statistic_pre_far_mask                   (0xFFFF0000)
#define  DI_IM_DI_PAN_TEETH_2_pan_teeth_statistic_nxt_far_mask                   (0x0000FFFF)
#define  DI_IM_DI_PAN_TEETH_2_pan_teeth_statistic_pre_far(data)                  (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_TEETH_2_pan_teeth_statistic_nxt_far(data)                  (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_TEETH_2_get_pan_teeth_statistic_pre_far(data)              ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_TEETH_2_get_pan_teeth_statistic_nxt_far(data)              (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_TEETH_3                                                   0x180242FC
#define  DI_IM_DI_PAN_TEETH_3_reg_addr                                           "0xB80242FC"
#define  DI_IM_DI_PAN_TEETH_3_reg                                                0xB80242FC
#define  DI_IM_DI_PAN_TEETH_3_inst_addr                                          "0x0098"
#define  set_DI_IM_DI_PAN_TEETH_3_reg(data)                                      (*((volatile unsigned int*)DI_IM_DI_PAN_TEETH_3_reg)=data)
#define  get_DI_IM_DI_PAN_TEETH_3_reg                                            (*((volatile unsigned int*)DI_IM_DI_PAN_TEETH_3_reg))
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_bias_shift                     (28)
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_largediff_th_shift             (14)
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_smalldiff_th_shift             (3)
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_factor_shift                   (0)
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_bias_mask                      (0xF0000000)
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_largediff_th_mask              (0x0FFFC000)
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_smalldiff_th_mask              (0x00003FF8)
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_factor_mask                    (0x00000007)
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_bias(data)                     (0xF0000000&((data)<<28))
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_largediff_th(data)             (0x0FFFC000&((data)<<14))
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_smalldiff_th(data)             (0x00003FF8&((data)<<3))
#define  DI_IM_DI_PAN_TEETH_3_pan_teeth_statistic_factor(data)                   (0x00000007&(data))
#define  DI_IM_DI_PAN_TEETH_3_get_pan_teeth_statistic_bias(data)                 ((0xF0000000&(data))>>28)
#define  DI_IM_DI_PAN_TEETH_3_get_pan_teeth_statistic_largediff_th(data)         ((0x0FFFC000&(data))>>14)
#define  DI_IM_DI_PAN_TEETH_3_get_pan_teeth_statistic_smalldiff_th(data)         ((0x00003FF8&(data))>>3)
#define  DI_IM_DI_PAN_TEETH_3_get_pan_teeth_statistic_factor(data)               (0x00000007&(data))

#define  DI_IM_DI_PAN_TEETH_4                                                   0x18024330
#define  DI_IM_DI_PAN_TEETH_4_reg_addr                                           "0xB8024330"
#define  DI_IM_DI_PAN_TEETH_4_reg                                                0xB8024330
#define  DI_IM_DI_PAN_TEETH_4_inst_addr                                          "0x0099"
#define  set_DI_IM_DI_PAN_TEETH_4_reg(data)                                      (*((volatile unsigned int*)DI_IM_DI_PAN_TEETH_4_reg)=data)
#define  get_DI_IM_DI_PAN_TEETH_4_reg                                            (*((volatile unsigned int*)DI_IM_DI_PAN_TEETH_4_reg))
#define  DI_IM_DI_PAN_TEETH_4_pan_mc_choose_one_side_en_shift                    (31)
#define  DI_IM_DI_PAN_TEETH_4_di_hmc_vlpf_en_shift                               (30)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_debug_en_shift                            (29)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_hori_protect_en_shift                     (28)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_vhf_en_shift                              (27)
#define  DI_IM_DI_PAN_TEETH_4_hmc_teeth_follow_ma_shift                          (26)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_verti_min_th_shift                        (16)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_hori_min_th_shift                         (8)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_hori_max_th_shift                         (0)
#define  DI_IM_DI_PAN_TEETH_4_pan_mc_choose_one_side_en_mask                     (0x80000000)
#define  DI_IM_DI_PAN_TEETH_4_di_hmc_vlpf_en_mask                                (0x40000000)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_debug_en_mask                             (0x20000000)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_hori_protect_en_mask                      (0x10000000)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_vhf_en_mask                               (0x08000000)
#define  DI_IM_DI_PAN_TEETH_4_hmc_teeth_follow_ma_mask                           (0x04000000)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_verti_min_th_mask                         (0x00FF0000)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_hori_min_th_mask                          (0x0000FF00)
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_hori_max_th_mask                          (0x000000FF)
#define  DI_IM_DI_PAN_TEETH_4_pan_mc_choose_one_side_en(data)                    (0x80000000&((data)<<31))
#define  DI_IM_DI_PAN_TEETH_4_di_hmc_vlpf_en(data)                               (0x40000000&((data)<<30))
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_debug_en(data)                            (0x20000000&((data)<<29))
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_hori_protect_en(data)                     (0x10000000&((data)<<28))
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_vhf_en(data)                              (0x08000000&((data)<<27))
#define  DI_IM_DI_PAN_TEETH_4_hmc_teeth_follow_ma(data)                          (0x04000000&((data)<<26))
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_verti_min_th(data)                        (0x00FF0000&((data)<<16))
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_hori_min_th(data)                         (0x0000FF00&((data)<<8))
#define  DI_IM_DI_PAN_TEETH_4_hmc_vlpf_hori_max_th(data)                         (0x000000FF&(data))
#define  DI_IM_DI_PAN_TEETH_4_get_pan_mc_choose_one_side_en(data)                ((0x80000000&(data))>>31)
#define  DI_IM_DI_PAN_TEETH_4_get_di_hmc_vlpf_en(data)                           ((0x40000000&(data))>>30)
#define  DI_IM_DI_PAN_TEETH_4_get_hmc_vlpf_debug_en(data)                        ((0x20000000&(data))>>29)
#define  DI_IM_DI_PAN_TEETH_4_get_hmc_vlpf_hori_protect_en(data)                 ((0x10000000&(data))>>28)
#define  DI_IM_DI_PAN_TEETH_4_get_hmc_vlpf_vhf_en(data)                          ((0x08000000&(data))>>27)
#define  DI_IM_DI_PAN_TEETH_4_get_hmc_teeth_follow_ma(data)                      ((0x04000000&(data))>>26)
#define  DI_IM_DI_PAN_TEETH_4_get_hmc_vlpf_verti_min_th(data)                    ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_PAN_TEETH_4_get_hmc_vlpf_hori_min_th(data)                     ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_PAN_TEETH_4_get_hmc_vlpf_hori_max_th(data)                     (0x000000FF&(data))

#define  DI_IM_DI_HMC_VLPF                                                      0x18024334
#define  DI_IM_DI_HMC_VLPF_reg_addr                                              "0xB8024334"
#define  DI_IM_DI_HMC_VLPF_reg                                                   0xB8024334
#define  DI_IM_DI_HMC_VLPF_inst_addr                                             "0x009A"
#define  set_DI_IM_DI_HMC_VLPF_reg(data)                                         (*((volatile unsigned int*)DI_IM_DI_HMC_VLPF_reg)=data)
#define  get_DI_IM_DI_HMC_VLPF_reg                                               (*((volatile unsigned int*)DI_IM_DI_HMC_VLPF_reg))
#define  DI_IM_DI_HMC_VLPF_hmc_vlpf_vhf_center_th_shift                          (24)
#define  DI_IM_DI_HMC_VLPF_hmc_vlpf_vhf_margin_th_shift                          (16)
#define  DI_IM_DI_HMC_VLPF_hmc_mv_choose_vlpf_shift                              (13)
#define  DI_IM_DI_HMC_VLPF_hmc_mv_refine_cmp_tmv_en_shift                        (12)
#define  DI_IM_DI_HMC_VLPF_hmc_mv_refine_cmp_tmv_th_shift                        (9)
#define  DI_IM_DI_HMC_VLPF_hmc_blending_with_ma_gain_line_t_en_shift             (8)
#define  DI_IM_DI_HMC_VLPF_hmc_blending_with_ma_gain_line_t_cnt_shift            (5)
#define  DI_IM_DI_HMC_VLPF_hmc_blending_with_ma_gain_line_t_factor_shift         (3)
#define  DI_IM_DI_HMC_VLPF_hme_debug_mode_shift                                  (0)
#define  DI_IM_DI_HMC_VLPF_hmc_vlpf_vhf_center_th_mask                           (0xFF000000)
#define  DI_IM_DI_HMC_VLPF_hmc_vlpf_vhf_margin_th_mask                           (0x00FF0000)
#define  DI_IM_DI_HMC_VLPF_hmc_mv_choose_vlpf_mask                               (0x0000E000)
#define  DI_IM_DI_HMC_VLPF_hmc_mv_refine_cmp_tmv_en_mask                         (0x00001000)
#define  DI_IM_DI_HMC_VLPF_hmc_mv_refine_cmp_tmv_th_mask                         (0x00000E00)
#define  DI_IM_DI_HMC_VLPF_hmc_blending_with_ma_gain_line_t_en_mask              (0x00000100)
#define  DI_IM_DI_HMC_VLPF_hmc_blending_with_ma_gain_line_t_cnt_mask             (0x000000E0)
#define  DI_IM_DI_HMC_VLPF_hmc_blending_with_ma_gain_line_t_factor_mask          (0x00000018)
#define  DI_IM_DI_HMC_VLPF_hme_debug_mode_mask                                   (0x00000007)
#define  DI_IM_DI_HMC_VLPF_hmc_vlpf_vhf_center_th(data)                          (0xFF000000&((data)<<24))
#define  DI_IM_DI_HMC_VLPF_hmc_vlpf_vhf_margin_th(data)                          (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HMC_VLPF_hmc_mv_choose_vlpf(data)                              (0x0000E000&((data)<<13))
#define  DI_IM_DI_HMC_VLPF_hmc_mv_refine_cmp_tmv_en(data)                        (0x00001000&((data)<<12))
#define  DI_IM_DI_HMC_VLPF_hmc_mv_refine_cmp_tmv_th(data)                        (0x00000E00&((data)<<9))
#define  DI_IM_DI_HMC_VLPF_hmc_blending_with_ma_gain_line_t_en(data)             (0x00000100&((data)<<8))
#define  DI_IM_DI_HMC_VLPF_hmc_blending_with_ma_gain_line_t_cnt(data)            (0x000000E0&((data)<<5))
#define  DI_IM_DI_HMC_VLPF_hmc_blending_with_ma_gain_line_t_factor(data)         (0x00000018&((data)<<3))
#define  DI_IM_DI_HMC_VLPF_hme_debug_mode(data)                                  (0x00000007&(data))
#define  DI_IM_DI_HMC_VLPF_get_hmc_vlpf_vhf_center_th(data)                      ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HMC_VLPF_get_hmc_vlpf_vhf_margin_th(data)                      ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HMC_VLPF_get_hmc_mv_choose_vlpf(data)                          ((0x0000E000&(data))>>13)
#define  DI_IM_DI_HMC_VLPF_get_hmc_mv_refine_cmp_tmv_en(data)                    ((0x00001000&(data))>>12)
#define  DI_IM_DI_HMC_VLPF_get_hmc_mv_refine_cmp_tmv_th(data)                    ((0x00000E00&(data))>>9)
#define  DI_IM_DI_HMC_VLPF_get_hmc_blending_with_ma_gain_line_t_en(data)         ((0x00000100&(data))>>8)
#define  DI_IM_DI_HMC_VLPF_get_hmc_blending_with_ma_gain_line_t_cnt(data)        ((0x000000E0&(data))>>5)
#define  DI_IM_DI_HMC_VLPF_get_hmc_blending_with_ma_gain_line_t_factor(data)     ((0x00000018&(data))>>3)
#define  DI_IM_DI_HMC_VLPF_get_hme_debug_mode(data)                              (0x00000007&(data))

#define  DI_IM_DI_BLENDING_CORRECTOR_1                                          0x18024344
#define  DI_IM_DI_BLENDING_CORRECTOR_1_reg_addr                                  "0xB8024344"
#define  DI_IM_DI_BLENDING_CORRECTOR_1_reg                                       0xB8024344
#define  DI_IM_DI_BLENDING_CORRECTOR_1_inst_addr                                 "0x009B"
#define  set_DI_IM_DI_BLENDING_CORRECTOR_1_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_BLENDING_CORRECTOR_1_reg)=data)
#define  get_DI_IM_DI_BLENDING_CORRECTOR_1_reg                                   (*((volatile unsigned int*)DI_IM_DI_BLENDING_CORRECTOR_1_reg))
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_refine_cmp_tmv_y_th_h_shift           (14)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_refine_cmp_tmv_y_th_m_shift           (11)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_refine_cmp_tmv_y_th_s_shift           (8)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_statistic_factor_shift                (0)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_refine_cmp_tmv_y_th_h_mask            (0x0001C000)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_refine_cmp_tmv_y_th_m_mask            (0x00003800)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_refine_cmp_tmv_y_th_s_mask            (0x00000700)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_statistic_factor_mask                 (0x000000FF)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_refine_cmp_tmv_y_th_h(data)           (0x0001C000&((data)<<14))
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_refine_cmp_tmv_y_th_m(data)           (0x00003800&((data)<<11))
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_refine_cmp_tmv_y_th_s(data)           (0x00000700&((data)<<8))
#define  DI_IM_DI_BLENDING_CORRECTOR_1_hmc_statistic_factor(data)                (0x000000FF&(data))
#define  DI_IM_DI_BLENDING_CORRECTOR_1_get_hmc_refine_cmp_tmv_y_th_h(data)       ((0x0001C000&(data))>>14)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_get_hmc_refine_cmp_tmv_y_th_m(data)       ((0x00003800&(data))>>11)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_get_hmc_refine_cmp_tmv_y_th_s(data)       ((0x00000700&(data))>>8)
#define  DI_IM_DI_BLENDING_CORRECTOR_1_get_hmc_statistic_factor(data)            (0x000000FF&(data))

#define  DI_IM_DI_PAN_DETECTION_CONTROL_1                                       0x18024354
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_reg_addr                               "0xB8024354"
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_reg                                    0xB8024354
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_inst_addr                              "0x009C"
#define  set_DI_IM_DI_PAN_DETECTION_CONTROL_1_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_CONTROL_1_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_CONTROL_1_reg                                (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_CONTROL_1_reg))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_mc_odd_mv_pass_en_shift            (31)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_mc_sobel_diff_min_th_shift         (24)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_mc_path_sel_shift                  (4)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_me_edgediff_min_th_shift           (1)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_en_shift                           (0)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_mc_odd_mv_pass_en_mask             (0x80000000)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_mc_sobel_diff_min_th_mask          (0x3F000000)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_mc_path_sel_mask                   (0x00000010)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_me_edgediff_min_th_mask            (0x0000000E)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_en_mask                            (0x00000001)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_mc_odd_mv_pass_en(data)            (0x80000000&((data)<<31))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_mc_sobel_diff_min_th(data)         (0x3F000000&((data)<<24))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_mc_path_sel(data)                  (0x00000010&((data)<<4))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_me_edgediff_min_th(data)           (0x0000000E&((data)<<1))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_pan_en(data)                           (0x00000001&(data))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_get_pan_mc_odd_mv_pass_en(data)        ((0x80000000&(data))>>31)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_get_pan_mc_sobel_diff_min_th(data)     ((0x3F000000&(data))>>24)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_get_pan_mc_path_sel(data)              ((0x00000010&(data))>>4)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_get_pan_me_edgediff_min_th(data)       ((0x0000000E&(data))>>1)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_1_get_pan_en(data)                       (0x00000001&(data))

#define  DI_IM_DI_PAN_DETECTION_CONTROL_2                                       0x18024358
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_reg_addr                               "0xB8024358"
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_reg                                    0xB8024358
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_inst_addr                              "0x009D"
#define  set_DI_IM_DI_PAN_DETECTION_CONTROL_2_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_CONTROL_2_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_CONTROL_2_reg                                (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_CONTROL_2_reg))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_teeth_check_th_shift            (12)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_teeth_check_en_shift            (11)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_n_shift                    (10)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_h_shift                    (9)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_v_shift                    (8)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_l_shift                    (7)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_r_shift                    (6)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_teeth_check_th_mask             (0x0000F000)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_teeth_check_en_mask             (0x00000800)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_n_mask                     (0x00000400)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_h_mask                     (0x00000200)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_v_mask                     (0x00000100)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_l_mask                     (0x00000080)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_r_mask                     (0x00000040)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_teeth_check_th(data)            (0x0000F000&((data)<<12))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_teeth_check_en(data)            (0x00000800&((data)<<11))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_n(data)                    (0x00000400&((data)<<10))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_h(data)                    (0x00000200&((data)<<9))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_v(data)                    (0x00000100&((data)<<8))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_l(data)                    (0x00000080&((data)<<7))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_pan_mc_edge_r(data)                    (0x00000040&((data)<<6))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_get_pan_mc_teeth_check_th(data)        ((0x0000F000&(data))>>12)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_get_pan_mc_teeth_check_en(data)        ((0x00000800&(data))>>11)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_get_pan_mc_edge_n(data)                ((0x00000400&(data))>>10)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_get_pan_mc_edge_h(data)                ((0x00000200&(data))>>9)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_get_pan_mc_edge_v(data)                ((0x00000100&(data))>>8)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_get_pan_mc_edge_l(data)                ((0x00000080&(data))>>7)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_2_get_pan_mc_edge_r(data)                ((0x00000040&(data))>>6)

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1                                     0x1802435C
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_reg_addr                             "0xB802435C"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_reg                                  0xB802435C
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_inst_addr                            "0x009E"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_1_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_1_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_1_reg                              (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_1_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_hmc_r7_pixelsum_shift                (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_hmc_r6_pixelsum_shift                (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_hmc_r7_pixelsum_mask                 (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_hmc_r6_pixelsum_mask                 (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_hmc_r7_pixelsum(data)                (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_hmc_r6_pixelsum(data)                (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_get_hmc_r7_pixelsum(data)            ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_1_get_hmc_r6_pixelsum(data)            (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2                                     0x18024360
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_reg_addr                             "0xB8024360"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_reg                                  0xB8024360
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_inst_addr                            "0x009F"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_2_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_2_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_2_reg                              (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_2_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_hmc_r5_pixelsum_shift                (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_hmc_r4_pixelsum_shift                (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_hmc_r5_pixelsum_mask                 (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_hmc_r4_pixelsum_mask                 (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_hmc_r5_pixelsum(data)                (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_hmc_r4_pixelsum(data)                (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_get_hmc_r5_pixelsum(data)            ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_2_get_hmc_r4_pixelsum(data)            (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3                                     0x18024364
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_reg_addr                             "0xB8024364"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_reg                                  0xB8024364
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_inst_addr                            "0x00A0"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_3_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_3_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_3_reg                              (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_3_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_hmc_r3_pixelsum_shift                (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_hmc_r2_pixelsum_shift                (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_hmc_r3_pixelsum_mask                 (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_hmc_r2_pixelsum_mask                 (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_hmc_r3_pixelsum(data)                (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_hmc_r2_pixelsum(data)                (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_get_hmc_r3_pixelsum(data)            ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_3_get_hmc_r2_pixelsum(data)            (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4                                     0x18024368
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_reg_addr                             "0xB8024368"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_reg                                  0xB8024368
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_inst_addr                            "0x00A1"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_4_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_4_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_4_reg                              (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_4_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_hmc_r1_pixelsum_shift                (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_hmc_c0_pixelsum_shift                (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_hmc_r1_pixelsum_mask                 (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_hmc_c0_pixelsum_mask                 (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_hmc_r1_pixelsum(data)                (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_hmc_c0_pixelsum(data)                (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_get_hmc_r1_pixelsum(data)            ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_4_get_hmc_c0_pixelsum(data)            (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5                                     0x1802436C
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_reg_addr                             "0xB802436C"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_reg                                  0xB802436C
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_inst_addr                            "0x00A2"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_5_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_5_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_5_reg                              (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_5_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_hmc_l1_pixelsum_shift                (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_hmc_l2_pixelsum_shift                (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_hmc_l1_pixelsum_mask                 (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_hmc_l2_pixelsum_mask                 (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_hmc_l1_pixelsum(data)                (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_hmc_l2_pixelsum(data)                (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_get_hmc_l1_pixelsum(data)            ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_5_get_hmc_l2_pixelsum(data)            (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6                                     0x18024370
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_reg_addr                             "0xB8024370"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_reg                                  0xB8024370
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_inst_addr                            "0x00A3"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_6_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_6_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_6_reg                              (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_6_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_hmc_l3_pixelsum_shift                (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_hmc_l4_pixelsum_shift                (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_hmc_l3_pixelsum_mask                 (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_hmc_l4_pixelsum_mask                 (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_hmc_l3_pixelsum(data)                (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_hmc_l4_pixelsum(data)                (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_get_hmc_l3_pixelsum(data)            ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_6_get_hmc_l4_pixelsum(data)            (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7                                     0x18024374
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_reg_addr                             "0xB8024374"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_reg                                  0xB8024374
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_inst_addr                            "0x00A4"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_7_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_7_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_7_reg                              (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_7_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_hmc_l5_pixelsum_shift                (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_hmc_l6_pixelsum_shift                (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_hmc_l5_pixelsum_mask                 (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_hmc_l6_pixelsum_mask                 (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_hmc_l5_pixelsum(data)                (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_hmc_l6_pixelsum(data)                (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_get_hmc_l5_pixelsum(data)            ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_7_get_hmc_l6_pixelsum(data)            (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8                                     0x18024378
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_reg_addr                             "0xB8024378"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_reg                                  0xB8024378
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_inst_addr                            "0x00A5"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_8_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_8_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_8_reg                              (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_8_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_hmc_l7_pixelsum_shift                (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_pan_me_border_top_width_shift        (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_hmc_l7_pixelsum_mask                 (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_pan_me_border_top_width_mask         (0x00000FFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_hmc_l7_pixelsum(data)                (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_pan_me_border_top_width(data)        (0x00000FFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_get_hmc_l7_pixelsum(data)            ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_8_get_pan_me_border_top_width(data)    (0x00000FFF&(data))

#define  DI_IM_DI_PAN_DETECTION_CONTROL_3                                       0x1802437C
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_reg_addr                               "0xB802437C"
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_reg                                    0xB802437C
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_inst_addr                              "0x00A6"
#define  set_DI_IM_DI_PAN_DETECTION_CONTROL_3_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_CONTROL_3_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_CONTROL_3_reg                                (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_CONTROL_3_reg))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_pan_me_border_bot_width_shift          (16)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_pan_me_border_left_width_shift         (8)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_pan_me_border_right_width_shift        (0)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_pan_me_border_bot_width_mask           (0x0FFF0000)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_pan_me_border_left_width_mask          (0x0000FF00)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_pan_me_border_right_width_mask         (0x000000FF)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_pan_me_border_bot_width(data)          (0x0FFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_pan_me_border_left_width(data)         (0x0000FF00&((data)<<8))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_pan_me_border_right_width(data)        (0x000000FF&(data))
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_get_pan_me_border_bot_width(data)      ((0x0FFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_get_pan_me_border_left_width(data)     ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_PAN_DETECTION_CONTROL_3_get_pan_me_border_right_width(data)    (0x000000FF&(data))

#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN                                        0x18024380
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_reg_addr                                "0xB8024380"
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_reg                                     0xB8024380
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_inst_addr                               "0x00A7"
#define  set_DI_IM_DI_FILM_NEW_FUNCTION_MAIN_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_FILM_NEW_FUNCTION_MAIN_reg)=data)
#define  get_DI_IM_DI_FILM_NEW_FUNCTION_MAIN_reg                                 (*((volatile unsigned int*)DI_IM_DI_FILM_NEW_FUNCTION_MAIN_reg))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_doublebuffer_en_shift           (24)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_bad_edit_en_shift                  (23)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_filmsequence_shift              (18)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_32detected1_shift               (17)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_32detected2_shift               (16)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_22detected_shift                (15)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_filmweavemode_shift             (13)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_mixedfilmconfuse_shift          (12)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_mixedfilmdetected_shift         (11)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_filmdetected_shift              (10)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_mixedfilm_margin_shift             (8)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_reg_sel_shift                   (7)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_badeditor_ratio_shift                   (5)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_pair3_ratio_shift                  (3)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_force_badeditor_en_shift                (2)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_pair3_en_shift                     (1)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_en_shift                        (0)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_doublebuffer_en_mask            (0x01000000)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_bad_edit_en_mask                   (0x00800000)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_filmsequence_mask               (0x007C0000)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_32detected1_mask                (0x00020000)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_32detected2_mask                (0x00010000)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_22detected_mask                 (0x00008000)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_filmweavemode_mask              (0x00006000)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_mixedfilmconfuse_mask           (0x00001000)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_mixedfilmdetected_mask          (0x00000800)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_filmdetected_mask               (0x00000400)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_mixedfilm_margin_mask              (0x00000300)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_reg_sel_mask                    (0x00000080)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_badeditor_ratio_mask                    (0x00000060)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_pair3_ratio_mask                   (0x00000018)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_force_badeditor_en_mask                 (0x00000004)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_pair3_en_mask                      (0x00000002)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_en_mask                         (0x00000001)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_doublebuffer_en(data)           (0x01000000&((data)<<24))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_bad_edit_en(data)                  (0x00800000&((data)<<23))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_filmsequence(data)              (0x007C0000&((data)<<18))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_32detected1(data)               (0x00020000&((data)<<17))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_32detected2(data)               (0x00010000&((data)<<16))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_22detected(data)                (0x00008000&((data)<<15))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_filmweavemode(data)             (0x00006000&((data)<<13))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_mixedfilmconfuse(data)          (0x00001000&((data)<<12))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_mixedfilmdetected(data)         (0x00000800&((data)<<11))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_filmdetected(data)              (0x00000400&((data)<<10))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_mixedfilm_margin(data)             (0x00000300&((data)<<8))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_reg_sel(data)                   (0x00000080&((data)<<7))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_badeditor_ratio(data)                   (0x00000060&((data)<<5))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_pair3_ratio(data)                  (0x00000018&((data)<<3))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_force_badeditor_en(data)                (0x00000004&((data)<<2))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_film_pair3_en(data)                     (0x00000002&((data)<<1))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_fw_film_en(data)                        (0x00000001&(data))
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_doublebuffer_en(data)       ((0x01000000&(data))>>24)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_film_bad_edit_en(data)              ((0x00800000&(data))>>23)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_filmsequence(data)          ((0x007C0000&(data))>>18)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_32detected1(data)           ((0x00020000&(data))>>17)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_32detected2(data)           ((0x00010000&(data))>>16)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_22detected(data)            ((0x00008000&(data))>>15)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_filmweavemode(data)         ((0x00006000&(data))>>13)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_mixedfilmconfuse(data)      ((0x00001000&(data))>>12)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_mixedfilmdetected(data)     ((0x00000800&(data))>>11)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_filmdetected(data)          ((0x00000400&(data))>>10)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_film_mixedfilm_margin(data)         ((0x00000300&(data))>>8)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_reg_sel(data)               ((0x00000080&(data))>>7)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_badeditor_ratio(data)               ((0x00000060&(data))>>5)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_film_pair3_ratio(data)              ((0x00000018&(data))>>3)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_force_badeditor_en(data)            ((0x00000004&(data))>>2)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_film_pair3_en(data)                 ((0x00000002&(data))>>1)
#define  DI_IM_DI_FILM_NEW_FUNCTION_MAIN_get_fw_film_en(data)                    (0x00000001&(data))

#define  DI_IM_DI_FILM_TopBotLine1                                              0x18024384
#define  DI_IM_DI_FILM_TopBotLine1_reg_addr                                      "0xB8024384"
#define  DI_IM_DI_FILM_TopBotLine1_reg                                           0xB8024384
#define  DI_IM_DI_FILM_TopBotLine1_inst_addr                                     "0x00A8"
#define  set_DI_IM_DI_FILM_TopBotLine1_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_FILM_TopBotLine1_reg)=data)
#define  get_DI_IM_DI_FILM_TopBotLine1_reg                                       (*((volatile unsigned int*)DI_IM_DI_FILM_TopBotLine1_reg))
#define  DI_IM_DI_FILM_TopBotLine1_fw_botline1_shift                             (16)
#define  DI_IM_DI_FILM_TopBotLine1_fw_topline1_shift                             (0)
#define  DI_IM_DI_FILM_TopBotLine1_fw_botline1_mask                              (0x07FF0000)
#define  DI_IM_DI_FILM_TopBotLine1_fw_topline1_mask                              (0x000007FF)
#define  DI_IM_DI_FILM_TopBotLine1_fw_botline1(data)                             (0x07FF0000&((data)<<16))
#define  DI_IM_DI_FILM_TopBotLine1_fw_topline1(data)                             (0x000007FF&(data))
#define  DI_IM_DI_FILM_TopBotLine1_get_fw_botline1(data)                         ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_FILM_TopBotLine1_get_fw_topline1(data)                         (0x000007FF&(data))

#define  DI_IM_DI_FILM_TopBotLine2                                              0x18024388
#define  DI_IM_DI_FILM_TopBotLine2_reg_addr                                      "0xB8024388"
#define  DI_IM_DI_FILM_TopBotLine2_reg                                           0xB8024388
#define  DI_IM_DI_FILM_TopBotLine2_inst_addr                                     "0x00A9"
#define  set_DI_IM_DI_FILM_TopBotLine2_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_FILM_TopBotLine2_reg)=data)
#define  get_DI_IM_DI_FILM_TopBotLine2_reg                                       (*((volatile unsigned int*)DI_IM_DI_FILM_TopBotLine2_reg))
#define  DI_IM_DI_FILM_TopBotLine2_fw_botline2_shift                             (16)
#define  DI_IM_DI_FILM_TopBotLine2_fw_topline2_shift                             (0)
#define  DI_IM_DI_FILM_TopBotLine2_fw_botline2_mask                              (0x07FF0000)
#define  DI_IM_DI_FILM_TopBotLine2_fw_topline2_mask                              (0x000007FF)
#define  DI_IM_DI_FILM_TopBotLine2_fw_botline2(data)                             (0x07FF0000&((data)<<16))
#define  DI_IM_DI_FILM_TopBotLine2_fw_topline2(data)                             (0x000007FF&(data))
#define  DI_IM_DI_FILM_TopBotLine2_get_fw_botline2(data)                         ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_FILM_TopBotLine2_get_fw_topline2(data)                         (0x000007FF&(data))

#define  DI_IM_DI_FILM_TopBotLine3                                              0x1802438C
#define  DI_IM_DI_FILM_TopBotLine3_reg_addr                                      "0xB802438C"
#define  DI_IM_DI_FILM_TopBotLine3_reg                                           0xB802438C
#define  DI_IM_DI_FILM_TopBotLine3_inst_addr                                     "0x00AA"
#define  set_DI_IM_DI_FILM_TopBotLine3_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_FILM_TopBotLine3_reg)=data)
#define  get_DI_IM_DI_FILM_TopBotLine3_reg                                       (*((volatile unsigned int*)DI_IM_DI_FILM_TopBotLine3_reg))
#define  DI_IM_DI_FILM_TopBotLine3_fw_botline3_shift                             (16)
#define  DI_IM_DI_FILM_TopBotLine3_fw_topline3_shift                             (0)
#define  DI_IM_DI_FILM_TopBotLine3_fw_botline3_mask                              (0x07FF0000)
#define  DI_IM_DI_FILM_TopBotLine3_fw_topline3_mask                              (0x000007FF)
#define  DI_IM_DI_FILM_TopBotLine3_fw_botline3(data)                             (0x07FF0000&((data)<<16))
#define  DI_IM_DI_FILM_TopBotLine3_fw_topline3(data)                             (0x000007FF&(data))
#define  DI_IM_DI_FILM_TopBotLine3_get_fw_botline3(data)                         ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_FILM_TopBotLine3_get_fw_topline3(data)                         (0x000007FF&(data))

#define  DI_IM_DI_FILM_PREV_FIELDMOTION                                         0x18024390
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_reg_addr                                 "0xB8024390"
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_reg                                      0xB8024390
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_inst_addr                                "0x00AB"
#define  set_DI_IM_DI_FILM_PREV_FIELDMOTION_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_FILM_PREV_FIELDMOTION_reg)=data)
#define  get_DI_IM_DI_FILM_PREV_FIELDMOTION_reg                                  (*((volatile unsigned int*)DI_IM_DI_FILM_PREV_FIELDMOTION_reg))
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_film_badeditor_flag_shift                (16)
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_film22_prevfilmmotion_shift              (8)
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_film_prevfilmmotion_shift                (0)
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_film_badeditor_flag_mask                 (0x00010000)
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_film22_prevfilmmotion_mask               (0x0000FF00)
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_film_prevfilmmotion_mask                 (0x000000FF)
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_film_badeditor_flag(data)                (0x00010000&((data)<<16))
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_film22_prevfilmmotion(data)              (0x0000FF00&((data)<<8))
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_film_prevfilmmotion(data)                (0x000000FF&(data))
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_get_film_badeditor_flag(data)            ((0x00010000&(data))>>16)
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_get_film22_prevfilmmotion(data)          ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_FILM_PREV_FIELDMOTION_get_film_prevfilmmotion(data)            (0x000000FF&(data))

#define  DI_IM_DI_FILM_MARK_INFORMATION                                         0x18024394
#define  DI_IM_DI_FILM_MARK_INFORMATION_reg_addr                                 "0xB8024394"
#define  DI_IM_DI_FILM_MARK_INFORMATION_reg                                      0xB8024394
#define  DI_IM_DI_FILM_MARK_INFORMATION_inst_addr                                "0x00AC"
#define  set_DI_IM_DI_FILM_MARK_INFORMATION_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_INFORMATION_reg)=data)
#define  get_DI_IM_DI_FILM_MARK_INFORMATION_reg                                  (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_INFORMATION_reg))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nextbotdetected3_shift              (11)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nexttopdetected3_shift              (10)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nextbotdetected2_shift              (9)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nexttopdetected2_shift              (8)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nextbotdetected1_shift              (7)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nexttopdetected1_shift              (6)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevbotdetected3_shift              (5)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevtopdetected3_shift              (4)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevbotdetected2_shift              (3)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevtopdetected2_shift              (2)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevbotdetected1_shift              (1)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevtopdetected1_shift              (0)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nextbotdetected3_mask               (0x00000800)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nexttopdetected3_mask               (0x00000400)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nextbotdetected2_mask               (0x00000200)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nexttopdetected2_mask               (0x00000100)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nextbotdetected1_mask               (0x00000080)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nexttopdetected1_mask               (0x00000040)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevbotdetected3_mask               (0x00000020)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevtopdetected3_mask               (0x00000010)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevbotdetected2_mask               (0x00000008)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevtopdetected2_mask               (0x00000004)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevbotdetected1_mask               (0x00000002)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevtopdetected1_mask               (0x00000001)
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nextbotdetected3(data)              (0x00000800&((data)<<11))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nexttopdetected3(data)              (0x00000400&((data)<<10))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nextbotdetected2(data)              (0x00000200&((data)<<9))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nexttopdetected2(data)              (0x00000100&((data)<<8))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nextbotdetected1(data)              (0x00000080&((data)<<7))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_nexttopdetected1(data)              (0x00000040&((data)<<6))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevbotdetected3(data)              (0x00000020&((data)<<5))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevtopdetected3(data)              (0x00000010&((data)<<4))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevbotdetected2(data)              (0x00000008&((data)<<3))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevtopdetected2(data)              (0x00000004&((data)<<2))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevbotdetected1(data)              (0x00000002&((data)<<1))
#define  DI_IM_DI_FILM_MARK_INFORMATION_film_prevtopdetected1(data)              (0x00000001&(data))
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_nextbotdetected3(data)          ((0x00000800&(data))>>11)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_nexttopdetected3(data)          ((0x00000400&(data))>>10)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_nextbotdetected2(data)          ((0x00000200&(data))>>9)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_nexttopdetected2(data)          ((0x00000100&(data))>>8)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_nextbotdetected1(data)          ((0x00000080&(data))>>7)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_nexttopdetected1(data)          ((0x00000040&(data))>>6)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_prevbotdetected3(data)          ((0x00000020&(data))>>5)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_prevtopdetected3(data)          ((0x00000010&(data))>>4)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_prevbotdetected2(data)          ((0x00000008&(data))>>3)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_prevtopdetected2(data)          ((0x00000004&(data))>>2)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_prevbotdetected1(data)          ((0x00000002&(data))>>1)
#define  DI_IM_DI_FILM_MARK_INFORMATION_get_film_prevtopdetected1(data)          (0x00000001&(data))

#define  DI_IM_DI_FILM_MARK_PREV1                                               0x18024398
#define  DI_IM_DI_FILM_MARK_PREV1_reg_addr                                       "0xB8024398"
#define  DI_IM_DI_FILM_MARK_PREV1_reg                                            0xB8024398
#define  DI_IM_DI_FILM_MARK_PREV1_inst_addr                                      "0x00AD"
#define  set_DI_IM_DI_FILM_MARK_PREV1_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_PREV1_reg)=data)
#define  get_DI_IM_DI_FILM_MARK_PREV1_reg                                        (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_PREV1_reg))
#define  DI_IM_DI_FILM_MARK_PREV1_film_prevbotmark1_shift                        (16)
#define  DI_IM_DI_FILM_MARK_PREV1_film_prevtopmark1_shift                        (0)
#define  DI_IM_DI_FILM_MARK_PREV1_film_prevbotmark1_mask                         (0x07FF0000)
#define  DI_IM_DI_FILM_MARK_PREV1_film_prevtopmark1_mask                         (0x000007FF)
#define  DI_IM_DI_FILM_MARK_PREV1_film_prevbotmark1(data)                        (0x07FF0000&((data)<<16))
#define  DI_IM_DI_FILM_MARK_PREV1_film_prevtopmark1(data)                        (0x000007FF&(data))
#define  DI_IM_DI_FILM_MARK_PREV1_get_film_prevbotmark1(data)                    ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_FILM_MARK_PREV1_get_film_prevtopmark1(data)                    (0x000007FF&(data))

#define  DI_IM_DI_FILM_MARK_PREV2                                               0x1802439C
#define  DI_IM_DI_FILM_MARK_PREV2_reg_addr                                       "0xB802439C"
#define  DI_IM_DI_FILM_MARK_PREV2_reg                                            0xB802439C
#define  DI_IM_DI_FILM_MARK_PREV2_inst_addr                                      "0x00AE"
#define  set_DI_IM_DI_FILM_MARK_PREV2_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_PREV2_reg)=data)
#define  get_DI_IM_DI_FILM_MARK_PREV2_reg                                        (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_PREV2_reg))
#define  DI_IM_DI_FILM_MARK_PREV2_film_prevbotmark2_shift                        (16)
#define  DI_IM_DI_FILM_MARK_PREV2_film_prevtopmark2_shift                        (0)
#define  DI_IM_DI_FILM_MARK_PREV2_film_prevbotmark2_mask                         (0x07FF0000)
#define  DI_IM_DI_FILM_MARK_PREV2_film_prevtopmark2_mask                         (0x000007FF)
#define  DI_IM_DI_FILM_MARK_PREV2_film_prevbotmark2(data)                        (0x07FF0000&((data)<<16))
#define  DI_IM_DI_FILM_MARK_PREV2_film_prevtopmark2(data)                        (0x000007FF&(data))
#define  DI_IM_DI_FILM_MARK_PREV2_get_film_prevbotmark2(data)                    ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_FILM_MARK_PREV2_get_film_prevtopmark2(data)                    (0x000007FF&(data))

#define  DI_IM_DI_FILM_MARK_PREV3                                               0x180243A0
#define  DI_IM_DI_FILM_MARK_PREV3_reg_addr                                       "0xB80243A0"
#define  DI_IM_DI_FILM_MARK_PREV3_reg                                            0xB80243A0
#define  DI_IM_DI_FILM_MARK_PREV3_inst_addr                                      "0x00AF"
#define  set_DI_IM_DI_FILM_MARK_PREV3_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_PREV3_reg)=data)
#define  get_DI_IM_DI_FILM_MARK_PREV3_reg                                        (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_PREV3_reg))
#define  DI_IM_DI_FILM_MARK_PREV3_film_prevbotmark3_shift                        (16)
#define  DI_IM_DI_FILM_MARK_PREV3_film_prevtopmark3_shift                        (0)
#define  DI_IM_DI_FILM_MARK_PREV3_film_prevbotmark3_mask                         (0x07FF0000)
#define  DI_IM_DI_FILM_MARK_PREV3_film_prevtopmark3_mask                         (0x000007FF)
#define  DI_IM_DI_FILM_MARK_PREV3_film_prevbotmark3(data)                        (0x07FF0000&((data)<<16))
#define  DI_IM_DI_FILM_MARK_PREV3_film_prevtopmark3(data)                        (0x000007FF&(data))
#define  DI_IM_DI_FILM_MARK_PREV3_get_film_prevbotmark3(data)                    ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_FILM_MARK_PREV3_get_film_prevtopmark3(data)                    (0x000007FF&(data))

#define  DI_IM_DI_FILM_MARK_NEXT1                                               0x180243A4
#define  DI_IM_DI_FILM_MARK_NEXT1_reg_addr                                       "0xB80243A4"
#define  DI_IM_DI_FILM_MARK_NEXT1_reg                                            0xB80243A4
#define  DI_IM_DI_FILM_MARK_NEXT1_inst_addr                                      "0x00B0"
#define  set_DI_IM_DI_FILM_MARK_NEXT1_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_NEXT1_reg)=data)
#define  get_DI_IM_DI_FILM_MARK_NEXT1_reg                                        (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_NEXT1_reg))
#define  DI_IM_DI_FILM_MARK_NEXT1_film_nextbotmark1_shift                        (16)
#define  DI_IM_DI_FILM_MARK_NEXT1_film_nexttopmark1_shift                        (0)
#define  DI_IM_DI_FILM_MARK_NEXT1_film_nextbotmark1_mask                         (0x07FF0000)
#define  DI_IM_DI_FILM_MARK_NEXT1_film_nexttopmark1_mask                         (0x000007FF)
#define  DI_IM_DI_FILM_MARK_NEXT1_film_nextbotmark1(data)                        (0x07FF0000&((data)<<16))
#define  DI_IM_DI_FILM_MARK_NEXT1_film_nexttopmark1(data)                        (0x000007FF&(data))
#define  DI_IM_DI_FILM_MARK_NEXT1_get_film_nextbotmark1(data)                    ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_FILM_MARK_NEXT1_get_film_nexttopmark1(data)                    (0x000007FF&(data))

#define  DI_IM_DI_FILM_MARK_NEXT2                                               0x180243A8
#define  DI_IM_DI_FILM_MARK_NEXT2_reg_addr                                       "0xB80243A8"
#define  DI_IM_DI_FILM_MARK_NEXT2_reg                                            0xB80243A8
#define  DI_IM_DI_FILM_MARK_NEXT2_inst_addr                                      "0x00B1"
#define  set_DI_IM_DI_FILM_MARK_NEXT2_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_NEXT2_reg)=data)
#define  get_DI_IM_DI_FILM_MARK_NEXT2_reg                                        (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_NEXT2_reg))
#define  DI_IM_DI_FILM_MARK_NEXT2_film_nextbotmark2_shift                        (16)
#define  DI_IM_DI_FILM_MARK_NEXT2_film_nexttopmark2_shift                        (0)
#define  DI_IM_DI_FILM_MARK_NEXT2_film_nextbotmark2_mask                         (0x07FF0000)
#define  DI_IM_DI_FILM_MARK_NEXT2_film_nexttopmark2_mask                         (0x000007FF)
#define  DI_IM_DI_FILM_MARK_NEXT2_film_nextbotmark2(data)                        (0x07FF0000&((data)<<16))
#define  DI_IM_DI_FILM_MARK_NEXT2_film_nexttopmark2(data)                        (0x000007FF&(data))
#define  DI_IM_DI_FILM_MARK_NEXT2_get_film_nextbotmark2(data)                    ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_FILM_MARK_NEXT2_get_film_nexttopmark2(data)                    (0x000007FF&(data))

#define  DI_IM_DI_FILM_MARK_NEXT3                                               0x180243AC
#define  DI_IM_DI_FILM_MARK_NEXT3_reg_addr                                       "0xB80243AC"
#define  DI_IM_DI_FILM_MARK_NEXT3_reg                                            0xB80243AC
#define  DI_IM_DI_FILM_MARK_NEXT3_inst_addr                                      "0x00B2"
#define  set_DI_IM_DI_FILM_MARK_NEXT3_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_NEXT3_reg)=data)
#define  get_DI_IM_DI_FILM_MARK_NEXT3_reg                                        (*((volatile unsigned int*)DI_IM_DI_FILM_MARK_NEXT3_reg))
#define  DI_IM_DI_FILM_MARK_NEXT3_film_nextbotmark3_shift                        (16)
#define  DI_IM_DI_FILM_MARK_NEXT3_film_nexttopmark3_shift                        (0)
#define  DI_IM_DI_FILM_MARK_NEXT3_film_nextbotmark3_mask                         (0x07FF0000)
#define  DI_IM_DI_FILM_MARK_NEXT3_film_nexttopmark3_mask                         (0x000007FF)
#define  DI_IM_DI_FILM_MARK_NEXT3_film_nextbotmark3(data)                        (0x07FF0000&((data)<<16))
#define  DI_IM_DI_FILM_MARK_NEXT3_film_nexttopmark3(data)                        (0x000007FF&(data))
#define  DI_IM_DI_FILM_MARK_NEXT3_get_film_nextbotmark3(data)                    ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_FILM_MARK_NEXT3_get_film_nexttopmark3(data)                    (0x000007FF&(data))

#define  DI_DI_SMD_Control_CandidateList                                        0x180243B0
#define  DI_DI_SMD_Control_CandidateList_reg_addr                                "0xB80243B0"
#define  DI_DI_SMD_Control_CandidateList_reg                                     0xB80243B0
#define  DI_DI_SMD_Control_CandidateList_inst_addr                               "0x00B3"
#define  set_DI_DI_SMD_Control_CandidateList_reg(data)                           (*((volatile unsigned int*)DI_DI_SMD_Control_CandidateList_reg)=data)
#define  get_DI_DI_SMD_Control_CandidateList_reg                                 (*((volatile unsigned int*)DI_DI_SMD_Control_CandidateList_reg))
#define  DI_DI_SMD_Control_CandidateList_smd_en_shift                            (31)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_hentryofmv_en_shift           (30)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_ventryofmv_en_shift           (29)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_sawtooth_en_shift             (28)
#define  DI_DI_SMD_Control_CandidateList_smd_spatialmv_counter_th_shift          (24)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_preinrateeth_en_shift         (23)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_resurrect_en_shift            (22)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_mvschanged_en_shift           (21)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_spatialfreqnomatch_en_shift   (20)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_outofrange_en_shift           (19)
#define  DI_DI_SMD_Control_CandidateList_smd_localmv_counter_th_shift            (16)
#define  DI_DI_SMD_Control_CandidateList_smd_lowbound_sad_forjudgemv_shift       (8)
#define  DI_DI_SMD_Control_CandidateList_smd_upperbound_sad_forjudgemv_shift     (0)
#define  DI_DI_SMD_Control_CandidateList_smd_en_mask                             (0x80000000)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_hentryofmv_en_mask            (0x40000000)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_ventryofmv_en_mask            (0x20000000)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_sawtooth_en_mask              (0x10000000)
#define  DI_DI_SMD_Control_CandidateList_smd_spatialmv_counter_th_mask           (0x03000000)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_preinrateeth_en_mask          (0x00800000)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_resurrect_en_mask             (0x00400000)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_mvschanged_en_mask            (0x00200000)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_spatialfreqnomatch_en_mask    (0x00100000)
#define  DI_DI_SMD_Control_CandidateList_smd_debug_outofrange_en_mask            (0x00080000)
#define  DI_DI_SMD_Control_CandidateList_smd_localmv_counter_th_mask             (0x00070000)
#define  DI_DI_SMD_Control_CandidateList_smd_lowbound_sad_forjudgemv_mask        (0x0000FF00)
#define  DI_DI_SMD_Control_CandidateList_smd_upperbound_sad_forjudgemv_mask      (0x000000FF)
#define  DI_DI_SMD_Control_CandidateList_smd_en(data)                            (0x80000000&((data)<<31))
#define  DI_DI_SMD_Control_CandidateList_smd_debug_hentryofmv_en(data)           (0x40000000&((data)<<30))
#define  DI_DI_SMD_Control_CandidateList_smd_debug_ventryofmv_en(data)           (0x20000000&((data)<<29))
#define  DI_DI_SMD_Control_CandidateList_smd_debug_sawtooth_en(data)             (0x10000000&((data)<<28))
#define  DI_DI_SMD_Control_CandidateList_smd_spatialmv_counter_th(data)          (0x03000000&((data)<<24))
#define  DI_DI_SMD_Control_CandidateList_smd_debug_preinrateeth_en(data)         (0x00800000&((data)<<23))
#define  DI_DI_SMD_Control_CandidateList_smd_debug_resurrect_en(data)            (0x00400000&((data)<<22))
#define  DI_DI_SMD_Control_CandidateList_smd_debug_mvschanged_en(data)           (0x00200000&((data)<<21))
#define  DI_DI_SMD_Control_CandidateList_smd_debug_spatialfreqnomatch_en(data)   (0x00100000&((data)<<20))
#define  DI_DI_SMD_Control_CandidateList_smd_debug_outofrange_en(data)           (0x00080000&((data)<<19))
#define  DI_DI_SMD_Control_CandidateList_smd_localmv_counter_th(data)            (0x00070000&((data)<<16))
#define  DI_DI_SMD_Control_CandidateList_smd_lowbound_sad_forjudgemv(data)       (0x0000FF00&((data)<<8))
#define  DI_DI_SMD_Control_CandidateList_smd_upperbound_sad_forjudgemv(data)     (0x000000FF&(data))
#define  DI_DI_SMD_Control_CandidateList_get_smd_en(data)                        ((0x80000000&(data))>>31)
#define  DI_DI_SMD_Control_CandidateList_get_smd_debug_hentryofmv_en(data)       ((0x40000000&(data))>>30)
#define  DI_DI_SMD_Control_CandidateList_get_smd_debug_ventryofmv_en(data)       ((0x20000000&(data))>>29)
#define  DI_DI_SMD_Control_CandidateList_get_smd_debug_sawtooth_en(data)         ((0x10000000&(data))>>28)
#define  DI_DI_SMD_Control_CandidateList_get_smd_spatialmv_counter_th(data)      ((0x03000000&(data))>>24)
#define  DI_DI_SMD_Control_CandidateList_get_smd_debug_preinrateeth_en(data)     ((0x00800000&(data))>>23)
#define  DI_DI_SMD_Control_CandidateList_get_smd_debug_resurrect_en(data)        ((0x00400000&(data))>>22)
#define  DI_DI_SMD_Control_CandidateList_get_smd_debug_mvschanged_en(data)       ((0x00200000&(data))>>21)
#define  DI_DI_SMD_Control_CandidateList_get_smd_debug_spatialfreqnomatch_en(data) ((0x00100000&(data))>>20)
#define  DI_DI_SMD_Control_CandidateList_get_smd_debug_outofrange_en(data)       ((0x00080000&(data))>>19)
#define  DI_DI_SMD_Control_CandidateList_get_smd_localmv_counter_th(data)        ((0x00070000&(data))>>16)
#define  DI_DI_SMD_Control_CandidateList_get_smd_lowbound_sad_forjudgemv(data)   ((0x0000FF00&(data))>>8)
#define  DI_DI_SMD_Control_CandidateList_get_smd_upperbound_sad_forjudgemv(data) (0x000000FF&(data))

#define  DI_DI_SMD_ChooseCandidate                                              0x180243B4
#define  DI_DI_SMD_ChooseCandidate_reg_addr                                      "0xB80243B4"
#define  DI_DI_SMD_ChooseCandidate_reg                                           0xB80243B4
#define  DI_DI_SMD_ChooseCandidate_inst_addr                                     "0x00B4"
#define  set_DI_DI_SMD_ChooseCandidate_reg(data)                                 (*((volatile unsigned int*)DI_DI_SMD_ChooseCandidate_reg)=data)
#define  get_DI_DI_SMD_ChooseCandidate_reg                                       (*((volatile unsigned int*)DI_DI_SMD_ChooseCandidate_reg))
#define  DI_DI_SMD_ChooseCandidate_smd_spatialmv_sad_th_shift                    (24)
#define  DI_DI_SMD_ChooseCandidate_smd_spatial_divergence_th_shift               (20)
#define  DI_DI_SMD_ChooseCandidate_smd_localmv_concentrate_ratio_th_shift        (16)
#define  DI_DI_SMD_ChooseCandidate_smd_localmv_sad_th_shift                      (8)
#define  DI_DI_SMD_ChooseCandidate_smd_reliablerange_sad_th_shift                (0)
#define  DI_DI_SMD_ChooseCandidate_smd_spatialmv_sad_th_mask                     (0xFF000000)
#define  DI_DI_SMD_ChooseCandidate_smd_spatial_divergence_th_mask                (0x00700000)
#define  DI_DI_SMD_ChooseCandidate_smd_localmv_concentrate_ratio_th_mask         (0x00070000)
#define  DI_DI_SMD_ChooseCandidate_smd_localmv_sad_th_mask                       (0x0000FF00)
#define  DI_DI_SMD_ChooseCandidate_smd_reliablerange_sad_th_mask                 (0x000000FF)
#define  DI_DI_SMD_ChooseCandidate_smd_spatialmv_sad_th(data)                    (0xFF000000&((data)<<24))
#define  DI_DI_SMD_ChooseCandidate_smd_spatial_divergence_th(data)               (0x00700000&((data)<<20))
#define  DI_DI_SMD_ChooseCandidate_smd_localmv_concentrate_ratio_th(data)        (0x00070000&((data)<<16))
#define  DI_DI_SMD_ChooseCandidate_smd_localmv_sad_th(data)                      (0x0000FF00&((data)<<8))
#define  DI_DI_SMD_ChooseCandidate_smd_reliablerange_sad_th(data)                (0x000000FF&(data))
#define  DI_DI_SMD_ChooseCandidate_get_smd_spatialmv_sad_th(data)                ((0xFF000000&(data))>>24)
#define  DI_DI_SMD_ChooseCandidate_get_smd_spatial_divergence_th(data)           ((0x00700000&(data))>>20)
#define  DI_DI_SMD_ChooseCandidate_get_smd_localmv_concentrate_ratio_th(data)    ((0x00070000&(data))>>16)
#define  DI_DI_SMD_ChooseCandidate_get_smd_localmv_sad_th(data)                  ((0x0000FF00&(data))>>8)
#define  DI_DI_SMD_ChooseCandidate_get_smd_reliablerange_sad_th(data)            (0x000000FF&(data))

#define  DI_DI_SMD_RefineMV1                                                    0x180243B8
#define  DI_DI_SMD_RefineMV1_reg_addr                                            "0xB80243B8"
#define  DI_DI_SMD_RefineMV1_reg                                                 0xB80243B8
#define  DI_DI_SMD_RefineMV1_inst_addr                                           "0x00B5"
#define  set_DI_DI_SMD_RefineMV1_reg(data)                                       (*((volatile unsigned int*)DI_DI_SMD_RefineMV1_reg)=data)
#define  get_DI_DI_SMD_RefineMV1_reg                                             (*((volatile unsigned int*)DI_DI_SMD_RefineMV1_reg))
#define  DI_DI_SMD_RefineMV1_smd_steeth_en_shift                                 (31)
#define  DI_DI_SMD_RefineMV1_smd_preintra_teeth_offset_shift                     (24)
#define  DI_DI_SMD_RefineMV1_smd_preintra_effect_shift                           (16)
#define  DI_DI_SMD_RefineMV1_smd_preintra_teeth_gain_shift                       (12)
#define  DI_DI_SMD_RefineMV1_smd_curr_teeth_gain_shift                           (8)
#define  DI_DI_SMD_RefineMV1_smd_teeth_new_mode_shift                            (6)
#define  DI_DI_SMD_RefineMV1_smd_curr_teeth_offset_shift                         (0)
#define  DI_DI_SMD_RefineMV1_smd_steeth_en_mask                                  (0x80000000)
#define  DI_DI_SMD_RefineMV1_smd_preintra_teeth_offset_mask                      (0x3F000000)
#define  DI_DI_SMD_RefineMV1_smd_preintra_effect_mask                            (0x003F0000)
#define  DI_DI_SMD_RefineMV1_smd_preintra_teeth_gain_mask                        (0x00007000)
#define  DI_DI_SMD_RefineMV1_smd_curr_teeth_gain_mask                            (0x00000700)
#define  DI_DI_SMD_RefineMV1_smd_teeth_new_mode_mask                             (0x000000C0)
#define  DI_DI_SMD_RefineMV1_smd_curr_teeth_offset_mask                          (0x0000003F)
#define  DI_DI_SMD_RefineMV1_smd_steeth_en(data)                                 (0x80000000&((data)<<31))
#define  DI_DI_SMD_RefineMV1_smd_preintra_teeth_offset(data)                     (0x3F000000&((data)<<24))
#define  DI_DI_SMD_RefineMV1_smd_preintra_effect(data)                           (0x003F0000&((data)<<16))
#define  DI_DI_SMD_RefineMV1_smd_preintra_teeth_gain(data)                       (0x00007000&((data)<<12))
#define  DI_DI_SMD_RefineMV1_smd_curr_teeth_gain(data)                           (0x00000700&((data)<<8))
#define  DI_DI_SMD_RefineMV1_smd_teeth_new_mode(data)                            (0x000000C0&((data)<<6))
#define  DI_DI_SMD_RefineMV1_smd_curr_teeth_offset(data)                         (0x0000003F&(data))
#define  DI_DI_SMD_RefineMV1_get_smd_steeth_en(data)                             ((0x80000000&(data))>>31)
#define  DI_DI_SMD_RefineMV1_get_smd_preintra_teeth_offset(data)                 ((0x3F000000&(data))>>24)
#define  DI_DI_SMD_RefineMV1_get_smd_preintra_effect(data)                       ((0x003F0000&(data))>>16)
#define  DI_DI_SMD_RefineMV1_get_smd_preintra_teeth_gain(data)                   ((0x00007000&(data))>>12)
#define  DI_DI_SMD_RefineMV1_get_smd_curr_teeth_gain(data)                       ((0x00000700&(data))>>8)
#define  DI_DI_SMD_RefineMV1_get_smd_teeth_new_mode(data)                        ((0x000000C0&(data))>>6)
#define  DI_DI_SMD_RefineMV1_get_smd_curr_teeth_offset(data)                     (0x0000003F&(data))

#define  DI_DI_SMD_RefineMV2                                                    0x180243BC
#define  DI_DI_SMD_RefineMV2_reg_addr                                            "0xB80243BC"
#define  DI_DI_SMD_RefineMV2_reg                                                 0xB80243BC
#define  DI_DI_SMD_RefineMV2_inst_addr                                           "0x00B6"
#define  set_DI_DI_SMD_RefineMV2_reg(data)                                       (*((volatile unsigned int*)DI_DI_SMD_RefineMV2_reg)=data)
#define  get_DI_DI_SMD_RefineMV2_reg                                             (*((volatile unsigned int*)DI_DI_SMD_RefineMV2_reg))
#define  DI_DI_SMD_RefineMV2_smd_mvs_vchanged_en_shift                           (31)
#define  DI_DI_SMD_RefineMV2_smd_mvs_hchanged_en_shift                           (30)
#define  DI_DI_SMD_RefineMV2_smd_resurrect_en_shift                              (29)
#define  DI_DI_SMD_RefineMV2_smd_resurrect_union_num_shift                       (24)
#define  DI_DI_SMD_RefineMV2_smd_resurrect_smallwindow_num_shift                 (20)
#define  DI_DI_SMD_RefineMV2_smd_resurrect_localcurr_num_shift                   (16)
#define  DI_DI_SMD_RefineMV2_smd_resurrect_minsad_th_shift                       (8)
#define  DI_DI_SMD_RefineMV2_smd_global_en_ratio_shift                           (0)
#define  DI_DI_SMD_RefineMV2_smd_mvs_vchanged_en_mask                            (0x80000000)
#define  DI_DI_SMD_RefineMV2_smd_mvs_hchanged_en_mask                            (0x40000000)
#define  DI_DI_SMD_RefineMV2_smd_resurrect_en_mask                               (0x20000000)
#define  DI_DI_SMD_RefineMV2_smd_resurrect_union_num_mask                        (0x1F000000)
#define  DI_DI_SMD_RefineMV2_smd_resurrect_smallwindow_num_mask                  (0x00F00000)
#define  DI_DI_SMD_RefineMV2_smd_resurrect_localcurr_num_mask                    (0x000F0000)
#define  DI_DI_SMD_RefineMV2_smd_resurrect_minsad_th_mask                        (0x0000FF00)
#define  DI_DI_SMD_RefineMV2_smd_global_en_ratio_mask                            (0x000000FF)
#define  DI_DI_SMD_RefineMV2_smd_mvs_vchanged_en(data)                           (0x80000000&((data)<<31))
#define  DI_DI_SMD_RefineMV2_smd_mvs_hchanged_en(data)                           (0x40000000&((data)<<30))
#define  DI_DI_SMD_RefineMV2_smd_resurrect_en(data)                              (0x20000000&((data)<<29))
#define  DI_DI_SMD_RefineMV2_smd_resurrect_union_num(data)                       (0x1F000000&((data)<<24))
#define  DI_DI_SMD_RefineMV2_smd_resurrect_smallwindow_num(data)                 (0x00F00000&((data)<<20))
#define  DI_DI_SMD_RefineMV2_smd_resurrect_localcurr_num(data)                   (0x000F0000&((data)<<16))
#define  DI_DI_SMD_RefineMV2_smd_resurrect_minsad_th(data)                       (0x0000FF00&((data)<<8))
#define  DI_DI_SMD_RefineMV2_smd_global_en_ratio(data)                           (0x000000FF&(data))
#define  DI_DI_SMD_RefineMV2_get_smd_mvs_vchanged_en(data)                       ((0x80000000&(data))>>31)
#define  DI_DI_SMD_RefineMV2_get_smd_mvs_hchanged_en(data)                       ((0x40000000&(data))>>30)
#define  DI_DI_SMD_RefineMV2_get_smd_resurrect_en(data)                          ((0x20000000&(data))>>29)
#define  DI_DI_SMD_RefineMV2_get_smd_resurrect_union_num(data)                   ((0x1F000000&(data))>>24)
#define  DI_DI_SMD_RefineMV2_get_smd_resurrect_smallwindow_num(data)             ((0x00F00000&(data))>>20)
#define  DI_DI_SMD_RefineMV2_get_smd_resurrect_localcurr_num(data)               ((0x000F0000&(data))>>16)
#define  DI_DI_SMD_RefineMV2_get_smd_resurrect_minsad_th(data)                   ((0x0000FF00&(data))>>8)
#define  DI_DI_SMD_RefineMV2_get_smd_global_en_ratio(data)                       (0x000000FF&(data))

#define  DI_DI_SMD_RefineMV3                                                    0x180243C0
#define  DI_DI_SMD_RefineMV3_reg_addr                                            "0xB80243C0"
#define  DI_DI_SMD_RefineMV3_reg                                                 0xB80243C0
#define  DI_DI_SMD_RefineMV3_inst_addr                                           "0x00B7"
#define  set_DI_DI_SMD_RefineMV3_reg(data)                                       (*((volatile unsigned int*)DI_DI_SMD_RefineMV3_reg)=data)
#define  get_DI_DI_SMD_RefineMV3_reg                                             (*((volatile unsigned int*)DI_DI_SMD_RefineMV3_reg))
#define  DI_DI_SMD_RefineMV3_smd_sfreq_diff_gain_shift                           (24)
#define  DI_DI_SMD_RefineMV3_smd_sfreq_diff_th_shift                             (16)
#define  DI_DI_SMD_RefineMV3_smd_sfreq_drop_th_shift                             (0)
#define  DI_DI_SMD_RefineMV3_smd_sfreq_diff_gain_mask                            (0x0F000000)
#define  DI_DI_SMD_RefineMV3_smd_sfreq_diff_th_mask                              (0x00FF0000)
#define  DI_DI_SMD_RefineMV3_smd_sfreq_drop_th_mask                              (0x000003FF)
#define  DI_DI_SMD_RefineMV3_smd_sfreq_diff_gain(data)                           (0x0F000000&((data)<<24))
#define  DI_DI_SMD_RefineMV3_smd_sfreq_diff_th(data)                             (0x00FF0000&((data)<<16))
#define  DI_DI_SMD_RefineMV3_smd_sfreq_drop_th(data)                             (0x000003FF&(data))
#define  DI_DI_SMD_RefineMV3_get_smd_sfreq_diff_gain(data)                       ((0x0F000000&(data))>>24)
#define  DI_DI_SMD_RefineMV3_get_smd_sfreq_diff_th(data)                         ((0x00FF0000&(data))>>16)
#define  DI_DI_SMD_RefineMV3_get_smd_sfreq_drop_th(data)                         (0x000003FF&(data))

#define  DI_DI_SMD_Final_adjustment1                                            0x180243C8
#define  DI_DI_SMD_Final_adjustment1_reg_addr                                    "0xB80243C8"
#define  DI_DI_SMD_Final_adjustment1_reg                                         0xB80243C8
#define  DI_DI_SMD_Final_adjustment1_inst_addr                                   "0x00B8"
#define  set_DI_DI_SMD_Final_adjustment1_reg(data)                               (*((volatile unsigned int*)DI_DI_SMD_Final_adjustment1_reg)=data)
#define  get_DI_DI_SMD_Final_adjustment1_reg                                     (*((volatile unsigned int*)DI_DI_SMD_Final_adjustment1_reg))
#define  DI_DI_SMD_Final_adjustment1_smd_drop_singleweaveline_en_shift           (31)
#define  DI_DI_SMD_Final_adjustment1_smd_drop_singleintraline_en_shift           (30)
#define  DI_DI_SMD_Final_adjustment1_smd_leftweave_gap_range_shift               (24)
#define  DI_DI_SMD_Final_adjustment1_smd_leftweave_gap_th_shift                  (16)
#define  DI_DI_SMD_Final_adjustment1_smd_rightweave_gap_range_shift              (8)
#define  DI_DI_SMD_Final_adjustment1_smd_rightweave_gap_th_shift                 (0)
#define  DI_DI_SMD_Final_adjustment1_smd_drop_singleweaveline_en_mask            (0x80000000)
#define  DI_DI_SMD_Final_adjustment1_smd_drop_singleintraline_en_mask            (0x40000000)
#define  DI_DI_SMD_Final_adjustment1_smd_leftweave_gap_range_mask                (0x1F000000)
#define  DI_DI_SMD_Final_adjustment1_smd_leftweave_gap_th_mask                   (0x001F0000)
#define  DI_DI_SMD_Final_adjustment1_smd_rightweave_gap_range_mask               (0x00001F00)
#define  DI_DI_SMD_Final_adjustment1_smd_rightweave_gap_th_mask                  (0x0000001F)
#define  DI_DI_SMD_Final_adjustment1_smd_drop_singleweaveline_en(data)           (0x80000000&((data)<<31))
#define  DI_DI_SMD_Final_adjustment1_smd_drop_singleintraline_en(data)           (0x40000000&((data)<<30))
#define  DI_DI_SMD_Final_adjustment1_smd_leftweave_gap_range(data)               (0x1F000000&((data)<<24))
#define  DI_DI_SMD_Final_adjustment1_smd_leftweave_gap_th(data)                  (0x001F0000&((data)<<16))
#define  DI_DI_SMD_Final_adjustment1_smd_rightweave_gap_range(data)              (0x00001F00&((data)<<8))
#define  DI_DI_SMD_Final_adjustment1_smd_rightweave_gap_th(data)                 (0x0000001F&(data))
#define  DI_DI_SMD_Final_adjustment1_get_smd_drop_singleweaveline_en(data)       ((0x80000000&(data))>>31)
#define  DI_DI_SMD_Final_adjustment1_get_smd_drop_singleintraline_en(data)       ((0x40000000&(data))>>30)
#define  DI_DI_SMD_Final_adjustment1_get_smd_leftweave_gap_range(data)           ((0x1F000000&(data))>>24)
#define  DI_DI_SMD_Final_adjustment1_get_smd_leftweave_gap_th(data)              ((0x001F0000&(data))>>16)
#define  DI_DI_SMD_Final_adjustment1_get_smd_rightweave_gap_range(data)          ((0x00001F00&(data))>>8)
#define  DI_DI_SMD_Final_adjustment1_get_smd_rightweave_gap_th(data)             (0x0000001F&(data))

#define  DI_DI_SMD_Final_adjustment2                                            0x180243CC
#define  DI_DI_SMD_Final_adjustment2_reg_addr                                    "0xB80243CC"
#define  DI_DI_SMD_Final_adjustment2_reg                                         0xB80243CC
#define  DI_DI_SMD_Final_adjustment2_inst_addr                                   "0x00B9"
#define  set_DI_DI_SMD_Final_adjustment2_reg(data)                               (*((volatile unsigned int*)DI_DI_SMD_Final_adjustment2_reg)=data)
#define  get_DI_DI_SMD_Final_adjustment2_reg                                     (*((volatile unsigned int*)DI_DI_SMD_Final_adjustment2_reg))
#define  DI_DI_SMD_Final_adjustment2_smd_line_continous_en_shift                 (31)
#define  DI_DI_SMD_Final_adjustment2_smd_leftintra_gap_range_shift               (24)
#define  DI_DI_SMD_Final_adjustment2_smd_leftintra_gap_th_shift                  (16)
#define  DI_DI_SMD_Final_adjustment2_smd_rightintra_gap_range_shift              (8)
#define  DI_DI_SMD_Final_adjustment2_smd_rightintra_gap_th_shift                 (0)
#define  DI_DI_SMD_Final_adjustment2_smd_line_continous_en_mask                  (0x80000000)
#define  DI_DI_SMD_Final_adjustment2_smd_leftintra_gap_range_mask                (0x1F000000)
#define  DI_DI_SMD_Final_adjustment2_smd_leftintra_gap_th_mask                   (0x001F0000)
#define  DI_DI_SMD_Final_adjustment2_smd_rightintra_gap_range_mask               (0x00001F00)
#define  DI_DI_SMD_Final_adjustment2_smd_rightintra_gap_th_mask                  (0x0000001F)
#define  DI_DI_SMD_Final_adjustment2_smd_line_continous_en(data)                 (0x80000000&((data)<<31))
#define  DI_DI_SMD_Final_adjustment2_smd_leftintra_gap_range(data)               (0x1F000000&((data)<<24))
#define  DI_DI_SMD_Final_adjustment2_smd_leftintra_gap_th(data)                  (0x001F0000&((data)<<16))
#define  DI_DI_SMD_Final_adjustment2_smd_rightintra_gap_range(data)              (0x00001F00&((data)<<8))
#define  DI_DI_SMD_Final_adjustment2_smd_rightintra_gap_th(data)                 (0x0000001F&(data))
#define  DI_DI_SMD_Final_adjustment2_get_smd_line_continous_en(data)             ((0x80000000&(data))>>31)
#define  DI_DI_SMD_Final_adjustment2_get_smd_leftintra_gap_range(data)           ((0x1F000000&(data))>>24)
#define  DI_DI_SMD_Final_adjustment2_get_smd_leftintra_gap_th(data)              ((0x001F0000&(data))>>16)
#define  DI_DI_SMD_Final_adjustment2_get_smd_rightintra_gap_range(data)          ((0x00001F00&(data))>>8)
#define  DI_DI_SMD_Final_adjustment2_get_smd_rightintra_gap_th(data)             (0x0000001F&(data))

#define  DI_DI_SMD_Compensate                                                   0x180243D0
#define  DI_DI_SMD_Compensate_reg_addr                                           "0xB80243D0"
#define  DI_DI_SMD_Compensate_reg                                                0xB80243D0
#define  DI_DI_SMD_Compensate_inst_addr                                          "0x00BA"
#define  set_DI_DI_SMD_Compensate_reg(data)                                      (*((volatile unsigned int*)DI_DI_SMD_Compensate_reg)=data)
#define  get_DI_DI_SMD_Compensate_reg                                            (*((volatile unsigned int*)DI_DI_SMD_Compensate_reg))
#define  DI_DI_SMD_Compensate_smd_compensate_teeth_th_shift                      (8)
#define  DI_DI_SMD_Compensate_smd_compensate_avg_shift                           (0)
#define  DI_DI_SMD_Compensate_smd_compensate_teeth_th_mask                       (0x0000FF00)
#define  DI_DI_SMD_Compensate_smd_compensate_avg_mask                            (0x000000FF)
#define  DI_DI_SMD_Compensate_smd_compensate_teeth_th(data)                      (0x0000FF00&((data)<<8))
#define  DI_DI_SMD_Compensate_smd_compensate_avg(data)                           (0x000000FF&(data))
#define  DI_DI_SMD_Compensate_get_smd_compensate_teeth_th(data)                  ((0x0000FF00&(data))>>8)
#define  DI_DI_SMD_Compensate_get_smd_compensate_avg(data)                       (0x000000FF&(data))

#define  DI_IM_DI_RTNR_Y_16_TH0_TH3                                             0x180243D8
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_reg_addr                                     "0xB80243D8"
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_reg                                          0xB80243D8
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_inst_addr                                    "0x00BB"
#define  set_DI_IM_DI_RTNR_Y_16_TH0_TH3_reg(data)                                (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_TH0_TH3_reg)=data)
#define  get_DI_IM_DI_RTNR_Y_16_TH0_TH3_reg                                      (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_TH0_TH3_reg))
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly3_shift                       (24)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly2_shift                       (16)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly1_shift                       (8)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly0_shift                       (0)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly3_mask                        (0xFF000000)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly2_mask                        (0x00FF0000)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly1_mask                        (0x0000FF00)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly0_mask                        (0x000000FF)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly3(data)                       (0xFF000000&((data)<<24))
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly2(data)                       (0x00FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly1(data)                       (0x0000FF00&((data)<<8))
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_cp_temporalthly0(data)                       (0x000000FF&(data))
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_get_cp_temporalthly3(data)                   ((0xFF000000&(data))>>24)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_get_cp_temporalthly2(data)                   ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_get_cp_temporalthly1(data)                   ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_RTNR_Y_16_TH0_TH3_get_cp_temporalthly0(data)                   (0x000000FF&(data))

#define  DI_IM_DI_RTNR_Y_16_TH4_TH7                                             0x180243DC
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_reg_addr                                     "0xB80243DC"
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_reg                                          0xB80243DC
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_inst_addr                                    "0x00BC"
#define  set_DI_IM_DI_RTNR_Y_16_TH4_TH7_reg(data)                                (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_TH4_TH7_reg)=data)
#define  get_DI_IM_DI_RTNR_Y_16_TH4_TH7_reg                                      (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_TH4_TH7_reg))
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly7_shift                       (24)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly6_shift                       (16)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly5_shift                       (8)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly4_shift                       (0)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly7_mask                        (0xFF000000)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly6_mask                        (0x00FF0000)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly5_mask                        (0x0000FF00)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly4_mask                        (0x000000FF)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly7(data)                       (0xFF000000&((data)<<24))
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly6(data)                       (0x00FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly5(data)                       (0x0000FF00&((data)<<8))
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_cp_temporalthly4(data)                       (0x000000FF&(data))
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_get_cp_temporalthly7(data)                   ((0xFF000000&(data))>>24)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_get_cp_temporalthly6(data)                   ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_get_cp_temporalthly5(data)                   ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_RTNR_Y_16_TH4_TH7_get_cp_temporalthly4(data)                   (0x000000FF&(data))

#define  DI_IM_DI_RTNR_Y_16_TH8_TH11                                            0x180243E0
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_reg_addr                                    "0xB80243E0"
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_reg                                         0xB80243E0
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_inst_addr                                   "0x00BD"
#define  set_DI_IM_DI_RTNR_Y_16_TH8_TH11_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_TH8_TH11_reg)=data)
#define  get_DI_IM_DI_RTNR_Y_16_TH8_TH11_reg                                     (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_TH8_TH11_reg))
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly11_shift                     (24)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly10_shift                     (16)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly9_shift                      (8)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly8_shift                      (0)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly11_mask                      (0xFF000000)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly10_mask                      (0x00FF0000)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly9_mask                       (0x0000FF00)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly8_mask                       (0x000000FF)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly11(data)                     (0xFF000000&((data)<<24))
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly10(data)                     (0x00FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly9(data)                      (0x0000FF00&((data)<<8))
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_cp_temporalthly8(data)                      (0x000000FF&(data))
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_get_cp_temporalthly11(data)                 ((0xFF000000&(data))>>24)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_get_cp_temporalthly10(data)                 ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_get_cp_temporalthly9(data)                  ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_RTNR_Y_16_TH8_TH11_get_cp_temporalthly8(data)                  (0x000000FF&(data))

#define  DI_IM_DI_RTNR_Y_16_TH12_TH14                                           0x180243E4
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_reg_addr                                   "0xB80243E4"
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_reg                                        0xB80243E4
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_inst_addr                                  "0x00BE"
#define  set_DI_IM_DI_RTNR_Y_16_TH12_TH14_reg(data)                              (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_TH12_TH14_reg)=data)
#define  get_DI_IM_DI_RTNR_Y_16_TH12_TH14_reg                                    (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_TH12_TH14_reg))
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_cp_temporalthly14_shift                    (16)
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_cp_temporalthly13_shift                    (8)
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_cp_temporalthly12_shift                    (0)
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_cp_temporalthly14_mask                     (0x00FF0000)
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_cp_temporalthly13_mask                     (0x0000FF00)
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_cp_temporalthly12_mask                     (0x000000FF)
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_cp_temporalthly14(data)                    (0x00FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_cp_temporalthly13(data)                    (0x0000FF00&((data)<<8))
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_cp_temporalthly12(data)                    (0x000000FF&(data))
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_get_cp_temporalthly14(data)                ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_get_cp_temporalthly13(data)                ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_RTNR_Y_16_TH12_TH14_get_cp_temporalthly12(data)                (0x000000FF&(data))

#define  DI_IM_DI_RTNR_C_TH0_TH3                                                0x180243E8
#define  DI_IM_DI_RTNR_C_TH0_TH3_reg_addr                                        "0xB80243E8"
#define  DI_IM_DI_RTNR_C_TH0_TH3_reg                                             0xB80243E8
#define  DI_IM_DI_RTNR_C_TH0_TH3_inst_addr                                       "0x00BF"
#define  set_DI_IM_DI_RTNR_C_TH0_TH3_reg(data)                                   (*((volatile unsigned int*)DI_IM_DI_RTNR_C_TH0_TH3_reg)=data)
#define  get_DI_IM_DI_RTNR_C_TH0_TH3_reg                                         (*((volatile unsigned int*)DI_IM_DI_RTNR_C_TH0_TH3_reg))
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc3_shift                          (24)
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc2_shift                          (16)
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc1_shift                          (8)
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc0_shift                          (0)
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc3_mask                           (0xFF000000)
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc2_mask                           (0x00FF0000)
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc1_mask                           (0x0000FF00)
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc0_mask                           (0x000000FF)
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc3(data)                          (0xFF000000&((data)<<24))
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc2(data)                          (0x00FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc1(data)                          (0x0000FF00&((data)<<8))
#define  DI_IM_DI_RTNR_C_TH0_TH3_cp_temporalthlc0(data)                          (0x000000FF&(data))
#define  DI_IM_DI_RTNR_C_TH0_TH3_get_cp_temporalthlc3(data)                      ((0xFF000000&(data))>>24)
#define  DI_IM_DI_RTNR_C_TH0_TH3_get_cp_temporalthlc2(data)                      ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_C_TH0_TH3_get_cp_temporalthlc1(data)                      ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_RTNR_C_TH0_TH3_get_cp_temporalthlc0(data)                      (0x000000FF&(data))

#define  DI_IM_DI_RTNR_C_TH4_TH6                                                0x180243EC
#define  DI_IM_DI_RTNR_C_TH4_TH6_reg_addr                                        "0xB80243EC"
#define  DI_IM_DI_RTNR_C_TH4_TH6_reg                                             0xB80243EC
#define  DI_IM_DI_RTNR_C_TH4_TH6_inst_addr                                       "0x00C0"
#define  set_DI_IM_DI_RTNR_C_TH4_TH6_reg(data)                                   (*((volatile unsigned int*)DI_IM_DI_RTNR_C_TH4_TH6_reg)=data)
#define  get_DI_IM_DI_RTNR_C_TH4_TH6_reg                                         (*((volatile unsigned int*)DI_IM_DI_RTNR_C_TH4_TH6_reg))
#define  DI_IM_DI_RTNR_C_TH4_TH6_cp_temporalthlc6_shift                          (16)
#define  DI_IM_DI_RTNR_C_TH4_TH6_cp_temporalthlc5_shift                          (8)
#define  DI_IM_DI_RTNR_C_TH4_TH6_cp_temporalthlc4_shift                          (0)
#define  DI_IM_DI_RTNR_C_TH4_TH6_cp_temporalthlc6_mask                           (0x00FF0000)
#define  DI_IM_DI_RTNR_C_TH4_TH6_cp_temporalthlc5_mask                           (0x0000FF00)
#define  DI_IM_DI_RTNR_C_TH4_TH6_cp_temporalthlc4_mask                           (0x000000FF)
#define  DI_IM_DI_RTNR_C_TH4_TH6_cp_temporalthlc6(data)                          (0x00FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_C_TH4_TH6_cp_temporalthlc5(data)                          (0x0000FF00&((data)<<8))
#define  DI_IM_DI_RTNR_C_TH4_TH6_cp_temporalthlc4(data)                          (0x000000FF&(data))
#define  DI_IM_DI_RTNR_C_TH4_TH6_get_cp_temporalthlc6(data)                      ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_C_TH4_TH6_get_cp_temporalthlc5(data)                      ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_RTNR_C_TH4_TH6_get_cp_temporalthlc4(data)                      (0x000000FF&(data))

#define  DI_IM_DI_RTNR_Y_16_K0_K7                                               0x180243F0
#define  DI_IM_DI_RTNR_Y_16_K0_K7_reg_addr                                       "0xB80243F0"
#define  DI_IM_DI_RTNR_Y_16_K0_K7_reg                                            0xB80243F0
#define  DI_IM_DI_RTNR_Y_16_K0_K7_inst_addr                                      "0x00C1"
#define  set_DI_IM_DI_RTNR_Y_16_K0_K7_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_K0_K7_reg)=data)
#define  get_DI_IM_DI_RTNR_Y_16_K0_K7_reg                                        (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_K0_K7_reg))
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k7_shift                         (28)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k6_shift                         (24)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k5_shift                         (20)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k4_shift                         (16)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k3_shift                         (12)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k2_shift                         (8)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k1_shift                         (4)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k0_shift                         (0)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k7_mask                          (0xF0000000)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k6_mask                          (0x0F000000)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k5_mask                          (0x00F00000)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k4_mask                          (0x000F0000)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k3_mask                          (0x0000F000)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k2_mask                          (0x00000F00)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k1_mask                          (0x000000F0)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k0_mask                          (0x0000000F)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k7(data)                         (0xF0000000&((data)<<28))
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k6(data)                         (0x0F000000&((data)<<24))
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k5(data)                         (0x00F00000&((data)<<20))
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k4(data)                         (0x000F0000&((data)<<16))
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k3(data)                         (0x0000F000&((data)<<12))
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k2(data)                         (0x00000F00&((data)<<8))
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k1(data)                         (0x000000F0&((data)<<4))
#define  DI_IM_DI_RTNR_Y_16_K0_K7_cp_temporal_y_k0(data)                         (0x0000000F&(data))
#define  DI_IM_DI_RTNR_Y_16_K0_K7_get_cp_temporal_y_k7(data)                     ((0xF0000000&(data))>>28)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_get_cp_temporal_y_k6(data)                     ((0x0F000000&(data))>>24)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_get_cp_temporal_y_k5(data)                     ((0x00F00000&(data))>>20)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_get_cp_temporal_y_k4(data)                     ((0x000F0000&(data))>>16)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_get_cp_temporal_y_k3(data)                     ((0x0000F000&(data))>>12)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_get_cp_temporal_y_k2(data)                     ((0x00000F00&(data))>>8)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_get_cp_temporal_y_k1(data)                     ((0x000000F0&(data))>>4)
#define  DI_IM_DI_RTNR_Y_16_K0_K7_get_cp_temporal_y_k0(data)                     (0x0000000F&(data))

#define  DI_IM_DI_RTNR_Y_16_K8_K15                                              0x180243F4
#define  DI_IM_DI_RTNR_Y_16_K8_K15_reg_addr                                      "0xB80243F4"
#define  DI_IM_DI_RTNR_Y_16_K8_K15_reg                                           0xB80243F4
#define  DI_IM_DI_RTNR_Y_16_K8_K15_inst_addr                                     "0x00C2"
#define  set_DI_IM_DI_RTNR_Y_16_K8_K15_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_K8_K15_reg)=data)
#define  get_DI_IM_DI_RTNR_Y_16_K8_K15_reg                                       (*((volatile unsigned int*)DI_IM_DI_RTNR_Y_16_K8_K15_reg))
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k15_shift                       (28)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k14_shift                       (24)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k13_shift                       (20)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k12_shift                       (16)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k11_shift                       (12)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k10_shift                       (8)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k9_shift                        (4)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k8_shift                        (0)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k15_mask                        (0xF0000000)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k14_mask                        (0x0F000000)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k13_mask                        (0x00F00000)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k12_mask                        (0x000F0000)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k11_mask                        (0x0000F000)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k10_mask                        (0x00000F00)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k9_mask                         (0x000000F0)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k8_mask                         (0x0000000F)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k15(data)                       (0xF0000000&((data)<<28))
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k14(data)                       (0x0F000000&((data)<<24))
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k13(data)                       (0x00F00000&((data)<<20))
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k12(data)                       (0x000F0000&((data)<<16))
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k11(data)                       (0x0000F000&((data)<<12))
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k10(data)                       (0x00000F00&((data)<<8))
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k9(data)                        (0x000000F0&((data)<<4))
#define  DI_IM_DI_RTNR_Y_16_K8_K15_cp_temporal_y_k8(data)                        (0x0000000F&(data))
#define  DI_IM_DI_RTNR_Y_16_K8_K15_get_cp_temporal_y_k15(data)                   ((0xF0000000&(data))>>28)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_get_cp_temporal_y_k14(data)                   ((0x0F000000&(data))>>24)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_get_cp_temporal_y_k13(data)                   ((0x00F00000&(data))>>20)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_get_cp_temporal_y_k12(data)                   ((0x000F0000&(data))>>16)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_get_cp_temporal_y_k11(data)                   ((0x0000F000&(data))>>12)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_get_cp_temporal_y_k10(data)                   ((0x00000F00&(data))>>8)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_get_cp_temporal_y_k9(data)                    ((0x000000F0&(data))>>4)
#define  DI_IM_DI_RTNR_Y_16_K8_K15_get_cp_temporal_y_k8(data)                    (0x0000000F&(data))

#define  DI_IM_DI_RTNR_C_K                                                      0x180243F8
#define  DI_IM_DI_RTNR_C_K_reg_addr                                              "0xB80243F8"
#define  DI_IM_DI_RTNR_C_K_reg                                                   0xB80243F8
#define  DI_IM_DI_RTNR_C_K_inst_addr                                             "0x00C3"
#define  set_DI_IM_DI_RTNR_C_K_reg(data)                                         (*((volatile unsigned int*)DI_IM_DI_RTNR_C_K_reg)=data)
#define  get_DI_IM_DI_RTNR_C_K_reg                                               (*((volatile unsigned int*)DI_IM_DI_RTNR_C_K_reg))
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k7_shift                                (28)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k6_shift                                (24)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k5_shift                                (20)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k4_shift                                (16)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k3_shift                                (12)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k2_shift                                (8)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k1_shift                                (4)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k0_shift                                (0)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k7_mask                                 (0x70000000)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k6_mask                                 (0x07000000)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k5_mask                                 (0x00700000)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k4_mask                                 (0x00070000)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k3_mask                                 (0x00007000)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k2_mask                                 (0x00000700)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k1_mask                                 (0x00000070)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k0_mask                                 (0x00000007)
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k7(data)                                (0x70000000&((data)<<28))
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k6(data)                                (0x07000000&((data)<<24))
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k5(data)                                (0x00700000&((data)<<20))
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k4(data)                                (0x00070000&((data)<<16))
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k3(data)                                (0x00007000&((data)<<12))
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k2(data)                                (0x00000700&((data)<<8))
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k1(data)                                (0x00000070&((data)<<4))
#define  DI_IM_DI_RTNR_C_K_cp_temporal_c_k0(data)                                (0x00000007&(data))
#define  DI_IM_DI_RTNR_C_K_get_cp_temporal_c_k7(data)                            ((0x70000000&(data))>>28)
#define  DI_IM_DI_RTNR_C_K_get_cp_temporal_c_k6(data)                            ((0x07000000&(data))>>24)
#define  DI_IM_DI_RTNR_C_K_get_cp_temporal_c_k5(data)                            ((0x00700000&(data))>>20)
#define  DI_IM_DI_RTNR_C_K_get_cp_temporal_c_k4(data)                            ((0x00070000&(data))>>16)
#define  DI_IM_DI_RTNR_C_K_get_cp_temporal_c_k3(data)                            ((0x00007000&(data))>>12)
#define  DI_IM_DI_RTNR_C_K_get_cp_temporal_c_k2(data)                            ((0x00000700&(data))>>8)
#define  DI_IM_DI_RTNR_C_K_get_cp_temporal_c_k1(data)                            ((0x00000070&(data))>>4)
#define  DI_IM_DI_RTNR_C_K_get_cp_temporal_c_k0(data)                            (0x00000007&(data))

#define  DI_DI_DATMemoryStartAdd1                                               0x18024400
#define  DI_DI_DATMemoryStartAdd1_reg_addr                                       "0xB8024400"
#define  DI_DI_DATMemoryStartAdd1_reg                                            0xB8024400
#define  DI_DI_DATMemoryStartAdd1_inst_addr                                      "0x00C4"
#define  set_DI_DI_DATMemoryStartAdd1_reg(data)                                  (*((volatile unsigned int*)DI_DI_DATMemoryStartAdd1_reg)=data)
#define  get_DI_DI_DATMemoryStartAdd1_reg                                        (*((volatile unsigned int*)DI_DI_DATMemoryStartAdd1_reg))
#define  DI_DI_DATMemoryStartAdd1_dat_mstart_115_87_shift                        (3)
#define  DI_DI_DATMemoryStartAdd1_dat_mstart_115_87_mask                         (0xFFFFFFF8)
#define  DI_DI_DATMemoryStartAdd1_dat_mstart_115_87(data)                        (0xFFFFFFF8&((data)<<3))
#define  DI_DI_DATMemoryStartAdd1_get_dat_mstart_115_87(data)                    ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_DATMemoryStartAdd2                                               0x18024404
#define  DI_DI_DATMemoryStartAdd2_reg_addr                                       "0xB8024404"
#define  DI_DI_DATMemoryStartAdd2_reg                                            0xB8024404
#define  DI_DI_DATMemoryStartAdd2_inst_addr                                      "0x00C5"
#define  set_DI_DI_DATMemoryStartAdd2_reg(data)                                  (*((volatile unsigned int*)DI_DI_DATMemoryStartAdd2_reg)=data)
#define  get_DI_DI_DATMemoryStartAdd2_reg                                        (*((volatile unsigned int*)DI_DI_DATMemoryStartAdd2_reg))
#define  DI_DI_DATMemoryStartAdd2_dat_mstart_86_58_shift                         (3)
#define  DI_DI_DATMemoryStartAdd2_dat_mstart_86_58_mask                          (0xFFFFFFF8)
#define  DI_DI_DATMemoryStartAdd2_dat_mstart_86_58(data)                         (0xFFFFFFF8&((data)<<3))
#define  DI_DI_DATMemoryStartAdd2_get_dat_mstart_86_58(data)                     ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_DATMemoryStartAdd3                                               0x18024408
#define  DI_DI_DATMemoryStartAdd3_reg_addr                                       "0xB8024408"
#define  DI_DI_DATMemoryStartAdd3_reg                                            0xB8024408
#define  DI_DI_DATMemoryStartAdd3_inst_addr                                      "0x00C6"
#define  set_DI_DI_DATMemoryStartAdd3_reg(data)                                  (*((volatile unsigned int*)DI_DI_DATMemoryStartAdd3_reg)=data)
#define  get_DI_DI_DATMemoryStartAdd3_reg                                        (*((volatile unsigned int*)DI_DI_DATMemoryStartAdd3_reg))
#define  DI_DI_DATMemoryStartAdd3_dat_mstart_57_29_shift                         (3)
#define  DI_DI_DATMemoryStartAdd3_dat_mstart_57_29_mask                          (0xFFFFFFF8)
#define  DI_DI_DATMemoryStartAdd3_dat_mstart_57_29(data)                         (0xFFFFFFF8&((data)<<3))
#define  DI_DI_DATMemoryStartAdd3_get_dat_mstart_57_29(data)                     ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_DATMemoryStartAdd4                                               0x1802440C
#define  DI_DI_DATMemoryStartAdd4_reg_addr                                       "0xB802440C"
#define  DI_DI_DATMemoryStartAdd4_reg                                            0xB802440C
#define  DI_DI_DATMemoryStartAdd4_inst_addr                                      "0x00C7"
#define  set_DI_DI_DATMemoryStartAdd4_reg(data)                                  (*((volatile unsigned int*)DI_DI_DATMemoryStartAdd4_reg)=data)
#define  get_DI_DI_DATMemoryStartAdd4_reg                                        (*((volatile unsigned int*)DI_DI_DATMemoryStartAdd4_reg))
#define  DI_DI_DATMemoryStartAdd4_dat_mstart_28_0_shift                          (3)
#define  DI_DI_DATMemoryStartAdd4_dat_mstart_28_0_mask                           (0xFFFFFFF8)
#define  DI_DI_DATMemoryStartAdd4_dat_mstart_28_0(data)                          (0xFFFFFFF8&((data)<<3))
#define  DI_DI_DATMemoryStartAdd4_get_dat_mstart_28_0(data)                      ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_INFMemoryStartAdd1                                               0x18024410
#define  DI_DI_INFMemoryStartAdd1_reg_addr                                       "0xB8024410"
#define  DI_DI_INFMemoryStartAdd1_reg                                            0xB8024410
#define  DI_DI_INFMemoryStartAdd1_inst_addr                                      "0x00C8"
#define  set_DI_DI_INFMemoryStartAdd1_reg(data)                                  (*((volatile unsigned int*)DI_DI_INFMemoryStartAdd1_reg)=data)
#define  get_DI_DI_INFMemoryStartAdd1_reg                                        (*((volatile unsigned int*)DI_DI_INFMemoryStartAdd1_reg))
#define  DI_DI_INFMemoryStartAdd1_inf_mstart_57_29_shift                         (3)
#define  DI_DI_INFMemoryStartAdd1_inf_mstart_57_29_mask                          (0xFFFFFFF8)
#define  DI_DI_INFMemoryStartAdd1_inf_mstart_57_29(data)                         (0xFFFFFFF8&((data)<<3))
#define  DI_DI_INFMemoryStartAdd1_get_inf_mstart_57_29(data)                     ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_INFMemoryStartAdd2                                               0x18024414
#define  DI_DI_INFMemoryStartAdd2_reg_addr                                       "0xB8024414"
#define  DI_DI_INFMemoryStartAdd2_reg                                            0xB8024414
#define  DI_DI_INFMemoryStartAdd2_inst_addr                                      "0x00C9"
#define  set_DI_DI_INFMemoryStartAdd2_reg(data)                                  (*((volatile unsigned int*)DI_DI_INFMemoryStartAdd2_reg)=data)
#define  get_DI_DI_INFMemoryStartAdd2_reg                                        (*((volatile unsigned int*)DI_DI_INFMemoryStartAdd2_reg))
#define  DI_DI_INFMemoryStartAdd2_inf_mstart_28_0_shift                          (3)
#define  DI_DI_INFMemoryStartAdd2_inf_mstart_28_0_mask                           (0xFFFFFFF8)
#define  DI_DI_INFMemoryStartAdd2_inf_mstart_28_0(data)                          (0xFFFFFFF8&((data)<<3))
#define  DI_DI_INFMemoryStartAdd2_get_inf_mstart_28_0(data)                      ((0xFFFFFFF8&(data))>>3)

#define  DI_DDR_RDATDMA_WTLENNUM                                                0x18024418
#define  DI_DDR_RDATDMA_WTLENNUM_reg_addr                                        "0xB8024418"
#define  DI_DDR_RDATDMA_WTLENNUM_reg                                             0xB8024418
#define  DI_DDR_RDATDMA_WTLENNUM_inst_addr                                       "0x00CA"
#define  set_DI_DDR_RDATDMA_WTLENNUM_reg(data)                                   (*((volatile unsigned int*)DI_DDR_RDATDMA_WTLENNUM_reg)=data)
#define  get_DI_DDR_RDATDMA_WTLENNUM_reg                                         (*((volatile unsigned int*)DI_DDR_RDATDMA_WTLENNUM_reg))
#define  DI_DDR_RDATDMA_WTLENNUM_dat_water_r_shift                               (24)
#define  DI_DDR_RDATDMA_WTLENNUM_dma_outstanding_en_shift                        (23)
#define  DI_DDR_RDATDMA_WTLENNUM_dat_len_r_shift                                 (16)
#define  DI_DDR_RDATDMA_WTLENNUM_dat_num_r_shift                                 (0)
#define  DI_DDR_RDATDMA_WTLENNUM_dat_water_r_mask                                (0xFF000000)
#define  DI_DDR_RDATDMA_WTLENNUM_dma_outstanding_en_mask                         (0x00800000)
#define  DI_DDR_RDATDMA_WTLENNUM_dat_len_r_mask                                  (0x007F0000)
#define  DI_DDR_RDATDMA_WTLENNUM_dat_num_r_mask                                  (0x0000FFFF)
#define  DI_DDR_RDATDMA_WTLENNUM_dat_water_r(data)                               (0xFF000000&((data)<<24))
#define  DI_DDR_RDATDMA_WTLENNUM_dma_outstanding_en(data)                        (0x00800000&((data)<<23))
#define  DI_DDR_RDATDMA_WTLENNUM_dat_len_r(data)                                 (0x007F0000&((data)<<16))
#define  DI_DDR_RDATDMA_WTLENNUM_dat_num_r(data)                                 (0x0000FFFF&(data))
#define  DI_DDR_RDATDMA_WTLENNUM_get_dat_water_r(data)                           ((0xFF000000&(data))>>24)
#define  DI_DDR_RDATDMA_WTLENNUM_get_dma_outstanding_en(data)                    ((0x00800000&(data))>>23)
#define  DI_DDR_RDATDMA_WTLENNUM_get_dat_len_r(data)                             ((0x007F0000&(data))>>16)
#define  DI_DDR_RDATDMA_WTLENNUM_get_dat_num_r(data)                             (0x0000FFFF&(data))

#define  DI_DDR_WDATDMA_WTLENNUM                                                0x1802441C
#define  DI_DDR_WDATDMA_WTLENNUM_reg_addr                                        "0xB802441C"
#define  DI_DDR_WDATDMA_WTLENNUM_reg                                             0xB802441C
#define  DI_DDR_WDATDMA_WTLENNUM_inst_addr                                       "0x00CB"
#define  set_DI_DDR_WDATDMA_WTLENNUM_reg(data)                                   (*((volatile unsigned int*)DI_DDR_WDATDMA_WTLENNUM_reg)=data)
#define  get_DI_DDR_WDATDMA_WTLENNUM_reg                                         (*((volatile unsigned int*)DI_DDR_WDATDMA_WTLENNUM_reg))
#define  DI_DDR_WDATDMA_WTLENNUM_dat_water_w_shift                               (24)
#define  DI_DDR_WDATDMA_WTLENNUM_wdma_close_shift                                (23)
#define  DI_DDR_WDATDMA_WTLENNUM_dat_len_w_shift                                 (16)
#define  DI_DDR_WDATDMA_WTLENNUM_dat_num_w_shift                                 (0)
#define  DI_DDR_WDATDMA_WTLENNUM_dat_water_w_mask                                (0xFF000000)
#define  DI_DDR_WDATDMA_WTLENNUM_wdma_close_mask                                 (0x00800000)
#define  DI_DDR_WDATDMA_WTLENNUM_dat_len_w_mask                                  (0x007F0000)
#define  DI_DDR_WDATDMA_WTLENNUM_dat_num_w_mask                                  (0x0000FFFF)
#define  DI_DDR_WDATDMA_WTLENNUM_dat_water_w(data)                               (0xFF000000&((data)<<24))
#define  DI_DDR_WDATDMA_WTLENNUM_wdma_close(data)                                (0x00800000&((data)<<23))
#define  DI_DDR_WDATDMA_WTLENNUM_dat_len_w(data)                                 (0x007F0000&((data)<<16))
#define  DI_DDR_WDATDMA_WTLENNUM_dat_num_w(data)                                 (0x0000FFFF&(data))
#define  DI_DDR_WDATDMA_WTLENNUM_get_dat_water_w(data)                           ((0xFF000000&(data))>>24)
#define  DI_DDR_WDATDMA_WTLENNUM_get_wdma_close(data)                            ((0x00800000&(data))>>23)
#define  DI_DDR_WDATDMA_WTLENNUM_get_dat_len_w(data)                             ((0x007F0000&(data))>>16)
#define  DI_DDR_WDATDMA_WTLENNUM_get_dat_num_w(data)                             (0x0000FFFF&(data))

#define  DI_DDR_DATDMA_RM                                                       0x18024420
#define  DI_DDR_DATDMA_RM_reg_addr                                               "0xB8024420"
#define  DI_DDR_DATDMA_RM_reg                                                    0xB8024420
#define  DI_DDR_DATDMA_RM_inst_addr                                              "0x00CC"
#define  set_DI_DDR_DATDMA_RM_reg(data)                                          (*((volatile unsigned int*)DI_DDR_DATDMA_RM_reg)=data)
#define  get_DI_DDR_DATDMA_RM_reg                                                (*((volatile unsigned int*)DI_DDR_DATDMA_RM_reg))
#define  DI_DDR_DATDMA_RM_rdma_remain_en_shift                                   (15)
#define  DI_DDR_DATDMA_RM_dat_remain_w_shift                                     (8)
#define  DI_DDR_DATDMA_RM_dat_remain_r_shift                                     (0)
#define  DI_DDR_DATDMA_RM_rdma_remain_en_mask                                    (0x00008000)
#define  DI_DDR_DATDMA_RM_dat_remain_w_mask                                      (0x00007F00)
#define  DI_DDR_DATDMA_RM_dat_remain_r_mask                                      (0x0000007F)
#define  DI_DDR_DATDMA_RM_rdma_remain_en(data)                                   (0x00008000&((data)<<15))
#define  DI_DDR_DATDMA_RM_dat_remain_w(data)                                     (0x00007F00&((data)<<8))
#define  DI_DDR_DATDMA_RM_dat_remain_r(data)                                     (0x0000007F&(data))
#define  DI_DDR_DATDMA_RM_get_rdma_remain_en(data)                               ((0x00008000&(data))>>15)
#define  DI_DDR_DATDMA_RM_get_dat_remain_w(data)                                 ((0x00007F00&(data))>>8)
#define  DI_DDR_DATDMA_RM_get_dat_remain_r(data)                                 (0x0000007F&(data))

#define  DI_DDR_RINFDMA_WTLENNUM                                                0x18024424
#define  DI_DDR_RINFDMA_WTLENNUM_reg_addr                                        "0xB8024424"
#define  DI_DDR_RINFDMA_WTLENNUM_reg                                             0xB8024424
#define  DI_DDR_RINFDMA_WTLENNUM_inst_addr                                       "0x00CD"
#define  set_DI_DDR_RINFDMA_WTLENNUM_reg(data)                                   (*((volatile unsigned int*)DI_DDR_RINFDMA_WTLENNUM_reg)=data)
#define  get_DI_DDR_RINFDMA_WTLENNUM_reg                                         (*((volatile unsigned int*)DI_DDR_RINFDMA_WTLENNUM_reg))
#define  DI_DDR_RINFDMA_WTLENNUM_inf_water_r_shift                               (24)
#define  DI_DDR_RINFDMA_WTLENNUM_inf_len_r_shift                                 (16)
#define  DI_DDR_RINFDMA_WTLENNUM_inf_num_r_shift                                 (0)
#define  DI_DDR_RINFDMA_WTLENNUM_inf_water_r_mask                                (0xFF000000)
#define  DI_DDR_RINFDMA_WTLENNUM_inf_len_r_mask                                  (0x007F0000)
#define  DI_DDR_RINFDMA_WTLENNUM_inf_num_r_mask                                  (0x0000FFFF)
#define  DI_DDR_RINFDMA_WTLENNUM_inf_water_r(data)                               (0xFF000000&((data)<<24))
#define  DI_DDR_RINFDMA_WTLENNUM_inf_len_r(data)                                 (0x007F0000&((data)<<16))
#define  DI_DDR_RINFDMA_WTLENNUM_inf_num_r(data)                                 (0x0000FFFF&(data))
#define  DI_DDR_RINFDMA_WTLENNUM_get_inf_water_r(data)                           ((0xFF000000&(data))>>24)
#define  DI_DDR_RINFDMA_WTLENNUM_get_inf_len_r(data)                             ((0x007F0000&(data))>>16)
#define  DI_DDR_RINFDMA_WTLENNUM_get_inf_num_r(data)                             (0x0000FFFF&(data))

#define  DI_DDR_WINFDMA_WTLENNUM                                                0x18024428
#define  DI_DDR_WINFDMA_WTLENNUM_reg_addr                                        "0xB8024428"
#define  DI_DDR_WINFDMA_WTLENNUM_reg                                             0xB8024428
#define  DI_DDR_WINFDMA_WTLENNUM_inst_addr                                       "0x00CE"
#define  set_DI_DDR_WINFDMA_WTLENNUM_reg(data)                                   (*((volatile unsigned int*)DI_DDR_WINFDMA_WTLENNUM_reg)=data)
#define  get_DI_DDR_WINFDMA_WTLENNUM_reg                                         (*((volatile unsigned int*)DI_DDR_WINFDMA_WTLENNUM_reg))
#define  DI_DDR_WINFDMA_WTLENNUM_inf_water_w_shift                               (24)
#define  DI_DDR_WINFDMA_WTLENNUM_inf_len_w_shift                                 (16)
#define  DI_DDR_WINFDMA_WTLENNUM_inf_num_w_shift                                 (0)
#define  DI_DDR_WINFDMA_WTLENNUM_inf_water_w_mask                                (0xFF000000)
#define  DI_DDR_WINFDMA_WTLENNUM_inf_len_w_mask                                  (0x007F0000)
#define  DI_DDR_WINFDMA_WTLENNUM_inf_num_w_mask                                  (0x0000FFFF)
#define  DI_DDR_WINFDMA_WTLENNUM_inf_water_w(data)                               (0xFF000000&((data)<<24))
#define  DI_DDR_WINFDMA_WTLENNUM_inf_len_w(data)                                 (0x007F0000&((data)<<16))
#define  DI_DDR_WINFDMA_WTLENNUM_inf_num_w(data)                                 (0x0000FFFF&(data))
#define  DI_DDR_WINFDMA_WTLENNUM_get_inf_water_w(data)                           ((0xFF000000&(data))>>24)
#define  DI_DDR_WINFDMA_WTLENNUM_get_inf_len_w(data)                             ((0x007F0000&(data))>>16)
#define  DI_DDR_WINFDMA_WTLENNUM_get_inf_num_w(data)                             (0x0000FFFF&(data))

#define  DI_DDR_INFDMA_RM                                                       0x1802442C
#define  DI_DDR_INFDMA_RM_reg_addr                                               "0xB802442C"
#define  DI_DDR_INFDMA_RM_reg                                                    0xB802442C
#define  DI_DDR_INFDMA_RM_inst_addr                                              "0x00CF"
#define  set_DI_DDR_INFDMA_RM_reg(data)                                          (*((volatile unsigned int*)DI_DDR_INFDMA_RM_reg)=data)
#define  get_DI_DDR_INFDMA_RM_reg                                                (*((volatile unsigned int*)DI_DDR_INFDMA_RM_reg))
#define  DI_DDR_INFDMA_RM_inf_remain_w_shift                                     (8)
#define  DI_DDR_INFDMA_RM_inf_remain_r_shift                                     (0)
#define  DI_DDR_INFDMA_RM_inf_remain_w_mask                                      (0x00007F00)
#define  DI_DDR_INFDMA_RM_inf_remain_r_mask                                      (0x0000007F)
#define  DI_DDR_INFDMA_RM_inf_remain_w(data)                                     (0x00007F00&((data)<<8))
#define  DI_DDR_INFDMA_RM_inf_remain_r(data)                                     (0x0000007F&(data))
#define  DI_DDR_INFDMA_RM_get_inf_remain_w(data)                                 ((0x00007F00&(data))>>8)
#define  DI_DDR_INFDMA_RM_get_inf_remain_r(data)                                 (0x0000007F&(data))

#define  DI_DDR_DMAStatus                                                       0x18024430
#define  DI_DDR_DMAStatus_reg_addr                                               "0xB8024430"
#define  DI_DDR_DMAStatus_reg                                                    0xB8024430
#define  DI_DDR_DMAStatus_inst_addr                                              "0x00D0"
#define  set_DI_DDR_DMAStatus_reg(data)                                          (*((volatile unsigned int*)DI_DDR_DMAStatus_reg)=data)
#define  get_DI_DDR_DMAStatus_reg                                                (*((volatile unsigned int*)DI_DDR_DMAStatus_reg))
#define  DI_DDR_DMAStatus_ccdinr_fifoerr_ie_shift                                (31)
#define  DI_DDR_DMAStatus_crc_128b_en_shift                                      (26)
#define  DI_DDR_DMAStatus_crc_128b_compare_fail_shift                            (25)
#define  DI_DDR_DMAStatus_dma_reset_st_shift                                     (24)
#define  DI_DDR_DMAStatus_ccdinr_flag_clr_shift                                  (16)
#define  DI_DDR_DMAStatus_ccdinr_ovfl_shift                                      (8)
#define  DI_DDR_DMAStatus_ccdinr_unfl_shift                                      (0)
#define  DI_DDR_DMAStatus_ccdinr_fifoerr_ie_mask                                 (0x80000000)
#define  DI_DDR_DMAStatus_crc_128b_en_mask                                       (0x04000000)
#define  DI_DDR_DMAStatus_crc_128b_compare_fail_mask                             (0x02000000)
#define  DI_DDR_DMAStatus_dma_reset_st_mask                                      (0x01000000)
#define  DI_DDR_DMAStatus_ccdinr_flag_clr_mask                                   (0x00FF0000)
#define  DI_DDR_DMAStatus_ccdinr_ovfl_mask                                       (0x0000FF00)
#define  DI_DDR_DMAStatus_ccdinr_unfl_mask                                       (0x000000FF)
#define  DI_DDR_DMAStatus_ccdinr_fifoerr_ie(data)                                (0x80000000&((data)<<31))
#define  DI_DDR_DMAStatus_crc_128b_en(data)                                      (0x04000000&((data)<<26))
#define  DI_DDR_DMAStatus_crc_128b_compare_fail(data)                            (0x02000000&((data)<<25))
#define  DI_DDR_DMAStatus_dma_reset_st(data)                                     (0x01000000&((data)<<24))
#define  DI_DDR_DMAStatus_ccdinr_flag_clr(data)                                  (0x00FF0000&((data)<<16))
#define  DI_DDR_DMAStatus_ccdinr_ovfl(data)                                      (0x0000FF00&((data)<<8))
#define  DI_DDR_DMAStatus_ccdinr_unfl(data)                                      (0x000000FF&(data))
#define  DI_DDR_DMAStatus_get_ccdinr_fifoerr_ie(data)                            ((0x80000000&(data))>>31)
#define  DI_DDR_DMAStatus_get_crc_128b_en(data)                                  ((0x04000000&(data))>>26)
#define  DI_DDR_DMAStatus_get_crc_128b_compare_fail(data)                        ((0x02000000&(data))>>25)
#define  DI_DDR_DMAStatus_get_dma_reset_st(data)                                 ((0x01000000&(data))>>24)
#define  DI_DDR_DMAStatus_get_ccdinr_flag_clr(data)                              ((0x00FF0000&(data))>>16)
#define  DI_DDR_DMAStatus_get_ccdinr_ovfl(data)                                  ((0x0000FF00&(data))>>8)
#define  DI_DDR_DMAStatus_get_ccdinr_unfl(data)                                  (0x000000FF&(data))

#define  DI_DDR_WDE                                                             0x18024434
#define  DI_DDR_WDE_reg_addr                                                     "0xB8024434"
#define  DI_DDR_WDE_reg                                                          0xB8024434
#define  DI_DDR_WDE_inst_addr                                                    "0x00D1"
#define  set_DI_DDR_WDE_reg(data)                                                (*((volatile unsigned int*)DI_DDR_WDE_reg)=data)
#define  get_DI_DDR_WDE_reg                                                      (*((volatile unsigned int*)DI_DDR_WDE_reg))
#define  DI_DDR_WDE_ccdinr_fifoerr_wde_shift                                     (31)
#define  DI_DDR_WDE_ccdinr_vs_reset_en_shift                                     (30)
#define  DI_DDR_WDE_ccdinr_fifoerr_wde_sub_shift                                 (29)
#define  DI_DDR_WDE_ccdinr_wd_to_main_shift                                      (1)
#define  DI_DDR_WDE_ccdinr_wd_to_sub_shift                                       (0)
#define  DI_DDR_WDE_ccdinr_fifoerr_wde_mask                                      (0x80000000)
#define  DI_DDR_WDE_ccdinr_vs_reset_en_mask                                      (0x40000000)
#define  DI_DDR_WDE_ccdinr_fifoerr_wde_sub_mask                                  (0x20000000)
#define  DI_DDR_WDE_ccdinr_wd_to_main_mask                                       (0x00000002)
#define  DI_DDR_WDE_ccdinr_wd_to_sub_mask                                        (0x00000001)
#define  DI_DDR_WDE_ccdinr_fifoerr_wde(data)                                     (0x80000000&((data)<<31))
#define  DI_DDR_WDE_ccdinr_vs_reset_en(data)                                     (0x40000000&((data)<<30))
#define  DI_DDR_WDE_ccdinr_fifoerr_wde_sub(data)                                 (0x20000000&((data)<<29))
#define  DI_DDR_WDE_ccdinr_wd_to_main(data)                                      (0x00000002&((data)<<1))
#define  DI_DDR_WDE_ccdinr_wd_to_sub(data)                                       (0x00000001&(data))
#define  DI_DDR_WDE_get_ccdinr_fifoerr_wde(data)                                 ((0x80000000&(data))>>31)
#define  DI_DDR_WDE_get_ccdinr_vs_reset_en(data)                                 ((0x40000000&(data))>>30)
#define  DI_DDR_WDE_get_ccdinr_fifoerr_wde_sub(data)                             ((0x20000000&(data))>>29)
#define  DI_DDR_WDE_get_ccdinr_wd_to_main(data)                                  ((0x00000002&(data))>>1)
#define  DI_DDR_WDE_get_ccdinr_wd_to_sub(data)                                   (0x00000001&(data))

#define  DI_DI1_WRRD_BoundaryAddr1                                              0x18024438
#define  DI_DI1_WRRD_BoundaryAddr1_reg_addr                                      "0xB8024438"
#define  DI_DI1_WRRD_BoundaryAddr1_reg                                           0xB8024438
#define  DI_DI1_WRRD_BoundaryAddr1_inst_addr                                     "0x00D2"
#define  set_DI_DI1_WRRD_BoundaryAddr1_reg(data)                                 (*((volatile unsigned int*)DI_DI1_WRRD_BoundaryAddr1_reg)=data)
#define  get_DI_DI1_WRRD_BoundaryAddr1_reg                                       (*((volatile unsigned int*)DI_DI1_WRRD_BoundaryAddr1_reg))
#define  DI_DI1_WRRD_BoundaryAddr1_di1_wrrd_downlimit_adr_shift                  (3)
#define  DI_DI1_WRRD_BoundaryAddr1_di1_wrrd_downlimit_adr_mask                   (0xFFFFFFF8)
#define  DI_DI1_WRRD_BoundaryAddr1_di1_wrrd_downlimit_adr(data)                  (0xFFFFFFF8&((data)<<3))
#define  DI_DI1_WRRD_BoundaryAddr1_get_di1_wrrd_downlimit_adr(data)              ((0xFFFFFFF8&(data))>>3)

#define  DI_DI1_WRRD_BoundaryAddr2                                              0x1802443C
#define  DI_DI1_WRRD_BoundaryAddr2_reg_addr                                      "0xB802443C"
#define  DI_DI1_WRRD_BoundaryAddr2_reg                                           0xB802443C
#define  DI_DI1_WRRD_BoundaryAddr2_inst_addr                                     "0x00D3"
#define  set_DI_DI1_WRRD_BoundaryAddr2_reg(data)                                 (*((volatile unsigned int*)DI_DI1_WRRD_BoundaryAddr2_reg)=data)
#define  get_DI_DI1_WRRD_BoundaryAddr2_reg                                       (*((volatile unsigned int*)DI_DI1_WRRD_BoundaryAddr2_reg))
#define  DI_DI1_WRRD_BoundaryAddr2_di1_wrrd_uplimit_adr_shift                    (3)
#define  DI_DI1_WRRD_BoundaryAddr2_di1_wrrd_uplimit_adr_mask                     (0xFFFFFFF8)
#define  DI_DI1_WRRD_BoundaryAddr2_di1_wrrd_uplimit_adr(data)                    (0xFFFFFFF8&((data)<<3))
#define  DI_DI1_WRRD_BoundaryAddr2_get_di1_wrrd_uplimit_adr(data)                ((0xFFFFFFF8&(data))>>3)

#define  DI_DI1_WRRD_BoundaryAdd_Status                                         0x18024440
#define  DI_DI1_WRRD_BoundaryAdd_Status_reg_addr                                 "0xB8024440"
#define  DI_DI1_WRRD_BoundaryAdd_Status_reg                                      0xB8024440
#define  DI_DI1_WRRD_BoundaryAdd_Status_inst_addr                                "0x00D4"
#define  set_DI_DI1_WRRD_BoundaryAdd_Status_reg(data)                            (*((volatile unsigned int*)DI_DI1_WRRD_BoundaryAdd_Status_reg)=data)
#define  get_DI_DI1_WRRD_BoundaryAdd_Status_reg                                  (*((volatile unsigned int*)DI_DI1_WRRD_BoundaryAdd_Status_reg))
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_wrrd_downup_limit_ov_clearstatus_shift (20)
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_wr_downlimit_ov_shift                (18)
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_wr_uplimit_ov_shift                  (16)
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_rd_downlimit_ov_shift                (8)
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_rd_uplimit_ov_shift                  (0)
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_wrrd_downup_limit_ov_clearstatus_mask (0x00100000)
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_wr_downlimit_ov_mask                 (0x000C0000)
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_wr_uplimit_ov_mask                   (0x00030000)
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_rd_downlimit_ov_mask                 (0x00003F00)
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_rd_uplimit_ov_mask                   (0x0000003F)
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_wrrd_downup_limit_ov_clearstatus(data) (0x00100000&((data)<<20))
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_wr_downlimit_ov(data)                (0x000C0000&((data)<<18))
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_wr_uplimit_ov(data)                  (0x00030000&((data)<<16))
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_rd_downlimit_ov(data)                (0x00003F00&((data)<<8))
#define  DI_DI1_WRRD_BoundaryAdd_Status_di1_rd_uplimit_ov(data)                  (0x0000003F&(data))
#define  DI_DI1_WRRD_BoundaryAdd_Status_get_di1_wrrd_downup_limit_ov_clearstatus(data) ((0x00100000&(data))>>20)
#define  DI_DI1_WRRD_BoundaryAdd_Status_get_di1_wr_downlimit_ov(data)            ((0x000C0000&(data))>>18)
#define  DI_DI1_WRRD_BoundaryAdd_Status_get_di1_wr_uplimit_ov(data)              ((0x00030000&(data))>>16)
#define  DI_DI1_WRRD_BoundaryAdd_Status_get_di1_rd_downlimit_ov(data)            ((0x00003F00&(data))>>8)
#define  DI_DI1_WRRD_BoundaryAdd_Status_get_di1_rd_uplimit_ov(data)              (0x0000003F&(data))

#define  DI_DI_Line_Base_Dma_Addr_L                                             0x1802445C
#define  DI_DI_Line_Base_Dma_Addr_L_reg_addr                                     "0xB802445C"
#define  DI_DI_Line_Base_Dma_Addr_L_reg                                          0xB802445C
#define  DI_DI_Line_Base_Dma_Addr_L_inst_addr                                    "0x00D5"
#define  set_DI_DI_Line_Base_Dma_Addr_L_reg(data)                                (*((volatile unsigned int*)DI_DI_Line_Base_Dma_Addr_L_reg)=data)
#define  get_DI_DI_Line_Base_Dma_Addr_L_reg                                      (*((volatile unsigned int*)DI_DI_Line_Base_Dma_Addr_L_reg))
#define  DI_DI_Line_Base_Dma_Addr_L_cp_line_dma_buffer_cnt_shift                 (29)
#define  DI_DI_Line_Base_Dma_Addr_L_ccdinr_write_addr_l_shift                    (0)
#define  DI_DI_Line_Base_Dma_Addr_L_cp_line_dma_buffer_cnt_mask                  (0x60000000)
#define  DI_DI_Line_Base_Dma_Addr_L_ccdinr_write_addr_l_mask                     (0x1FFFFFFF)
#define  DI_DI_Line_Base_Dma_Addr_L_cp_line_dma_buffer_cnt(data)                 (0x60000000&((data)<<29))
#define  DI_DI_Line_Base_Dma_Addr_L_ccdinr_write_addr_l(data)                    (0x1FFFFFFF&(data))
#define  DI_DI_Line_Base_Dma_Addr_L_get_cp_line_dma_buffer_cnt(data)             ((0x60000000&(data))>>29)
#define  DI_DI_Line_Base_Dma_Addr_L_get_ccdinr_write_addr_l(data)                (0x1FFFFFFF&(data))

#define  DI_DI_Line_Base_Dma_Addr_R                                             0x18024460
#define  DI_DI_Line_Base_Dma_Addr_R_reg_addr                                     "0xB8024460"
#define  DI_DI_Line_Base_Dma_Addr_R_reg                                          0xB8024460
#define  DI_DI_Line_Base_Dma_Addr_R_inst_addr                                    "0x00D6"
#define  set_DI_DI_Line_Base_Dma_Addr_R_reg(data)                                (*((volatile unsigned int*)DI_DI_Line_Base_Dma_Addr_R_reg)=data)
#define  get_DI_DI_Line_Base_Dma_Addr_R_reg                                      (*((volatile unsigned int*)DI_DI_Line_Base_Dma_Addr_R_reg))
#define  DI_DI_Line_Base_Dma_Addr_R_ccdinr_write_addr_r_shift                    (0)
#define  DI_DI_Line_Base_Dma_Addr_R_ccdinr_write_addr_r_mask                     (0x1FFFFFFF)
#define  DI_DI_Line_Base_Dma_Addr_R_ccdinr_write_addr_r(data)                    (0x1FFFFFFF&(data))
#define  DI_DI_Line_Base_Dma_Addr_R_get_ccdinr_write_addr_r(data)                (0x1FFFFFFF&(data))

#define  DI_DI_DMA_Multi_Req_Num                                                0x18024464
#define  DI_DI_DMA_Multi_Req_Num_reg_addr                                        "0xB8024464"
#define  DI_DI_DMA_Multi_Req_Num_reg                                             0xB8024464
#define  DI_DI_DMA_Multi_Req_Num_inst_addr                                       "0x00D7"
#define  set_DI_DI_DMA_Multi_Req_Num_reg(data)                                   (*((volatile unsigned int*)DI_DI_DMA_Multi_Req_Num_reg)=data)
#define  get_DI_DI_DMA_Multi_Req_Num_reg                                         (*((volatile unsigned int*)DI_DI_DMA_Multi_Req_Num_reg))
#define  DI_DI_DMA_Multi_Req_Num_dma_info_first_shift                            (31)
#define  DI_DI_DMA_Multi_Req_Num_rdma_req_num_shift                              (4)
#define  DI_DI_DMA_Multi_Req_Num_wdma_req_num_shift                              (0)
#define  DI_DI_DMA_Multi_Req_Num_dma_info_first_mask                             (0x80000000)
#define  DI_DI_DMA_Multi_Req_Num_rdma_req_num_mask                               (0x00000070)
#define  DI_DI_DMA_Multi_Req_Num_wdma_req_num_mask                               (0x00000003)
#define  DI_DI_DMA_Multi_Req_Num_dma_info_first(data)                            (0x80000000&((data)<<31))
#define  DI_DI_DMA_Multi_Req_Num_rdma_req_num(data)                              (0x00000070&((data)<<4))
#define  DI_DI_DMA_Multi_Req_Num_wdma_req_num(data)                              (0x00000003&(data))
#define  DI_DI_DMA_Multi_Req_Num_get_dma_info_first(data)                        ((0x80000000&(data))>>31)
#define  DI_DI_DMA_Multi_Req_Num_get_rdma_req_num(data)                          ((0x00000070&(data))>>4)
#define  DI_DI_DMA_Multi_Req_Num_get_wdma_req_num(data)                          (0x00000003&(data))

#define  DI_MVF_WATMemoryStart_S0_Add0                                          0x18024468
#define  DI_MVF_WATMemoryStart_S0_Add0_reg_addr                                  "0xB8024468"
#define  DI_MVF_WATMemoryStart_S0_Add0_reg                                       0xB8024468
#define  DI_MVF_WATMemoryStart_S0_Add0_inst_addr                                 "0x00D8"
#define  set_DI_MVF_WATMemoryStart_S0_Add0_reg(data)                             (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S0_Add0_reg)=data)
#define  get_DI_MVF_WATMemoryStart_S0_Add0_reg                                   (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S0_Add0_reg))
#define  DI_MVF_WATMemoryStart_S0_Add0_s0_mstart_115_87_shift                    (3)
#define  DI_MVF_WATMemoryStart_S0_Add0_s0_mstart_115_87_mask                     (0xFFFFFFF8)
#define  DI_MVF_WATMemoryStart_S0_Add0_s0_mstart_115_87(data)                    (0xFFFFFFF8&((data)<<3))
#define  DI_MVF_WATMemoryStart_S0_Add0_get_s0_mstart_115_87(data)                ((0xFFFFFFF8&(data))>>3)

#define  DI_MVF_WATMemoryStart_S0_Add1                                          0x1802446C
#define  DI_MVF_WATMemoryStart_S0_Add1_reg_addr                                  "0xB802446C"
#define  DI_MVF_WATMemoryStart_S0_Add1_reg                                       0xB802446C
#define  DI_MVF_WATMemoryStart_S0_Add1_inst_addr                                 "0x00D9"
#define  set_DI_MVF_WATMemoryStart_S0_Add1_reg(data)                             (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S0_Add1_reg)=data)
#define  get_DI_MVF_WATMemoryStart_S0_Add1_reg                                   (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S0_Add1_reg))
#define  DI_MVF_WATMemoryStart_S0_Add1_s0_mstart_86_58_shift                     (3)
#define  DI_MVF_WATMemoryStart_S0_Add1_s0_mstart_86_58_mask                      (0xFFFFFFF8)
#define  DI_MVF_WATMemoryStart_S0_Add1_s0_mstart_86_58(data)                     (0xFFFFFFF8&((data)<<3))
#define  DI_MVF_WATMemoryStart_S0_Add1_get_s0_mstart_86_58(data)                 ((0xFFFFFFF8&(data))>>3)

#define  DI_MVF_WATMemoryStart_S0_Add2                                          0x18024470
#define  DI_MVF_WATMemoryStart_S0_Add2_reg_addr                                  "0xB8024470"
#define  DI_MVF_WATMemoryStart_S0_Add2_reg                                       0xB8024470
#define  DI_MVF_WATMemoryStart_S0_Add2_inst_addr                                 "0x00DA"
#define  set_DI_MVF_WATMemoryStart_S0_Add2_reg(data)                             (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S0_Add2_reg)=data)
#define  get_DI_MVF_WATMemoryStart_S0_Add2_reg                                   (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S0_Add2_reg))
#define  DI_MVF_WATMemoryStart_S0_Add2_s0_mstart_57_29_shift                     (3)
#define  DI_MVF_WATMemoryStart_S0_Add2_s0_mstart_57_29_mask                      (0xFFFFFFF8)
#define  DI_MVF_WATMemoryStart_S0_Add2_s0_mstart_57_29(data)                     (0xFFFFFFF8&((data)<<3))
#define  DI_MVF_WATMemoryStart_S0_Add2_get_s0_mstart_57_29(data)                 ((0xFFFFFFF8&(data))>>3)

#define  DI_MVF_WATMemoryStart_S1Add0                                           0x18024474
#define  DI_MVF_WATMemoryStart_S1Add0_reg_addr                                   "0xB8024474"
#define  DI_MVF_WATMemoryStart_S1Add0_reg                                        0xB8024474
#define  DI_MVF_WATMemoryStart_S1Add0_inst_addr                                  "0x00DB"
#define  set_DI_MVF_WATMemoryStart_S1Add0_reg(data)                              (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S1Add0_reg)=data)
#define  get_DI_MVF_WATMemoryStart_S1Add0_reg                                    (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S1Add0_reg))
#define  DI_MVF_WATMemoryStart_S1Add0_s1_mstart_115_87_shift                     (3)
#define  DI_MVF_WATMemoryStart_S1Add0_s1_mstart_115_87_mask                      (0xFFFFFFF8)
#define  DI_MVF_WATMemoryStart_S1Add0_s1_mstart_115_87(data)                     (0xFFFFFFF8&((data)<<3))
#define  DI_MVF_WATMemoryStart_S1Add0_get_s1_mstart_115_87(data)                 ((0xFFFFFFF8&(data))>>3)

#define  DI_MVF_WATMemoryStart_S1_Add1                                          0x18024478
#define  DI_MVF_WATMemoryStart_S1_Add1_reg_addr                                  "0xB8024478"
#define  DI_MVF_WATMemoryStart_S1_Add1_reg                                       0xB8024478
#define  DI_MVF_WATMemoryStart_S1_Add1_inst_addr                                 "0x00DC"
#define  set_DI_MVF_WATMemoryStart_S1_Add1_reg(data)                             (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S1_Add1_reg)=data)
#define  get_DI_MVF_WATMemoryStart_S1_Add1_reg                                   (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S1_Add1_reg))
#define  DI_MVF_WATMemoryStart_S1_Add1_s1_mstart_86_58_shift                     (3)
#define  DI_MVF_WATMemoryStart_S1_Add1_s1_mstart_86_58_mask                      (0xFFFFFFF8)
#define  DI_MVF_WATMemoryStart_S1_Add1_s1_mstart_86_58(data)                     (0xFFFFFFF8&((data)<<3))
#define  DI_MVF_WATMemoryStart_S1_Add1_get_s1_mstart_86_58(data)                 ((0xFFFFFFF8&(data))>>3)

#define  DI_MVF_WATMemoryStart_S1_Add2                                          0x1802447C
#define  DI_MVF_WATMemoryStart_S1_Add2_reg_addr                                  "0xB802447C"
#define  DI_MVF_WATMemoryStart_S1_Add2_reg                                       0xB802447C
#define  DI_MVF_WATMemoryStart_S1_Add2_inst_addr                                 "0x00DD"
#define  set_DI_MVF_WATMemoryStart_S1_Add2_reg(data)                             (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S1_Add2_reg)=data)
#define  get_DI_MVF_WATMemoryStart_S1_Add2_reg                                   (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S1_Add2_reg))
#define  DI_MVF_WATMemoryStart_S1_Add2_s1_mstart_57_29_shift                     (3)
#define  DI_MVF_WATMemoryStart_S1_Add2_s1_mstart_57_29_mask                      (0xFFFFFFF8)
#define  DI_MVF_WATMemoryStart_S1_Add2_s1_mstart_57_29(data)                     (0xFFFFFFF8&((data)<<3))
#define  DI_MVF_WATMemoryStart_S1_Add2_get_s1_mstart_57_29(data)                 ((0xFFFFFFF8&(data))>>3)

#define  DI_MVF_DDR_WDMA_WTLENNUM                                               0x18024480
#define  DI_MVF_DDR_WDMA_WTLENNUM_reg_addr                                       "0xB8024480"
#define  DI_MVF_DDR_WDMA_WTLENNUM_reg                                            0xB8024480
#define  DI_MVF_DDR_WDMA_WTLENNUM_inst_addr                                      "0x00DE"
#define  set_DI_MVF_DDR_WDMA_WTLENNUM_reg(data)                                  (*((volatile unsigned int*)DI_MVF_DDR_WDMA_WTLENNUM_reg)=data)
#define  get_DI_MVF_DDR_WDMA_WTLENNUM_reg                                        (*((volatile unsigned int*)DI_MVF_DDR_WDMA_WTLENNUM_reg))
#define  DI_MVF_DDR_WDMA_WTLENNUM_mvf_inf_water_w_shift                          (24)
#define  DI_MVF_DDR_WDMA_WTLENNUM_mvf_inf_len_w_shift                            (16)
#define  DI_MVF_DDR_WDMA_WTLENNUM_mvf_inf_num_w_shift                            (0)
#define  DI_MVF_DDR_WDMA_WTLENNUM_mvf_inf_water_w_mask                           (0xFF000000)
#define  DI_MVF_DDR_WDMA_WTLENNUM_mvf_inf_len_w_mask                             (0x007F0000)
#define  DI_MVF_DDR_WDMA_WTLENNUM_mvf_inf_num_w_mask                             (0x0000FFFF)
#define  DI_MVF_DDR_WDMA_WTLENNUM_mvf_inf_water_w(data)                          (0xFF000000&((data)<<24))
#define  DI_MVF_DDR_WDMA_WTLENNUM_mvf_inf_len_w(data)                            (0x007F0000&((data)<<16))
#define  DI_MVF_DDR_WDMA_WTLENNUM_mvf_inf_num_w(data)                            (0x0000FFFF&(data))
#define  DI_MVF_DDR_WDMA_WTLENNUM_get_mvf_inf_water_w(data)                      ((0xFF000000&(data))>>24)
#define  DI_MVF_DDR_WDMA_WTLENNUM_get_mvf_inf_len_w(data)                        ((0x007F0000&(data))>>16)
#define  DI_MVF_DDR_WDMA_WTLENNUM_get_mvf_inf_num_w(data)                        (0x0000FFFF&(data))

#define  DI_MVF_DDR_WDATDMA_RM                                                  0x18024484
#define  DI_MVF_DDR_WDATDMA_RM_reg_addr                                          "0xB8024484"
#define  DI_MVF_DDR_WDATDMA_RM_reg                                               0xB8024484
#define  DI_MVF_DDR_WDATDMA_RM_inst_addr                                         "0x00DF"
#define  set_DI_MVF_DDR_WDATDMA_RM_reg(data)                                     (*((volatile unsigned int*)DI_MVF_DDR_WDATDMA_RM_reg)=data)
#define  get_DI_MVF_DDR_WDATDMA_RM_reg                                           (*((volatile unsigned int*)DI_MVF_DDR_WDATDMA_RM_reg))
#define  DI_MVF_DDR_WDATDMA_RM_mvf_inf_remain_w_shift                            (0)
#define  DI_MVF_DDR_WDATDMA_RM_mvf_inf_remain_w_mask                             (0x0000007F)
#define  DI_MVF_DDR_WDATDMA_RM_mvf_inf_remain_w(data)                            (0x0000007F&(data))
#define  DI_MVF_DDR_WDATDMA_RM_get_mvf_inf_remain_w(data)                        (0x0000007F&(data))

#define  DI_MVF_DDR_DMAStatus                                                   0x18024488
#define  DI_MVF_DDR_DMAStatus_reg_addr                                           "0xB8024488"
#define  DI_MVF_DDR_DMAStatus_reg                                                0xB8024488
#define  DI_MVF_DDR_DMAStatus_inst_addr                                          "0x00E0"
#define  set_DI_MVF_DDR_DMAStatus_reg(data)                                      (*((volatile unsigned int*)DI_MVF_DDR_DMAStatus_reg)=data)
#define  get_DI_MVF_DDR_DMAStatus_reg                                            (*((volatile unsigned int*)DI_MVF_DDR_DMAStatus_reg))
#define  DI_MVF_DDR_DMAStatus_mvf_wrrd_downup_limit_ov_clearstatus_shift         (21)
#define  DI_MVF_DDR_DMAStatus_mvf_set_first_frame_shift                          (20)
#define  DI_MVF_DDR_DMAStatus_wdma_s1_frame_cnt_shift                            (18)
#define  DI_MVF_DDR_DMAStatus_wdma_s0_frame_cnt_shift                            (16)
#define  DI_MVF_DDR_DMAStatus_mvf_flag_clr_shift                                 (14)
#define  DI_MVF_DDR_DMAStatus_mvf_ovfl_shift                                     (13)
#define  DI_MVF_DDR_DMAStatus_mvf_unfl_shift                                     (12)
#define  DI_MVF_DDR_DMAStatus_mvf_addr_downlimit_ov_shift                        (1)
#define  DI_MVF_DDR_DMAStatus_mvf_addr_uplimit_ov_shift                          (0)
#define  DI_MVF_DDR_DMAStatus_mvf_wrrd_downup_limit_ov_clearstatus_mask          (0x00200000)
#define  DI_MVF_DDR_DMAStatus_mvf_set_first_frame_mask                           (0x00100000)
#define  DI_MVF_DDR_DMAStatus_wdma_s1_frame_cnt_mask                             (0x000C0000)
#define  DI_MVF_DDR_DMAStatus_wdma_s0_frame_cnt_mask                             (0x00030000)
#define  DI_MVF_DDR_DMAStatus_mvf_flag_clr_mask                                  (0x00004000)
#define  DI_MVF_DDR_DMAStatus_mvf_ovfl_mask                                      (0x00002000)
#define  DI_MVF_DDR_DMAStatus_mvf_unfl_mask                                      (0x00001000)
#define  DI_MVF_DDR_DMAStatus_mvf_addr_downlimit_ov_mask                         (0x00000002)
#define  DI_MVF_DDR_DMAStatus_mvf_addr_uplimit_ov_mask                           (0x00000001)
#define  DI_MVF_DDR_DMAStatus_mvf_wrrd_downup_limit_ov_clearstatus(data)         (0x00200000&((data)<<21))
#define  DI_MVF_DDR_DMAStatus_mvf_set_first_frame(data)                          (0x00100000&((data)<<20))
#define  DI_MVF_DDR_DMAStatus_wdma_s1_frame_cnt(data)                            (0x000C0000&((data)<<18))
#define  DI_MVF_DDR_DMAStatus_wdma_s0_frame_cnt(data)                            (0x00030000&((data)<<16))
#define  DI_MVF_DDR_DMAStatus_mvf_flag_clr(data)                                 (0x00004000&((data)<<14))
#define  DI_MVF_DDR_DMAStatus_mvf_ovfl(data)                                     (0x00002000&((data)<<13))
#define  DI_MVF_DDR_DMAStatus_mvf_unfl(data)                                     (0x00001000&((data)<<12))
#define  DI_MVF_DDR_DMAStatus_mvf_addr_downlimit_ov(data)                        (0x00000002&((data)<<1))
#define  DI_MVF_DDR_DMAStatus_mvf_addr_uplimit_ov(data)                          (0x00000001&(data))
#define  DI_MVF_DDR_DMAStatus_get_mvf_wrrd_downup_limit_ov_clearstatus(data)     ((0x00200000&(data))>>21)
#define  DI_MVF_DDR_DMAStatus_get_mvf_set_first_frame(data)                      ((0x00100000&(data))>>20)
#define  DI_MVF_DDR_DMAStatus_get_wdma_s1_frame_cnt(data)                        ((0x000C0000&(data))>>18)
#define  DI_MVF_DDR_DMAStatus_get_wdma_s0_frame_cnt(data)                        ((0x00030000&(data))>>16)
#define  DI_MVF_DDR_DMAStatus_get_mvf_flag_clr(data)                             ((0x00004000&(data))>>14)
#define  DI_MVF_DDR_DMAStatus_get_mvf_ovfl(data)                                 ((0x00002000&(data))>>13)
#define  DI_MVF_DDR_DMAStatus_get_mvf_unfl(data)                                 ((0x00001000&(data))>>12)
#define  DI_MVF_DDR_DMAStatus_get_mvf_addr_downlimit_ov(data)                    ((0x00000002&(data))>>1)
#define  DI_MVF_DDR_DMAStatus_get_mvf_addr_uplimit_ov(data)                      (0x00000001&(data))

#define  DI_MVF_DDR_CRC                                                         0x1802448C
#define  DI_MVF_DDR_CRC_reg_addr                                                 "0xB802448C"
#define  DI_MVF_DDR_CRC_reg                                                      0xB802448C
#define  DI_MVF_DDR_CRC_inst_addr                                                "0x00E1"
#define  set_DI_MVF_DDR_CRC_reg(data)                                            (*((volatile unsigned int*)DI_MVF_DDR_CRC_reg)=data)
#define  get_DI_MVF_DDR_CRC_reg                                                  (*((volatile unsigned int*)DI_MVF_DDR_CRC_reg))
#define  DI_MVF_DDR_CRC_mvf_crc_shift                                            (0)
#define  DI_MVF_DDR_CRC_mvf_crc_mask                                             (0xFFFFFFFF)
#define  DI_MVF_DDR_CRC_mvf_crc(data)                                            (0xFFFFFFFF&(data))
#define  DI_MVF_DDR_CRC_get_mvf_crc(data)                                        (0xFFFFFFFF&(data))

#define  DI_MVF_WR_BoundaryAddr1                                                0x18024490
#define  DI_MVF_WR_BoundaryAddr1_reg_addr                                        "0xB8024490"
#define  DI_MVF_WR_BoundaryAddr1_reg                                             0xB8024490
#define  DI_MVF_WR_BoundaryAddr1_inst_addr                                       "0x00E2"
#define  set_DI_MVF_WR_BoundaryAddr1_reg(data)                                   (*((volatile unsigned int*)DI_MVF_WR_BoundaryAddr1_reg)=data)
#define  get_DI_MVF_WR_BoundaryAddr1_reg                                         (*((volatile unsigned int*)DI_MVF_WR_BoundaryAddr1_reg))
#define  DI_MVF_WR_BoundaryAddr1_mvf_wr_downlimit_adr_shift                      (3)
#define  DI_MVF_WR_BoundaryAddr1_mvf_wr_downlimit_adr_mask                       (0xFFFFFFF8)
#define  DI_MVF_WR_BoundaryAddr1_mvf_wr_downlimit_adr(data)                      (0xFFFFFFF8&((data)<<3))
#define  DI_MVF_WR_BoundaryAddr1_get_mvf_wr_downlimit_adr(data)                  ((0xFFFFFFF8&(data))>>3)

#define  DI_MVF_WR_BoundaryAddr2                                                0x18024494
#define  DI_MVF_WR_BoundaryAddr2_reg_addr                                        "0xB8024494"
#define  DI_MVF_WR_BoundaryAddr2_reg                                             0xB8024494
#define  DI_MVF_WR_BoundaryAddr2_inst_addr                                       "0x00E3"
#define  set_DI_MVF_WR_BoundaryAddr2_reg(data)                                   (*((volatile unsigned int*)DI_MVF_WR_BoundaryAddr2_reg)=data)
#define  get_DI_MVF_WR_BoundaryAddr2_reg                                         (*((volatile unsigned int*)DI_MVF_WR_BoundaryAddr2_reg))
#define  DI_MVF_WR_BoundaryAddr2_mvf_wr_uplimit_adr_shift                        (3)
#define  DI_MVF_WR_BoundaryAddr2_mvf_wr_uplimit_adr_mask                         (0xFFFFFFF8)
#define  DI_MVF_WR_BoundaryAddr2_mvf_wr_uplimit_adr(data)                        (0xFFFFFFF8&((data)<<3))
#define  DI_MVF_WR_BoundaryAddr2_get_mvf_wr_uplimit_adr(data)                    ((0xFFFFFFF8&(data))>>3)

#define  DI_MVF_WATMemoryStart_S0_Add3                                          0x18024498
#define  DI_MVF_WATMemoryStart_S0_Add3_reg_addr                                  "0xB8024498"
#define  DI_MVF_WATMemoryStart_S0_Add3_reg                                       0xB8024498
#define  DI_MVF_WATMemoryStart_S0_Add3_inst_addr                                 "0x00E4"
#define  set_DI_MVF_WATMemoryStart_S0_Add3_reg(data)                             (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S0_Add3_reg)=data)
#define  get_DI_MVF_WATMemoryStart_S0_Add3_reg                                   (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S0_Add3_reg))
#define  DI_MVF_WATMemoryStart_S0_Add3_s0_mstart_28_0_shift                      (3)
#define  DI_MVF_WATMemoryStart_S0_Add3_s0_mstart_28_0_mask                       (0xFFFFFFF8)
#define  DI_MVF_WATMemoryStart_S0_Add3_s0_mstart_28_0(data)                      (0xFFFFFFF8&((data)<<3))
#define  DI_MVF_WATMemoryStart_S0_Add3_get_s0_mstart_28_0(data)                  ((0xFFFFFFF8&(data))>>3)

#define  DI_MVF_WATMemoryStart_S1_Add3                                          0x1802449C
#define  DI_MVF_WATMemoryStart_S1_Add3_reg_addr                                  "0xB802449C"
#define  DI_MVF_WATMemoryStart_S1_Add3_reg                                       0xB802449C
#define  DI_MVF_WATMemoryStart_S1_Add3_inst_addr                                 "0x00E5"
#define  set_DI_MVF_WATMemoryStart_S1_Add3_reg(data)                             (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S1_Add3_reg)=data)
#define  get_DI_MVF_WATMemoryStart_S1_Add3_reg                                   (*((volatile unsigned int*)DI_MVF_WATMemoryStart_S1_Add3_reg))
#define  DI_MVF_WATMemoryStart_S1_Add3_s1_mstart_28_0_shift                      (3)
#define  DI_MVF_WATMemoryStart_S1_Add3_s1_mstart_28_0_mask                       (0xFFFFFFF8)
#define  DI_MVF_WATMemoryStart_S1_Add3_s1_mstart_28_0(data)                      (0xFFFFFFF8&((data)<<3))
#define  DI_MVF_WATMemoryStart_S1_Add3_get_s1_mstart_28_0(data)                  ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_I2R_DATMemoryStartAdd1                                           0x180244A0
#define  DI_DI_I2R_DATMemoryStartAdd1_reg_addr                                   "0xB80244A0"
#define  DI_DI_I2R_DATMemoryStartAdd1_reg                                        0xB80244A0
#define  DI_DI_I2R_DATMemoryStartAdd1_inst_addr                                  "0x00E6"
#define  set_DI_DI_I2R_DATMemoryStartAdd1_reg(data)                              (*((volatile unsigned int*)DI_DI_I2R_DATMemoryStartAdd1_reg)=data)
#define  get_DI_DI_I2R_DATMemoryStartAdd1_reg                                    (*((volatile unsigned int*)DI_DI_I2R_DATMemoryStartAdd1_reg))
#define  DI_DI_I2R_DATMemoryStartAdd1_dat_i2r_mstart_115_87_shift                (3)
#define  DI_DI_I2R_DATMemoryStartAdd1_dat_i2r_mstart_115_87_mask                 (0xFFFFFFF8)
#define  DI_DI_I2R_DATMemoryStartAdd1_dat_i2r_mstart_115_87(data)                (0xFFFFFFF8&((data)<<3))
#define  DI_DI_I2R_DATMemoryStartAdd1_get_dat_i2r_mstart_115_87(data)            ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_I2R_DATMemoryStartAdd2                                           0x180244A4
#define  DI_DI_I2R_DATMemoryStartAdd2_reg_addr                                   "0xB80244A4"
#define  DI_DI_I2R_DATMemoryStartAdd2_reg                                        0xB80244A4
#define  DI_DI_I2R_DATMemoryStartAdd2_inst_addr                                  "0x00E7"
#define  set_DI_DI_I2R_DATMemoryStartAdd2_reg(data)                              (*((volatile unsigned int*)DI_DI_I2R_DATMemoryStartAdd2_reg)=data)
#define  get_DI_DI_I2R_DATMemoryStartAdd2_reg                                    (*((volatile unsigned int*)DI_DI_I2R_DATMemoryStartAdd2_reg))
#define  DI_DI_I2R_DATMemoryStartAdd2_dat_i2r_mstart_86_58_shift                 (3)
#define  DI_DI_I2R_DATMemoryStartAdd2_dat_i2r_mstart_86_58_mask                  (0xFFFFFFF8)
#define  DI_DI_I2R_DATMemoryStartAdd2_dat_i2r_mstart_86_58(data)                 (0xFFFFFFF8&((data)<<3))
#define  DI_DI_I2R_DATMemoryStartAdd2_get_dat_i2r_mstart_86_58(data)             ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_I2R_DATMemoryStartAdd3                                           0x180244A8
#define  DI_DI_I2R_DATMemoryStartAdd3_reg_addr                                   "0xB80244A8"
#define  DI_DI_I2R_DATMemoryStartAdd3_reg                                        0xB80244A8
#define  DI_DI_I2R_DATMemoryStartAdd3_inst_addr                                  "0x00E8"
#define  set_DI_DI_I2R_DATMemoryStartAdd3_reg(data)                              (*((volatile unsigned int*)DI_DI_I2R_DATMemoryStartAdd3_reg)=data)
#define  get_DI_DI_I2R_DATMemoryStartAdd3_reg                                    (*((volatile unsigned int*)DI_DI_I2R_DATMemoryStartAdd3_reg))
#define  DI_DI_I2R_DATMemoryStartAdd3_dat_i2r_mstart_57_29_shift                 (3)
#define  DI_DI_I2R_DATMemoryStartAdd3_dat_i2r_mstart_57_29_mask                  (0xFFFFFFF8)
#define  DI_DI_I2R_DATMemoryStartAdd3_dat_i2r_mstart_57_29(data)                 (0xFFFFFFF8&((data)<<3))
#define  DI_DI_I2R_DATMemoryStartAdd3_get_dat_i2r_mstart_57_29(data)             ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_I2R_DATMemoryStartAdd4                                           0x180244AC
#define  DI_DI_I2R_DATMemoryStartAdd4_reg_addr                                   "0xB80244AC"
#define  DI_DI_I2R_DATMemoryStartAdd4_reg                                        0xB80244AC
#define  DI_DI_I2R_DATMemoryStartAdd4_inst_addr                                  "0x00E9"
#define  set_DI_DI_I2R_DATMemoryStartAdd4_reg(data)                              (*((volatile unsigned int*)DI_DI_I2R_DATMemoryStartAdd4_reg)=data)
#define  get_DI_DI_I2R_DATMemoryStartAdd4_reg                                    (*((volatile unsigned int*)DI_DI_I2R_DATMemoryStartAdd4_reg))
#define  DI_DI_I2R_DATMemoryStartAdd4_dat_i2r_mstart_28_0_shift                  (3)
#define  DI_DI_I2R_DATMemoryStartAdd4_dat_i2r_mstart_28_0_mask                   (0xFFFFFFF8)
#define  DI_DI_I2R_DATMemoryStartAdd4_dat_i2r_mstart_28_0(data)                  (0xFFFFFFF8&((data)<<3))
#define  DI_DI_I2R_DATMemoryStartAdd4_get_dat_i2r_mstart_28_0(data)              ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_I2R_INFMemoryStartAdd1                                           0x180244B0
#define  DI_DI_I2R_INFMemoryStartAdd1_reg_addr                                   "0xB80244B0"
#define  DI_DI_I2R_INFMemoryStartAdd1_reg                                        0xB80244B0
#define  DI_DI_I2R_INFMemoryStartAdd1_inst_addr                                  "0x00EA"
#define  set_DI_DI_I2R_INFMemoryStartAdd1_reg(data)                              (*((volatile unsigned int*)DI_DI_I2R_INFMemoryStartAdd1_reg)=data)
#define  get_DI_DI_I2R_INFMemoryStartAdd1_reg                                    (*((volatile unsigned int*)DI_DI_I2R_INFMemoryStartAdd1_reg))
#define  DI_DI_I2R_INFMemoryStartAdd1_inf_i2r_mstart_57_29_shift                 (3)
#define  DI_DI_I2R_INFMemoryStartAdd1_inf_i2r_mstart_57_29_mask                  (0xFFFFFFF8)
#define  DI_DI_I2R_INFMemoryStartAdd1_inf_i2r_mstart_57_29(data)                 (0xFFFFFFF8&((data)<<3))
#define  DI_DI_I2R_INFMemoryStartAdd1_get_inf_i2r_mstart_57_29(data)             ((0xFFFFFFF8&(data))>>3)

#define  DI_DI_I2R_INFMemoryStartAdd2                                           0x180244B4
#define  DI_DI_I2R_INFMemoryStartAdd2_reg_addr                                   "0xB80244B4"
#define  DI_DI_I2R_INFMemoryStartAdd2_reg                                        0xB80244B4
#define  DI_DI_I2R_INFMemoryStartAdd2_inst_addr                                  "0x00EB"
#define  set_DI_DI_I2R_INFMemoryStartAdd2_reg(data)                              (*((volatile unsigned int*)DI_DI_I2R_INFMemoryStartAdd2_reg)=data)
#define  get_DI_DI_I2R_INFMemoryStartAdd2_reg                                    (*((volatile unsigned int*)DI_DI_I2R_INFMemoryStartAdd2_reg))
#define  DI_DI_I2R_INFMemoryStartAdd2_inf_i2r_mstart_28_0_shift                  (3)
#define  DI_DI_I2R_INFMemoryStartAdd2_inf_i2r_mstart_28_0_mask                   (0xFFFFFFF8)
#define  DI_DI_I2R_INFMemoryStartAdd2_inf_i2r_mstart_28_0(data)                  (0xFFFFFFF8&((data)<<3))
#define  DI_DI_I2R_INFMemoryStartAdd2_get_inf_i2r_mstart_28_0(data)              ((0xFFFFFFF8&(data))>>3)

#define  DI_DI1_I2R_WRRD_BoundaryAddr1                                          0x180244D0
#define  DI_DI1_I2R_WRRD_BoundaryAddr1_reg_addr                                  "0xB80244D0"
#define  DI_DI1_I2R_WRRD_BoundaryAddr1_reg                                       0xB80244D0
#define  DI_DI1_I2R_WRRD_BoundaryAddr1_inst_addr                                 "0x00EC"
#define  set_DI_DI1_I2R_WRRD_BoundaryAddr1_reg(data)                             (*((volatile unsigned int*)DI_DI1_I2R_WRRD_BoundaryAddr1_reg)=data)
#define  get_DI_DI1_I2R_WRRD_BoundaryAddr1_reg                                   (*((volatile unsigned int*)DI_DI1_I2R_WRRD_BoundaryAddr1_reg))
#define  DI_DI1_I2R_WRRD_BoundaryAddr1_di1_i2r_wrrd_downlimit_adr_shift          (3)
#define  DI_DI1_I2R_WRRD_BoundaryAddr1_di1_i2r_wrrd_downlimit_adr_mask           (0xFFFFFFF8)
#define  DI_DI1_I2R_WRRD_BoundaryAddr1_di1_i2r_wrrd_downlimit_adr(data)          (0xFFFFFFF8&((data)<<3))
#define  DI_DI1_I2R_WRRD_BoundaryAddr1_get_di1_i2r_wrrd_downlimit_adr(data)      ((0xFFFFFFF8&(data))>>3)

#define  DI_DI1_I2R_WRRD_BoundaryAddr2                                          0x180244D4
#define  DI_DI1_I2R_WRRD_BoundaryAddr2_reg_addr                                  "0xB80244D4"
#define  DI_DI1_I2R_WRRD_BoundaryAddr2_reg                                       0xB80244D4
#define  DI_DI1_I2R_WRRD_BoundaryAddr2_inst_addr                                 "0x00ED"
#define  set_DI_DI1_I2R_WRRD_BoundaryAddr2_reg(data)                             (*((volatile unsigned int*)DI_DI1_I2R_WRRD_BoundaryAddr2_reg)=data)
#define  get_DI_DI1_I2R_WRRD_BoundaryAddr2_reg                                   (*((volatile unsigned int*)DI_DI1_I2R_WRRD_BoundaryAddr2_reg))
#define  DI_DI1_I2R_WRRD_BoundaryAddr2_di1_i2r_wrrd_uplimit_adr_shift            (3)
#define  DI_DI1_I2R_WRRD_BoundaryAddr2_di1_i2r_wrrd_uplimit_adr_mask             (0xFFFFFFF8)
#define  DI_DI1_I2R_WRRD_BoundaryAddr2_di1_i2r_wrrd_uplimit_adr(data)            (0xFFFFFFF8&((data)<<3))
#define  DI_DI1_I2R_WRRD_BoundaryAddr2_get_di1_i2r_wrrd_uplimit_adr(data)        ((0xFFFFFFF8&(data))>>3)

#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status                                     0x180244D8
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_reg_addr                             "0xB80244D8"
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_reg                                  0xB80244D8
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_inst_addr                            "0x00EE"
#define  set_DI_DI1_I2R_WRRD_BoundaryAdd_Status_reg(data)                        (*((volatile unsigned int*)DI_DI1_I2R_WRRD_BoundaryAdd_Status_reg)=data)
#define  get_DI_DI1_I2R_WRRD_BoundaryAdd_Status_reg                              (*((volatile unsigned int*)DI_DI1_I2R_WRRD_BoundaryAdd_Status_reg))
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_wrrd_downup_limit_ov_clearstatus_shift (20)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_wr_downlimit_ov_shift        (18)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_wr_uplimit_ov_shift          (16)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_rd_downlimit_ov_shift        (8)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_rd_uplimit_ov_shift          (0)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_wrrd_downup_limit_ov_clearstatus_mask (0x00100000)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_wr_downlimit_ov_mask         (0x000C0000)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_wr_uplimit_ov_mask           (0x00030000)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_rd_downlimit_ov_mask         (0x00003F00)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_rd_uplimit_ov_mask           (0x0000003F)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_wrrd_downup_limit_ov_clearstatus(data) (0x00100000&((data)<<20))
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_wr_downlimit_ov(data)        (0x000C0000&((data)<<18))
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_wr_uplimit_ov(data)          (0x00030000&((data)<<16))
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_rd_downlimit_ov(data)        (0x00003F00&((data)<<8))
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_di1_i2r_rd_uplimit_ov(data)          (0x0000003F&(data))
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_get_di1_i2r_wrrd_downup_limit_ov_clearstatus(data) ((0x00100000&(data))>>20)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_get_di1_i2r_wr_downlimit_ov(data)    ((0x000C0000&(data))>>18)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_get_di1_i2r_wr_uplimit_ov(data)      ((0x00030000&(data))>>16)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_get_di1_i2r_rd_downlimit_ov(data)    ((0x00003F00&(data))>>8)
#define  DI_DI1_I2R_WRRD_BoundaryAdd_Status_get_di1_i2r_rd_uplimit_ov(data)      (0x0000003F&(data))

#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr1                                      0x180244DC
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_reg_addr                              "0xB80244DC"
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_reg                                   0xB80244DC
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_inst_addr                             "0x00EF"
#define  set_DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_reg(data)                         (*((volatile unsigned int*)DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_reg)=data)
#define  get_DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_reg                               (*((volatile unsigned int*)DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_reg))
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_di1_mvf_i2r_wrrd_downlimit_adr_shift  (3)
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_di1_mvf_i2r_wrrd_downlimit_adr_mask   (0xFFFFFFF8)
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_di1_mvf_i2r_wrrd_downlimit_adr(data)  (0xFFFFFFF8&((data)<<3))
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr1_get_di1_mvf_i2r_wrrd_downlimit_adr(data) ((0xFFFFFFF8&(data))>>3)

#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr2                                      0x180244E0
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_reg_addr                              "0xB80244E0"
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_reg                                   0xB80244E0
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_inst_addr                             "0x00F0"
#define  set_DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_reg(data)                         (*((volatile unsigned int*)DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_reg)=data)
#define  get_DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_reg                               (*((volatile unsigned int*)DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_reg))
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_di1_mvf_i2r_wrrd_uplimit_adr_shift    (3)
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_di1_mvf_i2r_wrrd_uplimit_adr_mask     (0xFFFFFFF8)
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_di1_mvf_i2r_wrrd_uplimit_adr(data)    (0xFFFFFFF8&((data)<<3))
#define  DI_DI1_MVF_I2R_WRRD_BoundaryAddr2_get_di1_mvf_i2r_wrrd_uplimit_adr(data) ((0xFFFFFFF8&(data))>>3)

#define  DI_DI1_INFO_WRRD_BoundaryAddr1                                         0x180244E4
#define  DI_DI1_INFO_WRRD_BoundaryAddr1_reg_addr                                 "0xB80244E4"
#define  DI_DI1_INFO_WRRD_BoundaryAddr1_reg                                      0xB80244E4
#define  DI_DI1_INFO_WRRD_BoundaryAddr1_inst_addr                                "0x00F1"
#define  set_DI_DI1_INFO_WRRD_BoundaryAddr1_reg(data)                            (*((volatile unsigned int*)DI_DI1_INFO_WRRD_BoundaryAddr1_reg)=data)
#define  get_DI_DI1_INFO_WRRD_BoundaryAddr1_reg                                  (*((volatile unsigned int*)DI_DI1_INFO_WRRD_BoundaryAddr1_reg))
#define  DI_DI1_INFO_WRRD_BoundaryAddr1_di1_info_wrrd_downlimit_adr_shift        (3)
#define  DI_DI1_INFO_WRRD_BoundaryAddr1_di1_info_wrrd_downlimit_adr_mask         (0xFFFFFFF8)
#define  DI_DI1_INFO_WRRD_BoundaryAddr1_di1_info_wrrd_downlimit_adr(data)        (0xFFFFFFF8&((data)<<3))
#define  DI_DI1_INFO_WRRD_BoundaryAddr1_get_di1_info_wrrd_downlimit_adr(data)    ((0xFFFFFFF8&(data))>>3)

#define  DI_DI1_INFO_WRRD_BoundaryAddr2                                         0x180244E8
#define  DI_DI1_INFO_WRRD_BoundaryAddr2_reg_addr                                 "0xB80244E8"
#define  DI_DI1_INFO_WRRD_BoundaryAddr2_reg                                      0xB80244E8
#define  DI_DI1_INFO_WRRD_BoundaryAddr2_inst_addr                                "0x00F2"
#define  set_DI_DI1_INFO_WRRD_BoundaryAddr2_reg(data)                            (*((volatile unsigned int*)DI_DI1_INFO_WRRD_BoundaryAddr2_reg)=data)
#define  get_DI_DI1_INFO_WRRD_BoundaryAddr2_reg                                  (*((volatile unsigned int*)DI_DI1_INFO_WRRD_BoundaryAddr2_reg))
#define  DI_DI1_INFO_WRRD_BoundaryAddr2_di1_info_wrrd_uplimit_adr_shift          (3)
#define  DI_DI1_INFO_WRRD_BoundaryAddr2_di1_info_wrrd_uplimit_adr_mask           (0xFFFFFFF8)
#define  DI_DI1_INFO_WRRD_BoundaryAddr2_di1_info_wrrd_uplimit_adr(data)          (0xFFFFFFF8&((data)<<3))
#define  DI_DI1_INFO_WRRD_BoundaryAddr2_get_di1_info_wrrd_uplimit_adr(data)      ((0xFFFFFFF8&(data))>>3)

#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr1                                     0x180244EC
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_reg_addr                             "0xB80244EC"
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_reg                                  0xB80244EC
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_inst_addr                            "0x00F3"
#define  set_DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_reg(data)                        (*((volatile unsigned int*)DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_reg)=data)
#define  get_DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_reg                              (*((volatile unsigned int*)DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_reg))
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_di1_info_i2r_wrrd_downlimit_adr_shift (3)
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_di1_info_i2r_wrrd_downlimit_adr_mask (0xFFFFFFF8)
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_di1_info_i2r_wrrd_downlimit_adr(data) (0xFFFFFFF8&((data)<<3))
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr1_get_di1_info_i2r_wrrd_downlimit_adr(data) ((0xFFFFFFF8&(data))>>3)

#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr2                                     0x180244F0
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_reg_addr                             "0xB80244F0"
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_reg                                  0xB80244F0
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_inst_addr                            "0x00F4"
#define  set_DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_reg(data)                        (*((volatile unsigned int*)DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_reg)=data)
#define  get_DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_reg                              (*((volatile unsigned int*)DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_reg))
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_di1_info_i2r_wrrd_uplimit_adr_shift  (3)
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_di1_info_i2r_wrrd_uplimit_adr_mask   (0xFFFFFFF8)
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_di1_info_i2r_wrrd_uplimit_adr(data)  (0xFFFFFFF8&((data)<<3))
#define  DI_DI1_INFO_I2R_WRRD_BoundaryAddr2_get_di1_info_i2r_wrrd_uplimit_adr(data) ((0xFFFFFFF8&(data))>>3)

#define  DI_DISPI_BIST_FAIL_SEPARATE_1                                          0x18024500
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_reg_addr                                  "0xB8024500"
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_reg                                       0xB8024500
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_inst_addr                                 "0x00F5"
#define  set_DI_DISPI_BIST_FAIL_SEPARATE_1_reg(data)                             (*((volatile unsigned int*)DI_DISPI_BIST_FAIL_SEPARATE_1_reg)=data)
#define  get_DI_DISPI_BIST_FAIL_SEPARATE_1_reg                                   (*((volatile unsigned int*)DI_DISPI_BIST_FAIL_SEPARATE_1_reg))
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_di_li1_bist_fail_shift                    (24)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_di_li2_bist_fail_shift                    (16)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_di_li3_bist_fail_shift                    (8)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_rtnr_isnr_dma_bist_fail_shift             (0)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_di_li1_bist_fail_mask                     (0x0F000000)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_di_li2_bist_fail_mask                     (0x000F0000)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_di_li3_bist_fail_mask                     (0x0000FF00)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_rtnr_isnr_dma_bist_fail_mask              (0x0000000F)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_di_li1_bist_fail(data)                    (0x0F000000&((data)<<24))
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_di_li2_bist_fail(data)                    (0x000F0000&((data)<<16))
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_di_li3_bist_fail(data)                    (0x0000FF00&((data)<<8))
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_rtnr_isnr_dma_bist_fail(data)             (0x0000000F&(data))
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_get_di_li1_bist_fail(data)                ((0x0F000000&(data))>>24)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_get_di_li2_bist_fail(data)                ((0x000F0000&(data))>>16)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_get_di_li3_bist_fail(data)                ((0x0000FF00&(data))>>8)
#define  DI_DISPI_BIST_FAIL_SEPARATE_1_get_rtnr_isnr_dma_bist_fail(data)         (0x0000000F&(data))

#define  DI_DISPI_BIST_FAIL_SEPARATE_2                                          0x18024504
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_reg_addr                                  "0xB8024504"
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_reg                                       0xB8024504
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_inst_addr                                 "0x00F6"
#define  set_DI_DISPI_BIST_FAIL_SEPARATE_2_reg(data)                             (*((volatile unsigned int*)DI_DISPI_BIST_FAIL_SEPARATE_2_reg)=data)
#define  get_DI_DISPI_BIST_FAIL_SEPARATE_2_reg                                   (*((volatile unsigned int*)DI_DISPI_BIST_FAIL_SEPARATE_2_reg))
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_di_dma_wdat_bist_fail_shift               (24)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_di_dma_rdat_bist_fail_shift               (16)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_di_tr2to1_bist_fail_shift                 (10)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_rtnr_mcnr_tmv2_bist_fail_shift            (8)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_rtnr_mcnr_tmv1_bist_fail_shift            (0)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_di_dma_wdat_bist_fail_mask                (0xFF000000)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_di_dma_rdat_bist_fail_mask                (0x00FF0000)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_di_tr2to1_bist_fail_mask                  (0x00003C00)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_rtnr_mcnr_tmv2_bist_fail_mask             (0x00000300)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_rtnr_mcnr_tmv1_bist_fail_mask             (0x000000FF)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_di_dma_wdat_bist_fail(data)               (0xFF000000&((data)<<24))
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_di_dma_rdat_bist_fail(data)               (0x00FF0000&((data)<<16))
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_di_tr2to1_bist_fail(data)                 (0x00003C00&((data)<<10))
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_rtnr_mcnr_tmv2_bist_fail(data)            (0x00000300&((data)<<8))
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_rtnr_mcnr_tmv1_bist_fail(data)            (0x000000FF&(data))
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_get_di_dma_wdat_bist_fail(data)           ((0xFF000000&(data))>>24)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_get_di_dma_rdat_bist_fail(data)           ((0x00FF0000&(data))>>16)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_get_di_tr2to1_bist_fail(data)             ((0x00003C00&(data))>>10)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_get_rtnr_mcnr_tmv2_bist_fail(data)        ((0x00000300&(data))>>8)
#define  DI_DISPI_BIST_FAIL_SEPARATE_2_get_rtnr_mcnr_tmv1_bist_fail(data)        (0x000000FF&(data))

#define  DI_DISPI_BIST_FAIL_SEPARATE_3                                          0x18024508
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_reg_addr                                  "0xB8024508"
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_reg                                       0xB8024508
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_inst_addr                                 "0x00F7"
#define  set_DI_DISPI_BIST_FAIL_SEPARATE_3_reg(data)                             (*((volatile unsigned int*)DI_DISPI_BIST_FAIL_SEPARATE_3_reg)=data)
#define  get_DI_DISPI_BIST_FAIL_SEPARATE_3_reg                                   (*((volatile unsigned int*)DI_DISPI_BIST_FAIL_SEPARATE_3_reg))
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_di_li4_bist_fail_shift                    (24)
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_di_li5_bist_fail_shift                    (16)
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_di_li6_bist_fail_shift                    (9)
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_di_li4_bist_fail_mask                     (0xFF000000)
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_di_li5_bist_fail_mask                     (0x00FF0000)
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_di_li6_bist_fail_mask                     (0x00000600)
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_di_li4_bist_fail(data)                    (0xFF000000&((data)<<24))
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_di_li5_bist_fail(data)                    (0x00FF0000&((data)<<16))
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_di_li6_bist_fail(data)                    (0x00000600&((data)<<9))
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_get_di_li4_bist_fail(data)                ((0xFF000000&(data))>>24)
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_get_di_li5_bist_fail(data)                ((0x00FF0000&(data))>>16)
#define  DI_DISPI_BIST_FAIL_SEPARATE_3_get_di_li6_bist_fail(data)                ((0x00000600&(data))>>9)

#define  DI_DISPI_BIST_FAIL_SEPARATE_4                                          0x1802450C
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_reg_addr                                  "0xB802450C"
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_reg                                       0xB802450C
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_inst_addr                                 "0x00F8"
#define  set_DI_DISPI_BIST_FAIL_SEPARATE_4_reg(data)                             (*((volatile unsigned int*)DI_DISPI_BIST_FAIL_SEPARATE_4_reg)=data)
#define  get_DI_DISPI_BIST_FAIL_SEPARATE_4_reg                                   (*((volatile unsigned int*)DI_DISPI_BIST_FAIL_SEPARATE_4_reg))
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqdc2_bist_fail_shift                  (17)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqdc1_bist_fail_shift                  (16)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqc2_bist_fail_shift                   (1)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqc1_bist_fail_shift                   (0)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqdc2_bist_fail_mask                   (0x00060000)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqdc1_bist_fail_mask                   (0x00010000)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqc2_bist_fail_mask                    (0x00003FFE)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqc1_bist_fail_mask                    (0x00000001)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqdc2_bist_fail(data)                  (0x00060000&((data)<<17))
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqdc1_bist_fail(data)                  (0x00010000&((data)<<16))
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqc2_bist_fail(data)                   (0x00003FFE&((data)<<1))
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_di_pqc1_bist_fail(data)                   (0x00000001&(data))
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_get_di_pqdc2_bist_fail(data)              ((0x00060000&(data))>>17)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_get_di_pqdc1_bist_fail(data)              ((0x00010000&(data))>>16)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_get_di_pqc2_bist_fail(data)               ((0x00003FFE&(data))>>1)
#define  DI_DISPI_BIST_FAIL_SEPARATE_4_get_di_pqc1_bist_fail(data)               (0x00000001&(data))

#define  DI_DISPI_DRF_FAIL_SEPARATE_1                                           0x18024510
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_reg_addr                                   "0xB8024510"
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_reg                                        0xB8024510
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_inst_addr                                  "0x00F9"
#define  set_DI_DISPI_DRF_FAIL_SEPARATE_1_reg(data)                              (*((volatile unsigned int*)DI_DISPI_DRF_FAIL_SEPARATE_1_reg)=data)
#define  get_DI_DISPI_DRF_FAIL_SEPARATE_1_reg                                    (*((volatile unsigned int*)DI_DISPI_DRF_FAIL_SEPARATE_1_reg))
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_di_li1_drf_fail_shift                      (24)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_di_li2_drf_fail_shift                      (16)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_di_li3_drf_fail_shift                      (8)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_rtnr_isnr_dma_drf_fail_shift               (0)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_di_li1_drf_fail_mask                       (0x0F000000)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_di_li2_drf_fail_mask                       (0x000F0000)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_di_li3_drf_fail_mask                       (0x0000FF00)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_rtnr_isnr_dma_drf_fail_mask                (0x0000000F)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_di_li1_drf_fail(data)                      (0x0F000000&((data)<<24))
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_di_li2_drf_fail(data)                      (0x000F0000&((data)<<16))
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_di_li3_drf_fail(data)                      (0x0000FF00&((data)<<8))
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_rtnr_isnr_dma_drf_fail(data)               (0x0000000F&(data))
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_get_di_li1_drf_fail(data)                  ((0x0F000000&(data))>>24)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_get_di_li2_drf_fail(data)                  ((0x000F0000&(data))>>16)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_get_di_li3_drf_fail(data)                  ((0x0000FF00&(data))>>8)
#define  DI_DISPI_DRF_FAIL_SEPARATE_1_get_rtnr_isnr_dma_drf_fail(data)           (0x0000000F&(data))

#define  DI_DISPI_DRF_FAIL_SEPARATE_2                                           0x18024514
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_reg_addr                                   "0xB8024514"
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_reg                                        0xB8024514
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_inst_addr                                  "0x00FA"
#define  set_DI_DISPI_DRF_FAIL_SEPARATE_2_reg(data)                              (*((volatile unsigned int*)DI_DISPI_DRF_FAIL_SEPARATE_2_reg)=data)
#define  get_DI_DISPI_DRF_FAIL_SEPARATE_2_reg                                    (*((volatile unsigned int*)DI_DISPI_DRF_FAIL_SEPARATE_2_reg))
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_di_dma_wdat_drf_fail_shift                 (24)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_di_dma_rdat_drf_fail_shift                 (16)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_di_tr2to1_drf_fail_shift                   (10)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_rtnr_mcnr_tmv2_drf_fail_shift              (8)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_rtnr_mcnr_tmv1_drf_fail_shift              (0)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_di_dma_wdat_drf_fail_mask                  (0xFF000000)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_di_dma_rdat_drf_fail_mask                  (0x00FF0000)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_di_tr2to1_drf_fail_mask                    (0x00003C00)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_rtnr_mcnr_tmv2_drf_fail_mask               (0x00000300)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_rtnr_mcnr_tmv1_drf_fail_mask               (0x000000FF)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_di_dma_wdat_drf_fail(data)                 (0xFF000000&((data)<<24))
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_di_dma_rdat_drf_fail(data)                 (0x00FF0000&((data)<<16))
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_di_tr2to1_drf_fail(data)                   (0x00003C00&((data)<<10))
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_rtnr_mcnr_tmv2_drf_fail(data)              (0x00000300&((data)<<8))
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_rtnr_mcnr_tmv1_drf_fail(data)              (0x000000FF&(data))
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_get_di_dma_wdat_drf_fail(data)             ((0xFF000000&(data))>>24)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_get_di_dma_rdat_drf_fail(data)             ((0x00FF0000&(data))>>16)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_get_di_tr2to1_drf_fail(data)               ((0x00003C00&(data))>>10)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_get_rtnr_mcnr_tmv2_drf_fail(data)          ((0x00000300&(data))>>8)
#define  DI_DISPI_DRF_FAIL_SEPARATE_2_get_rtnr_mcnr_tmv1_drf_fail(data)          (0x000000FF&(data))

#define  DI_DISPI_DRF_FAIL_SEPARATE_3                                           0x18024518
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_reg_addr                                   "0xB8024518"
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_reg                                        0xB8024518
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_inst_addr                                  "0x00FB"
#define  set_DI_DISPI_DRF_FAIL_SEPARATE_3_reg(data)                              (*((volatile unsigned int*)DI_DISPI_DRF_FAIL_SEPARATE_3_reg)=data)
#define  get_DI_DISPI_DRF_FAIL_SEPARATE_3_reg                                    (*((volatile unsigned int*)DI_DISPI_DRF_FAIL_SEPARATE_3_reg))
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_di_li4_drf_fail_shift                      (24)
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_di_li5_drf_fail_shift                      (16)
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_di_li6_drf_fail_shift                      (9)
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_di_li4_drf_fail_mask                       (0xFF000000)
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_di_li5_drf_fail_mask                       (0x00FF0000)
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_di_li6_drf_fail_mask                       (0x00000600)
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_di_li4_drf_fail(data)                      (0xFF000000&((data)<<24))
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_di_li5_drf_fail(data)                      (0x00FF0000&((data)<<16))
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_di_li6_drf_fail(data)                      (0x00000600&((data)<<9))
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_get_di_li4_drf_fail(data)                  ((0xFF000000&(data))>>24)
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_get_di_li5_drf_fail(data)                  ((0x00FF0000&(data))>>16)
#define  DI_DISPI_DRF_FAIL_SEPARATE_3_get_di_li6_drf_fail(data)                  ((0x00000600&(data))>>9)

#define  DI_DISPI_DRF_FAIL_SEPARATE_4                                           0x1802451C
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_reg_addr                                   "0xB802451C"
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_reg                                        0xB802451C
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_inst_addr                                  "0x00FC"
#define  set_DI_DISPI_DRF_FAIL_SEPARATE_4_reg(data)                              (*((volatile unsigned int*)DI_DISPI_DRF_FAIL_SEPARATE_4_reg)=data)
#define  get_DI_DISPI_DRF_FAIL_SEPARATE_4_reg                                    (*((volatile unsigned int*)DI_DISPI_DRF_FAIL_SEPARATE_4_reg))
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqdc2_drf_fail_shift                    (17)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqdc1_drf_fail_shift                    (16)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqc2_drf_fail_shift                     (1)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqc1_drf_fail_shift                     (0)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqdc2_drf_fail_mask                     (0x00060000)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqdc1_drf_fail_mask                     (0x00010000)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqc2_drf_fail_mask                      (0x00003FFE)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqc1_drf_fail_mask                      (0x00000001)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqdc2_drf_fail(data)                    (0x00060000&((data)<<17))
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqdc1_drf_fail(data)                    (0x00010000&((data)<<16))
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqc2_drf_fail(data)                     (0x00003FFE&((data)<<1))
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_di_pqc1_drf_fail(data)                     (0x00000001&(data))
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_get_di_pqdc2_drf_fail(data)                ((0x00060000&(data))>>17)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_get_di_pqdc1_drf_fail(data)                ((0x00010000&(data))>>16)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_get_di_pqc2_drf_fail(data)                 ((0x00003FFE&(data))>>1)
#define  DI_DISPI_DRF_FAIL_SEPARATE_4_get_di_pqc1_drf_fail(data)                 (0x00000001&(data))

#define  DI_DISPI_BIST_RME                                                      0x18024520
#define  DI_DISPI_BIST_RME_reg_addr                                              "0xB8024520"
#define  DI_DISPI_BIST_RME_reg                                                   0xB8024520
#define  DI_DISPI_BIST_RME_inst_addr                                             "0x00FD"
#define  set_DI_DISPI_BIST_RME_reg(data)                                         (*((volatile unsigned int*)DI_DISPI_BIST_RME_reg)=data)
#define  get_DI_DISPI_BIST_RME_reg                                               (*((volatile unsigned int*)DI_DISPI_BIST_RME_reg))
#define  DI_DISPI_BIST_RME_di_pqdc2_rme_shift                                    (19)
#define  DI_DISPI_BIST_RME_di_pqdc1_rme_shift                                    (18)
#define  DI_DISPI_BIST_RME_di_pqc2_rme_shift                                     (16)
#define  DI_DISPI_BIST_RME_di_pqc1_rme_shift                                     (15)
#define  DI_DISPI_BIST_RME_rtnr_mcnr_tmv2_rme_shift                              (14)
#define  DI_DISPI_BIST_RME_rtnr_mcnr_tmv1_rme_shift                              (13)
#define  DI_DISPI_BIST_RME_di_li1_rme_shift                                      (12)
#define  DI_DISPI_BIST_RME_di_li2_rme_shift                                      (11)
#define  DI_DISPI_BIST_RME_di_li3_rme_shift                                      (10)
#define  DI_DISPI_BIST_RME_di_li4_rme_shift                                      (9)
#define  DI_DISPI_BIST_RME_di_li5_rme_shift                                      (8)
#define  DI_DISPI_BIST_RME_di_li6_rme_shift                                      (7)
#define  DI_DISPI_BIST_RME_di_li6_rme_bisr_shift                                 (6)
#define  DI_DISPI_BIST_RME_di_bisr_repaired_ro_shift                             (5)
#define  DI_DISPI_BIST_RME_di_tr2to1_rme_shift                                   (4)
#define  DI_DISPI_BIST_RME_rtnr_isnr_dma_rme_shift                               (2)
#define  DI_DISPI_BIST_RME_di_dma_wdat_rme_shift                                 (1)
#define  DI_DISPI_BIST_RME_di_dma_rdat_rme_shift                                 (0)
#define  DI_DISPI_BIST_RME_di_pqdc2_rme_mask                                     (0x00080000)
#define  DI_DISPI_BIST_RME_di_pqdc1_rme_mask                                     (0x00040000)
#define  DI_DISPI_BIST_RME_di_pqc2_rme_mask                                      (0x00030000)
#define  DI_DISPI_BIST_RME_di_pqc1_rme_mask                                      (0x00008000)
#define  DI_DISPI_BIST_RME_rtnr_mcnr_tmv2_rme_mask                               (0x00004000)
#define  DI_DISPI_BIST_RME_rtnr_mcnr_tmv1_rme_mask                               (0x00002000)
#define  DI_DISPI_BIST_RME_di_li1_rme_mask                                       (0x00001000)
#define  DI_DISPI_BIST_RME_di_li2_rme_mask                                       (0x00000800)
#define  DI_DISPI_BIST_RME_di_li3_rme_mask                                       (0x00000400)
#define  DI_DISPI_BIST_RME_di_li4_rme_mask                                       (0x00000200)
#define  DI_DISPI_BIST_RME_di_li5_rme_mask                                       (0x00000100)
#define  DI_DISPI_BIST_RME_di_li6_rme_mask                                       (0x00000080)
#define  DI_DISPI_BIST_RME_di_li6_rme_bisr_mask                                  (0x00000040)
#define  DI_DISPI_BIST_RME_di_bisr_repaired_ro_mask                              (0x00000020)
#define  DI_DISPI_BIST_RME_di_tr2to1_rme_mask                                    (0x00000010)
#define  DI_DISPI_BIST_RME_rtnr_isnr_dma_rme_mask                                (0x00000004)
#define  DI_DISPI_BIST_RME_di_dma_wdat_rme_mask                                  (0x00000002)
#define  DI_DISPI_BIST_RME_di_dma_rdat_rme_mask                                  (0x00000001)
#define  DI_DISPI_BIST_RME_di_pqdc2_rme(data)                                    (0x00080000&((data)<<19))
#define  DI_DISPI_BIST_RME_di_pqdc1_rme(data)                                    (0x00040000&((data)<<18))
#define  DI_DISPI_BIST_RME_di_pqc2_rme(data)                                     (0x00030000&((data)<<16))
#define  DI_DISPI_BIST_RME_di_pqc1_rme(data)                                     (0x00008000&((data)<<15))
#define  DI_DISPI_BIST_RME_rtnr_mcnr_tmv2_rme(data)                              (0x00004000&((data)<<14))
#define  DI_DISPI_BIST_RME_rtnr_mcnr_tmv1_rme(data)                              (0x00002000&((data)<<13))
#define  DI_DISPI_BIST_RME_di_li1_rme(data)                                      (0x00001000&((data)<<12))
#define  DI_DISPI_BIST_RME_di_li2_rme(data)                                      (0x00000800&((data)<<11))
#define  DI_DISPI_BIST_RME_di_li3_rme(data)                                      (0x00000400&((data)<<10))
#define  DI_DISPI_BIST_RME_di_li4_rme(data)                                      (0x00000200&((data)<<9))
#define  DI_DISPI_BIST_RME_di_li5_rme(data)                                      (0x00000100&((data)<<8))
#define  DI_DISPI_BIST_RME_di_li6_rme(data)                                      (0x00000080&((data)<<7))
#define  DI_DISPI_BIST_RME_di_li6_rme_bisr(data)                                 (0x00000040&((data)<<6))
#define  DI_DISPI_BIST_RME_di_bisr_repaired_ro(data)                             (0x00000020&((data)<<5))
#define  DI_DISPI_BIST_RME_di_tr2to1_rme(data)                                   (0x00000010&((data)<<4))
#define  DI_DISPI_BIST_RME_rtnr_isnr_dma_rme(data)                               (0x00000004&((data)<<2))
#define  DI_DISPI_BIST_RME_di_dma_wdat_rme(data)                                 (0x00000002&((data)<<1))
#define  DI_DISPI_BIST_RME_di_dma_rdat_rme(data)                                 (0x00000001&(data))
#define  DI_DISPI_BIST_RME_get_di_pqdc2_rme(data)                                ((0x00080000&(data))>>19)
#define  DI_DISPI_BIST_RME_get_di_pqdc1_rme(data)                                ((0x00040000&(data))>>18)
#define  DI_DISPI_BIST_RME_get_di_pqc2_rme(data)                                 ((0x00030000&(data))>>16)
#define  DI_DISPI_BIST_RME_get_di_pqc1_rme(data)                                 ((0x00008000&(data))>>15)
#define  DI_DISPI_BIST_RME_get_rtnr_mcnr_tmv2_rme(data)                          ((0x00004000&(data))>>14)
#define  DI_DISPI_BIST_RME_get_rtnr_mcnr_tmv1_rme(data)                          ((0x00002000&(data))>>13)
#define  DI_DISPI_BIST_RME_get_di_li1_rme(data)                                  ((0x00001000&(data))>>12)
#define  DI_DISPI_BIST_RME_get_di_li2_rme(data)                                  ((0x00000800&(data))>>11)
#define  DI_DISPI_BIST_RME_get_di_li3_rme(data)                                  ((0x00000400&(data))>>10)
#define  DI_DISPI_BIST_RME_get_di_li4_rme(data)                                  ((0x00000200&(data))>>9)
#define  DI_DISPI_BIST_RME_get_di_li5_rme(data)                                  ((0x00000100&(data))>>8)
#define  DI_DISPI_BIST_RME_get_di_li6_rme(data)                                  ((0x00000080&(data))>>7)
#define  DI_DISPI_BIST_RME_get_di_li6_rme_bisr(data)                             ((0x00000040&(data))>>6)
#define  DI_DISPI_BIST_RME_get_di_bisr_repaired_ro(data)                         ((0x00000020&(data))>>5)
#define  DI_DISPI_BIST_RME_get_di_tr2to1_rme(data)                               ((0x00000010&(data))>>4)
#define  DI_DISPI_BIST_RME_get_rtnr_isnr_dma_rme(data)                           ((0x00000004&(data))>>2)
#define  DI_DISPI_BIST_RME_get_di_dma_wdat_rme(data)                             ((0x00000002&(data))>>1)
#define  DI_DISPI_BIST_RME_get_di_dma_rdat_rme(data)                             (0x00000001&(data))

#define  DI_DISPI_BIST_RM_1                                                     0x18024524
#define  DI_DISPI_BIST_RM_1_reg_addr                                             "0xB8024524"
#define  DI_DISPI_BIST_RM_1_reg                                                  0xB8024524
#define  DI_DISPI_BIST_RM_1_inst_addr                                            "0x00FE"
#define  set_DI_DISPI_BIST_RM_1_reg(data)                                        (*((volatile unsigned int*)DI_DISPI_BIST_RM_1_reg)=data)
#define  get_DI_DISPI_BIST_RM_1_reg                                              (*((volatile unsigned int*)DI_DISPI_BIST_RM_1_reg))
#define  DI_DISPI_BIST_RM_1_di_li1_rm_shift                                      (24)
#define  DI_DISPI_BIST_RM_1_di_li2_rm_shift                                      (20)
#define  DI_DISPI_BIST_RM_1_di_li3_rm_shift                                      (16)
#define  DI_DISPI_BIST_RM_1_di_li4_rm_shift                                      (12)
#define  DI_DISPI_BIST_RM_1_di_li5_rm_shift                                      (8)
#define  DI_DISPI_BIST_RM_1_di_li6_rm_shift                                      (4)
#define  DI_DISPI_BIST_RM_1_di_li6_rm_bisr_shift                                 (0)
#define  DI_DISPI_BIST_RM_1_di_li1_rm_mask                                       (0x0F000000)
#define  DI_DISPI_BIST_RM_1_di_li2_rm_mask                                       (0x00F00000)
#define  DI_DISPI_BIST_RM_1_di_li3_rm_mask                                       (0x000F0000)
#define  DI_DISPI_BIST_RM_1_di_li4_rm_mask                                       (0x0000F000)
#define  DI_DISPI_BIST_RM_1_di_li5_rm_mask                                       (0x00000F00)
#define  DI_DISPI_BIST_RM_1_di_li6_rm_mask                                       (0x000000F0)
#define  DI_DISPI_BIST_RM_1_di_li6_rm_bisr_mask                                  (0x0000000F)
#define  DI_DISPI_BIST_RM_1_di_li1_rm(data)                                      (0x0F000000&((data)<<24))
#define  DI_DISPI_BIST_RM_1_di_li2_rm(data)                                      (0x00F00000&((data)<<20))
#define  DI_DISPI_BIST_RM_1_di_li3_rm(data)                                      (0x000F0000&((data)<<16))
#define  DI_DISPI_BIST_RM_1_di_li4_rm(data)                                      (0x0000F000&((data)<<12))
#define  DI_DISPI_BIST_RM_1_di_li5_rm(data)                                      (0x00000F00&((data)<<8))
#define  DI_DISPI_BIST_RM_1_di_li6_rm(data)                                      (0x000000F0&((data)<<4))
#define  DI_DISPI_BIST_RM_1_di_li6_rm_bisr(data)                                 (0x0000000F&(data))
#define  DI_DISPI_BIST_RM_1_get_di_li1_rm(data)                                  ((0x0F000000&(data))>>24)
#define  DI_DISPI_BIST_RM_1_get_di_li2_rm(data)                                  ((0x00F00000&(data))>>20)
#define  DI_DISPI_BIST_RM_1_get_di_li3_rm(data)                                  ((0x000F0000&(data))>>16)
#define  DI_DISPI_BIST_RM_1_get_di_li4_rm(data)                                  ((0x0000F000&(data))>>12)
#define  DI_DISPI_BIST_RM_1_get_di_li5_rm(data)                                  ((0x00000F00&(data))>>8)
#define  DI_DISPI_BIST_RM_1_get_di_li6_rm(data)                                  ((0x000000F0&(data))>>4)
#define  DI_DISPI_BIST_RM_1_get_di_li6_rm_bisr(data)                             (0x0000000F&(data))

#define  DI_DISPI_BIST_RM_2                                                     0x18024528
#define  DI_DISPI_BIST_RM_2_reg_addr                                             "0xB8024528"
#define  DI_DISPI_BIST_RM_2_reg                                                  0xB8024528
#define  DI_DISPI_BIST_RM_2_inst_addr                                            "0x00FF"
#define  set_DI_DISPI_BIST_RM_2_reg(data)                                        (*((volatile unsigned int*)DI_DISPI_BIST_RM_2_reg)=data)
#define  get_DI_DISPI_BIST_RM_2_reg                                              (*((volatile unsigned int*)DI_DISPI_BIST_RM_2_reg))
#define  DI_DISPI_BIST_RM_2_rtnr_mcnr_tmv2_rm_shift                              (28)
#define  DI_DISPI_BIST_RM_2_rtnr_mcnr_tmv1_rm_shift                              (24)
#define  DI_DISPI_BIST_RM_2_di_tr2to1_rm_shift                                   (16)
#define  DI_DISPI_BIST_RM_2_rtnr_isnr_dma_rm_shift                               (8)
#define  DI_DISPI_BIST_RM_2_di_dma_wdat_rm_shift                                 (4)
#define  DI_DISPI_BIST_RM_2_di_dma_rdat_rm_shift                                 (0)
#define  DI_DISPI_BIST_RM_2_rtnr_mcnr_tmv2_rm_mask                               (0xF0000000)
#define  DI_DISPI_BIST_RM_2_rtnr_mcnr_tmv1_rm_mask                               (0x0F000000)
#define  DI_DISPI_BIST_RM_2_di_tr2to1_rm_mask                                    (0x000F0000)
#define  DI_DISPI_BIST_RM_2_rtnr_isnr_dma_rm_mask                                (0x00000F00)
#define  DI_DISPI_BIST_RM_2_di_dma_wdat_rm_mask                                  (0x000000F0)
#define  DI_DISPI_BIST_RM_2_di_dma_rdat_rm_mask                                  (0x0000000F)
#define  DI_DISPI_BIST_RM_2_rtnr_mcnr_tmv2_rm(data)                              (0xF0000000&((data)<<28))
#define  DI_DISPI_BIST_RM_2_rtnr_mcnr_tmv1_rm(data)                              (0x0F000000&((data)<<24))
#define  DI_DISPI_BIST_RM_2_di_tr2to1_rm(data)                                   (0x000F0000&((data)<<16))
#define  DI_DISPI_BIST_RM_2_rtnr_isnr_dma_rm(data)                               (0x00000F00&((data)<<8))
#define  DI_DISPI_BIST_RM_2_di_dma_wdat_rm(data)                                 (0x000000F0&((data)<<4))
#define  DI_DISPI_BIST_RM_2_di_dma_rdat_rm(data)                                 (0x0000000F&(data))
#define  DI_DISPI_BIST_RM_2_get_rtnr_mcnr_tmv2_rm(data)                          ((0xF0000000&(data))>>28)
#define  DI_DISPI_BIST_RM_2_get_rtnr_mcnr_tmv1_rm(data)                          ((0x0F000000&(data))>>24)
#define  DI_DISPI_BIST_RM_2_get_di_tr2to1_rm(data)                               ((0x000F0000&(data))>>16)
#define  DI_DISPI_BIST_RM_2_get_rtnr_isnr_dma_rm(data)                           ((0x00000F00&(data))>>8)
#define  DI_DISPI_BIST_RM_2_get_di_dma_wdat_rm(data)                             ((0x000000F0&(data))>>4)
#define  DI_DISPI_BIST_RM_2_get_di_dma_rdat_rm(data)                             (0x0000000F&(data))

#define  DI_DISPI_BIST_RM_3                                                     0x1802452C
#define  DI_DISPI_BIST_RM_3_reg_addr                                             "0xB802452C"
#define  DI_DISPI_BIST_RM_3_reg                                                  0xB802452C
#define  DI_DISPI_BIST_RM_3_inst_addr                                            "0x0100"
#define  set_DI_DISPI_BIST_RM_3_reg(data)                                        (*((volatile unsigned int*)DI_DISPI_BIST_RM_3_reg)=data)
#define  get_DI_DISPI_BIST_RM_3_reg                                              (*((volatile unsigned int*)DI_DISPI_BIST_RM_3_reg))
#define  DI_DISPI_BIST_RM_3_di_pqdc2_rm_shift                                    (16)
#define  DI_DISPI_BIST_RM_3_di_pqdc1_rm_shift                                    (12)
#define  DI_DISPI_BIST_RM_3_di_pqc2_rm_shift                                     (4)
#define  DI_DISPI_BIST_RM_3_di_pqc1_rm_shift                                     (0)
#define  DI_DISPI_BIST_RM_3_di_pqdc2_rm_mask                                     (0x000F0000)
#define  DI_DISPI_BIST_RM_3_di_pqdc1_rm_mask                                     (0x0000F000)
#define  DI_DISPI_BIST_RM_3_di_pqc2_rm_mask                                      (0x00000FF0)
#define  DI_DISPI_BIST_RM_3_di_pqc1_rm_mask                                      (0x0000000F)
#define  DI_DISPI_BIST_RM_3_di_pqdc2_rm(data)                                    (0x000F0000&((data)<<16))
#define  DI_DISPI_BIST_RM_3_di_pqdc1_rm(data)                                    (0x0000F000&((data)<<12))
#define  DI_DISPI_BIST_RM_3_di_pqc2_rm(data)                                     (0x00000FF0&((data)<<4))
#define  DI_DISPI_BIST_RM_3_di_pqc1_rm(data)                                     (0x0000000F&(data))
#define  DI_DISPI_BIST_RM_3_get_di_pqdc2_rm(data)                                ((0x000F0000&(data))>>16)
#define  DI_DISPI_BIST_RM_3_get_di_pqdc1_rm(data)                                ((0x0000F000&(data))>>12)
#define  DI_DISPI_BIST_RM_3_get_di_pqc2_rm(data)                                 ((0x00000FF0&(data))>>4)
#define  DI_DISPI_BIST_RM_3_get_di_pqc1_rm(data)                                 (0x0000000F&(data))

#define  DI_DISPI_BIST_TEST_RWM                                                 0x18024530
#define  DI_DISPI_BIST_TEST_RWM_reg_addr                                         "0xB8024530"
#define  DI_DISPI_BIST_TEST_RWM_reg                                              0xB8024530
#define  DI_DISPI_BIST_TEST_RWM_inst_addr                                        "0x0101"
#define  set_DI_DISPI_BIST_TEST_RWM_reg(data)                                    (*((volatile unsigned int*)DI_DISPI_BIST_TEST_RWM_reg)=data)
#define  get_DI_DISPI_BIST_TEST_RWM_reg                                          (*((volatile unsigned int*)DI_DISPI_BIST_TEST_RWM_reg))
#define  DI_DISPI_BIST_TEST_RWM_pqdc_test_rwm_shift                              (2)
#define  DI_DISPI_BIST_TEST_RWM_pqc_test_rwm_shift                               (1)
#define  DI_DISPI_BIST_TEST_RWM_rtnr_mcnr_tmv1_bist_testrwm_shift                (0)
#define  DI_DISPI_BIST_TEST_RWM_pqdc_test_rwm_mask                               (0x00000004)
#define  DI_DISPI_BIST_TEST_RWM_pqc_test_rwm_mask                                (0x00000002)
#define  DI_DISPI_BIST_TEST_RWM_rtnr_mcnr_tmv1_bist_testrwm_mask                 (0x00000001)
#define  DI_DISPI_BIST_TEST_RWM_pqdc_test_rwm(data)                              (0x00000004&((data)<<2))
#define  DI_DISPI_BIST_TEST_RWM_pqc_test_rwm(data)                               (0x00000002&((data)<<1))
#define  DI_DISPI_BIST_TEST_RWM_rtnr_mcnr_tmv1_bist_testrwm(data)                (0x00000001&(data))
#define  DI_DISPI_BIST_TEST_RWM_get_pqdc_test_rwm(data)                          ((0x00000004&(data))>>2)
#define  DI_DISPI_BIST_TEST_RWM_get_pqc_test_rwm(data)                           ((0x00000002&(data))>>1)
#define  DI_DISPI_BIST_TEST_RWM_get_rtnr_mcnr_tmv1_bist_testrwm(data)            (0x00000001&(data))

#define  DI_db_reg_ctl                                                          0x18024538
#define  DI_db_reg_ctl_reg_addr                                                  "0xB8024538"
#define  DI_db_reg_ctl_reg                                                       0xB8024538
#define  DI_db_reg_ctl_inst_addr                                                 "0x0102"
#define  set_DI_db_reg_ctl_reg(data)                                             (*((volatile unsigned int*)DI_db_reg_ctl_reg)=data)
#define  get_DI_db_reg_ctl_reg                                                   (*((volatile unsigned int*)DI_db_reg_ctl_reg))
#define  DI_db_reg_ctl_sm_tog_apply_disable_shift                                (31)
#define  DI_db_reg_ctl_sm_tog_3d_mode_shift                                      (30)
#define  DI_db_reg_ctl_db_read_shift                                             (2)
#define  DI_db_reg_ctl_db_en_shift                                               (1)
#define  DI_db_reg_ctl_db_apply_shift                                            (0)
#define  DI_db_reg_ctl_sm_tog_apply_disable_mask                                 (0x80000000)
#define  DI_db_reg_ctl_sm_tog_3d_mode_mask                                       (0x40000000)
#define  DI_db_reg_ctl_db_read_mask                                              (0x00000004)
#define  DI_db_reg_ctl_db_en_mask                                                (0x00000002)
#define  DI_db_reg_ctl_db_apply_mask                                             (0x00000001)
#define  DI_db_reg_ctl_sm_tog_apply_disable(data)                                (0x80000000&((data)<<31))
#define  DI_db_reg_ctl_sm_tog_3d_mode(data)                                      (0x40000000&((data)<<30))
#define  DI_db_reg_ctl_db_read(data)                                             (0x00000004&((data)<<2))
#define  DI_db_reg_ctl_db_en(data)                                               (0x00000002&((data)<<1))
#define  DI_db_reg_ctl_db_apply(data)                                            (0x00000001&(data))
#define  DI_db_reg_ctl_get_sm_tog_apply_disable(data)                            ((0x80000000&(data))>>31)
#define  DI_db_reg_ctl_get_sm_tog_3d_mode(data)                                  ((0x40000000&(data))>>30)
#define  DI_db_reg_ctl_get_db_read(data)                                         ((0x00000004&(data))>>2)
#define  DI_db_reg_ctl_get_db_en(data)                                           ((0x00000002&(data))>>1)
#define  DI_db_reg_ctl_get_db_apply(data)                                        (0x00000001&(data))

#define  DI_i2r_db_reg_ctl                                                      0x1802453C
#define  DI_i2r_db_reg_ctl_reg_addr                                              "0xB802453C"
#define  DI_i2r_db_reg_ctl_reg                                                   0xB802453C
#define  DI_i2r_db_reg_ctl_inst_addr                                             "0x0103"
#define  set_DI_i2r_db_reg_ctl_reg(data)                                         (*((volatile unsigned int*)DI_i2r_db_reg_ctl_reg)=data)
#define  get_DI_i2r_db_reg_ctl_reg                                               (*((volatile unsigned int*)DI_i2r_db_reg_ctl_reg))
#define  DI_i2r_db_reg_ctl_smooth_toggle_end_en_shift                            (5)
#define  DI_i2r_db_reg_ctl_smooth_toggle_end_shift                               (4)
#define  DI_i2r_db_reg_ctl_smooth_toggle_end_i2r_shift                           (3)
#define  DI_i2r_db_reg_ctl_reg_sm_size_change_sw_detect_en_i2r_shift             (2)
#define  DI_i2r_db_reg_ctl_reg_sm_size_change_sw_detect_en_shift                 (1)
#define  DI_i2r_db_reg_ctl_reg_sm_size_change_hw_detect_en_shift                 (0)
#define  DI_i2r_db_reg_ctl_smooth_toggle_end_en_mask                             (0x00000020)
#define  DI_i2r_db_reg_ctl_smooth_toggle_end_mask                                (0x00000010)
#define  DI_i2r_db_reg_ctl_smooth_toggle_end_i2r_mask                            (0x00000008)
#define  DI_i2r_db_reg_ctl_reg_sm_size_change_sw_detect_en_i2r_mask              (0x00000004)
#define  DI_i2r_db_reg_ctl_reg_sm_size_change_sw_detect_en_mask                  (0x00000002)
#define  DI_i2r_db_reg_ctl_reg_sm_size_change_hw_detect_en_mask                  (0x00000001)
#define  DI_i2r_db_reg_ctl_smooth_toggle_end_en(data)                            (0x00000020&((data)<<5))
#define  DI_i2r_db_reg_ctl_smooth_toggle_end(data)                               (0x00000010&((data)<<4))
#define  DI_i2r_db_reg_ctl_smooth_toggle_end_i2r(data)                           (0x00000008&((data)<<3))
#define  DI_i2r_db_reg_ctl_reg_sm_size_change_sw_detect_en_i2r(data)             (0x00000004&((data)<<2))
#define  DI_i2r_db_reg_ctl_reg_sm_size_change_sw_detect_en(data)                 (0x00000002&((data)<<1))
#define  DI_i2r_db_reg_ctl_reg_sm_size_change_hw_detect_en(data)                 (0x00000001&(data))
#define  DI_i2r_db_reg_ctl_get_smooth_toggle_end_en(data)                        ((0x00000020&(data))>>5)
#define  DI_i2r_db_reg_ctl_get_smooth_toggle_end(data)                           ((0x00000010&(data))>>4)
#define  DI_i2r_db_reg_ctl_get_smooth_toggle_end_i2r(data)                       ((0x00000008&(data))>>3)
#define  DI_i2r_db_reg_ctl_get_reg_sm_size_change_sw_detect_en_i2r(data)         ((0x00000004&(data))>>2)
#define  DI_i2r_db_reg_ctl_get_reg_sm_size_change_sw_detect_en(data)             ((0x00000002&(data))>>1)
#define  DI_i2r_db_reg_ctl_get_reg_sm_size_change_hw_detect_en(data)             (0x00000001&(data))

#define  DI_ccdinr_dbg_mux                                                      0x180244F8
#define  DI_ccdinr_dbg_mux_reg_addr                                              "0xB80244F8"
#define  DI_ccdinr_dbg_mux_reg                                                   0xB80244F8
#define  DI_ccdinr_dbg_mux_inst_addr                                             "0x0104"
#define  set_DI_ccdinr_dbg_mux_reg(data)                                         (*((volatile unsigned int*)DI_ccdinr_dbg_mux_reg)=data)
#define  get_DI_ccdinr_dbg_mux_reg                                               (*((volatile unsigned int*)DI_ccdinr_dbg_mux_reg))
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_mode_s_shift                          (6)
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_target_s_shift                        (5)
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_mode_m_shift                          (4)
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_target_m_shift                        (3)
#define  DI_ccdinr_dbg_mux_ccdinr_debug_mode_shift                               (0)
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_mode_s_mask                           (0x00000040)
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_target_s_mask                         (0x00000020)
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_mode_m_mask                           (0x00000010)
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_target_m_mask                         (0x00000008)
#define  DI_ccdinr_dbg_mux_ccdinr_debug_mode_mask                                (0x00000007)
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_mode_s(data)                          (0x00000040&((data)<<6))
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_target_s(data)                        (0x00000020&((data)<<5))
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_mode_m(data)                          (0x00000010&((data)<<4))
#define  DI_ccdinr_dbg_mux_ccdinr_wd_debug_target_m(data)                        (0x00000008&((data)<<3))
#define  DI_ccdinr_dbg_mux_ccdinr_debug_mode(data)                               (0x00000007&(data))
#define  DI_ccdinr_dbg_mux_get_ccdinr_wd_debug_mode_s(data)                      ((0x00000040&(data))>>6)
#define  DI_ccdinr_dbg_mux_get_ccdinr_wd_debug_target_s(data)                    ((0x00000020&(data))>>5)
#define  DI_ccdinr_dbg_mux_get_ccdinr_wd_debug_mode_m(data)                      ((0x00000010&(data))>>4)
#define  DI_ccdinr_dbg_mux_get_ccdinr_wd_debug_target_m(data)                    ((0x00000008&(data))>>3)
#define  DI_ccdinr_dbg_mux_get_ccdinr_debug_mode(data)                           (0x00000007&(data))

#define  DI_DI_SMD_SADHisBinA                                                   0x18024544
#define  DI_DI_SMD_SADHisBinA_reg_addr                                           "0xB8024544"
#define  DI_DI_SMD_SADHisBinA_reg                                                0xB8024544
#define  DI_DI_SMD_SADHisBinA_inst_addr                                          "0x0105"
#define  set_DI_DI_SMD_SADHisBinA_reg(data)                                      (*((volatile unsigned int*)DI_DI_SMD_SADHisBinA_reg)=data)
#define  get_DI_DI_SMD_SADHisBinA_reg                                            (*((volatile unsigned int*)DI_DI_SMD_SADHisBinA_reg))
#define  DI_DI_SMD_SADHisBinA_smd_sad_his_bin0_shift                             (16)
#define  DI_DI_SMD_SADHisBinA_smd_sad_his_bin1_shift                             (0)
#define  DI_DI_SMD_SADHisBinA_smd_sad_his_bin0_mask                              (0xFFFF0000)
#define  DI_DI_SMD_SADHisBinA_smd_sad_his_bin1_mask                              (0x0000FFFF)
#define  DI_DI_SMD_SADHisBinA_smd_sad_his_bin0(data)                             (0xFFFF0000&((data)<<16))
#define  DI_DI_SMD_SADHisBinA_smd_sad_his_bin1(data)                             (0x0000FFFF&(data))
#define  DI_DI_SMD_SADHisBinA_get_smd_sad_his_bin0(data)                         ((0xFFFF0000&(data))>>16)
#define  DI_DI_SMD_SADHisBinA_get_smd_sad_his_bin1(data)                         (0x0000FFFF&(data))

#define  DI_DI_SMD_SADHisBinB                                                   0x18024548
#define  DI_DI_SMD_SADHisBinB_reg_addr                                           "0xB8024548"
#define  DI_DI_SMD_SADHisBinB_reg                                                0xB8024548
#define  DI_DI_SMD_SADHisBinB_inst_addr                                          "0x0106"
#define  set_DI_DI_SMD_SADHisBinB_reg(data)                                      (*((volatile unsigned int*)DI_DI_SMD_SADHisBinB_reg)=data)
#define  get_DI_DI_SMD_SADHisBinB_reg                                            (*((volatile unsigned int*)DI_DI_SMD_SADHisBinB_reg))
#define  DI_DI_SMD_SADHisBinB_smd_sad_his_bin2_shift                             (16)
#define  DI_DI_SMD_SADHisBinB_smd_sad_his_bin3_shift                             (0)
#define  DI_DI_SMD_SADHisBinB_smd_sad_his_bin2_mask                              (0xFFFF0000)
#define  DI_DI_SMD_SADHisBinB_smd_sad_his_bin3_mask                              (0x0000FFFF)
#define  DI_DI_SMD_SADHisBinB_smd_sad_his_bin2(data)                             (0xFFFF0000&((data)<<16))
#define  DI_DI_SMD_SADHisBinB_smd_sad_his_bin3(data)                             (0x0000FFFF&(data))
#define  DI_DI_SMD_SADHisBinB_get_smd_sad_his_bin2(data)                         ((0xFFFF0000&(data))>>16)
#define  DI_DI_SMD_SADHisBinB_get_smd_sad_his_bin3(data)                         (0x0000FFFF&(data))

#define  DI_DI_SMD_SADHisBinC                                                   0x1802454C
#define  DI_DI_SMD_SADHisBinC_reg_addr                                           "0xB802454C"
#define  DI_DI_SMD_SADHisBinC_reg                                                0xB802454C
#define  DI_DI_SMD_SADHisBinC_inst_addr                                          "0x0107"
#define  set_DI_DI_SMD_SADHisBinC_reg(data)                                      (*((volatile unsigned int*)DI_DI_SMD_SADHisBinC_reg)=data)
#define  get_DI_DI_SMD_SADHisBinC_reg                                            (*((volatile unsigned int*)DI_DI_SMD_SADHisBinC_reg))
#define  DI_DI_SMD_SADHisBinC_smd_sad_his_bin4_shift                             (16)
#define  DI_DI_SMD_SADHisBinC_smd_sad_his_bin5_shift                             (0)
#define  DI_DI_SMD_SADHisBinC_smd_sad_his_bin4_mask                              (0xFFFF0000)
#define  DI_DI_SMD_SADHisBinC_smd_sad_his_bin5_mask                              (0x0000FFFF)
#define  DI_DI_SMD_SADHisBinC_smd_sad_his_bin4(data)                             (0xFFFF0000&((data)<<16))
#define  DI_DI_SMD_SADHisBinC_smd_sad_his_bin5(data)                             (0x0000FFFF&(data))
#define  DI_DI_SMD_SADHisBinC_get_smd_sad_his_bin4(data)                         ((0xFFFF0000&(data))>>16)
#define  DI_DI_SMD_SADHisBinC_get_smd_sad_his_bin5(data)                         (0x0000FFFF&(data))

#define  DI_DI_SMD_SADHisBinD                                                   0x18024550
#define  DI_DI_SMD_SADHisBinD_reg_addr                                           "0xB8024550"
#define  DI_DI_SMD_SADHisBinD_reg                                                0xB8024550
#define  DI_DI_SMD_SADHisBinD_inst_addr                                          "0x0108"
#define  set_DI_DI_SMD_SADHisBinD_reg(data)                                      (*((volatile unsigned int*)DI_DI_SMD_SADHisBinD_reg)=data)
#define  get_DI_DI_SMD_SADHisBinD_reg                                            (*((volatile unsigned int*)DI_DI_SMD_SADHisBinD_reg))
#define  DI_DI_SMD_SADHisBinD_smd_sad_his_bin6_shift                             (16)
#define  DI_DI_SMD_SADHisBinD_smd_sad_his_bin7_shift                             (0)
#define  DI_DI_SMD_SADHisBinD_smd_sad_his_bin6_mask                              (0xFFFF0000)
#define  DI_DI_SMD_SADHisBinD_smd_sad_his_bin7_mask                              (0x0000FFFF)
#define  DI_DI_SMD_SADHisBinD_smd_sad_his_bin6(data)                             (0xFFFF0000&((data)<<16))
#define  DI_DI_SMD_SADHisBinD_smd_sad_his_bin7(data)                             (0x0000FFFF&(data))
#define  DI_DI_SMD_SADHisBinD_get_smd_sad_his_bin6(data)                         ((0xFFFF0000&(data))>>16)
#define  DI_DI_SMD_SADHisBinD_get_smd_sad_his_bin7(data)                         (0x0000FFFF&(data))

#define  DI_DI_SMD_SADHisBinE                                                   0x18024554
#define  DI_DI_SMD_SADHisBinE_reg_addr                                           "0xB8024554"
#define  DI_DI_SMD_SADHisBinE_reg                                                0xB8024554
#define  DI_DI_SMD_SADHisBinE_inst_addr                                          "0x0109"
#define  set_DI_DI_SMD_SADHisBinE_reg(data)                                      (*((volatile unsigned int*)DI_DI_SMD_SADHisBinE_reg)=data)
#define  get_DI_DI_SMD_SADHisBinE_reg                                            (*((volatile unsigned int*)DI_DI_SMD_SADHisBinE_reg))
#define  DI_DI_SMD_SADHisBinE_smd_sad_his_bin8_shift                             (16)
#define  DI_DI_SMD_SADHisBinE_smd_sad_his_bin9_shift                             (0)
#define  DI_DI_SMD_SADHisBinE_smd_sad_his_bin8_mask                              (0xFFFF0000)
#define  DI_DI_SMD_SADHisBinE_smd_sad_his_bin9_mask                              (0x0000FFFF)
#define  DI_DI_SMD_SADHisBinE_smd_sad_his_bin8(data)                             (0xFFFF0000&((data)<<16))
#define  DI_DI_SMD_SADHisBinE_smd_sad_his_bin9(data)                             (0x0000FFFF&(data))
#define  DI_DI_SMD_SADHisBinE_get_smd_sad_his_bin8(data)                         ((0xFFFF0000&(data))>>16)
#define  DI_DI_SMD_SADHisBinE_get_smd_sad_his_bin9(data)                         (0x0000FFFF&(data))

#define  DI_DI_SMD_SADHisBinF                                                   0x18024558
#define  DI_DI_SMD_SADHisBinF_reg_addr                                           "0xB8024558"
#define  DI_DI_SMD_SADHisBinF_reg                                                0xB8024558
#define  DI_DI_SMD_SADHisBinF_inst_addr                                          "0x010A"
#define  set_DI_DI_SMD_SADHisBinF_reg(data)                                      (*((volatile unsigned int*)DI_DI_SMD_SADHisBinF_reg)=data)
#define  get_DI_DI_SMD_SADHisBinF_reg                                            (*((volatile unsigned int*)DI_DI_SMD_SADHisBinF_reg))
#define  DI_DI_SMD_SADHisBinF_smd_sad_his_bin10_shift                            (16)
#define  DI_DI_SMD_SADHisBinF_smd_sad_his_bin11_shift                            (0)
#define  DI_DI_SMD_SADHisBinF_smd_sad_his_bin10_mask                             (0xFFFF0000)
#define  DI_DI_SMD_SADHisBinF_smd_sad_his_bin11_mask                             (0x0000FFFF)
#define  DI_DI_SMD_SADHisBinF_smd_sad_his_bin10(data)                            (0xFFFF0000&((data)<<16))
#define  DI_DI_SMD_SADHisBinF_smd_sad_his_bin11(data)                            (0x0000FFFF&(data))
#define  DI_DI_SMD_SADHisBinF_get_smd_sad_his_bin10(data)                        ((0xFFFF0000&(data))>>16)
#define  DI_DI_SMD_SADHisBinF_get_smd_sad_his_bin11(data)                        (0x0000FFFF&(data))

#define  DI_DI_SMD_SADHisBinG                                                   0x1802455C
#define  DI_DI_SMD_SADHisBinG_reg_addr                                           "0xB802455C"
#define  DI_DI_SMD_SADHisBinG_reg                                                0xB802455C
#define  DI_DI_SMD_SADHisBinG_inst_addr                                          "0x010B"
#define  set_DI_DI_SMD_SADHisBinG_reg(data)                                      (*((volatile unsigned int*)DI_DI_SMD_SADHisBinG_reg)=data)
#define  get_DI_DI_SMD_SADHisBinG_reg                                            (*((volatile unsigned int*)DI_DI_SMD_SADHisBinG_reg))
#define  DI_DI_SMD_SADHisBinG_smd_sad_his_bin12_shift                            (16)
#define  DI_DI_SMD_SADHisBinG_smd_sad_his_bin13_shift                            (0)
#define  DI_DI_SMD_SADHisBinG_smd_sad_his_bin12_mask                             (0xFFFF0000)
#define  DI_DI_SMD_SADHisBinG_smd_sad_his_bin13_mask                             (0x0000FFFF)
#define  DI_DI_SMD_SADHisBinG_smd_sad_his_bin12(data)                            (0xFFFF0000&((data)<<16))
#define  DI_DI_SMD_SADHisBinG_smd_sad_his_bin13(data)                            (0x0000FFFF&(data))
#define  DI_DI_SMD_SADHisBinG_get_smd_sad_his_bin12(data)                        ((0xFFFF0000&(data))>>16)
#define  DI_DI_SMD_SADHisBinG_get_smd_sad_his_bin13(data)                        (0x0000FFFF&(data))

#define  DI_DI_SMD_SADHisBinH                                                   0x18024560
#define  DI_DI_SMD_SADHisBinH_reg_addr                                           "0xB8024560"
#define  DI_DI_SMD_SADHisBinH_reg                                                0xB8024560
#define  DI_DI_SMD_SADHisBinH_inst_addr                                          "0x010C"
#define  set_DI_DI_SMD_SADHisBinH_reg(data)                                      (*((volatile unsigned int*)DI_DI_SMD_SADHisBinH_reg)=data)
#define  get_DI_DI_SMD_SADHisBinH_reg                                            (*((volatile unsigned int*)DI_DI_SMD_SADHisBinH_reg))
#define  DI_DI_SMD_SADHisBinH_smd_sad_his_bin14_shift                            (16)
#define  DI_DI_SMD_SADHisBinH_smd_sad_his_bin15_shift                            (0)
#define  DI_DI_SMD_SADHisBinH_smd_sad_his_bin14_mask                             (0xFFFF0000)
#define  DI_DI_SMD_SADHisBinH_smd_sad_his_bin15_mask                             (0x0000FFFF)
#define  DI_DI_SMD_SADHisBinH_smd_sad_his_bin14(data)                            (0xFFFF0000&((data)<<16))
#define  DI_DI_SMD_SADHisBinH_smd_sad_his_bin15(data)                            (0x0000FFFF&(data))
#define  DI_DI_SMD_SADHisBinH_get_smd_sad_his_bin14(data)                        ((0xFFFF0000&(data))>>16)
#define  DI_DI_SMD_SADHisBinH_get_smd_sad_his_bin15(data)                        (0x0000FFFF&(data))

#define  DI_DI_SMD_GMVCoeff3                                                    0x1802456C
#define  DI_DI_SMD_GMVCoeff3_reg_addr                                            "0xB802456C"
#define  DI_DI_SMD_GMVCoeff3_reg                                                 0xB802456C
#define  DI_DI_SMD_GMVCoeff3_inst_addr                                           "0x010D"
#define  set_DI_DI_SMD_GMVCoeff3_reg(data)                                       (*((volatile unsigned int*)DI_DI_SMD_GMVCoeff3_reg)=data)
#define  get_DI_DI_SMD_GMVCoeff3_reg                                             (*((volatile unsigned int*)DI_DI_SMD_GMVCoeff3_reg))
#define  DI_DI_SMD_GMVCoeff3_smd_firmwaremv_x_shift                              (4)
#define  DI_DI_SMD_GMVCoeff3_smd_firmwaremv_y_shift                              (0)
#define  DI_DI_SMD_GMVCoeff3_smd_firmwaremv_x_mask                               (0x00000070)
#define  DI_DI_SMD_GMVCoeff3_smd_firmwaremv_y_mask                               (0x00000007)
#define  DI_DI_SMD_GMVCoeff3_smd_firmwaremv_x(data)                              (0x00000070&((data)<<4))
#define  DI_DI_SMD_GMVCoeff3_smd_firmwaremv_y(data)                              (0x00000007&(data))
#define  DI_DI_SMD_GMVCoeff3_get_smd_firmwaremv_x(data)                          ((0x00000070&(data))>>4)
#define  DI_DI_SMD_GMVCoeff3_get_smd_firmwaremv_y(data)                          (0x00000007&(data))

#define  DI_DI_SMD_Pan1                                                         0x18024570
#define  DI_DI_SMD_Pan1_reg_addr                                                 "0xB8024570"
#define  DI_DI_SMD_Pan1_reg                                                      0xB8024570
#define  DI_DI_SMD_Pan1_inst_addr                                                "0x010E"
#define  set_DI_DI_SMD_Pan1_reg(data)                                            (*((volatile unsigned int*)DI_DI_SMD_Pan1_reg)=data)
#define  get_DI_DI_SMD_Pan1_reg                                                  (*((volatile unsigned int*)DI_DI_SMD_Pan1_reg))
#define  DI_DI_SMD_Pan1_smd_apply_result_mode_shift                              (30)
#define  DI_DI_SMD_Pan1_smd_firmware_pan_shift                                   (29)
#define  DI_DI_SMD_Pan1_smd_searchmv_apply_shift                                 (28)
#define  DI_DI_SMD_Pan1_smd_hardware_pan_en_shift                                (27)
#define  DI_DI_SMD_Pan1_smd_vpan_en_shift                                        (26)
#define  DI_DI_SMD_Pan1_smd_searchmv_apply_sad_th_shift                          (20)
#define  DI_DI_SMD_Pan1_smd_pg_no_pixel_ctr_en_shift                             (18)
#define  DI_DI_SMD_Pan1_smd_firmware_pan_sad_th_shift                            (12)
#define  DI_DI_SMD_Pan1_smd_vpan_work_th_shift                                   (8)
#define  DI_DI_SMD_Pan1_smd_vpan_jump_out_shift                                  (4)
#define  DI_DI_SMD_Pan1_smd_vpan_upper_bound_shift                               (0)
#define  DI_DI_SMD_Pan1_smd_apply_result_mode_mask                               (0xC0000000)
#define  DI_DI_SMD_Pan1_smd_firmware_pan_mask                                    (0x20000000)
#define  DI_DI_SMD_Pan1_smd_searchmv_apply_mask                                  (0x10000000)
#define  DI_DI_SMD_Pan1_smd_hardware_pan_en_mask                                 (0x08000000)
#define  DI_DI_SMD_Pan1_smd_vpan_en_mask                                         (0x04000000)
#define  DI_DI_SMD_Pan1_smd_searchmv_apply_sad_th_mask                           (0x03F00000)
#define  DI_DI_SMD_Pan1_smd_pg_no_pixel_ctr_en_mask                              (0x00040000)
#define  DI_DI_SMD_Pan1_smd_firmware_pan_sad_th_mask                             (0x0003F000)
#define  DI_DI_SMD_Pan1_smd_vpan_work_th_mask                                    (0x00000F00)
#define  DI_DI_SMD_Pan1_smd_vpan_jump_out_mask                                   (0x00000070)
#define  DI_DI_SMD_Pan1_smd_vpan_upper_bound_mask                                (0x0000000F)
#define  DI_DI_SMD_Pan1_smd_apply_result_mode(data)                              (0xC0000000&((data)<<30))
#define  DI_DI_SMD_Pan1_smd_firmware_pan(data)                                   (0x20000000&((data)<<29))
#define  DI_DI_SMD_Pan1_smd_searchmv_apply(data)                                 (0x10000000&((data)<<28))
#define  DI_DI_SMD_Pan1_smd_hardware_pan_en(data)                                (0x08000000&((data)<<27))
#define  DI_DI_SMD_Pan1_smd_vpan_en(data)                                        (0x04000000&((data)<<26))
#define  DI_DI_SMD_Pan1_smd_searchmv_apply_sad_th(data)                          (0x03F00000&((data)<<20))
#define  DI_DI_SMD_Pan1_smd_pg_no_pixel_ctr_en(data)                             (0x00040000&((data)<<18))
#define  DI_DI_SMD_Pan1_smd_firmware_pan_sad_th(data)                            (0x0003F000&((data)<<12))
#define  DI_DI_SMD_Pan1_smd_vpan_work_th(data)                                   (0x00000F00&((data)<<8))
#define  DI_DI_SMD_Pan1_smd_vpan_jump_out(data)                                  (0x00000070&((data)<<4))
#define  DI_DI_SMD_Pan1_smd_vpan_upper_bound(data)                               (0x0000000F&(data))
#define  DI_DI_SMD_Pan1_get_smd_apply_result_mode(data)                          ((0xC0000000&(data))>>30)
#define  DI_DI_SMD_Pan1_get_smd_firmware_pan(data)                               ((0x20000000&(data))>>29)
#define  DI_DI_SMD_Pan1_get_smd_searchmv_apply(data)                             ((0x10000000&(data))>>28)
#define  DI_DI_SMD_Pan1_get_smd_hardware_pan_en(data)                            ((0x08000000&(data))>>27)
#define  DI_DI_SMD_Pan1_get_smd_vpan_en(data)                                    ((0x04000000&(data))>>26)
#define  DI_DI_SMD_Pan1_get_smd_searchmv_apply_sad_th(data)                      ((0x03F00000&(data))>>20)
#define  DI_DI_SMD_Pan1_get_smd_pg_no_pixel_ctr_en(data)                         ((0x00040000&(data))>>18)
#define  DI_DI_SMD_Pan1_get_smd_firmware_pan_sad_th(data)                        ((0x0003F000&(data))>>12)
#define  DI_DI_SMD_Pan1_get_smd_vpan_work_th(data)                               ((0x00000F00&(data))>>8)
#define  DI_DI_SMD_Pan1_get_smd_vpan_jump_out(data)                              ((0x00000070&(data))>>4)
#define  DI_DI_SMD_Pan1_get_smd_vpan_upper_bound(data)                           (0x0000000F&(data))

#define  DI_DI_SMD_Pan2                                                         0x18024574
#define  DI_DI_SMD_Pan2_reg_addr                                                 "0xB8024574"
#define  DI_DI_SMD_Pan2_reg                                                      0xB8024574
#define  DI_DI_SMD_Pan2_inst_addr                                                "0x010F"
#define  set_DI_DI_SMD_Pan2_reg(data)                                            (*((volatile unsigned int*)DI_DI_SMD_Pan2_reg)=data)
#define  get_DI_DI_SMD_Pan2_reg                                                  (*((volatile unsigned int*)DI_DI_SMD_Pan2_reg))
#define  DI_DI_SMD_Pan2_smd_enter_pan_ctr_th_shift                               (26)
#define  DI_DI_SMD_Pan2_smd_vpan_gmv1_pixel_shift                                (20)
#define  DI_DI_SMD_Pan2_smd_vpan_total_pixel_shift                               (14)
#define  DI_DI_SMD_Pan2_smd_gmv3_th_shift                                        (0)
#define  DI_DI_SMD_Pan2_smd_enter_pan_ctr_th_mask                                (0xFC000000)
#define  DI_DI_SMD_Pan2_smd_vpan_gmv1_pixel_mask                                 (0x03F00000)
#define  DI_DI_SMD_Pan2_smd_vpan_total_pixel_mask                                (0x000FC000)
#define  DI_DI_SMD_Pan2_smd_gmv3_th_mask                                         (0x00003FFF)
#define  DI_DI_SMD_Pan2_smd_enter_pan_ctr_th(data)                               (0xFC000000&((data)<<26))
#define  DI_DI_SMD_Pan2_smd_vpan_gmv1_pixel(data)                                (0x03F00000&((data)<<20))
#define  DI_DI_SMD_Pan2_smd_vpan_total_pixel(data)                               (0x000FC000&((data)<<14))
#define  DI_DI_SMD_Pan2_smd_gmv3_th(data)                                        (0x00003FFF&(data))
#define  DI_DI_SMD_Pan2_get_smd_enter_pan_ctr_th(data)                           ((0xFC000000&(data))>>26)
#define  DI_DI_SMD_Pan2_get_smd_vpan_gmv1_pixel(data)                            ((0x03F00000&(data))>>20)
#define  DI_DI_SMD_Pan2_get_smd_vpan_total_pixel(data)                           ((0x000FC000&(data))>>14)
#define  DI_DI_SMD_Pan2_get_smd_gmv3_th(data)                                    (0x00003FFF&(data))

#define  DI_DI_SMD_Pan3                                                         0x18024578
#define  DI_DI_SMD_Pan3_reg_addr                                                 "0xB8024578"
#define  DI_DI_SMD_Pan3_reg                                                      0xB8024578
#define  DI_DI_SMD_Pan3_inst_addr                                                "0x0110"
#define  set_DI_DI_SMD_Pan3_reg(data)                                            (*((volatile unsigned int*)DI_DI_SMD_Pan3_reg)=data)
#define  get_DI_DI_SMD_Pan3_reg                                                  (*((volatile unsigned int*)DI_DI_SMD_Pan3_reg))
#define  DI_DI_SMD_Pan3_smd_addctr_gmv1_pixelth1_shift                           (24)
#define  DI_DI_SMD_Pan3_smd_addctr_gmv1_pixelth2_shift                           (16)
#define  DI_DI_SMD_Pan3_smd_search_apply_th_shift                                (8)
#define  DI_DI_SMD_Pan3_smd_rebuild_pan_ctr_shift                                (0)
#define  DI_DI_SMD_Pan3_smd_addctr_gmv1_pixelth1_mask                            (0x3F000000)
#define  DI_DI_SMD_Pan3_smd_addctr_gmv1_pixelth2_mask                            (0x003F0000)
#define  DI_DI_SMD_Pan3_smd_search_apply_th_mask                                 (0x00003F00)
#define  DI_DI_SMD_Pan3_smd_rebuild_pan_ctr_mask                                 (0x0000003F)
#define  DI_DI_SMD_Pan3_smd_addctr_gmv1_pixelth1(data)                           (0x3F000000&((data)<<24))
#define  DI_DI_SMD_Pan3_smd_addctr_gmv1_pixelth2(data)                           (0x003F0000&((data)<<16))
#define  DI_DI_SMD_Pan3_smd_search_apply_th(data)                                (0x00003F00&((data)<<8))
#define  DI_DI_SMD_Pan3_smd_rebuild_pan_ctr(data)                                (0x0000003F&(data))
#define  DI_DI_SMD_Pan3_get_smd_addctr_gmv1_pixelth1(data)                       ((0x3F000000&(data))>>24)
#define  DI_DI_SMD_Pan3_get_smd_addctr_gmv1_pixelth2(data)                       ((0x003F0000&(data))>>16)
#define  DI_DI_SMD_Pan3_get_smd_search_apply_th(data)                            ((0x00003F00&(data))>>8)
#define  DI_DI_SMD_Pan3_get_smd_rebuild_pan_ctr(data)                            (0x0000003F&(data))

#define  DI_DI_SMD_AdditionalCoeff1                                             0x1802457C
#define  DI_DI_SMD_AdditionalCoeff1_reg_addr                                     "0xB802457C"
#define  DI_DI_SMD_AdditionalCoeff1_reg                                          0xB802457C
#define  DI_DI_SMD_AdditionalCoeff1_inst_addr                                    "0x0111"
#define  set_DI_DI_SMD_AdditionalCoeff1_reg(data)                                (*((volatile unsigned int*)DI_DI_SMD_AdditionalCoeff1_reg)=data)
#define  get_DI_DI_SMD_AdditionalCoeff1_reg                                      (*((volatile unsigned int*)DI_DI_SMD_AdditionalCoeff1_reg))
#define  DI_DI_SMD_AdditionalCoeff1_smd_full_search_mode_shift                   (31)
#define  DI_DI_SMD_AdditionalCoeff1_smd_intra_en_shift                           (30)
#define  DI_DI_SMD_AdditionalCoeff1_smd_colony_drop_en_shift                     (29)
#define  DI_DI_SMD_AdditionalCoeff1_smd_colony_expanse_en_shift                  (28)
#define  DI_DI_SMD_AdditionalCoeff1_smd_colony_expanse_type_shift                (27)
#define  DI_DI_SMD_AdditionalCoeff1_smd_result_en_shift                          (26)
#define  DI_DI_SMD_AdditionalCoeff1_smd_curr_teeth_offset_c_shift                (20)
#define  DI_DI_SMD_AdditionalCoeff1_smd_curr_teeth_gain_c_shift                  (16)
#define  DI_DI_SMD_AdditionalCoeff1_smd_expanse_range_shift                      (13)
#define  DI_DI_SMD_AdditionalCoeff1_smd_left_weave_blend_shift                   (8)
#define  DI_DI_SMD_AdditionalCoeff1_smd_right_weave_blend_shift                  (0)
#define  DI_DI_SMD_AdditionalCoeff1_smd_full_search_mode_mask                    (0x80000000)
#define  DI_DI_SMD_AdditionalCoeff1_smd_intra_en_mask                            (0x40000000)
#define  DI_DI_SMD_AdditionalCoeff1_smd_colony_drop_en_mask                      (0x20000000)
#define  DI_DI_SMD_AdditionalCoeff1_smd_colony_expanse_en_mask                   (0x10000000)
#define  DI_DI_SMD_AdditionalCoeff1_smd_colony_expanse_type_mask                 (0x08000000)
#define  DI_DI_SMD_AdditionalCoeff1_smd_result_en_mask                           (0x04000000)
#define  DI_DI_SMD_AdditionalCoeff1_smd_curr_teeth_offset_c_mask                 (0x03F00000)
#define  DI_DI_SMD_AdditionalCoeff1_smd_curr_teeth_gain_c_mask                   (0x00070000)
#define  DI_DI_SMD_AdditionalCoeff1_smd_expanse_range_mask                       (0x0000E000)
#define  DI_DI_SMD_AdditionalCoeff1_smd_left_weave_blend_mask                    (0x00001F00)
#define  DI_DI_SMD_AdditionalCoeff1_smd_right_weave_blend_mask                   (0x0000001F)
#define  DI_DI_SMD_AdditionalCoeff1_smd_full_search_mode(data)                   (0x80000000&((data)<<31))
#define  DI_DI_SMD_AdditionalCoeff1_smd_intra_en(data)                           (0x40000000&((data)<<30))
#define  DI_DI_SMD_AdditionalCoeff1_smd_colony_drop_en(data)                     (0x20000000&((data)<<29))
#define  DI_DI_SMD_AdditionalCoeff1_smd_colony_expanse_en(data)                  (0x10000000&((data)<<28))
#define  DI_DI_SMD_AdditionalCoeff1_smd_colony_expanse_type(data)                (0x08000000&((data)<<27))
#define  DI_DI_SMD_AdditionalCoeff1_smd_result_en(data)                          (0x04000000&((data)<<26))
#define  DI_DI_SMD_AdditionalCoeff1_smd_curr_teeth_offset_c(data)                (0x03F00000&((data)<<20))
#define  DI_DI_SMD_AdditionalCoeff1_smd_curr_teeth_gain_c(data)                  (0x00070000&((data)<<16))
#define  DI_DI_SMD_AdditionalCoeff1_smd_expanse_range(data)                      (0x0000E000&((data)<<13))
#define  DI_DI_SMD_AdditionalCoeff1_smd_left_weave_blend(data)                   (0x00001F00&((data)<<8))
#define  DI_DI_SMD_AdditionalCoeff1_smd_right_weave_blend(data)                  (0x0000001F&(data))
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_full_search_mode(data)               ((0x80000000&(data))>>31)
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_intra_en(data)                       ((0x40000000&(data))>>30)
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_colony_drop_en(data)                 ((0x20000000&(data))>>29)
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_colony_expanse_en(data)              ((0x10000000&(data))>>28)
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_colony_expanse_type(data)            ((0x08000000&(data))>>27)
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_result_en(data)                      ((0x04000000&(data))>>26)
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_curr_teeth_offset_c(data)            ((0x03F00000&(data))>>20)
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_curr_teeth_gain_c(data)              ((0x00070000&(data))>>16)
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_expanse_range(data)                  ((0x0000E000&(data))>>13)
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_left_weave_blend(data)               ((0x00001F00&(data))>>8)
#define  DI_DI_SMD_AdditionalCoeff1_get_smd_right_weave_blend(data)              (0x0000001F&(data))

#define  DI_DI_SMD_AdditionalCoeff2                                             0x18024580
#define  DI_DI_SMD_AdditionalCoeff2_reg_addr                                     "0xB8024580"
#define  DI_DI_SMD_AdditionalCoeff2_reg                                          0xB8024580
#define  DI_DI_SMD_AdditionalCoeff2_inst_addr                                    "0x0112"
#define  set_DI_DI_SMD_AdditionalCoeff2_reg(data)                                (*((volatile unsigned int*)DI_DI_SMD_AdditionalCoeff2_reg)=data)
#define  get_DI_DI_SMD_AdditionalCoeff2_reg                                      (*((volatile unsigned int*)DI_DI_SMD_AdditionalCoeff2_reg))
#define  DI_DI_SMD_AdditionalCoeff2_smd_image_boundary_height_shift              (28)
#define  DI_DI_SMD_AdditionalCoeff2_smd_image_boundary_width_shift               (24)
#define  DI_DI_SMD_AdditionalCoeff2_smd_search_gmv_offset_shift                  (19)
#define  DI_DI_SMD_AdditionalCoeff2_smd_search_gmv_gain_shift                    (16)
#define  DI_DI_SMD_AdditionalCoeff2_smd_image_boundary_height_mask               (0xF0000000)
#define  DI_DI_SMD_AdditionalCoeff2_smd_image_boundary_width_mask                (0x0F000000)
#define  DI_DI_SMD_AdditionalCoeff2_smd_search_gmv_offset_mask                   (0x00F80000)
#define  DI_DI_SMD_AdditionalCoeff2_smd_search_gmv_gain_mask                     (0x00070000)
#define  DI_DI_SMD_AdditionalCoeff2_smd_image_boundary_height(data)              (0xF0000000&((data)<<28))
#define  DI_DI_SMD_AdditionalCoeff2_smd_image_boundary_width(data)               (0x0F000000&((data)<<24))
#define  DI_DI_SMD_AdditionalCoeff2_smd_search_gmv_offset(data)                  (0x00F80000&((data)<<19))
#define  DI_DI_SMD_AdditionalCoeff2_smd_search_gmv_gain(data)                    (0x00070000&((data)<<16))
#define  DI_DI_SMD_AdditionalCoeff2_get_smd_image_boundary_height(data)          ((0xF0000000&(data))>>28)
#define  DI_DI_SMD_AdditionalCoeff2_get_smd_image_boundary_width(data)           ((0x0F000000&(data))>>24)
#define  DI_DI_SMD_AdditionalCoeff2_get_smd_search_gmv_offset(data)              ((0x00F80000&(data))>>19)
#define  DI_DI_SMD_AdditionalCoeff2_get_smd_search_gmv_gain(data)                ((0x00070000&(data))>>16)

#define  DI_DI_SMD_V4HighFreq                                                   0x1802458C
#define  DI_DI_SMD_V4HighFreq_reg_addr                                           "0xB802458C"
#define  DI_DI_SMD_V4HighFreq_reg                                                0xB802458C
#define  DI_DI_SMD_V4HighFreq_inst_addr                                          "0x0113"
#define  set_DI_DI_SMD_V4HighFreq_reg(data)                                      (*((volatile unsigned int*)DI_DI_SMD_V4HighFreq_reg)=data)
#define  get_DI_DI_SMD_V4HighFreq_reg                                            (*((volatile unsigned int*)DI_DI_SMD_V4HighFreq_reg))
#define  DI_DI_SMD_V4HighFreq_smd_patterngenmode_shift                           (31)
#define  DI_DI_SMD_V4HighFreq_smd_v4highfreqeffect_shift                         (24)
#define  DI_DI_SMD_V4HighFreq_smd_v4highfreqth2_shift                            (16)
#define  DI_DI_SMD_V4HighFreq_smd_v4highfreqth1_shift                            (0)
#define  DI_DI_SMD_V4HighFreq_smd_patterngenmode_mask                            (0x80000000)
#define  DI_DI_SMD_V4HighFreq_smd_v4highfreqeffect_mask                          (0x3F000000)
#define  DI_DI_SMD_V4HighFreq_smd_v4highfreqth2_mask                             (0x007F0000)
#define  DI_DI_SMD_V4HighFreq_smd_v4highfreqth1_mask                             (0x00000FFF)
#define  DI_DI_SMD_V4HighFreq_smd_patterngenmode(data)                           (0x80000000&((data)<<31))
#define  DI_DI_SMD_V4HighFreq_smd_v4highfreqeffect(data)                         (0x3F000000&((data)<<24))
#define  DI_DI_SMD_V4HighFreq_smd_v4highfreqth2(data)                            (0x007F0000&((data)<<16))
#define  DI_DI_SMD_V4HighFreq_smd_v4highfreqth1(data)                            (0x00000FFF&(data))
#define  DI_DI_SMD_V4HighFreq_get_smd_patterngenmode(data)                       ((0x80000000&(data))>>31)
#define  DI_DI_SMD_V4HighFreq_get_smd_v4highfreqeffect(data)                     ((0x3F000000&(data))>>24)
#define  DI_DI_SMD_V4HighFreq_get_smd_v4highfreqth2(data)                        ((0x007F0000&(data))>>16)
#define  DI_DI_SMD_V4HighFreq_get_smd_v4highfreqth1(data)                        (0x00000FFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9                                     0x180245E8
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_reg_addr                             "0xB80245E8"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_reg                                  0xB80245E8
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_inst_addr                            "0x0114"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_9_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_9_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_9_reg                              (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_9_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_hmc_r16_pixelsum_shift               (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_hmc_r15_pixelsum_shift               (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_hmc_r16_pixelsum_mask                (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_hmc_r15_pixelsum_mask                (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_hmc_r16_pixelsum(data)               (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_hmc_r15_pixelsum(data)               (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_get_hmc_r16_pixelsum(data)           ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_9_get_hmc_r15_pixelsum(data)           (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10                                    0x180245EC
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_reg_addr                            "0xB80245EC"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_reg                                 0xB80245EC
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_inst_addr                           "0x0115"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_10_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_10_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_10_reg                             (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_10_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_hmc_r14_pixelsum_shift              (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_hmc_r13_pixelsum_shift              (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_hmc_r14_pixelsum_mask               (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_hmc_r13_pixelsum_mask               (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_hmc_r14_pixelsum(data)              (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_hmc_r13_pixelsum(data)              (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_get_hmc_r14_pixelsum(data)          ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_10_get_hmc_r13_pixelsum(data)          (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11                                    0x180245F0
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_reg_addr                            "0xB80245F0"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_reg                                 0xB80245F0
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_inst_addr                           "0x0116"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_11_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_11_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_11_reg                             (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_11_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_hmc_r12_pixelsum_shift              (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_hmc_r11_pixelsum_shift              (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_hmc_r12_pixelsum_mask               (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_hmc_r11_pixelsum_mask               (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_hmc_r12_pixelsum(data)              (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_hmc_r11_pixelsum(data)              (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_get_hmc_r12_pixelsum(data)          ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_11_get_hmc_r11_pixelsum(data)          (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12                                    0x180245F4
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_reg_addr                            "0xB80245F4"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_reg                                 0xB80245F4
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_inst_addr                           "0x0117"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_12_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_12_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_12_reg                             (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_12_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_hmc_r10_pixelsum_shift              (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_hmc_r9_pixelsum_shift               (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_hmc_r10_pixelsum_mask               (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_hmc_r9_pixelsum_mask                (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_hmc_r10_pixelsum(data)              (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_hmc_r9_pixelsum(data)               (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_get_hmc_r10_pixelsum(data)          ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_12_get_hmc_r9_pixelsum(data)           (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13                                    0x180245F8
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_reg_addr                            "0xB80245F8"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_reg                                 0xB80245F8
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_inst_addr                           "0x0118"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_13_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_13_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_13_reg                             (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_13_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_hmc_r8_pixelsum_shift               (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_hmc_l8_pixelsum_shift               (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_hmc_r8_pixelsum_mask                (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_hmc_l8_pixelsum_mask                (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_hmc_r8_pixelsum(data)               (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_hmc_l8_pixelsum(data)               (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_get_hmc_r8_pixelsum(data)           ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_13_get_hmc_l8_pixelsum(data)           (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14                                    0x180245FC
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_reg_addr                            "0xB80245FC"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_reg                                 0xB80245FC
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_inst_addr                           "0x0119"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_14_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_14_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_14_reg                             (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_14_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_hmc_l9_pixelsum_shift               (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_hmc_l10_pixelsum_shift              (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_hmc_l9_pixelsum_mask                (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_hmc_l10_pixelsum_mask               (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_hmc_l9_pixelsum(data)               (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_hmc_l10_pixelsum(data)              (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_get_hmc_l9_pixelsum(data)           ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_14_get_hmc_l10_pixelsum(data)          (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15                                    0x18024600
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_reg_addr                            "0xB8024600"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_reg                                 0xB8024600
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_inst_addr                           "0x011A"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_15_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_15_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_15_reg                             (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_15_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_hmc_l11_pixelsum_shift              (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_hmc_l12_pixelsum_shift              (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_hmc_l11_pixelsum_mask               (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_hmc_l12_pixelsum_mask               (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_hmc_l11_pixelsum(data)              (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_hmc_l12_pixelsum(data)              (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_get_hmc_l11_pixelsum(data)          ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_15_get_hmc_l12_pixelsum(data)          (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16                                    0x18024604
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_reg_addr                            "0xB8024604"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_reg                                 0xB8024604
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_inst_addr                           "0x011B"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_16_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_16_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_16_reg                             (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_16_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_hmc_l13_pixelsum_shift              (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_hmc_l14_pixelsum_shift              (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_hmc_l13_pixelsum_mask               (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_hmc_l14_pixelsum_mask               (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_hmc_l13_pixelsum(data)              (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_hmc_l14_pixelsum(data)              (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_get_hmc_l13_pixelsum(data)          ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_16_get_hmc_l14_pixelsum(data)          (0x0000FFFF&(data))

#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17                                    0x18024608
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_reg_addr                            "0xB8024608"
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_reg                                 0xB8024608
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_inst_addr                           "0x011C"
#define  set_DI_IM_DI_PAN_DETECTION_STATISTIC_17_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_17_reg)=data)
#define  get_DI_IM_DI_PAN_DETECTION_STATISTIC_17_reg                             (*((volatile unsigned int*)DI_IM_DI_PAN_DETECTION_STATISTIC_17_reg))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_hmc_l15_pixelsum_shift              (16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_hmc_l16_pixelsum_shift              (0)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_hmc_l15_pixelsum_mask               (0xFFFF0000)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_hmc_l16_pixelsum_mask               (0x0000FFFF)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_hmc_l15_pixelsum(data)              (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_hmc_l16_pixelsum(data)              (0x0000FFFF&(data))
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_get_hmc_l15_pixelsum(data)          ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_PAN_DETECTION_STATISTIC_17_get_hmc_l16_pixelsum(data)          (0x0000FFFF&(data))

#define  DI_DI_GST_Ctrl                                                         0x1802460C
#define  DI_DI_GST_Ctrl_reg_addr                                                 "0xB802460C"
#define  DI_DI_GST_Ctrl_reg                                                      0xB802460C
#define  DI_DI_GST_Ctrl_inst_addr                                                "0x011D"
#define  set_DI_DI_GST_Ctrl_reg(data)                                            (*((volatile unsigned int*)DI_DI_GST_Ctrl_reg)=data)
#define  get_DI_DI_GST_Ctrl_reg                                                  (*((volatile unsigned int*)DI_DI_GST_Ctrl_reg))
#define  DI_DI_GST_Ctrl_gst_en_shift                                             (31)
#define  DI_DI_GST_Ctrl_gst_debug_fmv2weave_shift                                (30)
#define  DI_DI_GST_Ctrl_gst_pregmv_needstable_shift                              (15)
#define  DI_DI_GST_Ctrl_gst_replace_sad_shift                                    (14)
#define  DI_DI_GST_Ctrl_gst_search_zmv_offset_shift                              (8)
#define  DI_DI_GST_Ctrl_gst_fmv2weave_p_shift                                    (4)
#define  DI_DI_GST_Ctrl_gst_fmv2weave_n_shift                                    (0)
#define  DI_DI_GST_Ctrl_gst_en_mask                                              (0x80000000)
#define  DI_DI_GST_Ctrl_gst_debug_fmv2weave_mask                                 (0x40000000)
#define  DI_DI_GST_Ctrl_gst_pregmv_needstable_mask                               (0x00008000)
#define  DI_DI_GST_Ctrl_gst_replace_sad_mask                                     (0x00004000)
#define  DI_DI_GST_Ctrl_gst_search_zmv_offset_mask                               (0x00003F00)
#define  DI_DI_GST_Ctrl_gst_fmv2weave_p_mask                                     (0x000000F0)
#define  DI_DI_GST_Ctrl_gst_fmv2weave_n_mask                                     (0x0000000F)
#define  DI_DI_GST_Ctrl_gst_en(data)                                             (0x80000000&((data)<<31))
#define  DI_DI_GST_Ctrl_gst_debug_fmv2weave(data)                                (0x40000000&((data)<<30))
#define  DI_DI_GST_Ctrl_gst_pregmv_needstable(data)                              (0x00008000&((data)<<15))
#define  DI_DI_GST_Ctrl_gst_replace_sad(data)                                    (0x00004000&((data)<<14))
#define  DI_DI_GST_Ctrl_gst_search_zmv_offset(data)                              (0x00003F00&((data)<<8))
#define  DI_DI_GST_Ctrl_gst_fmv2weave_p(data)                                    (0x000000F0&((data)<<4))
#define  DI_DI_GST_Ctrl_gst_fmv2weave_n(data)                                    (0x0000000F&(data))
#define  DI_DI_GST_Ctrl_get_gst_en(data)                                         ((0x80000000&(data))>>31)
#define  DI_DI_GST_Ctrl_get_gst_debug_fmv2weave(data)                            ((0x40000000&(data))>>30)
#define  DI_DI_GST_Ctrl_get_gst_pregmv_needstable(data)                          ((0x00008000&(data))>>15)
#define  DI_DI_GST_Ctrl_get_gst_replace_sad(data)                                ((0x00004000&(data))>>14)
#define  DI_DI_GST_Ctrl_get_gst_search_zmv_offset(data)                          ((0x00003F00&(data))>>8)
#define  DI_DI_GST_Ctrl_get_gst_fmv2weave_p(data)                                ((0x000000F0&(data))>>4)
#define  DI_DI_GST_Ctrl_get_gst_fmv2weave_n(data)                                (0x0000000F&(data))

#define  DI_DI_GST_Enter_origSADCheck                                           0x18024610
#define  DI_DI_GST_Enter_origSADCheck_reg_addr                                   "0xB8024610"
#define  DI_DI_GST_Enter_origSADCheck_reg                                        0xB8024610
#define  DI_DI_GST_Enter_origSADCheck_inst_addr                                  "0x011E"
#define  set_DI_DI_GST_Enter_origSADCheck_reg(data)                              (*((volatile unsigned int*)DI_DI_GST_Enter_origSADCheck_reg)=data)
#define  get_DI_DI_GST_Enter_origSADCheck_reg                                    (*((volatile unsigned int*)DI_DI_GST_Enter_origSADCheck_reg))
#define  DI_DI_GST_Enter_origSADCheck_gst_enter_origsad_lowth_shift              (16)
#define  DI_DI_GST_Enter_origSADCheck_gst_enter_origsad_offset_shift             (0)
#define  DI_DI_GST_Enter_origSADCheck_gst_enter_origsad_lowth_mask               (0x00FF0000)
#define  DI_DI_GST_Enter_origSADCheck_gst_enter_origsad_offset_mask              (0x000001FF)
#define  DI_DI_GST_Enter_origSADCheck_gst_enter_origsad_lowth(data)              (0x00FF0000&((data)<<16))
#define  DI_DI_GST_Enter_origSADCheck_gst_enter_origsad_offset(data)             (0x000001FF&(data))
#define  DI_DI_GST_Enter_origSADCheck_get_gst_enter_origsad_lowth(data)          ((0x00FF0000&(data))>>16)
#define  DI_DI_GST_Enter_origSADCheck_get_gst_enter_origsad_offset(data)         (0x000001FF&(data))

#define  DI_DI_GST_OutOfRangeCheck                                              0x18024614
#define  DI_DI_GST_OutOfRangeCheck_reg_addr                                      "0xB8024614"
#define  DI_DI_GST_OutOfRangeCheck_reg                                           0xB8024614
#define  DI_DI_GST_OutOfRangeCheck_inst_addr                                     "0x011F"
#define  set_DI_DI_GST_OutOfRangeCheck_reg(data)                                 (*((volatile unsigned int*)DI_DI_GST_OutOfRangeCheck_reg)=data)
#define  get_DI_DI_GST_OutOfRangeCheck_reg                                       (*((volatile unsigned int*)DI_DI_GST_OutOfRangeCheck_reg))
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_check_shift                    (31)
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_origsad_shift                  (16)
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_fracsadlowth_shift             (8)
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_fracsad_offset_shift           (0)
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_check_mask                     (0x80000000)
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_origsad_mask                   (0x00FF0000)
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_fracsadlowth_mask              (0x0000FF00)
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_fracsad_offset_mask            (0x000000FF)
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_check(data)                    (0x80000000&((data)<<31))
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_origsad(data)                  (0x00FF0000&((data)<<16))
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_fracsadlowth(data)             (0x0000FF00&((data)<<8))
#define  DI_DI_GST_OutOfRangeCheck_gst_outofrange_fracsad_offset(data)           (0x000000FF&(data))
#define  DI_DI_GST_OutOfRangeCheck_get_gst_outofrange_check(data)                ((0x80000000&(data))>>31)
#define  DI_DI_GST_OutOfRangeCheck_get_gst_outofrange_origsad(data)              ((0x00FF0000&(data))>>16)
#define  DI_DI_GST_OutOfRangeCheck_get_gst_outofrange_fracsadlowth(data)         ((0x0000FF00&(data))>>8)
#define  DI_DI_GST_OutOfRangeCheck_get_gst_outofrange_fracsad_offset(data)       (0x000000FF&(data))

#define  DI_DI_GST_FreqNonMatchCheck                                            0x18024618
#define  DI_DI_GST_FreqNonMatchCheck_reg_addr                                    "0xB8024618"
#define  DI_DI_GST_FreqNonMatchCheck_reg                                         0xB8024618
#define  DI_DI_GST_FreqNonMatchCheck_inst_addr                                   "0x0120"
#define  set_DI_DI_GST_FreqNonMatchCheck_reg(data)                               (*((volatile unsigned int*)DI_DI_GST_FreqNonMatchCheck_reg)=data)
#define  get_DI_DI_GST_FreqNonMatchCheck_reg                                     (*((volatile unsigned int*)DI_DI_GST_FreqNonMatchCheck_reg))
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_check_shift                (31)
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_origsad_shift              (16)
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_fracsad_lowth_shift        (8)
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_fracsad_offset_shift       (0)
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_check_mask                 (0x80000000)
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_origsad_mask               (0x00FF0000)
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_fracsad_lowth_mask         (0x0000FF00)
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_fracsad_offset_mask        (0x000000FF)
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_check(data)                (0x80000000&((data)<<31))
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_origsad(data)              (0x00FF0000&((data)<<16))
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_fracsad_lowth(data)        (0x0000FF00&((data)<<8))
#define  DI_DI_GST_FreqNonMatchCheck_gst_freqnonmatch_fracsad_offset(data)       (0x000000FF&(data))
#define  DI_DI_GST_FreqNonMatchCheck_get_gst_freqnonmatch_check(data)            ((0x80000000&(data))>>31)
#define  DI_DI_GST_FreqNonMatchCheck_get_gst_freqnonmatch_origsad(data)          ((0x00FF0000&(data))>>16)
#define  DI_DI_GST_FreqNonMatchCheck_get_gst_freqnonmatch_fracsad_lowth(data)    ((0x0000FF00&(data))>>8)
#define  DI_DI_GST_FreqNonMatchCheck_get_gst_freqnonmatch_fracsad_offset(data)   (0x000000FF&(data))

#define  DI_DI_SMD_CandidateLimitSAD                                            0x1802461C
#define  DI_DI_SMD_CandidateLimitSAD_reg_addr                                    "0xB802461C"
#define  DI_DI_SMD_CandidateLimitSAD_reg                                         0xB802461C
#define  DI_DI_SMD_CandidateLimitSAD_inst_addr                                   "0x0121"
#define  set_DI_DI_SMD_CandidateLimitSAD_reg(data)                               (*((volatile unsigned int*)DI_DI_SMD_CandidateLimitSAD_reg)=data)
#define  get_DI_DI_SMD_CandidateLimitSAD_reg                                     (*((volatile unsigned int*)DI_DI_SMD_CandidateLimitSAD_reg))
#define  DI_DI_SMD_CandidateLimitSAD_smd_gmv_sad_th_shift                        (24)
#define  DI_DI_SMD_CandidateLimitSAD_smd_gmv_sad_max_shift                       (16)
#define  DI_DI_SMD_CandidateLimitSAD_smd_localmv_sad_max_shift                   (8)
#define  DI_DI_SMD_CandidateLimitSAD_smd_spatialmv_sad_max_shift                 (0)
#define  DI_DI_SMD_CandidateLimitSAD_smd_gmv_sad_th_mask                         (0x7F000000)
#define  DI_DI_SMD_CandidateLimitSAD_smd_gmv_sad_max_mask                        (0x00FF0000)
#define  DI_DI_SMD_CandidateLimitSAD_smd_localmv_sad_max_mask                    (0x0000FF00)
#define  DI_DI_SMD_CandidateLimitSAD_smd_spatialmv_sad_max_mask                  (0x000000FF)
#define  DI_DI_SMD_CandidateLimitSAD_smd_gmv_sad_th(data)                        (0x7F000000&((data)<<24))
#define  DI_DI_SMD_CandidateLimitSAD_smd_gmv_sad_max(data)                       (0x00FF0000&((data)<<16))
#define  DI_DI_SMD_CandidateLimitSAD_smd_localmv_sad_max(data)                   (0x0000FF00&((data)<<8))
#define  DI_DI_SMD_CandidateLimitSAD_smd_spatialmv_sad_max(data)                 (0x000000FF&(data))
#define  DI_DI_SMD_CandidateLimitSAD_get_smd_gmv_sad_th(data)                    ((0x7F000000&(data))>>24)
#define  DI_DI_SMD_CandidateLimitSAD_get_smd_gmv_sad_max(data)                   ((0x00FF0000&(data))>>16)
#define  DI_DI_SMD_CandidateLimitSAD_get_smd_localmv_sad_max(data)               ((0x0000FF00&(data))>>8)
#define  DI_DI_SMD_CandidateLimitSAD_get_smd_spatialmv_sad_max(data)             (0x000000FF&(data))

#define  DI_IM_DI_HMC_ADJUSTABLE                                                0x1802464C
#define  DI_IM_DI_HMC_ADJUSTABLE_reg_addr                                        "0xB802464C"
#define  DI_IM_DI_HMC_ADJUSTABLE_reg                                             0xB802464C
#define  DI_IM_DI_HMC_ADJUSTABLE_inst_addr                                       "0x0122"
#define  set_DI_IM_DI_HMC_ADJUSTABLE_reg(data)                                   (*((volatile unsigned int*)DI_IM_DI_HMC_ADJUSTABLE_reg)=data)
#define  get_DI_IM_DI_HMC_ADJUSTABLE_reg                                         (*((volatile unsigned int*)DI_IM_DI_HMC_ADJUSTABLE_reg))
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_mv_refine_mor_en_shift                      (31)
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_dynamic_threshold_min_clip_shift            (28)
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_mv_refine_y_th_shift                        (20)
#define  DI_IM_DI_HMC_ADJUSTABLE_mc_dynamic_threshold_clip_en_shift              (19)
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_mv_refine_en_shift                          (18)
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_odd_mv_no_compesation_shift                 (17)
#define  DI_IM_DI_HMC_ADJUSTABLE_hme_max_absolute_count_shift                    (8)
#define  DI_IM_DI_HMC_ADJUSTABLE_hme_sobel_search_min_shift                      (0)
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_mv_refine_mor_en_mask                       (0x80000000)
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_dynamic_threshold_min_clip_mask             (0x70000000)
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_mv_refine_y_th_mask                         (0x0FF00000)
#define  DI_IM_DI_HMC_ADJUSTABLE_mc_dynamic_threshold_clip_en_mask               (0x00080000)
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_mv_refine_en_mask                           (0x00040000)
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_odd_mv_no_compesation_mask                  (0x00020000)
#define  DI_IM_DI_HMC_ADJUSTABLE_hme_max_absolute_count_mask                     (0x0000FF00)
#define  DI_IM_DI_HMC_ADJUSTABLE_hme_sobel_search_min_mask                       (0x0000000F)
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_mv_refine_mor_en(data)                      (0x80000000&((data)<<31))
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_dynamic_threshold_min_clip(data)            (0x70000000&((data)<<28))
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_mv_refine_y_th(data)                        (0x0FF00000&((data)<<20))
#define  DI_IM_DI_HMC_ADJUSTABLE_mc_dynamic_threshold_clip_en(data)              (0x00080000&((data)<<19))
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_mv_refine_en(data)                          (0x00040000&((data)<<18))
#define  DI_IM_DI_HMC_ADJUSTABLE_hmc_odd_mv_no_compesation(data)                 (0x00020000&((data)<<17))
#define  DI_IM_DI_HMC_ADJUSTABLE_hme_max_absolute_count(data)                    (0x0000FF00&((data)<<8))
#define  DI_IM_DI_HMC_ADJUSTABLE_hme_sobel_search_min(data)                      (0x0000000F&(data))
#define  DI_IM_DI_HMC_ADJUSTABLE_get_hmc_mv_refine_mor_en(data)                  ((0x80000000&(data))>>31)
#define  DI_IM_DI_HMC_ADJUSTABLE_get_hmc_dynamic_threshold_min_clip(data)        ((0x70000000&(data))>>28)
#define  DI_IM_DI_HMC_ADJUSTABLE_get_hmc_mv_refine_y_th(data)                    ((0x0FF00000&(data))>>20)
#define  DI_IM_DI_HMC_ADJUSTABLE_get_mc_dynamic_threshold_clip_en(data)          ((0x00080000&(data))>>19)
#define  DI_IM_DI_HMC_ADJUSTABLE_get_hmc_mv_refine_en(data)                      ((0x00040000&(data))>>18)
#define  DI_IM_DI_HMC_ADJUSTABLE_get_hmc_odd_mv_no_compesation(data)             ((0x00020000&(data))>>17)
#define  DI_IM_DI_HMC_ADJUSTABLE_get_hme_max_absolute_count(data)                ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_HMC_ADJUSTABLE_get_hme_sobel_search_min(data)                  (0x0000000F&(data))

#define  DI_IM_DI_HMC_ADJUSTABLE2                                               0x18024650
#define  DI_IM_DI_HMC_ADJUSTABLE2_reg_addr                                       "0xB8024650"
#define  DI_IM_DI_HMC_ADJUSTABLE2_reg                                            0xB8024650
#define  DI_IM_DI_HMC_ADJUSTABLE2_inst_addr                                      "0x0123"
#define  set_DI_IM_DI_HMC_ADJUSTABLE2_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_HMC_ADJUSTABLE2_reg)=data)
#define  get_DI_IM_DI_HMC_ADJUSTABLE2_reg                                        (*((volatile unsigned int*)DI_IM_DI_HMC_ADJUSTABLE2_reg))
#define  DI_IM_DI_HMC_ADJUSTABLE2_hme_x_continued_counter_shift                  (28)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_mor_noise_th_shift               (24)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_mor_zero_th1_hh_shift            (16)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_follow_ma_result_en_shift                  (15)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_cur_motion_en_shift              (14)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_mor_same_th1_hh_shift            (8)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_cur_motion_th_shift              (0)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hme_x_continued_counter_mask                   (0xF0000000)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_mor_noise_th_mask                (0x0F000000)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_mor_zero_th1_hh_mask             (0x003F0000)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_follow_ma_result_en_mask                   (0x00008000)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_cur_motion_en_mask               (0x00004000)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_mor_same_th1_hh_mask             (0x00003F00)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_cur_motion_th_mask               (0x000000FF)
#define  DI_IM_DI_HMC_ADJUSTABLE2_hme_x_continued_counter(data)                  (0xF0000000&((data)<<28))
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_mor_noise_th(data)               (0x0F000000&((data)<<24))
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_mor_zero_th1_hh(data)            (0x003F0000&((data)<<16))
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_follow_ma_result_en(data)                  (0x00008000&((data)<<15))
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_cur_motion_en(data)              (0x00004000&((data)<<14))
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_mor_same_th1_hh(data)            (0x00003F00&((data)<<8))
#define  DI_IM_DI_HMC_ADJUSTABLE2_hmc_mv_refine_cur_motion_th(data)              (0x000000FF&(data))
#define  DI_IM_DI_HMC_ADJUSTABLE2_get_hme_x_continued_counter(data)              ((0xF0000000&(data))>>28)
#define  DI_IM_DI_HMC_ADJUSTABLE2_get_hmc_mv_refine_mor_noise_th(data)           ((0x0F000000&(data))>>24)
#define  DI_IM_DI_HMC_ADJUSTABLE2_get_hmc_mv_refine_mor_zero_th1_hh(data)        ((0x003F0000&(data))>>16)
#define  DI_IM_DI_HMC_ADJUSTABLE2_get_hmc_follow_ma_result_en(data)              ((0x00008000&(data))>>15)
#define  DI_IM_DI_HMC_ADJUSTABLE2_get_hmc_mv_refine_cur_motion_en(data)          ((0x00004000&(data))>>14)
#define  DI_IM_DI_HMC_ADJUSTABLE2_get_hmc_mv_refine_mor_same_th1_hh(data)        ((0x00003F00&(data))>>8)
#define  DI_IM_DI_HMC_ADJUSTABLE2_get_hmc_mv_refine_cur_motion_th(data)          (0x000000FF&(data))

#define  DI_IM_DI_HMC_ADJUSTABLE3                                               0x18024654
#define  DI_IM_DI_HMC_ADJUSTABLE3_reg_addr                                       "0xB8024654"
#define  DI_IM_DI_HMC_ADJUSTABLE3_reg                                            0xB8024654
#define  DI_IM_DI_HMC_ADJUSTABLE3_inst_addr                                      "0x0124"
#define  set_DI_IM_DI_HMC_ADJUSTABLE3_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_HMC_ADJUSTABLE3_reg)=data)
#define  get_DI_IM_DI_HMC_ADJUSTABLE3_reg                                        (*((volatile unsigned int*)DI_IM_DI_HMC_ADJUSTABLE3_reg))
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_fail_follow_ma_result_en_shift             (30)
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_zero_th2_shift               (24)
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_same_th2_shift               (16)
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_zero_th1_shift               (8)
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_same_th1_shift               (0)
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_fail_follow_ma_result_en_mask              (0x40000000)
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_zero_th2_mask                (0x3F000000)
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_same_th2_mask                (0x003F0000)
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_zero_th1_mask                (0x00003F00)
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_same_th1_mask                (0x0000003F)
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_fail_follow_ma_result_en(data)             (0x40000000&((data)<<30))
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_zero_th2(data)               (0x3F000000&((data)<<24))
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_same_th2(data)               (0x003F0000&((data)<<16))
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_zero_th1(data)               (0x00003F00&((data)<<8))
#define  DI_IM_DI_HMC_ADJUSTABLE3_hmc_mv_refine_mor_same_th1(data)               (0x0000003F&(data))
#define  DI_IM_DI_HMC_ADJUSTABLE3_get_hmc_fail_follow_ma_result_en(data)         ((0x40000000&(data))>>30)
#define  DI_IM_DI_HMC_ADJUSTABLE3_get_hmc_mv_refine_mor_zero_th2(data)           ((0x3F000000&(data))>>24)
#define  DI_IM_DI_HMC_ADJUSTABLE3_get_hmc_mv_refine_mor_same_th2(data)           ((0x003F0000&(data))>>16)
#define  DI_IM_DI_HMC_ADJUSTABLE3_get_hmc_mv_refine_mor_zero_th1(data)           ((0x00003F00&(data))>>8)
#define  DI_IM_DI_HMC_ADJUSTABLE3_get_hmc_mv_refine_mor_same_th1(data)           (0x0000003F&(data))

#define  DI_IM_DI_HMC_ADJUSTABLE4                                               0x18024658
#define  DI_IM_DI_HMC_ADJUSTABLE4_reg_addr                                       "0xB8024658"
#define  DI_IM_DI_HMC_ADJUSTABLE4_reg                                            0xB8024658
#define  DI_IM_DI_HMC_ADJUSTABLE4_inst_addr                                      "0x0125"
#define  set_DI_IM_DI_HMC_ADJUSTABLE4_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_HMC_ADJUSTABLE4_reg)=data)
#define  get_DI_IM_DI_HMC_ADJUSTABLE4_reg                                        (*((volatile unsigned int*)DI_IM_DI_HMC_ADJUSTABLE4_reg))
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_sobel_en_shift                   (31)
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_sobel_non_edge_th_shift          (24)
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_sobel_diff_th_shift              (16)
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_mor_hh_h_th_shift                (8)
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_mor_hh_v_th_shift                (0)
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_sobel_en_mask                    (0x80000000)
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_sobel_non_edge_th_mask           (0x0F000000)
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_sobel_diff_th_mask               (0x001F0000)
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_mor_hh_h_th_mask                 (0x00001F00)
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_mor_hh_v_th_mask                 (0x0000001F)
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_sobel_en(data)                   (0x80000000&((data)<<31))
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_sobel_non_edge_th(data)          (0x0F000000&((data)<<24))
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_sobel_diff_th(data)              (0x001F0000&((data)<<16))
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_mor_hh_h_th(data)                (0x00001F00&((data)<<8))
#define  DI_IM_DI_HMC_ADJUSTABLE4_hmc_mv_refine_mor_hh_v_th(data)                (0x0000001F&(data))
#define  DI_IM_DI_HMC_ADJUSTABLE4_get_hmc_mv_refine_sobel_en(data)               ((0x80000000&(data))>>31)
#define  DI_IM_DI_HMC_ADJUSTABLE4_get_hmc_mv_refine_sobel_non_edge_th(data)      ((0x0F000000&(data))>>24)
#define  DI_IM_DI_HMC_ADJUSTABLE4_get_hmc_mv_refine_sobel_diff_th(data)          ((0x001F0000&(data))>>16)
#define  DI_IM_DI_HMC_ADJUSTABLE4_get_hmc_mv_refine_mor_hh_h_th(data)            ((0x00001F00&(data))>>8)
#define  DI_IM_DI_HMC_ADJUSTABLE4_get_hmc_mv_refine_mor_hh_v_th(data)            (0x0000001F&(data))

#define  DI_IM_DI_SC_ADJUSTMENT                                                 0x1802465C
#define  DI_IM_DI_SC_ADJUSTMENT_reg_addr                                         "0xB802465C"
#define  DI_IM_DI_SC_ADJUSTMENT_reg                                              0xB802465C
#define  DI_IM_DI_SC_ADJUSTMENT_inst_addr                                        "0x0126"
#define  set_DI_IM_DI_SC_ADJUSTMENT_reg(data)                                    (*((volatile unsigned int*)DI_IM_DI_SC_ADJUSTMENT_reg)=data)
#define  get_DI_IM_DI_SC_ADJUSTMENT_reg                                          (*((volatile unsigned int*)DI_IM_DI_SC_ADJUSTMENT_reg))
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond1_en_shift                      (31)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond2_en_shift                      (30)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond1_result_shift                  (29)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond2_result_shift                  (28)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_debug_en_shift                      (27)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond1_th_shift                      (16)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond2_th_shift                      (0)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond1_en_mask                       (0x80000000)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond2_en_mask                       (0x40000000)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond1_result_mask                   (0x20000000)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond2_result_mask                   (0x10000000)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_debug_en_mask                       (0x08000000)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond1_th_mask                       (0x07FF0000)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond2_th_mask                       (0x0000FFFF)
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond1_en(data)                      (0x80000000&((data)<<31))
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond2_en(data)                      (0x40000000&((data)<<30))
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond1_result(data)                  (0x20000000&((data)<<29))
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond2_result(data)                  (0x10000000&((data)<<28))
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_debug_en(data)                      (0x08000000&((data)<<27))
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond1_th(data)                      (0x07FF0000&((data)<<16))
#define  DI_IM_DI_SC_ADJUSTMENT_scene_change_cond2_th(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_SC_ADJUSTMENT_get_scene_change_cond1_en(data)                  ((0x80000000&(data))>>31)
#define  DI_IM_DI_SC_ADJUSTMENT_get_scene_change_cond2_en(data)                  ((0x40000000&(data))>>30)
#define  DI_IM_DI_SC_ADJUSTMENT_get_scene_change_cond1_result(data)              ((0x20000000&(data))>>29)
#define  DI_IM_DI_SC_ADJUSTMENT_get_scene_change_cond2_result(data)              ((0x10000000&(data))>>28)
#define  DI_IM_DI_SC_ADJUSTMENT_get_scene_change_debug_en(data)                  ((0x08000000&(data))>>27)
#define  DI_IM_DI_SC_ADJUSTMENT_get_scene_change_cond1_th(data)                  ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_SC_ADJUSTMENT_get_scene_change_cond2_th(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_HMC_PAN_CONTROL                                               0x18024660
#define  DI_IM_DI_HMC_PAN_CONTROL_reg_addr                                       "0xB8024660"
#define  DI_IM_DI_HMC_PAN_CONTROL_reg                                            0xB8024660
#define  DI_IM_DI_HMC_PAN_CONTROL_inst_addr                                      "0x0127"
#define  set_DI_IM_DI_HMC_PAN_CONTROL_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_CONTROL_reg)=data)
#define  get_DI_IM_DI_HMC_PAN_CONTROL_reg                                        (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_CONTROL_reg))
#define  DI_IM_DI_HMC_PAN_CONTROL_dummy_31_29_shift                              (29)
#define  DI_IM_DI_HMC_PAN_CONTROL_ma_horicom_teethdiff_en_shift                  (28)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_notteeth_recover_en_shift          (27)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_all_teeth_check_en_shift           (26)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_energy_check_en_shift              (25)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_correct_en_shift                   (24)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_blending_en_shift                  (23)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_mv_refine_sub_px_mv_en_shift               (21)
#define  DI_IM_DI_HMC_PAN_CONTROL_hme_avoid_rltype_vertical_pan_en_shift         (19)
#define  DI_IM_DI_HMC_PAN_CONTROL_hme_consider_mv_invalid_en_shift               (18)
#define  DI_IM_DI_HMC_PAN_CONTROL_hme_check_zero_mv_en_shift                     (17)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_adaptive_compensation_en_shift          (15)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_sub_pixel_mv_det_en_shift               (14)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_rls_en_shift                            (13)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_invalid_check_en_shift                  (12)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_sobel_diff_ref_y_add_bias_en_shift      (11)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_force_compensation_en_shift             (10)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_select_mv_hist_shift                    (9)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_debug_en_shift                             (8)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_debug_en_shift                          (7)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_fw_control_motion_vector_shift          (1)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_fw_control_motion_vector_det_shift      (0)
#define  DI_IM_DI_HMC_PAN_CONTROL_dummy_31_29_mask                               (0xE0000000)
#define  DI_IM_DI_HMC_PAN_CONTROL_ma_horicom_teethdiff_en_mask                   (0x10000000)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_notteeth_recover_en_mask           (0x08000000)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_all_teeth_check_en_mask            (0x04000000)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_energy_check_en_mask               (0x02000000)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_correct_en_mask                    (0x01000000)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_blending_en_mask                   (0x00800000)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_mv_refine_sub_px_mv_en_mask                (0x00200000)
#define  DI_IM_DI_HMC_PAN_CONTROL_hme_avoid_rltype_vertical_pan_en_mask          (0x00080000)
#define  DI_IM_DI_HMC_PAN_CONTROL_hme_consider_mv_invalid_en_mask                (0x00040000)
#define  DI_IM_DI_HMC_PAN_CONTROL_hme_check_zero_mv_en_mask                      (0x00020000)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_adaptive_compensation_en_mask           (0x00008000)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_sub_pixel_mv_det_en_mask                (0x00004000)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_rls_en_mask                             (0x00002000)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_invalid_check_en_mask                   (0x00001000)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_sobel_diff_ref_y_add_bias_en_mask       (0x00000800)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_force_compensation_en_mask              (0x00000400)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_select_mv_hist_mask                     (0x00000200)
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_debug_en_mask                              (0x00000100)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_debug_en_mask                           (0x00000080)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_fw_control_motion_vector_mask           (0x0000007E)
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_fw_control_motion_vector_det_mask       (0x00000001)
#define  DI_IM_DI_HMC_PAN_CONTROL_dummy_31_29(data)                              (0xE0000000&((data)<<29))
#define  DI_IM_DI_HMC_PAN_CONTROL_ma_horicom_teethdiff_en(data)                  (0x10000000&((data)<<28))
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_notteeth_recover_en(data)          (0x08000000&((data)<<27))
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_all_teeth_check_en(data)           (0x04000000&((data)<<26))
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_energy_check_en(data)              (0x02000000&((data)<<25))
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_correct_en(data)                   (0x01000000&((data)<<24))
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_half_mv_blending_en(data)                  (0x00800000&((data)<<23))
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_mv_refine_sub_px_mv_en(data)               (0x00200000&((data)<<21))
#define  DI_IM_DI_HMC_PAN_CONTROL_hme_avoid_rltype_vertical_pan_en(data)         (0x00080000&((data)<<19))
#define  DI_IM_DI_HMC_PAN_CONTROL_hme_consider_mv_invalid_en(data)               (0x00040000&((data)<<18))
#define  DI_IM_DI_HMC_PAN_CONTROL_hme_check_zero_mv_en(data)                     (0x00020000&((data)<<17))
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_adaptive_compensation_en(data)          (0x00008000&((data)<<15))
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_sub_pixel_mv_det_en(data)               (0x00004000&((data)<<14))
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_rls_en(data)                            (0x00002000&((data)<<13))
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_invalid_check_en(data)                  (0x00001000&((data)<<12))
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_sobel_diff_ref_y_add_bias_en(data)      (0x00000800&((data)<<11))
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_force_compensation_en(data)             (0x00000400&((data)<<10))
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_select_mv_hist(data)                    (0x00000200&((data)<<9))
#define  DI_IM_DI_HMC_PAN_CONTROL_hmc_debug_en(data)                             (0x00000100&((data)<<8))
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_mc_debug_en(data)                          (0x00000080&((data)<<7))
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_fw_control_motion_vector(data)          (0x0000007E&((data)<<1))
#define  DI_IM_DI_HMC_PAN_CONTROL_pan_me_fw_control_motion_vector_det(data)      (0x00000001&(data))
#define  DI_IM_DI_HMC_PAN_CONTROL_get_dummy_31_29(data)                          ((0xE0000000&(data))>>29)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_ma_horicom_teethdiff_en(data)              ((0x10000000&(data))>>28)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_hmc_half_mv_notteeth_recover_en(data)      ((0x08000000&(data))>>27)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_hmc_half_mv_all_teeth_check_en(data)       ((0x04000000&(data))>>26)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_hmc_half_mv_energy_check_en(data)          ((0x02000000&(data))>>25)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_hmc_half_mv_correct_en(data)               ((0x01000000&(data))>>24)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_hmc_half_mv_blending_en(data)              ((0x00800000&(data))>>23)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_hmc_mv_refine_sub_px_mv_en(data)           ((0x00200000&(data))>>21)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_hme_avoid_rltype_vertical_pan_en(data)     ((0x00080000&(data))>>19)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_hme_consider_mv_invalid_en(data)           ((0x00040000&(data))>>18)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_hme_check_zero_mv_en(data)                 ((0x00020000&(data))>>17)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_pan_mc_adaptive_compensation_en(data)      ((0x00008000&(data))>>15)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_pan_me_sub_pixel_mv_det_en(data)           ((0x00004000&(data))>>14)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_pan_mc_rls_en(data)                        ((0x00002000&(data))>>13)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_pan_me_invalid_check_en(data)              ((0x00001000&(data))>>12)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_pan_me_sobel_diff_ref_y_add_bias_en(data)  ((0x00000800&(data))>>11)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_pan_mc_force_compensation_en(data)         ((0x00000400&(data))>>10)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_pan_me_select_mv_hist(data)                ((0x00000200&(data))>>9)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_hmc_debug_en(data)                         ((0x00000100&(data))>>8)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_pan_mc_debug_en(data)                      ((0x00000080&(data))>>7)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_pan_me_fw_control_motion_vector(data)      ((0x0000007E&(data))>>1)
#define  DI_IM_DI_HMC_PAN_CONTROL_get_pan_me_fw_control_motion_vector_det(data)  (0x00000001&(data))

#define  DI_IM_DI_HMC_PAN_ADD_BIAS                                              0x18024664
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_reg_addr                                      "0xB8024664"
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_reg                                           0xB8024664
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_inst_addr                                     "0x0128"
#define  set_DI_IM_DI_HMC_PAN_ADD_BIAS_reg(data)                                 (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_ADD_BIAS_reg)=data)
#define  get_DI_IM_DI_HMC_PAN_ADD_BIAS_reg                                       (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_ADD_BIAS_reg))
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_3_shift      (26)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_2_shift      (22)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_1_shift      (18)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_th2_shift    (12)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_th1_shift    (6)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_th0_shift    (0)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_3_mask       (0x3C000000)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_2_mask       (0x03C00000)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_1_mask       (0x003C0000)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_th2_mask     (0x0003F000)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_th1_mask     (0x00000FC0)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_th0_mask     (0x0000003F)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_3(data)      (0x3C000000&((data)<<26))
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_2(data)      (0x03C00000&((data)<<22))
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_1(data)      (0x003C0000&((data)<<18))
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_th2(data)    (0x0003F000&((data)<<12))
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_th1(data)    (0x00000FC0&((data)<<6))
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_pan_me_sobel_diff_ref_y_add_bias_th0(data)    (0x0000003F&(data))
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_get_pan_me_sobel_diff_ref_y_add_bias_3(data)  ((0x3C000000&(data))>>26)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_get_pan_me_sobel_diff_ref_y_add_bias_2(data)  ((0x03C00000&(data))>>22)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_get_pan_me_sobel_diff_ref_y_add_bias_1(data)  ((0x003C0000&(data))>>18)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_get_pan_me_sobel_diff_ref_y_add_bias_th2(data) ((0x0003F000&(data))>>12)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_get_pan_me_sobel_diff_ref_y_add_bias_th1(data) ((0x00000FC0&(data))>>6)
#define  DI_IM_DI_HMC_PAN_ADD_BIAS_get_pan_me_sobel_diff_ref_y_add_bias_th0(data) (0x0000003F&(data))

#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1                                         0x18024668
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_reg_addr                                 "0xB8024668"
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_reg                                      0xB8024668
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_inst_addr                                "0x0129"
#define  set_DI_IM_DI_HMC_PAN_CONTROL_PAR_1_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_CONTROL_PAR_1_reg)=data)
#define  get_DI_IM_DI_HMC_PAN_CONTROL_PAR_1_reg                                  (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_CONTROL_PAR_1_reg))
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_pan_mc_rls_sobel_diff_min_th_shift       (18)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_pan_me_invalid_check_maxmin_diff_thd_shift (13)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_pan_me_invalid_check_cnt_thd_shift       (8)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_hme_sum_max_ratio_shift                  (0)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_pan_mc_rls_sobel_diff_min_th_mask        (0x007C0000)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_pan_me_invalid_check_maxmin_diff_thd_mask (0x0003E000)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_pan_me_invalid_check_cnt_thd_mask        (0x00001F00)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_hme_sum_max_ratio_mask                   (0x0000007F)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_pan_mc_rls_sobel_diff_min_th(data)       (0x007C0000&((data)<<18))
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_pan_me_invalid_check_maxmin_diff_thd(data) (0x0003E000&((data)<<13))
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_pan_me_invalid_check_cnt_thd(data)       (0x00001F00&((data)<<8))
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_hme_sum_max_ratio(data)                  (0x0000007F&(data))
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_get_pan_mc_rls_sobel_diff_min_th(data)   ((0x007C0000&(data))>>18)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_get_pan_me_invalid_check_maxmin_diff_thd(data) ((0x0003E000&(data))>>13)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_get_pan_me_invalid_check_cnt_thd(data)   ((0x00001F00&(data))>>8)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_1_get_hme_sum_max_ratio(data)              (0x0000007F&(data))

#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2                                         0x1802466C
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_reg_addr                                 "0xB802466C"
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_reg                                      0xB802466C
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_inst_addr                                "0x012A"
#define  set_DI_IM_DI_HMC_PAN_CONTROL_PAR_2_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_CONTROL_PAR_2_reg)=data)
#define  get_DI_IM_DI_HMC_PAN_CONTROL_PAR_2_reg                                  (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_CONTROL_PAR_2_reg))
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_hmc_sub_pixel_diff_thd_shift             (24)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_hme_avoid_rltype_vertical_pan_nedge_thd_shift (13)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_hme_avoid_rltype_vertical_pan_rledge_thd_shift (8)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_pan_mc_adaptive_compensation_teeth_thd_shift (0)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_hmc_sub_pixel_diff_thd_mask              (0xFF000000)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_hme_avoid_rltype_vertical_pan_nedge_thd_mask (0x0001E000)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_hme_avoid_rltype_vertical_pan_rledge_thd_mask (0x00001F00)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_pan_mc_adaptive_compensation_teeth_thd_mask (0x000000FF)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_hmc_sub_pixel_diff_thd(data)             (0xFF000000&((data)<<24))
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_hme_avoid_rltype_vertical_pan_nedge_thd(data) (0x0001E000&((data)<<13))
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_hme_avoid_rltype_vertical_pan_rledge_thd(data) (0x00001F00&((data)<<8))
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_pan_mc_adaptive_compensation_teeth_thd(data) (0x000000FF&(data))
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_get_hmc_sub_pixel_diff_thd(data)         ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_get_hme_avoid_rltype_vertical_pan_nedge_thd(data) ((0x0001E000&(data))>>13)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_get_hme_avoid_rltype_vertical_pan_rledge_thd(data) ((0x00001F00&(data))>>8)
#define  DI_IM_DI_HMC_PAN_CONTROL_PAR_2_get_pan_mc_adaptive_compensation_teeth_thd(data) (0x000000FF&(data))

#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2                                      0x18024674
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_reg_addr                              "0xB8024674"
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_reg                                   0xB8024674
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_inst_addr                             "0x012B"
#define  set_DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_reg(data)                         (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_reg)=data)
#define  get_DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_reg                               (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_reg))
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_hmc_half_mv_correct_weight1_shift     (28)
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_hmc_half_mv_correct_weight2_shift     (24)
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_hmc_half_mv_correct_weight1_mask      (0xF0000000)
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_hmc_half_mv_correct_weight2_mask      (0x0F000000)
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_hmc_half_mv_correct_weight1(data)     (0xF0000000&((data)<<28))
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_hmc_half_mv_correct_weight2(data)     (0x0F000000&((data)<<24))
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_get_hmc_half_mv_correct_weight1(data) ((0xF0000000&(data))>>28)
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_2_get_hmc_half_mv_correct_weight2(data) ((0x0F000000&(data))>>24)

#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3                                      0x18024678
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_reg_addr                              "0xB8024678"
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_reg                                   0xB8024678
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_inst_addr                             "0x012C"
#define  set_DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_reg(data)                         (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_reg)=data)
#define  get_DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_reg                               (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_reg))
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_hmc_half_mv_correct_weight3_shift     (28)
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_hmc_half_mv_correct_weight4_shift     (24)
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_hmc_half_mv_correct_weight3_mask      (0xF0000000)
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_hmc_half_mv_correct_weight4_mask      (0x0F000000)
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_hmc_half_mv_correct_weight3(data)     (0xF0000000&((data)<<28))
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_hmc_half_mv_correct_weight4(data)     (0x0F000000&((data)<<24))
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_get_hmc_half_mv_correct_weight3(data) ((0xF0000000&(data))>>28)
#define  DI_IM_DI_HMC_PAN_VERTICAL_INTRA_3_get_hmc_half_mv_correct_weight4(data) ((0x0F000000&(data))>>24)

#define  DI_IM_DI_HMC_PAN_DUMMY_1                                               0x1802467C
#define  DI_IM_DI_HMC_PAN_DUMMY_1_reg_addr                                       "0xB802467C"
#define  DI_IM_DI_HMC_PAN_DUMMY_1_reg                                            0xB802467C
#define  DI_IM_DI_HMC_PAN_DUMMY_1_inst_addr                                      "0x012D"
#define  set_DI_IM_DI_HMC_PAN_DUMMY_1_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_DUMMY_1_reg)=data)
#define  get_DI_IM_DI_HMC_PAN_DUMMY_1_reg                                        (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_DUMMY_1_reg))
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_prediff_th_shift           (24)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_nextdiff_th_shift          (18)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_energy_th1_shift           (12)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_energy_th2_shift           (6)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_energy_th3_shift           (0)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_prediff_th_mask            (0x3F000000)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_nextdiff_th_mask           (0x00FC0000)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_energy_th1_mask            (0x0003F000)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_energy_th2_mask            (0x00000FC0)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_energy_th3_mask            (0x0000003F)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_prediff_th(data)           (0x3F000000&((data)<<24))
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_nextdiff_th(data)          (0x00FC0000&((data)<<18))
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_energy_th1(data)           (0x0003F000&((data)<<12))
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_energy_th2(data)           (0x00000FC0&((data)<<6))
#define  DI_IM_DI_HMC_PAN_DUMMY_1_hmc_half_mv_correct_energy_th3(data)           (0x0000003F&(data))
#define  DI_IM_DI_HMC_PAN_DUMMY_1_get_hmc_half_mv_correct_prediff_th(data)       ((0x3F000000&(data))>>24)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_get_hmc_half_mv_correct_nextdiff_th(data)      ((0x00FC0000&(data))>>18)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_get_hmc_half_mv_correct_energy_th1(data)       ((0x0003F000&(data))>>12)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_get_hmc_half_mv_correct_energy_th2(data)       ((0x00000FC0&(data))>>6)
#define  DI_IM_DI_HMC_PAN_DUMMY_1_get_hmc_half_mv_correct_energy_th3(data)       (0x0000003F&(data))

#define  DI_IM_DI_HMC_PAN_DUMMY_2                                               0x18024680
#define  DI_IM_DI_HMC_PAN_DUMMY_2_reg_addr                                       "0xB8024680"
#define  DI_IM_DI_HMC_PAN_DUMMY_2_reg                                            0xB8024680
#define  DI_IM_DI_HMC_PAN_DUMMY_2_inst_addr                                      "0x012E"
#define  set_DI_IM_DI_HMC_PAN_DUMMY_2_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_DUMMY_2_reg)=data)
#define  get_DI_IM_DI_HMC_PAN_DUMMY_2_reg                                        (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_DUMMY_2_reg))
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_pre_th_shift          (27)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_pre_gain_shift        (21)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_nxt_th_shift          (16)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_nxt_gain_shift        (10)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_notteeth_recover_hline_th_shift    (2)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_pre_th_mask           (0xF8000000)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_pre_gain_mask         (0x07E00000)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_nxt_th_mask           (0x001F0000)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_nxt_gain_mask         (0x0000FC00)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_notteeth_recover_hline_th_mask     (0x000003FC)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_pre_th(data)          (0xF8000000&((data)<<27))
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_pre_gain(data)        (0x07E00000&((data)<<21))
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_nxt_th(data)          (0x001F0000&((data)<<16))
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_energy_check_nxt_gain(data)        (0x0000FC00&((data)<<10))
#define  DI_IM_DI_HMC_PAN_DUMMY_2_hmc_half_mv_notteeth_recover_hline_th(data)    (0x000003FC&((data)<<2))
#define  DI_IM_DI_HMC_PAN_DUMMY_2_get_hmc_half_mv_energy_check_pre_th(data)      ((0xF8000000&(data))>>27)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_get_hmc_half_mv_energy_check_pre_gain(data)    ((0x07E00000&(data))>>21)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_get_hmc_half_mv_energy_check_nxt_th(data)      ((0x001F0000&(data))>>16)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_get_hmc_half_mv_energy_check_nxt_gain(data)    ((0x0000FC00&(data))>>10)
#define  DI_IM_DI_HMC_PAN_DUMMY_2_get_hmc_half_mv_notteeth_recover_hline_th(data) ((0x000003FC&(data))>>2)

#define  DI_IM_DI_HMC_PAN_DUMMY_3                                               0x18024684
#define  DI_IM_DI_HMC_PAN_DUMMY_3_reg_addr                                       "0xB8024684"
#define  DI_IM_DI_HMC_PAN_DUMMY_3_reg                                            0xB8024684
#define  DI_IM_DI_HMC_PAN_DUMMY_3_inst_addr                                      "0x012F"
#define  set_DI_IM_DI_HMC_PAN_DUMMY_3_reg(data)                                  (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_DUMMY_3_reg)=data)
#define  get_DI_IM_DI_HMC_PAN_DUMMY_3_reg                                        (*((volatile unsigned int*)DI_IM_DI_HMC_PAN_DUMMY_3_reg))
#define  DI_IM_DI_HMC_PAN_DUMMY_3_dummy_31_29_shift                              (29)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_en_shift                  (28)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_gain_en_shift             (27)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_gain_factor_shift         (23)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_gain_shift                (17)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_half_mv_all_teeth_check_th_shift           (11)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_half_mv_correct_energy_bias_shift          (8)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_half_mv_notteeth_recover_dline_th_shift    (0)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_dummy_31_29_mask                               (0xE0000000)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_en_mask                   (0x10000000)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_gain_en_mask              (0x08000000)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_gain_factor_mask          (0x07800000)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_gain_mask                 (0x007E0000)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_half_mv_all_teeth_check_th_mask            (0x0001F800)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_half_mv_correct_energy_bias_mask           (0x00000700)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_half_mv_notteeth_recover_dline_th_mask     (0x000000FF)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_dummy_31_29(data)                              (0xE0000000&((data)<<29))
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_en(data)                  (0x10000000&((data)<<28))
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_gain_en(data)             (0x08000000&((data)<<27))
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_gain_factor(data)         (0x07800000&((data)<<23))
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_blending_with_ma_gain(data)                (0x007E0000&((data)<<17))
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_half_mv_all_teeth_check_th(data)           (0x0001F800&((data)<<11))
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_half_mv_correct_energy_bias(data)          (0x00000700&((data)<<8))
#define  DI_IM_DI_HMC_PAN_DUMMY_3_hmc_half_mv_notteeth_recover_dline_th(data)    (0x000000FF&(data))
#define  DI_IM_DI_HMC_PAN_DUMMY_3_get_dummy_31_29(data)                          ((0xE0000000&(data))>>29)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_get_hmc_blending_with_ma_en(data)              ((0x10000000&(data))>>28)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_get_hmc_blending_with_ma_gain_en(data)         ((0x08000000&(data))>>27)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_get_hmc_blending_with_ma_gain_factor(data)     ((0x07800000&(data))>>23)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_get_hmc_blending_with_ma_gain(data)            ((0x007E0000&(data))>>17)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_get_hmc_half_mv_all_teeth_check_th(data)       ((0x0001F800&(data))>>11)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_get_hmc_half_mv_correct_energy_bias(data)      ((0x00000700&(data))>>8)
#define  DI_IM_DI_HMC_PAN_DUMMY_3_get_hmc_half_mv_notteeth_recover_dline_th(data) (0x000000FF&(data))

#define  DI_RTNR_MA_SNR_CONTROL                                                 0x18024688
#define  DI_RTNR_MA_SNR_CONTROL_reg_addr                                         "0xB8024688"
#define  DI_RTNR_MA_SNR_CONTROL_reg                                              0xB8024688
#define  DI_RTNR_MA_SNR_CONTROL_inst_addr                                        "0x0130"
#define  set_DI_RTNR_MA_SNR_CONTROL_reg(data)                                    (*((volatile unsigned int*)DI_RTNR_MA_SNR_CONTROL_reg)=data)
#define  get_DI_RTNR_MA_SNR_CONTROL_reg                                          (*((volatile unsigned int*)DI_RTNR_MA_SNR_CONTROL_reg))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor5_shift               (24)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor4_shift               (20)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor3_shift               (16)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor2_shift               (12)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor1_shift               (8)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_isnr_debug_mode_selection_shift          (6)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_isnr_debug_mode_en_shift                 (5)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_debug_mode_selection_shift           (3)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_debug_mode_en_shift                  (2)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_mask_shift                           (1)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_en_shift                             (0)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor5_mask                (0x0F000000)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor4_mask                (0x00F00000)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor3_mask                (0x000F0000)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor2_mask                (0x0000F000)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor1_mask                (0x00000F00)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_isnr_debug_mode_selection_mask           (0x000000C0)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_isnr_debug_mode_en_mask                  (0x00000020)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_debug_mode_selection_mask            (0x00000018)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_debug_mode_en_mask                   (0x00000004)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_mask_mask                            (0x00000002)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_en_mask                              (0x00000001)
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor5(data)               (0x0F000000&((data)<<24))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor4(data)               (0x00F00000&((data)<<20))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor3(data)               (0x000F0000&((data)<<16))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor2(data)               (0x0000F000&((data)<<12))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_blending_factor1(data)               (0x00000F00&((data)<<8))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_isnr_debug_mode_selection(data)          (0x000000C0&((data)<<6))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_isnr_debug_mode_en(data)                 (0x00000020&((data)<<5))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_debug_mode_selection(data)           (0x00000018&((data)<<3))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_debug_mode_en(data)                  (0x00000004&((data)<<2))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_mask(data)                           (0x00000002&((data)<<1))
#define  DI_RTNR_MA_SNR_CONTROL_rtnr_ma_snr_en(data)                             (0x00000001&(data))
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_snr_blending_factor5(data)           ((0x0F000000&(data))>>24)
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_snr_blending_factor4(data)           ((0x00F00000&(data))>>20)
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_snr_blending_factor3(data)           ((0x000F0000&(data))>>16)
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_snr_blending_factor2(data)           ((0x0000F000&(data))>>12)
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_snr_blending_factor1(data)           ((0x00000F00&(data))>>8)
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_isnr_debug_mode_selection(data)      ((0x000000C0&(data))>>6)
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_isnr_debug_mode_en(data)             ((0x00000020&(data))>>5)
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_snr_debug_mode_selection(data)       ((0x00000018&(data))>>3)
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_snr_debug_mode_en(data)              ((0x00000004&(data))>>2)
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_snr_mask(data)                       ((0x00000002&(data))>>1)
#define  DI_RTNR_MA_SNR_CONTROL_get_rtnr_ma_snr_en(data)                         (0x00000001&(data))

#define  DI_RTNR_MA_SNR_MOTION_TH_LOW                                           0x1802468C
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_reg_addr                                   "0xB802468C"
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_reg                                        0xB802468C
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_inst_addr                                  "0x0131"
#define  set_DI_RTNR_MA_SNR_MOTION_TH_LOW_reg(data)                              (*((volatile unsigned int*)DI_RTNR_MA_SNR_MOTION_TH_LOW_reg)=data)
#define  get_DI_RTNR_MA_SNR_MOTION_TH_LOW_reg                                    (*((volatile unsigned int*)DI_RTNR_MA_SNR_MOTION_TH_LOW_reg))
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th4_low_shift           (24)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th3_low_shift           (16)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th2_low_shift           (8)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th1_low_shift           (0)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th4_low_mask            (0xFF000000)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th3_low_mask            (0x00FF0000)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th2_low_mask            (0x0000FF00)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th1_low_mask            (0x000000FF)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th4_low(data)           (0xFF000000&((data)<<24))
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th3_low(data)           (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th2_low(data)           (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_rtnr_ma_snr_motion_th1_low(data)           (0x000000FF&(data))
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_get_rtnr_ma_snr_motion_th4_low(data)       ((0xFF000000&(data))>>24)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_get_rtnr_ma_snr_motion_th3_low(data)       ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_get_rtnr_ma_snr_motion_th2_low(data)       ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_SNR_MOTION_TH_LOW_get_rtnr_ma_snr_motion_th1_low(data)       (0x000000FF&(data))

#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH                                          0x18024690
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_reg_addr                                  "0xB8024690"
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_reg                                       0xB8024690
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_inst_addr                                 "0x0132"
#define  set_DI_RTNR_MA_SNR_MOTION_TH_HIGH_reg(data)                             (*((volatile unsigned int*)DI_RTNR_MA_SNR_MOTION_TH_HIGH_reg)=data)
#define  get_DI_RTNR_MA_SNR_MOTION_TH_HIGH_reg                                   (*((volatile unsigned int*)DI_RTNR_MA_SNR_MOTION_TH_HIGH_reg))
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th4_high_shift         (24)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th3_high_shift         (16)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th2_high_shift         (8)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th1_high_shift         (0)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th4_high_mask          (0xFF000000)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th3_high_mask          (0x00FF0000)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th2_high_mask          (0x0000FF00)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th1_high_mask          (0x000000FF)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th4_high(data)         (0xFF000000&((data)<<24))
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th3_high(data)         (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th2_high(data)         (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_rtnr_ma_snr_motion_th1_high(data)         (0x000000FF&(data))
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_get_rtnr_ma_snr_motion_th4_high(data)     ((0xFF000000&(data))>>24)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_get_rtnr_ma_snr_motion_th3_high(data)     ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_get_rtnr_ma_snr_motion_th2_high(data)     ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_SNR_MOTION_TH_HIGH_get_rtnr_ma_snr_motion_th1_high(data)     (0x000000FF&(data))

#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH                                          0x18024694
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_reg_addr                                  "0xB8024694"
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_reg                                       0xB8024694
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_inst_addr                                 "0x0133"
#define  set_DI_RTNR_MA_SNR_MOTION_EDGE_TH_reg(data)                             (*((volatile unsigned int*)DI_RTNR_MA_SNR_MOTION_EDGE_TH_reg)=data)
#define  get_DI_RTNR_MA_SNR_MOTION_EDGE_TH_reg                                   (*((volatile unsigned int*)DI_RTNR_MA_SNR_MOTION_EDGE_TH_reg))
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_rtnr_ma_snr_edge_th_high_shift            (8)
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_rtnr_ma_snr_edge_th_low_shift             (0)
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_rtnr_ma_snr_edge_th_high_mask             (0x0000FF00)
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_rtnr_ma_snr_edge_th_low_mask              (0x000000FF)
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_rtnr_ma_snr_edge_th_high(data)            (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_rtnr_ma_snr_edge_th_low(data)             (0x000000FF&(data))
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_get_rtnr_ma_snr_edge_th_high(data)        ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_SNR_MOTION_EDGE_TH_get_rtnr_ma_snr_edge_th_low(data)         (0x000000FF&(data))

#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE                                         0x18024698
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_reg_addr                                 "0xB8024698"
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_reg                                      0xB8024698
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_inst_addr                                "0x0134"
#define  set_DI_RTNR_MA_SNR_MOTION_TH_SLOPE_reg(data)                            (*((volatile unsigned int*)DI_RTNR_MA_SNR_MOTION_TH_SLOPE_reg)=data)
#define  get_DI_RTNR_MA_SNR_MOTION_TH_SLOPE_reg                                  (*((volatile unsigned int*)DI_RTNR_MA_SNR_MOTION_TH_SLOPE_reg))
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope4_shift          (24)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope3_shift          (16)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope2_shift          (8)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope1_shift          (0)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope4_mask           (0xFF000000)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope3_mask           (0x00FF0000)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope2_mask           (0x0000FF00)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope1_mask           (0x000000FF)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope4(data)          (0xFF000000&((data)<<24))
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope3(data)          (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope2(data)          (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_rtnr_ma_snr_motion_slope1(data)          (0x000000FF&(data))
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_get_rtnr_ma_snr_motion_slope4(data)      ((0xFF000000&(data))>>24)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_get_rtnr_ma_snr_motion_slope3(data)      ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_get_rtnr_ma_snr_motion_slope2(data)      ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_SNR_MOTION_TH_SLOPE_get_rtnr_ma_snr_motion_slope1(data)      (0x000000FF&(data))

#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL                                        0x1802469C
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_reg_addr                                "0xB802469C"
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_reg                                     0xB802469C
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_inst_addr                               "0x0135"
#define  set_DI_RTNR_MA_SNR_STRENGTH_CONTROL_reg(data)                           (*((volatile unsigned int*)DI_RTNR_MA_SNR_STRENGTH_CONTROL_reg)=data)
#define  get_DI_RTNR_MA_SNR_STRENGTH_CONTROL_reg                                 (*((volatile unsigned int*)DI_RTNR_MA_SNR_STRENGTH_CONTROL_reg))
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_strength_shift              (24)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_output_clamp_shift          (16)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_edge_curve_slope_shift      (8)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_edge_curve_lo_th_shift      (0)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_strength_mask               (0x0F000000)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_output_clamp_mask           (0x00FF0000)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_edge_curve_slope_mask       (0x0000FF00)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_edge_curve_lo_th_mask       (0x000000FF)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_strength(data)              (0x0F000000&((data)<<24))
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_output_clamp(data)          (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_edge_curve_slope(data)      (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_rtnr_ma_snr_edge_curve_lo_th(data)      (0x000000FF&(data))
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_get_rtnr_ma_snr_strength(data)          ((0x0F000000&(data))>>24)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_get_rtnr_ma_snr_output_clamp(data)      ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_get_rtnr_ma_snr_edge_curve_slope(data)  ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_SNR_STRENGTH_CONTROL_get_rtnr_ma_snr_edge_curve_lo_th(data)  (0x000000FF&(data))

#define  DI_RTNR_OUTPUT_CLAMP                                                   0x18024800
#define  DI_RTNR_OUTPUT_CLAMP_reg_addr                                           "0xB8024800"
#define  DI_RTNR_OUTPUT_CLAMP_reg                                                0xB8024800
#define  DI_RTNR_OUTPUT_CLAMP_inst_addr                                          "0x0136"
#define  set_DI_RTNR_OUTPUT_CLAMP_reg(data)                                      (*((volatile unsigned int*)DI_RTNR_OUTPUT_CLAMP_reg)=data)
#define  get_DI_RTNR_OUTPUT_CLAMP_reg                                            (*((volatile unsigned int*)DI_RTNR_OUTPUT_CLAMP_reg))
#define  DI_RTNR_OUTPUT_CLAMP_rtnr_output_clamp_en_shift                         (16)
#define  DI_RTNR_OUTPUT_CLAMP_rtnr_output_clamp_chroma_shift                     (8)
#define  DI_RTNR_OUTPUT_CLAMP_rtnr_output_clamp_luma_shift                       (0)
#define  DI_RTNR_OUTPUT_CLAMP_rtnr_output_clamp_en_mask                          (0x00010000)
#define  DI_RTNR_OUTPUT_CLAMP_rtnr_output_clamp_chroma_mask                      (0x0000FF00)
#define  DI_RTNR_OUTPUT_CLAMP_rtnr_output_clamp_luma_mask                        (0x000000FF)
#define  DI_RTNR_OUTPUT_CLAMP_rtnr_output_clamp_en(data)                         (0x00010000&((data)<<16))
#define  DI_RTNR_OUTPUT_CLAMP_rtnr_output_clamp_chroma(data)                     (0x0000FF00&((data)<<8))
#define  DI_RTNR_OUTPUT_CLAMP_rtnr_output_clamp_luma(data)                       (0x000000FF&(data))
#define  DI_RTNR_OUTPUT_CLAMP_get_rtnr_output_clamp_en(data)                     ((0x00010000&(data))>>16)
#define  DI_RTNR_OUTPUT_CLAMP_get_rtnr_output_clamp_chroma(data)                 ((0x0000FF00&(data))>>8)
#define  DI_RTNR_OUTPUT_CLAMP_get_rtnr_output_clamp_luma(data)                   (0x000000FF&(data))

#define  DI_DI_SMD_WaterFlag_Ctr3                                               0x1802480C
#define  DI_DI_SMD_WaterFlag_Ctr3_reg_addr                                       "0xB802480C"
#define  DI_DI_SMD_WaterFlag_Ctr3_reg                                            0xB802480C
#define  DI_DI_SMD_WaterFlag_Ctr3_inst_addr                                      "0x0137"
#define  set_DI_DI_SMD_WaterFlag_Ctr3_reg(data)                                  (*((volatile unsigned int*)DI_DI_SMD_WaterFlag_Ctr3_reg)=data)
#define  get_DI_DI_SMD_WaterFlag_Ctr3_reg                                        (*((volatile unsigned int*)DI_DI_SMD_WaterFlag_Ctr3_reg))
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_elseintra_en_shift                         (31)
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_stillsad_th_shift                          (24)
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_fw_gmvy_shift                              (21)
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_stillsad_max_shift                         (16)
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_elseintra_en_mask                          (0x80000000)
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_stillsad_th_mask                           (0x1F000000)
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_fw_gmvy_mask                               (0x00E00000)
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_stillsad_max_mask                          (0x001F0000)
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_elseintra_en(data)                         (0x80000000&((data)<<31))
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_stillsad_th(data)                          (0x1F000000&((data)<<24))
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_fw_gmvy(data)                              (0x00E00000&((data)<<21))
#define  DI_DI_SMD_WaterFlag_Ctr3_smd_stillsad_max(data)                         (0x001F0000&((data)<<16))
#define  DI_DI_SMD_WaterFlag_Ctr3_get_smd_elseintra_en(data)                     ((0x80000000&(data))>>31)
#define  DI_DI_SMD_WaterFlag_Ctr3_get_smd_stillsad_th(data)                      ((0x1F000000&(data))>>24)
#define  DI_DI_SMD_WaterFlag_Ctr3_get_smd_fw_gmvy(data)                          ((0x00E00000&(data))>>21)
#define  DI_DI_SMD_WaterFlag_Ctr3_get_smd_stillsad_max(data)                     ((0x001F0000&(data))>>16)

#define  DI_DI_SMD_HardwarePan_Modify1                                          0x18024810
#define  DI_DI_SMD_HardwarePan_Modify1_reg_addr                                  "0xB8024810"
#define  DI_DI_SMD_HardwarePan_Modify1_reg                                       0xB8024810
#define  DI_DI_SMD_HardwarePan_Modify1_inst_addr                                 "0x0138"
#define  set_DI_DI_SMD_HardwarePan_Modify1_reg(data)                             (*((volatile unsigned int*)DI_DI_SMD_HardwarePan_Modify1_reg)=data)
#define  get_DI_DI_SMD_HardwarePan_Modify1_reg                                   (*((volatile unsigned int*)DI_DI_SMD_HardwarePan_Modify1_reg))
#define  DI_DI_SMD_HardwarePan_Modify1_smd_hardwarepan_firststep_shift           (31)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_streammv_gmv_diff_shift               (24)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_gmvb_sadmin_th_shift                  (20)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_fw_gmvx_shift                         (17)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_firmwarepan_sadmax_shift              (8)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_searchmvapply_ctr_shift               (0)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_hardwarepan_firststep_mask            (0x80000000)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_streammv_gmv_diff_mask                (0x1F000000)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_gmvb_sadmin_th_mask                   (0x00F00000)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_fw_gmvx_mask                          (0x000E0000)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_firmwarepan_sadmax_mask               (0x0001FF00)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_searchmvapply_ctr_mask                (0x000000FF)
#define  DI_DI_SMD_HardwarePan_Modify1_smd_hardwarepan_firststep(data)           (0x80000000&((data)<<31))
#define  DI_DI_SMD_HardwarePan_Modify1_smd_streammv_gmv_diff(data)               (0x1F000000&((data)<<24))
#define  DI_DI_SMD_HardwarePan_Modify1_smd_gmvb_sadmin_th(data)                  (0x00F00000&((data)<<20))
#define  DI_DI_SMD_HardwarePan_Modify1_smd_fw_gmvx(data)                         (0x000E0000&((data)<<17))
#define  DI_DI_SMD_HardwarePan_Modify1_smd_firmwarepan_sadmax(data)              (0x0001FF00&((data)<<8))
#define  DI_DI_SMD_HardwarePan_Modify1_smd_searchmvapply_ctr(data)               (0x000000FF&(data))
#define  DI_DI_SMD_HardwarePan_Modify1_get_smd_hardwarepan_firststep(data)       ((0x80000000&(data))>>31)
#define  DI_DI_SMD_HardwarePan_Modify1_get_smd_streammv_gmv_diff(data)           ((0x1F000000&(data))>>24)
#define  DI_DI_SMD_HardwarePan_Modify1_get_smd_gmvb_sadmin_th(data)              ((0x00F00000&(data))>>20)
#define  DI_DI_SMD_HardwarePan_Modify1_get_smd_fw_gmvx(data)                     ((0x000E0000&(data))>>17)
#define  DI_DI_SMD_HardwarePan_Modify1_get_smd_firmwarepan_sadmax(data)          ((0x0001FF00&(data))>>8)
#define  DI_DI_SMD_HardwarePan_Modify1_get_smd_searchmvapply_ctr(data)           (0x000000FF&(data))

#define  DI_DI_GST_Compensate                                                   0x1802481C
#define  DI_DI_GST_Compensate_reg_addr                                           "0xB802481C"
#define  DI_DI_GST_Compensate_reg                                                0xB802481C
#define  DI_DI_GST_Compensate_inst_addr                                          "0x0139"
#define  set_DI_DI_GST_Compensate_reg(data)                                      (*((volatile unsigned int*)DI_DI_GST_Compensate_reg)=data)
#define  get_DI_DI_GST_Compensate_reg                                            (*((volatile unsigned int*)DI_DI_GST_Compensate_reg))
#define  DI_DI_GST_Compensate_gst_subpixel_compensate_en_shift                   (31)
#define  DI_DI_GST_Compensate_gst_debug_subpixel_pan_shift                       (30)
#define  DI_DI_GST_Compensate_gst_subpixel_rlv2intra_en_shift                    (28)
#define  DI_DI_GST_Compensate_gst_integerpan_highpriority_shift                  (27)
#define  DI_DI_GST_Compensate_gst_pg_highpriority_shift                          (26)
#define  DI_DI_GST_Compensate_gst_compensate_fmv0_en_shift                       (25)
#define  DI_DI_GST_Compensate_gst_compensate_fmv1_en_shift                       (24)
#define  DI_DI_GST_Compensate_gst_compensate_fmv2_en_shift                       (23)
#define  DI_DI_GST_Compensate_gst_compensate_fmv3_en_shift                       (22)
#define  DI_DI_GST_Compensate_gst_compensate_fmv4_en_shift                       (21)
#define  DI_DI_GST_Compensate_gst_compensate_fmv5_en_shift                       (20)
#define  DI_DI_GST_Compensate_gst_compensate_fmv6_en_shift                       (19)
#define  DI_DI_GST_Compensate_gst_compensate_fmv7_en_shift                       (18)
#define  DI_DI_GST_Compensate_gst_compensate_fmv8_en_shift                       (17)
#define  DI_DI_GST_Compensate_gst_compensate_blending_en_shift                   (14)
#define  DI_DI_GST_Compensate_gst_blend_weight_shift                             (12)
#define  DI_DI_GST_Compensate_gst_subpixel_firmwarepan_shift                     (8)
#define  DI_DI_GST_Compensate_gst_subpixel_firmwarepan_fmv2_shift                (4)
#define  DI_DI_GST_Compensate_gst_subpixel_firmwarepan_fmv1_shift                (0)
#define  DI_DI_GST_Compensate_gst_subpixel_compensate_en_mask                    (0x80000000)
#define  DI_DI_GST_Compensate_gst_debug_subpixel_pan_mask                        (0x40000000)
#define  DI_DI_GST_Compensate_gst_subpixel_rlv2intra_en_mask                     (0x10000000)
#define  DI_DI_GST_Compensate_gst_integerpan_highpriority_mask                   (0x08000000)
#define  DI_DI_GST_Compensate_gst_pg_highpriority_mask                           (0x04000000)
#define  DI_DI_GST_Compensate_gst_compensate_fmv0_en_mask                        (0x02000000)
#define  DI_DI_GST_Compensate_gst_compensate_fmv1_en_mask                        (0x01000000)
#define  DI_DI_GST_Compensate_gst_compensate_fmv2_en_mask                        (0x00800000)
#define  DI_DI_GST_Compensate_gst_compensate_fmv3_en_mask                        (0x00400000)
#define  DI_DI_GST_Compensate_gst_compensate_fmv4_en_mask                        (0x00200000)
#define  DI_DI_GST_Compensate_gst_compensate_fmv5_en_mask                        (0x00100000)
#define  DI_DI_GST_Compensate_gst_compensate_fmv6_en_mask                        (0x00080000)
#define  DI_DI_GST_Compensate_gst_compensate_fmv7_en_mask                        (0x00040000)
#define  DI_DI_GST_Compensate_gst_compensate_fmv8_en_mask                        (0x00020000)
#define  DI_DI_GST_Compensate_gst_compensate_blending_en_mask                    (0x00004000)
#define  DI_DI_GST_Compensate_gst_blend_weight_mask                              (0x00003000)
#define  DI_DI_GST_Compensate_gst_subpixel_firmwarepan_mask                      (0x00000100)
#define  DI_DI_GST_Compensate_gst_subpixel_firmwarepan_fmv2_mask                 (0x000000F0)
#define  DI_DI_GST_Compensate_gst_subpixel_firmwarepan_fmv1_mask                 (0x0000000F)
#define  DI_DI_GST_Compensate_gst_subpixel_compensate_en(data)                   (0x80000000&((data)<<31))
#define  DI_DI_GST_Compensate_gst_debug_subpixel_pan(data)                       (0x40000000&((data)<<30))
#define  DI_DI_GST_Compensate_gst_subpixel_rlv2intra_en(data)                    (0x10000000&((data)<<28))
#define  DI_DI_GST_Compensate_gst_integerpan_highpriority(data)                  (0x08000000&((data)<<27))
#define  DI_DI_GST_Compensate_gst_pg_highpriority(data)                          (0x04000000&((data)<<26))
#define  DI_DI_GST_Compensate_gst_compensate_fmv0_en(data)                       (0x02000000&((data)<<25))
#define  DI_DI_GST_Compensate_gst_compensate_fmv1_en(data)                       (0x01000000&((data)<<24))
#define  DI_DI_GST_Compensate_gst_compensate_fmv2_en(data)                       (0x00800000&((data)<<23))
#define  DI_DI_GST_Compensate_gst_compensate_fmv3_en(data)                       (0x00400000&((data)<<22))
#define  DI_DI_GST_Compensate_gst_compensate_fmv4_en(data)                       (0x00200000&((data)<<21))
#define  DI_DI_GST_Compensate_gst_compensate_fmv5_en(data)                       (0x00100000&((data)<<20))
#define  DI_DI_GST_Compensate_gst_compensate_fmv6_en(data)                       (0x00080000&((data)<<19))
#define  DI_DI_GST_Compensate_gst_compensate_fmv7_en(data)                       (0x00040000&((data)<<18))
#define  DI_DI_GST_Compensate_gst_compensate_fmv8_en(data)                       (0x00020000&((data)<<17))
#define  DI_DI_GST_Compensate_gst_compensate_blending_en(data)                   (0x00004000&((data)<<14))
#define  DI_DI_GST_Compensate_gst_blend_weight(data)                             (0x00003000&((data)<<12))
#define  DI_DI_GST_Compensate_gst_subpixel_firmwarepan(data)                     (0x00000100&((data)<<8))
#define  DI_DI_GST_Compensate_gst_subpixel_firmwarepan_fmv2(data)                (0x000000F0&((data)<<4))
#define  DI_DI_GST_Compensate_gst_subpixel_firmwarepan_fmv1(data)                (0x0000000F&(data))
#define  DI_DI_GST_Compensate_get_gst_subpixel_compensate_en(data)               ((0x80000000&(data))>>31)
#define  DI_DI_GST_Compensate_get_gst_debug_subpixel_pan(data)                   ((0x40000000&(data))>>30)
#define  DI_DI_GST_Compensate_get_gst_subpixel_rlv2intra_en(data)                ((0x10000000&(data))>>28)
#define  DI_DI_GST_Compensate_get_gst_integerpan_highpriority(data)              ((0x08000000&(data))>>27)
#define  DI_DI_GST_Compensate_get_gst_pg_highpriority(data)                      ((0x04000000&(data))>>26)
#define  DI_DI_GST_Compensate_get_gst_compensate_fmv0_en(data)                   ((0x02000000&(data))>>25)
#define  DI_DI_GST_Compensate_get_gst_compensate_fmv1_en(data)                   ((0x01000000&(data))>>24)
#define  DI_DI_GST_Compensate_get_gst_compensate_fmv2_en(data)                   ((0x00800000&(data))>>23)
#define  DI_DI_GST_Compensate_get_gst_compensate_fmv3_en(data)                   ((0x00400000&(data))>>22)
#define  DI_DI_GST_Compensate_get_gst_compensate_fmv4_en(data)                   ((0x00200000&(data))>>21)
#define  DI_DI_GST_Compensate_get_gst_compensate_fmv5_en(data)                   ((0x00100000&(data))>>20)
#define  DI_DI_GST_Compensate_get_gst_compensate_fmv6_en(data)                   ((0x00080000&(data))>>19)
#define  DI_DI_GST_Compensate_get_gst_compensate_fmv7_en(data)                   ((0x00040000&(data))>>18)
#define  DI_DI_GST_Compensate_get_gst_compensate_fmv8_en(data)                   ((0x00020000&(data))>>17)
#define  DI_DI_GST_Compensate_get_gst_compensate_blending_en(data)               ((0x00004000&(data))>>14)
#define  DI_DI_GST_Compensate_get_gst_blend_weight(data)                         ((0x00003000&(data))>>12)
#define  DI_DI_GST_Compensate_get_gst_subpixel_firmwarepan(data)                 ((0x00000100&(data))>>8)
#define  DI_DI_GST_Compensate_get_gst_subpixel_firmwarepan_fmv2(data)            ((0x000000F0&(data))>>4)
#define  DI_DI_GST_Compensate_get_gst_subpixel_firmwarepan_fmv1(data)            (0x0000000F&(data))

#define  DI_DI_GST_FMV_Pan_Coeff1                                               0x18024830
#define  DI_DI_GST_FMV_Pan_Coeff1_reg_addr                                       "0xB8024830"
#define  DI_DI_GST_FMV_Pan_Coeff1_reg                                            0xB8024830
#define  DI_DI_GST_FMV_Pan_Coeff1_inst_addr                                      "0x013A"
#define  set_DI_DI_GST_FMV_Pan_Coeff1_reg(data)                                  (*((volatile unsigned int*)DI_DI_GST_FMV_Pan_Coeff1_reg)=data)
#define  get_DI_DI_GST_FMV_Pan_Coeff1_reg                                        (*((volatile unsigned int*)DI_DI_GST_FMV_Pan_Coeff1_reg))
#define  DI_DI_GST_FMV_Pan_Coeff1_gst_subpixel_firmwarepan_sadmin_shift          (16)
#define  DI_DI_GST_FMV_Pan_Coeff1_gst_subpixel_firmwarepan_sadmax_shift          (0)
#define  DI_DI_GST_FMV_Pan_Coeff1_gst_subpixel_firmwarepan_sadmin_mask           (0x003F0000)
#define  DI_DI_GST_FMV_Pan_Coeff1_gst_subpixel_firmwarepan_sadmax_mask           (0x000001FF)
#define  DI_DI_GST_FMV_Pan_Coeff1_gst_subpixel_firmwarepan_sadmin(data)          (0x003F0000&((data)<<16))
#define  DI_DI_GST_FMV_Pan_Coeff1_gst_subpixel_firmwarepan_sadmax(data)          (0x000001FF&(data))
#define  DI_DI_GST_FMV_Pan_Coeff1_get_gst_subpixel_firmwarepan_sadmin(data)      ((0x003F0000&(data))>>16)
#define  DI_DI_GST_FMV_Pan_Coeff1_get_gst_subpixel_firmwarepan_sadmax(data)      (0x000001FF&(data))

#define  DI_DI_MA_WeaveMode_check                                               0x18024840
#define  DI_DI_MA_WeaveMode_check_reg_addr                                       "0xB8024840"
#define  DI_DI_MA_WeaveMode_check_reg                                            0xB8024840
#define  DI_DI_MA_WeaveMode_check_inst_addr                                      "0x013B"
#define  set_DI_DI_MA_WeaveMode_check_reg(data)                                  (*((volatile unsigned int*)DI_DI_MA_WeaveMode_check_reg)=data)
#define  get_DI_DI_MA_WeaveMode_check_reg                                        (*((volatile unsigned int*)DI_DI_MA_WeaveMode_check_reg))
#define  DI_DI_MA_WeaveMode_check_ma_weavemode_check_en_shift                    (31)
#define  DI_DI_MA_WeaveMode_check_ma_weavemode_check_gain_shift                  (8)
#define  DI_DI_MA_WeaveMode_check_ma_weavemode_check_th_shift                    (0)
#define  DI_DI_MA_WeaveMode_check_ma_weavemode_check_en_mask                     (0x80000000)
#define  DI_DI_MA_WeaveMode_check_ma_weavemode_check_gain_mask                   (0x00000F00)
#define  DI_DI_MA_WeaveMode_check_ma_weavemode_check_th_mask                     (0x000000FF)
#define  DI_DI_MA_WeaveMode_check_ma_weavemode_check_en(data)                    (0x80000000&((data)<<31))
#define  DI_DI_MA_WeaveMode_check_ma_weavemode_check_gain(data)                  (0x00000F00&((data)<<8))
#define  DI_DI_MA_WeaveMode_check_ma_weavemode_check_th(data)                    (0x000000FF&(data))
#define  DI_DI_MA_WeaveMode_check_get_ma_weavemode_check_en(data)                ((0x80000000&(data))>>31)
#define  DI_DI_MA_WeaveMode_check_get_ma_weavemode_check_gain(data)              ((0x00000F00&(data))>>8)
#define  DI_DI_MA_WeaveMode_check_get_ma_weavemode_check_th(data)                (0x000000FF&(data))

#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1                                        0x18024844
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_reg_addr                                "0xB8024844"
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_reg                                     0xB8024844
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_inst_addr                               "0x013C"
#define  set_DI_IM_DI_RTNR_HMCNR_STATISTIC_1_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_1_reg)=data)
#define  get_DI_IM_DI_RTNR_HMCNR_STATISTIC_1_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_1_reg))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_hmcnr_r5_sum_shift                      (16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_hmcnr_r4_sum_shift                      (0)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_hmcnr_r5_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_hmcnr_r4_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_hmcnr_r5_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_hmcnr_r4_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_get_hmcnr_r5_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_1_get_hmcnr_r4_sum(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2                                        0x18024848
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_reg_addr                                "0xB8024848"
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_reg                                     0xB8024848
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_inst_addr                               "0x013D"
#define  set_DI_IM_DI_RTNR_HMCNR_STATISTIC_2_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_2_reg)=data)
#define  get_DI_IM_DI_RTNR_HMCNR_STATISTIC_2_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_2_reg))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_hmcnr_r3_sum_shift                      (16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_hmcnr_r2_sum_shift                      (0)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_hmcnr_r3_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_hmcnr_r2_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_hmcnr_r3_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_hmcnr_r2_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_get_hmcnr_r3_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_2_get_hmcnr_r2_sum(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3                                        0x1802484C
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_reg_addr                                "0xB802484C"
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_reg                                     0xB802484C
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_inst_addr                               "0x013E"
#define  set_DI_IM_DI_RTNR_HMCNR_STATISTIC_3_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_3_reg)=data)
#define  get_DI_IM_DI_RTNR_HMCNR_STATISTIC_3_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_3_reg))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_hmcnr_r1_sum_shift                      (16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_hmcnr_c0_sum_shift                      (0)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_hmcnr_r1_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_hmcnr_c0_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_hmcnr_r1_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_hmcnr_c0_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_get_hmcnr_r1_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_3_get_hmcnr_c0_sum(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4                                        0x18024850
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_reg_addr                                "0xB8024850"
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_reg                                     0xB8024850
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_inst_addr                               "0x013F"
#define  set_DI_IM_DI_RTNR_HMCNR_STATISTIC_4_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_4_reg)=data)
#define  get_DI_IM_DI_RTNR_HMCNR_STATISTIC_4_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_4_reg))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_hmcnr_l1_sum_shift                      (16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_hmcnr_l2_sum_shift                      (0)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_hmcnr_l1_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_hmcnr_l2_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_hmcnr_l1_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_hmcnr_l2_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_get_hmcnr_l1_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_4_get_hmcnr_l2_sum(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5                                        0x18024854
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_reg_addr                                "0xB8024854"
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_reg                                     0xB8024854
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_inst_addr                               "0x0140"
#define  set_DI_IM_DI_RTNR_HMCNR_STATISTIC_5_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_5_reg)=data)
#define  get_DI_IM_DI_RTNR_HMCNR_STATISTIC_5_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_5_reg))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_hmcnr_l3_sum_shift                      (16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_hmcnr_l4_sum_shift                      (0)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_hmcnr_l3_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_hmcnr_l4_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_hmcnr_l3_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_hmcnr_l4_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_get_hmcnr_l3_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_5_get_hmcnr_l4_sum(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6                                        0x18024858
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_reg_addr                                "0xB8024858"
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_reg                                     0xB8024858
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_inst_addr                               "0x0141"
#define  set_DI_IM_DI_RTNR_HMCNR_STATISTIC_6_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_6_reg)=data)
#define  get_DI_IM_DI_RTNR_HMCNR_STATISTIC_6_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_HMCNR_STATISTIC_6_reg))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_hmcnr_l5_sum_shift                      (16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_dummy_15_0_shift                        (0)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_hmcnr_l5_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_dummy_15_0_mask                         (0x0000FFFF)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_hmcnr_l5_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_dummy_15_0(data)                        (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_get_hmcnr_l5_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_HMCNR_STATISTIC_6_get_dummy_15_0(data)                    (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2                                          0x1802485C
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_reg_addr                                  "0xB802485C"
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_reg                                       0xB802485C
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_inst_addr                                 "0x0142"
#define  set_DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_reg                                   (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_reg))
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_cp_temporal_mad_y_th3_shift               (16)
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_cp_temporal_mad_c_th3_shift               (0)
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_cp_temporal_mad_y_th3_mask                (0x07FF0000)
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_cp_temporal_mad_c_th3_mask                (0x000007FF)
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_cp_temporal_mad_y_th3(data)               (0x07FF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_cp_temporal_mad_c_th3(data)               (0x000007FF&(data))
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_get_cp_temporal_mad_y_th3(data)           ((0x07FF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MAD_Y_TH2_C_TH2_get_cp_temporal_mad_c_th3(data)           (0x000007FF&(data))

#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_2                                          0x18024860
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_2_reg_addr                                  "0xB8024860"
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_2_reg                                       0xB8024860
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_2_inst_addr                                 "0x0143"
#define  set_DI_IM_DI_RTNR_MAD_Y_COUNTER_2_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_Y_COUNTER_2_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_Y_COUNTER_2_reg                                   (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_Y_COUNTER_2_reg))
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_2_cp_temporal_mad_countery2_shift           (0)
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_2_cp_temporal_mad_countery2_mask            (0x001FFFFF)
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_2_cp_temporal_mad_countery2(data)           (0x001FFFFF&(data))
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_2_get_cp_temporal_mad_countery2(data)       (0x001FFFFF&(data))

#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_3                                          0x18024864
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_3_reg_addr                                  "0xB8024864"
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_3_reg                                       0xB8024864
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_3_inst_addr                                 "0x0144"
#define  set_DI_IM_DI_RTNR_MAD_Y_COUNTER_3_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_Y_COUNTER_3_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_Y_COUNTER_3_reg                                   (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_Y_COUNTER_3_reg))
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_3_cp_temporal_mad_countery3_shift           (0)
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_3_cp_temporal_mad_countery3_mask            (0x001FFFFF)
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_3_cp_temporal_mad_countery3(data)           (0x001FFFFF&(data))
#define  DI_IM_DI_RTNR_MAD_Y_COUNTER_3_get_cp_temporal_mad_countery3(data)       (0x001FFFFF&(data))

#define  DI_IM_DI_RTNR_MAD_U_COUNTER_2                                          0x18024868
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_2_reg_addr                                  "0xB8024868"
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_2_reg                                       0xB8024868
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_2_inst_addr                                 "0x0145"
#define  set_DI_IM_DI_RTNR_MAD_U_COUNTER_2_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_U_COUNTER_2_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_U_COUNTER_2_reg                                   (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_U_COUNTER_2_reg))
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_2_cp_temporal_mad_counteru2_shift           (0)
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_2_cp_temporal_mad_counteru2_mask            (0x001FFFFF)
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_2_cp_temporal_mad_counteru2(data)           (0x001FFFFF&(data))
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_2_get_cp_temporal_mad_counteru2(data)       (0x001FFFFF&(data))

#define  DI_IM_DI_RTNR_MAD_U_COUNTER_3                                          0x1802486C
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_3_reg_addr                                  "0xB802486C"
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_3_reg                                       0xB802486C
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_3_inst_addr                                 "0x0146"
#define  set_DI_IM_DI_RTNR_MAD_U_COUNTER_3_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_U_COUNTER_3_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_U_COUNTER_3_reg                                   (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_U_COUNTER_3_reg))
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_3_cp_temporal_mad_counteru3_shift           (0)
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_3_cp_temporal_mad_counteru3_mask            (0x001FFFFF)
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_3_cp_temporal_mad_counteru3(data)           (0x001FFFFF&(data))
#define  DI_IM_DI_RTNR_MAD_U_COUNTER_3_get_cp_temporal_mad_counteru3(data)       (0x001FFFFF&(data))

#define  DI_IM_DI_RTNR_MAD_V_COUNTER_2                                          0x18024870
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_2_reg_addr                                  "0xB8024870"
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_2_reg                                       0xB8024870
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_2_inst_addr                                 "0x0147"
#define  set_DI_IM_DI_RTNR_MAD_V_COUNTER_2_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_V_COUNTER_2_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_V_COUNTER_2_reg                                   (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_V_COUNTER_2_reg))
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_2_cp_temporal_mad_counterv2_shift           (0)
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_2_cp_temporal_mad_counterv2_mask            (0x001FFFFF)
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_2_cp_temporal_mad_counterv2(data)           (0x001FFFFF&(data))
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_2_get_cp_temporal_mad_counterv2(data)       (0x001FFFFF&(data))

#define  DI_IM_DI_RTNR_MAD_V_COUNTER_3                                          0x18024874
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_3_reg_addr                                  "0xB8024874"
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_3_reg                                       0xB8024874
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_3_inst_addr                                 "0x0148"
#define  set_DI_IM_DI_RTNR_MAD_V_COUNTER_3_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_V_COUNTER_3_reg)=data)
#define  get_DI_IM_DI_RTNR_MAD_V_COUNTER_3_reg                                   (*((volatile unsigned int*)DI_IM_DI_RTNR_MAD_V_COUNTER_3_reg))
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_3_cp_temporal_mad_counterv3_shift           (0)
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_3_cp_temporal_mad_counterv3_mask            (0x001FFFFF)
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_3_cp_temporal_mad_counterv3(data)           (0x001FFFFF&(data))
#define  DI_IM_DI_RTNR_MAD_V_COUNTER_3_get_cp_temporal_mad_counterv3(data)       (0x001FFFFF&(data))

#define  DI_IM_DI_MA_VHF_CTRL                                                   0x180248D4
#define  DI_IM_DI_MA_VHF_CTRL_reg_addr                                           "0xB80248D4"
#define  DI_IM_DI_MA_VHF_CTRL_reg                                                0xB80248D4
#define  DI_IM_DI_MA_VHF_CTRL_inst_addr                                          "0x0149"
#define  set_DI_IM_DI_MA_VHF_CTRL_reg(data)                                      (*((volatile unsigned int*)DI_IM_DI_MA_VHF_CTRL_reg)=data)
#define  get_DI_IM_DI_MA_VHF_CTRL_reg                                            (*((volatile unsigned int*)DI_IM_DI_MA_VHF_CTRL_reg))
#define  DI_IM_DI_MA_VHF_CTRL_vhf_energy_th0_shift                               (24)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th4_shift                            (20)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th3_shift                            (16)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th2_shift                            (12)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th1_shift                            (8)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_en_shift                                       (7)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_check_mode_shift                               (5)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_teeth_depth_th_shift                           (0)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_energy_th0_mask                                (0xFF000000)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th4_mask                             (0x00F00000)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th3_mask                             (0x000F0000)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th2_mask                             (0x0000F000)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th1_mask                             (0x00000F00)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_en_mask                                        (0x00000080)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_check_mode_mask                                (0x00000060)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_teeth_depth_th_mask                            (0x0000001F)
#define  DI_IM_DI_MA_VHF_CTRL_vhf_energy_th0(data)                               (0xFF000000&((data)<<24))
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th4(data)                            (0x00F00000&((data)<<20))
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th3(data)                            (0x000F0000&((data)<<16))
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th2(data)                            (0x0000F000&((data)<<12))
#define  DI_IM_DI_MA_VHF_CTRL_vhf_fm_offset_th1(data)                            (0x00000F00&((data)<<8))
#define  DI_IM_DI_MA_VHF_CTRL_vhf_en(data)                                       (0x00000080&((data)<<7))
#define  DI_IM_DI_MA_VHF_CTRL_vhf_check_mode(data)                               (0x00000060&((data)<<5))
#define  DI_IM_DI_MA_VHF_CTRL_vhf_teeth_depth_th(data)                           (0x0000001F&(data))
#define  DI_IM_DI_MA_VHF_CTRL_get_vhf_energy_th0(data)                           ((0xFF000000&(data))>>24)
#define  DI_IM_DI_MA_VHF_CTRL_get_vhf_fm_offset_th4(data)                        ((0x00F00000&(data))>>20)
#define  DI_IM_DI_MA_VHF_CTRL_get_vhf_fm_offset_th3(data)                        ((0x000F0000&(data))>>16)
#define  DI_IM_DI_MA_VHF_CTRL_get_vhf_fm_offset_th2(data)                        ((0x0000F000&(data))>>12)
#define  DI_IM_DI_MA_VHF_CTRL_get_vhf_fm_offset_th1(data)                        ((0x00000F00&(data))>>8)
#define  DI_IM_DI_MA_VHF_CTRL_get_vhf_en(data)                                   ((0x00000080&(data))>>7)
#define  DI_IM_DI_MA_VHF_CTRL_get_vhf_check_mode(data)                           ((0x00000060&(data))>>5)
#define  DI_IM_DI_MA_VHF_CTRL_get_vhf_teeth_depth_th(data)                       (0x0000001F&(data))

#define  DI_IM_DI_MA_VHF_CTRL2                                                  0x180248D8
#define  DI_IM_DI_MA_VHF_CTRL2_reg_addr                                          "0xB80248D8"
#define  DI_IM_DI_MA_VHF_CTRL2_reg                                               0xB80248D8
#define  DI_IM_DI_MA_VHF_CTRL2_inst_addr                                         "0x014A"
#define  set_DI_IM_DI_MA_VHF_CTRL2_reg(data)                                     (*((volatile unsigned int*)DI_IM_DI_MA_VHF_CTRL2_reg)=data)
#define  get_DI_IM_DI_MA_VHF_CTRL2_reg                                           (*((volatile unsigned int*)DI_IM_DI_MA_VHF_CTRL2_reg))
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th4_shift                              (24)
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th3_shift                              (16)
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th2_shift                              (8)
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th1_shift                              (0)
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th4_mask                               (0xFF000000)
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th3_mask                               (0x00FF0000)
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th2_mask                               (0x0000FF00)
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th1_mask                               (0x000000FF)
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th4(data)                              (0xFF000000&((data)<<24))
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th3(data)                              (0x00FF0000&((data)<<16))
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th2(data)                              (0x0000FF00&((data)<<8))
#define  DI_IM_DI_MA_VHF_CTRL2_vhf_energy_th1(data)                              (0x000000FF&(data))
#define  DI_IM_DI_MA_VHF_CTRL2_get_vhf_energy_th4(data)                          ((0xFF000000&(data))>>24)
#define  DI_IM_DI_MA_VHF_CTRL2_get_vhf_energy_th3(data)                          ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_MA_VHF_CTRL2_get_vhf_energy_th2(data)                          ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_MA_VHF_CTRL2_get_vhf_energy_th1(data)                          (0x000000FF&(data))

#define  DI_IM_DI_MA_VHF_CTRL3                                                  0x180248DC
#define  DI_IM_DI_MA_VHF_CTRL3_reg_addr                                          "0xB80248DC"
#define  DI_IM_DI_MA_VHF_CTRL3_reg                                               0xB80248DC
#define  DI_IM_DI_MA_VHF_CTRL3_inst_addr                                         "0x014B"
#define  set_DI_IM_DI_MA_VHF_CTRL3_reg(data)                                     (*((volatile unsigned int*)DI_IM_DI_MA_VHF_CTRL3_reg)=data)
#define  get_DI_IM_DI_MA_VHF_CTRL3_reg                                           (*((volatile unsigned int*)DI_IM_DI_MA_VHF_CTRL3_reg))
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop4_shift                            (24)
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop3_shift                            (16)
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop2_shift                            (8)
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop1_shift                            (0)
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop4_mask                             (0xFF000000)
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop3_mask                             (0x00FF0000)
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop2_mask                             (0x0000FF00)
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop1_mask                             (0x000000FF)
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop4(data)                            (0xFF000000&((data)<<24))
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop3(data)                            (0x00FF0000&((data)<<16))
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop2(data)                            (0x0000FF00&((data)<<8))
#define  DI_IM_DI_MA_VHF_CTRL3_vhf_energy_slop1(data)                            (0x000000FF&(data))
#define  DI_IM_DI_MA_VHF_CTRL3_get_vhf_energy_slop4(data)                        ((0xFF000000&(data))>>24)
#define  DI_IM_DI_MA_VHF_CTRL3_get_vhf_energy_slop3(data)                        ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_MA_VHF_CTRL3_get_vhf_energy_slop2(data)                        ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_MA_VHF_CTRL3_get_vhf_energy_slop1(data)                        (0x000000FF&(data))

#define  DI_IM_DI_NINTRA_CONTROL                                                0x180248E0
#define  DI_IM_DI_NINTRA_CONTROL_reg_addr                                        "0xB80248E0"
#define  DI_IM_DI_NINTRA_CONTROL_reg                                             0xB80248E0
#define  DI_IM_DI_NINTRA_CONTROL_inst_addr                                       "0x014C"
#define  set_DI_IM_DI_NINTRA_CONTROL_reg(data)                                   (*((volatile unsigned int*)DI_IM_DI_NINTRA_CONTROL_reg)=data)
#define  get_DI_IM_DI_NINTRA_CONTROL_reg                                         (*((volatile unsigned int*)DI_IM_DI_NINTRA_CONTROL_reg))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_sr_minus_value_shift                     (30)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_ud_boundary_repeat_en_shift              (29)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_n_check2_control_disable_shift           (28)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_check2_y_diff_th_shift                   (20)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_lowpass_dir_count_th_shift               (16)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_output_lowpass_en_shift                  (15)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_dyn_dir_lowpass_en_shift                 (14)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_preline_dir_check2_en_shift              (13)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_preline_dir_check1_en_shift              (12)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_lowpass_dir_check_en_shift               (11)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_pre_dir_check_en_shift                   (10)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_min_second_dir_check2_en_shift           (9)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_min_second_dir_check_en_shift            (8)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_dynamic_cross_th_en_shift                (7)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_intersection_check_en_shift              (6)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_high_freq_detect_en_shift                (5)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_search_min_limit_en_shift                (4)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_vbound_detect_en_shift                   (3)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_ydiff_mode_shift                         (2)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_new_mode_en_shift                        (1)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_src_lpf_clamp_en_shift                   (0)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_sr_minus_value_mask                      (0x40000000)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_ud_boundary_repeat_en_mask               (0x20000000)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_n_check2_control_disable_mask            (0x10000000)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_check2_y_diff_th_mask                    (0x0FF00000)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_lowpass_dir_count_th_mask                (0x000F0000)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_output_lowpass_en_mask                   (0x00008000)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_dyn_dir_lowpass_en_mask                  (0x00004000)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_preline_dir_check2_en_mask               (0x00002000)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_preline_dir_check1_en_mask               (0x00001000)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_lowpass_dir_check_en_mask                (0x00000800)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_pre_dir_check_en_mask                    (0x00000400)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_min_second_dir_check2_en_mask            (0x00000200)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_min_second_dir_check_en_mask             (0x00000100)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_dynamic_cross_th_en_mask                 (0x00000080)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_intersection_check_en_mask               (0x00000040)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_high_freq_detect_en_mask                 (0x00000020)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_search_min_limit_en_mask                 (0x00000010)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_vbound_detect_en_mask                    (0x00000008)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_ydiff_mode_mask                          (0x00000004)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_new_mode_en_mask                         (0x00000002)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_src_lpf_clamp_en_mask                    (0x00000001)
#define  DI_IM_DI_NINTRA_CONTROL_nintra_sr_minus_value(data)                     (0x40000000&((data)<<30))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_ud_boundary_repeat_en(data)              (0x20000000&((data)<<29))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_n_check2_control_disable(data)           (0x10000000&((data)<<28))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_check2_y_diff_th(data)                   (0x0FF00000&((data)<<20))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_lowpass_dir_count_th(data)               (0x000F0000&((data)<<16))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_output_lowpass_en(data)                  (0x00008000&((data)<<15))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_dyn_dir_lowpass_en(data)                 (0x00004000&((data)<<14))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_preline_dir_check2_en(data)              (0x00002000&((data)<<13))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_preline_dir_check1_en(data)              (0x00001000&((data)<<12))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_lowpass_dir_check_en(data)               (0x00000800&((data)<<11))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_pre_dir_check_en(data)                   (0x00000400&((data)<<10))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_min_second_dir_check2_en(data)           (0x00000200&((data)<<9))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_min_second_dir_check_en(data)            (0x00000100&((data)<<8))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_dynamic_cross_th_en(data)                (0x00000080&((data)<<7))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_intersection_check_en(data)              (0x00000040&((data)<<6))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_high_freq_detect_en(data)                (0x00000020&((data)<<5))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_search_min_limit_en(data)                (0x00000010&((data)<<4))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_vbound_detect_en(data)                   (0x00000008&((data)<<3))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_ydiff_mode(data)                         (0x00000004&((data)<<2))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_new_mode_en(data)                        (0x00000002&((data)<<1))
#define  DI_IM_DI_NINTRA_CONTROL_nintra_src_lpf_clamp_en(data)                   (0x00000001&(data))
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_sr_minus_value(data)                 ((0x40000000&(data))>>30)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_ud_boundary_repeat_en(data)          ((0x20000000&(data))>>29)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_n_check2_control_disable(data)       ((0x10000000&(data))>>28)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_check2_y_diff_th(data)               ((0x0FF00000&(data))>>20)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_lowpass_dir_count_th(data)           ((0x000F0000&(data))>>16)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_output_lowpass_en(data)              ((0x00008000&(data))>>15)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_dyn_dir_lowpass_en(data)             ((0x00004000&(data))>>14)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_preline_dir_check2_en(data)          ((0x00002000&(data))>>13)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_preline_dir_check1_en(data)          ((0x00001000&(data))>>12)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_lowpass_dir_check_en(data)           ((0x00000800&(data))>>11)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_pre_dir_check_en(data)               ((0x00000400&(data))>>10)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_min_second_dir_check2_en(data)       ((0x00000200&(data))>>9)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_min_second_dir_check_en(data)        ((0x00000100&(data))>>8)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_dynamic_cross_th_en(data)            ((0x00000080&(data))>>7)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_intersection_check_en(data)          ((0x00000040&(data))>>6)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_high_freq_detect_en(data)            ((0x00000020&(data))>>5)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_search_min_limit_en(data)            ((0x00000010&(data))>>4)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_vbound_detect_en(data)               ((0x00000008&(data))>>3)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_ydiff_mode(data)                     ((0x00000004&(data))>>2)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_new_mode_en(data)                    ((0x00000002&(data))>>1)
#define  DI_IM_DI_NINTRA_CONTROL_get_nintra_src_lpf_clamp_en(data)               (0x00000001&(data))

#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE                                         0x180248E4
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_reg_addr                                 "0xB80248E4"
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_reg                                      0xB80248E4
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_inst_addr                                "0x014D"
#define  set_DI_IM_DI_NINTRA_LOWPASS_SOURCE_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_NINTRA_LOWPASS_SOURCE_reg)=data)
#define  get_DI_IM_DI_NINTRA_LOWPASS_SOURCE_reg                                  (*((volatile unsigned int*)DI_IM_DI_NINTRA_LOWPASS_SOURCE_reg))
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_yclamp_th_shift            (24)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_edge_slope_shift           (16)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_edge_th2_shift             (8)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_edge_th1_shift             (0)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_yclamp_th_mask             (0xFF000000)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_edge_slope_mask            (0x00FF0000)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_edge_th2_mask              (0x0000FF00)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_edge_th1_mask              (0x000000FF)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_yclamp_th(data)            (0xFF000000&((data)<<24))
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_edge_slope(data)           (0x00FF0000&((data)<<16))
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_edge_th2(data)             (0x0000FF00&((data)<<8))
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_nintra_lp_src_edge_th1(data)             (0x000000FF&(data))
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_get_nintra_lp_src_yclamp_th(data)        ((0xFF000000&(data))>>24)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_get_nintra_lp_src_edge_slope(data)       ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_get_nintra_lp_src_edge_th2(data)         ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_NINTRA_LOWPASS_SOURCE_get_nintra_lp_src_edge_th1(data)         (0x000000FF&(data))

#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT                                       0x180248E8
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_reg_addr                               "0xB80248E8"
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_reg                                    0xB80248E8
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_inst_addr                              "0x014E"
#define  set_DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_reg)=data)
#define  get_DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_reg                                (*((volatile unsigned int*)DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_reg))
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_nintra_dir_search_region_max_shift     (16)
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_nintra_hdiff_th2_shift                 (8)
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_nintra_hdiff_th1_shift                 (0)
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_nintra_dir_search_region_max_mask      (0x000F0000)
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_nintra_hdiff_th2_mask                  (0x0000FF00)
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_nintra_hdiff_th1_mask                  (0x000000FF)
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_nintra_dir_search_region_max(data)     (0x000F0000&((data)<<16))
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_nintra_hdiff_th2(data)                 (0x0000FF00&((data)<<8))
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_nintra_hdiff_th1(data)                 (0x000000FF&(data))
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_get_nintra_dir_search_region_max(data) ((0x000F0000&(data))>>16)
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_get_nintra_hdiff_th2(data)             ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_NINTRA_SEARCH_DIR_LIMIT_get_nintra_hdiff_th1(data)             (0x000000FF&(data))

#define  DI_IM_DI_NINTRA_INTERSECTION_TH                                        0x180248EC
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_reg_addr                                "0xB80248EC"
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_reg                                     0xB80248EC
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_inst_addr                               "0x014F"
#define  set_DI_IM_DI_NINTRA_INTERSECTION_TH_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_NINTRA_INTERSECTION_TH_reg)=data)
#define  get_DI_IM_DI_NINTRA_INTERSECTION_TH_reg                                 (*((volatile unsigned int*)DI_IM_DI_NINTRA_INTERSECTION_TH_reg))
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_nintra_crossslope_diff_th_shift         (16)
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_nintra_crossdiff_th_shift               (8)
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_nintra_slopediff_th_shift               (0)
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_nintra_crossslope_diff_th_mask          (0x00FF0000)
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_nintra_crossdiff_th_mask                (0x0000FF00)
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_nintra_slopediff_th_mask                (0x000000FF)
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_nintra_crossslope_diff_th(data)         (0x00FF0000&((data)<<16))
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_nintra_crossdiff_th(data)               (0x0000FF00&((data)<<8))
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_nintra_slopediff_th(data)               (0x000000FF&(data))
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_get_nintra_crossslope_diff_th(data)     ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_get_nintra_crossdiff_th(data)           ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_NINTRA_INTERSECTION_TH_get_nintra_slopediff_th(data)           (0x000000FF&(data))

#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH                                       0x180248F0
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_reg_addr                               "0xB80248F0"
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_reg                                    0xB80248F0
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_inst_addr                              "0x0150"
#define  set_DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_reg(data)                          (*((volatile unsigned int*)DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_reg)=data)
#define  get_DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_reg                                (*((volatile unsigned int*)DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_reg))
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_minsecond_diff_th3_shift        (24)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_minsecond_diff_th2_shift        (16)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_vertical_diff_th_shift          (8)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_minsecond_diff_th_shift         (0)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_minsecond_diff_th3_mask         (0xFF000000)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_minsecond_diff_th2_mask         (0x00FF0000)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_vertical_diff_th_mask           (0x0000FF00)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_minsecond_diff_th_mask          (0x000000FF)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_minsecond_diff_th3(data)        (0xFF000000&((data)<<24))
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_minsecond_diff_th2(data)        (0x00FF0000&((data)<<16))
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_vertical_diff_th(data)          (0x0000FF00&((data)<<8))
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_nintra_minsecond_diff_th(data)         (0x000000FF&(data))
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_get_nintra_minsecond_diff_th3(data)    ((0xFF000000&(data))>>24)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_get_nintra_minsecond_diff_th2(data)    ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_get_nintra_vertical_diff_th(data)      ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_get_nintra_minsecond_diff_th(data)     (0x000000FF&(data))

#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT                                        0x180248F4
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_reg_addr                                "0xB80248F4"
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_reg                                     0xB80248F4
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_inst_addr                               "0x0151"
#define  set_DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_reg)=data)
#define  get_DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_reg                                 (*((volatile unsigned int*)DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_reg))
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_nintra_trans_count_th2_shift            (16)
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_nintra_trans_count_th1_shift            (8)
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_nintra_hfq_hdiff_th_shift               (0)
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_nintra_trans_count_th2_mask             (0x00FF0000)
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_nintra_trans_count_th1_mask             (0x0000FF00)
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_nintra_hfq_hdiff_th_mask                (0x000000FF)
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_nintra_trans_count_th2(data)            (0x00FF0000&((data)<<16))
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_nintra_trans_count_th1(data)            (0x0000FF00&((data)<<8))
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_nintra_hfq_hdiff_th(data)               (0x000000FF&(data))
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_get_nintra_trans_count_th2(data)        ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_get_nintra_trans_count_th1(data)        ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_NINTRA_HIGH_FREQ_LIMIT_get_nintra_hfq_hdiff_th(data)           (0x000000FF&(data))

#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2                                          0x18024904
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_reg_addr                                  "0xB8024904"
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_reg                                       0xB8024904
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_inst_addr                                 "0x0152"
#define  set_DI_IM_DI_HMC_ME_REFINE_CTRL_2_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_HMC_ME_REFINE_CTRL_2_reg)=data)
#define  get_DI_IM_DI_HMC_ME_REFINE_CTRL_2_reg                                   (*((volatile unsigned int*)DI_IM_DI_HMC_ME_REFINE_CTRL_2_reg))
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_hmc_teeth_total_shift                     (24)
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_hmc_teeth_of_line_th_shift                (16)
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_hmc_fw_ctrl_bypass_shift                  (5)
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_hmc_teeth_total_mask                      (0xFF000000)
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_hmc_teeth_of_line_th_mask                 (0x00FF0000)
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_hmc_fw_ctrl_bypass_mask                   (0x00000020)
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_hmc_teeth_total(data)                     (0xFF000000&((data)<<24))
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_hmc_teeth_of_line_th(data)                (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_hmc_fw_ctrl_bypass(data)                  (0x00000020&((data)<<5))
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_get_hmc_teeth_total(data)                 ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_get_hmc_teeth_of_line_th(data)            ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HMC_ME_REFINE_CTRL_2_get_hmc_fw_ctrl_bypass(data)              ((0x00000020&(data))>>5)

#define  DI_IM_NEW_MCNR_CONTROL                                                 0x18024914
#define  DI_IM_NEW_MCNR_CONTROL_reg_addr                                         "0xB8024914"
#define  DI_IM_NEW_MCNR_CONTROL_reg                                              0xB8024914
#define  DI_IM_NEW_MCNR_CONTROL_inst_addr                                        "0x0153"
#define  set_DI_IM_NEW_MCNR_CONTROL_reg(data)                                    (*((volatile unsigned int*)DI_IM_NEW_MCNR_CONTROL_reg)=data)
#define  get_DI_IM_NEW_MCNR_CONTROL_reg                                          (*((volatile unsigned int*)DI_IM_NEW_MCNR_CONTROL_reg))
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_old_search_range_en_shift                 (28)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_mv_diff_max_en_shift                      (27)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_debug_mode_select_shift                   (24)
#define  DI_IM_NEW_MCNR_CONTROL_hori_boundary_th_shift                           (20)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_debug_mode_en_shift                       (14)
#define  DI_IM_NEW_MCNR_CONTROL_n_rtnr_c_k_select_shift                          (13)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_y_k_select_mc_shift                       (12)
#define  DI_IM_NEW_MCNR_CONTROL_n_rtnr_y_k_select_shift                          (11)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_weight_clamp_en_shift                     (10)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_weight_avg_en_shift                       (9)
#define  DI_IM_NEW_MCNR_CONTROL_n_c_zero_mv_k_en_shift                           (8)
#define  DI_IM_NEW_MCNR_CONTROL_n_mv_diff_distance_select_shift                  (5)
#define  DI_IM_NEW_MCNR_CONTROL_n_zero_mv_gain8_en_shift                         (4)
#define  DI_IM_NEW_MCNR_CONTROL_n_y_zero_mv_k_en_shift                           (3)
#define  DI_IM_NEW_MCNR_CONTROL_n_h_pan_zeromv_penalty_en_shift                  (2)
#define  DI_IM_NEW_MCNR_CONTROL_n_h_pan_flag_shift                               (1)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_new_en_shift                              (0)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_old_search_range_en_mask                  (0x10000000)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_mv_diff_max_en_mask                       (0x08000000)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_debug_mode_select_mask                    (0x07000000)
#define  DI_IM_NEW_MCNR_CONTROL_hori_boundary_th_mask                            (0x00F00000)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_debug_mode_en_mask                        (0x00004000)
#define  DI_IM_NEW_MCNR_CONTROL_n_rtnr_c_k_select_mask                           (0x00002000)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_y_k_select_mc_mask                        (0x00001000)
#define  DI_IM_NEW_MCNR_CONTROL_n_rtnr_y_k_select_mask                           (0x00000800)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_weight_clamp_en_mask                      (0x00000400)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_weight_avg_en_mask                        (0x00000200)
#define  DI_IM_NEW_MCNR_CONTROL_n_c_zero_mv_k_en_mask                            (0x00000100)
#define  DI_IM_NEW_MCNR_CONTROL_n_mv_diff_distance_select_mask                   (0x00000020)
#define  DI_IM_NEW_MCNR_CONTROL_n_zero_mv_gain8_en_mask                          (0x00000010)
#define  DI_IM_NEW_MCNR_CONTROL_n_y_zero_mv_k_en_mask                            (0x00000008)
#define  DI_IM_NEW_MCNR_CONTROL_n_h_pan_zeromv_penalty_en_mask                   (0x00000004)
#define  DI_IM_NEW_MCNR_CONTROL_n_h_pan_flag_mask                                (0x00000002)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_new_en_mask                               (0x00000001)
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_old_search_range_en(data)                 (0x10000000&((data)<<28))
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_mv_diff_max_en(data)                      (0x08000000&((data)<<27))
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_debug_mode_select(data)                   (0x07000000&((data)<<24))
#define  DI_IM_NEW_MCNR_CONTROL_hori_boundary_th(data)                           (0x00F00000&((data)<<20))
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_debug_mode_en(data)                       (0x00004000&((data)<<14))
#define  DI_IM_NEW_MCNR_CONTROL_n_rtnr_c_k_select(data)                          (0x00002000&((data)<<13))
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_y_k_select_mc(data)                       (0x00001000&((data)<<12))
#define  DI_IM_NEW_MCNR_CONTROL_n_rtnr_y_k_select(data)                          (0x00000800&((data)<<11))
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_weight_clamp_en(data)                     (0x00000400&((data)<<10))
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_weight_avg_en(data)                       (0x00000200&((data)<<9))
#define  DI_IM_NEW_MCNR_CONTROL_n_c_zero_mv_k_en(data)                           (0x00000100&((data)<<8))
#define  DI_IM_NEW_MCNR_CONTROL_n_mv_diff_distance_select(data)                  (0x00000020&((data)<<5))
#define  DI_IM_NEW_MCNR_CONTROL_n_zero_mv_gain8_en(data)                         (0x00000010&((data)<<4))
#define  DI_IM_NEW_MCNR_CONTROL_n_y_zero_mv_k_en(data)                           (0x00000008&((data)<<3))
#define  DI_IM_NEW_MCNR_CONTROL_n_h_pan_zeromv_penalty_en(data)                  (0x00000004&((data)<<2))
#define  DI_IM_NEW_MCNR_CONTROL_n_h_pan_flag(data)                               (0x00000002&((data)<<1))
#define  DI_IM_NEW_MCNR_CONTROL_n_mcnr_new_en(data)                              (0x00000001&(data))
#define  DI_IM_NEW_MCNR_CONTROL_get_n_mcnr_old_search_range_en(data)             ((0x10000000&(data))>>28)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_mcnr_mv_diff_max_en(data)                  ((0x08000000&(data))>>27)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_mcnr_debug_mode_select(data)               ((0x07000000&(data))>>24)
#define  DI_IM_NEW_MCNR_CONTROL_get_hori_boundary_th(data)                       ((0x00F00000&(data))>>20)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_mcnr_debug_mode_en(data)                   ((0x00004000&(data))>>14)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_rtnr_c_k_select(data)                      ((0x00002000&(data))>>13)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_mcnr_y_k_select_mc(data)                   ((0x00001000&(data))>>12)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_rtnr_y_k_select(data)                      ((0x00000800&(data))>>11)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_mcnr_weight_clamp_en(data)                 ((0x00000400&(data))>>10)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_mcnr_weight_avg_en(data)                   ((0x00000200&(data))>>9)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_c_zero_mv_k_en(data)                       ((0x00000100&(data))>>8)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_mv_diff_distance_select(data)              ((0x00000020&(data))>>5)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_zero_mv_gain8_en(data)                     ((0x00000010&(data))>>4)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_y_zero_mv_k_en(data)                       ((0x00000008&(data))>>3)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_h_pan_zeromv_penalty_en(data)              ((0x00000004&(data))>>2)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_h_pan_flag(data)                           ((0x00000002&(data))>>1)
#define  DI_IM_NEW_MCNR_CONTROL_get_n_mcnr_new_en(data)                          (0x00000001&(data))

#define  DI_IM_NEW_MCNR_PAN_CONDITION                                           0x18024918
#define  DI_IM_NEW_MCNR_PAN_CONDITION_reg_addr                                   "0xB8024918"
#define  DI_IM_NEW_MCNR_PAN_CONDITION_reg                                        0xB8024918
#define  DI_IM_NEW_MCNR_PAN_CONDITION_inst_addr                                  "0x0154"
#define  set_DI_IM_NEW_MCNR_PAN_CONDITION_reg(data)                              (*((volatile unsigned int*)DI_IM_NEW_MCNR_PAN_CONDITION_reg)=data)
#define  get_DI_IM_NEW_MCNR_PAN_CONDITION_reg                                    (*((volatile unsigned int*)DI_IM_NEW_MCNR_PAN_CONDITION_reg))
#define  DI_IM_NEW_MCNR_PAN_CONDITION_h_pan_mv_value_shift                       (8)
#define  DI_IM_NEW_MCNR_PAN_CONDITION_h_pan_mv_penalty_shift                     (0)
#define  DI_IM_NEW_MCNR_PAN_CONDITION_h_pan_mv_value_mask                        (0x00001F00)
#define  DI_IM_NEW_MCNR_PAN_CONDITION_h_pan_mv_penalty_mask                      (0x000000FF)
#define  DI_IM_NEW_MCNR_PAN_CONDITION_h_pan_mv_value(data)                       (0x00001F00&((data)<<8))
#define  DI_IM_NEW_MCNR_PAN_CONDITION_h_pan_mv_penalty(data)                     (0x000000FF&(data))
#define  DI_IM_NEW_MCNR_PAN_CONDITION_get_h_pan_mv_value(data)                   ((0x00001F00&(data))>>8)
#define  DI_IM_NEW_MCNR_PAN_CONDITION_get_h_pan_mv_penalty(data)                 (0x000000FF&(data))

#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION                                     0x1802491C
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_reg_addr                             "0xB802491C"
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_reg                                  0xB802491C
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_inst_addr                            "0x0155"
#define  set_DI_IM_NEW_MCNR_WEIGHTING_CONDITION_reg(data)                        (*((volatile unsigned int*)DI_IM_NEW_MCNR_WEIGHTING_CONDITION_reg)=data)
#define  get_DI_IM_NEW_MCNR_WEIGHTING_CONDITION_reg                              (*((volatile unsigned int*)DI_IM_NEW_MCNR_WEIGHTING_CONDITION_reg))
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_sad_min_slope_shift                  (20)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_mv_diff_slope_shift                  (16)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_sad_min_th_shift                     (8)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_mv_diff_th_shift                     (0)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_sad_min_slope_mask                   (0x00F00000)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_mv_diff_slope_mask                   (0x000F0000)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_sad_min_th_mask                      (0x0000FF00)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_mv_diff_th_mask                      (0x000000FF)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_sad_min_slope(data)                  (0x00F00000&((data)<<20))
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_mv_diff_slope(data)                  (0x000F0000&((data)<<16))
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_sad_min_th(data)                     (0x0000FF00&((data)<<8))
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_mv_diff_th(data)                     (0x000000FF&(data))
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_get_sad_min_slope(data)              ((0x00F00000&(data))>>20)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_get_mv_diff_slope(data)              ((0x000F0000&(data))>>16)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_get_sad_min_th(data)                 ((0x0000FF00&(data))>>8)
#define  DI_IM_NEW_MCNR_WEIGHTING_CONDITION_get_mv_diff_th(data)                 (0x000000FF&(data))

#define  DI_IM_NEW_MCNR_CLAMPING_VALUE                                          0x18024920
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_reg_addr                                  "0xB8024920"
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_reg                                       0xB8024920
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_inst_addr                                 "0x0156"
#define  set_DI_IM_NEW_MCNR_CLAMPING_VALUE_reg(data)                             (*((volatile unsigned int*)DI_IM_NEW_MCNR_CLAMPING_VALUE_reg)=data)
#define  get_DI_IM_NEW_MCNR_CLAMPING_VALUE_reg                                   (*((volatile unsigned int*)DI_IM_NEW_MCNR_CLAMPING_VALUE_reg))
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight3_shift                      (24)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight2_shift                      (20)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight1_shift                      (16)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight_mode_shift                  (15)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight_avg_mode_shift              (14)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_mcnr_weight_clamp_loth_shift              (9)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_mcnr_weight_clamp_upth_shift              (4)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight3_mask                       (0x0F000000)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight2_mask                       (0x00F00000)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight1_mask                       (0x000F0000)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight_mode_mask                   (0x00008000)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight_avg_mode_mask               (0x00004000)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_mcnr_weight_clamp_loth_mask               (0x00003E00)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_mcnr_weight_clamp_upth_mask               (0x000001F0)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight3(data)                      (0x0F000000&((data)<<24))
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight2(data)                      (0x00F00000&((data)<<20))
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight1(data)                      (0x000F0000&((data)<<16))
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight_mode(data)                  (0x00008000&((data)<<15))
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_n_mcnr_weight_avg_mode(data)              (0x00004000&((data)<<14))
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_mcnr_weight_clamp_loth(data)              (0x00003E00&((data)<<9))
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_mcnr_weight_clamp_upth(data)              (0x000001F0&((data)<<4))
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_get_n_mcnr_weight3(data)                  ((0x0F000000&(data))>>24)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_get_n_mcnr_weight2(data)                  ((0x00F00000&(data))>>20)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_get_n_mcnr_weight1(data)                  ((0x000F0000&(data))>>16)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_get_n_mcnr_weight_mode(data)              ((0x00008000&(data))>>15)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_get_n_mcnr_weight_avg_mode(data)          ((0x00004000&(data))>>14)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_get_mcnr_weight_clamp_loth(data)          ((0x00003E00&(data))>>9)
#define  DI_IM_NEW_MCNR_CLAMPING_VALUE_get_mcnr_weight_clamp_upth(data)          ((0x000001F0&(data))>>4)

#define  DI_IM_DI_HME_LINE_STATISTIC_1                                          0x18024924
#define  DI_IM_DI_HME_LINE_STATISTIC_1_reg_addr                                  "0xB8024924"
#define  DI_IM_DI_HME_LINE_STATISTIC_1_reg                                       0xB8024924
#define  DI_IM_DI_HME_LINE_STATISTIC_1_inst_addr                                 "0x0157"
#define  set_DI_IM_DI_HME_LINE_STATISTIC_1_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_1_reg)=data)
#define  get_DI_IM_DI_HME_LINE_STATISTIC_1_reg                                   (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_1_reg))
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l16_linesum_shift                     (24)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l15_linesum_shift                     (16)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l14_linesum_shift                     (8)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l13_linesum_shift                     (0)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l16_linesum_mask                      (0xFF000000)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l15_linesum_mask                      (0x00FF0000)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l14_linesum_mask                      (0x0000FF00)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l13_linesum_mask                      (0x000000FF)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l16_linesum(data)                     (0xFF000000&((data)<<24))
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l15_linesum(data)                     (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l14_linesum(data)                     (0x0000FF00&((data)<<8))
#define  DI_IM_DI_HME_LINE_STATISTIC_1_hmc_l13_linesum(data)                     (0x000000FF&(data))
#define  DI_IM_DI_HME_LINE_STATISTIC_1_get_hmc_l16_linesum(data)                 ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_get_hmc_l15_linesum(data)                 ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_get_hmc_l14_linesum(data)                 ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_HME_LINE_STATISTIC_1_get_hmc_l13_linesum(data)                 (0x000000FF&(data))

#define  DI_IM_DI_HME_LINE_STATISTIC_2                                          0x18024928
#define  DI_IM_DI_HME_LINE_STATISTIC_2_reg_addr                                  "0xB8024928"
#define  DI_IM_DI_HME_LINE_STATISTIC_2_reg                                       0xB8024928
#define  DI_IM_DI_HME_LINE_STATISTIC_2_inst_addr                                 "0x0158"
#define  set_DI_IM_DI_HME_LINE_STATISTIC_2_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_2_reg)=data)
#define  get_DI_IM_DI_HME_LINE_STATISTIC_2_reg                                   (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_2_reg))
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l12_linesum_shift                     (24)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l11_linesum_shift                     (16)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l10_linesum_shift                     (8)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l9_linesum_shift                      (0)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l12_linesum_mask                      (0xFF000000)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l11_linesum_mask                      (0x00FF0000)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l10_linesum_mask                      (0x0000FF00)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l9_linesum_mask                       (0x000000FF)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l12_linesum(data)                     (0xFF000000&((data)<<24))
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l11_linesum(data)                     (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l10_linesum(data)                     (0x0000FF00&((data)<<8))
#define  DI_IM_DI_HME_LINE_STATISTIC_2_hmc_l9_linesum(data)                      (0x000000FF&(data))
#define  DI_IM_DI_HME_LINE_STATISTIC_2_get_hmc_l12_linesum(data)                 ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_get_hmc_l11_linesum(data)                 ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_get_hmc_l10_linesum(data)                 ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_HME_LINE_STATISTIC_2_get_hmc_l9_linesum(data)                  (0x000000FF&(data))

#define  DI_IM_DI_HME_LINE_STATISTIC_3                                          0x1802492C
#define  DI_IM_DI_HME_LINE_STATISTIC_3_reg_addr                                  "0xB802492C"
#define  DI_IM_DI_HME_LINE_STATISTIC_3_reg                                       0xB802492C
#define  DI_IM_DI_HME_LINE_STATISTIC_3_inst_addr                                 "0x0159"
#define  set_DI_IM_DI_HME_LINE_STATISTIC_3_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_3_reg)=data)
#define  get_DI_IM_DI_HME_LINE_STATISTIC_3_reg                                   (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_3_reg))
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l8_linesum_shift                      (24)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l7_linesum_shift                      (16)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l6_linesum_shift                      (8)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l5_linesum_shift                      (0)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l8_linesum_mask                       (0xFF000000)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l7_linesum_mask                       (0x00FF0000)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l6_linesum_mask                       (0x0000FF00)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l5_linesum_mask                       (0x000000FF)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l8_linesum(data)                      (0xFF000000&((data)<<24))
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l7_linesum(data)                      (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l6_linesum(data)                      (0x0000FF00&((data)<<8))
#define  DI_IM_DI_HME_LINE_STATISTIC_3_hmc_l5_linesum(data)                      (0x000000FF&(data))
#define  DI_IM_DI_HME_LINE_STATISTIC_3_get_hmc_l8_linesum(data)                  ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_get_hmc_l7_linesum(data)                  ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_get_hmc_l6_linesum(data)                  ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_HME_LINE_STATISTIC_3_get_hmc_l5_linesum(data)                  (0x000000FF&(data))

#define  DI_IM_DI_HME_LINE_STATISTIC_4                                          0x18024930
#define  DI_IM_DI_HME_LINE_STATISTIC_4_reg_addr                                  "0xB8024930"
#define  DI_IM_DI_HME_LINE_STATISTIC_4_reg                                       0xB8024930
#define  DI_IM_DI_HME_LINE_STATISTIC_4_inst_addr                                 "0x015A"
#define  set_DI_IM_DI_HME_LINE_STATISTIC_4_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_4_reg)=data)
#define  get_DI_IM_DI_HME_LINE_STATISTIC_4_reg                                   (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_4_reg))
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l4_linesum_shift                      (24)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l3_linesum_shift                      (16)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l2_linesum_shift                      (8)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l1_linesum_shift                      (0)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l4_linesum_mask                       (0xFF000000)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l3_linesum_mask                       (0x00FF0000)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l2_linesum_mask                       (0x0000FF00)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l1_linesum_mask                       (0x000000FF)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l4_linesum(data)                      (0xFF000000&((data)<<24))
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l3_linesum(data)                      (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l2_linesum(data)                      (0x0000FF00&((data)<<8))
#define  DI_IM_DI_HME_LINE_STATISTIC_4_hmc_l1_linesum(data)                      (0x000000FF&(data))
#define  DI_IM_DI_HME_LINE_STATISTIC_4_get_hmc_l4_linesum(data)                  ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_get_hmc_l3_linesum(data)                  ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_get_hmc_l2_linesum(data)                  ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_HME_LINE_STATISTIC_4_get_hmc_l1_linesum(data)                  (0x000000FF&(data))

#define  DI_IM_DI_HME_LINE_STATISTIC_5                                          0x18024934
#define  DI_IM_DI_HME_LINE_STATISTIC_5_reg_addr                                  "0xB8024934"
#define  DI_IM_DI_HME_LINE_STATISTIC_5_reg                                       0xB8024934
#define  DI_IM_DI_HME_LINE_STATISTIC_5_inst_addr                                 "0x015B"
#define  set_DI_IM_DI_HME_LINE_STATISTIC_5_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_5_reg)=data)
#define  get_DI_IM_DI_HME_LINE_STATISTIC_5_reg                                   (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_5_reg))
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_c0_linesum_shift                      (24)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_r1_linesum_shift                      (16)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_r2_linesum_shift                      (8)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_r3_linesum_shift                      (0)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_c0_linesum_mask                       (0xFF000000)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_r1_linesum_mask                       (0x00FF0000)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_r2_linesum_mask                       (0x0000FF00)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_r3_linesum_mask                       (0x000000FF)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_c0_linesum(data)                      (0xFF000000&((data)<<24))
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_r1_linesum(data)                      (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_r2_linesum(data)                      (0x0000FF00&((data)<<8))
#define  DI_IM_DI_HME_LINE_STATISTIC_5_hmc_r3_linesum(data)                      (0x000000FF&(data))
#define  DI_IM_DI_HME_LINE_STATISTIC_5_get_hmc_c0_linesum(data)                  ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_get_hmc_r1_linesum(data)                  ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_get_hmc_r2_linesum(data)                  ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_HME_LINE_STATISTIC_5_get_hmc_r3_linesum(data)                  (0x000000FF&(data))

#define  DI_IM_DI_HME_LINE_STATISTIC_6                                          0x18024938
#define  DI_IM_DI_HME_LINE_STATISTIC_6_reg_addr                                  "0xB8024938"
#define  DI_IM_DI_HME_LINE_STATISTIC_6_reg                                       0xB8024938
#define  DI_IM_DI_HME_LINE_STATISTIC_6_inst_addr                                 "0x015C"
#define  set_DI_IM_DI_HME_LINE_STATISTIC_6_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_6_reg)=data)
#define  get_DI_IM_DI_HME_LINE_STATISTIC_6_reg                                   (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_6_reg))
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r4_linesum_shift                      (24)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r5_linesum_shift                      (16)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r6_linesum_shift                      (8)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r7_linesum_shift                      (0)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r4_linesum_mask                       (0xFF000000)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r5_linesum_mask                       (0x00FF0000)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r6_linesum_mask                       (0x0000FF00)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r7_linesum_mask                       (0x000000FF)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r4_linesum(data)                      (0xFF000000&((data)<<24))
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r5_linesum(data)                      (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r6_linesum(data)                      (0x0000FF00&((data)<<8))
#define  DI_IM_DI_HME_LINE_STATISTIC_6_hmc_r7_linesum(data)                      (0x000000FF&(data))
#define  DI_IM_DI_HME_LINE_STATISTIC_6_get_hmc_r4_linesum(data)                  ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_get_hmc_r5_linesum(data)                  ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_get_hmc_r6_linesum(data)                  ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_HME_LINE_STATISTIC_6_get_hmc_r7_linesum(data)                  (0x000000FF&(data))

#define  DI_IM_DI_HME_LINE_STATISTIC_7                                          0x1802493C
#define  DI_IM_DI_HME_LINE_STATISTIC_7_reg_addr                                  "0xB802493C"
#define  DI_IM_DI_HME_LINE_STATISTIC_7_reg                                       0xB802493C
#define  DI_IM_DI_HME_LINE_STATISTIC_7_inst_addr                                 "0x015D"
#define  set_DI_IM_DI_HME_LINE_STATISTIC_7_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_7_reg)=data)
#define  get_DI_IM_DI_HME_LINE_STATISTIC_7_reg                                   (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_7_reg))
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r8_linesum_shift                      (24)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r9_linesum_shift                      (16)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r10_linesum_shift                     (8)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r11_linesum_shift                     (0)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r8_linesum_mask                       (0xFF000000)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r9_linesum_mask                       (0x00FF0000)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r10_linesum_mask                      (0x0000FF00)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r11_linesum_mask                      (0x000000FF)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r8_linesum(data)                      (0xFF000000&((data)<<24))
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r9_linesum(data)                      (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r10_linesum(data)                     (0x0000FF00&((data)<<8))
#define  DI_IM_DI_HME_LINE_STATISTIC_7_hmc_r11_linesum(data)                     (0x000000FF&(data))
#define  DI_IM_DI_HME_LINE_STATISTIC_7_get_hmc_r8_linesum(data)                  ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_get_hmc_r9_linesum(data)                  ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_get_hmc_r10_linesum(data)                 ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_HME_LINE_STATISTIC_7_get_hmc_r11_linesum(data)                 (0x000000FF&(data))

#define  DI_IM_DI_HME_LINE_STATISTIC_8                                          0x18024940
#define  DI_IM_DI_HME_LINE_STATISTIC_8_reg_addr                                  "0xB8024940"
#define  DI_IM_DI_HME_LINE_STATISTIC_8_reg                                       0xB8024940
#define  DI_IM_DI_HME_LINE_STATISTIC_8_inst_addr                                 "0x015E"
#define  set_DI_IM_DI_HME_LINE_STATISTIC_8_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_8_reg)=data)
#define  get_DI_IM_DI_HME_LINE_STATISTIC_8_reg                                   (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_8_reg))
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r12_linesum_shift                     (24)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r13_linesum_shift                     (16)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r14_linesum_shift                     (8)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r15_linesum_shift                     (0)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r12_linesum_mask                      (0xFF000000)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r13_linesum_mask                      (0x00FF0000)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r14_linesum_mask                      (0x0000FF00)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r15_linesum_mask                      (0x000000FF)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r12_linesum(data)                     (0xFF000000&((data)<<24))
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r13_linesum(data)                     (0x00FF0000&((data)<<16))
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r14_linesum(data)                     (0x0000FF00&((data)<<8))
#define  DI_IM_DI_HME_LINE_STATISTIC_8_hmc_r15_linesum(data)                     (0x000000FF&(data))
#define  DI_IM_DI_HME_LINE_STATISTIC_8_get_hmc_r12_linesum(data)                 ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_get_hmc_r13_linesum(data)                 ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_get_hmc_r14_linesum(data)                 ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_HME_LINE_STATISTIC_8_get_hmc_r15_linesum(data)                 (0x000000FF&(data))

#define  DI_IM_DI_HME_LINE_STATISTIC_9                                          0x18024944
#define  DI_IM_DI_HME_LINE_STATISTIC_9_reg_addr                                  "0xB8024944"
#define  DI_IM_DI_HME_LINE_STATISTIC_9_reg                                       0xB8024944
#define  DI_IM_DI_HME_LINE_STATISTIC_9_inst_addr                                 "0x015F"
#define  set_DI_IM_DI_HME_LINE_STATISTIC_9_reg(data)                             (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_9_reg)=data)
#define  get_DI_IM_DI_HME_LINE_STATISTIC_9_reg                                   (*((volatile unsigned int*)DI_IM_DI_HME_LINE_STATISTIC_9_reg))
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_r16_linesum_shift                     (24)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_linesum_step_mv_diff_th_shift         (8)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_linesum_step_tolerance_shift          (4)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_linesum_step_shift                    (0)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_r16_linesum_mask                      (0xFF000000)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_linesum_step_mv_diff_th_mask          (0x00000F00)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_linesum_step_tolerance_mask           (0x000000F0)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_linesum_step_mask                     (0x0000000F)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_r16_linesum(data)                     (0xFF000000&((data)<<24))
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_linesum_step_mv_diff_th(data)         (0x00000F00&((data)<<8))
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_linesum_step_tolerance(data)          (0x000000F0&((data)<<4))
#define  DI_IM_DI_HME_LINE_STATISTIC_9_hmc_linesum_step(data)                    (0x0000000F&(data))
#define  DI_IM_DI_HME_LINE_STATISTIC_9_get_hmc_r16_linesum(data)                 ((0xFF000000&(data))>>24)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_get_hmc_linesum_step_mv_diff_th(data)     ((0x00000F00&(data))>>8)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_get_hmc_linesum_step_tolerance(data)      ((0x000000F0&(data))>>4)
#define  DI_IM_DI_HME_LINE_STATISTIC_9_get_hmc_linesum_step(data)                (0x0000000F&(data))

#define  DI_DI_DDR_CHECKSUM_CTRL                                                0x1802494C
#define  DI_DI_DDR_CHECKSUM_CTRL_reg_addr                                        "0xB802494C"
#define  DI_DI_DDR_CHECKSUM_CTRL_reg                                             0xB802494C
#define  DI_DI_DDR_CHECKSUM_CTRL_inst_addr                                       "0x0160"
#define  set_DI_DI_DDR_CHECKSUM_CTRL_reg(data)                                   (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_CTRL_reg)=data)
#define  get_DI_DI_DDR_CHECKSUM_CTRL_reg                                         (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_CTRL_reg))
#define  DI_DI_DDR_CHECKSUM_CTRL_di_ddr_comp_en_shift                            (31)
#define  DI_DI_DDR_CHECKSUM_CTRL_di_ddr_error_count_shift                        (0)
#define  DI_DI_DDR_CHECKSUM_CTRL_di_ddr_comp_en_mask                             (0x80000000)
#define  DI_DI_DDR_CHECKSUM_CTRL_di_ddr_error_count_mask                         (0x00FFFFFF)
#define  DI_DI_DDR_CHECKSUM_CTRL_di_ddr_comp_en(data)                            (0x80000000&((data)<<31))
#define  DI_DI_DDR_CHECKSUM_CTRL_di_ddr_error_count(data)                        (0x00FFFFFF&(data))
#define  DI_DI_DDR_CHECKSUM_CTRL_get_di_ddr_comp_en(data)                        ((0x80000000&(data))>>31)
#define  DI_DI_DDR_CHECKSUM_CTRL_get_di_ddr_error_count(data)                    (0x00FFFFFF&(data))

#define  DI_DI_DDR_CHECKSUM_FLAG_0                                              0x18024950
#define  DI_DI_DDR_CHECKSUM_FLAG_0_reg_addr                                      "0xB8024950"
#define  DI_DI_DDR_CHECKSUM_FLAG_0_reg                                           0xB8024950
#define  DI_DI_DDR_CHECKSUM_FLAG_0_inst_addr                                     "0x0161"
#define  set_DI_DI_DDR_CHECKSUM_FLAG_0_reg(data)                                 (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_FLAG_0_reg)=data)
#define  get_DI_DI_DDR_CHECKSUM_FLAG_0_reg                                       (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_FLAG_0_reg))
#define  DI_DI_DDR_CHECKSUM_FLAG_0_di_ddr_error_flag_127_96_shift                (0)
#define  DI_DI_DDR_CHECKSUM_FLAG_0_di_ddr_error_flag_127_96_mask                 (0xFFFFFFFF)
#define  DI_DI_DDR_CHECKSUM_FLAG_0_di_ddr_error_flag_127_96(data)                (0xFFFFFFFF&(data))
#define  DI_DI_DDR_CHECKSUM_FLAG_0_get_di_ddr_error_flag_127_96(data)            (0xFFFFFFFF&(data))

#define  DI_DI_DDR_CHECKSUM_FLAG_1                                              0x18024954
#define  DI_DI_DDR_CHECKSUM_FLAG_1_reg_addr                                      "0xB8024954"
#define  DI_DI_DDR_CHECKSUM_FLAG_1_reg                                           0xB8024954
#define  DI_DI_DDR_CHECKSUM_FLAG_1_inst_addr                                     "0x0162"
#define  set_DI_DI_DDR_CHECKSUM_FLAG_1_reg(data)                                 (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_FLAG_1_reg)=data)
#define  get_DI_DI_DDR_CHECKSUM_FLAG_1_reg                                       (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_FLAG_1_reg))
#define  DI_DI_DDR_CHECKSUM_FLAG_1_di_ddr_error_flag_95_64_shift                 (0)
#define  DI_DI_DDR_CHECKSUM_FLAG_1_di_ddr_error_flag_95_64_mask                  (0xFFFFFFFF)
#define  DI_DI_DDR_CHECKSUM_FLAG_1_di_ddr_error_flag_95_64(data)                 (0xFFFFFFFF&(data))
#define  DI_DI_DDR_CHECKSUM_FLAG_1_get_di_ddr_error_flag_95_64(data)             (0xFFFFFFFF&(data))

#define  DI_DI_DDR_CHECKSUM_FLAG_2                                              0x18024958
#define  DI_DI_DDR_CHECKSUM_FLAG_2_reg_addr                                      "0xB8024958"
#define  DI_DI_DDR_CHECKSUM_FLAG_2_reg                                           0xB8024958
#define  DI_DI_DDR_CHECKSUM_FLAG_2_inst_addr                                     "0x0163"
#define  set_DI_DI_DDR_CHECKSUM_FLAG_2_reg(data)                                 (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_FLAG_2_reg)=data)
#define  get_DI_DI_DDR_CHECKSUM_FLAG_2_reg                                       (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_FLAG_2_reg))
#define  DI_DI_DDR_CHECKSUM_FLAG_2_di_ddr_error_flag_63_32_shift                 (0)
#define  DI_DI_DDR_CHECKSUM_FLAG_2_di_ddr_error_flag_63_32_mask                  (0xFFFFFFFF)
#define  DI_DI_DDR_CHECKSUM_FLAG_2_di_ddr_error_flag_63_32(data)                 (0xFFFFFFFF&(data))
#define  DI_DI_DDR_CHECKSUM_FLAG_2_get_di_ddr_error_flag_63_32(data)             (0xFFFFFFFF&(data))

#define  DI_DI_DDR_CHECKSUM_FLAG_3                                              0x1802495C
#define  DI_DI_DDR_CHECKSUM_FLAG_3_reg_addr                                      "0xB802495C"
#define  DI_DI_DDR_CHECKSUM_FLAG_3_reg                                           0xB802495C
#define  DI_DI_DDR_CHECKSUM_FLAG_3_inst_addr                                     "0x0164"
#define  set_DI_DI_DDR_CHECKSUM_FLAG_3_reg(data)                                 (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_FLAG_3_reg)=data)
#define  get_DI_DI_DDR_CHECKSUM_FLAG_3_reg                                       (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_FLAG_3_reg))
#define  DI_DI_DDR_CHECKSUM_FLAG_3_di_ddr_error_flag_31_0_shift                  (0)
#define  DI_DI_DDR_CHECKSUM_FLAG_3_di_ddr_error_flag_31_0_mask                   (0xFFFFFFFF)
#define  DI_DI_DDR_CHECKSUM_FLAG_3_di_ddr_error_flag_31_0(data)                  (0xFFFFFFFF&(data))
#define  DI_DI_DDR_CHECKSUM_FLAG_3_get_di_ddr_error_flag_31_0(data)              (0xFFFFFFFF&(data))

#define  DI_DI_DDR_CHECKSUM_MASK_0                                              0x18024960
#define  DI_DI_DDR_CHECKSUM_MASK_0_reg_addr                                      "0xB8024960"
#define  DI_DI_DDR_CHECKSUM_MASK_0_reg                                           0xB8024960
#define  DI_DI_DDR_CHECKSUM_MASK_0_inst_addr                                     "0x0165"
#define  set_DI_DI_DDR_CHECKSUM_MASK_0_reg(data)                                 (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_MASK_0_reg)=data)
#define  get_DI_DI_DDR_CHECKSUM_MASK_0_reg                                       (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_MASK_0_reg))
#define  DI_DI_DDR_CHECKSUM_MASK_0_di_ddr_error_mask_127_96_shift                (0)
#define  DI_DI_DDR_CHECKSUM_MASK_0_di_ddr_error_mask_127_96_mask                 (0xFFFFFFFF)
#define  DI_DI_DDR_CHECKSUM_MASK_0_di_ddr_error_mask_127_96(data)                (0xFFFFFFFF&(data))
#define  DI_DI_DDR_CHECKSUM_MASK_0_get_di_ddr_error_mask_127_96(data)            (0xFFFFFFFF&(data))

#define  DI_DI_DDR_CHECKSUM_MASK_1                                              0x18024964
#define  DI_DI_DDR_CHECKSUM_MASK_1_reg_addr                                      "0xB8024964"
#define  DI_DI_DDR_CHECKSUM_MASK_1_reg                                           0xB8024964
#define  DI_DI_DDR_CHECKSUM_MASK_1_inst_addr                                     "0x0166"
#define  set_DI_DI_DDR_CHECKSUM_MASK_1_reg(data)                                 (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_MASK_1_reg)=data)
#define  get_DI_DI_DDR_CHECKSUM_MASK_1_reg                                       (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_MASK_1_reg))
#define  DI_DI_DDR_CHECKSUM_MASK_1_di_ddr_error_mask_95_64_shift                 (0)
#define  DI_DI_DDR_CHECKSUM_MASK_1_di_ddr_error_mask_95_64_mask                  (0xFFFFFFFF)
#define  DI_DI_DDR_CHECKSUM_MASK_1_di_ddr_error_mask_95_64(data)                 (0xFFFFFFFF&(data))
#define  DI_DI_DDR_CHECKSUM_MASK_1_get_di_ddr_error_mask_95_64(data)             (0xFFFFFFFF&(data))

#define  DI_DI_DDR_CHECKSUM_MASK_2                                              0x18024968
#define  DI_DI_DDR_CHECKSUM_MASK_2_reg_addr                                      "0xB8024968"
#define  DI_DI_DDR_CHECKSUM_MASK_2_reg                                           0xB8024968
#define  DI_DI_DDR_CHECKSUM_MASK_2_inst_addr                                     "0x0167"
#define  set_DI_DI_DDR_CHECKSUM_MASK_2_reg(data)                                 (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_MASK_2_reg)=data)
#define  get_DI_DI_DDR_CHECKSUM_MASK_2_reg                                       (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_MASK_2_reg))
#define  DI_DI_DDR_CHECKSUM_MASK_2_di_ddr_error_mask_63_32_shift                 (0)
#define  DI_DI_DDR_CHECKSUM_MASK_2_di_ddr_error_mask_63_32_mask                  (0xFFFFFFFF)
#define  DI_DI_DDR_CHECKSUM_MASK_2_di_ddr_error_mask_63_32(data)                 (0xFFFFFFFF&(data))
#define  DI_DI_DDR_CHECKSUM_MASK_2_get_di_ddr_error_mask_63_32(data)             (0xFFFFFFFF&(data))

#define  DI_DI_DDR_CHECKSUM_MASK_3                                              0x1802496C
#define  DI_DI_DDR_CHECKSUM_MASK_3_reg_addr                                      "0xB802496C"
#define  DI_DI_DDR_CHECKSUM_MASK_3_reg                                           0xB802496C
#define  DI_DI_DDR_CHECKSUM_MASK_3_inst_addr                                     "0x0168"
#define  set_DI_DI_DDR_CHECKSUM_MASK_3_reg(data)                                 (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_MASK_3_reg)=data)
#define  get_DI_DI_DDR_CHECKSUM_MASK_3_reg                                       (*((volatile unsigned int*)DI_DI_DDR_CHECKSUM_MASK_3_reg))
#define  DI_DI_DDR_CHECKSUM_MASK_3_di_ddr_error_mask_31_0_shift                  (0)
#define  DI_DI_DDR_CHECKSUM_MASK_3_di_ddr_error_mask_31_0_mask                   (0xFFFFFFFF)
#define  DI_DI_DDR_CHECKSUM_MASK_3_di_ddr_error_mask_31_0(data)                  (0xFFFFFFFF&(data))
#define  DI_DI_DDR_CHECKSUM_MASK_3_get_di_ddr_error_mask_31_0(data)              (0xFFFFFFFF&(data))

#define  DI_IM_NEW_MCNR_CONTROL2                                                0x18024970
#define  DI_IM_NEW_MCNR_CONTROL2_reg_addr                                        "0xB8024970"
#define  DI_IM_NEW_MCNR_CONTROL2_reg                                             0xB8024970
#define  DI_IM_NEW_MCNR_CONTROL2_inst_addr                                       "0x0169"
#define  set_DI_IM_NEW_MCNR_CONTROL2_reg(data)                                   (*((volatile unsigned int*)DI_IM_NEW_MCNR_CONTROL2_reg)=data)
#define  get_DI_IM_NEW_MCNR_CONTROL2_reg                                         (*((volatile unsigned int*)DI_IM_NEW_MCNR_CONTROL2_reg))
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_mad_min_uv_th_shift                      (24)
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_mad_min_th_shift                         (16)
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_y_boundary_th_shift                      (8)
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_v_pre_loadok_clr_shift                   (7)
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_v_pre_loadok_shift                       (6)
#define  DI_IM_NEW_MCNR_CONTROL2_cp_temporal_hmcnr_search_range_shift            (0)
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_mad_min_uv_th_mask                       (0xFF000000)
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_mad_min_th_mask                          (0x00FF0000)
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_y_boundary_th_mask                       (0x00000F00)
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_v_pre_loadok_clr_mask                    (0x00000080)
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_v_pre_loadok_mask                        (0x00000040)
#define  DI_IM_NEW_MCNR_CONTROL2_cp_temporal_hmcnr_search_range_mask             (0x0000000F)
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_mad_min_uv_th(data)                      (0xFF000000&((data)<<24))
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_mad_min_th(data)                         (0x00FF0000&((data)<<16))
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_y_boundary_th(data)                      (0x00000F00&((data)<<8))
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_v_pre_loadok_clr(data)                   (0x00000080&((data)<<7))
#define  DI_IM_NEW_MCNR_CONTROL2_n_mcnr_v_pre_loadok(data)                       (0x00000040&((data)<<6))
#define  DI_IM_NEW_MCNR_CONTROL2_cp_temporal_hmcnr_search_range(data)            (0x0000000F&(data))
#define  DI_IM_NEW_MCNR_CONTROL2_get_n_mcnr_mad_min_uv_th(data)                  ((0xFF000000&(data))>>24)
#define  DI_IM_NEW_MCNR_CONTROL2_get_n_mcnr_mad_min_th(data)                     ((0x00FF0000&(data))>>16)
#define  DI_IM_NEW_MCNR_CONTROL2_get_n_mcnr_y_boundary_th(data)                  ((0x00000F00&(data))>>8)
#define  DI_IM_NEW_MCNR_CONTROL2_get_n_mcnr_v_pre_loadok_clr(data)               ((0x00000080&(data))>>7)
#define  DI_IM_NEW_MCNR_CONTROL2_get_n_mcnr_v_pre_loadok(data)                   ((0x00000040&(data))>>6)
#define  DI_IM_NEW_MCNR_CONTROL2_get_cp_temporal_hmcnr_search_range(data)        (0x0000000F&(data))

#define  DI_DI_SMD_WaterFlow_Teeth_Ctr                                          0x18024974
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_reg_addr                                  "0xB8024974"
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_reg                                       0xB8024974
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_inst_addr                                 "0x016A"
#define  set_DI_DI_SMD_WaterFlow_Teeth_Ctr_reg(data)                             (*((volatile unsigned int*)DI_DI_SMD_WaterFlow_Teeth_Ctr_reg)=data)
#define  get_DI_DI_SMD_WaterFlow_Teeth_Ctr_reg                                   (*((volatile unsigned int*)DI_DI_SMD_WaterFlow_Teeth_Ctr_reg))
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_sawtooth_count_th_wf_shift            (20)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_min_total_th_wf_shift                 (16)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_compensate_teeth_th_wf_shift          (12)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_totalteethoffset_wf_shift             (8)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_currteethgain_wf_shift                (4)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_debugsawtooth_waterflow_en_shift      (1)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_waterflow_protect_en_shift            (0)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_sawtooth_count_th_wf_mask             (0x0FF00000)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_min_total_th_wf_mask                  (0x000F0000)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_compensate_teeth_th_wf_mask           (0x0000F000)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_totalteethoffset_wf_mask              (0x00000F00)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_currteethgain_wf_mask                 (0x000000F0)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_debugsawtooth_waterflow_en_mask       (0x00000002)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_waterflow_protect_en_mask             (0x00000001)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_sawtooth_count_th_wf(data)            (0x0FF00000&((data)<<20))
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_min_total_th_wf(data)                 (0x000F0000&((data)<<16))
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_compensate_teeth_th_wf(data)          (0x0000F000&((data)<<12))
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_totalteethoffset_wf(data)             (0x00000F00&((data)<<8))
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_currteethgain_wf(data)                (0x000000F0&((data)<<4))
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_debugsawtooth_waterflow_en(data)      (0x00000002&((data)<<1))
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_smd_waterflow_protect_en(data)            (0x00000001&(data))
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_get_smd_sawtooth_count_th_wf(data)        ((0x0FF00000&(data))>>20)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_get_smd_min_total_th_wf(data)             ((0x000F0000&(data))>>16)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_get_smd_compensate_teeth_th_wf(data)      ((0x0000F000&(data))>>12)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_get_smd_totalteethoffset_wf(data)         ((0x00000F00&(data))>>8)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_get_smd_currteethgain_wf(data)            ((0x000000F0&(data))>>4)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_get_smd_debugsawtooth_waterflow_en(data)  ((0x00000002&(data))>>1)
#define  DI_DI_SMD_WaterFlow_Teeth_Ctr_get_smd_waterflow_protect_en(data)        (0x00000001&(data))

#define  DI_DI_SMD_WaterFlow_Teeth_Count                                        0x18024978
#define  DI_DI_SMD_WaterFlow_Teeth_Count_reg_addr                                "0xB8024978"
#define  DI_DI_SMD_WaterFlow_Teeth_Count_reg                                     0xB8024978
#define  DI_DI_SMD_WaterFlow_Teeth_Count_inst_addr                               "0x016B"
#define  set_DI_DI_SMD_WaterFlow_Teeth_Count_reg(data)                           (*((volatile unsigned int*)DI_DI_SMD_WaterFlow_Teeth_Count_reg)=data)
#define  get_DI_DI_SMD_WaterFlow_Teeth_Count_reg                                 (*((volatile unsigned int*)DI_DI_SMD_WaterFlow_Teeth_Count_reg))
#define  DI_DI_SMD_WaterFlow_Teeth_Count_smd_sawtooth_count_wf_shift             (0)
#define  DI_DI_SMD_WaterFlow_Teeth_Count_smd_sawtooth_count_wf_mask              (0x0000FFFF)
#define  DI_DI_SMD_WaterFlow_Teeth_Count_smd_sawtooth_count_wf(data)             (0x0000FFFF&(data))
#define  DI_DI_SMD_WaterFlow_Teeth_Count_get_smd_sawtooth_count_wf(data)         (0x0000FFFF&(data))

#define  DI_DI_SMD_MA_MC_Weight_Ctr                                             0x1802497C
#define  DI_DI_SMD_MA_MC_Weight_Ctr_reg_addr                                     "0xB802497C"
#define  DI_DI_SMD_MA_MC_Weight_Ctr_reg                                          0xB802497C
#define  DI_DI_SMD_MA_MC_Weight_Ctr_inst_addr                                    "0x016C"
#define  set_DI_DI_SMD_MA_MC_Weight_Ctr_reg(data)                                (*((volatile unsigned int*)DI_DI_SMD_MA_MC_Weight_Ctr_reg)=data)
#define  get_DI_DI_SMD_MA_MC_Weight_Ctr_reg                                      (*((volatile unsigned int*)DI_DI_SMD_MA_MC_Weight_Ctr_reg))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatialmv_method_shift                   (30)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_db_tmv_out_shift                         (29)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_db_tmv_shift_shift                       (28)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_still_ma_en_shift                        (27)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_mv0_no_intra_en_shift                    (26)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outdata_limit_mvy_shift                  (24)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outdata_limit_mvx_shift                  (20)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outdata_limit_en_shift                   (16)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatial_mv_diff_gain_shift               (12)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatial_mv_diff_coring_shift             (8)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_odd_mvy_ma_out_select_shift              (5)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_smd_weight_out_debug_en_shift            (4)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatial_mv_diff_weight_en_shift          (3)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_smd_blend_clamp_en_shift                 (2)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_smd_blend_lpf_en_shift                   (1)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outofrange_lpf_en_shift                  (0)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatialmv_method_mask                    (0x40000000)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_db_tmv_out_mask                          (0x20000000)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_db_tmv_shift_mask                        (0x10000000)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_still_ma_en_mask                         (0x08000000)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_mv0_no_intra_en_mask                     (0x04000000)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outdata_limit_mvy_mask                   (0x03000000)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outdata_limit_mvx_mask                   (0x00300000)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outdata_limit_en_mask                    (0x00010000)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatial_mv_diff_gain_mask                (0x0000F000)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatial_mv_diff_coring_mask              (0x00000F00)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_odd_mvy_ma_out_select_mask               (0x00000020)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_smd_weight_out_debug_en_mask             (0x00000010)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatial_mv_diff_weight_en_mask           (0x00000008)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_smd_blend_clamp_en_mask                  (0x00000004)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_smd_blend_lpf_en_mask                    (0x00000002)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outofrange_lpf_en_mask                   (0x00000001)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatialmv_method(data)                   (0x40000000&((data)<<30))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_db_tmv_out(data)                         (0x20000000&((data)<<29))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_db_tmv_shift(data)                       (0x10000000&((data)<<28))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_still_ma_en(data)                        (0x08000000&((data)<<27))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_mv0_no_intra_en(data)                    (0x04000000&((data)<<26))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outdata_limit_mvy(data)                  (0x03000000&((data)<<24))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outdata_limit_mvx(data)                  (0x00300000&((data)<<20))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outdata_limit_en(data)                   (0x00010000&((data)<<16))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatial_mv_diff_gain(data)               (0x0000F000&((data)<<12))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatial_mv_diff_coring(data)             (0x00000F00&((data)<<8))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_odd_mvy_ma_out_select(data)              (0x00000020&((data)<<5))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_smd_weight_out_debug_en(data)            (0x00000010&((data)<<4))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_spatial_mv_diff_weight_en(data)          (0x00000008&((data)<<3))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_smd_blend_clamp_en(data)                 (0x00000004&((data)<<2))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_smd_blend_lpf_en(data)                   (0x00000002&((data)<<1))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_smd_outofrange_lpf_en(data)                  (0x00000001&(data))
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_spatialmv_method(data)               ((0x40000000&(data))>>30)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_db_tmv_out(data)                     ((0x20000000&(data))>>29)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_db_tmv_shift(data)                   ((0x10000000&(data))>>28)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_still_ma_en(data)                    ((0x08000000&(data))>>27)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_mv0_no_intra_en(data)                ((0x04000000&(data))>>26)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_outdata_limit_mvy(data)              ((0x03000000&(data))>>24)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_outdata_limit_mvx(data)              ((0x00300000&(data))>>20)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_outdata_limit_en(data)               ((0x00010000&(data))>>16)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_spatial_mv_diff_gain(data)           ((0x0000F000&(data))>>12)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_spatial_mv_diff_coring(data)         ((0x00000F00&(data))>>8)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_odd_mvy_ma_out_select(data)          ((0x00000020&(data))>>5)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_smd_weight_out_debug_en(data)        ((0x00000010&(data))>>4)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_spatial_mv_diff_weight_en(data)      ((0x00000008&(data))>>3)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_smd_blend_clamp_en(data)             ((0x00000004&(data))>>2)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_smd_blend_lpf_en(data)               ((0x00000002&(data))>>1)
#define  DI_DI_SMD_MA_MC_Weight_Ctr_get_smd_outofrange_lpf_en(data)              (0x00000001&(data))

#define  DI_DI_SMD_Diag_Edge_Protect_Ctr                                        0x18024980
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_reg_addr                                "0xB8024980"
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_reg                                     0xB8024980
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_inst_addr                               "0x016D"
#define  set_DI_DI_SMD_Diag_Edge_Protect_Ctr_reg(data)                           (*((volatile unsigned int*)DI_DI_SMD_Diag_Edge_Protect_Ctr_reg)=data)
#define  get_DI_DI_SMD_Diag_Edge_Protect_Ctr_reg                                 (*((volatile unsigned int*)DI_DI_SMD_Diag_Edge_Protect_Ctr_reg))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_smd_ma_only_center_en_shift         (27)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_smd_ma_only_v_en_shift              (26)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_smd_vs_detect_length_shift          (25)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_nintra_v_dir_flag_en_shift              (24)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_nintra_h_diff_th_shift                  (16)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_nintra_hv_diff_th_shift                 (8)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_diag_count_th_shift                 (5)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_intra_weight_method_vpan_shift      (4)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_intra_weight_method_shift           (3)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_mcdi2madi_debug_en_shift            (2)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_mcdi2madi_v_pan_new_en_shift        (1)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_mcdi2madi_en_shift                  (0)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_smd_ma_only_center_en_mask          (0x08000000)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_smd_ma_only_v_en_mask               (0x04000000)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_smd_vs_detect_length_mask           (0x02000000)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_nintra_v_dir_flag_en_mask               (0x01000000)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_nintra_h_diff_th_mask                   (0x00FF0000)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_nintra_hv_diff_th_mask                  (0x0000FF00)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_diag_count_th_mask                  (0x000000E0)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_intra_weight_method_vpan_mask       (0x00000010)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_intra_weight_method_mask            (0x00000008)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_mcdi2madi_debug_en_mask             (0x00000004)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_mcdi2madi_v_pan_new_en_mask         (0x00000002)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_mcdi2madi_en_mask                   (0x00000001)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_smd_ma_only_center_en(data)         (0x08000000&((data)<<27))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_smd_ma_only_v_en(data)              (0x04000000&((data)<<26))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_smd_vs_detect_length(data)          (0x02000000&((data)<<25))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_nintra_v_dir_flag_en(data)              (0x01000000&((data)<<24))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_nintra_h_diff_th(data)                  (0x00FF0000&((data)<<16))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_nintra_hv_diff_th(data)                 (0x0000FF00&((data)<<8))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_diag_count_th(data)                 (0x000000E0&((data)<<5))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_intra_weight_method_vpan(data)      (0x00000010&((data)<<4))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_intra_weight_method(data)           (0x00000008&((data)<<3))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_mcdi2madi_debug_en(data)            (0x00000004&((data)<<2))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_mcdi2madi_v_pan_new_en(data)        (0x00000002&((data)<<1))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_smd_mcdi2madi_en(data)                  (0x00000001&(data))
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_smd_smd_ma_only_center_en(data)     ((0x08000000&(data))>>27)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_smd_smd_ma_only_v_en(data)          ((0x04000000&(data))>>26)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_smd_smd_vs_detect_length(data)      ((0x02000000&(data))>>25)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_nintra_v_dir_flag_en(data)          ((0x01000000&(data))>>24)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_nintra_h_diff_th(data)              ((0x00FF0000&(data))>>16)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_nintra_hv_diff_th(data)             ((0x0000FF00&(data))>>8)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_smd_diag_count_th(data)             ((0x000000E0&(data))>>5)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_smd_intra_weight_method_vpan(data)  ((0x00000010&(data))>>4)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_smd_intra_weight_method(data)       ((0x00000008&(data))>>3)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_smd_mcdi2madi_debug_en(data)        ((0x00000004&(data))>>2)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_smd_mcdi2madi_v_pan_new_en(data)    ((0x00000002&(data))>>1)
#define  DI_DI_SMD_Diag_Edge_Protect_Ctr_get_smd_mcdi2madi_en(data)              (0x00000001&(data))

#define  DI_DI_SMD_Slow_Motion_handle1                                          0x18024984
#define  DI_DI_SMD_Slow_Motion_handle1_reg_addr                                  "0xB8024984"
#define  DI_DI_SMD_Slow_Motion_handle1_reg                                       0xB8024984
#define  DI_DI_SMD_Slow_Motion_handle1_inst_addr                                 "0x016E"
#define  set_DI_DI_SMD_Slow_Motion_handle1_reg(data)                             (*((volatile unsigned int*)DI_DI_SMD_Slow_Motion_handle1_reg)=data)
#define  get_DI_DI_SMD_Slow_Motion_handle1_reg                                   (*((volatile unsigned int*)DI_DI_SMD_Slow_Motion_handle1_reg))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_resurrectsmallwindownum2_shift        (28)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mv_pixel_acc_th2_shift                (24)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mv_pixel_acc_th_shift                 (20)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mv_pixel_acc_max_th_shift             (16)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_weight_lpf_select_shift               (15)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_outrange_teeth_select_shift           (13)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_teeth_value_select_shift              (12)
#define  DI_DI_SMD_Slow_Motion_handle1_gst_min_sad_nolimit_en_shift              (11)
#define  DI_DI_SMD_Slow_Motion_handle1_gst_gst_static_disable_shift              (10)
#define  DI_DI_SMD_Slow_Motion_handle1_gst_min_sad_compare_diable_shift          (9)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_linecontinous_new_condition_shift     (8)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_weave_dynamic_shift                   (6)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_spatialfreqnomatch_off_shift          (5)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_acc_smd_en_shift                      (4)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mess_conditionoff_shift               (3)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_sawtooth_condition_select_shift       (2)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_outofrange_content_new_shift          (1)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_acc_ctr_reset_shift                   (0)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_resurrectsmallwindownum2_mask         (0xF0000000)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mv_pixel_acc_th2_mask                 (0x07000000)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mv_pixel_acc_th_mask                  (0x00700000)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mv_pixel_acc_max_th_mask              (0x00070000)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_weight_lpf_select_mask                (0x00008000)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_outrange_teeth_select_mask            (0x00006000)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_teeth_value_select_mask               (0x00001000)
#define  DI_DI_SMD_Slow_Motion_handle1_gst_min_sad_nolimit_en_mask               (0x00000800)
#define  DI_DI_SMD_Slow_Motion_handle1_gst_gst_static_disable_mask               (0x00000400)
#define  DI_DI_SMD_Slow_Motion_handle1_gst_min_sad_compare_diable_mask           (0x00000200)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_linecontinous_new_condition_mask      (0x00000100)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_weave_dynamic_mask                    (0x000000C0)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_spatialfreqnomatch_off_mask           (0x00000020)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_acc_smd_en_mask                       (0x00000010)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mess_conditionoff_mask                (0x00000008)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_sawtooth_condition_select_mask        (0x00000004)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_outofrange_content_new_mask           (0x00000002)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_acc_ctr_reset_mask                    (0x00000001)
#define  DI_DI_SMD_Slow_Motion_handle1_smd_resurrectsmallwindownum2(data)        (0xF0000000&((data)<<28))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mv_pixel_acc_th2(data)                (0x07000000&((data)<<24))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mv_pixel_acc_th(data)                 (0x00700000&((data)<<20))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mv_pixel_acc_max_th(data)             (0x00070000&((data)<<16))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_weight_lpf_select(data)               (0x00008000&((data)<<15))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_outrange_teeth_select(data)           (0x00006000&((data)<<13))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_teeth_value_select(data)              (0x00001000&((data)<<12))
#define  DI_DI_SMD_Slow_Motion_handle1_gst_min_sad_nolimit_en(data)              (0x00000800&((data)<<11))
#define  DI_DI_SMD_Slow_Motion_handle1_gst_gst_static_disable(data)              (0x00000400&((data)<<10))
#define  DI_DI_SMD_Slow_Motion_handle1_gst_min_sad_compare_diable(data)          (0x00000200&((data)<<9))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_linecontinous_new_condition(data)     (0x00000100&((data)<<8))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_weave_dynamic(data)                   (0x000000C0&((data)<<6))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_spatialfreqnomatch_off(data)          (0x00000020&((data)<<5))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_acc_smd_en(data)                      (0x00000010&((data)<<4))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_mess_conditionoff(data)               (0x00000008&((data)<<3))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_sawtooth_condition_select(data)       (0x00000004&((data)<<2))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_outofrange_content_new(data)          (0x00000002&((data)<<1))
#define  DI_DI_SMD_Slow_Motion_handle1_smd_acc_ctr_reset(data)                   (0x00000001&(data))
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_resurrectsmallwindownum2(data)    ((0xF0000000&(data))>>28)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_mv_pixel_acc_th2(data)            ((0x07000000&(data))>>24)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_mv_pixel_acc_th(data)             ((0x00700000&(data))>>20)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_mv_pixel_acc_max_th(data)         ((0x00070000&(data))>>16)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_weight_lpf_select(data)           ((0x00008000&(data))>>15)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_outrange_teeth_select(data)       ((0x00006000&(data))>>13)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_teeth_value_select(data)          ((0x00001000&(data))>>12)
#define  DI_DI_SMD_Slow_Motion_handle1_get_gst_min_sad_nolimit_en(data)          ((0x00000800&(data))>>11)
#define  DI_DI_SMD_Slow_Motion_handle1_get_gst_gst_static_disable(data)          ((0x00000400&(data))>>10)
#define  DI_DI_SMD_Slow_Motion_handle1_get_gst_min_sad_compare_diable(data)      ((0x00000200&(data))>>9)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_linecontinous_new_condition(data) ((0x00000100&(data))>>8)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_weave_dynamic(data)               ((0x000000C0&(data))>>6)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_spatialfreqnomatch_off(data)      ((0x00000020&(data))>>5)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_acc_smd_en(data)                  ((0x00000010&(data))>>4)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_mess_conditionoff(data)           ((0x00000008&(data))>>3)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_sawtooth_condition_select(data)   ((0x00000004&(data))>>2)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_outofrange_content_new(data)      ((0x00000002&(data))>>1)
#define  DI_DI_SMD_Slow_Motion_handle1_get_smd_acc_ctr_reset(data)               (0x00000001&(data))

#define  DI_DI_SMD_Slow_Motion_handle2                                          0x18024988
#define  DI_DI_SMD_Slow_Motion_handle2_reg_addr                                  "0xB8024988"
#define  DI_DI_SMD_Slow_Motion_handle2_reg                                       0xB8024988
#define  DI_DI_SMD_Slow_Motion_handle2_inst_addr                                 "0x016F"
#define  set_DI_DI_SMD_Slow_Motion_handle2_reg(data)                             (*((volatile unsigned int*)DI_DI_SMD_Slow_Motion_handle2_reg)=data)
#define  get_DI_DI_SMD_Slow_Motion_handle2_reg                                   (*((volatile unsigned int*)DI_DI_SMD_Slow_Motion_handle2_reg))
#define  DI_DI_SMD_Slow_Motion_handle2_smd_mv_pixel_acc_th3_shift                (28)
#define  DI_DI_SMD_Slow_Motion_handle2_smd_messlevel_gain2_shift                 (24)
#define  DI_DI_SMD_Slow_Motion_handle2_smd_messlevel_gain_shift                  (20)
#define  DI_DI_SMD_Slow_Motion_handle2_gst_mv_limit_shift                        (16)
#define  DI_DI_SMD_Slow_Motion_handle2_smd_resurrectminsadth2_shift              (8)
#define  DI_DI_SMD_Slow_Motion_handle2_smd_reliablerangesadth2_shift             (0)
#define  DI_DI_SMD_Slow_Motion_handle2_smd_mv_pixel_acc_th3_mask                 (0x70000000)
#define  DI_DI_SMD_Slow_Motion_handle2_smd_messlevel_gain2_mask                  (0x0F000000)
#define  DI_DI_SMD_Slow_Motion_handle2_smd_messlevel_gain_mask                   (0x00F00000)
#define  DI_DI_SMD_Slow_Motion_handle2_gst_mv_limit_mask                         (0x00030000)
#define  DI_DI_SMD_Slow_Motion_handle2_smd_resurrectminsadth2_mask               (0x0000FF00)
#define  DI_DI_SMD_Slow_Motion_handle2_smd_reliablerangesadth2_mask              (0x000000FF)
#define  DI_DI_SMD_Slow_Motion_handle2_smd_mv_pixel_acc_th3(data)                (0x70000000&((data)<<28))
#define  DI_DI_SMD_Slow_Motion_handle2_smd_messlevel_gain2(data)                 (0x0F000000&((data)<<24))
#define  DI_DI_SMD_Slow_Motion_handle2_smd_messlevel_gain(data)                  (0x00F00000&((data)<<20))
#define  DI_DI_SMD_Slow_Motion_handle2_gst_mv_limit(data)                        (0x00030000&((data)<<16))
#define  DI_DI_SMD_Slow_Motion_handle2_smd_resurrectminsadth2(data)              (0x0000FF00&((data)<<8))
#define  DI_DI_SMD_Slow_Motion_handle2_smd_reliablerangesadth2(data)             (0x000000FF&(data))
#define  DI_DI_SMD_Slow_Motion_handle2_get_smd_mv_pixel_acc_th3(data)            ((0x70000000&(data))>>28)
#define  DI_DI_SMD_Slow_Motion_handle2_get_smd_messlevel_gain2(data)             ((0x0F000000&(data))>>24)
#define  DI_DI_SMD_Slow_Motion_handle2_get_smd_messlevel_gain(data)              ((0x00F00000&(data))>>20)
#define  DI_DI_SMD_Slow_Motion_handle2_get_gst_mv_limit(data)                    ((0x00030000&(data))>>16)
#define  DI_DI_SMD_Slow_Motion_handle2_get_smd_resurrectminsadth2(data)          ((0x0000FF00&(data))>>8)
#define  DI_DI_SMD_Slow_Motion_handle2_get_smd_reliablerangesadth2(data)         (0x000000FF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7                                         0x1802498C
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_reg_addr                                 "0xB802498C"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_reg                                      0xB802498C
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_inst_addr                                "0x0170"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_7_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_7_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_7_reg                                  (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_7_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_mcnr_r10_sum_shift                       (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_mcnr_r9_sum_shift                        (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_mcnr_r10_sum_mask                        (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_mcnr_r9_sum_mask                         (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_mcnr_r10_sum(data)                       (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_mcnr_r9_sum(data)                        (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_get_mcnr_r10_sum(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_7_get_mcnr_r9_sum(data)                    (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8                                         0x18024990
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_reg_addr                                 "0xB8024990"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_reg                                      0xB8024990
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_inst_addr                                "0x0171"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_8_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_8_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_8_reg                                  (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_8_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_mcnr_r8_sum_shift                        (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_mcnr_r7_sum_shift                        (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_mcnr_r8_sum_mask                         (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_mcnr_r7_sum_mask                         (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_mcnr_r8_sum(data)                        (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_mcnr_r7_sum(data)                        (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_get_mcnr_r8_sum(data)                    ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_8_get_mcnr_r7_sum(data)                    (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9                                         0x18024994
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_reg_addr                                 "0xB8024994"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_reg                                      0xB8024994
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_inst_addr                                "0x0172"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_9_reg(data)                            (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_9_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_9_reg                                  (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_9_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_mcnr_r6_sum_shift                        (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_mcnr_l6_sum_shift                        (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_mcnr_r6_sum_mask                         (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_mcnr_l6_sum_mask                         (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_mcnr_r6_sum(data)                        (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_mcnr_l6_sum(data)                        (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_get_mcnr_r6_sum(data)                    ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_9_get_mcnr_l6_sum(data)                    (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10                                        0x18024998
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_reg_addr                                "0xB8024998"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_reg                                     0xB8024998
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_inst_addr                               "0x0173"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_10_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_10_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_10_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_10_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_mcnr_l7_sum_shift                       (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_mcnr_l8_sum_shift                       (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_mcnr_l7_sum_mask                        (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_mcnr_l8_sum_mask                        (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_mcnr_l7_sum(data)                       (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_mcnr_l8_sum(data)                       (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_get_mcnr_l7_sum(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_10_get_mcnr_l8_sum(data)                   (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11                                        0x1802499C
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_reg_addr                                "0xB802499C"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_reg                                     0xB802499C
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_inst_addr                               "0x0174"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_11_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_11_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_11_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_11_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_mcnr_l9_sum_shift                       (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_mcnr_l10_sum_shift                      (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_mcnr_l9_sum_mask                        (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_mcnr_l10_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_mcnr_l9_sum(data)                       (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_mcnr_l10_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_get_mcnr_l9_sum(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_11_get_mcnr_l10_sum(data)                  (0x0000FFFF&(data))

#define  DI_DI_SMD_Slow_Motion_handle3                                          0x180249A0
#define  DI_DI_SMD_Slow_Motion_handle3_reg_addr                                  "0xB80249A0"
#define  DI_DI_SMD_Slow_Motion_handle3_reg                                       0xB80249A0
#define  DI_DI_SMD_Slow_Motion_handle3_inst_addr                                 "0x0175"
#define  set_DI_DI_SMD_Slow_Motion_handle3_reg(data)                             (*((volatile unsigned int*)DI_DI_SMD_Slow_Motion_handle3_reg)=data)
#define  get_DI_DI_SMD_Slow_Motion_handle3_reg                                   (*((volatile unsigned int*)DI_DI_SMD_Slow_Motion_handle3_reg))
#define  DI_DI_SMD_Slow_Motion_handle3_smd_outrange_field_diff_th_shift          (24)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_compensate_teeth_th2_shift            (20)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_field_diff_clamp_shift                (12)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_messlevel_vgain_shift                 (9)
#define  DI_DI_SMD_Slow_Motion_handle3_ma_smd_h_compensate_new_en_shift          (6)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_teeth_no_ressurrect_n_en_shift        (5)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_search_range_limit_en_shift           (4)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_hd_zero_mv_sad_select_shift           (3)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_messlevel_select_shift                (1)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_sadwindow_select_shift                (0)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_outrange_field_diff_th_mask           (0xFF000000)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_compensate_teeth_th2_mask             (0x00F00000)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_field_diff_clamp_mask                 (0x000FF000)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_messlevel_vgain_mask                  (0x00000E00)
#define  DI_DI_SMD_Slow_Motion_handle3_ma_smd_h_compensate_new_en_mask           (0x00000040)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_teeth_no_ressurrect_n_en_mask         (0x00000020)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_search_range_limit_en_mask            (0x00000010)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_hd_zero_mv_sad_select_mask            (0x00000008)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_messlevel_select_mask                 (0x00000006)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_sadwindow_select_mask                 (0x00000001)
#define  DI_DI_SMD_Slow_Motion_handle3_smd_outrange_field_diff_th(data)          (0xFF000000&((data)<<24))
#define  DI_DI_SMD_Slow_Motion_handle3_smd_compensate_teeth_th2(data)            (0x00F00000&((data)<<20))
#define  DI_DI_SMD_Slow_Motion_handle3_smd_field_diff_clamp(data)                (0x000FF000&((data)<<12))
#define  DI_DI_SMD_Slow_Motion_handle3_smd_messlevel_vgain(data)                 (0x00000E00&((data)<<9))
#define  DI_DI_SMD_Slow_Motion_handle3_ma_smd_h_compensate_new_en(data)          (0x00000040&((data)<<6))
#define  DI_DI_SMD_Slow_Motion_handle3_smd_teeth_no_ressurrect_n_en(data)        (0x00000020&((data)<<5))
#define  DI_DI_SMD_Slow_Motion_handle3_smd_search_range_limit_en(data)           (0x00000010&((data)<<4))
#define  DI_DI_SMD_Slow_Motion_handle3_smd_hd_zero_mv_sad_select(data)           (0x00000008&((data)<<3))
#define  DI_DI_SMD_Slow_Motion_handle3_smd_messlevel_select(data)                (0x00000006&((data)<<1))
#define  DI_DI_SMD_Slow_Motion_handle3_smd_sadwindow_select(data)                (0x00000001&(data))
#define  DI_DI_SMD_Slow_Motion_handle3_get_smd_outrange_field_diff_th(data)      ((0xFF000000&(data))>>24)
#define  DI_DI_SMD_Slow_Motion_handle3_get_smd_compensate_teeth_th2(data)        ((0x00F00000&(data))>>20)
#define  DI_DI_SMD_Slow_Motion_handle3_get_smd_field_diff_clamp(data)            ((0x000FF000&(data))>>12)
#define  DI_DI_SMD_Slow_Motion_handle3_get_smd_messlevel_vgain(data)             ((0x00000E00&(data))>>9)
#define  DI_DI_SMD_Slow_Motion_handle3_get_ma_smd_h_compensate_new_en(data)      ((0x00000040&(data))>>6)
#define  DI_DI_SMD_Slow_Motion_handle3_get_smd_teeth_no_ressurrect_n_en(data)    ((0x00000020&(data))>>5)
#define  DI_DI_SMD_Slow_Motion_handle3_get_smd_search_range_limit_en(data)       ((0x00000010&(data))>>4)
#define  DI_DI_SMD_Slow_Motion_handle3_get_smd_hd_zero_mv_sad_select(data)       ((0x00000008&(data))>>3)
#define  DI_DI_SMD_Slow_Motion_handle3_get_smd_messlevel_select(data)            ((0x00000006&(data))>>1)
#define  DI_DI_SMD_Slow_Motion_handle3_get_smd_sadwindow_select(data)            (0x00000001&(data))

#define  DI_DI_SMD_GMV_Penalty_Ctrl                                             0x180249A4
#define  DI_DI_SMD_GMV_Penalty_Ctrl_reg_addr                                     "0xB80249A4"
#define  DI_DI_SMD_GMV_Penalty_Ctrl_reg                                          0xB80249A4
#define  DI_DI_SMD_GMV_Penalty_Ctrl_inst_addr                                    "0x0176"
#define  set_DI_DI_SMD_GMV_Penalty_Ctrl_reg(data)                                (*((volatile unsigned int*)DI_DI_SMD_GMV_Penalty_Ctrl_reg)=data)
#define  get_DI_DI_SMD_GMV_Penalty_Ctrl_reg                                      (*((volatile unsigned int*)DI_DI_SMD_GMV_Penalty_Ctrl_reg))
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_messlevel_gain_slope_shift               (12)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_messlevel_th_shift                       (4)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_notonly_zero_gmv_shift                   (2)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_fmv_gmv_penalty_en_shift                 (1)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_gmv_candidate_method_shift               (0)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_messlevel_gain_slope_mask                (0x000FF000)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_messlevel_th_mask                        (0x00000FF0)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_notonly_zero_gmv_mask                    (0x00000004)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_fmv_gmv_penalty_en_mask                  (0x00000002)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_gmv_candidate_method_mask                (0x00000001)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_messlevel_gain_slope(data)               (0x000FF000&((data)<<12))
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_messlevel_th(data)                       (0x00000FF0&((data)<<4))
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_notonly_zero_gmv(data)                   (0x00000004&((data)<<2))
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_fmv_gmv_penalty_en(data)                 (0x00000002&((data)<<1))
#define  DI_DI_SMD_GMV_Penalty_Ctrl_smd_gmv_candidate_method(data)               (0x00000001&(data))
#define  DI_DI_SMD_GMV_Penalty_Ctrl_get_smd_messlevel_gain_slope(data)           ((0x000FF000&(data))>>12)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_get_smd_messlevel_th(data)                   ((0x00000FF0&(data))>>4)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_get_smd_notonly_zero_gmv(data)               ((0x00000004&(data))>>2)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_get_smd_fmv_gmv_penalty_en(data)             ((0x00000002&(data))>>1)
#define  DI_DI_SMD_GMV_Penalty_Ctrl_get_smd_gmv_candidate_method(data)           (0x00000001&(data))

#define  DI_DI_SMD_GMV_Penalty_Ctrl2                                            0x180249A8
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_reg_addr                                    "0xB80249A8"
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_reg                                         0xB80249A8
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_inst_addr                                   "0x0177"
#define  set_DI_DI_SMD_GMV_Penalty_Ctrl2_reg(data)                               (*((volatile unsigned int*)DI_DI_SMD_GMV_Penalty_Ctrl2_reg)=data)
#define  get_DI_DI_SMD_GMV_Penalty_Ctrl2_reg                                     (*((volatile unsigned int*)DI_DI_SMD_GMV_Penalty_Ctrl2_reg))
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_messlevel_field_diff_shift              (12)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_clamp_shift                         (4)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_sad_select_shift                    (3)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_penalty_clamp_en_shift              (2)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_only_teeth_mess_gain_en_shift       (1)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_penalty_mess_gain_en_shift          (0)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_messlevel_field_diff_mask               (0x000FF000)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_clamp_mask                          (0x00000FF0)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_sad_select_mask                     (0x00000008)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_penalty_clamp_en_mask               (0x00000004)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_only_teeth_mess_gain_en_mask        (0x00000002)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_penalty_mess_gain_en_mask           (0x00000001)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_messlevel_field_diff(data)              (0x000FF000&((data)<<12))
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_clamp(data)                         (0x00000FF0&((data)<<4))
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_sad_select(data)                    (0x00000008&((data)<<3))
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_penalty_clamp_en(data)              (0x00000004&((data)<<2))
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_only_teeth_mess_gain_en(data)       (0x00000002&((data)<<1))
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_smd_gmv_penalty_mess_gain_en(data)          (0x00000001&(data))
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_get_smd_messlevel_field_diff(data)          ((0x000FF000&(data))>>12)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_get_smd_gmv_clamp(data)                     ((0x00000FF0&(data))>>4)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_get_smd_gmv_sad_select(data)                ((0x00000008&(data))>>3)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_get_smd_gmv_penalty_clamp_en(data)          ((0x00000004&(data))>>2)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_get_smd_gmv_only_teeth_mess_gain_en(data)   ((0x00000002&(data))>>1)
#define  DI_DI_SMD_GMV_Penalty_Ctrl2_get_smd_gmv_penalty_mess_gain_en(data)      (0x00000001&(data))

#define  DI_DI_SMD_Resurrect_Ctrl                                               0x180249AC
#define  DI_DI_SMD_Resurrect_Ctrl_reg_addr                                       "0xB80249AC"
#define  DI_DI_SMD_Resurrect_Ctrl_reg                                            0xB80249AC
#define  DI_DI_SMD_Resurrect_Ctrl_inst_addr                                      "0x0178"
#define  set_DI_DI_SMD_Resurrect_Ctrl_reg(data)                                  (*((volatile unsigned int*)DI_DI_SMD_Resurrect_Ctrl_reg)=data)
#define  get_DI_DI_SMD_Resurrect_Ctrl_reg                                        (*((volatile unsigned int*)DI_DI_SMD_Resurrect_Ctrl_reg))
#define  DI_DI_SMD_Resurrect_Ctrl_smd_mv_teeth_detect_en_shift                   (11)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_notgmv_res_en_shift                        (10)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_teeth_res_en_shift                         (9)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_teeth_detect_method_shift                  (8)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_gst_compensate_avg_en_shift                (7)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_mv_pixel_acc_th4_shift                     (4)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_nongmv0_noacc_en_shift                     (2)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_resurrect_noacc_en_shift                   (1)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_mv_not_gmv_resurrect_en_shift              (0)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_mv_teeth_detect_en_mask                    (0x00000800)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_notgmv_res_en_mask                         (0x00000400)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_teeth_res_en_mask                          (0x00000200)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_teeth_detect_method_mask                   (0x00000100)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_gst_compensate_avg_en_mask                 (0x00000080)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_mv_pixel_acc_th4_mask                      (0x00000070)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_nongmv0_noacc_en_mask                      (0x00000004)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_resurrect_noacc_en_mask                    (0x00000002)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_mv_not_gmv_resurrect_en_mask               (0x00000001)
#define  DI_DI_SMD_Resurrect_Ctrl_smd_mv_teeth_detect_en(data)                   (0x00000800&((data)<<11))
#define  DI_DI_SMD_Resurrect_Ctrl_smd_notgmv_res_en(data)                        (0x00000400&((data)<<10))
#define  DI_DI_SMD_Resurrect_Ctrl_smd_teeth_res_en(data)                         (0x00000200&((data)<<9))
#define  DI_DI_SMD_Resurrect_Ctrl_smd_teeth_detect_method(data)                  (0x00000100&((data)<<8))
#define  DI_DI_SMD_Resurrect_Ctrl_smd_gst_compensate_avg_en(data)                (0x00000080&((data)<<7))
#define  DI_DI_SMD_Resurrect_Ctrl_smd_mv_pixel_acc_th4(data)                     (0x00000070&((data)<<4))
#define  DI_DI_SMD_Resurrect_Ctrl_smd_nongmv0_noacc_en(data)                     (0x00000004&((data)<<2))
#define  DI_DI_SMD_Resurrect_Ctrl_smd_resurrect_noacc_en(data)                   (0x00000002&((data)<<1))
#define  DI_DI_SMD_Resurrect_Ctrl_smd_mv_not_gmv_resurrect_en(data)              (0x00000001&(data))
#define  DI_DI_SMD_Resurrect_Ctrl_get_smd_mv_teeth_detect_en(data)               ((0x00000800&(data))>>11)
#define  DI_DI_SMD_Resurrect_Ctrl_get_smd_notgmv_res_en(data)                    ((0x00000400&(data))>>10)
#define  DI_DI_SMD_Resurrect_Ctrl_get_smd_teeth_res_en(data)                     ((0x00000200&(data))>>9)
#define  DI_DI_SMD_Resurrect_Ctrl_get_smd_teeth_detect_method(data)              ((0x00000100&(data))>>8)
#define  DI_DI_SMD_Resurrect_Ctrl_get_smd_gst_compensate_avg_en(data)            ((0x00000080&(data))>>7)
#define  DI_DI_SMD_Resurrect_Ctrl_get_smd_mv_pixel_acc_th4(data)                 ((0x00000070&(data))>>4)
#define  DI_DI_SMD_Resurrect_Ctrl_get_smd_nongmv0_noacc_en(data)                 ((0x00000004&(data))>>2)
#define  DI_DI_SMD_Resurrect_Ctrl_get_smd_resurrect_noacc_en(data)               ((0x00000002&(data))>>1)
#define  DI_DI_SMD_Resurrect_Ctrl_get_smd_mv_not_gmv_resurrect_en(data)          (0x00000001&(data))

#define  DI_DI_SMD_GMV_FW_COUNTER1                                              0x180249B0
#define  DI_DI_SMD_GMV_FW_COUNTER1_reg_addr                                      "0xB80249B0"
#define  DI_DI_SMD_GMV_FW_COUNTER1_reg                                           0xB80249B0
#define  DI_DI_SMD_GMV_FW_COUNTER1_inst_addr                                     "0x0179"
#define  set_DI_DI_SMD_GMV_FW_COUNTER1_reg(data)                                 (*((volatile unsigned int*)DI_DI_SMD_GMV_FW_COUNTER1_reg)=data)
#define  get_DI_DI_SMD_GMV_FW_COUNTER1_reg                                       (*((volatile unsigned int*)DI_DI_SMD_GMV_FW_COUNTER1_reg))
#define  DI_DI_SMD_GMV_FW_COUNTER1_smd_gmv1maxctr_fw_shift                       (16)
#define  DI_DI_SMD_GMV_FW_COUNTER1_smd_gmvctr_fw_shift                           (0)
#define  DI_DI_SMD_GMV_FW_COUNTER1_smd_gmv1maxctr_fw_mask                        (0xFFFF0000)
#define  DI_DI_SMD_GMV_FW_COUNTER1_smd_gmvctr_fw_mask                            (0x0000FFFF)
#define  DI_DI_SMD_GMV_FW_COUNTER1_smd_gmv1maxctr_fw(data)                       (0xFFFF0000&((data)<<16))
#define  DI_DI_SMD_GMV_FW_COUNTER1_smd_gmvctr_fw(data)                           (0x0000FFFF&(data))
#define  DI_DI_SMD_GMV_FW_COUNTER1_get_smd_gmv1maxctr_fw(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_DI_SMD_GMV_FW_COUNTER1_get_smd_gmvctr_fw(data)                       (0x0000FFFF&(data))

#define  DI_DI_SMD_GMV_FW_COUNTER2                                              0x180249B4
#define  DI_DI_SMD_GMV_FW_COUNTER2_reg_addr                                      "0xB80249B4"
#define  DI_DI_SMD_GMV_FW_COUNTER2_reg                                           0xB80249B4
#define  DI_DI_SMD_GMV_FW_COUNTER2_inst_addr                                     "0x017A"
#define  set_DI_DI_SMD_GMV_FW_COUNTER2_reg(data)                                 (*((volatile unsigned int*)DI_DI_SMD_GMV_FW_COUNTER2_reg)=data)
#define  get_DI_DI_SMD_GMV_FW_COUNTER2_reg                                       (*((volatile unsigned int*)DI_DI_SMD_GMV_FW_COUNTER2_reg))
#define  DI_DI_SMD_GMV_FW_COUNTER2_smd_gmv3maxctr_fw_shift                       (16)
#define  DI_DI_SMD_GMV_FW_COUNTER2_smd_gmv2maxctr_fw_shift                       (0)
#define  DI_DI_SMD_GMV_FW_COUNTER2_smd_gmv3maxctr_fw_mask                        (0xFFFF0000)
#define  DI_DI_SMD_GMV_FW_COUNTER2_smd_gmv2maxctr_fw_mask                        (0x0000FFFF)
#define  DI_DI_SMD_GMV_FW_COUNTER2_smd_gmv3maxctr_fw(data)                       (0xFFFF0000&((data)<<16))
#define  DI_DI_SMD_GMV_FW_COUNTER2_smd_gmv2maxctr_fw(data)                       (0x0000FFFF&(data))
#define  DI_DI_SMD_GMV_FW_COUNTER2_get_smd_gmv3maxctr_fw(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_DI_SMD_GMV_FW_COUNTER2_get_smd_gmv2maxctr_fw(data)                   (0x0000FFFF&(data))

#define  DI_DI_SMD_GMV1_value_FW                                                0x180249B8
#define  DI_DI_SMD_GMV1_value_FW_reg_addr                                        "0xB80249B8"
#define  DI_DI_SMD_GMV1_value_FW_reg                                             0xB80249B8
#define  DI_DI_SMD_GMV1_value_FW_inst_addr                                       "0x017B"
#define  set_DI_DI_SMD_GMV1_value_FW_reg(data)                                   (*((volatile unsigned int*)DI_DI_SMD_GMV1_value_FW_reg)=data)
#define  get_DI_DI_SMD_GMV1_value_FW_reg                                         (*((volatile unsigned int*)DI_DI_SMD_GMV1_value_FW_reg))
#define  DI_DI_SMD_GMV1_value_FW_smd_gmv1_y_fw_shift                             (16)
#define  DI_DI_SMD_GMV1_value_FW_smd_gmv1_x_fw_shift                             (0)
#define  DI_DI_SMD_GMV1_value_FW_smd_gmv1_y_fw_mask                              (0x00070000)
#define  DI_DI_SMD_GMV1_value_FW_smd_gmv1_x_fw_mask                              (0x00000007)
#define  DI_DI_SMD_GMV1_value_FW_smd_gmv1_y_fw(data)                             (0x00070000&((data)<<16))
#define  DI_DI_SMD_GMV1_value_FW_smd_gmv1_x_fw(data)                             (0x00000007&(data))
#define  DI_DI_SMD_GMV1_value_FW_get_smd_gmv1_y_fw(data)                         ((0x00070000&(data))>>16)
#define  DI_DI_SMD_GMV1_value_FW_get_smd_gmv1_x_fw(data)                         (0x00000007&(data))

#define  DI_DI_SMD_GMV2_value_FW                                                0x180249BC
#define  DI_DI_SMD_GMV2_value_FW_reg_addr                                        "0xB80249BC"
#define  DI_DI_SMD_GMV2_value_FW_reg                                             0xB80249BC
#define  DI_DI_SMD_GMV2_value_FW_inst_addr                                       "0x017C"
#define  set_DI_DI_SMD_GMV2_value_FW_reg(data)                                   (*((volatile unsigned int*)DI_DI_SMD_GMV2_value_FW_reg)=data)
#define  get_DI_DI_SMD_GMV2_value_FW_reg                                         (*((volatile unsigned int*)DI_DI_SMD_GMV2_value_FW_reg))
#define  DI_DI_SMD_GMV2_value_FW_smd_gmv2_y_fw_shift                             (16)
#define  DI_DI_SMD_GMV2_value_FW_smd_gmv2_x_fw_shift                             (0)
#define  DI_DI_SMD_GMV2_value_FW_smd_gmv2_y_fw_mask                              (0x00070000)
#define  DI_DI_SMD_GMV2_value_FW_smd_gmv2_x_fw_mask                              (0x00000007)
#define  DI_DI_SMD_GMV2_value_FW_smd_gmv2_y_fw(data)                             (0x00070000&((data)<<16))
#define  DI_DI_SMD_GMV2_value_FW_smd_gmv2_x_fw(data)                             (0x00000007&(data))
#define  DI_DI_SMD_GMV2_value_FW_get_smd_gmv2_y_fw(data)                         ((0x00070000&(data))>>16)
#define  DI_DI_SMD_GMV2_value_FW_get_smd_gmv2_x_fw(data)                         (0x00000007&(data))

#define  DI_DI_SMD_TMV_Similarity                                               0x180249C0
#define  DI_DI_SMD_TMV_Similarity_reg_addr                                       "0xB80249C0"
#define  DI_DI_SMD_TMV_Similarity_reg                                            0xB80249C0
#define  DI_DI_SMD_TMV_Similarity_inst_addr                                      "0x017D"
#define  set_DI_DI_SMD_TMV_Similarity_reg(data)                                  (*((volatile unsigned int*)DI_DI_SMD_TMV_Similarity_reg)=data)
#define  get_DI_DI_SMD_TMV_Similarity_reg                                        (*((volatile unsigned int*)DI_DI_SMD_TMV_Similarity_reg))
#define  DI_DI_SMD_TMV_Similarity_smd_dt_count_th2_shift                         (28)
#define  DI_DI_SMD_TMV_Similarity_smd_dt_count_th1_shift                         (24)
#define  DI_DI_SMD_TMV_Similarity_smd_c_teeth_disable_shift                      (23)
#define  DI_DI_SMD_TMV_Similarity_gst_static_tmvdiff_th_shift                    (18)
#define  DI_DI_SMD_TMV_Similarity_smd_tmv_acc3_shift                             (16)
#define  DI_DI_SMD_TMV_Similarity_smd_tmv_acc2_shift                             (14)
#define  DI_DI_SMD_TMV_Similarity_smd_tmv_acc1_shift                             (12)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvy_diff_th3_shift                        (10)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvx_diff_th3_shift                        (8)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvy_diff_th2_shift                        (6)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvx_diff_th2_shift                        (4)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvy_diff_th1_shift                        (2)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvx_diff_th1_shift                        (0)
#define  DI_DI_SMD_TMV_Similarity_smd_dt_count_th2_mask                          (0xF0000000)
#define  DI_DI_SMD_TMV_Similarity_smd_dt_count_th1_mask                          (0x0F000000)
#define  DI_DI_SMD_TMV_Similarity_smd_c_teeth_disable_mask                       (0x00800000)
#define  DI_DI_SMD_TMV_Similarity_gst_static_tmvdiff_th_mask                     (0x007C0000)
#define  DI_DI_SMD_TMV_Similarity_smd_tmv_acc3_mask                              (0x00030000)
#define  DI_DI_SMD_TMV_Similarity_smd_tmv_acc2_mask                              (0x0000C000)
#define  DI_DI_SMD_TMV_Similarity_smd_tmv_acc1_mask                              (0x00003000)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvy_diff_th3_mask                         (0x00000C00)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvx_diff_th3_mask                         (0x00000300)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvy_diff_th2_mask                         (0x000000C0)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvx_diff_th2_mask                         (0x00000030)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvy_diff_th1_mask                         (0x0000000C)
#define  DI_DI_SMD_TMV_Similarity_smd_tmvx_diff_th1_mask                         (0x00000003)
#define  DI_DI_SMD_TMV_Similarity_smd_dt_count_th2(data)                         (0xF0000000&((data)<<28))
#define  DI_DI_SMD_TMV_Similarity_smd_dt_count_th1(data)                         (0x0F000000&((data)<<24))
#define  DI_DI_SMD_TMV_Similarity_smd_c_teeth_disable(data)                      (0x00800000&((data)<<23))
#define  DI_DI_SMD_TMV_Similarity_gst_static_tmvdiff_th(data)                    (0x007C0000&((data)<<18))
#define  DI_DI_SMD_TMV_Similarity_smd_tmv_acc3(data)                             (0x00030000&((data)<<16))
#define  DI_DI_SMD_TMV_Similarity_smd_tmv_acc2(data)                             (0x0000C000&((data)<<14))
#define  DI_DI_SMD_TMV_Similarity_smd_tmv_acc1(data)                             (0x00003000&((data)<<12))
#define  DI_DI_SMD_TMV_Similarity_smd_tmvy_diff_th3(data)                        (0x00000C00&((data)<<10))
#define  DI_DI_SMD_TMV_Similarity_smd_tmvx_diff_th3(data)                        (0x00000300&((data)<<8))
#define  DI_DI_SMD_TMV_Similarity_smd_tmvy_diff_th2(data)                        (0x000000C0&((data)<<6))
#define  DI_DI_SMD_TMV_Similarity_smd_tmvx_diff_th2(data)                        (0x00000030&((data)<<4))
#define  DI_DI_SMD_TMV_Similarity_smd_tmvy_diff_th1(data)                        (0x0000000C&((data)<<2))
#define  DI_DI_SMD_TMV_Similarity_smd_tmvx_diff_th1(data)                        (0x00000003&(data))
#define  DI_DI_SMD_TMV_Similarity_get_smd_dt_count_th2(data)                     ((0xF0000000&(data))>>28)
#define  DI_DI_SMD_TMV_Similarity_get_smd_dt_count_th1(data)                     ((0x0F000000&(data))>>24)
#define  DI_DI_SMD_TMV_Similarity_get_smd_c_teeth_disable(data)                  ((0x00800000&(data))>>23)
#define  DI_DI_SMD_TMV_Similarity_get_gst_static_tmvdiff_th(data)                ((0x007C0000&(data))>>18)
#define  DI_DI_SMD_TMV_Similarity_get_smd_tmv_acc3(data)                         ((0x00030000&(data))>>16)
#define  DI_DI_SMD_TMV_Similarity_get_smd_tmv_acc2(data)                         ((0x0000C000&(data))>>14)
#define  DI_DI_SMD_TMV_Similarity_get_smd_tmv_acc1(data)                         ((0x00003000&(data))>>12)
#define  DI_DI_SMD_TMV_Similarity_get_smd_tmvy_diff_th3(data)                    ((0x00000C00&(data))>>10)
#define  DI_DI_SMD_TMV_Similarity_get_smd_tmvx_diff_th3(data)                    ((0x00000300&(data))>>8)
#define  DI_DI_SMD_TMV_Similarity_get_smd_tmvy_diff_th2(data)                    ((0x000000C0&(data))>>6)
#define  DI_DI_SMD_TMV_Similarity_get_smd_tmvx_diff_th2(data)                    ((0x00000030&(data))>>4)
#define  DI_DI_SMD_TMV_Similarity_get_smd_tmvy_diff_th1(data)                    ((0x0000000C&(data))>>2)
#define  DI_DI_SMD_TMV_Similarity_get_smd_tmvx_diff_th1(data)                    (0x00000003&(data))

#define  DI_DI_SMD_Teeth_Processing                                             0x180249C4
#define  DI_DI_SMD_Teeth_Processing_reg_addr                                     "0xB80249C4"
#define  DI_DI_SMD_Teeth_Processing_reg                                          0xB80249C4
#define  DI_DI_SMD_Teeth_Processing_inst_addr                                    "0x017E"
#define  set_DI_DI_SMD_Teeth_Processing_reg(data)                                (*((volatile unsigned int*)DI_DI_SMD_Teeth_Processing_reg)=data)
#define  get_DI_DI_SMD_Teeth_Processing_reg                                      (*((volatile unsigned int*)DI_DI_SMD_Teeth_Processing_reg))
#define  DI_DI_SMD_Teeth_Processing_smd_hori_diff_gain_shift                     (27)
#define  DI_DI_SMD_Teeth_Processing_smd_hori_diff_th_shift                       (20)
#define  DI_DI_SMD_Teeth_Processing_smd_teeth_th_tf_shift                        (13)
#define  DI_DI_SMD_Teeth_Processing_smd_mad_th_tf_shift                          (6)
#define  DI_DI_SMD_Teeth_Processing_smd_mv_pixel_acc_th5_shift                   (3)
#define  DI_DI_SMD_Teeth_Processing_smd_teeth_pos_shift                          (2)
#define  DI_DI_SMD_Teeth_Processing_smd_acc_teeth_count_en_shift                 (1)
#define  DI_DI_SMD_Teeth_Processing_smd_teeth_vlpf_en_shift                      (0)
#define  DI_DI_SMD_Teeth_Processing_smd_hori_diff_gain_mask                      (0xF8000000)
#define  DI_DI_SMD_Teeth_Processing_smd_hori_diff_th_mask                        (0x07F00000)
#define  DI_DI_SMD_Teeth_Processing_smd_teeth_th_tf_mask                         (0x000FE000)
#define  DI_DI_SMD_Teeth_Processing_smd_mad_th_tf_mask                           (0x00001FC0)
#define  DI_DI_SMD_Teeth_Processing_smd_mv_pixel_acc_th5_mask                    (0x00000038)
#define  DI_DI_SMD_Teeth_Processing_smd_teeth_pos_mask                           (0x00000004)
#define  DI_DI_SMD_Teeth_Processing_smd_acc_teeth_count_en_mask                  (0x00000002)
#define  DI_DI_SMD_Teeth_Processing_smd_teeth_vlpf_en_mask                       (0x00000001)
#define  DI_DI_SMD_Teeth_Processing_smd_hori_diff_gain(data)                     (0xF8000000&((data)<<27))
#define  DI_DI_SMD_Teeth_Processing_smd_hori_diff_th(data)                       (0x07F00000&((data)<<20))
#define  DI_DI_SMD_Teeth_Processing_smd_teeth_th_tf(data)                        (0x000FE000&((data)<<13))
#define  DI_DI_SMD_Teeth_Processing_smd_mad_th_tf(data)                          (0x00001FC0&((data)<<6))
#define  DI_DI_SMD_Teeth_Processing_smd_mv_pixel_acc_th5(data)                   (0x00000038&((data)<<3))
#define  DI_DI_SMD_Teeth_Processing_smd_teeth_pos(data)                          (0x00000004&((data)<<2))
#define  DI_DI_SMD_Teeth_Processing_smd_acc_teeth_count_en(data)                 (0x00000002&((data)<<1))
#define  DI_DI_SMD_Teeth_Processing_smd_teeth_vlpf_en(data)                      (0x00000001&(data))
#define  DI_DI_SMD_Teeth_Processing_get_smd_hori_diff_gain(data)                 ((0xF8000000&(data))>>27)
#define  DI_DI_SMD_Teeth_Processing_get_smd_hori_diff_th(data)                   ((0x07F00000&(data))>>20)
#define  DI_DI_SMD_Teeth_Processing_get_smd_teeth_th_tf(data)                    ((0x000FE000&(data))>>13)
#define  DI_DI_SMD_Teeth_Processing_get_smd_mad_th_tf(data)                      ((0x00001FC0&(data))>>6)
#define  DI_DI_SMD_Teeth_Processing_get_smd_mv_pixel_acc_th5(data)               ((0x00000038&(data))>>3)
#define  DI_DI_SMD_Teeth_Processing_get_smd_teeth_pos(data)                      ((0x00000004&(data))>>2)
#define  DI_DI_SMD_Teeth_Processing_get_smd_acc_teeth_count_en(data)             ((0x00000002&(data))>>1)
#define  DI_DI_SMD_Teeth_Processing_get_smd_teeth_vlpf_en(data)                  (0x00000001&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12                                        0x18024A00
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_reg_addr                                "0xB8024A00"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_reg                                     0xB8024A00
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_inst_addr                               "0x017F"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_12_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_12_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_12_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_12_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_mcnr_u3_sum_shift                       (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_mcnr_u2_sum_shift                       (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_mcnr_u3_sum_mask                        (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_mcnr_u2_sum_mask                        (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_mcnr_u3_sum(data)                       (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_mcnr_u2_sum(data)                       (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_get_mcnr_u3_sum(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_12_get_mcnr_u2_sum(data)                   (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13                                        0x18024A04
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_reg_addr                                "0xB8024A04"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_reg                                     0xB8024A04
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_inst_addr                               "0x0180"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_13_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_13_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_13_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_13_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_mcnr_u1_sum_shift                       (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_mcnr_v0_sum_shift                       (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_mcnr_u1_sum_mask                        (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_mcnr_v0_sum_mask                        (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_mcnr_u1_sum(data)                       (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_mcnr_v0_sum(data)                       (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_get_mcnr_u1_sum(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_13_get_mcnr_v0_sum(data)                   (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14                                        0x18024A08
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_reg_addr                                "0xB8024A08"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_reg                                     0xB8024A08
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_inst_addr                               "0x0181"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_14_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_14_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_14_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_14_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_mcnr_d1_sum_shift                       (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_mcnr_d2_sum_shift                       (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_mcnr_d1_sum_mask                        (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_mcnr_d2_sum_mask                        (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_mcnr_d1_sum(data)                       (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_mcnr_d2_sum(data)                       (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_get_mcnr_d1_sum(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_14_get_mcnr_d2_sum(data)                   (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15                                        0x18024A0C
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_reg_addr                                "0xB8024A0C"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_reg                                     0xB8024A0C
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_inst_addr                               "0x0182"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_15_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_15_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_15_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_15_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_mcnr_d3_sum_shift                       (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_mcnr_static_sum_shift                   (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_mcnr_d3_sum_mask                        (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_mcnr_static_sum_mask                    (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_mcnr_d3_sum(data)                       (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_mcnr_static_sum(data)                   (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_get_mcnr_d3_sum(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_15_get_mcnr_static_sum(data)               (0x0000FFFF&(data))

#define  DI_IM_NEW_MCNR_CONTROL3                                                0x18024A10
#define  DI_IM_NEW_MCNR_CONTROL3_reg_addr                                        "0xB8024A10"
#define  DI_IM_NEW_MCNR_CONTROL3_reg                                             0xB8024A10
#define  DI_IM_NEW_MCNR_CONTROL3_inst_addr                                       "0x0183"
#define  set_DI_IM_NEW_MCNR_CONTROL3_reg(data)                                   (*((volatile unsigned int*)DI_IM_NEW_MCNR_CONTROL3_reg)=data)
#define  get_DI_IM_NEW_MCNR_CONTROL3_reg                                         (*((volatile unsigned int*)DI_IM_NEW_MCNR_CONTROL3_reg))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_tmv_bz_select_shift                      (30)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_hist_shift_en_shift                  (29)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_only_h_c_en_shift                        (28)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_tmv_value0_en_shift                      (27)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_mv_nolimit_en_shift                  (26)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_still_stat_disable_shift                 (25)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_stat_pos_select_shift                (24)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_hist_all_en_shift                    (22)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_mv_gap_shift                      (20)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_blending_vertical_en_shift        (19)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_messlevel_th_shift                       (8)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_mv_lo_th_shift                    (4)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_blending_en_shift                 (3)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_kfactor_lpf_large_select_shift           (2)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_kfactor_lpf_method_shift                 (1)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_k_factor_lpf_en_shift                    (0)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_tmv_bz_select_mask                       (0xC0000000)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_hist_shift_en_mask                   (0x20000000)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_only_h_c_en_mask                         (0x10000000)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_tmv_value0_en_mask                       (0x08000000)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_mv_nolimit_en_mask                   (0x04000000)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_still_stat_disable_mask                  (0x02000000)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_stat_pos_select_mask                 (0x01000000)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_hist_all_en_mask                     (0x00400000)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_mv_gap_mask                       (0x00300000)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_blending_vertical_en_mask         (0x00080000)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_messlevel_th_mask                        (0x0000FF00)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_mv_lo_th_mask                     (0x000000F0)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_blending_en_mask                  (0x00000008)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_kfactor_lpf_large_select_mask            (0x00000004)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_kfactor_lpf_method_mask                  (0x00000002)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_k_factor_lpf_en_mask                     (0x00000001)
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_tmv_bz_select(data)                      (0xC0000000&((data)<<30))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_hist_shift_en(data)                  (0x20000000&((data)<<29))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_only_h_c_en(data)                        (0x10000000&((data)<<28))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_tmv_value0_en(data)                      (0x08000000&((data)<<27))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_mv_nolimit_en(data)                  (0x04000000&((data)<<26))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_still_stat_disable(data)                 (0x02000000&((data)<<25))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_stat_pos_select(data)                (0x01000000&((data)<<24))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mad_hist_all_en(data)                    (0x00400000&((data)<<22))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_mv_gap(data)                      (0x00300000&((data)<<20))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_blending_vertical_en(data)        (0x00080000&((data)<<19))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_messlevel_th(data)                       (0x0000FF00&((data)<<8))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_mv_lo_th(data)                    (0x000000F0&((data)<<4))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_mv_mad_blending_en(data)                 (0x00000008&((data)<<3))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_kfactor_lpf_large_select(data)           (0x00000004&((data)<<2))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_kfactor_lpf_method(data)                 (0x00000002&((data)<<1))
#define  DI_IM_NEW_MCNR_CONTROL3_n_mcnr_k_factor_lpf_en(data)                    (0x00000001&(data))
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_tmv_bz_select(data)                  ((0xC0000000&(data))>>30)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_mad_hist_shift_en(data)              ((0x20000000&(data))>>29)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_only_h_c_en(data)                    ((0x10000000&(data))>>28)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_tmv_value0_en(data)                  ((0x08000000&(data))>>27)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_mad_mv_nolimit_en(data)              ((0x04000000&(data))>>26)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_still_stat_disable(data)             ((0x02000000&(data))>>25)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_mad_stat_pos_select(data)            ((0x01000000&(data))>>24)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_mad_hist_all_en(data)                ((0x00400000&(data))>>22)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_mv_mad_mv_gap(data)                  ((0x00300000&(data))>>20)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_mv_mad_blending_vertical_en(data)    ((0x00080000&(data))>>19)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_messlevel_th(data)                   ((0x0000FF00&(data))>>8)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_mv_mad_mv_lo_th(data)                ((0x000000F0&(data))>>4)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_mv_mad_blending_en(data)             ((0x00000008&(data))>>3)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_kfactor_lpf_large_select(data)       ((0x00000004&(data))>>2)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_kfactor_lpf_method(data)             ((0x00000002&(data))>>1)
#define  DI_IM_NEW_MCNR_CONTROL3_get_n_mcnr_k_factor_lpf_en(data)                (0x00000001&(data))

#define  DI_IM_NEW_MCNR_MV_MAD_Offset                                           0x18024A14
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_reg_addr                                   "0xB8024A14"
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_reg                                        0xB8024A14
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_inst_addr                                  "0x0184"
#define  set_DI_IM_NEW_MCNR_MV_MAD_Offset_reg(data)                              (*((volatile unsigned int*)DI_IM_NEW_MCNR_MV_MAD_Offset_reg)=data)
#define  get_DI_IM_NEW_MCNR_MV_MAD_Offset_reg                                    (*((volatile unsigned int*)DI_IM_NEW_MCNR_MV_MAD_Offset_reg))
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_n_mcnr_mad_uv_offset_shift                 (8)
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_n_mcnr_mad_offset_shift                    (0)
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_n_mcnr_mad_uv_offset_mask                  (0x0000FF00)
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_n_mcnr_mad_offset_mask                     (0x000000FF)
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_n_mcnr_mad_uv_offset(data)                 (0x0000FF00&((data)<<8))
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_n_mcnr_mad_offset(data)                    (0x000000FF&(data))
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_get_n_mcnr_mad_uv_offset(data)             ((0x0000FF00&(data))>>8)
#define  DI_IM_NEW_MCNR_MV_MAD_Offset_get_n_mcnr_mad_offset(data)                (0x000000FF&(data))

#define  DI_IM_DI_MA_BLENDING_WEIGHT                                            0x18024A54
#define  DI_IM_DI_MA_BLENDING_WEIGHT_reg_addr                                    "0xB8024A54"
#define  DI_IM_DI_MA_BLENDING_WEIGHT_reg                                         0xB8024A54
#define  DI_IM_DI_MA_BLENDING_WEIGHT_inst_addr                                   "0x0185"
#define  set_DI_IM_DI_MA_BLENDING_WEIGHT_reg(data)                               (*((volatile unsigned int*)DI_IM_DI_MA_BLENDING_WEIGHT_reg)=data)
#define  get_DI_IM_DI_MA_BLENDING_WEIGHT_reg                                     (*((volatile unsigned int*)DI_IM_DI_MA_BLENDING_WEIGHT_reg))
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_range_max_shift             (16)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_range_min_shift             (8)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_replace_for_smd_shift       (5)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_range_en_shift              (4)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_teeth_compare_en_shift      (3)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_edge_srlv_en_shift          (2)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_mode_shift                  (0)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_range_max_mask              (0x00FF0000)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_range_min_mask              (0x0000FF00)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_replace_for_smd_mask        (0x00000020)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_range_en_mask               (0x00000010)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_teeth_compare_en_mask       (0x00000008)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_edge_srlv_en_mask           (0x00000004)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_mode_mask                   (0x00000003)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_range_max(data)             (0x00FF0000&((data)<<16))
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_range_min(data)             (0x0000FF00&((data)<<8))
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_replace_for_smd(data)       (0x00000020&((data)<<5))
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_range_en(data)              (0x00000010&((data)<<4))
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_teeth_compare_en(data)      (0x00000008&((data)<<3))
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_edge_srlv_en(data)          (0x00000004&((data)<<2))
#define  DI_IM_DI_MA_BLENDING_WEIGHT_blending_weight_mode(data)                  (0x00000003&(data))
#define  DI_IM_DI_MA_BLENDING_WEIGHT_get_blending_weight_range_max(data)         ((0x00FF0000&(data))>>16)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_get_blending_weight_range_min(data)         ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_get_blending_weight_replace_for_smd(data)   ((0x00000020&(data))>>5)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_get_blending_weight_range_en(data)          ((0x00000010&(data))>>4)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_get_blending_weight_teeth_compare_en(data)  ((0x00000008&(data))>>3)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_get_blending_weight_edge_srlv_en(data)      ((0x00000004&(data))>>2)
#define  DI_IM_DI_MA_BLENDING_WEIGHT_get_blending_weight_mode(data)              (0x00000003&(data))

#define  DI_IM_NEW_MCNR_TMV_Diff_TH                                             0x18024A68
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_reg_addr                                     "0xB8024A68"
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_reg                                          0xB8024A68
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_inst_addr                                    "0x0186"
#define  set_DI_IM_NEW_MCNR_TMV_Diff_TH_reg(data)                                (*((volatile unsigned int*)DI_IM_NEW_MCNR_TMV_Diff_TH_reg)=data)
#define  get_DI_IM_NEW_MCNR_TMV_Diff_TH_reg                                      (*((volatile unsigned int*)DI_IM_NEW_MCNR_TMV_Diff_TH_reg))
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_diff_tmv_th2_shift                    (26)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_diff_tmv_th1_shift                    (24)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th6_shift                    (20)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th5_shift                    (16)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th4_shift                    (12)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th3_shift                    (8)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th2_shift                    (4)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th1_shift                    (0)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_diff_tmv_th2_mask                     (0x0C000000)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_diff_tmv_th1_mask                     (0x03000000)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th6_mask                     (0x00F00000)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th5_mask                     (0x000F0000)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th4_mask                     (0x0000F000)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th3_mask                     (0x00000F00)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th2_mask                     (0x000000F0)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th1_mask                     (0x0000000F)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_diff_tmv_th2(data)                    (0x0C000000&((data)<<26))
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_diff_tmv_th1(data)                    (0x03000000&((data)<<24))
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th6(data)                    (0x00F00000&((data)<<20))
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th5(data)                    (0x000F0000&((data)<<16))
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th4(data)                    (0x0000F000&((data)<<12))
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th3(data)                    (0x00000F00&((data)<<8))
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th2(data)                    (0x000000F0&((data)<<4))
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_n_mcnr_tmv_diff_th1(data)                    (0x0000000F&(data))
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_get_n_mcnr_diff_tmv_th2(data)                ((0x0C000000&(data))>>26)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_get_n_mcnr_diff_tmv_th1(data)                ((0x03000000&(data))>>24)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_get_n_mcnr_tmv_diff_th6(data)                ((0x00F00000&(data))>>20)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_get_n_mcnr_tmv_diff_th5(data)                ((0x000F0000&(data))>>16)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_get_n_mcnr_tmv_diff_th4(data)                ((0x0000F000&(data))>>12)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_get_n_mcnr_tmv_diff_th3(data)                ((0x00000F00&(data))>>8)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_get_n_mcnr_tmv_diff_th2(data)                ((0x000000F0&(data))>>4)
#define  DI_IM_NEW_MCNR_TMV_Diff_TH_get_n_mcnr_tmv_diff_th1(data)                (0x0000000F&(data))

#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl                                        0x18024A6C
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_reg_addr                                "0xB8024A6C"
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_reg                                     0xB8024A6C
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_inst_addr                               "0x0187"
#define  set_DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_reg(data)                           (*((volatile unsigned int*)DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_reg)=data)
#define  get_DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_reg                                 (*((volatile unsigned int*)DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_reg))
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_diff_range3_shift            (24)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_diff_range2_shift            (22)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_diff_range1_shift            (20)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv0_diff_th3_shift              (16)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv0_diff_th2_shift              (12)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv0_diff_th1_shift              (8)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_penalty_clamp_en_shift       (3)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_diff_range3_mask             (0x03000000)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_diff_range2_mask             (0x00C00000)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_diff_range1_mask             (0x00300000)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv0_diff_th3_mask               (0x000F0000)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv0_diff_th2_mask               (0x00003000)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv0_diff_th1_mask               (0x00000F00)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_penalty_clamp_en_mask        (0x00000008)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_diff_range3(data)            (0x03000000&((data)<<24))
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_diff_range2(data)            (0x00C00000&((data)<<22))
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_diff_range1(data)            (0x00300000&((data)<<20))
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv0_diff_th3(data)              (0x000F0000&((data)<<16))
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv0_diff_th2(data)              (0x00003000&((data)<<12))
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv0_diff_th1(data)              (0x00000F00&((data)<<8))
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_n_mcnr_tmv_penalty_clamp_en(data)       (0x00000008&((data)<<3))
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_get_n_mcnr_tmv_diff_range3(data)        ((0x03000000&(data))>>24)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_get_n_mcnr_tmv_diff_range2(data)        ((0x00C00000&(data))>>22)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_get_n_mcnr_tmv_diff_range1(data)        ((0x00300000&(data))>>20)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_get_n_mcnr_tmv0_diff_th3(data)          ((0x000F0000&(data))>>16)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_get_n_mcnr_tmv0_diff_th2(data)          ((0x00003000&(data))>>12)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_get_n_mcnr_tmv0_diff_th1(data)          ((0x00000F00&(data))>>8)
#define  DI_IM_NEW_MCNR_TMV_Penalty_Ctrl_get_n_mcnr_tmv_penalty_clamp_en(data)   ((0x00000008&(data))>>3)

#define  DI_IM_NEW_MCNR_TMV_Penalty_TH                                          0x18024A70
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_reg_addr                                  "0xB8024A70"
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_reg                                       0xB8024A70
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_inst_addr                                 "0x0188"
#define  set_DI_IM_NEW_MCNR_TMV_Penalty_TH_reg(data)                             (*((volatile unsigned int*)DI_IM_NEW_MCNR_TMV_Penalty_TH_reg)=data)
#define  get_DI_IM_NEW_MCNR_TMV_Penalty_TH_reg                                   (*((volatile unsigned int*)DI_IM_NEW_MCNR_TMV_Penalty_TH_reg))
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty7_shift                 (24)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty6_shift                 (20)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty5_shift                 (16)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty4_shift                 (12)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty3_shift                 (8)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty2_shift                 (4)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty1_shift                 (0)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty7_mask                  (0x0F000000)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty6_mask                  (0x00F00000)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty5_mask                  (0x000F0000)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty4_mask                  (0x0000F000)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty3_mask                  (0x00000F00)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty2_mask                  (0x000000F0)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty1_mask                  (0x0000000F)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty7(data)                 (0x0F000000&((data)<<24))
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty6(data)                 (0x00F00000&((data)<<20))
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty5(data)                 (0x000F0000&((data)<<16))
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty4(data)                 (0x0000F000&((data)<<12))
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty3(data)                 (0x00000F00&((data)<<8))
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty2(data)                 (0x000000F0&((data)<<4))
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_n_mcnr_tmv_penalty1(data)                 (0x0000000F&(data))
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_get_n_mcnr_tmv_penalty7(data)             ((0x0F000000&(data))>>24)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_get_n_mcnr_tmv_penalty6(data)             ((0x00F00000&(data))>>20)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_get_n_mcnr_tmv_penalty5(data)             ((0x000F0000&(data))>>16)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_get_n_mcnr_tmv_penalty4(data)             ((0x0000F000&(data))>>12)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_get_n_mcnr_tmv_penalty3(data)             ((0x00000F00&(data))>>8)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_get_n_mcnr_tmv_penalty2(data)             ((0x000000F0&(data))>>4)
#define  DI_IM_NEW_MCNR_TMV_Penalty_TH_get_n_mcnr_tmv_penalty1(data)             (0x0000000F&(data))

#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH                                         0x18024A74
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_reg_addr                                 "0xB8024A74"
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_reg                                      0xB8024A74
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_inst_addr                                "0x0189"
#define  set_DI_IM_NEW_MCNR_TMV_GMV_diff_TH_reg(data)                            (*((volatile unsigned int*)DI_IM_NEW_MCNR_TMV_GMV_diff_TH_reg)=data)
#define  get_DI_IM_NEW_MCNR_TMV_GMV_diff_TH_reg                                  (*((volatile unsigned int*)DI_IM_NEW_MCNR_TMV_GMV_diff_TH_reg))
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_diff_tmv_pan_th2_shift            (26)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_diff_tmv_pan_th1_shift            (24)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th6_shift            (20)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th5_shift            (16)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th4_shift            (12)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th3_shift            (8)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th2_shift            (4)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th1_shift            (0)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_diff_tmv_pan_th2_mask             (0x0C000000)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_diff_tmv_pan_th1_mask             (0x03000000)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th6_mask             (0x00F00000)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th5_mask             (0x000F0000)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th4_mask             (0x0000F000)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th3_mask             (0x00000F00)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th2_mask             (0x000000F0)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th1_mask             (0x0000000F)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_diff_tmv_pan_th2(data)            (0x0C000000&((data)<<26))
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_diff_tmv_pan_th1(data)            (0x03000000&((data)<<24))
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th6(data)            (0x00F00000&((data)<<20))
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th5(data)            (0x000F0000&((data)<<16))
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th4(data)            (0x0000F000&((data)<<12))
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th3(data)            (0x00000F00&((data)<<8))
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th2(data)            (0x000000F0&((data)<<4))
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_n_mcnr_tmv_pan_diff_th1(data)            (0x0000000F&(data))
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_get_n_mcnr_diff_tmv_pan_th2(data)        ((0x0C000000&(data))>>26)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_get_n_mcnr_diff_tmv_pan_th1(data)        ((0x03000000&(data))>>24)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_get_n_mcnr_tmv_pan_diff_th6(data)        ((0x00F00000&(data))>>20)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_get_n_mcnr_tmv_pan_diff_th5(data)        ((0x000F0000&(data))>>16)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_get_n_mcnr_tmv_pan_diff_th4(data)        ((0x0000F000&(data))>>12)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_get_n_mcnr_tmv_pan_diff_th3(data)        ((0x00000F00&(data))>>8)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_get_n_mcnr_tmv_pan_diff_th2(data)        ((0x000000F0&(data))>>4)
#define  DI_IM_NEW_MCNR_TMV_GMV_diff_TH_get_n_mcnr_tmv_pan_diff_th1(data)        (0x0000000F&(data))

#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl                                        0x18024A78
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_reg_addr                                "0xB8024A78"
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_reg                                     0xB8024A78
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_inst_addr                               "0x018A"
#define  set_DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_reg(data)                           (*((volatile unsigned int*)DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_reg)=data)
#define  get_DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_reg                                 (*((volatile unsigned int*)DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_reg))
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_diff_range1_v_shift          (18)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_diff_range2_shift            (14)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_diff_range1_shift            (12)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_penalty_th1_shift            (4)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_penalty_clamp_en_shift       (3)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_penalty_select_shift         (0)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_diff_range1_v_mask           (0x000C0000)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_diff_range2_mask             (0x0000C000)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_diff_range1_mask             (0x00003000)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_penalty_th1_mask             (0x000000F0)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_penalty_clamp_en_mask        (0x00000008)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_penalty_select_mask          (0x00000003)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_diff_range1_v(data)          (0x000C0000&((data)<<18))
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_diff_range2(data)            (0x0000C000&((data)<<14))
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_diff_range1(data)            (0x00003000&((data)<<12))
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_penalty_th1(data)            (0x000000F0&((data)<<4))
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_penalty_clamp_en(data)       (0x00000008&((data)<<3))
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_n_mcnr_pan_penalty_select(data)         (0x00000003&(data))
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_get_n_mcnr_pan_diff_range1_v(data)      ((0x000C0000&(data))>>18)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_get_n_mcnr_pan_diff_range2(data)        ((0x0000C000&(data))>>14)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_get_n_mcnr_pan_diff_range1(data)        ((0x00003000&(data))>>12)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_get_n_mcnr_pan_penalty_th1(data)        ((0x000000F0&(data))>>4)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_get_n_mcnr_pan_penalty_clamp_en(data)   ((0x00000008&(data))>>3)
#define  DI_IM_NEW_MCNR_GMV_Penalty_Ctrl_get_n_mcnr_pan_penalty_select(data)     (0x00000003&(data))

#define  DI_IM_NEW_MCNR_GMV_Penalty_TH                                          0x18024A7C
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_reg_addr                                  "0xB8024A7C"
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_reg                                       0xB8024A7C
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_inst_addr                                 "0x018B"
#define  set_DI_IM_NEW_MCNR_GMV_Penalty_TH_reg(data)                             (*((volatile unsigned int*)DI_IM_NEW_MCNR_GMV_Penalty_TH_reg)=data)
#define  get_DI_IM_NEW_MCNR_GMV_Penalty_TH_reg                                   (*((volatile unsigned int*)DI_IM_NEW_MCNR_GMV_Penalty_TH_reg))
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty7_shift                 (24)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty6_shift                 (20)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty5_shift                 (16)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty4_shift                 (12)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty3_shift                 (8)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty2_shift                 (4)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty1_shift                 (0)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty7_mask                  (0x0F000000)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty6_mask                  (0x00F00000)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty5_mask                  (0x000F0000)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty4_mask                  (0x0000F000)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty3_mask                  (0x00000F00)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty2_mask                  (0x000000F0)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty1_mask                  (0x0000000F)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty7(data)                 (0x0F000000&((data)<<24))
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty6(data)                 (0x00F00000&((data)<<20))
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty5(data)                 (0x000F0000&((data)<<16))
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty4(data)                 (0x0000F000&((data)<<12))
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty3(data)                 (0x00000F00&((data)<<8))
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty2(data)                 (0x000000F0&((data)<<4))
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_n_mcnr_pan_penalty1(data)                 (0x0000000F&(data))
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_get_n_mcnr_pan_penalty7(data)             ((0x0F000000&(data))>>24)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_get_n_mcnr_pan_penalty6(data)             ((0x00F00000&(data))>>20)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_get_n_mcnr_pan_penalty5(data)             ((0x000F0000&(data))>>16)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_get_n_mcnr_pan_penalty4(data)             ((0x0000F000&(data))>>12)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_get_n_mcnr_pan_penalty3(data)             ((0x00000F00&(data))>>8)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_get_n_mcnr_pan_penalty2(data)             ((0x000000F0&(data))>>4)
#define  DI_IM_NEW_MCNR_GMV_Penalty_TH_get_n_mcnr_pan_penalty1(data)             (0x0000000F&(data))

#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl                                           0x18024A80
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_reg_addr                                   "0xB8024A80"
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_reg                                        0xB8024A80
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_inst_addr                                  "0x018C"
#define  set_DI_IM_NEW_MCNR_GMV_Hist_Ctrl_reg(data)                              (*((volatile unsigned int*)DI_IM_NEW_MCNR_GMV_Hist_Ctrl_reg)=data)
#define  get_DI_IM_NEW_MCNR_GMV_Hist_Ctrl_reg                                    (*((volatile unsigned int*)DI_IM_NEW_MCNR_GMV_Hist_Ctrl_reg))
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_mv_hist_shift_shift                 (30)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_vmv_th2_shift                       (24)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_vmv_th1_shift                       (16)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_hmv_th2_shift                       (8)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_hmv_th1_shift                       (0)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_mv_hist_shift_mask                  (0xC0000000)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_vmv_th2_mask                        (0x0F000000)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_vmv_th1_mask                        (0x000F0000)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_hmv_th2_mask                        (0x00001F00)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_hmv_th1_mask                        (0x0000001F)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_mv_hist_shift(data)                 (0xC0000000&((data)<<30))
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_vmv_th2(data)                       (0x0F000000&((data)<<24))
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_vmv_th1(data)                       (0x000F0000&((data)<<16))
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_hmv_th2(data)                       (0x00001F00&((data)<<8))
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_n_mcnr_hmv_th1(data)                       (0x0000001F&(data))
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_get_n_mcnr_mv_hist_shift(data)             ((0xC0000000&(data))>>30)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_get_n_mcnr_vmv_th2(data)                   ((0x0F000000&(data))>>24)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_get_n_mcnr_vmv_th1(data)                   ((0x000F0000&(data))>>16)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_get_n_mcnr_hmv_th2(data)                   ((0x00001F00&(data))>>8)
#define  DI_IM_NEW_MCNR_GMV_Hist_Ctrl_get_n_mcnr_hmv_th1(data)                   (0x0000001F&(data))

#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl                                           0x18024A84
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_reg_addr                                   "0xB8024A84"
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_reg                                        0xB8024A84
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_inst_addr                                  "0x018D"
#define  set_DI_IM_NEW_MCNR_MV_Debug_Ctrl_reg(data)                              (*((volatile unsigned int*)DI_IM_NEW_MCNR_MV_Debug_Ctrl_reg)=data)
#define  get_DI_IM_NEW_MCNR_MV_Debug_Ctrl_reg                                    (*((volatile unsigned int*)DI_IM_NEW_MCNR_MV_Debug_Ctrl_reg))
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_k_debug_value_start_shift           (28)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_k_debug_value_offset_shift          (24)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_debug_blocksize_v_shift             (16)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_debug_blocksize_h_shift             (8)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_vector_debug_gain_shift             (4)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_debug_422_mode_shift                (3)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_mv_select_debug_shift               (0)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_k_debug_value_start_mask            (0xF0000000)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_k_debug_value_offset_mask           (0x0F000000)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_debug_blocksize_v_mask              (0x00FF0000)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_debug_blocksize_h_mask              (0x0000FF00)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_vector_debug_gain_mask              (0x000000F0)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_debug_422_mode_mask                 (0x00000008)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_mv_select_debug_mask                (0x00000003)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_k_debug_value_start(data)           (0xF0000000&((data)<<28))
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_k_debug_value_offset(data)          (0x0F000000&((data)<<24))
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_debug_blocksize_v(data)             (0x00FF0000&((data)<<16))
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_debug_blocksize_h(data)             (0x0000FF00&((data)<<8))
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_vector_debug_gain(data)             (0x000000F0&((data)<<4))
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_debug_422_mode(data)                (0x00000008&((data)<<3))
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_n_mcnr_mv_select_debug(data)               (0x00000003&(data))
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_get_n_mcnr_k_debug_value_start(data)       ((0xF0000000&(data))>>28)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_get_n_mcnr_k_debug_value_offset(data)      ((0x0F000000&(data))>>24)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_get_n_mcnr_debug_blocksize_v(data)         ((0x00FF0000&(data))>>16)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_get_n_mcnr_debug_blocksize_h(data)         ((0x0000FF00&(data))>>8)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_get_n_mcnr_vector_debug_gain(data)         ((0x000000F0&(data))>>4)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_get_n_mcnr_debug_422_mode(data)            ((0x00000008&(data))>>3)
#define  DI_IM_NEW_MCNR_MV_Debug_Ctrl_get_n_mcnr_mv_select_debug(data)           (0x00000003&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16                                        0x18024A88
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_reg_addr                                "0xB8024A88"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_reg                                     0xB8024A88
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_inst_addr                               "0x018E"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_16_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_16_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_16_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_16_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_mcnr_u5_sum_shift                       (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_mcnr_u4_sum_shift                       (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_mcnr_u5_sum_mask                        (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_mcnr_u4_sum_mask                        (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_mcnr_u5_sum(data)                       (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_mcnr_u4_sum(data)                       (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_get_mcnr_u5_sum(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_16_get_mcnr_u4_sum(data)                   (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17                                        0x18024A8C
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_reg_addr                                "0xB8024A8C"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_reg                                     0xB8024A8C
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_inst_addr                               "0x018F"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_17_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_17_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_17_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_17_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_mcnr_d4_sum_shift                       (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_mcnr_d5_sum_shift                       (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_mcnr_d4_sum_mask                        (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_mcnr_d5_sum_mask                        (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_mcnr_d4_sum(data)                       (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_mcnr_d5_sum(data)                       (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_get_mcnr_d4_sum(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_17_get_mcnr_d5_sum(data)                   (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18                                        0x18024A90
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_reg_addr                                "0xB8024A90"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_reg                                     0xB8024A90
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_inst_addr                               "0x0190"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_18_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_18_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_18_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_18_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_mcnr_u6_sum_shift                       (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_mcnr_d6_sum_shift                       (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_mcnr_u6_sum_mask                        (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_mcnr_d6_sum_mask                        (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_mcnr_u6_sum(data)                       (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_mcnr_d6_sum(data)                       (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_get_mcnr_u6_sum(data)                   ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_18_get_mcnr_d6_sum(data)                   (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19                                        0x18024A94
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_reg_addr                                "0xB8024A94"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_reg                                     0xB8024A94
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_inst_addr                               "0x0191"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_19_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_19_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_19_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_19_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_mcnr_l14_sum_shift                      (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_mcnr_l15_sum_shift                      (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_mcnr_l14_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_mcnr_l15_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_mcnr_l14_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_mcnr_l15_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_get_mcnr_l14_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_19_get_mcnr_l15_sum(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20                                        0x18024A98
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_reg_addr                                "0xB8024A98"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_reg                                     0xB8024A98
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_inst_addr                               "0x0192"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_20_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_20_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_20_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_20_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_mcnr_l12_sum_shift                      (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_mcnr_l13_sum_shift                      (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_mcnr_l12_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_mcnr_l13_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_mcnr_l12_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_mcnr_l13_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_get_mcnr_l12_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_20_get_mcnr_l13_sum(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21                                        0x18024A9C
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_reg_addr                                "0xB8024A9C"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_reg                                     0xB8024A9C
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_inst_addr                               "0x0193"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_21_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_21_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_21_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_21_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_mcnr_r11_sum_shift                      (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_mcnr_l11_sum_shift                      (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_mcnr_r11_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_mcnr_l11_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_mcnr_r11_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_mcnr_l11_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_get_mcnr_r11_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_21_get_mcnr_l11_sum(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22                                        0x18024AA0
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_reg_addr                                "0xB8024AA0"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_reg                                     0xB8024AA0
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_inst_addr                               "0x0194"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_22_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_22_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_22_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_22_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_mcnr_r13_sum_shift                      (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_mcnr_r12_sum_shift                      (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_mcnr_r13_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_mcnr_r12_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_mcnr_r13_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_mcnr_r12_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_get_mcnr_r13_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_22_get_mcnr_r12_sum(data)                  (0x0000FFFF&(data))

#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23                                        0x18024AA4
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_reg_addr                                "0xB8024AA4"
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_reg                                     0xB8024AA4
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_inst_addr                               "0x0195"
#define  set_DI_IM_DI_RTNR_MCNR_STATISTIC_23_reg(data)                           (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_23_reg)=data)
#define  get_DI_IM_DI_RTNR_MCNR_STATISTIC_23_reg                                 (*((volatile unsigned int*)DI_IM_DI_RTNR_MCNR_STATISTIC_23_reg))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_mcnr_r15_sum_shift                      (16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_mcnr_r14_sum_shift                      (0)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_mcnr_r15_sum_mask                       (0xFFFF0000)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_mcnr_r14_sum_mask                       (0x0000FFFF)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_mcnr_r15_sum(data)                      (0xFFFF0000&((data)<<16))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_mcnr_r14_sum(data)                      (0x0000FFFF&(data))
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_get_mcnr_r15_sum(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_IM_DI_RTNR_MCNR_STATISTIC_23_get_mcnr_r14_sum(data)                  (0x0000FFFF&(data))

#define  DI_IM_NEW_MCNR_CONTROL4                                                0x18024AA8
#define  DI_IM_NEW_MCNR_CONTROL4_reg_addr                                        "0xB8024AA8"
#define  DI_IM_NEW_MCNR_CONTROL4_reg                                             0xB8024AA8
#define  DI_IM_NEW_MCNR_CONTROL4_inst_addr                                       "0x0196"
#define  set_DI_IM_NEW_MCNR_CONTROL4_reg(data)                                   (*((volatile unsigned int*)DI_IM_NEW_MCNR_CONTROL4_reg)=data)
#define  get_DI_IM_NEW_MCNR_CONTROL4_reg                                         (*((volatile unsigned int*)DI_IM_NEW_MCNR_CONTROL4_reg))
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_mv_th_shift                      (28)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_hi_shift                         (24)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_lo_shift                         (20)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_en_shift                         (19)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_mad_hist_clip_shift                      (12)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_messlevel_shift_shift                    (9)
#define  DI_IM_NEW_MCNR_CONTROL4_tmv_no_reset_flag_shift                         (8)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_v_pan_mv_shift                           (4)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_v_search_range_shift                     (0)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_mv_th_mask                       (0xF0000000)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_hi_mask                          (0x0F000000)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_lo_mask                          (0x00F00000)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_en_mask                          (0x00080000)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_mad_hist_clip_mask                       (0x0000F000)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_messlevel_shift_mask                     (0x00000200)
#define  DI_IM_NEW_MCNR_CONTROL4_tmv_no_reset_flag_mask                          (0x00000100)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_v_pan_mv_mask                            (0x000000F0)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_v_search_range_mask                      (0x00000007)
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_mv_th(data)                      (0xF0000000&((data)<<28))
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_hi(data)                         (0x0F000000&((data)<<24))
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_lo(data)                         (0x00F00000&((data)<<20))
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_k_limit_en(data)                         (0x00080000&((data)<<19))
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_mad_hist_clip(data)                      (0x0000F000&((data)<<12))
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_messlevel_shift(data)                    (0x00000200&((data)<<9))
#define  DI_IM_NEW_MCNR_CONTROL4_tmv_no_reset_flag(data)                         (0x00000100&((data)<<8))
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_v_pan_mv(data)                           (0x000000F0&((data)<<4))
#define  DI_IM_NEW_MCNR_CONTROL4_n_mcnr_v_search_range(data)                     (0x00000007&(data))
#define  DI_IM_NEW_MCNR_CONTROL4_get_n_mcnr_k_limit_mv_th(data)                  ((0xF0000000&(data))>>28)
#define  DI_IM_NEW_MCNR_CONTROL4_get_n_mcnr_k_limit_hi(data)                     ((0x0F000000&(data))>>24)
#define  DI_IM_NEW_MCNR_CONTROL4_get_n_mcnr_k_limit_lo(data)                     ((0x00F00000&(data))>>20)
#define  DI_IM_NEW_MCNR_CONTROL4_get_n_mcnr_k_limit_en(data)                     ((0x00080000&(data))>>19)
#define  DI_IM_NEW_MCNR_CONTROL4_get_n_mcnr_mad_hist_clip(data)                  ((0x0000F000&(data))>>12)
#define  DI_IM_NEW_MCNR_CONTROL4_get_n_mcnr_messlevel_shift(data)                ((0x00000200&(data))>>9)
#define  DI_IM_NEW_MCNR_CONTROL4_get_tmv_no_reset_flag(data)                     ((0x00000100&(data))>>8)
#define  DI_IM_NEW_MCNR_CONTROL4_get_n_mcnr_v_pan_mv(data)                       ((0x000000F0&(data))>>4)
#define  DI_IM_NEW_MCNR_CONTROL4_get_n_mcnr_v_search_range(data)                 (0x00000007&(data))

#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2                                     0x18024AAC
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_reg_addr                             "0xB8024AAC"
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_reg                                  0xB8024AAC
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_inst_addr                            "0x0197"
#define  set_DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_reg(data)                        (*((volatile unsigned int*)DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_reg)=data)
#define  get_DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_reg                              (*((volatile unsigned int*)DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_reg))
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_nintra_min_second_diff_th4_shift     (8)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_nintra_vertical_diff_th2_shift       (0)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_nintra_min_second_diff_th4_mask      (0x0000FF00)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_nintra_vertical_diff_th2_mask        (0x000000FF)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_nintra_min_second_diff_th4(data)     (0x0000FF00&((data)<<8))
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_nintra_vertical_diff_th2(data)       (0x000000FF&(data))
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_get_nintra_min_second_diff_th4(data) ((0x0000FF00&(data))>>8)
#define  DI_IM_DI_NINTRA_1ST_2ND_YDIFF_TH_2_get_nintra_vertical_diff_th2(data)   (0x000000FF&(data))

#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl                                      0x18024AB0
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_reg_addr                              "0xB8024AB0"
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_reg                                   0xB8024AB0
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_inst_addr                             "0x0198"
#define  set_DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_reg(data)                         (*((volatile unsigned int*)DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_reg)=data)
#define  get_DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_reg                               (*((volatile unsigned int*)DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_reg))
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_penalty_clamp_slope_shift      (24)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_messlevel_lo_th_shift          (16)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_messlevel_hi_th_shift          (8)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_penalty_clamp_lo_shift         (4)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_penalty_clamp_hi_shift         (0)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_penalty_clamp_slope_mask       (0xFF000000)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_messlevel_lo_th_mask           (0x00FF0000)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_messlevel_hi_th_mask           (0x0000FF00)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_penalty_clamp_lo_mask          (0x000000F0)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_penalty_clamp_hi_mask          (0x0000000F)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_penalty_clamp_slope(data)      (0xFF000000&((data)<<24))
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_messlevel_lo_th(data)          (0x00FF0000&((data)<<16))
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_messlevel_hi_th(data)          (0x0000FF00&((data)<<8))
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_penalty_clamp_lo(data)         (0x000000F0&((data)<<4))
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_n_mcnr_penalty_clamp_hi(data)         (0x0000000F&(data))
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_get_n_mcnr_penalty_clamp_slope(data)  ((0xFF000000&(data))>>24)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_get_n_mcnr_messlevel_lo_th(data)      ((0x00FF0000&(data))>>16)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_get_n_mcnr_messlevel_hi_th(data)      ((0x0000FF00&(data))>>8)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_get_n_mcnr_penalty_clamp_lo(data)     ((0x000000F0&(data))>>4)
#define  DI_IM_NEW_MCNR_Penalty_Clamp_Ctrl_get_n_mcnr_penalty_clamp_hi(data)     (0x0000000F&(data))

#define  DI_IM_NEW_MCNR_Statistic_boundary                                      0x18024AB4
#define  DI_IM_NEW_MCNR_Statistic_boundary_reg_addr                              "0xB8024AB4"
#define  DI_IM_NEW_MCNR_Statistic_boundary_reg                                   0xB8024AB4
#define  DI_IM_NEW_MCNR_Statistic_boundary_inst_addr                             "0x0199"
#define  set_DI_IM_NEW_MCNR_Statistic_boundary_reg(data)                         (*((volatile unsigned int*)DI_IM_NEW_MCNR_Statistic_boundary_reg)=data)
#define  get_DI_IM_NEW_MCNR_Statistic_boundary_reg                               (*((volatile unsigned int*)DI_IM_NEW_MCNR_Statistic_boundary_reg))
#define  DI_IM_NEW_MCNR_Statistic_boundary_n_mcnr_y_boundary_th2_shift           (8)
#define  DI_IM_NEW_MCNR_Statistic_boundary_n_mcnr_x_boundary_th2_shift           (0)
#define  DI_IM_NEW_MCNR_Statistic_boundary_n_mcnr_y_boundary_th2_mask            (0x0000FF00)
#define  DI_IM_NEW_MCNR_Statistic_boundary_n_mcnr_x_boundary_th2_mask            (0x000000FF)
#define  DI_IM_NEW_MCNR_Statistic_boundary_n_mcnr_y_boundary_th2(data)           (0x0000FF00&((data)<<8))
#define  DI_IM_NEW_MCNR_Statistic_boundary_n_mcnr_x_boundary_th2(data)           (0x000000FF&(data))
#define  DI_IM_NEW_MCNR_Statistic_boundary_get_n_mcnr_y_boundary_th2(data)       ((0x0000FF00&(data))>>8)
#define  DI_IM_NEW_MCNR_Statistic_boundary_get_n_mcnr_x_boundary_th2(data)       (0x000000FF&(data))

#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW                                 0x18024AB8
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_reg_addr                         "0xB8024AB8"
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_reg                              0xB8024AB8
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_inst_addr                        "0x019A"
#define  set_DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_reg(data)                    (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_reg)=data)
#define  get_DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_reg                          (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_reg))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_rtnr_ma_isnr_getmotion_motionth3_l_shift (16)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_rtnr_ma_isnr_getmotion_motionth2_l_shift (8)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_rtnr_ma_isnr_getmotion_motionth1_l_shift (0)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_rtnr_ma_isnr_getmotion_motionth3_l_mask (0x00FF0000)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_rtnr_ma_isnr_getmotion_motionth2_l_mask (0x0000FF00)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_rtnr_ma_isnr_getmotion_motionth1_l_mask (0x000000FF)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_rtnr_ma_isnr_getmotion_motionth3_l(data) (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_rtnr_ma_isnr_getmotion_motionth2_l(data) (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_rtnr_ma_isnr_getmotion_motionth1_l(data) (0x000000FF&(data))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_get_rtnr_ma_isnr_getmotion_motionth3_l(data) ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_get_rtnr_ma_isnr_getmotion_motionth2_l(data) ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_LOW_get_rtnr_ma_isnr_getmotion_motionth1_l(data) (0x000000FF&(data))

#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID                                 0x18024ABC
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_reg_addr                         "0xB8024ABC"
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_reg                              0xB8024ABC
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_inst_addr                        "0x019B"
#define  set_DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_reg(data)                    (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_reg)=data)
#define  get_DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_reg                          (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_reg))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_rtnr_ma_isnr_getmotion_motionth3_m_shift (16)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_rtnr_ma_isnr_getmotion_motionth2_m_shift (8)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_rtnr_ma_isnr_getmotion_motionth1_m_shift (0)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_rtnr_ma_isnr_getmotion_motionth3_m_mask (0x00FF0000)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_rtnr_ma_isnr_getmotion_motionth2_m_mask (0x0000FF00)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_rtnr_ma_isnr_getmotion_motionth1_m_mask (0x000000FF)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_rtnr_ma_isnr_getmotion_motionth3_m(data) (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_rtnr_ma_isnr_getmotion_motionth2_m(data) (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_rtnr_ma_isnr_getmotion_motionth1_m(data) (0x000000FF&(data))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_get_rtnr_ma_isnr_getmotion_motionth3_m(data) ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_get_rtnr_ma_isnr_getmotion_motionth2_m(data) ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID_get_rtnr_ma_isnr_getmotion_motionth1_m(data) (0x000000FF&(data))

#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2                                0x18024AC0
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_reg_addr                        "0xB8024AC0"
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_reg                             0xB8024AC0
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_inst_addr                       "0x019C"
#define  set_DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_reg(data)                   (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_reg)=data)
#define  get_DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_reg                         (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_reg))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_rtnr_ma_isnr_getmotion_motionth3_n_shift (16)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_rtnr_ma_isnr_getmotion_motionth2_n_shift (8)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_rtnr_ma_isnr_getmotion_motionth1_n_shift (0)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_rtnr_ma_isnr_getmotion_motionth3_n_mask (0x00FF0000)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_rtnr_ma_isnr_getmotion_motionth2_n_mask (0x0000FF00)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_rtnr_ma_isnr_getmotion_motionth1_n_mask (0x000000FF)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_rtnr_ma_isnr_getmotion_motionth3_n(data) (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_rtnr_ma_isnr_getmotion_motionth2_n(data) (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_rtnr_ma_isnr_getmotion_motionth1_n(data) (0x000000FF&(data))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_get_rtnr_ma_isnr_getmotion_motionth3_n(data) ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_get_rtnr_ma_isnr_getmotion_motionth2_n(data) ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_MID2_get_rtnr_ma_isnr_getmotion_motionth1_n(data) (0x000000FF&(data))

#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH                                0x18024AC4
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_reg_addr                        "0xB8024AC4"
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_reg                             0xB8024AC4
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_inst_addr                       "0x019D"
#define  set_DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_reg(data)                   (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_reg)=data)
#define  get_DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_reg                         (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_reg))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_rtnr_ma_isnr_getmotion_motionth3_h_shift (16)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_rtnr_ma_isnr_getmotion_motionth2_h_shift (8)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_rtnr_ma_isnr_getmotion_motionth1_h_shift (0)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_rtnr_ma_isnr_getmotion_motionth3_h_mask (0x00FF0000)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_rtnr_ma_isnr_getmotion_motionth2_h_mask (0x0000FF00)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_rtnr_ma_isnr_getmotion_motionth1_h_mask (0x000000FF)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_rtnr_ma_isnr_getmotion_motionth3_h(data) (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_rtnr_ma_isnr_getmotion_motionth2_h(data) (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_rtnr_ma_isnr_getmotion_motionth1_h(data) (0x000000FF&(data))
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_get_rtnr_ma_isnr_getmotion_motionth3_h(data) ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_get_rtnr_ma_isnr_getmotion_motionth2_h(data) ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_ISNR_GETMOTION_MOTIONTH_HIGH_get_rtnr_ma_isnr_getmotion_motionth1_h(data) (0x000000FF&(data))

#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM                                  0x18024AC8
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_reg_addr                          "0xB8024AC8"
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_reg                               0xB8024AC8
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_inst_addr                         "0x019E"
#define  set_DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_reg(data)                     (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_reg)=data)
#define  get_DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_reg                           (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_reg))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_rtnr_ma_isnr_getmotion_edgeslope3_lm_shift (16)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_rtnr_ma_isnr_getmotion_edgeslope2_lm_shift (8)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_rtnr_ma_isnr_getmotion_edgeslope1_lm_shift (0)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_rtnr_ma_isnr_getmotion_edgeslope3_lm_mask (0x00FF0000)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_rtnr_ma_isnr_getmotion_edgeslope2_lm_mask (0x0000FF00)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_rtnr_ma_isnr_getmotion_edgeslope1_lm_mask (0x000000FF)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_rtnr_ma_isnr_getmotion_edgeslope3_lm(data) (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_rtnr_ma_isnr_getmotion_edgeslope2_lm(data) (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_rtnr_ma_isnr_getmotion_edgeslope1_lm(data) (0x000000FF&(data))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_get_rtnr_ma_isnr_getmotion_edgeslope3_lm(data) ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_get_rtnr_ma_isnr_getmotion_edgeslope2_lm(data) ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPELM_get_rtnr_ma_isnr_getmotion_edgeslope1_lm(data) (0x000000FF&(data))

#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN                                  0x18024ACC
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_reg_addr                          "0xB8024ACC"
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_reg                               0xB8024ACC
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_inst_addr                         "0x019F"
#define  set_DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_reg(data)                     (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_reg)=data)
#define  get_DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_reg                           (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_reg))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_rtnr_ma_isnr_getmotion_edgeslope3_mn_shift (16)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_rtnr_ma_isnr_getmotion_edgeslope2_mn_shift (8)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_rtnr_ma_isnr_getmotion_edgeslope1_mn_shift (0)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_rtnr_ma_isnr_getmotion_edgeslope3_mn_mask (0x00FF0000)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_rtnr_ma_isnr_getmotion_edgeslope2_mn_mask (0x0000FF00)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_rtnr_ma_isnr_getmotion_edgeslope1_mn_mask (0x000000FF)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_rtnr_ma_isnr_getmotion_edgeslope3_mn(data) (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_rtnr_ma_isnr_getmotion_edgeslope2_mn(data) (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_rtnr_ma_isnr_getmotion_edgeslope1_mn(data) (0x000000FF&(data))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_get_rtnr_ma_isnr_getmotion_edgeslope3_mn(data) ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_get_rtnr_ma_isnr_getmotion_edgeslope2_mn(data) ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPEMN_get_rtnr_ma_isnr_getmotion_edgeslope1_mn(data) (0x000000FF&(data))

#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH                                  0x18024AD0
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_reg_addr                          "0xB8024AD0"
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_reg                               0xB8024AD0
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_inst_addr                         "0x01A0"
#define  set_DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_reg(data)                     (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_reg)=data)
#define  get_DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_reg                           (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_reg))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_rtnr_ma_isnr_getmotion_edgeslope3_nh_shift (16)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_rtnr_ma_isnr_getmotion_edgeslope2_nh_shift (8)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_rtnr_ma_isnr_getmotion_edgeslope1_nh_shift (0)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_rtnr_ma_isnr_getmotion_edgeslope3_nh_mask (0x00FF0000)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_rtnr_ma_isnr_getmotion_edgeslope2_nh_mask (0x0000FF00)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_rtnr_ma_isnr_getmotion_edgeslope1_nh_mask (0x000000FF)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_rtnr_ma_isnr_getmotion_edgeslope3_nh(data) (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_rtnr_ma_isnr_getmotion_edgeslope2_nh(data) (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_rtnr_ma_isnr_getmotion_edgeslope1_nh(data) (0x000000FF&(data))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_get_rtnr_ma_isnr_getmotion_edgeslope3_nh(data) ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_get_rtnr_ma_isnr_getmotion_edgeslope2_nh(data) ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGESLOPENH_get_rtnr_ma_isnr_getmotion_edgeslope1_nh(data) (0x000000FF&(data))

#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH                                      0x18024AD4
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_reg_addr                              "0xB8024AD4"
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_reg                                   0xB8024AD4
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_inst_addr                             "0x01A1"
#define  set_DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_reg(data)                         (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_reg)=data)
#define  get_DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_reg                               (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_reg))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth4_shift  (24)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth3_shift  (16)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth2_shift  (8)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth1_shift  (0)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth4_mask   (0xFF000000)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth3_mask   (0x00FF0000)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth2_mask   (0x0000FF00)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth1_mask   (0x000000FF)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth4(data)  (0xFF000000&((data)<<24))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth3(data)  (0x00FF0000&((data)<<16))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth2(data)  (0x0000FF00&((data)<<8))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_rtnr_ma_isnr_getmotion_edgeth1(data)  (0x000000FF&(data))
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_get_rtnr_ma_isnr_getmotion_edgeth4(data) ((0xFF000000&(data))>>24)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_get_rtnr_ma_isnr_getmotion_edgeth3(data) ((0x00FF0000&(data))>>16)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_get_rtnr_ma_isnr_getmotion_edgeth2(data) ((0x0000FF00&(data))>>8)
#define  DI_RTNR_MA_ISNR_GETMOTION_EDGE_TH_get_rtnr_ma_isnr_getmotion_edgeth1(data) (0x000000FF&(data))

#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN                                         0x18024AD8
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_reg_addr                                 "0xB8024AD8"
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_reg                                      0xB8024AD8
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_inst_addr                                "0x01A2"
#define  set_DI_RTNR_MA_ISNR_GETMOTION_MAIN_reg(data)                            (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_MAIN_reg)=data)
#define  get_DI_RTNR_MA_ISNR_GETMOTION_MAIN_reg                                  (*((volatile unsigned int*)DI_RTNR_MA_ISNR_GETMOTION_MAIN_reg))
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_isnr_getmotion_en_shift             (31)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_isnr_filmmotion_update_shift        (30)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_ma_isnr_getmotion_ydiffmask_shift   (8)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_ma_isnr_getmotion_edgemask_shift    (4)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_ma_isnr_getmotion_motionoffset_shift (0)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_isnr_getmotion_en_mask              (0x80000000)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_isnr_filmmotion_update_mask         (0x40000000)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_ma_isnr_getmotion_ydiffmask_mask    (0x00000300)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_ma_isnr_getmotion_edgemask_mask     (0x00000010)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_ma_isnr_getmotion_motionoffset_mask (0x0000000F)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_isnr_getmotion_en(data)             (0x80000000&((data)<<31))
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_isnr_filmmotion_update(data)        (0x40000000&((data)<<30))
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_ma_isnr_getmotion_ydiffmask(data)   (0x00000300&((data)<<8))
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_ma_isnr_getmotion_edgemask(data)    (0x00000010&((data)<<4))
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_rtnr_ma_isnr_getmotion_motionoffset(data) (0x0000000F&(data))
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_get_rtnr_isnr_getmotion_en(data)         ((0x80000000&(data))>>31)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_get_rtnr_isnr_filmmotion_update(data)    ((0x40000000&(data))>>30)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_get_rtnr_ma_isnr_getmotion_ydiffmask(data) ((0x00000300&(data))>>8)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_get_rtnr_ma_isnr_getmotion_edgemask(data) ((0x00000010&(data))>>4)
#define  DI_RTNR_MA_ISNR_GETMOTION_MAIN_get_rtnr_ma_isnr_getmotion_motionoffset(data) (0x0000000F&(data))

#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH                                    0x18024ADC
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_reg_addr                            "0xB8024ADC"
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_reg                                 0xB8024ADC
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_inst_addr                           "0x01A3"
#define  set_DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_reg(data)                       (*((volatile unsigned int*)DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_reg)=data)
#define  get_DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_reg                             (*((volatile unsigned int*)DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_reg))
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_dy_vertical_diff_th_en_shift (10)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_diff_s_v_divd_shift          (9)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_dy_hdiff_th_en_shift         (8)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_hdiff_th2_lo_shift           (4)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_hdiff_th1_lo_shift           (0)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_dy_vertical_diff_th_en_mask  (0x00000400)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_diff_s_v_divd_mask           (0x00000200)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_dy_hdiff_th_en_mask          (0x00000100)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_hdiff_th2_lo_mask            (0x000000F0)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_hdiff_th1_lo_mask            (0x0000000F)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_dy_vertical_diff_th_en(data) (0x00000400&((data)<<10))
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_diff_s_v_divd(data)          (0x00000200&((data)<<9))
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_dy_hdiff_th_en(data)         (0x00000100&((data)<<8))
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_hdiff_th2_lo(data)           (0x000000F0&((data)<<4))
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_nintra_hdiff_th1_lo(data)           (0x0000000F&(data))
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_get_nintra_dy_vertical_diff_th_en(data) ((0x00000400&(data))>>10)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_get_nintra_diff_s_v_divd(data)      ((0x00000200&(data))>>9)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_get_nintra_dy_hdiff_th_en(data)     ((0x00000100&(data))>>8)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_get_nintra_hdiff_th2_lo(data)       ((0x000000F0&(data))>>4)
#define  DI_IM_DI_NINTRA_DYN_SEARCH_RANGE_TH_get_nintra_hdiff_th1_lo(data)       (0x0000000F&(data))

#define  DI_DI_PTG_CTRL                                                         0x18024AE0
#define  DI_DI_PTG_CTRL_reg_addr                                                 "0xB8024AE0"
#define  DI_DI_PTG_CTRL_reg                                                      0xB8024AE0
#define  DI_DI_PTG_CTRL_inst_addr                                                "0x01A4"
#define  set_DI_DI_PTG_CTRL_reg(data)                                            (*((volatile unsigned int*)DI_DI_PTG_CTRL_reg)=data)
#define  get_DI_DI_PTG_CTRL_reg                                                  (*((volatile unsigned int*)DI_DI_PTG_CTRL_reg))
#define  DI_DI_PTG_CTRL_di_color_bar_mode_en_shift                               (22)
#define  DI_DI_PTG_CTRL_di_color_bar_vertical_mode_shift                         (4)
#define  DI_DI_PTG_CTRL_di_color_num_shift                                       (0)
#define  DI_DI_PTG_CTRL_di_color_bar_mode_en_mask                                (0x00C00000)
#define  DI_DI_PTG_CTRL_di_color_bar_vertical_mode_mask                          (0x00000010)
#define  DI_DI_PTG_CTRL_di_color_num_mask                                        (0x00000003)
#define  DI_DI_PTG_CTRL_di_color_bar_mode_en(data)                               (0x00C00000&((data)<<22))
#define  DI_DI_PTG_CTRL_di_color_bar_vertical_mode(data)                         (0x00000010&((data)<<4))
#define  DI_DI_PTG_CTRL_di_color_num(data)                                       (0x00000003&(data))
#define  DI_DI_PTG_CTRL_get_di_color_bar_mode_en(data)                           ((0x00C00000&(data))>>22)
#define  DI_DI_PTG_CTRL_get_di_color_bar_vertical_mode(data)                     ((0x00000010&(data))>>4)
#define  DI_DI_PTG_CTRL_get_di_color_num(data)                                   (0x00000003&(data))

#define  DI_DI_PTG_C0Y_Cb_Cr                                                    0x18024AE4
#define  DI_DI_PTG_C0Y_Cb_Cr_reg_addr                                            "0xB8024AE4"
#define  DI_DI_PTG_C0Y_Cb_Cr_reg                                                 0xB8024AE4
#define  DI_DI_PTG_C0Y_Cb_Cr_inst_addr                                           "0x01A5"
#define  set_DI_DI_PTG_C0Y_Cb_Cr_reg(data)                                       (*((volatile unsigned int*)DI_DI_PTG_C0Y_Cb_Cr_reg)=data)
#define  get_DI_DI_PTG_C0Y_Cb_Cr_reg                                             (*((volatile unsigned int*)DI_DI_PTG_C0Y_Cb_Cr_reg))
#define  DI_DI_PTG_C0Y_Cb_Cr_di_i_c0y_92b_shift                                  (16)
#define  DI_DI_PTG_C0Y_Cb_Cr_di_i_c0cr_92b_shift                                 (8)
#define  DI_DI_PTG_C0Y_Cb_Cr_di_i_c0cb_92b_shift                                 (0)
#define  DI_DI_PTG_C0Y_Cb_Cr_di_i_c0y_92b_mask                                   (0x00FF0000)
#define  DI_DI_PTG_C0Y_Cb_Cr_di_i_c0cr_92b_mask                                  (0x0000FF00)
#define  DI_DI_PTG_C0Y_Cb_Cr_di_i_c0cb_92b_mask                                  (0x000000FF)
#define  DI_DI_PTG_C0Y_Cb_Cr_di_i_c0y_92b(data)                                  (0x00FF0000&((data)<<16))
#define  DI_DI_PTG_C0Y_Cb_Cr_di_i_c0cr_92b(data)                                 (0x0000FF00&((data)<<8))
#define  DI_DI_PTG_C0Y_Cb_Cr_di_i_c0cb_92b(data)                                 (0x000000FF&(data))
#define  DI_DI_PTG_C0Y_Cb_Cr_get_di_i_c0y_92b(data)                              ((0x00FF0000&(data))>>16)
#define  DI_DI_PTG_C0Y_Cb_Cr_get_di_i_c0cr_92b(data)                             ((0x0000FF00&(data))>>8)
#define  DI_DI_PTG_C0Y_Cb_Cr_get_di_i_c0cb_92b(data)                             (0x000000FF&(data))

#define  DI_DI_PTG_C1Y_Cb_Cr                                                    0x18024AE8
#define  DI_DI_PTG_C1Y_Cb_Cr_reg_addr                                            "0xB8024AE8"
#define  DI_DI_PTG_C1Y_Cb_Cr_reg                                                 0xB8024AE8
#define  DI_DI_PTG_C1Y_Cb_Cr_inst_addr                                           "0x01A6"
#define  set_DI_DI_PTG_C1Y_Cb_Cr_reg(data)                                       (*((volatile unsigned int*)DI_DI_PTG_C1Y_Cb_Cr_reg)=data)
#define  get_DI_DI_PTG_C1Y_Cb_Cr_reg                                             (*((volatile unsigned int*)DI_DI_PTG_C1Y_Cb_Cr_reg))
#define  DI_DI_PTG_C1Y_Cb_Cr_di_i_c1y_92b_shift                                  (16)
#define  DI_DI_PTG_C1Y_Cb_Cr_di_i_c1cr_92b_shift                                 (8)
#define  DI_DI_PTG_C1Y_Cb_Cr_di_i_c1cb_92b_shift                                 (0)
#define  DI_DI_PTG_C1Y_Cb_Cr_di_i_c1y_92b_mask                                   (0x00FF0000)
#define  DI_DI_PTG_C1Y_Cb_Cr_di_i_c1cr_92b_mask                                  (0x0000FF00)
#define  DI_DI_PTG_C1Y_Cb_Cr_di_i_c1cb_92b_mask                                  (0x000000FF)
#define  DI_DI_PTG_C1Y_Cb_Cr_di_i_c1y_92b(data)                                  (0x00FF0000&((data)<<16))
#define  DI_DI_PTG_C1Y_Cb_Cr_di_i_c1cr_92b(data)                                 (0x0000FF00&((data)<<8))
#define  DI_DI_PTG_C1Y_Cb_Cr_di_i_c1cb_92b(data)                                 (0x000000FF&(data))
#define  DI_DI_PTG_C1Y_Cb_Cr_get_di_i_c1y_92b(data)                              ((0x00FF0000&(data))>>16)
#define  DI_DI_PTG_C1Y_Cb_Cr_get_di_i_c1cr_92b(data)                             ((0x0000FF00&(data))>>8)
#define  DI_DI_PTG_C1Y_Cb_Cr_get_di_i_c1cb_92b(data)                             (0x000000FF&(data))

#define  DI_DI_PTG_C2Y_Cb_Cr                                                    0x18024AEC
#define  DI_DI_PTG_C2Y_Cb_Cr_reg_addr                                            "0xB8024AEC"
#define  DI_DI_PTG_C2Y_Cb_Cr_reg                                                 0xB8024AEC
#define  DI_DI_PTG_C2Y_Cb_Cr_inst_addr                                           "0x01A7"
#define  set_DI_DI_PTG_C2Y_Cb_Cr_reg(data)                                       (*((volatile unsigned int*)DI_DI_PTG_C2Y_Cb_Cr_reg)=data)
#define  get_DI_DI_PTG_C2Y_Cb_Cr_reg                                             (*((volatile unsigned int*)DI_DI_PTG_C2Y_Cb_Cr_reg))
#define  DI_DI_PTG_C2Y_Cb_Cr_di_i_c2y_92b_shift                                  (16)
#define  DI_DI_PTG_C2Y_Cb_Cr_di_i_c2cr_92b_shift                                 (8)
#define  DI_DI_PTG_C2Y_Cb_Cr_di_i_c2cb_92b_shift                                 (0)
#define  DI_DI_PTG_C2Y_Cb_Cr_di_i_c2y_92b_mask                                   (0x00FF0000)
#define  DI_DI_PTG_C2Y_Cb_Cr_di_i_c2cr_92b_mask                                  (0x0000FF00)
#define  DI_DI_PTG_C2Y_Cb_Cr_di_i_c2cb_92b_mask                                  (0x000000FF)
#define  DI_DI_PTG_C2Y_Cb_Cr_di_i_c2y_92b(data)                                  (0x00FF0000&((data)<<16))
#define  DI_DI_PTG_C2Y_Cb_Cr_di_i_c2cr_92b(data)                                 (0x0000FF00&((data)<<8))
#define  DI_DI_PTG_C2Y_Cb_Cr_di_i_c2cb_92b(data)                                 (0x000000FF&(data))
#define  DI_DI_PTG_C2Y_Cb_Cr_get_di_i_c2y_92b(data)                              ((0x00FF0000&(data))>>16)
#define  DI_DI_PTG_C2Y_Cb_Cr_get_di_i_c2cr_92b(data)                             ((0x0000FF00&(data))>>8)
#define  DI_DI_PTG_C2Y_Cb_Cr_get_di_i_c2cb_92b(data)                             (0x000000FF&(data))

#define  DI_DI_PTG_C3Y_Cb_Cr                                                    0x18024AF0
#define  DI_DI_PTG_C3Y_Cb_Cr_reg_addr                                            "0xB8024AF0"
#define  DI_DI_PTG_C3Y_Cb_Cr_reg                                                 0xB8024AF0
#define  DI_DI_PTG_C3Y_Cb_Cr_inst_addr                                           "0x01A8"
#define  set_DI_DI_PTG_C3Y_Cb_Cr_reg(data)                                       (*((volatile unsigned int*)DI_DI_PTG_C3Y_Cb_Cr_reg)=data)
#define  get_DI_DI_PTG_C3Y_Cb_Cr_reg                                             (*((volatile unsigned int*)DI_DI_PTG_C3Y_Cb_Cr_reg))
#define  DI_DI_PTG_C3Y_Cb_Cr_di_i_c3y_92b_shift                                  (16)
#define  DI_DI_PTG_C3Y_Cb_Cr_di_i_c3cr_92b_shift                                 (8)
#define  DI_DI_PTG_C3Y_Cb_Cr_di_i_c3cb_92b_shift                                 (0)
#define  DI_DI_PTG_C3Y_Cb_Cr_di_i_c3y_92b_mask                                   (0x00FF0000)
#define  DI_DI_PTG_C3Y_Cb_Cr_di_i_c3cr_92b_mask                                  (0x0000FF00)
#define  DI_DI_PTG_C3Y_Cb_Cr_di_i_c3cb_92b_mask                                  (0x000000FF)
#define  DI_DI_PTG_C3Y_Cb_Cr_di_i_c3y_92b(data)                                  (0x00FF0000&((data)<<16))
#define  DI_DI_PTG_C3Y_Cb_Cr_di_i_c3cr_92b(data)                                 (0x0000FF00&((data)<<8))
#define  DI_DI_PTG_C3Y_Cb_Cr_di_i_c3cb_92b(data)                                 (0x000000FF&(data))
#define  DI_DI_PTG_C3Y_Cb_Cr_get_di_i_c3y_92b(data)                              ((0x00FF0000&(data))>>16)
#define  DI_DI_PTG_C3Y_Cb_Cr_get_di_i_c3cr_92b(data)                             ((0x0000FF00&(data))>>8)
#define  DI_DI_PTG_C3Y_Cb_Cr_get_di_i_c3cb_92b(data)                             (0x000000FF&(data))

#define  DI_DI_PTG_C4Y_Cb_Cr                                                    0x18024AF4
#define  DI_DI_PTG_C4Y_Cb_Cr_reg_addr                                            "0xB8024AF4"
#define  DI_DI_PTG_C4Y_Cb_Cr_reg                                                 0xB8024AF4
#define  DI_DI_PTG_C4Y_Cb_Cr_inst_addr                                           "0x01A9"
#define  set_DI_DI_PTG_C4Y_Cb_Cr_reg(data)                                       (*((volatile unsigned int*)DI_DI_PTG_C4Y_Cb_Cr_reg)=data)
#define  get_DI_DI_PTG_C4Y_Cb_Cr_reg                                             (*((volatile unsigned int*)DI_DI_PTG_C4Y_Cb_Cr_reg))
#define  DI_DI_PTG_C4Y_Cb_Cr_di_i_c4y_92b_shift                                  (16)
#define  DI_DI_PTG_C4Y_Cb_Cr_di_i_c4cr_92b_shift                                 (8)
#define  DI_DI_PTG_C4Y_Cb_Cr_di_i_c4cb_92b_shift                                 (0)
#define  DI_DI_PTG_C4Y_Cb_Cr_di_i_c4y_92b_mask                                   (0x00FF0000)
#define  DI_DI_PTG_C4Y_Cb_Cr_di_i_c4cr_92b_mask                                  (0x0000FF00)
#define  DI_DI_PTG_C4Y_Cb_Cr_di_i_c4cb_92b_mask                                  (0x000000FF)
#define  DI_DI_PTG_C4Y_Cb_Cr_di_i_c4y_92b(data)                                  (0x00FF0000&((data)<<16))
#define  DI_DI_PTG_C4Y_Cb_Cr_di_i_c4cr_92b(data)                                 (0x0000FF00&((data)<<8))
#define  DI_DI_PTG_C4Y_Cb_Cr_di_i_c4cb_92b(data)                                 (0x000000FF&(data))
#define  DI_DI_PTG_C4Y_Cb_Cr_get_di_i_c4y_92b(data)                              ((0x00FF0000&(data))>>16)
#define  DI_DI_PTG_C4Y_Cb_Cr_get_di_i_c4cr_92b(data)                             ((0x0000FF00&(data))>>8)
#define  DI_DI_PTG_C4Y_Cb_Cr_get_di_i_c4cb_92b(data)                             (0x000000FF&(data))

#define  DI_DI_PTG_C5Y_Cr_Cb                                                    0x18024AF8
#define  DI_DI_PTG_C5Y_Cr_Cb_reg_addr                                            "0xB8024AF8"
#define  DI_DI_PTG_C5Y_Cr_Cb_reg                                                 0xB8024AF8
#define  DI_DI_PTG_C5Y_Cr_Cb_inst_addr                                           "0x01AA"
#define  set_DI_DI_PTG_C5Y_Cr_Cb_reg(data)                                       (*((volatile unsigned int*)DI_DI_PTG_C5Y_Cr_Cb_reg)=data)
#define  get_DI_DI_PTG_C5Y_Cr_Cb_reg                                             (*((volatile unsigned int*)DI_DI_PTG_C5Y_Cr_Cb_reg))
#define  DI_DI_PTG_C5Y_Cr_Cb_di_i_c5y_92b_shift                                  (16)
#define  DI_DI_PTG_C5Y_Cr_Cb_di_i_c5cr_92b_shift                                 (8)
#define  DI_DI_PTG_C5Y_Cr_Cb_di_i_c5cb_92b_shift                                 (0)
#define  DI_DI_PTG_C5Y_Cr_Cb_di_i_c5y_92b_mask                                   (0x00FF0000)
#define  DI_DI_PTG_C5Y_Cr_Cb_di_i_c5cr_92b_mask                                  (0x0000FF00)
#define  DI_DI_PTG_C5Y_Cr_Cb_di_i_c5cb_92b_mask                                  (0x000000FF)
#define  DI_DI_PTG_C5Y_Cr_Cb_di_i_c5y_92b(data)                                  (0x00FF0000&((data)<<16))
#define  DI_DI_PTG_C5Y_Cr_Cb_di_i_c5cr_92b(data)                                 (0x0000FF00&((data)<<8))
#define  DI_DI_PTG_C5Y_Cr_Cb_di_i_c5cb_92b(data)                                 (0x000000FF&(data))
#define  DI_DI_PTG_C5Y_Cr_Cb_get_di_i_c5y_92b(data)                              ((0x00FF0000&(data))>>16)
#define  DI_DI_PTG_C5Y_Cr_Cb_get_di_i_c5cr_92b(data)                             ((0x0000FF00&(data))>>8)
#define  DI_DI_PTG_C5Y_Cr_Cb_get_di_i_c5cb_92b(data)                             (0x000000FF&(data))

#define  DI_DI_PTG_C6Y_Cb_Cr                                                    0x18024AFC
#define  DI_DI_PTG_C6Y_Cb_Cr_reg_addr                                            "0xB8024AFC"
#define  DI_DI_PTG_C6Y_Cb_Cr_reg                                                 0xB8024AFC
#define  DI_DI_PTG_C6Y_Cb_Cr_inst_addr                                           "0x01AB"
#define  set_DI_DI_PTG_C6Y_Cb_Cr_reg(data)                                       (*((volatile unsigned int*)DI_DI_PTG_C6Y_Cb_Cr_reg)=data)
#define  get_DI_DI_PTG_C6Y_Cb_Cr_reg                                             (*((volatile unsigned int*)DI_DI_PTG_C6Y_Cb_Cr_reg))
#define  DI_DI_PTG_C6Y_Cb_Cr_di_i_c6y_92b_shift                                  (16)
#define  DI_DI_PTG_C6Y_Cb_Cr_di_i_c6cr_92b_shift                                 (8)
#define  DI_DI_PTG_C6Y_Cb_Cr_di_i_c6cb_92b_shift                                 (0)
#define  DI_DI_PTG_C6Y_Cb_Cr_di_i_c6y_92b_mask                                   (0x00FF0000)
#define  DI_DI_PTG_C6Y_Cb_Cr_di_i_c6cr_92b_mask                                  (0x0000FF00)
#define  DI_DI_PTG_C6Y_Cb_Cr_di_i_c6cb_92b_mask                                  (0x000000FF)
#define  DI_DI_PTG_C6Y_Cb_Cr_di_i_c6y_92b(data)                                  (0x00FF0000&((data)<<16))
#define  DI_DI_PTG_C6Y_Cb_Cr_di_i_c6cr_92b(data)                                 (0x0000FF00&((data)<<8))
#define  DI_DI_PTG_C6Y_Cb_Cr_di_i_c6cb_92b(data)                                 (0x000000FF&(data))
#define  DI_DI_PTG_C6Y_Cb_Cr_get_di_i_c6y_92b(data)                              ((0x00FF0000&(data))>>16)
#define  DI_DI_PTG_C6Y_Cb_Cr_get_di_i_c6cr_92b(data)                             ((0x0000FF00&(data))>>8)
#define  DI_DI_PTG_C6Y_Cb_Cr_get_di_i_c6cb_92b(data)                             (0x000000FF&(data))

#define  DI_DI_PTG_C7Y_Cb_Cr                                                    0x18024BD0
#define  DI_DI_PTG_C7Y_Cb_Cr_reg_addr                                            "0xB8024BD0"
#define  DI_DI_PTG_C7Y_Cb_Cr_reg                                                 0xB8024BD0
#define  DI_DI_PTG_C7Y_Cb_Cr_inst_addr                                           "0x01AC"
#define  set_DI_DI_PTG_C7Y_Cb_Cr_reg(data)                                       (*((volatile unsigned int*)DI_DI_PTG_C7Y_Cb_Cr_reg)=data)
#define  get_DI_DI_PTG_C7Y_Cb_Cr_reg                                             (*((volatile unsigned int*)DI_DI_PTG_C7Y_Cb_Cr_reg))
#define  DI_DI_PTG_C7Y_Cb_Cr_di_i_c7y_92b_shift                                  (16)
#define  DI_DI_PTG_C7Y_Cb_Cr_di_i_c7cr_92b_shift                                 (8)
#define  DI_DI_PTG_C7Y_Cb_Cr_di_i_c7cb_92b_shift                                 (0)
#define  DI_DI_PTG_C7Y_Cb_Cr_di_i_c7y_92b_mask                                   (0x00FF0000)
#define  DI_DI_PTG_C7Y_Cb_Cr_di_i_c7cr_92b_mask                                  (0x0000FF00)
#define  DI_DI_PTG_C7Y_Cb_Cr_di_i_c7cb_92b_mask                                  (0x000000FF)
#define  DI_DI_PTG_C7Y_Cb_Cr_di_i_c7y_92b(data)                                  (0x00FF0000&((data)<<16))
#define  DI_DI_PTG_C7Y_Cb_Cr_di_i_c7cr_92b(data)                                 (0x0000FF00&((data)<<8))
#define  DI_DI_PTG_C7Y_Cb_Cr_di_i_c7cb_92b(data)                                 (0x000000FF&(data))
#define  DI_DI_PTG_C7Y_Cb_Cr_get_di_i_c7y_92b(data)                              ((0x00FF0000&(data))>>16)
#define  DI_DI_PTG_C7Y_Cb_Cr_get_di_i_c7cr_92b(data)                             ((0x0000FF00&(data))>>8)
#define  DI_DI_PTG_C7Y_Cb_Cr_get_di_i_c7cb_92b(data)                             (0x000000FF&(data))

#define  DI_DI_PTG_ACT_WINDOW                                                   0x18024BD4
#define  DI_DI_PTG_ACT_WINDOW_reg_addr                                           "0xB8024BD4"
#define  DI_DI_PTG_ACT_WINDOW_reg                                                0xB8024BD4
#define  DI_DI_PTG_ACT_WINDOW_inst_addr                                          "0x01AD"
#define  set_DI_DI_PTG_ACT_WINDOW_reg(data)                                      (*((volatile unsigned int*)DI_DI_PTG_ACT_WINDOW_reg)=data)
#define  get_DI_DI_PTG_ACT_WINDOW_reg                                            (*((volatile unsigned int*)DI_DI_PTG_ACT_WINDOW_reg))
#define  DI_DI_PTG_ACT_WINDOW_di_ptg_length_shift                                (16)
#define  DI_DI_PTG_ACT_WINDOW_di_ptg_width_shift                                 (0)
#define  DI_DI_PTG_ACT_WINDOW_di_ptg_length_mask                                 (0x3FFF0000)
#define  DI_DI_PTG_ACT_WINDOW_di_ptg_width_mask                                  (0x00003FFF)
#define  DI_DI_PTG_ACT_WINDOW_di_ptg_length(data)                                (0x3FFF0000&((data)<<16))
#define  DI_DI_PTG_ACT_WINDOW_di_ptg_width(data)                                 (0x00003FFF&(data))
#define  DI_DI_PTG_ACT_WINDOW_get_di_ptg_length(data)                            ((0x3FFF0000&(data))>>16)
#define  DI_DI_PTG_ACT_WINDOW_get_di_ptg_width(data)                             (0x00003FFF&(data))

#define  DI_DI_DI_SRAM_SELF_TEST                                                0x18024BE0
#define  DI_DI_DI_SRAM_SELF_TEST_reg_addr                                        "0xB8024BE0"
#define  DI_DI_DI_SRAM_SELF_TEST_reg                                             0xB8024BE0
#define  DI_DI_DI_SRAM_SELF_TEST_inst_addr                                       "0x01AE"
#define  set_DI_DI_DI_SRAM_SELF_TEST_reg(data)                                   (*((volatile unsigned int*)DI_DI_DI_SRAM_SELF_TEST_reg)=data)
#define  get_DI_DI_DI_SRAM_SELF_TEST_reg                                         (*((volatile unsigned int*)DI_DI_DI_SRAM_SELF_TEST_reg))
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_debug_bit_sel_dc_shift             (16)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_fail_bit_status_ro_dc_shift        (8)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sftx_sf_tx_mode_dc_shift                (7)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sftx_sf_tx_start_dc_shift               (6)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sftx_sf_tx_work_ro_dc_shift             (5)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_gated_dc_shift               (4)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_mode_dc_shift                (3)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_start_dc_shift               (2)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_done_ro_dc_shift             (1)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_err_ro_dc_shift              (0)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_debug_bit_sel_dc_mask              (0x00FF0000)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_fail_bit_status_ro_dc_mask         (0x00000100)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sftx_sf_tx_mode_dc_mask                 (0x00000080)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sftx_sf_tx_start_dc_mask                (0x00000040)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sftx_sf_tx_work_ro_dc_mask              (0x00000020)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_gated_dc_mask                (0x00000010)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_mode_dc_mask                 (0x00000008)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_start_dc_mask                (0x00000004)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_done_ro_dc_mask              (0x00000002)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_err_ro_dc_mask               (0x00000001)
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_debug_bit_sel_dc(data)             (0x00FF0000&((data)<<16))
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_fail_bit_status_ro_dc(data)        (0x00000100&((data)<<8))
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sftx_sf_tx_mode_dc(data)                (0x00000080&((data)<<7))
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sftx_sf_tx_start_dc(data)               (0x00000040&((data)<<6))
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sftx_sf_tx_work_ro_dc(data)             (0x00000020&((data)<<5))
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_gated_dc(data)               (0x00000010&((data)<<4))
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_mode_dc(data)                (0x00000008&((data)<<3))
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_start_dc(data)               (0x00000004&((data)<<2))
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_done_ro_dc(data)             (0x00000002&((data)<<1))
#define  DI_DI_DI_SRAM_SELF_TEST_di_sram_sfrx_sf_rx_err_ro_dc(data)              (0x00000001&(data))
#define  DI_DI_DI_SRAM_SELF_TEST_get_di_sram_sfrx_debug_bit_sel_dc(data)         ((0x00FF0000&(data))>>16)
#define  DI_DI_DI_SRAM_SELF_TEST_get_di_sram_sfrx_fail_bit_status_ro_dc(data)    ((0x00000100&(data))>>8)
#define  DI_DI_DI_SRAM_SELF_TEST_get_di_sram_sftx_sf_tx_mode_dc(data)            ((0x00000080&(data))>>7)
#define  DI_DI_DI_SRAM_SELF_TEST_get_di_sram_sftx_sf_tx_start_dc(data)           ((0x00000040&(data))>>6)
#define  DI_DI_DI_SRAM_SELF_TEST_get_di_sram_sftx_sf_tx_work_ro_dc(data)         ((0x00000020&(data))>>5)
#define  DI_DI_DI_SRAM_SELF_TEST_get_di_sram_sfrx_sf_rx_gated_dc(data)           ((0x00000010&(data))>>4)
#define  DI_DI_DI_SRAM_SELF_TEST_get_di_sram_sfrx_sf_rx_mode_dc(data)            ((0x00000008&(data))>>3)
#define  DI_DI_DI_SRAM_SELF_TEST_get_di_sram_sfrx_sf_rx_start_dc(data)           ((0x00000004&(data))>>2)
#define  DI_DI_DI_SRAM_SELF_TEST_get_di_sram_sfrx_sf_rx_done_ro_dc(data)         ((0x00000002&(data))>>1)
#define  DI_DI_DI_SRAM_SELF_TEST_get_di_sram_sfrx_sf_rx_err_ro_dc(data)          (0x00000001&(data))

#define  DI_ccdinr_Timing_monitor_ctrl                                          0x18024B00
#define  DI_ccdinr_Timing_monitor_ctrl_reg_addr                                  "0xB8024B00"
#define  DI_ccdinr_Timing_monitor_ctrl_reg                                       0xB8024B00
#define  DI_ccdinr_Timing_monitor_ctrl_inst_addr                                 "0x01AF"
#define  set_DI_ccdinr_Timing_monitor_ctrl_reg(data)                             (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_ctrl_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_ctrl_reg                                   (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_ctrl_reg))
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_en_shift                   (31)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_i2rnd_mode_shift           (29)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_src_shift                  (28)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_unit_shift                 (27)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_multi_mode_shift           (26)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_compare_shift              (24)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_sta0_shift                 (12)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_end0_shift                 (8)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_sta1_shift                 (4)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_end1_shift                 (0)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_en_mask                    (0x80000000)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_i2rnd_mode_mask            (0x60000000)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_src_mask                   (0x10000000)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_unit_mask                  (0x08000000)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_multi_mode_mask            (0x04000000)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_compare_mask               (0x03000000)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_sta0_mask                  (0x0000F000)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_end0_mask                  (0x00000F00)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_sta1_mask                  (0x000000F0)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_end1_mask                  (0x0000000F)
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_en(data)                   (0x80000000&((data)<<31))
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_i2rnd_mode(data)           (0x60000000&((data)<<29))
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_src(data)                  (0x10000000&((data)<<28))
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_unit(data)                 (0x08000000&((data)<<27))
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_multi_mode(data)           (0x04000000&((data)<<26))
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_compare(data)              (0x03000000&((data)<<24))
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_sta0(data)                 (0x0000F000&((data)<<12))
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_end0(data)                 (0x00000F00&((data)<<8))
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_sta1(data)                 (0x000000F0&((data)<<4))
#define  DI_ccdinr_Timing_monitor_ctrl_timing_monitor_end1(data)                 (0x0000000F&(data))
#define  DI_ccdinr_Timing_monitor_ctrl_get_timing_monitor_en(data)               ((0x80000000&(data))>>31)
#define  DI_ccdinr_Timing_monitor_ctrl_get_timing_monitor_i2rnd_mode(data)       ((0x60000000&(data))>>29)
#define  DI_ccdinr_Timing_monitor_ctrl_get_timing_monitor_src(data)              ((0x10000000&(data))>>28)
#define  DI_ccdinr_Timing_monitor_ctrl_get_timing_monitor_unit(data)             ((0x08000000&(data))>>27)
#define  DI_ccdinr_Timing_monitor_ctrl_get_timing_monitor_multi_mode(data)       ((0x04000000&(data))>>26)
#define  DI_ccdinr_Timing_monitor_ctrl_get_timing_monitor_compare(data)          ((0x03000000&(data))>>24)
#define  DI_ccdinr_Timing_monitor_ctrl_get_timing_monitor_sta0(data)             ((0x0000F000&(data))>>12)
#define  DI_ccdinr_Timing_monitor_ctrl_get_timing_monitor_end0(data)             ((0x00000F00&(data))>>8)
#define  DI_ccdinr_Timing_monitor_ctrl_get_timing_monitor_sta1(data)             ((0x000000F0&(data))>>4)
#define  DI_ccdinr_Timing_monitor_ctrl_get_timing_monitor_end1(data)             (0x0000000F&(data))

#define  DI_ccdinr_Timing_monitor_multi                                         0x18024B04
#define  DI_ccdinr_Timing_monitor_multi_reg_addr                                 "0xB8024B04"
#define  DI_ccdinr_Timing_monitor_multi_reg                                      0xB8024B04
#define  DI_ccdinr_Timing_monitor_multi_inst_addr                                "0x01B0"
#define  set_DI_ccdinr_Timing_monitor_multi_reg(data)                            (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_multi_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_multi_reg                                  (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_multi_reg))
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta2_shift                (28)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end2_shift                (24)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta3_shift                (20)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end3_shift                (16)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta4_shift                (12)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end4_shift                (8)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta5_shift                (4)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end5_shift                (0)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta2_mask                 (0xF0000000)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end2_mask                 (0x0F000000)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta3_mask                 (0x00F00000)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end3_mask                 (0x000F0000)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta4_mask                 (0x0000F000)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end4_mask                 (0x00000F00)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta5_mask                 (0x000000F0)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end5_mask                 (0x0000000F)
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta2(data)                (0xF0000000&((data)<<28))
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end2(data)                (0x0F000000&((data)<<24))
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta3(data)                (0x00F00000&((data)<<20))
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end3(data)                (0x000F0000&((data)<<16))
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta4(data)                (0x0000F000&((data)<<12))
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end4(data)                (0x00000F00&((data)<<8))
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_sta5(data)                (0x000000F0&((data)<<4))
#define  DI_ccdinr_Timing_monitor_multi_timing_monitor_end5(data)                (0x0000000F&(data))
#define  DI_ccdinr_Timing_monitor_multi_get_timing_monitor_sta2(data)            ((0xF0000000&(data))>>28)
#define  DI_ccdinr_Timing_monitor_multi_get_timing_monitor_end2(data)            ((0x0F000000&(data))>>24)
#define  DI_ccdinr_Timing_monitor_multi_get_timing_monitor_sta3(data)            ((0x00F00000&(data))>>20)
#define  DI_ccdinr_Timing_monitor_multi_get_timing_monitor_end3(data)            ((0x000F0000&(data))>>16)
#define  DI_ccdinr_Timing_monitor_multi_get_timing_monitor_sta4(data)            ((0x0000F000&(data))>>12)
#define  DI_ccdinr_Timing_monitor_multi_get_timing_monitor_end4(data)            ((0x00000F00&(data))>>8)
#define  DI_ccdinr_Timing_monitor_multi_get_timing_monitor_sta5(data)            ((0x000000F0&(data))>>4)
#define  DI_ccdinr_Timing_monitor_multi_get_timing_monitor_end5(data)            (0x0000000F&(data))

#define  DI_ccdinr_Timing_monitor_compare_th                                    0x18024B08
#define  DI_ccdinr_Timing_monitor_compare_th_reg_addr                            "0xB8024B08"
#define  DI_ccdinr_Timing_monitor_compare_th_reg                                 0xB8024B08
#define  DI_ccdinr_Timing_monitor_compare_th_inst_addr                           "0x01B1"
#define  set_DI_ccdinr_Timing_monitor_compare_th_reg(data)                       (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_compare_th_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_compare_th_reg                             (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_compare_th_reg))
#define  DI_ccdinr_Timing_monitor_compare_th_t_m_compare_th_shift                (0)
#define  DI_ccdinr_Timing_monitor_compare_th_t_m_compare_th_mask                 (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_compare_th_t_m_compare_th(data)                (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_compare_th_get_t_m_compare_th(data)            (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_golden                                        0x18024B0C
#define  DI_ccdinr_Timing_monitor_golden_reg_addr                                "0xB8024B0C"
#define  DI_ccdinr_Timing_monitor_golden_reg                                     0xB8024B0C
#define  DI_ccdinr_Timing_monitor_golden_inst_addr                               "0x01B2"
#define  set_DI_ccdinr_Timing_monitor_golden_reg(data)                           (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_golden_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_golden_reg                                 (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_golden_reg))
#define  DI_ccdinr_Timing_monitor_golden_t_m_golden_shift                        (0)
#define  DI_ccdinr_Timing_monitor_golden_t_m_golden_mask                         (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_golden_t_m_golden(data)                        (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_golden_get_t_m_golden(data)                    (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_result1                                       0x18024B10
#define  DI_ccdinr_Timing_monitor_result1_reg_addr                               "0xB8024B10"
#define  DI_ccdinr_Timing_monitor_result1_reg                                    0xB8024B10
#define  DI_ccdinr_Timing_monitor_result1_inst_addr                              "0x01B3"
#define  set_DI_ccdinr_Timing_monitor_result1_reg(data)                          (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_result1_reg                                (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result1_reg))
#define  DI_ccdinr_Timing_monitor_result1_t_m_result_previous1_shift             (0)
#define  DI_ccdinr_Timing_monitor_result1_t_m_result_previous1_mask              (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_result1_t_m_result_previous1(data)             (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_result1_get_t_m_result_previous1(data)         (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_result2                                       0x18024B14
#define  DI_ccdinr_Timing_monitor_result2_reg_addr                               "0xB8024B14"
#define  DI_ccdinr_Timing_monitor_result2_reg                                    0xB8024B14
#define  DI_ccdinr_Timing_monitor_result2_inst_addr                              "0x01B4"
#define  set_DI_ccdinr_Timing_monitor_result2_reg(data)                          (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result2_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_result2_reg                                (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result2_reg))
#define  DI_ccdinr_Timing_monitor_result2_t_m_result_previous2_shift             (0)
#define  DI_ccdinr_Timing_monitor_result2_t_m_result_previous2_mask              (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_result2_t_m_result_previous2(data)             (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_result2_get_t_m_result_previous2(data)         (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_result3                                       0x18024B18
#define  DI_ccdinr_Timing_monitor_result3_reg_addr                               "0xB8024B18"
#define  DI_ccdinr_Timing_monitor_result3_reg                                    0xB8024B18
#define  DI_ccdinr_Timing_monitor_result3_inst_addr                              "0x01B5"
#define  set_DI_ccdinr_Timing_monitor_result3_reg(data)                          (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result3_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_result3_reg                                (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result3_reg))
#define  DI_ccdinr_Timing_monitor_result3_t_m_result_previous3_shift             (0)
#define  DI_ccdinr_Timing_monitor_result3_t_m_result_previous3_mask              (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_result3_t_m_result_previous3(data)             (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_result3_get_t_m_result_previous3(data)         (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_result4                                       0x18024B1C
#define  DI_ccdinr_Timing_monitor_result4_reg_addr                               "0xB8024B1C"
#define  DI_ccdinr_Timing_monitor_result4_reg                                    0xB8024B1C
#define  DI_ccdinr_Timing_monitor_result4_inst_addr                              "0x01B6"
#define  set_DI_ccdinr_Timing_monitor_result4_reg(data)                          (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result4_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_result4_reg                                (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result4_reg))
#define  DI_ccdinr_Timing_monitor_result4_t_m_result_previous4_shift             (0)
#define  DI_ccdinr_Timing_monitor_result4_t_m_result_previous4_mask              (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_result4_t_m_result_previous4(data)             (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_result4_get_t_m_result_previous4(data)         (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_max                                           0x18024B20
#define  DI_ccdinr_Timing_monitor_max_reg_addr                                   "0xB8024B20"
#define  DI_ccdinr_Timing_monitor_max_reg                                        0xB8024B20
#define  DI_ccdinr_Timing_monitor_max_inst_addr                                  "0x01B7"
#define  set_DI_ccdinr_Timing_monitor_max_reg(data)                              (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_max_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_max_reg                                    (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_max_reg))
#define  DI_ccdinr_Timing_monitor_max_t_m_result_max_shift                       (0)
#define  DI_ccdinr_Timing_monitor_max_t_m_result_max_mask                        (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_max_t_m_result_max(data)                       (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_max_get_t_m_result_max(data)                   (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_min                                           0x18024B24
#define  DI_ccdinr_Timing_monitor_min_reg_addr                                   "0xB8024B24"
#define  DI_ccdinr_Timing_monitor_min_reg                                        0xB8024B24
#define  DI_ccdinr_Timing_monitor_min_inst_addr                                  "0x01B8"
#define  set_DI_ccdinr_Timing_monitor_min_reg(data)                              (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_min_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_min_reg                                    (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_min_reg))
#define  DI_ccdinr_Timing_monitor_min_t_m_result_min_shift                       (0)
#define  DI_ccdinr_Timing_monitor_min_t_m_result_min_mask                        (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_min_t_m_result_min(data)                       (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_min_get_t_m_result_min(data)                   (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_st                                            0x18024B28
#define  DI_ccdinr_Timing_monitor_st_reg_addr                                    "0xB8024B28"
#define  DI_ccdinr_Timing_monitor_st_reg                                         0xB8024B28
#define  DI_ccdinr_Timing_monitor_st_inst_addr                                   "0x01B9"
#define  set_DI_ccdinr_Timing_monitor_st_reg(data)                               (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_st_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_st_reg                                     (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_st_reg))
#define  DI_ccdinr_Timing_monitor_st_compare_hit_shift                           (2)
#define  DI_ccdinr_Timing_monitor_st_hsync_hit_den_error_shift                   (1)
#define  DI_ccdinr_Timing_monitor_st_vsync_hit_den_error_shift                   (0)
#define  DI_ccdinr_Timing_monitor_st_compare_hit_mask                            (0x00000004)
#define  DI_ccdinr_Timing_monitor_st_hsync_hit_den_error_mask                    (0x00000002)
#define  DI_ccdinr_Timing_monitor_st_vsync_hit_den_error_mask                    (0x00000001)
#define  DI_ccdinr_Timing_monitor_st_compare_hit(data)                           (0x00000004&((data)<<2))
#define  DI_ccdinr_Timing_monitor_st_hsync_hit_den_error(data)                   (0x00000002&((data)<<1))
#define  DI_ccdinr_Timing_monitor_st_vsync_hit_den_error(data)                   (0x00000001&(data))
#define  DI_ccdinr_Timing_monitor_st_get_compare_hit(data)                       ((0x00000004&(data))>>2)
#define  DI_ccdinr_Timing_monitor_st_get_hsync_hit_den_error(data)               ((0x00000002&(data))>>1)
#define  DI_ccdinr_Timing_monitor_st_get_vsync_hit_den_error(data)               (0x00000001&(data))

#define  DI_ccdinr_Timing_monitor_ctrl_1                                        0x18024B30
#define  DI_ccdinr_Timing_monitor_ctrl_1_reg_addr                                "0xB8024B30"
#define  DI_ccdinr_Timing_monitor_ctrl_1_reg                                     0xB8024B30
#define  DI_ccdinr_Timing_monitor_ctrl_1_inst_addr                               "0x01BA"
#define  set_DI_ccdinr_Timing_monitor_ctrl_1_reg(data)                           (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_ctrl_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_ctrl_1_reg                                 (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_ctrl_1_reg))
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_en_1_shift               (31)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_i2rnd_mode_1_shift       (29)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_src_1_shift              (28)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_unit_1_shift             (27)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_multi_mode_1_shift       (26)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_compare_1_shift          (24)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_sta0_1_shift             (12)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_end0_1_shift             (8)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_sta1_1_shift             (4)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_end1_1_shift             (0)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_en_1_mask                (0x80000000)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_i2rnd_mode_1_mask        (0x60000000)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_src_1_mask               (0x10000000)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_unit_1_mask              (0x08000000)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_multi_mode_1_mask        (0x04000000)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_compare_1_mask           (0x03000000)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_sta0_1_mask              (0x0000F000)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_end0_1_mask              (0x00000F00)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_sta1_1_mask              (0x000000F0)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_end1_1_mask              (0x0000000F)
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_en_1(data)               (0x80000000&((data)<<31))
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_i2rnd_mode_1(data)       (0x60000000&((data)<<29))
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_src_1(data)              (0x10000000&((data)<<28))
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_unit_1(data)             (0x08000000&((data)<<27))
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_multi_mode_1(data)       (0x04000000&((data)<<26))
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_compare_1(data)          (0x03000000&((data)<<24))
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_sta0_1(data)             (0x0000F000&((data)<<12))
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_end0_1(data)             (0x00000F00&((data)<<8))
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_sta1_1(data)             (0x000000F0&((data)<<4))
#define  DI_ccdinr_Timing_monitor_ctrl_1_timing_monitor_end1_1(data)             (0x0000000F&(data))
#define  DI_ccdinr_Timing_monitor_ctrl_1_get_timing_monitor_en_1(data)           ((0x80000000&(data))>>31)
#define  DI_ccdinr_Timing_monitor_ctrl_1_get_timing_monitor_i2rnd_mode_1(data)   ((0x60000000&(data))>>29)
#define  DI_ccdinr_Timing_monitor_ctrl_1_get_timing_monitor_src_1(data)          ((0x10000000&(data))>>28)
#define  DI_ccdinr_Timing_monitor_ctrl_1_get_timing_monitor_unit_1(data)         ((0x08000000&(data))>>27)
#define  DI_ccdinr_Timing_monitor_ctrl_1_get_timing_monitor_multi_mode_1(data)   ((0x04000000&(data))>>26)
#define  DI_ccdinr_Timing_monitor_ctrl_1_get_timing_monitor_compare_1(data)      ((0x03000000&(data))>>24)
#define  DI_ccdinr_Timing_monitor_ctrl_1_get_timing_monitor_sta0_1(data)         ((0x0000F000&(data))>>12)
#define  DI_ccdinr_Timing_monitor_ctrl_1_get_timing_monitor_end0_1(data)         ((0x00000F00&(data))>>8)
#define  DI_ccdinr_Timing_monitor_ctrl_1_get_timing_monitor_sta1_1(data)         ((0x000000F0&(data))>>4)
#define  DI_ccdinr_Timing_monitor_ctrl_1_get_timing_monitor_end1_1(data)         (0x0000000F&(data))

#define  DI_ccdinr_Timing_monitor_multi_1                                       0x18024B34
#define  DI_ccdinr_Timing_monitor_multi_1_reg_addr                               "0xB8024B34"
#define  DI_ccdinr_Timing_monitor_multi_1_reg                                    0xB8024B34
#define  DI_ccdinr_Timing_monitor_multi_1_inst_addr                              "0x01BB"
#define  set_DI_ccdinr_Timing_monitor_multi_1_reg(data)                          (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_multi_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_multi_1_reg                                (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_multi_1_reg))
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta2_1_shift            (28)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end2_1_shift            (24)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta3_1_shift            (20)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end3_1_shift            (16)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta4_1_shift            (12)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end4_1_shift            (8)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta5_1_shift            (4)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end5_1_shift            (0)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta2_1_mask             (0xF0000000)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end2_1_mask             (0x0F000000)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta3_1_mask             (0x00F00000)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end3_1_mask             (0x000F0000)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta4_1_mask             (0x0000F000)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end4_1_mask             (0x00000F00)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta5_1_mask             (0x000000F0)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end5_1_mask             (0x0000000F)
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta2_1(data)            (0xF0000000&((data)<<28))
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end2_1(data)            (0x0F000000&((data)<<24))
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta3_1(data)            (0x00F00000&((data)<<20))
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end3_1(data)            (0x000F0000&((data)<<16))
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta4_1(data)            (0x0000F000&((data)<<12))
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end4_1(data)            (0x00000F00&((data)<<8))
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_sta5_1(data)            (0x000000F0&((data)<<4))
#define  DI_ccdinr_Timing_monitor_multi_1_timing_monitor_end5_1(data)            (0x0000000F&(data))
#define  DI_ccdinr_Timing_monitor_multi_1_get_timing_monitor_sta2_1(data)        ((0xF0000000&(data))>>28)
#define  DI_ccdinr_Timing_monitor_multi_1_get_timing_monitor_end2_1(data)        ((0x0F000000&(data))>>24)
#define  DI_ccdinr_Timing_monitor_multi_1_get_timing_monitor_sta3_1(data)        ((0x00F00000&(data))>>20)
#define  DI_ccdinr_Timing_monitor_multi_1_get_timing_monitor_end3_1(data)        ((0x000F0000&(data))>>16)
#define  DI_ccdinr_Timing_monitor_multi_1_get_timing_monitor_sta4_1(data)        ((0x0000F000&(data))>>12)
#define  DI_ccdinr_Timing_monitor_multi_1_get_timing_monitor_end4_1(data)        ((0x00000F00&(data))>>8)
#define  DI_ccdinr_Timing_monitor_multi_1_get_timing_monitor_sta5_1(data)        ((0x000000F0&(data))>>4)
#define  DI_ccdinr_Timing_monitor_multi_1_get_timing_monitor_end5_1(data)        (0x0000000F&(data))

#define  DI_ccdinr_Timing_monitor_compare_th_1                                  0x18024B38
#define  DI_ccdinr_Timing_monitor_compare_th_1_reg_addr                          "0xB8024B38"
#define  DI_ccdinr_Timing_monitor_compare_th_1_reg                               0xB8024B38
#define  DI_ccdinr_Timing_monitor_compare_th_1_inst_addr                         "0x01BC"
#define  set_DI_ccdinr_Timing_monitor_compare_th_1_reg(data)                     (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_compare_th_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_compare_th_1_reg                           (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_compare_th_1_reg))
#define  DI_ccdinr_Timing_monitor_compare_th_1_t_m_compare_th_1_shift            (0)
#define  DI_ccdinr_Timing_monitor_compare_th_1_t_m_compare_th_1_mask             (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_compare_th_1_t_m_compare_th_1(data)            (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_compare_th_1_get_t_m_compare_th_1(data)        (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_golden_1                                      0x18024B3C
#define  DI_ccdinr_Timing_monitor_golden_1_reg_addr                              "0xB8024B3C"
#define  DI_ccdinr_Timing_monitor_golden_1_reg                                   0xB8024B3C
#define  DI_ccdinr_Timing_monitor_golden_1_inst_addr                             "0x01BD"
#define  set_DI_ccdinr_Timing_monitor_golden_1_reg(data)                         (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_golden_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_golden_1_reg                               (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_golden_1_reg))
#define  DI_ccdinr_Timing_monitor_golden_1_t_m_golden_1_shift                    (0)
#define  DI_ccdinr_Timing_monitor_golden_1_t_m_golden_1_mask                     (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_golden_1_t_m_golden_1(data)                    (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_golden_1_get_t_m_golden_1(data)                (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_result1_1                                     0x18024B40
#define  DI_ccdinr_Timing_monitor_result1_1_reg_addr                             "0xB8024B40"
#define  DI_ccdinr_Timing_monitor_result1_1_reg                                  0xB8024B40
#define  DI_ccdinr_Timing_monitor_result1_1_inst_addr                            "0x01BE"
#define  set_DI_ccdinr_Timing_monitor_result1_1_reg(data)                        (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result1_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_result1_1_reg                              (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result1_1_reg))
#define  DI_ccdinr_Timing_monitor_result1_1_t_m_result_previous1_1_shift         (0)
#define  DI_ccdinr_Timing_monitor_result1_1_t_m_result_previous1_1_mask          (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_result1_1_t_m_result_previous1_1(data)         (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_result1_1_get_t_m_result_previous1_1(data)     (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_result2_1                                     0x18024B44
#define  DI_ccdinr_Timing_monitor_result2_1_reg_addr                             "0xB8024B44"
#define  DI_ccdinr_Timing_monitor_result2_1_reg                                  0xB8024B44
#define  DI_ccdinr_Timing_monitor_result2_1_inst_addr                            "0x01BF"
#define  set_DI_ccdinr_Timing_monitor_result2_1_reg(data)                        (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result2_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_result2_1_reg                              (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result2_1_reg))
#define  DI_ccdinr_Timing_monitor_result2_1_t_m_result_previous2_1_shift         (0)
#define  DI_ccdinr_Timing_monitor_result2_1_t_m_result_previous2_1_mask          (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_result2_1_t_m_result_previous2_1(data)         (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_result2_1_get_t_m_result_previous2_1(data)     (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_result3_1                                     0x18024B48
#define  DI_ccdinr_Timing_monitor_result3_1_reg_addr                             "0xB8024B48"
#define  DI_ccdinr_Timing_monitor_result3_1_reg                                  0xB8024B48
#define  DI_ccdinr_Timing_monitor_result3_1_inst_addr                            "0x01C0"
#define  set_DI_ccdinr_Timing_monitor_result3_1_reg(data)                        (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result3_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_result3_1_reg                              (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result3_1_reg))
#define  DI_ccdinr_Timing_monitor_result3_1_t_m_result_previous3_1_shift         (0)
#define  DI_ccdinr_Timing_monitor_result3_1_t_m_result_previous3_1_mask          (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_result3_1_t_m_result_previous3_1(data)         (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_result3_1_get_t_m_result_previous3_1(data)     (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_result4_1                                     0x18024B4C
#define  DI_ccdinr_Timing_monitor_result4_1_reg_addr                             "0xB8024B4C"
#define  DI_ccdinr_Timing_monitor_result4_1_reg                                  0xB8024B4C
#define  DI_ccdinr_Timing_monitor_result4_1_inst_addr                            "0x01C1"
#define  set_DI_ccdinr_Timing_monitor_result4_1_reg(data)                        (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result4_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_result4_1_reg                              (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_result4_1_reg))
#define  DI_ccdinr_Timing_monitor_result4_1_t_m_result_previous4_1_shift         (0)
#define  DI_ccdinr_Timing_monitor_result4_1_t_m_result_previous4_1_mask          (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_result4_1_t_m_result_previous4_1(data)         (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_result4_1_get_t_m_result_previous4_1(data)     (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_max_1                                         0x18024B50
#define  DI_ccdinr_Timing_monitor_max_1_reg_addr                                 "0xB8024B50"
#define  DI_ccdinr_Timing_monitor_max_1_reg                                      0xB8024B50
#define  DI_ccdinr_Timing_monitor_max_1_inst_addr                                "0x01C2"
#define  set_DI_ccdinr_Timing_monitor_max_1_reg(data)                            (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_max_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_max_1_reg                                  (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_max_1_reg))
#define  DI_ccdinr_Timing_monitor_max_1_t_m_result_max_1_shift                   (0)
#define  DI_ccdinr_Timing_monitor_max_1_t_m_result_max_1_mask                    (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_max_1_t_m_result_max_1(data)                   (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_max_1_get_t_m_result_max_1(data)               (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_min_1                                         0x18024B54
#define  DI_ccdinr_Timing_monitor_min_1_reg_addr                                 "0xB8024B54"
#define  DI_ccdinr_Timing_monitor_min_1_reg                                      0xB8024B54
#define  DI_ccdinr_Timing_monitor_min_1_inst_addr                                "0x01C3"
#define  set_DI_ccdinr_Timing_monitor_min_1_reg(data)                            (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_min_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_min_1_reg                                  (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_min_1_reg))
#define  DI_ccdinr_Timing_monitor_min_1_t_m_result_min_1_shift                   (0)
#define  DI_ccdinr_Timing_monitor_min_1_t_m_result_min_1_mask                    (0x0FFFFFFF)
#define  DI_ccdinr_Timing_monitor_min_1_t_m_result_min_1(data)                   (0x0FFFFFFF&(data))
#define  DI_ccdinr_Timing_monitor_min_1_get_t_m_result_min_1(data)               (0x0FFFFFFF&(data))

#define  DI_ccdinr_Timing_monitor_st_1                                          0x18024B58
#define  DI_ccdinr_Timing_monitor_st_1_reg_addr                                  "0xB8024B58"
#define  DI_ccdinr_Timing_monitor_st_1_reg                                       0xB8024B58
#define  DI_ccdinr_Timing_monitor_st_1_inst_addr                                 "0x01C4"
#define  set_DI_ccdinr_Timing_monitor_st_1_reg(data)                             (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_st_1_reg)=data)
#define  get_DI_ccdinr_Timing_monitor_st_1_reg                                   (*((volatile unsigned int*)DI_ccdinr_Timing_monitor_st_1_reg))
#define  DI_ccdinr_Timing_monitor_st_1_compare_hit_1_shift                       (2)
#define  DI_ccdinr_Timing_monitor_st_1_hsync_hit_den_error_1_shift               (1)
#define  DI_ccdinr_Timing_monitor_st_1_vsync_hit_den_error_1_shift               (0)
#define  DI_ccdinr_Timing_monitor_st_1_compare_hit_1_mask                        (0x00000004)
#define  DI_ccdinr_Timing_monitor_st_1_hsync_hit_den_error_1_mask                (0x00000002)
#define  DI_ccdinr_Timing_monitor_st_1_vsync_hit_den_error_1_mask                (0x00000001)
#define  DI_ccdinr_Timing_monitor_st_1_compare_hit_1(data)                       (0x00000004&((data)<<2))
#define  DI_ccdinr_Timing_monitor_st_1_hsync_hit_den_error_1(data)               (0x00000002&((data)<<1))
#define  DI_ccdinr_Timing_monitor_st_1_vsync_hit_den_error_1(data)               (0x00000001&(data))
#define  DI_ccdinr_Timing_monitor_st_1_get_compare_hit_1(data)                   ((0x00000004&(data))>>2)
#define  DI_ccdinr_Timing_monitor_st_1_get_hsync_hit_den_error_1(data)           ((0x00000002&(data))>>1)
#define  DI_ccdinr_Timing_monitor_st_1_get_vsync_hit_den_error_1(data)           (0x00000001&(data))

#define  DI_DI_PQ_CMP                                                           0x18024C00
#define  DI_DI_PQ_CMP_reg_addr                                                   "0xB8024C00"
#define  DI_DI_PQ_CMP_reg                                                        0xB8024C00
#define  DI_DI_PQ_CMP_inst_addr                                                  "0x01C5"
#define  set_DI_DI_PQ_CMP_reg(data)                                              (*((volatile unsigned int*)DI_DI_PQ_CMP_reg)=data)
#define  get_DI_DI_PQ_CMP_reg                                                    (*((volatile unsigned int*)DI_DI_PQ_CMP_reg))
#define  DI_DI_PQ_CMP_cmp_en_shift                                               (31)
#define  DI_DI_PQ_CMP_cmp_width_div32_shift                                      (16)
#define  DI_DI_PQ_CMP_cmp_height_shift                                           (0)
#define  DI_DI_PQ_CMP_cmp_en_mask                                                (0x80000000)
#define  DI_DI_PQ_CMP_cmp_width_div32_mask                                       (0x01FF0000)
#define  DI_DI_PQ_CMP_cmp_height_mask                                            (0x00003FFF)
#define  DI_DI_PQ_CMP_cmp_en(data)                                               (0x80000000&((data)<<31))
#define  DI_DI_PQ_CMP_cmp_width_div32(data)                                      (0x01FF0000&((data)<<16))
#define  DI_DI_PQ_CMP_cmp_height(data)                                           (0x00003FFF&(data))
#define  DI_DI_PQ_CMP_get_cmp_en(data)                                           ((0x80000000&(data))>>31)
#define  DI_DI_PQ_CMP_get_cmp_width_div32(data)                                  ((0x01FF0000&(data))>>16)
#define  DI_DI_PQ_CMP_get_cmp_height(data)                                       (0x00003FFF&(data))

#define  DI_DI_PQ_CMP_PAIR                                                      0x18024C04
#define  DI_DI_PQ_CMP_PAIR_reg_addr                                              "0xB8024C04"
#define  DI_DI_PQ_CMP_PAIR_reg                                                   0xB8024C04
#define  DI_DI_PQ_CMP_PAIR_inst_addr                                             "0x01C6"
#define  set_DI_DI_PQ_CMP_PAIR_reg(data)                                         (*((volatile unsigned int*)DI_DI_PQ_CMP_PAIR_reg)=data)
#define  get_DI_DI_PQ_CMP_PAIR_reg                                               (*((volatile unsigned int*)DI_DI_PQ_CMP_PAIR_reg))
#define  DI_DI_PQ_CMP_PAIR_cmp_line_sum_bit_shift                                (16)
#define  DI_DI_PQ_CMP_PAIR_cmp_400_old_mode_en_shift                             (15)
#define  DI_DI_PQ_CMP_PAIR_cmp_pair_para_shift                                   (11)
#define  DI_DI_PQ_CMP_PAIR_cmp_jump4_en_shift                                    (10)
#define  DI_DI_PQ_CMP_PAIR_cmp_qp_mode_shift                                     (8)
#define  DI_DI_PQ_CMP_PAIR_cmp_dic_mode_en_shift                                 (7)
#define  DI_DI_PQ_CMP_PAIR_two_line_prediction_en_shift                          (6)
#define  DI_DI_PQ_CMP_PAIR_cmp_line_mode_shift                                   (5)
#define  DI_DI_PQ_CMP_PAIR_cmp_data_color_shift                                  (4)
#define  DI_DI_PQ_CMP_PAIR_cmp_data_bit_width_shift                              (2)
#define  DI_DI_PQ_CMP_PAIR_cmp_data_format_shift                                 (0)
#define  DI_DI_PQ_CMP_PAIR_cmp_line_sum_bit_mask                                 (0xFFFF0000)
#define  DI_DI_PQ_CMP_PAIR_cmp_400_old_mode_en_mask                              (0x00008000)
#define  DI_DI_PQ_CMP_PAIR_cmp_pair_para_mask                                    (0x00007800)
#define  DI_DI_PQ_CMP_PAIR_cmp_jump4_en_mask                                     (0x00000400)
#define  DI_DI_PQ_CMP_PAIR_cmp_qp_mode_mask                                      (0x00000300)
#define  DI_DI_PQ_CMP_PAIR_cmp_dic_mode_en_mask                                  (0x00000080)
#define  DI_DI_PQ_CMP_PAIR_two_line_prediction_en_mask                           (0x00000040)
#define  DI_DI_PQ_CMP_PAIR_cmp_line_mode_mask                                    (0x00000020)
#define  DI_DI_PQ_CMP_PAIR_cmp_data_color_mask                                   (0x00000010)
#define  DI_DI_PQ_CMP_PAIR_cmp_data_bit_width_mask                               (0x0000000C)
#define  DI_DI_PQ_CMP_PAIR_cmp_data_format_mask                                  (0x00000003)
#define  DI_DI_PQ_CMP_PAIR_cmp_line_sum_bit(data)                                (0xFFFF0000&((data)<<16))
#define  DI_DI_PQ_CMP_PAIR_cmp_400_old_mode_en(data)                             (0x00008000&((data)<<15))
#define  DI_DI_PQ_CMP_PAIR_cmp_pair_para(data)                                   (0x00007800&((data)<<11))
#define  DI_DI_PQ_CMP_PAIR_cmp_jump4_en(data)                                    (0x00000400&((data)<<10))
#define  DI_DI_PQ_CMP_PAIR_cmp_qp_mode(data)                                     (0x00000300&((data)<<8))
#define  DI_DI_PQ_CMP_PAIR_cmp_dic_mode_en(data)                                 (0x00000080&((data)<<7))
#define  DI_DI_PQ_CMP_PAIR_two_line_prediction_en(data)                          (0x00000040&((data)<<6))
#define  DI_DI_PQ_CMP_PAIR_cmp_line_mode(data)                                   (0x00000020&((data)<<5))
#define  DI_DI_PQ_CMP_PAIR_cmp_data_color(data)                                  (0x00000010&((data)<<4))
#define  DI_DI_PQ_CMP_PAIR_cmp_data_bit_width(data)                              (0x0000000C&((data)<<2))
#define  DI_DI_PQ_CMP_PAIR_cmp_data_format(data)                                 (0x00000003&(data))
#define  DI_DI_PQ_CMP_PAIR_get_cmp_line_sum_bit(data)                            ((0xFFFF0000&(data))>>16)
#define  DI_DI_PQ_CMP_PAIR_get_cmp_400_old_mode_en(data)                         ((0x00008000&(data))>>15)
#define  DI_DI_PQ_CMP_PAIR_get_cmp_pair_para(data)                               ((0x00007800&(data))>>11)
#define  DI_DI_PQ_CMP_PAIR_get_cmp_jump4_en(data)                                ((0x00000400&(data))>>10)
#define  DI_DI_PQ_CMP_PAIR_get_cmp_qp_mode(data)                                 ((0x00000300&(data))>>8)
#define  DI_DI_PQ_CMP_PAIR_get_cmp_dic_mode_en(data)                             ((0x00000080&(data))>>7)
#define  DI_DI_PQ_CMP_PAIR_get_two_line_prediction_en(data)                      ((0x00000040&(data))>>6)
#define  DI_DI_PQ_CMP_PAIR_get_cmp_line_mode(data)                               ((0x00000020&(data))>>5)
#define  DI_DI_PQ_CMP_PAIR_get_cmp_data_color(data)                              ((0x00000010&(data))>>4)
#define  DI_DI_PQ_CMP_PAIR_get_cmp_data_bit_width(data)                          ((0x0000000C&(data))>>2)
#define  DI_DI_PQ_CMP_PAIR_get_cmp_data_format(data)                             (0x00000003&(data))

#define  DI_DI_PQ_CMP_BIT                                                       0x18024C08
#define  DI_DI_PQ_CMP_BIT_reg_addr                                               "0xB8024C08"
#define  DI_DI_PQ_CMP_BIT_reg                                                    0xB8024C08
#define  DI_DI_PQ_CMP_BIT_inst_addr                                              "0x01C7"
#define  set_DI_DI_PQ_CMP_BIT_reg(data)                                          (*((volatile unsigned int*)DI_DI_PQ_CMP_BIT_reg)=data)
#define  get_DI_DI_PQ_CMP_BIT_reg                                                (*((volatile unsigned int*)DI_DI_PQ_CMP_BIT_reg))
#define  DI_DI_PQ_CMP_BIT_first_line_more_bit_shift                              (24)
#define  DI_DI_PQ_CMP_BIT_block_limit_bit_shift                                  (16)
#define  DI_DI_PQ_CMP_BIT_line_limit_bit_shift                                   (8)
#define  DI_DI_PQ_CMP_BIT_frame_limit_bit_shift                                  (0)
#define  DI_DI_PQ_CMP_BIT_first_line_more_bit_mask                               (0x3F000000)
#define  DI_DI_PQ_CMP_BIT_block_limit_bit_mask                                   (0x003F0000)
#define  DI_DI_PQ_CMP_BIT_line_limit_bit_mask                                    (0x00003F00)
#define  DI_DI_PQ_CMP_BIT_frame_limit_bit_mask                                   (0x0000003F)
#define  DI_DI_PQ_CMP_BIT_first_line_more_bit(data)                              (0x3F000000&((data)<<24))
#define  DI_DI_PQ_CMP_BIT_block_limit_bit(data)                                  (0x003F0000&((data)<<16))
#define  DI_DI_PQ_CMP_BIT_line_limit_bit(data)                                   (0x00003F00&((data)<<8))
#define  DI_DI_PQ_CMP_BIT_frame_limit_bit(data)                                  (0x0000003F&(data))
#define  DI_DI_PQ_CMP_BIT_get_first_line_more_bit(data)                          ((0x3F000000&(data))>>24)
#define  DI_DI_PQ_CMP_BIT_get_block_limit_bit(data)                              ((0x003F0000&(data))>>16)
#define  DI_DI_PQ_CMP_BIT_get_line_limit_bit(data)                               ((0x00003F00&(data))>>8)
#define  DI_DI_PQ_CMP_BIT_get_frame_limit_bit(data)                              (0x0000003F&(data))

#define  DI_DI_PQ_CMP_ENABLE                                                    0x18024C0C
#define  DI_DI_PQ_CMP_ENABLE_reg_addr                                            "0xB8024C0C"
#define  DI_DI_PQ_CMP_ENABLE_reg                                                 0xB8024C0C
#define  DI_DI_PQ_CMP_ENABLE_inst_addr                                           "0x01C8"
#define  set_DI_DI_PQ_CMP_ENABLE_reg(data)                                       (*((volatile unsigned int*)DI_DI_PQ_CMP_ENABLE_reg)=data)
#define  get_DI_DI_PQ_CMP_ENABLE_reg                                             (*((volatile unsigned int*)DI_DI_PQ_CMP_ENABLE_reg))
#define  DI_DI_PQ_CMP_ENABLE_input_fifo_pause_cycle_shift                        (28)
#define  DI_DI_PQ_CMP_ENABLE_tail_dummy_throughput_shift                         (27)
#define  DI_DI_PQ_CMP_ENABLE_first_predict_nc_mode_shift                         (26)
#define  DI_DI_PQ_CMP_ENABLE_cmp_ctrl_para0_shift                                (21)
#define  DI_DI_PQ_CMP_ENABLE_g_ratio_shift                                       (16)
#define  DI_DI_PQ_CMP_ENABLE_add_last2blk_over_curve_bit_shift                   (15)
#define  DI_DI_PQ_CMP_ENABLE_variation_maxmin_en_shift                           (14)
#define  DI_DI_PQ_CMP_ENABLE_dynamic_sum_line_rst_shift                          (13)
#define  DI_DI_PQ_CMP_ENABLE_blk0_add_en_shift                                   (12)
#define  DI_DI_PQ_CMP_ENABLE_guarantee_max_qp_en_shift                           (11)
#define  DI_DI_PQ_CMP_ENABLE_dynamic_allocate_ratio_en_shift                     (10)
#define  DI_DI_PQ_CMP_ENABLE_poor_limit_min_qp_en_shift                          (9)
#define  DI_DI_PQ_CMP_ENABLE_balance_en_shift                                    (8)
#define  DI_DI_PQ_CMP_ENABLE_fisrt_line_more_en_shift                            (7)
#define  DI_DI_PQ_CMP_ENABLE_blk0_add_half_en_shift                              (6)
#define  DI_DI_PQ_CMP_ENABLE_do_422_mode_shift                                   (4)
#define  DI_DI_PQ_CMP_ENABLE_first_predict_nc_en_shift                           (3)
#define  DI_DI_PQ_CMP_ENABLE_not_enough_bit_do_422_en_shift                      (2)
#define  DI_DI_PQ_CMP_ENABLE_not_rich_do_422_en_shift                            (1)
#define  DI_DI_PQ_CMP_ENABLE_rb_lossy_do_422_en_shift                            (0)
#define  DI_DI_PQ_CMP_ENABLE_input_fifo_pause_cycle_mask                         (0xF0000000)
#define  DI_DI_PQ_CMP_ENABLE_tail_dummy_throughput_mask                          (0x08000000)
#define  DI_DI_PQ_CMP_ENABLE_first_predict_nc_mode_mask                          (0x04000000)
#define  DI_DI_PQ_CMP_ENABLE_cmp_ctrl_para0_mask                                 (0x03E00000)
#define  DI_DI_PQ_CMP_ENABLE_g_ratio_mask                                        (0x001F0000)
#define  DI_DI_PQ_CMP_ENABLE_add_last2blk_over_curve_bit_mask                    (0x00008000)
#define  DI_DI_PQ_CMP_ENABLE_variation_maxmin_en_mask                            (0x00004000)
#define  DI_DI_PQ_CMP_ENABLE_dynamic_sum_line_rst_mask                           (0x00002000)
#define  DI_DI_PQ_CMP_ENABLE_blk0_add_en_mask                                    (0x00001000)
#define  DI_DI_PQ_CMP_ENABLE_guarantee_max_qp_en_mask                            (0x00000800)
#define  DI_DI_PQ_CMP_ENABLE_dynamic_allocate_ratio_en_mask                      (0x00000400)
#define  DI_DI_PQ_CMP_ENABLE_poor_limit_min_qp_en_mask                           (0x00000200)
#define  DI_DI_PQ_CMP_ENABLE_balance_en_mask                                     (0x00000100)
#define  DI_DI_PQ_CMP_ENABLE_fisrt_line_more_en_mask                             (0x00000080)
#define  DI_DI_PQ_CMP_ENABLE_blk0_add_half_en_mask                               (0x00000040)
#define  DI_DI_PQ_CMP_ENABLE_do_422_mode_mask                                    (0x00000030)
#define  DI_DI_PQ_CMP_ENABLE_first_predict_nc_en_mask                            (0x00000008)
#define  DI_DI_PQ_CMP_ENABLE_not_enough_bit_do_422_en_mask                       (0x00000004)
#define  DI_DI_PQ_CMP_ENABLE_not_rich_do_422_en_mask                             (0x00000002)
#define  DI_DI_PQ_CMP_ENABLE_rb_lossy_do_422_en_mask                             (0x00000001)
#define  DI_DI_PQ_CMP_ENABLE_input_fifo_pause_cycle(data)                        (0xF0000000&((data)<<28))
#define  DI_DI_PQ_CMP_ENABLE_tail_dummy_throughput(data)                         (0x08000000&((data)<<27))
#define  DI_DI_PQ_CMP_ENABLE_first_predict_nc_mode(data)                         (0x04000000&((data)<<26))
#define  DI_DI_PQ_CMP_ENABLE_cmp_ctrl_para0(data)                                (0x03E00000&((data)<<21))
#define  DI_DI_PQ_CMP_ENABLE_g_ratio(data)                                       (0x001F0000&((data)<<16))
#define  DI_DI_PQ_CMP_ENABLE_add_last2blk_over_curve_bit(data)                   (0x00008000&((data)<<15))
#define  DI_DI_PQ_CMP_ENABLE_variation_maxmin_en(data)                           (0x00004000&((data)<<14))
#define  DI_DI_PQ_CMP_ENABLE_dynamic_sum_line_rst(data)                          (0x00002000&((data)<<13))
#define  DI_DI_PQ_CMP_ENABLE_blk0_add_en(data)                                   (0x00001000&((data)<<12))
#define  DI_DI_PQ_CMP_ENABLE_guarantee_max_qp_en(data)                           (0x00000800&((data)<<11))
#define  DI_DI_PQ_CMP_ENABLE_dynamic_allocate_ratio_en(data)                     (0x00000400&((data)<<10))
#define  DI_DI_PQ_CMP_ENABLE_poor_limit_min_qp_en(data)                          (0x00000200&((data)<<9))
#define  DI_DI_PQ_CMP_ENABLE_balance_en(data)                                    (0x00000100&((data)<<8))
#define  DI_DI_PQ_CMP_ENABLE_fisrt_line_more_en(data)                            (0x00000080&((data)<<7))
#define  DI_DI_PQ_CMP_ENABLE_blk0_add_half_en(data)                              (0x00000040&((data)<<6))
#define  DI_DI_PQ_CMP_ENABLE_do_422_mode(data)                                   (0x00000030&((data)<<4))
#define  DI_DI_PQ_CMP_ENABLE_first_predict_nc_en(data)                           (0x00000008&((data)<<3))
#define  DI_DI_PQ_CMP_ENABLE_not_enough_bit_do_422_en(data)                      (0x00000004&((data)<<2))
#define  DI_DI_PQ_CMP_ENABLE_not_rich_do_422_en(data)                            (0x00000002&((data)<<1))
#define  DI_DI_PQ_CMP_ENABLE_rb_lossy_do_422_en(data)                            (0x00000001&(data))
#define  DI_DI_PQ_CMP_ENABLE_get_input_fifo_pause_cycle(data)                    ((0xF0000000&(data))>>28)
#define  DI_DI_PQ_CMP_ENABLE_get_tail_dummy_throughput(data)                     ((0x08000000&(data))>>27)
#define  DI_DI_PQ_CMP_ENABLE_get_first_predict_nc_mode(data)                     ((0x04000000&(data))>>26)
#define  DI_DI_PQ_CMP_ENABLE_get_cmp_ctrl_para0(data)                            ((0x03E00000&(data))>>21)
#define  DI_DI_PQ_CMP_ENABLE_get_g_ratio(data)                                   ((0x001F0000&(data))>>16)
#define  DI_DI_PQ_CMP_ENABLE_get_add_last2blk_over_curve_bit(data)               ((0x00008000&(data))>>15)
#define  DI_DI_PQ_CMP_ENABLE_get_variation_maxmin_en(data)                       ((0x00004000&(data))>>14)
#define  DI_DI_PQ_CMP_ENABLE_get_dynamic_sum_line_rst(data)                      ((0x00002000&(data))>>13)
#define  DI_DI_PQ_CMP_ENABLE_get_blk0_add_en(data)                               ((0x00001000&(data))>>12)
#define  DI_DI_PQ_CMP_ENABLE_get_guarantee_max_qp_en(data)                       ((0x00000800&(data))>>11)
#define  DI_DI_PQ_CMP_ENABLE_get_dynamic_allocate_ratio_en(data)                 ((0x00000400&(data))>>10)
#define  DI_DI_PQ_CMP_ENABLE_get_poor_limit_min_qp_en(data)                      ((0x00000200&(data))>>9)
#define  DI_DI_PQ_CMP_ENABLE_get_balance_en(data)                                ((0x00000100&(data))>>8)
#define  DI_DI_PQ_CMP_ENABLE_get_fisrt_line_more_en(data)                        ((0x00000080&(data))>>7)
#define  DI_DI_PQ_CMP_ENABLE_get_blk0_add_half_en(data)                          ((0x00000040&(data))>>6)
#define  DI_DI_PQ_CMP_ENABLE_get_do_422_mode(data)                               ((0x00000030&(data))>>4)
#define  DI_DI_PQ_CMP_ENABLE_get_first_predict_nc_en(data)                       ((0x00000008&(data))>>3)
#define  DI_DI_PQ_CMP_ENABLE_get_not_enough_bit_do_422_en(data)                  ((0x00000004&(data))>>2)
#define  DI_DI_PQ_CMP_ENABLE_get_not_rich_do_422_en(data)                        ((0x00000002&(data))>>1)
#define  DI_DI_PQ_CMP_ENABLE_get_rb_lossy_do_422_en(data)                        (0x00000001&(data))

#define  DI_DI_PQ_CMP_SMOOTH                                                    0x18024C10
#define  DI_DI_PQ_CMP_SMOOTH_reg_addr                                            "0xB8024C10"
#define  DI_DI_PQ_CMP_SMOOTH_reg                                                 0xB8024C10
#define  DI_DI_PQ_CMP_SMOOTH_inst_addr                                           "0x01C9"
#define  set_DI_DI_PQ_CMP_SMOOTH_reg(data)                                       (*((volatile unsigned int*)DI_DI_PQ_CMP_SMOOTH_reg)=data)
#define  get_DI_DI_PQ_CMP_SMOOTH_reg                                             (*((volatile unsigned int*)DI_DI_PQ_CMP_SMOOTH_reg))
#define  DI_DI_PQ_CMP_SMOOTH_dic_mode_option_shift                               (28)
#define  DI_DI_PQ_CMP_SMOOTH_not_enough_bit_do_422_qp_shift                      (24)
#define  DI_DI_PQ_CMP_SMOOTH_not_rich_do_422_th_shift                            (20)
#define  DI_DI_PQ_CMP_SMOOTH_rb_lossy_do_422_qp_level_shift                      (16)
#define  DI_DI_PQ_CMP_SMOOTH_dic_mode_entry_th_shift                             (12)
#define  DI_DI_PQ_CMP_SMOOTH_variation_value_th_shift                            (8)
#define  DI_DI_PQ_CMP_SMOOTH_variation_num_th_shift                              (4)
#define  DI_DI_PQ_CMP_SMOOTH_variation_near_num_th_shift                         (0)
#define  DI_DI_PQ_CMP_SMOOTH_dic_mode_option_mask                                (0xF0000000)
#define  DI_DI_PQ_CMP_SMOOTH_not_enough_bit_do_422_qp_mask                       (0x07000000)
#define  DI_DI_PQ_CMP_SMOOTH_not_rich_do_422_th_mask                             (0x00F00000)
#define  DI_DI_PQ_CMP_SMOOTH_rb_lossy_do_422_qp_level_mask                       (0x00070000)
#define  DI_DI_PQ_CMP_SMOOTH_dic_mode_entry_th_mask                              (0x0000F000)
#define  DI_DI_PQ_CMP_SMOOTH_variation_value_th_mask                             (0x00000F00)
#define  DI_DI_PQ_CMP_SMOOTH_variation_num_th_mask                               (0x00000070)
#define  DI_DI_PQ_CMP_SMOOTH_variation_near_num_th_mask                          (0x00000007)
#define  DI_DI_PQ_CMP_SMOOTH_dic_mode_option(data)                               (0xF0000000&((data)<<28))
#define  DI_DI_PQ_CMP_SMOOTH_not_enough_bit_do_422_qp(data)                      (0x07000000&((data)<<24))
#define  DI_DI_PQ_CMP_SMOOTH_not_rich_do_422_th(data)                            (0x00F00000&((data)<<20))
#define  DI_DI_PQ_CMP_SMOOTH_rb_lossy_do_422_qp_level(data)                      (0x00070000&((data)<<16))
#define  DI_DI_PQ_CMP_SMOOTH_dic_mode_entry_th(data)                             (0x0000F000&((data)<<12))
#define  DI_DI_PQ_CMP_SMOOTH_variation_value_th(data)                            (0x00000F00&((data)<<8))
#define  DI_DI_PQ_CMP_SMOOTH_variation_num_th(data)                              (0x00000070&((data)<<4))
#define  DI_DI_PQ_CMP_SMOOTH_variation_near_num_th(data)                         (0x00000007&(data))
#define  DI_DI_PQ_CMP_SMOOTH_get_dic_mode_option(data)                           ((0xF0000000&(data))>>28)
#define  DI_DI_PQ_CMP_SMOOTH_get_not_enough_bit_do_422_qp(data)                  ((0x07000000&(data))>>24)
#define  DI_DI_PQ_CMP_SMOOTH_get_not_rich_do_422_th(data)                        ((0x00F00000&(data))>>20)
#define  DI_DI_PQ_CMP_SMOOTH_get_rb_lossy_do_422_qp_level(data)                  ((0x00070000&(data))>>16)
#define  DI_DI_PQ_CMP_SMOOTH_get_dic_mode_entry_th(data)                         ((0x0000F000&(data))>>12)
#define  DI_DI_PQ_CMP_SMOOTH_get_variation_value_th(data)                        ((0x00000F00&(data))>>8)
#define  DI_DI_PQ_CMP_SMOOTH_get_variation_num_th(data)                          ((0x00000070&(data))>>4)
#define  DI_DI_PQ_CMP_SMOOTH_get_variation_near_num_th(data)                     (0x00000007&(data))

#define  DI_DI_PQ_CMP_ALLOCATE                                                  0x18024C14
#define  DI_DI_PQ_CMP_ALLOCATE_reg_addr                                          "0xB8024C14"
#define  DI_DI_PQ_CMP_ALLOCATE_reg                                               0xB8024C14
#define  DI_DI_PQ_CMP_ALLOCATE_inst_addr                                         "0x01CA"
#define  set_DI_DI_PQ_CMP_ALLOCATE_reg(data)                                     (*((volatile unsigned int*)DI_DI_PQ_CMP_ALLOCATE_reg)=data)
#define  get_DI_DI_PQ_CMP_ALLOCATE_reg                                           (*((volatile unsigned int*)DI_DI_PQ_CMP_ALLOCATE_reg))
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_ratio_max_shift                  (24)
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_ratio_min_shift                  (16)
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_line_shift                       (8)
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_more_shift                       (4)
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_less_shift                       (0)
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_ratio_max_mask                   (0x1F000000)
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_ratio_min_mask                   (0x001F0000)
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_line_mask                        (0x00000700)
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_more_mask                        (0x000000F0)
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_less_mask                        (0x0000000F)
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_ratio_max(data)                  (0x1F000000&((data)<<24))
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_ratio_min(data)                  (0x001F0000&((data)<<16))
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_line(data)                       (0x00000700&((data)<<8))
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_more(data)                       (0x000000F0&((data)<<4))
#define  DI_DI_PQ_CMP_ALLOCATE_dynamic_allocate_less(data)                       (0x0000000F&(data))
#define  DI_DI_PQ_CMP_ALLOCATE_get_dynamic_allocate_ratio_max(data)              ((0x1F000000&(data))>>24)
#define  DI_DI_PQ_CMP_ALLOCATE_get_dynamic_allocate_ratio_min(data)              ((0x001F0000&(data))>>16)
#define  DI_DI_PQ_CMP_ALLOCATE_get_dynamic_allocate_line(data)                   ((0x00000700&(data))>>8)
#define  DI_DI_PQ_CMP_ALLOCATE_get_dynamic_allocate_more(data)                   ((0x000000F0&(data))>>4)
#define  DI_DI_PQ_CMP_ALLOCATE_get_dynamic_allocate_less(data)                   (0x0000000F&(data))

#define  DI_DI_PQ_CMP_POOR                                                      0x18024C18
#define  DI_DI_PQ_CMP_POOR_reg_addr                                              "0xB8024C18"
#define  DI_DI_PQ_CMP_POOR_reg                                                   0xB8024C18
#define  DI_DI_PQ_CMP_POOR_inst_addr                                             "0x01CB"
#define  set_DI_DI_PQ_CMP_POOR_reg(data)                                         (*((volatile unsigned int*)DI_DI_PQ_CMP_POOR_reg)=data)
#define  get_DI_DI_PQ_CMP_POOR_reg                                               (*((volatile unsigned int*)DI_DI_PQ_CMP_POOR_reg))
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp4_shift                               (24)
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp3_shift                               (16)
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp2_shift                               (8)
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp1_shift                               (0)
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp4_mask                                (0x1F000000)
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp3_mask                                (0x001F0000)
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp2_mask                                (0x00001F00)
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp1_mask                                (0x0000001F)
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp4(data)                               (0x1F000000&((data)<<24))
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp3(data)                               (0x001F0000&((data)<<16))
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp2(data)                               (0x00001F00&((data)<<8))
#define  DI_DI_PQ_CMP_POOR_poor_limit_th_qp1(data)                               (0x0000001F&(data))
#define  DI_DI_PQ_CMP_POOR_get_poor_limit_th_qp4(data)                           ((0x1F000000&(data))>>24)
#define  DI_DI_PQ_CMP_POOR_get_poor_limit_th_qp3(data)                           ((0x001F0000&(data))>>16)
#define  DI_DI_PQ_CMP_POOR_get_poor_limit_th_qp2(data)                           ((0x00001F00&(data))>>8)
#define  DI_DI_PQ_CMP_POOR_get_poor_limit_th_qp1(data)                           (0x0000001F&(data))

#define  DI_DI_PQ_CMP_Guarantee                                                 0x18024C1C
#define  DI_DI_PQ_CMP_Guarantee_reg_addr                                         "0xB8024C1C"
#define  DI_DI_PQ_CMP_Guarantee_reg                                              0xB8024C1C
#define  DI_DI_PQ_CMP_Guarantee_inst_addr                                        "0x01CC"
#define  set_DI_DI_PQ_CMP_Guarantee_reg(data)                                    (*((volatile unsigned int*)DI_DI_PQ_CMP_Guarantee_reg)=data)
#define  get_DI_DI_PQ_CMP_Guarantee_reg                                          (*((volatile unsigned int*)DI_DI_PQ_CMP_Guarantee_reg))
#define  DI_DI_PQ_CMP_Guarantee_cmp_crc_ro_line_sel_shift                        (16)
#define  DI_DI_PQ_CMP_Guarantee_dic_mode_qp_th_rb_shift                          (12)
#define  DI_DI_PQ_CMP_Guarantee_dic_mode_qp_th_g_shift                           (8)
#define  DI_DI_PQ_CMP_Guarantee_guarantee_max_rb_qp_shift                        (4)
#define  DI_DI_PQ_CMP_Guarantee_guarantee_max_g_qp_shift                         (0)
#define  DI_DI_PQ_CMP_Guarantee_cmp_crc_ro_line_sel_mask                         (0x3FFF0000)
#define  DI_DI_PQ_CMP_Guarantee_dic_mode_qp_th_rb_mask                           (0x0000F000)
#define  DI_DI_PQ_CMP_Guarantee_dic_mode_qp_th_g_mask                            (0x00000F00)
#define  DI_DI_PQ_CMP_Guarantee_guarantee_max_rb_qp_mask                         (0x000000F0)
#define  DI_DI_PQ_CMP_Guarantee_guarantee_max_g_qp_mask                          (0x0000000F)
#define  DI_DI_PQ_CMP_Guarantee_cmp_crc_ro_line_sel(data)                        (0x3FFF0000&((data)<<16))
#define  DI_DI_PQ_CMP_Guarantee_dic_mode_qp_th_rb(data)                          (0x0000F000&((data)<<12))
#define  DI_DI_PQ_CMP_Guarantee_dic_mode_qp_th_g(data)                           (0x00000F00&((data)<<8))
#define  DI_DI_PQ_CMP_Guarantee_guarantee_max_rb_qp(data)                        (0x000000F0&((data)<<4))
#define  DI_DI_PQ_CMP_Guarantee_guarantee_max_g_qp(data)                         (0x0000000F&(data))
#define  DI_DI_PQ_CMP_Guarantee_get_cmp_crc_ro_line_sel(data)                    ((0x3FFF0000&(data))>>16)
#define  DI_DI_PQ_CMP_Guarantee_get_dic_mode_qp_th_rb(data)                      ((0x0000F000&(data))>>12)
#define  DI_DI_PQ_CMP_Guarantee_get_dic_mode_qp_th_g(data)                       ((0x00000F00&(data))>>8)
#define  DI_DI_PQ_CMP_Guarantee_get_guarantee_max_rb_qp(data)                    ((0x000000F0&(data))>>4)
#define  DI_DI_PQ_CMP_Guarantee_get_guarantee_max_g_qp(data)                     (0x0000000F&(data))

#define  DI_DI_PQ_CMP_BALANCE                                                   0x18024C20
#define  DI_DI_PQ_CMP_BALANCE_reg_addr                                           "0xB8024C20"
#define  DI_DI_PQ_CMP_BALANCE_reg                                                0xB8024C20
#define  DI_DI_PQ_CMP_BALANCE_inst_addr                                          "0x01CD"
#define  set_DI_DI_PQ_CMP_BALANCE_reg(data)                                      (*((volatile unsigned int*)DI_DI_PQ_CMP_BALANCE_reg)=data)
#define  get_DI_DI_PQ_CMP_BALANCE_reg                                            (*((volatile unsigned int*)DI_DI_PQ_CMP_BALANCE_reg))
#define  DI_DI_PQ_CMP_BALANCE_variation_maxmin_th2_shift                         (24)
#define  DI_DI_PQ_CMP_BALANCE_variation_maxmin_th_shift                          (16)
#define  DI_DI_PQ_CMP_BALANCE_balance_rb_ov_th_shift                             (12)
#define  DI_DI_PQ_CMP_BALANCE_balance_rb_ud_th_shift                             (10)
#define  DI_DI_PQ_CMP_BALANCE_balance_rb_give_shift                              (8)
#define  DI_DI_PQ_CMP_BALANCE_balance_g_ov_th_shift                              (4)
#define  DI_DI_PQ_CMP_BALANCE_balance_g_ud_th_shift                              (2)
#define  DI_DI_PQ_CMP_BALANCE_balance_g_give_shift                               (0)
#define  DI_DI_PQ_CMP_BALANCE_variation_maxmin_th2_mask                          (0xFF000000)
#define  DI_DI_PQ_CMP_BALANCE_variation_maxmin_th_mask                           (0x00FF0000)
#define  DI_DI_PQ_CMP_BALANCE_balance_rb_ov_th_mask                              (0x00003000)
#define  DI_DI_PQ_CMP_BALANCE_balance_rb_ud_th_mask                              (0x00000C00)
#define  DI_DI_PQ_CMP_BALANCE_balance_rb_give_mask                               (0x00000300)
#define  DI_DI_PQ_CMP_BALANCE_balance_g_ov_th_mask                               (0x00000030)
#define  DI_DI_PQ_CMP_BALANCE_balance_g_ud_th_mask                               (0x0000000C)
#define  DI_DI_PQ_CMP_BALANCE_balance_g_give_mask                                (0x00000003)
#define  DI_DI_PQ_CMP_BALANCE_variation_maxmin_th2(data)                         (0xFF000000&((data)<<24))
#define  DI_DI_PQ_CMP_BALANCE_variation_maxmin_th(data)                          (0x00FF0000&((data)<<16))
#define  DI_DI_PQ_CMP_BALANCE_balance_rb_ov_th(data)                             (0x00003000&((data)<<12))
#define  DI_DI_PQ_CMP_BALANCE_balance_rb_ud_th(data)                             (0x00000C00&((data)<<10))
#define  DI_DI_PQ_CMP_BALANCE_balance_rb_give(data)                              (0x00000300&((data)<<8))
#define  DI_DI_PQ_CMP_BALANCE_balance_g_ov_th(data)                              (0x00000030&((data)<<4))
#define  DI_DI_PQ_CMP_BALANCE_balance_g_ud_th(data)                              (0x0000000C&((data)<<2))
#define  DI_DI_PQ_CMP_BALANCE_balance_g_give(data)                               (0x00000003&(data))
#define  DI_DI_PQ_CMP_BALANCE_get_variation_maxmin_th2(data)                     ((0xFF000000&(data))>>24)
#define  DI_DI_PQ_CMP_BALANCE_get_variation_maxmin_th(data)                      ((0x00FF0000&(data))>>16)
#define  DI_DI_PQ_CMP_BALANCE_get_balance_rb_ov_th(data)                         ((0x00003000&(data))>>12)
#define  DI_DI_PQ_CMP_BALANCE_get_balance_rb_ud_th(data)                         ((0x00000C00&(data))>>10)
#define  DI_DI_PQ_CMP_BALANCE_get_balance_rb_give(data)                          ((0x00000300&(data))>>8)
#define  DI_DI_PQ_CMP_BALANCE_get_balance_g_ov_th(data)                          ((0x00000030&(data))>>4)
#define  DI_DI_PQ_CMP_BALANCE_get_balance_g_ud_th(data)                          ((0x0000000C&(data))>>2)
#define  DI_DI_PQ_CMP_BALANCE_get_balance_g_give(data)                           (0x00000003&(data))

#define  DI_DI_PQ_CMP_IRQ_EN                                                    0x18024C24
#define  DI_DI_PQ_CMP_IRQ_EN_reg_addr                                            "0xB8024C24"
#define  DI_DI_PQ_CMP_IRQ_EN_reg                                                 0xB8024C24
#define  DI_DI_PQ_CMP_IRQ_EN_inst_addr                                           "0x01CE"
#define  set_DI_DI_PQ_CMP_IRQ_EN_reg(data)                                       (*((volatile unsigned int*)DI_DI_PQ_CMP_IRQ_EN_reg)=data)
#define  get_DI_DI_PQ_CMP_IRQ_EN_reg                                             (*((volatile unsigned int*)DI_DI_PQ_CMP_IRQ_EN_reg))
#define  DI_DI_PQ_CMP_IRQ_EN_prs_over_line_sum_bit_irq_en_shift                  (18)
#define  DI_DI_PQ_CMP_IRQ_EN_tail_fifo_overflow_irq_en_shift                     (17)
#define  DI_DI_PQ_CMP_IRQ_EN_input_fifo_overflow_irq_en_shift                    (16)
#define  DI_DI_PQ_CMP_IRQ_EN_block_fifo_overflow_irq_en_shift                    (15)
#define  DI_DI_PQ_CMP_IRQ_EN_input_size_more_irq_en_shift                        (14)
#define  DI_DI_PQ_CMP_IRQ_EN_input_size_less_irq_en_shift                        (13)
#define  DI_DI_PQ_CMP_IRQ_EN_over_flb_irq_en_shift                               (12)
#define  DI_DI_PQ_CMP_IRQ_EN_request_fifo_even_overflow_irq_en_shift             (9)
#define  DI_DI_PQ_CMP_IRQ_EN_request_fifo_odd_overflow_irq_en_shift              (8)
#define  DI_DI_PQ_CMP_IRQ_EN_g_fifo_even_overflow_irq_en_shift                   (6)
#define  DI_DI_PQ_CMP_IRQ_EN_r_fifo_even_overflow_irq_en_shift                   (5)
#define  DI_DI_PQ_CMP_IRQ_EN_b_fifo_even_overflow_irq_en_shift                   (4)
#define  DI_DI_PQ_CMP_IRQ_EN_g_fifo_odd_overflow_irq_en_shift                    (2)
#define  DI_DI_PQ_CMP_IRQ_EN_r_fifo_odd_overflow_irq_en_shift                    (1)
#define  DI_DI_PQ_CMP_IRQ_EN_b_fifo_odd_overflow_irq_en_shift                    (0)
#define  DI_DI_PQ_CMP_IRQ_EN_prs_over_line_sum_bit_irq_en_mask                   (0x00040000)
#define  DI_DI_PQ_CMP_IRQ_EN_tail_fifo_overflow_irq_en_mask                      (0x00020000)
#define  DI_DI_PQ_CMP_IRQ_EN_input_fifo_overflow_irq_en_mask                     (0x00010000)
#define  DI_DI_PQ_CMP_IRQ_EN_block_fifo_overflow_irq_en_mask                     (0x00008000)
#define  DI_DI_PQ_CMP_IRQ_EN_input_size_more_irq_en_mask                         (0x00004000)
#define  DI_DI_PQ_CMP_IRQ_EN_input_size_less_irq_en_mask                         (0x00002000)
#define  DI_DI_PQ_CMP_IRQ_EN_over_flb_irq_en_mask                                (0x00001000)
#define  DI_DI_PQ_CMP_IRQ_EN_request_fifo_even_overflow_irq_en_mask              (0x00000200)
#define  DI_DI_PQ_CMP_IRQ_EN_request_fifo_odd_overflow_irq_en_mask               (0x00000100)
#define  DI_DI_PQ_CMP_IRQ_EN_g_fifo_even_overflow_irq_en_mask                    (0x00000040)
#define  DI_DI_PQ_CMP_IRQ_EN_r_fifo_even_overflow_irq_en_mask                    (0x00000020)
#define  DI_DI_PQ_CMP_IRQ_EN_b_fifo_even_overflow_irq_en_mask                    (0x00000010)
#define  DI_DI_PQ_CMP_IRQ_EN_g_fifo_odd_overflow_irq_en_mask                     (0x00000004)
#define  DI_DI_PQ_CMP_IRQ_EN_r_fifo_odd_overflow_irq_en_mask                     (0x00000002)
#define  DI_DI_PQ_CMP_IRQ_EN_b_fifo_odd_overflow_irq_en_mask                     (0x00000001)
#define  DI_DI_PQ_CMP_IRQ_EN_prs_over_line_sum_bit_irq_en(data)                  (0x00040000&((data)<<18))
#define  DI_DI_PQ_CMP_IRQ_EN_tail_fifo_overflow_irq_en(data)                     (0x00020000&((data)<<17))
#define  DI_DI_PQ_CMP_IRQ_EN_input_fifo_overflow_irq_en(data)                    (0x00010000&((data)<<16))
#define  DI_DI_PQ_CMP_IRQ_EN_block_fifo_overflow_irq_en(data)                    (0x00008000&((data)<<15))
#define  DI_DI_PQ_CMP_IRQ_EN_input_size_more_irq_en(data)                        (0x00004000&((data)<<14))
#define  DI_DI_PQ_CMP_IRQ_EN_input_size_less_irq_en(data)                        (0x00002000&((data)<<13))
#define  DI_DI_PQ_CMP_IRQ_EN_over_flb_irq_en(data)                               (0x00001000&((data)<<12))
#define  DI_DI_PQ_CMP_IRQ_EN_request_fifo_even_overflow_irq_en(data)             (0x00000200&((data)<<9))
#define  DI_DI_PQ_CMP_IRQ_EN_request_fifo_odd_overflow_irq_en(data)              (0x00000100&((data)<<8))
#define  DI_DI_PQ_CMP_IRQ_EN_g_fifo_even_overflow_irq_en(data)                   (0x00000040&((data)<<6))
#define  DI_DI_PQ_CMP_IRQ_EN_r_fifo_even_overflow_irq_en(data)                   (0x00000020&((data)<<5))
#define  DI_DI_PQ_CMP_IRQ_EN_b_fifo_even_overflow_irq_en(data)                   (0x00000010&((data)<<4))
#define  DI_DI_PQ_CMP_IRQ_EN_g_fifo_odd_overflow_irq_en(data)                    (0x00000004&((data)<<2))
#define  DI_DI_PQ_CMP_IRQ_EN_r_fifo_odd_overflow_irq_en(data)                    (0x00000002&((data)<<1))
#define  DI_DI_PQ_CMP_IRQ_EN_b_fifo_odd_overflow_irq_en(data)                    (0x00000001&(data))
#define  DI_DI_PQ_CMP_IRQ_EN_get_prs_over_line_sum_bit_irq_en(data)              ((0x00040000&(data))>>18)
#define  DI_DI_PQ_CMP_IRQ_EN_get_tail_fifo_overflow_irq_en(data)                 ((0x00020000&(data))>>17)
#define  DI_DI_PQ_CMP_IRQ_EN_get_input_fifo_overflow_irq_en(data)                ((0x00010000&(data))>>16)
#define  DI_DI_PQ_CMP_IRQ_EN_get_block_fifo_overflow_irq_en(data)                ((0x00008000&(data))>>15)
#define  DI_DI_PQ_CMP_IRQ_EN_get_input_size_more_irq_en(data)                    ((0x00004000&(data))>>14)
#define  DI_DI_PQ_CMP_IRQ_EN_get_input_size_less_irq_en(data)                    ((0x00002000&(data))>>13)
#define  DI_DI_PQ_CMP_IRQ_EN_get_over_flb_irq_en(data)                           ((0x00001000&(data))>>12)
#define  DI_DI_PQ_CMP_IRQ_EN_get_request_fifo_even_overflow_irq_en(data)         ((0x00000200&(data))>>9)
#define  DI_DI_PQ_CMP_IRQ_EN_get_request_fifo_odd_overflow_irq_en(data)          ((0x00000100&(data))>>8)
#define  DI_DI_PQ_CMP_IRQ_EN_get_g_fifo_even_overflow_irq_en(data)               ((0x00000040&(data))>>6)
#define  DI_DI_PQ_CMP_IRQ_EN_get_r_fifo_even_overflow_irq_en(data)               ((0x00000020&(data))>>5)
#define  DI_DI_PQ_CMP_IRQ_EN_get_b_fifo_even_overflow_irq_en(data)               ((0x00000010&(data))>>4)
#define  DI_DI_PQ_CMP_IRQ_EN_get_g_fifo_odd_overflow_irq_en(data)                ((0x00000004&(data))>>2)
#define  DI_DI_PQ_CMP_IRQ_EN_get_r_fifo_odd_overflow_irq_en(data)                ((0x00000002&(data))>>1)
#define  DI_DI_PQ_CMP_IRQ_EN_get_b_fifo_odd_overflow_irq_en(data)                (0x00000001&(data))

#define  DI_DI_PQ_CMP_IRQ_ST                                                    0x18024C28
#define  DI_DI_PQ_CMP_IRQ_ST_reg_addr                                            "0xB8024C28"
#define  DI_DI_PQ_CMP_IRQ_ST_reg                                                 0xB8024C28
#define  DI_DI_PQ_CMP_IRQ_ST_inst_addr                                           "0x01CF"
#define  set_DI_DI_PQ_CMP_IRQ_ST_reg(data)                                       (*((volatile unsigned int*)DI_DI_PQ_CMP_IRQ_ST_reg)=data)
#define  get_DI_DI_PQ_CMP_IRQ_ST_reg                                             (*((volatile unsigned int*)DI_DI_PQ_CMP_IRQ_ST_reg))
#define  DI_DI_PQ_CMP_IRQ_ST_pqc_irq_shift                                       (31)
#define  DI_DI_PQ_CMP_IRQ_ST_prs_over_line_sum_bit_st_shift                      (18)
#define  DI_DI_PQ_CMP_IRQ_ST_tail_fifo_overflow_st_shift                         (17)
#define  DI_DI_PQ_CMP_IRQ_ST_input_fifo_overflow_st_shift                        (16)
#define  DI_DI_PQ_CMP_IRQ_ST_block_fifo_overflow_st_shift                        (15)
#define  DI_DI_PQ_CMP_IRQ_ST_input_size_more_st_shift                            (14)
#define  DI_DI_PQ_CMP_IRQ_ST_input_size_less_st_shift                            (13)
#define  DI_DI_PQ_CMP_IRQ_ST_over_flb_st_shift                                   (12)
#define  DI_DI_PQ_CMP_IRQ_ST_request_fifo_even_overflow_st_shift                 (9)
#define  DI_DI_PQ_CMP_IRQ_ST_request_fifo_odd_overflow_st_shift                  (8)
#define  DI_DI_PQ_CMP_IRQ_ST_g_fifo_even_overflow_st_shift                       (6)
#define  DI_DI_PQ_CMP_IRQ_ST_r_fifo_even_overflow_st_shift                       (5)
#define  DI_DI_PQ_CMP_IRQ_ST_b_fifo_even_overflow_st_shift                       (4)
#define  DI_DI_PQ_CMP_IRQ_ST_g_fifo_odd_overflow_st_shift                        (2)
#define  DI_DI_PQ_CMP_IRQ_ST_r_fifo_odd_overflow_st_shift                        (1)
#define  DI_DI_PQ_CMP_IRQ_ST_b_fifo_odd_overflow_st_shift                        (0)
#define  DI_DI_PQ_CMP_IRQ_ST_pqc_irq_mask                                        (0x80000000)
#define  DI_DI_PQ_CMP_IRQ_ST_prs_over_line_sum_bit_st_mask                       (0x00040000)
#define  DI_DI_PQ_CMP_IRQ_ST_tail_fifo_overflow_st_mask                          (0x00020000)
#define  DI_DI_PQ_CMP_IRQ_ST_input_fifo_overflow_st_mask                         (0x00010000)
#define  DI_DI_PQ_CMP_IRQ_ST_block_fifo_overflow_st_mask                         (0x00008000)
#define  DI_DI_PQ_CMP_IRQ_ST_input_size_more_st_mask                             (0x00004000)
#define  DI_DI_PQ_CMP_IRQ_ST_input_size_less_st_mask                             (0x00002000)
#define  DI_DI_PQ_CMP_IRQ_ST_over_flb_st_mask                                    (0x00001000)
#define  DI_DI_PQ_CMP_IRQ_ST_request_fifo_even_overflow_st_mask                  (0x00000200)
#define  DI_DI_PQ_CMP_IRQ_ST_request_fifo_odd_overflow_st_mask                   (0x00000100)
#define  DI_DI_PQ_CMP_IRQ_ST_g_fifo_even_overflow_st_mask                        (0x00000040)
#define  DI_DI_PQ_CMP_IRQ_ST_r_fifo_even_overflow_st_mask                        (0x00000020)
#define  DI_DI_PQ_CMP_IRQ_ST_b_fifo_even_overflow_st_mask                        (0x00000010)
#define  DI_DI_PQ_CMP_IRQ_ST_g_fifo_odd_overflow_st_mask                         (0x00000004)
#define  DI_DI_PQ_CMP_IRQ_ST_r_fifo_odd_overflow_st_mask                         (0x00000002)
#define  DI_DI_PQ_CMP_IRQ_ST_b_fifo_odd_overflow_st_mask                         (0x00000001)
#define  DI_DI_PQ_CMP_IRQ_ST_pqc_irq(data)                                       (0x80000000&((data)<<31))
#define  DI_DI_PQ_CMP_IRQ_ST_prs_over_line_sum_bit_st(data)                      (0x00040000&((data)<<18))
#define  DI_DI_PQ_CMP_IRQ_ST_tail_fifo_overflow_st(data)                         (0x00020000&((data)<<17))
#define  DI_DI_PQ_CMP_IRQ_ST_input_fifo_overflow_st(data)                        (0x00010000&((data)<<16))
#define  DI_DI_PQ_CMP_IRQ_ST_block_fifo_overflow_st(data)                        (0x00008000&((data)<<15))
#define  DI_DI_PQ_CMP_IRQ_ST_input_size_more_st(data)                            (0x00004000&((data)<<14))
#define  DI_DI_PQ_CMP_IRQ_ST_input_size_less_st(data)                            (0x00002000&((data)<<13))
#define  DI_DI_PQ_CMP_IRQ_ST_over_flb_st(data)                                   (0x00001000&((data)<<12))
#define  DI_DI_PQ_CMP_IRQ_ST_request_fifo_even_overflow_st(data)                 (0x00000200&((data)<<9))
#define  DI_DI_PQ_CMP_IRQ_ST_request_fifo_odd_overflow_st(data)                  (0x00000100&((data)<<8))
#define  DI_DI_PQ_CMP_IRQ_ST_g_fifo_even_overflow_st(data)                       (0x00000040&((data)<<6))
#define  DI_DI_PQ_CMP_IRQ_ST_r_fifo_even_overflow_st(data)                       (0x00000020&((data)<<5))
#define  DI_DI_PQ_CMP_IRQ_ST_b_fifo_even_overflow_st(data)                       (0x00000010&((data)<<4))
#define  DI_DI_PQ_CMP_IRQ_ST_g_fifo_odd_overflow_st(data)                        (0x00000004&((data)<<2))
#define  DI_DI_PQ_CMP_IRQ_ST_r_fifo_odd_overflow_st(data)                        (0x00000002&((data)<<1))
#define  DI_DI_PQ_CMP_IRQ_ST_b_fifo_odd_overflow_st(data)                        (0x00000001&(data))
#define  DI_DI_PQ_CMP_IRQ_ST_get_pqc_irq(data)                                   ((0x80000000&(data))>>31)
#define  DI_DI_PQ_CMP_IRQ_ST_get_prs_over_line_sum_bit_st(data)                  ((0x00040000&(data))>>18)
#define  DI_DI_PQ_CMP_IRQ_ST_get_tail_fifo_overflow_st(data)                     ((0x00020000&(data))>>17)
#define  DI_DI_PQ_CMP_IRQ_ST_get_input_fifo_overflow_st(data)                    ((0x00010000&(data))>>16)
#define  DI_DI_PQ_CMP_IRQ_ST_get_block_fifo_overflow_st(data)                    ((0x00008000&(data))>>15)
#define  DI_DI_PQ_CMP_IRQ_ST_get_input_size_more_st(data)                        ((0x00004000&(data))>>14)
#define  DI_DI_PQ_CMP_IRQ_ST_get_input_size_less_st(data)                        ((0x00002000&(data))>>13)
#define  DI_DI_PQ_CMP_IRQ_ST_get_over_flb_st(data)                               ((0x00001000&(data))>>12)
#define  DI_DI_PQ_CMP_IRQ_ST_get_request_fifo_even_overflow_st(data)             ((0x00000200&(data))>>9)
#define  DI_DI_PQ_CMP_IRQ_ST_get_request_fifo_odd_overflow_st(data)              ((0x00000100&(data))>>8)
#define  DI_DI_PQ_CMP_IRQ_ST_get_g_fifo_even_overflow_st(data)                   ((0x00000040&(data))>>6)
#define  DI_DI_PQ_CMP_IRQ_ST_get_r_fifo_even_overflow_st(data)                   ((0x00000020&(data))>>5)
#define  DI_DI_PQ_CMP_IRQ_ST_get_b_fifo_even_overflow_st(data)                   ((0x00000010&(data))>>4)
#define  DI_DI_PQ_CMP_IRQ_ST_get_g_fifo_odd_overflow_st(data)                    ((0x00000004&(data))>>2)
#define  DI_DI_PQ_CMP_IRQ_ST_get_r_fifo_odd_overflow_st(data)                    ((0x00000002&(data))>>1)
#define  DI_DI_PQ_CMP_IRQ_ST_get_b_fifo_odd_overflow_st(data)                    (0x00000001&(data))

#define  DI_DI_PQ_CMP_ST                                                        0x18024C2C
#define  DI_DI_PQ_CMP_ST_reg_addr                                                "0xB8024C2C"
#define  DI_DI_PQ_CMP_ST_reg                                                     0xB8024C2C
#define  DI_DI_PQ_CMP_ST_inst_addr                                               "0x01D0"
#define  set_DI_DI_PQ_CMP_ST_reg(data)                                           (*((volatile unsigned int*)DI_DI_PQ_CMP_ST_reg)=data)
#define  get_DI_DI_PQ_CMP_ST_reg                                                 (*((volatile unsigned int*)DI_DI_PQ_CMP_ST_reg))
#define  DI_DI_PQ_CMP_ST_cmp_two_pixel_mode_shift                                (31)
#define  DI_DI_PQ_CMP_ST_g_ratio_max_shift                                       (24)
#define  DI_DI_PQ_CMP_ST_g_ratio_min_shift                                       (16)
#define  DI_DI_PQ_CMP_ST_cmp_package_height_cnt_shift                            (0)
#define  DI_DI_PQ_CMP_ST_cmp_two_pixel_mode_mask                                 (0x80000000)
#define  DI_DI_PQ_CMP_ST_g_ratio_max_mask                                        (0x1F000000)
#define  DI_DI_PQ_CMP_ST_g_ratio_min_mask                                        (0x001F0000)
#define  DI_DI_PQ_CMP_ST_cmp_package_height_cnt_mask                             (0x00003FFF)
#define  DI_DI_PQ_CMP_ST_cmp_two_pixel_mode(data)                                (0x80000000&((data)<<31))
#define  DI_DI_PQ_CMP_ST_g_ratio_max(data)                                       (0x1F000000&((data)<<24))
#define  DI_DI_PQ_CMP_ST_g_ratio_min(data)                                       (0x001F0000&((data)<<16))
#define  DI_DI_PQ_CMP_ST_cmp_package_height_cnt(data)                            (0x00003FFF&(data))
#define  DI_DI_PQ_CMP_ST_get_cmp_two_pixel_mode(data)                            ((0x80000000&(data))>>31)
#define  DI_DI_PQ_CMP_ST_get_g_ratio_max(data)                                   ((0x1F000000&(data))>>24)
#define  DI_DI_PQ_CMP_ST_get_g_ratio_min(data)                                   ((0x001F0000&(data))>>16)
#define  DI_DI_PQ_CMP_ST_get_cmp_package_height_cnt(data)                        (0x00003FFF&(data))

#define  DI_DI_PQ_CMP_QP_ST                                                     0x18024C30
#define  DI_DI_PQ_CMP_QP_ST_reg_addr                                             "0xB8024C30"
#define  DI_DI_PQ_CMP_QP_ST_reg                                                  0xB8024C30
#define  DI_DI_PQ_CMP_QP_ST_inst_addr                                            "0x01D1"
#define  set_DI_DI_PQ_CMP_QP_ST_reg(data)                                        (*((volatile unsigned int*)DI_DI_PQ_CMP_QP_ST_reg)=data)
#define  get_DI_DI_PQ_CMP_QP_ST_reg                                              (*((volatile unsigned int*)DI_DI_PQ_CMP_QP_ST_reg))
#define  DI_DI_PQ_CMP_QP_ST_long_term_qp_measure_en_shift                        (31)
#define  DI_DI_PQ_CMP_QP_ST_cmp_ctrl_para1_shift                                 (24)
#define  DI_DI_PQ_CMP_QP_ST_long_term_g_qp_max_shift                             (20)
#define  DI_DI_PQ_CMP_QP_ST_long_term_rb_qp_max_shift                            (16)
#define  DI_DI_PQ_CMP_QP_ST_cmp_ctrl_para2_shift                                 (8)
#define  DI_DI_PQ_CMP_QP_ST_short_term_g_qp_max_shift                            (4)
#define  DI_DI_PQ_CMP_QP_ST_short_term_rb_qp_max_shift                           (0)
#define  DI_DI_PQ_CMP_QP_ST_long_term_qp_measure_en_mask                         (0x80000000)
#define  DI_DI_PQ_CMP_QP_ST_cmp_ctrl_para1_mask                                  (0x7F000000)
#define  DI_DI_PQ_CMP_QP_ST_long_term_g_qp_max_mask                              (0x00F00000)
#define  DI_DI_PQ_CMP_QP_ST_long_term_rb_qp_max_mask                             (0x000F0000)
#define  DI_DI_PQ_CMP_QP_ST_cmp_ctrl_para2_mask                                  (0x0000FF00)
#define  DI_DI_PQ_CMP_QP_ST_short_term_g_qp_max_mask                             (0x000000F0)
#define  DI_DI_PQ_CMP_QP_ST_short_term_rb_qp_max_mask                            (0x0000000F)
#define  DI_DI_PQ_CMP_QP_ST_long_term_qp_measure_en(data)                        (0x80000000&((data)<<31))
#define  DI_DI_PQ_CMP_QP_ST_cmp_ctrl_para1(data)                                 (0x7F000000&((data)<<24))
#define  DI_DI_PQ_CMP_QP_ST_long_term_g_qp_max(data)                             (0x00F00000&((data)<<20))
#define  DI_DI_PQ_CMP_QP_ST_long_term_rb_qp_max(data)                            (0x000F0000&((data)<<16))
#define  DI_DI_PQ_CMP_QP_ST_cmp_ctrl_para2(data)                                 (0x0000FF00&((data)<<8))
#define  DI_DI_PQ_CMP_QP_ST_short_term_g_qp_max(data)                            (0x000000F0&((data)<<4))
#define  DI_DI_PQ_CMP_QP_ST_short_term_rb_qp_max(data)                           (0x0000000F&(data))
#define  DI_DI_PQ_CMP_QP_ST_get_long_term_qp_measure_en(data)                    ((0x80000000&(data))>>31)
#define  DI_DI_PQ_CMP_QP_ST_get_cmp_ctrl_para1(data)                             ((0x7F000000&(data))>>24)
#define  DI_DI_PQ_CMP_QP_ST_get_long_term_g_qp_max(data)                         ((0x00F00000&(data))>>20)
#define  DI_DI_PQ_CMP_QP_ST_get_long_term_rb_qp_max(data)                        ((0x000F0000&(data))>>16)
#define  DI_DI_PQ_CMP_QP_ST_get_cmp_ctrl_para2(data)                             ((0x0000FF00&(data))>>8)
#define  DI_DI_PQ_CMP_QP_ST_get_short_term_g_qp_max(data)                        ((0x000000F0&(data))>>4)
#define  DI_DI_PQ_CMP_QP_ST_get_short_term_rb_qp_max(data)                       (0x0000000F&(data))

#define  DI_DI_PQ_CMP_FIFO_ST1                                                  0x18024C34
#define  DI_DI_PQ_CMP_FIFO_ST1_reg_addr                                          "0xB8024C34"
#define  DI_DI_PQ_CMP_FIFO_ST1_reg                                               0xB8024C34
#define  DI_DI_PQ_CMP_FIFO_ST1_inst_addr                                         "0x01D2"
#define  set_DI_DI_PQ_CMP_FIFO_ST1_reg(data)                                     (*((volatile unsigned int*)DI_DI_PQ_CMP_FIFO_ST1_reg)=data)
#define  get_DI_DI_PQ_CMP_FIFO_ST1_reg                                           (*((volatile unsigned int*)DI_DI_PQ_CMP_FIFO_ST1_reg))
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_measure_en_shift                       (31)
#define  DI_DI_PQ_CMP_FIFO_ST1_cmp_ctrl_para3_shift                              (24)
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_even_g_shift                           (16)
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_even_r_shift                           (8)
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_even_b_shift                           (0)
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_measure_en_mask                        (0x80000000)
#define  DI_DI_PQ_CMP_FIFO_ST1_cmp_ctrl_para3_mask                               (0x7F000000)
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_even_g_mask                            (0x00FF0000)
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_even_r_mask                            (0x0000FF00)
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_even_b_mask                            (0x000000FF)
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_measure_en(data)                       (0x80000000&((data)<<31))
#define  DI_DI_PQ_CMP_FIFO_ST1_cmp_ctrl_para3(data)                              (0x7F000000&((data)<<24))
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_even_g(data)                           (0x00FF0000&((data)<<16))
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_even_r(data)                           (0x0000FF00&((data)<<8))
#define  DI_DI_PQ_CMP_FIFO_ST1_fifo_water_even_b(data)                           (0x000000FF&(data))
#define  DI_DI_PQ_CMP_FIFO_ST1_get_fifo_water_measure_en(data)                   ((0x80000000&(data))>>31)
#define  DI_DI_PQ_CMP_FIFO_ST1_get_cmp_ctrl_para3(data)                          ((0x7F000000&(data))>>24)
#define  DI_DI_PQ_CMP_FIFO_ST1_get_fifo_water_even_g(data)                       ((0x00FF0000&(data))>>16)
#define  DI_DI_PQ_CMP_FIFO_ST1_get_fifo_water_even_r(data)                       ((0x0000FF00&(data))>>8)
#define  DI_DI_PQ_CMP_FIFO_ST1_get_fifo_water_even_b(data)                       (0x000000FF&(data))

#define  DI_DI_PQ_CMP_FIFO_ST2                                                  0x18024C38
#define  DI_DI_PQ_CMP_FIFO_ST2_reg_addr                                          "0xB8024C38"
#define  DI_DI_PQ_CMP_FIFO_ST2_reg                                               0xB8024C38
#define  DI_DI_PQ_CMP_FIFO_ST2_inst_addr                                         "0x01D3"
#define  set_DI_DI_PQ_CMP_FIFO_ST2_reg(data)                                     (*((volatile unsigned int*)DI_DI_PQ_CMP_FIFO_ST2_reg)=data)
#define  get_DI_DI_PQ_CMP_FIFO_ST2_reg                                           (*((volatile unsigned int*)DI_DI_PQ_CMP_FIFO_ST2_reg))
#define  DI_DI_PQ_CMP_FIFO_ST2_fifo_water_odd_g_shift                            (16)
#define  DI_DI_PQ_CMP_FIFO_ST2_fifo_water_odd_r_shift                            (8)
#define  DI_DI_PQ_CMP_FIFO_ST2_fifo_water_odd_b_shift                            (0)
#define  DI_DI_PQ_CMP_FIFO_ST2_fifo_water_odd_g_mask                             (0x00FF0000)
#define  DI_DI_PQ_CMP_FIFO_ST2_fifo_water_odd_r_mask                             (0x0000FF00)
#define  DI_DI_PQ_CMP_FIFO_ST2_fifo_water_odd_b_mask                             (0x000000FF)
#define  DI_DI_PQ_CMP_FIFO_ST2_fifo_water_odd_g(data)                            (0x00FF0000&((data)<<16))
#define  DI_DI_PQ_CMP_FIFO_ST2_fifo_water_odd_r(data)                            (0x0000FF00&((data)<<8))
#define  DI_DI_PQ_CMP_FIFO_ST2_fifo_water_odd_b(data)                            (0x000000FF&(data))
#define  DI_DI_PQ_CMP_FIFO_ST2_get_fifo_water_odd_g(data)                        ((0x00FF0000&(data))>>16)
#define  DI_DI_PQ_CMP_FIFO_ST2_get_fifo_water_odd_r(data)                        ((0x0000FF00&(data))>>8)
#define  DI_DI_PQ_CMP_FIFO_ST2_get_fifo_water_odd_b(data)                        (0x000000FF&(data))

#define  DI_DI_PQ_CMP_LEFT_ST                                                   0x18024C3C
#define  DI_DI_PQ_CMP_LEFT_ST_reg_addr                                           "0xB8024C3C"
#define  DI_DI_PQ_CMP_LEFT_ST_reg                                                0xB8024C3C
#define  DI_DI_PQ_CMP_LEFT_ST_inst_addr                                          "0x01D4"
#define  set_DI_DI_PQ_CMP_LEFT_ST_reg(data)                                      (*((volatile unsigned int*)DI_DI_PQ_CMP_LEFT_ST_reg)=data)
#define  get_DI_DI_PQ_CMP_LEFT_ST_reg                                            (*((volatile unsigned int*)DI_DI_PQ_CMP_LEFT_ST_reg))
#define  DI_DI_PQ_CMP_LEFT_ST_g_frame_left_shift                                 (16)
#define  DI_DI_PQ_CMP_LEFT_ST_rb_frame_left_shift                                (0)
#define  DI_DI_PQ_CMP_LEFT_ST_g_frame_left_mask                                  (0xFFFF0000)
#define  DI_DI_PQ_CMP_LEFT_ST_rb_frame_left_mask                                 (0x0000FFFF)
#define  DI_DI_PQ_CMP_LEFT_ST_g_frame_left(data)                                 (0xFFFF0000&((data)<<16))
#define  DI_DI_PQ_CMP_LEFT_ST_rb_frame_left(data)                                (0x0000FFFF&(data))
#define  DI_DI_PQ_CMP_LEFT_ST_get_g_frame_left(data)                             ((0xFFFF0000&(data))>>16)
#define  DI_DI_PQ_CMP_LEFT_ST_get_rb_frame_left(data)                            (0x0000FFFF&(data))

#define  DI_DI_PQ_CMP_PACKAGE_ST                                                0x18024C40
#define  DI_DI_PQ_CMP_PACKAGE_ST_reg_addr                                        "0xB8024C40"
#define  DI_DI_PQ_CMP_PACKAGE_ST_reg                                             0xB8024C40
#define  DI_DI_PQ_CMP_PACKAGE_ST_inst_addr                                       "0x01D5"
#define  set_DI_DI_PQ_CMP_PACKAGE_ST_reg(data)                                   (*((volatile unsigned int*)DI_DI_PQ_CMP_PACKAGE_ST_reg)=data)
#define  get_DI_DI_PQ_CMP_PACKAGE_ST_reg                                         (*((volatile unsigned int*)DI_DI_PQ_CMP_PACKAGE_ST_reg))
#define  DI_DI_PQ_CMP_PACKAGE_ST_total_package_long_term_shift                   (31)
#define  DI_DI_PQ_CMP_PACKAGE_ST_total_package_even_shift                        (0)
#define  DI_DI_PQ_CMP_PACKAGE_ST_total_package_long_term_mask                    (0x80000000)
#define  DI_DI_PQ_CMP_PACKAGE_ST_total_package_even_mask                         (0x00FFFFFF)
#define  DI_DI_PQ_CMP_PACKAGE_ST_total_package_long_term(data)                   (0x80000000&((data)<<31))
#define  DI_DI_PQ_CMP_PACKAGE_ST_total_package_even(data)                        (0x00FFFFFF&(data))
#define  DI_DI_PQ_CMP_PACKAGE_ST_get_total_package_long_term(data)               ((0x80000000&(data))>>31)
#define  DI_DI_PQ_CMP_PACKAGE_ST_get_total_package_even(data)                    (0x00FFFFFF&(data))

#define  DI_DI_PQ_CMP_CRC_EVEN_G                                                0x18024C44
#define  DI_DI_PQ_CMP_CRC_EVEN_G_reg_addr                                        "0xB8024C44"
#define  DI_DI_PQ_CMP_CRC_EVEN_G_reg                                             0xB8024C44
#define  DI_DI_PQ_CMP_CRC_EVEN_G_inst_addr                                       "0x01D6"
#define  set_DI_DI_PQ_CMP_CRC_EVEN_G_reg(data)                                   (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_EVEN_G_reg)=data)
#define  get_DI_DI_PQ_CMP_CRC_EVEN_G_reg                                         (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_EVEN_G_reg))
#define  DI_DI_PQ_CMP_CRC_EVEN_G_cmp_crc_even_g_shift                            (0)
#define  DI_DI_PQ_CMP_CRC_EVEN_G_cmp_crc_even_g_mask                             (0xFFFFFFFF)
#define  DI_DI_PQ_CMP_CRC_EVEN_G_cmp_crc_even_g(data)                            (0xFFFFFFFF&(data))
#define  DI_DI_PQ_CMP_CRC_EVEN_G_get_cmp_crc_even_g(data)                        (0xFFFFFFFF&(data))

#define  DI_DI_PQ_CMP_CRC_EVEN_R                                                0x18024C48
#define  DI_DI_PQ_CMP_CRC_EVEN_R_reg_addr                                        "0xB8024C48"
#define  DI_DI_PQ_CMP_CRC_EVEN_R_reg                                             0xB8024C48
#define  DI_DI_PQ_CMP_CRC_EVEN_R_inst_addr                                       "0x01D7"
#define  set_DI_DI_PQ_CMP_CRC_EVEN_R_reg(data)                                   (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_EVEN_R_reg)=data)
#define  get_DI_DI_PQ_CMP_CRC_EVEN_R_reg                                         (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_EVEN_R_reg))
#define  DI_DI_PQ_CMP_CRC_EVEN_R_cmp_crc_even_r_shift                            (0)
#define  DI_DI_PQ_CMP_CRC_EVEN_R_cmp_crc_even_r_mask                             (0xFFFFFFFF)
#define  DI_DI_PQ_CMP_CRC_EVEN_R_cmp_crc_even_r(data)                            (0xFFFFFFFF&(data))
#define  DI_DI_PQ_CMP_CRC_EVEN_R_get_cmp_crc_even_r(data)                        (0xFFFFFFFF&(data))

#define  DI_DI_PQ_CMP_CRC_EVEN_B                                                0x18024C4C
#define  DI_DI_PQ_CMP_CRC_EVEN_B_reg_addr                                        "0xB8024C4C"
#define  DI_DI_PQ_CMP_CRC_EVEN_B_reg                                             0xB8024C4C
#define  DI_DI_PQ_CMP_CRC_EVEN_B_inst_addr                                       "0x01D8"
#define  set_DI_DI_PQ_CMP_CRC_EVEN_B_reg(data)                                   (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_EVEN_B_reg)=data)
#define  get_DI_DI_PQ_CMP_CRC_EVEN_B_reg                                         (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_EVEN_B_reg))
#define  DI_DI_PQ_CMP_CRC_EVEN_B_cmp_crc_even_b_shift                            (0)
#define  DI_DI_PQ_CMP_CRC_EVEN_B_cmp_crc_even_b_mask                             (0xFFFFFFFF)
#define  DI_DI_PQ_CMP_CRC_EVEN_B_cmp_crc_even_b(data)                            (0xFFFFFFFF&(data))
#define  DI_DI_PQ_CMP_CRC_EVEN_B_get_cmp_crc_even_b(data)                        (0xFFFFFFFF&(data))

#define  DI_DI_PQ_CMP_CRC_ODD_G                                                 0x18024C50
#define  DI_DI_PQ_CMP_CRC_ODD_G_reg_addr                                         "0xB8024C50"
#define  DI_DI_PQ_CMP_CRC_ODD_G_reg                                              0xB8024C50
#define  DI_DI_PQ_CMP_CRC_ODD_G_inst_addr                                        "0x01D9"
#define  set_DI_DI_PQ_CMP_CRC_ODD_G_reg(data)                                    (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_ODD_G_reg)=data)
#define  get_DI_DI_PQ_CMP_CRC_ODD_G_reg                                          (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_ODD_G_reg))
#define  DI_DI_PQ_CMP_CRC_ODD_G_cmp_crc_odd_g_shift                              (0)
#define  DI_DI_PQ_CMP_CRC_ODD_G_cmp_crc_odd_g_mask                               (0xFFFFFFFF)
#define  DI_DI_PQ_CMP_CRC_ODD_G_cmp_crc_odd_g(data)                              (0xFFFFFFFF&(data))
#define  DI_DI_PQ_CMP_CRC_ODD_G_get_cmp_crc_odd_g(data)                          (0xFFFFFFFF&(data))

#define  DI_DI_PQ_CMP_CRC_ODD_R                                                 0x18024C54
#define  DI_DI_PQ_CMP_CRC_ODD_R_reg_addr                                         "0xB8024C54"
#define  DI_DI_PQ_CMP_CRC_ODD_R_reg                                              0xB8024C54
#define  DI_DI_PQ_CMP_CRC_ODD_R_inst_addr                                        "0x01DA"
#define  set_DI_DI_PQ_CMP_CRC_ODD_R_reg(data)                                    (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_ODD_R_reg)=data)
#define  get_DI_DI_PQ_CMP_CRC_ODD_R_reg                                          (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_ODD_R_reg))
#define  DI_DI_PQ_CMP_CRC_ODD_R_cmp_crc_odd_r_shift                              (0)
#define  DI_DI_PQ_CMP_CRC_ODD_R_cmp_crc_odd_r_mask                               (0xFFFFFFFF)
#define  DI_DI_PQ_CMP_CRC_ODD_R_cmp_crc_odd_r(data)                              (0xFFFFFFFF&(data))
#define  DI_DI_PQ_CMP_CRC_ODD_R_get_cmp_crc_odd_r(data)                          (0xFFFFFFFF&(data))

#define  DI_DI_PQ_CMP_CRC_ODD_B                                                 0x18024C58
#define  DI_DI_PQ_CMP_CRC_ODD_B_reg_addr                                         "0xB8024C58"
#define  DI_DI_PQ_CMP_CRC_ODD_B_reg                                              0xB8024C58
#define  DI_DI_PQ_CMP_CRC_ODD_B_inst_addr                                        "0x01DB"
#define  set_DI_DI_PQ_CMP_CRC_ODD_B_reg(data)                                    (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_ODD_B_reg)=data)
#define  get_DI_DI_PQ_CMP_CRC_ODD_B_reg                                          (*((volatile unsigned int*)DI_DI_PQ_CMP_CRC_ODD_B_reg))
#define  DI_DI_PQ_CMP_CRC_ODD_B_cmp_crc_odd_b_shift                              (0)
#define  DI_DI_PQ_CMP_CRC_ODD_B_cmp_crc_odd_b_mask                               (0xFFFFFFFF)
#define  DI_DI_PQ_CMP_CRC_ODD_B_cmp_crc_odd_b(data)                              (0xFFFFFFFF&(data))
#define  DI_DI_PQ_CMP_CRC_ODD_B_get_cmp_crc_odd_b(data)                          (0xFFFFFFFF&(data))

#define  DI_DI_PQ_CMP_PACKAGE_ODD_ST                                            0x18024C5C
#define  DI_DI_PQ_CMP_PACKAGE_ODD_ST_reg_addr                                    "0xB8024C5C"
#define  DI_DI_PQ_CMP_PACKAGE_ODD_ST_reg                                         0xB8024C5C
#define  DI_DI_PQ_CMP_PACKAGE_ODD_ST_inst_addr                                   "0x01DC"
#define  set_DI_DI_PQ_CMP_PACKAGE_ODD_ST_reg(data)                               (*((volatile unsigned int*)DI_DI_PQ_CMP_PACKAGE_ODD_ST_reg)=data)
#define  get_DI_DI_PQ_CMP_PACKAGE_ODD_ST_reg                                     (*((volatile unsigned int*)DI_DI_PQ_CMP_PACKAGE_ODD_ST_reg))
#define  DI_DI_PQ_CMP_PACKAGE_ODD_ST_total_package_odd_shift                     (0)
#define  DI_DI_PQ_CMP_PACKAGE_ODD_ST_total_package_odd_mask                      (0x00FFFFFF)
#define  DI_DI_PQ_CMP_PACKAGE_ODD_ST_total_package_odd(data)                     (0x00FFFFFF&(data))
#define  DI_DI_PQ_CMP_PACKAGE_ODD_ST_get_total_package_odd(data)                 (0x00FFFFFF&(data))

#define  DI_DI_PQ_CMP_BLK0_ADD0                                                 0x18024C60
#define  DI_DI_PQ_CMP_BLK0_ADD0_reg_addr                                         "0xB8024C60"
#define  DI_DI_PQ_CMP_BLK0_ADD0_reg                                              0xB8024C60
#define  DI_DI_PQ_CMP_BLK0_ADD0_inst_addr                                        "0x01DD"
#define  set_DI_DI_PQ_CMP_BLK0_ADD0_reg(data)                                    (*((volatile unsigned int*)DI_DI_PQ_CMP_BLK0_ADD0_reg)=data)
#define  get_DI_DI_PQ_CMP_BLK0_ADD0_reg                                          (*((volatile unsigned int*)DI_DI_PQ_CMP_BLK0_ADD0_reg))
#define  DI_DI_PQ_CMP_BLK0_ADD0_blk0_add_value0_shift                            (24)
#define  DI_DI_PQ_CMP_BLK0_ADD0_dic_mode_tolerance_shift                         (16)
#define  DI_DI_PQ_CMP_BLK0_ADD0_blk0_add_value32_shift                           (8)
#define  DI_DI_PQ_CMP_BLK0_ADD0_blk0_add_value16_shift                           (0)
#define  DI_DI_PQ_CMP_BLK0_ADD0_blk0_add_value0_mask                             (0x3F000000)
#define  DI_DI_PQ_CMP_BLK0_ADD0_dic_mode_tolerance_mask                          (0x00FF0000)
#define  DI_DI_PQ_CMP_BLK0_ADD0_blk0_add_value32_mask                            (0x00003F00)
#define  DI_DI_PQ_CMP_BLK0_ADD0_blk0_add_value16_mask                            (0x0000003F)
#define  DI_DI_PQ_CMP_BLK0_ADD0_blk0_add_value0(data)                            (0x3F000000&((data)<<24))
#define  DI_DI_PQ_CMP_BLK0_ADD0_dic_mode_tolerance(data)                         (0x00FF0000&((data)<<16))
#define  DI_DI_PQ_CMP_BLK0_ADD0_blk0_add_value32(data)                           (0x00003F00&((data)<<8))
#define  DI_DI_PQ_CMP_BLK0_ADD0_blk0_add_value16(data)                           (0x0000003F&(data))
#define  DI_DI_PQ_CMP_BLK0_ADD0_get_blk0_add_value0(data)                        ((0x3F000000&(data))>>24)
#define  DI_DI_PQ_CMP_BLK0_ADD0_get_dic_mode_tolerance(data)                     ((0x00FF0000&(data))>>16)
#define  DI_DI_PQ_CMP_BLK0_ADD0_get_blk0_add_value32(data)                       ((0x00003F00&(data))>>8)
#define  DI_DI_PQ_CMP_BLK0_ADD0_get_blk0_add_value16(data)                       (0x0000003F&(data))

#define  DI_DI_PQ_CMP_BLK0_ADD1                                                 0x18024C64
#define  DI_DI_PQ_CMP_BLK0_ADD1_reg_addr                                         "0xB8024C64"
#define  DI_DI_PQ_CMP_BLK0_ADD1_reg                                              0xB8024C64
#define  DI_DI_PQ_CMP_BLK0_ADD1_inst_addr                                        "0x01DE"
#define  set_DI_DI_PQ_CMP_BLK0_ADD1_reg(data)                                    (*((volatile unsigned int*)DI_DI_PQ_CMP_BLK0_ADD1_reg)=data)
#define  get_DI_DI_PQ_CMP_BLK0_ADD1_reg                                          (*((volatile unsigned int*)DI_DI_PQ_CMP_BLK0_ADD1_reg))
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value8_shift                            (24)
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value4_shift                            (16)
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value2_shift                            (8)
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value1_shift                            (0)
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value8_mask                             (0x3F000000)
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value4_mask                             (0x003F0000)
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value2_mask                             (0x00003F00)
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value1_mask                             (0x0000003F)
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value8(data)                            (0x3F000000&((data)<<24))
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value4(data)                            (0x003F0000&((data)<<16))
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value2(data)                            (0x00003F00&((data)<<8))
#define  DI_DI_PQ_CMP_BLK0_ADD1_blk0_add_value1(data)                            (0x0000003F&(data))
#define  DI_DI_PQ_CMP_BLK0_ADD1_get_blk0_add_value8(data)                        ((0x3F000000&(data))>>24)
#define  DI_DI_PQ_CMP_BLK0_ADD1_get_blk0_add_value4(data)                        ((0x003F0000&(data))>>16)
#define  DI_DI_PQ_CMP_BLK0_ADD1_get_blk0_add_value2(data)                        ((0x00003F00&(data))>>8)
#define  DI_DI_PQ_CMP_BLK0_ADD1_get_blk0_add_value1(data)                        (0x0000003F&(data))

#define  DI_DI_PQ_DECMP                                                         0x18024C80
#define  DI_DI_PQ_DECMP_reg_addr                                                 "0xB8024C80"
#define  DI_DI_PQ_DECMP_reg                                                      0xB8024C80
#define  DI_DI_PQ_DECMP_inst_addr                                                "0x01DF"
#define  set_DI_DI_PQ_DECMP_reg(data)                                            (*((volatile unsigned int*)DI_DI_PQ_DECMP_reg)=data)
#define  get_DI_DI_PQ_DECMP_reg                                                  (*((volatile unsigned int*)DI_DI_PQ_DECMP_reg))
#define  DI_DI_PQ_DECMP_decmp_en_shift                                           (31)
#define  DI_DI_PQ_DECMP_decmp_width_div32_shift                                  (16)
#define  DI_DI_PQ_DECMP_decmp_height_shift                                       (0)
#define  DI_DI_PQ_DECMP_decmp_en_mask                                            (0x80000000)
#define  DI_DI_PQ_DECMP_decmp_width_div32_mask                                   (0x01FF0000)
#define  DI_DI_PQ_DECMP_decmp_height_mask                                        (0x00003FFF)
#define  DI_DI_PQ_DECMP_decmp_en(data)                                           (0x80000000&((data)<<31))
#define  DI_DI_PQ_DECMP_decmp_width_div32(data)                                  (0x01FF0000&((data)<<16))
#define  DI_DI_PQ_DECMP_decmp_height(data)                                       (0x00003FFF&(data))
#define  DI_DI_PQ_DECMP_get_decmp_en(data)                                       ((0x80000000&(data))>>31)
#define  DI_DI_PQ_DECMP_get_decmp_width_div32(data)                              ((0x01FF0000&(data))>>16)
#define  DI_DI_PQ_DECMP_get_decmp_height(data)                                   (0x00003FFF&(data))

#define  DI_DI_PQ_DECMP_PAIR                                                    0x18024C84
#define  DI_DI_PQ_DECMP_PAIR_reg_addr                                            "0xB8024C84"
#define  DI_DI_PQ_DECMP_PAIR_reg                                                 0xB8024C84
#define  DI_DI_PQ_DECMP_PAIR_inst_addr                                           "0x01E0"
#define  set_DI_DI_PQ_DECMP_PAIR_reg(data)                                       (*((volatile unsigned int*)DI_DI_PQ_DECMP_PAIR_reg)=data)
#define  get_DI_DI_PQ_DECMP_PAIR_reg                                             (*((volatile unsigned int*)DI_DI_PQ_DECMP_PAIR_reg))
#define  DI_DI_PQ_DECMP_PAIR_decmp_line_sum_bit_shift                            (16)
#define  DI_DI_PQ_DECMP_PAIR_decmp_400_old_mode_en_shift                         (15)
#define  DI_DI_PQ_DECMP_PAIR_decmp_pair_para_shift                               (11)
#define  DI_DI_PQ_DECMP_PAIR_decmp_jump4_en_shift                                (10)
#define  DI_DI_PQ_DECMP_PAIR_decmp_qp_mode_shift                                 (8)
#define  DI_DI_PQ_DECMP_PAIR_decmp_dic_mode_en_shift                             (7)
#define  DI_DI_PQ_DECMP_PAIR_decmp_two_line_prediction_en_shift                  (6)
#define  DI_DI_PQ_DECMP_PAIR_decmp_line_mode_shift                               (5)
#define  DI_DI_PQ_DECMP_PAIR_decmp_data_color_shift                              (4)
#define  DI_DI_PQ_DECMP_PAIR_decmp_data_bit_width_shift                          (2)
#define  DI_DI_PQ_DECMP_PAIR_decmp_data_format_shift                             (0)
#define  DI_DI_PQ_DECMP_PAIR_decmp_line_sum_bit_mask                             (0xFFFF0000)
#define  DI_DI_PQ_DECMP_PAIR_decmp_400_old_mode_en_mask                          (0x00008000)
#define  DI_DI_PQ_DECMP_PAIR_decmp_pair_para_mask                                (0x00007800)
#define  DI_DI_PQ_DECMP_PAIR_decmp_jump4_en_mask                                 (0x00000400)
#define  DI_DI_PQ_DECMP_PAIR_decmp_qp_mode_mask                                  (0x00000300)
#define  DI_DI_PQ_DECMP_PAIR_decmp_dic_mode_en_mask                              (0x00000080)
#define  DI_DI_PQ_DECMP_PAIR_decmp_two_line_prediction_en_mask                   (0x00000040)
#define  DI_DI_PQ_DECMP_PAIR_decmp_line_mode_mask                                (0x00000020)
#define  DI_DI_PQ_DECMP_PAIR_decmp_data_color_mask                               (0x00000010)
#define  DI_DI_PQ_DECMP_PAIR_decmp_data_bit_width_mask                           (0x0000000C)
#define  DI_DI_PQ_DECMP_PAIR_decmp_data_format_mask                              (0x00000003)
#define  DI_DI_PQ_DECMP_PAIR_decmp_line_sum_bit(data)                            (0xFFFF0000&((data)<<16))
#define  DI_DI_PQ_DECMP_PAIR_decmp_400_old_mode_en(data)                         (0x00008000&((data)<<15))
#define  DI_DI_PQ_DECMP_PAIR_decmp_pair_para(data)                               (0x00007800&((data)<<11))
#define  DI_DI_PQ_DECMP_PAIR_decmp_jump4_en(data)                                (0x00000400&((data)<<10))
#define  DI_DI_PQ_DECMP_PAIR_decmp_qp_mode(data)                                 (0x00000300&((data)<<8))
#define  DI_DI_PQ_DECMP_PAIR_decmp_dic_mode_en(data)                             (0x00000080&((data)<<7))
#define  DI_DI_PQ_DECMP_PAIR_decmp_two_line_prediction_en(data)                  (0x00000040&((data)<<6))
#define  DI_DI_PQ_DECMP_PAIR_decmp_line_mode(data)                               (0x00000020&((data)<<5))
#define  DI_DI_PQ_DECMP_PAIR_decmp_data_color(data)                              (0x00000010&((data)<<4))
#define  DI_DI_PQ_DECMP_PAIR_decmp_data_bit_width(data)                          (0x0000000C&((data)<<2))
#define  DI_DI_PQ_DECMP_PAIR_decmp_data_format(data)                             (0x00000003&(data))
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_line_sum_bit(data)                        ((0xFFFF0000&(data))>>16)
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_400_old_mode_en(data)                     ((0x00008000&(data))>>15)
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_pair_para(data)                           ((0x00007800&(data))>>11)
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_jump4_en(data)                            ((0x00000400&(data))>>10)
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_qp_mode(data)                             ((0x00000300&(data))>>8)
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_dic_mode_en(data)                         ((0x00000080&(data))>>7)
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_two_line_prediction_en(data)              ((0x00000040&(data))>>6)
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_line_mode(data)                           ((0x00000020&(data))>>5)
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_data_color(data)                          ((0x00000010&(data))>>4)
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_data_bit_width(data)                      ((0x0000000C&(data))>>2)
#define  DI_DI_PQ_DECMP_PAIR_get_decmp_data_format(data)                         (0x00000003&(data))

#define  DI_DI_PQ_DECMP_SAT_EN                                                  0x18024C88
#define  DI_DI_PQ_DECMP_SAT_EN_reg_addr                                          "0xB8024C88"
#define  DI_DI_PQ_DECMP_SAT_EN_reg                                               0xB8024C88
#define  DI_DI_PQ_DECMP_SAT_EN_inst_addr                                         "0x01E1"
#define  set_DI_DI_PQ_DECMP_SAT_EN_reg(data)                                     (*((volatile unsigned int*)DI_DI_PQ_DECMP_SAT_EN_reg)=data)
#define  get_DI_DI_PQ_DECMP_SAT_EN_reg                                           (*((volatile unsigned int*)DI_DI_PQ_DECMP_SAT_EN_reg))
#define  DI_DI_PQ_DECMP_SAT_EN_decmp_crc_ro_line_sel_shift                       (16)
#define  DI_DI_PQ_DECMP_SAT_EN_decmp_ctrl_para_shift                             (3)
#define  DI_DI_PQ_DECMP_SAT_EN_saturation_type_delta_shift                       (2)
#define  DI_DI_PQ_DECMP_SAT_EN_saturation_type_shift                             (1)
#define  DI_DI_PQ_DECMP_SAT_EN_saturation_en_shift                               (0)
#define  DI_DI_PQ_DECMP_SAT_EN_decmp_crc_ro_line_sel_mask                        (0x3FFF0000)
#define  DI_DI_PQ_DECMP_SAT_EN_decmp_ctrl_para_mask                              (0x0000FFF8)
#define  DI_DI_PQ_DECMP_SAT_EN_saturation_type_delta_mask                        (0x00000004)
#define  DI_DI_PQ_DECMP_SAT_EN_saturation_type_mask                              (0x00000002)
#define  DI_DI_PQ_DECMP_SAT_EN_saturation_en_mask                                (0x00000001)
#define  DI_DI_PQ_DECMP_SAT_EN_decmp_crc_ro_line_sel(data)                       (0x3FFF0000&((data)<<16))
#define  DI_DI_PQ_DECMP_SAT_EN_decmp_ctrl_para(data)                             (0x0000FFF8&((data)<<3))
#define  DI_DI_PQ_DECMP_SAT_EN_saturation_type_delta(data)                       (0x00000004&((data)<<2))
#define  DI_DI_PQ_DECMP_SAT_EN_saturation_type(data)                             (0x00000002&((data)<<1))
#define  DI_DI_PQ_DECMP_SAT_EN_saturation_en(data)                               (0x00000001&(data))
#define  DI_DI_PQ_DECMP_SAT_EN_get_decmp_crc_ro_line_sel(data)                   ((0x3FFF0000&(data))>>16)
#define  DI_DI_PQ_DECMP_SAT_EN_get_decmp_ctrl_para(data)                         ((0x0000FFF8&(data))>>3)
#define  DI_DI_PQ_DECMP_SAT_EN_get_saturation_type_delta(data)                   ((0x00000004&(data))>>2)
#define  DI_DI_PQ_DECMP_SAT_EN_get_saturation_type(data)                         ((0x00000002&(data))>>1)
#define  DI_DI_PQ_DECMP_SAT_EN_get_saturation_en(data)                           (0x00000001&(data))

#define  DI_DI_PQ_DECMP_IRQ_EN                                                  0x18024C8C
#define  DI_DI_PQ_DECMP_IRQ_EN_reg_addr                                          "0xB8024C8C"
#define  DI_DI_PQ_DECMP_IRQ_EN_reg                                               0xB8024C8C
#define  DI_DI_PQ_DECMP_IRQ_EN_inst_addr                                         "0x01E2"
#define  set_DI_DI_PQ_DECMP_IRQ_EN_reg(data)                                     (*((volatile unsigned int*)DI_DI_PQ_DECMP_IRQ_EN_reg)=data)
#define  get_DI_DI_PQ_DECMP_IRQ_EN_reg                                           (*((volatile unsigned int*)DI_DI_PQ_DECMP_IRQ_EN_reg))
#define  DI_DI_PQ_DECMP_IRQ_EN_not_finish_irq_even_en_shift                      (21)
#define  DI_DI_PQ_DECMP_IRQ_EN_underflow_irq_even_en_shift                       (20)
#define  DI_DI_PQ_DECMP_IRQ_EN_dic_error_even_en_shift                           (19)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_r_error_even_en_shift                         (18)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_g_error_even_en_shift                         (17)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_b_error_even_en_shift                         (16)
#define  DI_DI_PQ_DECMP_IRQ_EN_not_finish_irq_odd_en_shift                       (5)
#define  DI_DI_PQ_DECMP_IRQ_EN_underflow_irq_odd_en_shift                        (4)
#define  DI_DI_PQ_DECMP_IRQ_EN_dic_error_odd_en_shift                            (3)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_r_error_odd_en_shift                          (2)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_g_error_odd_en_shift                          (1)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_b_error_odd_en_shift                          (0)
#define  DI_DI_PQ_DECMP_IRQ_EN_not_finish_irq_even_en_mask                       (0x00200000)
#define  DI_DI_PQ_DECMP_IRQ_EN_underflow_irq_even_en_mask                        (0x00100000)
#define  DI_DI_PQ_DECMP_IRQ_EN_dic_error_even_en_mask                            (0x00080000)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_r_error_even_en_mask                          (0x00040000)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_g_error_even_en_mask                          (0x00020000)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_b_error_even_en_mask                          (0x00010000)
#define  DI_DI_PQ_DECMP_IRQ_EN_not_finish_irq_odd_en_mask                        (0x00000020)
#define  DI_DI_PQ_DECMP_IRQ_EN_underflow_irq_odd_en_mask                         (0x00000010)
#define  DI_DI_PQ_DECMP_IRQ_EN_dic_error_odd_en_mask                             (0x00000008)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_r_error_odd_en_mask                           (0x00000004)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_g_error_odd_en_mask                           (0x00000002)
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_b_error_odd_en_mask                           (0x00000001)
#define  DI_DI_PQ_DECMP_IRQ_EN_not_finish_irq_even_en(data)                      (0x00200000&((data)<<21))
#define  DI_DI_PQ_DECMP_IRQ_EN_underflow_irq_even_en(data)                       (0x00100000&((data)<<20))
#define  DI_DI_PQ_DECMP_IRQ_EN_dic_error_even_en(data)                           (0x00080000&((data)<<19))
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_r_error_even_en(data)                         (0x00040000&((data)<<18))
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_g_error_even_en(data)                         (0x00020000&((data)<<17))
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_b_error_even_en(data)                         (0x00010000&((data)<<16))
#define  DI_DI_PQ_DECMP_IRQ_EN_not_finish_irq_odd_en(data)                       (0x00000020&((data)<<5))
#define  DI_DI_PQ_DECMP_IRQ_EN_underflow_irq_odd_en(data)                        (0x00000010&((data)<<4))
#define  DI_DI_PQ_DECMP_IRQ_EN_dic_error_odd_en(data)                            (0x00000008&((data)<<3))
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_r_error_odd_en(data)                          (0x00000004&((data)<<2))
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_g_error_odd_en(data)                          (0x00000002&((data)<<1))
#define  DI_DI_PQ_DECMP_IRQ_EN_crc_b_error_odd_en(data)                          (0x00000001&(data))
#define  DI_DI_PQ_DECMP_IRQ_EN_get_not_finish_irq_even_en(data)                  ((0x00200000&(data))>>21)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_underflow_irq_even_en(data)                   ((0x00100000&(data))>>20)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_dic_error_even_en(data)                       ((0x00080000&(data))>>19)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_crc_r_error_even_en(data)                     ((0x00040000&(data))>>18)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_crc_g_error_even_en(data)                     ((0x00020000&(data))>>17)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_crc_b_error_even_en(data)                     ((0x00010000&(data))>>16)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_not_finish_irq_odd_en(data)                   ((0x00000020&(data))>>5)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_underflow_irq_odd_en(data)                    ((0x00000010&(data))>>4)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_dic_error_odd_en(data)                        ((0x00000008&(data))>>3)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_crc_r_error_odd_en(data)                      ((0x00000004&(data))>>2)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_crc_g_error_odd_en(data)                      ((0x00000002&(data))>>1)
#define  DI_DI_PQ_DECMP_IRQ_EN_get_crc_b_error_odd_en(data)                      (0x00000001&(data))

#define  DI_DI_PQ_DECMP_IRQ_st                                                  0x18024C90
#define  DI_DI_PQ_DECMP_IRQ_st_reg_addr                                          "0xB8024C90"
#define  DI_DI_PQ_DECMP_IRQ_st_reg                                               0xB8024C90
#define  DI_DI_PQ_DECMP_IRQ_st_inst_addr                                         "0x01E3"
#define  set_DI_DI_PQ_DECMP_IRQ_st_reg(data)                                     (*((volatile unsigned int*)DI_DI_PQ_DECMP_IRQ_st_reg)=data)
#define  get_DI_DI_PQ_DECMP_IRQ_st_reg                                           (*((volatile unsigned int*)DI_DI_PQ_DECMP_IRQ_st_reg))
#define  DI_DI_PQ_DECMP_IRQ_st_pqdc_irq_shift                                    (31)
#define  DI_DI_PQ_DECMP_IRQ_st_in_fifo_overflow_even_st_shift                    (27)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_r_overflow_even_st_shift                     (26)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_g_overflow_even_st_shift                     (25)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_b_overflow_even_st_shift                     (24)
#define  DI_DI_PQ_DECMP_IRQ_st_not_finish_irq_even_st_shift                      (21)
#define  DI_DI_PQ_DECMP_IRQ_st_underflow_irq_even_st_shift                       (20)
#define  DI_DI_PQ_DECMP_IRQ_st_dic_error_even_st_shift                           (19)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_r_error_even_st_shift                         (18)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_g_error_even_st_shift                         (17)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_b_error_even_st_shift                         (16)
#define  DI_DI_PQ_DECMP_IRQ_st_in_fifo_overflow_odd_st_shift                     (11)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_r_overflow_odd_st_shift                      (10)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_g_overflow_odd_st_shift                      (9)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_b_overflow_odd_st_shift                      (8)
#define  DI_DI_PQ_DECMP_IRQ_st_not_finish_irq_odd_st_shift                       (5)
#define  DI_DI_PQ_DECMP_IRQ_st_underflow_irq_odd_st_shift                        (4)
#define  DI_DI_PQ_DECMP_IRQ_st_dic_error_odd_st_shift                            (3)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_r_error_odd_st_shift                          (2)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_g_error_odd_st_shift                          (1)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_b_error_odd_st_shift                          (0)
#define  DI_DI_PQ_DECMP_IRQ_st_pqdc_irq_mask                                     (0x80000000)
#define  DI_DI_PQ_DECMP_IRQ_st_in_fifo_overflow_even_st_mask                     (0x08000000)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_r_overflow_even_st_mask                      (0x04000000)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_g_overflow_even_st_mask                      (0x02000000)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_b_overflow_even_st_mask                      (0x01000000)
#define  DI_DI_PQ_DECMP_IRQ_st_not_finish_irq_even_st_mask                       (0x00200000)
#define  DI_DI_PQ_DECMP_IRQ_st_underflow_irq_even_st_mask                        (0x00100000)
#define  DI_DI_PQ_DECMP_IRQ_st_dic_error_even_st_mask                            (0x00080000)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_r_error_even_st_mask                          (0x00040000)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_g_error_even_st_mask                          (0x00020000)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_b_error_even_st_mask                          (0x00010000)
#define  DI_DI_PQ_DECMP_IRQ_st_in_fifo_overflow_odd_st_mask                      (0x00000800)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_r_overflow_odd_st_mask                       (0x00000400)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_g_overflow_odd_st_mask                       (0x00000200)
#define  DI_DI_PQ_DECMP_IRQ_st_ring_b_overflow_odd_st_mask                       (0x00000100)
#define  DI_DI_PQ_DECMP_IRQ_st_not_finish_irq_odd_st_mask                        (0x00000020)
#define  DI_DI_PQ_DECMP_IRQ_st_underflow_irq_odd_st_mask                         (0x00000010)
#define  DI_DI_PQ_DECMP_IRQ_st_dic_error_odd_st_mask                             (0x00000008)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_r_error_odd_st_mask                           (0x00000004)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_g_error_odd_st_mask                           (0x00000002)
#define  DI_DI_PQ_DECMP_IRQ_st_crc_b_error_odd_st_mask                           (0x00000001)
#define  DI_DI_PQ_DECMP_IRQ_st_pqdc_irq(data)                                    (0x80000000&((data)<<31))
#define  DI_DI_PQ_DECMP_IRQ_st_in_fifo_overflow_even_st(data)                    (0x08000000&((data)<<27))
#define  DI_DI_PQ_DECMP_IRQ_st_ring_r_overflow_even_st(data)                     (0x04000000&((data)<<26))
#define  DI_DI_PQ_DECMP_IRQ_st_ring_g_overflow_even_st(data)                     (0x02000000&((data)<<25))
#define  DI_DI_PQ_DECMP_IRQ_st_ring_b_overflow_even_st(data)                     (0x01000000&((data)<<24))
#define  DI_DI_PQ_DECMP_IRQ_st_not_finish_irq_even_st(data)                      (0x00200000&((data)<<21))
#define  DI_DI_PQ_DECMP_IRQ_st_underflow_irq_even_st(data)                       (0x00100000&((data)<<20))
#define  DI_DI_PQ_DECMP_IRQ_st_dic_error_even_st(data)                           (0x00080000&((data)<<19))
#define  DI_DI_PQ_DECMP_IRQ_st_crc_r_error_even_st(data)                         (0x00040000&((data)<<18))
#define  DI_DI_PQ_DECMP_IRQ_st_crc_g_error_even_st(data)                         (0x00020000&((data)<<17))
#define  DI_DI_PQ_DECMP_IRQ_st_crc_b_error_even_st(data)                         (0x00010000&((data)<<16))
#define  DI_DI_PQ_DECMP_IRQ_st_in_fifo_overflow_odd_st(data)                     (0x00000800&((data)<<11))
#define  DI_DI_PQ_DECMP_IRQ_st_ring_r_overflow_odd_st(data)                      (0x00000400&((data)<<10))
#define  DI_DI_PQ_DECMP_IRQ_st_ring_g_overflow_odd_st(data)                      (0x00000200&((data)<<9))
#define  DI_DI_PQ_DECMP_IRQ_st_ring_b_overflow_odd_st(data)                      (0x00000100&((data)<<8))
#define  DI_DI_PQ_DECMP_IRQ_st_not_finish_irq_odd_st(data)                       (0x00000020&((data)<<5))
#define  DI_DI_PQ_DECMP_IRQ_st_underflow_irq_odd_st(data)                        (0x00000010&((data)<<4))
#define  DI_DI_PQ_DECMP_IRQ_st_dic_error_odd_st(data)                            (0x00000008&((data)<<3))
#define  DI_DI_PQ_DECMP_IRQ_st_crc_r_error_odd_st(data)                          (0x00000004&((data)<<2))
#define  DI_DI_PQ_DECMP_IRQ_st_crc_g_error_odd_st(data)                          (0x00000002&((data)<<1))
#define  DI_DI_PQ_DECMP_IRQ_st_crc_b_error_odd_st(data)                          (0x00000001&(data))
#define  DI_DI_PQ_DECMP_IRQ_st_get_pqdc_irq(data)                                ((0x80000000&(data))>>31)
#define  DI_DI_PQ_DECMP_IRQ_st_get_in_fifo_overflow_even_st(data)                ((0x08000000&(data))>>27)
#define  DI_DI_PQ_DECMP_IRQ_st_get_ring_r_overflow_even_st(data)                 ((0x04000000&(data))>>26)
#define  DI_DI_PQ_DECMP_IRQ_st_get_ring_g_overflow_even_st(data)                 ((0x02000000&(data))>>25)
#define  DI_DI_PQ_DECMP_IRQ_st_get_ring_b_overflow_even_st(data)                 ((0x01000000&(data))>>24)
#define  DI_DI_PQ_DECMP_IRQ_st_get_not_finish_irq_even_st(data)                  ((0x00200000&(data))>>21)
#define  DI_DI_PQ_DECMP_IRQ_st_get_underflow_irq_even_st(data)                   ((0x00100000&(data))>>20)
#define  DI_DI_PQ_DECMP_IRQ_st_get_dic_error_even_st(data)                       ((0x00080000&(data))>>19)
#define  DI_DI_PQ_DECMP_IRQ_st_get_crc_r_error_even_st(data)                     ((0x00040000&(data))>>18)
#define  DI_DI_PQ_DECMP_IRQ_st_get_crc_g_error_even_st(data)                     ((0x00020000&(data))>>17)
#define  DI_DI_PQ_DECMP_IRQ_st_get_crc_b_error_even_st(data)                     ((0x00010000&(data))>>16)
#define  DI_DI_PQ_DECMP_IRQ_st_get_in_fifo_overflow_odd_st(data)                 ((0x00000800&(data))>>11)
#define  DI_DI_PQ_DECMP_IRQ_st_get_ring_r_overflow_odd_st(data)                  ((0x00000400&(data))>>10)
#define  DI_DI_PQ_DECMP_IRQ_st_get_ring_g_overflow_odd_st(data)                  ((0x00000200&(data))>>9)
#define  DI_DI_PQ_DECMP_IRQ_st_get_ring_b_overflow_odd_st(data)                  ((0x00000100&(data))>>8)
#define  DI_DI_PQ_DECMP_IRQ_st_get_not_finish_irq_odd_st(data)                   ((0x00000020&(data))>>5)
#define  DI_DI_PQ_DECMP_IRQ_st_get_underflow_irq_odd_st(data)                    ((0x00000010&(data))>>4)
#define  DI_DI_PQ_DECMP_IRQ_st_get_dic_error_odd_st(data)                        ((0x00000008&(data))>>3)
#define  DI_DI_PQ_DECMP_IRQ_st_get_crc_r_error_odd_st(data)                      ((0x00000004&(data))>>2)
#define  DI_DI_PQ_DECMP_IRQ_st_get_crc_g_error_odd_st(data)                      ((0x00000002&(data))>>1)
#define  DI_DI_PQ_DECMP_IRQ_st_get_crc_b_error_odd_st(data)                      (0x00000001&(data))

#define  DI_DI_PQ_DECMP_MARK_EN                                                 0x18024C94
#define  DI_DI_PQ_DECMP_MARK_EN_reg_addr                                         "0xB8024C94"
#define  DI_DI_PQ_DECMP_MARK_EN_reg                                              0xB8024C94
#define  DI_DI_PQ_DECMP_MARK_EN_inst_addr                                        "0x01E4"
#define  set_DI_DI_PQ_DECMP_MARK_EN_reg(data)                                    (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_EN_reg)=data)
#define  get_DI_DI_PQ_DECMP_MARK_EN_reg                                          (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_EN_reg))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_do_422_shift                             (31)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_dic_shift                                (17)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp_sel_shift                             (16)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp7_shift                                (7)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp6_shift                                (6)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp5_shift                                (5)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp4_shift                                (4)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp3_shift                                (3)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp2_shift                                (2)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp1_shift                                (1)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp0_shift                                (0)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_do_422_mask                              (0x80000000)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_dic_mask                                 (0x00020000)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp_sel_mask                              (0x00010000)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp7_mask                                 (0x00000080)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp6_mask                                 (0x00000040)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp5_mask                                 (0x00000020)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp4_mask                                 (0x00000010)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp3_mask                                 (0x00000008)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp2_mask                                 (0x00000004)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp1_mask                                 (0x00000002)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp0_mask                                 (0x00000001)
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_do_422(data)                             (0x80000000&((data)<<31))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_dic(data)                                (0x00020000&((data)<<17))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp_sel(data)                             (0x00010000&((data)<<16))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp7(data)                                (0x00000080&((data)<<7))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp6(data)                                (0x00000040&((data)<<6))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp5(data)                                (0x00000020&((data)<<5))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp4(data)                                (0x00000010&((data)<<4))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp3(data)                                (0x00000008&((data)<<3))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp2(data)                                (0x00000004&((data)<<2))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp1(data)                                (0x00000002&((data)<<1))
#define  DI_DI_PQ_DECMP_MARK_EN_mark_en_qp0(data)                                (0x00000001&(data))
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_do_422(data)                         ((0x80000000&(data))>>31)
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_dic(data)                            ((0x00020000&(data))>>17)
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_qp_sel(data)                         ((0x00010000&(data))>>16)
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_qp7(data)                            ((0x00000080&(data))>>7)
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_qp6(data)                            ((0x00000040&(data))>>6)
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_qp5(data)                            ((0x00000020&(data))>>5)
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_qp4(data)                            ((0x00000010&(data))>>4)
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_qp3(data)                            ((0x00000008&(data))>>3)
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_qp2(data)                            ((0x00000004&(data))>>2)
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_qp1(data)                            ((0x00000002&(data))>>1)
#define  DI_DI_PQ_DECMP_MARK_EN_get_mark_en_qp0(data)                            (0x00000001&(data))

#define  DI_DI_PQ_DECMP_MARK_color_01                                           0x18024C98
#define  DI_DI_PQ_DECMP_MARK_color_01_reg_addr                                   "0xB8024C98"
#define  DI_DI_PQ_DECMP_MARK_color_01_reg                                        0xB8024C98
#define  DI_DI_PQ_DECMP_MARK_color_01_inst_addr                                  "0x01E5"
#define  set_DI_DI_PQ_DECMP_MARK_color_01_reg(data)                              (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_color_01_reg)=data)
#define  get_DI_DI_PQ_DECMP_MARK_color_01_reg                                    (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_color_01_reg))
#define  DI_DI_PQ_DECMP_MARK_color_01_mark_color_0_shift                         (16)
#define  DI_DI_PQ_DECMP_MARK_color_01_mark_color_1_shift                         (0)
#define  DI_DI_PQ_DECMP_MARK_color_01_mark_color_0_mask                          (0xFFFF0000)
#define  DI_DI_PQ_DECMP_MARK_color_01_mark_color_1_mask                          (0x0000FFFF)
#define  DI_DI_PQ_DECMP_MARK_color_01_mark_color_0(data)                         (0xFFFF0000&((data)<<16))
#define  DI_DI_PQ_DECMP_MARK_color_01_mark_color_1(data)                         (0x0000FFFF&(data))
#define  DI_DI_PQ_DECMP_MARK_color_01_get_mark_color_0(data)                     ((0xFFFF0000&(data))>>16)
#define  DI_DI_PQ_DECMP_MARK_color_01_get_mark_color_1(data)                     (0x0000FFFF&(data))

#define  DI_DI_PQ_DECMP_MARK_color_23                                           0x18024C9C
#define  DI_DI_PQ_DECMP_MARK_color_23_reg_addr                                   "0xB8024C9C"
#define  DI_DI_PQ_DECMP_MARK_color_23_reg                                        0xB8024C9C
#define  DI_DI_PQ_DECMP_MARK_color_23_inst_addr                                  "0x01E6"
#define  set_DI_DI_PQ_DECMP_MARK_color_23_reg(data)                              (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_color_23_reg)=data)
#define  get_DI_DI_PQ_DECMP_MARK_color_23_reg                                    (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_color_23_reg))
#define  DI_DI_PQ_DECMP_MARK_color_23_mark_color_2_shift                         (16)
#define  DI_DI_PQ_DECMP_MARK_color_23_mark_color_3_shift                         (0)
#define  DI_DI_PQ_DECMP_MARK_color_23_mark_color_2_mask                          (0xFFFF0000)
#define  DI_DI_PQ_DECMP_MARK_color_23_mark_color_3_mask                          (0x0000FFFF)
#define  DI_DI_PQ_DECMP_MARK_color_23_mark_color_2(data)                         (0xFFFF0000&((data)<<16))
#define  DI_DI_PQ_DECMP_MARK_color_23_mark_color_3(data)                         (0x0000FFFF&(data))
#define  DI_DI_PQ_DECMP_MARK_color_23_get_mark_color_2(data)                     ((0xFFFF0000&(data))>>16)
#define  DI_DI_PQ_DECMP_MARK_color_23_get_mark_color_3(data)                     (0x0000FFFF&(data))

#define  DI_DI_PQ_DECMP_MARK_color_45                                           0x18024CA0
#define  DI_DI_PQ_DECMP_MARK_color_45_reg_addr                                   "0xB8024CA0"
#define  DI_DI_PQ_DECMP_MARK_color_45_reg                                        0xB8024CA0
#define  DI_DI_PQ_DECMP_MARK_color_45_inst_addr                                  "0x01E7"
#define  set_DI_DI_PQ_DECMP_MARK_color_45_reg(data)                              (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_color_45_reg)=data)
#define  get_DI_DI_PQ_DECMP_MARK_color_45_reg                                    (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_color_45_reg))
#define  DI_DI_PQ_DECMP_MARK_color_45_mark_color_4_shift                         (16)
#define  DI_DI_PQ_DECMP_MARK_color_45_mark_color_5_shift                         (0)
#define  DI_DI_PQ_DECMP_MARK_color_45_mark_color_4_mask                          (0xFFFF0000)
#define  DI_DI_PQ_DECMP_MARK_color_45_mark_color_5_mask                          (0x0000FFFF)
#define  DI_DI_PQ_DECMP_MARK_color_45_mark_color_4(data)                         (0xFFFF0000&((data)<<16))
#define  DI_DI_PQ_DECMP_MARK_color_45_mark_color_5(data)                         (0x0000FFFF&(data))
#define  DI_DI_PQ_DECMP_MARK_color_45_get_mark_color_4(data)                     ((0xFFFF0000&(data))>>16)
#define  DI_DI_PQ_DECMP_MARK_color_45_get_mark_color_5(data)                     (0x0000FFFF&(data))

#define  DI_DI_PQ_DECMP_MARK_color_67                                           0x18024CA4
#define  DI_DI_PQ_DECMP_MARK_color_67_reg_addr                                   "0xB8024CA4"
#define  DI_DI_PQ_DECMP_MARK_color_67_reg                                        0xB8024CA4
#define  DI_DI_PQ_DECMP_MARK_color_67_inst_addr                                  "0x01E8"
#define  set_DI_DI_PQ_DECMP_MARK_color_67_reg(data)                              (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_color_67_reg)=data)
#define  get_DI_DI_PQ_DECMP_MARK_color_67_reg                                    (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_color_67_reg))
#define  DI_DI_PQ_DECMP_MARK_color_67_mark_color_6_shift                         (16)
#define  DI_DI_PQ_DECMP_MARK_color_67_mark_color_7_shift                         (0)
#define  DI_DI_PQ_DECMP_MARK_color_67_mark_color_6_mask                          (0xFFFF0000)
#define  DI_DI_PQ_DECMP_MARK_color_67_mark_color_7_mask                          (0x0000FFFF)
#define  DI_DI_PQ_DECMP_MARK_color_67_mark_color_6(data)                         (0xFFFF0000&((data)<<16))
#define  DI_DI_PQ_DECMP_MARK_color_67_mark_color_7(data)                         (0x0000FFFF&(data))
#define  DI_DI_PQ_DECMP_MARK_color_67_get_mark_color_6(data)                     ((0xFFFF0000&(data))>>16)
#define  DI_DI_PQ_DECMP_MARK_color_67_get_mark_color_7(data)                     (0x0000FFFF&(data))

#define  DI_DI_PQ_DECMP_MARK_color_422                                          0x18024CA8
#define  DI_DI_PQ_DECMP_MARK_color_422_reg_addr                                  "0xB8024CA8"
#define  DI_DI_PQ_DECMP_MARK_color_422_reg                                       0xB8024CA8
#define  DI_DI_PQ_DECMP_MARK_color_422_inst_addr                                 "0x01E9"
#define  set_DI_DI_PQ_DECMP_MARK_color_422_reg(data)                             (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_color_422_reg)=data)
#define  get_DI_DI_PQ_DECMP_MARK_color_422_reg                                   (*((volatile unsigned int*)DI_DI_PQ_DECMP_MARK_color_422_reg))
#define  DI_DI_PQ_DECMP_MARK_color_422_mark_color_dic_shift                      (16)
#define  DI_DI_PQ_DECMP_MARK_color_422_mark_color_422_shift                      (0)
#define  DI_DI_PQ_DECMP_MARK_color_422_mark_color_dic_mask                       (0xFFFF0000)
#define  DI_DI_PQ_DECMP_MARK_color_422_mark_color_422_mask                       (0x0000FFFF)
#define  DI_DI_PQ_DECMP_MARK_color_422_mark_color_dic(data)                      (0xFFFF0000&((data)<<16))
#define  DI_DI_PQ_DECMP_MARK_color_422_mark_color_422(data)                      (0x0000FFFF&(data))
#define  DI_DI_PQ_DECMP_MARK_color_422_get_mark_color_dic(data)                  ((0xFFFF0000&(data))>>16)
#define  DI_DI_PQ_DECMP_MARK_color_422_get_mark_color_422(data)                  (0x0000FFFF&(data))

#define  DI_DI_PQ_DECMP_ST                                                      0x18024CAC
#define  DI_DI_PQ_DECMP_ST_reg_addr                                              "0xB8024CAC"
#define  DI_DI_PQ_DECMP_ST_reg                                                   0xB8024CAC
#define  DI_DI_PQ_DECMP_ST_inst_addr                                             "0x01EA"
#define  set_DI_DI_PQ_DECMP_ST_reg(data)                                         (*((volatile unsigned int*)DI_DI_PQ_DECMP_ST_reg)=data)
#define  get_DI_DI_PQ_DECMP_ST_reg                                               (*((volatile unsigned int*)DI_DI_PQ_DECMP_ST_reg))
#define  DI_DI_PQ_DECMP_ST_decmp_two_pixel_mode_shift                            (31)
#define  DI_DI_PQ_DECMP_ST_decmp_crc_error_line_shift                            (16)
#define  DI_DI_PQ_DECMP_ST_decmp_package_height_cnt_shift                        (0)
#define  DI_DI_PQ_DECMP_ST_decmp_two_pixel_mode_mask                             (0x80000000)
#define  DI_DI_PQ_DECMP_ST_decmp_crc_error_line_mask                             (0x3FFF0000)
#define  DI_DI_PQ_DECMP_ST_decmp_package_height_cnt_mask                         (0x00003FFF)
#define  DI_DI_PQ_DECMP_ST_decmp_two_pixel_mode(data)                            (0x80000000&((data)<<31))
#define  DI_DI_PQ_DECMP_ST_decmp_crc_error_line(data)                            (0x3FFF0000&((data)<<16))
#define  DI_DI_PQ_DECMP_ST_decmp_package_height_cnt(data)                        (0x00003FFF&(data))
#define  DI_DI_PQ_DECMP_ST_get_decmp_two_pixel_mode(data)                        ((0x80000000&(data))>>31)
#define  DI_DI_PQ_DECMP_ST_get_decmp_crc_error_line(data)                        ((0x3FFF0000&(data))>>16)
#define  DI_DI_PQ_DECMP_ST_get_decmp_package_height_cnt(data)                    (0x00003FFF&(data))

#define  DI_DI_PQ_DECMP_CRC_EVEN_G                                              0x18024CB0
#define  DI_DI_PQ_DECMP_CRC_EVEN_G_reg_addr                                      "0xB8024CB0"
#define  DI_DI_PQ_DECMP_CRC_EVEN_G_reg                                           0xB8024CB0
#define  DI_DI_PQ_DECMP_CRC_EVEN_G_inst_addr                                     "0x01EB"
#define  set_DI_DI_PQ_DECMP_CRC_EVEN_G_reg(data)                                 (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_EVEN_G_reg)=data)
#define  get_DI_DI_PQ_DECMP_CRC_EVEN_G_reg                                       (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_EVEN_G_reg))
#define  DI_DI_PQ_DECMP_CRC_EVEN_G_decmp_crc_even_g_shift                        (0)
#define  DI_DI_PQ_DECMP_CRC_EVEN_G_decmp_crc_even_g_mask                         (0xFFFFFFFF)
#define  DI_DI_PQ_DECMP_CRC_EVEN_G_decmp_crc_even_g(data)                        (0xFFFFFFFF&(data))
#define  DI_DI_PQ_DECMP_CRC_EVEN_G_get_decmp_crc_even_g(data)                    (0xFFFFFFFF&(data))

#define  DI_DI_PQ_DECMP_CRC_EVEN_R                                              0x18024CB4
#define  DI_DI_PQ_DECMP_CRC_EVEN_R_reg_addr                                      "0xB8024CB4"
#define  DI_DI_PQ_DECMP_CRC_EVEN_R_reg                                           0xB8024CB4
#define  DI_DI_PQ_DECMP_CRC_EVEN_R_inst_addr                                     "0x01EC"
#define  set_DI_DI_PQ_DECMP_CRC_EVEN_R_reg(data)                                 (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_EVEN_R_reg)=data)
#define  get_DI_DI_PQ_DECMP_CRC_EVEN_R_reg                                       (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_EVEN_R_reg))
#define  DI_DI_PQ_DECMP_CRC_EVEN_R_decmp_crc_even_r_shift                        (0)
#define  DI_DI_PQ_DECMP_CRC_EVEN_R_decmp_crc_even_r_mask                         (0xFFFFFFFF)
#define  DI_DI_PQ_DECMP_CRC_EVEN_R_decmp_crc_even_r(data)                        (0xFFFFFFFF&(data))
#define  DI_DI_PQ_DECMP_CRC_EVEN_R_get_decmp_crc_even_r(data)                    (0xFFFFFFFF&(data))

#define  DI_DI_PQ_DECMP_CRC_EVEN_B                                              0x18024CB8
#define  DI_DI_PQ_DECMP_CRC_EVEN_B_reg_addr                                      "0xB8024CB8"
#define  DI_DI_PQ_DECMP_CRC_EVEN_B_reg                                           0xB8024CB8
#define  DI_DI_PQ_DECMP_CRC_EVEN_B_inst_addr                                     "0x01ED"
#define  set_DI_DI_PQ_DECMP_CRC_EVEN_B_reg(data)                                 (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_EVEN_B_reg)=data)
#define  get_DI_DI_PQ_DECMP_CRC_EVEN_B_reg                                       (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_EVEN_B_reg))
#define  DI_DI_PQ_DECMP_CRC_EVEN_B_decmp_crc_even_b_shift                        (0)
#define  DI_DI_PQ_DECMP_CRC_EVEN_B_decmp_crc_even_b_mask                         (0xFFFFFFFF)
#define  DI_DI_PQ_DECMP_CRC_EVEN_B_decmp_crc_even_b(data)                        (0xFFFFFFFF&(data))
#define  DI_DI_PQ_DECMP_CRC_EVEN_B_get_decmp_crc_even_b(data)                    (0xFFFFFFFF&(data))

#define  DI_DI_PQ_DECMP_CRC_ODD_G                                               0x18024CBC
#define  DI_DI_PQ_DECMP_CRC_ODD_G_reg_addr                                       "0xB8024CBC"
#define  DI_DI_PQ_DECMP_CRC_ODD_G_reg                                            0xB8024CBC
#define  DI_DI_PQ_DECMP_CRC_ODD_G_inst_addr                                      "0x01EE"
#define  set_DI_DI_PQ_DECMP_CRC_ODD_G_reg(data)                                  (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_ODD_G_reg)=data)
#define  get_DI_DI_PQ_DECMP_CRC_ODD_G_reg                                        (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_ODD_G_reg))
#define  DI_DI_PQ_DECMP_CRC_ODD_G_decmp_crc_odd_g_shift                          (0)
#define  DI_DI_PQ_DECMP_CRC_ODD_G_decmp_crc_odd_g_mask                           (0xFFFFFFFF)
#define  DI_DI_PQ_DECMP_CRC_ODD_G_decmp_crc_odd_g(data)                          (0xFFFFFFFF&(data))
#define  DI_DI_PQ_DECMP_CRC_ODD_G_get_decmp_crc_odd_g(data)                      (0xFFFFFFFF&(data))

#define  DI_DI_PQ_DECMP_CRC_ODD_R                                               0x18024CC0
#define  DI_DI_PQ_DECMP_CRC_ODD_R_reg_addr                                       "0xB8024CC0"
#define  DI_DI_PQ_DECMP_CRC_ODD_R_reg                                            0xB8024CC0
#define  DI_DI_PQ_DECMP_CRC_ODD_R_inst_addr                                      "0x01EF"
#define  set_DI_DI_PQ_DECMP_CRC_ODD_R_reg(data)                                  (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_ODD_R_reg)=data)
#define  get_DI_DI_PQ_DECMP_CRC_ODD_R_reg                                        (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_ODD_R_reg))
#define  DI_DI_PQ_DECMP_CRC_ODD_R_decmp_crc_odd_r_shift                          (0)
#define  DI_DI_PQ_DECMP_CRC_ODD_R_decmp_crc_odd_r_mask                           (0xFFFFFFFF)
#define  DI_DI_PQ_DECMP_CRC_ODD_R_decmp_crc_odd_r(data)                          (0xFFFFFFFF&(data))
#define  DI_DI_PQ_DECMP_CRC_ODD_R_get_decmp_crc_odd_r(data)                      (0xFFFFFFFF&(data))

#define  DI_DI_PQ_DECMP_CRC_ODD_B                                               0x18024CC4
#define  DI_DI_PQ_DECMP_CRC_ODD_B_reg_addr                                       "0xB8024CC4"
#define  DI_DI_PQ_DECMP_CRC_ODD_B_reg                                            0xB8024CC4
#define  DI_DI_PQ_DECMP_CRC_ODD_B_inst_addr                                      "0x01F0"
#define  set_DI_DI_PQ_DECMP_CRC_ODD_B_reg(data)                                  (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_ODD_B_reg)=data)
#define  get_DI_DI_PQ_DECMP_CRC_ODD_B_reg                                        (*((volatile unsigned int*)DI_DI_PQ_DECMP_CRC_ODD_B_reg))
#define  DI_DI_PQ_DECMP_CRC_ODD_B_decmp_crc_odd_b_shift                          (0)
#define  DI_DI_PQ_DECMP_CRC_ODD_B_decmp_crc_odd_b_mask                           (0xFFFFFFFF)
#define  DI_DI_PQ_DECMP_CRC_ODD_B_decmp_crc_odd_b(data)                          (0xFFFFFFFF&(data))
#define  DI_DI_PQ_DECMP_CRC_ODD_B_get_decmp_crc_odd_b(data)                      (0xFFFFFFFF&(data))

#define  DI_DI_PQ_DECMP_PAUSE_CYCLE                                             0x18024CD0
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_reg_addr                                     "0xB8024CD0"
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_reg                                          0xB8024CD0
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_inst_addr                                    "0x01F1"
#define  set_DI_DI_PQ_DECMP_PAUSE_CYCLE_reg(data)                                (*((volatile unsigned int*)DI_DI_PQ_DECMP_PAUSE_CYCLE_reg)=data)
#define  get_DI_DI_PQ_DECMP_PAUSE_CYCLE_reg                                      (*((volatile unsigned int*)DI_DI_PQ_DECMP_PAUSE_CYCLE_reg))
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_decmp_pause_cycle_measure_en_shift           (31)
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_decmp_pause_cycle_long_term_shift            (30)
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_decmp_pause_cycle_shift                      (0)
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_decmp_pause_cycle_measure_en_mask            (0x80000000)
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_decmp_pause_cycle_long_term_mask             (0x40000000)
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_decmp_pause_cycle_mask                       (0x000000FF)
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_decmp_pause_cycle_measure_en(data)           (0x80000000&((data)<<31))
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_decmp_pause_cycle_long_term(data)            (0x40000000&((data)<<30))
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_decmp_pause_cycle(data)                      (0x000000FF&(data))
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_get_decmp_pause_cycle_measure_en(data)       ((0x80000000&(data))>>31)
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_get_decmp_pause_cycle_long_term(data)        ((0x40000000&(data))>>30)
#define  DI_DI_PQ_DECMP_PAUSE_CYCLE_get_decmp_pause_cycle(data)                  (0x000000FF&(data))

#define  DI_DI_FILM_TEETHSHAKE                                                  0x18024CD4
#define  DI_DI_FILM_TEETHSHAKE_reg_addr                                          "0xB8024CD4"
#define  DI_DI_FILM_TEETHSHAKE_reg                                               0xB8024CD4
#define  DI_DI_FILM_TEETHSHAKE_inst_addr                                         "0x01F2"
#define  set_DI_DI_FILM_TEETHSHAKE_reg(data)                                     (*((volatile unsigned int*)DI_DI_FILM_TEETHSHAKE_reg)=data)
#define  get_DI_DI_FILM_TEETHSHAKE_reg                                           (*((volatile unsigned int*)DI_DI_FILM_TEETHSHAKE_reg))
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethth_teeth_both_en_shift               (31)
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethth_timing_shift                      (30)
#define  DI_DI_FILM_TEETHSHAKE_di_film_bothdiff_shift_shift                      (23)
#define  DI_DI_FILM_TEETHSHAKE_di_film_bothdiff_weight_shift                     (17)
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethshake_diff_lb_shift                  (9)
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethshake_same_ub_shift                  (1)
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethshake_en_shift                       (0)
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethth_teeth_both_en_mask                (0x80000000)
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethth_timing_mask                       (0x40000000)
#define  DI_DI_FILM_TEETHSHAKE_di_film_bothdiff_shift_mask                       (0x01800000)
#define  DI_DI_FILM_TEETHSHAKE_di_film_bothdiff_weight_mask                      (0x007E0000)
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethshake_diff_lb_mask                   (0x0001FE00)
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethshake_same_ub_mask                   (0x000001FE)
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethshake_en_mask                        (0x00000001)
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethth_teeth_both_en(data)               (0x80000000&((data)<<31))
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethth_timing(data)                      (0x40000000&((data)<<30))
#define  DI_DI_FILM_TEETHSHAKE_di_film_bothdiff_shift(data)                      (0x01800000&((data)<<23))
#define  DI_DI_FILM_TEETHSHAKE_di_film_bothdiff_weight(data)                     (0x007E0000&((data)<<17))
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethshake_diff_lb(data)                  (0x0001FE00&((data)<<9))
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethshake_same_ub(data)                  (0x000001FE&((data)<<1))
#define  DI_DI_FILM_TEETHSHAKE_di_film_teethshake_en(data)                       (0x00000001&(data))
#define  DI_DI_FILM_TEETHSHAKE_get_di_film_teethth_teeth_both_en(data)           ((0x80000000&(data))>>31)
#define  DI_DI_FILM_TEETHSHAKE_get_di_film_teethth_timing(data)                  ((0x40000000&(data))>>30)
#define  DI_DI_FILM_TEETHSHAKE_get_di_film_bothdiff_shift(data)                  ((0x01800000&(data))>>23)
#define  DI_DI_FILM_TEETHSHAKE_get_di_film_bothdiff_weight(data)                 ((0x007E0000&(data))>>17)
#define  DI_DI_FILM_TEETHSHAKE_get_di_film_teethshake_diff_lb(data)              ((0x0001FE00&(data))>>9)
#define  DI_DI_FILM_TEETHSHAKE_get_di_film_teethshake_same_ub(data)              ((0x000001FE&(data))>>1)
#define  DI_DI_FILM_TEETHSHAKE_get_di_film_teethshake_en(data)                   (0x00000001&(data))

#define  DI_DI_FILM_NEW_FUNCTION                                                0x18024CD8
#define  DI_DI_FILM_NEW_FUNCTION_reg_addr                                        "0xB8024CD8"
#define  DI_DI_FILM_NEW_FUNCTION_reg                                             0xB8024CD8
#define  DI_DI_FILM_NEW_FUNCTION_inst_addr                                       "0x01F3"
#define  set_DI_DI_FILM_NEW_FUNCTION_reg(data)                                   (*((volatile unsigned int*)DI_DI_FILM_NEW_FUNCTION_reg)=data)
#define  get_DI_DI_FILM_NEW_FUNCTION_reg                                         (*((volatile unsigned int*)DI_DI_FILM_NEW_FUNCTION_reg))
#define  DI_DI_FILM_NEW_FUNCTION_di_film_teethth_moving_single_side_shift        (29)
#define  DI_DI_FILM_NEW_FUNCTION_di_film_framestaticonly_shift                   (28)
#define  DI_DI_FILM_NEW_FUNCTION_di_film_teethth_prog_ub_shift                   (20)
#define  DI_DI_FILM_NEW_FUNCTION_di_film_statusbothdiffsum_159_140_shift         (0)
#define  DI_DI_FILM_NEW_FUNCTION_di_film_teethth_moving_single_side_mask         (0x20000000)
#define  DI_DI_FILM_NEW_FUNCTION_di_film_framestaticonly_mask                    (0x10000000)
#define  DI_DI_FILM_NEW_FUNCTION_di_film_teethth_prog_ub_mask                    (0x0FF00000)
#define  DI_DI_FILM_NEW_FUNCTION_di_film_statusbothdiffsum_159_140_mask          (0x000FFFFF)
#define  DI_DI_FILM_NEW_FUNCTION_di_film_teethth_moving_single_side(data)        (0x20000000&((data)<<29))
#define  DI_DI_FILM_NEW_FUNCTION_di_film_framestaticonly(data)                   (0x10000000&((data)<<28))
#define  DI_DI_FILM_NEW_FUNCTION_di_film_teethth_prog_ub(data)                   (0x0FF00000&((data)<<20))
#define  DI_DI_FILM_NEW_FUNCTION_di_film_statusbothdiffsum_159_140(data)         (0x000FFFFF&(data))
#define  DI_DI_FILM_NEW_FUNCTION_get_di_film_teethth_moving_single_side(data)    ((0x20000000&(data))>>29)
#define  DI_DI_FILM_NEW_FUNCTION_get_di_film_framestaticonly(data)               ((0x10000000&(data))>>28)
#define  DI_DI_FILM_NEW_FUNCTION_get_di_film_teethth_prog_ub(data)               ((0x0FF00000&(data))>>20)
#define  DI_DI_FILM_NEW_FUNCTION_get_di_film_statusbothdiffsum_159_140(data)     (0x000FFFFF&(data))

#define  DI_DI_FILM_BOTHDIFF_CTRL                                               0x18024CDC
#define  DI_DI_FILM_BOTHDIFF_CTRL_reg_addr                                       "0xB8024CDC"
#define  DI_DI_FILM_BOTHDIFF_CTRL_reg                                            0xB8024CDC
#define  DI_DI_FILM_BOTHDIFF_CTRL_inst_addr                                      "0x01F4"
#define  set_DI_DI_FILM_BOTHDIFF_CTRL_reg(data)                                  (*((volatile unsigned int*)DI_DI_FILM_BOTHDIFF_CTRL_reg)=data)
#define  get_DI_DI_FILM_BOTHDIFF_CTRL_reg                                        (*((volatile unsigned int*)DI_DI_FILM_BOTHDIFF_CTRL_reg))
#define  DI_DI_FILM_BOTHDIFF_CTRL_di_film_hbcounter_method_shift                 (31)
#define  DI_DI_FILM_BOTHDIFF_CTRL_di_film_bothdiff_range_shift                   (29)
#define  DI_DI_FILM_BOTHDIFF_CTRL_di_film_statusbothdiffsum_139_120_shift        (0)
#define  DI_DI_FILM_BOTHDIFF_CTRL_di_film_hbcounter_method_mask                  (0x80000000)
#define  DI_DI_FILM_BOTHDIFF_CTRL_di_film_bothdiff_range_mask                    (0x60000000)
#define  DI_DI_FILM_BOTHDIFF_CTRL_di_film_statusbothdiffsum_139_120_mask         (0x000FFFFF)
#define  DI_DI_FILM_BOTHDIFF_CTRL_di_film_hbcounter_method(data)                 (0x80000000&((data)<<31))
#define  DI_DI_FILM_BOTHDIFF_CTRL_di_film_bothdiff_range(data)                   (0x60000000&((data)<<29))
#define  DI_DI_FILM_BOTHDIFF_CTRL_di_film_statusbothdiffsum_139_120(data)        (0x000FFFFF&(data))
#define  DI_DI_FILM_BOTHDIFF_CTRL_get_di_film_hbcounter_method(data)             ((0x80000000&(data))>>31)
#define  DI_DI_FILM_BOTHDIFF_CTRL_get_di_film_bothdiff_range(data)               ((0x60000000&(data))>>29)
#define  DI_DI_FILM_BOTHDIFF_CTRL_get_di_film_statusbothdiffsum_139_120(data)    (0x000FFFFF&(data))

#define  DI_DI_FILM_HSIZE_CTRL                                                  0x18024CE0
#define  DI_DI_FILM_HSIZE_CTRL_reg_addr                                          "0xB8024CE0"
#define  DI_DI_FILM_HSIZE_CTRL_reg                                               0xB8024CE0
#define  DI_DI_FILM_HSIZE_CTRL_inst_addr                                         "0x01F5"
#define  set_DI_DI_FILM_HSIZE_CTRL_reg(data)                                     (*((volatile unsigned int*)DI_DI_FILM_HSIZE_CTRL_reg)=data)
#define  get_DI_DI_FILM_HSIZE_CTRL_reg                                           (*((volatile unsigned int*)DI_DI_FILM_HSIZE_CTRL_reg))
#define  DI_DI_FILM_HSIZE_CTRL_di_film_xpos_3by4_shift                           (25)
#define  DI_DI_FILM_HSIZE_CTRL_di_film_xpos_1by4_shift                           (20)
#define  DI_DI_FILM_HSIZE_CTRL_di_film_statusbothdiffsum_119_100_shift           (0)
#define  DI_DI_FILM_HSIZE_CTRL_di_film_xpos_3by4_mask                            (0x3E000000)
#define  DI_DI_FILM_HSIZE_CTRL_di_film_xpos_1by4_mask                            (0x01F00000)
#define  DI_DI_FILM_HSIZE_CTRL_di_film_statusbothdiffsum_119_100_mask            (0x000FFFFF)
#define  DI_DI_FILM_HSIZE_CTRL_di_film_xpos_3by4(data)                           (0x3E000000&((data)<<25))
#define  DI_DI_FILM_HSIZE_CTRL_di_film_xpos_1by4(data)                           (0x01F00000&((data)<<20))
#define  DI_DI_FILM_HSIZE_CTRL_di_film_statusbothdiffsum_119_100(data)           (0x000FFFFF&(data))
#define  DI_DI_FILM_HSIZE_CTRL_get_di_film_xpos_3by4(data)                       ((0x3E000000&(data))>>25)
#define  DI_DI_FILM_HSIZE_CTRL_get_di_film_xpos_1by4(data)                       ((0x01F00000&(data))>>20)
#define  DI_DI_FILM_HSIZE_CTRL_get_di_film_statusbothdiffsum_119_100(data)       (0x000FFFFF&(data))

#define  DI_DI_FILM_VSIZE_CTRL                                                  0x18024CE4
#define  DI_DI_FILM_VSIZE_CTRL_reg_addr                                          "0xB8024CE4"
#define  DI_DI_FILM_VSIZE_CTRL_reg                                               0xB8024CE4
#define  DI_DI_FILM_VSIZE_CTRL_inst_addr                                         "0x01F6"
#define  set_DI_DI_FILM_VSIZE_CTRL_reg(data)                                     (*((volatile unsigned int*)DI_DI_FILM_VSIZE_CTRL_reg)=data)
#define  get_DI_DI_FILM_VSIZE_CTRL_reg                                           (*((volatile unsigned int*)DI_DI_FILM_VSIZE_CTRL_reg))
#define  DI_DI_FILM_VSIZE_CTRL_di_film_ypos_3by4_shift                           (25)
#define  DI_DI_FILM_VSIZE_CTRL_di_film_ypos_1by4_shift                           (20)
#define  DI_DI_FILM_VSIZE_CTRL_di_film_statusbothdiffsum_99_80_shift             (0)
#define  DI_DI_FILM_VSIZE_CTRL_di_film_ypos_3by4_mask                            (0x3E000000)
#define  DI_DI_FILM_VSIZE_CTRL_di_film_ypos_1by4_mask                            (0x01F00000)
#define  DI_DI_FILM_VSIZE_CTRL_di_film_statusbothdiffsum_99_80_mask              (0x000FFFFF)
#define  DI_DI_FILM_VSIZE_CTRL_di_film_ypos_3by4(data)                           (0x3E000000&((data)<<25))
#define  DI_DI_FILM_VSIZE_CTRL_di_film_ypos_1by4(data)                           (0x01F00000&((data)<<20))
#define  DI_DI_FILM_VSIZE_CTRL_di_film_statusbothdiffsum_99_80(data)             (0x000FFFFF&(data))
#define  DI_DI_FILM_VSIZE_CTRL_get_di_film_ypos_3by4(data)                       ((0x3E000000&(data))>>25)
#define  DI_DI_FILM_VSIZE_CTRL_get_di_film_ypos_1by4(data)                       ((0x01F00000&(data))>>20)
#define  DI_DI_FILM_VSIZE_CTRL_get_di_film_statusbothdiffsum_99_80(data)         (0x000FFFFF&(data))

#define  DI_DI_FILM_NONFILMREGION_EXTEND                                        0x18024CE8
#define  DI_DI_FILM_NONFILMREGION_EXTEND_reg_addr                                "0xB8024CE8"
#define  DI_DI_FILM_NONFILMREGION_EXTEND_reg                                     0xB8024CE8
#define  DI_DI_FILM_NONFILMREGION_EXTEND_inst_addr                               "0x01F7"
#define  set_DI_DI_FILM_NONFILMREGION_EXTEND_reg(data)                           (*((volatile unsigned int*)DI_DI_FILM_NONFILMREGION_EXTEND_reg)=data)
#define  get_DI_DI_FILM_NONFILMREGION_EXTEND_reg                                 (*((volatile unsigned int*)DI_DI_FILM_NONFILMREGION_EXTEND_reg))
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_nonfilmregion_force_shift       (28)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_nonfilmregion_up_extend_shift   (24)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_nonfilmregion_dn_extend_shift   (20)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_statusbothdiffsum_79_60_shift   (0)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_nonfilmregion_force_mask        (0x10000000)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_nonfilmregion_up_extend_mask    (0x0F000000)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_nonfilmregion_dn_extend_mask    (0x00F00000)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_statusbothdiffsum_79_60_mask    (0x000FFFFF)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_nonfilmregion_force(data)       (0x10000000&((data)<<28))
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_nonfilmregion_up_extend(data)   (0x0F000000&((data)<<24))
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_nonfilmregion_dn_extend(data)   (0x00F00000&((data)<<20))
#define  DI_DI_FILM_NONFILMREGION_EXTEND_di_film_statusbothdiffsum_79_60(data)   (0x000FFFFF&(data))
#define  DI_DI_FILM_NONFILMREGION_EXTEND_get_di_film_nonfilmregion_force(data)   ((0x10000000&(data))>>28)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_get_di_film_nonfilmregion_up_extend(data) ((0x0F000000&(data))>>24)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_get_di_film_nonfilmregion_dn_extend(data) ((0x00F00000&(data))>>20)
#define  DI_DI_FILM_NONFILMREGION_EXTEND_get_di_film_statusbothdiffsum_79_60(data) (0x000FFFFF&(data))

#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE                                      0x18024CEC
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_reg_addr                              "0xB8024CEC"
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_reg                                   0xB8024CEC
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_inst_addr                             "0x01F8"
#define  set_DI_DI_FILM_NONFILMREGION_DEBOUNCE_reg(data)                         (*((volatile unsigned int*)DI_DI_FILM_NONFILMREGION_DEBOUNCE_reg)=data)
#define  get_DI_DI_FILM_NONFILMREGION_DEBOUNCE_reg                               (*((volatile unsigned int*)DI_DI_FILM_NONFILMREGION_DEBOUNCE_reg))
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_di_film_nonfilmregion_up_debounce_shift (24)
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_di_film_nonfilmregion_dn_debounce_shift (20)
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_di_film_statusbothdiffsum_59_40_shift (0)
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_di_film_nonfilmregion_up_debounce_mask (0x0F000000)
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_di_film_nonfilmregion_dn_debounce_mask (0x00F00000)
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_di_film_statusbothdiffsum_59_40_mask  (0x000FFFFF)
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_di_film_nonfilmregion_up_debounce(data) (0x0F000000&((data)<<24))
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_di_film_nonfilmregion_dn_debounce(data) (0x00F00000&((data)<<20))
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_di_film_statusbothdiffsum_59_40(data) (0x000FFFFF&(data))
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_get_di_film_nonfilmregion_up_debounce(data) ((0x0F000000&(data))>>24)
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_get_di_film_nonfilmregion_dn_debounce(data) ((0x00F00000&(data))>>20)
#define  DI_DI_FILM_NONFILMREGION_DEBOUNCE_get_di_film_statusbothdiffsum_59_40(data) (0x000FFFFF&(data))

#define  DI_DI_FILM_NONFILMREGION_1                                             0x18024CF0
#define  DI_DI_FILM_NONFILMREGION_1_reg_addr                                     "0xB8024CF0"
#define  DI_DI_FILM_NONFILMREGION_1_reg                                          0xB8024CF0
#define  DI_DI_FILM_NONFILMREGION_1_inst_addr                                    "0x01F9"
#define  set_DI_DI_FILM_NONFILMREGION_1_reg(data)                                (*((volatile unsigned int*)DI_DI_FILM_NONFILMREGION_1_reg)=data)
#define  get_DI_DI_FILM_NONFILMREGION_1_reg                                      (*((volatile unsigned int*)DI_DI_FILM_NONFILMREGION_1_reg))
#define  DI_DI_FILM_NONFILMREGION_1_di_film_nonfilmregion_s_big_shift            (26)
#define  DI_DI_FILM_NONFILMREGION_1_di_film_nonfilmregion_s_small_shift          (20)
#define  DI_DI_FILM_NONFILMREGION_1_di_film_statusbothdiffsum_39_20_shift        (0)
#define  DI_DI_FILM_NONFILMREGION_1_di_film_nonfilmregion_s_big_mask             (0xFC000000)
#define  DI_DI_FILM_NONFILMREGION_1_di_film_nonfilmregion_s_small_mask           (0x03F00000)
#define  DI_DI_FILM_NONFILMREGION_1_di_film_statusbothdiffsum_39_20_mask         (0x000FFFFF)
#define  DI_DI_FILM_NONFILMREGION_1_di_film_nonfilmregion_s_big(data)            (0xFC000000&((data)<<26))
#define  DI_DI_FILM_NONFILMREGION_1_di_film_nonfilmregion_s_small(data)          (0x03F00000&((data)<<20))
#define  DI_DI_FILM_NONFILMREGION_1_di_film_statusbothdiffsum_39_20(data)        (0x000FFFFF&(data))
#define  DI_DI_FILM_NONFILMREGION_1_get_di_film_nonfilmregion_s_big(data)        ((0xFC000000&(data))>>26)
#define  DI_DI_FILM_NONFILMREGION_1_get_di_film_nonfilmregion_s_small(data)      ((0x03F00000&(data))>>20)
#define  DI_DI_FILM_NONFILMREGION_1_get_di_film_statusbothdiffsum_39_20(data)    (0x000FFFFF&(data))

#define  DI_DI_FILM_NONFILMREGION_2                                             0x18024CF4
#define  DI_DI_FILM_NONFILMREGION_2_reg_addr                                     "0xB8024CF4"
#define  DI_DI_FILM_NONFILMREGION_2_reg                                          0xB8024CF4
#define  DI_DI_FILM_NONFILMREGION_2_inst_addr                                    "0x01FA"
#define  set_DI_DI_FILM_NONFILMREGION_2_reg(data)                                (*((volatile unsigned int*)DI_DI_FILM_NONFILMREGION_2_reg)=data)
#define  get_DI_DI_FILM_NONFILMREGION_2_reg                                      (*((volatile unsigned int*)DI_DI_FILM_NONFILMREGION_2_reg))
#define  DI_DI_FILM_NONFILMREGION_2_di_film_nonfilmregion_th_shift               (26)
#define  DI_DI_FILM_NONFILMREGION_2_di_film_nonfilmregion_s_both_shift           (20)
#define  DI_DI_FILM_NONFILMREGION_2_di_film_statusbothdiffsum_19_0_shift         (0)
#define  DI_DI_FILM_NONFILMREGION_2_di_film_nonfilmregion_th_mask                (0xFC000000)
#define  DI_DI_FILM_NONFILMREGION_2_di_film_nonfilmregion_s_both_mask            (0x03F00000)
#define  DI_DI_FILM_NONFILMREGION_2_di_film_statusbothdiffsum_19_0_mask          (0x000FFFFF)
#define  DI_DI_FILM_NONFILMREGION_2_di_film_nonfilmregion_th(data)               (0xFC000000&((data)<<26))
#define  DI_DI_FILM_NONFILMREGION_2_di_film_nonfilmregion_s_both(data)           (0x03F00000&((data)<<20))
#define  DI_DI_FILM_NONFILMREGION_2_di_film_statusbothdiffsum_19_0(data)         (0x000FFFFF&(data))
#define  DI_DI_FILM_NONFILMREGION_2_get_di_film_nonfilmregion_th(data)           ((0xFC000000&(data))>>26)
#define  DI_DI_FILM_NONFILMREGION_2_get_di_film_nonfilmregion_s_both(data)       ((0x03F00000&(data))>>20)
#define  DI_DI_FILM_NONFILMREGION_2_get_di_film_statusbothdiffsum_19_0(data)     (0x000FFFFF&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======DI register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ma_smoothintra90:1;
        RBus_UInt32  ma_onedirectionweaveen:1;
        RBus_UInt32  ccdinr_h_flip_en:1;
        RBus_UInt32  cp_tresultweight:3;
        RBus_UInt32  write_enable_8:1;
        RBus_UInt32  ip_enable:1;
        RBus_UInt32  write_enable_7:1;
        RBus_UInt32  di444to422lowpass:1;
        RBus_UInt32  write_enable_6:1;
        RBus_UInt32  cp_temporalenable:1;
        RBus_UInt32  write_enable_5:1;
        RBus_UInt32  film_enable:5;
        RBus_UInt32  write_enable_4:1;
        RBus_UInt32  ma_horicomen:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  write_enable_2:1;
        RBus_UInt32  ma_messintra90:1;
        RBus_UInt32  write_enable_1:1;
        RBus_UInt32  ma_3aenable:1;
        RBus_UInt32  write_enable_0:1;
        RBus_UInt32  ma_controlmode:2;
    };
}di_im_di_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fun_y_en:1;
        RBus_UInt32  y10bitsin:1;
        RBus_UInt32  c10bitsin:1;
        RBus_UInt32  game_mode_3a:1;
        RBus_UInt32  res1:10;
        RBus_UInt32  cr_fh_switch:1;
        RBus_UInt32  cr_autoimg_enable:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  di_r_drop_odd_line:1;
        RBus_UInt32  di_l_drop_odd_line:1;
        RBus_UInt32  res3:8;
        RBus_UInt32  dma_force_4buf:1;
        RBus_UInt32  framemotion_pxs_sel:1;
        RBus_UInt32  di_clock_gating_disable:1;
        RBus_UInt32  res4:2;
    };
}di_color_recovery_option_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_confuse:1;
        RBus_UInt32  di_3d_l_flag:1;
        RBus_UInt32  field_confuse_i2rnd:1;
        RBus_UInt32  readstart:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  unfreeze_polarity:1;
        RBus_UInt32  auto_frz_num:3;
        RBus_UInt32  auto_freeze:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  film_debugmode:1;
        RBus_UInt32  ma_debugmode:3;
        RBus_UInt32  ma_modeselect:1;
        RBus_UInt32  cp_tnrdebugmode:1;
    };
}di_im_di_debug_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  singlefieldintra:1;
        RBus_UInt32  hsize:11;
        RBus_UInt32  vsize:10;
        RBus_UInt32  hblksize:10;
    };
}di_im_di_active_window_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fixedwindowmode:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  nxt_rpt_flag_disable:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  hsize_msb:2;
        RBus_UInt32  vsize_msb:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  hblksize_msb:1;
        RBus_UInt32  freeze:1;
        RBus_UInt32  force2d:1;
        RBus_UInt32  force2d_i2rnd:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  field_confuse_error:4;
        RBus_UInt32  field_confuse_i2rnd_error:4;
        RBus_UInt32  delpixelen:1;
        RBus_UInt32  dellineen:1;
        RBus_UInt32  fixedwindow5:1;
        RBus_UInt32  fixedwindow4:1;
        RBus_UInt32  fixedwindow3:1;
        RBus_UInt32  fixedwindow2:1;
        RBus_UInt32  fixedwindow1:1;
        RBus_UInt32  fixedwindow0:1;
    };
}di_im_di_weave_window_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_12_0:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xstart_12_0:13;
    };
}di_im_di_weave_window_0_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_12_0:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xend_12_0:13;
    };
}di_im_di_weave_window_0_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_25_13:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xstart_25_13:13;
    };
}di_im_di_weave_window_1_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_25_13:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xend_25_13:13;
    };
}di_im_di_weave_window_1_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_38_26:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xstart_38_26:13;
    };
}di_im_di_weave_window_2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_38_26:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xend_38_26:13;
    };
}di_im_di_weave_window_2_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_51_39:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xstart_51_39:13;
    };
}di_im_di_weave_window_3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_51_39:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xend_51_39:13;
    };
}di_im_di_weave_window_3_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_64_52:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xstart_64_52:13;
    };
}di_im_di_weave_window_4_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_64_52:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xend_64_52:13;
    };
}di_im_di_weave_window_4_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_77_65:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xstart_77_65:13;
    };
}di_im_di_weave_window_5_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_77_65:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  xend_77_65:13;
    };
}di_im_di_weave_window_5_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  pseudo_memc_film22_sequence:2;
        RBus_UInt32  res2:4;
        RBus_UInt32  res3:3;
        RBus_UInt32  ma_class_h_th1_cmp:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  ma_class_h_th1:5;
        RBus_UInt32  res5:3;
        RBus_UInt32  ma_class_h_th2:5;
    };
}di_im_di_classify_thclassify_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  ma_blend_fmcomb3:2;
        RBus_UInt32  ma_blend_fmcomb2:2;
        RBus_UInt32  ma_blend_fmcomb1_hor:2;
        RBus_UInt32  ma_blend_fmcomb1:2;
        RBus_UInt32  ma_blend_fmcomb0:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  ma_blend10_weight:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  ma_blend01_weight:3;
    };
}di_im_di_blend_and_weighting_method_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802404c_31:1;
        RBus_UInt32  ma_sobelthm:10;
        RBus_UInt32  ma_sobelths:10;
        RBus_UInt32  force_2d_timing_en:1;
        RBus_UInt32  force_2d_timing_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  vodma_film_en:1;
        RBus_UInt32  dummy1802404c_6_3:4;
        RBus_UInt32  force_di_nxt:1;
        RBus_UInt32  force_dma_intra:1;
        RBus_UInt32  force_dma_2d:1;
    };
}di_im_di_mpeg_sequence_app_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_vedge_nolp_en:3;
        RBus_UInt32  ma_class_s_th2:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  ma_class_rlv_th1_cmp:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  ma_class_rlv_th1:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  ma_class_rlv_th2:5;
    };
}di_im_di_classify2_thclassify_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_new_class_en:1;
        RBus_UInt32  res1:25;
        RBus_UInt32  ma_vedge_add_rlv:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  ma_vedge_nonlpfm_en:1;
        RBus_UInt32  ma_vedge_force90_en:1;
        RBus_UInt32  ma_vedge_force_intra_en:1;
    };
}di_im_di_new_class_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_420_en:2;
        RBus_UInt32  rdma_random_en:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  linesize_even:11;
        RBus_UInt32  res2:1;
        RBus_UInt32  linesize_odd:11;
    };
}di_im_di_dma_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_var4thl:8;
        RBus_UInt32  cr_var3thl:8;
        RBus_UInt32  cr_var2thl:8;
        RBus_UInt32  cr_var1thl:8;
    };
}di_im_di_xc_auto_balance_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bcclowpassyenablecontrol:1;
        RBus_UInt32  autoimg_lpf_enable:1;
        RBus_UInt32  autoimg_debug_enable:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  cr_transitionthl:8;
        RBus_UInt32  cr_meanthl:8;
    };
}di_im_di_xc_auto_balance_th2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cr_thl_mainbalance:8;
        RBus_UInt32  cr_thl_subbalance:16;
    };
}di_im_di_xc_auto_balance_th3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_intra_line_cont_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  ma_follow_new_intra_en:1;
        RBus_UInt32  intra_ma_mess_enable:1;
        RBus_UInt32  res2:24;
    };
}di_im_di_intra_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_framemtha:8;
        RBus_UInt32  ma_framehtha:8;
        RBus_UInt32  ma_framerlvtha:8;
        RBus_UInt32  ma_framestha:8;
    };
}di_im_di_ma_frame_motion_th_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_framemthb:8;
        RBus_UInt32  ma_framehthb:8;
        RBus_UInt32  ma_framerlvthb:8;
        RBus_UInt32  ma_framesthb:8;
    };
}di_im_di_ma_frame_motion_th_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_framemthc:8;
        RBus_UInt32  ma_framehthc:8;
        RBus_UInt32  ma_framerlvthc:8;
        RBus_UInt32  ma_framesthc:8;
    };
}di_im_di_ma_frame_motion_th_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_fieldteethstha:8;
        RBus_UInt32  ma_fieldteethmtha:8;
        RBus_UInt32  ma_fieldteethhtha:8;
        RBus_UInt32  ma_fieldteethrlvtha:8;
    };
}di_im_di_ma_field_teeth_th_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_horicomth:8;
        RBus_UInt32  res1:8;
        RBus_UInt32  ma_ydiffth:8;
        RBus_UInt32  ma_fieldteeththb:8;
    };
}di_im_di_ma_others_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_sawtoothmth:8;
        RBus_UInt32  ma_sawtoothhth:8;
        RBus_UInt32  ma_sawtoothrlvth:8;
        RBus_UInt32  ma_sawtoothsth:8;
    };
}di_im_di_ma_sawtooth_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_teethth_en:2;
        RBus_UInt32  film_teethth_ratio:6;
        RBus_UInt32  film_teethth_prog_lb:8;
        RBus_UInt32  film_teethth_moving_lb:8;
        RBus_UInt32  film_teethth_teeth_lb:8;
    };
}di_im_di_film_teeth_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  forfw_1:32;
    };
}di_im_di_ma_vertext_th_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_leavequick_en:1;
        RBus_UInt32  film_verscrollingtext_en:1;
        RBus_UInt32  film_thumbnail_en:1;
        RBus_UInt32  film_pair1_en:1;
        RBus_UInt32  film_pair2_en:1;
        RBus_UInt32  film_pair_en_auto:1;
        RBus_UInt32  film_violate_strict_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  film22_sawtooththl:8;
        RBus_UInt32  film_sawtooththl:8;
        RBus_UInt32  film_frmotionthl:8;
    };
}di_im_di_film_sawtooth_filmframe_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_fieldmotionsumthl:8;
        RBus_UInt32  film22_fistaticsthl:8;
        RBus_UInt32  film_frstaticsthl:8;
        RBus_UInt32  film_fistaticsthl:8;
    };
}di_im_di_film_static_sum_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_pairratio_all1:4;
        RBus_UInt32  film_pairratio_all2:4;
        RBus_UInt32  film_fiminsthl:8;
        RBus_UInt32  film_fimaxsthl:16;
    };
}di_im_di_film_field_judge_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_subfieldmotionsumthl:8;
        RBus_UInt32  film22_subfistaticsthl:8;
        RBus_UInt32  film_subfrstaticsthl:8;
        RBus_UInt32  film_subfistaticsthl:8;
    };
}di_im_di_film_static_sum_sub_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_pairratio_sub1:4;
        RBus_UInt32  film_pairratio_sub2:4;
        RBus_UInt32  film_subfiminsthl:8;
        RBus_UInt32  film_subfimaxsthl:16;
    };
}di_im_di_film_field_judge_sub_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film22_debounce_fieldnum:4;
        RBus_UInt32  film32_debounce_fieldnum:4;
        RBus_UInt32  dummy180240b4_23_19:5;
        RBus_UInt32  film22_filter_andor:1;
        RBus_UInt32  film_sawtooth_choose:2;
        RBus_UInt32  film22_subfieldmotionsumthl:8;
        RBus_UInt32  film22_fieldmotionsumthl:8;
    };
}di_im_di_film_motion_sum_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film22_quick_decision_en:2;
        RBus_UInt32  res1:22;
        RBus_UInt32  film_bot_margin:4;
        RBus_UInt32  film_top_margin:4;
    };
}di_im_di_si_film_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  forfw_2:32;
    };
}di_film_dummy_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_hifreq_thl:16;
        RBus_UInt32  film_hifreq_cnt_thl:4;
        RBus_UInt32  film_3d_mode:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  film_motionstatus_choose:1;
        RBus_UInt32  film_hbcounter:8;
    };
}di_im_di_si_film_hb_cout_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy180240c4_31_10:22;
        RBus_UInt32  top_field:1;
        RBus_UInt32  film_hifreq_flag:1;
        RBus_UInt32  film_detected:1;
        RBus_UInt32  film_subdetected:1;
        RBus_UInt32  film_confuse:1;
        RBus_UInt32  film_sequence:5;
    };
}di_im_di_si_film_final_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_framestatic:8;
        RBus_UInt32  film_framepair:16;
        RBus_UInt32  film_prefistatic1:8;
    };
}di_im_di_si_film_pattern_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_nxtfistatic1:8;
        RBus_UInt32  film_prefistatic2:8;
        RBus_UInt32  film_nxtfistatic2:8;
        RBus_UInt32  film_nxtfimotion:8;
    };
}di_im_di_si_film_pattern_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_detected321:8;
        RBus_UInt32  film_match321:8;
        RBus_UInt32  film_violate321:8;
        RBus_UInt32  film_sequence321_39_32:8;
    };
}di_im_di_si_film_32_result_1_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_sequence321_31_0:32;
    };
}di_im_di_si_film_32_result_1_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_detected322:8;
        RBus_UInt32  film_match322:8;
        RBus_UInt32  film_violate322:8;
        RBus_UInt32  film_sequence322_39_32:8;
    };
}di_im_di_si_film_32_result_2_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_sequence322_31_0:32;
    };
}di_im_di_si_film_32_result_2_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_detected22:8;
        RBus_UInt32  film_match22:8;
        RBus_UInt32  film_violate22:8;
        RBus_UInt32  film_sequence22_39_32:8;
    };
}di_im_di_si_film_22_result_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_sequence22_31_0:32;
    };
}di_im_di_si_film_22_result_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_719_700:20;
    };
}di_im_di_si_film_motion_next_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_699_680:20;
    };
}di_im_di_si_film_motion_next_h_t_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_679_660:20;
    };
}di_im_di_si_film_motion_next_h_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_659_640:20;
    };
}di_im_di_si_film_motion_next_h_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_639_620:20;
    };
}di_im_di_si_film_motion_next_v_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_619_600:20;
    };
}di_im_di_si_film_motion_next_v_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_599_580:20;
    };
}di_im_di_si_film_motion_next_v_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_579_560:20;
    };
}di_im_di_si_film_motion_next_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_559_540:20;
    };
}di_im_di_si_film_motion_pre_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_539_520:20;
    };
}di_im_di_si_film_motion_pre_h_t_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_519_500:20;
    };
}di_im_di_si_film_motion_pre_h_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_499_480:20;
    };
}di_im_di_si_film_motion_pre_h_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_479_460:20;
    };
}di_im_di_si_film_motion_pre_v_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_459_440:20;
    };
}di_im_di_si_film_motion_pre_v_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_439_420:20;
    };
}di_im_di_si_film_motion_pre_v_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_419_400:20;
    };
}di_im_di_si_film_motion_pre_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_399_380:20;
    };
}di_im_di_si_film_motion_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_379_360:20;
    };
}di_im_di_si_film_motion_h_t_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_359_340:20;
    };
}di_im_di_si_film_motion_h_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_339_320:20;
    };
}di_im_di_si_film_motion_h_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_319_300:20;
    };
}di_im_di_si_film_motion_v_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_299_280:20;
    };
}di_im_di_si_film_motion_v_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_279_260:20;
    };
}di_im_di_si_film_motion_v_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_259_240:20;
    };
}di_im_di_si_film_motion_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_239_220:20;
    };
}di_im_di_si_film_motion_h_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_219_200:20;
    };
}di_im_di_si_film_motion_h_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_199_180:20;
    };
}di_im_di_si_film_motion_h_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_179_160:20;
    };
}di_im_di_si_film_motion_h_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_159_140:20;
    };
}di_im_di_si_film_motion_h_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_139_120:20;
    };
}di_im_di_si_film_motion_h_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_119_100:20;
    };
}di_im_di_si_film_motion_h_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_99_80:20;
    };
}di_im_di_si_film_motion_h_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_79_60:20;
    };
}di_im_di_si_film_motion_h_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_59_40:20;
    };
}di_im_di_si_film_motion_h_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_39_20:20;
    };
}di_im_di_si_film_motion_h_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  film_motionstatus_19_0:20;
    };
}di_im_di_si_film_motion_h_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  total_frame_motion_sum:24;
    };
}di_im_di_si_ma_total_fm_sum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  large_frame_motion_pixel:24;
    };
}di_im_di_si_ma_large_fm_pixel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  large_frame_motion_sum:24;
    };
}di_im_di_si_ma_large_fm_sum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  mess_horizontal_pixel:24;
    };
}di_im_di_si_ma_mess_h_pixel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cr_subbal_status:3;
        RBus_UInt32  cr_enable_mainbalance:1;
        RBus_UInt32  cr_mean3_status:8;
        RBus_UInt32  cr_mean2_status:8;
        RBus_UInt32  cr_mean1_status:8;
    };
}di_im_di_si_image_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_i2rnd_sel:1;
        RBus_UInt32  fbuf_crc_compare_en:1;
        RBus_UInt32  fbuf_crc_continous_mode:1;
        RBus_UInt32  fbuf_crc_compare_done:1;
        RBus_UInt32  fbuf_crc_r1_compare_fail:1;
        RBus_UInt32  fbuf_crc_r2_compare_fail:1;
        RBus_UInt32  fbuf_crc_r3_compare_fail:1;
        RBus_UInt32  fbuf_crc_r4_compare_fail:1;
        RBus_UInt32  fbuf_crc_r1_compare_fail_3d:1;
        RBus_UInt32  fbuf_crc_r2_compare_fail_3d:1;
        RBus_UInt32  fbuf_crc_r3_compare_fail_3d:1;
        RBus_UInt32  fbuf_crc_r4_compare_fail_3d:1;
        RBus_UInt32  fbuf_crc_info_r1_compare_fail:1;
        RBus_UInt32  fbuf_crc_info_r2_compare_fail:1;
        RBus_UInt32  di_crc_ctrl_conti:1;
        RBus_UInt32  di_crc_ctrl_start:1;
        RBus_UInt32  cr_amount_subbalance:16;
    };
}di_im_di_si_sub_in_auto_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_crc_result:32;
    };
}di_im_di_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  cp_partialstill:1;
        RBus_UInt32  cp_partialstillnew:1;
    };
}di_im_di_si_still_info_for_ne_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  film22_nxtfistatic1:8;
        RBus_UInt32  film22_nxtfimotion:8;
    };
}di_im_di_si_film22_detector_pattern_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  cp_temporalthly:8;
        RBus_UInt32  cp_temporalthlc:8;
    };
}di_im_di_tnr_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_rtnr_rgb444_enable:1;
        RBus_UInt32  cp_progressive_line_dma:1;
        RBus_UInt32  cp_rtnr_rgb444_8bit_mode:1;
        RBus_UInt32  cp_rtnr_output_previous:1;
        RBus_UInt32  res2:19;
        RBus_UInt32  cp_rtnr_updatelockflg:1;
        RBus_UInt32  cp_rtnr_updatelocken:1;
        RBus_UInt32  cp_rtnr_mad_window:2;
        RBus_UInt32  cp_rtnr_rounding_correction:1;
        RBus_UInt32  cp_rtnr_progressive:1;
        RBus_UInt32  cp_rtnr_c_enable:1;
        RBus_UInt32  cp_rtnr_y_enable:1;
    };
}di_im_di_rtnr_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy180241a4_31_27:5;
        RBus_UInt32  cp_rtnr_k_force_modify_index:3;
        RBus_UInt32  cp_rtnr_k_force_modify_mode:1;
        RBus_UInt32  cp_rtnr_ne_follow_k_modify:1;
        RBus_UInt32  cp_rtnr_k_force_modify_en_c:1;
        RBus_UInt32  cp_rtnr_k_force_modify_en_y:1;
        RBus_UInt32  cp_rtnr_k_force_modify_offset:4;
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_24:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_23:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_22:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_21:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_20:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_14:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_13:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_12:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_11:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_10:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_04:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_03:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_02:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_01:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_00:1;
    };
}di_im_di_rtnr_k_force_modify_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_24:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_23:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_22:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_21:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_20:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_14:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_13:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_12:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_11:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_10:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_04:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_03:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_02:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_01:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_00:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  tr2to1_dist:11;
    };
}di_tr2to1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_24:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_23:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_22:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_21:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_20:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_14:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_13:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_12:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_11:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_10:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_04:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_03:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_02:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_01:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_00:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_24:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_23:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_22:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_21:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_20:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_14:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_13:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_12:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_11:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_10:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_04:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_03:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_02:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_01:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_00:1;
    };
}di_im_di_rtnr_k_force_modify_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  cp_temporal_mad_y_th1:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  cp_temporal_mad_y_th2:11;
    };
}di_im_di_rtnr_mad_y_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  cp_temporal_mad_c_th1:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  cp_temporal_mad_c_th2:11;
    };
}di_im_di_rtnr_mad_c_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cp_temporal_mad_countery:21;
    };
}di_im_di_rtnr_mad_y_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cp_temporal_mad_counteru:21;
    };
}di_im_di_rtnr_mad_u_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cp_temporal_mad_counterv:21;
    };
}di_im_di_rtnr_mad_v_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_24:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_23:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_22:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_21:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_20:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_14:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_13:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_12:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_11:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_10:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_04:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_03:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_02:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_01:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_00:1;
        RBus_UInt32  dummy180241c4_15_13:3;
        RBus_UInt32  cp_temporal_num_match_l:4;
        RBus_UInt32  cp_temporal_l_qlfy_th:4;
        RBus_UInt32  cp_temporal_c_k_decision:3;
        RBus_UInt32  cp_temporal_edge_crct_en:1;
        RBus_UInt32  res2:1;
    };
}di_im_di_rtnr_ediff_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cp_temporal_sad_offset_y:8;
        RBus_UInt32  cp_temporal_sad_offset_u:8;
        RBus_UInt32  cp_temporal_sad_offset_v:8;
    };
}di_im_di_rtnr_sad_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_e_th1_y:8;
        RBus_UInt32  cp_temporal_e_th2_y:8;
        RBus_UInt32  cp_temporal_e_th1_c:8;
        RBus_UInt32  cp_temporal_e_th2_c:8;
    };
}di_im_di_rtnr_ediff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy180241d0_31_22:10;
        RBus_UInt32  cp_temporal_sbl_thm_y:10;
        RBus_UInt32  dummy180241d0_11_10:2;
        RBus_UInt32  cp_temporal_sbl_ths_y:10;
    };
}di_im_di_rtnr_ediff_sobel_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  cp_temporal_nl_up_bnd_y:8;
        RBus_UInt32  cp_temporal_nl_low_bnd_y:8;
    };
}di_im_di_rtnr_level_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cp_temporal_same_et_cnt_y:24;
    };
}di_im_di_rtnr_et_count_y_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_same_et_sad_sum_y:32;
    };
}di_im_di_rtnr_et_sum_y_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_same_et_sad_sum_u:32;
    };
}di_im_di_rtnr_et_sum_u_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_same_et_sad_sum_v:32;
    };
}di_im_di_rtnr_et_sum_v_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  set_sobeledgetypeen:1;
        RBus_UInt32  set_stillmotion_tha:4;
        RBus_UInt32  set_stillmotion_thb:4;
        RBus_UInt32  set_stillmotion_thc:4;
        RBus_UInt32  set_classifysmooth:3;
        RBus_UInt32  set_frame_offset_verystill:4;
        RBus_UInt32  set_frame_offset_still:3;
        RBus_UInt32  set_frame_offset_motion:3;
        RBus_UInt32  set_frame_offset_verymotion:4;
        RBus_UInt32  cp_temporal_xc_switch:1;
        RBus_UInt32  cp_temporal_xc_en:1;
    };
}di_im_di_tnr_xc_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  set_sobeledgetype_sel:2;
        RBus_UInt32  res1:5;
        RBus_UInt32  hfd_highfrequencydetectoren:1;
        RBus_UInt32  hfd_highlowhighdiff_thl:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  hfd_highlowhighdiff_count_thl:4;
        RBus_UInt32  res3:4;
        RBus_UInt32  hfd_3x3blockteethcount_thl:4;
    };
}di_im_di_hfd_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hfd_checklinemotioncounten:1;
        RBus_UInt32  hfd_framekcombineoflinemotion:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  hfd_linemotioncount_thl2:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  hfd_linemotioncount_thl:11;
    };
}di_im_di_hfd_line_motion_count_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  hfd_statistic:24;
    };
}di_im_di_hfd_statistic_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  hmc_window_en:1;
        RBus_UInt32  hmc_window_top:10;
        RBus_UInt32  hmc_window_bot:10;
        RBus_UInt32  res2:8;
    };
}di_im_di_hfd_ma_error_recovery_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_new_intra_low_angle_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_intra_new_gradient_correct_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_intra_post_process_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  btr_hmc_blendchoose:1;
        RBus_UInt32  btr_blendtemporaldebugmode:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  btr_solb_cur1_count:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  btr_solb_cur0_count:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  btr_solb_temporallength:3;
        RBus_UInt32  btr_info_save_mode:2;
        RBus_UInt32  btr_blendtemporalrecovery_dma_en:1;
        RBus_UInt32  btr_sola_method0_blendtype:1;
        RBus_UInt32  btr_sola_method0_successtime:3;
        RBus_UInt32  btr_sola_method:1;
        RBus_UInt32  btr_sola_temporallength:2;
        RBus_UInt32  btr_solutiontype:1;
        RBus_UInt32  btr_blendtemporalrecoveryen:1;
    };
}di_im_di_btr_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  btr_sola_method0_cur1_pre4_max:2;
        RBus_UInt32  btr_sola_method0_cur1_pre4_min:2;
        RBus_UInt32  btr_sola_method0_cur1_pre3_max:2;
        RBus_UInt32  btr_sola_method0_cur1_pre3_min:2;
        RBus_UInt32  btr_sola_method0_cur1_pre2_max:2;
        RBus_UInt32  btr_sola_method0_cur1_pre2_min:2;
        RBus_UInt32  btr_sola_method0_cur1_pre1_max:2;
        RBus_UInt32  btr_sola_method0_cur1_pre1_min:2;
        RBus_UInt32  btr_sola_method0_cur0_pre4_max:2;
        RBus_UInt32  btr_sola_method0_cur0_pre4_min:2;
        RBus_UInt32  btr_sola_method0_cur0_pre3_max:2;
        RBus_UInt32  btr_sola_method0_cur0_pre3_min:2;
        RBus_UInt32  btr_sola_method0_cur0_pre2_max:2;
        RBus_UInt32  btr_sola_method0_cur0_pre2_min:2;
        RBus_UInt32  btr_sola_method0_cur0_pre1_max:2;
        RBus_UInt32  btr_sola_method0_cur0_pre1_min:2;
    };
}di_im_di_btr_sola_method0_min_max_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  btr_longweavesum:24;
    };
}di_im_di_btr_longweave_statistic_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ber_lowpasssum:24;
    };
}di_im_di_ber_lowpass_statistic_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  ber_closeclevel_max:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  ber_closeclevel_min:8;
        RBus_UInt32  ber_blendspatial_lpf_blendingtype:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  ber_blendspatialclassify:1;
        RBus_UInt32  ber_blendspatialrecoveryen:1;
    };
}di_im_di_ber_spatial_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  ber_diffylevel_max:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  ber_diffylevel_min:10;
    };
}di_im_di_ber_spatial_diffy_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ber_totalcontinuesum:24;
        RBus_UInt32  ber_spatialcontinuelength:4;
        RBus_UInt32  ber_blendtemporaltype:1;
        RBus_UInt32  ber_blendtemporalblock:2;
        RBus_UInt32  ber_blendtemporalrevoeryen:1;
    };
}di_im_di_ber_temporal_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  hmc_info_line_count2:10;
        RBus_UInt32  hmc_info_line_count1:10;
    };
}di_im_di_hmc_line_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_info_teeth_count2:16;
        RBus_UInt32  hmc_info_teeth_count1:16;
    };
}di_im_di_hmc_teeth_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  hmc_info_debug_en:1;
        RBus_UInt32  hmc_info_vdiff_th:8;
        RBus_UInt32  hmc_info_end1:10;
        RBus_UInt32  hmc_info_start1:10;
    };
}di_im_di_hmc_info_range_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  hmc_info_end2:10;
        RBus_UInt32  hmc_info_start2:10;
    };
}di_im_di_hmc_info_range_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  film_mask_frmdif_thd:8;
        RBus_UInt32  film_mask_fiedif_thd:8;
        RBus_UInt32  res2:3;
        RBus_UInt32  film_mask_pass_thd:4;
        RBus_UInt32  film_mask_en:1;
    };
}di_im_di_film_mask_detection_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  film_edgetype_sobelthm:10;
        RBus_UInt32  film_edgetype_sobelths:10;
        RBus_UInt32  res2:3;
        RBus_UInt32  film_edgetype_n_pass:1;
        RBus_UInt32  film_edgetype_l_pass:1;
        RBus_UInt32  film_edgetype_h_pass:1;
        RBus_UInt32  film_edgetype_r_pass:1;
        RBus_UInt32  film_edgetype_v_pass:1;
    };
}di_im_di_film_edge_type_check_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  hmc_startline:10;
    };
}di_im_di_hmc_3a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_hmc_statistic_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_hmc_botline:12;
        RBus_UInt32  ma_hmc_topline:12;
        RBus_UInt32  ma_hmc_lineratio:8;
    };
}di_im_di_hmc_statistic1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ma_hmc_botline2:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  ma_hmc_topline2:12;
    };
}di_im_di_hmc_statistic2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  hsd_in_hsize:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  no_hs_mode:1;
        RBus_UInt32  hsd_in_vsize:12;
    };
}di_im_di_no_hs_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ma_hmc_botline3:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  ma_hmc_topline3:12;
    };
}di_im_di_hmc_statistic3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  cnt_for_porch_size:7;
        RBus_UInt32  tnrxc_pixel_counter:16;
    };
}di_im_di_framesobel_statistic_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  hmc_vector_follow_pan_en:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  hmc_dynamic_threshold_max_clip:8;
        RBus_UInt32  hmc_dynamic_threshold_bias:6;
        RBus_UInt32  hmc_dynamic_threshold_en:1;
        RBus_UInt32  res3:9;
    };
}di_im_di_framesobel_statistic_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tnrxc_mkii_thc2:8;
        RBus_UInt32  tnrxc_mkii_thc1:8;
        RBus_UInt32  tnrxc_mkii_thy:8;
        RBus_UInt32  dummy180242a0_7_2:6;
        RBus_UInt32  tnrxc_dbguvmode:1;
        RBus_UInt32  tnrxc_mkii_en:1;
    };
}di_tnrxc_mkii_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_y_kout_dark_2:4;
        RBus_UInt32  cp_temporal_y_kin_dark_2:4;
        RBus_UInt32  cp_temporal_y_dark_th:8;
        RBus_UInt32  res1:4;
        RBus_UInt32  cp_temporal_y_kout_dark:4;
        RBus_UInt32  cp_temporal_y_kin_dark:4;
        RBus_UInt32  res2:3;
        RBus_UInt32  cp_temporal_y_dark_k_en:1;
    };
}di_im_di_rtnr_k_dark_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy180242a8_31_29:3;
        RBus_UInt32  rtnr_refined_c_en:1;
        RBus_UInt32  rtnr_th_localedgediff:12;
        RBus_UInt32  rtnr_stilledge_debug:1;
        RBus_UInt32  rtnr_stilledge_bonusbias:3;
        RBus_UInt32  rtnr_localedge_debug:1;
        RBus_UInt32  rtnr_act_bias:3;
        RBus_UInt32  dummy180242a8_7:1;
        RBus_UInt32  rtnr_crct_bias:3;
        RBus_UInt32  rtnr_crct_debug:1;
        RBus_UInt32  rtnr_stilledge_en:1;
        RBus_UInt32  rtnr_localedge_en:1;
        RBus_UInt32  rtnr_new_formula_en:1;
    };
}di_im_di_rtnr_refined_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy180242ac_31_17:15;
        RBus_UInt32  rtnr_stilledge_th_edgdiff:9;
        RBus_UInt32  rtnr_stilledge_th_edg:8;
    };
}di_im_di_rtnr_refined_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cp_temporal_ediff_c_en6:1;
        RBus_UInt32  cp_temporal_ediff_c_en5:1;
        RBus_UInt32  cp_temporal_ediff_c_en4:1;
        RBus_UInt32  cp_temporal_ediff_c_en3:1;
        RBus_UInt32  cp_temporal_ediff_c_en2:1;
        RBus_UInt32  cp_temporal_ediff_c_en1:1;
        RBus_UInt32  cp_temporal_ediff_c_en0:1;
    };
}di_im_di_rtnr_ediff_enable_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  cp_temporal_y_k_decision:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cp_temporal_ediff_en14:1;
        RBus_UInt32  cp_temporal_ediff_en13:1;
        RBus_UInt32  cp_temporal_ediff_en12:1;
        RBus_UInt32  cp_temporal_ediff_en11:1;
        RBus_UInt32  cp_temporal_ediff_en10:1;
        RBus_UInt32  cp_temporal_ediff_en9:1;
        RBus_UInt32  cp_temporal_ediff_en8:1;
        RBus_UInt32  cp_temporal_ediff_en7:1;
        RBus_UInt32  cp_temporal_ediff_en6:1;
        RBus_UInt32  cp_temporal_ediff_en5:1;
        RBus_UInt32  cp_temporal_ediff_en4:1;
        RBus_UInt32  cp_temporal_ediff_en3:1;
        RBus_UInt32  cp_temporal_ediff_en2:1;
        RBus_UInt32  cp_temporal_ediff_en1:1;
        RBus_UInt32  cp_temporal_ediff_en0:1;
    };
}di_im_di_rtnr_ediff_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cp_temporal_hmcnr_mad_window:2;
        RBus_UInt32  cp_temporal_hmcnr_weight:3;
        RBus_UInt32  res2:11;
        RBus_UInt32  cp_temporal_hmcnr_y_en:1;
        RBus_UInt32  cp_temporal_hmcnr_debug_progressive:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  cp_temporal_hmcnr_uv_with_y:1;
        RBus_UInt32  hmcnr_mvx_avg_en:1;
        RBus_UInt32  hmcnr_mvy_avg_en:1;
        RBus_UInt32  res4:2;
    };
}di_im_di_rtnr_hmcnr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  rtnr_k_debugmode:1;
        RBus_UInt32  prtnr_4k2k:1;
        RBus_UInt32  res2:15;
        RBus_UInt32  rtnr_new_method_k_extend_en:1;
        RBus_UInt32  res3:3;
    };
}di_im_di_rtnr_new_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_teeth_statistic_pre_near:16;
        RBus_UInt32  pan_teeth_statistic_nxt_near:16;
    };
}di_im_di_pan_teeth_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_teeth_statistic_pre_far:16;
        RBus_UInt32  pan_teeth_statistic_nxt_far:16;
    };
}di_im_di_pan_teeth_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_teeth_statistic_bias:4;
        RBus_UInt32  pan_teeth_statistic_largediff_th:14;
        RBus_UInt32  pan_teeth_statistic_smalldiff_th:11;
        RBus_UInt32  pan_teeth_statistic_factor:3;
    };
}di_im_di_pan_teeth_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_mc_choose_one_side_en:1;
        RBus_UInt32  di_hmc_vlpf_en:1;
        RBus_UInt32  hmc_vlpf_debug_en:1;
        RBus_UInt32  hmc_vlpf_hori_protect_en:1;
        RBus_UInt32  hmc_vlpf_vhf_en:1;
        RBus_UInt32  hmc_teeth_follow_ma:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  hmc_vlpf_verti_min_th:8;
        RBus_UInt32  hmc_vlpf_hori_min_th:8;
        RBus_UInt32  hmc_vlpf_hori_max_th:8;
    };
}di_im_di_pan_teeth_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_vlpf_vhf_center_th:8;
        RBus_UInt32  hmc_vlpf_vhf_margin_th:8;
        RBus_UInt32  hmc_mv_choose_vlpf:3;
        RBus_UInt32  hmc_mv_refine_cmp_tmv_en:1;
        RBus_UInt32  hmc_mv_refine_cmp_tmv_th:3;
        RBus_UInt32  hmc_blending_with_ma_gain_line_t_en:1;
        RBus_UInt32  hmc_blending_with_ma_gain_line_t_cnt:3;
        RBus_UInt32  hmc_blending_with_ma_gain_line_t_factor:2;
        RBus_UInt32  hme_debug_mode:3;
    };
}di_im_di_hmc_vlpf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  hmc_refine_cmp_tmv_y_th_h:3;
        RBus_UInt32  hmc_refine_cmp_tmv_y_th_m:3;
        RBus_UInt32  hmc_refine_cmp_tmv_y_th_s:3;
        RBus_UInt32  hmc_statistic_factor:8;
    };
}di_im_di_blending_corrector_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_blending_corrector_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_blending_corrector_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_blending_corrector_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_mc_odd_mv_pass_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  pan_mc_sobel_diff_min_th:6;
        RBus_UInt32  res2:19;
        RBus_UInt32  pan_mc_path_sel:1;
        RBus_UInt32  pan_me_edgediff_min_th:3;
        RBus_UInt32  pan_en:1;
    };
}di_im_di_pan_detection_control_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  pan_mc_teeth_check_th:4;
        RBus_UInt32  pan_mc_teeth_check_en:1;
        RBus_UInt32  pan_mc_edge_n:1;
        RBus_UInt32  pan_mc_edge_h:1;
        RBus_UInt32  pan_mc_edge_v:1;
        RBus_UInt32  pan_mc_edge_l:1;
        RBus_UInt32  pan_mc_edge_r:1;
        RBus_UInt32  res2:6;
    };
}di_im_di_pan_detection_control_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r7_pixelsum:16;
        RBus_UInt32  hmc_r6_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r5_pixelsum:16;
        RBus_UInt32  hmc_r4_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r3_pixelsum:16;
        RBus_UInt32  hmc_r2_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r1_pixelsum:16;
        RBus_UInt32  hmc_c0_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l1_pixelsum:16;
        RBus_UInt32  hmc_l2_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l3_pixelsum:16;
        RBus_UInt32  hmc_l4_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l5_pixelsum:16;
        RBus_UInt32  hmc_l6_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l7_pixelsum:16;
        RBus_UInt32  res1:4;
        RBus_UInt32  pan_me_border_top_width:12;
    };
}di_im_di_pan_detection_statistic_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  pan_me_border_bot_width:12;
        RBus_UInt32  pan_me_border_left_width:8;
        RBus_UInt32  pan_me_border_right_width:8;
    };
}di_im_di_pan_detection_control_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  fw_film_doublebuffer_en:1;
        RBus_UInt32  film_bad_edit_en:1;
        RBus_UInt32  fw_film_filmsequence:5;
        RBus_UInt32  fw_film_32detected1:1;
        RBus_UInt32  fw_film_32detected2:1;
        RBus_UInt32  fw_film_22detected:1;
        RBus_UInt32  fw_film_filmweavemode:2;
        RBus_UInt32  fw_film_mixedfilmconfuse:1;
        RBus_UInt32  fw_film_mixedfilmdetected:1;
        RBus_UInt32  fw_film_filmdetected:1;
        RBus_UInt32  film_mixedfilm_margin:2;
        RBus_UInt32  fw_film_reg_sel:1;
        RBus_UInt32  badeditor_ratio:2;
        RBus_UInt32  film_pair3_ratio:2;
        RBus_UInt32  force_badeditor_en:1;
        RBus_UInt32  film_pair3_en:1;
        RBus_UInt32  fw_film_en:1;
    };
}di_im_di_film_new_function_main_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  fw_botline1:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  fw_topline1:11;
    };
}di_im_di_film_topbotline1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  fw_botline2:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  fw_topline2:11;
    };
}di_im_di_film_topbotline2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  fw_botline3:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  fw_topline3:11;
    };
}di_im_di_film_topbotline3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  film_badeditor_flag:1;
        RBus_UInt32  film22_prevfilmmotion:8;
        RBus_UInt32  film_prevfilmmotion:8;
    };
}di_im_di_film_prev_fieldmotion_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  film_nextbotdetected3:1;
        RBus_UInt32  film_nexttopdetected3:1;
        RBus_UInt32  film_nextbotdetected2:1;
        RBus_UInt32  film_nexttopdetected2:1;
        RBus_UInt32  film_nextbotdetected1:1;
        RBus_UInt32  film_nexttopdetected1:1;
        RBus_UInt32  film_prevbotdetected3:1;
        RBus_UInt32  film_prevtopdetected3:1;
        RBus_UInt32  film_prevbotdetected2:1;
        RBus_UInt32  film_prevtopdetected2:1;
        RBus_UInt32  film_prevbotdetected1:1;
        RBus_UInt32  film_prevtopdetected1:1;
    };
}di_im_di_film_mark_information_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  film_prevbotmark1:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  film_prevtopmark1:11;
    };
}di_im_di_film_mark_prev1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  film_prevbotmark2:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  film_prevtopmark2:11;
    };
}di_im_di_film_mark_prev2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  film_prevbotmark3:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  film_prevtopmark3:11;
    };
}di_im_di_film_mark_prev3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  film_nextbotmark1:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  film_nexttopmark1:11;
    };
}di_im_di_film_mark_next1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  film_nextbotmark2:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  film_nexttopmark2:11;
    };
}di_im_di_film_mark_next2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  film_nextbotmark3:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  film_nexttopmark3:11;
    };
}di_im_di_film_mark_next3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_en:1;
        RBus_UInt32  smd_debug_hentryofmv_en:1;
        RBus_UInt32  smd_debug_ventryofmv_en:1;
        RBus_UInt32  smd_debug_sawtooth_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_spatialmv_counter_th:2;
        RBus_UInt32  smd_debug_preinrateeth_en:1;
        RBus_UInt32  smd_debug_resurrect_en:1;
        RBus_UInt32  smd_debug_mvschanged_en:1;
        RBus_UInt32  smd_debug_spatialfreqnomatch_en:1;
        RBus_UInt32  smd_debug_outofrange_en:1;
        RBus_UInt32  smd_localmv_counter_th:3;
        RBus_UInt32  smd_lowbound_sad_forjudgemv:8;
        RBus_UInt32  smd_upperbound_sad_forjudgemv:8;
    };
}di_di_smd_control_candidatelist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_spatialmv_sad_th:8;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_spatial_divergence_th:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_localmv_concentrate_ratio_th:3;
        RBus_UInt32  smd_localmv_sad_th:8;
        RBus_UInt32  smd_reliablerange_sad_th:8;
    };
}di_di_smd_choosecandidate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_steeth_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_preintra_teeth_offset:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  smd_preintra_effect:6;
        RBus_UInt32  res3:1;
        RBus_UInt32  smd_preintra_teeth_gain:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  smd_curr_teeth_gain:3;
        RBus_UInt32  smd_teeth_new_mode:2;
        RBus_UInt32  smd_curr_teeth_offset:6;
    };
}di_di_smd_refinemv1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_mvs_vchanged_en:1;
        RBus_UInt32  smd_mvs_hchanged_en:1;
        RBus_UInt32  smd_resurrect_en:1;
        RBus_UInt32  smd_resurrect_union_num:5;
        RBus_UInt32  smd_resurrect_smallwindow_num:4;
        RBus_UInt32  smd_resurrect_localcurr_num:4;
        RBus_UInt32  smd_resurrect_minsad_th:8;
        RBus_UInt32  smd_global_en_ratio:8;
    };
}di_di_smd_refinemv2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  smd_sfreq_diff_gain:4;
        RBus_UInt32  smd_sfreq_diff_th:8;
        RBus_UInt32  res2:6;
        RBus_UInt32  smd_sfreq_drop_th:10;
    };
}di_di_smd_refinemv3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_smd_panning1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_drop_singleweaveline_en:1;
        RBus_UInt32  smd_drop_singleintraline_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_leftweave_gap_range:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  smd_leftweave_gap_th:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  smd_rightweave_gap_range:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  smd_rightweave_gap_th:5;
    };
}di_di_smd_final_adjustment1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_line_continous_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_leftintra_gap_range:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  smd_leftintra_gap_th:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  smd_rightintra_gap_range:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  smd_rightintra_gap_th:5;
    };
}di_di_smd_final_adjustment2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  smd_compensate_teeth_th:8;
        RBus_UInt32  smd_compensate_avg:8;
    };
}di_di_smd_compensate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthly3:8;
        RBus_UInt32  cp_temporalthly2:8;
        RBus_UInt32  cp_temporalthly1:8;
        RBus_UInt32  cp_temporalthly0:8;
    };
}di_im_di_rtnr_y_16_th0_th3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthly7:8;
        RBus_UInt32  cp_temporalthly6:8;
        RBus_UInt32  cp_temporalthly5:8;
        RBus_UInt32  cp_temporalthly4:8;
    };
}di_im_di_rtnr_y_16_th4_th7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthly11:8;
        RBus_UInt32  cp_temporalthly10:8;
        RBus_UInt32  cp_temporalthly9:8;
        RBus_UInt32  cp_temporalthly8:8;
    };
}di_im_di_rtnr_y_16_th8_th11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cp_temporalthly14:8;
        RBus_UInt32  cp_temporalthly13:8;
        RBus_UInt32  cp_temporalthly12:8;
    };
}di_im_di_rtnr_y_16_th12_th14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthlc3:8;
        RBus_UInt32  cp_temporalthlc2:8;
        RBus_UInt32  cp_temporalthlc1:8;
        RBus_UInt32  cp_temporalthlc0:8;
    };
}di_im_di_rtnr_c_th0_th3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cp_temporalthlc6:8;
        RBus_UInt32  cp_temporalthlc5:8;
        RBus_UInt32  cp_temporalthlc4:8;
    };
}di_im_di_rtnr_c_th4_th6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_y_k7:4;
        RBus_UInt32  cp_temporal_y_k6:4;
        RBus_UInt32  cp_temporal_y_k5:4;
        RBus_UInt32  cp_temporal_y_k4:4;
        RBus_UInt32  cp_temporal_y_k3:4;
        RBus_UInt32  cp_temporal_y_k2:4;
        RBus_UInt32  cp_temporal_y_k1:4;
        RBus_UInt32  cp_temporal_y_k0:4;
    };
}di_im_di_rtnr_y_16_k0_k7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_y_k15:4;
        RBus_UInt32  cp_temporal_y_k14:4;
        RBus_UInt32  cp_temporal_y_k13:4;
        RBus_UInt32  cp_temporal_y_k12:4;
        RBus_UInt32  cp_temporal_y_k11:4;
        RBus_UInt32  cp_temporal_y_k10:4;
        RBus_UInt32  cp_temporal_y_k9:4;
        RBus_UInt32  cp_temporal_y_k8:4;
    };
}di_im_di_rtnr_y_16_k8_k15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_temporal_c_k7:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  cp_temporal_c_k6:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  cp_temporal_c_k5:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  cp_temporal_c_k4:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  cp_temporal_c_k3:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  cp_temporal_c_k2:3;
        RBus_UInt32  res7:1;
        RBus_UInt32  cp_temporal_c_k1:3;
        RBus_UInt32  res8:1;
        RBus_UInt32  cp_temporal_c_k0:3;
    };
}di_im_di_rtnr_c_k_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_mstart_115_87:29;
        RBus_UInt32  res1:3;
    };
}di_di_datmemorystartadd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_mstart_86_58:29;
        RBus_UInt32  res1:3;
    };
}di_di_datmemorystartadd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_mstart_57_29:29;
        RBus_UInt32  res1:3;
    };
}di_di_datmemorystartadd3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_mstart_28_0:29;
        RBus_UInt32  res1:3;
    };
}di_di_datmemorystartadd4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inf_mstart_57_29:29;
        RBus_UInt32  res1:3;
    };
}di_di_infmemorystartadd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inf_mstart_28_0:29;
        RBus_UInt32  res1:3;
    };
}di_di_infmemorystartadd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_water_r:8;
        RBus_UInt32  dma_outstanding_en:1;
        RBus_UInt32  dat_len_r:7;
        RBus_UInt32  dat_num_r:16;
    };
}di_ddr_rdatdma_wtlennum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_water_w:8;
        RBus_UInt32  wdma_close:1;
        RBus_UInt32  dat_len_w:7;
        RBus_UInt32  dat_num_w:16;
    };
}di_ddr_wdatdma_wtlennum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  rdma_remain_en:1;
        RBus_UInt32  dat_remain_w:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  dat_remain_r:7;
    };
}di_ddr_datdma_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inf_water_r:8;
        RBus_UInt32  res1:1;
        RBus_UInt32  inf_len_r:7;
        RBus_UInt32  inf_num_r:16;
    };
}di_ddr_rinfdma_wtlennum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inf_water_w:8;
        RBus_UInt32  res1:1;
        RBus_UInt32  inf_len_w:7;
        RBus_UInt32  inf_num_w:16;
    };
}di_ddr_winfdma_wtlennum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:17;
        RBus_UInt32  inf_remain_w:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  inf_remain_r:7;
    };
}di_ddr_infdma_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ccdinr_fifoerr_ie:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  crc_128b_en:1;
        RBus_UInt32  crc_128b_compare_fail:1;
        RBus_UInt32  dma_reset_st:1;
        RBus_UInt32  ccdinr_flag_clr:8;
        RBus_UInt32  ccdinr_ovfl:8;
        RBus_UInt32  ccdinr_unfl:8;
    };
}di_ddr_dmastatus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ccdinr_fifoerr_wde:1;
        RBus_UInt32  ccdinr_vs_reset_en:1;
        RBus_UInt32  ccdinr_fifoerr_wde_sub:1;
        RBus_UInt32  res1:27;
        RBus_UInt32  ccdinr_wd_to_main:1;
        RBus_UInt32  ccdinr_wd_to_sub:1;
    };
}di_ddr_wde_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_wrrd_downlimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_di1_wrrd_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_wrrd_uplimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_di1_wrrd_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  di1_wrrd_downup_limit_ov_clearstatus:1;
        RBus_UInt32  di1_wr_downlimit_ov:2;
        RBus_UInt32  di1_wr_uplimit_ov:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  di1_rd_downlimit_ov:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  di1_rd_uplimit_ov:6;
    };
}di_di1_wrrd_boundaryadd_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_datmemorystartadd1_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_datmemorystartadd2_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_datmemorystartadd3_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_datmemorystartadd4_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_infmemorystartadd1_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_infmemorystartadd2_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_line_dma_buffer_cnt:2;
        RBus_UInt32  ccdinr_write_addr_l:29;
    };
}di_di_line_base_dma_addr_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  ccdinr_write_addr_r:29;
    };
}di_di_line_base_dma_addr_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dma_info_first:1;
        RBus_UInt32  res1:24;
        RBus_UInt32  rdma_req_num:3;
        RBus_UInt32  res2:2;
        RBus_UInt32  wdma_req_num:2;
    };
}di_di_dma_multi_req_num_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  s0_mstart_115_87:29;
        RBus_UInt32  res1:3;
    };
}di_mvf_watmemorystart_s0_add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  s0_mstart_86_58:29;
        RBus_UInt32  res1:3;
    };
}di_mvf_watmemorystart_s0_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  s0_mstart_57_29:29;
        RBus_UInt32  res1:3;
    };
}di_mvf_watmemorystart_s0_add2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  s1_mstart_115_87:29;
        RBus_UInt32  res1:3;
    };
}di_mvf_watmemorystart_s1add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  s1_mstart_86_58:29;
        RBus_UInt32  res1:3;
    };
}di_mvf_watmemorystart_s1_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  s1_mstart_57_29:29;
        RBus_UInt32  res1:3;
    };
}di_mvf_watmemorystart_s1_add2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mvf_inf_water_w:8;
        RBus_UInt32  res1:1;
        RBus_UInt32  mvf_inf_len_w:7;
        RBus_UInt32  mvf_inf_num_w:16;
    };
}di_mvf_ddr_wdma_wtlennum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  mvf_inf_remain_w:7;
    };
}di_mvf_ddr_wdatdma_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  mvf_wrrd_downup_limit_ov_clearstatus:1;
        RBus_UInt32  mvf_set_first_frame:1;
        RBus_UInt32  wdma_s1_frame_cnt:2;
        RBus_UInt32  wdma_s0_frame_cnt:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  mvf_flag_clr:1;
        RBus_UInt32  mvf_ovfl:1;
        RBus_UInt32  mvf_unfl:1;
        RBus_UInt32  res3:10;
        RBus_UInt32  mvf_addr_downlimit_ov:1;
        RBus_UInt32  mvf_addr_uplimit_ov:1;
    };
}di_mvf_ddr_dmastatus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mvf_crc:32;
    };
}di_mvf_ddr_crc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mvf_wr_downlimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_mvf_wr_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mvf_wr_uplimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_mvf_wr_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  s0_mstart_28_0:29;
        RBus_UInt32  res1:3;
    };
}di_mvf_watmemorystart_s0_add3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  s1_mstart_28_0:29;
        RBus_UInt32  res1:3;
    };
}di_mvf_watmemorystart_s1_add3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_i2r_mstart_115_87:29;
        RBus_UInt32  res1:3;
    };
}di_di_i2r_datmemorystartadd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_i2r_mstart_86_58:29;
        RBus_UInt32  res1:3;
    };
}di_di_i2r_datmemorystartadd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_i2r_mstart_57_29:29;
        RBus_UInt32  res1:3;
    };
}di_di_i2r_datmemorystartadd3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_i2r_mstart_28_0:29;
        RBus_UInt32  res1:3;
    };
}di_di_i2r_datmemorystartadd4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inf_i2r_mstart_57_29:29;
        RBus_UInt32  res1:3;
    };
}di_di_i2r_infmemorystartadd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inf_i2r_mstart_28_0:29;
        RBus_UInt32  res1:3;
    };
}di_di_i2r_infmemorystartadd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_datmemorystartadd1_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_datmemorystartadd2_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_datmemorystartadd3_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_datmemorystartadd4_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_infmemorystartadd1_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_infmemorystartadd2_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_i2r_wrrd_downlimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_di1_i2r_wrrd_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_i2r_wrrd_uplimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_di1_i2r_wrrd_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  di1_i2r_wrrd_downup_limit_ov_clearstatus:1;
        RBus_UInt32  di1_i2r_wr_downlimit_ov:2;
        RBus_UInt32  di1_i2r_wr_uplimit_ov:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  di1_i2r_rd_downlimit_ov:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  di1_i2r_rd_uplimit_ov:6;
    };
}di_di1_i2r_wrrd_boundaryadd_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_mvf_i2r_wrrd_downlimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_di1_mvf_i2r_wrrd_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_mvf_i2r_wrrd_uplimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_di1_mvf_i2r_wrrd_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_info_wrrd_downlimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_di1_info_wrrd_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_info_wrrd_uplimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_di1_info_wrrd_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_info_i2r_wrrd_downlimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_di1_info_i2r_wrrd_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_info_i2r_wrrd_uplimit_adr:29;
        RBus_UInt32  res1:3;
    };
}di_di1_info_i2r_wrrd_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  di_li1_bist_fail:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  di_li2_bist_fail:4;
        RBus_UInt32  di_li3_bist_fail:8;
        RBus_UInt32  res3:4;
        RBus_UInt32  rtnr_isnr_dma_bist_fail:4;
    };
}di_dispi_bist_fail_separate_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_dma_wdat_bist_fail:8;
        RBus_UInt32  di_dma_rdat_bist_fail:8;
        RBus_UInt32  res1:2;
        RBus_UInt32  di_tr2to1_bist_fail:4;
        RBus_UInt32  rtnr_mcnr_tmv2_bist_fail:2;
        RBus_UInt32  rtnr_mcnr_tmv1_bist_fail:8;
    };
}di_dispi_bist_fail_separate_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_li4_bist_fail:8;
        RBus_UInt32  di_li5_bist_fail:8;
        RBus_UInt32  res1:5;
        RBus_UInt32  di_li6_bist_fail:2;
        RBus_UInt32  res2:9;
    };
}di_dispi_bist_fail_separate_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  di_pqdc2_bist_fail:2;
        RBus_UInt32  di_pqdc1_bist_fail:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  di_pqc2_bist_fail:13;
        RBus_UInt32  di_pqc1_bist_fail:1;
    };
}di_dispi_bist_fail_separate_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  di_li1_drf_fail:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  di_li2_drf_fail:4;
        RBus_UInt32  di_li3_drf_fail:8;
        RBus_UInt32  res3:4;
        RBus_UInt32  rtnr_isnr_dma_drf_fail:4;
    };
}di_dispi_drf_fail_separate_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_dma_wdat_drf_fail:8;
        RBus_UInt32  di_dma_rdat_drf_fail:8;
        RBus_UInt32  res1:2;
        RBus_UInt32  di_tr2to1_drf_fail:4;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_fail:2;
        RBus_UInt32  rtnr_mcnr_tmv1_drf_fail:8;
    };
}di_dispi_drf_fail_separate_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_li4_drf_fail:8;
        RBus_UInt32  di_li5_drf_fail:8;
        RBus_UInt32  res1:5;
        RBus_UInt32  di_li6_drf_fail:2;
        RBus_UInt32  res2:9;
    };
}di_dispi_drf_fail_separate_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  di_pqdc2_drf_fail:2;
        RBus_UInt32  di_pqdc1_drf_fail:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  di_pqc2_drf_fail:13;
        RBus_UInt32  di_pqc1_drf_fail:1;
    };
}di_dispi_drf_fail_separate_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  di_pqdc2_rme:1;
        RBus_UInt32  di_pqdc1_rme:1;
        RBus_UInt32  di_pqc2_rme:2;
        RBus_UInt32  di_pqc1_rme:1;
        RBus_UInt32  rtnr_mcnr_tmv2_rme:1;
        RBus_UInt32  rtnr_mcnr_tmv1_rme:1;
        RBus_UInt32  di_li1_rme:1;
        RBus_UInt32  di_li2_rme:1;
        RBus_UInt32  di_li3_rme:1;
        RBus_UInt32  di_li4_rme:1;
        RBus_UInt32  di_li5_rme:1;
        RBus_UInt32  di_li6_rme:1;
        RBus_UInt32  di_li6_rme_bisr:1;
        RBus_UInt32  di_bisr_repaired_ro:1;
        RBus_UInt32  di_tr2to1_rme:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  rtnr_isnr_dma_rme:1;
        RBus_UInt32  di_dma_wdat_rme:1;
        RBus_UInt32  di_dma_rdat_rme:1;
    };
}di_dispi_bist_rme_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  di_li1_rm:4;
        RBus_UInt32  di_li2_rm:4;
        RBus_UInt32  di_li3_rm:4;
        RBus_UInt32  di_li4_rm:4;
        RBus_UInt32  di_li5_rm:4;
        RBus_UInt32  di_li6_rm:4;
        RBus_UInt32  di_li6_rm_bisr:4;
    };
}di_dispi_bist_rm_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_mcnr_tmv2_rm:4;
        RBus_UInt32  rtnr_mcnr_tmv1_rm:4;
        RBus_UInt32  res1:4;
        RBus_UInt32  di_tr2to1_rm:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  rtnr_isnr_dma_rm:4;
        RBus_UInt32  di_dma_wdat_rm:4;
        RBus_UInt32  di_dma_rdat_rm:4;
    };
}di_dispi_bist_rm_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  di_pqdc2_rm:4;
        RBus_UInt32  di_pqdc1_rm:4;
        RBus_UInt32  di_pqc2_rm:8;
        RBus_UInt32  di_pqc1_rm:4;
    };
}di_dispi_bist_rm_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  pqdc_test_rwm:1;
        RBus_UInt32  pqc_test_rwm:1;
        RBus_UInt32  rtnr_mcnr_tmv1_bist_testrwm:1;
    };
}di_dispi_bist_test_rwm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_dispi_bist_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sm_tog_apply_disable:1;
        RBus_UInt32  sm_tog_3d_mode:1;
        RBus_UInt32  res1:27;
        RBus_UInt32  db_read:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_apply:1;
    };
}di_db_reg_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  smooth_toggle_end_en:1;
        RBus_UInt32  smooth_toggle_end:1;
        RBus_UInt32  smooth_toggle_end_i2r:1;
        RBus_UInt32  reg_sm_size_change_sw_detect_en_i2r:1;
        RBus_UInt32  reg_sm_size_change_sw_detect_en:1;
        RBus_UInt32  reg_sm_size_change_hw_detect_en:1;
    };
}di_i2r_db_reg_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  ccdinr_wd_debug_mode_s:1;
        RBus_UInt32  ccdinr_wd_debug_target_s:1;
        RBus_UInt32  ccdinr_wd_debug_mode_m:1;
        RBus_UInt32  ccdinr_wd_debug_target_m:1;
        RBus_UInt32  ccdinr_debug_mode:3;
    };
}di_ccdinr_dbg_mux_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin0:16;
        RBus_UInt32  smd_sad_his_bin1:16;
    };
}di_di_smd_sadhisbina_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin2:16;
        RBus_UInt32  smd_sad_his_bin3:16;
    };
}di_di_smd_sadhisbinb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin4:16;
        RBus_UInt32  smd_sad_his_bin5:16;
    };
}di_di_smd_sadhisbinc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin6:16;
        RBus_UInt32  smd_sad_his_bin7:16;
    };
}di_di_smd_sadhisbind_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin8:16;
        RBus_UInt32  smd_sad_his_bin9:16;
    };
}di_di_smd_sadhisbine_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin10:16;
        RBus_UInt32  smd_sad_his_bin11:16;
    };
}di_di_smd_sadhisbinf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin12:16;
        RBus_UInt32  smd_sad_his_bin13:16;
    };
}di_di_smd_sadhisbing_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin14:16;
        RBus_UInt32  smd_sad_his_bin15:16;
    };
}di_di_smd_sadhisbinh_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  smd_firmwaremv_x:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_firmwaremv_y:3;
    };
}di_di_smd_gmvcoeff3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_apply_result_mode:2;
        RBus_UInt32  smd_firmware_pan:1;
        RBus_UInt32  smd_searchmv_apply:1;
        RBus_UInt32  smd_hardware_pan_en:1;
        RBus_UInt32  smd_vpan_en:1;
        RBus_UInt32  smd_searchmv_apply_sad_th:6;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_pg_no_pixel_ctr_en:1;
        RBus_UInt32  smd_firmware_pan_sad_th:6;
        RBus_UInt32  smd_vpan_work_th:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_vpan_jump_out:3;
        RBus_UInt32  smd_vpan_upper_bound:4;
    };
}di_di_smd_pan1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_enter_pan_ctr_th:6;
        RBus_UInt32  smd_vpan_gmv1_pixel:6;
        RBus_UInt32  smd_vpan_total_pixel:6;
        RBus_UInt32  smd_gmv3_th:14;
    };
}di_di_smd_pan2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_addctr_gmv1_pixelth1:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  smd_addctr_gmv1_pixelth2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  smd_search_apply_th:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  smd_rebuild_pan_ctr:6;
    };
}di_di_smd_pan3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_full_search_mode:1;
        RBus_UInt32  smd_intra_en:1;
        RBus_UInt32  smd_colony_drop_en:1;
        RBus_UInt32  smd_colony_expanse_en:1;
        RBus_UInt32  smd_colony_expanse_type:1;
        RBus_UInt32  smd_result_en:1;
        RBus_UInt32  smd_curr_teeth_offset_c:6;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_curr_teeth_gain_c:3;
        RBus_UInt32  smd_expanse_range:3;
        RBus_UInt32  smd_left_weave_blend:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  smd_right_weave_blend:5;
    };
}di_di_smd_additionalcoeff1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_image_boundary_height:4;
        RBus_UInt32  smd_image_boundary_width:4;
        RBus_UInt32  smd_search_gmv_offset:5;
        RBus_UInt32  smd_search_gmv_gain:3;
        RBus_UInt32  res1:16;
    };
}di_di_smd_additionalcoeff2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_patterngenmode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_v4highfreqeffect:6;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_v4highfreqth2:7;
        RBus_UInt32  res3:4;
        RBus_UInt32  smd_v4highfreqth1:12;
    };
}di_di_smd_v4highfreq_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r16_pixelsum:16;
        RBus_UInt32  hmc_r15_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r14_pixelsum:16;
        RBus_UInt32  hmc_r13_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r12_pixelsum:16;
        RBus_UInt32  hmc_r11_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r10_pixelsum:16;
        RBus_UInt32  hmc_r9_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r8_pixelsum:16;
        RBus_UInt32  hmc_l8_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l9_pixelsum:16;
        RBus_UInt32  hmc_l10_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l11_pixelsum:16;
        RBus_UInt32  hmc_l12_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l13_pixelsum:16;
        RBus_UInt32  hmc_l14_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l15_pixelsum:16;
        RBus_UInt32  hmc_l16_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gst_en:1;
        RBus_UInt32  gst_debug_fmv2weave:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  gst_pregmv_needstable:1;
        RBus_UInt32  gst_replace_sad:1;
        RBus_UInt32  gst_search_zmv_offset:6;
        RBus_UInt32  gst_fmv2weave_p:4;
        RBus_UInt32  gst_fmv2weave_n:4;
    };
}di_di_gst_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  gst_enter_origsad_lowth:8;
        RBus_UInt32  res2:7;
        RBus_UInt32  gst_enter_origsad_offset:9;
    };
}di_di_gst_enter_origsadcheck_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gst_outofrange_check:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  gst_outofrange_origsad:8;
        RBus_UInt32  gst_outofrange_fracsadlowth:8;
        RBus_UInt32  gst_outofrange_fracsad_offset:8;
    };
}di_di_gst_outofrangecheck_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gst_freqnonmatch_check:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  gst_freqnonmatch_origsad:8;
        RBus_UInt32  gst_freqnonmatch_fracsad_lowth:8;
        RBus_UInt32  gst_freqnonmatch_fracsad_offset:8;
    };
}di_di_gst_freqnonmatchcheck_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_gmv_sad_th:7;
        RBus_UInt32  smd_gmv_sad_max:8;
        RBus_UInt32  smd_localmv_sad_max:8;
        RBus_UInt32  smd_spatialmv_sad_max:8;
    };
}di_di_smd_candidatelimitsad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_mv_refine_mor_en:1;
        RBus_UInt32  hmc_dynamic_threshold_min_clip:3;
        RBus_UInt32  hmc_mv_refine_y_th:8;
        RBus_UInt32  mc_dynamic_threshold_clip_en:1;
        RBus_UInt32  hmc_mv_refine_en:1;
        RBus_UInt32  hmc_odd_mv_no_compesation:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  hme_max_absolute_count:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  hme_sobel_search_min:4;
    };
}di_im_di_hmc_adjustable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hme_x_continued_counter:4;
        RBus_UInt32  hmc_mv_refine_mor_noise_th:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  hmc_mv_refine_mor_zero_th1_hh:6;
        RBus_UInt32  hmc_follow_ma_result_en:1;
        RBus_UInt32  hmc_mv_refine_cur_motion_en:1;
        RBus_UInt32  hmc_mv_refine_mor_same_th1_hh:6;
        RBus_UInt32  hmc_mv_refine_cur_motion_th:8;
    };
}di_im_di_hmc_adjustable2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  hmc_fail_follow_ma_result_en:1;
        RBus_UInt32  hmc_mv_refine_mor_zero_th2:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  hmc_mv_refine_mor_same_th2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  hmc_mv_refine_mor_zero_th1:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  hmc_mv_refine_mor_same_th1:6;
    };
}di_im_di_hmc_adjustable3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_mv_refine_sobel_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  hmc_mv_refine_sobel_non_edge_th:4;
        RBus_UInt32  res2:3;
        RBus_UInt32  hmc_mv_refine_sobel_diff_th:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  hmc_mv_refine_mor_hh_h_th:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  hmc_mv_refine_mor_hh_v_th:5;
    };
}di_im_di_hmc_adjustable4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scene_change_cond1_en:1;
        RBus_UInt32  scene_change_cond2_en:1;
        RBus_UInt32  scene_change_cond1_result:1;
        RBus_UInt32  scene_change_cond2_result:1;
        RBus_UInt32  scene_change_debug_en:1;
        RBus_UInt32  scene_change_cond1_th:11;
        RBus_UInt32  scene_change_cond2_th:16;
    };
}di_im_di_sc_adjustment_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy18024660_31_29:3;
        RBus_UInt32  ma_horicom_teethdiff_en:1;
        RBus_UInt32  hmc_half_mv_notteeth_recover_en:1;
        RBus_UInt32  hmc_half_mv_all_teeth_check_en:1;
        RBus_UInt32  hmc_half_mv_energy_check_en:1;
        RBus_UInt32  hmc_half_mv_correct_en:1;
        RBus_UInt32  hmc_half_mv_blending_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  hmc_mv_refine_sub_px_mv_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  hme_avoid_rltype_vertical_pan_en:1;
        RBus_UInt32  hme_consider_mv_invalid_en:1;
        RBus_UInt32  hme_check_zero_mv_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  pan_mc_adaptive_compensation_en:1;
        RBus_UInt32  pan_me_sub_pixel_mv_det_en:1;
        RBus_UInt32  pan_mc_rls_en:1;
        RBus_UInt32  pan_me_invalid_check_en:1;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_en:1;
        RBus_UInt32  pan_mc_force_compensation_en:1;
        RBus_UInt32  pan_me_select_mv_hist:1;
        RBus_UInt32  hmc_debug_en:1;
        RBus_UInt32  pan_mc_debug_en:1;
        RBus_UInt32  pan_me_fw_control_motion_vector:6;
        RBus_UInt32  pan_me_fw_control_motion_vector_det:1;
    };
}di_im_di_hmc_pan_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_3:4;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_2:4;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_1:4;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_th2:6;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_th1:6;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_th0:6;
    };
}di_im_di_hmc_pan_add_bias_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  pan_mc_rls_sobel_diff_min_th:5;
        RBus_UInt32  pan_me_invalid_check_maxmin_diff_thd:5;
        RBus_UInt32  pan_me_invalid_check_cnt_thd:5;
        RBus_UInt32  res2:1;
        RBus_UInt32  hme_sum_max_ratio:7;
    };
}di_im_di_hmc_pan_control_par_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_sub_pixel_diff_thd:8;
        RBus_UInt32  res1:7;
        RBus_UInt32  hme_avoid_rltype_vertical_pan_nedge_thd:4;
        RBus_UInt32  hme_avoid_rltype_vertical_pan_rledge_thd:5;
        RBus_UInt32  pan_mc_adaptive_compensation_teeth_thd:8;
    };
}di_im_di_hmc_pan_control_par_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_half_mv_correct_weight1:4;
        RBus_UInt32  hmc_half_mv_correct_weight2:4;
        RBus_UInt32  res1:24;
    };
}di_im_di_hmc_pan_vertical_intra_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_half_mv_correct_weight3:4;
        RBus_UInt32  hmc_half_mv_correct_weight4:4;
        RBus_UInt32  res1:24;
    };
}di_im_di_hmc_pan_vertical_intra_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  hmc_half_mv_correct_prediff_th:6;
        RBus_UInt32  hmc_half_mv_correct_nextdiff_th:6;
        RBus_UInt32  hmc_half_mv_correct_energy_th1:6;
        RBus_UInt32  hmc_half_mv_correct_energy_th2:6;
        RBus_UInt32  hmc_half_mv_correct_energy_th3:6;
    };
}di_im_di_hmc_pan_dummy_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_half_mv_energy_check_pre_th:5;
        RBus_UInt32  hmc_half_mv_energy_check_pre_gain:6;
        RBus_UInt32  hmc_half_mv_energy_check_nxt_th:5;
        RBus_UInt32  hmc_half_mv_energy_check_nxt_gain:6;
        RBus_UInt32  hmc_half_mv_notteeth_recover_hline_th:8;
        RBus_UInt32  res1:2;
    };
}di_im_di_hmc_pan_dummy_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy18024684_31_29:3;
        RBus_UInt32  hmc_blending_with_ma_en:1;
        RBus_UInt32  hmc_blending_with_ma_gain_en:1;
        RBus_UInt32  hmc_blending_with_ma_gain_factor:4;
        RBus_UInt32  hmc_blending_with_ma_gain:6;
        RBus_UInt32  hmc_half_mv_all_teeth_check_th:6;
        RBus_UInt32  hmc_half_mv_correct_energy_bias:3;
        RBus_UInt32  hmc_half_mv_notteeth_recover_dline_th:8;
    };
}di_im_di_hmc_pan_dummy_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  rtnr_ma_snr_blending_factor5:4;
        RBus_UInt32  rtnr_ma_snr_blending_factor4:4;
        RBus_UInt32  rtnr_ma_snr_blending_factor3:4;
        RBus_UInt32  rtnr_ma_snr_blending_factor2:4;
        RBus_UInt32  rtnr_ma_snr_blending_factor1:4;
        RBus_UInt32  rtnr_ma_isnr_debug_mode_selection:2;
        RBus_UInt32  rtnr_ma_isnr_debug_mode_en:1;
        RBus_UInt32  rtnr_ma_snr_debug_mode_selection:2;
        RBus_UInt32  rtnr_ma_snr_debug_mode_en:1;
        RBus_UInt32  rtnr_ma_snr_mask:1;
        RBus_UInt32  rtnr_ma_snr_en:1;
    };
}di_rtnr_ma_snr_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_snr_motion_th4_low:8;
        RBus_UInt32  rtnr_ma_snr_motion_th3_low:8;
        RBus_UInt32  rtnr_ma_snr_motion_th2_low:8;
        RBus_UInt32  rtnr_ma_snr_motion_th1_low:8;
    };
}di_rtnr_ma_snr_motion_th_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_snr_motion_th4_high:8;
        RBus_UInt32  rtnr_ma_snr_motion_th3_high:8;
        RBus_UInt32  rtnr_ma_snr_motion_th2_high:8;
        RBus_UInt32  rtnr_ma_snr_motion_th1_high:8;
    };
}di_rtnr_ma_snr_motion_th_high_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  rtnr_ma_snr_edge_th_high:8;
        RBus_UInt32  rtnr_ma_snr_edge_th_low:8;
    };
}di_rtnr_ma_snr_motion_edge_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_snr_motion_slope4:8;
        RBus_UInt32  rtnr_ma_snr_motion_slope3:8;
        RBus_UInt32  rtnr_ma_snr_motion_slope2:8;
        RBus_UInt32  rtnr_ma_snr_motion_slope1:8;
    };
}di_rtnr_ma_snr_motion_th_slope_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  rtnr_ma_snr_strength:4;
        RBus_UInt32  rtnr_ma_snr_output_clamp:8;
        RBus_UInt32  rtnr_ma_snr_edge_curve_slope:8;
        RBus_UInt32  rtnr_ma_snr_edge_curve_lo_th:8;
    };
}di_rtnr_ma_snr_strength_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  rtnr_output_clamp_en:1;
        RBus_UInt32  rtnr_output_clamp_chroma:8;
        RBus_UInt32  rtnr_output_clamp_luma:8;
    };
}di_rtnr_output_clamp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_elseintra_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_stillsad_th:5;
        RBus_UInt32  smd_fw_gmvy:3;
        RBus_UInt32  smd_stillsad_max:5;
        RBus_UInt32  res2:16;
    };
}di_di_smd_waterflag_ctr3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_hardwarepan_firststep:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_streammv_gmv_diff:5;
        RBus_UInt32  smd_gmvb_sadmin_th:4;
        RBus_UInt32  smd_fw_gmvx:3;
        RBus_UInt32  smd_firmwarepan_sadmax:9;
        RBus_UInt32  smd_searchmvapply_ctr:8;
    };
}di_di_smd_hardwarepan_modify1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gst_subpixel_compensate_en:1;
        RBus_UInt32  gst_debug_subpixel_pan:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  gst_subpixel_rlv2intra_en:1;
        RBus_UInt32  gst_integerpan_highpriority:1;
        RBus_UInt32  gst_pg_highpriority:1;
        RBus_UInt32  gst_compensate_fmv0_en:1;
        RBus_UInt32  gst_compensate_fmv1_en:1;
        RBus_UInt32  gst_compensate_fmv2_en:1;
        RBus_UInt32  gst_compensate_fmv3_en:1;
        RBus_UInt32  gst_compensate_fmv4_en:1;
        RBus_UInt32  gst_compensate_fmv5_en:1;
        RBus_UInt32  gst_compensate_fmv6_en:1;
        RBus_UInt32  gst_compensate_fmv7_en:1;
        RBus_UInt32  gst_compensate_fmv8_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  gst_compensate_blending_en:1;
        RBus_UInt32  gst_blend_weight:2;
        RBus_UInt32  res3:3;
        RBus_UInt32  gst_subpixel_firmwarepan:1;
        RBus_UInt32  gst_subpixel_firmwarepan_fmv2:4;
        RBus_UInt32  gst_subpixel_firmwarepan_fmv1:4;
    };
}di_di_gst_compensate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  gst_subpixel_firmwarepan_sadmin:6;
        RBus_UInt32  res2:7;
        RBus_UInt32  gst_subpixel_firmwarepan_sadmax:9;
    };
}di_di_gst_fmv_pan_coeff1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_weavemode_check_en:1;
        RBus_UInt32  res1:19;
        RBus_UInt32  ma_weavemode_check_gain:4;
        RBus_UInt32  ma_weavemode_check_th:8;
    };
}di_di_ma_weavemode_check_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_r5_sum:16;
        RBus_UInt32  hmcnr_r4_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_r3_sum:16;
        RBus_UInt32  hmcnr_r2_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_r1_sum:16;
        RBus_UInt32  hmcnr_c0_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_l1_sum:16;
        RBus_UInt32  hmcnr_l2_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_l3_sum:16;
        RBus_UInt32  hmcnr_l4_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_l5_sum:16;
        RBus_UInt32  dummy18024858_15_0:16;
    };
}di_im_di_rtnr_hmcnr_statistic_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  cp_temporal_mad_y_th3:11;
        RBus_UInt32  res2:5;
        RBus_UInt32  cp_temporal_mad_c_th3:11;
    };
}di_im_di_rtnr_mad_y_th2_c_th2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cp_temporal_mad_countery2:21;
    };
}di_im_di_rtnr_mad_y_counter_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cp_temporal_mad_countery3:21;
    };
}di_im_di_rtnr_mad_y_counter_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cp_temporal_mad_counteru2:21;
    };
}di_im_di_rtnr_mad_u_counter_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cp_temporal_mad_counteru3:21;
    };
}di_im_di_rtnr_mad_u_counter_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cp_temporal_mad_counterv2:21;
    };
}di_im_di_rtnr_mad_v_counter_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cp_temporal_mad_counterv3:21;
    };
}di_im_di_rtnr_mad_v_counter_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vhf_energy_th0:8;
        RBus_UInt32  vhf_fm_offset_th4:4;
        RBus_UInt32  vhf_fm_offset_th3:4;
        RBus_UInt32  vhf_fm_offset_th2:4;
        RBus_UInt32  vhf_fm_offset_th1:4;
        RBus_UInt32  vhf_en:1;
        RBus_UInt32  vhf_check_mode:2;
        RBus_UInt32  vhf_teeth_depth_th:5;
    };
}di_im_di_ma_vhf_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vhf_energy_th4:8;
        RBus_UInt32  vhf_energy_th3:8;
        RBus_UInt32  vhf_energy_th2:8;
        RBus_UInt32  vhf_energy_th1:8;
    };
}di_im_di_ma_vhf_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vhf_energy_slop4:8;
        RBus_UInt32  vhf_energy_slop3:8;
        RBus_UInt32  vhf_energy_slop2:8;
        RBus_UInt32  vhf_energy_slop1:8;
    };
}di_im_di_ma_vhf_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  nintra_sr_minus_value:1;
        RBus_UInt32  nintra_ud_boundary_repeat_en:1;
        RBus_UInt32  nintra_n_check2_control_disable:1;
        RBus_UInt32  nintra_check2_y_diff_th:8;
        RBus_UInt32  nintra_lowpass_dir_count_th:4;
        RBus_UInt32  nintra_output_lowpass_en:1;
        RBus_UInt32  nintra_dyn_dir_lowpass_en:1;
        RBus_UInt32  nintra_preline_dir_check2_en:1;
        RBus_UInt32  nintra_preline_dir_check1_en:1;
        RBus_UInt32  nintra_lowpass_dir_check_en:1;
        RBus_UInt32  nintra_pre_dir_check_en:1;
        RBus_UInt32  nintra_min_second_dir_check2_en:1;
        RBus_UInt32  nintra_min_second_dir_check_en:1;
        RBus_UInt32  nintra_dynamic_cross_th_en:1;
        RBus_UInt32  nintra_intersection_check_en:1;
        RBus_UInt32  nintra_high_freq_detect_en:1;
        RBus_UInt32  nintra_search_min_limit_en:1;
        RBus_UInt32  nintra_vbound_detect_en:1;
        RBus_UInt32  nintra_ydiff_mode:1;
        RBus_UInt32  nintra_new_mode_en:1;
        RBus_UInt32  nintra_src_lpf_clamp_en:1;
    };
}di_im_di_nintra_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nintra_lp_src_yclamp_th:8;
        RBus_UInt32  nintra_lp_src_edge_slope:8;
        RBus_UInt32  nintra_lp_src_edge_th2:8;
        RBus_UInt32  nintra_lp_src_edge_th1:8;
    };
}di_im_di_nintra_lowpass_source_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  nintra_dir_search_region_max:4;
        RBus_UInt32  nintra_hdiff_th2:8;
        RBus_UInt32  nintra_hdiff_th1:8;
    };
}di_im_di_nintra_search_dir_limit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  nintra_crossslope_diff_th:8;
        RBus_UInt32  nintra_crossdiff_th:8;
        RBus_UInt32  nintra_slopediff_th:8;
    };
}di_im_di_nintra_intersection_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nintra_minsecond_diff_th3:8;
        RBus_UInt32  nintra_minsecond_diff_th2:8;
        RBus_UInt32  nintra_vertical_diff_th:8;
        RBus_UInt32  nintra_minsecond_diff_th:8;
    };
}di_im_di_nintra_1st_2nd_ydiff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  nintra_trans_count_th2:8;
        RBus_UInt32  nintra_trans_count_th1:8;
        RBus_UInt32  nintra_hfq_hdiff_th:8;
    };
}di_im_di_nintra_high_freq_limit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_hmc_me_refine_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_teeth_total:8;
        RBus_UInt32  hmc_teeth_of_line_th:8;
        RBus_UInt32  res1:10;
        RBus_UInt32  hmc_fw_ctrl_bypass:1;
        RBus_UInt32  res2:5;
    };
}di_im_di_hmc_me_refine_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_hmc_me_refine_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_hmc_me_refine_ctrl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_hmc_me_refine_ctrl_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  n_mcnr_old_search_range_en:1;
        RBus_UInt32  n_mcnr_mv_diff_max_en:1;
        RBus_UInt32  n_mcnr_debug_mode_select:3;
        RBus_UInt32  hori_boundary_th:4;
        RBus_UInt32  res2:5;
        RBus_UInt32  n_mcnr_debug_mode_en:1;
        RBus_UInt32  n_rtnr_c_k_select:1;
        RBus_UInt32  n_mcnr_y_k_select_mc:1;
        RBus_UInt32  n_rtnr_y_k_select:1;
        RBus_UInt32  n_mcnr_weight_clamp_en:1;
        RBus_UInt32  n_mcnr_weight_avg_en:1;
        RBus_UInt32  n_c_zero_mv_k_en:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  n_mv_diff_distance_select:1;
        RBus_UInt32  n_zero_mv_gain8_en:1;
        RBus_UInt32  n_y_zero_mv_k_en:1;
        RBus_UInt32  n_h_pan_zeromv_penalty_en:1;
        RBus_UInt32  n_h_pan_flag:1;
        RBus_UInt32  n_mcnr_new_en:1;
    };
}di_im_new_mcnr_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  h_pan_mv_value:5;
        RBus_UInt32  h_pan_mv_penalty:8;
    };
}di_im_new_mcnr_pan_condition_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  sad_min_slope:4;
        RBus_UInt32  mv_diff_slope:4;
        RBus_UInt32  sad_min_th:8;
        RBus_UInt32  mv_diff_th:8;
    };
}di_im_new_mcnr_weighting_condition_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  n_mcnr_weight3:4;
        RBus_UInt32  n_mcnr_weight2:4;
        RBus_UInt32  n_mcnr_weight1:4;
        RBus_UInt32  n_mcnr_weight_mode:1;
        RBus_UInt32  n_mcnr_weight_avg_mode:1;
        RBus_UInt32  mcnr_weight_clamp_loth:5;
        RBus_UInt32  mcnr_weight_clamp_upth:5;
        RBus_UInt32  res2:4;
    };
}di_im_new_mcnr_clamping_value_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l16_linesum:8;
        RBus_UInt32  hmc_l15_linesum:8;
        RBus_UInt32  hmc_l14_linesum:8;
        RBus_UInt32  hmc_l13_linesum:8;
    };
}di_im_di_hme_line_statistic_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l12_linesum:8;
        RBus_UInt32  hmc_l11_linesum:8;
        RBus_UInt32  hmc_l10_linesum:8;
        RBus_UInt32  hmc_l9_linesum:8;
    };
}di_im_di_hme_line_statistic_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l8_linesum:8;
        RBus_UInt32  hmc_l7_linesum:8;
        RBus_UInt32  hmc_l6_linesum:8;
        RBus_UInt32  hmc_l5_linesum:8;
    };
}di_im_di_hme_line_statistic_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l4_linesum:8;
        RBus_UInt32  hmc_l3_linesum:8;
        RBus_UInt32  hmc_l2_linesum:8;
        RBus_UInt32  hmc_l1_linesum:8;
    };
}di_im_di_hme_line_statistic_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_c0_linesum:8;
        RBus_UInt32  hmc_r1_linesum:8;
        RBus_UInt32  hmc_r2_linesum:8;
        RBus_UInt32  hmc_r3_linesum:8;
    };
}di_im_di_hme_line_statistic_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r4_linesum:8;
        RBus_UInt32  hmc_r5_linesum:8;
        RBus_UInt32  hmc_r6_linesum:8;
        RBus_UInt32  hmc_r7_linesum:8;
    };
}di_im_di_hme_line_statistic_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r8_linesum:8;
        RBus_UInt32  hmc_r9_linesum:8;
        RBus_UInt32  hmc_r10_linesum:8;
        RBus_UInt32  hmc_r11_linesum:8;
    };
}di_im_di_hme_line_statistic_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r12_linesum:8;
        RBus_UInt32  hmc_r13_linesum:8;
        RBus_UInt32  hmc_r14_linesum:8;
        RBus_UInt32  hmc_r15_linesum:8;
    };
}di_im_di_hme_line_statistic_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r16_linesum:8;
        RBus_UInt32  res1:12;
        RBus_UInt32  hmc_linesum_step_mv_diff_th:4;
        RBus_UInt32  hmc_linesum_step_tolerance:4;
        RBus_UInt32  hmc_linesum_step:4;
    };
}di_im_di_hme_line_statistic_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_comp_en:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  di_ddr_error_count:24;
    };
}di_di_ddr_checksum_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_flag_127_96:32;
    };
}di_di_ddr_checksum_flag_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_flag_95_64:32;
    };
}di_di_ddr_checksum_flag_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_flag_63_32:32;
    };
}di_di_ddr_checksum_flag_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_flag_31_0:32;
    };
}di_di_ddr_checksum_flag_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_mask_127_96:32;
    };
}di_di_ddr_checksum_mask_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_mask_95_64:32;
    };
}di_di_ddr_checksum_mask_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_mask_63_32:32;
    };
}di_di_ddr_checksum_mask_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_mask_31_0:32;
    };
}di_di_ddr_checksum_mask_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_mad_min_uv_th:8;
        RBus_UInt32  n_mcnr_mad_min_th:8;
        RBus_UInt32  res1:4;
        RBus_UInt32  n_mcnr_y_boundary_th:4;
        RBus_UInt32  n_mcnr_v_pre_loadok_clr:1;
        RBus_UInt32  n_mcnr_v_pre_loadok:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  cp_temporal_hmcnr_search_range:4;
    };
}di_im_new_mcnr_control2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  smd_sawtooth_count_th_wf:8;
        RBus_UInt32  smd_min_total_th_wf:4;
        RBus_UInt32  smd_compensate_teeth_th_wf:4;
        RBus_UInt32  smd_totalteethoffset_wf:4;
        RBus_UInt32  smd_currteethgain_wf:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  smd_debugsawtooth_waterflow_en:1;
        RBus_UInt32  smd_waterflow_protect_en:1;
    };
}di_di_smd_waterflow_teeth_ctr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  smd_sawtooth_count_wf:16;
    };
}di_di_smd_waterflow_teeth_count_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_spatialmv_method:1;
        RBus_UInt32  smd_db_tmv_out:1;
        RBus_UInt32  smd_db_tmv_shift:1;
        RBus_UInt32  smd_still_ma_en:1;
        RBus_UInt32  smd_mv0_no_intra_en:1;
        RBus_UInt32  smd_outdata_limit_mvy:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  smd_outdata_limit_mvx:2;
        RBus_UInt32  res3:3;
        RBus_UInt32  smd_outdata_limit_en:1;
        RBus_UInt32  smd_spatial_mv_diff_gain:4;
        RBus_UInt32  smd_spatial_mv_diff_coring:4;
        RBus_UInt32  res4:2;
        RBus_UInt32  smd_odd_mvy_ma_out_select:1;
        RBus_UInt32  smd_smd_weight_out_debug_en:1;
        RBus_UInt32  smd_spatial_mv_diff_weight_en:1;
        RBus_UInt32  smd_smd_blend_clamp_en:1;
        RBus_UInt32  smd_smd_blend_lpf_en:1;
        RBus_UInt32  smd_outofrange_lpf_en:1;
    };
}di_di_smd_ma_mc_weight_ctr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  smd_smd_ma_only_center_en:1;
        RBus_UInt32  smd_smd_ma_only_v_en:1;
        RBus_UInt32  smd_smd_vs_detect_length:1;
        RBus_UInt32  nintra_v_dir_flag_en:1;
        RBus_UInt32  nintra_h_diff_th:8;
        RBus_UInt32  nintra_hv_diff_th:8;
        RBus_UInt32  smd_diag_count_th:3;
        RBus_UInt32  smd_intra_weight_method_vpan:1;
        RBus_UInt32  smd_intra_weight_method:1;
        RBus_UInt32  smd_mcdi2madi_debug_en:1;
        RBus_UInt32  smd_mcdi2madi_v_pan_new_en:1;
        RBus_UInt32  smd_mcdi2madi_en:1;
    };
}di_di_smd_diag_edge_protect_ctr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_resurrectsmallwindownum2:4;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_mv_pixel_acc_th2:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_mv_pixel_acc_th:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  smd_mv_pixel_acc_max_th:3;
        RBus_UInt32  smd_weight_lpf_select:1;
        RBus_UInt32  smd_outrange_teeth_select:2;
        RBus_UInt32  smd_teeth_value_select:1;
        RBus_UInt32  gst_min_sad_nolimit_en:1;
        RBus_UInt32  gst_gst_static_disable:1;
        RBus_UInt32  gst_min_sad_compare_diable:1;
        RBus_UInt32  smd_linecontinous_new_condition:1;
        RBus_UInt32  smd_weave_dynamic:2;
        RBus_UInt32  smd_spatialfreqnomatch_off:1;
        RBus_UInt32  smd_acc_smd_en:1;
        RBus_UInt32  smd_mess_conditionoff:1;
        RBus_UInt32  smd_sawtooth_condition_select:1;
        RBus_UInt32  smd_outofrange_content_new:1;
        RBus_UInt32  smd_acc_ctr_reset:1;
    };
}di_di_smd_slow_motion_handle1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_mv_pixel_acc_th3:3;
        RBus_UInt32  smd_messlevel_gain2:4;
        RBus_UInt32  smd_messlevel_gain:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  gst_mv_limit:2;
        RBus_UInt32  smd_resurrectminsadth2:8;
        RBus_UInt32  smd_reliablerangesadth2:8;
    };
}di_di_smd_slow_motion_handle2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_r10_sum:16;
        RBus_UInt32  mcnr_r9_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_r8_sum:16;
        RBus_UInt32  mcnr_r7_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_r6_sum:16;
        RBus_UInt32  mcnr_l6_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_l7_sum:16;
        RBus_UInt32  mcnr_l8_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_l9_sum:16;
        RBus_UInt32  mcnr_l10_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_outrange_field_diff_th:8;
        RBus_UInt32  smd_compensate_teeth_th2:4;
        RBus_UInt32  smd_field_diff_clamp:8;
        RBus_UInt32  smd_messlevel_vgain:3;
        RBus_UInt32  res1:2;
        RBus_UInt32  ma_smd_h_compensate_new_en:1;
        RBus_UInt32  smd_teeth_no_ressurrect_n_en:1;
        RBus_UInt32  smd_search_range_limit_en:1;
        RBus_UInt32  smd_hd_zero_mv_sad_select:1;
        RBus_UInt32  smd_messlevel_select:2;
        RBus_UInt32  smd_sadwindow_select:1;
    };
}di_di_smd_slow_motion_handle3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  smd_messlevel_gain_slope:8;
        RBus_UInt32  smd_messlevel_th:8;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_notonly_zero_gmv:1;
        RBus_UInt32  smd_fmv_gmv_penalty_en:1;
        RBus_UInt32  smd_gmv_candidate_method:1;
    };
}di_di_smd_gmv_penalty_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  smd_messlevel_field_diff:8;
        RBus_UInt32  smd_gmv_clamp:8;
        RBus_UInt32  smd_gmv_sad_select:1;
        RBus_UInt32  smd_gmv_penalty_clamp_en:1;
        RBus_UInt32  smd_gmv_only_teeth_mess_gain_en:1;
        RBus_UInt32  smd_gmv_penalty_mess_gain_en:1;
    };
}di_di_smd_gmv_penalty_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  smd_mv_teeth_detect_en:1;
        RBus_UInt32  smd_notgmv_res_en:1;
        RBus_UInt32  smd_teeth_res_en:1;
        RBus_UInt32  smd_teeth_detect_method:1;
        RBus_UInt32  smd_gst_compensate_avg_en:1;
        RBus_UInt32  smd_mv_pixel_acc_th4:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_nongmv0_noacc_en:1;
        RBus_UInt32  smd_resurrect_noacc_en:1;
        RBus_UInt32  smd_mv_not_gmv_resurrect_en:1;
    };
}di_di_smd_resurrect_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_gmv1maxctr_fw:16;
        RBus_UInt32  smd_gmvctr_fw:16;
    };
}di_di_smd_gmv_fw_counter1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_gmv3maxctr_fw:16;
        RBus_UInt32  smd_gmv2maxctr_fw:16;
    };
}di_di_smd_gmv_fw_counter2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  smd_gmv1_y_fw:3;
        RBus_UInt32  res2:13;
        RBus_UInt32  smd_gmv1_x_fw:3;
    };
}di_di_smd_gmv1_value_fw_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  smd_gmv2_y_fw:3;
        RBus_UInt32  res2:13;
        RBus_UInt32  smd_gmv2_x_fw:3;
    };
}di_di_smd_gmv2_value_fw_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_dt_count_th2:4;
        RBus_UInt32  smd_dt_count_th1:4;
        RBus_UInt32  smd_c_teeth_disable:1;
        RBus_UInt32  gst_static_tmvdiff_th:5;
        RBus_UInt32  smd_tmv_acc3:2;
        RBus_UInt32  smd_tmv_acc2:2;
        RBus_UInt32  smd_tmv_acc1:2;
        RBus_UInt32  smd_tmvy_diff_th3:2;
        RBus_UInt32  smd_tmvx_diff_th3:2;
        RBus_UInt32  smd_tmvy_diff_th2:2;
        RBus_UInt32  smd_tmvx_diff_th2:2;
        RBus_UInt32  smd_tmvy_diff_th1:2;
        RBus_UInt32  smd_tmvx_diff_th1:2;
    };
}di_di_smd_tmv_similarity_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_hori_diff_gain:5;
        RBus_UInt32  smd_hori_diff_th:7;
        RBus_UInt32  smd_teeth_th_tf:7;
        RBus_UInt32  smd_mad_th_tf:7;
        RBus_UInt32  smd_mv_pixel_acc_th5:3;
        RBus_UInt32  smd_teeth_pos:1;
        RBus_UInt32  smd_acc_teeth_count_en:1;
        RBus_UInt32  smd_teeth_vlpf_en:1;
    };
}di_di_smd_teeth_processing_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_u3_sum:16;
        RBus_UInt32  mcnr_u2_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_u1_sum:16;
        RBus_UInt32  mcnr_v0_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_d1_sum:16;
        RBus_UInt32  mcnr_d2_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_d3_sum:16;
        RBus_UInt32  mcnr_static_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_tmv_bz_select:2;
        RBus_UInt32  n_mcnr_mad_hist_shift_en:1;
        RBus_UInt32  n_mcnr_only_h_c_en:1;
        RBus_UInt32  n_mcnr_tmv_value0_en:1;
        RBus_UInt32  n_mcnr_mad_mv_nolimit_en:1;
        RBus_UInt32  n_mcnr_still_stat_disable:1;
        RBus_UInt32  n_mcnr_mad_stat_pos_select:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  n_mcnr_mad_hist_all_en:1;
        RBus_UInt32  n_mcnr_mv_mad_mv_gap:2;
        RBus_UInt32  n_mcnr_mv_mad_blending_vertical_en:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  n_mcnr_messlevel_th:8;
        RBus_UInt32  n_mcnr_mv_mad_mv_lo_th:4;
        RBus_UInt32  n_mcnr_mv_mad_blending_en:1;
        RBus_UInt32  n_mcnr_kfactor_lpf_large_select:1;
        RBus_UInt32  n_mcnr_kfactor_lpf_method:1;
        RBus_UInt32  n_mcnr_k_factor_lpf_en:1;
    };
}di_im_new_mcnr_control3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  n_mcnr_mad_uv_offset:8;
        RBus_UInt32  n_mcnr_mad_offset:8;
    };
}di_im_new_mcnr_mv_mad_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  blending_weight_range_max:8;
        RBus_UInt32  blending_weight_range_min:8;
        RBus_UInt32  res2:2;
        RBus_UInt32  blending_weight_replace_for_smd:1;
        RBus_UInt32  blending_weight_range_en:1;
        RBus_UInt32  blending_weight_teeth_compare_en:1;
        RBus_UInt32  blending_weight_edge_srlv_en:1;
        RBus_UInt32  blending_weight_mode:2;
    };
}di_im_di_ma_blending_weight_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  n_mcnr_diff_tmv_th2:2;
        RBus_UInt32  n_mcnr_diff_tmv_th1:2;
        RBus_UInt32  n_mcnr_tmv_diff_th6:4;
        RBus_UInt32  n_mcnr_tmv_diff_th5:4;
        RBus_UInt32  n_mcnr_tmv_diff_th4:4;
        RBus_UInt32  n_mcnr_tmv_diff_th3:4;
        RBus_UInt32  n_mcnr_tmv_diff_th2:4;
        RBus_UInt32  n_mcnr_tmv_diff_th1:4;
    };
}di_im_new_mcnr_tmv_diff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  n_mcnr_tmv_diff_range3:2;
        RBus_UInt32  n_mcnr_tmv_diff_range2:2;
        RBus_UInt32  n_mcnr_tmv_diff_range1:2;
        RBus_UInt32  n_mcnr_tmv0_diff_th3:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  n_mcnr_tmv0_diff_th2:2;
        RBus_UInt32  n_mcnr_tmv0_diff_th1:4;
        RBus_UInt32  res3:4;
        RBus_UInt32  n_mcnr_tmv_penalty_clamp_en:1;
        RBus_UInt32  res4:3;
    };
}di_im_new_mcnr_tmv_penalty_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  n_mcnr_tmv_penalty7:4;
        RBus_UInt32  n_mcnr_tmv_penalty6:4;
        RBus_UInt32  n_mcnr_tmv_penalty5:4;
        RBus_UInt32  n_mcnr_tmv_penalty4:4;
        RBus_UInt32  n_mcnr_tmv_penalty3:4;
        RBus_UInt32  n_mcnr_tmv_penalty2:4;
        RBus_UInt32  n_mcnr_tmv_penalty1:4;
    };
}di_im_new_mcnr_tmv_penalty_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  n_mcnr_diff_tmv_pan_th2:2;
        RBus_UInt32  n_mcnr_diff_tmv_pan_th1:2;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th6:4;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th5:4;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th4:4;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th3:4;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th2:4;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th1:4;
    };
}di_im_new_mcnr_tmv_gmv_diff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  n_mcnr_pan_diff_range1_v:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  n_mcnr_pan_diff_range2:2;
        RBus_UInt32  n_mcnr_pan_diff_range1:2;
        RBus_UInt32  res3:4;
        RBus_UInt32  n_mcnr_pan_penalty_th1:4;
        RBus_UInt32  n_mcnr_pan_penalty_clamp_en:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  n_mcnr_pan_penalty_select:2;
    };
}di_im_new_mcnr_gmv_penalty_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  n_mcnr_pan_penalty7:4;
        RBus_UInt32  n_mcnr_pan_penalty6:4;
        RBus_UInt32  n_mcnr_pan_penalty5:4;
        RBus_UInt32  n_mcnr_pan_penalty4:4;
        RBus_UInt32  n_mcnr_pan_penalty3:4;
        RBus_UInt32  n_mcnr_pan_penalty2:4;
        RBus_UInt32  n_mcnr_pan_penalty1:4;
    };
}di_im_new_mcnr_gmv_penalty_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_mv_hist_shift:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  n_mcnr_vmv_th2:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  n_mcnr_vmv_th1:4;
        RBus_UInt32  res3:3;
        RBus_UInt32  n_mcnr_hmv_th2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  n_mcnr_hmv_th1:5;
    };
}di_im_new_mcnr_gmv_hist_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_k_debug_value_start:4;
        RBus_UInt32  n_mcnr_k_debug_value_offset:4;
        RBus_UInt32  n_mcnr_debug_blocksize_v:8;
        RBus_UInt32  n_mcnr_debug_blocksize_h:8;
        RBus_UInt32  n_mcnr_vector_debug_gain:4;
        RBus_UInt32  n_mcnr_debug_422_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  n_mcnr_mv_select_debug:2;
    };
}di_im_new_mcnr_mv_debug_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_u5_sum:16;
        RBus_UInt32  mcnr_u4_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_d4_sum:16;
        RBus_UInt32  mcnr_d5_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_u6_sum:16;
        RBus_UInt32  mcnr_d6_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_l14_sum:16;
        RBus_UInt32  mcnr_l15_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_l12_sum:16;
        RBus_UInt32  mcnr_l13_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_r11_sum:16;
        RBus_UInt32  mcnr_l11_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_r13_sum:16;
        RBus_UInt32  mcnr_r12_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_r15_sum:16;
        RBus_UInt32  mcnr_r14_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_k_limit_mv_th:4;
        RBus_UInt32  n_mcnr_k_limit_hi:4;
        RBus_UInt32  n_mcnr_k_limit_lo:4;
        RBus_UInt32  n_mcnr_k_limit_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  n_mcnr_mad_hist_clip:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  n_mcnr_messlevel_shift:1;
        RBus_UInt32  tmv_no_reset_flag:1;
        RBus_UInt32  n_mcnr_v_pan_mv:4;
        RBus_UInt32  res3:1;
        RBus_UInt32  n_mcnr_v_search_range:3;
    };
}di_im_new_mcnr_control4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  nintra_min_second_diff_th4:8;
        RBus_UInt32  nintra_vertical_diff_th2:8;
    };
}di_im_di_nintra_1st_2nd_ydiff_th_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_penalty_clamp_slope:8;
        RBus_UInt32  n_mcnr_messlevel_lo_th:8;
        RBus_UInt32  n_mcnr_messlevel_hi_th:8;
        RBus_UInt32  n_mcnr_penalty_clamp_lo:4;
        RBus_UInt32  n_mcnr_penalty_clamp_hi:4;
    };
}di_im_new_mcnr_penalty_clamp_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  n_mcnr_y_boundary_th2:8;
        RBus_UInt32  n_mcnr_x_boundary_th2:8;
    };
}di_im_new_mcnr_statistic_boundary_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth3_l:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth2_l:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth1_l:8;
    };
}di_rtnr_ma_isnr_getmotion_motionth_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth3_m:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth2_m:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth1_m:8;
    };
}di_rtnr_ma_isnr_getmotion_motionth_mid_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth3_n:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth2_n:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth1_n:8;
    };
}di_rtnr_ma_isnr_getmotion_motionth_mid2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth3_h:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth2_h:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth1_h:8;
    };
}di_rtnr_ma_isnr_getmotion_motionth_high_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope3_lm:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope2_lm:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope1_lm:8;
    };
}di_rtnr_ma_isnr_getmotion_edgeslopelm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope3_mn:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope2_mn:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope1_mn:8;
    };
}di_rtnr_ma_isnr_getmotion_edgeslopemn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope3_nh:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope2_nh:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope1_nh:8;
    };
}di_rtnr_ma_isnr_getmotion_edgeslopenh_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeth4:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeth3:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeth2:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeth1:8;
    };
}di_rtnr_ma_isnr_getmotion_edge_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_isnr_getmotion_en:1;
        RBus_UInt32  rtnr_isnr_filmmotion_update:1;
        RBus_UInt32  res1:20;
        RBus_UInt32  rtnr_ma_isnr_getmotion_ydiffmask:2;
        RBus_UInt32  res2:3;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgemask:1;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionoffset:4;
    };
}di_rtnr_ma_isnr_getmotion_main_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  nintra_dy_vertical_diff_th_en:1;
        RBus_UInt32  nintra_diff_s_v_divd:1;
        RBus_UInt32  nintra_dy_hdiff_th_en:1;
        RBus_UInt32  nintra_hdiff_th2_lo:4;
        RBus_UInt32  nintra_hdiff_th1_lo:4;
    };
}di_im_di_nintra_dyn_search_range_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  di_color_bar_mode_en:2;
        RBus_UInt32  res2:17;
        RBus_UInt32  di_color_bar_vertical_mode:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  di_color_num:2;
    };
}di_di_ptg_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  di_i_c0y_92b:8;
        RBus_UInt32  di_i_c0cr_92b:8;
        RBus_UInt32  di_i_c0cb_92b:8;
    };
}di_di_ptg_c0y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  di_i_c1y_92b:8;
        RBus_UInt32  di_i_c1cr_92b:8;
        RBus_UInt32  di_i_c1cb_92b:8;
    };
}di_di_ptg_c1y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  di_i_c2y_92b:8;
        RBus_UInt32  di_i_c2cr_92b:8;
        RBus_UInt32  di_i_c2cb_92b:8;
    };
}di_di_ptg_c2y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  di_i_c3y_92b:8;
        RBus_UInt32  di_i_c3cr_92b:8;
        RBus_UInt32  di_i_c3cb_92b:8;
    };
}di_di_ptg_c3y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  di_i_c4y_92b:8;
        RBus_UInt32  di_i_c4cr_92b:8;
        RBus_UInt32  di_i_c4cb_92b:8;
    };
}di_di_ptg_c4y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  di_i_c5y_92b:8;
        RBus_UInt32  di_i_c5cr_92b:8;
        RBus_UInt32  di_i_c5cb_92b:8;
    };
}di_di_ptg_c5y_cr_cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  di_i_c6y_92b:8;
        RBus_UInt32  di_i_c6cr_92b:8;
        RBus_UInt32  di_i_c6cb_92b:8;
    };
}di_di_ptg_c6y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  di_i_c7y_92b:8;
        RBus_UInt32  di_i_c7cr_92b:8;
        RBus_UInt32  di_i_c7cb_92b:8;
    };
}di_di_ptg_c7y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  di_ptg_length:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  di_ptg_width:14;
    };
}di_di_ptg_act_window_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  di_sram_sfrx_debug_bit_sel_dc:8;
        RBus_UInt32  res2:7;
        RBus_UInt32  di_sram_sfrx_fail_bit_status_ro_dc:1;
        RBus_UInt32  di_sram_sftx_sf_tx_mode_dc:1;
        RBus_UInt32  di_sram_sftx_sf_tx_start_dc:1;
        RBus_UInt32  di_sram_sftx_sf_tx_work_ro_dc:1;
        RBus_UInt32  di_sram_sfrx_sf_rx_gated_dc:1;
        RBus_UInt32  di_sram_sfrx_sf_rx_mode_dc:1;
        RBus_UInt32  di_sram_sfrx_sf_rx_start_dc:1;
        RBus_UInt32  di_sram_sfrx_sf_rx_done_ro_dc:1;
        RBus_UInt32  di_sram_sfrx_sf_rx_err_ro_dc:1;
    };
}di_di_di_sram_self_test_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  timing_monitor_en:1;
        RBus_UInt32  timing_monitor_i2rnd_mode:2;
        RBus_UInt32  timing_monitor_src:1;
        RBus_UInt32  timing_monitor_unit:1;
        RBus_UInt32  timing_monitor_multi_mode:1;
        RBus_UInt32  timing_monitor_compare:2;
        RBus_UInt32  res1:8;
        RBus_UInt32  timing_monitor_sta0:4;
        RBus_UInt32  timing_monitor_end0:4;
        RBus_UInt32  timing_monitor_sta1:4;
        RBus_UInt32  timing_monitor_end1:4;
    };
}di_ccdinr_timing_monitor_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  timing_monitor_sta2:4;
        RBus_UInt32  timing_monitor_end2:4;
        RBus_UInt32  timing_monitor_sta3:4;
        RBus_UInt32  timing_monitor_end3:4;
        RBus_UInt32  timing_monitor_sta4:4;
        RBus_UInt32  timing_monitor_end4:4;
        RBus_UInt32  timing_monitor_sta5:4;
        RBus_UInt32  timing_monitor_end5:4;
    };
}di_ccdinr_timing_monitor_multi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_compare_th:28;
    };
}di_ccdinr_timing_monitor_compare_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_golden:28;
    };
}di_ccdinr_timing_monitor_golden_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_previous1:28;
    };
}di_ccdinr_timing_monitor_result1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_previous2:28;
    };
}di_ccdinr_timing_monitor_result2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_previous3:28;
    };
}di_ccdinr_timing_monitor_result3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_previous4:28;
    };
}di_ccdinr_timing_monitor_result4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_max:28;
    };
}di_ccdinr_timing_monitor_max_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_min:28;
    };
}di_ccdinr_timing_monitor_min_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  compare_hit:1;
        RBus_UInt32  hsync_hit_den_error:1;
        RBus_UInt32  vsync_hit_den_error:1;
    };
}di_ccdinr_timing_monitor_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  timing_monitor_en_1:1;
        RBus_UInt32  timing_monitor_i2rnd_mode_1:2;
        RBus_UInt32  timing_monitor_src_1:1;
        RBus_UInt32  timing_monitor_unit_1:1;
        RBus_UInt32  timing_monitor_multi_mode_1:1;
        RBus_UInt32  timing_monitor_compare_1:2;
        RBus_UInt32  res1:8;
        RBus_UInt32  timing_monitor_sta0_1:4;
        RBus_UInt32  timing_monitor_end0_1:4;
        RBus_UInt32  timing_monitor_sta1_1:4;
        RBus_UInt32  timing_monitor_end1_1:4;
    };
}di_ccdinr_timing_monitor_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  timing_monitor_sta2_1:4;
        RBus_UInt32  timing_monitor_end2_1:4;
        RBus_UInt32  timing_monitor_sta3_1:4;
        RBus_UInt32  timing_monitor_end3_1:4;
        RBus_UInt32  timing_monitor_sta4_1:4;
        RBus_UInt32  timing_monitor_end4_1:4;
        RBus_UInt32  timing_monitor_sta5_1:4;
        RBus_UInt32  timing_monitor_end5_1:4;
    };
}di_ccdinr_timing_monitor_multi_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_compare_th_1:28;
    };
}di_ccdinr_timing_monitor_compare_th_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_golden_1:28;
    };
}di_ccdinr_timing_monitor_golden_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_previous1_1:28;
    };
}di_ccdinr_timing_monitor_result1_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_previous2_1:28;
    };
}di_ccdinr_timing_monitor_result2_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_previous3_1:28;
    };
}di_ccdinr_timing_monitor_result3_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_previous4_1:28;
    };
}di_ccdinr_timing_monitor_result4_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_max_1:28;
    };
}di_ccdinr_timing_monitor_max_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  t_m_result_min_1:28;
    };
}di_ccdinr_timing_monitor_min_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  compare_hit_1:1;
        RBus_UInt32  hsync_hit_den_error_1:1;
        RBus_UInt32  vsync_hit_den_error_1:1;
    };
}di_ccdinr_timing_monitor_st_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_en:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  cmp_width_div32:9;
        RBus_UInt32  res2:2;
        RBus_UInt32  cmp_height:14;
    };
}di_di_pq_cmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_line_sum_bit:16;
        RBus_UInt32  cmp_400_old_mode_en:1;
        RBus_UInt32  cmp_pair_para:4;
        RBus_UInt32  cmp_jump4_en:1;
        RBus_UInt32  cmp_qp_mode:2;
        RBus_UInt32  cmp_dic_mode_en:1;
        RBus_UInt32  two_line_prediction_en:1;
        RBus_UInt32  cmp_line_mode:1;
        RBus_UInt32  cmp_data_color:1;
        RBus_UInt32  cmp_data_bit_width:2;
        RBus_UInt32  cmp_data_format:2;
    };
}di_di_pq_cmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  first_line_more_bit:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  block_limit_bit:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  line_limit_bit:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  frame_limit_bit:6;
    };
}di_di_pq_cmp_bit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  input_fifo_pause_cycle:4;
        RBus_UInt32  tail_dummy_throughput:1;
        RBus_UInt32  first_predict_nc_mode:1;
        RBus_UInt32  cmp_ctrl_para0:5;
        RBus_UInt32  g_ratio:5;
        RBus_UInt32  add_last2blk_over_curve_bit:1;
        RBus_UInt32  variation_maxmin_en:1;
        RBus_UInt32  dynamic_sum_line_rst:1;
        RBus_UInt32  blk0_add_en:1;
        RBus_UInt32  guarantee_max_qp_en:1;
        RBus_UInt32  dynamic_allocate_ratio_en:1;
        RBus_UInt32  poor_limit_min_qp_en:1;
        RBus_UInt32  balance_en:1;
        RBus_UInt32  fisrt_line_more_en:1;
        RBus_UInt32  blk0_add_half_en:1;
        RBus_UInt32  do_422_mode:2;
        RBus_UInt32  first_predict_nc_en:1;
        RBus_UInt32  not_enough_bit_do_422_en:1;
        RBus_UInt32  not_rich_do_422_en:1;
        RBus_UInt32  rb_lossy_do_422_en:1;
    };
}di_di_pq_cmp_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dic_mode_option:4;
        RBus_UInt32  res1:1;
        RBus_UInt32  not_enough_bit_do_422_qp:3;
        RBus_UInt32  not_rich_do_422_th:4;
        RBus_UInt32  res2:1;
        RBus_UInt32  rb_lossy_do_422_qp_level:3;
        RBus_UInt32  dic_mode_entry_th:4;
        RBus_UInt32  variation_value_th:4;
        RBus_UInt32  res3:1;
        RBus_UInt32  variation_num_th:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  variation_near_num_th:3;
    };
}di_di_pq_cmp_smooth_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dynamic_allocate_ratio_max:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  dynamic_allocate_ratio_min:5;
        RBus_UInt32  res3:5;
        RBus_UInt32  dynamic_allocate_line:3;
        RBus_UInt32  dynamic_allocate_more:4;
        RBus_UInt32  dynamic_allocate_less:4;
    };
}di_di_pq_cmp_allocate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  poor_limit_th_qp4:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  poor_limit_th_qp3:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  poor_limit_th_qp2:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  poor_limit_th_qp1:5;
    };
}di_di_pq_cmp_poor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  cmp_crc_ro_line_sel:14;
        RBus_UInt32  dic_mode_qp_th_rb:4;
        RBus_UInt32  dic_mode_qp_th_g:4;
        RBus_UInt32  guarantee_max_rb_qp:4;
        RBus_UInt32  guarantee_max_g_qp:4;
    };
}di_di_pq_cmp_guarantee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  variation_maxmin_th2:8;
        RBus_UInt32  variation_maxmin_th:8;
        RBus_UInt32  res1:2;
        RBus_UInt32  balance_rb_ov_th:2;
        RBus_UInt32  balance_rb_ud_th:2;
        RBus_UInt32  balance_rb_give:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  balance_g_ov_th:2;
        RBus_UInt32  balance_g_ud_th:2;
        RBus_UInt32  balance_g_give:2;
    };
}di_di_pq_cmp_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  prs_over_line_sum_bit_irq_en:1;
        RBus_UInt32  tail_fifo_overflow_irq_en:1;
        RBus_UInt32  input_fifo_overflow_irq_en:1;
        RBus_UInt32  block_fifo_overflow_irq_en:1;
        RBus_UInt32  input_size_more_irq_en:1;
        RBus_UInt32  input_size_less_irq_en:1;
        RBus_UInt32  over_flb_irq_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  request_fifo_even_overflow_irq_en:1;
        RBus_UInt32  request_fifo_odd_overflow_irq_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  g_fifo_even_overflow_irq_en:1;
        RBus_UInt32  r_fifo_even_overflow_irq_en:1;
        RBus_UInt32  b_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  g_fifo_odd_overflow_irq_en:1;
        RBus_UInt32  r_fifo_odd_overflow_irq_en:1;
        RBus_UInt32  b_fifo_odd_overflow_irq_en:1;
    };
}di_di_pq_cmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pqc_irq:1;
        RBus_UInt32  res1:12;
        RBus_UInt32  prs_over_line_sum_bit_st:1;
        RBus_UInt32  tail_fifo_overflow_st:1;
        RBus_UInt32  input_fifo_overflow_st:1;
        RBus_UInt32  block_fifo_overflow_st:1;
        RBus_UInt32  input_size_more_st:1;
        RBus_UInt32  input_size_less_st:1;
        RBus_UInt32  over_flb_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  request_fifo_even_overflow_st:1;
        RBus_UInt32  request_fifo_odd_overflow_st:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  g_fifo_even_overflow_st:1;
        RBus_UInt32  r_fifo_even_overflow_st:1;
        RBus_UInt32  b_fifo_even_overflow_st:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  g_fifo_odd_overflow_st:1;
        RBus_UInt32  r_fifo_odd_overflow_st:1;
        RBus_UInt32  b_fifo_odd_overflow_st:1;
    };
}di_di_pq_cmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_two_pixel_mode:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  g_ratio_max:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  g_ratio_min:5;
        RBus_UInt32  res3:2;
        RBus_UInt32  cmp_package_height_cnt:14;
    };
}di_di_pq_cmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  long_term_qp_measure_en:1;
        RBus_UInt32  cmp_ctrl_para1:7;
        RBus_UInt32  long_term_g_qp_max:4;
        RBus_UInt32  long_term_rb_qp_max:4;
        RBus_UInt32  cmp_ctrl_para2:8;
        RBus_UInt32  short_term_g_qp_max:4;
        RBus_UInt32  short_term_rb_qp_max:4;
    };
}di_di_pq_cmp_qp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_water_measure_en:1;
        RBus_UInt32  cmp_ctrl_para3:7;
        RBus_UInt32  fifo_water_even_g:8;
        RBus_UInt32  fifo_water_even_r:8;
        RBus_UInt32  fifo_water_even_b:8;
    };
}di_di_pq_cmp_fifo_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  fifo_water_odd_g:8;
        RBus_UInt32  fifo_water_odd_r:8;
        RBus_UInt32  fifo_water_odd_b:8;
    };
}di_di_pq_cmp_fifo_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  g_frame_left:16;
        RBus_UInt32  rb_frame_left:16;
    };
}di_di_pq_cmp_left_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  total_package_long_term:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  total_package_even:24;
    };
}di_di_pq_cmp_package_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_g:32;
    };
}di_di_pq_cmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_r:32;
    };
}di_di_pq_cmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_b:32;
    };
}di_di_pq_cmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_odd_g:32;
    };
}di_di_pq_cmp_crc_odd_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_odd_r:32;
    };
}di_di_pq_cmp_crc_odd_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_odd_b:32;
    };
}di_di_pq_cmp_crc_odd_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  total_package_odd:24;
    };
}di_di_pq_cmp_package_odd_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value0:6;
        RBus_UInt32  dic_mode_tolerance:8;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value32:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value16:6;
    };
}di_di_pq_cmp_blk0_add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value8:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value4:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value2:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  blk0_add_value1:6;
    };
}di_di_pq_cmp_blk0_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_en:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  decmp_width_div32:9;
        RBus_UInt32  res2:2;
        RBus_UInt32  decmp_height:14;
    };
}di_di_pq_decmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_line_sum_bit:16;
        RBus_UInt32  decmp_400_old_mode_en:1;
        RBus_UInt32  decmp_pair_para:4;
        RBus_UInt32  decmp_jump4_en:1;
        RBus_UInt32  decmp_qp_mode:2;
        RBus_UInt32  decmp_dic_mode_en:1;
        RBus_UInt32  decmp_two_line_prediction_en:1;
        RBus_UInt32  decmp_line_mode:1;
        RBus_UInt32  decmp_data_color:1;
        RBus_UInt32  decmp_data_bit_width:2;
        RBus_UInt32  decmp_data_format:2;
    };
}di_di_pq_decmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  decmp_crc_ro_line_sel:14;
        RBus_UInt32  decmp_ctrl_para:13;
        RBus_UInt32  saturation_type_delta:1;
        RBus_UInt32  saturation_type:1;
        RBus_UInt32  saturation_en:1;
    };
}di_di_pq_decmp_sat_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  not_finish_irq_even_en:1;
        RBus_UInt32  underflow_irq_even_en:1;
        RBus_UInt32  dic_error_even_en:1;
        RBus_UInt32  crc_r_error_even_en:1;
        RBus_UInt32  crc_g_error_even_en:1;
        RBus_UInt32  crc_b_error_even_en:1;
        RBus_UInt32  res2:10;
        RBus_UInt32  not_finish_irq_odd_en:1;
        RBus_UInt32  underflow_irq_odd_en:1;
        RBus_UInt32  dic_error_odd_en:1;
        RBus_UInt32  crc_r_error_odd_en:1;
        RBus_UInt32  crc_g_error_odd_en:1;
        RBus_UInt32  crc_b_error_odd_en:1;
    };
}di_di_pq_decmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pqdc_irq:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  in_fifo_overflow_even_st:1;
        RBus_UInt32  ring_r_overflow_even_st:1;
        RBus_UInt32  ring_g_overflow_even_st:1;
        RBus_UInt32  ring_b_overflow_even_st:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  not_finish_irq_even_st:1;
        RBus_UInt32  underflow_irq_even_st:1;
        RBus_UInt32  dic_error_even_st:1;
        RBus_UInt32  crc_r_error_even_st:1;
        RBus_UInt32  crc_g_error_even_st:1;
        RBus_UInt32  crc_b_error_even_st:1;
        RBus_UInt32  res3:4;
        RBus_UInt32  in_fifo_overflow_odd_st:1;
        RBus_UInt32  ring_r_overflow_odd_st:1;
        RBus_UInt32  ring_g_overflow_odd_st:1;
        RBus_UInt32  ring_b_overflow_odd_st:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  not_finish_irq_odd_st:1;
        RBus_UInt32  underflow_irq_odd_st:1;
        RBus_UInt32  dic_error_odd_st:1;
        RBus_UInt32  crc_r_error_odd_st:1;
        RBus_UInt32  crc_g_error_odd_st:1;
        RBus_UInt32  crc_b_error_odd_st:1;
    };
}di_di_pq_decmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_en_do_422:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  mark_en_dic:1;
        RBus_UInt32  mark_en_qp_sel:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  mark_en_qp7:1;
        RBus_UInt32  mark_en_qp6:1;
        RBus_UInt32  mark_en_qp5:1;
        RBus_UInt32  mark_en_qp4:1;
        RBus_UInt32  mark_en_qp3:1;
        RBus_UInt32  mark_en_qp2:1;
        RBus_UInt32  mark_en_qp1:1;
        RBus_UInt32  mark_en_qp0:1;
    };
}di_di_pq_decmp_mark_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_0:16;
        RBus_UInt32  mark_color_1:16;
    };
}di_di_pq_decmp_mark_color_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_2:16;
        RBus_UInt32  mark_color_3:16;
    };
}di_di_pq_decmp_mark_color_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_4:16;
        RBus_UInt32  mark_color_5:16;
    };
}di_di_pq_decmp_mark_color_45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_6:16;
        RBus_UInt32  mark_color_7:16;
    };
}di_di_pq_decmp_mark_color_67_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_dic:16;
        RBus_UInt32  mark_color_422:16;
    };
}di_di_pq_decmp_mark_color_422_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_two_pixel_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  decmp_crc_error_line:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  decmp_package_height_cnt:14;
    };
}di_di_pq_decmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_g:32;
    };
}di_di_pq_decmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_r:32;
    };
}di_di_pq_decmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_b:32;
    };
}di_di_pq_decmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_odd_g:32;
    };
}di_di_pq_decmp_crc_odd_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_odd_r:32;
    };
}di_di_pq_decmp_crc_odd_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_odd_b:32;
    };
}di_di_pq_decmp_crc_odd_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_pause_cycle_measure_en:1;
        RBus_UInt32  decmp_pause_cycle_long_term:1;
        RBus_UInt32  res1:22;
        RBus_UInt32  decmp_pause_cycle:8;
    };
}di_di_pq_decmp_pause_cycle_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_teethth_teeth_both_en:1;
        RBus_UInt32  di_film_teethth_timing:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  di_film_bothdiff_shift:2;
        RBus_UInt32  di_film_bothdiff_weight:6;
        RBus_UInt32  di_film_teethshake_diff_lb:8;
        RBus_UInt32  di_film_teethshake_same_ub:8;
        RBus_UInt32  di_film_teethshake_en:1;
    };
}di_di_film_teethshake_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  di_film_teethth_moving_single_side:1;
        RBus_UInt32  di_film_framestaticonly:1;
        RBus_UInt32  di_film_teethth_prog_ub:8;
        RBus_UInt32  di_film_statusbothdiffsum_159_140:20;
    };
}di_di_film_new_function_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_hbcounter_method:1;
        RBus_UInt32  di_film_bothdiff_range:2;
        RBus_UInt32  res1:9;
        RBus_UInt32  di_film_statusbothdiffsum_139_120:20;
    };
}di_di_film_bothdiff_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  di_film_xpos_3by4:5;
        RBus_UInt32  di_film_xpos_1by4:5;
        RBus_UInt32  di_film_statusbothdiffsum_119_100:20;
    };
}di_di_film_hsize_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  di_film_ypos_3by4:5;
        RBus_UInt32  di_film_ypos_1by4:5;
        RBus_UInt32  di_film_statusbothdiffsum_99_80:20;
    };
}di_di_film_vsize_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di_film_nonfilmregion_force:1;
        RBus_UInt32  di_film_nonfilmregion_up_extend:4;
        RBus_UInt32  di_film_nonfilmregion_dn_extend:4;
        RBus_UInt32  di_film_statusbothdiffsum_79_60:20;
    };
}di_di_film_nonfilmregion_extend_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  di_film_nonfilmregion_up_debounce:4;
        RBus_UInt32  di_film_nonfilmregion_dn_debounce:4;
        RBus_UInt32  di_film_statusbothdiffsum_59_40:20;
    };
}di_di_film_nonfilmregion_debounce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_nonfilmregion_s_big:6;
        RBus_UInt32  di_film_nonfilmregion_s_small:6;
        RBus_UInt32  di_film_statusbothdiffsum_39_20:20;
    };
}di_di_film_nonfilmregion_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_nonfilmregion_th:6;
        RBus_UInt32  di_film_nonfilmregion_s_both:6;
        RBus_UInt32  di_film_statusbothdiffsum_19_0:20;
    };
}di_di_film_nonfilmregion_2_RBUS;

#else //apply LITTLE_ENDIAN

//======DI register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_controlmode:2;
        RBus_UInt32  write_enable_0:1;
        RBus_UInt32  ma_3aenable:1;
        RBus_UInt32  write_enable_1:1;
        RBus_UInt32  ma_messintra90:1;
        RBus_UInt32  write_enable_2:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ma_horicomen:1;
        RBus_UInt32  write_enable_4:1;
        RBus_UInt32  film_enable:5;
        RBus_UInt32  write_enable_5:1;
        RBus_UInt32  cp_temporalenable:1;
        RBus_UInt32  write_enable_6:1;
        RBus_UInt32  di444to422lowpass:1;
        RBus_UInt32  write_enable_7:1;
        RBus_UInt32  ip_enable:1;
        RBus_UInt32  write_enable_8:1;
        RBus_UInt32  cp_tresultweight:3;
        RBus_UInt32  ccdinr_h_flip_en:1;
        RBus_UInt32  ma_onedirectionweaveen:1;
        RBus_UInt32  ma_smoothintra90:1;
        RBus_UInt32  res2:3;
    };
}di_im_di_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  di_clock_gating_disable:1;
        RBus_UInt32  framemotion_pxs_sel:1;
        RBus_UInt32  dma_force_4buf:1;
        RBus_UInt32  res2:8;
        RBus_UInt32  di_l_drop_odd_line:1;
        RBus_UInt32  di_r_drop_odd_line:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  cr_autoimg_enable:1;
        RBus_UInt32  cr_fh_switch:1;
        RBus_UInt32  res4:10;
        RBus_UInt32  game_mode_3a:1;
        RBus_UInt32  c10bitsin:1;
        RBus_UInt32  y10bitsin:1;
        RBus_UInt32  fun_y_en:1;
    };
}di_color_recovery_option_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_tnrdebugmode:1;
        RBus_UInt32  ma_modeselect:1;
        RBus_UInt32  ma_debugmode:3;
        RBus_UInt32  film_debugmode:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  auto_freeze:1;
        RBus_UInt32  auto_frz_num:3;
        RBus_UInt32  unfreeze_polarity:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  readstart:13;
        RBus_UInt32  field_confuse_i2rnd:1;
        RBus_UInt32  di_3d_l_flag:1;
        RBus_UInt32  field_confuse:1;
    };
}di_im_di_debug_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hblksize:10;
        RBus_UInt32  vsize:10;
        RBus_UInt32  hsize:11;
        RBus_UInt32  singlefieldintra:1;
    };
}di_im_di_active_window_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fixedwindow0:1;
        RBus_UInt32  fixedwindow1:1;
        RBus_UInt32  fixedwindow2:1;
        RBus_UInt32  fixedwindow3:1;
        RBus_UInt32  fixedwindow4:1;
        RBus_UInt32  fixedwindow5:1;
        RBus_UInt32  dellineen:1;
        RBus_UInt32  delpixelen:1;
        RBus_UInt32  field_confuse_i2rnd_error:4;
        RBus_UInt32  field_confuse_error:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  force2d_i2rnd:1;
        RBus_UInt32  force2d:1;
        RBus_UInt32  freeze:1;
        RBus_UInt32  hblksize_msb:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  vsize_msb:2;
        RBus_UInt32  hsize_msb:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  nxt_rpt_flag_disable:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  fixedwindowmode:2;
    };
}di_im_di_weave_window_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xstart_12_0:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_12_0:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_0_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xend_12_0:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_12_0:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_0_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xstart_25_13:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_25_13:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_1_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xend_25_13:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_25_13:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_1_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xstart_38_26:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_38_26:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_2_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xend_38_26:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_38_26:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_2_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xstart_51_39:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_51_39:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_3_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xend_51_39:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_51_39:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_3_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xstart_64_52:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_64_52:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_4_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xend_64_52:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_64_52:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_4_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xstart_77_65:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  ystart_77_65:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_5_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  xend_77_65:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  yend_77_65:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_weave_window_5_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_class_h_th2:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  ma_class_h_th1:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  ma_class_h_th1_cmp:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  res4:4;
        RBus_UInt32  pseudo_memc_film22_sequence:2;
        RBus_UInt32  res5:2;
    };
}di_im_di_classify_thclassify_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_blend01_weight:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  ma_blend10_weight:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  ma_blend_fmcomb0:2;
        RBus_UInt32  ma_blend_fmcomb1:2;
        RBus_UInt32  ma_blend_fmcomb1_hor:2;
        RBus_UInt32  ma_blend_fmcomb2:2;
        RBus_UInt32  ma_blend_fmcomb3:2;
        RBus_UInt32  res3:14;
    };
}di_im_di_blend_and_weighting_method_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  force_dma_2d:1;
        RBus_UInt32  force_dma_intra:1;
        RBus_UInt32  force_di_nxt:1;
        RBus_UInt32  dummy1802404c_6_3:4;
        RBus_UInt32  vodma_film_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  force_2d_timing_mode:1;
        RBus_UInt32  force_2d_timing_en:1;
        RBus_UInt32  ma_sobelths:10;
        RBus_UInt32  ma_sobelthm:10;
        RBus_UInt32  dummy1802404c_31:1;
    };
}di_im_di_mpeg_sequence_app_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_class_rlv_th2:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  ma_class_rlv_th1:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  ma_class_rlv_th1_cmp:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  ma_class_s_th2:5;
        RBus_UInt32  ma_vedge_nolp_en:3;
    };
}di_im_di_classify2_thclassify_threshold_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_vedge_force_intra_en:1;
        RBus_UInt32  ma_vedge_force90_en:1;
        RBus_UInt32  ma_vedge_nonlpfm_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  ma_vedge_add_rlv:2;
        RBus_UInt32  res2:25;
        RBus_UInt32  ma_new_class_en:1;
    };
}di_im_di_new_class_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  linesize_odd:11;
        RBus_UInt32  res1:1;
        RBus_UInt32  linesize_even:11;
        RBus_UInt32  res2:6;
        RBus_UInt32  rdma_random_en:1;
        RBus_UInt32  dma_420_en:2;
    };
}di_im_di_dma_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_var1thl:8;
        RBus_UInt32  cr_var2thl:8;
        RBus_UInt32  cr_var3thl:8;
        RBus_UInt32  cr_var4thl:8;
    };
}di_im_di_xc_auto_balance_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_meanthl:8;
        RBus_UInt32  cr_transitionthl:8;
        RBus_UInt32  res1:13;
        RBus_UInt32  autoimg_debug_enable:1;
        RBus_UInt32  autoimg_lpf_enable:1;
        RBus_UInt32  bcclowpassyenablecontrol:1;
    };
}di_im_di_xc_auto_balance_th2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_thl_subbalance:16;
        RBus_UInt32  cr_thl_mainbalance:8;
        RBus_UInt32  res1:8;
    };
}di_im_di_xc_auto_balance_th3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_intra_line_cont_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  intra_ma_mess_enable:1;
        RBus_UInt32  ma_follow_new_intra_en:1;
        RBus_UInt32  res2:6;
    };
}di_im_di_intra_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_framestha:8;
        RBus_UInt32  ma_framerlvtha:8;
        RBus_UInt32  ma_framehtha:8;
        RBus_UInt32  ma_framemtha:8;
    };
}di_im_di_ma_frame_motion_th_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_framesthb:8;
        RBus_UInt32  ma_framerlvthb:8;
        RBus_UInt32  ma_framehthb:8;
        RBus_UInt32  ma_framemthb:8;
    };
}di_im_di_ma_frame_motion_th_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_framesthc:8;
        RBus_UInt32  ma_framerlvthc:8;
        RBus_UInt32  ma_framehthc:8;
        RBus_UInt32  ma_framemthc:8;
    };
}di_im_di_ma_frame_motion_th_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_fieldteethrlvtha:8;
        RBus_UInt32  ma_fieldteethhtha:8;
        RBus_UInt32  ma_fieldteethmtha:8;
        RBus_UInt32  ma_fieldteethstha:8;
    };
}di_im_di_ma_field_teeth_th_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_fieldteeththb:8;
        RBus_UInt32  ma_ydiffth:8;
        RBus_UInt32  res1:8;
        RBus_UInt32  ma_horicomth:8;
    };
}di_im_di_ma_others_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_sawtoothsth:8;
        RBus_UInt32  ma_sawtoothrlvth:8;
        RBus_UInt32  ma_sawtoothhth:8;
        RBus_UInt32  ma_sawtoothmth:8;
    };
}di_im_di_ma_sawtooth_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_teethth_teeth_lb:8;
        RBus_UInt32  film_teethth_moving_lb:8;
        RBus_UInt32  film_teethth_prog_lb:8;
        RBus_UInt32  film_teethth_ratio:6;
        RBus_UInt32  film_teethth_en:2;
    };
}di_im_di_film_teeth_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  forfw_1:32;
    };
}di_im_di_ma_vertext_th_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_frmotionthl:8;
        RBus_UInt32  film_sawtooththl:8;
        RBus_UInt32  film22_sawtooththl:8;
        RBus_UInt32  res1:1;
        RBus_UInt32  film_violate_strict_en:1;
        RBus_UInt32  film_pair_en_auto:1;
        RBus_UInt32  film_pair2_en:1;
        RBus_UInt32  film_pair1_en:1;
        RBus_UInt32  film_thumbnail_en:1;
        RBus_UInt32  film_verscrollingtext_en:1;
        RBus_UInt32  film_leavequick_en:1;
    };
}di_im_di_film_sawtooth_filmframe_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_fistaticsthl:8;
        RBus_UInt32  film_frstaticsthl:8;
        RBus_UInt32  film22_fistaticsthl:8;
        RBus_UInt32  film_fieldmotionsumthl:8;
    };
}di_im_di_film_static_sum_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_fimaxsthl:16;
        RBus_UInt32  film_fiminsthl:8;
        RBus_UInt32  film_pairratio_all2:4;
        RBus_UInt32  film_pairratio_all1:4;
    };
}di_im_di_film_field_judge_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_subfistaticsthl:8;
        RBus_UInt32  film_subfrstaticsthl:8;
        RBus_UInt32  film22_subfistaticsthl:8;
        RBus_UInt32  film_subfieldmotionsumthl:8;
    };
}di_im_di_film_static_sum_sub_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_subfimaxsthl:16;
        RBus_UInt32  film_subfiminsthl:8;
        RBus_UInt32  film_pairratio_sub2:4;
        RBus_UInt32  film_pairratio_sub1:4;
    };
}di_im_di_film_field_judge_sub_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film22_fieldmotionsumthl:8;
        RBus_UInt32  film22_subfieldmotionsumthl:8;
        RBus_UInt32  film_sawtooth_choose:2;
        RBus_UInt32  film22_filter_andor:1;
        RBus_UInt32  dummy180240b4_23_19:5;
        RBus_UInt32  film32_debounce_fieldnum:4;
        RBus_UInt32  film22_debounce_fieldnum:4;
    };
}di_im_di_film_motion_sum_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_top_margin:4;
        RBus_UInt32  film_bot_margin:4;
        RBus_UInt32  res1:22;
        RBus_UInt32  film22_quick_decision_en:2;
    };
}di_im_di_si_film_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  forfw_2:32;
    };
}di_film_dummy_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_hbcounter:8;
        RBus_UInt32  film_motionstatus_choose:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  film_3d_mode:2;
        RBus_UInt32  film_hifreq_cnt_thl:4;
        RBus_UInt32  film_hifreq_thl:16;
    };
}di_im_di_si_film_hb_cout_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_sequence:5;
        RBus_UInt32  film_confuse:1;
        RBus_UInt32  film_subdetected:1;
        RBus_UInt32  film_detected:1;
        RBus_UInt32  film_hifreq_flag:1;
        RBus_UInt32  top_field:1;
        RBus_UInt32  dummy180240c4_31_10:22;
    };
}di_im_di_si_film_final_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_prefistatic1:8;
        RBus_UInt32  film_framepair:16;
        RBus_UInt32  film_framestatic:8;
    };
}di_im_di_si_film_pattern_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_nxtfimotion:8;
        RBus_UInt32  film_nxtfistatic2:8;
        RBus_UInt32  film_prefistatic2:8;
        RBus_UInt32  film_nxtfistatic1:8;
    };
}di_im_di_si_film_pattern_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_sequence321_39_32:8;
        RBus_UInt32  film_violate321:8;
        RBus_UInt32  film_match321:8;
        RBus_UInt32  film_detected321:8;
    };
}di_im_di_si_film_32_result_1_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_sequence321_31_0:32;
    };
}di_im_di_si_film_32_result_1_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_sequence322_39_32:8;
        RBus_UInt32  film_violate322:8;
        RBus_UInt32  film_match322:8;
        RBus_UInt32  film_detected322:8;
    };
}di_im_di_si_film_32_result_2_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_sequence322_31_0:32;
    };
}di_im_di_si_film_32_result_2_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_sequence22_39_32:8;
        RBus_UInt32  film_violate22:8;
        RBus_UInt32  film_match22:8;
        RBus_UInt32  film_detected22:8;
    };
}di_im_di_si_film_22_result_a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_sequence22_31_0:32;
    };
}di_im_di_si_film_22_result_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_719_700:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_next_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_699_680:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_next_h_t_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_679_660:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_next_h_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_659_640:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_next_h_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_639_620:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_next_v_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_619_600:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_next_v_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_599_580:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_next_v_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_579_560:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_next_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_559_540:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_pre_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_539_520:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_pre_h_t_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_519_500:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_pre_h_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_499_480:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_pre_h_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_479_460:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_pre_v_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_459_440:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_pre_v_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_439_420:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_pre_v_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_419_400:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_pre_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_399_380:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_379_360:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_t_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_359_340:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_339_320:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_319_300:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_v_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_299_280:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_v_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_279_260:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_v_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_259_240:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_239_220:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_219_200:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_199_180:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_179_160:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_159_140:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_139_120:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_119_100:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_99_80:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_79_60:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_59_40:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_39_20:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_motionstatus_19_0:20;
        RBus_UInt32  res1:12;
    };
}di_im_di_si_film_motion_h_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  total_frame_motion_sum:24;
        RBus_UInt32  res1:8;
    };
}di_im_di_si_ma_total_fm_sum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  large_frame_motion_pixel:24;
        RBus_UInt32  res1:8;
    };
}di_im_di_si_ma_large_fm_pixel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  large_frame_motion_sum:24;
        RBus_UInt32  res1:8;
    };
}di_im_di_si_ma_large_fm_sum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mess_horizontal_pixel:24;
        RBus_UInt32  res1:8;
    };
}di_im_di_si_ma_mess_h_pixel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_mean1_status:8;
        RBus_UInt32  cr_mean2_status:8;
        RBus_UInt32  cr_mean3_status:8;
        RBus_UInt32  cr_enable_mainbalance:1;
        RBus_UInt32  cr_subbal_status:3;
        RBus_UInt32  res1:4;
    };
}di_im_di_si_image_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_amount_subbalance:16;
        RBus_UInt32  di_crc_ctrl_start:1;
        RBus_UInt32  di_crc_ctrl_conti:1;
        RBus_UInt32  fbuf_crc_info_r2_compare_fail:1;
        RBus_UInt32  fbuf_crc_info_r1_compare_fail:1;
        RBus_UInt32  fbuf_crc_r4_compare_fail_3d:1;
        RBus_UInt32  fbuf_crc_r3_compare_fail_3d:1;
        RBus_UInt32  fbuf_crc_r2_compare_fail_3d:1;
        RBus_UInt32  fbuf_crc_r1_compare_fail_3d:1;
        RBus_UInt32  fbuf_crc_r4_compare_fail:1;
        RBus_UInt32  fbuf_crc_r3_compare_fail:1;
        RBus_UInt32  fbuf_crc_r2_compare_fail:1;
        RBus_UInt32  fbuf_crc_r1_compare_fail:1;
        RBus_UInt32  fbuf_crc_compare_done:1;
        RBus_UInt32  fbuf_crc_continous_mode:1;
        RBus_UInt32  fbuf_crc_compare_en:1;
        RBus_UInt32  crc_i2rnd_sel:1;
    };
}di_im_di_si_sub_in_auto_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_crc_result:32;
    };
}di_im_di_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_partialstillnew:1;
        RBus_UInt32  cp_partialstill:1;
        RBus_UInt32  res1:30;
    };
}di_im_di_si_still_info_for_ne_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film22_nxtfimotion:8;
        RBus_UInt32  film22_nxtfistatic1:8;
        RBus_UInt32  res1:16;
    };
}di_im_di_si_film22_detector_pattern_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthlc:8;
        RBus_UInt32  cp_temporalthly:8;
        RBus_UInt32  res1:16;
    };
}di_im_di_tnr_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_rtnr_y_enable:1;
        RBus_UInt32  cp_rtnr_c_enable:1;
        RBus_UInt32  cp_rtnr_progressive:1;
        RBus_UInt32  cp_rtnr_rounding_correction:1;
        RBus_UInt32  cp_rtnr_mad_window:2;
        RBus_UInt32  cp_rtnr_updatelocken:1;
        RBus_UInt32  cp_rtnr_updatelockflg:1;
        RBus_UInt32  res1:19;
        RBus_UInt32  cp_rtnr_output_previous:1;
        RBus_UInt32  cp_rtnr_rgb444_8bit_mode:1;
        RBus_UInt32  cp_progressive_line_dma:1;
        RBus_UInt32  cp_rtnr_rgb444_enable:1;
        RBus_UInt32  res2:1;
    };
}di_im_di_rtnr_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_rtnr_k_force_modify_0_00:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_01:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_02:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_03:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_04:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_10:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_11:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_12:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_13:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_14:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_20:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_21:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_22:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_23:1;
        RBus_UInt32  cp_rtnr_k_force_modify_0_24:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_rtnr_k_force_modify_offset:4;
        RBus_UInt32  cp_rtnr_k_force_modify_en_y:1;
        RBus_UInt32  cp_rtnr_k_force_modify_en_c:1;
        RBus_UInt32  cp_rtnr_ne_follow_k_modify:1;
        RBus_UInt32  cp_rtnr_k_force_modify_mode:1;
        RBus_UInt32  cp_rtnr_k_force_modify_index:3;
        RBus_UInt32  dummy180241a4_31_27:5;
    };
}di_im_di_rtnr_k_force_modify_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr2to1_dist:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  cp_rtnr_k_force_modify_1_00:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_01:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_02:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_03:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_04:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_10:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_11:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_12:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_13:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_14:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_20:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_21:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_22:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_23:1;
        RBus_UInt32  cp_rtnr_k_force_modify_1_24:1;
        RBus_UInt32  res2:1;
    };
}di_tr2to1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_rtnr_k_force_modify_2_00:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_01:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_02:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_03:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_04:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_10:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_11:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_12:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_13:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_14:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_20:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_21:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_22:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_23:1;
        RBus_UInt32  cp_rtnr_k_force_modify_2_24:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_00:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_01:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_02:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_03:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_04:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_10:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_11:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_12:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_13:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_14:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_20:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_21:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_22:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_23:1;
        RBus_UInt32  cp_rtnr_k_force_modify_3_24:1;
        RBus_UInt32  res2:1;
    };
}di_im_di_rtnr_k_force_modify_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_y_th2:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  cp_temporal_mad_y_th1:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_rtnr_mad_y_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_c_th2:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  cp_temporal_mad_c_th1:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_rtnr_mad_c_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_countery:21;
        RBus_UInt32  res1:11;
    };
}di_im_di_rtnr_mad_y_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_counteru:21;
        RBus_UInt32  res1:11;
    };
}di_im_di_rtnr_mad_u_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_counterv:21;
        RBus_UInt32  res1:11;
    };
}di_im_di_rtnr_mad_v_counter_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_temporal_edge_crct_en:1;
        RBus_UInt32  cp_temporal_c_k_decision:3;
        RBus_UInt32  cp_temporal_l_qlfy_th:4;
        RBus_UInt32  cp_temporal_num_match_l:4;
        RBus_UInt32  dummy180241c4_15_13:3;
        RBus_UInt32  cp_rtnr_k_force_modify_4_00:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_01:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_02:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_03:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_04:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_10:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_11:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_12:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_13:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_14:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_20:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_21:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_22:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_23:1;
        RBus_UInt32  cp_rtnr_k_force_modify_4_24:1;
        RBus_UInt32  res2:1;
    };
}di_im_di_rtnr_ediff_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_sad_offset_v:8;
        RBus_UInt32  cp_temporal_sad_offset_u:8;
        RBus_UInt32  cp_temporal_sad_offset_y:8;
        RBus_UInt32  res1:8;
    };
}di_im_di_rtnr_sad_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_e_th2_c:8;
        RBus_UInt32  cp_temporal_e_th1_c:8;
        RBus_UInt32  cp_temporal_e_th2_y:8;
        RBus_UInt32  cp_temporal_e_th1_y:8;
    };
}di_im_di_rtnr_ediff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_sbl_ths_y:10;
        RBus_UInt32  dummy180241d0_11_10:2;
        RBus_UInt32  cp_temporal_sbl_thm_y:10;
        RBus_UInt32  dummy180241d0_31_22:10;
    };
}di_im_di_rtnr_ediff_sobel_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_nl_low_bnd_y:8;
        RBus_UInt32  cp_temporal_nl_up_bnd_y:8;
        RBus_UInt32  res1:16;
    };
}di_im_di_rtnr_level_bound_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_same_et_cnt_y:24;
        RBus_UInt32  res1:8;
    };
}di_im_di_rtnr_et_count_y_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_same_et_sad_sum_y:32;
    };
}di_im_di_rtnr_et_sum_y_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_same_et_sad_sum_u:32;
    };
}di_im_di_rtnr_et_sum_u_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_same_et_sad_sum_v:32;
    };
}di_im_di_rtnr_et_sum_v_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_xc_en:1;
        RBus_UInt32  cp_temporal_xc_switch:1;
        RBus_UInt32  set_frame_offset_verymotion:4;
        RBus_UInt32  set_frame_offset_motion:3;
        RBus_UInt32  set_frame_offset_still:3;
        RBus_UInt32  set_frame_offset_verystill:4;
        RBus_UInt32  set_classifysmooth:3;
        RBus_UInt32  set_stillmotion_thc:4;
        RBus_UInt32  set_stillmotion_thb:4;
        RBus_UInt32  set_stillmotion_tha:4;
        RBus_UInt32  set_sobeledgetypeen:1;
    };
}di_im_di_tnr_xc_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hfd_3x3blockteethcount_thl:4;
        RBus_UInt32  res1:4;
        RBus_UInt32  hfd_highlowhighdiff_count_thl:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  hfd_highlowhighdiff_thl:8;
        RBus_UInt32  hfd_highfrequencydetectoren:1;
        RBus_UInt32  res3:5;
        RBus_UInt32  set_sobeledgetype_sel:2;
    };
}di_im_di_hfd_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hfd_linemotioncount_thl:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  hfd_linemotioncount_thl2:11;
        RBus_UInt32  res2:2;
        RBus_UInt32  hfd_framekcombineoflinemotion:2;
        RBus_UInt32  hfd_checklinemotioncounten:1;
    };
}di_im_di_hfd_line_motion_count_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hfd_statistic:24;
        RBus_UInt32  res1:8;
    };
}di_im_di_hfd_statistic_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  hmc_window_bot:10;
        RBus_UInt32  hmc_window_top:10;
        RBus_UInt32  hmc_window_en:1;
        RBus_UInt32  res2:3;
    };
}di_im_di_hfd_ma_error_recovery_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_new_intra_low_angle_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_intra_new_gradient_correct_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_intra_post_process_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  btr_blendtemporalrecoveryen:1;
        RBus_UInt32  btr_solutiontype:1;
        RBus_UInt32  btr_sola_temporallength:2;
        RBus_UInt32  btr_sola_method:1;
        RBus_UInt32  btr_sola_method0_successtime:3;
        RBus_UInt32  btr_sola_method0_blendtype:1;
        RBus_UInt32  btr_blendtemporalrecovery_dma_en:1;
        RBus_UInt32  btr_info_save_mode:2;
        RBus_UInt32  btr_solb_temporallength:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  btr_solb_cur0_count:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  btr_solb_cur1_count:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  btr_blendtemporaldebugmode:2;
        RBus_UInt32  btr_hmc_blendchoose:1;
        RBus_UInt32  res4:5;
    };
}di_im_di_btr_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  btr_sola_method0_cur0_pre1_min:2;
        RBus_UInt32  btr_sola_method0_cur0_pre1_max:2;
        RBus_UInt32  btr_sola_method0_cur0_pre2_min:2;
        RBus_UInt32  btr_sola_method0_cur0_pre2_max:2;
        RBus_UInt32  btr_sola_method0_cur0_pre3_min:2;
        RBus_UInt32  btr_sola_method0_cur0_pre3_max:2;
        RBus_UInt32  btr_sola_method0_cur0_pre4_min:2;
        RBus_UInt32  btr_sola_method0_cur0_pre4_max:2;
        RBus_UInt32  btr_sola_method0_cur1_pre1_min:2;
        RBus_UInt32  btr_sola_method0_cur1_pre1_max:2;
        RBus_UInt32  btr_sola_method0_cur1_pre2_min:2;
        RBus_UInt32  btr_sola_method0_cur1_pre2_max:2;
        RBus_UInt32  btr_sola_method0_cur1_pre3_min:2;
        RBus_UInt32  btr_sola_method0_cur1_pre3_max:2;
        RBus_UInt32  btr_sola_method0_cur1_pre4_min:2;
        RBus_UInt32  btr_sola_method0_cur1_pre4_max:2;
    };
}di_im_di_btr_sola_method0_min_max_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  btr_longweavesum:24;
        RBus_UInt32  res1:8;
    };
}di_im_di_btr_longweave_statistic_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ber_lowpasssum:24;
        RBus_UInt32  res1:8;
    };
}di_im_di_ber_lowpass_statistic_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ber_blendspatialrecoveryen:1;
        RBus_UInt32  ber_blendspatialclassify:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  ber_blendspatial_lpf_blendingtype:1;
        RBus_UInt32  ber_closeclevel_min:8;
        RBus_UInt32  res2:4;
        RBus_UInt32  ber_closeclevel_max:8;
        RBus_UInt32  res3:8;
    };
}di_im_di_ber_spatial_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ber_diffylevel_min:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  ber_diffylevel_max:10;
        RBus_UInt32  res2:6;
    };
}di_im_di_ber_spatial_diffy_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ber_blendtemporalrevoeryen:1;
        RBus_UInt32  ber_blendtemporalblock:2;
        RBus_UInt32  ber_blendtemporaltype:1;
        RBus_UInt32  ber_spatialcontinuelength:4;
        RBus_UInt32  ber_totalcontinuesum:24;
    };
}di_im_di_ber_temporal_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_info_line_count1:10;
        RBus_UInt32  hmc_info_line_count2:10;
        RBus_UInt32  res1:12;
    };
}di_im_di_hmc_line_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_info_teeth_count1:16;
        RBus_UInt32  hmc_info_teeth_count2:16;
    };
}di_im_di_hmc_teeth_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_info_start1:10;
        RBus_UInt32  hmc_info_end1:10;
        RBus_UInt32  hmc_info_vdiff_th:8;
        RBus_UInt32  hmc_info_debug_en:1;
        RBus_UInt32  res1:3;
    };
}di_im_di_hmc_info_range_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_info_start2:10;
        RBus_UInt32  hmc_info_end2:10;
        RBus_UInt32  res1:12;
    };
}di_im_di_hmc_info_range_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_mask_en:1;
        RBus_UInt32  film_mask_pass_thd:4;
        RBus_UInt32  res1:3;
        RBus_UInt32  film_mask_fiedif_thd:8;
        RBus_UInt32  film_mask_frmdif_thd:8;
        RBus_UInt32  res2:8;
    };
}di_im_di_film_mask_detection_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_edgetype_v_pass:1;
        RBus_UInt32  film_edgetype_r_pass:1;
        RBus_UInt32  film_edgetype_h_pass:1;
        RBus_UInt32  film_edgetype_l_pass:1;
        RBus_UInt32  film_edgetype_n_pass:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  film_edgetype_sobelths:10;
        RBus_UInt32  film_edgetype_sobelthm:10;
        RBus_UInt32  res2:4;
    };
}di_im_di_film_edge_type_check_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_startline:10;
        RBus_UInt32  res1:22;
    };
}di_im_di_hmc_3a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_hmc_statistic_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_hmc_lineratio:8;
        RBus_UInt32  ma_hmc_topline:12;
        RBus_UInt32  ma_hmc_botline:12;
    };
}di_im_di_hmc_statistic1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_hmc_topline2:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ma_hmc_botline2:12;
        RBus_UInt32  res2:4;
    };
}di_im_di_hmc_statistic2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hsd_in_vsize:12;
        RBus_UInt32  no_hs_mode:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  hsd_in_hsize:13;
        RBus_UInt32  res2:3;
    };
}di_im_di_no_hs_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_hmc_topline3:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ma_hmc_botline3:12;
        RBus_UInt32  res2:4;
    };
}di_im_di_hmc_statistic3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tnrxc_pixel_counter:16;
        RBus_UInt32  cnt_for_porch_size:7;
        RBus_UInt32  res1:9;
    };
}di_im_di_framesobel_statistic_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  hmc_dynamic_threshold_en:1;
        RBus_UInt32  hmc_dynamic_threshold_bias:6;
        RBus_UInt32  hmc_dynamic_threshold_max_clip:8;
        RBus_UInt32  res2:5;
        RBus_UInt32  hmc_vector_follow_pan_en:1;
        RBus_UInt32  res3:2;
    };
}di_im_di_framesobel_statistic_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tnrxc_mkii_en:1;
        RBus_UInt32  tnrxc_dbguvmode:1;
        RBus_UInt32  dummy180242a0_7_2:6;
        RBus_UInt32  tnrxc_mkii_thy:8;
        RBus_UInt32  tnrxc_mkii_thc1:8;
        RBus_UInt32  tnrxc_mkii_thc2:8;
    };
}di_tnrxc_mkii_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_y_dark_k_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cp_temporal_y_kin_dark:4;
        RBus_UInt32  cp_temporal_y_kout_dark:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  cp_temporal_y_dark_th:8;
        RBus_UInt32  cp_temporal_y_kin_dark_2:4;
        RBus_UInt32  cp_temporal_y_kout_dark_2:4;
    };
}di_im_di_rtnr_k_dark_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_new_formula_en:1;
        RBus_UInt32  rtnr_localedge_en:1;
        RBus_UInt32  rtnr_stilledge_en:1;
        RBus_UInt32  rtnr_crct_debug:1;
        RBus_UInt32  rtnr_crct_bias:3;
        RBus_UInt32  dummy180242a8_7:1;
        RBus_UInt32  rtnr_act_bias:3;
        RBus_UInt32  rtnr_localedge_debug:1;
        RBus_UInt32  rtnr_stilledge_bonusbias:3;
        RBus_UInt32  rtnr_stilledge_debug:1;
        RBus_UInt32  rtnr_th_localedgediff:12;
        RBus_UInt32  rtnr_refined_c_en:1;
        RBus_UInt32  dummy180242a8_31_29:3;
    };
}di_im_di_rtnr_refined_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_stilledge_th_edg:8;
        RBus_UInt32  rtnr_stilledge_th_edgdiff:9;
        RBus_UInt32  dummy180242ac_31_17:15;
    };
}di_im_di_rtnr_refined_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_ediff_c_en0:1;
        RBus_UInt32  cp_temporal_ediff_c_en1:1;
        RBus_UInt32  cp_temporal_ediff_c_en2:1;
        RBus_UInt32  cp_temporal_ediff_c_en3:1;
        RBus_UInt32  cp_temporal_ediff_c_en4:1;
        RBus_UInt32  cp_temporal_ediff_c_en5:1;
        RBus_UInt32  cp_temporal_ediff_c_en6:1;
        RBus_UInt32  res1:25;
    };
}di_im_di_rtnr_ediff_enable_c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_ediff_en0:1;
        RBus_UInt32  cp_temporal_ediff_en1:1;
        RBus_UInt32  cp_temporal_ediff_en2:1;
        RBus_UInt32  cp_temporal_ediff_en3:1;
        RBus_UInt32  cp_temporal_ediff_en4:1;
        RBus_UInt32  cp_temporal_ediff_en5:1;
        RBus_UInt32  cp_temporal_ediff_en6:1;
        RBus_UInt32  cp_temporal_ediff_en7:1;
        RBus_UInt32  cp_temporal_ediff_en8:1;
        RBus_UInt32  cp_temporal_ediff_en9:1;
        RBus_UInt32  cp_temporal_ediff_en10:1;
        RBus_UInt32  cp_temporal_ediff_en11:1;
        RBus_UInt32  cp_temporal_ediff_en12:1;
        RBus_UInt32  cp_temporal_ediff_en13:1;
        RBus_UInt32  cp_temporal_ediff_en14:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_temporal_y_k_decision:1;
        RBus_UInt32  res2:15;
    };
}di_im_di_rtnr_ediff_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  hmcnr_mvy_avg_en:1;
        RBus_UInt32  hmcnr_mvx_avg_en:1;
        RBus_UInt32  cp_temporal_hmcnr_uv_with_y:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cp_temporal_hmcnr_debug_progressive:1;
        RBus_UInt32  cp_temporal_hmcnr_y_en:1;
        RBus_UInt32  res3:11;
        RBus_UInt32  cp_temporal_hmcnr_weight:3;
        RBus_UInt32  cp_temporal_hmcnr_mad_window:2;
        RBus_UInt32  res4:8;
    };
}di_im_di_rtnr_hmcnr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  rtnr_new_method_k_extend_en:1;
        RBus_UInt32  res2:15;
        RBus_UInt32  prtnr_4k2k:1;
        RBus_UInt32  rtnr_k_debugmode:1;
        RBus_UInt32  res3:11;
    };
}di_im_di_rtnr_new_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_teeth_statistic_nxt_near:16;
        RBus_UInt32  pan_teeth_statistic_pre_near:16;
    };
}di_im_di_pan_teeth_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_teeth_statistic_nxt_far:16;
        RBus_UInt32  pan_teeth_statistic_pre_far:16;
    };
}di_im_di_pan_teeth_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_teeth_statistic_factor:3;
        RBus_UInt32  pan_teeth_statistic_smalldiff_th:11;
        RBus_UInt32  pan_teeth_statistic_largediff_th:14;
        RBus_UInt32  pan_teeth_statistic_bias:4;
    };
}di_im_di_pan_teeth_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_vlpf_hori_max_th:8;
        RBus_UInt32  hmc_vlpf_hori_min_th:8;
        RBus_UInt32  hmc_vlpf_verti_min_th:8;
        RBus_UInt32  res1:2;
        RBus_UInt32  hmc_teeth_follow_ma:1;
        RBus_UInt32  hmc_vlpf_vhf_en:1;
        RBus_UInt32  hmc_vlpf_hori_protect_en:1;
        RBus_UInt32  hmc_vlpf_debug_en:1;
        RBus_UInt32  di_hmc_vlpf_en:1;
        RBus_UInt32  pan_mc_choose_one_side_en:1;
    };
}di_im_di_pan_teeth_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hme_debug_mode:3;
        RBus_UInt32  hmc_blending_with_ma_gain_line_t_factor:2;
        RBus_UInt32  hmc_blending_with_ma_gain_line_t_cnt:3;
        RBus_UInt32  hmc_blending_with_ma_gain_line_t_en:1;
        RBus_UInt32  hmc_mv_refine_cmp_tmv_th:3;
        RBus_UInt32  hmc_mv_refine_cmp_tmv_en:1;
        RBus_UInt32  hmc_mv_choose_vlpf:3;
        RBus_UInt32  hmc_vlpf_vhf_margin_th:8;
        RBus_UInt32  hmc_vlpf_vhf_center_th:8;
    };
}di_im_di_hmc_vlpf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_statistic_factor:8;
        RBus_UInt32  hmc_refine_cmp_tmv_y_th_s:3;
        RBus_UInt32  hmc_refine_cmp_tmv_y_th_m:3;
        RBus_UInt32  hmc_refine_cmp_tmv_y_th_h:3;
        RBus_UInt32  res1:15;
    };
}di_im_di_blending_corrector_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_blending_corrector_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_blending_corrector_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_blending_corrector_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_en:1;
        RBus_UInt32  pan_me_edgediff_min_th:3;
        RBus_UInt32  pan_mc_path_sel:1;
        RBus_UInt32  res1:19;
        RBus_UInt32  pan_mc_sobel_diff_min_th:6;
        RBus_UInt32  res2:1;
        RBus_UInt32  pan_mc_odd_mv_pass_en:1;
    };
}di_im_di_pan_detection_control_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  pan_mc_edge_r:1;
        RBus_UInt32  pan_mc_edge_l:1;
        RBus_UInt32  pan_mc_edge_v:1;
        RBus_UInt32  pan_mc_edge_h:1;
        RBus_UInt32  pan_mc_edge_n:1;
        RBus_UInt32  pan_mc_teeth_check_en:1;
        RBus_UInt32  pan_mc_teeth_check_th:4;
        RBus_UInt32  res2:16;
    };
}di_im_di_pan_detection_control_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r6_pixelsum:16;
        RBus_UInt32  hmc_r7_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r4_pixelsum:16;
        RBus_UInt32  hmc_r5_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r2_pixelsum:16;
        RBus_UInt32  hmc_r3_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_c0_pixelsum:16;
        RBus_UInt32  hmc_r1_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l2_pixelsum:16;
        RBus_UInt32  hmc_l1_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l4_pixelsum:16;
        RBus_UInt32  hmc_l3_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l6_pixelsum:16;
        RBus_UInt32  hmc_l5_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_me_border_top_width:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  hmc_l7_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_me_border_right_width:8;
        RBus_UInt32  pan_me_border_left_width:8;
        RBus_UInt32  pan_me_border_bot_width:12;
        RBus_UInt32  res1:4;
    };
}di_im_di_pan_detection_control_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fw_film_en:1;
        RBus_UInt32  film_pair3_en:1;
        RBus_UInt32  force_badeditor_en:1;
        RBus_UInt32  film_pair3_ratio:2;
        RBus_UInt32  badeditor_ratio:2;
        RBus_UInt32  fw_film_reg_sel:1;
        RBus_UInt32  film_mixedfilm_margin:2;
        RBus_UInt32  fw_film_filmdetected:1;
        RBus_UInt32  fw_film_mixedfilmdetected:1;
        RBus_UInt32  fw_film_mixedfilmconfuse:1;
        RBus_UInt32  fw_film_filmweavemode:2;
        RBus_UInt32  fw_film_22detected:1;
        RBus_UInt32  fw_film_32detected2:1;
        RBus_UInt32  fw_film_32detected1:1;
        RBus_UInt32  fw_film_filmsequence:5;
        RBus_UInt32  film_bad_edit_en:1;
        RBus_UInt32  fw_film_doublebuffer_en:1;
        RBus_UInt32  res1:7;
    };
}di_im_di_film_new_function_main_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fw_topline1:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  fw_botline1:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_film_topbotline1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fw_topline2:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  fw_botline2:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_film_topbotline2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fw_topline3:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  fw_botline3:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_film_topbotline3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_prevfilmmotion:8;
        RBus_UInt32  film22_prevfilmmotion:8;
        RBus_UInt32  film_badeditor_flag:1;
        RBus_UInt32  res1:15;
    };
}di_im_di_film_prev_fieldmotion_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_prevtopdetected1:1;
        RBus_UInt32  film_prevbotdetected1:1;
        RBus_UInt32  film_prevtopdetected2:1;
        RBus_UInt32  film_prevbotdetected2:1;
        RBus_UInt32  film_prevtopdetected3:1;
        RBus_UInt32  film_prevbotdetected3:1;
        RBus_UInt32  film_nexttopdetected1:1;
        RBus_UInt32  film_nextbotdetected1:1;
        RBus_UInt32  film_nexttopdetected2:1;
        RBus_UInt32  film_nextbotdetected2:1;
        RBus_UInt32  film_nexttopdetected3:1;
        RBus_UInt32  film_nextbotdetected3:1;
        RBus_UInt32  res1:20;
    };
}di_im_di_film_mark_information_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_prevtopmark1:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  film_prevbotmark1:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_film_mark_prev1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_prevtopmark2:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  film_prevbotmark2:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_film_mark_prev2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_prevtopmark3:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  film_prevbotmark3:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_film_mark_prev3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_nexttopmark1:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  film_nextbotmark1:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_film_mark_next1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_nexttopmark2:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  film_nextbotmark2:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_film_mark_next2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  film_nexttopmark3:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  film_nextbotmark3:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_film_mark_next3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_upperbound_sad_forjudgemv:8;
        RBus_UInt32  smd_lowbound_sad_forjudgemv:8;
        RBus_UInt32  smd_localmv_counter_th:3;
        RBus_UInt32  smd_debug_outofrange_en:1;
        RBus_UInt32  smd_debug_spatialfreqnomatch_en:1;
        RBus_UInt32  smd_debug_mvschanged_en:1;
        RBus_UInt32  smd_debug_resurrect_en:1;
        RBus_UInt32  smd_debug_preinrateeth_en:1;
        RBus_UInt32  smd_spatialmv_counter_th:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_debug_sawtooth_en:1;
        RBus_UInt32  smd_debug_ventryofmv_en:1;
        RBus_UInt32  smd_debug_hentryofmv_en:1;
        RBus_UInt32  smd_en:1;
    };
}di_di_smd_control_candidatelist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_reliablerange_sad_th:8;
        RBus_UInt32  smd_localmv_sad_th:8;
        RBus_UInt32  smd_localmv_concentrate_ratio_th:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_spatial_divergence_th:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_spatialmv_sad_th:8;
    };
}di_di_smd_choosecandidate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_curr_teeth_offset:6;
        RBus_UInt32  smd_teeth_new_mode:2;
        RBus_UInt32  smd_curr_teeth_gain:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_preintra_teeth_gain:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_preintra_effect:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  smd_preintra_teeth_offset:6;
        RBus_UInt32  res4:1;
        RBus_UInt32  smd_steeth_en:1;
    };
}di_di_smd_refinemv1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_global_en_ratio:8;
        RBus_UInt32  smd_resurrect_minsad_th:8;
        RBus_UInt32  smd_resurrect_localcurr_num:4;
        RBus_UInt32  smd_resurrect_smallwindow_num:4;
        RBus_UInt32  smd_resurrect_union_num:5;
        RBus_UInt32  smd_resurrect_en:1;
        RBus_UInt32  smd_mvs_hchanged_en:1;
        RBus_UInt32  smd_mvs_vchanged_en:1;
    };
}di_di_smd_refinemv2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sfreq_drop_th:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  smd_sfreq_diff_th:8;
        RBus_UInt32  smd_sfreq_diff_gain:4;
        RBus_UInt32  res2:4;
    };
}di_di_smd_refinemv3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_smd_panning1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_rightweave_gap_th:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  smd_rightweave_gap_range:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  smd_leftweave_gap_th:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  smd_leftweave_gap_range:5;
        RBus_UInt32  res4:1;
        RBus_UInt32  smd_drop_singleintraline_en:1;
        RBus_UInt32  smd_drop_singleweaveline_en:1;
    };
}di_di_smd_final_adjustment1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_rightintra_gap_th:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  smd_rightintra_gap_range:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  smd_leftintra_gap_th:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  smd_leftintra_gap_range:5;
        RBus_UInt32  res4:2;
        RBus_UInt32  smd_line_continous_en:1;
    };
}di_di_smd_final_adjustment2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_compensate_avg:8;
        RBus_UInt32  smd_compensate_teeth_th:8;
        RBus_UInt32  res1:16;
    };
}di_di_smd_compensate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthly0:8;
        RBus_UInt32  cp_temporalthly1:8;
        RBus_UInt32  cp_temporalthly2:8;
        RBus_UInt32  cp_temporalthly3:8;
    };
}di_im_di_rtnr_y_16_th0_th3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthly4:8;
        RBus_UInt32  cp_temporalthly5:8;
        RBus_UInt32  cp_temporalthly6:8;
        RBus_UInt32  cp_temporalthly7:8;
    };
}di_im_di_rtnr_y_16_th4_th7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthly8:8;
        RBus_UInt32  cp_temporalthly9:8;
        RBus_UInt32  cp_temporalthly10:8;
        RBus_UInt32  cp_temporalthly11:8;
    };
}di_im_di_rtnr_y_16_th8_th11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthly12:8;
        RBus_UInt32  cp_temporalthly13:8;
        RBus_UInt32  cp_temporalthly14:8;
        RBus_UInt32  res1:8;
    };
}di_im_di_rtnr_y_16_th12_th14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthlc0:8;
        RBus_UInt32  cp_temporalthlc1:8;
        RBus_UInt32  cp_temporalthlc2:8;
        RBus_UInt32  cp_temporalthlc3:8;
    };
}di_im_di_rtnr_c_th0_th3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporalthlc4:8;
        RBus_UInt32  cp_temporalthlc5:8;
        RBus_UInt32  cp_temporalthlc6:8;
        RBus_UInt32  res1:8;
    };
}di_im_di_rtnr_c_th4_th6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_y_k0:4;
        RBus_UInt32  cp_temporal_y_k1:4;
        RBus_UInt32  cp_temporal_y_k2:4;
        RBus_UInt32  cp_temporal_y_k3:4;
        RBus_UInt32  cp_temporal_y_k4:4;
        RBus_UInt32  cp_temporal_y_k5:4;
        RBus_UInt32  cp_temporal_y_k6:4;
        RBus_UInt32  cp_temporal_y_k7:4;
    };
}di_im_di_rtnr_y_16_k0_k7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_y_k8:4;
        RBus_UInt32  cp_temporal_y_k9:4;
        RBus_UInt32  cp_temporal_y_k10:4;
        RBus_UInt32  cp_temporal_y_k11:4;
        RBus_UInt32  cp_temporal_y_k12:4;
        RBus_UInt32  cp_temporal_y_k13:4;
        RBus_UInt32  cp_temporal_y_k14:4;
        RBus_UInt32  cp_temporal_y_k15:4;
    };
}di_im_di_rtnr_y_16_k8_k15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_c_k0:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  cp_temporal_c_k1:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  cp_temporal_c_k2:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  cp_temporal_c_k3:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  cp_temporal_c_k4:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  cp_temporal_c_k5:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  cp_temporal_c_k6:3;
        RBus_UInt32  res7:1;
        RBus_UInt32  cp_temporal_c_k7:3;
        RBus_UInt32  res8:1;
    };
}di_im_di_rtnr_c_k_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dat_mstart_115_87:29;
    };
}di_di_datmemorystartadd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dat_mstart_86_58:29;
    };
}di_di_datmemorystartadd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dat_mstart_57_29:29;
    };
}di_di_datmemorystartadd3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dat_mstart_28_0:29;
    };
}di_di_datmemorystartadd4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  inf_mstart_57_29:29;
    };
}di_di_infmemorystartadd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  inf_mstart_28_0:29;
    };
}di_di_infmemorystartadd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_num_r:16;
        RBus_UInt32  dat_len_r:7;
        RBus_UInt32  dma_outstanding_en:1;
        RBus_UInt32  dat_water_r:8;
    };
}di_ddr_rdatdma_wtlennum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_num_w:16;
        RBus_UInt32  dat_len_w:7;
        RBus_UInt32  wdma_close:1;
        RBus_UInt32  dat_water_w:8;
    };
}di_ddr_wdatdma_wtlennum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dat_remain_r:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  dat_remain_w:7;
        RBus_UInt32  rdma_remain_en:1;
        RBus_UInt32  res2:16;
    };
}di_ddr_datdma_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inf_num_r:16;
        RBus_UInt32  inf_len_r:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  inf_water_r:8;
    };
}di_ddr_rinfdma_wtlennum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inf_num_w:16;
        RBus_UInt32  inf_len_w:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  inf_water_w:8;
    };
}di_ddr_winfdma_wtlennum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inf_remain_r:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  inf_remain_w:7;
        RBus_UInt32  res2:17;
    };
}di_ddr_infdma_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ccdinr_unfl:8;
        RBus_UInt32  ccdinr_ovfl:8;
        RBus_UInt32  ccdinr_flag_clr:8;
        RBus_UInt32  dma_reset_st:1;
        RBus_UInt32  crc_128b_compare_fail:1;
        RBus_UInt32  crc_128b_en:1;
        RBus_UInt32  res1:4;
        RBus_UInt32  ccdinr_fifoerr_ie:1;
    };
}di_ddr_dmastatus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ccdinr_wd_to_sub:1;
        RBus_UInt32  ccdinr_wd_to_main:1;
        RBus_UInt32  res1:27;
        RBus_UInt32  ccdinr_fifoerr_wde_sub:1;
        RBus_UInt32  ccdinr_vs_reset_en:1;
        RBus_UInt32  ccdinr_fifoerr_wde:1;
    };
}di_ddr_wde_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di1_wrrd_downlimit_adr:29;
    };
}di_di1_wrrd_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di1_wrrd_uplimit_adr:29;
    };
}di_di1_wrrd_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_rd_uplimit_ov:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  di1_rd_downlimit_ov:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  di1_wr_uplimit_ov:2;
        RBus_UInt32  di1_wr_downlimit_ov:2;
        RBus_UInt32  di1_wrrd_downup_limit_ov_clearstatus:1;
        RBus_UInt32  res3:11;
    };
}di_di1_wrrd_boundaryadd_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_datmemorystartadd1_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_datmemorystartadd2_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_datmemorystartadd3_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_datmemorystartadd4_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_infmemorystartadd1_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_infmemorystartadd2_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ccdinr_write_addr_l:29;
        RBus_UInt32  cp_line_dma_buffer_cnt:2;
        RBus_UInt32  res1:1;
    };
}di_di_line_base_dma_addr_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ccdinr_write_addr_r:29;
        RBus_UInt32  res1:3;
    };
}di_di_line_base_dma_addr_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wdma_req_num:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  rdma_req_num:3;
        RBus_UInt32  res2:24;
        RBus_UInt32  dma_info_first:1;
    };
}di_di_dma_multi_req_num_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  s0_mstart_115_87:29;
    };
}di_mvf_watmemorystart_s0_add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  s0_mstart_86_58:29;
    };
}di_mvf_watmemorystart_s0_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  s0_mstart_57_29:29;
    };
}di_mvf_watmemorystart_s0_add2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  s1_mstart_115_87:29;
    };
}di_mvf_watmemorystart_s1add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  s1_mstart_86_58:29;
    };
}di_mvf_watmemorystart_s1_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  s1_mstart_57_29:29;
    };
}di_mvf_watmemorystart_s1_add2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mvf_inf_num_w:16;
        RBus_UInt32  mvf_inf_len_w:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  mvf_inf_water_w:8;
    };
}di_mvf_ddr_wdma_wtlennum_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mvf_inf_remain_w:7;
        RBus_UInt32  res1:25;
    };
}di_mvf_ddr_wdatdma_rm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mvf_addr_uplimit_ov:1;
        RBus_UInt32  mvf_addr_downlimit_ov:1;
        RBus_UInt32  res1:10;
        RBus_UInt32  mvf_unfl:1;
        RBus_UInt32  mvf_ovfl:1;
        RBus_UInt32  mvf_flag_clr:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  wdma_s0_frame_cnt:2;
        RBus_UInt32  wdma_s1_frame_cnt:2;
        RBus_UInt32  mvf_set_first_frame:1;
        RBus_UInt32  mvf_wrrd_downup_limit_ov_clearstatus:1;
        RBus_UInt32  res3:10;
    };
}di_mvf_ddr_dmastatus_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mvf_crc:32;
    };
}di_mvf_ddr_crc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  mvf_wr_downlimit_adr:29;
    };
}di_mvf_wr_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  mvf_wr_uplimit_adr:29;
    };
}di_mvf_wr_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  s0_mstart_28_0:29;
    };
}di_mvf_watmemorystart_s0_add3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  s1_mstart_28_0:29;
    };
}di_mvf_watmemorystart_s1_add3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dat_i2r_mstart_115_87:29;
    };
}di_di_i2r_datmemorystartadd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dat_i2r_mstart_86_58:29;
    };
}di_di_i2r_datmemorystartadd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dat_i2r_mstart_57_29:29;
    };
}di_di_i2r_datmemorystartadd3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  dat_i2r_mstart_28_0:29;
    };
}di_di_i2r_datmemorystartadd4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  inf_i2r_mstart_57_29:29;
    };
}di_di_i2r_infmemorystartadd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  inf_i2r_mstart_28_0:29;
    };
}di_di_i2r_infmemorystartadd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_datmemorystartadd1_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_datmemorystartadd2_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_datmemorystartadd3_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_datmemorystartadd4_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_infmemorystartadd1_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_di_i2r_infmemorystartadd2_3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di1_i2r_wrrd_downlimit_adr:29;
    };
}di_di1_i2r_wrrd_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di1_i2r_wrrd_uplimit_adr:29;
    };
}di_di1_i2r_wrrd_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di1_i2r_rd_uplimit_ov:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  di1_i2r_rd_downlimit_ov:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  di1_i2r_wr_uplimit_ov:2;
        RBus_UInt32  di1_i2r_wr_downlimit_ov:2;
        RBus_UInt32  di1_i2r_wrrd_downup_limit_ov_clearstatus:1;
        RBus_UInt32  res3:11;
    };
}di_di1_i2r_wrrd_boundaryadd_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di1_mvf_i2r_wrrd_downlimit_adr:29;
    };
}di_di1_mvf_i2r_wrrd_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di1_mvf_i2r_wrrd_uplimit_adr:29;
    };
}di_di1_mvf_i2r_wrrd_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di1_info_wrrd_downlimit_adr:29;
    };
}di_di1_info_wrrd_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di1_info_wrrd_uplimit_adr:29;
    };
}di_di1_info_wrrd_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di1_info_i2r_wrrd_downlimit_adr:29;
    };
}di_di1_info_i2r_wrrd_boundaryaddr1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  di1_info_i2r_wrrd_uplimit_adr:29;
    };
}di_di1_info_i2r_wrrd_boundaryaddr2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_isnr_dma_bist_fail:4;
        RBus_UInt32  res1:4;
        RBus_UInt32  di_li3_bist_fail:8;
        RBus_UInt32  di_li2_bist_fail:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  di_li1_bist_fail:4;
        RBus_UInt32  res3:4;
    };
}di_dispi_bist_fail_separate_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_mcnr_tmv1_bist_fail:8;
        RBus_UInt32  rtnr_mcnr_tmv2_bist_fail:2;
        RBus_UInt32  di_tr2to1_bist_fail:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  di_dma_rdat_bist_fail:8;
        RBus_UInt32  di_dma_wdat_bist_fail:8;
    };
}di_dispi_bist_fail_separate_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  di_li6_bist_fail:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  di_li5_bist_fail:8;
        RBus_UInt32  di_li4_bist_fail:8;
    };
}di_dispi_bist_fail_separate_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_pqc1_bist_fail:1;
        RBus_UInt32  di_pqc2_bist_fail:13;
        RBus_UInt32  res1:2;
        RBus_UInt32  di_pqdc1_bist_fail:1;
        RBus_UInt32  di_pqdc2_bist_fail:2;
        RBus_UInt32  res2:13;
    };
}di_dispi_bist_fail_separate_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_isnr_dma_drf_fail:4;
        RBus_UInt32  res1:4;
        RBus_UInt32  di_li3_drf_fail:8;
        RBus_UInt32  di_li2_drf_fail:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  di_li1_drf_fail:4;
        RBus_UInt32  res3:4;
    };
}di_dispi_drf_fail_separate_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_mcnr_tmv1_drf_fail:8;
        RBus_UInt32  rtnr_mcnr_tmv2_drf_fail:2;
        RBus_UInt32  di_tr2to1_drf_fail:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  di_dma_rdat_drf_fail:8;
        RBus_UInt32  di_dma_wdat_drf_fail:8;
    };
}di_dispi_drf_fail_separate_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  di_li6_drf_fail:2;
        RBus_UInt32  res2:5;
        RBus_UInt32  di_li5_drf_fail:8;
        RBus_UInt32  di_li4_drf_fail:8;
    };
}di_dispi_drf_fail_separate_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_pqc1_drf_fail:1;
        RBus_UInt32  di_pqc2_drf_fail:13;
        RBus_UInt32  res1:2;
        RBus_UInt32  di_pqdc1_drf_fail:1;
        RBus_UInt32  di_pqdc2_drf_fail:2;
        RBus_UInt32  res2:13;
    };
}di_dispi_drf_fail_separate_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_dma_rdat_rme:1;
        RBus_UInt32  di_dma_wdat_rme:1;
        RBus_UInt32  rtnr_isnr_dma_rme:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  di_tr2to1_rme:1;
        RBus_UInt32  di_bisr_repaired_ro:1;
        RBus_UInt32  di_li6_rme_bisr:1;
        RBus_UInt32  di_li6_rme:1;
        RBus_UInt32  di_li5_rme:1;
        RBus_UInt32  di_li4_rme:1;
        RBus_UInt32  di_li3_rme:1;
        RBus_UInt32  di_li2_rme:1;
        RBus_UInt32  di_li1_rme:1;
        RBus_UInt32  rtnr_mcnr_tmv1_rme:1;
        RBus_UInt32  rtnr_mcnr_tmv2_rme:1;
        RBus_UInt32  di_pqc1_rme:1;
        RBus_UInt32  di_pqc2_rme:2;
        RBus_UInt32  di_pqdc1_rme:1;
        RBus_UInt32  di_pqdc2_rme:1;
        RBus_UInt32  res2:12;
    };
}di_dispi_bist_rme_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_li6_rm_bisr:4;
        RBus_UInt32  di_li6_rm:4;
        RBus_UInt32  di_li5_rm:4;
        RBus_UInt32  di_li4_rm:4;
        RBus_UInt32  di_li3_rm:4;
        RBus_UInt32  di_li2_rm:4;
        RBus_UInt32  di_li1_rm:4;
        RBus_UInt32  res1:4;
    };
}di_dispi_bist_rm_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_dma_rdat_rm:4;
        RBus_UInt32  di_dma_wdat_rm:4;
        RBus_UInt32  rtnr_isnr_dma_rm:4;
        RBus_UInt32  res1:4;
        RBus_UInt32  di_tr2to1_rm:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  rtnr_mcnr_tmv1_rm:4;
        RBus_UInt32  rtnr_mcnr_tmv2_rm:4;
    };
}di_dispi_bist_rm_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_pqc1_rm:4;
        RBus_UInt32  di_pqc2_rm:8;
        RBus_UInt32  di_pqdc1_rm:4;
        RBus_UInt32  di_pqdc2_rm:4;
        RBus_UInt32  res1:12;
    };
}di_dispi_bist_rm_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_mcnr_tmv1_bist_testrwm:1;
        RBus_UInt32  pqc_test_rwm:1;
        RBus_UInt32  pqdc_test_rwm:1;
        RBus_UInt32  res1:29;
    };
}di_dispi_bist_test_rwm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_dispi_bist_ls_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_apply:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_read:1;
        RBus_UInt32  res1:27;
        RBus_UInt32  sm_tog_3d_mode:1;
        RBus_UInt32  sm_tog_apply_disable:1;
    };
}di_db_reg_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_sm_size_change_hw_detect_en:1;
        RBus_UInt32  reg_sm_size_change_sw_detect_en:1;
        RBus_UInt32  reg_sm_size_change_sw_detect_en_i2r:1;
        RBus_UInt32  smooth_toggle_end_i2r:1;
        RBus_UInt32  smooth_toggle_end:1;
        RBus_UInt32  smooth_toggle_end_en:1;
        RBus_UInt32  res1:26;
    };
}di_i2r_db_reg_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ccdinr_debug_mode:3;
        RBus_UInt32  ccdinr_wd_debug_target_m:1;
        RBus_UInt32  ccdinr_wd_debug_mode_m:1;
        RBus_UInt32  ccdinr_wd_debug_target_s:1;
        RBus_UInt32  ccdinr_wd_debug_mode_s:1;
        RBus_UInt32  res1:25;
    };
}di_ccdinr_dbg_mux_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin1:16;
        RBus_UInt32  smd_sad_his_bin0:16;
    };
}di_di_smd_sadhisbina_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin3:16;
        RBus_UInt32  smd_sad_his_bin2:16;
    };
}di_di_smd_sadhisbinb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin5:16;
        RBus_UInt32  smd_sad_his_bin4:16;
    };
}di_di_smd_sadhisbinc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin7:16;
        RBus_UInt32  smd_sad_his_bin6:16;
    };
}di_di_smd_sadhisbind_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin9:16;
        RBus_UInt32  smd_sad_his_bin8:16;
    };
}di_di_smd_sadhisbine_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin11:16;
        RBus_UInt32  smd_sad_his_bin10:16;
    };
}di_di_smd_sadhisbinf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin13:16;
        RBus_UInt32  smd_sad_his_bin12:16;
    };
}di_di_smd_sadhisbing_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sad_his_bin15:16;
        RBus_UInt32  smd_sad_his_bin14:16;
    };
}di_di_smd_sadhisbinh_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_firmwaremv_y:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_firmwaremv_x:3;
        RBus_UInt32  res2:25;
    };
}di_di_smd_gmvcoeff3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_vpan_upper_bound:4;
        RBus_UInt32  smd_vpan_jump_out:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_vpan_work_th:4;
        RBus_UInt32  smd_firmware_pan_sad_th:6;
        RBus_UInt32  smd_pg_no_pixel_ctr_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_searchmv_apply_sad_th:6;
        RBus_UInt32  smd_vpan_en:1;
        RBus_UInt32  smd_hardware_pan_en:1;
        RBus_UInt32  smd_searchmv_apply:1;
        RBus_UInt32  smd_firmware_pan:1;
        RBus_UInt32  smd_apply_result_mode:2;
    };
}di_di_smd_pan1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_gmv3_th:14;
        RBus_UInt32  smd_vpan_total_pixel:6;
        RBus_UInt32  smd_vpan_gmv1_pixel:6;
        RBus_UInt32  smd_enter_pan_ctr_th:6;
    };
}di_di_smd_pan2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_rebuild_pan_ctr:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_search_apply_th:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  smd_addctr_gmv1_pixelth2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  smd_addctr_gmv1_pixelth1:6;
        RBus_UInt32  res4:2;
    };
}di_di_smd_pan3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_right_weave_blend:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  smd_left_weave_blend:5;
        RBus_UInt32  smd_expanse_range:3;
        RBus_UInt32  smd_curr_teeth_gain_c:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_curr_teeth_offset_c:6;
        RBus_UInt32  smd_result_en:1;
        RBus_UInt32  smd_colony_expanse_type:1;
        RBus_UInt32  smd_colony_expanse_en:1;
        RBus_UInt32  smd_colony_drop_en:1;
        RBus_UInt32  smd_intra_en:1;
        RBus_UInt32  smd_full_search_mode:1;
    };
}di_di_smd_additionalcoeff1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  smd_search_gmv_gain:3;
        RBus_UInt32  smd_search_gmv_offset:5;
        RBus_UInt32  smd_image_boundary_width:4;
        RBus_UInt32  smd_image_boundary_height:4;
    };
}di_di_smd_additionalcoeff2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_v4highfreqth1:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  smd_v4highfreqth2:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_v4highfreqeffect:6;
        RBus_UInt32  res3:1;
        RBus_UInt32  smd_patterngenmode:1;
    };
}di_di_smd_v4highfreq_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r15_pixelsum:16;
        RBus_UInt32  hmc_r16_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r13_pixelsum:16;
        RBus_UInt32  hmc_r14_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r11_pixelsum:16;
        RBus_UInt32  hmc_r12_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r9_pixelsum:16;
        RBus_UInt32  hmc_r10_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l8_pixelsum:16;
        RBus_UInt32  hmc_r8_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l10_pixelsum:16;
        RBus_UInt32  hmc_l9_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l12_pixelsum:16;
        RBus_UInt32  hmc_l11_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l14_pixelsum:16;
        RBus_UInt32  hmc_l13_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l16_pixelsum:16;
        RBus_UInt32  hmc_l15_pixelsum:16;
    };
}di_im_di_pan_detection_statistic_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gst_fmv2weave_n:4;
        RBus_UInt32  gst_fmv2weave_p:4;
        RBus_UInt32  gst_search_zmv_offset:6;
        RBus_UInt32  gst_replace_sad:1;
        RBus_UInt32  gst_pregmv_needstable:1;
        RBus_UInt32  res1:14;
        RBus_UInt32  gst_debug_fmv2weave:1;
        RBus_UInt32  gst_en:1;
    };
}di_di_gst_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gst_enter_origsad_offset:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  gst_enter_origsad_lowth:8;
        RBus_UInt32  res2:8;
    };
}di_di_gst_enter_origsadcheck_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gst_outofrange_fracsad_offset:8;
        RBus_UInt32  gst_outofrange_fracsadlowth:8;
        RBus_UInt32  gst_outofrange_origsad:8;
        RBus_UInt32  res1:7;
        RBus_UInt32  gst_outofrange_check:1;
    };
}di_di_gst_outofrangecheck_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gst_freqnonmatch_fracsad_offset:8;
        RBus_UInt32  gst_freqnonmatch_fracsad_lowth:8;
        RBus_UInt32  gst_freqnonmatch_origsad:8;
        RBus_UInt32  res1:7;
        RBus_UInt32  gst_freqnonmatch_check:1;
    };
}di_di_gst_freqnonmatchcheck_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_spatialmv_sad_max:8;
        RBus_UInt32  smd_localmv_sad_max:8;
        RBus_UInt32  smd_gmv_sad_max:8;
        RBus_UInt32  smd_gmv_sad_th:7;
        RBus_UInt32  res1:1;
    };
}di_di_smd_candidatelimitsad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hme_sobel_search_min:4;
        RBus_UInt32  res1:4;
        RBus_UInt32  hme_max_absolute_count:8;
        RBus_UInt32  res2:1;
        RBus_UInt32  hmc_odd_mv_no_compesation:1;
        RBus_UInt32  hmc_mv_refine_en:1;
        RBus_UInt32  mc_dynamic_threshold_clip_en:1;
        RBus_UInt32  hmc_mv_refine_y_th:8;
        RBus_UInt32  hmc_dynamic_threshold_min_clip:3;
        RBus_UInt32  hmc_mv_refine_mor_en:1;
    };
}di_im_di_hmc_adjustable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_mv_refine_cur_motion_th:8;
        RBus_UInt32  hmc_mv_refine_mor_same_th1_hh:6;
        RBus_UInt32  hmc_mv_refine_cur_motion_en:1;
        RBus_UInt32  hmc_follow_ma_result_en:1;
        RBus_UInt32  hmc_mv_refine_mor_zero_th1_hh:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  hmc_mv_refine_mor_noise_th:4;
        RBus_UInt32  hme_x_continued_counter:4;
    };
}di_im_di_hmc_adjustable2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_mv_refine_mor_same_th1:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  hmc_mv_refine_mor_zero_th1:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  hmc_mv_refine_mor_same_th2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  hmc_mv_refine_mor_zero_th2:6;
        RBus_UInt32  hmc_fail_follow_ma_result_en:1;
        RBus_UInt32  res4:1;
    };
}di_im_di_hmc_adjustable3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_mv_refine_mor_hh_v_th:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  hmc_mv_refine_mor_hh_h_th:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  hmc_mv_refine_sobel_diff_th:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  hmc_mv_refine_sobel_non_edge_th:4;
        RBus_UInt32  res4:3;
        RBus_UInt32  hmc_mv_refine_sobel_en:1;
    };
}di_im_di_hmc_adjustable4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scene_change_cond2_th:16;
        RBus_UInt32  scene_change_cond1_th:11;
        RBus_UInt32  scene_change_debug_en:1;
        RBus_UInt32  scene_change_cond2_result:1;
        RBus_UInt32  scene_change_cond1_result:1;
        RBus_UInt32  scene_change_cond2_en:1;
        RBus_UInt32  scene_change_cond1_en:1;
    };
}di_im_di_sc_adjustment_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_me_fw_control_motion_vector_det:1;
        RBus_UInt32  pan_me_fw_control_motion_vector:6;
        RBus_UInt32  pan_mc_debug_en:1;
        RBus_UInt32  hmc_debug_en:1;
        RBus_UInt32  pan_me_select_mv_hist:1;
        RBus_UInt32  pan_mc_force_compensation_en:1;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_en:1;
        RBus_UInt32  pan_me_invalid_check_en:1;
        RBus_UInt32  pan_mc_rls_en:1;
        RBus_UInt32  pan_me_sub_pixel_mv_det_en:1;
        RBus_UInt32  pan_mc_adaptive_compensation_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  hme_check_zero_mv_en:1;
        RBus_UInt32  hme_consider_mv_invalid_en:1;
        RBus_UInt32  hme_avoid_rltype_vertical_pan_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  hmc_mv_refine_sub_px_mv_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  hmc_half_mv_blending_en:1;
        RBus_UInt32  hmc_half_mv_correct_en:1;
        RBus_UInt32  hmc_half_mv_energy_check_en:1;
        RBus_UInt32  hmc_half_mv_all_teeth_check_en:1;
        RBus_UInt32  hmc_half_mv_notteeth_recover_en:1;
        RBus_UInt32  ma_horicom_teethdiff_en:1;
        RBus_UInt32  dummy18024660_31_29:3;
    };
}di_im_di_hmc_pan_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_th0:6;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_th1:6;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_th2:6;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_1:4;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_2:4;
        RBus_UInt32  pan_me_sobel_diff_ref_y_add_bias_3:4;
        RBus_UInt32  res1:2;
    };
}di_im_di_hmc_pan_add_bias_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hme_sum_max_ratio:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  pan_me_invalid_check_cnt_thd:5;
        RBus_UInt32  pan_me_invalid_check_maxmin_diff_thd:5;
        RBus_UInt32  pan_mc_rls_sobel_diff_min_th:5;
        RBus_UInt32  res2:9;
    };
}di_im_di_hmc_pan_control_par_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pan_mc_adaptive_compensation_teeth_thd:8;
        RBus_UInt32  hme_avoid_rltype_vertical_pan_rledge_thd:5;
        RBus_UInt32  hme_avoid_rltype_vertical_pan_nedge_thd:4;
        RBus_UInt32  res1:7;
        RBus_UInt32  hmc_sub_pixel_diff_thd:8;
    };
}di_im_di_hmc_pan_control_par_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  hmc_half_mv_correct_weight2:4;
        RBus_UInt32  hmc_half_mv_correct_weight1:4;
    };
}di_im_di_hmc_pan_vertical_intra_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  hmc_half_mv_correct_weight4:4;
        RBus_UInt32  hmc_half_mv_correct_weight3:4;
    };
}di_im_di_hmc_pan_vertical_intra_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_half_mv_correct_energy_th3:6;
        RBus_UInt32  hmc_half_mv_correct_energy_th2:6;
        RBus_UInt32  hmc_half_mv_correct_energy_th1:6;
        RBus_UInt32  hmc_half_mv_correct_nextdiff_th:6;
        RBus_UInt32  hmc_half_mv_correct_prediff_th:6;
        RBus_UInt32  res1:2;
    };
}di_im_di_hmc_pan_dummy_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  hmc_half_mv_notteeth_recover_hline_th:8;
        RBus_UInt32  hmc_half_mv_energy_check_nxt_gain:6;
        RBus_UInt32  hmc_half_mv_energy_check_nxt_th:5;
        RBus_UInt32  hmc_half_mv_energy_check_pre_gain:6;
        RBus_UInt32  hmc_half_mv_energy_check_pre_th:5;
    };
}di_im_di_hmc_pan_dummy_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_half_mv_notteeth_recover_dline_th:8;
        RBus_UInt32  hmc_half_mv_correct_energy_bias:3;
        RBus_UInt32  hmc_half_mv_all_teeth_check_th:6;
        RBus_UInt32  hmc_blending_with_ma_gain:6;
        RBus_UInt32  hmc_blending_with_ma_gain_factor:4;
        RBus_UInt32  hmc_blending_with_ma_gain_en:1;
        RBus_UInt32  hmc_blending_with_ma_en:1;
        RBus_UInt32  dummy18024684_31_29:3;
    };
}di_im_di_hmc_pan_dummy_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_snr_en:1;
        RBus_UInt32  rtnr_ma_snr_mask:1;
        RBus_UInt32  rtnr_ma_snr_debug_mode_en:1;
        RBus_UInt32  rtnr_ma_snr_debug_mode_selection:2;
        RBus_UInt32  rtnr_ma_isnr_debug_mode_en:1;
        RBus_UInt32  rtnr_ma_isnr_debug_mode_selection:2;
        RBus_UInt32  rtnr_ma_snr_blending_factor1:4;
        RBus_UInt32  rtnr_ma_snr_blending_factor2:4;
        RBus_UInt32  rtnr_ma_snr_blending_factor3:4;
        RBus_UInt32  rtnr_ma_snr_blending_factor4:4;
        RBus_UInt32  rtnr_ma_snr_blending_factor5:4;
        RBus_UInt32  res1:4;
    };
}di_rtnr_ma_snr_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_snr_motion_th1_low:8;
        RBus_UInt32  rtnr_ma_snr_motion_th2_low:8;
        RBus_UInt32  rtnr_ma_snr_motion_th3_low:8;
        RBus_UInt32  rtnr_ma_snr_motion_th4_low:8;
    };
}di_rtnr_ma_snr_motion_th_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_snr_motion_th1_high:8;
        RBus_UInt32  rtnr_ma_snr_motion_th2_high:8;
        RBus_UInt32  rtnr_ma_snr_motion_th3_high:8;
        RBus_UInt32  rtnr_ma_snr_motion_th4_high:8;
    };
}di_rtnr_ma_snr_motion_th_high_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_snr_edge_th_low:8;
        RBus_UInt32  rtnr_ma_snr_edge_th_high:8;
        RBus_UInt32  res1:16;
    };
}di_rtnr_ma_snr_motion_edge_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_snr_motion_slope1:8;
        RBus_UInt32  rtnr_ma_snr_motion_slope2:8;
        RBus_UInt32  rtnr_ma_snr_motion_slope3:8;
        RBus_UInt32  rtnr_ma_snr_motion_slope4:8;
    };
}di_rtnr_ma_snr_motion_th_slope_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_snr_edge_curve_lo_th:8;
        RBus_UInt32  rtnr_ma_snr_edge_curve_slope:8;
        RBus_UInt32  rtnr_ma_snr_output_clamp:8;
        RBus_UInt32  rtnr_ma_snr_strength:4;
        RBus_UInt32  res1:4;
    };
}di_rtnr_ma_snr_strength_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_output_clamp_luma:8;
        RBus_UInt32  rtnr_output_clamp_chroma:8;
        RBus_UInt32  rtnr_output_clamp_en:1;
        RBus_UInt32  res1:15;
    };
}di_rtnr_output_clamp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  smd_stillsad_max:5;
        RBus_UInt32  smd_fw_gmvy:3;
        RBus_UInt32  smd_stillsad_th:5;
        RBus_UInt32  res2:2;
        RBus_UInt32  smd_elseintra_en:1;
    };
}di_di_smd_waterflag_ctr3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_searchmvapply_ctr:8;
        RBus_UInt32  smd_firmwarepan_sadmax:9;
        RBus_UInt32  smd_fw_gmvx:3;
        RBus_UInt32  smd_gmvb_sadmin_th:4;
        RBus_UInt32  smd_streammv_gmv_diff:5;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_hardwarepan_firststep:1;
    };
}di_di_smd_hardwarepan_modify1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gst_subpixel_firmwarepan_fmv1:4;
        RBus_UInt32  gst_subpixel_firmwarepan_fmv2:4;
        RBus_UInt32  gst_subpixel_firmwarepan:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  gst_blend_weight:2;
        RBus_UInt32  gst_compensate_blending_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  gst_compensate_fmv8_en:1;
        RBus_UInt32  gst_compensate_fmv7_en:1;
        RBus_UInt32  gst_compensate_fmv6_en:1;
        RBus_UInt32  gst_compensate_fmv5_en:1;
        RBus_UInt32  gst_compensate_fmv4_en:1;
        RBus_UInt32  gst_compensate_fmv3_en:1;
        RBus_UInt32  gst_compensate_fmv2_en:1;
        RBus_UInt32  gst_compensate_fmv1_en:1;
        RBus_UInt32  gst_compensate_fmv0_en:1;
        RBus_UInt32  gst_pg_highpriority:1;
        RBus_UInt32  gst_integerpan_highpriority:1;
        RBus_UInt32  gst_subpixel_rlv2intra_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  gst_debug_subpixel_pan:1;
        RBus_UInt32  gst_subpixel_compensate_en:1;
    };
}di_di_gst_compensate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gst_subpixel_firmwarepan_sadmax:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  gst_subpixel_firmwarepan_sadmin:6;
        RBus_UInt32  res2:10;
    };
}di_di_gst_fmv_pan_coeff1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ma_weavemode_check_th:8;
        RBus_UInt32  ma_weavemode_check_gain:4;
        RBus_UInt32  res1:19;
        RBus_UInt32  ma_weavemode_check_en:1;
    };
}di_di_ma_weavemode_check_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_r4_sum:16;
        RBus_UInt32  hmcnr_r5_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_r2_sum:16;
        RBus_UInt32  hmcnr_r3_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_c0_sum:16;
        RBus_UInt32  hmcnr_r1_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_l2_sum:16;
        RBus_UInt32  hmcnr_l1_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmcnr_l4_sum:16;
        RBus_UInt32  hmcnr_l3_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy18024858_15_0:16;
        RBus_UInt32  hmcnr_l5_sum:16;
    };
}di_im_di_rtnr_hmcnr_statistic_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_c_th3:11;
        RBus_UInt32  res1:5;
        RBus_UInt32  cp_temporal_mad_y_th3:11;
        RBus_UInt32  res2:5;
    };
}di_im_di_rtnr_mad_y_th2_c_th2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_countery2:21;
        RBus_UInt32  res1:11;
    };
}di_im_di_rtnr_mad_y_counter_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_countery3:21;
        RBus_UInt32  res1:11;
    };
}di_im_di_rtnr_mad_y_counter_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_counteru2:21;
        RBus_UInt32  res1:11;
    };
}di_im_di_rtnr_mad_u_counter_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_counteru3:21;
        RBus_UInt32  res1:11;
    };
}di_im_di_rtnr_mad_u_counter_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_counterv2:21;
        RBus_UInt32  res1:11;
    };
}di_im_di_rtnr_mad_v_counter_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_mad_counterv3:21;
        RBus_UInt32  res1:11;
    };
}di_im_di_rtnr_mad_v_counter_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vhf_teeth_depth_th:5;
        RBus_UInt32  vhf_check_mode:2;
        RBus_UInt32  vhf_en:1;
        RBus_UInt32  vhf_fm_offset_th1:4;
        RBus_UInt32  vhf_fm_offset_th2:4;
        RBus_UInt32  vhf_fm_offset_th3:4;
        RBus_UInt32  vhf_fm_offset_th4:4;
        RBus_UInt32  vhf_energy_th0:8;
    };
}di_im_di_ma_vhf_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vhf_energy_th1:8;
        RBus_UInt32  vhf_energy_th2:8;
        RBus_UInt32  vhf_energy_th3:8;
        RBus_UInt32  vhf_energy_th4:8;
    };
}di_im_di_ma_vhf_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vhf_energy_slop1:8;
        RBus_UInt32  vhf_energy_slop2:8;
        RBus_UInt32  vhf_energy_slop3:8;
        RBus_UInt32  vhf_energy_slop4:8;
    };
}di_im_di_ma_vhf_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nintra_src_lpf_clamp_en:1;
        RBus_UInt32  nintra_new_mode_en:1;
        RBus_UInt32  nintra_ydiff_mode:1;
        RBus_UInt32  nintra_vbound_detect_en:1;
        RBus_UInt32  nintra_search_min_limit_en:1;
        RBus_UInt32  nintra_high_freq_detect_en:1;
        RBus_UInt32  nintra_intersection_check_en:1;
        RBus_UInt32  nintra_dynamic_cross_th_en:1;
        RBus_UInt32  nintra_min_second_dir_check_en:1;
        RBus_UInt32  nintra_min_second_dir_check2_en:1;
        RBus_UInt32  nintra_pre_dir_check_en:1;
        RBus_UInt32  nintra_lowpass_dir_check_en:1;
        RBus_UInt32  nintra_preline_dir_check1_en:1;
        RBus_UInt32  nintra_preline_dir_check2_en:1;
        RBus_UInt32  nintra_dyn_dir_lowpass_en:1;
        RBus_UInt32  nintra_output_lowpass_en:1;
        RBus_UInt32  nintra_lowpass_dir_count_th:4;
        RBus_UInt32  nintra_check2_y_diff_th:8;
        RBus_UInt32  nintra_n_check2_control_disable:1;
        RBus_UInt32  nintra_ud_boundary_repeat_en:1;
        RBus_UInt32  nintra_sr_minus_value:1;
        RBus_UInt32  res1:1;
    };
}di_im_di_nintra_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nintra_lp_src_edge_th1:8;
        RBus_UInt32  nintra_lp_src_edge_th2:8;
        RBus_UInt32  nintra_lp_src_edge_slope:8;
        RBus_UInt32  nintra_lp_src_yclamp_th:8;
    };
}di_im_di_nintra_lowpass_source_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nintra_hdiff_th1:8;
        RBus_UInt32  nintra_hdiff_th2:8;
        RBus_UInt32  nintra_dir_search_region_max:4;
        RBus_UInt32  res1:12;
    };
}di_im_di_nintra_search_dir_limit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nintra_slopediff_th:8;
        RBus_UInt32  nintra_crossdiff_th:8;
        RBus_UInt32  nintra_crossslope_diff_th:8;
        RBus_UInt32  res1:8;
    };
}di_im_di_nintra_intersection_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nintra_minsecond_diff_th:8;
        RBus_UInt32  nintra_vertical_diff_th:8;
        RBus_UInt32  nintra_minsecond_diff_th2:8;
        RBus_UInt32  nintra_minsecond_diff_th3:8;
    };
}di_im_di_nintra_1st_2nd_ydiff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nintra_hfq_hdiff_th:8;
        RBus_UInt32  nintra_trans_count_th1:8;
        RBus_UInt32  nintra_trans_count_th2:8;
        RBus_UInt32  res1:8;
    };
}di_im_di_nintra_high_freq_limit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_hmc_me_refine_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  hmc_fw_ctrl_bypass:1;
        RBus_UInt32  res2:10;
        RBus_UInt32  hmc_teeth_of_line_th:8;
        RBus_UInt32  hmc_teeth_total:8;
    };
}di_im_di_hmc_me_refine_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_hmc_me_refine_ctrl_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_hmc_me_refine_ctrl_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:32;
    };
}di_im_di_hmc_me_refine_ctrl_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_new_en:1;
        RBus_UInt32  n_h_pan_flag:1;
        RBus_UInt32  n_h_pan_zeromv_penalty_en:1;
        RBus_UInt32  n_y_zero_mv_k_en:1;
        RBus_UInt32  n_zero_mv_gain8_en:1;
        RBus_UInt32  n_mv_diff_distance_select:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  n_c_zero_mv_k_en:1;
        RBus_UInt32  n_mcnr_weight_avg_en:1;
        RBus_UInt32  n_mcnr_weight_clamp_en:1;
        RBus_UInt32  n_rtnr_y_k_select:1;
        RBus_UInt32  n_mcnr_y_k_select_mc:1;
        RBus_UInt32  n_rtnr_c_k_select:1;
        RBus_UInt32  n_mcnr_debug_mode_en:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  hori_boundary_th:4;
        RBus_UInt32  n_mcnr_debug_mode_select:3;
        RBus_UInt32  n_mcnr_mv_diff_max_en:1;
        RBus_UInt32  n_mcnr_old_search_range_en:1;
        RBus_UInt32  res3:3;
    };
}di_im_new_mcnr_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  h_pan_mv_penalty:8;
        RBus_UInt32  h_pan_mv_value:5;
        RBus_UInt32  res1:19;
    };
}di_im_new_mcnr_pan_condition_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mv_diff_th:8;
        RBus_UInt32  sad_min_th:8;
        RBus_UInt32  mv_diff_slope:4;
        RBus_UInt32  sad_min_slope:4;
        RBus_UInt32  res1:8;
    };
}di_im_new_mcnr_weighting_condition_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  mcnr_weight_clamp_upth:5;
        RBus_UInt32  mcnr_weight_clamp_loth:5;
        RBus_UInt32  n_mcnr_weight_avg_mode:1;
        RBus_UInt32  n_mcnr_weight_mode:1;
        RBus_UInt32  n_mcnr_weight1:4;
        RBus_UInt32  n_mcnr_weight2:4;
        RBus_UInt32  n_mcnr_weight3:4;
        RBus_UInt32  res2:4;
    };
}di_im_new_mcnr_clamping_value_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l13_linesum:8;
        RBus_UInt32  hmc_l14_linesum:8;
        RBus_UInt32  hmc_l15_linesum:8;
        RBus_UInt32  hmc_l16_linesum:8;
    };
}di_im_di_hme_line_statistic_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l9_linesum:8;
        RBus_UInt32  hmc_l10_linesum:8;
        RBus_UInt32  hmc_l11_linesum:8;
        RBus_UInt32  hmc_l12_linesum:8;
    };
}di_im_di_hme_line_statistic_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l5_linesum:8;
        RBus_UInt32  hmc_l6_linesum:8;
        RBus_UInt32  hmc_l7_linesum:8;
        RBus_UInt32  hmc_l8_linesum:8;
    };
}di_im_di_hme_line_statistic_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_l1_linesum:8;
        RBus_UInt32  hmc_l2_linesum:8;
        RBus_UInt32  hmc_l3_linesum:8;
        RBus_UInt32  hmc_l4_linesum:8;
    };
}di_im_di_hme_line_statistic_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r3_linesum:8;
        RBus_UInt32  hmc_r2_linesum:8;
        RBus_UInt32  hmc_r1_linesum:8;
        RBus_UInt32  hmc_c0_linesum:8;
    };
}di_im_di_hme_line_statistic_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r7_linesum:8;
        RBus_UInt32  hmc_r6_linesum:8;
        RBus_UInt32  hmc_r5_linesum:8;
        RBus_UInt32  hmc_r4_linesum:8;
    };
}di_im_di_hme_line_statistic_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r11_linesum:8;
        RBus_UInt32  hmc_r10_linesum:8;
        RBus_UInt32  hmc_r9_linesum:8;
        RBus_UInt32  hmc_r8_linesum:8;
    };
}di_im_di_hme_line_statistic_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_r15_linesum:8;
        RBus_UInt32  hmc_r14_linesum:8;
        RBus_UInt32  hmc_r13_linesum:8;
        RBus_UInt32  hmc_r12_linesum:8;
    };
}di_im_di_hme_line_statistic_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hmc_linesum_step:4;
        RBus_UInt32  hmc_linesum_step_tolerance:4;
        RBus_UInt32  hmc_linesum_step_mv_diff_th:4;
        RBus_UInt32  res1:12;
        RBus_UInt32  hmc_r16_linesum:8;
    };
}di_im_di_hme_line_statistic_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_count:24;
        RBus_UInt32  res1:7;
        RBus_UInt32  di_ddr_comp_en:1;
    };
}di_di_ddr_checksum_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_flag_127_96:32;
    };
}di_di_ddr_checksum_flag_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_flag_95_64:32;
    };
}di_di_ddr_checksum_flag_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_flag_63_32:32;
    };
}di_di_ddr_checksum_flag_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_flag_31_0:32;
    };
}di_di_ddr_checksum_flag_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_mask_127_96:32;
    };
}di_di_ddr_checksum_mask_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_mask_95_64:32;
    };
}di_di_ddr_checksum_mask_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_mask_63_32:32;
    };
}di_di_ddr_checksum_mask_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ddr_error_mask_31_0:32;
    };
}di_di_ddr_checksum_mask_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cp_temporal_hmcnr_search_range:4;
        RBus_UInt32  res1:2;
        RBus_UInt32  n_mcnr_v_pre_loadok:1;
        RBus_UInt32  n_mcnr_v_pre_loadok_clr:1;
        RBus_UInt32  n_mcnr_y_boundary_th:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  n_mcnr_mad_min_th:8;
        RBus_UInt32  n_mcnr_mad_min_uv_th:8;
    };
}di_im_new_mcnr_control2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_waterflow_protect_en:1;
        RBus_UInt32  smd_debugsawtooth_waterflow_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_currteethgain_wf:4;
        RBus_UInt32  smd_totalteethoffset_wf:4;
        RBus_UInt32  smd_compensate_teeth_th_wf:4;
        RBus_UInt32  smd_min_total_th_wf:4;
        RBus_UInt32  smd_sawtooth_count_th_wf:8;
        RBus_UInt32  res2:4;
    };
}di_di_smd_waterflow_teeth_ctr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sawtooth_count_wf:16;
        RBus_UInt32  res1:16;
    };
}di_di_smd_waterflow_teeth_count_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_outofrange_lpf_en:1;
        RBus_UInt32  smd_smd_blend_lpf_en:1;
        RBus_UInt32  smd_smd_blend_clamp_en:1;
        RBus_UInt32  smd_spatial_mv_diff_weight_en:1;
        RBus_UInt32  smd_smd_weight_out_debug_en:1;
        RBus_UInt32  smd_odd_mvy_ma_out_select:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_spatial_mv_diff_coring:4;
        RBus_UInt32  smd_spatial_mv_diff_gain:4;
        RBus_UInt32  smd_outdata_limit_en:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  smd_outdata_limit_mvx:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  smd_outdata_limit_mvy:2;
        RBus_UInt32  smd_mv0_no_intra_en:1;
        RBus_UInt32  smd_still_ma_en:1;
        RBus_UInt32  smd_db_tmv_shift:1;
        RBus_UInt32  smd_db_tmv_out:1;
        RBus_UInt32  smd_spatialmv_method:1;
        RBus_UInt32  res4:1;
    };
}di_di_smd_ma_mc_weight_ctr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_mcdi2madi_en:1;
        RBus_UInt32  smd_mcdi2madi_v_pan_new_en:1;
        RBus_UInt32  smd_mcdi2madi_debug_en:1;
        RBus_UInt32  smd_intra_weight_method:1;
        RBus_UInt32  smd_intra_weight_method_vpan:1;
        RBus_UInt32  smd_diag_count_th:3;
        RBus_UInt32  nintra_hv_diff_th:8;
        RBus_UInt32  nintra_h_diff_th:8;
        RBus_UInt32  nintra_v_dir_flag_en:1;
        RBus_UInt32  smd_smd_vs_detect_length:1;
        RBus_UInt32  smd_smd_ma_only_v_en:1;
        RBus_UInt32  smd_smd_ma_only_center_en:1;
        RBus_UInt32  res1:4;
    };
}di_di_smd_diag_edge_protect_ctr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_acc_ctr_reset:1;
        RBus_UInt32  smd_outofrange_content_new:1;
        RBus_UInt32  smd_sawtooth_condition_select:1;
        RBus_UInt32  smd_mess_conditionoff:1;
        RBus_UInt32  smd_acc_smd_en:1;
        RBus_UInt32  smd_spatialfreqnomatch_off:1;
        RBus_UInt32  smd_weave_dynamic:2;
        RBus_UInt32  smd_linecontinous_new_condition:1;
        RBus_UInt32  gst_min_sad_compare_diable:1;
        RBus_UInt32  gst_gst_static_disable:1;
        RBus_UInt32  gst_min_sad_nolimit_en:1;
        RBus_UInt32  smd_teeth_value_select:1;
        RBus_UInt32  smd_outrange_teeth_select:2;
        RBus_UInt32  smd_weight_lpf_select:1;
        RBus_UInt32  smd_mv_pixel_acc_max_th:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_mv_pixel_acc_th:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  smd_mv_pixel_acc_th2:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  smd_resurrectsmallwindownum2:4;
    };
}di_di_smd_slow_motion_handle1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_reliablerangesadth2:8;
        RBus_UInt32  smd_resurrectminsadth2:8;
        RBus_UInt32  gst_mv_limit:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_messlevel_gain:4;
        RBus_UInt32  smd_messlevel_gain2:4;
        RBus_UInt32  smd_mv_pixel_acc_th3:3;
        RBus_UInt32  res2:1;
    };
}di_di_smd_slow_motion_handle2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_r9_sum:16;
        RBus_UInt32  mcnr_r10_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_r7_sum:16;
        RBus_UInt32  mcnr_r8_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_l6_sum:16;
        RBus_UInt32  mcnr_r6_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_l8_sum:16;
        RBus_UInt32  mcnr_l7_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_l10_sum:16;
        RBus_UInt32  mcnr_l9_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_sadwindow_select:1;
        RBus_UInt32  smd_messlevel_select:2;
        RBus_UInt32  smd_hd_zero_mv_sad_select:1;
        RBus_UInt32  smd_search_range_limit_en:1;
        RBus_UInt32  smd_teeth_no_ressurrect_n_en:1;
        RBus_UInt32  ma_smd_h_compensate_new_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  smd_messlevel_vgain:3;
        RBus_UInt32  smd_field_diff_clamp:8;
        RBus_UInt32  smd_compensate_teeth_th2:4;
        RBus_UInt32  smd_outrange_field_diff_th:8;
    };
}di_di_smd_slow_motion_handle3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_gmv_candidate_method:1;
        RBus_UInt32  smd_fmv_gmv_penalty_en:1;
        RBus_UInt32  smd_notonly_zero_gmv:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_messlevel_th:8;
        RBus_UInt32  smd_messlevel_gain_slope:8;
        RBus_UInt32  res2:12;
    };
}di_di_smd_gmv_penalty_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_gmv_penalty_mess_gain_en:1;
        RBus_UInt32  smd_gmv_only_teeth_mess_gain_en:1;
        RBus_UInt32  smd_gmv_penalty_clamp_en:1;
        RBus_UInt32  smd_gmv_sad_select:1;
        RBus_UInt32  smd_gmv_clamp:8;
        RBus_UInt32  smd_messlevel_field_diff:8;
        RBus_UInt32  res1:12;
    };
}di_di_smd_gmv_penalty_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_mv_not_gmv_resurrect_en:1;
        RBus_UInt32  smd_resurrect_noacc_en:1;
        RBus_UInt32  smd_nongmv0_noacc_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  smd_mv_pixel_acc_th4:3;
        RBus_UInt32  smd_gst_compensate_avg_en:1;
        RBus_UInt32  smd_teeth_detect_method:1;
        RBus_UInt32  smd_teeth_res_en:1;
        RBus_UInt32  smd_notgmv_res_en:1;
        RBus_UInt32  smd_mv_teeth_detect_en:1;
        RBus_UInt32  res2:20;
    };
}di_di_smd_resurrect_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_gmvctr_fw:16;
        RBus_UInt32  smd_gmv1maxctr_fw:16;
    };
}di_di_smd_gmv_fw_counter1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_gmv2maxctr_fw:16;
        RBus_UInt32  smd_gmv3maxctr_fw:16;
    };
}di_di_smd_gmv_fw_counter2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_gmv1_x_fw:3;
        RBus_UInt32  res1:13;
        RBus_UInt32  smd_gmv1_y_fw:3;
        RBus_UInt32  res2:13;
    };
}di_di_smd_gmv1_value_fw_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_gmv2_x_fw:3;
        RBus_UInt32  res1:13;
        RBus_UInt32  smd_gmv2_y_fw:3;
        RBus_UInt32  res2:13;
    };
}di_di_smd_gmv2_value_fw_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_tmvx_diff_th1:2;
        RBus_UInt32  smd_tmvy_diff_th1:2;
        RBus_UInt32  smd_tmvx_diff_th2:2;
        RBus_UInt32  smd_tmvy_diff_th2:2;
        RBus_UInt32  smd_tmvx_diff_th3:2;
        RBus_UInt32  smd_tmvy_diff_th3:2;
        RBus_UInt32  smd_tmv_acc1:2;
        RBus_UInt32  smd_tmv_acc2:2;
        RBus_UInt32  smd_tmv_acc3:2;
        RBus_UInt32  gst_static_tmvdiff_th:5;
        RBus_UInt32  smd_c_teeth_disable:1;
        RBus_UInt32  smd_dt_count_th1:4;
        RBus_UInt32  smd_dt_count_th2:4;
    };
}di_di_smd_tmv_similarity_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smd_teeth_vlpf_en:1;
        RBus_UInt32  smd_acc_teeth_count_en:1;
        RBus_UInt32  smd_teeth_pos:1;
        RBus_UInt32  smd_mv_pixel_acc_th5:3;
        RBus_UInt32  smd_mad_th_tf:7;
        RBus_UInt32  smd_teeth_th_tf:7;
        RBus_UInt32  smd_hori_diff_th:7;
        RBus_UInt32  smd_hori_diff_gain:5;
    };
}di_di_smd_teeth_processing_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_u2_sum:16;
        RBus_UInt32  mcnr_u3_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_v0_sum:16;
        RBus_UInt32  mcnr_u1_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_d2_sum:16;
        RBus_UInt32  mcnr_d1_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_static_sum:16;
        RBus_UInt32  mcnr_d3_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_k_factor_lpf_en:1;
        RBus_UInt32  n_mcnr_kfactor_lpf_method:1;
        RBus_UInt32  n_mcnr_kfactor_lpf_large_select:1;
        RBus_UInt32  n_mcnr_mv_mad_blending_en:1;
        RBus_UInt32  n_mcnr_mv_mad_mv_lo_th:4;
        RBus_UInt32  n_mcnr_messlevel_th:8;
        RBus_UInt32  res1:3;
        RBus_UInt32  n_mcnr_mv_mad_blending_vertical_en:1;
        RBus_UInt32  n_mcnr_mv_mad_mv_gap:2;
        RBus_UInt32  n_mcnr_mad_hist_all_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  n_mcnr_mad_stat_pos_select:1;
        RBus_UInt32  n_mcnr_still_stat_disable:1;
        RBus_UInt32  n_mcnr_mad_mv_nolimit_en:1;
        RBus_UInt32  n_mcnr_tmv_value0_en:1;
        RBus_UInt32  n_mcnr_only_h_c_en:1;
        RBus_UInt32  n_mcnr_mad_hist_shift_en:1;
        RBus_UInt32  n_mcnr_tmv_bz_select:2;
    };
}di_im_new_mcnr_control3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_mad_offset:8;
        RBus_UInt32  n_mcnr_mad_uv_offset:8;
        RBus_UInt32  res1:16;
    };
}di_im_new_mcnr_mv_mad_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  blending_weight_mode:2;
        RBus_UInt32  blending_weight_edge_srlv_en:1;
        RBus_UInt32  blending_weight_teeth_compare_en:1;
        RBus_UInt32  blending_weight_range_en:1;
        RBus_UInt32  blending_weight_replace_for_smd:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  blending_weight_range_min:8;
        RBus_UInt32  blending_weight_range_max:8;
        RBus_UInt32  res2:8;
    };
}di_im_di_ma_blending_weight_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_tmv_diff_th1:4;
        RBus_UInt32  n_mcnr_tmv_diff_th2:4;
        RBus_UInt32  n_mcnr_tmv_diff_th3:4;
        RBus_UInt32  n_mcnr_tmv_diff_th4:4;
        RBus_UInt32  n_mcnr_tmv_diff_th5:4;
        RBus_UInt32  n_mcnr_tmv_diff_th6:4;
        RBus_UInt32  n_mcnr_diff_tmv_th1:2;
        RBus_UInt32  n_mcnr_diff_tmv_th2:2;
        RBus_UInt32  res1:4;
    };
}di_im_new_mcnr_tmv_diff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  n_mcnr_tmv_penalty_clamp_en:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  n_mcnr_tmv0_diff_th1:4;
        RBus_UInt32  n_mcnr_tmv0_diff_th2:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  n_mcnr_tmv0_diff_th3:4;
        RBus_UInt32  n_mcnr_tmv_diff_range1:2;
        RBus_UInt32  n_mcnr_tmv_diff_range2:2;
        RBus_UInt32  n_mcnr_tmv_diff_range3:2;
        RBus_UInt32  res4:6;
    };
}di_im_new_mcnr_tmv_penalty_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_tmv_penalty1:4;
        RBus_UInt32  n_mcnr_tmv_penalty2:4;
        RBus_UInt32  n_mcnr_tmv_penalty3:4;
        RBus_UInt32  n_mcnr_tmv_penalty4:4;
        RBus_UInt32  n_mcnr_tmv_penalty5:4;
        RBus_UInt32  n_mcnr_tmv_penalty6:4;
        RBus_UInt32  n_mcnr_tmv_penalty7:4;
        RBus_UInt32  res1:4;
    };
}di_im_new_mcnr_tmv_penalty_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_tmv_pan_diff_th1:4;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th2:4;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th3:4;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th4:4;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th5:4;
        RBus_UInt32  n_mcnr_tmv_pan_diff_th6:4;
        RBus_UInt32  n_mcnr_diff_tmv_pan_th1:2;
        RBus_UInt32  n_mcnr_diff_tmv_pan_th2:2;
        RBus_UInt32  res1:4;
    };
}di_im_new_mcnr_tmv_gmv_diff_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_pan_penalty_select:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  n_mcnr_pan_penalty_clamp_en:1;
        RBus_UInt32  n_mcnr_pan_penalty_th1:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  n_mcnr_pan_diff_range1:2;
        RBus_UInt32  n_mcnr_pan_diff_range2:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  n_mcnr_pan_diff_range1_v:2;
        RBus_UInt32  res4:12;
    };
}di_im_new_mcnr_gmv_penalty_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_pan_penalty1:4;
        RBus_UInt32  n_mcnr_pan_penalty2:4;
        RBus_UInt32  n_mcnr_pan_penalty3:4;
        RBus_UInt32  n_mcnr_pan_penalty4:4;
        RBus_UInt32  n_mcnr_pan_penalty5:4;
        RBus_UInt32  n_mcnr_pan_penalty6:4;
        RBus_UInt32  n_mcnr_pan_penalty7:4;
        RBus_UInt32  res1:4;
    };
}di_im_new_mcnr_gmv_penalty_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_hmv_th1:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  n_mcnr_hmv_th2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  n_mcnr_vmv_th1:4;
        RBus_UInt32  res3:4;
        RBus_UInt32  n_mcnr_vmv_th2:4;
        RBus_UInt32  res4:2;
        RBus_UInt32  n_mcnr_mv_hist_shift:2;
    };
}di_im_new_mcnr_gmv_hist_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_mv_select_debug:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  n_mcnr_debug_422_mode:1;
        RBus_UInt32  n_mcnr_vector_debug_gain:4;
        RBus_UInt32  n_mcnr_debug_blocksize_h:8;
        RBus_UInt32  n_mcnr_debug_blocksize_v:8;
        RBus_UInt32  n_mcnr_k_debug_value_offset:4;
        RBus_UInt32  n_mcnr_k_debug_value_start:4;
    };
}di_im_new_mcnr_mv_debug_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_u4_sum:16;
        RBus_UInt32  mcnr_u5_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_d5_sum:16;
        RBus_UInt32  mcnr_d4_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_d6_sum:16;
        RBus_UInt32  mcnr_u6_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_l15_sum:16;
        RBus_UInt32  mcnr_l14_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_l13_sum:16;
        RBus_UInt32  mcnr_l12_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_l11_sum:16;
        RBus_UInt32  mcnr_r11_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_r12_sum:16;
        RBus_UInt32  mcnr_r13_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mcnr_r14_sum:16;
        RBus_UInt32  mcnr_r15_sum:16;
    };
}di_im_di_rtnr_mcnr_statistic_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_v_search_range:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  n_mcnr_v_pan_mv:4;
        RBus_UInt32  tmv_no_reset_flag:1;
        RBus_UInt32  n_mcnr_messlevel_shift:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  n_mcnr_mad_hist_clip:4;
        RBus_UInt32  res3:3;
        RBus_UInt32  n_mcnr_k_limit_en:1;
        RBus_UInt32  n_mcnr_k_limit_lo:4;
        RBus_UInt32  n_mcnr_k_limit_hi:4;
        RBus_UInt32  n_mcnr_k_limit_mv_th:4;
    };
}di_im_new_mcnr_control4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nintra_vertical_diff_th2:8;
        RBus_UInt32  nintra_min_second_diff_th4:8;
        RBus_UInt32  res1:16;
    };
}di_im_di_nintra_1st_2nd_ydiff_th_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_penalty_clamp_hi:4;
        RBus_UInt32  n_mcnr_penalty_clamp_lo:4;
        RBus_UInt32  n_mcnr_messlevel_hi_th:8;
        RBus_UInt32  n_mcnr_messlevel_lo_th:8;
        RBus_UInt32  n_mcnr_penalty_clamp_slope:8;
    };
}di_im_new_mcnr_penalty_clamp_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  n_mcnr_x_boundary_th2:8;
        RBus_UInt32  n_mcnr_y_boundary_th2:8;
        RBus_UInt32  res1:16;
    };
}di_im_new_mcnr_statistic_boundary_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth1_l:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth2_l:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth3_l:8;
        RBus_UInt32  res1:8;
    };
}di_rtnr_ma_isnr_getmotion_motionth_low_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth1_m:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth2_m:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth3_m:8;
        RBus_UInt32  res1:8;
    };
}di_rtnr_ma_isnr_getmotion_motionth_mid_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth1_n:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth2_n:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth3_n:8;
        RBus_UInt32  res1:8;
    };
}di_rtnr_ma_isnr_getmotion_motionth_mid2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth1_h:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth2_h:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionth3_h:8;
        RBus_UInt32  res1:8;
    };
}di_rtnr_ma_isnr_getmotion_motionth_high_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope1_lm:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope2_lm:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope3_lm:8;
        RBus_UInt32  res1:8;
    };
}di_rtnr_ma_isnr_getmotion_edgeslopelm_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope1_mn:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope2_mn:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope3_mn:8;
        RBus_UInt32  res1:8;
    };
}di_rtnr_ma_isnr_getmotion_edgeslopemn_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope1_nh:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope2_nh:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeslope3_nh:8;
        RBus_UInt32  res1:8;
    };
}di_rtnr_ma_isnr_getmotion_edgeslopenh_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeth1:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeth2:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeth3:8;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgeth4:8;
    };
}di_rtnr_ma_isnr_getmotion_edge_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rtnr_ma_isnr_getmotion_motionoffset:4;
        RBus_UInt32  rtnr_ma_isnr_getmotion_edgemask:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  rtnr_ma_isnr_getmotion_ydiffmask:2;
        RBus_UInt32  res2:20;
        RBus_UInt32  rtnr_isnr_filmmotion_update:1;
        RBus_UInt32  rtnr_isnr_getmotion_en:1;
    };
}di_rtnr_ma_isnr_getmotion_main_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nintra_hdiff_th1_lo:4;
        RBus_UInt32  nintra_hdiff_th2_lo:4;
        RBus_UInt32  nintra_dy_hdiff_th_en:1;
        RBus_UInt32  nintra_diff_s_v_divd:1;
        RBus_UInt32  nintra_dy_vertical_diff_th_en:1;
        RBus_UInt32  res1:21;
    };
}di_im_di_nintra_dyn_search_range_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_color_num:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  di_color_bar_vertical_mode:1;
        RBus_UInt32  res2:17;
        RBus_UInt32  di_color_bar_mode_en:2;
        RBus_UInt32  res3:8;
    };
}di_di_ptg_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_i_c0cb_92b:8;
        RBus_UInt32  di_i_c0cr_92b:8;
        RBus_UInt32  di_i_c0y_92b:8;
        RBus_UInt32  res1:8;
    };
}di_di_ptg_c0y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_i_c1cb_92b:8;
        RBus_UInt32  di_i_c1cr_92b:8;
        RBus_UInt32  di_i_c1y_92b:8;
        RBus_UInt32  res1:8;
    };
}di_di_ptg_c1y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_i_c2cb_92b:8;
        RBus_UInt32  di_i_c2cr_92b:8;
        RBus_UInt32  di_i_c2y_92b:8;
        RBus_UInt32  res1:8;
    };
}di_di_ptg_c2y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_i_c3cb_92b:8;
        RBus_UInt32  di_i_c3cr_92b:8;
        RBus_UInt32  di_i_c3y_92b:8;
        RBus_UInt32  res1:8;
    };
}di_di_ptg_c3y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_i_c4cb_92b:8;
        RBus_UInt32  di_i_c4cr_92b:8;
        RBus_UInt32  di_i_c4y_92b:8;
        RBus_UInt32  res1:8;
    };
}di_di_ptg_c4y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_i_c5cb_92b:8;
        RBus_UInt32  di_i_c5cr_92b:8;
        RBus_UInt32  di_i_c5y_92b:8;
        RBus_UInt32  res1:8;
    };
}di_di_ptg_c5y_cr_cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_i_c6cb_92b:8;
        RBus_UInt32  di_i_c6cr_92b:8;
        RBus_UInt32  di_i_c6y_92b:8;
        RBus_UInt32  res1:8;
    };
}di_di_ptg_c6y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_i_c7cb_92b:8;
        RBus_UInt32  di_i_c7cr_92b:8;
        RBus_UInt32  di_i_c7y_92b:8;
        RBus_UInt32  res1:8;
    };
}di_di_ptg_c7y_cb_cr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_ptg_width:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  di_ptg_length:14;
        RBus_UInt32  res2:2;
    };
}di_di_ptg_act_window_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_sram_sfrx_sf_rx_err_ro_dc:1;
        RBus_UInt32  di_sram_sfrx_sf_rx_done_ro_dc:1;
        RBus_UInt32  di_sram_sfrx_sf_rx_start_dc:1;
        RBus_UInt32  di_sram_sfrx_sf_rx_mode_dc:1;
        RBus_UInt32  di_sram_sfrx_sf_rx_gated_dc:1;
        RBus_UInt32  di_sram_sftx_sf_tx_work_ro_dc:1;
        RBus_UInt32  di_sram_sftx_sf_tx_start_dc:1;
        RBus_UInt32  di_sram_sftx_sf_tx_mode_dc:1;
        RBus_UInt32  di_sram_sfrx_fail_bit_status_ro_dc:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  di_sram_sfrx_debug_bit_sel_dc:8;
        RBus_UInt32  res2:8;
    };
}di_di_di_sram_self_test_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  timing_monitor_end1:4;
        RBus_UInt32  timing_monitor_sta1:4;
        RBus_UInt32  timing_monitor_end0:4;
        RBus_UInt32  timing_monitor_sta0:4;
        RBus_UInt32  res1:8;
        RBus_UInt32  timing_monitor_compare:2;
        RBus_UInt32  timing_monitor_multi_mode:1;
        RBus_UInt32  timing_monitor_unit:1;
        RBus_UInt32  timing_monitor_src:1;
        RBus_UInt32  timing_monitor_i2rnd_mode:2;
        RBus_UInt32  timing_monitor_en:1;
    };
}di_ccdinr_timing_monitor_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  timing_monitor_end5:4;
        RBus_UInt32  timing_monitor_sta5:4;
        RBus_UInt32  timing_monitor_end4:4;
        RBus_UInt32  timing_monitor_sta4:4;
        RBus_UInt32  timing_monitor_end3:4;
        RBus_UInt32  timing_monitor_sta3:4;
        RBus_UInt32  timing_monitor_end2:4;
        RBus_UInt32  timing_monitor_sta2:4;
    };
}di_ccdinr_timing_monitor_multi_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_compare_th:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_compare_th_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_golden:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_golden_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_previous1:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_result1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_previous2:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_result2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_previous3:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_result3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_previous4:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_result4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_max:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_max_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_min:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_min_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vsync_hit_den_error:1;
        RBus_UInt32  hsync_hit_den_error:1;
        RBus_UInt32  compare_hit:1;
        RBus_UInt32  res1:29;
    };
}di_ccdinr_timing_monitor_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  timing_monitor_end1_1:4;
        RBus_UInt32  timing_monitor_sta1_1:4;
        RBus_UInt32  timing_monitor_end0_1:4;
        RBus_UInt32  timing_monitor_sta0_1:4;
        RBus_UInt32  res1:8;
        RBus_UInt32  timing_monitor_compare_1:2;
        RBus_UInt32  timing_monitor_multi_mode_1:1;
        RBus_UInt32  timing_monitor_unit_1:1;
        RBus_UInt32  timing_monitor_src_1:1;
        RBus_UInt32  timing_monitor_i2rnd_mode_1:2;
        RBus_UInt32  timing_monitor_en_1:1;
    };
}di_ccdinr_timing_monitor_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  timing_monitor_end5_1:4;
        RBus_UInt32  timing_monitor_sta5_1:4;
        RBus_UInt32  timing_monitor_end4_1:4;
        RBus_UInt32  timing_monitor_sta4_1:4;
        RBus_UInt32  timing_monitor_end3_1:4;
        RBus_UInt32  timing_monitor_sta3_1:4;
        RBus_UInt32  timing_monitor_end2_1:4;
        RBus_UInt32  timing_monitor_sta2_1:4;
    };
}di_ccdinr_timing_monitor_multi_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_compare_th_1:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_compare_th_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_golden_1:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_golden_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_previous1_1:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_result1_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_previous2_1:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_result2_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_previous3_1:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_result3_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_previous4_1:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_result4_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_max_1:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_max_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_m_result_min_1:28;
        RBus_UInt32  res1:4;
    };
}di_ccdinr_timing_monitor_min_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vsync_hit_den_error_1:1;
        RBus_UInt32  hsync_hit_den_error_1:1;
        RBus_UInt32  compare_hit_1:1;
        RBus_UInt32  res1:29;
    };
}di_ccdinr_timing_monitor_st_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_height:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  cmp_width_div32:9;
        RBus_UInt32  res2:6;
        RBus_UInt32  cmp_en:1;
    };
}di_di_pq_cmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_data_format:2;
        RBus_UInt32  cmp_data_bit_width:2;
        RBus_UInt32  cmp_data_color:1;
        RBus_UInt32  cmp_line_mode:1;
        RBus_UInt32  two_line_prediction_en:1;
        RBus_UInt32  cmp_dic_mode_en:1;
        RBus_UInt32  cmp_qp_mode:2;
        RBus_UInt32  cmp_jump4_en:1;
        RBus_UInt32  cmp_pair_para:4;
        RBus_UInt32  cmp_400_old_mode_en:1;
        RBus_UInt32  cmp_line_sum_bit:16;
    };
}di_di_pq_cmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  frame_limit_bit:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  line_limit_bit:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  block_limit_bit:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  first_line_more_bit:6;
        RBus_UInt32  res4:2;
    };
}di_di_pq_cmp_bit_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rb_lossy_do_422_en:1;
        RBus_UInt32  not_rich_do_422_en:1;
        RBus_UInt32  not_enough_bit_do_422_en:1;
        RBus_UInt32  first_predict_nc_en:1;
        RBus_UInt32  do_422_mode:2;
        RBus_UInt32  blk0_add_half_en:1;
        RBus_UInt32  fisrt_line_more_en:1;
        RBus_UInt32  balance_en:1;
        RBus_UInt32  poor_limit_min_qp_en:1;
        RBus_UInt32  dynamic_allocate_ratio_en:1;
        RBus_UInt32  guarantee_max_qp_en:1;
        RBus_UInt32  blk0_add_en:1;
        RBus_UInt32  dynamic_sum_line_rst:1;
        RBus_UInt32  variation_maxmin_en:1;
        RBus_UInt32  add_last2blk_over_curve_bit:1;
        RBus_UInt32  g_ratio:5;
        RBus_UInt32  cmp_ctrl_para0:5;
        RBus_UInt32  first_predict_nc_mode:1;
        RBus_UInt32  tail_dummy_throughput:1;
        RBus_UInt32  input_fifo_pause_cycle:4;
    };
}di_di_pq_cmp_enable_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  variation_near_num_th:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  variation_num_th:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  variation_value_th:4;
        RBus_UInt32  dic_mode_entry_th:4;
        RBus_UInt32  rb_lossy_do_422_qp_level:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  not_rich_do_422_th:4;
        RBus_UInt32  not_enough_bit_do_422_qp:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  dic_mode_option:4;
    };
}di_di_pq_cmp_smooth_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dynamic_allocate_less:4;
        RBus_UInt32  dynamic_allocate_more:4;
        RBus_UInt32  dynamic_allocate_line:3;
        RBus_UInt32  res1:5;
        RBus_UInt32  dynamic_allocate_ratio_min:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  dynamic_allocate_ratio_max:5;
        RBus_UInt32  res3:3;
    };
}di_di_pq_cmp_allocate_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  poor_limit_th_qp1:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  poor_limit_th_qp2:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  poor_limit_th_qp3:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  poor_limit_th_qp4:5;
        RBus_UInt32  res4:3;
    };
}di_di_pq_cmp_poor_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  guarantee_max_g_qp:4;
        RBus_UInt32  guarantee_max_rb_qp:4;
        RBus_UInt32  dic_mode_qp_th_g:4;
        RBus_UInt32  dic_mode_qp_th_rb:4;
        RBus_UInt32  cmp_crc_ro_line_sel:14;
        RBus_UInt32  res1:2;
    };
}di_di_pq_cmp_guarantee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  balance_g_give:2;
        RBus_UInt32  balance_g_ud_th:2;
        RBus_UInt32  balance_g_ov_th:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  balance_rb_give:2;
        RBus_UInt32  balance_rb_ud_th:2;
        RBus_UInt32  balance_rb_ov_th:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  variation_maxmin_th:8;
        RBus_UInt32  variation_maxmin_th2:8;
    };
}di_di_pq_cmp_balance_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_fifo_odd_overflow_irq_en:1;
        RBus_UInt32  r_fifo_odd_overflow_irq_en:1;
        RBus_UInt32  g_fifo_odd_overflow_irq_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  b_fifo_even_overflow_irq_en:1;
        RBus_UInt32  r_fifo_even_overflow_irq_en:1;
        RBus_UInt32  g_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  request_fifo_odd_overflow_irq_en:1;
        RBus_UInt32  request_fifo_even_overflow_irq_en:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  over_flb_irq_en:1;
        RBus_UInt32  input_size_less_irq_en:1;
        RBus_UInt32  input_size_more_irq_en:1;
        RBus_UInt32  block_fifo_overflow_irq_en:1;
        RBus_UInt32  input_fifo_overflow_irq_en:1;
        RBus_UInt32  tail_fifo_overflow_irq_en:1;
        RBus_UInt32  prs_over_line_sum_bit_irq_en:1;
        RBus_UInt32  res4:13;
    };
}di_di_pq_cmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  b_fifo_odd_overflow_st:1;
        RBus_UInt32  r_fifo_odd_overflow_st:1;
        RBus_UInt32  g_fifo_odd_overflow_st:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  b_fifo_even_overflow_st:1;
        RBus_UInt32  r_fifo_even_overflow_st:1;
        RBus_UInt32  g_fifo_even_overflow_st:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  request_fifo_odd_overflow_st:1;
        RBus_UInt32  request_fifo_even_overflow_st:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  over_flb_st:1;
        RBus_UInt32  input_size_less_st:1;
        RBus_UInt32  input_size_more_st:1;
        RBus_UInt32  block_fifo_overflow_st:1;
        RBus_UInt32  input_fifo_overflow_st:1;
        RBus_UInt32  tail_fifo_overflow_st:1;
        RBus_UInt32  prs_over_line_sum_bit_st:1;
        RBus_UInt32  res4:12;
        RBus_UInt32  pqc_irq:1;
    };
}di_di_pq_cmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_package_height_cnt:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  g_ratio_min:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  g_ratio_max:5;
        RBus_UInt32  res3:2;
        RBus_UInt32  cmp_two_pixel_mode:1;
    };
}di_di_pq_cmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  short_term_rb_qp_max:4;
        RBus_UInt32  short_term_g_qp_max:4;
        RBus_UInt32  cmp_ctrl_para2:8;
        RBus_UInt32  long_term_rb_qp_max:4;
        RBus_UInt32  long_term_g_qp_max:4;
        RBus_UInt32  cmp_ctrl_para1:7;
        RBus_UInt32  long_term_qp_measure_en:1;
    };
}di_di_pq_cmp_qp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_water_even_b:8;
        RBus_UInt32  fifo_water_even_r:8;
        RBus_UInt32  fifo_water_even_g:8;
        RBus_UInt32  cmp_ctrl_para3:7;
        RBus_UInt32  fifo_water_measure_en:1;
    };
}di_di_pq_cmp_fifo_st1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_water_odd_b:8;
        RBus_UInt32  fifo_water_odd_r:8;
        RBus_UInt32  fifo_water_odd_g:8;
        RBus_UInt32  res1:7;
        RBus_UInt32  res2:1;
    };
}di_di_pq_cmp_fifo_st2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rb_frame_left:16;
        RBus_UInt32  g_frame_left:16;
    };
}di_di_pq_cmp_left_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  total_package_even:24;
        RBus_UInt32  res1:7;
        RBus_UInt32  total_package_long_term:1;
    };
}di_di_pq_cmp_package_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_g:32;
    };
}di_di_pq_cmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_r:32;
    };
}di_di_pq_cmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_even_b:32;
    };
}di_di_pq_cmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_odd_g:32;
    };
}di_di_pq_cmp_crc_odd_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_odd_r:32;
    };
}di_di_pq_cmp_crc_odd_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmp_crc_odd_b:32;
    };
}di_di_pq_cmp_crc_odd_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  total_package_odd:24;
        RBus_UInt32  res1:8;
    };
}di_di_pq_cmp_package_odd_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  blk0_add_value16:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value32:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  dic_mode_tolerance:8;
        RBus_UInt32  blk0_add_value0:6;
        RBus_UInt32  res3:2;
    };
}di_di_pq_cmp_blk0_add0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  blk0_add_value1:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  blk0_add_value2:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  blk0_add_value4:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  blk0_add_value8:6;
        RBus_UInt32  res4:2;
    };
}di_di_pq_cmp_blk0_add1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_height:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  decmp_width_div32:9;
        RBus_UInt32  res2:6;
        RBus_UInt32  decmp_en:1;
    };
}di_di_pq_decmp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_data_format:2;
        RBus_UInt32  decmp_data_bit_width:2;
        RBus_UInt32  decmp_data_color:1;
        RBus_UInt32  decmp_line_mode:1;
        RBus_UInt32  decmp_two_line_prediction_en:1;
        RBus_UInt32  decmp_dic_mode_en:1;
        RBus_UInt32  decmp_qp_mode:2;
        RBus_UInt32  decmp_jump4_en:1;
        RBus_UInt32  decmp_pair_para:4;
        RBus_UInt32  decmp_400_old_mode_en:1;
        RBus_UInt32  decmp_line_sum_bit:16;
    };
}di_di_pq_decmp_pair_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  saturation_en:1;
        RBus_UInt32  saturation_type:1;
        RBus_UInt32  saturation_type_delta:1;
        RBus_UInt32  decmp_ctrl_para:13;
        RBus_UInt32  decmp_crc_ro_line_sel:14;
        RBus_UInt32  res1:2;
    };
}di_di_pq_decmp_sat_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_b_error_odd_en:1;
        RBus_UInt32  crc_g_error_odd_en:1;
        RBus_UInt32  crc_r_error_odd_en:1;
        RBus_UInt32  dic_error_odd_en:1;
        RBus_UInt32  underflow_irq_odd_en:1;
        RBus_UInt32  not_finish_irq_odd_en:1;
        RBus_UInt32  res1:10;
        RBus_UInt32  crc_b_error_even_en:1;
        RBus_UInt32  crc_g_error_even_en:1;
        RBus_UInt32  crc_r_error_even_en:1;
        RBus_UInt32  dic_error_even_en:1;
        RBus_UInt32  underflow_irq_even_en:1;
        RBus_UInt32  not_finish_irq_even_en:1;
        RBus_UInt32  res2:10;
    };
}di_di_pq_decmp_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_b_error_odd_st:1;
        RBus_UInt32  crc_g_error_odd_st:1;
        RBus_UInt32  crc_r_error_odd_st:1;
        RBus_UInt32  dic_error_odd_st:1;
        RBus_UInt32  underflow_irq_odd_st:1;
        RBus_UInt32  not_finish_irq_odd_st:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  ring_b_overflow_odd_st:1;
        RBus_UInt32  ring_g_overflow_odd_st:1;
        RBus_UInt32  ring_r_overflow_odd_st:1;
        RBus_UInt32  in_fifo_overflow_odd_st:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  crc_b_error_even_st:1;
        RBus_UInt32  crc_g_error_even_st:1;
        RBus_UInt32  crc_r_error_even_st:1;
        RBus_UInt32  dic_error_even_st:1;
        RBus_UInt32  underflow_irq_even_st:1;
        RBus_UInt32  not_finish_irq_even_st:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  ring_b_overflow_even_st:1;
        RBus_UInt32  ring_g_overflow_even_st:1;
        RBus_UInt32  ring_r_overflow_even_st:1;
        RBus_UInt32  in_fifo_overflow_even_st:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  pqdc_irq:1;
    };
}di_di_pq_decmp_irq_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_en_qp0:1;
        RBus_UInt32  mark_en_qp1:1;
        RBus_UInt32  mark_en_qp2:1;
        RBus_UInt32  mark_en_qp3:1;
        RBus_UInt32  mark_en_qp4:1;
        RBus_UInt32  mark_en_qp5:1;
        RBus_UInt32  mark_en_qp6:1;
        RBus_UInt32  mark_en_qp7:1;
        RBus_UInt32  res1:8;
        RBus_UInt32  mark_en_qp_sel:1;
        RBus_UInt32  mark_en_dic:1;
        RBus_UInt32  res2:13;
        RBus_UInt32  mark_en_do_422:1;
    };
}di_di_pq_decmp_mark_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_1:16;
        RBus_UInt32  mark_color_0:16;
    };
}di_di_pq_decmp_mark_color_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_3:16;
        RBus_UInt32  mark_color_2:16;
    };
}di_di_pq_decmp_mark_color_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_5:16;
        RBus_UInt32  mark_color_4:16;
    };
}di_di_pq_decmp_mark_color_45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_7:16;
        RBus_UInt32  mark_color_6:16;
    };
}di_di_pq_decmp_mark_color_67_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mark_color_422:16;
        RBus_UInt32  mark_color_dic:16;
    };
}di_di_pq_decmp_mark_color_422_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_package_height_cnt:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  decmp_crc_error_line:14;
        RBus_UInt32  res2:1;
        RBus_UInt32  decmp_two_pixel_mode:1;
    };
}di_di_pq_decmp_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_g:32;
    };
}di_di_pq_decmp_crc_even_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_r:32;
    };
}di_di_pq_decmp_crc_even_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_even_b:32;
    };
}di_di_pq_decmp_crc_even_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_odd_g:32;
    };
}di_di_pq_decmp_crc_odd_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_odd_r:32;
    };
}di_di_pq_decmp_crc_odd_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_crc_odd_b:32;
    };
}di_di_pq_decmp_crc_odd_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  decmp_pause_cycle:8;
        RBus_UInt32  res1:22;
        RBus_UInt32  decmp_pause_cycle_long_term:1;
        RBus_UInt32  decmp_pause_cycle_measure_en:1;
    };
}di_di_pq_decmp_pause_cycle_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_teethshake_en:1;
        RBus_UInt32  di_film_teethshake_same_ub:8;
        RBus_UInt32  di_film_teethshake_diff_lb:8;
        RBus_UInt32  di_film_bothdiff_weight:6;
        RBus_UInt32  di_film_bothdiff_shift:2;
        RBus_UInt32  res1:5;
        RBus_UInt32  di_film_teethth_timing:1;
        RBus_UInt32  di_film_teethth_teeth_both_en:1;
    };
}di_di_film_teethshake_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_statusbothdiffsum_159_140:20;
        RBus_UInt32  di_film_teethth_prog_ub:8;
        RBus_UInt32  di_film_framestaticonly:1;
        RBus_UInt32  di_film_teethth_moving_single_side:1;
        RBus_UInt32  res1:2;
    };
}di_di_film_new_function_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_statusbothdiffsum_139_120:20;
        RBus_UInt32  res1:9;
        RBus_UInt32  di_film_bothdiff_range:2;
        RBus_UInt32  di_film_hbcounter_method:1;
    };
}di_di_film_bothdiff_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_statusbothdiffsum_119_100:20;
        RBus_UInt32  di_film_xpos_1by4:5;
        RBus_UInt32  di_film_xpos_3by4:5;
        RBus_UInt32  res1:2;
    };
}di_di_film_hsize_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_statusbothdiffsum_99_80:20;
        RBus_UInt32  di_film_ypos_1by4:5;
        RBus_UInt32  di_film_ypos_3by4:5;
        RBus_UInt32  res1:2;
    };
}di_di_film_vsize_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_statusbothdiffsum_79_60:20;
        RBus_UInt32  di_film_nonfilmregion_dn_extend:4;
        RBus_UInt32  di_film_nonfilmregion_up_extend:4;
        RBus_UInt32  di_film_nonfilmregion_force:1;
        RBus_UInt32  res1:3;
    };
}di_di_film_nonfilmregion_extend_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_statusbothdiffsum_59_40:20;
        RBus_UInt32  di_film_nonfilmregion_dn_debounce:4;
        RBus_UInt32  di_film_nonfilmregion_up_debounce:4;
        RBus_UInt32  res1:4;
    };
}di_di_film_nonfilmregion_debounce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_statusbothdiffsum_39_20:20;
        RBus_UInt32  di_film_nonfilmregion_s_small:6;
        RBus_UInt32  di_film_nonfilmregion_s_big:6;
    };
}di_di_film_nonfilmregion_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  di_film_statusbothdiffsum_19_0:20;
        RBus_UInt32  di_film_nonfilmregion_s_both:6;
        RBus_UInt32  di_film_nonfilmregion_th:6;
    };
}di_di_film_nonfilmregion_2_RBUS;




#endif 


#endif 
